// $Id$
var ZDBBackupUtil = new function()
{
	this.showBackupDBReactDlg = function(jsonInfo, requestOptions){
		if(!loadReact(ZDBBackupUtil.showBackupDBReactDlg,[jsonInfo, requestOptions])){
			return;
		}
		if(!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/react/ZRBackupDialog.js"],"APPENDTODOC", ZDBBackupUtil.showBackupDBReactDlg, [jsonInfo, requestOptions])){
			return
		}
//		var jsonInfo = JSON.parse(response.responseText);
		if(jsonInfo.DONTSHOWBACKUP == "true"){
			var msg = jsonInfo.DONTSHOWBACKUPMSG;
			var arr = msg.split(';');
		    if(arr[1] != null)
		    {
		      var upgradeTabLink = ZDBGlobal.upgradeLink;

  	         if(ZDBGlobal.IS_ONPREMISE_BUILD&&ZDBGlobal.IS_FREE_EDITION)
               {
                var compareTabLink=ZDBI18NMap.g("zrop.license.compare.js.editions");
                arr[1]='<a href="'+compareTabLink+ '" target="_blank"">'+arr[1]+'</a>';               }
		       else
		      {
		        arr[1] = '<a href="'+upgradeTabLink+'">' + arr[1] + '</a>';  
		      }
		      msg = arr.join("");
		    }
	    	StatusMsgAPI.showErrorMsg(msg);
			return;
		}
		var holder = ZRBaseComponentsUtils.getContainer("BACKUPDIV",document.body);//NO I18N
		var backupFactory = React.createFactory(FullPageDialog);
		var backupRef = ReactDOM.render(backupFactory({dlgName:"BACKUPDB",jsonInfo:jsonInfo}),holder);//NO I18N
		var saveButton = $("DataBackupSave");
        saveButton.scheduleStatusEl = requestOptions["SCHEDULESTATUSEL"];
    	ZDBBackupUtil.setUserSettings();
  	    var dbId = requestOptions.DBID;
  	    var onClose = null;
  	    var el = requestOptions["EL"];
  	    var parEl = DOMUtils.getParentWithAttrValue(el,"class","ZRSDBList ZRSDBHighlight");//NO I18N
  	    if(!parEl)
		{
    		//In pricing page - backup tab
    		parEl = saveButton.scheduleStatusEl;
		}
  	    else
		{
    		onClose = ZDBCreateDB.removeHighlight;
		}
  	    parEl.isDialogOpen = true;
  	    holder.parEl = parEl;
  	    holder.setAttribute("isDialog","true");
  	    holder.className = "ZRSShadow";
  	    ZDBDialogUtil.showDialog(holder,{TITLE:ZDBI18NMap.g("zrpt.common.pricing.backup.js.bkp_setting"),	  
											          DESC:ZDBI18NMap.g("zrpt.common.pricing.backup.js.desc"),
											          MODAL:true,DONTREMOVE:true,CALLOUT:true,SRCEL:saveButton.scheduleStatusEl,
											          ONCLOSE:onClose,USEREACT:true}); //NO I18N
  	    $("ZDBEditShareProcess").className="mcLoaded";
	}
	
	
  this.openBackupDatabaseDlg = function(el,dbId)
  {
	  if(!dbId){
	      dbId = el.getAttribute("dbId");
	  }
//      AjaxAPI.sendRequest({URL:"/ZRDBSettingsInfoFetcher.ma?ZDBACTION=BACKUPDLG&DBID="+dbId, //No I18N
//                             ONSUCCESSFUNC:ZDBBackupUtil.showBackupDBReactDlg,
//                             SCHEDULESTATUSEL:el,DBID:dbId,OPSTATUSID:"ZDBMainLoader",EL:el}); //No I18N
    ZRSAjax.get('/reportsapi/DBBACKUPINFO', 'DBID='+dbId, {
        successHandler: {
            func: ZDBBackupUtil.showBackupDBReactDlg,
            ctx: ZDBBackupUtil
        },
        SCHEDULESTATUSEL:el,
        DBID:dbId,
        EL:el
    });
  }
  
  this.showBackupDatabaseDlg = function(response,requestOptions)
  {
      $("ZDBAjaxResponseStore").innerHTML = response.responseText;
      var el = $("ZDBBackupDatabase");
      var saveButton = $("DataBackupSave");
      saveButton.scheduleStatusEl = requestOptions["SCHEDULESTATUSEL"];
      el.style.display = "block";
      ZDBBackupUtil.setUserSettings();
  	  var dbId = requestOptions.DBID;
  	  var onClose = null;
  	  var parEl = $('ZDBLISTDBTD_' + dbId);
  	  if(!parEl)
		  {
    		  //In pricing page - backup tab
    		  parEl = saveButton.scheduleStatusEl;
		  }
  	  else
		  {
    		  onClose = ZDBCreateDB.removeHighlight;
		  }
  	  parEl.isDialogOpen = true;
  	  el.parEl = parEl;
  	  ZDBDialogUtil.showDialog(el,{TITLE:ZDBI18NMap.g("zrpt.common.pricing.backup.js.bkp_setting"),	  
											          DESC:ZDBI18NMap.g("zrpt.common.pricing.backup.js.desc"),
											          ADDFRAME:true,MODAL:true,DONTREMOVE:false,CALLOUT:true,SRCEL:saveButton.scheduleStatusEl,
											          ONCLOSE:onClose}); //No I18n
  }
	this.toggleSchedulePeriod = function(optValue,resize)
  {
    $("schedule_daily").style.display = "none";
    $("schedule_weekly").style.display = "none";
    $("schedule_monthly").style.display = "none";
    if(optValue != "none")
    {
      var enableDiv = $("schedule_"+optValue);
      enableDiv.style.display = "";
      $("ZDBStopScheduleOpt").style.display="";
    }
    else
    {
      $("ZDBStopScheduleOpt").style.display="none";
    }
  }

  this.getSchedulerName = function()
  {
    var repeatType = $("repeatinterval")[$("repeatinterval").selectedIndex].value;// $("repeatinterval").value;  //No I18N
    var schedulerName = "none" ;  //No I18N
    if(repeatType == "daily")
    {
      var hourVal = $("ZDB_DLY_HRS_INT").value;
      var minVal = $("ZDB_DLY_MINS_INT").value;
      var timeInMin = parseInt( hourVal * 60) + parseInt(minVal) ;
      schedulerName = timeInMin + "_" + repeatType;
    }
    else if(repeatType == "weekly")
    {
      var hourVal = $("ZDB_WLY_HRS_INT").value;
      var minVal = $("ZDB_WLY_MINS_INT").value;
      var timeInMin = parseInt( hourVal * 60) + parseInt(minVal);
      var schDay = $("weeklyinterval")[$("weeklyinterval").selectedIndex].value; //$("weeklyinterval").value ;
      schedulerName = timeInMin + "_" + repeatType + "_" + schDay;    
    }
    else if(repeatType == "monthly")
    {
      var hourVal = $("ZDB_MLY_HRS_INT").value;
      var minVal = $("ZDB_MLY_MINS_INT").value;
      var timeInMin = parseInt( hourVal * 60) + parseInt(minVal) ;
      var schDate = $("monthlyinterval")[$("monthlyinterval").selectedIndex].value; // $("monthlyinterval").value ;
      schedulerName = timeInMin + "_" + repeatType + "_" + schDate;
    }
    return schedulerName ; 
  }

  this.setBackupSchedule = function(el,dbId)
  {
    var params = "DBID="+ dbId; //No I18N
    var schedulerName = this.getSchedulerName();
    params += "&ZDBACTION=BACKUPSCHEDULESET&SCHEDULERNAME="+schedulerName; //No I18N
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBBackupDatabase.ve?",  //No I18N
                               PARAMETERS:params,
                               ONSUCCESSFUNC:ZDBBackupUtil.successalertfn,
                               SCHEDULERNAME:schedulerName,
                               SCHEDULESTATUSEL:el.scheduleStatusEl,
                               OPSTATUSID:"ZDBEditShareProcess"});  //No I18N

  }

  this.successalertfn = function(response,requestOptions)
  {
    ZDBDialogUtil.closeDialog();
    var scheduleStatusEl = requestOptions["SCHEDULESTATUSEL"];
    var scheduleStatus = "";
    var schedulerName = requestOptions["SCHEDULERNAME"];
    var fromPricingPage = scheduleStatusEl && scheduleStatusEl.getAttribute("fromPricingPage") == "true";
    if(schedulerName == "none")
    {
       if(fromPricingPage)
       {
         ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrpt.common.pricing.backup.js.back_up_disable"), "zdbpsuccessmsg"); //No I18N
       }
       else
       {
         ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.pricing.backup.js.back_up_disable"));
       }
       scheduleStatus = ZDBI18NMap.g("zrpt.common.pricing.backup.js.not_sch"); 
    }
    else
    {
       if(fromPricingPage)
       {
         ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrpt.common.pricing.backup.js.back_up_sccess"), "zdbpsuccessmsg");  //No I18N
       }
       else
       {
         ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.pricing.backup.js.back_up_sccess"));
       }
       scheduleStatus = ZDBI18NMap.g("zrpt.common.pricing.backup.js.sch");
    }
    if(scheduleStatusEl && fromPricingPage)
    {
      jQuery(".zrlink", scheduleStatusEl).html(scheduleStatus);	//No I18N
    }
    document.body.style.overflow="auto";
  };

  this.setUserSettings = function()
  {
    var perUnit = $("ZDB_BKP_SCH_PERODICUNIT").innerHTML;
    var calFreq = $("ZDB_BKP_SCH_CALENDARFREQ").innerHTML;
    var calTime = $("ZDB_BKP_SCH_CALENDARTIME").innerHTML;
    var calDay = $("ZDB_BKP_SCH_CALENDARDAY").innerHTML;
    var calDate = $("ZDB_BKP_SCH_CALENDARDATE").innerHTML;
    $("schedule_daily").style.display = "none";
    $("schedule_weekly").style.display = "none";
    $("schedule_monthly").style.display = "none";
    var repeatIntElem = $("repeatinterval");
    if(calFreq == "daily")
    {
      repeatIntElem.value = calFreq;
      $("schedule_daily").style.display = "";
      var hr = Math.floor(calTime / 60);
      var min = calTime % 60;
      $("ZDB_DLY_HRS_INT").value = hr;
      $("ZDB_DLY_MINS_INT").value = min;      
    }
    else if(calFreq == "weekly")
    {
      repeatIntElem.value = calFreq;
      $("schedule_weekly").style.display = "";
      var hr = Math.floor(calTime / 60);
      var min = calTime % 60;
      $("ZDB_WLY_HRS_INT").value = hr;
      $("ZDB_WLY_MINS_INT").value = min;
      $("weeklyinterval").value = calDay;
    }
    else if(calFreq == "monthly")
    {
      repeatIntElem.value = calFreq;
      $("schedule_monthly").style.display = "";
      var hr = Math.floor(calTime / 60);
      var min = calTime % 60;
      $("ZDB_MLY_HRS_INT").value = hr;
      $("ZDB_MLY_MINS_INT").value = min;
      $("monthlyinterval").value = calDate;
    }
    else
    {
      ZDBBackupUtil.stopScheduling();
    }
  }

  this.stopScheduling = function()
  {
    $("repeatinterval").value = "none"; //No I18N
    $("ZDBStopScheduleOpt").style.display="none"; //No I18N
    ZDBBackupUtil.toggleSchedulePeriod("none");  //No I18N
  }
  
  this.toggleSchedulePeriod = function(optValue)
  {
    $("schedule_daily").style.display = "none";
    $("schedule_weekly").style.display = "none";
    $("schedule_monthly").style.display = "none";
    if(optValue != "none")
    {
      var enableDiv = $("schedule_"+optValue);
      enableDiv.style.display = "";
      $("ZDBStopScheduleOpt").style.display="";
    }
    else
    {
      $("ZDBStopScheduleOpt").style.display="none";
    }
  }
}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBBackupUtil.openBackupDatabaseDlg"]=ZDBBackupUtil.openBackupDatabaseDlg;
