//$Id$

var ZRSMInteg = new function()
{
	 this.isAuthenticated = false;
	 this.isNewDB = true;
     this.initialize = function()
     {
         if(ZRSMInteg.initialized === true)
         {
        	 return;
         }     
         ZRSMInteg.showDemoDlg = jQuery("#SMWIZARDHOLDER").attr("showDemoDlg"); //No i18N
         ZRSMInteg.hiddenHolder = $("SMHIDDENHOLDER");
         ZRSMInteg.wizardHolder = $("SMWIZARDHOLDER");
         
         ZRSMInteg.demoDlg =  $("SMDemoDlg");
         
    	 ZRSMInteg.dbDetailsDlg = $("SMDBDetailsDlg");
         ZRSMInteg.hiddenHolder.appendChild(ZRSMInteg.wizardHolder);
         
         ZRSMInteg.hiddenHolder.appendChild(ZRSMInteg.dbDetailsDlg);
         
         ZRSMInteg.initElsNFunctions();
         ZRSMInteg.initialized = true;
     };
     
     this.initElsNFunctions = function()
     {
		 jQuery("#SMSKIPDEMO").click(function(){ZRSMInteg.submitDemoDlg();}) ; //No I18N
         jQuery("#SMAuthorizeButton").click(function(){ZRSMInteg.authorizeUser('auth'); }); //No I18N
     };
     
     this.setDlgTitle = function()
     {
             var title = "";
             var desc = "";
             switch(ZRSMInteg.step)
             {
                 case 1:
                     title = ZDBI18NMap.f("zrpt.conn.js.setupdlg.step1.title",ZDBI18NMap.g("zrpt.connector.js.surveymonkey"));
                     desc = ZDBI18NMap.f('zrpt.conn.js.createdbdesc',ZDBI18NMap.g('zrpt.connector.js.surveymonkey')) ;                     
                     break;
                 case 2:
                     title = ZDBI18NMap.f("zrpt.conn.js.setupdlg.step2.title",ZDBI18NMap.g("zrpt.connector.js.surveymonkey"));
                     desc = ZDBI18NMap.f('zrpt.conn.js.scheduledlgdesc',ZDBI18NMap.g('zrpt.connector.js.surveymonkey')) ;
                     break;
                 case 3:
                     title = ZDBI18NMap.f("zrpt.conn.js.dbsuccess.title",ZDBI18NMap.g("zrpt.connector.js.surveymonkey"));
                     desc =  ZDBI18NMap.f("zrpt.conn.js.dbsuccess.desc",ZDBI18NMap.g("zrpt.connector.js.surveymonkey"));
                     break;   
             }
             $("zdbImpSMDlgTitle").innerHTML = title;
             $("zdbImpSMDlgDesc").innerHTML = desc;
     };
 
	this.showDBDetailsDlg = function(el, isNewDB)
	{
            if(!ZDBLazyLoadUtil.loadSnippet("ZRSM_IMPORT_DLG","/ZRSMDBDetailsDlg.cc?ISNEWDB="+isNewDB,this,"APPENDTODOC"))
            {    
            	return;
            }
            delete ZDBLazyLoadUtil.loadedSnippets.ZRSM_IMPORT_DLG;
            ZRSMInteg.isNewDB = isNewDB;
            ZRSMInteg.isUserExpired = $("SM_IS_EXPIRED_USER").value;
            ZRSMInteg.isNotAnSFUser = $("SM_IS_NOT_USER").value;
            ZRSMInteg.isReportsUser = $("SM_IS_REPORTS_USER").value;
            if(ZRSMInteg.isUserExpired === "true")
            {
            	ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.conn.js.userexpired.msg",ZDBI18NMap.f("zrpt.connector.js.mscrm"),ZDBGlobal.PRODUCTNAME));
            	return;
            }   
            else if(ZRSMInteg.isReportsUser !== "true" && ZRSMInteg.isNotAnSFUser === "true")
            {
            	ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.conn.js.otherservice.freeuser",ZDBI18NMap.g("zrpt.connector.js.mscrm"),ZDBGlobal.PRODUCT_NAME));
            	return;
            }
            else if(ZRSMInteg.isNotAnSFUser === "true")
            {
            	var infoDlg =  $("SMTrialInfo");
            	infoDlg.style.display = "" ;
            	ZDBDialogUtil.showDialog(infoDlg,{TITLE:ZDBI18NMap.f("zrpt.conn.js.title_trial",ZDBGlobal.PRODUCT_NAME,ZDBI18NMap.g("zrpt.connector.js.surveymonkey")), ADDFRAME:true,MODAL:true,DONTREMOVE:true});
            }
            else
            {
            	ZRSMInteg.initializeAndShowDBDlg();
            }
    };
    
    this.initializeAndShowDBDlg = function()
    {
        ZDBDialogUtil.closeDialog();
        ZRSMInteg.initialize();
        if(ZRSMInteg.showDemoDlg === "true")
	 	{
        	ZDBDialogUtil.showDialog(ZRSMInteg.demoDlg,{TITLE:ZDBI18NMap.f("zrpt.conn.js.demo.title",ZDBI18NMap.g("zrpt.connector.js.surveymonkey")),
        						ADDFRAME:true,DONTREMOVE:true, MODAL:true});
        	ZDBUtil.setFocus("SMSKIPDEMO",true); //No I18N
	 	}
        else
    	{
        	ZRSMInteg.showDlgBasedOnSelection();
    	}
    };
    
    this.submitDemoDlg = function()
    {
    	if($("ZDBZDShowDemoCheck").checked)
        {
    		ZRSMInteg.showDemoDlg = false;
            var url = "/ConnectorAction.ma?ZDBACTION=DONTSHOWDEMODLG&CONNECTORID=18"; //No I18N
            AjaxAPI.sendRequest({URL:url,ONSUCCESSFUNC:ZRSMInteg.showSMImpDlg});  //No I18N
        }
    	else
    	{
    		ZRSMInteg.showSMImpDlg();
    	}
    }
    
    this.showSMImpDlg = function()
    {
    	ZDBDialogUtil.closeDialog();
    	ZRSMInteg.showDlgBasedOnSelection();
    }
    
    this.showDlgBasedOnSelection = function()
    {
    	ZRSMInteg.showSMDBDetailsDlg();	
    	if(ZRSMInteg.isNewDB == "true")
    	{
    		ZDBFullPageDialog.showDialog(ZRSMInteg.wizardHolder,{ADDFRAME:true, MODAL:true,ONCLOSE:ZRSMInteg.handleDlgClose});
    	}
    	else
    	{
    		ZDBInlineDialog.showDialog(ZRSMInteg.wizardHolder,{ADDFRAME:true,MODAL:true,TITLE:ZDBI18NMap.f("zrpt.conn.js.setupdlg.title",ZDBI18NMap.g("zrpt.connector.js.surveymonkey"))});
            $("SMDlgTtlBar").className = "";//No I18N
            $("SMDlgTtlBar").style.padding = "25px 25px 0px";//No I18N
            $("SMGenInfo").style.width = "40%";//No I18N
            $("SMWIZARDHOLDER").style.minWidth = "1141px";//No I18N
    	}
    	ZRSMInteg.setDlgTitle();
    }
    
    this.showSMDBDetailsDlg = function()
    {
        // Show DBDetailsDlg Div
    	ZRSMInteg.step = 1;
    	ZRSMInteg.wizardHolder.appendChild(ZRSMInteg.dbDetailsDlg);
    	ZRSMInteg.setDlgTitle();
        ZDBUtil.setFocus("SMDBNAME",true); //No I18N
    };
    
    this.authorizeUser = function(state)
    {
 	   var w = 918;
 	   var h = 732;
 	   var left = Number((screen.width/2)-(w/2));
       var top = Number((screen.height/2)-(h/2));
 	   window.open($("SM_AUTH_URL").value +'&state='+state,'ReportsWindow', 'width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);//NO I18N
    };
    
	this.storeAuthCode = function(code, state)
	{
		if(state === "auth")
		{
			$("SMAUTHCODE").value=code;
			if($("SMAUTHCODE").value !== "null")
			{
				ZRSMInteg.successAuth();
			}
			else
			{
				ZRSMInteg.cancelActivity();
			}
		}
		else
		{
			if(code !== "null")
			{
				var params ="&AUTHCODE="+code+"&DBID="+ZDBClientUI.dbId+"&CONNDBINFOID="+$("CONNDBINFOID").value; //No I18N           
				AjaxAPI.sendRequest({URL:"/ZRSMAction.ma?&ZDBACTION=SMREAUTH",PARAMETERS:params, METHOD:"POST",
                ONSUCCESSFUNC:ZRSMInteg.successReAuth,OPSTATUSID:"ZDBMainLoader"}); //No I18N			
			}
		}
	};
	
	this.successAuth = function(response)
	{
		ZRSMInteg.isAuthenticated = true;
		$("SMDBDetsSubmit").className = "buttonCompBoxBg";
		jQuery("#SMDBDetsSubmit").unbind("click").click(function(){ ZRSMInteg.showSchSettingsDlg(this.form);}); //No I18N 
		var respDiv = jQuery("#SMAUTHSUCCESS");// No I18N
		jQuery(respDiv).show("slow");   // No I18N
		setTimeout(function(){jQuery("#SMAuthSuccessMsg").css({"border":"0px","background-color":"white","font-weight":"400"});},5000);
	};
	
    this.showSchSettingsDlg = function(frm)
    {
        if(!validateForm(frm))
        {
          return;
        }
        hideCustomMessage();
        var isNewDB = ZRSMInteg.isNewDB;
        var params = "&AUTHCODE="+ $("SMAUTHCODE").value + "&ISNEWDB=" + isNewDB; //No I18N
        if(isNewDB == "true")
        {
        	params += "&DATABASENAME=" + encodeURIComponent(frm.SMDBNAME.value) + "&DATABASEDESC=" + encodeURIComponent(frm.SMDBDESC.value) //No I18N
        }
        else
        {
        	params += "&DBID=" + ZDBClientUI.dbId;//No I18N
        }
        if(ZRSMInteg.isAuthenticated)
        {
        	AjaxAPI.sendRequest({URL:"/ZRSMSchDlg.cc?ZDBACTION=SMSHOWSCHDLG",PARAMETERS:params, METHOD:"POST", 
                ONSUCCESSFUNC:ZRSMInteg.showScheduleDlg,ONFAILUREFUNC:ZRSMInteg.errorOnSubDBDetails, OPSTATUSID:"SMCREATEDBOPTSTATUS"}); //No I18N
        }
        else
        {
        	alert("Not Authenticated");//NO I18N
        }
    };
	
    this.showScheduleDlg = function (response)
    {
    	ZRSMInteg.step = 2;
    	var div = document.createElement("div");
        div.innerHTML = response.responseText;
        ZRSMInteg.schSettingsDlg=div;      
        ZRSMInteg.hiddenHolder.appendChild(ZRSMInteg.dbDetailsDlg);
        ZRSMInteg.wizardHolder.appendChild(div);
        $("SMCreate").onclick=function () { ZRSMInteg.submitCreateDB(this.form);};
        jQuery("#SMCreatePrevious").click(function(){ZRSMInteg.showDBDetsDlgFromSchDlg();}); //No I18N
        ZRSMInteg.setDlgTitle();
        ZRConnector.changeSchTimeToCurrentTime();
    };
    
    this.errorOnSubDBDetails = function(response,reponsetext)
    {
        var errCode = response.getResponsePart("ERRORCODE");
        var errMsg = response.getResponsePart("STATUS_MESSAGE");
        errCode = trimAll(errCode);
        if(errCode === "META_DBNAME_DUPLICATE")
        {
            showCustomMessage(errMsg, $("SMDBNAME"));
            return;
        }
        else
        {
             ZDBAlertAPI.showMsg(errMsg);
        }
    };
    
    this.showDBDetsDlgFromSchDlg = function ()
    {
    	//this.isAuthenticated = false;
    	//ZRSMInteg.cancelActivity();
    	ZRSMInteg.schSettingsDlg.parentNode.removeChild(ZRSMInteg.schSettingsDlg);
    	ZRSMInteg.showSMDBDetailsDlg();
    };
    
    this.submitCreateDB = function(form)
    {
    	var atleastOneSelected = ZRSMInteg.checkIfOneSurveySelected();
    	if(!atleastOneSelected)
    	{
    		return;
    	}
		var needReports = "";
		if(form.NEEDREPORTS && form.NEEDREPORTS.checked == false)
		{
			needReports = "&NEEDREPORTS=true";  // No I18N
		}
    	var isNewDB = form.ISNEWDB.value;
        var params = "&TIMEZONE=" + encodeURIComponent(form.SMTIMEZONE.value) + "&SCHEDULETIME=" + ZRConnector.getSchTime() + "&CLEANUPMONTHS=" + ZRConnector.getCleanupMonths() //NO I18N
                     +"&ACCESSTOKEN="+form.ACCESSTOKEN.value+"&EMAILID="+encodeURIComponent(form.EMAILID.value)+"&ADDNEWSURVEYSBYDEFAULT="+form.ADDNEWSURVEYSBYDEFAULT.checked//No I18N
                     +"&SCHTIMEZONE="+ ZRConnector.getSchTimeZone() + "&ISNEWDB=" + isNewDB +"&SMSURVEYIDS=" + ZRSMInteg.getSelectedSurveys(form) + needReports; //No I18N
        if(isNewDB == "true")
        {
        	params += "&DATABASENAME=" + encodeURIComponent(form.SMDBNAME.value) + "&DATABASEDESC=" + encodeURIComponent(form.SMDBDESC.value) //No I18N
        }
        else
        {
        	params += "&DBID=" + ZDBClientUI.dbId;//No I18N
        }
        
        AjaxAPI.sendRequest({URL:"/ZRSMInitialInfoDlg.cc?&ZDBACTION=SMCREATEDB",PARAMETERS:params, METHOD:"POST",
                ONSUCCESSFUNC:ZRSMInteg.showSuccessDBDlg, OPSTATUSID:"SMCREATEOPTSTATUS"}); //No I18N
    };
    
    this.checkIfOneSurveySelected = function()
    {
    	var isOneSel = false;
    	jQuery('div#SMSurveysContainer input[type=checkbox]').each(function() {//NO I18N
    		if ($(this).checked) {
    			isOneSel = true;
    			return true;
    		}
    	});
    	if(!isOneSel)
    	{
    		ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.surveymonkey.js.nosurveyselected"));
    	}
    	return isOneSel;
    }
    
    this.getSelectedSurveys = function(form)
    {
        var selMods = "[";
        jQuery('div#SMSurveysContainer input[type=checkbox]').each(function() {//NO I18N
            if ($(this).checked) {
            	selMods += "\"" +jQuery(this).attr('value') + "\"" + "," ;//NO I18N
            }
         });
        selMods += "]";
        return selMods;
    };
    
    this.showSuccessDBDlg = function(response,responseText)
    {
        // Show Dlg
      ZRSMInteg.step = 3;
      var div = document.createElement("div");
      div.innerHTML = response.responseText;
      ZRSMInteg.successInfoDlg = div;
      ZRSMInteg.schSettingsDlg.parentNode.removeChild(ZRSMInteg.schSettingsDlg);
      ZRSMInteg.wizardHolder.appendChild(ZRSMInteg.successInfoDlg);    
      ZRSMInteg.setDlgTitle();
      ZDBDialogUtil.positionCenter(ZDBDialogUtil.focusDialog);
    };
    
    this.handleSMDlgClose = function(el, event)
    {
    	if(ZRSMInteg.isNewDB == "true")
    	{
    		ZDBInlineDialog.closeDialogByType(el,event);
    	}
    	else
    	{
    		ZRSMInteg.handleDlgClose();
    		ZDBInlineDialog.closeDialog();
    	}
    }

    this.handleDlgClose = function()
    {
    	ZRConnector.removeTimeZoneComponent();
        var step = ZRSMInteg.step;
        switch(step)
        {
            case 1:
            {
                // Need to re-append the current step div in the hiddenHolder.
            	ZRSMInteg.cancelActivity(); 
            	break;
                     
            }
            case 2:
            {
                var dlg = ZRSMInteg.schSettingsDlg;
                dlg.parentNode.removeChild(dlg);       
                ZRSMInteg.cancelActivity();
                break;
            }           
            case 3:
            {
            	var dbId = $("ZRSMDBId").value; 
            	var dlg = ZRSMInteg.successInfoDlg;
            	dlg.parentNode.removeChild(dlg);
				window.url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + dbId; //No I18N            	
				setTimeout( "window.location.href = window.url;", 0);// jshint ignore:line
            	break; 
            }            
        }
        return true;
    };
    
    this.cancelActivity = function() 
    { 
   	  jQuery("#SMAuthSuccessMsg").css({"border":"1px","background-color":"rgb(150,255,65,0.4)","font-weight":"bold"});//NO I18N
   	  $("SMAUTHSUCCESS").style.display = "none";
   	  $("SMDBDetsSubmit").className="buttonCompBoxBg alpha";
      jQuery("#SMDBDetsSubmit").unbind('click'); //No I18N
    };
    
    this.showEditSchDlg = function(conndbinfoid)
    {
      AjaxAPI.sendRequest({URL:"/ZRSMEditSchDlg.cc?DBID="+ZDBClientUI.dbId+"&CONNDBINFOID=" + conndbinfoid,
    	  METHOD :"GET", 	//No I18N
          ONSUCCESSFUNC:ZRSMInteg.handleShowEditSchDlgSucc,
          OPSTATUSID:"ZDBMainLoader"}); //No I18N
        
    };
    
    this.handleShowEditSchDlgSucc = function(response,responseText)
    {
    	var div = document.createElement("div");
    	div.innerHTML = response.responseText;
        document.body.appendChild(div);
        ZDBDialogUtil.closeDialog();

        ZDBDialogUtil.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true,    //No I18N
        			ONCLOSE:ZRConnector.removeTimeZoneComponent,TITLE:ZDBI18NMap.f("zrpt.conn.js.edit.setup",ZDBI18NMap.g("zrpt.connector.js.surveymonkey"))});
        jQuery("#SMEditSchSubmit").click(function(){ ZRSMInteg.submitEditSchDets(this.form);}); //No I18N
        ZRConnector.setSchDetails();
        ZRConnector.setCleanupMonths();
        ZRConnector.checkIfAllSelOrDesel(null, 'SELECTALLSURVEYS', 'SMSurveysContainer');//No I18N
    };
    
    this.submitEditSchDets = function(frm)
    {
      if(!validateForm(frm))
      {
        return;
      }
      var atleastOneSelected = ZRSMInteg.checkIfOneSurveySelected();
      if(!atleastOneSelected)
      {
    	  return;
      }
      
      var params = "&SCHEDULETIME=" + ZRConnector.getSchTime() + "&DBID=" + ZDBClientUI.dbId + "&CONNDBINFOID=" + frm.CONNDBINFOID.value + "&CLEANUPMONTHS=" + ZRConnector.getCleanupMonths() //No I18N
      			+"&CONNECTORID=" + $("CONNECTORID").value + "&ZOHO_SELECTED_MODULES="+ ZRSMInteg.getSelectedSurveys(frm) + "&SCHTIMEZONE="+ ZRConnector.getSchTimeZone()+"&NEW_AUTO_SYNC="+frm.ADDNEWSURVEYSBYDEFAULT.checked; //No I18N
      AjaxAPI.sendRequest({URL:"/ConnectorAction.ma?&ZDBACTION=SAVEEDITSETTINGS",PARAMETERS:params, METHOD:"POST",
              ONSUCCESSFUNC:ZRSMInteg.handleSubmitEditSchSucc,OPSTATUSID:"SMEDITSCHOPTSTATUS"}); //No I18N
    };
    
    this.handleSubmitEditSchSucc = function(response, requestOptions)
    {
    	ZDBDialogUtil.closeDialog();
    	ZDBMsgBox.showSuccess(response.responseText);
    	ZRConnector.updateSchTypeNTime(response, requestOptions);
    };
    
    this.showEditLoginDlg = function(conndbinfoid)
    {
    	var params = "&DBID="+ZDBClientUI.dbId+"&CONNDBINFOID="+conndbinfoid;//No I18N
        AjaxAPI.sendRequest({URL:"/ZRSMValidity.cc?ZDBACTION=SMVALIDITY",
        			 PARAMETERS:params,
        	    	 METHOD :"GET", 	//No I18N
                     ONSUCCESSFUNC:ZRSMInteg.handleShowEditLoginDlgSucc,
                     OPSTATUSID:"ZDBMainLoader"}); //No I18N
    };
    
    this.handleShowEditLoginDlgSucc = function(response,responseText)
    {
    	var div = document.createElement("div");
        div.innerHTML = response.responseText;
        document.body.appendChild(div);
        ZDBDialogUtil.closeDialog();

        ZDBDialogUtil.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true, TITLE:ZDBI18NMap.f("zrpt.conn.js.reauth.title",ZDBI18NMap.g("zrpt.connector.js.surveymonkey"))});
    };
    
	this.successReAuth = function(response,requestOptions)
	{
		 var respArr = JSON.parse(response.responseText);
		 var status = respArr[0];
		 if(status === "SAMEUSER")
		 {
			 ZRSMInteg.updateSuccess();
		 }
		 if(status === "USERMISMATCH")
		 {
			 var connDBInfoId = respArr[1];
			 var userEmail = respArr[2];
			 var oldUserEmail = respArr[3];
			 var accessToken = respArr[4];
			 ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.surveymonkey.js.diffusermsg",oldUserEmail,userEmail,ZDBDomainAPI.getProductName()),"ZDBYESNO",//NO I18N
					 {ONCLICK:ZRSMInteg.confirmReAuth,CONNDBINFOID:connDBInfoId,ACCESSTOKEN:accessToken,EMAILID:userEmail},ZDBI18NMap.g("zrpt.zendesk.js.diffuserconfirm"));    //No I18N
		 }		 	
	};	
	
	this.confirmReAuth = function (clickType,requestOptions)
	{
		if(clickType != "YES")
		{
			return;
		}
		ZRSMInteg.updateDBDetails(requestOptions["CONNDBINFOID"],requestOptions["EMAILID"],requestOptions["ACCESSTOKEN"]);		
	};
	
	this.updateDBDetails = function (connDBInfoId,emailId,accessToken)
	{
		var params ="&DBID="+ZDBClientUI.dbId+"&CONNDBINFOID="+connDBInfoId+"&ACCESSTOKEN="+accessToken+"&EMAILID="+emailId; //No I18N           
      	AjaxAPI.sendRequest({URL:"/ZRSMAction.ma?&ZDBACTION=UPDATECONNINFO",PARAMETERS:params, METHOD:"POST",
              ONSUCCESSFUNC:ZRSMInteg.updateSuccess,OPSTATUSID:"ZDBMainLoader"}); //No I18N
	
	};
	
	this.updateSuccess = function(response,requestOptions)
	{
		if(response != null)
		{
			$("SMUserEmail").innerHTML = response.responseText;
		}
		var respDiv = jQuery("#SMLoginDetailsDlg").find("[elname='respDiv']");    // No I18N
		respDiv.html(ZDBI18NMap.f("zrpt.conn.js.reauthsuccessmsg",ZDBI18NMap.f("zrpt.connector.js.surveymonkey")));//NO I18N
		jQuery(respDiv).show("slow");   // No I18N
		$("validityState").style.color="green"; // NO I18N
		$("validityState").innerHTML="Active";//NO I18N
		if($("SMRevNote"))
		{
			$("SMRevNote").style.display="none";//NO I18N
		}
		setTimeout(function(){respDiv.hide("slow");},5000);
	};
	
	this.postListener = function(event)
	{
		var serverURL = $("SERVER_URL").value;
		if(event.origin === serverURL)
		{
			var data = event.data;
			ZRSMInteg.storeAuthCode(data.code, data.state);
		}
	};
	
};

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRSMInteg.showDBDetailsDlg"] = ZRSMInteg.showDBDetailsDlg ;//NO I18N
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRSMInteg.showEditSchDlg"] = ZRSMInteg.showEditSchDlg;//NO I18N
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRSMInteg.showEditLoginDlg"] = ZRSMInteg.showEditLoginDlg;//NO I18N

window.addEventListener("message", ZRSMInteg.postListener,true);//No I18N