//$Id$
var ZRZCampaignsIntegration = new function()
{
	
	this.initialize = function()
	{
		if(!ZRZCampaignsIntegration.initializeDone)
        {
			ZRZCampaignsIntegration.showDemoDlg = $("ZCAMPAIGNS_SHOW_DEMO").value;
			ZRZCampaignsIntegration.hiddenHolder = $("ZCAMPAIGNSHIDDENHOLDER");
			ZRZCampaignsIntegration.wizardHolder = $("ZCAMPAIGNSWIZARDHOLDER");
			ZRZCampaignsIntegration.demoDlg =  $("ZCampaignsDemoDlg");
			ZRZCampaignsIntegration.hiddenHolder.appendChild(ZRZCampaignsIntegration.demoDlg);
			ZRZCampaignsIntegration.dbDetailsDlg = $("ZCampaignsDBDetailsDlg");
			ZRZCampaignsIntegration.hiddenHolder.appendChild(ZRZCampaignsIntegration.wizardHolder);
			ZRZCampaignsIntegration.hiddenHolder.appendChild(ZRZCampaignsIntegration.dbDetailsDlg);
			ZRZCampaignsIntegration.initializeDone = true;
        }
	}
	
	this.setDlgTitle = function()
    {
        var title = "";
        var desc = "";
        switch(ZRZCampaignsIntegration.step)
        {
            case 1:
                title = ZDBI18NMap.f("zrpt.conn.js.demo.title",ZDBI18NMap.g("zrpt.connector.js.zcampaigns"));
                break;
            case 2:
                title = ZDBI18NMap.f("zrpt.conn.js.setupdlg.step1.title",ZDBI18NMap.g("zrpt.connector.js.zcampaigns"));
                desc = ZDBI18NMap.f('zrpt.conn.js.createdbdesc',ZDBI18NMap.g('zrpt.connector.js.zcampaigns'));                     
                break;
            case 3:
            	title = ZDBI18NMap.f("zrpt.conn.js.dbsuccess.title",ZDBI18NMap.g("zrpt.connector.js.zcampaigns"));
                desc = ZDBI18NMap.f("zrpt.conn.js.dbsuccess.desc",ZDBI18NMap.g("zrpt.connector.js.zcampaigns"));
                break;
        }
        $("ZDBZCAMPAIGNSIMPORTDLGTITLE").innerHTML = title;
        $("ZDBZCAMPAIGNSMPORTDLGDESC").innerHTML = desc;
    }
	
	this.dlgCloseActivity = function()
    {
        switch(ZRZCampaignsIntegration.step)
        {
        case 1:
            break;
        case 2:
            {
                hideCustomMessage();
                break;
            }
        case 3:
            { 
        		var dlg = ZRZCampaignsIntegration.successInfoDlg;
        		dlg.parentNode.removeChild(dlg);
            
        		window.url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + ZRZCampaignsIntegration.destDBID; //No I18N
        		setTimeout( "window.location.href = window.url;", 0);// jshint ignore:line
        		break
            }
        }
        return true;
    }
	
	this.showDBDetailsDlg = function()
	{
		if(!ZDBLazyLoadUtil.loadSnippet("ZRZCAMPAIGNS_IMPORT_DLG","/ZRZCampaignsDBDetailsDlg.cc?ZDBACTION=ZCAMPAIGNSLIST",this,"APPENDTODOC",null,null,null,null))
        {
            return;
        }
		ZRZCampaignsIntegration.isExpiredUser = $("ZCAMPAIGNS_EXPIRED_USER").value
		if(ZRZCampaignsIntegration.isExpiredUser === "true")
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.conn.js.userexpired.msg",ZDBI18NMap.f("zrpt.connector.js.zcampaigns"),ZDBGlobal.PRODUCTNAME));
        	return;
		}
		ZRZCampaignsIntegration.isFreshUser = $("ZCAMPAIGNS_IS_NOT_USER").value;
        if(ZRZCampaignsIntegration.isFreshUser === "true")
        {
        	var infoDlg =  $("ZCampaignsTrialInfo");
        	infoDlg.style.display = "" ;
        	ZDBDialogUtil.showDialog(infoDlg,{TITLE:ZDBI18NMap.f("zrpt.conn.js.title_trial",ZDBGlobal.PRODUCT_NAME,ZDBI18NMap.g("zrpt.connector.js.zcampaigns")), ADDFRAME:true,MODAL:true,DONTREMOVE:true});
        }
        else
        {
        	ZRZCampaignsIntegration.initializeAndShowDBDetailsDlg();
        }
	}
	
	this.initializeAndShowDBDetailsDlg = function()
	{
		ZDBDialogUtil.closeDialog();
		ZRZCampaignsIntegration.initialize();
		ZRZCampaignsIntegration.initFuncs();
		if(ZRZCampaignsIntegration.showDemoDlg === "true")
        {
			ZRZCampaignsIntegration.showZCampaignsDemoDlg();
            ZDBDialogUtil.showDialog(ZRZCampaignsIntegration.demoDlg,{TITLE:ZDBI18NMap.f("zrpt.conn.js.demo.title",ZDBI18NMap.g("zrpt.connector.js.zcampaigns")),
                    ADDFRAME:true,DONTREMOVE:true, MODAL:true,ONCLOSE:ZRZCampaignsIntegration.dlgCloseActivity});
        }
		else
		{
			ZRZCampaignsIntegration.step = 2;
			ZRZCampaignsIntegration.showZCampaignsDBDetailsDlg();
			ZDBFullPageDialog.showDialog(ZRZCampaignsIntegration.wizardHolder,{ADDFRAME:true,DONTREMOVE:true, 
	            											MODAL:true, ONCLOSE:ZRZCampaignsIntegration.dlgCloseActivity});
			ZRZCampaignsIntegration.setDlgTitle();
		}
	}
	
	this.initFuncs = function()
    {
        jQuery("#ZCAMPAIGNSSKIPDEMO").click(function(){ZRZCampaignsIntegration.submitDemoDlg(); }); //No I18N 
        jQuery("#ZCampaignsDBCancel").click(function(){ZDBInlineDialog.closeDialogByType(this); });  //NO I18N
    }
	
	this.showZCampaignsDemoDlg = function()
    {
		ZRZCampaignsIntegration.step = 1;
		ZRZCampaignsIntegration.hiddenHolder.appendChild(ZRZCampaignsIntegration.dbDetailsDlg);
		ZRZCampaignsIntegration.wizardHolder.appendChild(ZRZCampaignsIntegration.demoDlg); 
    }
	
	this.submitDemoDlg = function()
    {
        if($("ZDBShowDemoCheck").checked)
        {
        	ZRZCampaignsIntegration.showDemoDlg = false;
            var url = "/ConnectorAction.ma?ZDBACTION=DONTSHOWDEMODLG&CONNECTORID=23"; //No I18N
            AjaxAPI.sendRequest({URL:url});
        }
        ZDBDialogUtil.closeDialog();
        ZRZCampaignsIntegration.showZCampaignsDBDetailsDlg();
    }
	
	this.showZCampaignsDBDetailsDlg = function()
	{
		ZRZCampaignsIntegration.step = 2;
		ZRZCampaignsIntegration.hiddenHolder.appendChild(ZRZCampaignsIntegration.demoDlg);
		ZRZCampaignsIntegration.wizardHolder.appendChild(ZRZCampaignsIntegration.dbDetailsDlg);
		if(ZRZCampaignsIntegration.existImport)
		{
			ZDBInlineDialog.showDialog(ZRZCampaignsIntegration.wizardHolder,{ADDFRAME:true,DONTREMOVE:true, MODAL:true,ONCLOSE:ZRZCampaignsIntegration.dlgCloseActivity,TITLE:ZDBI18NMap.f("zrpt.conn.js.setupdlg.title",ZDBI18NMap.g("zrpt.connector.js.zcampaigns"))});
			ZRZCampaignsIntegration.modifyPropsForExistImport();
		}
		else
		{
			ZDBUtil.setFocus("ZCAMPAIGNSDATABASENAME",true); //No I18N
	        ZDBFullPageDialog.showDialog(ZRZCampaignsIntegration.wizardHolder,{ADDFRAME:true,DONTREMOVE:true, MODAL:true,
	        								ONCLOSE:ZRZCampaignsIntegration.dlgCloseActivity});
		}
		ZRZCampaignsIntegration.setDlgTitle();
		ZRZCampaignsIntegration.showTimePeriodCampaigns(3);
        $("ZCAMPAIGNSDBDetailsSubmit").onclick=function () {ZRZCampaignsIntegration.createDB(this.form);};
        ZRConnector.changeSchTimeToCurrentTime();
	}
	
	this.modifyPropsForExistImport = function()
	{
		$("ZCampaignsDlgTitle").className = "";
		jQuery('#genDetails').hide();  //NO I18N
		$("ZCampaignsDlgTitle").style.padding="15px 15px 15px 25px";
		$("GenInfo").style.padding = "0px 110px 0px 0px";
	}
	
	this.showExistImpDBDetailsDlg = function()
	{
		ZRZCampaignsIntegration.existImport = true;
		ZRZCampaignsIntegration.showDBDetailsDlg();
	}
	
	this.showTimePeriodCampaigns = function(period)
	{
		var currDate = new Date();
		if(period == 0)
		{
			currDate = new Date(0);
		}
		else
		{
			currDate.setMonth(currDate.getMonth() - period);
		}
		var noCampaigns = true;
		jQuery('div#ZCAMPAIGNSCONTAINER input[type=checkbox]').each(function() {//NO I18N
        	var campId = jQuery(this).attr('value');  //NO I18N
        	var sentTime = jQuery(this).attr('senttime');  //NO I18N
        	var sentTimeArr = sentTime.split(" ");
        	var date = sentTimeArr[0];
        	var time = sentTimeArr[1];
        	var timeArr = time.split(":");
        	var dateArr = date.split("-");
        	var campSentDate = new Date(dateArr[2], dateArr[1]-1, dateArr[0], timeArr[0], timeArr[1], timeArr[2], 0);
        	var divId = "ZCampaign" + campId;  //NO I18N
        	if(campSentDate < currDate)
        	{
        		this.checked = false;
        		$(divId).style.display = 'none';
        	}
        	else
        	{
        		noCampaigns = false;
        		$(divId).style.display = '';
        		$("ZNoCampaignMsg").style.display='none';
        	}
    	    });
		if(noCampaigns)
		{
			$("ZNoCampaignMsg").style.display='';
		}
	}
	
	this.createDB = function(form)
	{
		var loader = $("ZCampaignsLOADER");
		var campaigns = ZRConnector.getSelectedModulesAlone(form, "ZCAMPAIGNSCONTAINER");  //NO I18N
		var orgId = $("ORGID").value;
		var orgName = $("ORGNAME").value;
		if(campaigns === '[]')
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.zcampaignsinteg.js.nocampaignselected.alert"));
		}
		else
		{
			var autoSync = false;
			if($("SubmitAutoSync").checked)
			{
				autoSync = true;
			}
			var modules = ZRConnector.getSelectedModulesAlone(form, "ZCampaignsModContainer");  //NO I18N
			var params = "&SCHEDULETIME=" + ZRConnector.getSchTime() + "&AUTO_SYNC=" + autoSync +  //NO I18N
			 "&SCHTIMEZONE="+ZRConnector.getSchTimeZone() +  //NO I18N
			 "&SELECTEDCAMPAIGNS=" + campaigns +"&ZOHO_SELECTED_MODULES=" + modules + "&ORGID=" + orgId + "&ORGNAME=" + orgName + "&CLEANUPMONTHS=" + ZRConnector.getCleanupMonths();  //NO I18N
			if(!ZRZCampaignsIntegration.existImport)
			{
				params += "&DATABASENAME=" + encodeURIComponent($("ZCAMPAIGNSDATABASENAME").value) + //No I18N
				 "&DATABASEDESC=" + encodeURIComponent($("ZCAMPAIGNSDATABASEDESC").value) + "&EXISTIMPORT=false";  //NO I18N
			}
			else
			{
				params += "&EXISTIMPORT=true" + "&DBID=" + ZDBClientUI.dbId;  //NO I18N
			}
			AjaxAPI.sendRequest({URL:"/ZRZCampaignsDBSuccDlg.cc?&ZDBACTION=ZCAMPAIGNSCREATEDB", PARAMETERS:params,
								ONSUCCESSFUNC:ZRZCampaignsIntegration.showSuccessDBDlg, OPSTATUSID:loader}); 
		}
	}
	
	this.showSuccessDBDlg = function(response,responseText)
    {
		ZRZCampaignsIntegration.step = 3;
        var div = document.createElement("div");
        div.innerHTML = response.responseText;
        ZRZCampaignsIntegration.successInfoDlg = div;
        ZRZCampaignsIntegration.dbDetailsDlg.parentNode.removeChild(ZRZCampaignsIntegration.dbDetailsDlg);
        ZRZCampaignsIntegration.wizardHolder.appendChild(ZRZCampaignsIntegration.successInfoDlg);    
        ZRZCampaignsIntegration.setDlgTitle();
        ZRZCampaignsIntegration.destDBID = $("ZCAMPAIGNSDBID").value;
    }
	
	/* ###################################################################################################
     * ############################## Import Flow Completed ###############################
     * ###################################################################################################*/
	
	this.showEditFieldsDlg = function(connDBInfoId)
    {
		ZRZCampaignsIntegration.CONNDBINFOID = connDBInfoId;
        AjaxAPI.sendRequest({URL:"/ZRZCampaignsEditFieldsDlg.cc?ZDBACTION=ZCAMPAIGNSEDITSETUP&DBID="+ZDBClientUI.dbId+"&CONNDBINFOID="+connDBInfoId,
        	METHOD :"GET",	//No I18N
            ONSUCCESSFUNC:ZRZCampaignsIntegration.handleShowEditFieldsDlgSucc,
            ONFAILUREFUNC:ZRZCampaignsIntegration.handleShowEditFieldsDlgFail,
            OPSTATUSID:"ZDBMainLoader"}); //No I18N
    }
	
	this.handleShowEditFieldsDlgSucc = function(response, responseText)
	{
		var div = document.createElement("div");
        div.innerHTML = response.responseText;
        document.body.appendChild(div);
        ZDBDialogUtil.closeDialog();
 
        ZDBDialogUtil.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true,
                              TITLE:ZDBI18NMap.f("zrpt.conn.js.edit.setup",ZDBI18NMap.g("zrpt.connector.js.zcampaigns"))});     //NO I18N
        jQuery("#ZCampaignsEditFieldSubmit").click(function(){ZRZCampaignsIntegration.submitEditFieldsDets(this.form);}); //No I18N
        ZRConnector.setSchDetails();
        ZRZCampaignsIntegration.toggleCleaupDiv();
	}
	
	this.toggleCleaupDiv = function()
	{
		var cleanupOptions = $("CLEANUPSELECT")
		for (var i = 0; i < cleanupOptions.options.length; i++) 
		{
			if (cleanupOptions.options[i].value === $("ZCAMPAIGNSCLEANUP").value)
			{
				cleanupOptions.options[i].selected = true;
		        return;
		    }
		}
	}
	
	this.handleShowEditFieldsDlgFail = function(response, reponsetext)
	{
		var errCode = response.getResponsePart("ERRORCODE");
        var errMsg = response.getResponsePart("STATUS_MESSAGE");
        errCode = trimAll(errCode);
        ZDBAlertAPI.showMsg(errMsg);
	}
	
	this.submitEditFieldsDets = function(form)
	{
		var loader = $("ZCAMPAIGNSEDITFIELDOPTSTATUS");
		var campaigns = ZRConnector.getSelectedModulesAlone(form, "ZCAMPAIGNSCONTAINER");  //NO I18N
		if(campaigns === '[]')
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.zcampaignsinteg.js.nocampaignselected.alert"));
		}
		var autoSync = false;
		if($("SubmitAutoSync").checked)
		{
			autoSync = true;
		}
		var modules = ZRConnector.getSelectedModulesAlone(form, "ZCampaignsModContainer");  //NO I18N
		var params =  "&SCHEDULETIME=" + ZRConnector.getSchTime(form) + "&SCHTIMEZONE="+ ZRConnector.getSchTimeZone() //No I18N  
		  + "&DBID=" + form.ZOHO_DBID.value + "&NEW_AUTO_SYNC=" + autoSync + "&CONNDBINFOID=" + form.ZOHO_CONNDBINFOID.value + "&CONNECTORID=23"  //NO I18N
		  +"&ZOHO_SELECTED_MODULES=" + modules + "&CLEANUPMONTHS=" + ZRConnector.getCleanupMonths() + "&SUBENTITIES="+campaigns; //No I18N
		AjaxAPI.sendRequest({URL:"/ConnectorAction.ma?&ZDBACTION=SAVEEDITSETTINGS", PARAMETERS:params,  //No I18N 
			ONSUCCESSFUNC:ZRZCampaignsIntegration.handleSubmitFieldDetSucc,OPSTATUSID: loader});
	}
	
	this.handleSubmitFieldDetSucc = function(response, requestOptions)
	{
		ZRConnector.alertIfNeeded(response,requestOptions);
		ZRConnector.updateSchTypeNTime(response, requestOptions);
	}
	
	this.searchCampaigns = function()
    {
        var searchPagesElem = $("ZSearchCampaigns");
        var containerDivId = searchPagesElem.getAttribute("searchdivid");
        var attr = "search"; //No I18N
        var basedOnTag = "input"; //No I18N
        ZDBClientUtil.searchAndDisplay(containerDivId,basedOnTag,attr,searchPagesElem,$("ZNoCampaignMsg"));         
    }
	
}
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRZCampaignsIntegration.showDBDetailsDlg"] = ZRZCampaignsIntegration.showDBDetailsDlg;//NO I18N
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRZCampaignsIntegration.showEditFieldsDlg"] = ZRZCampaignsIntegration.showEditFieldsDlg;//NO I18N
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRZCampaignsIntegration.showExistImpDBDetailsDlg"] = ZRZCampaignsIntegration.showExistImpDBDetailsDlg;//NO I18N