//$Id$

var WidgetChartConstants = new function () {

    //Data Tab Constants
    this.LEGEND_GROUPBY_OPERATION = "chart.legend.operation";//NO I18N
    this.LEGEND_VALUE = "chart.legend.value";//NO I18N
    this.LEGEND_VALUE_UNITS = "chart.legend.units";//NO I18N
    this.TARGET_MARKER_GROUPBY_OPERATION = "chart.targetMarker.operation";//NO I18N
    this.MAXIMUM_RANGE_GROUPBY_OPERATION = "chart.maxRange.operation";//NO I18N
    this.TARGET_MARKER_VALUE_UNITS = "chart.targetMarker.units";//NO I18N
    this.MAXIMUM_RANGE_VALUE = "chart.axes.yaxis[0].maxRange";//NO I18N
    this.MAXIMUM_RANGE_VALUE_UNITS = "chart.maxRange.units";//NO I18N
    this.LEVEL_MARKER_UNITS = "chart.leverMarker.units";//NO I18N
    this.TARGET_MARKER_VALUE = "chart.targetMarker.value";//NO I18N
    
    //View Type
    this.VIEWTYPE_GROUP_VALUE = "GROUP";//NO I18N
    this.VIEWTYPE_THRESHOLD_VALUE = "THRESHOLD";//NO I18N
    this.VIEWTYPE_TEXTAXIS_VALUE = "TEXTAXIS";//NO I18N
    this.VIEWTYPE_YAXIS_VALUE = "YAXIS";//NO I18N
    this.VIEWTYPE_YAXIS_INSTKEY = 2;
    this.VIEWTYPE_GROUP_INSTKEY = 1;
    this.VIEWTYPE_THRESHOLD_INSTKEY = 2;
    this.VIEWTYPE_TEXTAXIS_INSTKEY = 3;

    //Chart Settings Constants
    this.RANGES_ENABLE = "chart.ranges.enabled";//NO I18N
    this.RANGES_UNITS = "chart.ranges.units";//NO I18N
    this.MAXIMUM_RANGE_COLOR = "chart.plot.plotoptions.bullet.levelMarker.color[0]";//NO I18N
    this.RANGE_ONE = "chart.plot.plotoptions.bullet.levelMarker.value[1]";//NO I18N
    this.RANGE_ONE_COLOR = "chart.plot.plotoptions.bullet.levelMarker.color[1]";//NO I18N
    this.RANGE_TWO = "chart.plot.plotoptions.bullet.levelMarker.value[2]";//NO I18N
    this.RANGE_TWO_COLOR = "chart.plot.plotoptions.bullet.levelMarker.color[2]";//NO I18N
    this.RANGE_THREE = "chart.plot.plotoptions.bullet.levelMarker.value[3]";//NO I18N
    this.RANGE_THREE_COLOR = "chart.plot.plotoptions.bullet.levelMarker.color[3]";//NO I18N
    this.RANGE_FOUR = "chart.plot.plotoptions.bullet.levelMarker.value[4]";//NO I18N
    this.RANGE_FOUR_COLOR = "chart.plot.plotoptions.bullet.levelMarker.color[4]";//NO I18N
    this.RANGE_FIVE = "chart.plot.plotoptions.bullet.levelMarker.value[5]";//NO I18N
    this.RANGE_FIVE_COLOR = "chart.plot.plotoptions.bullet.levelMarker.color[5]";//NO I18N

    this.TITLE_TEXT = "canvas.title.text";//NO I18N
    this.LEGEND_COLORS = "legend.colors";//NO I18N
    this.LEGEND_BANDWIDTH = "chart.plot.plotoptions.bullet.bandWidth";//NO I18N
    this.TARGET_MARKER_LABEL_ENABLE = "chart.plot.plotoptions.bullet.targetMarker.label.enabled";//NO I18N
    this.TARGET_MARKER_DASH_STYLE = "chart.plot.plotoptions.bullet.targetMarker.dashStyle";//NO I18N
    this.TARGET_MARKER_COLOR = "chart.plot.plotoptions.bullet.targetMarker.color";//NO I18N
    this.TARGET_MARKER_SIZE = "chart.plot.plotoptions.bullet.targetMarker.size";//NO I18N
    this.NEEDLE_TYPE = "chart.plot.plotoptions.dial.needle.type";//NO I18N
    this.NEEDLE_STROKE_COLOR = "chart.plot.plotoptions.dial.needle.strokeColor";//NO I18N
    this.NEEDLE_FILL_COLOR = "chart.plot.plotoptions.dial.needle.fillColor";//NO I18N
    this.NEEDLE_WIDTH = "chart.plot.plotoptions.dial.needle.width";//NO I18N
    this.ORIENTATION = "chart.axes.rotated";//NO I18N
    this.TICK_LABEL = "chart.axes.yaxis[0].show";//NO I18N
    this.MIN_MAX_LABEL = "chart.plot.plotoptions.dial.minmaxlabels.show";//NO I18N
    this.DATA_LABEL = "chart.plot.plotoptions.bullet.datalabels.show";//NO I18N
    this.LEVER_MARKER_BANDWIDTH = "chart.plot.plotoptions.bullet.levelMarker.bandWidth";//NO I18N
    this.RANGES_KEYS = [this.RANGE_ONE, this.RANGE_TWO, this.RANGE_THREE, this.RANGE_FOUR, this.RANGE_FIVE];

    this.DEFAULT_TYPE = 'bullet';//NO I18N
    this.DEFAULT_VALUE_PERCENT = 100;
    this.DEFAULT_MAXIMUM_RANGE_PERCENT = 0;
    this.DEFAULT_TARGET_PERCENT = 0;
    this.DEFAULT_DATA_COLOR = '#4682b4';//NO I18N
    this.DEFAULT_MAX_RANGE_COLOR = '#E5E5E5';//NO I18N
    this.DEFAULT_DATA_BANDWIDTH_BULLET = 40;
    this.DEFAULT_DATA_BANDWIDTH_DIAL= 30;
    this.DEFAULT_LEVEL_MARKER_COLOR = ['#c8c8c8', '#d6d6d6', '#e5e5e5', '#e0e0e0', '#f4f4f4'];//NO I18N
    this.DEFAULT_LEVEL_MARKER_BANDWIDTH_BULLET = 60;
    this.DEFAULT_LEVEL_MARKER_BANDWIDTH_DIAL = 40;
    this.BULLET_CHART_BANDWIDTH_KEY = 'chart.plot.plotoptions.bullet.bandWidth';//NO I18N
    this.BULLET_LEVEL_MARKER_BANDWIDTH_KEY = 'chart.plot.plotoptions.bullet.levelMarker.bandWidth';//NO I18N
    this.BULLET_CHART_LEGEND_COLOR_KEY = 'legend.colors';//NO I18N
    this.BULLET_LEVEL_MARKER_COLOR_KEY = 'chart.plot.plotoptions.bullet.levelMarker.color';//NO I18N
    this.PREVIEW_RANGE_COLORS = ['#e5e5e5', '#c8c8c8', '#d6d6d6','#e0e0e0', '#f4f4f4'];//NO I18N
    this.DEFAULT_TARGET_MARKER_COLOR = '#808080';//NO I18N
    this.DEFAULT_TARGET_MARKER_SIZE = 3;
    this.DEFAULT_TARGET_MARKER_DASHSTYLE = 'solid';//NO I18N
    this.DEFAULT_TARGET_MARKER_DASHWIDTH = '1';//NO I18N
    this.DEFAULT_NEEDLE_TYPE = 'round';//NO I18N
    this.DEFAULT_NEEDLE_FILLCOLOR = '#808080';//NO I18N
    this.DEFAULT_NEEDLE_STROKECOLOR = '#000000';//NO I18N
    this.DEFAULT_NEEDLE_WIDTH = 5;
    this.DEFAULT_COLOR = '#000000';//NO I18N
    this.RANGES_COLOR_FORMAT = "chart.plot.plotoptions.bullet.levelMarker.color[$]";//NO I18N
    this.RANGES_VALUE_FORMAT = "chart.plot.plotoptions.bullet.levelMarker.value[$]";//NO I18N
    this.BULLET_DATA = [
        "Customers", //NO I18N
        7,
        [
            10,
            2.5,
            5
        ],
        8
    ];
    this.DIAL_DATA = [
        "Customers", //NO I18N
        8,
        [
            10
        ],
        9
    ];
    this.DEFAULT_RANGES = {};
    this.DEFAULT_RANGES[this.RANGE_ONE] = '25';//NO I18N
    this.DEFAULT_RANGES[this.RANGE_ONE_COLOR] = '13158600';//NO I18N
    this.DEFAULT_RANGES[this.RANGE_TWO] = '50';//NO I18N
    this.DEFAULT_RANGES[this.RANGE_TWO_COLOR] = '14079702';//NO I18N
    this.DEFAULT_RANGES[this.RANGE_THREE] = '';//NO I18N
    this.DEFAULT_RANGES[this.RANGE_THREE_COLOR] = '';//NO I18N
    this.DEFAULT_RANGES[this.RANGE_FOUR] = '';
    this.DEFAULT_RANGES[this.RANGE_FOUR_COLOR] = '';
    this.DEFAULT_RANGES[this.RANGE_FIVE] = '';
    this.DEFAULT_RANGES[this.RANGE_FIVE_COLOR] = '';
    this.DATA_OPERATIONS_EL_KEYS = ['LEGEND', 'THRESHOLD', 'TEXTAXIS'];//NO I18N 
    this.DATA_OPERATION_KEYS = [this.LEGEND_GROUPBY_OPERATION, this.TARGET_MARKER_GROUPBY_OPERATION, this.MAXIMUM_RANGE_GROUPBY_OPERATION];
    this.getBulletChart= function(){
    	return {
            "seriesdata": {//NO I18N
                "chartdata": [//NO I18N
                    {
                        "type": "bullet", //NO I18N
                        "yaxiscolumnorder": [//NO I18N
                            0
                        ],
                        "data": [//NO I18N
                            [
                                [
                                    "Customers", //NO I18N
                                    77100,
                                    [
                                        30000,
                                        50000,
                                        100000
                                    ],
                                    85000
                                ]
                            ]
                        ]
                    }
                ]
            },
            "metadata": {//NO I18N
                "columns": [//NO I18N
                    {
                        "dataindex": 1, //NO I18N
                        "columnname": "", //NO I18N
                        "datatype": "numeric"//NO I18N
                    },
                    {
                        "dataindex": 0, //NO I18N  
                        "columnname": "Customers",//NO I18N
                        "datatype": "ordinal"//NO I18N
                    },
                    {
                        "dataindex": 2, //NO I18N
                        "columnname": "Ranges", //NO I18N
                        "datatype": "numeric"//NO I18N
                    },
                    {
                        "dataindex": 3, //NO I18N
                        "columnname": "Target", //NO I18N
                        "datatype": "numeric"//NO I18N
                    }
                ],
                "axes": {//NO I18N
                    "x": [//NO I18N
                        0
                    ],
                    "y": [//NO I18N
                        [
                            0
                        ]
                    ],
                    "tooltip": [0, 3, 2]
                }
            },
            "chart": {//NO I18N
            	"fontSize": 13, //NO I18N
                "fontColor": "#404040", //NO I18N
                "fontFamily": "Proxima Nova",//NO I18N
                "axes": {//NO I18N
                    "rotated": true, //NO I18N
                    "xaxis": {//NO I18N
                        "show": false//NO I18N
                    },
                    "yaxis": [//NO I18N
                        {
                            "label": {//NO I18N
                                "show": false//NO I18N
                            },
                            "grid": {//NO I18N
                                "color": "transparent"//NO I18N
                            },
                            "axisline": {//NO I18N
                                "show": false//NO I18N
                            },
                            "ticklabel": {//NO I18N
                                "rotation": 0, //NO I18N
                                "fontSize": 13, //NO I18N
                                "fontColor": "#404040", //NO I18N
                                "fontFamily": "Proxima Nova",//NO I18N
                                "maxWidth": null,//NO I18N
                                "minmaxlabels": {//NO I18N
                                    "show": true//NO I18N
                                }
                            },
                            "show": false//NO I18N
                        }
                    ]
                },
                "plot": {//NO I18N
                    "plotoptions": {//NO I18N
                        "bullet": {//NO I18N
                            "levelMarker": {//NO I18N
                            	"dataindex": 2, //NO I18N
                                "color": [//NO I18N
                                    "#f0f0f0", //NO I18N
                                    "#c8c8c8", //NO I18N
                                    "#e5e5e5", //NO I18N
                                    "#e5e5e5", //NO I18N
                                    "#fff", //NO I18N
                                    "#fff"//NO I18N
                                ],
                                "bandWidth": 60//NO I18N
                            },
                            "bandWidth": 40, //NO I18N
                            "legendHighlightEffect": {}, //NO I18N
                            "datalabels": {//NO I18N
                                "show": true, //NO I18N
                                "fontSize": 13, //NO I18N
                                "fontColor": "#ffffff", //NO I18N
                                "fontFamily": "Proxima Nova"//NO I18N
                            },
                            "targetMarker": {//NO I18N
                            	"outerStrokeWidth": 3, //NO I18N
                                "dataindex": 3, //NO I18N
                                "outerStrokeColor" : "#808080", //NO I18N
                                "dashStyle": "solid", //NO I18N
                                "strokeWidth": 1, //NO I18N
                                "enabled": true,//NO I18N
                            	"label" : { //NO I18N
                            		"enabled" : false, //NO I18N
                            		"fontSize" : 12 //NO I18N
                            	},
                            },
                            "events": {//NO I18N
                                "cursor": "default"//NO I18N
                            }
                        }
                    },
                    "animation": {//NO I18N
                        "enabled": true//NO I18N
                    }
                },
                "marginTop": 10, //NO I18N
                "marginRight": 5, //NO I18N
                "marginBottom": 7, //NO I18N
                "marginLeft": 5//NO I18N
            },
            "legend": {//NO I18N
                "colors": [//NO I18N
                    "#4682B4"//NO I18N
                ]
            },
            "canvas": {//NO I18N
                "title": {//NO I18N
                    "show": false//NO I18N
                },
                "subtitle": {//NO I18N
                    "show": false//NO I18N
                },
                "border": {//NO I18N
                    "show": false//NO I18N
                },
                "shadow": {//NO I18N
                    "show": false//NO I18N
                },
                "background": {//NO I18N
                },
                "theme": "th_zohoreports",//NO I18N
                events : {
                	onload : function(e, obj){
                		obj.firstLoad = true;
                	} 
                }
                	
            },
            "tooltip": {//NO I18N
                "enabled": true, //NO I18N
                "footerContent": null, //NO I18N
                "maxWidth": "1000%" //NO I18N
            }
        };
    };
    this.getDialChart = function(){
    	return {
            "seriesdata": {//NO I18N
                "chartdata": [{//NO I18N
                        "type": 18, //NO I18N
                        "yaxiscolumnorder": [//NO I18N
                            0
                        ],
                        "data": [//NO I18N
                            [
                                [
                                    "i10", //NO I18N
                                    11.5
                                ]
                            ]
                        ]
                    }]
            },
            "metadata": {//NO I18N
                "axes": {//NO I18N
                    "x": [//NO I18N
                        0
                    ], 
                    "y": [//NO I18N
                        [
                            1
                        ]
                    ],
                    "tooltip": [//NO I18N
                        0,
                        1
                    ]
                },
                "columns": [{//NO I18N
                        "dataindex": 0, //NO I18N
                        "datatype": "ordinal"//NO I18N
                    }, {
                        "dataindex": 1, //NO I18N
                        "datatype": "numeric"//NO I18N
                    }]
            },
            "chart": {//NO I18N
            	"fontSize": 13, //NO I18N
                "fontColor": "#404040", //NO I18N
                "fontFamily": "Proxima Nova",//NO I18N
                "axes": {//NO I18N
                    "yaxis": [{//NO I18N
                            "show": false, //NO I18N
//                            "maxRange": 30//NO I18N
                        }]
                },
                "plot": {//NO I18N
                    "plotoptions": {//NO I18N
                        "dial": {//NO I18N
                        	"datalabels": {//NO I18N
                                "show": true, //NO I18N
                                "y" : function(d, chartObj, bbox){//NO I18N
                                    return chartObj.plotarea_approx.y - (chartObj.plotarea_approx.innerRadius / 2) + (bbox.height / 2);
                                }
                            },
                            "minmaxlabels": {//NO I18N
                                "show": false, //NO I18N
                                "fontFamily": "Proxima Nova"//NO I18N
                            },
                            "targetMarker": {//NO I18N
                            	
                                "dataindex": 3, //NO I18N
                                "color": [//NO I18N
                                    "grey"//NO I18N
                                ],
                                "dashStyle": "solid", //NO I18N
                                "outerStrokeWidth": 3, //NO I18N
                                "outerStrokeColor" : "#808080", //NO I18N
                                "enabled": true,//NO I18N
                            	"label" : {//NO I18N
                            		"enabled" : false//NO I18N
                            	}
                            },
                            
                            "needle": {//NO I18N
                                "width": 5, //NO I18N
                                "strokeColor": "#000000", //NO I18N
                                "fillColor": "#808080"//NO I18N
                            },
                            "levelMarker": {//NO I18N
                                "dataindex": 2, //NO I18N
                                "enabled": true, //NO I18N
                                "color": [//NO I18N
                                    "#f0f0f0", //NO I18N
                                    "#c8c8c8", //NO I18N
                                    "#e5e5e5", //NO I18N
                                    "#e5e5e5", //NO I18N
                                    "#fff", //NO I18N
                                    "#fff"//NO I18N
                                ],
                                "bandWidth": 40//NO I18N
                            },
                            "bandWidth": 30, //NO I18N
                            "events" : {//NO I18N
                            	"enabled" : true//NO I18N
                            },
                            "outerPadding" : 5 //NO I18N
                        }
                    },
                    "animation": {//NO I18N
                        "enabled": true//NO I18N
                    }
                },
                "marginTop": 0, //NO I18N
                "marginRight": 5, //NO I18N
                "marginBottom": 5, //NO I18N
                "marginLeft": 5//NO I18N
            },
            "legend": {//NO I18N
                "colors": [//NO I18N
                    "#4682B4"//NO I18N
                ]
            },
            "canvas": {//NO I18N
                "title": {//NO I18N
                    "show": false//NO I18N
                },
                "subtitle": {//NO I18N
                    "show": false//NO I18N
                },
                "border": {//NO I18N
                    "show": false//NO I18N
                },
                "shadow": {//NO I18N
                    "show": false//NO I18N
                },
                "background": {//NO I18N
                    "color": "transparent"//NO I18N
                },
                "theme": "th_zohoreports",//NO I18N
                events : {
                	onload : function(e, obj){
                		obj.firstLoad = true;
                	} 
                }
            },
            "tooltip": {//NO I18N
                "enabled": true, //NO I18N
                "footerContent": null, //NO I18N
                "maxWidth": "1000%" //NO I18N
            }
        };
    };
};
