//$Id$

var ZDBEditModeSelect = new function()
{
    this.curEl = null;//
    this.borderAdjust = (BROWSER.IE)?0:2;
    this.editOptsEl = null;//The static cached reference to edit menu.

    var _this = this;

    this.showEditOptsMenuEl = function(el,ev)
    {
//    	if(_this.menuExpanded){
//    		return;
//    	}
        var cur = ZDBDashEdit.getCurEditState();
        var curDashChild = ZDBUtil.getParentWithAttr(el,"isDashBoardDiv");    //No I18N
        curDashChild.det = null;
        curDashChild.oldDet = null;
        _this.positionVerticalResizer(curDashChild,cur);
         ZDBUtil.stopEventBubble(ev);
        if(cur.mode != "select" || _this.curEl == el)
        {
            return;
        }
        ZDBTxtIndicator.hideHighlight();
        _this.hideOptsMenu();
        _this.curEl = el;
        var editOptsEl = _this.editOptsEl;
        if(editOptsEl == null)
        {
            editOptsEl = $("ZDBDashEditOptsMenu");
            _this.editOptsEl = editOptsEl;
            ZDBUtil.setNamedChildEls(editOptsEl,editOptsEl);
        }
        else if(editOptsEl.parentNode)
        {
            editOptsEl.parentNode.removeChild(editOptsEl);
        }
        
        if(editOptsEl.curDashChild != curDashChild){
        	_this.clearMoreOptions();
        }
        editOptsEl.curDashChild = curDashChild;
       
        var eltype = curDashChild.getAttribute("eltype");
        var htmlActions = {
            viewOptions:false,
            editText:true,
            refresh:false,
            separator : false
        };
        var isHtml = (eltype == "HTML");  //No I18N
        var isUfEl = curDashChild.isUFEl;
        var isResizable = (!isHtml  && !isUfEl);
        for(var i in htmlActions)
        {
            editOptsEl[i].style.display =  (isHtml == htmlActions[i]) ?"":"none";
        }      
       var widgetType = curDashChild.getAttribute("viewtype")==="WIDGET";//No I18N
        var widgetActions = {
            widgetEdit:widgetType,
            widgetCopy:widgetType,
            viewOptions:(!isHtml)
        };
        for(var menu in widgetActions)
        {
            editOptsEl[menu].style.display = (widgetActions[menu]) ? "":"none";
        }
      DOMUtils.addCSSClass([curDashChild], "dashChildSel");
      _this.reposMenu(curDashChild,cur);
        var isExpanded = curDashChild.getAttribute("isExpanded") == "true";
      if(!isUfEl)
        {
          _this.toggleExpandMenu(isExpanded);
      }
        editOptsEl.style.display=(isUfEl)?"none":"";
        _this.vResizeDiv.style.display=(isResizable)?"":"none";
        _this.vResizeDiv.curEl = el;
        _this.hResizeDiv.curEl = el;
        cur.curDash.appendChild(editOptsEl);
        cur.curDash.appendChild(_this.hResizeDiv);
        cur.curDash.appendChild(_this.vResizeDiv);
    };

    this.checkNDeleteWidgetJSCharts = function(clickType, requestOptions)
    {
        if(clickType == "NO")
        {
            return;
        }
        var relEl = requestOptions[RELEL];
        ZDBEditModeSelect.removeDashChild(relEl);
    }
    
    this.alertToDeleteWidgetJSCharts = function(relEl)
    {
        ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.dashboard.widget.js.deletewidgetconfirm"),"ZDBYESNO",{ONCLICK:ZDBEditModeSelect.checkNDeleteWidgetJSCharts,RELEL:relEl});   //No I18N
    }

    this.reposMenu = function(curDashChild,cur)
    {
    	var dashView = curDashChild.ctx ? curDashChild.ctx.dashView : null;
    	var diff = (dashView!=null && ZDBUtil.hasScrollBar(dashView.dashDiv))?-ZDBGlobal.scrollThick:0;
    	diff = diff + 10;//margin added
        var eStyle = _this.editOptsEl.style;
        var det = ZDBDCellFinder.getCachedElDetails(curDashChild,cur.curDash);
        eStyle.top = (det.realTop) + 3 + "px";
        eStyle.right = ((cur.clWidth - (det.left + det.realWidth)) + diff) + "px";   //No I18N
        _this.positionHorizontalResizer(curDashChild, cur);
    };

    this.positionHorizontalResizer = function (curDashChild, cur) {
        var det = ZDBDCellFinder.getCachedElDetails(curDashChild, cur.curDash);
        _this.vResizeDiv.style.width = (det.realWidth) + "px";
        _this.vResizeDiv.style.top = ((det.realTop + det.realHeight) - (jQuery(_this.vResizeDiv).height())) + "px";
        _this.vResizeDiv.style.left = (det.left) + "px";
    }

    this.positionVerticalResizer = function(curDashChild,cur)
    {
        var isExpanded = curDashChild.getAttribute("isExpanded") == "true";
        if(curDashChild.getAttribute('viewtype') === 'WIDGET' && !isExpanded)
        {
             var det = ZDBDCellFinder.getCachedElDetails(curDashChild,cur.curDash);
            _this.hResizeDiv.style.height = (det.realHeight-2)+"px";
            _this.hResizeDiv.style.top = (det.realTop+1)+"px";
            _this.hResizeDiv.style.left = (det.left + det.realWidth-(jQuery(_this.hResizeDiv).width()))+'px';
            _this.hResizeDiv.widgetEvent = true;
            _this.hResizeDiv.style.display="";
        }
        else
            {
                _this.hResizeDiv.style.display="none";
            }
    }

    this.showVerticalResizer = function (el, event)//to revisit
    {
        var dashView = ZDBClientUI.selectedTab.view;
        if (!dashView.editMode) {
            return;
        }
        var dashRow = DOMUtils.getSelfOrParentWithAttrValue(el, "isrow", "true");//No I18N
        var dashRowChilds = dashRow.childNodes;
        var firstDashChild = DOMUtils.getFirstMatchingChild(dashRowChilds[0], null, "isdashboarddiv", "true");//No I18N
        if (!firstDashChild) {
            firstDashChild = DOMUtils.getFirstMatchingChild(dashRowChilds[1], null, "isdashboarddiv", "true");//No I18N
        }
        var isExpanded = firstDashChild.getAttribute("isExpanded") === "true";//No I18N
        dashRowChilds[0].det = null;
        var cur = ZDBDashEdit.getCurEditState();
        var det = ZDBDCellFinder.getCachedElDetails(dashRowChilds[0], cur.curDash);
        if (!det || !firstDashChild || isExpanded)
        	{
        		return;
        	}
        _this.hResizeDiv.curEl = firstDashChild.modalDiv;
        _this.hResizeDiv.style.height = (det.realHeight - 2) + "px";
        _this.hResizeDiv.style.top = (det.realTop + 1) + "px";
        _this.hResizeDiv.style.left = (det.realWidth - 2) + "px";
        _this.hResizeDiv.style.display = "";//(isResizable && !isExpanded)?"":"none";
        _this.vResizeDiv.style.display = "none";
        _this.hResizeDiv.widgetEvent = false;

    };

    this.hideOptsMenuEl = function(regEl,ev)
    {
        if(_this.curEl == null || ZDBDialogUtil.focusDialog != null)
        {
            return;
        }
        var toEl = (ev) ? ev.relatedTarget : window.event.toElement;
        if(toEl == _this.curEl || toEl == _this.editOptsEl)
        {
            return;
        }
        if(toEl != null)
        {
            var el = ZDBUtil.getParentWithAttr(toEl,"isEditOptsMenu");  //No I18N
            if(el == _this.editOptsEl)
            {
                return;
            }
        }
        _this.hideOptsMenu();
         _this.hideResizeDivs();
    };
  
    this.hideOptsMenu = function()
    {
//    	if(_this.menuExpanded){
//    		return;
//    	}
        if(_this.editOptsEl)
        {
            _this.editOptsEl.style.display = "none";
        }
        if(_this.curEl != null)
        {
            var curDashChild = ZDBUtil.getParentWithAttr(_this.curEl,"isDashBoardDiv");   //No I18N
            DOMUtils.removeCSSClass([curDashChild],"dashChildSel");
        }
        _this.curEl = null;
    };
        
    this.hideResizeDivs = function()
    {
        _this.vResizeDiv.style.display = "none";
        _this.hResizeDiv.style.display = "none";
    };

    this.expandOrContract = function(el)
    {
        var dashChildDiv = ZDBUtil.getParentWithAttr(_this.curEl,"isDashboardDiv"); //No I18N
        var view = ZDBClientUI.getViewObj(dashChildDiv,"view");
        var curRow = ZDBUtil.getParentWithAttr(dashChildDiv,"isDashboardRowDIV"); //No I18N
        var cur = ZDBDashEdit.getCurEditState();
        var isExpanded = dashChildDiv.getAttribute("isExpanded") == "true";
        var scrollTop = cur.curDash.scrollTop;
        var contentStyle = dashChildDiv.dlgBody.style;
        contentStyle.display="none";
        var previousWidth= ZDBClientUtil.getInnerWidth(dashChildDiv);
        if(isExpanded)
        {
            ZDBDPlacer.contract(cur,dashChildDiv,curRow);
        }
        else
        {
            ZDBDPlacer.expand(cur,dashChildDiv,curRow);
        }
        var currentWidth= ZDBClientUtil.getInnerWidth(dashChildDiv);
        var dashView = dashChildDiv.ctx ? dashChildDiv.ctx.dashView : ZDBClientUI.selectedTab.view;
        _this.toggleExpandMenu(!isExpanded);
        ZDBDStructure.updateStructInfo(dashView,true);
        ZDBDPlacer.resizeParentNode(dashChildDiv, dashView.dashDiv.clientWidth, !isExpanded);
        ZDBDPlacer.resizeContentArea(dashChildDiv,true, dashView.dashDiv.clientWidth);
        _this.reposMenu(dashChildDiv,cur);
        cur.curDash.scrollTop = scrollTop;
        if(dashChildDiv.showNavVisibility && !ZDBGlobal.IS_MOBILE)//retaining the position of Navig comp (excluding for IOS case)
        {//only for pivot and summary
            var navigCompPar = dashChildDiv.dlgBody.view.navigCompPar;//DOMUtils.getFirstChild(tableCompHolder,"elname" ,"navigComp");//No I18N
            var diffWidth = currentWidth - previousWidth;
            var right = parseInt(navigCompPar.style.right);
            if(right != 0)
            {
                right = right + diffWidth;//when size is minimum change/shift required
            }
            if(right < 0  ||(right >= 0 && dashChildDiv.navChange < 0))
            {
                if(isExpanded)
                {
                    dashChildDiv.navChange=right;
                    right=0;
                }
                else
                {
                    right=diffWidth + dashChildDiv.navChange;
                    dashChildDiv.navChange=0;
                }
            }
            navigCompPar.style.right = right+"px";//No I18N
        }
    };

    this.toggleExpandMenu= function(isExpanded)
    {
        var editOptsEl = _this.editOptsEl;
        editOptsEl.expandMenu.style.display=(isExpanded)?"none":"";
        editOptsEl.contractMenu.style.display=(isExpanded)?"":"none";
    };

    this.applyViewOptions = function(el,event)
    {
        var viewOptions = ZDBEditModeSelect.viewOptions;
        var dashChild = viewOptions.dashChild;
        var modified = false;
        var refreshChild = false;
        _this.hideResizeDivs();
        var enableDisableOpts = {
            dlgTitle:"showtitle",//No I18N
            dlgDesc:"desc",//No I18N
            dlgSBox:"sbox",//No I18N
            VMFiltersHolder:"showVMfilter",//No I18N
            excludeDashGlobalFilters:"excludeDashGlobalFilters",//NO I18N
        }; //NO I18N
        for(var i in enableDisableOpts)
        {
            var childEl = dashChild[i];
            var optName = enableDisableOpts[i];
            var newVal = (viewOptions[optName].checked)? "true":"false";
            var oldVal = dashChild.getAttribute(optName);
            if(newVal != oldVal)
            {
                dashChild.setAttribute(optName, newVal);
                if(optName=="showVMfilter"){
                    childEl = dashChild.dlgBody.view.VMFiltersHolder;
                    childEl.style.display = (newVal == "true")?"":"none";
                    refreshChild = true;
                }
                modified = true;
            }
        }
        var lp = viewOptions["lp"].value;
        if(dashChild.getAttribute("lp") != lp)
        {
            dashChild.setAttribute("lp",lp);
            refreshChild = true;
            modified = true;
        }
        var tlMapCol = viewOptions.mapTLFilter.value;
        var colId = DOMUtils.getFirstMatchingChild(viewOptions.mapTLFilter, "*", "value", tlMapCol).getAttribute("colId");//NO I18N
        if(dashChild.getAttribute("tlColumnMapping") != colId)
        {
        	if(!colId)
        	{
        		dashChild.removeAttribute("tlColumnMapping");
        	}
        	else
        	{
        		dashChild.setAttribute("tlColumnMapping",colId);
        	}
            modified = true;
        }
        viewOptions.dashChild = null;
        ZDBDialogUtil.closeDialog(el,event);
        if(modified)
        {
            ZDBDashEdit.childModified(dashChild);
        }

        if(refreshChild)
        {
            ZDBDashboardAPI.refreshChild(dashChild);
        }
        if(dashChild.getAttribute('showtitle') !== 'true' && dashChild.getAttribute('desc') !== 'true') {
            dashChild.setAttribute('onmouseenter', 'DashUtils.showOptionsOnMouseEnter(this, event)');
        } else {
            dashChild.dashViewOptions.style.display = '';
            dashChild.removeAttribute('onmouseenter');
        }
    };

    this.showViewOptionsDlg = function(el)
    {
        var viewOptions = ZDBEditModeSelect.viewOptions;
        el = _this.editOptsEl.moreOptions;
        if(_this.menuExpanded){
        	_this.clearMoreOptions();
        }
        if(viewOptions == null)
        {
            viewOptions =$("ZDBEditOptsDlg");
            ZDBEditModeSelect.viewOptions = viewOptions;
            document.body.appendChild(viewOptions);
            viewOptions.style.display="";
            ZDBUtil.setNamedChildEls(viewOptions,viewOptions);
        }
        var dashChild =  DOMUtils.getParentWithAttr(_this.curEl,"isDashBoardDiv");  //No I18N
        viewOptions.dashChild = dashChild;
        var optNames = ["showtitle","desc","showVMfilter","excludeDashGlobalFilters","sbox"]; //NO I18N        
      	for(var i=0;i < optNames.length;i++)
    		{
	        	var enabled = dashChild.getAttribute(optNames[i])=="true";
	        	viewOptions[optNames[i]].checked = enabled;
    		}

        //-- Do it in here.
        var viewType = dashChild.getAttribute("viewType");
        var hideSearchOption = ((viewType== "AnalysisView") //No I18N
            || (viewType=="Pivot") || (viewType == "SummaryView"));    //No I18N
        var hideVMFilterOption =   !hideSearchOption;
        if(viewType == "WIDGET")
        {
        	hideSearchOption = true;
        	hideVMFilterOption = true;
        	viewOptions.showtitlelabel.style.display = "none";
        	viewOptions.desclabel.style.display = "none";
        }
        else
        {
       		viewOptions.showtitlelabel.style.display = "";
        	viewOptions.desclabel.style.display = "";
        }
        viewOptions.sboxDiv.style.display = (hideSearchOption)?"none":"";
        viewOptions.vmFilterDiv.style.display = (hideVMFilterOption)?"none":"";
    
        var lgPos = ZDBDStructure.getLegendPos(dashChild);
        viewOptions.lpDiv.style.display=(lgPos != null)? "":"none";
        if(lgPos != null)
        {
            DOMUtils.setValueOnEl(viewOptions.lp,lgPos);
        }
        
        var left1 = ZDBUtil.getObjLeft(el)+ZDBClientUtil.getInnerWidth(el);
        var objId = dashChild.getAttribute("objId");
        viewOptions.style.position = "absolute";
         viewOptions.style.left = "0px";
         viewOptions.style.top = "0px";
        viewOptions.style.visibility = "hidden";
        viewOptions.style.display = "";
        document.body.appendChild(viewOptions);
        left1 = left1 - viewOptions.offsetWidth;
        viewOptions.style.position = "";
        viewOptions.style.left = "";
        viewOptions.style.top = "";
      	var viewDlg = ZDBDialogUtil.showDialog(viewOptions,{MODAL:true,ADDFRAME:true,CALLOUT:true,SRCEL:el,
        											TITLE:ZDBI18NMap.g('zrpt.dashboard.edit.options.js.dlgTtl',viewOptions)});
        var view = (dashChild.view) ? dashChild.view : dashChild.ctx.view;
        var tlMapColId = dashChild.getAttribute("tlColumnMapping");
        if(view.type == "Table" || view.type == "QueryTable" || view.type == "Report")
        {
        	ZDBEditModeSelect.construtMapTLFilterOptionsForTableQTTabularView(viewOptions,view);
        	ZDBDialogUtil.calloutPosition(viewDlg);
        	if(tlMapColId && (tlMapColId != ""))
        	{
        		var mapValue =  DOMUtils.getFirstMatchingChild(viewOptions.mapTLFilter,"*","colId",tlMapColId).getAttribute("value");//NO I18N
            	DOMUtils.setValueOnEl(viewOptions.mapTLFilter,mapValue);
        	}
        }
        else if(view.jsonForTLColumnMapping)
        {
        	ZDBEditModeSelect.construtMapTLFilterOptions(viewOptions,view.jsonForTLColumnMapping);
        	ZDBDialogUtil.calloutPosition(viewDlg);
            if(tlMapColId && (tlMapColId != ""))
            {
            	var mapValue =  DOMUtils.getFirstMatchingChild(viewOptions.mapTLFilter,"*","colId",tlMapColId).getAttribute("value");//NO I18N
            	DOMUtils.setValueOnEl(viewOptions.mapTLFilter,mapValue);
            }
        }
        else
        {
        	var parentViewId = view.parentViewId;
            var xml = (view.type == "WIDGET") ? WidgetUtils.getConfig(view.objId, view, !ZDBUtil.isNewView(view)) : ZDBAnalysisConfig.getConfig(view);
            var template = DOMUtils.getFirstMatchingChild(viewOptions, "div", "elname","filterValsLoading");//NO I18N
            var filterValsLoading = template.cloneNode(true);
            viewOptions.parentNode.appendChild(filterValsLoading);
            filterValsLoading.style.display = "";
            AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZAGetValidFilterCols.ma?OBJID="+objId+"&PARENTVIEWID="+parentViewId+"&ZDBACTION="+"ZAGETVALIDFILTERCOLS",
            	REQUESTHEADERS: {
                    "Content-type": "text/xml;charset=utf-8"//No I18N
                }, 
            	POSTBODY:xml,
            	TLMAPCOL:tlMapColId,
            	VIEW:view,
            	VIEWOPTIONS:viewOptions,
            	VIEWDLG : viewDlg,
                ONSUCCESSFUNC:ZDBEditModeSelect.handleGetValidFilterColsResp,
                OPSTATUSID:filterValsLoading});
        }
       
    };
    
    this.showOrHideTLMapping = function()
    {
    	var timelineEnabled = ZDBClientUI.selectedTab.view.timeLineCompEnabled;
    	var viewOptions = ZDBEditModeSelect.viewOptions;
    	var mapTLDiv = viewOptions.mapTlDiv;
    	if(!viewOptions.excludeDashGlobalFilters.checked && timelineEnabled)
    	{
    		mapTLDiv.style.display = "";
    	}
    	else
    	{
    		mapTLDiv.style.display = "none";
    	}
    }
    
    this.construtMapTLFilterOptionsForTableQTTabularView = function(viewOptions, view)
    {
    	var colHeaders = view.colHeaders;
    	var mapTLFilter = viewOptions.mapTLFilter;
    	var noneOption = document.createElement("option");
        mapTLFilter.innerHTML = "";
    	noneOption.setAttribute("value","NONE");//NO I18N
    	noneOption.innerHTML = ZDBI18NMap.f("zrpt.dashboard.js.nooptionselected");
    	mapTLFilter.appendChild(noneOption);
    	for(var i=0; i<colHeaders.length; i++)
    	{
    		var colType = colHeaders[i].type;
    		if(colType == "DATE" || colType == "DATE_AS_DATE")
    		{
	    		var colId = colHeaders[i].colId;
	    		var colName = colHeaders[i].displayName;
	    		var newOption = document.createElement("option");
				newOption.setAttribute("value",colName);
				colName = ZDBEscapeUtil.encodeForHtml(colName);
				newOption.innerHTML = colName;
				newOption.setAttribute("colId",colId);
				mapTLFilter.appendChild(newOption);
    		}
    	}
    	ZDBEditModeSelect.showOrHideTLMapping();
    	viewOptions.style.visibility = "visible";
    }

    this.handleGetValidFilterColsResp = function(response, requestOptions)
    {
    	var jsonResp = JSON.parse(response.responseText);
    	var view = requestOptions["VIEW"];
    	var viewOptions = requestOptions["VIEWOPTIONS"];
    	var viewDlg = requestOptions["VIEWDLG"];
    	var tlMapColId = requestOptions["TLMAPCOL"];
    	ZDBEditModeSelect.construtMapTLFilterOptions(viewOptions, jsonResp);
    	ZDBDialogUtil.calloutPosition(viewDlg);
    	if(tlMapColId != "" && tlMapColId != "null" && tlMapColId)
    	{
    		var mapEl =  DOMUtils.getFirstMatchingChild(viewOptions.mapTLFilter,"*","colId",tlMapColId)
    		if(mapEl)
    		{
    			var value = mapEl.getAttribute("value");//NO I18N
    			DOMUtils.setValueOnEl(viewOptions.mapTLFilter,value);
    		}
    	}
    	view.jsonForTLColumnMapping = jsonResp;
    }
    
    this.construtMapTLFilterOptions = function(viewOptions, jsonResp)
    {
    	var mapTLFilter = viewOptions.mapTLFilter;
    	var noneOption = document.createElement("option");
    	mapTLFilter.innerHTML = "";
    	noneOption.setAttribute("value","NONE");//NO I18N
    	noneOption.innerHTML = ZDBI18NMap.f("zrpt.dashboard.js.nooptionselected");
    	mapTLFilter.appendChild(noneOption);
    	for(var tableKey in jsonResp.colDet)
    	{
    		var tableName = jsonResp.tableDet[tableKey].displayName;
    		for(var colKey in jsonResp.colDet[tableKey])
    		{
    				var colObj = jsonResp.colDet[tableKey][colKey];
    				if(colObj["ADDONTYPE"] == "ABSDATECATEGORICAL")
    				{
    					var newOption = document.createElement("option");
    					var colName = colObj["DISP_NAME"];
    					var name =  colName + " " + ZDBI18NMap.g("zrpt.dashboard.js.intext") + " " + tableName;
    					newOption.setAttribute("value",name);
    					name = ZDBEscapeUtil.encodeForHtml(name);
    					newOption.innerHTML = name;
    					newOption.setAttribute("colId",colObj["COLUMN_ID"]);
    					mapTLFilter.appendChild(newOption);
    				}
    		}
    	}
    	ZDBEditModeSelect.showOrHideTLMapping();
    	viewOptions.style.visibility = "visible";
    }
    
    this.changeClass = function(el)//view options are set based on the class change
    {
        el.className = (el.className=="zdboptionchecked")?"zdboptionunchecked":"zdboptionchecked";
    };

  

    this.removeDashChild = function(relEl)
    {
        var curEl = _this.curEl;
        //$$ - Rememeber to call remove of the child component.
        var dashChildDiv = ZDBUtil.getParentWithAttr(curEl,"isDashboardDiv"); //No I18N
        var view = dashChildDiv.view;
        if(view && view.type === 'WIDGET')//Temporary Fix
        {
        	if (!ZDBUtil.isNewView(view)) {
        		view.dashView.trashWidget.push(view.objId);
        	}
        	else if (dashChildDiv.isNewView) { // Decrement the widgets count for failed case
        		view.dashView.decrementNewWidgetsWaitingForFirstResponse();
        	}
        }
        ZDBEditModeSelect.removeDashChildOnSuccess(dashChildDiv,relEl);
    };


    this.removeDashChildOnSuccess = function(dashChildDiv,relEl)
    {
        dashChildDiv.style.visibility="hidden";
        var cur = ZDBDashEdit.getCurEditState();
        _this.addAdjustWidthDivIfNeeded(dashChildDiv);
        cur.removeChild = dashChildDiv;
        ZDBDashRelVisEffect.showEffect(cur,dashChildDiv,relEl,_this.removeChildEnd,false);
    };

    this.validateDashUf= function(dashChildDiv,view)
    {      
      var elType = dashChildDiv.getAttribute("eltype");
      if(!(elType=="VIEW"))
      {
          return;
      }
      this.validateDashboard(view);
    };
    
    this.showMoreOptions = function(el, event){
    	ZDBToolTip.hide(null, true);
    	var editOptsEl = _this.editOptsEl;
    	var moreMenu = _this.moreMenu = editOptsEl.moreOptionsMenu;
    	if(moreMenu.parentElement !== document.body){
    		document.body.appendChild(moreMenu);
    	}
    	if(!_this.menuExpanded){
    		moreMenu.style.display = "block";
    		ZDBUtil.setNamedChildEls(moreMenu,moreMenu,null,true);
    		moreMenu.params = {
    				SRCEL : el,
    				MODAL : true
    		};
    		ZDBDialogUtil.fixedCalloutPosition(moreMenu, el, {order : ["BOTTOM", "TOP"], marginLeft : 5});
    		ZDBDialogUtil.freezeBackground(moreMenu);
    		moreMenu.style.visibility = "visible";
    		_this.menuExpanded = true;
    		moreMenu.freezeLayer.addEventListener("click", _this.clearMoreOptions);
    		event.stopPropagation();
    	}
    	
    }
    
    this.clearMoreOptions = function(){
    	if(_this.menuExpanded){
    		_this.editOptsEl.moreOptions.appendChild(_this.moreMenu);
    		_this.moreMenu.style.display = "";
    		_this.moreMenu.style.visibility = "";
    		_this.moreMenu.style.left = "";
    		var freezeLayer = _this.moreMenu.freezeLayer;
    		freezeLayer.removeEventListener("click", _this.clearMoreOptions);
    		freezeLayer.parentElement.removeChild(freezeLayer);
        	delete _this.menuExpanded;
    	}
    	
    }

    this.validateDashboard = function(view)
    {
      var viewParams = "";
          if(this.objId > -1)
          {
            viewParams += "&OBJID=" + view.objId; //No I18N
          }
          else
          {
            viewParams += "&DBID=" + view.dbId; //No I18N
          }
          var action="DASHBOARDUFVALIDATION"; //NO I18N
          var doXML = ZDBDStructure.getDashBoardCurrentConfig(view,false);
          var url = "/DashUFAction.ma?"+ viewParams; //NO I18N
          url+="&ZDBACTION="+action; //NO I18N
          AjaxAPI.sendRequest({URL:url,POSTBODY:doXML,
                           REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //NO I18N
                           VIEW:view,ACTION:action,ONSUCCESSFUNC:ZDBDashboardAPI.hndldashUFActionResp});
    };
    
    this.addAdjustWidthDivIfNeeded = function(dashChildDiv,parent)
    {
    	return;
    	/*THE BELOW TO BE REMOVED $$NEWUI$$*/
    };

    this.addAdjustWidthDiv = function(dashChildDiv,view)
    {
    	return;
    	/*THE BELOW TO BE REMOVED $$NEWUI$$*/
    };

    this.addTempDivIfNeeded = function(newChild)
    {
    	return;
    	/*THE BELOW TO BE REMOVED $$NEWUI$$*/
    };

    this.getTempDiv = function()
    {
        var tempDiv = document.createElement("div");
        tempDiv.style.height = "40px";//No I18N
        tempDiv.style.marginTop = "40px";//No I18N
        tempDiv.innerHTML = "&nbsp;";//No I18N
        tempDiv.style.background = "#CCCCCC";//No I18N
        return tempDiv;
    };

    this.addAdjustWidthDivOnResize = function(dashChildDiv)
    {
        var parentNode = dashChildDiv.parentNode;
        var adjacentTD = (parentNode.previousSibling!=null)?parentNode.previousSibling:parentNode.nextSibling;
        if(adjacentTD==null)
            {
                return;
            }
         var dashboardDivs = DOMUtils.getChildElsWithAttr(adjacentTD,"isdashboarddiv","true");//No I18N
         if(dashboardDivs.length > 0)
             {
                 return;
             }
        var tempDiv = _this.getTempDiv();
        adjacentTD.appendChild(tempDiv);
        _this.tempAdjustDiv = tempDiv;
        _this.removeTempAdjustDiv();

    };

    this.removeTempAdjustDiv = function()
    {
        var tempAdjustDiv = ZDBEditModeSelect.tempAdjustDiv;
        if(tempAdjustDiv==null)
        {
            return;
        }
        var view = ZDBClientUI.getViewObj(tempAdjustDiv,"view");
        ZDBEditModeSelect.addAdjustWidthDiv(tempAdjustDiv,view);
        tempAdjustDiv.parentNode.removeChild(tempAdjustDiv);
        ZDBEditModeSelect.tempAdjustDiv = null;
    };

    this.removeChildEnd = function()
    {
        _this.hideOptsMenu();
        _this.hideResizeDivs();
        var cur = ZDBDashEdit.getCurEditState();
        var dashChildDiv = cur.removeChild;
        var view = dashChildDiv.ctx ? dashChildDiv.ctx.dashView : cur.view;
    
        cur.removeChild = null;
        dashChildDiv.parentNode.removeChild(dashChildDiv);
        ZDBDStructure.updateStructInfo(view,true);
        var dashChilds = cur.view.dashChilds;
        if(dashChilds.length == 0)
        {
            ZDBDPlacer.addNewDummyRow(cur,true);
        }
        _this.validateDashUf(dashChildDiv,view);
    };

    this.editText = function(el,event)
    {
        if(_this.curEl == null){
            return;
        }
        ZDBDHtmlImgEditor.editText(_this.curEl,event);
    };



    this.reload = function(el,event)
    {
        var curEl = _this.curEl;
        //$$ - Rememeber to call remove of the child component.
        var dashChildDiv = ZDBUtil.getParentWithAttr(curEl,"isDashboardDiv"); //No I18N
        var view = ZDBClientUI.getViewObj(dashChildDiv, "view");//No I18N
        if(view && view.type === 'WIDGET')
        	{
        		view.fetched = false;
        	}
        ZDBDashboardAPI.refreshChild(dashChildDiv);
    };
	
    this.initResizing = function()
    {
        if(ZDBEditModeSelect.initializedResizing){
            return;
        }

        ZDBEditModeSelect.resizeModalDiv = $("ZDBResizeModalDiv");
        var hResizeDiv = $("ZDBDHResizeDiv");
        var vResizeDiv = $("ZDBDVResizeDiv");
        hResizeDiv.relatedResizeDiv = vResizeDiv;
        vResizeDiv.relatedResizeDiv = hResizeDiv;
        _this.hResizeDiv = hResizeDiv;
        _this.vResizeDiv = vResizeDiv;
        ZDBEditModeSelect.initializedResizing = true;			
    };
	
    this.resizeVertically = function(el,event)
    {
        var curEl = el.curEl;
        var relResizeElProp = (el.id=="ZDBDVResizeDiv")?"height":"width";
        var dashChildDiv = ZDBUtil.getParentWithAttr(curEl,"isDashboardDiv"); //No I18N
        _this.resizeStarted = true;
        ZDBTxtIndicator.hideHighlight();
        var dlgBody = dashChildDiv.dlgBody;
        var curPos = ZDBUtil.getCursorPos(event);
        ZDBEditModeSelect.startX = curPos.x;
        ZDBEditModeSelect.startY = curPos.y;
        ZDBEditModeSelect.curResizeEl = el;
        var dashView = dashChildDiv.ctx ? dashChildDiv.ctx.dashView : null;
        var dashMainDiv = null;
        if(dashView)
        {
            dashMainDiv = dashView.dashDiv;
        }
        else
        {
            dashMainDiv = ZDBClientUI.selectedTab.view.dashDiv;
        }
        _this.dashMainDiv = dashMainDiv;
        var dashMainDivParent = dashMainDiv.offsetParent;
         _this.verticalUpperLimit = (ZDBUtil.getObjTop(dashMainDivParent))+10;
         _this.verticalLowerLimit = (_this.verticalUpperLimit+dashMainDivParent.offsetHeight)-20;

         var dashMainDivLeft = ZDBUtil.getObjLeft(dashMainDiv);

         _this.horizontalWidthRangeStart = dashMainDiv.clientWidth * 0.25;
         _this.horizontalWidthRangeEnd = dashMainDiv.clientWidth * 0.75;

         _this.horizontalStartLimit = dashMainDivLeft + _this.horizontalWidthRangeStart;
         _this.horizontalEndLimit = dashMainDivLeft + _this.horizontalWidthRangeEnd;
         _this.initialOffSetLeft = dashChildDiv.offsetLeft;

        ZDBEditModeSelect.setPositionDetails(el);
        ZDBEditModeSelect.setPositionDetails(el.relatedResizeDiv);
        ZDBEditModeSelect.startDlgBodyWidth = parseInt(dashChildDiv.clientWidth);
        ZDBEditModeSelect.startDlgBodyHeight = parseInt(dlgBody.clientHeight);
        ZDBEditModeSelect.startModalDivWidth = ZDBEditModeSelect.startDlgBodyWidth;//parseInt(dashChildDiv.offsetWidth) - _this.borderAdjust;
        ZDBEditModeSelect.startChildDivHeight = parseInt(dashChildDiv.clientHeight);//parseInt(dashChildDiv.offsetHeight)-_this.borderAdjust;
        var tr = ZDBUtil.getParentWithAttr(dashChildDiv,"isexpanded").parentNode;    //No I18N
        var curTD = tr.childNodes[0];
        ZDBEditModeSelect.curTD = curTD;
        var adjacentTD = curTD.nextSibling;//(curTD.previousSibling!=null)?curTD.previousSibling:curTD.nextSibling;
        ZDBEditModeSelect.adjacentTD = adjacentTD;
        ZDBEditModeSelect.startCurTDWidth = (curTD!=null)?parseInt(curTD.offsetWidth):null;
        ZDBEditModeSelect.startAdjacentTDWidth = (adjacentTD!=null)?parseInt(adjacentTD.offsetWidth):null;
        ZDBEditModeSelect.curDashChildDiv = dashChildDiv;
        var resizeModalDiv = _this.resizeModalDiv;
        if(resizeModalDiv.parentNode!=document.body)
        {
            document.body.appendChild(resizeModalDiv);
        }
        resizeModalDiv.style.cursor = (el.id=="ZDBDVResizeDiv")?"n-resize":"e-resize";
        resizeModalDiv.style.display = "";
        resizeModalDiv.className = "alpha0";
        ZDBUtil.stopEventBubble(event);
        document.onmousemove = ZDBEditModeSelect.startVResizing;
        document.onmouseup = ZDBEditModeSelect.stopVResizing;
    };
	
    this.setPositionDetails = function(el)
    {
        el.posDetails = {
            TOP:parseInt(el.style.top),
            LEFT:parseInt(el.style.left),
            WIDTH:parseInt(ZDBClientUtil.getInnerWidth(el)),
            HEIGHT:parseInt(ZDBClientUtil.getInnerHeight(el))
            };
    };
	
    this.startVResizing = function(event)
    {
        var curPos = ZDBUtil.getCursorPos(event);
        var curResizeEl = ZDBEditModeSelect.curResizeEl;
        if(curPos.y >= _this.verticalLowerLimit || curPos.y <= _this.verticalUpperLimit)
            {
                _this.step = (curPos.y >= _this.verticalLowerLimit)?5:-5;
                _this.scrollDownNResize(event);
                return;
            }
        if(((_this.horizontalStartLimit - curPos.x > -3  || _this.horizontalEndLimit - curPos.x < 3 ) && !_this.hResizeDiv.widgetEvent) && (curResizeEl.id=="ZDBDHResizeDiv"))
            {
        	    _this.hideResizeDivs();
        	    _this.stopVResizing();
        	    _this.resizeLimitReached = false;
                return;
            }
        _this.autoScrollForReizeEnabled = false;
        var curResizeElProp = (curResizeEl.id=="ZDBDVResizeDiv")?"top":"left";
        var relResizeElProp = (curResizeEl.id=="ZDBDVResizeDiv")?"height":"width";
        var startDlgBodyMeasure = (curResizeEl.id=="ZDBDVResizeDiv")?ZDBEditModeSelect.startDlgBodyHeight:ZDBEditModeSelect.startDlgBodyWidth;
        var startchildDivMeasure = (curResizeEl.id=="ZDBDVResizeDiv")?ZDBEditModeSelect.startChildDivHeight:ZDBEditModeSelect.startModalDivWidth;
        var curDashChildDiv = ZDBEditModeSelect.curDashChildDiv;
        var diffX = (curPos.x - ZDBEditModeSelect.startX);
        var diffY = (curPos.y - ZDBEditModeSelect.startY);
        var diff = (curResizeEl.id=="ZDBDVResizeDiv")?diffY:diffX;
        if(_this.hResizeDiv.widgetEvent && curResizeEl.id=="ZDBDHResizeDiv")
        {
        	_this.adjustWidgetWidth(curDashChildDiv,diff,relResizeElProp);
        	}
        else if(curResizeEl.id=="ZDBDHResizeDiv")
	        {
            _this.adjustDependentViewSize(curDashChildDiv,diff,relResizeElProp);
        }
        else
        {
	            _this.adjustThisViewSizeOnly(curDashChildDiv,diff,relResizeElProp,startDlgBodyMeasure,startchildDivMeasure);
        }
        if(_this.resizeLimitReached)
            {
        		_this.stopVResizing();
        		_this.hideResizeDivs();
        		_this.resizeLimitReached = false;
        		return;
            }
        curResizeEl.style[curResizeElProp] = (curResizeEl.posDetails[curResizeElProp.toUpperCase()] + diff)+"px";
        _this.positionDetailsSet = true;
    };



    this.scrollDownNResize = function(event)
    {
        _this.autoScrollForReizeEnabled = true;
        _this.autoResize(event);
    };

    this.autoResize = function()
    {
        
        if(_this.autoScrollForReizeEnabled==false)
            {
                return;
            }
            
        var dashChildDiv = ZDBEditModeSelect.curDashChildDiv;
        var dlgBody = dashChildDiv.dlgBody;
        ZDBEditModeSelect.startDlgBodyHeight = parseInt(dlgBody.clientHeight);
        var curResizeEl = ZDBEditModeSelect.curResizeEl;
        var step = parseInt(_this.step);
        ZDBEditModeSelect.startY = _this.verticalLowerLimit;
        ZDBEditModeSelect.startChildDivHeight = parseInt(dashChildDiv.clientHeight);
        _this.adjustThisViewSizeOnly(dashChildDiv,step,"height",ZDBEditModeSelect.startDlgBodyHeight,ZDBEditModeSelect.startChildDivHeight);//No I18N
        
        curResizeEl.relatedResizeDiv.posDetails["HEIGHT"]  = (parseInt(curResizeEl.relatedResizeDiv.style.height)+step);
        curResizeEl.relatedResizeDiv.style.height = curResizeEl.relatedResizeDiv.posDetails["HEIGHT"]+"px";

        curResizeEl.posDetails["TOP"]  = (parseInt(curResizeEl.style.top)+step);
        curResizeEl.style.top = (curResizeEl.posDetails["TOP"])+"px";

        _this.dashMainDiv.scrollTop = _this.dashMainDiv.scrollTop+step;
        setTimeout(_this.autoResize,300);
        
    };

	
    this.adjustThisViewSizeOnly = function (curDashChildDiv, diff, relResizeElProp, startDlgBodyMeasure, startChildDivMeasure)
    {
        var isChartView = (curDashChildDiv.getAttribute("viewtype") === "AnalysisView");//No I18N
        var isWidgetView = curDashChildDiv.getAttribute("viewtype") === "WIDGET";//NO I18N
        var minHeight = (isChartView) ? 150 : 60;
        if (((startDlgBodyMeasure + diff) < (minHeight)))
            {
        	_this.resizeLimitReached = true;
                return;
            }
       _this.removeViewB4Resizing(curDashChildDiv);
        curDashChildDiv.dlgBody.style[relResizeElProp] = (startDlgBodyMeasure + diff) + "px";
        curDashChildDiv.style[relResizeElProp] = (startChildDivMeasure + diff + 2) + "px";
        curDashChildDiv.modalDiv.style[relResizeElProp] = (startChildDivMeasure + diff + 2) + "px";
        var scrollTop = _this.dashMainDiv.scrollTop;
        var scrollHeight = _this.dashMainDiv.scrollHeight;
        var dashHeight = _this.dashMainDiv.offsetHeight;
        if (scrollTop >= (scrollHeight - dashHeight))
        	{	        
            if (_this.adjustScrollDiv == null)
	        	{		
	        	var div = document.createElement("div");		
                _this.adjustScrollDiv = div;
                div.style.height = curDashChildDiv.offsetHeight + "px";
	        	div.style.visibility = "hidden";		
	        	div.innerHTML = "&nbsp;";//No I18N		
	        	_this.dashMainDiv.appendChild(_this.adjustScrollDiv);		
	        	}		
        	}
        if (isWidgetView && curDashChildDiv.view.layout < 6) {
			curDashChildDiv.det = null;
            _this.positionVerticalResizer(curDashChildDiv, ZDBDashEdit.getCurEditState());
        }
    };
        
    this.removeViewB4Resizing = function(dashChildDiv)
    {
     var isView = (dashChildDiv.getAttribute("eltype")=="VIEW");//No I18N
     var isShared =(dashChildDiv.getAttribute("isviewshared")=="true");//No I18N
    	var isWidgetView = (dashChildDiv.getAttribute('viewtype')==='WIDGET');//NO I18N
    	if(isWidgetView)
            {
    			dashChildDiv.dlgBody.childNodes[0].style.visibility = 'hidden';
    			return;
            }
        if(isView && dashChildDiv.dlgBody.childNodes[0] && isShared)
        	{
                dashChildDiv.dlgBody.removeChild(dashChildDiv.dlgBody.childNodes[0]);
    }
    };
	
    this.adjustDependentViewSize = function(curDashChildDiv,diff,relResizeElProp)
    {
        var curTD = ZDBEditModeSelect.curTD;
        var adjacentTD = ZDBEditModeSelect.adjacentTD;
        _this.curAdjacentDashboardDivs = (_this.curAdjacentDashboardDivs!=null)?_this.curAdjacentDashboardDivs:DOMUtils.getChildElsWithAttr(adjacentTD,"isdashboarddiv","true");//ZDBEditModeSelect.getAdjacentDependentView(td);//No I18N
        _this.adjustWidthOrHeight( _this.curAdjacentDashboardDivs,-1*diff,relResizeElProp);
        if(_this.resizeLimitReached)
        	{
        		return;
        	}
        
        _this.curTDDashboardDivs = (_this.curTDDashboardDivs!=null)?_this.curTDDashboardDivs:DOMUtils.getChildElsWithAttr(curTD,"isdashboarddiv","true");//No I18N
        _this.adjustWidthOrHeight(_this.curTDDashboardDivs,diff,relResizeElProp);
        _this.adjustTDSize(curTD,adjacentTD,relResizeElProp,diff);
        if(ZDBEditModeSelect.curTD.offsetHeight > 0)
    	{
        	ZDBEditModeSelect.curResizeEl.style.height =  ZDBEditModeSelect.curTD.offsetHeight + 'px';
    	}
    };
		
    this.adjustTDSize = function(td,adjacentTD,relResizeElProp,diff)
    {
    	if(td!=null){
    		ZDBEditModeSelect.curTD.style[relResizeElProp] = ((ZDBEditModeSelect.startCurTDWidth)+(diff))+"px";
    	}
    	
    	if(adjacentTD!=null){
    		ZDBEditModeSelect.adjacentTD.style[relResizeElProp] = ((ZDBEditModeSelect.startAdjacentTDWidth)+(-diff))+"px";
    	}
    };


    this.adjustWidgetWidth = function(curDashChildDiv,diff,relResizeElProp,startOrEnd)
    {
    	var curTDStartRange = (diff >= 0)?true:false;
        var minWidth = (ZDBClientUtil.getInnerWidth(_this.dashMainDiv) * 0.10);
        var maxWidth = parseFloat(curDashChildDiv.parentNode.style.width) - 2*0.0066*_this.dashMainDiv.offsetWidth;
        if(_this.positionDetailsSet!=true || curDashChildDiv.posDetails==null)
        	{
        	  ZDBEditModeSelect.setPositionDetails(curDashChildDiv);
              ZDBEditModeSelect.setPositionDetails(curDashChildDiv.dlgBody);
              ZDBEditModeSelect.setPositionDetails(curDashChildDiv.modalDiv);
    }
        var dlgBodyMeasure = curDashChildDiv.dlgBody.posDetails[relResizeElProp.toUpperCase()]+(diff);
        var curDashChildDivLeft = curDashChildDiv.offsetLeft;
        var widthMaxDiff = 1;
        WidgetUtils.addSeparator(curDashChildDiv);//costly, identify structural change
        if((((maxWidth - (dlgBodyMeasure + 22)) < widthMaxDiff) && curTDStartRange) || ((dlgBodyMeasure - minWidth < widthMaxDiff) && !curTDStartRange) || _this.initialOffSetLeft !== curDashChildDivLeft)
            {
        	_this.resizeLimitReached = true;
                return;
            }
        curDashChildDiv.style[relResizeElProp] =  dlgBodyMeasure + 22 + "px";
        curDashChildDiv.dlgBody.style[relResizeElProp] = dlgBodyMeasure +"px";
        curDashChildDiv.modalDiv.style[relResizeElProp] = dlgBodyMeasure + 22 + "px";
        curDashChildDiv.widgetResized = true;
        curDashChildDiv.det = null;
        _this.positionHorizontalResizer(curDashChildDiv, ZDBDashEdit.getCurEditState());
    };
	

    this.adjustWidthOrHeight = function(dashboardDivs,diff,relResizeElProp)
    {
        if(dashboardDivs==null){
            return;
        }
        for(var i=0; i<dashboardDivs.length; i++)
        {
            if(_this.positionDetailsSet!=true || dashboardDivs[i].posDetails==null)
            {
                ZDBEditModeSelect.setPositionDetails(dashboardDivs[i]);
                ZDBEditModeSelect.setPositionDetails(dashboardDivs[i].dlgBody);
                ZDBEditModeSelect.setPositionDetails(dashboardDivs[i].modalDiv);
            }
            _this.removeViewB4Resizing(dashboardDivs[i]);
            var dlgBodyMeasure = dashboardDivs[i].dlgBody.posDetails[relResizeElProp.toUpperCase()]+(diff);
            var minWidth = (ZDBClientUtil.getInnerWidth(_this.dashMainDiv) * 0.20);
            var isWidget = dashboardDivs[i].view && dashboardDivs[i].view.type === 'WIDGET';
            var isHTML = dashboardDivs[i].getAttribute("eltype")==="HTML";//NO I18N
            if(isWidget && (diff > 0 || dlgBodyMeasure <  minWidth || dlgBodyMeasure <  100))
            	{
            		continue;
            	}
            if(dlgBodyMeasure <  minWidth || dlgBodyMeasure <  100)
                {
                    _this.resizeLimitReached = true;
                    return;
                }
            var viewPadding = (isHTML)? 0 : 20;
            dashboardDivs[i].style[relResizeElProp] = (dlgBodyMeasure + viewPadding) + 'px';
            dashboardDivs[i].dlgBody.style[relResizeElProp] = dlgBodyMeasure + 'px';
            dashboardDivs[i].modalDiv.style[relResizeElProp] = (dlgBodyMeasure + viewPadding) + 'px';
            if(isHTML)
                {
                    dashboardDivs[i].style.height = "auto";
                    dashboardDivs[i].dlgBody.style.height = "auto";
                    dashboardDivs[i].modalDiv.style.height = dashboardDivs[i].offsetHeight + "px";
                    continue;
                }
            var paddingApplied = 5;
            var isDeleted = dashboardDivs[i].getAttribute("eltype")==="DELETED";//NO I18N
            if(!isDeleted){
            	dashboardDivs[i].dlgTitle.style[relResizeElProp] = (dlgBodyMeasure + 20 - paddingApplied) + "px";//remove padding
                dashboardDivs[i].dlgDesc.style[relResizeElProp] = (dlgBodyMeasure + 20 - paddingApplied) + "px";//remove padding
            }
        }
    };
	
    this.getAdjacentDependentView = function(td)
    {
        var adjacentTD = (td.previousSibling!=null)?td.previousSibling:td.nextSibling;
        if(adjacentTD == null)
        {
            return null;
        }
        var adjacentDashboardDivs = DOMUtils.getChildElsWithAttr(adjacentTD,"isdashboarddiv","true");//No I18N
        return adjacentDashboardDivs;
    };

    this.stopVResizing = function()
    {
        _this.reloadAdjustedViews();
        var curDashChildDiv = ZDBEditModeSelect.curDashChildDiv;
        var dashView = curDashChildDiv.ctx ? curDashChildDiv.ctx.dashView : null;
        if(dashView)
        {
            dashView.setModified();
        }
        else
        {
            ZDBClientUI.selectedTab.view.setModified();
        }
        var resizeModalDiv = ZDBEditModeSelect.resizeModalDiv;
        resizeModalDiv.style.cursor = "";
        resizeModalDiv.style.display = "none";
        document.onmousemove = null;
        document.onmouseup = null;
        ZDBEditModeSelect.startY = null;
        ZDBEditModeSelect.startDlgBodyHeight = null;
        ZDBEditModeSelect.curDashChildDiv.det = null;
        ZDBEditModeSelect.curDashChildDiv.oldDet = null;
        ZDBEditModeSelect.adjacentTD = null;
        ZDBEditModeSelect.curTD = null;
        ZDBEditModeSelect.startCurTDWidth = null;
        ZDBEditModeSelect.startAdjacentTDWidth = null;
        curDashChildDiv.det = null;
        ZDBEditModeSelect.curDashChildDiv = null;
        ZDBDashEdit.updateDashDim();
        _this.positionDetailsSet = false;
        _this.autoScrollForReizeEnabled = false;
        if(_this.adjustScrollDiv){
         _this.adjustScrollDiv.parentNode.removeChild(_this.adjustScrollDiv);
        }
        _this.adjustScrollDiv = null;
        _this.resizeStarted = false;
    };
	
    this.reloadAdjustedViews = function()
    {
        if(_this.curAdjacentDashboardDivs==null && _this.curTDDashboardDivs == null)
        {
        	if(_this.curDashChildDiv.view && _this.curDashChildDiv.view.type === 'WIDGET')
        		{
        			_this.curDashChildDiv.view.renderer.resize(_this.curDashChildDiv.dlgBody);
        			ZDBEditModeSelect.curDashChildDiv.dlgBody.childNodes[0].style.visibility = 'visible';
        			return;
        		}
            ZDBDashboardAPI.refreshChild(ZDBEditModeSelect.curDashChildDiv);
        }
        else if(!_this.hResizeDiv.widgetEvent)
        {
            _this.reloadThisViews(_this.curTDDashboardDivs);
            _this.reloadThisViews(_this.curAdjacentDashboardDivs);
            _this.curAdjacentDashboardDivs = null;
            _this.curTDDashboardDivs = null;
        }

    };
	
    this.reloadThisViews = function(viewList)
    {
        if(viewList==null){
            return;
        }
        var views = viewList;
        var eltype;
        var isHtml;
        var len = views.length;
        for(var i=0; i<len; i++)
        {
            eltype = views[i].getAttribute("eltype");
            if(views[i].getAttribute('viewtype') === 'WIDGET')
            	{
            		views[i].dlgBody.childNodes[0].style.visibility = 'visible';
            		continue;
            	}
            isHtml = (eltype == "HTML");//No I18N
            if(isHtml){
                continue;
            }
            ZDBDashboardAPI.refreshChild(views[i]);
        }
    };
    
    };


