 //$Id$

var ZDBSheetFormatExtn = new function()
{

  this.showColumnFormatDlg = function(element,gridObj)
  {
    if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js",this,ZDBSheetFormatExtn.showColumnFormatDlg,[element,gridObj]))
    {
        return;
    }
    var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
    if(gridObj.selectedCols.length == 0 && lastFocusCell != null)
    {
      gridObj.addSelectedCol(lastFocusCell.colObj);
      gridObj.selectColumn();
    }

    var colHead = gridObj.getSelectedColHead();
    if(colHead == null)
    {
      ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selCol2Format"));
      return false;
    }
    var type = (colHead.type == "REFCOL") ? colHead.refColType:(colHead.type == "RELCOL")?colHead.relColType : colHead.type; //No I18N
    type = ZDBUtil.dataTypeVsdataTypeNum[type];
    ZDBSheetFormatExtn.dataType = type;
    var editFrmtColOpts = new ZDBEditColumnFormat(gridObj.objId,ZDBEditColumnFormat.NORMAL_COL_FORMAT,null);
    ZDBSheetFormatExtn.editFrmtColOpts = editFrmtColOpts;
	ZDBSheetFormatExtn.showFormatDlg(gridObj,colHead,null,editFrmtColOpts);
	ZDBSheetFormatExtn.enableDisableColumnFormatOpts(ZDBSheetFormatExtn.dataType,gridObj.type);
    ZDBSheetFormatExtn.setValuesInFormatDlg(gridObj,colHead,null,editFrmtColOpts);
    ZDBSheetFormatExtn.hideTabs();
    if(colHead.cellEl)
    {
    	ZDBDialogUtil.closeDialog();
    	ZDBSheetFormatExtn.showFormatDlg(gridObj,colHead,null,editFrmtColOpts);
    }
  }

  this.enableDisableColumnFormatOpts = function(dataType,viewType, opr)
  {
	viewType = (!viewType) ? ZDBClientUI.selectedTab.view.type : viewType;

	var editFrmtColOpts = ZDBSheetFormatExtn.editFrmtColOpts;

    var alignList = $("ZRAlignListOpt");
    alignList.style.display = ((viewType === 'AnalysisView' || viewType === 'WIDGET') && editFrmtColOpts.mode === ZDBEditColumnFormat.EDIT_CUSTOM_FORMAT) ? "none" : "";

    var urlAltText = $("ZDBURLAltText");
    urlAltText.style.display = (dataType == ZDBConst.URL && (viewType == "Table" || viewType == "Report" || viewType == "QueryTable")) ? "" : "none";

    var currSymOpt = $("ZRCurrSymOpt");
    currSymOpt.style.display = (dataType == ZDBConst.CURRENCY) ? "" : "none";

    var currSymList = $("ZDBCountryNameList");
    currSymList.disabled = (viewType == "Report"|| editFrmtColOpts.mode === ZDBEditColumnFormat.EDIT_CUSTOM_FORMAT);	//No I18N

    var unitsOpt = $("ZRUnitsListOpt");
    unitsOpt.style.display = ZDBSheetFormatExtn.isNumberOnly(dataType, opr) || ZDBSheetFormatExtn.isDecimalOrCurrency(dataType) ? "" : "none";

    var unitsList = $("ZDBUnitsList");
    unitsList.disabled = (dataType == ZDBConst.AUTO_NUMBER);	//No I18N

    var deciPlaceOpt = $("ZRDeciPlacesOpt");
    deciPlaceOpt.style.display = (ZDBSheetFormatExtn.isDecimalOrCurrency(dataType) || dataType == ZDBConst.PERCENT) ? "" : "none";

    var deciPlaces = $("ZDBDeciPlaces");
    deciPlaces.disabled = !(ZDBSheetFormatExtn.isDecimalOrCurrency(dataType) || dataType == ZDBConst.PERCENT);

    var negNumOpt = $("ZRNegNumOpt");
    negNumOpt.style.display = (dataType == ZDBConst.CURRENCY) ? "" : "none";

    var sepCheck = $("ZRSeparatorCheck");
    sepCheck.style.display = ZDBSheetFormatExtn.isNumberOnly(dataType, opr) || ZDBSheetFormatExtn.isDecimalOrCurrency(dataType) || dataType == ZDBConst.PERCENT ? "" : "none";

    var sepOpts = $("ZRSeparatorOpts");
    sepOpts.style.display = ZDBSheetFormatExtn.isNumberOnly(dataType, opr) || ZDBSheetFormatExtn.isDecimalOrCurrency(dataType) || dataType == ZDBConst.PERCENT ? "" : "none";

    var thouSepOpts = $("ZRThouSepOpt");
    thouSepOpts.style.display = (ZDBSheetFormatExtn.isNumberOnly(dataType, opr) || ZDBSheetFormatExtn.isDecimalOrCurrency(dataType) || dataType == ZDBConst.PERCENT) ? "" : "none";

    var deciSepOpts = $("ZRDeciSepOpt");
    deciSepOpts.style.display = ZDBSheetFormatExtn.isNumberOnly(dataType, opr) || ZDBSheetFormatExtn.isDecimalOrCurrency(dataType) || dataType == ZDBConst.PERCENT ? "" : "none";

    var deciSep = $("ZDBDeciSeparator");
    deciSep.disabled = ZDBSheetFormatExtn.isNumberOnly(dataType, opr);

    var percentCheck = $("ZRPercentCheck");
    percentCheck.style.display = (dataType == ZDBConst.PERCENT) ? "" : "none";
    
    var displayDate = dataType == ZDBConst.DATE || dataType == ZDBConst.DATE_AS_DATE || ((opr == "ABSQUARTER" || opr == "ABSMONTH") && dataType != ZDBConst.PERCENT); // No I18n
    
    var quarterFmt = $("ZRQuarterFmt");
    quarterFmt.style.display = (opr == "QUARTER" && dataType != ZDBConst.PERCENT) ? "" : "none";
    
    var monthFmt = $("ZRMonthFmt");
    monthFmt.style.display = (opr == "MONTH" && dataType != ZDBConst.PERCENT) ? "" : "none";
    
    var weekFmt = $("ZRWeekFmt");
    weekFmt.style.display = (opr == "WEEK" && dataType != ZDBConst.PERCENT) ? "" : "none";
    
    var weekDayFmt = $("ZRWeekDayFmt");
    weekDayFmt.style.display = (opr == "WEEKDAY" && dataType != ZDBConst.PERCENT) ? "" : "none";
    
    var hourFmt = $("ZRHourFmt");
    hourFmt.style.display = (opr == "HOUR" && dataType != ZDBConst.PERCENT) ? "" : "none";
    
    var weekNYrFmt = $("ZRWeekNYearFmt");
    weekNYrFmt.style.display = (opr == "ABSWEEK" && dataType != ZDBConst.PERCENT) ? "" : "none";

    var sampleDateFormat = $("ZDBDateForList");
    sampleDateFormat.style.display = displayDate ? "" : "none";

    var custDateFormatOpt = $("ZRCustDateFormatOpt");
    custDateFormatOpt.style.display = displayDate ? "" : "none";

    if(displayDate)
    {
      var element = ZDBUtil.getCachedRef(ZDBSheetFormatExtn, "ZDBDateFormatList");  //No I18N
      var dateFormatTbl = element.cloneNode(true);
      var dateList = $("ZDBDateForList");
      dateList.innerHTML="";
      dateList.appendChild(dateFormatTbl);
      ZDBSheetFormatExtn.removeMiscOption(dateList);
      ZDBSheetFormatExtn.dateList = dateList;
      ZDBSheetFormatExtn.showOrHideDateLists(dateList, dataType, opr);
    }
    
    if(editFrmtColOpts.mode === ZDBEditColumnFormat.EDIT_CUSTOM_FORMAT)
    {
    	var enabledOpts = [], i = 0;
    	
    	enabledOpts = alignList.style.display == "none" ? enabledOpts : enabledOpts.concat(["ALIGNLIST"]);
        
    	enabledOpts = urlAltText.style.display == "none" ? enabledOpts : enabledOpts.concat(["ALTTEXT"]);

    	enabledOpts = currSymOpt.style.display == "none" || currSymList.disabled ? enabledOpts : enabledOpts.concat(["CountryNameList"]);

    	enabledOpts = unitsOpt.style.display == "none" || unitsList.disabled ? enabledOpts : enabledOpts.concat(["UnitsList"]);

    	enabledOpts = deciPlaceOpt.style.display == "none" || deciPlaces.disabled ? enabledOpts : enabledOpts.concat(["DECIPLACES"]);

    	enabledOpts = negNumOpt.style.display == "none" ? enabledOpts : enabledOpts.concat(["Negative"]);

    	enabledOpts = sepOpts.style.display == "none" ? enabledOpts : enabledOpts.concat(["LOCALE"]);

    	enabledOpts = thouSepOpts.style.display  == "none" ? enabledOpts : enabledOpts.concat(["THOUSEPARATOR"]);

    	enabledOpts = deciSepOpts.style.display == "none" || deciSep.disabled ? enabledOpts : enabledOpts.concat(["DECISEPARATOR"]);

    	enabledOpts = percentCheck.style.display == "none" ? enabledOpts : enabledOpts.concat(["ShowPercent"]);

    	enabledOpts = quarterFmt.style.display == "none" ? enabledOpts : enabledOpts.concat(["QUARTERFMT"]);

    	enabledOpts = monthFmt.style.display == "none" ? enabledOpts : enabledOpts.concat(["MONTHFMT"]);

    	enabledOpts = weekFmt.style.display == "none" ? enabledOpts : enabledOpts.concat(["WEEKFMT"]);

    	enabledOpts = weekDayFmt.style.display == "none" ? enabledOpts : enabledOpts.concat(["WEEKDAYFMT"]);

    	enabledOpts = hourFmt.style.display == "none" ? enabledOpts : enabledOpts.concat(["HOURFMT"]);

    	enabledOpts = weekNYrFmt.style.display == "none" ? enabledOpts : enabledOpts.concat(["WEEKNYEARFMT"]);

    	enabledOpts = displayDate ? enabledOpts.concat(["CusDateFormat"]) : enabledOpts;
    	return enabledOpts;
    }

  }
  
  this.isNumberOnly = function(dataType, opr)
  {
	  return dataType == ZDBConst.AUTO_NUMBER || dataType == ZDBConst.NUMBER || (dataType == ZDBConst.POSITIVE_NUMBER && opr != "YEAR" && opr != "DAY" && opr != "HOUR"); //No I18n
  }
  
  this.isDecimalOrCurrency = function(dataType)
  {
	  return dataType == ZDBConst.DECIMAL_NUMBER || dataType == ZDBConst.CURRENCY;
  }
  
  this.showOrHideDateLists = function(dateList, dataType, opr)
  {
	  var fmtType;
	  var view = ZDBClientUI.selectedTab.view;
	  if(opr == "ABSQUARTER")
	  {
		  fmtType = "Quarter"; // No I18N
	  }
	  else if(opr == "ABSMONTH")
	  {
		  fmtType = "Month"; // No I18N
	  }
	  else if(view.type != null && view.type == "AnalysisView" || view.type == "Pivot" || view.type == "SummaryView" || view.type == "WIDGET") //No I18n
	  {
		  if(opr == "TIMESTAMP")
		  {
			  fmtType = "ChartsDateWithTime"; //No I18n
		  }
		  else
		  {
			  fmtType = "ChartsDateOnly"; // No I18N
		  }
	  }
	  else
	  {
		  fmtType = "TableDate"; //No I18n
	  }
	  var reqEl;
	  var els = document.getElementsByClassName("ZRSDateHeaderPar"); //No I18N
	  for(var i = 0; i<els.length; i++)
	  {
		  var type = els[i].getAttribute("fmttype");
		  if(type != null && type.indexOf(fmtType) == -1)
		  {
			  els[i].style.display = "none";
		  }
		  else if(type != null)
		  {
			  els[i].style.display = "";
			  if(fmtType == "Quarter" || fmtType == "Month")
			  {
				  var childEl = els[i].getElementsByClassName("ZRSDateListHolder");
				  if(childEl[0].style.display == "none")
				  {
					  ZDBImport.setDateGroupVisible(els[i].childNodes[0]);
				  }
			  }
		  }
	  }	
  }
  
  this.dateOperations = ["ABSQUARTER","ABSMONTH", "QUARTER", "MONTH", "WEEKDAY", "WEEK", "HOUR", "ABSWEEK"]; // No I18N

  this.setDefaultFormatOpts_New = function(dataType, colHead, opr)
  {
	var menu = ZDBUtil.datatypeVsFormatType[ZDBUtil.dataTypeNumVsSubtypeDisp[dataType]];

	colHead = (colHead != null) ? colHead : new ZDBFormatColHeader(dataType);
	var alignList = $("ZDBAlignList");
	ZDBUtil.setValueInSelectBox(alignList,'value',colHead.alignment); //No I18N

	if(dataType == ZDBConst.URL)
	{
	  var inputEl = $("ZDBAltTextInputEl");
      inputEl.value = (colHead.altText != null) ? colHead.altText : "";
	}

	if(dataType == ZDBConst.CURRENCY)
	{
	  var currSymbol = $("ZDBCountryNameList");
	  var currIndex = 0;
	  if(colHead.showSymbol && colHead.currencyFormat)
	  {
		var currIndex = getDataIndex(currSymbol,'value',colHead.currencyFormat.split(":")[0]);     //No I18N
	    if(currIndex < 0)
	    {
	      currIndex = getDataIndex(currSymbol,'display',colHead.currencyFormat.split(":")[0]);     //No I18N
	    }
	  }
	  currSymbol[currIndex].selected = true;

	  var negativeObj = $("ZDBNegative");
	  index = getDataIndex(negativeObj,'value',colHead.showNegativeSign);
	  negativeObj[index].selected = true;
	}

	if(menu == "Numeric" || menu == "Float" || menu == "Cur" || menu == "Percent")
	{
	      if(menu != "Percent")
          {
            var unitsList = $("ZDBUnitsList");
            if(colHead.unitsList)
            {
              var unitSym = ((colHead.unitsList.split(":")).length > 1) ? colHead.unitsList.split(":")[1] : colHead.unitsList;
            }
            else
            {
              var unitSym = colHead.unitsSymbol;
            }
	  		var unitsIndex = 0;
	  		if(unitSym)
	  		{
		  		unitsIndex = getDataIndex(unitsList,'display',unitSym);     //No I18N
		  		unitsIndex = (unitsIndex < 0) ? 0 : unitsIndex;
	 	 	}
	  		unitsList[unitsIndex].selected = true;
	  	}

	  var deciPlaces = $("ZDBDeciPlaces");
	  ZDBUtil.setValueInSelectBox(deciPlaces,'value',colHead.decimalPlaces+"");

	  if((unitsIndex > 0) && (dataType == ZDBConst.NUMBER || dataType == ZDBConst.POSITIVE_NUMBER))
	  {
		$("ZRDeciPlacesOpt").style.display = "";
		deciPlaces.disabled = false;
		var view = ZDBSheetFormatExtn.editFrmtColOpts.view || ZDBClientUI.selectedTab.view;
		if(view.type && view.type == "AnalysisView" || view.type == "Pivot" || view.type == "WIDGET" || view.type == "SummaryView")
		{
			var enabledOpts = view.zacf.getEnabledOpts();
			if(enabledOpts.indexOf("DECIPLACES") == -1)
			{
				enabledOpts.push("DECIPLACES");
			}
		}
	  }

	}

	if(dataType == ZDBConst.DATE || dataType == ZDBConst.DATE_AS_DATE || opr == "ABSQUARTER" || opr == "ABSMONTH")
	{
	  $("cusDateFormat").value = colHead.dateFormat;
	  $("cusDateSample").value = ZDBImport.getSampleDate(colHead.dateFormat);
      ZDBSheetFormat.showDateFormats(colHead.dateFormat,ZDBSheetFormatExtn.dateList);
	}
	
	if(opr == "MONTH")
	{
		var monthSelect = $("ZDBMonthFmt");
		ZDBUtil.setValueInSelectBox(monthSelect, "value", colHead.dateFormat); // NO I18N
		ZDBSheetFormatExtn.setEgValue(monthSelect);
	}
	
	if(opr == "QUARTER")
	{
		var quarterSelect = $("ZDBQuarterFmt");
		ZDBUtil.setValueInSelectBox(quarterSelect, "value", colHead.dateFormat); // NO I18N
		ZDBSheetFormatExtn.setEgValue(quarterSelect);
	}
	
	if(opr == "WEEK")
	{
		var weekSelect = $("ZDBWeekFmt");
		ZDBUtil.setValueInSelectBox(weekSelect, "value", colHead.dateFormat); // NO I18N
		ZDBSheetFormatExtn.setEgValue(weekSelect);
	}
	
	if(opr == "WEEKDAY")
	{
		var weekDaySelect = $("ZDBWeekDayFmt");
		ZDBUtil.setValueInSelectBox(weekDaySelect, "value", colHead.dateFormat); // NO I18N
		ZDBSheetFormatExtn.setEgValue(weekDaySelect);
	}
	
	if(opr == "HOUR")
	{
		var hourSelect = $("ZDBHourFmt");
		ZDBUtil.setValueInSelectBox(hourSelect, "value", colHead.dateFormat); // NO I18N
		ZDBSheetFormatExtn.setEgValue(hourSelect);
	}
	
	if(opr == "ABSWEEK")
	{
		var weekNYrSel = $("ZDBWeekNYearFmt");
		ZDBUtil.setValueInSelectBox(weekNYrSel, "value", colHead.dateFormat); // NO I18N
		ZDBSheetFormatExtn.setEgValue(weekNYrSel);
	}

	$("ZDBLocale").checked = colHead.userLocale;

	var thouSeparator = $("ZDBThouSeparator");
	thouSeparator.disabled = colHead.userLocale;
	ZDBUtil.setValueInSelectBox(thouSeparator,'value',colHead.thousandSeparator); //No I18N

	var deciSeparator = $("ZDBDeciSeparator");
	deciSeparator.disabled = (colHead.userLocale || dataType == ZDBConst.AUTO_NUMBER || dataType == ZDBConst.NUMBER || dataType == ZDBConst.POSITIVE_NUMBER);
	ZDBUtil.setValueInSelectBox(deciSeparator,'value',colHead.decimalSeparator); //No I18N

	$("ZDBShowPercent").checked = (dataType == ZDBConst.PERCENT && colHead.showSymbol) ? true : false;
  }

  this.setDefaultFormatOpts = function(dataType, colHead)
  {
	if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js",this,ZDBSheetFormatExtn.setDefaultFormatOpts,[dataType, colHead]))
	{
        return;
	}
	var menu = ZDBUtil.datatypeVsFormatType[dataType];
	var viewType = ZDBClientUI.selectedTab.view.type;
        var editFrmtColOpts = ZDBSheetFormatExtn.editFrmtColOpts;

	var alignment = $("ZDB"+menu+"AlignList");
	ZDBUtil.setValueInSelectBox(alignment,'value',colHead.alignment); //No I18N

	var altText = $("ZDBURLAltText");
    altText.style.display = "none";

    if(colHead.type == "URL" && menu == "Text" && editFrmtColOpts.mode != ZDBEditColumnFormat.EDIT_CUSTOM_FORMAT)
    {
        altText.style.display = "";
        var inputEl = $("ZDBAltTextInputEl");
        inputEl.value = (colHead.altText != null) ? colHead.altText : "";
    }

    if(menu == "Date")
    {
      var element = ZDBUtil.getCachedRef(ZDBSheetFormatExtn, "ZDBDateFormatList");  //No I18N
      var dateFormatTbl = element.cloneNode(true);
      var dateList = $("ZDBDateForList");
      dateList.innerHTML="";
      dateList.appendChild(dateFormatTbl);
      $("cusDateFormat").value = colHead.dateFormat;
      $("cusDateSample").value = ZDBImport.getSampleDate(colHead.dateFormat);
      ZDBSheetFormatExtn.removeMiscOption(dateList);
      ZDBSheetFormat.showDateFormats(colHead.dateFormat,dateList);
      $('ZRCustDateFormatOpt').style.display = '';
    }
    if(menu =="Numeric")
    {
      $("ZDB"+menu+"Locale").checked = colHead.userLocale;
      var thouSeparator = $("ZDB"+menu+"ThouSeparator");
      thouSeparator.disabled = colHead.userLocale;
      ZDBUtil.setValueInSelectBox(thouSeparator,'value',colHead.thousandSeparator); //No I18N
        var countryNameList = $("ZDBNumericFormatList");
        ZDBUtil.setValueInSelectBox($("ZDBNumDeciPlaces"),'value',colHead.decimalPlaces+"");
        var index = getDataIndex(countryNameList,'value',colHead.unitsSymbol);     //No I18N
        if(index <0)
        {
          countryNameList[0].selected = true;
          $("NumericDecimalDiv").style.display="none";
          $("ZDBNumDeciPlaces")[0].selected = true;
          $("ZDBNumDeciPlaces").disabled = true;
        }
        else
        {
          $("NumericDecimalDiv").style.display="table-row";
          countryNameList[index].selected = true;
          $("ZDBNumDeciPlaces").disabled = false;
        }
        countryNameList.disabled = (viewType == "Report") ? true : false;   //No I18N
        if(dataType == "AUTO_NUMBER")
        {
          countryNameList.disabled = true;
          $("NumericDecimalDiv").style.display="none";
          $("ZDBNumDeciPlaces").disabled = true;
        }
    }
    else if(menu == "Float" || menu == "Cur" || menu == "Percent")
    {
      var decimalObj = $("ZDB"+menu+"DeciPlaces");
      ZDBUtil.setValueInSelectBox(decimalObj,'value',colHead.decimalPlaces+"");

      $("ZDB"+menu+"Locale").checked = colHead.userLocale;
      var thouSeparator = $("ZDB"+menu+"ThouSeparator");
      var deciSeparator = $("ZDB"+menu+"DeciSeparator");
      thouSeparator.disabled = colHead.userLocale;
      deciSeparator.disabled = colHead.userLocale;
      ZDBUtil.setValueInSelectBox(thouSeparator,'value',colHead.thousandSeparator); //No I18N
      ZDBUtil.setValueInSelectBox(deciSeparator,'value',colHead.decimalSeparator); //No I18N
      if(menu == "Cur")
      {
        var countryNameList = $("ZDBCountryNameList");
        var formatList = $("ZDBCurrencyFormatList");
        var format = "None";//No I18N
        var currencySymbol = colHead.currencyFormat;
        if(colHead.currencyFormat.split(":")!=undefined)
        {
            currencySymbol = colHead.currencyFormat.split(":")[0];
        }
        format = colHead.unitsSymbol;
        if(format == undefined)
            {
                format = "None";//No I18N
            }
        format = colHead.unitsList || format;
        if(colHead.showSymbol)
        {
          index = getDataIndex(countryNameList,'value',currencySymbol);     //No I18N
          if(index < 0)
          {
            index = getDataIndex(countryNameList,'display',currencySymbol);     //No I18N
          }
          countryNameList[index].selected = true;
        }
        else
        {
          countryNameList[0].selected = true;
        }
        index = getDataIndex(formatList,'value',format);     //No I18N
        index = (index < 0) ? 0 : index;
        formatList[index].selected = true;
        countryNameList.disabled = (viewType == "Report" || editFrmtColOpts.mode == ZDBEditColumnFormat.EDIT_CUSTOM_FORMAT)  ? true : false;   //No I18N
        formatList.disabled = (viewType == "Report") ? true : false;   //No I18N
        var negativeObj = $("ZDBNegative");
        index = getDataIndex(negativeObj,'value',colHead.showNegativeSign);
        negativeObj[index].selected = true;
      }
      if(menu == "Float")
      {
        var countryNameList = $("ZDBDecimalFormatList");
        index = getDataIndex(countryNameList,'value',colHead.unitsSymbol);     //No I18N
        index = (index < 0) ? 0 : index;
        countryNameList[index].selected = true;
        countryNameList.disabled = (viewType == "Report") ? true : false;   //No I18N
      }
      if(menu == "Percent")
      {
        $("ZDBShow"+menu).checked = (colHead.showSymbol) ? true : false;
      }
    }
  }

  this.setValuesInFormatDlg = function(gridObj,colHead,listEl,editFrmtColOpts, opr)
  {
    var type = (colHead.type == "REFCOL") ? colHead.refColType:(colHead.type == "RELCOL")?colHead.relColType : colHead.type; //No I18N
    var menu = ZDBUtil.datatypeVsFormatType[type];
    $("ZDBColFmtObjIdInp").value="" + editFrmtColOpts.objId;
    $("ZDBColFmtColIdInp").value="" + colHead.colId;
    if(gridObj)
    {
    	$("ZDBColFmtObjTypeInp").value="" + gridObj.type;
    }
    var tdEl = $("ZDBAddFormatTable");
    ZDBUtil.removeNonElements(tdEl);
    if(tdEl.childNodes.length > 0)
    {
      $("ZDBDummyFormatTblDiv").appendChild(tdEl.childNodes[0]);
    }
    var tableEl = $("ZDBFormatOptions");
    tdEl.innerHTML="";
    jQuery(tableEl).prepend(jQuery("#ZRFormatColTypeDiv"));	//No I18N
    jQuery(tableEl).prepend(jQuery("#ZRFormatColNameDiv"));	//No I18N

    $("ZRFormatColTypeDiv").style.display = "";
    $("ZRFormatColNameDiv").style.display = "";

    if(editFrmtColOpts.mode != ZDBEditColumnFormat.EDIT_FROM_FORMULA &&
  		  editFrmtColOpts.mode != ZDBEditColumnFormat.EDIT_FROM_REPORTS)
    {

    	var colEl = $("ZDBFormatColName");
      colEl.innerHTML = ZDBEscapeUtil.encodeForHtml(colHead.displayName);

      var colType = $("ZDBFormatColType");
      var type = ZDBUtil.dataTypeVsDisplayType[colHead.type];
      if(ZDBSheetFormatExtn.dateOperations.indexOf(opr) > -1 || opr == "YEAR" || opr == "DAY")
      {
    	  type = "Date"; //No I18N
      }
      colType.innerHTML = type;
    }
    else
    {
    	$("ZRFormatColTypeDiv").style.display = "none";
    	$("ZRFormatColNameDiv").style.display = "none";
    }
    tdEl.appendChild(tableEl);
    this.setDefaultFormatOpts_New(ZDBSheetFormatExtn.dataType, colHead, opr);
  }

  this.showFormatDlg = function(gridObj,colHead,listEl,editFrmtColOpts,srcEl)
  {
	var form = ZDBUtil.getCachedRef(ZDBSheetFormatExtn,'ZDBColumnFormatFrm'); //No I18N
        form.setAttribute("isModified","false");
	form.colHead = colHead;
	form.listEl = listEl;
	form.gridObj = gridObj;
	form.editFrmtColOpts = editFrmtColOpts;
	srcEl = (srcEl) ? srcEl : colHead.cellEl;
	var callout = (srcEl) ? true : false;
	var el = ZDBUtil.getCachedRef(ZDBSheetFormatExtn, "ZDBColumnFormatDlg");    //No I18N
    el.style.display = "block";
    var title = ZDBI18NMap.g("zrpt.common.column.format.js.dlgTtl",el);
	ZDBDialogUtil.showDialog(el,{TITLE:title,HELPDOC:ZDBI18NMap.g("zrpt.common.column.format.js.helplink"),HELPVIDEO:"ZDBClientUI.showVideo('"+ZDBI18NMap.g('zrpt.common.column.format.js.helpvideolink')+"');",ADDFRAME:true,MODAL:true,CALLOUT:callout,SRCEL:srcEl}); //No I18N
    $("ZDBCOLUMNFORMATOPTSTATUS").className = "mcLoaded";
  }
  
  this.setEgValue = function (el)
  {
	var value = el.value;
	var type = el.getAttribute("name");
	var eg;
	if(type == "MONTHFMT")
	{
		if(value == "MMM")
		{
			eg = "Jan, Feb, Mar"; // No I18n
		}
		if(value == "MMMM")
		{
			eg = "January, February, March"; // No I18n
		}
		var egEl =  $("fmtEgMon");
	}
	if(type == "QUARTERFMT")
	{
		if(value == "qq")
		{
			eg = "Q1, Q2"; // No I18n
		}
		if(value == "qqqq")
		{
			eg = "Quarter1, Quarter2"; // No I18n
		}
		var egEl = $("fmtEgQr");
	}
	if(type == "WEEKFMT")
	{
		if(value == "WW")
		{
			eg = "W1, W2, W3"; //No I18n
		}
		if(value == "WWWW")
		{
			eg = "Week1, Week2, Week3"; //No I18n
		}
		var egEl = $("fmtEgWeek");
	}
	if(type == "WEEKDAYFMT")
	{
		if(value == "EEE")
		{
			eg = "Sun, Mon, Tue"; //No I18n
		}
		if(value == "EEEE")
		{
			eg = "Sunday, Monday, Tuesday"; //No I18n
		}
		var egEl = $("fmtEgWeekDay");
	}
	if(type == "HOURFMT")
	{
		if(value == "24-h")
		{
			eg = "11, 12, 13, 14"; //No I18n
		}
		if(value == "12-h")
		{
			eg = "11 AM, 12 PM, 1 PM, 2 PM"; //No I18n
		}
		var egEl = $("fmtEgHour");
	}
	if(type == "WEEKNYEARFMT")
	{
		if(value == "0")
		{
			eg = "W01 2012, W02 2012"; //No I18n
		}
		else if(value == "1")
		{
			eg = "Week 01 2012, Week 02 2012"; //No I18n
		}
		else if(value == "2")
		{
			eg = "01 Apr 2012 - 07 Apr 2012"; //No I18n
		}
		var egEl = $("fmtEgWeekNYr");
	}
	egEl.innerText = "Eg: " + eg; // No I18n
	
  }
  
  this.hideTabs = function()
  {
	  var tabSelector = $("posTabSel");
	  var applyToAllDiv = $("isApplyToAll");
	  tabSelector.style.display = "none";
	  applyToAllDiv.style.display = "none";
	  return;
  }
  
  this.replaceApplyToAllDiv = function(isWidget)
  {
	  var applyToAllDiv = $("isApplyToAll");
	  var clonedDiv = applyToAllDiv.cloneNode(true);
	  applyToAllDiv.parentNode.replaceChild(clonedDiv, applyToAllDiv);
	  var label = $(applyToAllLabel);
	  if(isWidget)
	  {
		  label.innerText = ZDBI18NMap.g("zrpt.column.js.formatclm.applytoall.widget");
	  }
	  else
	  {
		  label.innerText = ZDBI18NMap.g("zrpt.column.js.formatclm.applytoall.chart");
	  }
  }
  
  this.showOrHideTabs = function(colFormats, view, srcEl, dataType) // Nandha needs code clean up
  {
	var isChart = view.type == "AnalysisView"; 
	var isWidget = view.type == "WIDGET";
	var instKey = srcEl.getAttribute("instKey");
	var oldInstKey = ZDBAnalysisView.replaceInstKey(view, instKey);
	var positions = view.zacf.getAvlblPositions();
	positions = ZACF.getValidPositions(view, instKey, positions);
	var tabSelector = $("posTabSel");
	ZDBSheetFormatExtn.replaceApplyToAllDiv(isWidget);
	var applyToAllDiv = $("isApplyToAll");
	var tabParent = $("tabPar");
	var applyToAll = $("applyToAll");
	var opr = ZACF.getCorresOperation(view.zacf.getCurrKey(), view, "operation");
	if(!ZDBGlobal.enablePosFormatting || !(isChart||isWidget) || positions.length == 1 
			|| (dataType == ZDBConst.PLAIN && ZDBSheetFormatExtn.dateOperations.indexOf(opr) == -1 && isChart && view.chartObj.getChartType() != ZCHARTCONST.get("PIE")) // No I18n 
				|| (dataType == ZDBConst.POSITIVE_NUMBER && (opr == "YEAR" || opr == "DAY")) || dataType == ZDBConst.EMAIL || dataType == ZDBConst.URL || dataType == ZDBConst.BOOLEAN || dataType == ZDBConst.MULTI_LINE// No I18n
					|| dataType == ZDBConst.GEO || dataType == ZDBConst.GEO_NUM) 
  	{
  		ZDBSheetFormatExtn.hideTabs();
  		if(isChart && view.chartObj.getChartType() != ZCHARTCONST.get("PIE")) // positions length will be 1 for multiy pie charts
  		{
  			return;
  		}
  	}
	else
	{
		tabSelector.style.display = "";
		applyToAllDiv.style.display = "inline";
		var currPositions = Object.keys(colFormats);
		if(view.zacf.get()["APPLYTOALL"])
		{
			applyToAll.checked = true;
		}
		else
		{
			applyToAll.checked = false;
			var operation = ZACF.getCorresOperation(view.zacf.getCurrKey(), view, "operation"); //NO I18n
			var format = colFormats[positions[0]] || ZACF.getFormatInfo(view, "DEFAULT");
			ZDBSheetFormatExtn.setValuesInFormatDlg(view, format, null, ZDBSheetFormatExtn.editFrmtColOpts, operation);
		}
		applyToAll.addEventListener("click",function(event){ZDBSheetFormatExtn.toggleApplyToAllOpt(applyToAll, view, tabParent, srcEl, this, event);});
		applyToAllDiv.addEventListener("click",function(event){ZDBSheetFormatExtn.toggleApplyToAllOpt(applyToAll, view, tabParent, srcEl, this, event);});
	}
	var tab = document.createElement("div");
  	var numOfTabs = positions.length;
  	tab.className = "posTab";
  	tab.setAttribute("isSelected", false);
  	tab.addEventListener("mouseover", 
  			function()
  			{
		  		if(event.target.getAttribute("isSelected") == "false")
		  		{
		  			this.style.backgroundColor = "#efefef";
		  		}
  			});
  	
  	while(tabParent.firstChild)
  	{
  		tabParent.removeChild(tabParent.firstChild);
  	}
  	var proceed = ZACF.showOrHideTabsForPie(view, srcEl, tabParent, tab, positions);
  	if(proceed)
  	{
  		var borderDiv = document.createElement("div");
  		borderDiv.className = "borderTab";
  		tabParent.appendChild(borderDiv.cloneNode());
	  	for(var i=0; i< numOfTabs; i++)
	  	{
	  		var newTab = tab.cloneNode();
	  		newTab.setAttribute("type","positionTab");
	  		if(i==0)
	  		{
	  			newTab.className += " posTabSelected"; //No I18N
	  			newTab.setAttribute("isSelected", true);
	  			newTab.style.borderLeft = "0px"; // No I18N
	  		}
	  		if(applyToAll.checked && i != 0)
	  		{
	  			newTab.className = "posTab posTabDisable"; //NO I18N
	  		}
	  		newTab.addEventListener("click", function(){ZDBSheetFormatExtn.changePosTab(this, srcEl);});
	  		ZACF.addListeners(newTab);
	  		newTab.innerText = ZACF.getDisplayValue(view, positions[i], instKey);
	  		newTab.setAttribute("value", positions[i]);
	  		tabParent.appendChild(newTab);
	  	}
  	}
  	if(applyToAll.checked)
  	{
  		tabSelector.className = "tabSelector";
		tabParent.className = "tabPar";
  	}
  	else
  	{
  		tabSelector.className = "tabSelector slideTab";
  		tabParent.className = "tabPar showTab";
  	}
  	var sibling = $("ZRFormatColTypeDiv");
   sibling.parentNode.insertBefore(tabSelector, sibling.nextSibling);
   sibling.parentNode.insertBefore(applyToAllDiv, sibling.nextSibling);
  }
  
  this.changePosTab = function(el, srcEl)
  {
	  if(el.getAttribute("isSelected") == "true" || $("applyToAll").checked == true)
	  {
		  return;
	  }
	  var view = ZDBClientUI.getViewObj(srcEl, "view");
	  var parent = el.parentElement;
	  var prevTab;
	  var tabs = ZDBUtil.getElsWithTagNAttrWithVal(parent, "type", "positionTab", "div"); //No I18n
	  for(var i = 0; i < tabs.length; i++)
	  {
		  var ele = tabs[i];
		  if(ele.getAttribute("isSelected") == "true")
		  {
			  prevTab = ele;
		  }
		  ele.className="posTab";
		  ele.setAttribute("isSelected", false);
	  }
	  ZACF.updateTempFmt(view, prevTab);
	  el.className += " posTabSelected"; //No I18N
	  el.setAttribute("isSelected", true);
	  if(parent.firstChild == el)
	  {
		  el.style.borderLeft="0px"; // No I18N
	  }
	  if(parent.lastChild == el)
	  {
		  el.style.borderRight = "0px"; // No I18N
	  }
	  var value = el.getAttribute("value");
	  var instKey = srcEl.getAttribute("instKey");
	  var positions = view.zacf.getAvlblPositions();
	  var tempFmt = view.zacf.tempFmt;
	  var zacf = tempFmt[positions[0]] || ZACF.getFormatInfo(view, positions[0]) || ZACF.getFormatInfo(view, "DEFAULT");//view.type == "WIDGET" ? WidgetEditor.editor.cinfo.ZAF.zacf[instKey][positions[0]] : view.zaf.zacf[instKey][positions[0]];
	  var colFormat = tempFmt[value] || zacf; // || tempFmt[positions[0]] if First Tab is Default. Now its display Value is Axis
	  var opr = ZACF.getCorresOperation(instKey, view, "operation");
	  this.blinkOnce(view);
	  ZDBSheetFormatExtn.setValuesInFormatDlg(null,colFormat,null,ZDBSheetFormatExtn.editFrmtColOpts, opr);
  }
  
  this.blinkOnce = function (view)
  {
	  var formNodes = {};
  	  ZDBUtil.setNamedChildEls($('ZDBAddFormatTable'),formNodes,'name');
      delete formNodes.nameSet;
	  var enabledOptions = view.zacf.getEnabledOpts();
  	  for(var nodeKey in formNodes) 
  	  {
	  	  if(enabledOptions.indexOf(nodeKey) == -1)
	  	  {
	  		continue;
	  	  }
	  	  var node = formNodes[nodeKey];
	  	  node.style.opacity = 0;
	      var callTimeout = setTimeOut(node);
	      callTimeout();
  	  }
  	  function setTimeOut(node)
  	  {
  		  var callTimeout = function()
  		  {
  			  setTimeout(function(){node.style.opacity = 1}, 100);
  		  }
  		  return callTimeout;
  	  }
  }
  
  this.toggleApplyToAllOpt = function(el, view, tabParent, srcEl, clickedEl, event)
  {
	  if(el != clickedEl)
	  {
		  el.checked = !el.checked;
	  }
	  else
	  {
	  	event.stopPropagation();
	  }
	  var tabs = ZDBUtil.getElsWithTagNAttrWithVal(tabParent, "type", "positionTab", "div"); //No i18n
	  if(el.checked)
	  {
		for(var i = 0; i<tabs.length; i++)
		{
//			var tab = tabs[i];
//			if(i != 0)
//			{
//				tab.className = "posTab posTabDisable"; //NO I18N
//			}
//			else
//			{
//				tab.className = "posTab posTabSelected"; //No I18n
//			}
		}
		view.zacf.tempFmt["APPLYTOALL"] = true;
		var tabSelector = $("posTabSel");
		tabSelector.className = "tabSelector";
		tabParent.className = "tabPar";
	}
	  else
	  {
		  ZACF.updateTempFmt(view, null, true);
		  for(var i = 0; i<tabs.length; i++)
			{
				var tab = tabs[i];
				if(tab.getAttribute("isSelected") == "false")
				{
					tab.className = "posTab"; //NO I18N 
				}
				else if(tab.getAttribute("isSelected") == "true")
				{
					tab.className = "posTab posTabSelected";
				}
			}
		  view.zacf.tempFmt["APPLYTOALL"] = false;
		  var tabSelector = $("posTabSel");
		  tabSelector.className = "tabSelector slideTab";
		  tabParent.className = "tabPar showTab";
	  }
  }

  this.showHideDecimalOption= function(el)
  {
	var type = ZDBSheetFormatExtn.dataType;
        this.setDefaultDecimalValue(el);
	if(!(type == ZDBConst.NUMBER || type == ZDBConst.POSITIVE_NUMBER))
	{
	  return;
	}
	var formatDiv = $("ZDBUnitsList");
	var selectedFormat = jQuery(formatDiv).find(":selected").text();

	var deciPlacesDiv = $("ZRDeciPlacesOpt");
	var deciPlaces = $("ZDBDeciPlaces");
	if(selectedFormat=="None")
	{
	  deciPlacesDiv.style.display="none";
	  deciPlaces[0].selected = true;
	  deciPlaces.disabled = true;
	}
	else
	{
	  deciPlacesDiv.style.display="table-row";
	  deciPlaces.disabled = false;
	  var view = ZDBSheetFormatExtn.editFrmtColOpts.view || ZDBClientUI.selectedTab.view;
	  if(view.type && view.type == "AnalysisView" || view.type == "Pivot" || view.type == "WIDGET" || view.type == "SummaryView")
      {
		  var enabledOpts = view.zacf.getEnabledOpts();
		  if(enabledOpts.indexOf("DECIPLACES") == -1)
		  {
			  enabledOpts.push("DECIPLACES");
		  }
      }
	}
  }

  this.setDefaultDecimalValue= function(el)
  {
		var selectedFormat = jQuery(el).find(":selected").text();
		if(selectedFormat!="None" )
		{
        $("ZDBDeciPlaces").selectedIndex=3;
     }
  }

  this.apppliedFormatModified = function(appliedFormatOpt)
  {
      appliedFormatOpt.setAttribute("isModified","true");
  }

  this.formModified = function(form)
  {
      form.setAttribute("isModified","true");
  }

  this.validateSeparators = function(el)
  {
	  var thouSep = $("ZDBThouSeparator").value;
	  var deciSep = $("ZDBDeciSeparator").value;
	  var msg = ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.separatorsAreSame");
	  if((thouSep == 1 && deciSep == 1) || (thouSep == 2 && deciSep == 0))
	  {
		  showCustomMessage(msg, el);
		  return false;
	  }
	  else
	  {
		  hideCustomMessage();
		  return true;
	  }

  }
  
  this.removeMiscOption =  function(dateList)
  {
      jQuery(dateList).find("div[elname='miscellaneous']").hide();
  }

  this.submit = function(form)
  {
	if(!ZDBSheetFormatExtn.validateSeparators($("ZDBThouSeparator")))
	{
	   return;
	}
    if(form.editFrmtColOpts.mode === ZDBEditColumnFormat.EDIT_CUSTOM_FORMAT) {
      var colHead = form.colHead;
      var view = form.editFrmtColOpts.view;
      var type = (colHead.type == "REFCOL") ? colHead.refColType : (colHead.type == "RELCOL") ? colHead.relColType : colHead.type; //No I18N
      if(type == "DATE" || (ZACF.isPie(view) && ZACF.getCorresOperation(view.zacf.getCurrKey(), view, "operation") == "DATE" || ZACF.getCorresOperation(view.zacf.getCurrKey(), view) == "TIMESTAMP")) // type will be percent for Pie chart
      {
        var dlgEl = ZDBDialogUtil.focusDialog.bodyContent;
        var dateFormatEl = jQuery(dlgEl).find("#cusDateFormat")[0];
        var dateFormat = dateFormatEl.value;
        if(dateFormat.trim())
        {
          var url = "/ZDBImportData.ve?ZDBACTION=DATEFORMATVALIDATE&DATEFORMAT=" + encodeURIComponent(dateFormat);   //No I18N
          AjaxAPI.sendRequest({URL:url,ONSUCCESSFUNC:"ZDBSheetFormatExtn.handleDateFormatValidate"});   //No I18N
          return;
        }
      }
      var view = form.editFrmtColOpts.view;
      if(!ZACF.validateMonthNQtrFmt(view.zacf.getCurrKey(), view))
      {
    	  return;
      }
      ZACF.updateTempFmt(view, null);
      ZACF.updateZACFInst(view);
      return;
    }
    var dlgEl = ZDBDialogUtil.focusDialog.bodyContent;
    var els = DOMUtils.getChildElsWithAttr(dlgEl,"name","*");    //No I18N
    if(!validateFormElements(els,dlgEl))
    {
      return;
    }
    var colHead = form.colHead;
    var action = '/ZDBDatabaseActionMI.ma'; //No I18N
    var onSuccessFunc = 'ZDBSheetFormatExtn.closeDlg'; //No I18N
    if(form.editFrmtColOpts.mode == ZDBEditColumnFormat.EDIT_FROM_TABLE)
    {
      onSuccessFunc = 'ZRFormulaColumn.updateEditForDlg' //No I18N
    }
    else if(form.editFrmtColOpts.mode == ZDBEditColumnFormat.EDIT_FROM_REPORTS)
    {
      var formulaDlg = ZDBUtil.getCachedRef(ZDBDerivedField,'ZDBDERIVEDFIELDDIALOG'); //No I18N
      this.setFormatInColHead(colHead);
      formulaDlg.formatColDet = colHead;
      formulaDlg.formatApplied = true;
        ZDBDialogUtil.closeDialog();
        return;
      }
    else if(form.editFrmtColOpts.mode == ZDBEditColumnFormat.EDIT_FROM_FORMULA)
    {
      var formulaDlg = ZDBUtil.getCachedRef(ZDBDerivedField,'ZDBDERIVEDFIELDDIALOG'); //No I18N
      this.setFormatInColHead(colHead);
      formulaDlg.formatColDet = colHead;
      formulaDlg.formatApplied = true;
      ZDBDialogUtil.closeDialog();
      return;
    }
    action += '?FROMEDITFROMULAS=' + form.editFrmtColOpts.mode;//No I18N
    form.action = action;
    form.setAttribute('onsuccessfunc',onSuccessFunc);
    var type = (colHead.type == "REFCOL") ? colHead.refColType : (colHead.type == "RELCOL") ? colHead.relColType : colHead.type; //No I18N
    if(type == "DATE" || type == "DATE_AS_DATE")
    {
      var dateFormatEl = jQuery(dlgEl).find("#cusDateFormat")[0];
      var dateFormat = dateFormatEl.value;
      if(dateFormat.trim())
      {
          var url = "/ZDBImportData.ve?ZDBACTION=DATEFORMATVALIDATE&DATEFORMAT=" + encodeURIComponent(dateFormat);   //No I18N
          AjaxAPI.sendRequest({URL:url,ONSUCCESSFUNC:"ZDBSheetFormatExtn.handleImportDateValidate"});   //No I18N
          return;
      }
      else
      {
        return;
      }
    }
    if(type == "URL")
    {
        var altText = $("ZDBURLAltText");
        var inputEl = $("ZDBAltTextInputEl");
        ZDBUtil.removeAttribute(inputEl, "name");
        var value = inputEl.value;
        if(value != null && value != "")
        {
            ZDBUtil.setAttribute(inputEl, "ALTTEXT", "name");
        }
        AjaxAPI.submit(form);
    }
    else
    {
      AjaxAPI.submit(form,{PAREL:form,GRIDOBJ:form.gridObj,VIEW:form.editFrmtColOpts.view});
    }
  }

  this.handleImportDateValidate = function(response,requestOptions)
  {
    if(response.responseText == "false")
    {
        var dfEl = $("cusDateFormat");
        showCustomMessage(ZDBI18NMap.g("zrpt.common.sheetformat.custommsg.js.invalidDateFormatStr"), dfEl);
        return;
    }
    else
    {
      var form = document.getElementById("ZDBColumnFormatFrm");
      AjaxAPI.submit(form,{GRIDOBJ:form.gridObj});
    }
  }

  this.handleDateFormatValidate = function(response,requestOptions)
  {
	  if(response.responseText == "false")
	    {
	        var dfEl = $("cusDateFormat");
	        showCustomMessage(ZDBI18NMap.g("zrpt.common.sheetformat.custommsg.js.invalidDateFormatStr"), dfEl);
	    }
	  else
		  {
		  var form = document.getElementById("ZDBColumnFormatFrm");
		  ZACF.updateTempFmt(form.editFrmtColOpts.view);
		  ZACF.updateZACFInst(form.editFrmtColOpts.view);
		  }
	  return;
  }

  this.closeDlg = function(response,requestOptions)
  {
  	var gridObj = ZDBDataGrid.parseGridResponse(null,response.responseText);
    ZDBClientUI.selectedTab.view.viewCtx.handle(gridObj);
    if(BROWSER.SAFARI == 1) //  to fix safari issue , safari current version only computes table layout fixed after this
	  {
    	ZDBUtil.removeAndInsertJsObj(gridObj);
	  }
    gridObj.maintainWidthArray(gridObj.colHead);
    gridObj.adjustInViewRowsHeight();
    ZDBDialogUtil.closeDialog();
  }

  this.enableOrDisableSepOptn = function()
  {
	var userLocale = $("ZDBLocale").checked;
	var type = ZDBSheetFormatExtn.dataType;
	$("ZDBThouSeparator").disabled = userLocale;
	$("ZDBDeciSeparator").disabled = (type == ZDBConst.NUMBER || type == ZDBConst.POSITIVE_NUMBER ||
										type == ZDBConst.AUTO_NUMBER || userLocale);
  }

  this.setFormatInColHead = function(colHead)
  {
	var dataType = ZDBUtil.dataTypeVsdataTypeNum[colHead.type];
	var dataTypeFormatType = ZDBUtil.datatypeVsFormatType[colHead.type];

	var alignList = $("ZDBAlignList");
	colHead.alignment = alignList[alignList.selectedIndex].value;

	if(dataType == ZDBConst.URL)
	{
	  var altTextInp = $("ZDBAltTextInputEl").value;
	  colHead.altText = (altTextInp && altTextInp != "") ? altTextInp : "";
	}
	if(dataType == ZDBConst.DATE || dataType == ZDBConst.DATE_AS_DATE)
	{
	  colHead.dateFormat = $("cusDateFormat").value;
	}

	if(dataTypeFormatType != "Text" && dataTypeFormatType != "Date")
	{
	  colHead.userLocale = $("ZDBLocale").checked;

	  var thouSep = $("ZDBThouSeparator");
	  colHead.thousandSeparator = thouSep[thouSep.selectedIndex].value;
	}

	if(dataType == ZDBConst.CURRENCY)
	{
	  var currencyFormat = $("ZDBCountryNameList");
	  colHead.currencyFormat = currencyFormat[currencyFormat.selectedIndex].value;
	  if(colHead.currencyFormat != "None")
	  {
		  colHead.showSymbol = true;
	  }

	  var negativeOpts = $("ZDBNegative");
	  colHead.showNegativeSign = (negativeOpts[negativeOpts.selectedIndex].value == "true");
	}

	if(dataType != ZDBConst.PERCENT && dataTypeFormatType != "Text")
	{
	  var unitsList = $("ZDBUnitsList");
	  var units = unitsList[unitsList.selectedIndex].value;
	  var currFmt = colHead.currencyFormat.split(":")[0];
          colHead.currencyFormat = currFmt;	//No I18N
	  colHead.unitsSymbol = units;	//No I18N
	}

	if((((dataType == ZDBConst.NUMBER || dataType == ZDBConst.POSITIVE_NUMBER) && units!="None") || dataType == ZDBConst.DECIMAL_NUMBER || dataType == ZDBConst.CURRENCY || dataType == ZDBConst.PERCENT))
	{
	  var deciPlacesList = $("ZDBDeciPlaces");
	  colHead.decimalPlaces = deciPlacesList[deciPlacesList.selectedIndex].value;

	  var deciSep = $("ZDBDeciSeparator");
	  colHead.decimalSeparator = deciSep[deciSep.selectedIndex].value;
	}

	if(dataType == ZDBConst.PERCENT)
	{
	  colHead.showSymbol = $("ZDBShowPercent").checked;
	}
  }

}


ZDBEditColumnFormat.NORMAL_COL_FORMAT = 1;
ZDBEditColumnFormat.EDIT_FROM_TABLE = 2;
ZDBEditColumnFormat.EDIT_FROM_REPORTS = 3;
ZDBEditColumnFormat.EDIT_FROM_FORMULA = 4;
ZDBEditColumnFormat.EDIT_CUSTOM_FORMAT = 5;

function ZDBEditColumnFormat(objId,mode,view)
{
  this.objId = objId;
  this.mode = mode;
  this.view = view;

}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBSheetFormatExtn.showColumnFormatDlg"]=ZDBSheetFormatExtn.showColumnFormatDlg;
