//$Id$

var ZDBIntegration = new function()
{

  this.postListener = function(event)
  {
	if(ZDBGlobal.FROMSERVICE =='ZP' || ZDBGlobal.FROMSERVICE =='ZC')
	{
		if(event.origin)
		{
			var eventdata = event.data;
			if(eventdata && eventdata === "refreshColumnList")
			{
				var view = window.ZDBClientUI.selectedTab.view;
				ZDBAnalysisView.sendTblColInfoReq(null, view);
			}
			else if(eventdata && eventdata === "styling")
			{// for Creator styling
				var el = event.element;
				var className = event.className;
				ZDBUtil.addClass(el, className);
			}
			else
			{
				ZDBIntegration.getXMLConfig();
			}
		}
		else
		{
			ZDBIntegration.getXMLConfig();
		}
	}
  }


  // This method is used for the CreatorUI Automation. Now, removed the setDomain. We need to handle this too with listner
  this.closeEditorWindow = function()
  {
    window.parent.ViewEditor.closeEditorWindow();
  }

  this.init = function()
  {
	  var parent = window.parent;
	  var message = {};
	  message.type="init";
	  parent.postMessage(message, "*");
  }

  this.getXMLConfig = function()
  {
      if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","ZAAnalysisFields"],"APPENDTODOC",ZDBIntegration.getXMLConfig))
      {
          return;
      }
	  var xml = "";
	  var view = window.ZDBClientUI.selectedTab.view;
	  if(!ZDBAnalysisEditViewMode.validateViewCheck(view))
	  {
		  return xml;
	  }
	  xml = ZDBAnalysisConfig.getCurrentConfig(view,true);
	  var parent = window.parent;
	  var message = {};
	  message.type="xml";
	  message.data=xml;
	  parent.postMessage(message,"*");
  }

  this.addColumnNotify = function()
  {
      var parent = window.parent;
      var message = {};
      message.type="addColumn";
      parent.postMessage(message,"*");
  }
}

window.addEventListener("message", ZDBIntegration.postListener,true);
