//$Id$

var ZDBPricing = new function()
{
	this.selectedObjects = "";
	this.selectedEmailIds = "";
	this.selectedZUIDs = "";
	this.validPromo = false;

	this.sendMails = new Array();
	this.selectTab = function(el,showStatusMsg,respArray)
	{
		var selectedTab = $("ZDBPriceSelTab");
		selectedTab.id = "";
		el.setAttribute("id","ZDBPriceSelTab");
		
		var showPage = el.getAttribute("showpage");
		var action = el.getAttribute("action");
	    var localStore = "true";
	    var url= "";
	    if(action == "WHITELABELREBRANDING"){
	    	AjaxAPI.sendRequest({URL:"/ZRCustomDomains.cc?ZDBACTION="+action, METHOD:"GET", SHOWPAGE:showPage, ONSUCCESSFUNC:ZDBPricing.handleTabResp,
                OPSTATUSID:"ZDBMainLoader"});  //No I18N
	    }else{
	    	if(action == "MANAGEUSERS")
		    {
				ZDBPricing.sendMails = ZDBPricing.sendMails || new Array();
				if(ZDBPricing.isCached == null)
				{
					ZDBPricing.isCached = localStore = false;
				}
				url="&LOCALSTORE="+localStore;    //No I18N
		    }
	    	AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION="+action+"&STRUCT=false"+"&SHOWPAGE="+showPage+url, METHOD:"GET",    //No I18N
		    	SHOWPAGE:showPage,SHOWSTATUSMSG:showStatusMsg,RESPARRAY:respArray,ONSUCCESSFUNC:ZDBPricing.handleTabResp,
		    	OPSTATUSID:"ZDBMainLoader"});  //No I18N
	    }
	    ZDBPricing.selectedObjects = "";
		ZDBPricing.selectedEmailIds = "";
		ZDBPricing.selectedZUIDs = "";
	}
	
	this.planChange = function(el)
	{
		var planId = el.getAttribute("planId");
		var isTrial = el.getAttribute("isTrial");
		var isTrialUser = el.getAttribute("isTrialUser");
		var plan = el.getAttribute("planName");
		var currentPlanId = el.getAttribute("currentplanid");
		var selectedPlanId =el.getAttribute("planid");
		var userProfileId =el.getAttribute("profileId");
		var cost = el.getAttribute("cost");
		var storePlanId = el.getAttribute("storePlanId");
		var curPlanCost = jQuery(".ManageRBtn").attr("cost");		//No I18N
		if (isTrial == "true")
		{
			//call Zoho stores with out profile  Id url
			AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=TRIALPLAN&STRUCT=false&PLANID=" + storePlanId, METHOD: "GET", ONSUCCESSFUNC:ZDBPricing.handleRespNSelectTab,OPSTATUSID:"ZDBMainLoader"});    //No I18N
		}
	    else if (isTrialUser == "true" && selectedPlanId == "1" && plan == "Free")
	    {
	      AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=DOWNGRADETRIAL",   //No I18N
	                                             ONSUCCESSFUNC:ZDBPricing.handleRespNSelectTab,
	                                             OPSTATUSID:"ZDBMainLoader"});  //No I18N
	    }
		else 
		{
			AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION=MANAGEPLAN&STRUCT=false&SHOWPAGE=ManagePlan&PLANID=" + planId + "&ISTRIAL=" + isTrial+ "&PLAN=" + plan + "&PROFILEID=" + encodeURIComponent(userProfileId), METHOD: "GET", CURRENTPLANID:currentPlanId,SELECTEDPLANID:selectedPlanId,COST:cost,CURPLANCOST:curPlanCost,ISTRIALUSER:isTrialUser, STOREPLANID:storePlanId, ONSUCCESSFUNC:ZDBPricing.handlePlanChangeResp,OPSTATUSID:"ZDBMainLoader"});   // No I18N
		}
	}
	
	this.showDowngradeConfirmDlg = function(response,requestOptions)
	{
	    var el = requestOptions["DOWNGRADEBUTTON"];
	    var container = document.createElement("DIV");
	    container.style.display = "none";
	    document.body.appendChild(container);
	    container.innerHTML = response.responseText;
	    var confirmDlg = $("ZDBDowngradeConfirmDlg");
		confirmDlg.style.display = "";
		$("ZDBConfirmBtn").el = el;
		ZDBDialogUtil.showDialog(confirmDlg,{TITLE:ZDBI18NMap.g("zrpt.common.pricing.js.downgrade_proceed"),ADDFRAME:true,FRAMETYPE:'ZDBInfoDlg',MODAL:true, FREEZEBGCLASSNAME:'blackFreezeLayer'});   //No I18N
	}
	
	this.confirmDowngrade = function(confirmBtn)
	{
		ZDBPricing.payNUpdatePlan(confirmBtn.el);
		ZDBDialogUtil.closeDialog();
	}
	
	this.continuePayNUpdatePlan = function(el)
	{
		var isdowngrade = (el.getAttribute("ISDOWNGRADE")=="true");
		if(isdowngrade)
		{
	      var targetPlanId =el.getAttribute("STOREPLANID");
		  var addOnUserCB = $("ZDBAdonUser");
		  var addOnUsrCount = (addOnUserCB[addOnUserCB.selectedIndex]).value;
		  if (el.getAttribute("planId") == 1 && addOnUsrCount > 0)
		  {
		    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.pricing.js.cannot_purchase_user"));
		    return;
		  }
		  else
		  {
		      var addOnRowsCB = $("ZDBAdonRows");
		      var addOnSchMailCB = $("ZDBAdonSchMail");
		      var addOnAPIUnitsCB = $("ZDBAdonAPIUnits");
		      var addOnRowName = (addOnRowsCB[addOnRowsCB.selectedIndex]).value;
		      var addOnSchMailName = (addOnSchMailCB[addOnSchMailCB.selectedIndex]).value; 
		      var addOnAPIUnitsName = (addOnAPIUnitsCB[addOnAPIUnitsCB.selectedIndex]).value; 
		      AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION=CONFIRMDOWNGRADE&STRUCT=false&" +
		  							"SHOWPAGE=DowngradeConfirm&PLANID=" +targetPlanId + 			//No I18N
		  							"&USERADDONQTY=" + addOnUsrCount + 								//No I18N
		  							"&ROWADDONNAME=" + addOnRowName+								//No I18N
		  							"&MAILSCHEDADDONNAME="+addOnSchMailName+						//No I18N
		  							"&APIUNITSADDONNAME="+addOnAPIUnitsName,						//No I18N
		  						METHOD:"GET",    // No I18N
		                        DOWNGRADEBUTTON:el,
		                        ONSUCCESSFUNC:ZDBPricing.showDowngradeConfirmDlg,
		                        OPSTATUSID:"ZDBMainLoader"});  // No I18N
		  }
		}
		else if(jQuery('#ZDBTotalPrice').text().replace('$', '') == 0 && ZDBPricing.BEG_PRICE == 0)
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.common.pricing.js.cannot_purchase"));
			ZRUserAnalytics.checkAndPushToServer("Zero Dollar Issue", "Payment", "Pricing", true, null, null, null);//NO I18N
			return;
		}
		else
		{
			ZDBPricing.payNUpdatePlan(el);
		}
	};
	
	this.handlePlanChangeResp = function(response,requestOptions)
	{
        var holder = $("ZDBPriceContentHolder");
            holder.innerHTML = response.getOnlyHtml();
            var payButton = $("ZDBPaymentBtn");
            payButton.setAttribute("payallowed","true");
            var plans = new Array(
	            ZDBI18NMap.g("zrpt.common.pricing.js.free"),
	            ZDBI18NMap.g("zrpt.common.pricing.js.basic"),
	            ZDBI18NMap.g("zrpt.common.pricing.js.premium"),
	            ZDBI18NMap.g("zrpt.common.pricing.js.standard"),
	            ZDBI18NMap.g("zrpt.common.pricing.js.enterprise"),  // Need to check
	            ZDBI18NMap.g("zrpt.common.pricing.js.old_basic"),   // Need to check
	            ZDBI18NMap.g("zrpt.common.pricing.js.old_standard"),  // Need to check 
	            ZDBI18NMap.g("zrpt.common.pricing.js.proffessional"),
	            ZDBI18NMap.g("zrpt.common.pricing.js.proffessionalplus"),
	            ZDBI18NMap.g("zrpt.common.pricing.js.old_enterprise")  // Need to check
	         );
            var currentPlanId = requestOptions["CURRENTPLANID"];
            var selectedPlanId = requestOptions["SELECTEDPLANID"];

            var addOnVar = $("AddOn_Temp");

            /*  SETTING User , Row & Sch mail AddOns ALREADY PURCHASED - START */
			addOnUserCombo = $("ZDBAdonUser");
			addOnUserCombo.value = addOnVar.getAttribute("addOnUserCnt");

			$("ZDBAdonRows").value = addOnVar.getAttribute("addOnRowsName") || 0;
			
			$("ZDBAdonSchMail").value = addOnVar.getAttribute("addOnEmlSchdName") || 0;
			
			$("ZDBAdonAPIUnits").value = addOnVar.getAttribute("addOnAPIUnits") || 0;
			
		    /*  SETTING User & Row AddOns ALREADY PURCHASED - END */

            /*  SETTING CONNECTORS ALREADY PURCHASED - START */
            var addOnConnectorValue = addOnVar.getAttribute("addOnCnctrName");
            var selectedCntrsArray = addOnConnectorValue.split(",");
            var contrAddOns = DOMUtils.getChildElsWithAttr($("ZDBConnectorsHolder"), "id", "ZDBAddOnElt"); //No I18N
            
            for(var i =0;i<selectedCntrsArray.length;i++)
            {
                for(var j=0;j<contrAddOns.length;j++)
                {
                    if(selectedCntrsArray[i] ==  contrAddOns[j].value)
                    {
                        contrAddOns[j].checked = true;
                        break;
                    }
                }
            }
            for(var j=0;j<contrAddOns.length;j++)
            {
              if (contrAddOns[j].getAttribute("freeForPaidPlans") == "true")
              {
                if (selectedPlanId != 1)
                {
                    contrAddOns[j].checked = true;
                    contrAddOns[j].disabled = true;
                }
                else if (selectedPlanId == 1 && currentPlanId != 1)
                {
                    contrAddOns[j].checked = false;
                }
              }
              if(contrAddOns[j].getAttribute("freeForProAbove") == "true")
            	{
              	if (selectedPlanId != 1 && selectedPlanId != 3)
                {
                    contrAddOns[j].checked = true;
                    contrAddOns[j].disabled = true;
                }
             }
              	
            }
            /*  SETTING CONNECTORS ALREADY PURCHASED - END*/

            var trialUser = requestOptions["ISTRIALUSER"];
            var cost = requestOptions["COST"];
            var action = (selectedPlanId>currentPlanId)?ZDBI18NMap.g("zrpt.common.pricing.js.upgrade"):
            		(selectedPlanId!=currentPlanId)?  ZDBI18NMap.g("zrpt.common.pricing.js.downgrade"):"";
            var planChangeDesc = "";
            if (trialUser === "true")
            {
	        	  planChangeDesc = ZDBI18NMap.f("zrpt.common.pricing.js.trial_plan",plans[currentPlanId-1]);
            }
            else
            {
	        	  var curPlanCost = requestOptions["CURPLANCOST"];
	        	  if(!curPlanCost){ //curPlanCost is undefined when clicking Manage btn
	        		  curPlanCost = cost || 0;
	        	  }
	        	  var amt = ZDBI18NMap.f("zrpt.common.pricing.upgrade.js.dollar",new Number(curPlanCost).toFixed(2));
	        	  planChangeDesc = plans[currentPlanId-1] + " - " + amt;
              payButton.setAttribute("ISDOWNGRADE", (action === ZDBI18NMap.g("zrpt.common.pricing.js.downgrade"))?"true":"false");
              payButton.setAttribute("STOREPLANID", requestOptions["STOREPLANID"]);
            }
            jQuery("#ZDBPlanChangeDescDiv").html(planChangeDesc);		//No I18N
            var planPriceDisp = $("ZDBPlanPrice");
            planPriceDisp.setAttribute("planPrice",cost);
            ZDBPricing.calculatePricing(false, selectedPlanId);
          	ZDBPricing.updateUserDetails_New();
          	ZDBPricing.BEG_PRICE = jQuery('#ZDBTotalPrice').text().replace('$', ''); // No I18N
	}
	
	this.payNUpdatePlan = function(el)
	{
	    var payAllowed = (el.getAttribute("payallowed")=="true");
	    if(!payAllowed){
	            return;
	    }
	    // el.setAttribute("payallowed","false");
	    var planId = el.getAttribute("planId");
	    var hasProfileId = el.getAttribute("hasProfileId");
	    var isReactiveUser = el.getAttribute("isReactiveUser");
	    var addOnUserCB = $("ZDBAdonUser");
	    var addOnUsrId = addOnUserCB.getAttribute("addOnPlanId");
	    var addOnUsrCount = (addOnUserCB[addOnUserCB.selectedIndex]).value;
	    var addOnRowsCB = $("ZDBAdonRows");
	    var payPeriod = parseInt(ZDBPricing.getRadioSelectedValue($("ZDBSubscriptionForm"),"subscriptionMode"));    //No I18N
	    var addOnRowName = (addOnRowsCB[addOnRowsCB.selectedIndex]).value;
	    var addOnSchMailEl = $("ZDBAdonSchMail");
	    var addOnSchMailName = addOnSchMailEl[addOnSchMailEl.selectedIndex].value;
	    
	    var addOnAPIUnitsEl = $("ZDBAdonAPIUnits");
	    var addOnAPIUnitsName = addOnAPIUnitsEl[addOnAPIUnitsEl.selectedIndex].value;
	    var contrAddOns = DOMUtils.getChildElsWithAttr($("ZDBConnectorsHolder"), "id", "ZDBAddOnElt"); //No I18N
	    var connectorAddOns = "None"; //No I18N
	    for ( var i = 0; i < contrAddOns.length; i++)
	    {
	        if(contrAddOns[i].checked)
	        {
	            if(planId > 1 && contrAddOns[i].getAttribute("freeForPaidPlans") == "true" || (planId > 3 && contrAddOns[i].getAttribute("freeForProAbove") == "true"))
	            {
	              continue;
	            }
	            connectorAddOns = (connectorAddOns=="None")? contrAddOns[i].value : connectorAddOns + ',' + contrAddOns[i].value;
	        }
	    }
	    var addOnVar = $("AddOn_Temp");
	    var addOnEmlCount = $("ZDBAdonSchMail").value;
	    var promoCode = $("promoCode");
	    var promoCodeStr = "";
	    if (promoCode != null)
	    {
	      var promoCodeVal = promoCode.value;
	      if (ZDBPricing.validateCoupon(promoCodeVal, false))
	      {
	        promoCodeStr =  "&PROMOCODE=" + encodeURIComponent(promoCodeVal); //No I18N
	      }
	    }
	
	    var upgradeParams = "&PLANID=" + planId + 										//No I18N
	    					"&ADDONID_USER=" + addOnUsrId + 							//No I18N
	    					"&ADDONQTY_USER=" + addOnUsrCount + 						//No I18N
	    					"&ADDONNAME_ROWS=" + encodeURIComponent(addOnRowName) + 	//No I18N
	    					"&ADDONNAME_SCHMAIL=" + addOnSchMailName + 					//No I18N
	    					"&ADDONNAME_APIUNITS="+addOnAPIUnitsName+					//No I18N
	    					"&ADDON_CONNECTORS=" + encodeURIComponent(connectorAddOns) +//No I18N
	    					"&PAYPERIOD="+ payPeriod + promoCodeStr;					//No I18N
	
	    if (isReactiveUser == "true")
	    {
	        // call Zoho Reports and then zoho stores with out profile id url
	    	AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=REACTIVATEUSER" + upgradeParams, ONSUCCESSFUNC:ZDBPricing.invokeStoresPage, OPSTATUSID:"ZDBMainLoader"});  //No I18N
																																											
	
	    }
	    else if (hasProfileId == "true")
	    {
	    	// call Zoho Reports and then zoho stores with profile id url
	    	AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=CHANGEPLAN" + upgradeParams, ONSUCCESSFUNC:ZDBPricing.handleChangePlan, OPSTATUSID:"ZDBMainLoader"});  //No I18N
																																										
	    }
	    else
	    {
	    	// call Zoho Reports and then zoho stores with out profile id url
	    	AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=NEWPAIDUSER" + upgradeParams, ONSUCCESSFUNC:ZDBPricing.invokeStoresPage, OPSTATUSID:"ZDBMainLoader"});  //No I18N
																																										
	    }
	};

	this.changeCardDetails = function()
	{
		AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=CHANGEPAYMENTDETAILS",   //No I18N
                                           ONSUCCESSFUNC:ZDBPricing.invokeStoresPage,
                                           OPSTATUSID:"ZDBMainLoader"});    //No I18N
	}
	
	this.handleTabResp = function(response,requestOptions)
	{
		var holder = $("ZDBPriceContentHolder");
		holder.innerHTML = response.getOnlyHtml();
		ZDBPricing.setPageHeight();
		if(requestOptions["SHOWSTATUSMSG"])
		{
		  var respArray = requestOptions["RESPARRAY"];
		  ZDBPricing.showPurchaseStatusMsg(respArray);
		}
		if(requestOptions["SHOWPAGE"]=="ManageQueryTable"){ZDBPricing.getSelectedQueryTables();}
		if(requestOptions["SHOWPAGE"]=="ManageUsers")
		{
		   ZDBPricing.changeInviteCont();
		}
		if(requestOptions["SHOWPAGE"]=="WhiteLabelRebranding")
		{
			var height = jQuery("#ZDBPriceContentHolder").css("min-height").replace(/[^-\d\.]/g, '');//No I18N
			if(height == 0)
			{
				jQuery("#ZDBPriceContentHolder").css("min-height", jQuery("#ZDBPriceContentHolder").height());		//No I18N
			}
			RebrandAdminDialog.attachEventListener();
			RebrandAdminDialog.hmPageContentLoad = null;
			DMMultiUserSignUp.signUpContentLoaded = false; 
		}
		if($("searchUserFld") && requestOptions["ZDBACTION"] == "SEARCHUSER")
		{
			$("searchUserFld").value = jQuery("#searchUserFld").attr("tipValue");
		}
		
		if(jQuery("#ZDBDialogHiddenDiv").children("#ZDBAddUserDlg")[0]){
			jQuery("#ZDBPriceContentHolder").children("#ZDBAddUserDlg").remove();	//No I18N
		}
	};

	
	this.setPageHeight = function()
	{
		var mainDiv = $("ZDBPMainDiv");
		var contentHolder = $("ZDBPriceContentHolder");
		contentHolder.style.height = "";
		var footer = $("ZDBPFooter");
		var contentHolderTop = ZDBUtil.getObjTop(contentHolder);
		var documentHeight = jQuery(window).height();
		var setPageHeightRequired = (((mainDiv.offsetHeight) + ($("ZDBHEADER").offsetHeight)) < documentHeight);
		if(setPageHeightRequired)
		{
			var h = ((jQuery(window).height() - contentHolderTop) - footer.offsetHeight - 56) + "px";//margin top = 50 + 6 border	//No I18N
			jQuery(contentHolder).css("min-height", h);		//No I18N
		}
	}

  this.handleChangePlan = function(resp,reqOpts)
  {
		  var respArray = resp.responseText.split(",");
    	var isCancelPlan = respArray[2]=="CANCEL";
      var planChangeSt = respArray[3];
      if(isCancelPlan && planChangeSt)
      {//Showing downgrade feedback form
        ZDBPricing.changePlanReqNResp = [resp,reqOpts];
        AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION=DOWNGRADEFEEDBACKFORM&SHOWPAGE=DowngradeFeedbackForm&STRUCT=false",
                              METHOD:"GET",    //No I18N
                              ONSUCCESSFUNC:ZDBPricing.handleDowngradeFeedbackForm,
                              OPSTATUSID:"ZDBMainLoader"});  //No I18N
      }
      else
      {
        ZDBPricing.handleRespNSelectTab(resp,reqOpts);
      }
  }

  this.handleDowngradeFeedbackForm = function(resp,reqOpts)
  {
    var container = document.createElement("DIV");
    container.style.display = "none";
    document.body.appendChild(container);

    container.innerHTML = resp.responseText;
    var confirmDlg = $("ZRFeedbackFormDlg");
    jQuery("#ZRFeedbackFormDlg .zdbpsuccessmsg.zrdownsuccessmsg")     //No I18N
      .html(ZDBI18NMap.f("zrpt.common.pricing.js.success_downgrade","Free")); //No I18N

    confirmDlg.style.display = "";
    ZDBDialogUtil.showDialog(confirmDlg, {
          ADDFRAME:true,
          FRAMETYPE:'ZRDowngradeFeedbackForm',    //No I18N
          MODAL:false, 
          FREEZEBGCLASSNAME:'blackFreezeLayer',    //No I18N
          NOESC:true,
          ONESC: ZDBPricing.closeFeedbackForm
        });   //No I18N
    jQuery(".zrSkipDlg").click(function(ev){      //No I18N
      ZDBPricing.closeFeedbackForm(this,ev);
    });
  }
		
	this.handleRespNSelectTab = function(response,requestOptions)	
	{
		var respArray = response.responseText.split(",");
    	var targetTab = respArray[0];
		var tabMainDiv = $("TabMainDiv");
		ZDBUtil.setNamedChildEls(tabMainDiv,tabMainDiv,"showpage"); //No I18N
		var display = (targetTab=="ManageQueryTable")?"":"none";    //No I18N
		tabMainDiv.ManageQueryTable.style.display =display; 
		var targetTab = (targetTab=="ManageQueryTable")?"CurrentPlanDetails":targetTab; //No I18N
		var showStatusMsg = (respArray[3] != null);
		ZDBPricing.selectTab(tabMainDiv[targetTab],showStatusMsg,respArray);
	}
  
  this.showPurchaseStatusMsg = function(respArray)
  {
    var planName = respArray[1];
    var action = respArray[2];
    var status = respArray[3];
    ZDBPricing.initStatusMsgs(planName);
    if (status.trim() == "success")
    { 
				
      if (action.trim() == "UPGRADE" || action.trim() == "MODIFY")
      {
        if (planName.trim() == "addOn")
        {
          ZDBPricing.showStatusMsg(ZDBPricing.successMsg["ADDONSCHANGESUCCESS"],"zdbpsuccessmsg");  //No I18N
        }
        else if (planName.trim() == "Payperiod")
        {
          ZDBPricing.showStatusMsg(ZDBPricing.successMsg["PAYPERIODCGESUCCESS"],"zdbpsuccessmsg");  //No I18N
        }
        else
        {
          ZDBPricing.showStatusMsg(ZDBI18NMap.f("zrpt.common.pricing.js.success_upgrade",planName),"zdbpsuccessmsg"); //No I18N
        }
      }
      else if (action.trim() == "trial")
      {
        ZDBPricing.showStatusMsg(ZDBI18NMap.f("zrpt.common.pricing.js.upgrade_trial",planName),"zdbpsuccessmsg");  //No I18N
      }
      else
      {
        ZDBPricing.showStatusMsg(ZDBI18NMap.f("zrpt.common.pricing.js.success_downgrade",planName),"zdbpsuccessmsg");//No I18N
				if(planName=="Basic Old" || planName=="Free")
				{
					ZDBPricing.setZDBLogo();
				}
      }
    }
  }
  
	this.invokeStoresPage = function(response,requestOptions)	
	{
		var plansHolder = $("PlanHolder");
		plansHolder.style.display = "none";
		var targetUrl = response.responseText;
		var cardDetailsPage = $("cardDetails");
		cardDetailsPage.style.display = "";
		cardDetailsPage.src = targetUrl;
	}

  this.showDowngradeSummary = function()
  {
		var summaryDlg = $("ZBBPlanLimitAlertDlg");
		summaryDlg.style.display = "";
		ZDBDialogUtil.showDialog(summaryDlg,{TITLE:ZDBI18NMap.g("zrpt.common.pricing.js.plan_changed"),ADDFRAME:true,FRAMETYPE:'ZDBInfoDlg',MODAL:true,  FREEZEBGCLASSNAME:'blackFreezeLayer'});    //No I18N
  }
	
	this.handleContResp = function(response,requestOptions)
	{
		var holder = $("ZDBPriceContentHolder");
		holder.innerHTML = response.getOnlyHtml();
	}
		
	this.upgrade = function(plan)
	{
		if(plan==null){return;}
		AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?STRUCT=false"+"&SHOWPAGE=ChangePlan"+"&plan="+plan, METHOD: "GET",    //No I18N
														ONFAILUREFUNC:ZDBPricing.handleContFailure,
															ONSUCCESSFUNC:ZDBPricing.handleContResp,
																	OPSTATUSID:"ZDBMainLoader"});   //No I18N
	}
	
	this.selectAllUsers = function(selectAllCheckbox)
	{
		var selectAllStatus = selectAllCheckbox.checked;
		var userActivationTable = $("ZDBListingTable");
		var selectedUsers = ZDBUtil.getElsWithTagNAttrWithVal(userActivationTable, "type", "checkbox", "input");  //No I18N
		var usersLength = selectedUsers.length;
		var emailids = "";
		var zuids = "";
		
		for(var i=0; i<usersLength; i++)
		{
			var selUser = selectedUsers[i];
			
			if(!jQuery(selUser).parents("tr").attr("currentrow")){	//Skip header el
				continue;
			}
			
			if(selectAllStatus==true)
	        {
	          var zuid = selUser.getAttribute("zuid");
	          var actualzuidArr = zuid.split("###");
                  var actualzuid = actualzuidArr[0];
                  if(actualzuid==null || actualzuid < 0)
	          {
	            if(emailids != "")
	            {
	              emailids += ",";
	            }
	            emailids += selUser.value;
	          }
	          else
	          {
                    if(zuids != "")
                    {
                      zuids += ",";
                    }
	            zuids += zuid;
	          }
	        }
			selUser.checked = selectAllStatus;
		}
		
		
		
		ZDBPricing.selectedEmailIds = emailids;
		ZDBPricing.selectedZUIDs = zuids;
	}
	
	this.selectObj = function(checkbox,selectAllCheck)
	{
		var objValue = checkbox.value;

		if(checkbox.checked == false)
		{
			var idx = ZDBPricing.selectedObjects.indexOf(","+objValue);
			if(idx > -1){
			ZDBPricing.selectedObjects = ZDBUtil.replaceStr(ZDBPricing.selectedObjects,','+objValue,'');
			}
		}
		else
		{
		ZDBPricing.selectedObjects = ZDBPricing.selectedObjects+","+objValue;
		
		}
		if(selectAllCheck==true){
		ZDBPricing.checkSelectAllCheckbox();
		}
	}
	
	this.selectUsr = function(checkbox,selectAllCheck)
	{
    var zuid = checkbox.getAttribute("zuid");
    var checkBoxStatus=checkbox.checked;

    var actualzuidArr = zuid.split("###");
    var actualzuid = actualzuidArr[0];
    if(actualzuid==null || actualzuid < 0)
    {
      var objValue = checkbox.value;
      ZDBPricing.addEmailIdToSelObjs(objValue,checkBoxStatus);
    }
    else
    {
      ZDBPricing.addZUIDtoSelObjs(zuid,checkBoxStatus);
    }

		if(selectAllCheck==true)
    {
      ZDBPricing.checkSelectAllCheckbox();
    }
  }
 
  this.addEmailIdToSelObjs = function(objValue, checkBoxStatus)
  {
    if(checkBoxStatus==false)
    {
			var idx = ZDBPricing.selectedEmailIds.indexOf(","+objValue);
      if(idx > -1)
      {
        ZDBPricing.selectedEmailIds = ZDBUtil.replaceStr(ZDBPricing.selectedEmailIds,','+objValue,'');
      }
    }
    else
    {
      if(ZDBPricing.selectedEmailIds != "")
      {
        ZDBPricing.selectedEmailIds += ",";
      }
      ZDBPricing.selectedEmailIds += objValue;
    }
	}
	
  this.addZUIDtoSelObjs = function(zuid,checkBoxStatus)
  {
    if(checkBoxStatus==false)
    {
			var idx = ZDBPricing.selectedZUIDs.indexOf(","+zuid);
      if(idx > -1)
      {
        ZDBPricing.selectedZUIDs = ZDBUtil.replaceStr(ZDBPricing.selectedZUIDs,','+zuid,'');
      }
    }
    else
    {
      ZDBPricing.selectedZUIDs = ZDBPricing.selectedZUIDs+","+zuid;
    }
	}
	
	this.checkSelectAllCheckbox = function()
	{
		var userActivationTable = $("ZDBListingTable");
		var selectedUsers = userActivationTable.getElementsByTagName("input");
		var usersLength = selectedUsers.length;
		var selection = true;
		for(i=0; i<usersLength; i++)
			{
				if(selectedUsers[i].checked == false){selection = false;}
			}
			$("selectAllUsersCheckbox").checked = selection;
	}
	
	this.manageUsers = function(el,operation)
	{
		 if(ZDBPricing.selectedEmailIds=="" && ZDBPricing.selectedZUIDs=="")
		 {
			 var displayAction = el.getAttribute("displayAction");
			 ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.pricing.manageusr.js.slt_one_usr",displayAction)); 
			 return;
		 }
	     var emailIdStr = "";
	     var zuIdStr = "";
	     var nDiv = $("navigatorDiv");
	     var pattern = nDiv.getAttribute("pattern");
	     var nextSet = nDiv.getAttribute("nextset");
	     var mode = nDiv.getAttribute("mode");
	     if (ZDBPricing.selectedEmailIds != "" && ZDBPricing.selectedEmailIds != null)
	     {
	    	 emailIdStr = "&EMAILIDS="+ encodeURIComponent(ZDBPricing.selectedEmailIds); //No I18N
	     }
	     if (ZDBPricing.selectedZUIDs != "" && ZDBPricing.selectedZUIDs != null)
	     {
	    	 zuIdStr = "&ZUIDS=" + encodeURIComponent(ZDBPricing.selectedZUIDs); //No I18N
	     }
		 AjaxAPI.sendRequest({URL:"/ZDBPricingAction.ma?ZDBACTION=" + operation + "&USERLISTONLY=true" +		//No I18N
			 						emailIdStr + zuIdStr + "&PATTERN=" + encodeURIComponent(pattern) + "&NEXTSET=" + nextSet + "&MODE=" + mode, //No I18N
			 					 OPERATION:operation,
			 					 ONSUCCESSFUNC:ZDBPricing.handleUserStatus,
                                 OPSTATUSID:"ZDBMainLoader"			//No I18N
                             });
	};

  this.showDBWiseUsers = function(elem)
  {
     var nextSet = elem.getAttribute("nextset");
     var action = elem.getAttribute("action");
     var pattern = elem.getAttribute("pattern");
     if (action == "SEARCHDB")
     {
       var searchEle = $("searchUserFld");
       var pattern = searchEle.value;
       if(pattern==''){pattern="__list__all__";}
     }     
     var urlString = "&PATTERN=" + encodeURIComponent(pattern) + "&NEXTSET=" + nextSet + "&MGUSRACTION=" + action; //No I18N
	 AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION=MANAGEDBUSERS&STRUCT=false&SHOWPAGE=ManageUsers"+urlString, METHOD:"GET",//No I18N
                 ONSUCCESSFUNC:ZDBPricing.handleTabResp,
                 OPSTATUSID:"ZDBMainLoader"});  //No I18N
  }
  
  this.switchDBAndUserList = function(el){
	  var selEl = jQuery(el);
	  var forId = selEl.find(":selected").attr("for");		//No I18N
	  
	  if("dblistopt" == forId){
		  var forEl = jQuery("#"+forId+" a");		//No I18N
		  this.showDBWiseUsers(forEl[0]);
	  }
	  else if("uslistopt" == forId){
		  this.getUserPattern("__list__all__");	//No I18N
	  }
  };

  this.exportUserList = function()
  {
    var paramMap = new Object();
    var exportList = $("exportUserListDiv");
    paramMap["PATTERN"] = exportList.getAttribute("pattern"); //No I18N
    paramMap["VIEWOPTION"] = exportList.getAttribute("view"); //No I18N
    paramMap["MODE"] = exportList.getAttribute("mode"); //No I18N

    var url = ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBPricing.ve?ZDBACTION=EXPORTUSERLIST"; //No I18N
    var frm = $("ZDBUserListExportForm");
    ZDBUtil.removeAllChildren(frm);

    for(var i in paramMap)
    {
      var vals = paramMap[i];
      if (vals.length > 0)
      {
        var el = document.createElement("input");
        el.setAttribute("type","hidden");
        el.setAttribute("name", i);
        if (i == "PATTERN")
        {el.setAttribute("value",vals);}
        else {el.setAttribute("value",encodeURIComponent(vals));}
        frm.appendChild(el);
      }
    }

    var qa;
    try
    {
       qa = $("ZDBExpUsrDBListQa").getAttribute("qa");
    }
    catch(e){}
    if(qa != null && qa != undefined && qa != "false")
    {
       var expBtn = $("exportUserListDiv");
       var els = expBtn.getElementsByTagName("a");
       var expFile = els[0].getAttribute("EXPFILENAME");
       var expDir = els[0].getAttribute("ZDBQAREFSUBDIR");
       var onsuccessfunc = els[0].getAttribute("onsuccessfunc");
       var onfailurefunc = els[0].getAttribute("onfailurefunc");
       url += "&EXPFILENAME="+expFile+"&ZDBQAREFSUBDIR="+expDir; //No I18N
       frm.setAttribute("onsuccessfunc",onsuccessfunc);
       frm.setAttribute("onfailurefunc",onfailurefunc);
    }

    frm.action=url;
    AjaxAPI.submit(frm);
  }

  this.getUserPattern = function(pattern)
  {
    AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION=GETINDEXEDUSERS&STRUCT=false&SHOWPAGE=ManageUsers&PATTERN="+encodeURIComponent(pattern), METHOD:"GET",//No I18N
                 ONSUCCESSFUNC:ZDBPricing.handleTabResp,
                 SHOWPAGE:"ManageUsers", OPSTATUSID:"ZDBMainLoader"});  //No I18N
  }
	
  this.clearSearchField = function(el)
  {
    var val = el.value;
    if(val == ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.searchuseremail") || val == "Search Databases" ){el.value = "";}
  }

  this.checkKeyAndSearch = function(el,ev)
  {
    if(!ev){ev = window.event};
    if(ev.keyCode == 13)
    {
      var action = el.getAttribute("action");
      if (action != null && action == "SEARCHDB")
      {ZDBPricing.showDBWiseUsers(el);}
      else
      {ZDBPricing.searchUserPattern();}
      return false;
    }
    return true;
  }

  this.searchUserPattern = function()
  {
    var searchEle = $("searchUserFld");
    var pattern = searchEle.value.trim();
    if(pattern==''){pattern="__list__all__";}
    AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION=SEARCHUSER&STRUCT=false&SHOWPAGE=ManageUsers&PATTERN="+encodeURIComponent(pattern), METHOD:"GET",//No I18N
                 ONSUCCESSFUNC:ZDBPricing.handleTabResp,
                 SHOWPAGE:"ManageUsers", OPSTATUSID:"ZDBMainLoader",ZDBACTION:"SEARCHUSER"});  //No I18N
  }
	
  this.getNextUserSet = function()
  {
    var nDiv = $("navigatorDiv");
    var pattern = nDiv.getAttribute("pattern");
    var nextSet = nDiv.getAttribute("nextset");
    var mode = nDiv.getAttribute("mode");
    AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION=GETNEXTUSERSSET&LOCALSTORE=false&STRUCT=false&SHOWPAGE=ManageUsers&PATTERN="+encodeURIComponent(pattern)+"&NEXTSET="+nextSet+"&MODE="+mode, METHOD:"GET",//No I18N
                 ONSUCCESSFUNC:ZDBPricing.handleTabResp,
                  SHOWPAGE:"ManageUsers", OPSTATUSID:"ZDBMainLoader"});  //No I18N
  }
	
  this.getPrevUserSet = function()
  {
    var nDiv = $("navigatorDiv");
    var pattern = nDiv.getAttribute("pattern");
    var nextSet = nDiv.getAttribute("nextset");
    var mode = nDiv.getAttribute("mode");
    AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION=GETPREVUSERSSET&LOCALSTORE=true&STRUCT=false&SHOWPAGE=ManageUsers&PATTERN="+encodeURIComponent(pattern)+"&NEXTSET="+nextSet+"&MODE="+mode, METHOD:"GET",//No I18N
                 ONSUCCESSFUNC:ZDBPricing.handleTabResp,
                 SHOWPAGE:"ManageUsers", OPSTATUSID:"ZDBMainLoader"});  //No I18N
  }

  this.initStatusMsgs = function(plan)
  {
    if(ZDBPricing.statusMsgsInitialized!=true)
    {
      ZDBPricing.successMsg = new Object;
      ZDBPricing.successMsg["DELETEUSER"] = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.slt_usr_del"); //No I18N
      ZDBPricing.successMsg["ACTIVATEUSER"] = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.users_activate"); //No I18N
      ZDBPricing.successMsg["DEACTIVATEUSER"] = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.users_deactivate"); //No I18N
      ZDBPricing.successMsg["ADDNEWUSER"] =  ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.new_usr_add"); //No I18N
      ZDBPricing.successMsg["PLANCHANGESUCCESS"] =  ZDBI18NMap.f("zrpt.common.pricing.manageusr.js.plan_changed",plan); //No I18N
      ZDBPricing.successMsg["TRIALPLANCHANGESUCCESS"] =  ZDBI18NMap.f("zrpt.common.pricing.manageusr.js.plan_changed_trial",plan); //No I18N
      ZDBPricing.successMsg["ADDONSCHANGESUCCESS"] =  ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.addon_modified"); //No I18N
      ZDBPricing.successMsg["PAYPERIODCGESUCCESS"] =  ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.payterm_modified"); //No I18N
      ZDBPricing.successMsg["TIMEOUTTRYAGAIN"] = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.conn_timeout");  //No I18N
      ZDBPricing.successMsg["ADDONCHANGEFAILURE"] = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.addon_change_fail"); //No I18N
      ZDBPricing.successMsg["TRIALPLANCHANGEFAILURE"] = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.trial_req_fail"); //No I18N
      ZDBPricing.successMsg["PLANCHANGEFAILURE"] = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.plan_change_req"); //No I18N
      ZDBPricing.successMsg["PAYPERIODCGEFAILURE"] =  ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.payterm_cge_fail"); //No I18N
      ZDBPricing.successMsg["SENDINVITEMAILREQ"] =  ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.invitemailsent"); //No I18N
      ZDBPricing.statusMsgsInitialized = true;
    }
  }
	
this.openAddUserDlg = function()
{
	if(!ZDBClientUI.showZContacts && !ZDBClientUI.showGoogleContacts)
	{
		$("ZDBAddUsersFromMenu").style.display="none";
	}
        if(!ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare","APPENDTODOC",ZDBPricing.openAddUserDlg))
        {
          return;
        }

        var addUserDlg = $("ZDBAddUserDlg");
        if($("zdbcontactsholder"))
        {
          $("zdbcontactsholder").value="";
        }
        else
        {
          $("domainUsersHolder").innerHTML = "";
          ZDBSecuritySettings.addUserElForDomainUsers();
        }
        addUserDlg.style.display = "";		
        ZDBPricing.getMyContactsFromIAM();
        ZDBUtil.setIfGAppsUser();
        ZDBDialogUtil.showDialog(addUserDlg, {ADDFRAME:true, MODAL:true, TITLE:ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.add_new_usr"), DONTREMOVE:true, ONCLOSE:ZDBPricing.closeContactsDialogDiv} );
}

  this.closeContactsDialogDiv = function()
  {
    var el = ZDBDialogUtil.focusDialog;
    if(el!=null)
    {
      ZDBPricing.clearAllBeforeCloseDiv(el);
      el.style.display = "none";
    }
    return true;
  }

	this.clearAllBeforeCloseDiv = function(el)
	{
		if(el.id == "contacts")
		{
			$("searchContactStr").setAttribute("tipShown","true");
			$("searchContactStr").value = ZDBI18NMap.g("zrpt.common.toolbar.share.zdbalertmsg.js.searchcontacts");
			$("searchContactStr").blur();
		}
		else if(el.id == "existingsharedcontacts")
		{
			// Nothing
		}
		else if(el.id == "GoogleContacts")
		{
			$("searchGContactStr").value = ZDBI18NMap.g("zrpt.common.toolbar.share.zdbalertmsg.js.searchcontacts");;
			$("searchGContactStr").setAttribute("tipShown","true");
		}
	    else if(el.id == "GoogleAppUsers")
	    {
	      $("searchGAppUserStr").value = ZDBI18NMap.g("zrpt.common.toolbar.share.zdbalertmsg.js.searchusers");
	      $("searchGAppUserStr").setAttribute("tipShown","true");
	    }
	    else if(el.id == "ZDBAddUserDlg"){
	    	var str = ZDBI18NMap.g("zrpt.explorer.share.shareview.js.enteremailadd");
	    	jQuery("#zdbcontactsholder").html(str).val(str);	//No I18N
	    	jQuery("#ZDBInvUsersProcess").className = "mcLoaded";
	    }
	    else if(el.id == "CRMPlusUsers")
	    {
	    	$("searchCRMPlusContactStr").setAttribute("tipShown","true");
			$("searchCRMPlusContactStr").value = ZDBI18NMap.g("zrpt.common.toolbar.share.zdbalertmsg.js.searchcontacts");
			$("searchCRMPlusContactStr").blur();
	    }
	};
	
	this.getMyContactsFromIAM = function()
  {
    var autoFillParams = "&ZDBACTION=GETMYCONTACTS";    //No I18N
    AjaxAPI.sendRequest({URL:"/ZDBSecurityAction.ma",PARAMETERS:autoFillParams, //No I18N
                               ONSUCCESSFUNC:ZDBAutoFillContacts.fillMyUsers,
                               METHOD: 'GET', OPSTATUSID:"ZDBInvUsersProcess"});   //No I18N
  }

  this.addUser = function()
  {
    
    var emailIds = "";
    var emailIdsInputBox = $("zdbcontactsholder");
    if(emailIdsInputBox)
    {
      emailIds = ZDBSecuritySettings.getUsersFromUserDlg();
      try
      {
         emailIds = ZDBUtil.getValidatedEmailsAsCommaSeparated(emailIds);
      }
      catch(e)
      {
          ZDBAlertAPI.showMsg(e.message);
          return;
      }
    }
    else
    {
      emailIds = ZDBSecuritySettings.getUsersFromDomainUsersDlg();
    }
    if(emailIds == "")
    {
          ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.invalid_email_ids"));
          return;
    }
    ZDBPricing.sendMails = ZDBPricing.sendMails.concat(emailIds.split(","));
    var nDiv = $("navigatorDiv");
    var pattern = nDiv.getAttribute("pattern");
    var nextSet = nDiv.getAttribute("nextset");
    var mode = nDiv.getAttribute("mode");
    var params = "&USERLISTONLY=true&EMAILIDS=" + encodeURIComponent(emailIds) + "&PATTERN=" + encodeURIComponent(pattern) + "&NEXTSET=" + nextSet + "&MODE=" + mode; //No I18N
    AjaxAPI.sendRequest({URL:"/ZDBPricingAction.ma?ZDBACTION=ADDNEWUSER",    //No I18N
      PARAMETERS:params,
      OPERATION:"ADDNEWUSER",    //No I18N
      ONSUCCESSFUNC:ZDBPricing.handleUserStatus,
      OPSTATUSID:"ZDBMainLoader"});  //No I18N
    if(emailIdsInputBox)
    {
      emailIdsInputBox.value = "";
    }
    else
    {
      $("domainUsersHolder").innerHTML = "";
      ZDBSecuritySettings.addUserElForDomainUsers();
    }
    ZDBDialogUtil.closeDialog();
  }

  this.handleUserStatus = function(response,requestOptions)
  {
    var operation = requestOptions["OPERATION"];
    var params = response.getResponseParams();
    var modUsrCount = params["NEWUSERS"];
    if (modUsrCount === "0")
    {
      var action =  "";
      if (operation == "DEACTIVATEUSER")
      {
        action = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.deactivated");
      }
      else if (operation == "ACTIVATEUSER")
      {
        action = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.activated");
      }
      else if (operation == "ADDNEWUSER")
      {
        action = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.added");
      }
      ZDBPricing.showStatusMsg(ZDBI18NMap.f("zrpt.common.pricing.manageusr.js.usr_already_exist",action), "zdbpsuccessmsg"); //No I18N
    }
    else
    {
      ZDBPricing.initStatusMsgs();
      ZDBPricing.selectedObjects = "";
      ZDBPricing.selectedEmailIds = "";
      ZDBPricing.selectedZUIDs = "";
      var userListContainer = $("ZDBUserListContainer");
      userListContainer.innerHTML = response.getOnlyHtml();
      ZDBPricing.showStatusMsg(ZDBPricing.successMsg[operation],"zdbpsuccessmsg");
    }
    ZDBPricing.changeInviteCont();
    ZDBPricing.handleSearchComp();
	ZDBPricing.setPageHeight();
  }
  
  this.handleSearchComp = function()
  {
	 var navigEl = jQuery("#navigatorDiv");	//No I18N
	 var searchStr = navigEl.attr("pattern");	//No I18N
	 var mode = navigEl.attr("mode");			//No I18N
	 if(mode == "user_index" || searchStr=="" || searchStr == "__list__all__")
	 {
		 return;
	 }
	 jQuery("#searchUserFld").attr("value",searchStr);	//No I18N
  }

	this.showStatusMsg = function(msg,className)
	{
		var statusMsgBar = $("ZDBPStatusMsgBar");
		statusMsgBar.innerHTML = msg;
		statusMsgBar.className = className;
		statusMsgBar.style.display = "";
		ZDBPricing.waitNHide(className,90);
	}
	
	this.waitNHide = function(className,startingAlphaPercentage)
	{
		var statusMsgBar = $("ZDBPStatusMsgBar");
		setTimeout(function(){ZDBPricing.dimNHideStatusMsg(statusMsgBar,className,startingAlphaPercentage)},10000);
	}
	
	this.dimNHideStatusMsg = function(statusMsgBar,className,alphaPercentage)
	{
		statusMsgBar.className = className + " dim"+alphaPercentage;
		alphaPercentage = alphaPercentage-10;
		if(alphaPercentage>0){
			setTimeout(function(){ZDBPricing.dimNHideStatusMsg(statusMsgBar,className,alphaPercentage)},50);
		}
		else{
			statusMsgBar.style.display = "none";
		}
	}
	
	this.changeUserStatus = function(el,status)	
	{
		var emailId = el.getAttribute("emailid");
		var zuid= el.getAttribute("zuid");
        var actualzuidArr = zuid.split("###");
        var actualzuid = actualzuidArr[0];
        if(actualzuid==null || actualzuid < 0)
        {
            ZDBPricing.selectedEmailIds=emailId;
        }
        else
        {
            ZDBPricing.selectedZUIDs=zuid;
        }
		var operation = (status=="Active")?"DEACTIVATEUSER":"ACTIVATEUSER"; //No I18N
		ZDBPricing.manageUsers(el, operation);
	}
	
	this.showOrHideDetails = function(el)
	{
		var expanded = el.getAttribute("expanded");
		var rows = ZDBUtil.getElsWithAttrName($("ZDBListingTable"),"row");  //No I18N
		var currRow = DOMUtils.getParentWithAttr(el,"currentRow");  //No I18N
		rows[currRow.rowIndex].style.display = (expanded=="true")?"none":"";
		currRow.className = (expanded=="true")?"":"expandUserRoles";
		el.setAttribute("expanded",(expanded=="true")?"false":"true");
	}

	this.getSelectedQueryTables = function()
	{
		var activationTable = $("ZDBListingTable");
		var checkboxes = activationTable.getElementsByTagName("input");
		for(i=0; i<checkboxes.length; i++)
		{
			if(checkboxes[i].checked==true){
				ZDBPricing.selectedObjects = ZDBPricing.selectedObjects +","+checkboxes[i].value;
			}
		}
	}
	
	this.toggleRebrandSettings = function(el)
	{
		var settingsHidden = el.getAttribute("settingshidden");
		el.className = (settingsHidden=="true")?"contractOptions":"expandOptions";
		el.setAttribute("settingshidden",(settingsHidden=="true")?"false":"true");
		$("ZDBRSettingsDiv").style.display = (settingsHidden=="true")?"":"none";    //No I18N
	}
		
	this.saveRebrandSettings = function()
	{
		var logoUrl = jQuery("#ZDBLogoUrl").val();		//No I18N
		
		var pwdByOptEl = jQuery(".pwdByOpt input[type=radio]").filter(function(a,b){ if(b.checked){ return b;}})[0];
		var params = "&POWEREDBYOPTION="+pwdByOptEl.value+"&LOGOURL="+logoUrl;			//No I18N
		AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=UPDATEREBRANDSETTINGS",PARAMETERS: params, 
			ONSUCCESSFUNC:"ZDBPricing.successRebrandingSetting",OPSTATUSID:"ZDBMainLoader"});   //No I18N
	}
	
	this.successRebrandingSetting = function(resp, reqOpt)	{
		var respObj = JSON.parse(resp.responseText);
		jQuery("#ZDBLogo").attr("tip", respObj.LOGOURL).attr("redirecturl",respObj.LOGOURL);	//No I18N
		ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrpt.common.pricing.rebranding.js.setting_saved"),"zdbpsuccessmsg"); //No I18N
	};
	
	this.showPreview = function(response,requestOptions)
	{
		var responseArray = response.responseText.split(",");
		var bannerLogo = $("ZDBLogo");
		var imgSrc = responseArray[0].trim();
		var redirectURL = responseArray[1].trim();
		if(imgSrc != "NO_IMAGE")
		{
			var logoPreview = $("ZDBRebrandingPreview");
			$("LogoPreviewHolder").className = "";
			$("RemoveLink").style.display = "";
			$("NotUploadedTxt").style.display = "none";
			logoPreview.src = imgSrc;
			bannerLogo.src = imgSrc;
		}
		if(redirectURL){
			jQuery(bannerLogo).attr("redirectURL",redirectURL).attr("tip",redirectURL);	//No I18N
		}
		ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrpt.common.pricing.rebranding.js.setting_saved"),"zdbpsuccessmsg"); //No I18N
	};
	
	this.validateLogo = function(fileName)
	{
		var pat = new RegExp("\\.(png|gif|bmp|jpg|jpeg|png)$","i");
		if(fileName === "" || pat.test(fileName))
		{
			// can submit the form without specifying the rebrand URL
			return true;
		}
		return false;
	};

	this.removeRebrandLogo = function()
	{
		AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=REMOVEREBRANDLOGO",ONSUCCESSFUNC:ZDBPricing.handleRemoveRebrandLogoResp,OPSTATUSID:"ZDBMainLoader"});   //No I18N
	};
	
	this.handleRemoveRebrandLogoResp = function(response,requestOptions)
  {
		
		var logoPreview = $("ZDBRebrandingPreview");
		logoPreview.src = logoPreview.getAttribute("noImageUrl");
		//$("LogoPreviewHolder").className = "noimage";
		$("RemoveLink").style.display = "none";
		$("NotUploadedTxt").style.display = "";
		$("uploadFile").value = "";
		$("PWDBYOPTION_NONE").checked = true;
		ZDBPricing.setZDBLogo(true);
		ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrpt.common.pricing.rebranding.js.logoremoved"),"zdbpsuccessmsg");	//No I18N
  }
	
	this.setZDBLogo = function(fromRemoveLogo)
	{
		var bannerLogo = $("ZDBLogo");
		var serviceUrl = bannerLogo.getAttribute("serviceUrl");
		bannerLogo.src = bannerLogo.getAttribute("serviceLogo");
		bannerLogo.setAttribute("redirectURL",serviceUrl);
		bannerLogo.setAttribute("title",serviceUrl);
		if(fromRemoveLogo){
		$("ZDBLogoUrl").value = serviceUrl;
		}
	}
	
	this.showTooltip = function(el,tooltipId)
	{
		var elParent = el.parentNode;
		var left = ZDBUtil.getObjLeft(elParent)+elParent.offsetWidth;
		var top = ZDBUtil.getObjTop(el);
		var tooltipDiv = $(tooltipId);
		tooltipDiv.style.position = "absolute";
		tooltipDiv.style.top = top+"px";
		tooltipDiv.style.left = left+"px";
		this.tooltipDiv = tooltipDiv;
		//tooltipDiv.innerHTML = "Tooltip comes here...";
		document.body.appendChild(tooltipDiv);
		tooltipDiv.style.display = "";
	}
	
	this.hideTooltip = function(tooltipId)
	{
		var tooltipDiv = jQuery("div[id='"+tooltipId+"']").filter(":visible");	//No I18N
		tooltipDiv.css("display", "none");	//No I18N
	};
	
	this.toggleConnectorDetailSlider = function()
	{
              jQuery("#PricingPlanTable").find("[conctrDetail='true']").toggle(100);  //No I18N
              var conctrTreeNode = $("conctrTree");
              var state = conctrTreeNode.getAttribute("state");
              state = state * -1;
              conctrTreeNode.setAttribute("state", state);
              var collapser = (state > 0)?"+":"-";
              conctrTreeNode.innerHTML = collapser;
	}
	
	this.slideContent = function(el,contentId)
	{
		var elParent = el.parentNode;
		var left = ZDBUtil.getObjLeft(elParent);
		var top = ZDBUtil.getObjTop(elParent)+elParent.offsetHeight;
		var contentDiv = $(contentId);
		var contentDivHolder = contentDiv.parentNode;
		document.body.appendChild(contentDivHolder);
		contentDivHolder.style.visibility = "hidden";
		contentDiv.style.visibility = "hidden";
		contentDivHolder.style.display = "";
		var offsetHeight = contentDiv.offsetHeight;
		var contentDivTop = -(offsetHeight);
		contentDiv.style.top = contentDivTop+"px";
		contentDivHolder.style.height = offsetHeight;
		contentDivHolder.style.position = "absolute";
		contentDivHolder.style.top = top+"px"
		contentDivHolder.style.left = left+"px";
		contentDiv.style.left = "0px";
		contentDiv.style.display = "";
		contentDiv.style.visibility = "visible";
		contentDivHolder.style.visibility = "visible";
		setTimeout(function(){ZDBPricing.slideDiv(contentDiv,contentDivTop)},10);
	}
	
	this.slideDiv = function(contentDiv,contentDivTop)
	{
		if(contentDivTop<0)
		{
			contentDiv.style.top = contentDivTop+"px";
			contentDivTop = contentDivTop+25	;
			setTimeout(function(){ZDBPricing.slideDiv(contentDiv,contentDivTop)},10);
		}else{contentDiv.style.top = "0px";}
	}
	
	this.hideSlideContent = function(contentId)
	{
		var contentDiv = $(contentId);
		contentDiv.parentNode.style.display = "none";
	}
	
  this.checkKeyHideSlide = function(el,ev)
  {
    if(!ev){ev = window.event};
    if(ev.keyCode == 27)
    {
      ZDBPricing.hideSlideContent(el);
      return false;
    }
    return true;
  }

	this.sendQTActivationRequest = function(el)
	{
		if(el.triggered){return;}
		var objSelected = ZDBPricing.selectedObjects.split(",");
		if((objSelected.length-1)>3){ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.pricing.mng_qry_tbl.js.slt_5_qry"));return;}
		el.triggered = true;
		AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=DEACTIVATEQUERYTABLES"+"&OBJIDS=" + encodeURIComponent(ZDBPricing.selectedObjects),  //No I18N
                                             ONSUCCESSFUNC:ZDBPricing.handleManageQTTab,
                                             OPSTATUSID:"ZDBMainLoader"});  //No I18N

	}

  this.qtActivationDisabled = function(el)
  {
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.pricing.mng_qry_tbl.js.qry_tbl_activation"));
  }

  this.handleManageQTTab = function(response,requestOptions)
  {
    ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrpt.common.pricing.mng_qry_tbl.js.qry_tbl_activate_success"),"zdbpsuccessmsg"); //No I18N
	var tabMainDiv = $("TabMainDiv");
	ZDBUtil.setNamedChildEls(tabMainDiv,tabMainDiv,"showpage"); //No I18N
	var targetTab = response.responseText;
	ZDBPricing.selectTab(tabMainDiv[targetTab]);
  }
  
  	this.calculateAdon_New = function(el, planId)
	{
	    var rowDiv = ZDBUtil.getParentWithAttr(el,"currentRow");    // No I18N
	    ZDBUtil.setNamedChildEls(rowDiv,rowDiv);
	    var total = $("ZDBTotalPrice");
	    ZDBPricing.calculatePricing(false, planId);
	    ZDBPricing.updateUserDetails_New(el);
	    var toHighLightElts = [rowDiv.amount,total];
	    
	    ZDBPricing.highlightCalculation(toHighLightElts,150);
	};

	
	this.calculateAdon = function(el, rowId, allAddOn, planId)
	{
	    var rowDiv = ZDBUtil.getParentWithAttr(el,"currentRow");    // No I18N
	    ZDBUtil.setNamedChildEls(rowDiv,rowDiv);
	    var total = $("ZDBTotalPrice");
	    ZDBPricing.calculatePricing(false, planId);
	    if(rowId) { $(rowId).style.display = "table-row"; }
	    if(el.value == 0 && rowId){
	    	$(rowId).style.display = "none";
	    }
	    else if(rowId) { 
	    	$(rowId).style.display = "table-row"; 
	    }

	    ZDBPricing.updateUserDetails();
	    var toHighLightElts ;
	    if(allAddOn)
	    {
	        var addOnsList = DOMUtils.getChildElsWithAttr($("ZDBConnectorsHolder"), "elname", "amount"); //No I18N
	        toHighLightElts = addOnsList;
	        toHighLightElts.push(total);
	    }
	    else
	    {
	        toHighLightElts = [rowDiv.amount,total];
	    }
	    
	    ZDBPricing.highlightCalculation(toHighLightElts,150);
	}
  
    this.updateUserDetails = function()
    {
      var planUserCountDisp = $("ZDBPlanUserCount");
      var adonUserCountDisp = $("ZDBAddOnUserCount");
      var totalUserCountDisp = $("ZDBTotalUserCount");
      var planRowCountDisp = $("ZDBPlanRowCount");
      
      var planRowCount = planRowCountDisp.getAttribute("allowedPlanRows").trim();
      var adonRowCountDisp = $("ZDBAddOnRowCount");
      var totalRowCountDisp = $("ZDBTotalRowCount");

      var newAddOnUsers = $("ZDBAdonUser").value;
      adonUserCountDisp.innerHTML = ZDBPricing.thousandSeparator(newAddOnUsers);
      totalUserCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planUserCountDisp.innerHTML) + parseInt(newAddOnUsers));

      var newAddOnRow = $("ZDBAdonRows");
      var adOnRowSelIndex = newAddOnRow.selectedIndex;
      var addOnRowSelValue = newAddOnRow[adOnRowSelIndex].getAttribute("arows");
      adonRowCountDisp.innerHTML = ZDBPricing.thousandSeparator(addOnRowSelValue);
      totalRowCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planRowCount) + parseInt(addOnRowSelValue));
      planRowCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planRowCount));
      
      //Schedule email
      var planSchMailCountDisp = $("ZDBPlanSchMailCount");
      var addonSchMailCountDisp = $("ZDBAddOnSchMailCount");
      var totalSchMailCountDisp = $("ZDBTotalSchMailCount");
      var newAddOnSchMail = $("ZDBAdonSchMail");
      var adOnSchMailSelIndex = newAddOnSchMail.selectedIndex;
      var addOnSchMailSelValue = newAddOnSchMail[adOnSchMailSelIndex].getAttribute("arows") || 0;
      addonSchMailCountDisp.innerHTML = ZDBPricing.thousandSeparator(addOnSchMailSelValue);
      totalSchMailCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planSchMailCountDisp.innerHTML) + parseInt(addOnSchMailSelValue));
      planSchMailCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planSchMailCountDisp.getAttribute("allowedPlanSchMails").trim()));

      // API Units
      var planAPIUnitsCountDisp = $("ZDBPlanAPIUnitsCount");
      var addonAPIUnitsCountDisp = $("ZDBAddOnAPIUnitsCount");
      var totalAPIUnitsCountDisp = $("ZDBTotalAPIUnitsCount");
      var newAddOnAPIUnits = $("ZDBAdonAPIUnits");
      var adOnAPIUnitsSelIndex = newAddOnAPIUnits.selectedIndex;
      var addOnAPIUnitsSelValue = newAddOnAPIUnits[adOnAPIUnitsSelIndex].getAttribute("arows") || 0;
      addonAPIUnitsCountDisp.innerHTML = ZDBPricing.thousandSeparator(addOnAPIUnitsSelValue);
      totalAPIUnitsCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planAPIUnitsCountDisp.getAttribute("allowedPlanAPIUnits").trim()) + parseInt(addOnAPIUnitsSelValue));
      planAPIUnitsCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planAPIUnitsCountDisp.getAttribute("allowedPlanAPIUnits").trim()));
      
      ZDBPricing.highlightCalculation([adonUserCountDisp, totalUserCountDisp, 
                                       adonRowCountDisp, totalRowCountDisp,
                                       addonSchMailCountDisp,addonAPIUnitsCountDisp]
      							,100);
    };
    
    this.updateUserDetails_New = function(el)
    {
      var planUserCountDisp = $("ZDBPlanUserCount");
      var totalUserCountDisp = $("ZDBTotalUserCount");
      var planRowCountDisp = $("ZDBPlanRowCount");
      
      var planRowCount = planRowCountDisp.getAttribute("allowedPlanRows").trim();
      var totalRowCountDisp = $("ZDBTotalRowCount");

      var newAddOnUsers = $("ZDBAdonUser").value;
      totalUserCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planUserCountDisp.innerHTML) + parseInt(newAddOnUsers));

      var newAddOnRow = $("ZDBAdonRows");
      var adOnRowSelIndex = newAddOnRow.selectedIndex;
      var addOnRowSelValue = newAddOnRow[adOnRowSelIndex].getAttribute("arows");
      totalRowCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planRowCount) + parseInt(addOnRowSelValue));
      planRowCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planRowCount));
      
      //Schedule email
      var planSchMailCountDisp = $("ZDBPlanSchMailCount");
      var totalSchMailCountDisp = $("ZDBTotalSchMailCount");
      var newAddOnSchMail = $("ZDBAdonSchMail");
      var adOnSchMailSelIndex = newAddOnSchMail.selectedIndex;
      var addOnSchMailSelValue = newAddOnSchMail[adOnSchMailSelIndex].getAttribute("arows") || 0;
      totalSchMailCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planSchMailCountDisp.innerHTML) + parseInt(addOnSchMailSelValue));
      planSchMailCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planSchMailCountDisp.getAttribute("allowedPlanSchMails").trim()));

      // API Units
      var planAPIUnitsCountDisp = $("ZDBPlanAPIUnitsCount");
      var totalAPIUnitsCountDisp = $("ZDBTotalAPIUnitsCount");
      var newAddOnAPIUnits = $("ZDBAdonAPIUnits");
      var adOnAPIUnitsSelIndex = newAddOnAPIUnits.selectedIndex;
      var addOnAPIUnitsSelValue = newAddOnAPIUnits[adOnAPIUnitsSelIndex].getAttribute("arows") || 0;
      totalAPIUnitsCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planAPIUnitsCountDisp.getAttribute("allowedPlanAPIUnits").trim()) + parseInt(addOnAPIUnitsSelValue));
      planAPIUnitsCountDisp.innerHTML = ZDBPricing.thousandSeparator(parseInt(planAPIUnitsCountDisp.getAttribute("allowedPlanAPIUnits").trim()));
      var highLightEl = jQuery(el).parent().next().find("span");
      ZDBPricing.highlightCalculation(highLightEl ,100);
    };
	
	this.calculatePricing = function(highlightAllChanges, planId)
	{
						var addonRows = $("ZDBAdonRows").value;
            var adonUser = $("ZDBAdonUser").value;
            var adonSchMail = $("ZDBAdonSchMail").value;
            var adonAPIUnits = $("ZDBAdonAPIUnits").value;
            var subscriptionPeriod = parseInt(ZDBPricing.getRadioSelectedValue($("ZDBSubscriptionForm"),"subscriptionMode"));   //No I18N
																																
            switch(subscriptionPeriod)
            {
                case 0:var payPeriodTxt=i18n.g("zrpt.pricing.changeplan.js.year");break;
                case 1:var period = ZDBI18NMap.g("zrpt.common.pricing.interval.js.month"); var payPeriodTxt=ZDBI18NMap.g("zrpt.pricing.changeplan.js.monthly");break;
                case 3:var period = ZDBI18NMap.g("zrpt.common.pricing.interval.js.quarter"); var payPeriodTxt=ZDBI18NMap.g("zrpt.pricing.changeplan.js.quarterly");break;
                case 6:var period = ZDBI18NMap.f("zrpt.common.pricing.interval.js.months",6); var payPeriodTxt=ZDBI18NMap.g("zrpt.pricing.changeplan.js.half_year");break;
                case 12: var period = ZDBI18NMap.g("zrpt.common.pricing.interval.js.year"); var payPeriodTxt=ZDBI18NMap.g("zrpt.pricing.changeplan.js.year");break;
            }
            
            //Discount calculation
            var discount = (subscriptionPeriod==6)?0.05:(subscriptionPeriod==12)?0.1:0;
            if(discount > 0 && ZDBPricing.validPromo)
            {//Discount for promocode
              discount = (subscriptionPeriod==6)?0.15:(subscriptionPeriod==12)?ZDBGlobal.promoCodeDiscount:0;
            }
            
            var planPriceDisp = $("ZDBPlanPrice");
            var adonRowPriceDisp = $("ZDBAdonRowPrice");
            var adonUserPriceDisp = $("ZDBAdonUserPrice");
            var adonSchMailPriceDisp = $("ZDBAdonSchMailPrice");
            var adonAPIUnitsPriceDisp = $("ZDBAdonAPIUnitsPrice");
            var totalPriceDisp = $("ZDBTotalPrice");

            var planPrice = (planPriceDisp.getAttribute("planPrice")*subscriptionPeriod);
            var actualPlanPrice = planPrice;
            planPrice = planPrice - (planPrice *discount);

            /* ####### ADDON - ROW STARTS ####### */
            var adonRowPrice = (addonRows!=0)?($(addonRows).getAttribute("price")*subscriptionPeriod):0;
            var actualAdonRowPrice = adonRowPrice;
            adonRowPrice = adonRowPrice-(adonRowPrice * discount);
            var rowPaidTxt = adonRowPrice > 0 ? "paidTxtAmt" : "";		//No I18N
            /* ####### ADDON - ROW ENDS ####### */

            /* ####### ADDON - USER STARTS ####### */
            var adonUserPrice =  (adonUser * $("AddOn_1User").getAttribute("price") * subscriptionPeriod);
            var actualAdonUserPrice = adonUserPrice;
            adonUserPrice = adonUserPrice - (adonUserPrice * discount);
            var usrPaidTxt = adonUserPrice > 0 ? "paidTxtAmt" : "";		//No I18N
            
            /* ####### ADDON - SCHEDULE EMAIL STARTS ####### */
            
            var adonSchEmailsPrice =  (adonSchMail != 0) ? ($(adonSchMail).getAttribute("price") * subscriptionPeriod):0;
            var actualAdonSchEmailPrice = adonSchEmailsPrice;
            adonSchEmailsPrice = adonSchEmailsPrice - (adonSchEmailsPrice * discount);
            var schMailPaidTxt = adonSchEmailsPrice > 0 ? "paidTxtAmt" : "";		//No I18N
            	
            /* ####### ADDON - API Units STARTS ####### */
            
            var adonAPIUnitsPrice =  (adonAPIUnits != 0) ? ($(adonAPIUnits).getAttribute("price") * subscriptionPeriod):0;
            var actualAdonAPIUnitsPrice = adonAPIUnitsPrice;
            adonAPIUnitsPrice = adonAPIUnitsPrice - (adonAPIUnitsPrice * discount);
            var apiUnitPaidTxt = adonAPIUnitsPrice > 0 ? "paidTxtAmt" : "";		//No I18N

            /* ####### ADDON - CONNECTOR STARTS ####### */
            var addOns = DOMUtils.getChildElsWithAttr($("ZDBConnectorsHolder"), "id", "ZDBAddOnElt");	//No I18N
            var cntrs = new Array();
            for ( var i = 0; i < addOns.length; i++)
            {
                var cntr = {};
                var adonCntrPrice = 0;
                var actualAdonCnctrPrice = 0;
                var parentDiv = DOMUtils.getParentWithAttr(addOns[i],"currentRow");
                var spanElt = DOMUtils.getChildElsWithAttr(parentDiv, "id", "ZDBAddOnCost"); //No I18N
																								
                if(addOns[i].checked && !(planPrice > 0 && addOns[i].getAttribute("freeForPaidPlans") == "true") && !(planId > 3 && addOns[i].getAttribute("freeForProAbove") == "true"))
                {
                    var adonCntrPrice1 = $(addOns[i].value).getAttribute("price") * subscriptionPeriod;
                    actualAdonCnctrPrice = actualAdonCnctrPrice + adonCntrPrice1;
                    adonCntrPrice = adonCntrPrice + (adonCntrPrice1 - (adonCntrPrice1 * discount));
                }
                cntr.costSpan = spanElt;
                cntr.actualPrice = actualAdonCnctrPrice;
                cntr.cost = adonCntrPrice;
                cntrs.push(cntr);
            }
            /* ####### ADDON - CONNECTOR ENDS ####### */

            var actualPrice = actualPlanPrice + actualAdonRowPrice + actualAdonUserPrice+
            					actualAdonSchEmailPrice + actualAdonAPIUnitsPrice;
            var totalPrice = planPrice + adonRowPrice + adonUserPrice + adonSchEmailsPrice + adonAPIUnitsPrice;
            for(var i=0;i<cntrs.length;i++)
            {
                actualPrice += cntrs[i].actualPrice;
                totalPrice += cntrs[i].cost;
            }
            var paymentHeader=$("PlanPaymentHeader");
            var planName=paymentHeader.getAttribute("plan");
            paymentHeader.innerHTML = ZDBI18NMap.f("zrpt.pricing.changeplan.js.plan", planName, payPeriodTxt);
            var paymentDesc = $("ZDBPaymentDesc");
            paymentDesc.innerHTML = ZDBI18NMap.f("zrpt.common.pricing.upgrade.js.total_charges",period);
            planPriceDisp.innerHTML = ZDBI18NMap.f("zrpt.common.pricing.upgrade.js.dollar",planPrice.toFixed(2));
            
            adonRowPriceDisp.innerHTML = ZDBI18NMap.f("zrpt.common.pricing.upgrade.js.dollar",adonRowPrice.toFixed(2));
            adonRowPriceDisp.className = rowPaidTxt;
            
            adonUserPriceDisp.innerHTML = ZDBI18NMap.f("zrpt.common.pricing.upgrade.js.dollar",adonUserPrice.toFixed(2));
            adonUserPriceDisp.className = usrPaidTxt;
            
            adonSchMailPriceDisp.innerHTML = ZDBI18NMap.f("zrpt.common.pricing.upgrade.js.dollar",adonSchEmailsPrice.toFixed(2));
            adonSchMailPriceDisp.className = schMailPaidTxt;
            
            adonAPIUnitsPriceDisp.innerHTML = ZDBI18NMap.f("zrpt.common.pricing.upgrade.js.dollar",adonAPIUnitsPrice.toFixed(2));
            adonAPIUnitsPriceDisp.className = apiUnitPaidTxt;
            
            for(var i=0;i<cntrs.length;i++)
            {
            	var connectorEl = cntrs[i].costSpan[0]; 
            	connectorEl.innerHTML = ZDBI18NMap.f("zrpt.common.pricing.upgrade.js.dollar",cntrs[i].cost.toFixed(2)); ;
                if(cntrs[i].cost > 0){
                	jQuery(connectorEl).addClass("paidTxtAmt");	//No I18N
                }
            }
            totalPriceDisp.innerHTML = ZDBI18NMap.f("zrpt.common.pricing.upgrade.js.dollar",totalPrice.toFixed(2));
            var saveMoneyText=$("saveMoneyText");
            if(discount > 0 && ZDBPricing.validPromo)
            {
              var savePrice = actualPrice-totalPrice;
              saveMoneyText.innerHTML=ZDBI18NMap.f("zrpt.pricing.changeplan.js.discount_saved",actualPrice,totalPrice,savePrice.toFixed(2));
              saveMoneyText.className="validPromoOffer";
              ZDBPricing.validPromo = false;
            }
            else
            {
              saveMoneyText.innerHTML = ZDBI18NMap.g("zrpt.pricing.changeplan.js.promo.code.hint");
              saveMoneyText.className="promoHintLabel";
            }

            if(highlightAllChanges)
            {
                var highLightList = [planPriceDisp,adonRowPriceDisp,adonUserPriceDisp,totalPriceDisp,$("periodDisp"),adonSchMailPriceDisp,adonAPIUnitsPriceDisp];
                for(var i=0;i<cntrs.length;i++)
                {
                    highLightList.push(cntrs[i].costSpan[0]);
                }
                ZDBPricing.highlightCalculation(highLightList,150);
            }
	};
	
	this.getRadioSelectedValue = function(form,name)
	{
		var radio = form[name];
		var len = radio.length;
		for(var i=0; i<len; i++)
		{
			var opt = radio[i];
			if(opt.checked == true)
			{
			return opt.value;
			}
		}
	}
	
	this.highlightCalculation = function(els,blueValue)
	{
		var len = els.length;
		var bgcolor = (blueValue + 5 <255)?"rgb(255,252,"+blueValue+")":""; //No I18N
																			
		for(i=0; i<len; i++){
			els[i].style.backgroundColor = bgcolor;
		}
		blueValue = blueValue + 5;
		if(blueValue<255){
			setTimeout(function(){ZDBPricing.highlightCalculation(els,blueValue)},50);
		}
	}
	
	this.backToPrevious = function(tabName)
	{
		var tabMainDiv = $("TabMainDiv");
		ZDBUtil.setNamedChildEls(tabMainDiv,tabMainDiv,"showpage"); //No I18N
		ZDBPricing.selectTab(tabMainDiv[tabName]);
	}

  this.togglePromoCode = function ()
  {
      var promoTextBox = $("promoTxtBox");
      promoTextBox.style.display=(promoTextBox.style.display == "") ? "none" :"";
  }

  this.verifyPromoCode = function(planId)
  {
    var promoCodeStr = $("promoCode").value;
    if (ZDBPricing.validateCoupon(promoCodeStr, true))
    {
      AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?ZDBACTION=VERIFYPROMOCODE" + "&PROMOCODE=" + encodeURIComponent(promoCodeStr), //No I18N
                                       ONSUCCESSFUNC:ZDBPricing.applyPromoCodeAndCalculateCost, //No I18N
                                       PLANID:planId, OPSTATUSID:""});  //No I18N
    }
  }

  this.validateCoupon = function(promoCodeStr, throwErr)
  {
    if (promoCodeStr == "" || promoCodeStr == null || promoCodeStr.length > 10)
    {
      if(throwErr)
      {
        ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.pricing.changeplan.js.invalid_coupon"));
      }
      return false;
    }
    var targetPayperiod = parseInt(ZDBPricing.getRadioSelectedValue($("ZDBSubscriptionForm"),"subscriptionMode"));   //No I18N
    if (targetPayperiod < 6)
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.pricing.changeplan.js.coupon_invalid_term"));
      return false;
    }
/*  get the target plan chosen by the user */
    return true;
  }

  this.applyPromoCodeAndCalculateCost = function(response,requestOptions)	
  {
    var respArray = response.responseText.split(",");
    var isPromoValid = respArray[0];
    var discount = respArray[1];
    if(isPromoValid == "Valid Promotional Code")
    {
      ZDBPricing.validPromo = true;
      ZDBPricing.calculatePricing(true, requestOptions.PLANID);
      var saveMoneyText=$("saveMoneyText");
      ZDBPricing.highlightCalculation([saveMoneyText],100);
    }
    else
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.pricing.changeplan.js.invalid_coupon"));
    }
  }

  this.thousandSeparator = function(displayValue)
  {
      displayValue = displayValue + '';
      var value = displayValue.split('.');
      var intPart = value[0];
      var deciPart = value.length > 1 ? '.' + value[1] : '';
      if (intPart.length < 3)
      {
        return displayValue;
      }
      var count = 0;
      var number = "";
      for (var i = intPart.length - 1; i >= 0; i--)
      {
        var digit = intPart.charAt(i);
        if (count == 3)
        {
          number += ",";
          number += digit;
          count = 1;
        }
        else
        {
          number += digit;
          count ++;
        }
      }
      intPart = ZDBPricing.reverse(number);
      displayValue = intPart + deciPart;
      return displayValue;
  }

  this.reverse = function(str)
  {
    var temp = '';
    for(var i = (str.length-1); i >= 0; i--)
    {
      temp = temp + str.charAt(i);
    }
    return temp;
  }

  this.changeInviteCont = function()
  {
    var listTblEls = $("ZDBListingTable");
    var trs = listTblEls.getElementsByTagName("tr");
    for(var i=0; i<trs.length; i++)
    {
      var td = DOMUtils.getFirstMatchingChild(trs[i],"td","isInvLinkEnable","true"); //No I18N
      if(!td) continue;
      var hidEl = DOMUtils.getFirstMatchingChild(td,"input");     //No I18N
      var spnEl = DOMUtils.getFirstMatchingChild(td,"span");      //No I18N
      if(ZDBPricing.sendMails.indexOf(hidEl.getAttribute("__em")) != -1)
      {
        spnEl.innerHTML = ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.mailsent");
        spnEl.className="sendinvite";
        spnEl.setAttribute("onclick","");
      }
    }

  }
  
  this.sendInvite = function(curEl)
  {
    curEl = curEl || this;
    var hidEl = DOMUtils.getFirstMatchingChild(curEl.parentNode.parentNode,"input","type","hidden");  //No I18N
    var email = hidEl.getAttribute("__em");
    if(email=="" || email==null) { return; }
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.anotheinvit"),
        "ZDBYESNO",{ONCLICK:ZDBPricing.sendInviteMail,ELEMENT:curEl,EMAILID:email},     //No I18N
        ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.sentinvitation"));
  }

  this.sendInviteMail = function(clickType, requestOptions)
  {
    if(clickType == "NO")
    {
      return;
    }
    var curEl = requestOptions["ELEMENT"];
    var email = requestOptions["EMAILID"];
    ZDBPricing.sendMails.push(email);
    var nDiv = $("navigatorDiv");
    var pattern = nDiv.getAttribute("pattern");
    var nextSet = nDiv.getAttribute("nextset");
    var mode = nDiv.getAttribute("mode");
    AjaxAPI.sendRequest({ URL:"/ZDBPricingAction.ma?ZDBACTION=SENDINVITEMAILREQ&PATTERN=__list__all__&MODE="+mode+"&NEXTSET="+nextSet+  //No I18N
      "&EMAILID="+encodeURIComponent(email), OPERATION:"SENDINVITEMAILREQ", ONSUCCESSFUNC:ZDBPricing.handleUserStatus, OPSTATUSID:"ZDBMainLoader" }); //No I18N
  }

  this.toggleConnectors = function(elt)
  {
      var addOns = DOMUtils.getChildElsWithAttr($("ZDBConnectorsHolder"), "id", "ZDBAddOnElt"); //No I18N
      for(var i=0;i<addOns.length;i++)
      {
          addOns[i].checked = elt.checked;
      }
      ZDBPricing.calculateAdon(elt,null,true);
  }

  this.showConnectorsDetails = function()
  {
      var cntrDetElt = $("ZDBPCntrDetails");
      var relDiv = $("ZDBCntrsDts");
      var mainDiv = $("ZDBPriceContentHolder");
      cntrDetElt.style.left = ((ZDBUtil.getObjLeft(relDiv,false,mainDiv))- (relDiv.offsetWidth/2)) + "px";
      cntrDetElt.style.top = (ZDBUtil.getObjTop(relDiv,false,mainDiv)+relDiv.offsetHeight+13)+"px";
      $("ZDBPCntrDetails").style.display="";
      jQuery(document.body).click(function(event) {
          if(event.target != relDiv && jQuery(event.target).parents("[id=ZDBPCntrDetails]").length==0)
          {
              var cntrElt = $("ZDBPCntrDetails");//No I18N
              cntrElt.style.display ="none";
              jQuery(document.body).unbind("click");//No I18N
          }
      });
      jQuery(document).bind('keydown',function(event){
          if(event.which == 27)
          {
              var cntrElt = $("ZDBPCntrDetails");//No I18N
              cntrElt.style.display ="none";
              jQuery(document).unbind("keydown");//No I18N
          }
      }
     );
  }

  //This method use for skipping feedback form. This method will closed the current dialog and redirect to "current plan" tab
  this.closeFeedbackForm = function(el,ev)
  {
    if(ev == undefined)
    {
      ev = window.event;
    }
    ZDBDialogUtil.closeDialog(el,ev);
    var reqNresp = ZDBPricing.changePlanReqNResp;   //Already cached in plan change informations (req and resp)
    ZDBPricing.handleRespNSelectTab(reqNresp[0],reqNresp[1]); //Redirect to current plan tab
  }

  this.submitDowngradeFeedbackForm = function(formEl)
  {
    jQuery(".formResp").hide();   //No I18N
    var feedVal = jQuery("#ZDBFeedbackFrm textarea").val();   //No I18N
    if(feedVal === undefined || ((feedVal = feedVal.trim()) == ""))
    {
      alert("Please provide your feedback and then submit the form.");   //No I18N
      return false;
    }
    return AjaxAPI.submit(formEl);
  }

  this.successSubmit = function(resp,reqOpts)
  {
    ZDBPricing.closeFeedbackForm(jQuery(".feedbackFormsubmitBtn")[0]);
  };
  
  this.uploadUserLogo = function(fileEl){
	  if(!ZDBPricing.validateLogo(fileEl.value)){
		  ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.pricing.rebranding.js.filetypenotsupport"));
		  return false;
	  }
	  var formEl = fileEl.form;
	  formEl.action = "/ZDBPricing.ve?ZDBACTION=UPLOADUSERLOGO";
	  formEl.setAttribute("ONSUCCESSFUNC", "ZDBPricing.showPreviewLogo");
	  //formEl.setAttribute("ONFAILUREFUNC", "ZDBPricing.uploadErrMsg");
	  formEl.setAttribute("OPSTATUSID", "ZDBMainLoader");
	  AjaxAPI.submit(formEl);
  };
  
  this.showPreviewLogo = function(resp, reqOpt){
	  var resultString = ZDBPricing.stripHTML(resp.responseText);
	  var respObj = JSON.parse(resultString);
	  jQuery("#ZDBRebrandingPreview").attr("src", respObj.LOGOURL); 		//No I18N
	  jQuery("#ZDBLogo").attr("src", respObj.LOGOURL);		//No I18N
	  $("RemoveLink").style.display = "";
	  $("NotUploadedTxt").style.display = "none";
	  ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrpt.common.pricing.rebranding.js.logouploaded"),"zdbpsuccessmsg");	//No I18N
  };
  
  //this.uploadErrMsg = function(resp){
  //	  console.log(resp.getResponsePart());
  //}
  
  this.changePwdByLogoOption = function(val){
	  if(val == 0){
		  jQuery("#CRMPlusRebrandLogoHolder").hide();//No I18N
	  }
	  else if(val == 1){
		  jQuery("#CRMPlusRebrandLogoHolder").show();//No I18N
		  jQuery("#RebrandLogoChosen").hide();//No I18N
	  }
	  else{
		  var existUsrLogo = jQuery('[name="USERLOGOFILEEXIST"]');//No I18N
		  var imgSrc = existUsrLogo.attr("src");//No I18N
		  if(imgSrc == "")
		  {
			  existUsrLogo.hide();//No I18N
			  jQuery('[name="CUSTOMREBRANDFILESUPPORT"]').css('display', 'table-cell');  //No I18N
		  }
		  jQuery("#RebrandLogoChosen").show();//No I18N
		  jQuery("#CRMPlusRebrandLogoHolder").show();//No I18N
	  }
  }
  
  this.successCRMPlusRebrandFunc = function(resp, reqOpts)
  {
	  var respObj = JSON.parse(resp.responseText);
	  var pwdByOpt = respObj.SHOW_PWDBY;
	  if(pwdByOpt == 0)
	  {
		  var serverURL = jQuery('[name="SERVERURL"]').val();//No I18N
		  var logoURLEl = jQuery('[name="LOGOURL"]');//No I18N
		  logoURLEl.attr("x", serverURL);//No I18N
		  logoURLEl.val(serverURL);
	  }
	  if(pwdByOpt < 2)
	  {
		  var existUsrLogo = jQuery('[name="USERLOGOFILEEXIST"]');//No I18N
		  existUsrLogo.attr("src", "");//No I18N
		  var usrLogoNewFile = jQuery('[name="USERLOGOFILENEW"]'); //No I18N
		  usrLogoNewFile.attr("actSrc", "");//No I18N
	  }
	  if(pwdByOpt == 2)
	  {
		  var existUsrLogoSrc = jQuery('[name="USERLOGOFILEEXIST"]').attr("src");//No I18N
		  jQuery('[name="USERLOGOFILENEW"]').attr("actSrc", existUsrLogoSrc); //No I18N
	  }
	  ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrpt.common.pricing.rebranding.js.setting_saved"),"zdbpsuccessmsg"); //No I18N
  }
  
  this.saveCRMPlusRebrandSettings = function(frm){
	  if(!ZDBPricing.validateLogo(frm.USERLOGOFILENEW.value)){
		  ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.pricing.rebranding.js.filetypenotsupport"));
		  return false;
	  }
	  frm.action = "/ZDBPricing.ve?ZDBACTION=UPDATEREBRANDSETTINGSCRMPLUS";
	  frm.setAttribute("ONSUCCESSFUNC", "ZDBPricing.successCRMPlusRebrandFunc");
	  AjaxAPI.submit(frm);
  }
  
  this.changeCRMPlusRebrandImage = function(event, el){
	  var fileObj = event.target.files[0];
	  if(fileObj)
	  {
		  jQuery('[name="CUSTOMREBRANDFILESUPPORT"]').hide();//No I18N
		  jQuery('[name="USERLOGOFILEEXIST"]').css('display', 'inline');//No I18N
		  jQuery('[name="USERLOGOFILEEXIST"]').attr("src", URL.createObjectURL(event.target.files[0]));//No I18N
	  }
	  else
	  {
		  var imgSrc = el.getAttribute("actSrc");
		  if(imgSrc)
		  {
			  jQuery('[name="USERLOGOFILEEXIST"]').attr("src", imgSrc);  //No I18N
		  }
		  else
		  {
			  jQuery('[name="USERLOGOFILEEXIST"]').attr("src", "");//No I18N
			  jQuery('[name="USERLOGOFILEEXIST"]').hide();//No I18N
			  jQuery('[name="CUSTOMREBRANDFILESUPPORT"]').css('display', 'table-cell');  //No I18N
		  }
	  }
  };

  this.upgradeRows = function(){
  	AjaxAPI.sendRequest({ URL:"/ZDBPricing.ve?ZDBACTION=UPGRADEROWS", ONSUCCESSFUNC:ZDBPricing.handleUpgradeRowsSuccess, OPSTATUSID:"ZDBMainLoader",ONFAILUREFUNC:ZDBPricing.handleUpgradeRowsFailure }); //No I18N
  };

  this.handleUpgradeRowsSuccess = function(response, request){
  	var totalRows = 100000;
  	var remainingRows = jQuery("#ZRUsedRows").text().replace(",",""); // No I18N
  	jQuery("#ZRAllowedRows").text(totalRows); // No I18N
  	jQuery("#ZRRemainingRows").text(totalRows - remainingRows); // No I18N
  	jQuery("#ZRRowRemarks").text("-"); // No I18N
  	ZDBMsgBox.showHintMsg(ZDBI18NMap.g("zrpt.pricing.notification.js.rows_upgraded_to_100000"), "success"); // No I18N
  };

  this.handleUpgradeRowsFailure = function(){
  	ZDBMsgBox.showHintMsg(ZDBI18NMap.g("zrpt.pricing.notification.js.rows_upgrade_failure"),"error",9000);//No I18N
  };

  this.stripHTML = function(htmlString)
  {
  	var tmp = document.createElement("DIV");
  	tmp.innerHTML = htmlString;
  	var stringVar = tmp.textContent;
  	return stringVar;
  };

  //ZROP LICENSING
  this.registerNewLicense=function(fileEl){
  	if(!ZDBPricing.validateLicFile(fileEl.value)){
		  ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrop.register.license.invalid"));
		  return false;
	  }
  	var formEl = fileEl.form;
  	formEl.action = "/ZDBPricing.ve?ZDBACTION=REGISTERLICENSE";
  	formEl.setAttribute("ONSUCCESSFUNC", "ZDBPricing.regLicenseSuccess");
	formEl.setAttribute("ONFAILUREFUNC", "ZDBPricing.regLicenseFailure");
	AjaxAPI.submit(formEl);
  }
  this.validateLicFile = function(fileName)
	{
		var pat = new RegExp("\\.(xml)$","i");
		if(pat.test(fileName))
		{
			return true;
		}
		return false;
	};
  this.regLicenseSuccess=function(resp, reqOpt){
  	ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrop.register.license.success"),"zdbpsuccessmsg");//No I18N
  	ZDBPricing.selectTab(document.getElementById("ZDBPriceSelTab"));
  }
  this.regLicenseFailure=function(resp){
  	ZDBPricing.showStatusMsg(ZDBI18NMap.g("zrop.register.license.failure"),"zdbinfomsg");//No I18N
  }
//ZROP LICENSING
  
  
  this.showEnquiry = function(element, event)
	{
		var callBack = function(response,request){
			var div = document.createElement("div");
			div.setAttribute("isDialog", "true");
			div.innerHTML = response.getOnlyHtml();
			ZDBMenu.addShadow(div);
			div.style.width="500px";
			ZDBDialogUtil.showDialog(div,{MODAL:true});
			if(BROWSER.IE && BROWSER.VERSION == "9.0"){
				addPlaceHolder(jQuery("#demoRequestFocusEl")[0]);
				addPlaceHolder(jQuery("#ZDBDemoContactNumber")[0]);
				addPlaceHolder(jQuery("#ZDBDemoContactTime")[0]);
			}
		}
		var url = ZDBGlobal.CTX +"/ZDBEnquiryUI.cc";//NO I18N
		AjaxAPI.sendRequest({URL:url,METHOD:"GET",ONSUCCESSFUNC:callBack,INVOKESCRIPTS:true,OPSTATUSID:"ZDBMainLoader"});
	}
  
  
  
}
function addPlaceHolder(el){ //for placeholders in IE9
	el.placeholder = el.getAttribute("placeholder");
	el.onfocus = function(){
		if(this.value == this.placeholder){
			this.value = "";
			el.style.opacity= "1";
		}
	};
	el.onblur = function(){
		if(this.value.length == 0)
		{
			this.value = this.placeholder;
			el.style.opacity = '0.5';
		}
	};
	el.onblur();
}


