//$Id$

var ZDBScreenGrabber = new function(){
	this.startScreenShot = function(element, feedBackType)
	{
		//ignorei18n_start
	  if(jQuery("#ZRFeedBack").attr("screenShotPresent") == "true"){
		  return;
	  }
	  jQuery("#ZRFeedBack").hide();
	  document.body.feedBackType = feedBackType;
	  var type = ZDBClientUI.selectedTab && ZDBClientUI.selectedTab.view.type;
	  if(type == "AnalysisView" || type == "Dashboard"){
		  var parent = document.querySelector("#ZDBPLACEHOLDER");
		  var svgs = parent.querySelectorAll("svg.svgarea");
		  for(var i=0; i<svgs.length; i++){
			  try{
				  var parentHTML = "";
				  var svgParent = svgs[i].parentNode;
				  var svgs_temp = [].slice.call(svgParent.querySelectorAll("svg"));
				  svgs[i].appendChild(document.querySelector(".svgPattern").cloneNode(true))
				  svgs_temp.forEach(function(d){
					  var temp  = new XMLSerializer().serializeToString(d);
					  parentHTML += temp;
				  });
				  var boundingRect = svgs[i].getBoundingClientRect();
				  var svgContainer;
				  var str ="<svg xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' xml:space='preserve' width='"+boundingRect.width+"' height='"+boundingRect.height+"'>"+parentHTML+"</svg>";
				  parentHTML = encodeURIComponent(str);
				  svgContainer = "data:image/svg+xml," + parentHTML; 
				  var img = new Image();
				  //img.crossOrigin = "Anonymous";
				  img.onload = function(event){
					  var img = event.target;
					  var canvas = document.createElement("canvas");
					  canvas.width = img.width; //for IE
					  canvas.height = img.height; //for IE
					  var context = canvas.getContext("2d");
					  context.drawImage(img,0,0);
					   var finalImage = new Image;
					   try{
					   finalImage.src = canvas.toDataURL("image/png");
					   }
					   catch(e){
						   //error
					   }
					   finalImage.setAttribute("elname","tempScreenShotImage");
					  img.parent.appendChild(finalImage);
					  if(BROWSER.IE != 1){
						  img.parent.querySelector(".legendarea").style.display="";
					  }
				  };
				  img.src = svgContainer;
				  img.style.position = "absolute";
				  img.style.width = boundingRect.width + 'px';img.style.height = boundingRect.height + 'px';
				  img.parent = svgParent;
				  img.svg = svgs[i];
				  img.width = boundingRect.width;
				  img.height = boundingRect.height;
				  var children = svgParent.children;
				  for(var j=0; j<children.length; j++){
					  children[j].style.display = "none";
				  }
			  }
			  catch(e){
				  //error
			  }
		  }
	  }
	  if(feedBackType == 0){
	    Screengrabber.open({"targetObject":jQuery("#ZDBFeedBackImages"), "fetchImageURL":"ZDBProxy.ma?ZDBACTION=FEEDBACKPROXY"});
	  }
	  else
	  {
	    Screengrabber.open({"targetObject":jQuery("#ZDBFeedBackImages2"), "fetchImageURL":"ZDBProxy.ma?ZDBACTION=FEEDBACKPROXY"});
	  }
	  
	  jQuery("body").on('screengrabberclose',function(event){ZDBScreenGrabber.screenGrabberFinished(event);});
	//ignorei18n_end
	}
	 
	this.screenGrabberFinished = function(event)
	{
		//ignorei18n_start
		var type = ZDBClientUI.selectedTab && ZDBClientUI.selectedTab.view.type;
		if(type == "AnalysisView" || type == "Dashboard"){
			  var parent = document.querySelector("#ZDBPLACEHOLDER");
			  var svgs = parent.querySelectorAll("svg.svgarea");
			  for(var i=0; i<svgs.length; i++){
				  var svgParent = svgs[i].parentNode;
				  var img = svgParent.querySelector("[elname='tempScreenShotImage']");
				  try{
					  svgParent.removeChild(img);
				  }
				  catch(e){
					  //error
					  continue;
				  }
				  var children = svgParent.children;
				  for(var j=0; j<children.length; j++){
					  children[j].style.display = "";
				  }
			  }
		  }
	  jQuery("#ZRFeedBack").show();
	  if(!document.body.screenShot){
		  jQuery("body").off('screengrabberclose');
		  return;
	  }
	  var imgSrc = document.body.screenShot;
	  document.body.screenShot = null;
	  var imgTag = jQuery('<img>').attr({'src':imgSrc}).addClass("ZDBScreenShotImageTag");
	  var targetObj, paramContainer, captureButton;
	  if(document.body.feedBackType == 0){
	    targetObj = jQuery("#ZDBFeedBackImages");
	    targetObj.show().siblings("[elname='commentsForFeedback']").find("textarea").css("height","219px");
	    paramContainer = jQuery("#ZDBParamsOfFeedBackForm");
	    captureButton = jQuery("#ZDBScreenCaptureIcon");
	  }
	  else
	  {
	    targetObj = jQuery("#ZDBFeedBackImages2");
	    targetObj.show().siblings().children("[elname='commentsForFeedback']").find("textarea").css("height","162px");
	    paramContainer = jQuery("#ZDBParamsOfSupportForm");
	    captureButton = jQuery("#ZDBScreenCaptureIcon2");
	  }
	  
	  var child = jQuery("<span>").addClass("ZDBScreenGrabberClose").on("click",function(event){ZDBScreenGrabber.removeScreenShot(this, event);});
	  var span = jQuery("<span>").addClass("ZDBScreenGrabberTemplate").html(ZDBI18NMap.g("zrpt.common.js.screenshot")).append(child)
	        .on("mouseenter",function(event){ZDBScreenGrabber.showImagePreview(this,event);})
	        .on("mouseleave",function(event){ZDBScreenGrabber.hideImagePreview(this,event);});
	  targetObj.append(span);
	  var imgContainer = jQuery("<div>").addClass("ZDBScreenShotContainerDIV").attr("screenshotid","dummy");
	  imgContainer.append(imgTag);
	  targetObj.append(imgContainer);
	  var inputTag = jQuery("<input>").attr({"type":"hidden","screenshotid":"dummy","value":imgSrc,"name":"SCREENSHOT"})
	  .appendTo(paramContainer);
	  jQuery("body").off('screengrabberclose');
	  jQuery("#ZRFeedBack").attr("screenShotPresent", "true");
	  captureButton.attr("blocked",true).removeClass("ZDBScreenCaptureHighlight").addClass("ZDBDisabledScreenGrabIcon");
	//ignorei18n_end
	}

	this.showImagePreview = function(element, event){

	  var imgDIV = jQuery(element).siblings("[screenshotid='dummy']");//NO I18N
	  var baseDiv, form;
	  if(document.body.feedBackType == 0){
	    baseDiv = jQuery("#ZDBFeedBackImages")[0];
	    form = jQuery(baseDiv).parents("#ZDBFeedbackFrm")[0];
	  }
	  else
	  {
	    baseDiv = jQuery("#ZDBFeedBackImages2")[0];
	    form = jQuery(baseDiv).parents("#ZDBContactSupportFrm")[0];
	  }
	  imgDIV.addClass("ZDBScreenShotShow");
	  var span = jQuery(element);
	  var top = span[0].offsetTop - baseDiv.scrollTop - form.scrollTop - 115;
	  var left = span[0].offsetLeft;
	  imgDIV.css({"left":left,"top":top,"width":"195px","height":"115px"});//NO I18N
	}

	this.hideImagePreview = function(element, event){
	  var imgDIV = jQuery(element).siblings("[screenshotid='dummy']");//NO I18N
	  imgDIV.removeClass("ZDBScreenShotShow");
	}

	this.removeScreenShot = function(element, event)
	{
	  jQuery("#ZRFeedBack").find("form").css("overflow-y","");//NO I18N
	  var baseDIV, paramContainer, captureButton;
	  if(document.body.feedBackType == 0){
	    baseDIV = jQuery("#ZDBFeedBackImages");//NO I18N
	    baseDIV.siblings("[elname='commentsForFeedback']").find("textarea").css("height","245px");//NO I18N
	    baseDIV.children().remove();
	    baseDIV.hide();
	    paramContainer = jQuery("#ZDBParamsOfFeedBackForm");//NO I18N
	    captureButton = jQuery("#ZDBScreenCaptureIcon");//NO I18N
	  }
	  else
	  {
	    baseDIV = jQuery("#ZDBFeedBackImages2");//NO I18N
	    baseDIV.siblings().children("[elname='commentsForFeedback']").find("textarea").css("height","188px");//NO I18N
	    baseDIV.children().remove();
	    baseDIV.hide();
	    paramContainer = jQuery("#ZDBParamsOfSupportForm");//NO I18N
	    captureButton = jQuery("#ZDBScreenCaptureIcon2");//NO I18N
	  }
	  paramContainer.find("input[screenshotid]").remove();
	  jQuery("#ZRFeedBack").attr("screenShotPresent", "false");//NO I18N
	  captureButton.attr("blocked",false).removeClass("ZDBDisabledScreenGrabIcon").addClass("ZDBScreenCaptureHighlight");//NO I18N
	}

	this.showFeedBack = function(element, event)
	{
		var callBack = function(response,request){
			var div = document.createElement("div");
			div.setAttribute("isDialog", "true");
			div.innerHTML = response.getOnlyHtml();
			ZDBMenu.addShadow(div);
			div.style.width="500px";
			var isContactSupport = element.getAttribute("elname")=="contactsupport";//NO I18N
			var feedBackFrm = DOMUtils.getFirstMatchingChild(div,"*","name","feedBackFrm");
			var focusEl = DOMUtils.getFirstMatchingChild(feedBackFrm,"*","id","contactSupportFocusEl");
			if(isContactSupport)
				{
					var contactSupportButton = DOMUtils.getFirstMatchingChild(div,"div","elname","contactSupport");//NO I18N
					var feedBackButton = DOMUtils.getFirstMatchingChild(div,"div","elname","feedBack");//NO I18N
					var contactSupportFrm = DOMUtils.getFirstMatchingChild(div,"*","name","contactSupportFrm");
					var feedBackFrm = DOMUtils.getFirstMatchingChild(div,"*","name","feedBackFrm");
					jQuery(contactSupportButton).addClass("greenBtn");
					jQuery(feedBackButton).removeClass("greenBtn");
					contactSupportButton.setAttribute("selected","true");
					feedBackButton.removeAttribute("selected");
					contactSupportButton.style.display="block";
					feedBackButton.style.display="none";
					contactSupportFrm.style.display="block";
					feedBackFrm.style.display="none";
					focusEl = DOMUtils.getFirstMatchingChild(contactSupportFrm,"*","id","contactSupportFocusEl");
				}
			ZDBDialogUtil.showDialog(div,{MODAL:true});
			ZDBUtil.setFocus(focusEl,true);
			if(BROWSER.IE && BROWSER.VERSION == "9.0"){
				addPlaceHolder(jQuery("#ZDBFeedBackComments")[0]);
			    addPlaceHolder(jQuery("#ZDBContactSupportComment")[0]);
			    addPlaceHolder(jQuery("#ZDBContactSupportContactNumber")[0]);
				addPlaceHolder(jQuery("#demoRequestFocusEl")[0]);
				addPlaceHolder(jQuery("#ZDBDemoContactNumber")[0]);
				addPlaceHolder(jQuery("#ZDBDemoContactTime")[0]);
			}
                        ZRFeedbackDlg.prefillReqDemoForm();
		}
		var url = ZDBGlobal.CTX +"/ZDBFeedBackUI.cc";//NO I18N
		AjaxAPI.sendRequest({URL:url,METHOD:"GET",ONSUCCESSFUNC:callBack,INVOKESCRIPTS:true,OPSTATUSID:"ZDBMainLoader"});
	}
}


