//$Id$ 
 
function ZDBGeneralProp(propSetUtil)
{
    var generalProp = propSetUtil.propSetForm.generalProp;
    var propSetUtil = propSetUtil;
    
    this.setGeneralPropValues = function()
    {
        var view = propSetUtil.view;
        ZDBUtil.setNamedChildEls(generalProp,generalProp,"propname",false);
        var title = propSetUtil.getPropValue(PropSettings.CHART_TITLE, PropSettings.STATIC_PROP, PropSettings.STRING_PROPTYPE);//No I18N
        if(title == null || title === '-NA-')
        {
            title = view.displayName;
        }
        generalProp[PropSettings.CHART_TITLE].value = title;
        var desc = propSetUtil.getPropValue(PropSettings.CHART_DESCRIPTION, PropSettings.STATIC_PROP, PropSettings.STRING_PROPTYPE);//No I18N
        if(desc == null)
        {
            desc = view.description;
        }
        generalProp[PropSettings.CHART_DESCRIPTION].value = desc;
        var graphSelected = propSetUtil.view.graphSelected ;
        if(graphSelected != "TABLE_CHART")
        {
            var dispPropHdr = propSetUtil.propSetForm.dispPropHdr;
            dispPropHdr.style.display="";
            var nullValComp = propSetUtil.propSetForm.nullValComp;
            nullValComp.style.display="";
            var defNullVal = propSetUtil.getPropValue(PropSettings.CHART_NULL_VALUE, PropSettings.STATIC_PROP, PropSettings.STRING_PROPTYPE);//No I18N
            if(defNullVal == null)
            {
                    defNullVal = view.dbNullVal ? view.dbNullVal : PropSettings.CHART_UNKNOWN_VALUE; 
            }
            generalProp[PropSettings.CHART_NULL_VALUE].value = defNullVal;
            if(view.isShowMissingValueAllowed)
	        {
    	    	this.showMissignValueCheckBox();
        	}
    		this.setMissValEl(generalProp[PropSettings.CHART_MISSING_VALUE]);
        }
        else
    	{
            var dispPropHdr = propSetUtil.propSetForm.dispPropHdr;
            dispPropHdr.style.display = "none";
            var nullValComp = propSetUtil.propSetForm.nullValComp;
            nullValComp.style.display = "none";
    	}
    }
    
    this.showMissignValueCheckBox = function()
    {
		//var showMissingValue = DOMUtils.getFirstMatchingChild(propSetUtil.propSetForm,"*","elname","showMissingValue");
		var showMissingValue = propSetUtil.propSetForm.showMissingValue;
		showMissingValue.style.display="";
    }

	this.setMissValEl = function(el)
	{
	    el.checked = false;
	    if(propSetUtil.getPropValue(PropSettings.CHART_MISSING_VALUE,  PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE))
	    {
	        el.checked = true;
	        ZDBGeneralProp.setMissingValue(el);
	    }
	}

    this.setPieItemLabelVal = function()
    {
        var propValue = propSetUtil.getPropValue(PropSettings.CHART_DEFAULT_ITEMLABEL_PROP,
                                        PropSettings.STATIC_PROP, PropSettings.DOUBLE_PROPTYPE);
        var pieItemLabel = propSetUtil.propSetForm.pieItemLabel;
        pieItemLabel.style.display = "";
        ZDBUtil.setNamedChildEls(pieItemLabel, pieItemLabel);
        if(!propValue)
        {
            ZDBGeneralProp.setDataLabelValues(pieItemLabel, false, true, "1");
        }
        else
        {
            propValue = parseInt(propValue);
            switch(propValue)
            {
                case 0:
                    ZDBGeneralProp.setDataLabelValues(pieItemLabel, false, false, "0");
                    break;
                case 1:
                    ZDBGeneralProp.setDataLabelValues(pieItemLabel, false, true, "1");
                    break;
                case 2:
                    ZDBGeneralProp.setDataLabelValues(pieItemLabel, true, false, "2");
                    break;
                case 3:
                    ZDBGeneralProp.setDataLabelValues(pieItemLabel, true, true, "3");
                    break;
            }
        }
    }
    
    this.setDataLabelFontDlg = function(propSetUtil)
    {
    	propSetUtil.fontPropObj = new ZDBFontProp(propSetUtil.propSetForm.generalProp, propSetUtil);
        propSetUtil.fontPropObj.initFontProp();
        var fontDlg = propSetUtil.propSetForm.DLFontDlg;
    	fontDlg.style.display = "";
    }
    

    this.setPackBubbleLabelVal = function()
    {
        var propValue = propSetUtil.getPropValue(PropSettings.PACKBUBBLE_DATALABEL_PROP,
                                        PropSettings.STATIC_PROP, PropSettings.DOUBLE_PROPTYPE);
        var packBubbleLbl = propSetUtil.propSetForm.packBubbleLbl;
        packBubbleLbl.style.display = "";
        ZDBUtil.setNamedChildEls(packBubbleLbl, packBubbleLbl);
        var val = propValue ? parseInt(propValue) : 1;
        packBubbleLbl.packLblVal.checked = (val === 1) ? true : false;
        packBubbleLbl.setAttribute("propValue", val);
    };
    
    this.setGeneralPropMap = function()
    {
        var view = propSetUtil.view;
        ZDBUtil.setNamedChildEls(generalProp, generalProp, "propname", false);
        this.noEmptyValueinPropMap(generalProp[PropSettings.CHART_TITLE], PropSettings.CHART_TITLE, view.title, view.displayName);
        propSetUtil.setPropMap(generalProp[PropSettings.CHART_DESCRIPTION], view.description);
        propSetUtil.setPropMap(propSetUtil.propSetForm.pieItemLabel,"1",true);
        propSetUtil.setPropMap(propSetUtil.propSetForm.packBubbleLbl,"1",true);
        var defNullVal = view.dbNullVal ? view.dbNullVal : PropSettings.CHART_UNKNOWN_VALUE;
        propSetUtil.setPropMap(generalProp[PropSettings.CHART_NULL_VALUE], defNullVal, true);
        propSetUtil.setPropMap(generalProp[PropSettings.CHART_MISSING_VALUE], "false", true);
        if(view.graphSelected === "PIE" && view.subGraphType === "FUNNEL")
        {
        	propSetUtil.funnelObj.setFunnelPropMap();
        }
        if(view.graphSelected === "PIE" || view.graphSelected == "BUBBLE" && view.subGraphType == "PACKEDBUBBLE")
        {
        	propSetUtil.setPropMap(generalProp[PropSettings.CHART_DATALABEL_FONT], new ZDBFontObject("Default", '' , '', 0), true); //NO I18n
        }
    }
    	
    this.noEmptyValueinPropMap = function(propEl, propName, initValue,displayName)
    {
        if(propEl.value !== '' && propEl.value!=displayName)
        {
            propSetUtil.setPropMap(propEl, initValue);
        }
        else
        {
            propSetUtil.deleteFromPropMap(propName);
        }
    }
    
    this.checkGeneralProp = function()
    {
        var titleEl = generalProp[PropSettings.CHART_TITLE];
        var descEl = generalProp[PropSettings.CHART_DESCRIPTION];
        var titleVal = titleEl.value;
        if(titleVal.length > ZDBConst.TITLE_MAX_LENGTH)
        {
            return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.genPropNav, titleEl, ZDBI18NMap.f("zrpt.common.analysis.settings.js.titleMaxLenExceedErr",ZDBConst.TITLE_MAX_LENGTH)); //No I18N
        }
        var descVal = descEl.value;
        if(descVal.length > ZDBConst.DESCRIPTION_MAX_LENGTH)
        {
            return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.genPropNav, descEl, ZDBI18NMap.f("zrpt.common.analysis.settings.js.descMaxLenExceedErr",ZDBConst.DESCRIPTION_MAX_LENGTH)); //No I18N
        }
        
        return true;
    }
    
    this.checkNullValueProp = function()
    {
    	var nullEl = generalProp[PropSettings.CHART_NULL_VALUE];
        var nullVal = nullEl.value;
        if(nullVal.length > ZDBConst.TITLE_MAX_LENGTH)
        {
            return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.genPropNav, nullEl, ZDBI18NMap.f("zrpt.common.analysis.settings.js.nullValMaxLenExceedErr",ZDBConst.TITLE_MAX_LENGTH)); //No I18N
        }
        else if(nullVal === '')
    	{
            return ZDBPropValidator.showErrorMsg(propSetUtil.propSetForm, propSetUtil.propSetForm.genPropNav, nullEl, ZDBI18NMap.g("zrpt.common.analysis.settings.js.noNullValErr"), true); //No I18N
    	}
        return true;
    }
    
    return this;
}

ZDBGeneralProp.setMissingValue = function(el)
	{
	    var propValue = el.checked;
	    el.setAttribute("propValue" , propValue+ "");
	}


ZDBGeneralProp.setDataLabelValues = function(pieItemLabel, value, percent, propVal)
{
    pieItemLabel.dataLblVal.checked = value;
    pieItemLabel.dataLblPercent.checked = percent;
    pieItemLabel.setAttribute("propValue", propVal);
}

ZDBGeneralProp.setPackBubbleValue = function(checkBox)
{
    var parentDiv = ZDBUtil.getParentWithAttributeValue(checkBox, "elname", "packBubbleLbl"); //No I18N
    ZDBUtil.setNamedChildEls(parentDiv, parentDiv);
    var propVal = checkBox.checked ? "1" : "0";
    parentDiv.setAttribute("propValue", propVal);
}

ZDBGeneralProp.setValue = function(checkBox)
{
    var parentDiv = ZDBUtil.getParentWithAttributeValue(checkBox, "elname", "pieItemLabel"); //No I18N
    ZDBUtil.setNamedChildEls(parentDiv, parentDiv);
    var propVal = "1";
    if(checkBox.checked)
    {
        propVal = parentDiv.dataLblPercent.checked ? "3" : "2";
    }
    else
    {
        propVal = parentDiv.dataLblPercent.checked ? "1" : "0";
    }
    parentDiv.setAttribute("propValue", propVal);
}

ZDBGeneralProp.setPercent = function(checkBox)
{
    var parentDiv = ZDBUtil.getParentWithAttributeValue(checkBox, "elname", "pieItemLabel"); //No I18N
    ZDBUtil.setNamedChildEls(parentDiv, parentDiv);
    var propSetUtil = ZDBClientUI.getViewObj(checkBox, "propSetUtil");
    var view = propSetUtil.view;
    var isFunnelChart = view.graphSelected === "PIE" && view.subGraphType === "FUNNEL"; //No I18N
    var propVal = "1";
    if(checkBox.checked)
    {
        propVal = parentDiv.dataLblVal.checked ? "3" : "1";
        if(isFunnelChart) 
        {
            parentDiv.conversionOpt.style.display = "";
            parentDiv.ZAPercLbl.innerHTML = ZDBI18NMap.g("zrpt.home.import.step2.js.percent") + ":";
        }
    }
    else
    {
        propVal = parentDiv.dataLblVal.checked ? "2" : "0";
        if(isFunnelChart) 
        {
            parentDiv.conversionOpt.style.display = "none";
            parentDiv.ZAPercLbl.innerHTML = ZDBI18NMap.g("zrpt.home.import.step2.js.percent");
        }
    }
    parentDiv.setAttribute("propValue", propVal);
}
