//$Id$
var ZDBAnalysisConfig = new function()
{

this.PARAMSTOTRANSFER = ["VCID","COLUMN_ID","OPERATION","FILTER_OPERATION","DTYPE","ADDONTYPE",//No I18N
                          "VIEWTYPE","CRITERIA","DISPLAYCRITERIA","EXCLUDE","NR","SUBTYPE",//No I18N
                          "LEGENDORDER","DYNCRIT","SHOWVALUEAS","BASEFIELD","BASEFIELDFN","BASEFIELDPOS","SHOWSUMMARY","SHOWROWSUMMARY", //No I18N
                          "FIELD_COL_TYPE" , "PARENT_OBJ_ID", "DBCOLNAME","CUSTOMBASEID","REFERREDTBLID","REFERREDCOLUMNID","REFCOLFUNCTION","REFCOLADDONTYPE","REFCOLSUBTYPE","RANGESIZE","INSTKEY","PREV","NEXT","NULLCB","CENTERCB","TYPEOFCALC","DISPCOLNAME","GEOROLE","ORIGDATATYPE","DEPGEOCOLID","SHOWTOTALASIDX","SHOWTOTALASTYPE","SHOWTOTALASFUNC","SHOWTOTALASFORMULA","SUBFUNC","LEVEL"];//No I18N
this.XMLPARAMSTOTRANSFER = ["cinst","cno","op","fop","dt","aot","vt","cr","dcr","ex","nr","st","lo","dyc","sva","bf","bff","bfp","ss","srs" //No I18N
	,"ft","po","dcn","custbaseid","reftblid","refcolid","refcolfun","refcolaot","refcolst","rs","inst","prev","next","includeNull","includeCenter","typeOfCalc","dspcolname","grl","odt","dgc","stid","stt","stfunc","stfor","subfunc","lvl"];//No I18N

this.CURLISTPARAMS = ["PVTCOLUMNNAME", "COMBOTYPE"];//No I18N
this.XMLCURLISTPARAMS = ["pcn", "ct"];//No I18N

this.LABELPARAMSTOTRANSFER = ["FORM_KEY","KEY","AXIS","DISPLAY","value","MODIFIED"];//No I18N
this.LABELXMLPARAMSTOTRANSFER = ["fk","k","x","disp","val","mod"];//No I18N

this.ANALGRIDPARAMS = ["SORTCRITERIA","SORTTYPE","COLSIZE"];//No I18N
this.ANALGRIDXMLPARAMS = ["sc","st","cs"];//No I18N

this.AXISPARAMS=["FORM_KEY","MINVAL","MAXVAL","INTERVAL"];//No I18N
this.AXISXMLPARAMS=["fk","min","max","iv"];//No I18N

this.LEGENDCRITERIAPARAMS = ["value","legId","origval","subtype","operation"]; //No I18N
this.LEGENDCRITERIAXMLPARAMS = ["dv","ikey","ov","st","op"]; //No I18N

this.VMFILTERPARAMS = ["COLUMN_ID","DISPLAYNAME","ADDONTYPE","OPERATION","EXCLUDE","SUBTYPE","NR","UITYPE","LABEL","ISALLVAL","POSITION","WIDTH","CRITERIA","DISPLAYCRITERIA","DEFAULTCRITERIA","DEFAULTDISPLAYCRITERIA","CUSTOMDATEFILTER","INCLUDETIME", "CASCADELIST", "FIELD_COL_TYPE" , "PARENT_OBJ_ID","DBCOLNAME","REL_OPERATION","REL_SUBTYPE","REL_NR","REL_CRITERIA","REL_DISPCRITERIA","ORIGCOLNAME"];//No I18N
this.VMFILTERXMLPARAMS = ["cno","dn","aot","op","ex","st","nr","uit","lbl","isall","pos","wdth","cr","dcr","defcr","defdcr","cdtfltr","it","cl","ft","po","dcn","rop","rst","rnr","rcr","rdcr","origcn"];//No I18N

this.ZRTLPARAMS = ["LABEL","VALUE","SELVALS","DISPLAY_SELVALS","NR","PREF_COLS","COL_ASSOSIDX","POSITION"];//No I18N
this.ZRTLXMLPARAMS = ["lbl","dvl","selval","dispselval","nr","pc","cai","position"];//No I18N


this.DASHBOARDUFCRPARAMS = ["DASHBOARDID","VIEWID","UFCOMPID","LABELNAME","EXCLUDE"];//No I18N
this.DASHBOARDUFCRXMLPARAMS = ["did","vid","ufcid","lbl","ex"];//No I18N

this.LEGENDCOLORPARAMS = ["INSTID","KEYVALUE","COLOR","SAVECOLOR"]; //No I18N
this.LEGENDCOLORXMLPARAMS = ["i","k","c","sc"];//No I18N

this.PVTCOLPARAMS=["CRITERIA","COLSIZE"];//No I18N
this.PVTCOLXMLPARAMS=["cr","cs"];//No I18N

this.CHARTPROPXMLPARAMS=["k","v"];//No I18N

this.DRILLPARAMS = ["CRITERIA", "LEVEL", "PATH"]; //No I18N
this.DRILLXMLPARAMS = ["cr", "lvl", "pth"]; //No I18N

this.CHARTDRILLPARAMS = ["FIELDID", "DRILLDOWN"]; //No I18N
this.CHARTDRILLXMLPARAMS = ["fid", "drl"]; //No I18N

this.CONDFORMATPARAMS = ["DATAVAL", "ROWVAL", "COLVAL"];	//NO I18N
this.CONDFORMATXMLPARAMS = ["dv", "rv", "cv"];	//NO I18N

this.CONDFORMATCRITPARAMS = ["CRITERIA", "INST"];	//NO I18N
this.CONDFORMATCRITXMLPARAMS = ["cr", "inst"];	//NO I18N

this.CONDLISTPARAMS = ["CONDITION", "FORMATVAL", "FONTDISP", "BGDISP", "TEXTALIGN", "KPI", "TEXTFUNC"]; //NO I18N
this.CONDLISTXMLPARAMS = ["cond", "fv", "ftd", "bgd", "ta", "kpi", "tf"];	//NO I18N
        
this.sendCompleteInfo = function(view)
{
   return (view.permissions.designModify == 1 && ZDBUtil.isViewModified(view)) || view.isUnpersistedView();
}

this.getCurrentConfig = function(view,sendVMFilterInfo,addDrillCr,DynDrill)
{
   return this.getConfig(view, this.sendCompleteInfo(view), sendVMFilterInfo, addDrillCr, DynDrill);
}

this.isVMFilterDivPresent = function(view)
{
    var VMFiltersList = view.VMFiltersList;
    return (VMFiltersList.length<=0)?false:true;
}
this.checkIfInstIdPresent = function(view)
{
    var sendCompleteInfo = false;
    var list = view.currentList;
    for(var i=0, j = list.length; i < j; i++)
    {
     if(list[i].getAttribute("SORTTYPE") || list[i].getAttribute("COLSIZE"))
      {
       var cinst= list[i].getAttribute("VCID");
       if(cinst=="")
        {
            sendCompleteInfo = true;
        }
      }
    }
    return sendCompleteInfo;
}
this.getConfig = function(view,sendCompleteInfo,sendVMFilterInfo,addDrillCr,DynDrill)
{
  var xmlBuf = new ZDBStrBuf();
  xmlBuf.sTag("zadata")//No I18N
        .attr("csrftoken",(getCookie("CSRF_TOKEN")));//No I18N
    if(ZDBClientUI.zoho_criteria)
    {
       xmlBuf.attr("zoho_criteria",ZDBClientUI.zoho_criteria);//No I18N
    }
    xmlBuf.a(">\n<dbobj ");//No I18N

//  if(ZDBUtil.isNewView(view))
//  {
  xmlBuf.attr(" dispname",view.displayName); // NO I18N
//  }
  var legendTitle = view.legendTitleValue != null ? view.legendTitleValue:"";
  var merge = view.graphSelected == "SAREA"?"true":view.merge;//No I18N
       xmlBuf.attr("desc",view.description)//No I18N
//        .attr(" dispname",view.displayName)
        .attr("type",view.type) //NO I18N
        .a("><zaav ")//No I18N
        .attr("gt",view.userGrpSel)//No I18N
        .attr("sgt",view.userSubGrpSel)//No I18N
        .attr("title",(view.title))//No I18N
        .attr("merge",merge)//No I18N
        .attr("lp",view.legendPos)//No I18N
        .attr("lt",(legendTitle))//No I18N
        .attr("ltm",view.legendTitleModified)//No I18N
        .attr("lf",view.legendFilterEnable)//No I18N
        .attr("cinfo",sendCompleteInfo)//No I18N
        .attr("rgs",view.rowGrandSummary)//No I18N
        .attr("cgs",view.colGrandSummary)//No I18N
        .attr("rst",view.rowSubTotal)//No I18N
        .attr("ast",view.colSubTotal)//No I18N
        .attr("jt",view.joinType) //No I18N
        .a(">");

  this.getViewColInstXML(view, xmlBuf,sendCompleteInfo);
  this.getXMLRowForDrillDown(view, xmlBuf, this.DRILLPARAMS, this.DRILLXMLPARAMS, "zadrl",DynDrill); //No I18N
  ZAFilterMenu.requestConstructor(view, xmlBuf,sendCompleteInfo);
  if(sendCompleteInfo)
  {
	  this.getXMLConfigForShowTotalAsFunc(view, xmlBuf);
      this.getXMLRowJS(view.legDetInfo,xmlBuf,
		this.LEGENDCOLORPARAMS,
		this.LEGENDCOLORXMLPARAMS,"zalm");//No I18N

      this.getXMLChartPropforPivot(view.chartProp,xmlBuf,
  	        this.CHARTPROPXMLPARAMS,"zacp");//No I18N

      if(view.gridObj)
      {
    	  var differentProps = view.gridObj.getModifiedThemeProps();
    	  if(differentProps)
    	  {
    		  this.getXMLChartPropforPivot(view.gridObj.themeProp,xmlBuf,
    				  this.CHARTPROPXMLPARAMS,"zatp");//No I18N
    	  }
      }
      
      this.getXMLRowForVMFilterConfig(view.VMFiltersList,xmlBuf,
                this.VMFILTERPARAMS,
                this.VMFILTERXMLPARAMS,"zavmf");//NO I18N

      this.getXMLRowForChartDrill(view, xmlBuf,
                this.CHARTDRILLPARAMS,
                this.CHARTDRILLXMLPARAMS, "zadl"); //No I18N
      this.getXMLRowForCondFormat(view, xmlBuf, this.CONDFORMATPARAMS, this.CONDFORMATXMLPARAMS, "zacondf");	//NO I18N
      if(view.propSet)
      {
    	  this.getPropsXMLRow(view,xmlBuf,"propc"); //No I18N  
      }
 }

if(ZDBAnalysisConfig.isViewConfigModified(view)){
    this.validateZAPvtCriteria(view);
    this.getXMLRowJS(view.pvCritPropInfo,xmlBuf,
		         this.PVTCOLPARAMS,
			 this.PVTCOLXMLPARAMS,"pvp");//No I18N
                         }

  if(view.chartObj && view.chartObj.getLegendModel())
  {
    this.getLegendNVMFCr(view,xmlBuf);
  }
  if(sendVMFilterInfo)
  {
	ZAVMFilter.getAllVMFilterCriteria(view,xmlBuf);
  }
  xmlBuf.eNTag("zaav");//No I18N
  if(view.folderId > 0)
  {
      xmlBuf.sTag("zfv")//No I18N
          .attr("fno",view.folderId)//No I18N
          .eTag();
  }
  xmlBuf.eNTag("dbobj")//No I18N
        .eNTag("zadata");//No I18N

  return xmlBuf.toString();
}

this.getLegendNVMFCr = function(view,xmlBuf)
{
	var legendCritInfo = view.legendCritInfo;
	if(legendCritInfo && legendCritInfo.length > 0)
	{
		 for(var i =0; i < legendCritInfo.length; i++)
		 {
			this.getRowJS(legendCritInfo[i],xmlBuf,
			         this.LEGENDCRITERIAPARAMS,
					 this.LEGENDCRITERIAXMLPARAMS,"zclc");//No I18N
		 }
	}
    
}

this.validateZAPvtCriteria = function(view)
{
    var zaPVTColEls = view.pvCritPropInfo;
    if(!zaPVTColEls || zaPVTColEls.length <= 0)
    {
        return;
    }
    var currentList = view.currentList;
    var instIdList = {};
    var xAxisList = ZDBUtil.getElementsWithAttribute(currentList, "viewType", "XAXIS"); //No I18N
    var textAxisList = ZDBUtil.getElementsWithAttribute(currentList, "viewType", "TEXTAXIS"); //No I18N
    for(var i=0, j=xAxisList.length; i<j; i++)
    {
        var instKey = xAxisList[i].getAttribute("INSTKEY");
        instIdList[instKey] = {};
    }
    for(var i=0, j=textAxisList.length; i<j; i++)
    {
        var instKey = textAxisList[i].getAttribute("INSTKEY");
        instIdList[instKey] = {};
    }
    var newPVTCols = [];
    for(var i1=0; i1 < zaPVTColEls.length; i1++)
    {
    	if(zaPVTColEls[i1])
		{
	        var criteria = zaPVTColEls[i1]["CRITERIA"];
	        var validCr = this.splitCriteriaAndValidate(criteria, instIdList);
	        if(validCr)
	        {
	            newPVTCols[newPVTCols.length] = zaPVTColEls[i1];
	        }
		}
    }
    delete zaPVTColEls;
    view.zaPVTColEls = newPVTCols;
}

this.splitCriteriaAndValidate = function(criteria, instIdList)
{
    var PPAT = "-P-"; //No I18N
    var NPAT = "-N-"; //No I18N
    var colData = criteria.split(PPAT);
    var validCr = true;
    for(var j=0, len=colData.length; j<len; j++)
    {
        if(j === 0)
        {
            if(!instIdList[colData[j]] && colData[j] != "-NA-")
            {
                validCr = false;
                break;
            }
        }
        else if(j+1 === len)
        {
            var strLen = colData[j].indexOf(NPAT) === -1 ? colData[j].length : colData[j].indexOf(NPAT);
            var value = colData[j].substring(0, strLen);
            if(this.checkInstKeyInVal(value, instIdList))
            {
                validCr = false;
                break;
            }
        }
        else
        {
            var arr = colData[j].split(NPAT);
            if(!instIdList[arr[1]])
            {
                validCr = false;
                break;
            }
            if(this.checkInstKeyInVal(arr[0], instIdList))
            {
                validCr = false;
                break;
            }
        }
    }
    return validCr;
}

this.checkInstKeyInVal = function(value, instIdList)
{
    if(value.indexOf("-V-") !== -1)
    {
        value = value.substr("-V-".length, value.length); //No I18N
        if(!instIdList[value])//hasV
        {
            return true;
        }
    }
    return false;
}

this.getViewColInstXML = function(view,xmlBuf,sendCompleteInfo)
{
    var list = view.currentList;
    var listProp = view.curListProp;
    var params = this.PARAMSTOTRANSFER;
    var xmlParams = this.XMLPARAMSTOTRANSFER;
    //  view.relDateFilter = false;
    for(var i=0, j = list.length; i < j; i++)
    {
        if(list[i] == null)
        {
            continue;
        }

        if(sendCompleteInfo)
        {
        xmlBuf.sTag(list[i].getAttribute("XMLTAGNAME"))
            .attr("cid",i+1);//No I18N
        for(var k = 0,l = params.length; k < l; k++)
        {
            if(list[i].getAttribute(params[k]))
            {
                xmlBuf.attr(xmlParams[k] ,list[i].getAttribute(params[k]));
            }
        }
        var instKey = list[i].getAttribute('instkey');
        if(listProp)
    	{
        	var addProps = listProp[instKey];
            if(addProps)
            {
              for(var propName in addProps)
              {
            	  var index = this.CURLISTPARAMS.indexOf(propName);
            	  if(index > -1)
        		  {
            		  xmlBuf.attr(this.XMLCURLISTPARAMS[index],addProps[propName]);
        		  }            	  
              }
            }
    	}
        xmlBuf.a('>\n');//NO I18N
            xmlBuf.a(ZACF.getXMLFromInst(view,instKey));
        xmlBuf.eNTag(list[i].getAttribute("XMLTAGNAME"));
        }
    }
    for(i=0, j = list.length; i < j; i++)
    {
        if(list[i] == null)
        {
            continue;
        }
        var sortType = list[i].getAttribute("SORTTYPE");
        var sortAllowed = (sortType!=null)?(sortType==="")?false:true:false;
        if(sortAllowed || list[i].getAttribute("COLSIZE"))
        {
           if(ZDBAnalysisConfig.isViewConfigModified(view))
           {
        	   var instkey = list[i].getAttribute("instkey");
            this.getRow(list[i],xmlBuf,this.ANALGRIDPARAMS,this.ANALGRIDXMLPARAMS,"zavcip",{"inst":instkey});//No I18N
            }
        }
    }
    if(sendCompleteInfo) 
    {
    	xmlBuf.a(ZACF.getXMLFromInst(view,view.zacf.getMergeAxisKey()));
    }
}

this.getKey= function(fields,isShowValueAs)
{
    var value = fields.getAttribute("column_id") + "," + fields.getAttribute("operation") + "," + fields.getAttribute("viewtype");
    if(isShowValueAs)
    {
      value = value + "," + fields.getAttribute("showvalueas");
    }
    return value;
}
this.getXMLRow = function(curDiv,xmlBuf,params,xmlParams,tagName)
{
  if(curDiv!=null)
  {
    ZDBUtil.removeNonElements(curDiv);
    var elements = curDiv.getElementsByTagName("div");
    for(var i=0; i<elements.length; i++)
    {
      this.getRow(elements[i],xmlBuf,params,xmlParams,tagName);
    }
  }
}

this.getXMLRowJS = function(curEls, xmlBuf, params, xmlParams, tagName)
{
	if(curEls != null)
	{
		for(var i =0; i<curEls.length; i++)
		{
			var curEl = curEls[i];
			if(curEl)
			{
				this.getRowJS(curEl, xmlBuf, params, xmlParams, tagName);
			}
		}
	}
}

this.getXMLRowForDrillDown = function(view, xmlBuf, params, xmlParams, tagName,DynDrill)
{
    if(view.zrsDrillObj && view.zrsDrillObj.drillLevel > 0)
    {
        
        if(DynDrill)
        {
          var drillInfo = [ null,view.zrsDrillObj.drillLevel , view.drillDet.critInfo];
        }
        else
        {
        	var drillInfo = [view.zrsDrillObj.criteria, view.zrsDrillObj.drillLevel, view.drillDet.critInfo];
        }
        xmlBuf.sTag(tagName);
        for(var i=0; i < params.length; i++) {
            xmlBuf.attr(xmlParams[i], drillInfo[i]);
        }
        
        if(view.nxtdrillChartColour !== null && view.nxtdrillChartColour !== undefined)
        {
           xmlBuf.attr("nxtdrillChartColour",view.nxtdrillChartColour); //NO I18N
        }
        
        if(view.zrsDrillObj.extraParams != null)
        {
        	for (var k in view.zrsDrillObj.extraParams) {
        		if (view.zrsDrillObj.extraParams.hasOwnProperty(k)) {
        			xmlBuf.attr(k, view.zrsDrillObj.extraParams[k]);
        		}
        	}
       	}
        
        xmlBuf.eTag();
    }
}

this.getXMLConfigForShowTotalAsFunc = function(view, xmlBuf)
{
	if(!view.showTotalAs)
	{
		return;
	}
	var showTotalAsFuncs = view.showTotalAs;
	var tagName = "zatotalas";//NO I18N
	xmlBuf.a("\n");//NO I18N
	xmlBuf.sTag(tagName);
	xmlBuf.a(">\n");//NO I18N
	for(var j=0;j<Object.keys(showTotalAsFuncs).length;j++)
	{
		var tag = "zavcitotalfunc";//NO I18N
		var instKey = Object.keys(showTotalAsFuncs)[j];
		var oper = showTotalAsFuncs[instKey];
		if(oper != null)
		{
			xmlBuf.sTag(tag);
			xmlBuf.attr("instkey",instKey);//NO I18N
			xmlBuf.attr("oper",oper);//NO I18N
			xmlBuf.attr("type","0");//NO I18N
			xmlBuf.a(">\n");//NO I18N
			xmlBuf.eNTag(tag);
		}
	}
	xmlBuf.eNTag(tagName);
}

this.getXMLRowForCondFormat = function(view, xmlBuf, params, xmlParams, tagName)
{
	if(!view.condFormat)
	{
		return;
	}
	var condFormatRules = !view.condFormat.condFormatRules ? view.condFormat.setCondFormatRules() : view.condFormat.condFormatRules;
	if(condFormatRules!=null)
	{
		for(var j=0;j<Object.keys(condFormatRules).length;j++)
		{
			var rule = condFormatRules[j];
			if(!rule)
			{
				continue;
			}
			var data = rule.getAllVals();
			var condList = data[params.length];
			if(condList.length <=0)
			{
				continue;
			}
			xmlBuf.sTag(tagName);
			for(var i=0;i<params.length; i++)
			{
				if(!data[i])	data[i]="null";
				xmlBuf.attr(xmlParams[i], data[i]);
			}
			xmlBuf.a(">\n");	//NO I18N
			
			//Send criteria details here
			//this.getXMLRowForCondFormatCrit(crit, xmlBuf, this.CONDFORMATCRITPARAMS, this.CONDFORMATCRITXMLPARAMS, "zacondcr");	//for the time being crit is col inst
			
			
			for(var i=0;i<condList.length; i++)
			{
				var cond = condList[i];
				this.getXMLRowForCondList(cond, xmlBuf, this.CONDLISTPARAMS, this.CONDLISTXMLPARAMS, "zacond");	//NO I18N
			}
			xmlBuf.eNTag(tagName);
		}
	}
}

//this.getXMLRowForCondFormatCrit = function(crit, xmlBuf, params, xmlParams, tagName)
//{
//	xmlBuf.sTag(tagName);
//	var data = ["Central", crit];	//temporary hack
//	for(var i=0;i<params.length; i++)
//	{
//		xmlBuf.attr(xmlParams[i], data[i]);
//	}
//	xmlBuf.eTag();
//}

this.getXMLRowForCondList = function(condList, xmlBuf, params, xmlParams, tagName)
{
	if(condList!=null)
	{
		xmlBuf.sTag(tagName);
		for(var i=0;i<params.length;i++)
		{
			if(condList[i] == null || condList[i] == undefined)
			{
				condList[i] = null;
			}
			if(condList[i] instanceof Object)
			{
				condList[i] = JSON.stringify(condList[i]);
			}
			xmlBuf.attr(xmlParams[i], condList[i]);
		}
		xmlBuf.eTag();
	}
}

this.getXMLRowForChartDrill = function(view, xmlBuf, params, xmlParams, tagName)
{
    if(view.drillArrInfo)
    {
        var len = view.drillArrInfo.length;
        for(var i=0; i<len; i++)
        {
            var drillInfo = view.drillArrInfo[i];
            xmlBuf.sTag(tagName);
            for(var j=0; j < params.length; j++) {
                xmlBuf.attr(xmlParams[j], drillInfo[j]);
            }
            xmlBuf.eTag();
        }
    }
};

this.getXMLChartPropforPivot = function(chartProp,xmlBuf,xmlParams,tagName)
{
  if(chartProp!=null)
  {
     this.getPivotXMLChartPropRow(chartProp,xmlBuf,xmlParams,tagName);
  }
}

this.getXMLRowForVMFilterConfig = function(VMFiltersList,xmlBuf,params,xmlParams,tagName)
{
  var len = VMFiltersList.length;
  if(len > 0)
  {
    for(var i=0; i<len; i++)
    {
      ZDBAnalysisConfig.getRow(VMFiltersList[i],xmlBuf,params,xmlParams,tagName);
    }
  }
}

this.getPropsXMLRow = function(view,xmlBuf,tagName)
{
    var propTypes = ZDBAnalysisConfig.propTypes; // [tagName] - [XMLnames] map from server side
    var propSet = view.propSet;
    xmlBuf.a("<"+tagName+">");
    for(var propName in propSet)
    {
        for(var instId in propSet[propName])
        {
            for(var propType in propSet[propName][instId])
            {
                var xmlNames = propTypes[propType];
                if(xmlNames)
                {
                    var propValue = propSet[propName][instId][propType];
                    if(propType === PropSettings.MULTIVAL_PROPTYPE && propValue instanceof Array)
                    {
                        for(var i = 0; i < propValue.length; i++)
                        {
                            this.getPropRow(xmlBuf, xmlNames, propName, instId, propType, propValue[i]);
                        }
                    }
                    else
                    {
                        this.getPropRow(xmlBuf, xmlNames, propName, instId, propType, propValue);
                    }
                }
            }
        }
    }
    xmlBuf.a("</"+tagName+">");
}

this.getPropRow = function(xmlBuf, xmlNames, propName, instId, propType, propValue)
{
	xmlBuf.sTag(propType);
	xmlBuf.attr(xmlNames[0], instId);
	xmlBuf.attr(xmlNames[1], propName);
	if(propValue instanceof Array)
	{
		for(var i = 2, j=0 ; j<propValue.length; i++, j++)
		{
			xmlBuf.attr(xmlNames[i], propValue[j]);
		}
	}
	else
	{
		xmlBuf.attr(xmlNames[2], propValue);
	}
	xmlBuf.eTag();
}

this.getRow = function(curElement,xmlBuf,params,xmlParams,tagName,addProps)
{
  xmlBuf.sTag(tagName);
  for(var k=0; k < params.length; k++)
  {
    var val= curElement.getAttribute(params[k]);
    if(val != null)
    {
      xmlBuf.attr(xmlParams[k],val);
    }
  }
  if(addProps != null)
  {
    for(var propName in addProps)
    {
       xmlBuf.attr(propName,addProps[propName]);
    }
  }
  xmlBuf.eTag();
}

this.getRowJS = function(curElement,xmlBuf,params,xmlParams,tagName,addProps)
{
  xmlBuf.sTag(tagName);
  for(var k=0; k < params.length; k++)
  {
    var val= curElement[params[k]];
    if(val != null)
    {
      xmlBuf.attr(xmlParams[k],val);
    }
  }
  if(addProps != null)
  {
    for(var propName in addProps)
    {
       xmlBuf.attr(propName,addProps[propName]);
    }
  }
  xmlBuf.eTag();
}

this.getPivotXMLChartPropRow = function(chartProp,xmlBuf,xmlParams,tagName)
{
  for(var key in chartProp)
  {
      var value = ZDBEscapeUtil.encodeForXML(chartProp[key]);
      xmlBuf.buf.push("<"+tagName+ " " + xmlParams[0] + "='"+key+"' "+ xmlParams[1] +"='"+value+"'></"+tagName+">");//No I18N
  }
}

this.isViewConfigModified = function(view)
{
    var adminMod = (view.permissions.designModify == 1 && ZDBUtil.isViewModified(view));
    var sharedMod = (view.permissions.designModify == 0 && view.confModified);
    var standAlone = (ZDBClientUI.standAlone && view.confModified);
    var isVMFilterMod = view.IsVMFilterApplied;
    var legFilterMod = (view.legendCritInfo && view.legendCritInfo.length > 0);
    var viewMod = (adminMod || sharedMod || isVMFilterMod || legFilterMod || standAlone);
    return viewMod;
    // if anyone is modified, then View is modified
}


}
