//$Id$
function SettingsObj(view)
{
	var settingsEl = ZDBUtil.getCloneNode($("ZDBSettings"));
	var view = view;
	
	this.getSettingsEl = function()
	{
		return settingsEl;
	}
	
    this.showDialog = function(el)
    {
		ZDBUtil.setNamedChildEls(settingsEl, settingsEl);
        var settingsTab = settingsEl.ZDBGenProp; //$("ChartSettings");
        if(settingsTab == "null")
        {
          return;
        }
        settingsEl.closeDialog = settings.closeDialog;
        settingsEl.style.display="block";
        var helpLink = ((view.typeValue == ZDBClientViewAPI.TYPE_PIVOT) && !ZDBClientUI.isCustomDomain) ? ZDBI18NMap.g("zrpt.common.analysis.settings.js.help.pivottable") : "" ; //No I18N        
        settingsEl.ZDBGenProp.focusEl = settingsEl.frmTitle;
        ZDBInlineDialog.showDialog(settingsEl, { //inline showDialog method is called
            VIEW:view,
            TITLE: ZDBI18NMap.g("zrpt.common.analysis.settings.js.dlgTtl"),
            HELP: helpLink
        });

        this.configSettings();
        	ZDBUtil.setNamedChildEls(settingsEl, settingsEl);
        	jQuery("#ZAPivotNav").find("div").click(function(){ZDBInlineDialog.changeTab(this, 'ZAsettingsHolder');});//No I18N
        	ZACF.appendZACFOptions(view, settingsEl);
                if(settings.viewContainsAbsWeek(view) && view.typeValue != ZDBClientViewAPI.TYPE_SUMMARY)
                {
                    ZDBAxisProp.setWeekYearFormatEl(settingsEl.weekYearFormat,view.propSetUtil);
                }
            ZDBInlineDialog.changeTab(settingsEl.ZACondFormatMainTab, settingsEl.settingsHolder);
            ZACondFormUtil.populateMenu(view, settingsEl.ZACondFormat, settingsEl);
            ZDBInlineDialog.changeTab(settingsEl.ZDBGenProp, settingsEl.settingsHolder);

        }
	
	this.configSettings = function()
    {
        var graphSelected = view.graphSelected;
        if(ZDBGlobal.integrated)
        {
            if((graphSelected == "TABLE_CHART") || (graphSelected == "WEB" && view.legendType))
            {
                return null;
            }
        }

        settingsEl.frmTitle.value = view.title ? (view.title=="" ? view.displayName : view.title) : view.displayName;	//$("frmTitle")
        settingsEl.frmDescription.value = view.description ? view.description : "";	//$("frmDescription")
        settingsEl.hideRId.checked = (view.chartProp && view.chartProp.zr_hide_row_id) ? view.chartProp.zr_hide_row_id : false;	//$("hideRId")
        settingsEl.wrapColHead.checked = (view.chartProp && view.chartProp.zr_wrap_colHead) ? view.chartProp.zr_wrap_colHead : false;
        settingsEl.grpLblRpt.checked = (view.chartProp && view.chartProp.zr_show_grpLblRpt) ? view.chartProp.zr_show_grpLblRpt : false;	//$("grpLblRpt")
//        $("zrTheme").value = (view.chartProp && view.chartProp.zr_Theme) ? view.chartProp.zr_Theme : "default"; //No I18N
        settings.addShowMissingValColumns(settingsEl);
        var defNullVal = (view.dbNullVal ? view.dbNullVal : (view.typeValue === ZDBClientViewAPI.TYPE_PIVOT ? "-No Value-" : "")); //No I18N
        settingsEl.nullValDefEl.value = (view.chartProp && view.chartProp.zr_null_value) ? view.chartProp.zr_null_value :	//$("nullValDefEl") 
        					view.chartProp.zr_null_value !== "" ? defNullVal : view.chartProp.zr_null_value;
        var isColWidth = (view.chartProp && view.chartProp.zr_uni_col_width) ? true : false;
        var defColWidthEl = settingsEl.defColWidthEl; //$("defColWidthEl");
        settingsEl.resizeColWidId.checked = false;	//$("resizeColWidId")
        if(isColWidth)
        {
            //defColWidthEl.value = view.chartProp.zr_uni_col_width;
        	defColWidthEl.value = view.gridObj.defColWidth;
            defColWidthEl.removeAttribute("disabled");
        }
        else
        {
            defColWidthEl.value = ZDBGlobal.stdCellWidth;
            defColWidthEl.setAttribute("disabled", !isColWidth);
        }
        var colWidId = settingsEl.colWidId;	//$("colWidId");
        colWidId.checked = isColWidth;
        ZDBAnalysisEditViewMode.toggleUniColWidthOpt(colWidId);
        var defaultTab = (ZDBGlobal.integrated) ? defaultTab : settingsEl.ZDBGenProp;	//$("ChartSettings") ;
        return defaultTab;
    }
}

var settings = new function()
{
    this.showDialog = function(el)
    {
    	view = ZDBClientUI.getViewObj(el,"view");
        if(ZDBGlobal.ISNEWLAYOUT && view.type == "AnalysisView") {
            PropSettings.showDialog(el, view);
            return;
        }
        view.settingsObj = new SettingsObj(view);//ZDBUtil.getCloneNode($("ZDBSettings"));
        settings.currentViewObj = view;
        view.settingsObj.showDialog(el);
    }

    this.closeDialog = function(dlgEl)
    {
        var dynamicFieldsTBL = document.getElementById("dynamicFieldsTBL");
        settings.removeAllChilds(dynamicFieldsTBL);
        return true;
    }
    
    this.switchTabs = function(el, event) 
    {
    	var srcEl = ZDBUtil.getSourceElement(event);
        var className = srcEl.getAttribute('className');
        if(!className) {
            return;
        }
        hideCustomMessage();
        var toSet = DOMUtils.getSelfOrParentWithAttrValue(srcEl, "elname", "settingsHolder");//NO I18N
        toSet.setAttribute('class',className);
    }
    
	this.addShowMissingValColumns = function(dlg)
    {
    	var view = ZDBClientUI.selectedTab.view;
		dlg.pvtShowMissingValue.style.display="none";
		if(view.isShowMissingValueAllowed == true && (view.allowedMissValColInXAxis.length>0 || view.allowedMissValColInYAxis.length>0))
		{
			dlg.pvtShowMissingValue.style.display="";
			dlg.pvtShowMissingValueForXAxis.style.display="none";
			if(view.allowedMissValColInXAxis.length>0)
			{
				dlg.pvtShowMissingValueForXAxis.style.display="";
				dlg.displayChooseColsForXAxis.style.display="none";
				dlg.displayPvtSmvForXAxis.style.display="none";
				var xAxisList = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","XAXIS");// NO I18N
				settings.addShowMissValColDiv(dlg.missValColInputForCols,dlg.missValPivotModelForCols,view.allowedMissValColInXAxis,xAxisList,"XAXIS");// No I18N
			}
			dlg.pvtShowMissingValueForYAxis.style.display="none";
			if(view.allowedMissValColInYAxis.length>0)
			{
				dlg.pvtShowMissingValueForYAxis.style.display="";
				dlg.displayChooseColsForYAxis.style.display="none";
				dlg.displayPvtSmvForYAxis.style.display="none";
				var yAxisList = ZDBUtil.getElementsWithAttribute(view.currentList, "viewType","YAXIS");// NO I18N
				settings.addShowMissValColDiv(dlg.missValColInputForRows,dlg.missValPivotModelForRows,view.allowedMissValColInYAxis,yAxisList,"YAXIS");// NO I18N
			}
		}
    }
    
    this.addShowMissValColDiv = function(missVal,missValPivotModel,allowedMissValCol,axisList,axisType)
	{
		//ZDBUtil.setNamedChildEls(dlg,dlg,"elname");
		var view = ZDBClientUI.selectedTab.view;
		missVal.innerHTML="";
		missVal.style.height = "0px";
		var boxHeight = Math.ceil(allowedMissValCol.length/2)*30;
		if(boxHeight>90)
		{
			boxHeight=90;
		}
		missVal.style.height = boxHeight+"px";
		for(var i=0;i<allowedMissValCol.length;i++)
		{
			for(var j=0;j<axisList.length;j++)
			{
				var allowedMissValOrgKey = ZDBAnalysisView.replaceInstKey(view,allowedMissValCol[i]);
				if(allowedMissValOrgKey == axisList[j].getAttribute("instkey"))
				{
					var name=axisList[j].fieldName.textContent;
					if(axisList[j].getAttribute("addontype")=="ABSDATECATEGORICAL")
					{
						name+="("+axisList[j].operation.textContent+")";
					}
					missVal.innerHTML+="<span class=\"showMissValElements\"><input style=\"float:left;margin-left:8px;\" type=\"checkbox\" onclick=\"settings.markCommonCheckBox(this);\" axistype=\""+axisType+"\" elname=\""+axisType+"missValColInst"+allowedMissValCol[i]+"\" instId=\""+axisList[j].getAttribute("column_id")+"_"+axisList[j].getAttribute("operation")+"_"+axisType+"\" propValue=\"false\" propType=\"zdbs\" propName=\""+PropSettings.CHART_MISSING_VALUE+"\"><span class=\"showMissValText\" tip=\""+ZDBEscapeUtil.escSplCharAsHTMLWithSpaceEncode(name)+"\" onmousemove=\"ZDBToolTip.checkLengthAndShow(this);\" onmouseout=\"ZDBToolTip.hide(this,event);\"><span axistype=\""+axisType+"\" checkBoxElName=\""+axisType+"missValColInst"+allowedMissValCol[i]+"\" onclick=\"settings.markCheckBoxFromLabel(this);\" style=\"cursor:pointer;\">"+ZDBEscapeUtil.encodeForHtml(name)+"</span></span></span>";
					continue;
				}
			}
		}
		settings.setMissValEl(view,missVal,missValPivotModel,axisType);
	}
    
    this.setMissValEl = function(view,missValParDiv,missValPivotModel,axisType)
    {
    	var modelName;
    	if(axisType == "XAXIS")
    	{
    		modelName = PropSettings.PVT_MISSING_VALUE_HIERARCHICAL_MODEL_XAXIS;
    	}
    	else if(axisType == "YAXIS")
    	{
    		modelName = PropSettings.PVT_MISSING_VALUE_HIERARCHICAL_MODEL_YAXIS;
    	}
    	missValPivotModel.checked = false;
        if(view.propSetUtil.getPropValue(modelName , PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE))
        {
        	missValPivotModel.checked = true;
            ZDBAnalysisEditViewMode.setMissingValue(view,missValPivotModel,true,modelName);
        }
    	var inputTags = missValParDiv.getElementsByTagName("input");
	  	for(var i=0;i<inputTags.length; i++)
	  	{
	  		var missValEl = inputTags[i];
	  		missValEl.checked = false;
	        if(view.propSetUtil.getPropValue(PropSettings.CHART_MISSING_VALUE, missValEl.getAttribute("instId") ,PropSettings.STRING_PROPTYPE))
	        {
	        	missValEl.checked = true;
	            ZDBAnalysisEditViewMode.setMissingValue(view,missValEl,false,null);
	        }
	  	}
	  	settings.markCommonCheckBox(inputTags[0]);
    }

    this.markCommonCheckBox = function(element)
    {
    	var settingsEl = ZDBUtil.getParentWithAttributeValue(element, "elname", "pvtShowMissingValue");//NO I18N
    	ZDBUtil.setNamedChildEls(settingsEl, settingsEl);
    	var missValColList,commonCkeckBoxEl,chooseColumnsEl,pvtMissValColListBox;
    	if(element.getAttribute('axistype') == "XAXIS")
    	{
    		missValColList = settingsEl.missValColInputForCols;
    		commonCkeckBoxEl = settingsEl.commonMissValColForXAxis;
    		chooseColumnsEl = settingsEl.displayChooseColsForXAxis;
    		pvtMissValColListBox = settingsEl.displayPvtSmvForXAxis;
    	}
    	else if(element.getAttribute('axistype') == "YAXIS")
    	{
    		missValColList = settingsEl.missValColInputForRows;
    		commonCkeckBoxEl = settingsEl.commonMissValColForYAxis;
    		chooseColumnsEl = settingsEl.displayChooseColsForYAxis;
    		pvtMissValColListBox = settingsEl.displayPvtSmvForYAxis;
        }
    	var value = false;
    	var inputTags = missValColList.getElementsByTagName("input");
		for(var i=0;i<inputTags.length; i++)
		{
			var missValEl = inputTags[i];
			if(missValEl.checked == true)
			{
				value=true;
				break;
			}
		}
		commonCkeckBoxEl.checked = value;
		if(value)
		{
			chooseColumnsEl.style.display = "";
		}
		else
		{
			chooseColumnsEl.style.display = "none";
    		jQuery(pvtMissValColListBox).slideUp("slow","linear");//NO I18N
		}
    }
    
    this.markCheckBoxFromLabel = function(element)
    {
    	var settingsEl = ZDBUtil.getParentWithAttributeValue(element, "elname", "pvtShowMissingValue");//NO I18N
    	ZDBUtil.setNamedChildEls(settingsEl, settingsEl);
    	var missValColList;
    	if(element.getAttribute('axistype') == "XAXIS")
    	{
    		missValColList = settingsEl.missValColInputForCols;
    	}
    	else if(element.getAttribute('axistype') == "YAXIS")
    	{
    		missValColList = settingsEl.missValColInputForRows;
    	}
    	var elname = element.getAttribute("checkBoxElName");
    	var checkBox = DOMUtils.getFirstMatchingChild(missValColList,'*','elname',elname);
    	checkBox.checked = checkBox.checked ^ true;
    	settings.markCommonCheckBox(checkBox);
    }
    
    this.displayMissValBox = function(element)
    {
    	var settingsEl = ZDBUtil.getParentWithAttributeValue(element, "elname", "pvtShowMissingValue");//NO I18N
    	ZDBUtil.setNamedChildEls(settingsEl, settingsEl);
    	
    	if(element.getAttribute('axistype') == "XAXIS")
    	{
    		jQuery(settingsEl.displayPvtSmvForXAxis).slideToggle("slow","linear");//NO I18N
    		jQuery(settingsEl.displayPvtSmvForYAxis).slideUp("slow","linear");//NO I18N
//    		if(settingsEl.displayPvtSmvForXAxis.style.display == "none")
//    		{
//    			settingsEl.displayPvtSmvForXAxis.style.display = "inline-block";//NO I18N
//    		}
//    		else
//    		{
//    			settingsEl.displayPvtSmvForXAxis.style.display = "none";
//    		}
//    		settingsEl.displayPvtSmvForYAxis.style.display="none";
    	}
    	else if(element.getAttribute('axistype') == "YAXIS")
    	{
    		jQuery(settingsEl.displayPvtSmvForYAxis).slideToggle("slow","linear");//NO I18N
    		jQuery(settingsEl.displayPvtSmvForXAxis).slideUp("slow","linear");//NO I18N
//    		if(settingsEl.displayPvtSmvForYAxis.style.display == "none")
//    		{
//    			settingsEl.displayPvtSmvForYAxis.style.display = "inline-block";
//    		}
//    		else
//    		{
//    			settingsEl.displayPvtSmvForYAxis.style.display = "none";
//    		}
//    		settingsEl.displayPvtSmvForXAxis.style.display="none";
    	}
    }
    
    this.markAllMissValCol = function(element)
    {
    	var settingsEl = ZDBUtil.getParentWithAttributeValue(element, "elname", "pvtShowMissingValue");//NO I18N
    	ZDBUtil.setNamedChildEls(settingsEl, settingsEl);
    	var axistype = element.getAttribute('axistype');
    	var value = element.checked;
    	var missValColList,hierarchyEl,chooseColumnsEl,displayPvtSmvCols;
    	if(axistype == "XAXIS")
    	{
    		missValColList = settingsEl.missValColInputForCols;
    		hierarchyEl = settingsEl.missValPivotModelForCols;
    		chooseColumnsEl = settingsEl.displayChooseColsForXAxis;
    		displayPvtSmvCols = settingsEl.displayPvtSmvForXAxis;
    	}
    	else if(axistype == "YAXIS")
    	{
    		missValColList = settingsEl.missValColInputForRows;
    		hierarchyEl = settingsEl.missValPivotModelForRows; 
    		chooseColumnsEl = settingsEl.displayChooseColsForYAxis;
    		displayPvtSmvCols = settingsEl.displayPvtSmvForYAxis;
    	}
    	var inputTags = missValColList.getElementsByTagName("input");
		for(var i=0;i<inputTags.length; i++)
		{
			var missValEl = inputTags[i];
			missValEl.checked = value;
		}
		if(value)
		{
			chooseColumnsEl.style.display="";
		}
		else
		{
			jQuery(displayPvtSmvCols).slideUp("slow","linear");//NO I18N
			chooseColumnsEl.style.display="none";
    		//hierarchyEl.checked=value;
		}
    }

    this.setChkBoxValue = function(el)
    {
        el.value = (el.checked) ? "true" : "false";
    }

    this.viewContainsAbsWeek = function(view)
    {
        return settings.isAxisContainsAbsWeek(view)|| settings.isFilterContainsAbsWeek(view) || settings.isVMFilterContainsAbsWeek(view) ;
    }
    
    this.isAxisContainsAbsWeek = function(view)
    {
        var axisFlds = view.graphFields;
        var axisElems = axisFlds.getElementsByTagName("div");
        for(var i=0, j = axisElems.length; i < j; i++)
        {
            if(axisElems[i].getAttribute("viewtype") != null)
            {
                if(axisElems[i].getAttribute("operation") == "ABSWEEK")
                {
                    return true;
                }
            }
        }
        return false;
    }
    
    this.checkIfElementHasABSWeek = function(el)
    {
        for(var i=0, j = el.length; i < j; i++)
        {
            if(el[i].getAttribute("viewtype") != null)
            {
                if(el[i].getAttribute("operation") == "ABS" && el[i].getAttribute("subtype") == 109)
                {
                    return true;
                }
            }
        }
        return false;
    }
    
    this.isFilterContainsAbsWeek = function(view)
    {
        var filterFlds = view.filterFields;
        var filterElems = filterFlds.getElementsByTagName("div");
        return settings.checkIfElementHasABSWeek(filterElems);
    }
      
    this.isVMFilterContainsAbsWeek = function(view)
    {
        var vmfilterFlds = view.VMFilterFields;
        var vmfilterElems = vmfilterFlds.getElementsByTagName("div");
        
        if( settings.checkIfElementHasABSWeek(vmfilterElems))
        {
            return true;
        }
        
        vmfilterFlds = view.grphAddOnHolder;
        vmfilterElems = vmfilterFlds.getElementsByTagName("div");
        
        return settings.checkIfElementHasABSWeek(vmfilterElems);
    }

    this.showOrHideLegend = function(el)
    {
        var propSetUtil = ZDBClientUI.getViewObj(el,"propSetUtil");//No I18N
        if(el.checked)
        {
        	this.setLegendProperties(propSetUtil);
        }
        else
        {
        	this.disableLegendProperties(propSetUtil);
        }
    }

    this.setLegendProperties = function(propSetUtil)
    {
        var propSetForm = propSetUtil.propSetForm;
        var view = propSetUtil.view;
        (propSetForm.legendTitleCBox).disabled = false;
        var zdbLegendCombo = propSetForm.zdbLegendCombo ;
        zdbLegendCombo.disabled = false;
        (propSetForm.zdbLegUtils).className = "inlineLegUtils";
        (propSetForm.legendFilterBoxes).disabled = false;
        (propSetForm.legendTitle).disabled = false;
        var defaultLegTitle = view.legendType["clrdisplayname"] ? view.legendType["clrdisplayname"] : "Legend"; //No i18N
        var legendTitle = (view.legendTitleValue != null && view.legendTitleModified) ? view.legendTitleValue : defaultLegTitle;
        (propSetForm.legendTitle).value = legendTitle;
        if(legendTitle == "" || legendTitle == null)
        {
            (propSetForm.legendTitleCBox).checked = false;
        }
        else
        {
            (propSetForm.legendTitleCBox).checked = true;
        }
        this.enableOrDisableLegendTitle(propSetForm.legendTitleCBox, propSetUtil);

//        view.legendPos = view.legendPos == "NONE" ? "RIGHT" : view.legendPos;//No I18N
        var posMap={
            NONE:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.hidden"),
            DEF:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.right"),
            RIGHT:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.right"),
            LEFT:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.left"),
            TOPRIGHT:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.topright"),
            TOPCENTER:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.topcenter"),
            TOPLEFT:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.topleft"),
            BOTTOMRIGHT:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.bottomright"),
            BOTTOMCENTER:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.bottomcenter"),
            BOTTOMLEFT:ZDBI18NMap.g("zrpt.common.analysis.legendPos.settings.js.bottomleft")
        };
        zdbLegendCombo = PropSettings.selectFromCombo(zdbLegendCombo, posMap[view.legendPos], "displayValue");

        var supportedLegend = ZDBEmbed.isSupportedLegend(view);
        if(supportedLegend == false)
        {
            (propSetForm.legendFilterBoxesTd).style.display = "none";
        }
        else
        {
            (propSetForm.legendFilterBoxesTd).style.display = "";
            (propSetForm.legendFilterBoxes).checked = view.legendFilterEnable;
        }
        ZALegendSettings.disableLegendLabel(propSetUtil, false);
        this.showHideLegendPosOpt(view,propSetForm);
    }

    this.showHideLegendPosOpt = function(view,propSetForm)
    {
        var graphSel = view.graphSelected;
        if(graphSel.match(/^(MAPSCATTER|MAPBUBBLE|MAPAREA|MAPPIE|MAPPIEBUBBLE|)$/))
        {
            propSetForm.zdblegendPosEl.style.display =  "none";
        }
    }
    this.disableLegendProperties = function(propSetUtil)
    {
        var propSetForm = propSetUtil.propSetForm;
        var view = propSetUtil.view;
        (propSetForm.legendTitleCBox).disabled = true;
        (propSetForm.legendTitle).disabled = true;
        var defaultLegTitle = view.legendType["clrdisplayname"] ? view.legendType["clrdisplayname"] : "Legend"; //No i18N
        var legendTitle = (view.legendTitleValue != null && view.legendTitleModified) ? view.legendTitleValue : defaultLegTitle;
        (propSetForm.legendTitle).value = legendTitle;
        (propSetForm.zdbLegendCombo).disabled = false;
        (propSetForm.legTitle).className = "inlineLegUtils alpha";
		(propSetForm.legFilter).className = "inlineLegUtils alpha";
        (propSetForm.legendFilterBoxes).disabled = true;
         ZALegendSettings.disableLegendLabel(propSetUtil, false);
         this.showHideLegendPosOpt(propSetUtil.view,propSetForm);
    }
    
    this.enableOrDisableLegendProps = function(el)
    {
    	var view = ZDBClientUI.getViewObj(el,"view");
    	var propSetForm = view.propSetUtil.propSetForm;
    	if(propSetForm.zdbLegendCombo.value == "NONE")
    	{
    		(propSetForm.legTitle).className = "inlineLegUtils alpha";
    		(propSetForm.legFilter).className = "inlineLegUtils alpha";
    		(propSetForm.legendTitleCBox).disabled = true;
    		(propSetForm.legendTitle).disabled = true;
    		(propSetForm.legendFilterBoxes).disabled = true;
    	}
    	else
    	{
    		(propSetForm.legTitle).className = "inlineLegUtils";
    		(propSetForm.legFilter).className = "inlineLegUtils";
    		(propSetForm.legendTitleCBox).disabled = false;
    		(propSetForm.legendTitle).disabled = false;
    		(propSetForm.legendFilterBoxes).disabled = false;
            var titleEl = (propSetForm.legendTitle);
    		titleEl.value = view.legendTitleValue ? view.legendTitleValue : view.legendType["clrdisplayname"] ? view.legendType["clrdisplayname"] : "Legend"; //No I18N
    	}
    }

    this.enableOrDisableLegendTitle = function(el, propSetUtil)
    {
    	if(!propSetUtil)
        {
            propSetUtil = ZDBClientUI.getViewObj(el, "propSetUtil");
        }
        var propSetForm = propSetUtil.propSetForm;
        var titleEl = (propSetForm.legendTitle);
        var legendPos = propSetUtil.view.legendPos;  
        titleEl.disabled = legendPos != "NONE" ? !el.checked : true; //No I18N
        var view = propSetUtil.view;
        titleEl.value = view.legendTitleValue ? view.legendTitleValue : view.legendType["clrdisplayname"] ? view.legendType["clrdisplayname"] : "Legend"; //No I18N
    }

    this.removeAllChilds = function(parent)
    {
        var removableContent= parent.childNodes;
        while(removableContent.length>0)
        {
          parent.removeChild(parent.childNodes[0]);
        }
    }

}

this.setLegendFormatKey = function(view)
{
	var propSetUtil = view.propSetUtil;
	var propSetForm = propSetUtil.propSetForm;
	var legendAxis = view.legendType.legendType;
	var currentList = view.currentList;
	var instKey;
	for(var i = 0; i<currentList.length; i++)
	{
		var curr = currentList[i];
		if(curr.getAttribute("viewType") == legendAxis)
		{
			instKey = curr.getAttribute("instkey");
			break;
		}
	}
	if(instKey == null || view.chartSelectedEl.isMultiY)
	{
		propSetForm.ZACFDlgLinkLeg.style.display = "none";
	}
	propSetForm.ZACFDlgLinkLeg.setAttribute("position", "Legend"); // NO I18N
	propSetForm.ZACFDlgLinkLeg.setAttribute("instkey", instKey);
	propSetForm.ZACFDlgLinkLeg.addEventListener('click', function()
            {
            	view.zacf.setKey(instKey);
            	ZDBPopUpMenu.gridOper(this);
//            	var dateListDiv = document.getElementById("ZDBColumnFormatFrm");
//            	dateListDiv.onload = settings.checkForDate(this, instKey);
            });
}

//this.checkForDate = function(el, instKey)
//{
//	var view = ZDBClientUI.getViewObj(el,"view"); //No I18N
//	if(view.legendType.clroperation == "DATE") //No I18N
//	{
//		var els = document.getElementsByClassName("ZRSDateHeaderPar"); //No I18N
//		for(var i = 0; i<els.length; i++)
//		{
//			var type = els[i].getAttribute("fmttype");
//			if(type == "DateWithTime")
//			{
//				els[i].style.display = "none";
//			}
//		}	
//	}
//}

var ZDBScroller = new function()
{
    this.intializeScroller = function(holderParent)
    {
        ZDBUtil.setNamedChildEls(holderParent,holderParent,"scrollel");
    }

    this.checkNSetButtonStyle = function(obj)
    {
        if(!obj.zdbFilterListBox)
        {
            obj.elnameSet = false;
        }
        ZDBUtil.setNamedChildEls(obj,obj);
        obj.zdbFilterListBox.style.display="block";
        if(obj.zdbFilterListBox.offsetWidth < obj.itemLstTbEl.offsetWidth)
        {
            if(parseInt(obj.itemLstTbEl.style.marginLeft)==0){
                ZDBScroller.setClass(obj.left,"");//No I18N
                ZDBScroller.setClass(obj.right,"alpha");//No I18N
            }
            else{
                ZDBScroller.setClass(obj.left,"");//No I18N
                ZDBScroller.setClass(obj.right,"");//No I18N
            }
        }
        else{
            ZDBScroller.setClass(obj.left,"deleteRuleClass");//No I18N
            ZDBScroller.setClass(obj.right,"deleteRuleClass");//No I18N
        }
    }

    this.startScroll = function(scrollClick,event, step, timeInterval)
    {
        this.timeInterval=timeInterval?timeInterval:10;
        this.step=step?step:15;
        this.directionButton=scrollClick;

        if(ZDBScroller.directionButton.getAttribute("direction")=="down" ||
                    ZDBScroller.directionButton.getAttribute("direction")=="up") //No I18N
        {
            this.intervalID = setInterval(ZDBScroller.move, ZDBScroller.timeInterval);
        }
        else if(ZDBScroller.directionButton.getAttribute("direction")=="left" ||
                    ZDBScroller.directionButton.getAttribute("direction")=="right") //No I18N
        {
            this.intervalID = setInterval(ZDBScroller.move, ZDBScroller.timeInterval);
        }
        ZDBScroller.directionButton.onmouseout=ZDBScroller.stopScroll;
        ZDBScroller.directionButton.onmouseup=ZDBScroller.stopScroll;
        ZDBUtil.stopEventBubble(event);
    }

    this.stopScroll = function(event)
    {
        clearInterval(ZDBScroller.intervalID);
        ZDBUtil.stopEventBubble(event);
    }

    this.move = function()
    {
        var scrollAreaParent = DOMUtils.getParentWithAttr(ZDBScroller.directionButton,"holderParent");
        ZDBScroller.intializeScroller(scrollAreaParent);
        ZDBTabHandler.visibleArea = scrollAreaParent;
        ZDBUtil.removeNonElements(scrollAreaParent.holder);
        var navKeyParent = DOMUtils.getParentWithAttr(ZDBScroller.directionButton,"navKeyParent");
        ZDBUtil.setNamedChildEls(navKeyParent,navKeyParent,"direction");
        var contentToMove=scrollAreaParent.content;

        if(contentToMove!=null)
        {
          if (ZDBScroller.directionButton.getAttribute("direction")=="up")
          {
            contentToMove.style.position="relative";
            var top=parseInt(contentToMove.style.top);
            if (top==0)
            {
              ZDBScroller.setClass(navKeyParent.up,"alpha");//No I18N
              ZDBScroller.setClass(navKeyParent.down,"");
              return;
            }
            else
            {
              contentToMove.style.top=top+ZDBScroller.step+"px";
              ZDBScroller.setClass(navKeyParent.down,"");
              ZDBScroller.setClass(navKeyParent.up,"");
              return;
            }
          }
          else if (ZDBScroller.directionButton.getAttribute("direction")=="down")
          {
            contentToMove.style.position="relative";
            var top=parseInt(contentToMove.style.top);
            if((top + contentToMove.offsetHeight) > (contentToMove.parentNode.offsetHeight))
            {
              contentToMove.style.top=top-ZDBScroller.step+"px";
              ZDBScroller.setClass(navKeyParent.down,"");
              ZDBScroller.setClass(navKeyParent.up,"");
            }
            else
            {
              ZDBScroller.setClass(navKeyParent.down,"alpha");//No I18N
              ZDBScroller.setClass(navKeyParent.up,"");
            }
          }
          else if (ZDBScroller.directionButton.getAttribute("direction")=="left")
          {
            var filterEl = DOMUtils.getParentWithAttr(contentToMove,"FILTEREL");//No I18N
            var left=parseInt(contentToMove.style.marginLeft);
            if((left + contentToMove.offsetWidth) > (scrollAreaParent.holder.offsetWidth))
            {
              contentToMove.style.marginLeft=left-ZDBScroller.step+"px"; //NO I18N
              ZDBScroller.setClass(navKeyParent.left,"");
              ZDBScroller.setClass(navKeyParent.right,"");
            }
            else
            {
              if(filterEl.itemList.getAttribute("NEXT1")=="-1")
              {
                ZDBScroller.setClass(navKeyParent.left,"alpha");//No I18N
                return;
              }
            }

            if((left + contentToMove.offsetWidth - scrollAreaParent.holder.offsetWidth) <
                                            (scrollAreaParent.holder.offsetWidth))
            {
              if(filterEl)
              {
                if(filterEl.itemList)
                {
                  ZDBAnalysisFilter.fetchNext(filterEl);
                  ZDBScroller.setClass(navKeyParent.left,"");
                  ZDBScroller.setClass(navKeyParent.right,"");
                }
                else
                {
                  ZDBScroller.setClass(navKeyParent.left,"alpha");//No I18N
                  ZDBScroller.setClass(navKeyParent.right,"");
                }
              }
            }
          }
          else if (ZDBScroller.directionButton.getAttribute("direction")=="right")
          {
            var left=parseInt(contentToMove.style.marginLeft);
            if (left==0)
            {
              ZDBScroller.setClass(navKeyParent.right,"alpha");//No I18N
              return;
            }
            else
            {
              contentToMove.style.marginLeft=left+ZDBScroller.step+"px"; //NO I18N
              ZDBScroller.setClass(navKeyParent.right,"");
              ZDBScroller.setClass(navKeyParent.left,"");
            }
          }
        }
  }

  this.setClass = function(el,clsName)
  {
    var newCls = "zdbScrollBtn" + el.getAttribute("direction") + " " + clsName;//No I18N
    if(trimAll(newCls) != trimAll(el.className))
    {
      el.className=newCls;
    }
  }

  this.setScrollerTop = function(scrollNode)
  {
      scrollNode.scrollTop = scrollNode.scrollHeight;
  }
}

var EfxOptions = new function()
{
    this.glowEl = function(el, joinClass, functionToEval)
    {
        if(el.getAttribute("noeffect")=="true")
	{
            return;
	}
        el.className=el.className+joinClass;
	this.currentEl = el;
	//functionToEval is not defined anywhere
	if(functionToEval)
	{
            (functionToEval)();
	}
    }

    this.normal = function(el, joinClass)
    {
      if(el.getAttribute("noeffect")=="true")
      {
          return;
      }
      var length=el.className.length;
      var classNormal = el.className;
      var joinClassLen = joinClass.length
      var classToApply = classNormal.substr(0, length-joinClassLen)
      el.className=classToApply
    }
}

var switchFunction = new function()
{
    this.changeProperties = function(el, event, eltoHide, classToAdd, functionToExecute)
    {
        var view = ZDBClientUI.getViewObj(el,"view");
	$(eltoHide).style.display="none";
	el.style.display="";
	ZDBAnalysisEditViewMode.mergeOrSplit(el);
    }
}

var ZDBAnalysisUtil = new function()
{
    this.showChartDlg = function(element, event)
    {
        if(ZDBAnalysisView.chartDlgShown){
            this.closeChartChooser(event);
            return;
        }
        if(!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/analysisview/ZDBOtherChart.js"],"APPENDTODOC",
                ZDBAnalysisUtil.showChartDlg,[element,event],"ZDBMainLoader")){
              return;
        }
        ZDBLazyLoadUtil.loadExternalSVG("themes/common/svgimages/chartchooser.svg");//NO I18N
        var isPublicViewOrStandAlone = element.getAttribute("notLoggedInOrStandAlone");
        var view = ZDBClientUI.getViewObj(element,"view");
        if(view.viewCtx.dashView || isPublicViewOrStandAlone == "true"){
            ZDBChartOptions.miniChartChooser(element,view);
            ZDBAnalysisView.chartDlgShown = true;
            return;
        }
        if(ZDBAnalysisView.chartTypeDlg == null)
        {
            ZDBContentCache.appendAndGet("Chart_Options_Dlg","GridMenu",document.body);
            var chartGroup = $("BIGICONSTD");
            var chartTypeDlg = rem$("ZDBChartTypeDlg");
            ZDBAnalysisView.chartTypeDlg = chartTypeDlg;
            ZDBAnalysisView.chartTypeDlg.chartGroup = chartGroup;
            jQuery(ZDBAnalysisView.chartTypeDlg.querySelectorAll("div[is3D]")).hide();
            var divs = ZDBAnalysisView.chartTypeDlg.querySelector(".subTypeCharts").querySelectorAll("div[sgt]");//NO I18N
            for(var i=0;i<divs.length;i++){
                ZDBUtil.attachEvent(divs[i],"click",ZDBChartOptions.refreshView,false);
            }
            divs = ZDBAnalysisView.chartTypeDlg.querySelector(".types").querySelectorAll("span[elname]");//NO I18N
            for(var i=0;i<divs.length;i++){
                ZDBUtil.attachEvent(divs[i],"click",ZDBChartOptions.mouseEnterHandler);
                ZDBUtil.attachEvent(divs[i],"mouseover",function(event){ZDBToolTip.show(DOMUtils.getElOrParentWithAttr(event.target,"fadeIn"),event,"TOP")});
                ZDBUtil.attachEvent(divs[i],"mouseleave",function(event){ZDBToolTip.hide(event,true)});
            }
            divs = ZDBAnalysisView.chartTypeDlg.querySelector(".subTypeCharts").querySelectorAll(".chartSubTypeContainer");//NO I18N
            for(var i=0;i<divs.length;i++){
                ZDBUtil.attachEvent(divs[i],"mouseenter",function(event){ZDBToolTip.show(DOMUtils.getElOrParentWithAttr(event.target,"sgt"),event,"BOTTOM",true,true)});
                ZDBUtil.attachEvent(divs[i],"mouseleave",function(event){ZDBToolTip.hide(event,true)});
            }
        }
        ZDBChartOptions.initialize(view.graphSelected,view);
        var chartDlg = ZDBAnalysisView.chartTypeDlg;
        ZDBAnalysisView.chartTypeDlg.view = view;
        chartDlg.style.display="";
        view.oldGraphSelected = view.graphSelected;
        view.oldSubGraphType = view.subGraphType;
        var dlgParams = {MODAL: false,CALLOUT:true,MANUALPOS:'NOARROW',//NO I18N
                VIEW: view, DONTREMOVE: true,SRCEL:element,ONCLOSE:ZDBAnalysisUtil.closeChartChooser};
        if(view.viewCtx.dashView || isPublicViewOrStandAlone == "true") {
            dlgParams.MANUALPOS = false;
        }
        ZDBDialogUtil.showDialog(chartDlg, dlgParams);
        ZDBAnalysisView.chartTypeDlg.style.left = parseInt(ZDBAnalysisView.chartTypeDlg.style.left) - 1 + "px";
        ZDBAnalysisView.chartTypeDlg.style.top = parseInt(ZDBAnalysisView.chartTypeDlg.style.top) + "px";
        if(!ZDBGlobal.notLoggedInOrStandAlone){
            ZDBUtil.addClass(chartDlg.params.SRCEL, "ZRChartDlgSrc");
        }
        ZDBAnalysisView.chartDlgShown = true;
        ZDBUtil.attachEvent(document,"mouseup",ZDBAnalysisUtil.hideChartSelector,false);
    }

    this.hideChartSelector = function(event){
    	if(event.type == "keyup"){
            if(event.keyCode == KEY.ESC){
                ZDBAnalysisUtil.closeChartChooser(event);
            }
        }
        else{
            var target =event.target || event.srcElement;
            var el = ZDBUtil.getParentWithAttr(target,"isChartSelector");
            var isFromDash = ZDBUtil.getParentWithAttributeValue(target, "selected", "true"); //No I18N
            var embedChartType = !(target instanceof SVGElement) && target.className.indexOf("ZREmbedChartChooser") != -1;
            if(!embedChartType && target.id != "ZAOtherCharts" && !el && !(isFromDash && isFromDash == ZDBAnalysisView.miniChartTypeDlg.src)){ //NO I18N
                ZDBAnalysisUtil.closeChartChooser(event);
            }
        }
    };

    this.hideOnScroll = function(event){
        try{
            if(!ZDBClientUI.selectedTab.view.editMode && ((ZDBAnalysisView.chartTypeDlg && ZDBDialogUtil.focusDialog == ZDBAnalysisView.chartTypeDlg) || ZDBAnalysisView.miniChartTypeDlg)){
                this.closeChartChooser(event);
            }
        }
        catch(e){
            //Focused dialog and charttype dialog are not created yet.
        }
    }

    this.closeChartChooser = function(event){
        var isMiniChart = !(ZDBDialogUtil.focusDialog && ZDBAnalysisView.chartTypeDlg && ZDBDialogUtil.focusDialog === ZDBAnalysisView.chartTypeDlg);
        if(isMiniChart){
            var divs = ZDBAnalysisView.miniChartTypeDlg.querySelectorAll("div");//NO I18N
            for(var i=0,len=divs.length; i<len; i++){
                ZDBUtil.removeClass(divs[i], "hov");
            }
            ZDBAnalysisView.miniChartTypeDlg.style.display = "none";
            if(!(ZDBAnalysisView.miniChartTypeDlg.src instanceof SVGElement)){
            	ZDBUtil.removeClass(ZDBAnalysisView.miniChartTypeDlg.src, "ZRMiniChartSrc");
                ZDBUtil.removeClass(ZDBAnalysisView.miniChartTypeDlg.src, "WTheme");
                ZDBUtil.removeClass(ZDBAnalysisView.miniChartTypeDlg.src, "WTTheme");
            }
            ZDBUtil.detachEvent(document,"mouseup",ZDBAnalysisUtil.hideChartSelector,false);
        }
        else{
            var subCharts = ZDBAnalysisView.chartTypeDlg.querySelector(".subTypeCharts").querySelectorAll("div[elname='subChartHolder']");//NO I18N
            for(var i=0; i<subCharts.length; i++){
                subCharts[i].style.display = "none";
            }
            ZDBAnalysisView.chartTypeDlg.querySelector(".types").style.marginLeft = "0px";//NO I18N
            ZDBAnalysisView.chartTypeDlg.querySelector("div[scrollDir]").children[0].className = "ra";//NO I18N
            ZDBDialogUtil.focusDialog.params.ONCLOSE = null;
            ZDBDialogUtil.closeDialog();
            ZDBUtil.removeClass(ZDBAnalysisView.chartTypeDlg.params.SRCEL, "ZRChartDlgSrc");
        }
        ZDBAnalysisView.chartDlgShown = false;
        ZDBUtil.detachEvent(document,"mouseup",ZDBAnalysisUtil.hideChartSelector,false);
        try{
            DashUtils.hideOptionsMenu();
        }
        catch(e){
            //No dashboard opened
        }
    }
    this.applyChanges = function(element, event)
    {
        var isMiniChart = !(ZDBDialogUtil.focusDialog && ZDBAnalysisView.chartTypeDlg && ZDBDialogUtil.focusDialog == ZDBAnalysisView.chartTypeDlg);
        var view = (isMiniChart)?ZDBAnalysisView.miniChartTypeDlg.view:ZDBAnalysisView.chartTypeDlg.view;
        view.graphSelectionApplied = true;
        ZDBAnalysisUtil.handleSizeField(view);
        ZDBAnalysisView.checkAndRefresh(view);
        if(ZDBDialogUtil.focusDialog != null)
        {
            ZDBDialogUtil.closeDialog();
        }
    };

    //either add size field or show context message while changing to bubble chart
    this.handleSizeField = function(view)
    {
        if(view.chartSelectedEl.isMultiY && view.subGraphType === "PACKEDBUBBLE")
        {
            return; // multiy packedbubble should not have size field
        }
        var grpType = view.graphSelected;
        var sizeField = view.dropAreas.SIZEAXIS;
        var bubbleGrp = /^(BUBBLE|MAPBUBBLE|MAPPIEBUBBLE)$/;
        if(grpType.match(bubbleGrp) && sizeField.childElementCount === 0)
        {
            ZDBAnalysisUtil.addSizeField(view);
        }
        else
        {
            ZDBAnalysisUtil.displaySizeMessage(view);
        }
    };

    // display message when bubble chart changed to other chart with size present
    this.displaySizeMessage = function(view)
    {
        if(view.chartSelectedEl.isMultiY && view.subGraphType === "PACKEDBUBBLE")
        {
            return;
        }
        if(view.editMode)
        {
            var sizeField = view.dropAreas.SIZEAXIS;
            var bubbleGrp = /^(BUBBLE|MAPBUBBLE|MAPPIEBUBBLE)$/;
            var chart = view.graphSelected;
            var oldChart = view.oldGraphSelected;
            if(chart !== "TABLE_CHART" && oldChart.match(bubbleGrp) && //No I18N
                    chart.match(bubbleGrp) === null && sizeField.childElementCount === 1)
            {
                ZDBMsgBox.showChartInfo(ZDBI18NMap.g("zrpt.common.analysis.js.bubbleChart"));
            }
        }
    };

    // add the column dropped in x or y-axis to size field on selecting bubble from other charts dlg
    this.addSizeField = function(view)
    {
        var aggAxis = ZDBAnalysisView.getAggregateAxis(view);
        var dropArea = (aggAxis === 'X') ? view.dropAreas.XAXIS : view.dropAreas.YAXIS; //No I18N
        var childEl = jQuery(dropArea).children();
        if(childEl.length === 0)
        {
            dropArea = (aggAxis === 'X') ? view.dropAreas.YAXIS : view.dropAreas.XAXIS; //No I18N
            childEl = jQuery(dropArea).children();
        }
        var axisDiv = childEl[0];
        var sizeDiv = axisDiv.cloneNode(true);
        sizeDiv.setAttribute("instkey", "");
        var operation = sizeDiv.getAttribute("operation");
        var aot = sizeDiv.getAttribute("addontype");
        var abbrev;
        if(operation === "GROUPBY" || operation === "DISCRETE" || operation === "MEACATEGORY"
                || operation === "CONTINUOUS" || aot === "ABSDATECATEGORICAL" || operation ==="GEO") //No I18N
        {
            operation = "COUNT"; //No I18N
            abbrev = "Count"; //No I18N
        }
        else
        {
            ZDBUtil.setNamedChildEls(axisDiv, axisDiv);
            abbrev = axisDiv.operation.innerHTML;
        }
        sizeDiv.setAttribute("operation", operation);
        ZDBUtil.setNamedChildEls(sizeDiv, sizeDiv);
        sizeDiv.operation.innerHTML = abbrev;

        var sizeAxis = view.dropAreas["SIZEAXIS"];
        if(view.editMode)
        {
            ZDBAnalysisEditViewMode.selectTab("graph", null, view); //No I18N
            view.addFieldToArea(sizeDiv, sizeAxis);

            var sizeEl = jQuery(sizeAxis).closest("div:has([droparea])")[0];
            sizeEl.style.backgroundColor = "";
            ZDBAnalysisEditViewMode.startHighlighting(jQuery(sizeEl).removeClass().addClass("sizeAxisDiv"));
        }
        else
        {
            view.addFieldToArea(sizeDiv, sizeAxis);
        }
    }
    
//    this.handleSingleColChart = function(view)
//    {
//    	if(view != null && view.type == "AnalysisView" && view.permissions.designModify && ZDBGlobal.convSingleColChart)
//    	{
//	    	var xAxisCont = view.dropAreas.XAXIS;
//	    	var yAxisCont = view.dropAreas.YAXIS;
//	    	var viewCols = view.addedViewCols[0];
//	    	if(viewCols == null)
//	    	{
//	    		return;
//	    	}
//	    	var opr = viewCols.opr;
//	    	var xChildEl = jQuery(xAxisCont).children();
//	    	var yChildEl = jQuery(yAxisCont).children();
//	    	if(xChildEl.length == 0 && yChildEl.length == 1)
//	    	{
//	    		var yDiv = yChildEl[0];
//	    		var xDiv = yDiv.cloneNode(true);
//	    		ZDBUtil.setNamedChildEls(yDiv, yDiv);
//	    		ZDBUtil.setNamedChildEls(xDiv, xDiv);
////	    		var aot = yDiv.getAttribute("addontype");
////	    		var opr = yDiv.getAttribute("operation");
////	    		var dType = yDiv.getAttribute("dtype");
////	    		if(opr == "AGG_FORMULA")
////	    		{/*Do Nothing*/}
////	    		else if(opr == "VAR" || opr.indexOf("DC") != -1)
////	    		{
////    				ZDBAnalysisView.setOperationOnField(xDiv, opr, "XAXIS", null, view); //No I18n
////    				
////	    		}
////	    		else if(dType == "DIMENSIONAL" && aot != "NUMBER")
////	    		{
////	    			if(opr == "COUNT" && aot != "ABSDATECATEGORICAL")
////	    			{
////	    				ZDBAnalysisView.setOperationOnField(xDiv, "GROUPBY", "XAXIS", null, view);//No I18n
////	    			}
////	    			else
////	    			{
////	    				ZDBAnalysisView.setOperationOnField(xDiv, "COUNT", "XAXIS", null, view);//No I18n
////	    			}
////	    			if(aot == "ABSDATECATEGORICAL")
////	    			{
////	    				xDiv.setAttribute("dtype", "MEASURE");
////	    			}
////	    		}
////	    		else if(aot == "NUMBER")
////	    		{
////	    			if(dType == "DIMENSIONAL")
////	    			{
////	    				xDiv.setAttribute("dtype", "MEASURE")
////	    			}
////	    			else
////	    			{
////	    				ZDBAnalysisView.setOperationOnField(yDiv, "MEACATEGORY", "XAXIS", null, view);//No I18n
////	    			}
////    				ZDBAnalysisView.setOperationOnField(xDiv, "COUNT", "XAXIS", null, view);//No I18n
////	    		}
//	    		
//	    		ZDBAnalysisView.setOperationOnField(xDiv, opr, "XAXIS", null, view);//No I18n
//	    		
//	    		xDiv.setAttribute("instkey", "");
//	            view.addFieldToArea(xDiv, xAxisCont);
//	            view.modified = 1;
//	            var xContDiv = jQuery(xAxisCont).closest("div:has([droparea])")[0];
//	            xContDiv.style.backgroundColor = "";
//	            ZDBAnalysisEditViewMode.startHighlighting(jQuery(xContDiv).removeClass().addClass("sizeAxisDiv"));
//	            view.userGrpSel = view.userGrpSel == "BEST" ? "PIE" : view.userGrpSel; //No I18N
//	    	}
//	    	else if(xChildEl.length == 1 && yChildEl.length == 0)
//	    	{
//	    		var xDiv = xChildEl[0];
//	    		var yDiv = xDiv.cloneNode(true);
//	    		ZDBUtil.setNamedChildEls(yDiv, yDiv);
//	    		ZDBUtil.setNamedChildEls(xDiv, xDiv);
////	    		var aot = xDiv.getAttribute("addontype");
////	    		var opr = xDiv.getAttribute("operation");
////	    		var dType = xDiv.getAttribute("dtype");
////	    		if(opr == "AGG_FORMULA")
////	    		{/*Do Nothing*/}
////	    		else if(opr == "VAR" || opr.indexOf("DC") != -1)
////	    		{
////    				ZDBAnalysisView.setOperationOnField(yDiv, opr, "YAXIS", null, view);//No I18n
////	    		}
////	    		else if(dType == "DIMENSIONAL" && aot != "NUMBER")
////	    		{
////	    			if(opr == "COUNT" && aot != "ABSDATECATEGORICAL")
////	    			{
////	    				ZDBAnalysisView.setOperationOnField(yDiv, "GROUPBY", "YAXIS", null, view);//No I18n
////	    			}
////	    			else
////	    			{
////	    				ZDBAnalysisView.setOperationOnField(yDiv, "COUNT", "YAXIS", null, view);//No I18n
////	    			}
////	    			if(aot == "ABSDATECATEGORICAL")
////	    			{
////	    				yDiv.setAttribute("dtype", "MEASURE");
////	    			}
////	    		}
////	    		else if(aot == "NUMBER")
////	    		{
////	    			if(dType == "DIMENSIONAL")
////	    			{
////	    				yDiv.setAttribute("dtype", "MEASURE")
////	    			}
////	    			else
////	    			{
////	    				ZDBAnalysisView.setOperationOnField(xDiv, "MEACATEGORY", "XAXIS", null, view);//No I18n
////	    			}
////	    			ZDBAnalysisView.setOperationOnField(yDiv, "COUNT", "YAXIS", null, view);//No I18n
////	    		}
//	    		
//	    		ZDBAnalysisView.setOperationOnField(yDiv, opr, "XAXIS", null, view);//No I18n
//	    		
//	    		yDiv.setAttribute("instkey", "");
//	            view.addFieldToArea(yDiv, yAxisCont);
//	            view.modified = 1;
//	            var yContDiv = jQuery(yAxisCont).closest("div:has([droparea])")[0];
//	            yContDiv.style.backgroundColor = "";
//	            ZDBAnalysisEditViewMode.startHighlighting(jQuery(yContDiv).removeClass().addClass("sizeAxisDiv"));
////	            view.userGrpSel = view.userGrpSel == "BEST" ? "PIE" : view.userGrpSel; //No I18N
//	    	}
//    	}
//    }

    this.setElementSelected = function(el, elParent, defaultClass, selectedClass)
    {
      var holder = el.parentNode;
      if(elParent!=null)
      {
        holder = elParent;
      }

      var tagname = el.tagName;
      var totalEls = holder.getElementsByTagName(tagname);
      for(var i =0, j = totalEls.length; i < j; i++)
      {
        if((totalEls[i]==el))
        {
          totalEls[i].className = selectedClass;
          totalEls[i].setAttribute("noeffect","true");
        }
        else
        {
          totalEls[i].className = defaultClass;
          totalEls[i].setAttribute("noeffect","false");
        }
      }
    };

    this.isPropInCurPropList = function(curListProp, prop, val)
    {
        for(var i in curListProp)
        {
            if(curListProp[i][prop] && curListProp[i][prop] == val) // for string or number check
            {
                return true;
            }
        }
        return false;
    }

    this.showHideTableDiv =  function(el,parEl)
    {
        var hide = null;
        var fieldHolder = $("ZDBAnalysisFieldHolder");
        if(fieldHolder.hideTables == null) {
            fieldHolder.hideTables = [], fieldHolder.showTables = [];
        }

        var tableName = parEl.getElementsByTagName("span")[0].innerHTML;
        var idx = fieldHolder.hideTables.indexOf(tableName);
        if(idx == -1)
        {
            idx = fieldHolder.showTables.indexOf(tableName);
            if (idx != -1) {
                hide = "false";
            }
        }
        else {
            hide = "true";
        }

        hide = (hide==null) ? el.getAttribute("db_hide") : hide;
        el.style.display = (hide == "true") ? "" : "none";
        el.setAttribute("db_hide",(hide=="true") ? "false" : "true");

        if(hide==="true") {
            ZDBAnalysisUtil.resetOptions(fieldHolder.showTables, tableName, fieldHolder.hideTables);
        }
        else {
            ZDBAnalysisUtil.resetOptions(fieldHolder.hideTables, tableName, fieldHolder.showTables);
        }

        var childSpan = DOMUtils.getFirstMatchingChild(parEl, "span", "childSpan", "true"); //No I18N
        childSpan.className = (hide === "true") ?  "folderOpen adjOpenPos" : "folderClose adjClosePos"; //No I18N
    };

    // reset show / hide based on user selection
    this.resetOptions = function(pushTable, tblName, spliceTable)
    {
        var idx = pushTable.indexOf(tblName);
        if(idx == -1) {
            pushTable.push(tblName);
        }
        idx = spliceTable.indexOf(tblName);
        var spliceCount = (idx == -1) ? 0 : 1;
        spliceTable.splice(idx, spliceCount);
    };

    this.showHideTable = function(el)
    {
        var parHolderEl = DOMUtils.getParentWithAttr(el,"parentHolder"); //No I18N
        var hideDiv =  DOMUtils.getChildElsWithAttr(parHolderEl,"expParent","expParent"); //No I18N
        if(hideDiv != null)
        {
            ZDBAnalysisUtil.showHideTableDiv(hideDiv[0] , el);
        }
        return true;
    };

    this.updateFieldCacheStatus = function(view)
    {
        var cacheDiv  = $("ZAFIELDCACHEABLE");
        view.fieldsCacheable = cacheDiv.getAttribute("isCacheable") == "true";
        view.isDefaultFields = cacheDiv.getAttribute("isDefaultFields") == "true";
    };
}

var ZDBContextMenu = new function()
{
    this.showDrillMenuJS = function(event, data, jsChart)
    {
        var clickedEl = ZDBUtil.getSourceElement(event);
        var view = ZDBClientUI.getViewObj(clickedEl,"view");
        var criteria = ZDBVUDataAPI.getCriteria(event, data);
        view.clrCriteria = criteria;
        if(!view.drillDet.isClrDrillable && view.drillDet.isCyclicDrillReached  &&
                (!(ZDBGlobal.isDynDrillEnabled ) || !view.drillDet.isClrDynDrillable))
        {
            ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.toolbar.pivot.zdbalertmsg.js.cyclicdrillreached"));
            ZDBAnalysisView.chartClick(event);
            return;
        }	
        else if(view.editMode)
        {
            ZDBAnalysisView.chartClick(event);
            return;
        } 	
        else if( ( !view.drillDet.isClrDrillable  && (!(ZDBGlobal.isDynDrillEnabled ) || !view.drillDet.isClrDynDrillable) ) ||(!view.permissions.drilldown) || !view.drillDet.isChartDrillable)
        {
            ZDBAnalysisView.chartClick(event);
            return;
        }
        else if((view.drillDet.isClrDrillable || ((ZDBGlobal.isDynDrillEnabled) && view.drillDet.isClrDynDrillable )) )
        {
            if((!ZDBGlobal.isDynDrillEnabled) && view.permissions.vud == 0  && view.drillDet.isClrDrillable )
            {
                ZDBAnalysisView.drillDown(event, clickedEl);
            }
            else
            {
                var seriesIdx = null;
                //init altered to null instead of 0 -> since 0 is valid arr index;
                var data = data["data"];
                if(view.chartSelectedEl.isMultiY)
                {
                    seriesIdx = data[1].columnindex - 1;
                }
                else
                {
                    var colIdx = 0;
                    var chartObj = view.chartObj;
                    if(view.graphSelected === "PIE")
                    {
                        var chartData = chartObj.getData();
                        colIdx = chartData.metadata.axes.x[0];
                        var dataArr = chartObj.getChartData()[0].data[0][0] instanceof Array ?
                                    chartObj.getChartData()[0].data[0] : chartObj.getChartData()[0].data;
                        var curData = chartData.metadata.columns[colIdx];
                        var catIdx = curData.dataindex;
                        var clickVal = data[catIdx].value;
                        for(var i=0; i < dataArr.length; i++)
                        {
                            if(clickVal == dataArr[i][catIdx])
                            {
                                seriesIdx = i;
                                break;
                            }
                        }
                    }
                    else
                    {
                        var clrIdx = chartObj.getColorIdx();
                        if(clrIdx != null && clrIdx >= 0)
                        {
                            colIdx = data.length - 1;
                            var val = data[colIdx].value;
                            var seriesData = chartObj.getChartData();
                            for(var i=0; seriesData && i < seriesData.length; i++)
                            {
                                if(seriesData[i].seriesname === val)
                                {
                                    seriesIdx = i;
                                    break;
                                }
                            }
                        }
                        else
                        {
                            seriesIdx = 0;
                        }
                    }
                }
                view.chartObj.seriesIdx = seriesIdx;
                ZDBContextMenu.showChartDrillMenu(clickedEl, view, event);
            }
        }
    };
	
	this.enableChartEvents = function(chartObj)
	{
		chartObj.handleChartEvents(true);
	};
	
	this.showChartDrillMenu = function(clickedEl,view,event,lblclick)
	{
      var drillMenu = $("ZADrillOptMenu");
      if(!drillMenu)
      {
        drillMenu = ZDBContentCache.appendAndGet("Chart_Drill_Menu","GridMenu",document.body);
      }
      var menu = view.drillMenuOpt;
      if(!menu)
      {
        menu = ZDBUtil.getCloneNode(drillMenu);
        view.drillMenuOpt = menu;
      }
      menu.clickedDrillEl = clickedEl;
      var xChck = event.changedTouches && event.changedTouches[0] ? event.changedTouches[0].pageX : event.pageX ;
	  var yChck = event.changedTouches && event.changedTouches[0] ? event.changedTouches[0].pageY : event.pageY ;
      menu.pointX = ZDBGlobal.IS_MOBILE ? xChck - window.pageXOffset : event.clientX ;
      menu.pointY = ZDBGlobal.IS_MOBILE ? yChck - window.pageYOffset : event.clientY ;
      //alert(menu.pointX);
      //alert(menu.pointY);
      var chck = menu.pointX;
      menu.setAttribute("drillMenu","true");
      clickedEl.view = view;
      var menuContainer = ToolTip.getToolTipHolder(view);
      
      view.chartObj.handleChartEvents(false);
      
      //------ Only when dynamic Drill is enabled --------------------------
      if(ZDBGlobal.isDynDrillEnabled)
      {
    	  var drillfunc = lblclick === true ? "drillDownJS" : "drillDown"; // NO I18N
          var vudfunc = lblclick === true ? "lblVUDClick" : "chartClick";  // NO I18N
          var VudMenu = DOMUtils.getFirstMatchingChild(menu,"td","elName","vudElem");; // NO I18N
          var drillMenu =  DOMUtils.getFirstMatchingChild(menu,"td","elName","drillElem");    // NO I18N
          drillMenu.srcMenu = menu ;
          var defdrillElem = DOMUtils.getFirstMatchingChild(menu,"td","elName","defdrillElem");// NO I18N
          var nxtdrillCol = DOMUtils.getFirstMatchingChild(defdrillElem,"span","elName","defDrillCol");// NO I18N
          var lbldefdrillCol = view["lbldefdrillCol"];
          var clrdefdrillCol = view["clrdefdrillCol"];
          defdrillElem.setAttribute("func",drillfunc);
          nxtdrillCol.setAttribute("func",drillfunc);
    	  VudMenu.setAttribute("func",vudfunc);
         drillMenu.setAttribute("func","");
          var defdrilltip ="";
       if(lblclick === true)
       {
    	  var nxtdrillOp = (lbldefdrillCol !== null && lbldefdrillCol !== undefined ) ? DrilldownConstants.dispDate[lbldefdrillCol.OPERATION] : "";
    	  var nxtdrillOpdisp = (nxtdrillOp !== null && nxtdrillOp !== undefined ) ? "("+nxtdrillOp+")" : "";
    	  nxtdrillCol.innerHTML = (lbldefdrillCol !== null && lbldefdrillCol !== undefined ) ? "'" + ZDBEscapeUtil.encodeForHtml(lbldefdrillCol.DISP_NAME)+ nxtdrillOpdisp +"'" : "" ;
    	  var paddingstr = (lbldefdrillCol !== null && lbldefdrillCol !== undefined ) ?  "0px 5px" : "0px 13px";// NO I18N
    	  defdrillElem.style.display = (lbldefdrillCol !== null && lbldefdrillCol !== undefined ) ? "block" : "none"; 
    	  view.chartObj.seriesIdx =null;
           defdrilltip = lbldefdrillCol !== null && lbldefdrillCol !== undefined ? ZDBEscapeUtil.encodeForHtmlAttr(lbldefdrillCol.DISP_NAME)+ nxtdrillOpdisp : "" ; // NO I18N
            var eventName = (BROWSER.IS_MOBILE) ? "ontouchend" : "onclick";//NO I18N
           drillMenu[eventName]= function(event){
                            ZADynamicDrillList.dynamicDrillDownJS(event,"LABELDRILL"); // NO I18N
                            ZDBUtil.stopEventBubble(event);
                            } ;
    	  if(ZDBGlobal.IS_MOBILE)
  	      {
    		  drillMenu.onmouseover = null;drillMenu.onmouseout = null;
              defdrillElem.onmouseover=null;defdrillElem.onmouseout=null;	      
  	      }
        }
        else
        {
    	  clrdefdrillCol = clrdefdrillCol == null ? lbldefdrillCol : clrdefdrillCol ;
    	  var nxtdrillOp = (clrdefdrillCol !== null && clrdefdrillCol !== undefined ) ? DrilldownConstants.dispDate[clrdefdrillCol.OPERATION] : "";
    	  var nxtdrillOpdisp = (nxtdrillOp !== null && nxtdrillOp !== undefined ) ? "("+nxtdrillOp+")" : "";
    	  nxtdrillCol.innerHTML=(clrdefdrillCol !== null  && clrdefdrillCol !== undefined)? "'" + ZDBEscapeUtil.encodeForHtml(clrdefdrillCol.DISP_NAME)+ nxtdrillOpdisp +"'" : "";
    	  defdrillElem.style.display = (clrdefdrillCol !== null  && clrdefdrillCol !== undefined) ?  "block" : "none"; 
    	  var paddingstr = (lbldefdrillCol !== null && lbldefdrillCol !== undefined ) ?  "0px 5px" : "0px 13px"; // NO I18N
            defdrilltip = clrdefdrillCol !== null && clrdefdrillCol !== undefined ? ZDBEscapeUtil.encodeForHtmlAttr(clrdefdrillCol.DISP_NAME)+ nxtdrillOpdisp : "" ; // NO I18N
             var eventName = (BROWSER.IS_MOBILE) ? "ontouchend" : "onclick"; //No I18N
           drillMenu[eventName]= function(event){
                            ZADynamicDrillList.dynamicDrillDownJS(event);
                            ZDBUtil.stopEventBubble(event);
                            } ;
            
    	 if(ZDBGlobal.IS_MOBILE)
  	      {
    		      drillMenu.onmouseover = null;drillMenu.onmouseout = null;
                  defdrillElem.onmouseover=null; defdrillElem.onmouseout=null;    		      
  	      }
    	  VudMenu.style.display="block";
         }
       VudMenu.style.padding = paddingstr; defdrillElem.style.padding = paddingstr;  drillMenu.style.padding = paddingstr;     
       if(view.permissions.vud == 0) {
          VudMenu.style.display ="none";
         }
       drillMenu.style.borderRadius =  (view.permissions.vud == 0 ) ? "6px" : "0px 0px 6px 6px"; // NO I18N
      }
      //----------------------------------------//

      menuContainer.appendChild(menu);
      menu.view = view;
      ZRSMenu.showMenu(event, null, menu,1, ZDBContextMenu.enableChartEvents.bind(this, view.chartObj));
      ZRSDrillDown.setDrillMenuPos(menu,event,menuContainer);
      if(ZDBGlobal.isDynDrillEnabled)
      {
       defdrillElem.setAttribute("tip", defdrilltip);
      }
      ZDBUtil.stopEventBubble(event);
    };
	
	this.showChartMenu = function(event)
	{
		var clickedEl = ZDBUtil.getSourceElement(event);
		var view = ZDBClientUI.getViewObj(clickedEl,"view");
		if((!ZDBClientUI.isDBOwner )
				|| (view == null)
				|| ((view.viewCtx != null) && view.viewCtx.isStandAlone())
				|| (ZDBGlobal.integrated == true)
				|| (view.chartArea.blured==true || view.chartArea.blured==null))
		{
			ZDBUtil.stopEventBubble(event);
			return false;
		}

		if(event.type=="click" && navigator.platform!="MacIntel"){return;}
		if(clickedEl.tagName=="AREA")
		{
			return false;
		}
		var menu = ZDBContentCache.appendAndGet("Chart_Context_Menu","GridMenu",document.body);
		menu.view = view;
		ZRSMenu.showMenu(event, null, menu,1);
		var menuItem = jQuery(menu).find("a[func='PropSettings.showDialog']").parent()[0];
		if(menuItem)
		{
			if(view.zrsDrillObj && view.zrsDrillObj.drillLevel > 0) {
				menuItem.style.display = "none";
			}
			else {
				menuItem.style.display = "";
			}
		}
		ZDBUtil.stopEventBubble(event);
	}

}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["settings.showDialog"]=settings.showDialog;
