//$Id$
var ZAFailSafeAction = new function()
{
    // send ajax request to fetch data for the given task
    this.handleFailSafe = function(view, lazyLoadKey)
    {
        var url = "/ZAFailSafeAction.ma?"; //No I18N
        var params = "TASKKEY="+lazyLoadKey+"&SEQKEY="+view.SEQKEY+"&ZDBACTION=LAZYLOADDATA"; //No I18N
        params += ZDBUtil.isNewView(view) ? "" : "&OBJID=" + view.objId; //No I18N
        params += "&PARENTVIEWID=" + view.parentViewId + "&EDITMODE=" + (view.editMode == true); //No I18N
        var height = (view.chartHeight < 40) ? 40 : view.chartHeight;
        params += "&height="+ height + "&width=" + view.chartWidth; //No I18N
        params += view.viewCtx.getAdditionalParams();

        var xml = ZDBAnalysisConfig.getCurrentConfig(view, true);
        AjaxAPI.sendRequest({URL:url+params, POSTBODY:xml, REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},
                            VIEW:view, TASKKEY:lazyLoadKey,
                            ONSUCCESSFUNC:ZAFailSafeAction.placeLazyLoadData,
                            ONFAILUREFUNC:ZDBAnalysisView.handleFailure,
                            OPSTATUSID:view.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.analysis.js.generate_rpt"))}); //No I18N
    };
    
    this.placeLazyLoadData = function(response, requestOptions)
    {
        var view = requestOptions["VIEW"];
        var tabView = view.viewCtx.dashView ? view.viewCtx.dashView : view;
        var func = function(){ZAFailSafeAction.placeLazyLoadData(response, requestOptions);};
        if(!ZDBTabSwitchHandler.isRelevendTab2Exec(tabView, func))
        {
            return;
        }
        var thResp = response.responseText.trim();
        var jsonObj = JSON.parse(thResp);
        var taskKey = requestOptions["TASKKEY"];
        ZALazyLoadData.taskAction(view, taskKey, jsonObj);
    };
};