//$Id$
/**
 *
 */

var CloudDBPage = new function ()
{
    this.editorGlobal;
    this.showCreateCloudDB = function (element)
    {
        var lzName = element.getAttribute("lzName");
        var lzOper = (element.getAttribute("lzOper")) ? element.getAttribute("lzOper") : "APPENDTODOC"; //No I18N
        var lzJs = element.getAttribute("lzJs");
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZRCloudDB.cc", this, lzOper))
        {
            return;
        }
        CloudDBPage.showCreateCloudDBDlg();
    };
    this.showCreateCloudDBDlg = function ()
    {
        var checkROMode = ZDBClientUI.readOnlyMode;
        if (checkROMode)
        {
            ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.javaerr.common.js.ro_mode"));
            return;
        }

        var clouddbDlg = ZDBUtil.getCachedRef(this, "ZRCloudDBDialog");
        ZDBFullPageDialog.showDialog(clouddbDlg, {MODAL: true,DONTREMOVE:false});
        $("ZRCloudDBInlineDlgBar").style.display = "none";
        $("ExistingConnection").style.display = "none";
        if($("LiveConnectDiv"))
        {
            $("LiveConnectDiv").style.display = "";
        }
        CloudDBPage.loadNewTblSettings(clouddbDlg);
    };
    this.loadNewTblSettings = function (clouddbDlg)
    {
        if (!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js", "APPENDTODOC", CloudDBPage.loadNewTblSettings,[clouddbDlg]))
        {
            return;
        }
        hideCustomMessage();
        ZDBUtil.setAttribute($("CloudDBImport"), "false", "isExistImp");
        ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 1, "stepNo");
        if($("ZRSHelpCenter") && jQuery("#CloudDBHelp").children().length==0)
        {
            var helpIcons =$("ZRSHelpCenter").cloneNode(true);
            var anchortag = jQuery(helpIcons).children()[0];
            var link=ZDBI18NMap.f("zrpt.links.js.clouddbimport",ZDBGlobal.DID);
            ZDBUtil.setAttribute(anchortag,link,"href");
            $("CloudDBHelp").appendChild(helpIcons);
        }
        CloudDBPage.enableOptForStep();
        CloudDBPage.enableInitialPage(clouddbDlg);
        CloudDBPage.loadQueryEditor();
        var impOptionSelect = $("ZDBSCHIMPORTTYPE");
        jQuery(impOptionSelect).empty();
        var permLevel = "1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$" //DB owners have all permissions
        var perms = permLevel.split("$");
        impOptionSelect = ZDBImport.setImportOption(impOptionSelect, perms);
    };
    this.enableInitialPage = function (frm)
    {
        hideCustomMessage();
        $("SERVICENAME").options[0].selected = true;
        CloudDBPage.enableDisableDBType($("SERVICENAME").value, frm);
        $("CloudDBSingleTbl").checked = "checked"; //No I18N
        CloudDBPage.tableOrQueryOption(1);
        $("HOST").value = ""; //No I18N
        $("USERNAME").value = ""; //No I18N
        $("PASSWORD").value = ""; //No I18N
        $("INSTANCENAME").value = "";
        $("SID").value = "";
        $("CONN_CloudDBNAME").value = ""; //No I18N
        $("USESSL").checked = false;
    };
    this.enableOptForStep = function ()
    {
        var stepNo = ZDBUtil.getAttribute($("ZRCloudDBNextBtn"), "stepNo");
        var totalStep = 4;
        if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") == "true" || ZDBClientUI.isRemoteDB)
        {
            totalStep = 2;
        }
        else
        {
            $("ZRCloudDBTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",stepNo);
            $("ZRCloudDBInlineTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",stepNo);
        }
        if (stepNo == 1) {
            $("ZRCloudDBTitle").innerHTML = ZDBI18NMap.g("zrpt.home.js.connectclouddb");
            $("ZRCloudDBDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step1.description");
            $("ZRCloudDBInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.home.js.connectclouddb");
            $("ZRCloudDBInlineDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step1.description");
            $("CloudDataSource").style.display = "";
            if(ZDBClientUI.isRemoteDB || ($("CloudDBLiveConnect") && ($("SERVICENAME").value == 1 || ($("SERVICENAME").value == 2 && ZDBGlobal.isAzureLiveEnabled))
            		&& ZDBClientUI.selectedTab == null && $("CloudDBLiveConnect").checked == true))
            {
                $("ZDBRemoteDBStep2").style.display = "none";
                CloudDBPage.checkLiveConnect(true);
                if(ZDBClientUI.selectedTab)
                {
                    $("ZRCloudDBTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",stepNo);
                    $("ZRCloudDBInlineTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",stepNo);
                }
            }
            else
            {
                $("SelectTablesToImport").style.display = "none";
                $("DataSourceDetails").style.display = "none";
                if($("CloudDBLiveConnect")){
                CloudDBPage.checkLiveConnect(false);
            }
            }
            $("ZRSettings").style.display = "none";
            $("PreviewGrid").style.display = "none";
            $("SchSettings").style.display = "none";
            $("ZRCloudDBPrevBtn").style.display = "none";
            $("ZRCloudDBNextBtn").style.display = "";
            ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
            $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
            $("ZRCloudDBCreateBtn").style.display = "none";
            $("ZRCloudDBImportBtn").style.display = "none";
             $("ZRCloudDBCancelBtn").style.display = "";
            $("ZRRDBCreateBtn").style.display = "none";
            $("ZDBJOINTABLE").style.display="none";
            $("OnImpError").style.display="none";
            $("remoteDBImportNote").style.display="";
            if(ZDBClientUI.selectedTab == null)
            {
                $("ZRCloudDBTitleStep").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.stepone");
            }
            $("ShowCloudDBCmplt").style.display = "none";
            $('ZRCloudDBCmpltOk').style.display = "none";
//            if($("CloudDBPeriodicFetch")){
//            CloudDBPage.checkLiveConnect(false);
//            }
        }
        if (stepNo == 2) {
            $("ZRCloudDBTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step2.dbdataselect");
            $("ZRCloudDBDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step2.description");
            $("ZRCloudDBInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step2.dbdataselect");
            $("ZRCloudDBInlineDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step2.description");
            $("CloudDataSource").style.display = "none";
            if(ZDBClientUI.isRemoteDB || ($("CloudDBLiveConnect") && ($("SERVICENAME").value == 1 || ($("SERVICENAME").value == 2 && ZDBGlobal.isAzureLiveEnabled))
            		&& ZDBClientUI.selectedTab == null && $("CloudDBLiveConnect").checked == true))
            {
                $("ZDBRemoteDBStep2").style.display = "";
                $("ZRRDBCreateBtn").style.display = "";
                $("ZRCloudDBNextBtn").style.display = "none";
                $("ZRCloudDBTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",stepNo);
                $("ZRCloudDBInlineTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",stepNo);
                $("ZRCloudDBTitle").innerHTML = ZDBI18NMap.g("zrpt.home.import.step2.js.remotedb");
                $("ZRCloudDBInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.home.import.step2.js.remotedb");
                $("ZRCloudDBDesc").innerHTML=ZDBI18NMap.f("zrpt.home.import.js.remotedbdesc",RDBPage.serviceNameMap[$("SERVICENAME").value]);
                $("ZRCloudDBInlineDesc").innerHTML = ZDBI18NMap.f("zrpt.home.import.js.remotedbdesc",RDBPage.serviceNameMap[$("SERVICENAME").value]);
            }
            else
            {
                $("SelectTablesToImport").style.display = "";
                $("ZRCloudDBNextBtn").style.display = "";
                ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
                $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
                $("ZRRDBCreateBtn").style.display = "none";
            }
            $("MultipleTableImport").style.display = "inline-block";
            $("ZRSettings").style.display = "none";
            $("PreviewGrid").style.display = "none";
            $("SchSettings").style.display = "none";
            $("ZRCloudDBPrevBtn").style.display = "";
            $("ZRCloudDBCreateBtn").style.display = "none";
             $("ZRCloudDBCancelBtn").style.display = "";
            $("ZDBJOINTABLE").style.display="none";
            if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") == "true")
            {
                $("DataSourceDetails").style.display = "";
                $("ZRCloudDBPrevBtn").style.display = "none";
                $("MultipleTableImport").style.display = "none";
                $("ZRCloudDBTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",1);
                $("ZRCloudDBInlineTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",1);
                $("ZRCloudDBInlineTitleStep").style.display="inline-block";
            }
            $("OnImpError").style.display="none";
            $("remoteDBImportNote").style.display="none";
            $("ZRCloudDBTitleStep").style.display = "inline-block";
            $("ShowCloudDBCmplt").style.display = "none";
             $('ZRCloudDBCmpltOk').style.display = "none";
             $("ZRCloudDBImportBtn").style.display = "none";
        }
        if (stepNo == 3) {
            $("ZRCloudDBTitle").innerHTML = ZDBI18NMap.f('zrpt.databasedata.import.js.step3.dbpreviewdata', ZDBGlobal.PRODUCTNAME);
            $("ZRCloudDBDesc").innerHTML = ZDBI18NMap.f('zrpt.databasedata.import.js.step3.description', ZDBGlobal.PRODUCTNAME);
            $("ZRCloudDBInlineTitle").innerHTML = ZDBI18NMap.f("zrpt.databasedata.import.js.step3.dbpreviewdata", ZDBGlobal.PRODUCTNAME);
            $("ZRCloudDBInlineDesc").innerHTML = ZDBI18NMap.f("zrpt.databasedata.import.js.step3.description", ZDBGlobal.PRODUCTNAME);
            $("CloudDataSource").style.display = "none";
            $("SelectTablesToImport").style.display = "none";
            $("DataSourceDetails").style.display = "none";
            $("ZRSettings").style.display = "";
            $("ZRTblNameDiv").style.diplay = "";
            $("ZRExistTblNameDiv").style.display = "none";
            $("SchSettings").style.display = "none";
            $("ZRCloudDBPrevBtn").style.display = "";
            $("ZRCloudDBNextBtn").style.display = "";
             $("ZRCloudDBCancelBtn").style.display = "";
            ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
            $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
            $("ZRCloudDBCreateBtn").style.display = "none";
            $("OnImpError").style.display="";
            if ($("CloudDBCustomQuery").checked || $("CloudDBSingleTbl").checked)
            {
                $("PreviewGrid").style.display = "";

            } else
            {
                $("PreviewGrid").style.display = "none";
            }
            if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") == "true")
            {
                $("ZRDBNameDiv").style.display = "none";
                $("ZRDBDesc").style.display = "none";
                $("ZRCloudDBCreateBtn").style.display = "none";
                $("ZRCloudDBImportBtn").style.display = "";
                ZDBUtil.setAttribute($("ZRCloudDBImportBtn"), 'CloudDBPage.submitCloudDBForm(this.form)', 'onclick');
                $("ZRCloudDBNextBtn").style.display = "none";
                $("SchSettings").style.display = "";
                $("SchImportType").style.display = "block";
                $("SchCanAddNewCol").style.display = "none";
                $("SchTimeZone").style.display = "none";
                $("ZRExistTblName").innerHTML = ZDBClientUI.selectedTab.view.displayName;
                $("ZRTblNameDiv").style.display = "none";
                $("ZRExistTblNameDiv").style.display = "";
                $("ZRCloudDBTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",2);
                $("ZRCloudDBInlineTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",2);
                $("ZRCloudDBInlineTitleStep").style.display="inline-block";
            }
            if($("JOINNEEDED").value == "true")
            {
                $("ZDBJOINTABLE").style.display="";
            }
            else
            {
                $("ZDBJOINTABLE").style.display="none";
            }
            $("remoteDBImportNote").style.display="none";
            $("ShowCloudDBCmplt").style.display = "none";
             $('ZRCloudDBCmpltOk').style.display = "none";
        }
        if (stepNo == 4) {
            $("ZRCloudDBTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step4.syncsettings");
            $("ZRCloudDBDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step4.description");
            $("ZRCloudDBInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step4.syncsettings");
            $("ZRCloudDBInlineDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step4.description");
            $("CloudDataSource").style.display = "none";
            $("SelectTablesToImport").style.display = "none";
            $("DataSourceDetails").style.display = "none";
            $("ZRSettings").style.display = "none";
            $("PreviewGrid").style.display = "none";
            $("SchSettings").style.display = "";
//            $("SchImportType").style.display = "block";
//            $("SchCanAddNewCol").style.display = "block";
            $("SchTimeZone").style.display = "block";
            $("ZRCloudDBPrevBtn").style.display = "";
            $("ZRCloudDBNextBtn").style.display = "none";
            $("ZRCloudDBCreateBtn").style.display = "";
            ZDBUtil.setAttribute($("ZRCloudDBCreateBtn"), 'CloudDBPage.submitCloudDBForm(this.form)', 'onclick');
             $("ZRCloudDBCancelBtn").style.display = "";
            $("ZDBJOINTABLE").style.display="none";
            $("OnImpError").style.display="none";
            $("remoteDBImportNote").style.display="none";
            $("ShowCloudDBCmplt").style.display = "none";
             $('ZRCloudDBCmpltOk').style.display = "none";
             $("ZRCloudDBImportBtn").style.display = "none";
        }
        if(stepNo == 5)
        {
            $("ZRCloudDBTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.setupcomplete");
            $("ZRCloudDBDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.setupcmplt.desc");
            $("ZRCloudDBInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.setupcomplete");
            $("ZRCloudDBInlineDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.setupcmplt.desc");
            $("CloudDataSource").style.display = "none";
            $("SelectTablesToImport").style.display = "none";
            $("DataSourceDetails").style.display = "none";
            $("ZRSettings").style.display = "none";
            $("PreviewGrid").style.display = "none";
            $("SchSettings").style.display = "none";
            $("SchTimeZone").style.display = "none";
            $("ZRCloudDBPrevBtn").style.display = "none";
            $("ZRCloudDBNextBtn").style.display = "none";
            $("ZRCloudDBCreateBtn").style.display = "none";
            $("ZRCloudDBCancelBtn").style.display = "none";
            $("ZDBJOINTABLE").style.display="none";
            $("OnImpError").style.display="none";
            $("remoteDBImportNote").style.display="none";
            $("ShowCloudDBCmplt").style.display = "";
            $("ZRCloudDBTitleStep").style.display = "none";
            $("ZRCloudDBInlineTitleStep").style.display = "none";
             $('ZRCloudDBCmpltOk').style.display = "";
             $("ZRCloudDBImportBtn").style.display = "none";
        }

    };
    this.gotoNextStep = function (frm)
    {
        hideCustomMessage();
        var stepNo = ZDBUtil.getAttribute($("ZRCloudDBNextBtn"), "stepNo");
        ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), '', 'onclick');
        $("ZRCloudDBNextBtn").className='buttonCompBoxBg alpha';
        if (stepNo == 1)
        {
            if (!CloudDBPage.validateConnDet(frm))
            {
                ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
                $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
                return false;
            }
            if(ZDBClientUI.isRemoteDB || ($("CloudDBLiveConnect") && ($("SERVICENAME").value == 1 || ($("SERVICENAME").value == 2 && ZDBGlobal.isAzureLiveEnabled))
            		&& ZDBClientUI.selectedTab == null && $("CloudDBLiveConnect").checked == true))
            {
                if(!ZDBLazyLoadUtil.loadJsAlone("ZRRemoteDB","APPENDTODOC",CloudDBPage.gotoNextStep,[frm]))
                {
                    return;
                }
                else
                {
                    CloudDBPage.incValueByOne($("ZRCloudDBNextBtn"), "stepNo"); //No I18N
                    RDBPage.gotoNextStep();
                    return;
                }
            }
            else
            {
                CloudDBPage.testDataSourcegetTables(frm);
            }
        } else if (stepNo == 2)
        {
            if ($("CloudDBCustomQuery").checked || $("CloudDBSingleTbl").checked)
            {
                if ($("CloudDBImport").getAttribute("isExistImp") == "true")
                {
                    CloudDBPage.getPreviewForExistImport($("ZRCloudDBNextBtn"));
                } else
                {
                    CloudDBPage.showPreview($("ZRCloudDBNextBtn"));
                }
            } else
            {
                CloudDBPage.showZRSettingsPage();
            }
        } else if (stepNo == 3)
        {
            CloudDBPage.validateNames($("ZRCloudDBNextBtn"),frm);
        }
    };

    this.incValueByOne = function (el, attr)
    {
        var val = el.getAttribute(attr);
        val++;
        ZDBUtil.setAttribute(el, val, attr);
    };

    this.decValueByOne = function (el, attr)
    {
        var val = el.getAttribute(attr);
        val--;
        ZDBUtil.setAttribute(el, val, attr);
    };

    this.gotoPrevStep = function ()
    {
        hideCustomMessage();
        CloudDBPage.decValueByOne($("ZRCloudDBNextBtn"), "stepNo"); //No I18N
        CloudDBPage.enableOptForStep();
    };

    this.enableDisableDBType = function (val, frm)
    {
        var redshiftDefaultPort = 5439;
        var dbtypediv = jQuery(frm).find("#DBTypeDiv");
        var dbtype = jQuery(frm).find("#DBTYPE");
        var port = jQuery(frm).find("#PORT");
        var portdiv = jQuery(frm).find("#PortDiv");
        var servicename;
        var dbname=jQuery(frm).find("#CONN_CloudDBNAMELabel");
        var fetchtype = jQuery(frm).find("#LiveConnectDiv");
        var usernamehelp = jQuery(frm).find("#UserNameHelp");
        var hostnamelabel=jQuery(frm).find("#HOSTNAMELABEL");
        var hostnamelabeltip=jQuery(frm).find("#EndpointHelp");
        var passwordlabel=jQuery(frm).find("#PASSWORDLABEL");
        var dbpassword=jQuery(frm).find("#PASSWORD");
        var hostNameInput=jQuery(frm).find("#HOST");
        var usessldiv = jQuery(frm).find('#USESSLDiv');
        usessldiv.removeClass("alpha");
        var usessl = jQuery(frm).find('#USESSL');
        usessl.prop('checked',false); //No I18N
        if(fetchtype)
        {
                fetchtype.hide();
        }
        CloudDBPage.renderDatabaseTypes(val,frm);
        if (val == 0) { //Amazon RDS
            dbtypediv.show();
            dbtype.val(0);
            CloudDBPage.enableDisableOtherParams(0,frm);
            CloudDBPage.assignDefaultPort(0, frm);
            servicename = ZDBI18NMap.g("zrpt.databasedata.dbtype.js.amazonrds");
            usernamehelp.hide();
             portdiv.show();
            usessl.attr('disabled', false);//No I18N
        } else if (val == 1) {  //Amazon Redshift
            dbtypediv.hide();
            dbtype.val(3); //Posgres SQL
            CloudDBPage.enableDisableOtherParams(3,frm);
            servicename = ZDBI18NMap.g("zrpt.databasedata.dbtype.js.amazonredshift");
            if(fetchtype && $("LiveConnectHelp") && ZDBClientUI.selectedTab == null)
            {
                fetchtype.show();
                ZDBUtil.setAttribute($("LiveConnectHelp"),ZDBI18NMap.f("zrpt.databasedata.js.liveconnecthelptxt",ZDBGlobal.PRODUCTNAME,servicename),"tip");
            }
            port.val(redshiftDefaultPort);
            usernamehelp.hide();
             portdiv.show();
	    usessl.attr('disabled', false); //No I18N
        } else if (val == 2) {  //Microsoft Azure SQL
            dbtypediv.hide();
            dbtype.val(1);//SQL Server
            CloudDBPage.enableDisableOtherParams(1,frm);
            servicename = ZDBI18NMap.g("zrpt.databasedata.dbtype.js.azure");
            if(ZDBGlobal.isAzureLiveEnabled && fetchtype && $("LiveConnectHelp") && ZDBClientUI.selectedTab == null)
            {
                fetchtype.show();
                ZDBUtil.setAttribute($("LiveConnectHelp"),ZDBI18NMap.f("zrpt.databasedata.js.liveconnecthelptxt",ZDBGlobal.PRODUCTNAME,servicename),"tip");
            }
            var sid = jQuery(frm).find("#InstanceNameDiv");
            sid.hide();
            CloudDBPage.assignDefaultPort(1, frm);
            usernamehelp.show();
             portdiv.show();
            usessl.prop('checked',true);//No I18N
            usessldiv.addClass("alpha");
            usessl.attr('disabled', true); //No I18N
        }
        else if(val == 3) { //Other Cloud Services
            dbtypediv.show();
            dbtype.val(0);
            CloudDBPage.enableDisableOtherParams(0,frm);
            CloudDBPage.assignDefaultPort(dbtype.val(), frm);
            usernamehelp.hide();
            portdiv.show();
            usessl.attr('disabled', false);//No I18N
            servicename = ZDBI18NMap.g("Cloud database");
        }
        else if(val == 4) { //Google cloud sql
            dbtypediv.hide();
            dbtype.val(0);
            CloudDBPage.enableDisableOtherParams(0,frm);
            CloudDBPage.assignDefaultPort(0, frm);
            portdiv.hide();
            usernamehelp.hide();
            usessl.attr('disabled', false);//No I18N
            servicename = ZDBI18NMap.g("zrpt.databasedata.dbtype.js.googlecloudsql");
        }
        else if(val == 5) { //Heroku
             dbtypediv.hide();
            dbtype.val(3);
            CloudDBPage.enableDisableOtherParams(3,frm);
            CloudDBPage.assignDefaultPort(3, frm);
            portdiv.show();
            usernamehelp.hide();
            usessl.prop('checked',true);//No I18N
            usessldiv.addClass("alpha");
            usessl.attr('disabled', true); //No I18N
            servicename = ZDBI18NMap.g("zrpt.databasedata.dbtype.js.heroku");
        }
        else if (val == 9) {   //Local Database
            dbtypediv.show();
            dbtype.val(0);
            CloudDBPage.enableDisableOtherParams(0,frm);
            CloudDBPage.assignDefaultPort(0, frm);
            servicename = ZDBI18NMap.g("zrpt.databasedata.js.dbtype.localdatabase");
            portdiv.show();
            usessldiv.addClass("alpha");
            usessl.attr('disabled', true); //No I18N
         }
        hostnamelabel.html((val==9)?ZDBI18NMap.g('zrpt.databasedata.connname.js.hostname'):ZDBI18NMap.g('zrpt.databasedata.connname.js.endpoint'));
        hostnamelabeltip.attr('tip',(val==9)?ZDBI18NMap.g('zrpt.databasedata.import.js.field.hostname'):ZDBI18NMap.g('zrpt.databasedata.import.js.field.endpoint'));//No I18N
        hostNameInput.attr('errormsg',(val==9)?ZDBI18NMap.g('zrpt.databasedata.import.js.error.hostnameerr'):ZDBI18NMap.g('zrpt.databasedata.import.js.error.endpointerr'));//No I18N
        passwordlabel.attr('class',(val==9)?"":"mandatory");//No I18N
        dbpassword.attr('validatemethod',(val==9)?"":"ZDBValidator.checkValidInput");//No I18N
        dbpassword.attr('isnullable',(val==9)?"true":"false");//No I18N
        dbname.html(ZDBI18NMap.f("zrpt.databasedata.databasename.js.in",servicename));
    };
    this.renderDatabaseTypes = function(val,frm){
       var dbtypediv;
                ZDBClientUI.dBTypeJSON=JSON.parse(jQuery('#DBTYPESJSON').html());//No I18N
               if(frm==undefined){
            dbtypediv=jQuery( ZDBUtil.getCachedRef(this, "ZRCloudDBDialog")).find('#DBTYPE');
        }
        else{
           dbtypediv=jQuery(frm).find('#DBTYPE');
        }
         dbtypediv.html("");
           jQuery.each(ZDBClientUI.dBTypeJSON, function (key, data) {;
           var services=data.SERVICES;
           var servicesArray=services.split(",");
           if(servicesArray.indexOf(val.toString())>-1){
            var dbTypeDropDown=jQuery("<option id=\""+data.NAME+"\" value=\""+key+"\">"+data.DISPLAYNAME+"</option>");
            dbtypediv.append(dbTypeDropDown);
        }
           })
           };

     this.enableDisableOtherParamsZrop = function (value,frm,ele,eve){
        if(value > 5 && value != 9){
             var dbdetails = ZDBI18NMap.g('zrpt.databasedata.js.LocalandCloud'+value);
             ele.setAttribute("tip",ZDBI18NMap.f('zrpt.databasedata.js.alertToUpdatejar',ZDBGlobal.homeDir_name,dbdetails.split(",")[0],dbdetails.split(",")[1]));
             ZDBToolTip.show(ele,eve,'RIGHT'); //No I18N
        }else{
             ZDBToolTip.hide(ele);
        }
        CloudDBPage.enableDisableOtherParams(value,frm);
     }
    this.enableDisableOtherParams = function (value, frm)
    {
    	  var servicename = jQuery(frm).find("#SERVICENAME")[0].value;

          hideCustomMessage();
          if(servicename == 9 && value == 9 && ZDBGlobal.IS_ONPREMISE_BUILD) //  servicename - 9 => Local Databases ; value - 9 => SQL Server - Windows Authentication.
          {																	 //  This check is to specify to the user, the model in which the domain name and host name should be mentioned for MSSQL Windows Authentication.
        	  jQuery(frm).find("#HOST")[0].placeholder = "DomainName\\HostName";	//No I18N
          }
          else
          {
        	  jQuery(frm).find("#HOST")[0].placeholder = ""; //No I18N
          }
          jQuery(frm).find("#USERNAME")[0].value = ""; //No I18N
          jQuery(frm).find("#PASSWORD")[0].value = ""; //No I18N
          jQuery(frm).find("#INSTANCENAME")[0].value = "";//No I18N
          jQuery(frm).find("#SID")[0].value = "";//No I18N
          jQuery(frm).find("#CONN_CloudDBNAME")[0].value = ""; //No I18N
          var instanceNamediv = jQuery(frm).find("#InstanceNameDiv");
          var siddiv = jQuery(frm).find("#SIDDiv");
          var cloudDBNameDiv = jQuery(frm).find("#CloudDBNameDiv");
          var instancenamelabel=jQuery(frm).find("#INSTANCENAMELABEL");
          var sidlabel=jQuery(frm).find("#SIDLABEL");
          var dbInstanceNameHelp=jQuery(frm).find("#InstanceNameHelp");
          var usesslDiv = jQuery(frm).find('#USESSLDiv');
          var dbTypes=ZDBClientUI.dBTypeJSON;
          var dbTypeObj=dbTypes[value];
          if(dbTypeObj.INSTANCENAME.REQUIREMENT=="TRUE"){
              instanceNamediv.show();
              instancenamelabel.html(ZDBI18NMap.g(dbTypeObj.INSTANCENAME.INSTANCENAME_KEY));
          }else{
              instanceNamediv.hide();
          }
          if(dbTypeObj.SID.REQUIREMENT=="TRUE"){
              siddiv.show();
               sidlabel.html(ZDBI18NMap.g(dbTypeObj.SID.SID_KEY));
          }else{
              siddiv.hide();
          }
          if(dbTypeObj.DATABASENAME_REQUIRED=="TRUE"){
              cloudDBNameDiv.show();
          }else{
              cloudDBNameDiv.hide();
          }
          if(dbTypeObj.INSTANCENAME.INSTANCENAME_HELPKEY!=undefined){
              dbInstanceNameHelp.attr('tip',ZDBI18NMap.g(dbTypeObj.INSTANCENAME.INSTANCENAME_HELPKEY));//No I18N
              dbInstanceNameHelp.show();
          }else{
             dbInstanceNameHelp.hide();
          }
          if(dbTypeObj.SSL || dbTypeObj.DISPLAYNAME == "Oracle")
          {
              usesslDiv.show();
          }
          else
          {
              usesslDiv.hide();
          }
    };
    this.assignDefaultPort = function (dbtype, frm) {
         var port = jQuery(frm).find("#PORT");
         var dbTypes=ZDBClientUI.dBTypeJSON;
         port.val(dbTypes[dbtype].DEFAULT_PORT);
    };

    this.testDataSourcegetTables = function (frm)
    {
        var conndetails = {};
        if ($("ConnectionId").value != -10)
        {
            conndetails["CONNECTIONID"] = $("ConnectionId").value;
        }
        if ($("DBID").value != -10)
        {
            conndetails["DBID"] = $("DBID").value;
        }
        conndetails["SERVICENAME"] = $("SERVICENAME").value;
        conndetails["DATABASETYPE"] = CloudDBPage.getDatabaseType($("SERVICENAME").value);
        conndetails["HOSTNAME"] = $("HOST").value;
        conndetails["PORT"] = $("PORT").value;
        conndetails["USERNAME"] = $("USERNAME").value;
        conndetails["PASSWORD"] = encodeURIComponent($("PASSWORD").value);
        conndetails["INSTANCENAME"] = $("INSTANCENAME").value;
        conndetails["SID"] = $("SID").value;
        conndetails["CLOUDDATABASENAME"] = $("CONN_CloudDBNAME").value;
        conndetails["USESSL"] = $("USESSL").checked;
        var params = "ZDBACTION=TESTANDFETCHTABLES&CONNDETAILS=" + encodeURIComponent(JSON.stringify(conndetails)); //No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ONSUCCESSFUNC: "CloudDBPage.showSelectTablesPage", ONFAILUREFUNC: "CloudDBPage.handleFailure", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});
    };

    this.validateConnDet = function (cloudDBFrm)
    {
        ZDBUtil.setNamedChildEls(cloudDBFrm, cloudDBFrm, "name");

        var host = cloudDBFrm.HOST.value;
        if (!ZDBValidator.checkValidInput(host))
        {
            showCustomMessage(ZDBUtil.getAttribute(cloudDBFrm.HOST, "errormsg"), cloudDBFrm.HOST);
            return false;
        }

        var port = cloudDBFrm.PORT.value;
        if (!ZDBValidator.isNumber(port, false))
        {
            showCustomMessage(ZDBUtil.getAttribute(cloudDBFrm.PORT, "errormsg"), cloudDBFrm.PORT);
            return false;
        }
        if (cloudDBFrm.DBTYPE.value == 2)
        {
            var sid = cloudDBFrm.SID.value;
            if (!ZDBValidator.checkValidInput(sid))
            {
                showCustomMessage(ZDBUtil.getAttribute(cloudDBFrm.SID, "errormsg"), cloudDBFrm.SID);
                return false;
            }
        }
        var username = cloudDBFrm.USERNAME.value;
        if (!ZDBValidator.checkValidInput(username) && cloudDBFrm.DBTYPE.value != 7)
        {
            showCustomMessage(ZDBUtil.getAttribute(cloudDBFrm.USERNAME, "errormsg"), cloudDBFrm.USERNAME);
            return false;
        }

//        var password = cloudDBFrm.PASSWORD.value;
//        if (!ZDBValidator.checkValidInput(password)&&(cloudDBFrm.SERVICENAME.value!=9))
//        {
//            showCustomMessage(ZDBUtil.getAttribute(cloudDBFrm.PASSWORD, "errormsg"), cloudDBFrm.PASSWORD);
//            return false;
//        }

        var conn_clouddbname = cloudDBFrm.CONN_CloudDBNAME.value;
        if(cloudDBFrm.DBTYPE.value != 2)
        {
            if (!ZDBValidator.checkValidInput(conn_clouddbname))
            {
                showCustomMessage(ZDBUtil.getAttribute(cloudDBFrm.CONN_CloudDBNAME, "errormsg"), cloudDBFrm.CONN_CloudDBNAME);
                return false;
            }
        }
        return true;
    };


    this.showSelectTablesPage = function (response, requestOptions)
    {
        var result = JSON.parse(response.responseText);
        var tables = result.tableList;
        CloudDBPage.refreshPage($("ZRCloudDBDialog"));
        CloudDBPage.loadTableNames(tables);
        if (result.scheduleDetails != null)
        {
            var schDet = [];
            schDet = result.scheduleDetails;
            CloudDBPage.setExistScheduleDet(schDet, result.schWarnMailCount, result.scheduleTimeZone, result.displayTimeZone, $("ZRCloudDBDialog"));
        } else
        {
            CloudDBPage.setDefaultScheduleDet($("ZRCloudDBDialog"));
        }
        CloudDBPage.incValueByOne($("ZRCloudDBNextBtn"), "stepNo"); //No I18N
        CloudDBPage.enableOptForStep();
    };

    this.tableOrQueryOption = function (val)
    {
        if (val == 1)
        {
            $("SingleTblList").style.display = "";
            $("CloudDBSingleTbl").checked = "checked"; //No I18N
            $("CustomQuery").style.display = "none";
            $("MultipleTblList").style.display = "none";
        } else if (val == 2)
        {
            $("SingleTblList").style.display = "none";
            $("CustomQuery").style.display = "";
            $("CloudDBCustomQuery").checked = "checked"; //No I18N
            $("MultipleTblList").style.display = "none";
            var editor;
            if (ZDBClientUI.selectedTab != null)
            {
                editor = ZDBClientUI.selectedTab.view.editor;
            } else
            {
                editor = CloudDBPage.editorGlobal;
            }
            editor.focus();
            editor.setCursor(0, 0);
        } else if (val == 3)
        {
            $("SingleTblList").style.display = "none";
            $("CustomQuery").style.display = "none";
            $("MultipleTblList").style.display = "";
            $("CloudDBMultipleTbl").checked = "checked"; //No I18N
        }
    };
    this.refreshPage = function (frm)
    {
        jQuery($("TableNames_Single")).empty();
        jQuery($("SelectTbls")).empty();
        jQuery($("SelectedTables")).empty();
        $("SelectAllTbls").className = "zrcheckbox";
        ZDBUtil.setAttribute($("SelectAllTbls"), "false", "selected");
        ZDBUtil.setAttribute($("MultipleTblList"), 0, "totTables");
        ZDBUtil.setAttribute($("MultipleTblList"), 0, "selectedTables");
        var selectedTablesArray = [];
        var selectedSchemaArray = [];
        var reportsTableArray = [];
        ZDBUtil.setAttribute($("MultipleTblList"), selectedTablesArray.toString(), "selectedTablesArray");
        ZDBUtil.setAttribute($("MultipleTblList"), selectedSchemaArray.toString(), "selectedSchemaArray");
        ZDBUtil.setAttribute($("MultipleTblList"), reportsTableArray.toString(), "reportsTableArray");
        $("repeatinterval").options[0].selected = "true";
        CloudDBPage.toggleSchedulePeriod("none", frm); //No I18N
        $("ZDBSCHIMPORTTYPE").options[1].selected = "true";
        CloudDBPage.showMatchColList($("ZDBSCHIMPORTTYPE"));
        if($("DBTYPE").value != 2)
        {
            $("ZRDBName").value = $("CONN_CloudDBNAME").value;
        }
        else
        {
            $("ZRDBName").value = $("SID").value;
        }
        $("ZRDBDesc").value = "";
        $("ZDBCANADDNEWCOLUMN").checked = false;
    };

    this.loadQueryEditor = function ()
    {
        if (!ZDBLazyLoadUtil.loadJsAlone("ZRQueryEditor", "APPENDTODOC", CloudDBPage.loadQueryEditor))
        {
            return;
        }
        if (!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_QUERYEDITOR", "APPENDTODOC", CloudDBPage.loadQueryEditor)) {
            return;
        }
        jQuery($("CustomQuery")).empty();
        var textarea = document.createElement("textarea");
        textarea.setAttribute("id", "QueryEditor");
        $("CustomQuery").appendChild(textarea);
        var textArea = $("QueryEditor");
        var editor = CodeMirror.fromTextArea(textArea, {
            mode: "text/x-mysql", //No I18N
            lineNumbers: true,
            styleActiveLine: true,
            //autoCloseBrackets: true,
            matchBrackets: true,
            scrollbarStyle: "simple", //No I18N
            //extraKeys: {"Ctrl-Space": "autocomplete", "Alt-F": "findPersistent", "Ctrl-G": "findNext", "Shift-Ctrl-G": "findPrev", "Ctrl-F": "find", "Ctrl-J": "jump"}, //No I18N
            //extraKeys: {"Ctrl-Space": "autocomplete"},//No I18N
            highlightSelectionMatches: {showToken: /\w/},
        });
        editor.setSize(null, 135);
        if (ZDBClientUI.selectedTab != null)
        {
            ZDBClientUI.selectedTab.view.editor = editor;
        } else
        {
            CloudDBPage.editorGlobal = editor;
        }
    };

    this.loadTableNames = function (tableList)
    {
        var editor;
        if (ZDBClientUI.selectedTab != null)
        {
            editor = ZDBClientUI.selectedTab.view.editor;
        } else
        {
            editor = CloudDBPage.editorGlobal;
        }
	var tableName = tableList[0];
        var schema = tableName["SCH_NAME"];
	var tableNameWithoutSchema = tableName["TBL_NAME"];
	var dispName = (schema)?(schema+'.'+tableNameWithoutSchema):tableNameWithoutSchema; //No I18N
        var sampleQuery = "SELECT * FROM " + dispName + "\n\n/* " + ZDBI18NMap.g("zrpt.databasedata.js.queryeditor.qry_msg") + " */\n\n\n\n\n\n\n"; //No I18N
        editor.setValue(sampleQuery);
        ZDBUtil.setAttribute($("MultipleTblList"), tableList.length, "totTables");
        for (var i = 0; i < tableList.length; i++)
        {
            CloudDBPage.loadSingleTblList(tableList[i]);
            CloudDBPage.loadMultipleTblList(tableList[i]);
        }
    };

    this.loadSingleTblList = function (tableName)
    {
        var singleTblList = $("TableNames_Single");
        var option = document.createElement("option");
        var schema = tableName["SCH_NAME"];
        var tableNameWithoutSchema = tableName["TBL_NAME"];
        var dispName = (schema)?(schema+'.'+tableNameWithoutSchema):tableNameWithoutSchema; //No I18N
        option.value = tableNameWithoutSchema;
        if(schema){
        	option.setAttribute('SCHEMA',schema);
        }
        option.setAttribute('TBLNAME',tableNameWithoutSchema);
        option.text = dispName;
        singleTblList.appendChild(option);
    };

    this.loadMultipleTblList = function (tbEl)
    {
        var selectTbl = $("SelectTbls");
        var tblDiv = document.createElement("span");
        var schema = tbEl["SCH_NAME"];
        var tableNameWithoutSchema = tbEl["TBL_NAME"];
        var dispName = (schema)?(schema+'.'+tableNameWithoutSchema):tableNameWithoutSchema; //No I18N
        tblDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(dispName);
        if(schema){
        	tblDiv.setAttribute('SCHEMA',schema);
        }
        tblDiv.setAttribute('TBLNAME',tableNameWithoutSchema);
        tblDiv.className = "zrcheckbox";
        tblDiv.onclick = CloudDBPage.selectTables;
        ZDBUtil.setAttribute(tblDiv, "false", "added");
        ZDBUtil.setAttribute(tblDiv, "false", "selected");
        selectTbl.appendChild(tblDiv);
    };
    this.selectTables = function (event)
    {
        var el = window.event ? window.event.srcElement : event.target;
        var attrVal = ZDBUtil.getAttribute(el, "selected");
        var status = (attrVal == "true") ? "false" : "true";
        CloudDBPage.selectDBTables(el, status);
    };

    this.selectDBTables = function (el, attrVal)
    {
        var added = ZDBUtil.getAttribute(el, "added");
        ZDBUtil.setAttribute(el, attrVal, "selected");
        var selectedTblCont = $("SelectedTables");
        var selectedTablesArray = [];
        var selectedSchemaArray = [];
        if (ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray") != "")
            selectedTablesArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray").split(',');
        if (ZDBUtil.getAttribute($("MultipleTblList"), "selectedSchemaArray") != "")
        	selectedSchemaArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedSchemaArray").split(',');
        if (attrVal == "true" && added == "false")
        {
            el.className = "zrcheckboxsel";
            ZDBUtil.setAttribute(el, "true", "added");
            var selectedTbl = document.createElement("div");
            var selectedTblClose = document.createElement("input");
            selectedTblClose.setAttribute("type", "button");
            selectedTblClose.className = "zrdbRemoveSelTbl";
            selectedTbl.innerHTML = el.innerHTML;
            selectedTbl.setAttribute("value",el.getAttribute("tblname"));
            selectedTblClose.onclick = CloudDBPage.removeSelectedTables;
            selectedTbl.appendChild(selectedTblClose);
            selectedTbl.selectTbl = el;
            selectedTbl.className = "zrdbSelectedTbl";
            el.selectedTbl = selectedTbl;
            CloudDBPage.incValueByOne($("MultipleTblList"), "selectedTables"); //No I18N
            if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0)
            {
                CloudDBPage.incValueByOne($("MultipleTblList"), "matchedTablesSelectedCont"); //No I18N
            }
            selectedTablesArray.push(el.getAttribute("TBLNAME"));
            selectedSchemaArray.push((el.getAttribute("SCHEMA"))?el.getAttribute("SCHEMA"):"null"); //No I18N
            ZDBUtil.setAttribute($("MultipleTblList"), selectedTablesArray.toString(), "selectedTablesArray");
            ZDBUtil.setAttribute($("MultipleTblList"), selectedSchemaArray.toString(), "selectedSchemaArray");
            selectedTblCont.appendChild(selectedTbl);
        } else if (attrVal == "false" && added == "true")
        {
            el.className = "zrcheckbox";
            ZDBUtil.setAttribute(el, "false", "added");
            CloudDBPage.decValueByOne($("MultipleTblList"), "selectedTables"); //No I18N
            if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0)
            {
                CloudDBPage.decValueByOne($("MultipleTblList"), "matchedTablesSelectedCont"); //No I18N
            }

            var tblName = el.getAttribute('tblname');
            var index = selectedTablesArray.indexOf(tblName);
            selectedTablesArray.splice(index, 1);
            selectedSchemaArray.splice(index, 1);
            ZDBUtil.setAttribute($("MultipleTblList"), selectedTablesArray.toString(), "selectedTablesArray");
            ZDBUtil.setAttribute($("MultipleTblList"), selectedSchemaArray.toString(), "selectedSchemaArray");
            var selectedTbl = el.selectedTbl;
            jQuery(selectedTbl).remove();
        }
        var selectAllEl = $("SelectAllTbls");
        if ((ZDBUtil.getAttribute($("MultipleTblList"), "selectedTables") == ZDBUtil.getAttribute($("MultipleTblList"), "totTables")) || (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0 && ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") == ZDBUtil.getAttribute($("MultipleTblList"), "matchedTablesSelectedCont")))
        {
            selectAllEl.className = "zrcheckboxsel";
            ZDBUtil.setAttribute(selectAllEl, "true", "selected");
        } else
        {
            selectAllEl.className = "zrcheckbox";
            ZDBUtil.setAttribute(selectAllEl, "false", "selected");
        }
        if(selectedTablesArray.length> 0)
    {
              $("ZRCloudDBRemoveAll").style.display = "";
    }
    else
    {
              $("ZRCloudDBRemoveAll").style.display = "none";
    }

    };
    this.removeSelectedTables = function (event)
    {
        var srcEl = window.event ? window.event.srcElement : event.target;
        var el = jQuery(srcEl).parent("div").get(0);        //No I18N
        el.selectTbl.className = "zrcheckbox";
        CloudDBPage.decValueByOne($("MultipleTblList"), "selectedTables"); //No I18N
        if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0 && jQuery(el.selectTbl).is(":visible") && (ZDBUtil.getAttribute(el.selectTbl, "selected") == "true"))
            CloudDBPage.decValueByOne($("MultipleTblList"), "matchedTablesSelectedCont"); //No I18N
        ZDBUtil.setAttribute(el.selectTbl, "false", "added");
        ZDBUtil.setAttribute(el.selectTbl, "false", "selected");
        var selectedTablesArray = [];
        var selectedSchemaArray = [];
        selectedTablesArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray").split(',');
	selectedSchemaArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedSchemaArray").split(',');
        var index = selectedTablesArray.indexOf(ZDBUtil.getAttribute(el,"value"));
        selectedTablesArray.splice(index, 1);
	selectedSchemaArray.splice(index, 1);
        ZDBUtil.setAttribute($("MultipleTblList"), selectedTablesArray.toString(), "selectedTablesArray");
	ZDBUtil.setAttribute($("MultipleTblList"), selectedSchemaArray.toString(), "selectedSchemaArray");
        jQuery(el).remove();
        var selectAllTbl = $("SelectAllTbls");
        if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") && !jQuery(el.selectTbl).is(":visible") && (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") == ZDBUtil.getAttribute($("MultipleTblList"), "matchedTablesSelectedCont")))    //No I18N
        {
            selectAllTbl.className = "zrcheckboxsel";
            ZDBUtil.setAttribute(selectAllTbl, "true", "selected");
        } else
        {
            selectAllTbl.className = "zrcheckbox";
            ZDBUtil.setAttribute(selectAllTbl, "false", "selected");
        }
        if(selectedTablesArray.length <= 0)
    {
        $("ZRCloudDBRemoveAll").style.display = "none";
    }
    };
    this.selectAllTables = function (el)
    {
        var selected = ZDBUtil.getAttribute(el, "selected");
        var selectTblCont = $("SelectTbls");
        var selectTblList = jQuery(selectTblCont).children(":visible");        //No I18N
        el.className = (selected == "true") ? "zrcheckbox" : "zrcheckboxsel";
        var status = (selected == "true") ? "false" : "true";
        ZDBUtil.setAttribute(el, status, "selected");
        for (var i = 0; i < selectTblList.length; i++)
        {
            var selectTbl = selectTblList[i];
            CloudDBPage.selectDBTables(selectTbl, status);
        }
    };
    this.removeAllTables = function ()
    {
        var selectedTblCont = $("SelectedTables");
        var selectedTbl = selectedTblCont.getElementsByTagName("div");
        for (var i = selectedTbl.length; i > 0; i--)
        {
            var selectTbl = selectedTbl[0].selectTbl;
            CloudDBPage.selectDBTables(selectTbl, "false");
        }
    };
    this.searchTables = function (searchEl)
    {
        ZDBUtil.setAttribute($("MultipleTblList"), 0, "matchedCount");
        ZDBUtil.setAttribute($("MultipleTblList"), 0, "matchedTablesSelectedCont");
        var value = ZDBSearchUtil.getSearchValue(searchEl);
        value = (value) ? value.toLowerCase() : "";
        var selectTbl = $("SelectTbls");
        var tblsList = selectTbl.getElementsByTagName("span");
        if (selectTbl.getElementsByTagName("div"))
            jQuery(selectTbl.getElementsByTagName("div")).remove();
        var tblDiv = document.createElement("div");
        tblDiv.innerHTML = ZDBI18NMap.g("zrpt.databasedata.js.no_matching_tables");
        tblDiv.className = "noData";
        selectTbl.appendChild(tblDiv);
        for (var i = 0; i < tblsList.length; i++)
        {
            var tblEl = tblsList[i];
            var tblName = tblEl.innerHTML;
            var matched = ((tblName.toLowerCase().indexOf(value)) > -1);
            tblEl.style.display = (matched || (value == null) || (value == "")) ? "block" : "none";
            if (matched || (value == null) || (value == ""))
                CloudDBPage.incValueByOne($("MultipleTblList"), "matchedCount"); //No I18N
            if ((ZDBUtil.getAttribute(tblEl, "selected") == "true") && (matched || (value == null) || (value == "")))
                CloudDBPage.incValueByOne($("MultipleTblList"), "matchedTablesSelectedCont"); //No I18N
        }
        if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0)
            jQuery(tblDiv).remove();
        var selectAllEl = $("SelectAllTbls");
        if ((ZDBUtil.getAttribute($("MultipleTblList"), "selectedTables") == ZDBUtil.getAttribute($("MultipleTblList"), "totTables")) || (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0 && ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") == ZDBUtil.getAttribute($("MultipleTblList"), "matchedTablesSelectedCont")))
        {
            selectAllEl.className = "zrcheckboxsel";
            ZDBUtil.setAttribute(selectAllEl, "true", "selected");
        } else
        {
            selectAllEl.className = "zrcheckbox";
            ZDBUtil.setAttribute(selectAllEl, "false", "selected");
        }
    };
    this.checkKeyAndSearch = function (el, ev)
    {
        CloudDBPage.searchTables(el);
        return true;
    };
    this.showPreview = function (el)
    {
        var conndetails = {};
        if ($("ConnectionId").value != -10)
        {
            conndetails["CONNECTIONID"] = $("ConnectionId").value;
        }
        if ($("DBID").value != -10)
        {
            conndetails["DBID"] = $("DBID").value;
        }
        conndetails["SERVICENAME"] = $("SERVICENAME").value;
        conndetails["DATABASETYPE"] =CloudDBPage.getDatabaseType($("SERVICENAME").value);
        conndetails["HOSTNAME"] = $("HOST").value;
        conndetails["PORT"] = $("PORT").value;
        conndetails["USERNAME"] = $("USERNAME").value;
        conndetails["PASSWORD"] = encodeURIComponent($("PASSWORD").value);
        conndetails["INSTANCENAME"] = $("INSTANCENAME").value;
        conndetails["SID"] = $("SID").value;
        conndetails["CLOUDDATABASENAME"] = $("CONN_CloudDBNAME").value;
        conndetails["USESSL"] = $("USESSL").checked;
        var params = "ZDBACTION=SHOWPREVIEW&CONNDETAILS=" + encodeURIComponent(JSON.stringify(conndetails)); //No I18N
        var query;
        if ($("CloudDBCustomQuery").checked)
        {
            var editor;
            if (ZDBClientUI.selectedTab != null)
            {
                editor = ZDBClientUI.selectedTab.view.editor;
            } else
            {
                editor = CloudDBPage.editorGlobal;
            }
            query = editor.getValue();
            editor.setCursor(0, 0);
            query = query.replace(/(\/\*([\s\S]*?)\*\/)|(\/\/(.*)$)/gm, ''); //to remove comments
            query = query.replace(/\r?\n|\r/g, " "); //to remove new line
            query = query.trim(); //to remove white space at end
            $("CustomQueryValue").setAttribute("query",query);
            if (!CloudDBPage.validateQuery(query))
            {
                ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
                $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
                return;
            }
            params = params + "&QUERYTYPE=" + 2; //No I18N
            params = params + "&CUSTOMQUERY=" + encodeURIComponent(query); //No I18N
        } else if ($("CloudDBSingleTbl").checked)
        {
            params = params + "&QUERYTYPE=" + 1; //No I18N
            var tableNameWithSchema = CloudDBPage.getTableNamewithSchemaName($("TableNames_Single"));
            params = params + "&TABLENAME=" + encodeURIComponent(tableNameWithSchema[0]);//No I18N
            if(tableNameWithSchema.length>1 && tableNameWithSchema[1]!=null){
            	params = params + "&SCHEMANAME=" + encodeURIComponent(tableNameWithSchema[1]); //No I18N
            }
        }
        params += "&FILETYPE=CSV&LOCATION=CLOUDDATABASE"; //No I18N
        if($("DBID").value != -10)
        {
            params+="&DBID="+ZDBClientUI.dbId; //No I18N
        }
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ELEMENT: el, ONSUCCESSFUNC: "CloudDBPage.handlePreviewScript", ONFAILUREFUNC: "CloudDBPage.handleFailure", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});

    };
    this.getTableNamewithSchemaName = function(tableEl){
    	var tblNameAndSchema = [];
    	tblNameAndSchema.push(tableEl.value);
        var schema = tableEl.options[tableEl.selectedIndex].getAttribute("SCHEMA");
        if(schema){
        	tblNameAndSchema.push(schema);
        }
    	return tblNameAndSchema;
    }
    this.getTableNamewithSchema = function(tableNameWithSchema){
    	var tblNameAndSchema = [];
    	var schemaRegex = new RegExp('\\[.*\\]\\.\\[.*\\]');
    	if(schemaRegex.test(tableNameWithSchema)){
    		var temp = tableNameWithSchema.match(/\.\[.*\]/);
    		tblNameAndSchema.push(temp[0].substring(2,temp[0].length-1));
    		temp = tableNameWithSchema.match(/\[.*\]\./);
    		tblNameAndSchema.push(temp[0].substring(1,temp[0].length-2));
    		return tblNameAndSchema;
    	}
    	tblNameAndSchema.push(tableNameWithSchema);
    	return tblNameAndSchema;
    };
    this.setDateFormat = function (jsonObj)
    {
        if (jsonObj.csvConfig)
        {
            var csvconfig = jsonObj.csvConfig;
            if (csvconfig[4].dateFormat != null && csvconfig[4].dateFormat != "")
            {
                $("ZOHO_DATE_FORMAT").value = csvconfig[4].dateFormat;
            }
        }
    };
    this.validateQuery = function (query)
    {
        if (query == "")
        {
            ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
            $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
            ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.querytable.errmsg.js.noSQLQueryErr"), null, null);
            return false;
        } else if (query.substr(0, 6).toLowerCase() != "select") //No I18N
        {
            ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
            $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
            ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.querytable.errmsg.js.onlySelQueriesAllowed"), null, null);
            return false;
        }
        return true;
    };
    this.handlePreviewScript = function (response, requestOptions)
    {
        if (!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList", "APPENDTODOC", CloudDBPage.handlePreviewScript, [response, requestOptions]))
        {
            return;
        }


        jQuery($("SampleTableHolder")).empty();
        $("PreviewGrid").style.display = "block";
        var responseString = JSON.parse(response.responseText);
        var filename = responseString.FILENAME;
        $("FILENAME").setAttribute("value", filename);
        var sampleTblScript = responseString.SAMPLETBLSCRIPT;
        var previewGrid = invokeSampleTableScripts(JSON.parse(sampleTblScript));
        $("ZDBJOINTABLE").style.marginRight = "400px";//No I18N
        if(JSON.parse(sampleTblScript).IDENTIFIEDJOINS)
        {
            $("JOINNEEDED").value = "true";
        }
        else
        {
            $("JOINNEEDED").value = "false";
        }
        CloudDBPage.setDateFormat(JSON.parse(sampleTblScript));
        addSampleTableToView(previewGrid, true);
        if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") == "false")
        {
            ZDBImport.setExistColumnList(previewGrid);
        }
        CloudDBPage.showZRSettingsPage();
    };
    this.showZRSettingsPage = function ()
    {
        jQuery($("ZRSelectedMultipleTbls")).empty();
        if ($("DBID").value != -10)
        {
            $("ZRDBNameDiv").style.display = "none";
            $("ZRDBDesc").style.display = "none";
        } else
        {
            $("ZRDBNameDiv").style.display = "block";
            $("ZRDBDesc").style.display = "block";
        }
        if ($("CloudDBSingleTbl").checked || $("CloudDBCustomQuery").checked)
        {
            $("ZRTblNameDiv").style.display = "";
            $("ZRMultipleTblNames").style.display = "none";
            if ($("CloudDBSingleTbl").checked)
            {
                $("ZRTblName").value = $("TableNames_Single").value;
            } else if ($("CloudDBCustomQuery").checked)
            {
                $("ZRTblName").value = "New Table"; //No I18N
            }
            if($("ZDBSCHIMPORTTYPE").options[2])
            {
                $("ZDBSCHIMPORTTYPE").options[2].disabled = false;
            }
            if($("ZDBSCHIMPORTTYPE").options[3])
            {
                $("ZDBSCHIMPORTTYPE").options[3].disabled = false;
            }
            if($("CloudDBCustomQuery").checked)
            {
                $("ZDBSCHIMPORTTYPE").options[0].selected = "true";
            }
            else
            {
                $("ZDBSCHIMPORTTYPE").options[1].selected = "true";
            }

        } else if ($("CloudDBMultipleTbl").checked)
        {
            $("JOINNEEDED").value = "false";
            if (ZDBUtil.getAttribute($("MultipleTblList"), "selectedTables") == 0)
            {
                ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.databasedata.multipletbl.js.notableselected"), null, null);
                ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
                $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
                return false;
            }
            $("ZRTblNameDiv").style.display = "none";
            $("ZRMultipleTblNames").style.display = "";
            $("PreviewGrid").style.display = "none";
            CloudDBPage.loadSelectedMultipleTblNames();
            $("ZDBSCHIMPORTTYPE").options[1].selected = true;
            CloudDBPage.showMatchColList($("ZDBSCHIMPORTTYPE"));
            if($("ZDBSCHIMPORTTYPE").options[2])
            {
                $("ZDBSCHIMPORTTYPE").options[2].disabled = true;
            }
            if($("ZDBSCHIMPORTTYPE").options[3])
            {
                $("ZDBSCHIMPORTTYPE").options[3].disabled = true;
            }
            $("ZDBSCHIMPORTTYPE").options[1].selected = "true";
        }
        CloudDBPage.incValueByOne($("ZRCloudDBNextBtn"), "stepNo"); //No I18N
        CloudDBPage.enableOptForStep();
        if ($("DBID").value != -10)
        {
            if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") != "true" && !$("CloudDBMultipleTbl").checked)
            {
                $("ZRTblName").focus();
            }
        }
        else
        {
            $("ZRDBName").focus();
        }
    };
   this.loadSelectedMultipleTblNames = function ()
    {
        var selectedTablesArray = [];
	var reportsTableArray = [];
        var selectedTablesArrayStr = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray");
        selectedTablesArray = selectedTablesArrayStr.split(',');
	var selectedSchemaArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedSchemaArray").split(',');
        var selectedTbls = $("SelectedTblsFinal");
        var reportstbls = $("ReportsTables");
        jQuery(reportstbls).empty();
        jQuery(selectedTbls).empty();
        for (i = 0; i < selectedTablesArray.length; i++)
        {
            var tblDiv = document.createElement("span");
            ZDBUtil.setAttribute(tblDiv,selectedTablesArray[i]+"_tbl","id");
            tblDiv.innerHTML = (selectedSchemaArray[i] && selectedSchemaArray[i]!='null')?(selectedSchemaArray[i]+'.'+selectedTablesArray[i]):selectedTablesArray[i]; //No I18N
	    //reportsTableArray.push(tblDiv.innerHTML);
            tblDiv.className = "zrdbSelectedTblFinal";
            tblDiv.style.display = "block";
            selectedTbls.appendChild(tblDiv);
            var reportstblDiv = document.createElement("div");
            var reportstblnameDiv = document.createElement("span");
            reportstblnameDiv.style.display="inline-block";
            reportstblnameDiv.style.textOverflow="ellipsis"; //No I18N
            reportstblnameDiv.style.overflow="hidden";
            reportstblnameDiv.style.maxWidth="260px"; //No I18N
            //reportstblnameDiv.innerHTML = ZDBEscapeUtil.encodeForHtml((selectedSchemaArray[i] && selectedSchemaArray[i]!='null')?(selectedSchemaArray[i]+'.'+selectedTablesArray[i]):selectedTablesArray[i]); //No I18N
            reportstblnameDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(selectedTablesArray[i]);
            ZDBUtil.setAttribute(reportstblDiv,"CloudDBPage.editRepTblName(this,event)","onclick");
            reportstblDiv.appendChild(reportstblnameDiv);
            reportstblDiv.className = "zrdbSelectedTbl";
            reportstblDiv.style.display = "block";
            ZDBUtil.setAttribute(reportstblDiv,selectedTablesArray[i],"orgTbl");
            ZDBUtil.setAttribute(reportstblDiv,selectedTablesArray[i],"id");
            ZDBUtil.setAttribute(reportstblDiv,"CloudDBPage.highLytPar(this)","onmouseover");
            ZDBUtil.setAttribute(reportstblDiv,"CloudDBPage.dehighLytPar(this)","onmouseout");
            reportstblDiv.style.paddingLeft="0px";//No I18N
            var reportstbleditDiv = document.createElement("div");
            reportstbleditDiv.className = "zrdbEditRepTbl";
            reportstblDiv.appendChild(reportstbleditDiv);
            reportstbls.appendChild(reportstblDiv);
        }

        reportsTableArray = selectedTablesArray.slice();
        ZDBUtil.setAttribute($("MultipleTblList"), reportsTableArray.toString(), "reportsTableArray");
    };

    this.validateNames = function (el,frm)
    {
        var params = "";
        var importparams = {};
        if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") == "false")
        {
            if ($("CloudDBSingleTbl").checked || $("CloudDBCustomQuery").checked)
            {
                if (!ZDBValidator.checkValidInput($("ZRTblName").value) || !ZDBValidator.checkLength($("ZRTblName").value,$("ZRTblName")))
                {
                    showCustomMessage(ZDBUtil.getAttribute($("ZRTblName"), "errormsg"), $("ZRTblName"));
                    ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
                    $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
                    return false;
                }
            } else
            {
                if(!CloudDBPage.validatemultipletablenames())
                {
                     ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
                     $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
                    return false;
                }

            }
            if ($("DBID").value == -10)
            {
                if (!ZDBValidator.checkValidInput($("ZRDBName").value)|| !ZDBValidator.checkLength($("ZRDBName").value,$("ZRDBName")))
                {
                    showCustomMessage(ZDBUtil.getAttribute($("ZRDBName"), "errormsg"), $("ZRDBName"));
                    ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
                    $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
                    return false;
                }
                importparams["DBNAME"] = $("ZRDBName").value;
                importparams["DESCRIPTION"] = $("ZRDBDescription").value;
            } else
            {
                params += "DBID=" + $("DBID").value; //No I18N
                if ($("CloudDBSingleTbl").checked || $("CloudDBCustomQuery").checked)
                {
                    if ($("CloudDBSingleTbl").checked)
                    {
                        importparams["DATAFETCHTYPE"] = 1;
                        var singletable = {};
                        singletable["ONPREMISETBNAME"] = $("TableNames_Single").value;
                        singletable["ZOHOREPORTSTBNAME"] = $("ZRTblName").value;
                        importparams["SINGLETABLEORQUERY"] = singletable;
                    } else if ($("CloudDBCustomQuery").checked)
                    {
                        importparams["DATAFETCHTYPE"] = 2;
                        var customquery = {};
                        customquery["ONPREMISECUSTOMQUERY"] = $("CustomQueryValue").getAttribute("query");
                        customquery["ZOHOREPORTSTBNAME"] = $("ZRTblName").value;
                        importparams["SINGLETABLEORQUERY"] = customquery;
                    }
                } else
                {
                    importparams["DATAFETCHTYPE"] = 3;
                    var multipleTable = [];
                    var selectedTablesArray = [];
                    selectedTablesArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray").split(',');
                    var selectedSchemaArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedSchemaArray").split(',');
                    var reportsTableArray = [];
                    reportsTableArray = ZDBUtil.getAttribute($("MultipleTblList"), "reportsTableArray").split(',');
                    for (i = 0; i < selectedTablesArray.length; i++)
                    {
                        var tablenames = {};
                        //var tableNameWithSchema = CloudDBPage.getTableNamewithSchemaName(ZDBEscapeUtil.decodeForHtml(selectedTablesArray[i]));
                        tablenames["ONPREMISETBNAME"] = ZDBEscapeUtil.decodeForHtml(selectedTablesArray[i]);
                        tablenames["ZOHOREPORTSTBNAME"] = reportsTableArray[i];
			if(selectedSchemaArray[i] && selectedSchemaArray[i]!='null'){
                        tablenames["ONPREMISESCHEMA"] = ZDBEscapeUtil.decodeForHtml(selectedSchemaArray[i]); //(tableNameWithSchema.length>1)?tableNameWithSchema[1]:null;
			}
                        multipleTable.push(tablenames);
                    }
                    importparams["MULTIPLETABLE"] = multipleTable;
                }
            }
            params += "&TABLEDETAILS=" + encodeURIComponent(JSON.stringify(importparams)); //No I18N
        }
        params += "&ZDBACTION=VALIDATETABLENAMES"; //No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ELEMENT:frm, ONSUCCESSFUNC: "CloudDBPage.showSyncSettings", ONFAILUREFUNC: "CloudDBPage.handleFailure", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});
    };
    this.showSyncSettings = function (response, requestOptions)
    {
	//--ZROP Changes--
		if(ZDBGlobal.IS_ONPREMISE_BUILD && ZDBGlobal.IS_FREE_EDITION){
			$("repeatinterval").setAttribute("disabled","disabled"); //No I18N
			$("repeatintervalerr").style.display="table"; //No I18N
		}
		else{
			$("repeatinterval").removeAttribute("disabled"); //No I18N
			$("repeatintervalerr").style.display="none"; //NO I18N
		}
	//--ZROP Changes--
        CloudDBPage.incValueByOne($("ZRCloudDBNextBtn"), "stepNo"); //No I18N
        CloudDBPage.enableOptForStep();
        CloudDBPage.toggleSchedulePeriod($("repeatinterval").value,requestOptions['ELEMENT'])
    };
    this.showMatchColList = function (element)
    {
        var matchCol = jQuery(element).siblings("[id='MatchingColumns']")[0];
        if (element.value == "UPDATEADD" || element.value == "DELETEUPDATEADD")
        {
            matchCol.style.display = "block";
        } else
        {
            matchCol.style.display = "none";
        }
    };

    this.toggleSchedulePeriod = function (optValue, frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        if(frm.schedule_minutes){
            frm.schedule_minutes.style.display = "none";
        }
        frm.schedule_periodic.style.display = "none";
        frm.schedule_daily.style.display = "none";
        frm.schedule_weekly.style.display = "none";
        frm.schedule_monthly.style.display = "none";

	
	/*15,30 and 45 minutes enabled by mistake in IDC - should be shown only in OP build.
	This is for users who have alreday scheduled  mins schedule in IDC*/ 
	if(optValue=="minutes" && !ZDBGlobal.IS_ONPREMISE_BUILD){
		optValue = "none"; // No I18N
	}	

        if (optValue != "none")
        {
            var enableDiv;
            if(optValue ==  "minutes")
            {
                enableDiv=frm.schedule_minutes;
            }
            if(optValue == "periodic")
            {
                enableDiv = frm.schedule_periodic;
            }
            else if (optValue == "daily")
            {
                enableDiv = frm.schedule_daily;
            } else if (optValue == "weekly") //No I18N
            {
                enableDiv = frm.schedule_weekly;
            } else if (optValue == "monthly") //No I18N
            {
                enableDiv = frm.schedule_monthly;
            }
            enableDiv.style.display = "";
            frm.sch_failure_warning.style.display = "";
            if(frm.SchImportType && frm.SchCanAddNewCol)
            {
                frm.SchImportType.style.display = "";
                frm.SchCanAddNewCol.style.display = "";
            }
        } else
        {
            frm.sch_failure_warning.style.display = "none";
            if(frm.SchImportType && frm.SchCanAddNewCol)
            {
                frm.SchImportType.style.display = "none";
                frm.SchCanAddNewCol.style.display = "none";
            }
        }
    };
    this.submitCloudDBForm = function (frm)
    {
        var params = "";
        var conndetails = {};
        var importparams = {};
        var isExistImp = false;
        if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") == "false")
        {
            ZDBUtil.setAttribute($("ZRCloudDBCreateBtn"), '', 'onclick');
            if ($("ConnectionId").value != -10)
            {
                conndetails["CONNECTIONID"] = $("ConnectionId").value;
            }
            if ($("DBID").value != -10)
            {
                conndetails["DBID"] = $("DBID").value;
            }
            conndetails["SERVICENAME"] = $("SERVICENAME").value;
            conndetails["DATABASETYPE"] =CloudDBPage.getDatabaseType($("SERVICENAME").value);
            conndetails["HOSTNAME"] = $("HOST").value;
            conndetails["PORT"] = $("PORT").value;
            conndetails["USERNAME"] = $("USERNAME").value;
            conndetails["PASSWORD"] = encodeURIComponent($("PASSWORD").value);
            conndetails["INSTANCENAME"] = $("INSTANCENAME").value;
            conndetails["SID"] = $("SID").value;
            conndetails["CLOUDDATABASENAME"] = $("CONN_CloudDBNAME").value;
            conndetails["USESSL"] = $("USESSL").checked;
            if ($("DBID").value == -10)
            {
                importparams["DBNAME"] = $("ZRDBName").value;
                importparams["DESCRIPTION"] = $("ZRDBDescription").value;
                params = "ZDBACTION=CREATEDATASRCDBANDTBL"; //No I18N
            }
            else
            {
                importparams["DBNAME"] = $("ZDBDBNAME").innerHTML;
                 params = "ZDBACTION=CREATEDATASRCANDTBL"; //No I18N
                 params += "&DBID=" + ZDBClientUI.dbId; //No I18N
            }
            params += "&CONNDETAILS=" + encodeURIComponent(JSON.stringify(conndetails)); //No I18N
        } else
        {
            ZDBUtil.setAttribute($("ZRCloudDBImportBtn"), '', 'onclick');
            params = "ZDBACTION=EXISTIMPORTCLOUDDB"; //No I18N
            params += "&CONNECTIONID=" + $("ExistImpConnectionId").innerHTML; //No I18N
            params += "&OBJID=" + $("ExistImpObjId").innerHTML; //No I18N
            params += "&DBID=" + ZDBClientUI.dbId; //No I18N
            params+="&EXISTTBLNAME="+encodeURIComponent(ZDBClientUI.selectedTab.view.displayName); //No I18N
            isExistImp = true;
        }
        if ($("CloudDBSingleTbl").checked || $("CloudDBCustomQuery").checked)
        {
            if ($("CloudDBSingleTbl").checked)
            {
                importparams["DATAFETCHTYPE"] = 1;
                var singletable = {};
                var tableNamewithSchema = CloudDBPage.getTableNamewithSchemaName($("TableNames_Single"));
                singletable["ONPREMISETBNAME"] = tableNamewithSchema[0];
                if(tableNamewithSchema.length>1 && tableNamewithSchema[1]){
                	singletable["ONPREMISESCHEMA"] = (tableNamewithSchema[1])?tableNamewithSchema[1]:null;
                }
                if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") == "false")
                {
                    singletable["ZOHOREPORTSTBNAME"] = $("ZRTblName").value;
                }
                importparams["SINGLETABLEORQUERY"] = singletable;
            } else if ($("CloudDBCustomQuery").checked)
            {
                importparams["DATAFETCHTYPE"] = 2;
                var customquery = {};
                customquery["ONPREMISECUSTOMQUERY"] = $("CustomQueryValue").getAttribute("query");
                if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") == "false")
                {
                    customquery["ZOHOREPORTSTBNAME"] = $("ZRTblName").value;
                }
                importparams["SINGLETABLEORQUERY"] = customquery;
            }
            var fieldXML = "<Fields ";    //No I18N
            var typeXML = "<FieldType ";  //No I18N
            var countryXML = "<FieldCountry ";    //No I18N
            var jsonNodeXML = "<JSONNodePath ";    //No I18N
            var fieldNullableXML = "<FIELDNULLABLE "; //No I18N
            var fieldstXML = "<FIELDSUBTYPES "; //No I18N
            var colHeaders = sampleTableGrid.colHeaders;
            var colLen = colHeaders.length;
            var countries = sampleTableGrid.currencyCountries;
            var isSelColExist = false;
            var checked;
            var dataType;
            var curHead;
            var index = 0;
            var fieldst= "";
            var isExist = false;
            var row = getDataTypeRow(isExist);
            if (!isANCTypeUnique(colHeaders))
            {
                return false;
            }
            for (var i = 0; i < colLen; i++)
            {
                curHead = colHeaders[i];
                if (curHead.objType !== ZDBConst.COLHEAD)
                {
                    continue;
                }
                checked = curHead["importNode"].getAttribute("checked");    //No I18N
                if (!isSelColExist && checked == "true")
                {
                    isSelColExist = true;
                }

                var selOpt = curHead.dataType[curHead.dataType.selectedIndex];
                dataType = (checked == "true") ? selOpt.value : -2; ///PK: Skip column

                if (curHead.status == ZDBConst.CLEAR)
                {
                    fieldXML += "F" + index + "=\"" + ZDBEscapeUtil.encodeForXML(curHead.displayName) + "\" ";    //No I18N
                    typeXML += "F" + index + "=\"" + dataType + "\" ";   //No I18N
                    countryXML += "FC" + index + "=\"" + countries[index] + "\" ";    //No I18N
                    fieldNullableXML += "F" + index + "=\"" + ZDBEscapeUtil.encodeForXML(curHead.isNullable) + "\" ";    //No I18N
                    if(dataType == ZDBConst.GEO || dataType == ZDBConst.GEO_NUM)
                    {
                      var geoDet = "";
                      var geoR = selOpt.getAttribute("georole");
                      if(geoR != null){geoDet +="GEOR"+":"+geoR;  }//NO I18N
                      if(geoDet.trim()!=""){fieldst += "F" + index + "=\""+ geoR+"\" ";}//No I18N
                    }
                    ++index;
                }
            }

            fieldXML += "/>";
            typeXML += "/>";
            countryXML += "/>";
            jsonNodeXML += "/>";
            fieldNullableXML += "/>";
            fieldstXML=fieldstXML+fieldst+"/>";
            if (!isSelColExist)
            {
                alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.selCol2ProceedImport"));
                return false;
            }
            var tabConfig = "<data>\n" + fieldXML + "\n" + typeXML + "\n" + countryXML + "\n" + fieldNullableXML + "\n"+fieldstXML+"\n"; //No I18N
            tabConfig += "</data>";
            params += "&TABLECONFIG=" + encodeURIComponent(tabConfig) //No I18N
                    + "&ZOHO_DATE_FORMAT=" + $("ZOHO_DATE_FORMAT").value //No I18N
                    + "&FILENAME=" + encodeURIComponent($("FILENAME").value) //No I18N
                    + "&JOINSLIST="+$("JOINSLIST").value;//No I18N
            if ($("ZDBSCHIMPORTTYPE").value == "UPDATEADD" || $("ZDBSCHIMPORTTYPE").value == "DELETEUPDATEADD")
            {
                var matchCols = new Array();
                var matchList = document.getElementsByName("ZOHO_MATCHING_COLUMNS");
                var count = 0;

                for (var i = 0, j = matchList.length; i < j; i++)
                {
                    if (matchList[i].checked)
                    {
                        matchCols[count] = matchList[i].value;
                        count++;
                    }
                }
                if(count == 0)
                {
                    showCustomMessage(ZDBI18NMap.g("zrpt.common.matchingcol.js.errmsg"), matchList[0]);
                    return;
                }
                params += "&MATCHINGCOLS=" + encodeURIComponent(matchCols.toString()); //No I18N
            }
        } else
        {
            importparams["DATAFETCHTYPE"] = 3;
            var multipleTable = [];
            var selectedTablesArray = [];
            selectedTablesArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray").split(',');
            var selectedSchemaArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedSchemaArray").split(',');
            var reportsTableArray = [];
            reportsTableArray = ZDBUtil.getAttribute($("MultipleTblList"), "reportsTableArray").split(',');
            for (i = 0; i < selectedTablesArray.length; i++)
            {
                var tablenames = {};
                //var tableNameWithSchema = CloudDBPage.getTableNamewithSchemaName(ZDBEscapeUtil.decodeForHtml(selectedTablesArray[i]));
                tablenames["ONPREMISETBNAME"] = ZDBEscapeUtil.decodeForHtml(selectedTablesArray[i]);
                tablenames["ZOHOREPORTSTBNAME"] = reportsTableArray[i];
		if(selectedSchemaArray[i] && selectedSchemaArray[i]!='null'){
                	tablenames["ONPREMISESCHEMA"] = ZDBEscapeUtil.decodeForHtml(selectedSchemaArray[i]);//(tableNameWithSchema.length>1)?tableNameWithSchema[1]:null;
		}
                multipleTable.push(tablenames);
            }
            importparams["MULTIPLETABLE"] = multipleTable;
        }
        params += "&TABLEDETAILS=" + encodeURIComponent(JSON.stringify(importparams)); //No I18N
        params += "&ZOHO_ON_FORMAT_ERROR=" + $("OnImportError").value; //No I18N
        params += "&SCHEDULEIMPORTTYPE=" + $("ZDBSCHIMPORTTYPE").value;//No I18N
        params += "&CANADDNEWCOLUMN=" + $("ZDBCANADDNEWCOLUMN").checked;//No I18N
        if (ZDBUtil.getAttribute($("CloudDBImport"), "isExistImp") == "false")
        {
            var schedulerName = CloudDBPage.getSchedulerName(frm);
            var schFailWarnCount = $("sch_failure_count").value;
            var repeatType = $("repeatinterval")[$("repeatinterval").selectedIndex].value;
            var list = repeatType == "daily" ? "ZDB_DLY_TIMEZONE_SEARCH" : repeatType == "weekly" ? "ZDB_WLY_TIMEZONE_SEARCH" : "ZDB_MLY_TIMEZONE_SEARCH";//No I18N
            params += "&SCHEDULERNAME=" + schedulerName;  //No I18N
            params += "&SCHEDULETIMEZONE=" + encodeURIComponent($(list + "_ZRTimezoneList").getAttribute("selectedTimeZone"));//No I18N
            params += "&ZDBSCHFAILWARNCOUNT=" + schFailWarnCount;   //No I18N
        }
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ELEMENT: frm, ONSUCCESSFUNC: "CloudDBPage.showAlert", ONFAILUREFUNC: "CloudDBPage.handleFailure",ISEXISTIMP:isExistImp,OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});
    };
    this.onTextChange = function (el)
    {
        var parent = jQuery(el).parent("div").get(0); //No I18N
        var index = jQuery(parent).index();
        var reportsTableArray = ZDBUtil.getAttribute($("MultipleTblList"), "reportsTableArray").split(',');
        reportsTableArray[index] = el.value;
        ZDBUtil.setAttribute($("MultipleTblList"), reportsTableArray, "reportsTableArray");
    };
    this.validatemultipletablenames = function ()
    {
        var reportsTableArray = ZDBUtil.getAttribute($("MultipleTblList"), "reportsTableArray").split(',');
        for (i = 0; i < reportsTableArray.length; i++)
        {
            var str = reportsTableArray[i];
            str = str.trim();
            if (!((str.length != 0) && (str.length <= parseInt($("ZRTblName").getAttribute("zdbfieldlength")))))
            {
                showCustomMessage(ZDBI18NMap.f("zrpt.newtable.import.tblname.js.errmsg", $("ZRTblName").getAttribute("zdbfieldlength")), $(reportsTableArray[i]));
                CloudDBPage.editRepTblName($(reportsTableArray[i]));
                return false;
            }
        }
        for (i = 0; i < reportsTableArray.length; i++)
        {
            for (j = i + 1; j < reportsTableArray.length; j++)
            {
                if (reportsTableArray[i] === reportsTableArray[j])
                {
                    showCustomMessage(ZDBI18NMap.g("zrpt.databasedata.multipletable.js.validate"), $(reportsTableArray[i]));
                    CloudDBPage.editRepTblName($(reportsTableArray[i]));
                    return false;
                }
            }
        }
        return true;
    };
    this.getSchedulerName = function (frm)
    {
        var repeatType = frm.repeatinterval[frm.repeatinterval.selectedIndex].value;
        var schedulerName = "none";    //No I18N
        if (repeatType == "periodic")
        {
            schedulerName = frm.periodicinterval[frm.periodicinterval.selectedIndex].value;
        } else if (repeatType == "daily") //No I18N
        {
            var hourVal = frm.ZDB_DLY_HRS_INT.value;
            var minVal = frm.ZDB_DLY_MINS_INT.value;
            var timeInMin = parseInt(hourVal * 60) + parseInt(minVal);
            schedulerName = timeInMin + "_" + repeatType;
        } else if (repeatType == "weekly") //No I18N
        {
            var hourVal = frm.ZDB_WLY_HRS_INT.value;
            var minVal = frm.ZDB_WLY_MINS_INT.value;
            var timeInMin = parseInt(hourVal * 60) + parseInt(minVal);
            var schDay = frm.weeklyinterval[frm.weeklyinterval.selectedIndex].value;
            schedulerName = timeInMin + "_" + repeatType + "_" + schDay;
        } else if (repeatType == "monthly") //No I18N
        {
            var hourVal = frm.ZDB_MLY_HRS_INT.value;
            var minVal = frm.ZDB_MLY_MINS_INT.value;
            var timeInMin = parseInt(hourVal * 60) + parseInt(minVal);
            var schDate = frm.monthlyinterval[frm.monthlyinterval.selectedIndex].value;
            schedulerName = timeInMin + "_" + repeatType + "_" + schDate;
        } else if (repeatType == "minutes") //No I18N
        {
            schedulerName = frm.lessthanhourinterval[frm.lessthanhourinterval.selectedIndex].value;
        }
        return schedulerName;
    };

    this.showAlert = function(response,requestOptions)
    {
        var params={};
        params = JSON.parse(response.responseText);
        var name = params['NAME'];
        var emailid = params['EMAILID'];
        var sourcename = params['CLOUDSOURCENAME'];
        var str;
        if(params['OBJID'])
        {
            str = ZDBI18NMap.g('zrpt.common.js.table');
        }
        else
        {
            str = ZDBI18NMap.g('zrpt.common.js.database');
        }
        var msg = ZDBI18NMap.f('zrpt.databasedata.setup.js.sucess',ZDBEscapeUtil.encodeForHtml(sourcename),ZDBEscapeUtil.encodeForHtml(name),ZDBEscapeUtil.encodeForHtml(str));
        $("ZRCloudDBNextBtn").setAttribute("stepNo",5);
        CloudDBPage.enableOptForStep();
        var msgnode = $('ZRCloudDBSetupCompMsg').cloneNode(true);
        msgnode.innerHTML = msg;
        msgnode.style.display='inline-block';
        jQuery("#ShowCloudDBCmplt").empty();  //No I18N
        $("ShowCloudDBCmplt").appendChild(msgnode);
        $('ZRCloudDBCmpltOk').setAttribute("DBID",params['DBID']);
        if(params['OBJID'])
        {
            $('ZRCloudDBCmpltOk').setAttribute("OBJID",params['OBJID']);
        }
        $('ZRCloudDBCancelBtn').style.display="none";
    };
    this.switchView = function(el)
    {
             ZDBInlineDialog.closeDialogByType(el);
             if(ZDBClientUI.selectedTab == null)
             {
                var url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + el.getAttribute('DBID');//No I18N
                window.location.href = url;
             }
             else if(!el.getAttribute('OBJID'))
             {
                var tab = ZDBClientUI.selectedTab;
                ZDBNavigation.refreshExplorer();
                ZDBClientUI.removeTab(tab);
                ZDBClientUI.selectTab(ZDBNavigation.explorerTab);
                if(!$('ZDBEXPLORERDATASOURCE_TITEM'))
                {
                    window.location.reload();
                }
                if($('DatasourceBack'))
                {
                    ZRConnector.refreshDataSourcesDlg($('DatasourceBack'));
                }
             }
         }
    this.showCreateCloudDBTable = function (element)
    {
     if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC",  CloudDBPage.showCreateCloudDBTable, [element]))
            {
                return;
            }
        var tabs = ZDBClientUI.tabOrderList;
        var len = tabs.length;
        for(i=0;i<len;i++)
        {
            var tab = tabs[i];
            var cloudDBView = tab.view.clouddbview;
            if(cloudDBView && tab.view.dialogStatus && tab.view.dialogStatus>0)
            {
                ZDBClientUI.removeTab(ZDBClientUI.selectedTab);
                ZDBClientUI.selectTab(tab);
                return;
            }
        }
        var params = "ZDBACTION=FETCHEXISTINGCONNECTIONS"; //No I18N
        params += "&DBID=" + ZDBClientUI.dbId; //No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ELEMENT: element, ONSUCCESSFUNC: "CloudDBPage.loadExistingConnections", OPSTATUSID: "ZDBMainLoader"});
    };

    this.loadExistingConnections = function (response, requestOptions)
    {
        var element = requestOptions["ELEMENT"];
        var lzName = element.getAttribute("lzName");
        var lzOper = (element.getAttribute("lzOper")) ? element.getAttribute("lzOper") : "APPENDTODOC"; //No I18N
        var lzJs = element.getAttribute("lzJs");
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZRCloudDB.cc", this, lzOper))
        {
            return;
        }
        var clouddbDlg = ZDBClientUI.$("ZRCloudDBDialog");
        ZDBUtil.setNamedChildEls(clouddbDlg, clouddbDlg, "id");
        CloudDBPage.showCreateCloudDBTableDlg(clouddbDlg);
        var responseString = JSON.parse(response.responseText);
        var paramsJson = [];
        paramsJson = responseString.existingConnections;
        var existConnSelect = $("ConnectionId");
        var defaultOpt = $("SelectExistingConnection");
        jQuery(existConnSelect).empty();
        existConnSelect.appendChild(defaultOpt);
        $("DBID").value = ZDBClientUI.dbId;
        if (paramsJson.length < 1)
        {
            $("ExistingConnection").style.display = "none";
            return;
        }
        for (i = 0; i < paramsJson.length; i++)
        {
            var connDet = {};
            connDet = paramsJson[i];
            var option = document.createElement("option");
            option.setAttribute("id", connDet.CONNECTIONID);
            option.setAttribute("value", connDet.CONNECTIONID);
            option.setAttribute("servicename", connDet.SERVICENAME);
            option.setAttribute("dbtype", connDet.DATABASETYPE);
            option.setAttribute("hostname", connDet.HOSTNAME);
            option.setAttribute("port", connDet.PORT);
            option.setAttribute("username", connDet.USERNAME);
            option.setAttribute("password", connDet.PASSWORD);
            option.setAttribute("instancename", connDet.INSTANCENAME);
            option.setAttribute("sid", connDet.SID);
            option.setAttribute("clouddbname", connDet.CLOUDDATABASENAME);
            option.setAttribute("useSSL",connDet.USESSL);
            var dbTypes=ZDBClientUI.dBTypeJSON;
            if (connDet.SERVICENAME == 0)
            {
                option.innerHTML = $("AmazonRds").innerHTML + "" + dbTypes[connDet.DATABASETYPE].DISPLAYNAME + "";
                if(connDet.DATABASETYPE!=2)
                {
                    option.innerHTML+="(" + connDet.CLOUDDATABASENAME + ")";
                }
                else
                {
                    option.innerHTML+="(" + connDet.SID + ")";
                }
            }
            else if(connDet.SERVICENAME == 3||connDet.SERVICENAME == 4||connDet.SERVICENAME == 9)
            {
                 option.innerHTML = dbTypes[connDet.DATABASETYPE].DISPLAYNAME+ "" + "(" + connDet.CLOUDDATABASENAME + ")";
            }
            else
            {
                option.innerHTML = $("SERVICENAME").options[connDet.SERVICENAME].innerHTML + "" + "(" + connDet.CLOUDDATABASENAME + ")";
            }
            existConnSelect.appendChild(option);
        }

    };
    this.showCreateCloudDBTableDlg = function (clouddbDlg)
    {
        var checkROMode = ZDBClientUI.readOnlyMode;
        if (checkROMode)
        {
            ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.javaerr.common.js.ro_mode"));
            return;
        }
        var onclose = CloudDBPage.removeObj;
        ZDBInlineDialog.showDialog(clouddbDlg, {MODAL: true, DONTREMOVE: false, TITLE: ZDBI18NMap.f("zrpt.databasedata.import.js.step1.dbconnectionsetting"),ONCLOSE:onclose});
        ZDBClientUI.selectedTab.view.clouddbview = clouddbDlg;
        $("ZRCloudBTitleBar").style.display = "none";
        $("CloudDBImport").setAttribute("qa", true);
        CloudDBPage.loadNewTblSettings(clouddbDlg);
        $("ExistingConnection").style.display = "block";
        if($("LiveConnectDiv"))
        {
            $("LiveConnectDiv").style.display = "none";
        }
        CloudDBPage.editMode(clouddbDlg);
    };
    this.fillConnSettingsForm = function (value, frm)
    {
        if (value == -10)
        {
            CloudDBPage.enableInitialPage(frm);
            CloudDBPage.editMode(frm);
            return;
        }
        var element = document.getElementById(value);
        $("SERVICENAME").value = element.getAttribute("servicename");
        CloudDBPage.enableDisableDBType($("SERVICENAME").value, frm);
        $("DBTYPE").value = element.getAttribute("dbtype");
        CloudDBPage.enableDisableOtherParams(element.getAttribute("dbtype"),frm)
        $("HOST").value = element.getAttribute("hostname");
        $("SID").value = element.getAttribute("sid");
        $("INSTANCENAME").value = element.getAttribute("instancename");
        $("USERNAME").value = element.getAttribute("username");
        $("PASSWORD").value = element.getAttribute("password");
        $("CONN_CloudDBNAME").value = element.getAttribute("clouddbname");
        $("PORT").value = element.getAttribute("port");
        if(element.getAttribute("usessl") == "true")
        {
            $("USESSL").checked = true;
        }
        else
        {
            $("USESSL").checked = false;
        }
        CloudDBPage.readOnlyMode();
    };

    this.readOnlyMode = function ()
    {
        $("SERVICENAME").setAttribute("disabled", true);
        $("DBTYPE").setAttribute("disabled", true);
        $("HOST").setAttribute("readonly", true);
        $("HOST").setAttribute("class", "scratchsearchfield alpha");
        $("SID").setAttribute("readonly", true);
        $("SID").setAttribute("class", "scratchsearchfield alpha");
        $("INSTANCENAME").setAttribute("readonly", true);
        $("INSTANCENAME").setAttribute("class", "scratchsearchfield alpha");
        $("USERNAME").setAttribute("readonly", true);
        $("USERNAME").setAttribute("class", "scratchsearchfield alpha");
        $("PASSWORD").setAttribute("readonly", true);
        $("PASSWORD").setAttribute("class", "scratchsearchfield alpha");
        $("CONN_CloudDBNAME").setAttribute("readonly", true);
        $("CONN_CloudDBNAME").setAttribute("class", "scratchsearchfield alpha");
        $("PORT").setAttribute("readonly", true);
        $("PORT").setAttribute("class", "scratchsearchfield alpha");
        $("USESSL").setAttribute("disabled", "disabled");
        $("USESSL").setAttribute("class", "alpha");
    };

    this.editMode = function ()
    {
        $("SERVICENAME").removeAttribute("disabled");
        $("DBTYPE").removeAttribute("disabled");
        $("HOST").removeAttribute("readonly");
        $("HOST").setAttribute("class", "scratchsearchfield");
        $("SID").removeAttribute("readonly");
        $("SID").setAttribute("class", "scratchsearchfield");
        $("INSTANCENAME").removeAttribute("readonly");
        $("INSTANCENAME").setAttribute("class", "scratchsearchfield");
        $("USERNAME").removeAttribute("readonly");
        $("USERNAME").setAttribute("class", "scratchsearchfield");
        $("PASSWORD").removeAttribute("readonly");
        $("PASSWORD").setAttribute("class", "scratchsearchfield");
        $("CONN_CloudDBNAME").removeAttribute("readonly");
        $("CONN_CloudDBNAME").setAttribute("class", "scratchsearchfield");
        $("PORT").removeAttribute("readonly");
        $("PORT").setAttribute("class", "scratchsearchfield");
        $("USESSL").removeAttribute("disabled");
        $("USESSL").removeAttribute("class");
    };

    this.showExistImpDialog = function (connId)
    {
        var params = "ZDBACTION=FETCHTABLESFOREXISTIMP&CONNECTIONID=" + connId + "&OBJID=" + ZDBClientUI.selectedTab.view.objId; //No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ONSUCCESSFUNC: "CloudDBPage.cntShowExistImpDialog", OPSTATUSID: "ZDBMainLoader"});
    };
    this.cntShowExistImpDialog = function (response, requestOptions)
    {
        var lzName = "CLOUDDB_TABLE_EXISTIMP_DLG"; //No I18N
        var lzOper = "APPENDTODOC"; //No I18N
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZRCloudDB.cc", this, lzOper))
        {
            return;
        }
        var clouddbDlg = ZDBClientUI.$("ZRCloudDBDialog");
        var clouddbExistImpDlg = clouddbDlg.cloneNode(true);
        var onclose = CloudDBPage.removeObj;
        ZDBInlineDialog.showDialog(clouddbExistImpDlg, {MODAL: true, DONTREMOVE: false, TITLE: ZDBI18NMap.f("zrpt.common.import.js.existimport_dlg_title"),ONCLOSE:onclose});
        ZDBClientUI.selectedTab.view.clouddbview = clouddbExistImpDlg;
        $("ZRCloudBTitleBar").style.display = "none";
        if($("ZRSHelpCenter") && jQuery("#CloudDBHelp").children().length==0)
        {
            var helpIcons =$("ZRSHelpCenter").cloneNode(true);
            var anchortag = jQuery(helpIcons).children()[0];
            var link=ZDBI18NMap.g("zrpt.links.js.clouddbimport");
            ZDBUtil.setAttribute(anchortag,link,"href");
            $("CloudDBHelp").appendChild(helpIcons);
        }
        ZDBUtil.setAttribute($("CloudDBImport"), "true", "isExistImp");
        CloudDBPage.loadQueryEditor();
        ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 1, "stepNo");
        var params = JSON.parse(response.responseText);
        $("cloudServiceName").innerHTML = ZDBEscapeUtil.encodeForHtml(params.cloudServiceName);
        $("cloudServiceName").setAttribute('tip',params.cloudServiceName);
        $("cloudEndpoint").innerHTML = ZDBEscapeUtil.encodeForHtml(params.endpoint);
        $("cloudEndpoint").setAttribute('tip',params.endpoint);
        $("cloudDBName").innerHTML = ZDBEscapeUtil.encodeForHtml(params.dbname);
        $("cloudDBName").setAttribute('tip',params.dbname);
        $("EndPointLabel").innerHTML=ZDBEscapeUtil.encodeForHtml((params.cloudServiceName=="Local Database")?ZDBI18NMap.g("zrpt.databasedata.connname.js.hostname"):ZDBI18NMap.g("zrpt.databasedata.connname.js.endpoint"));
        var impOptionSelect = $("ZDBSCHIMPORTTYPE");
        jQuery(impOptionSelect).empty();
        var permLevel = ZDBClientUI.selectedTab.view.permLevel;
        var perms = permLevel.split("$");
        impOptionSelect = ZDBImport.setImportOption(impOptionSelect, perms);
        CloudDBPage.showSelectTablesPage(response, requestOptions);
        var datafetchtype = params.DATAFETCHTYPE;
        var editor;
        if (ZDBClientUI.selectedTab != null)
        {
            editor = ZDBClientUI.selectedTab.view.editor;
        } else
        {
            editor = CloudDBPage.editorGlobal;
        }
        if (datafetchtype == 1 || datafetchtype == 3)
        {
            CloudDBPage.tableOrQueryOption(1);
	    $("TableNames_Single").options[0].selected = true;
            var sampleQuery;
            var tables = params.tableList;
	    var table = tables[0];
	    var tableNameWithoutSchema = table["TBL_NAME"];
	    var schema = table["SCH_NAME"];
	    var dispName = (schema)?(schema+'.'+tableNameWithoutSchema):tableNameWithoutSchema;	//No I18N
            sampleQuery = "SELECT * FROM " + dispName + "\n\n/* " + ZDBI18NMap.g("zrpt.databasedata.js.queryeditor.qry_msg") + " */\n\n\n\n\n\n\n"; //No I18N
            for(i=0;i<tables.length;i++)
            {
                if(params.TABLENAME == tables[i]["TBL_NAME"] && tables[i]["SCH_NAME"] && tables[i]["SCH_NAME"] == params.SCHEMA)
                {
		    table = tables[i];
        	    schema = table["SCH_NAME"];
		    tableNameWithoutSchema = table["TBL_NAME"];
		    dispName = (schema)?(schema+'.'+tableNameWithoutSchema):tableNameWithoutSchema; //No I18N
                    $("TableNames_Single").value = params.TABLENAME;
                    sampleQuery = "SELECT * FROM " + dispName + "\n\n/* " + ZDBI18NMap.g("zrpt.databasedata.js.queryeditor.qry_msg") + " */\n\n\n\n\n\n\n"; //No I18N
                    break;
                }
            }
            editor.setValue(sampleQuery);
        } else if (datafetchtype == 2)
        {
            CloudDBPage.tableOrQueryOption(2);
            editor.setValue(params.CUSTOMQUERY);
        }
        $("ExistImpConnectionId").innerHTML = params.CONNECTIONID;
        $("ExistImpObjId").innerHTML = params.OBJID;
        var matchColumns = params.MATCHCOLS;
        ZDBImport.setExistColumnList(ZDBClientUI.selectedTab.view);
        if (matchColumns != null && matchColumns != "")
        {
            var matchColList = matchColumns.split(',');
            var view = ZDBClientUI.selectedTab.view;
            ZDBImport.setCheckListColumn(view, matchColList);
        }
        var importTypes = $("ZDBSCHIMPORTTYPE").getElementsByTagName("option");
        for(var i=0;i<importTypes.length;i++)
        {
            var curOption = importTypes[i];
            if(curOption.value == params.SCHEDULEIMPORTTYPE)
            {
                curOption.selected = true;
                break;
            }
        }
        CloudDBPage.showMatchColList($("ZDBSCHIMPORTTYPE"));
        $("OnImportError").value = params.ONIMPERROR;
        if (params.CANADDNEWCOLUMN == 0)
        {
            $("ZDBCANADDNEWCOLUMN").checked = false;
        } else
        {
            $("ZDBCANADDNEWCOLUMN").checked = true;
        }
    };

    this.getPreviewForExistImport = function (el)
    {
        var query;
        var params = "CONNECTIONID=" + $("ExistImpConnectionId").innerHTML; //No I18N
        if ($("CloudDBCustomQuery").checked)
        {
            var editor;
            if (ZDBClientUI.selectedTab != null)
            {
                editor = ZDBClientUI.selectedTab.view.editor;
            } else
            {
                editor = CloudDBPage.editorGlobal;
            }
            query = editor.getValue();
            query = query.replace(/(\/\*([\s\S]*?)\*\/)|(\/\/(.*)$)/gm, ''); //to remove comments
            query = query.replace(/\r?\n|\r/g, " "); //to remove new line
            query = query.trim(); //to remove white space at end
            $("CustomQueryValue").setAttribute("query",query);
            if (!CloudDBPage.validateQuery(query))
            {

                return;
            }
            params = params + "&CUSTOMQUERY=" + encodeURIComponent(query); //No I18N
        } else if ($("CloudDBSingleTbl").checked)
        {
            params = params + "&TABLENAME=" + $("TableNames_Single").value;//No I18N
	    var tableNameWithSchema = CloudDBPage.getTableNamewithSchemaName($("TableNames_Single"));
            if(tableNameWithSchema.length>1 && tableNameWithSchema[1]!=null){
            	params = params + "&SCHEMANAME=" + tableNameWithSchema[1]; //No I18N
            }
        }
        params = params + "&OBJID=" + ZDBClientUI.selectedTab.view.objId;//No I18N
        params = params+"&DBID="+ZDBClientUI.dbId; //No I18N
        params += "&FILETYPE=CSV&LOCATION=CLOUDDATABASE&ZDBACTION=SHOWPREVIEWFOREXISTIMP"; //No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ELEMENT: el, ONSUCCESSFUNC: "CloudDBPage.handlePreviewScript", ONFAILUREFUNC: "CloudDBPage.handleFailure", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});
    };
    this.setDefaultScheduleDet = function (frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        frm.repeatinterval.options[0].selected = "true";
        CloudDBPage.toggleSchedulePeriod("none", frm); //No I18N
        frm.ZDB_DLY_HRS_INT.value = 0;
        frm.ZDB_DLY_MINS_INT.value = 0;
        frm.sch_failure_count.value = ZDBConst.DEFAULT_SCH_FAILURE_COUNT;
        frm.weeklyinterval.value = 1;
    };

    this.setExistScheduleDet = function (schDet, count, scheduleTimeZone, displayTimeZone, frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        var perTime = schDet[0];
        var perUnit = schDet[1];
        var calFreq = schDet[2];
        var calTime = schDet[3];
        var calDay = schDet[5];
        var calDate = schDet[6];

        frm.schedule_periodic.style.display = "none";
        frm.schedule_daily.style.display = "none";
        frm.schedule_weekly.style.display = "none";
        frm.schedule_monthly.style.display = "none";
        frm.sch_failure_warning.style.display = "";
        frm.sch_failure_count.style.display = "";
        if (count == "null")
        {
            count = ZDBConst.DEFAULT_SCH_FAILURE_COUNT;
        }
        frm.sch_failure_count.value = count;
        var repeatIntElem = frm.repeatinterval;

        if (calFreq == "daily")
        {
            repeatIntElem.value = calFreq;
            frm.schedule_daily.style.display = "";
            var hr = ZDBFunctions.floor(calTime / 60);
            var min = calTime % 60;
            frm.ZDB_DLY_HRS_INT.value = hr;
            frm.ZDB_DLY_MINS_INT.value = min;
            frm.ZDB_DLY_TIMEZONE.innerHTML = ZDBI18NMap.f("zrpt.schsettings.js.usertimeZone", displayTimeZone);
            ZDBUtil.setAttribute(frm.ZDB_DLY_TIMEZONE_SEARCH_ZRTimezoneList, scheduleTimeZone, "selectedTimeZone");
        } else if (calFreq == "weekly") //No I18N
        {
            repeatIntElem.value = calFreq;
            frm.schedule_weekly.style.display = "";
            var hr = ZDBFunctions.floor(calTime / 60);
            var min = calTime % 60;
            frm.ZDB_WLY_HRS_INT.value = hr;
            frm.ZDB_WLY_MINS_INT.value = min;
            frm.weeklyinterval.value = calDay;
            frm.ZDB_WLY_TIMEZONE.innerHTML = ZDBI18NMap.f("zrpt.schsettings.js.usertimeZone", displayTimeZone);
            ZDBUtil.setAttribute(frm.ZDB_WLY_TIMEZONE_SEARCH_ZRTimezoneList, scheduleTimeZone, "selectedTimeZone");
        } else if (calFreq == "monthly") //No I18N
        {
            repeatIntElem.value = calFreq;
            frm.schedule_monthly.style.display = "";
            var hr = ZDBFunctions.floor(calTime / 60);
            var min = calTime % 60;
            frm.ZDB_MLY_HRS_INT.value = hr;
            frm.ZDB_MLY_MINS_INT.value = min;
            frm.monthlyinterval.value = calDate;
            frm.ZDB_MLY_TIMEZONE.innerHTML = ZDBI18NMap.f("zrpt.schsettings.js.usertimeZone", displayTimeZone);
            ZDBUtil.setAttribute(frm.ZDB_MLY_TIMEZONE_SEARCH_ZRTimezoneList, scheduleTimeZone, "selectedTimeZone");
        } else if (calFreq == null)
        {
            if(jQuery(repeatIntElem).find('option[value="periodic"]').length>0)
            {
                if(perUnit == "HOURS"){
	                repeatIntElem.value = "periodic"; //No I18N
	                frm.schedule_periodic.style.display = "";
	                var hrs = perTime+"_hours"; //No I18N
	                frm.periodicinterval.value = hrs;
                }
		else if(!ZDBGlobal.IS_ONPREMISE_BUILD){
			/*15,30 and 45 minutes enabled by mistake in IDC - should be shown only in OP build.
        This is for users who have alreday scheduled  mins schedule in IDC*/
			CloudDBPage.stopScheduling(false, frm);
		}
		else{
	            	repeatIntElem.value = "minutes"; //No I18N
	            	frm.schedule_minutes.style.display = "";
	            	var mins =perTime+"_Minutes"; //No I18N
	            	frm.lessthanhourinterval.value = mins;
	            }
            }
            else
            {
                CloudDBPage.stopScheduling(false, frm);
            }
        } else
        {
            CloudDBPage.stopScheduling(false, frm);
        }
    };

    this.stopScheduling = function (resize,frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        frm.repeatinterval.value = "none"; //No I18N
        frm.sch_failure_warning.style.display = "none";
        CloudDBPage.toggleSchedulePeriod("none",frm);   //No I18N
        frm.sch_failure_count.value = ZDBConst.DEFAULT_SCH_FAILURE_COUNT;
    };

    this.refreshCloudDBTbl = function (el, connId,objId,isConnector)
    {
        ZDBDialogUtil.closeDialog(el);
        var params = "&OBJID=" + objId + "&CONNECTIONID=" + connId + "&ZDBACTION=REFETCHCLOUDDBTBL"; //No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ONSUCCESSFUNC: "CloudDBPage.showRefetchSucessAlert", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS"),ISCONNECTOR:isConnector,ELEMENT:el,CONNECTIONID:connId,OBJID:objId});
    };

    this.showRefetchSucessAlert = function (response, requestOptions)
    {
        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.schimport.custommsg.js.refetchStarted"));
        if(requestOptions["ISCONNECTOR"])
        {
            ZRConnector.handleClouddbModSyncResp(response, requestOptions);
        }
    };

    this.editSetup = function (connectionId, element)
    {
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?&CONNECTIONID=" + connectionId + "&DBID=" + ZDBClientUI.dbId + "&ZDBACTION=EDITCONNECTION", ONSUCCESSFUNC: "CloudDBPage.showEditDlg", ELEMENT: element, OPSTATUSID: "ZDBMainLoader"});
    };

    this.showEditDlg = function (response, requestOptions)
    {
        var lzName = "CLOUDDB_TABLE_EDIT_DLG"; //No I18N
        var lzOper = "APPENDTODOC"; //No I18N
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZRCloudDB.cc", this, lzOper))
        {
            return;
        }
        var formel = document.createElement("form");
        formel.setAttribute("style", "width:390px;align:right;");
        var clouddbEditDlg = ZDBClientUI.$("CloudDataSource");
        var editDlg = clouddbEditDlg.cloneNode(true);
        editDlg.style.display="";
        var result = JSON.parse(response.responseText);
        formel.setAttribute("id", result.CONNECTIONID);
        formel.setAttribute("qa", true);
        formel.appendChild(editDlg);
        var btns = ZDBClientUI.$("ZREditConnBts").cloneNode(true);
        btns.style.display = "";
        formel.appendChild(btns);
        ZDBDialogUtil.showDialog(formel, {MODAL: true, ADDFRAME: true, DONTREMOVE: false, SHADOW: true, TITLECLASS: 'schedule', TITLE: ZDBI18NMap.g('zrpt.databasedata.edit.js.connection')}); // NO I18N
        formel.ZRCloudDBSaveBtn.setAttribute("onclick", "CloudDBPage.saveConnection(this.form)");
        CloudDBPage.setConnectionDet(formel, response);
        CloudDBPage.editMode();
    };
    this.setConnectionDet = function (editDlg, response)
    {
        var result = JSON.parse(response.responseText);
        ZDBUtil.setNamedChildEls(editDlg, editDlg, "id");
        editDlg.ExistingConnection.style.display = "none";
        editDlg.SERVICENAME.value = result.SERVICENAME;
        CloudDBPage.enableDisableDBType(result.SERVICENAME, editDlg);
        editDlg.DBTYPE.value = result.DATABASETYPE;
        if(result.SERVICENAME===0){
        CloudDBPage.enableDisableOtherParams(result.DATABASETYPE, editDlg);
        }
        editDlg.HOST.value = result.HOSTNAME;
        editDlg.INSTANCENAME.value = result.INSTANCENAME;
        editDlg.PORT.value = result.PORT;
        editDlg.SID.value = result.SID;
        editDlg.USERNAME.value = result.USERNAME;
        editDlg.PASSWORD.value = result.PASSWORD;
        editDlg.CONN_CloudDBNAME.value = result.CLOUDDATABASENAME;
        if(result.USESSL)
        {
            editDlg.USESSL.checked = true;
        }
        else
        {
            editDlg.USESSL.checked = false;
        }
    };
    this.saveConnection = function (frm)
    {
        if (!CloudDBPage.validateConnDet(frm))
        {
            return false;
        }
        var connectionId = frm.getAttribute("id");
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        var conndetails = {};
        conndetails["SERVICENAME"] = frm.SERVICENAME.value;
        conndetails["DATABASETYPE"] = CloudDBPage.getDatabaseType(frm.SERVICENAME.value,frm);
        conndetails["HOSTNAME"] = frm.HOST.value;
        conndetails["PORT"] = frm.PORT.value;
        conndetails["USERNAME"] = frm.USERNAME.value;
        conndetails["PASSWORD"] = encodeURIComponent(frm.PASSWORD.value);
        conndetails["INSTANCENAME"] = frm.INSTANCENAME.value;
        conndetails["SID"] = frm.SID.value;
        conndetails["CLOUDDATABASENAME"] = frm.CONN_CloudDBNAME.value;
        conndetails["USESSL"] = frm.USESSL.checked;
        var params = "CONNECTIONID=" + connectionId;//No I18N
        params += "&CONNDETAILS=" + encodeURIComponent(JSON.stringify(conndetails));//No I18N
        params += "&ZDBACTION=SAVEEDIT";//No I18N
        params += "&DBID=" + ZDBClientUI.dbId;//No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ONSUCCESSFUNC: "CloudDBPage.showSaveSucessAlert", OPSTATUSID: frm.ZREDITSTATUS, ELEMENT: frm});
    };
    this.showSaveSucessAlert = function (response, requestOptions)
    {
        var resp = JSON.parse(response.responseText);
        var el = requestOptions.ELEMENT;
        if(resp.connchanged === false)
        {
            ZDBDialogUtil.closeDialog(el);
            ZDBMsgBox.showInfo(ZDBI18NMap.g('zrpt.databasedata.edit.js.nochanges'));
            return;
        }
        var elId = "-11_" + el.getAttribute("id");
        var obj = ZRConnector.connJson[elId];
        obj.connname = resp.connname;
        obj.storedconnname = resp.storedconnname;
        $("storedConnName").innerHTML = ZDBEscapeUtil.encodeForHtml(obj.storedconnname);
        $("connName").innerHTML = ZDBEscapeUtil.encodeForHtml(obj.connname);
        jQuery($(elId)).find("[id='ConnSubName']")[0].innerHTML = ZDBEscapeUtil.encodeForHtml(obj.storedconnname);
        jQuery($(elId)).find("[id='ConnMainName']")[0].innerHTML = ZDBEscapeUtil.encodeForHtml(obj.connname);
        ZDBDialogUtil.closeDialog(el);
        ZDBMsgBox.showSuccess(ZDBI18NMap.g('zrpt.databasedata.edit.js.sucess'));
    };

    this.showSyncEdit = function (connectionId)
    {
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?&CONNECTIONID=" + connectionId + "&DBID=" + ZDBClientUI.dbId + "&ZDBACTION=FETCHSYNCDET", ONSUCCESSFUNC: "CloudDBPage.cntshowSyncEdit", OPSTATUSID: "ZDBMainLoader"});
    };

    this.cntshowSyncEdit = function (response, requestOptions)
    {
        var lzName = "CLOUDDB_SYNC_EDIT_DLG"; //No I18N
        var lzOper = "APPENDTODOC"; //No I18N
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZRCloudDB.cc", this, lzOper))
        {
            return;
        }
        var formel = document.createElement("form");
        var editDlg = ZDBClientUI.$("SchTimeZone").cloneNode(true);
        ZDBUtil.setAttribute(editDlg,"margin-top:0px","style");
        formel.appendChild(editDlg);
        var btns = ZDBClientUI.$("ZREditConnBts").cloneNode(true);
        btns.style.display = "";
        formel.appendChild(btns);
        ZDBDialogUtil.showDialog(formel, {MODAL: true, ADDFRAME: true, DONTREMOVE: false, SHADOW: true, TITLECLASS: 'schedule', TITLE: ZDBI18NMap.g('zrpt.databasedata.edit.js.sync')}); // NO I18N
        ZDBUtil.setNamedChildEls(formel, formel, "id");
        formel.ZREditConnBts.setAttribute("style", "margin-top: 10px; margin-left: 160px;");
        formel.ZRCloudDBSaveBtn.setAttribute("onclick", "CloudDBPage.saveSync(this.form)");
        var result = JSON.parse(response.responseText);
        formel.setAttribute("id",result.CONNECTIONID);
        if (result.scheduleDetails != null)
        {
            var schDet = [];
            schDet = result.scheduleDetails;
            CloudDBPage.setExistScheduleDet(schDet, result.schWarnMailCount, result.scheduleTimeZone, result.displayTimeZone, formel);
        } else
        {
            CloudDBPage.setDefaultScheduleDet(formel);
        }
    };

    this.saveSync = function (frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        var schedulerName = CloudDBPage.getSchedulerName(frm);
        var schFailWarnCount = frm.sch_failure_count.value;  //No I18N
        var repeatType = frm.repeatinterval.value;
        var timeZone = repeatType == "daily" ? frm.ZDB_DLY_TIMEZONE_SEARCH_ZRTimezoneList.getAttribute("selectedTimeZone") : repeatType == "weekly" ? frm.ZDB_WLY_TIMEZONE_SEARCH_ZRTimezoneList.getAttribute("selectedTimeZone") : frm.ZDB_MLY_TIMEZONE_SEARCH_ZRTimezoneList.getAttribute("selectedTimeZone");//No I18N
        var params;
        params = "SCHEDULERNAME=" + schedulerName;  //No I18N
        params += "&SCHEDULETIMEZONE=" + timeZone;//No I18N
        params += "&ZDBSCHFAILWARNCOUNT=" + schFailWarnCount;   //No I18N
        var connectionId = frm.getAttribute("id");
        params += "&CONNECTIONID=" + connectionId;//No I18N
        params += "&DBID=" + ZDBClientUI.dbId;//No I18N
        params += "&ZDBACTION=SAVESYNC";//No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ONSUCCESSFUNC: "CloudDBPage.showSaveSyncSucessAlert", OPSTATUSID: frm.ZREDITSTATUS, ELEMENT: frm});
    };
    this.showSaveSyncSucessAlert = function (response, requestOptions)
    {
        var el = requestOptions.ELEMENT;
        var elId = "-11_" + el.getAttribute("id");
        var obj = ZRConnector.connJson[elId];
        var resp = JSON.parse(response.responseText);
        obj.schtype = resp.schtype;
        obj.nextschtime = resp.nextschtime;
        obj.timezone = resp.timezone;
        if(elId == ZRConnector.curConnector)
        {
            $("connSchType").innerHTML = obj.schtype;
            $("connNextSchTime").innerHTML = obj.nextschtime;
            $("connTimeZone").innerHTML = obj.timezone;
        }
        $(elId + "_connSchTime").innerHTML = obj.nextschtime;
        ZDBDialogUtil.closeDialog(el);
        ZDBMsgBox.showSuccess(ZDBI18NMap.g('zrpt.databasedata.syncedit.js.sucess'));
    };
    this.deleteConnector = function (connectionId, parEl)
    {
        var params;
        params = "CONNECTIONID=" + connectionId;//No I18N
        params += "&DBID=" + ZDBClientUI.dbId;//No I18N
        params += "&ZDBACTION=DELETECONNECTOR";//No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params, ELEMENTID: parEl, ONSUCCESSFUNC: "ZRConnector.showRespMsg", OPSTATUSID: "ZDBMainLoader"});
    };

    this.handleFailure = function (response, requestOptions)
    {
        ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'CloudDBPage.gotoNextStep(this.form)', 'onclick');
        $("ZRCloudDBNextBtn").className='buttonCompBoxBg';
        if($("ZRCloudDBCreateBtn")){
        ZDBUtil.setAttribute($("ZRCloudDBCreateBtn"), 'CloudDBPage.submitCloudDBForm(this.form)', 'onclick');
        }
        else if($("ZRCloudDBImportBtn")){
        ZDBUtil.setAttribute($("ZRCloudDBImportBtn"), 'CloudDBPage.submitCloudDBForm(this.form)', 'onclick');
        }
        var errCode = response.getResponsePart("ERRORCODE");
        var errMsg = response.getResponsePart("STATUS_MESSAGE");
        errCode = trimAll(errCode);
        if(errCode!=null)
        {
	    if('DB_CONN_ERR_SOCK_ERROR' == errCode || 'DB_CONN_ERR_LOGIN' == errCode || 'DB_CONN_ERR_DB_NOT_PRESENT' == errCode){
		AjaxAPI.onFailureFunc(response,requestOptions);
		return;
	    }
            if('DBNAME_DUPLICATE' == errCode || 'META_DBNAME_DUPLICATE' == errCode)
            {
                showCustomMessage(errMsg, $("ZRDBName"));
                return;
            }
            else if('META_DBOBJECT_NAME_DUPLICATED' == errCode && !$("CloudDBMultipleTbl").checked)
            {
                showCustomMessage(errMsg,$("ZRTblName"));
                return;
            }
            else if('META_DBOBJECT_NAME_DUPLICATED' == errCode && $("CloudDBMultipleTbl").checked)
            {
                var str = errMsg;
                str=str.trim();
                var tblNameDet = response.getResponsePart("OTHER_DETAILS");
                var tblName = tblNameDet.substring(2,tblNameDet.length-2);
                if($(tblName))
                {
                    showCustomMessage(errMsg,$(tblName));
                    CloudDBPage.editRepTblName($(tblName));
                }
                else
                {
                     showCustomMessage(errMsg,$("ReportsTables"));
                }
            }
            else if('NO_TABLE_EXISTS_IN_DATA_SOURCE' == errCode)
            {
                if($("DBTYPE").value!=2)
                {
                    showCustomMessage(errMsg,$("CONN_CloudDBNAME"));
                }
                else
                {
                    showCustomMessage(errMsg,$("SID"));
                }
            }
            else if('IMPORT_FILE_NUMBER_OF_FIELDS_EXCEEDS_SIZE' == errCode && $("CloudDBMultipleTbl").checked)
            {
                var tblNameDet = response.getResponsePart("OTHER_DETAILS");
                var tblName = tblNameDet.substring(2,tblNameDet.length-2);
                errMsg = errMsg.substring(1,errMsg.length-2);///to remove punctuation
                var msg = errMsg+" "+ZDBI18NMap.f("zrpt.databasedata.js.intable",tblName);
                ZDBAlertAPI.showErrorMsg(msg);
            }
            else
            {
                ZDBAlertAPI.showErrorMsg(errMsg, null, errCode);
            }
        }
    };
    this.showModEdit = function(objId,isFromCloudDB)
    {
        var params = "ZDBACTION=SHOWMODEDIT"; //No I18N
        params+="&OBJID="+objId; //No I18N
        params+="&DBID="+ZDBClientUI.dbId;//No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params,ONSUCCESSFUNC: "CloudDBPage.showModEditDlg",OPSTATUSID: "ZDBMainLoader",OBJID:objId,ISFROMCLOUDDB:isFromCloudDB});
    };
    this.showModEditDlg = function(response, requestOptions)
    {
        if (!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js", "APPENDTODOC", CloudDBPage.showModEditDlg,[response, requestOptions]))
        {
            return;
        }
        if (!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList", "APPENDTODOC", CloudDBPage.showModEditDlg,[response, requestOptions]))
        {
            return;
        }
        var lzName = "CLOUDDB_TABLE_EDIT_DLG"; //No I18N
        var lzOper = "APPENDTODOC"; //No I18N
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZRCloudDB.cc", this, lzOper))
        {
            return;
        }
        var formel = document.createElement("form");
        formel.setAttribute("style", "width:495px;align:right;");
        var importtype = $("SchImportType").cloneNode(true);
        ZDBUtil.setNamedChildEls(importtype,importtype,"id");
        jQuery(importtype.ZDBSCHIMPORTTYPE).empty();
        var result = JSON.parse(response.responseText);
        var permLevel = result.GRIDOBJ.perm[0];
        var perms = permLevel.split("$");
        var impOptionSelect = importtype.ZDBSCHIMPORTTYPE;
        impOptionSelect = ZDBImport.setImportOption(importtype.ZDBSCHIMPORTTYPE, perms);
        var addcolumn = $("SchCanAddNewCol").cloneNode(true);
        formel.setAttribute("id",requestOptions["OBJID"]);
        formel.setAttribute("qa", true);
        var desc = document.createElement("div");
        desc.className="gray";
        desc.innerHTML=ZDBI18NMap.g("zrpt.databasedata.modedit.js.txt");
        formel.appendChild(desc);
        formel.appendChild(importtype);
        formel.appendChild(addcolumn);
        var btns = ZDBClientUI.$("ZREditConnBts").cloneNode(true);
        btns.style.display = "";
        btns.style.marginLeft = "150px"; //No I18N
        formel.appendChild(btns);
        formel.ZRCloudDBSaveBtn.setAttribute("onclick", "CloudDBPage.saveModImportSettings(this.form)");
        var colheads = [];
        var colArr = result.GRIDOBJ.colHead;
        for(var i=0;i<colArr.length;++i)
        {
            var c = colArr[i];
            var colHeader = new ZDBColHeader(this,c[0],c[1],c[2],c[3],c[4],c[5],c[6],c[7],c[8],c[9],c[10],c[11], c[12], c[13],c[14],c[15],false, ZDBConst.CLEAR, c[16], c[17], c[18], c[19], c[20], c[21], c[22], c[23], c[24],c[25], c[26],c[27],c[28],c[29],c[30],c[31],c[32],c[33],c[34],c[35],c[36],c[37],c[38],c[39],c[40],c[41],c[42],c[43],c[44],c[45],c[46],c[47],c[48],c[49],c[50]);
            colheads[i] = colHeader;
        }
        var dg = {};
        dg["colHeaders"] = colheads;
        ZDBImport.setExistColumnList(dg,formel);
        if(result.MATCHCOLS!=null && result.MATCHCOLS!="")
        {
            var matchColList = result.MATCHCOLS.split(',');
            ZDBImport.setCheckListColumn(dg,matchColList,formel);
        }
        ZDBUtil.setNamedChildEls(formel,formel,"id");
        formel.ZDBSCHIMPORTTYPE.value = result.SCHEDULEIMPORTTYPE;
        CloudDBPage.showMatchColList(formel.ZDBSCHIMPORTTYPE);
        if (result.CANADDNEWCOLUMN)
        {
            formel.ZDBCANADDNEWCOLUMN.checked = true;
        }
        else
        {
            formel.ZDBCANADDNEWCOLUMN.checked = false;
        }
        var title = requestOptions["ISFROMCLOUDDB"]==true?'zrpt.databasedata.edit.js.syncimport':'zrpt.edit.js.syncimport';//No I18N
        ZDBDialogUtil.showDialog(formel, {MODAL: true, ADDFRAME: true, DONTREMOVE: false, SHADOW: true, TITLECLASS: 'schedule', TITLE: ZDBI18NMap.g(title)}); // NO I18N
    };

    this.saveModImportSettings = function(el)
    {
        ZDBUtil.setNamedChildEls(el,el,"id");
        var params = "SCHEDULEIMPORTTYPE=" +el.ZDBSCHIMPORTTYPE.value;//No I18N
        params += "&CANADDNEWCOLUMN=" + el.ZDBCANADDNEWCOLUMN.checked;//No I18N
        if (el.ZDBSCHIMPORTTYPE.value == "UPDATEADD" || el.ZDBSCHIMPORTTYPE.value == "DELETEUPDATEADD")
        {
            var matchCols = new Array();
            var matchList = jQuery(el).find("[name='ZOHO_MATCHING_COLUMNS']");
            var count = 0;

            for (var i = 0, j = matchList.length; i < j; i++)
            {
                if (matchList[i].checked)
                {
                    matchCols[count] = matchList[i].value;
                    count++;
                }
            }
            if(count == 0)
            {
                showCustomMessage(ZDBI18NMap.g("zrpt.common.matchingcol.js.errmsg"),matchList[0]);
                return;
            }
            params += "&MATCHINGCOLS=" + matchCols.toString(); //No I18N
        }
        params+="&ZDBACTION=SAVEMODEDIT"; //No I18N
        params+="&OBJID="+el.getAttribute("id"); //No I18N
        AjaxAPI.sendRequest({URL: "/ZRCloudDBAction.ma?", PARAMETERS: params,ONSUCCESSFUNC: "ZRConnector.handleModEditResp",OPSTATUSID: el.ZREDITSTATUS,ELEMENT:el});
    };

    this.highLytPar = function(el)
    {
        var parid = el.getAttribute("orgTbl");
        var parEl = $(parid+"_tbl");
        parEl.className = "zrdbSelectedTblFinalHover";
        var child =  jQuery(el).children()[0];
        child.style.maxWidth="240px"; //No I18N
    };

    this.dehighLytPar = function(el)
    {
        var parid = el.getAttribute("orgTbl");
        var parEl = $(parid+"_tbl");
        parEl.className = "zrdbSelectedTblFinal";
        var ch =  jQuery(el).children()[0];
        ch.style.maxWidth="260px"; //No I18N
    };

    this.editRepTblName = function(element,event)
    {
        jQuery(element).unbind("click"); //No I18N
        element.onclick = "";
        element.style.backgroundColor="#FFFFFF";
        var el =  jQuery(element).children()[0];
        var icon = jQuery(element).children()[1];
        icon.style.display="none";
        var inputTabEl = $("repTblEdit").cloneNode("true");
        inputTabEl.originalValue = ZDBEscapeUtil.decodeForHtml(el.innerHTML);
        el.style.display = "none";
        inputTabEl.style.paddingleft = "-5px"; //No I18N
        inputTabEl.style.width = jQuery(element).width()-10+ "px";
        inputTabEl.style.height = jQuery(element).height()-2+ "px";//border reduced
        inputTabEl.value = inputTabEl.originalValue;
        inputTabEl.style.display = "";
        ZDBUtil.setTimeout(ZDBUtil.setFocus, null, [inputTabEl], 5);
        element.appendChild(inputTabEl);
        if(event){
       ZDBUtil.stopEventBubble(event);
        }
       CloudDBPage.highLytPar(element);
    };

    this.resetTblName = function(el,frm)
    {
        var parel = jQuery(el).siblings()[0];
        var icon = jQuery(el).siblings()[1];
        var pardiv = jQuery(parel).parent()[0];
        if(el.value !=="")
        {
            parel.innerHTML = ZDBEscapeUtil.encodeForHtml(el.value);
        }
        else
        {
            parel.innerHTML = ZDBEscapeUtil.encodeForHtml(el.originalValue);
        }
        el.style.display = "none";
        icon.style.display = "";
        parel.style.display="inline-block";
        jQuery(pardiv).bind("click", function(event){ CloudDBPage.editRepTblName(this,event)});
        ZDBUtil.setAttribute(pardiv,'CloudDBPage.editRepTblName(this,event)','onclick');
        ZDBUtil.setAttribute(pardiv,el.value,"id");
        pardiv.style.backgroundColor="";
        jQuery(el).remove();
        var index = jQuery(parel).parent().index();
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        var reportsTableArray = ZDBUtil.getAttribute(frm.MultipleTblList, "reportsTableArray").split(',');
        reportsTableArray[index] = ZDBEscapeUtil.decodeForHtml(parel.innerHTML);
        ZDBUtil.setAttribute(frm.MultipleTblList, reportsTableArray, "reportsTableArray");
        CloudDBPage.dehighLytPar(pardiv);
    };

    this.checkLiveConnect = function(isLive)
    {
        if(isLive)
        {
            $("CloudDBLiveConnect").checked = true;
        }
        else
        {
            $("CloudDBPeriodicFetch").checked=true;
        }
    };

    this.removeObj = function()
    {
        hideCustomMessage();
        var tab = ZDBClientUI.selectedTab;
        if(tab.view.clouddbview)
        {
            tab.view.clouddbview = null;
        }
    }

    this.showDataSourcesDlg = function()
    {
        var view = ZDBClientUI.selectedTab.view;
        var connId = view.connectionId;
        CloudDBPage.showDataSourcesDlgInExp("-11_" + connId);
//        var id = "-11_" + connId;
//        ZRConnector.changeClass($(id));
    }

    this.showDataSourcesDlgInExp = function(elId)
    {
        if(ZRConnector.isDlgOpened)
        {
            ZDBClientUI.selectTab(ZDBNavigation.explorerTab);
            return;
        }
        ZRConnector.isDlgOpened = true;
        var params = "&DBID=" + ZDBClientUI.dbId; // No I18N
        AjaxAPI.sendRequest({
                URL:"/ZRDataSources.cc?ZDBACTION=FETCHDATASOURCES", // No I18N
    			METHOD:"GET", //No I18N
                PARAMETERS:params,
                ONSUCCESSFUNC:CloudDBPage.handleDataSourcePage,
                OPSTATUSID:"ZDBMainLoader", // No I18N
                ELEMENTID:elId
            });
    };

    this.handleDataSourcePage = function(response,requestOptions)
    {
        ZDBClientUI.selectTab(ZDBNavigation.explorerTab);
        ZRConnector.successDataSourcesDlg(response,requestOptions);
        ZRConnector.changeClass($(requestOptions["ELEMENTID"]), null, 'switch');//No I18N
    }
    this.getDatabaseType = function(servicename,frm){
        var toReturn;
        if(servicename==1){
           toReturn=3//PostgreSQL for Redshift
        }else if(servicename==2){
           toReturn=1//MSSQL for Azure
        }else if(servicename==5){
            toReturn=3//PostgreSQL for Heroku
        }
        else if(servicename == 4){
			toReturn=0 //MySQL for Google Cloud SQL
		}else{
            if(frm==undefined){
                toReturn = $("DBTYPE").value;
            }else{
                toReturn=frm.DBTYPE.value
            }
        }
        return toReturn;
}
};

ZDBLazyLoadFuncMap.lazyLoadFuncMap["CloudDBPage.showCreateCloudDB"] = CloudDBPage.showCreateCloudDB;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["CloudDBPage.showCreateCloudDBTable"] = CloudDBPage.showCreateCloudDBTable;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["CloudDBPage.showExistImpDialog"] = CloudDBPage.showExistImpDialog;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["CloudDBPage.showDataSourcesDlg"] = CloudDBPage.showDataSourcesDlg;

