//$Id$

var ZAComboLegendEdit = new function()
{
    var legObj;

    this.modifyChartTypeRefresh = function(view)
    {
        if(!view)
        {
            view = ZDBClientUI.selectedTab.view;
        }
        var chartObj = view.chartObj;
        var legendModel = chartObj.getLegendModel();
        
        var legVal = view.chartSelectedEl.isMultiY ? legObj["instId"] : legObj["origValue"];
        var comboVal = legObj["comboType"] ? '0' : '1'; //No I18N
        var list = view.chartSelectedEl.isMultiY ? view.curListProp : legendModel.getComboLineValList();
        
        list = legendModel.comboValUpdate(list, comboVal, legVal);
    	legendModel.updateComboToView(list);
    	legObj["comboType"] = !legObj["comboType"];
    	var chartData = chartObj.getChartData();
    	chartData[legObj["index"]].type = legendModel.alterComboChartType(legObj["comboType"], view.subGraphType);
    	chartObj.redrawNewChartType();
    	view.setModified();
    	return;
    }

    // display combo option in color legend popup menu (in edit mode)
    this.showComboInLegendPopup = function(view, legObjVar)
    {
    	legObj = legObjVar;
        var filterIncl = $("Include");
        var filterExcl = $("Exclude");
        var legendRename = $("LegendRename");
        var menuItem = $("ChangeCombo");
       
        filterIncl.style.display = view.chartSelectedEl.isMultiY ? "none" : "" ; 
        filterExcl.style.display = view.chartSelectedEl.isMultiY ? "none" : "" ;
        legendRename.style.display = view.chartSelectedEl.isMultiY ? "" : "none" ;
        if(view.chartSelectedEl.isMultiY)
    	{
        	legendRename.setAttribute("clrOrder", legObj["index"]); 
    	}
        var graphType = view.graphSelected;
        
        if(graphType != "COMBO")
        {
            menuItem.style.display = "none";
        }
        else
        {
            menuItem.style.display="";
            menuItem.innerHTML = legObj["comboType"] ? ZDBI18NMap.g("zrpt.popup.dynamic.js.comboBar")  //No I18N
            						: ZDBI18NMap.g("zrpt.popup.dynamic.js.comboLine");
        }
    }
}