//$Id$
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 * 
 * @author john-3139
 */
//ignorei18n_start

(function (win) {
//    if (win.fetch) {
//        //fetch implementations needs to go here.
//    } else {
    function __ZRSAjax() {
        this.requestWithNoBody = ['get', 'head', 'delete'];
        this.requestWithBody = ['post', 'put'];
    }
    function __ZRSAjaxTransport(config) {
        this.config = config || {};
        this.commonHeaders = {
            'X-Requested-With': 'XMLHttpRequest',
            'Accept': 'application/json'
        };
        this.xhr = new XMLHttpRequest();
        this.removeLoader = false;
        this.loader = null;
        if (!this.config.noLoader) {
            this.attachLoader();
        }
        this.xhr.onreadystatechange = this.onreadystatechange.bind(this);
        this.xhr.ontimeout = this.timeOutHandler.bind(this);
    }
    __ZRSAjax.prototype.ajaxTransport = __ZRSAjaxTransport;
    __ZRSAjax.prototype.sendReqWithNoBody = function (config) {
        if (!config.url) {
            throw 'Provide a valid URL';
        }
        var curTransportConfig = new this.ajaxTransport(config);
        curTransportConfig.handleNonBodyRequestParams();
        curTransportConfig.open();
        curTransportConfig.xhr.responseType = 'json';
        curTransportConfig.addCommonHeaders();
        curTransportConfig.addNonBodyRequestSpecificHeaders();
        curTransportConfig.send();
    };
    __ZRSAjaxTransport.prototype.createLoader = function () {
        var loader = document.createElement('div');
//    loader.id = new Date().getTime();
        loader.className = 'zdbLoaded';
        loader.setAttribute('elname', 'loadingDiv');
        var loaderTxt = document.createElement('div');
        loaderTxt.className = 'loadingImage';
        loaderTxt.setAttribute('elname', 'textEl');
        loaderTxt.innerText = ZDBI18NMap.g('zrpt.chart.dyndrilldown.js.loading');
        loader.appendChild(loaderTxt);
        return loader;
    };
    __ZRSAjaxTransport.prototype.attachLoader = function () {
        if (this.config.loader) {
            this.removeLoader = false;
            if (this.config.loader instanceof HTMLElement) {
                this.loader = this.config.loader;
            } else if (typeof this.config.loader === 'string') {
                this.loader = document.getElementById(this.config.loader);
            }
        } else {
            this.removeLoader = true;
            var newLoader = this.createLoader();
            document.body.appendChild(newLoader);
            this.loader = newLoader;
        }
    };
    __ZRSAjaxTransport.prototype.addCommonHeaders = function () {
        this.setRequestHeader(this.commonHeaders);
    };
    __ZRSAjaxTransport.prototype.addNonBodyRequestSpecificHeaders = function () {
        //get, head, delete specific headers
    };
    __ZRSAjaxTransport.prototype.handleNonBodyRequestParams = function () {
        var data = this.config.data;
        if (data) {
            var url = this.getURLSuffixed(this.config.url);
            this.config.url = this.attachParameters(url, data);
        }
    };
    __ZRSAjaxTransport.prototype.getURLSuffixed = function (dest) {
        if (dest.lastIndexOf('?') === -1)
        {
            dest += "?";
        } else if (dest.indexOf('?') > 0 && dest.charAt(dest.length - 1) !== '?' && dest.charAt(dest.length - 1) !== '&')
        {
            dest += "&";
        }
        return dest;
    };
    __ZRSAjax.prototype.sendReqWithBody = function (config) {
        if (!config.url) {
            throw 'Provide a valid URL';
        }
        var curTransportConfig = new this.ajaxTransport(config);
        var body = curTransportConfig.handleBodyRequestParams();
        curTransportConfig.open();
        curTransportConfig.xhr.responseType = 'json';
        curTransportConfig.addCommonHeaders();
        curTransportConfig.addBodyRequestSpecificHeaders(body);
        curTransportConfig.send(body);
    };
    __ZRSAjaxTransport.prototype.addBodyRequestSpecificHeaders = function () {
        //post, put specific headers
        this.setRequestHeader({
            'Content-Type': 'application/x-www-form-urlencoded'
        });
    };
    __ZRSAjaxTransport.prototype.handleBodyRequestParams = function () {
        var data = this.config.data;
        var resultantParameters = '';
        if (data) {
            resultantParameters = this.attachParameters(resultantParameters, data);
        }
        //adding csrf
        resultantParameters = resultantParameters ? resultantParameters + '&' : '';
        resultantParameters += 'ZDB_CSRF_TOKEN=' + this.getCookie("CSRF_TOKEN");
        return resultantParameters;
    };
    __ZRSAjaxTransport.prototype.attachParameters = function (dest, data) {
        var typeOfData = typeof data;
        if (typeOfData === 'string') {
            dest += data;
        } else if (typeOfData === 'object' && !(data instanceof Array)) {
            var keys = Object.keys(data);
            var dataString = '';
            keys.forEach(function (key) {
                var value = data[key];
                var finalVal = key + '=' + value;
                dataString += dataString ? '&' + finalVal : finalVal;
            });
            dest += dataString;
        } else {
            throw 'Provide data as an Object or String';
        }
        return dest;
    };
    __ZRSAjaxTransport.prototype.getCookie = function (name) {
        var arg = name + "=";
        var alen = arg.length;
        var clen = document.cookie.length;
        var i = 0;
        while (i < clen) {
            var j = i + alen;
            if (document.cookie.substring(i, j) === arg) {
                return getCookieVal(j, document);
            }
            i = document.cookie.indexOf(" ", i) + 1;
            if (i === 0) {
                break;
            }
        }
        return null;
    };
    __ZRSAjaxTransport.prototype.open = function () {
        var dest = this.config.url;
        if (dest.indexOf('/reports/') < 0) {
            dest = ZDBGlobal.REPORTS_CONTEXT_NAME + dest;
        }
        this.xhr.open(this.config.method, dest, true);
    };
    __ZRSAjaxTransport.prototype.setTimeout = function (milliseconds) {
        this.xhr.timeout = milliseconds;
    };
    __ZRSAjaxTransport.prototype.timeOutHandler = function (e) {
        //console.log('timeout');
    };
    __ZRSAjaxTransport.prototype.abort = function () {
        this.xhr.abort();
    };
    __ZRSAjaxTransport.prototype.send = function (body) {
        if (!this.config.noLoader) {
            var loaderClassName = this.loader.className;
            loaderClassName = loaderClassName.substring(0, loaderClassName.lastIndexOf('ed'));
            loaderClassName += 'ing';
            this.loader.className = loaderClassName;
        }
        this.xhr.send(body);
    };
    __ZRSAjaxTransport.prototype.setRequestHeader = function (headers) {
        var headerKeys = Object.keys(headers);
        headerKeys.forEach(function (header) {
            this.xhr.setRequestHeader(header, headers[header]);
        }.bind(this));
    };
    __ZRSAjaxTransport.prototype.onreadystatechange = function () {
        if (this.xhr.readyState === XMLHttpRequest.UNSEND) {
            //console.log('unsent');
        }
        if (this.xhr.readyState === XMLHttpRequest.OPENED) {
            //console.log('opened');
        }
        if (this.xhr.readyState === XMLHttpRequest.HEADERS_RECEIVED) {
            //console.log('headers_received');
        }
        if (this.xhr.readyState === XMLHttpRequest.LOADING) {
            //console.log('loading');
        }
        if (this.xhr.readyState === XMLHttpRequest.DONE) {
            if (!this.config.noLoader) {
                var loaderClassName = this.loader.className;
                if (loaderClassName.lastIndexOf('ing') > -1) {
                    //to avoid same loader issue with lazyloading and ajax from old requests
                    loaderClassName = loaderClassName.substring(0, loaderClassName.lastIndexOf('ing'));
                    loaderClassName += 'ed';
                }
                this.loader.className = loaderClassName;
                if (this.removeLoader) {
                    this.loader.parentNode.removeChild(this.loader);
                }
            }
            if (this.xhr.status === 0) {
                //either abort is called
                //network failure
                //CORS failure
                //other network related security failures(https, http)
            } else if (this.xhr.status === 200) {
                //request is a success.
                this.successHandler();
            } else if (this.xhr.status >= 400 && this.xhr.status <= 499) {
                //Failure Cases.
                this.failureHandler();
            } else if (this.xhr.status >= 500) {
                //Error Cases.
                this.errorHandler();
            }
        }
    };
    __ZRSAjaxTransport.prototype.validateHandlerEthnicity = function (handlerObj) {
        if (typeof handlerObj.func !== 'function') {
            throw 'Provide a proper function reference';
        }
        if (typeof handlerObj.ctx !== 'object') {
            throw 'Provide a proper execution context for the success handler';
        }
        if (handlerObj.args && !(handlerObj.args instanceof Array)) {
            throw 'Arguments should be given as a Javascript array';
        }
    };
    __ZRSAjaxTransport.prototype.successHandler = function () {
        //console.log('success');
        //console.log(this.xhr.response);
        if (this.config.successHandler) {
            this.validateHandlerEthnicity(this.config.successHandler);
            var output = this.getResponseJSON();
            this.config.successHandler.func.apply(this.config.successHandler.ctx, [output.data, this.config]);
        }
    };
    __ZRSAjaxTransport.prototype.failureHandler = function () {
        //console.log('failure');
        //console.log(this.xhr.response);
        try{
            if (this.config.failureHandler) {
                this.validateHandlerEthnicity(this.config.failureHandler);
                var output = this.getResponseJSON();
                this.config.failureHandler.func.apply(this.config.failureHandler.ctx, [output, this.config]);
            } else if (!this.config.dcDefFailFunc) {
                ZDBAlertAPI.showErrorMsg(this.xhr.response.message);
            }
        }catch(error){
            this.config.failureHandler.func.apply(this.config.failureHandler.ctx, [this.xhr.response, this.config]);
        }
    };
    __ZRSAjaxTransport.prototype.errorHandler = function () {
        //console.log('error');
        //console.log(this.xhr.response);
        try{
            if (this.config.errorHandler) {
                this.validateHandlerEthnicity(this.config.errorHandler);
                var output = this.getResponseJSON();
                this.config.errorHandler.func.apply(this.config.errorHandler.ctx, [output, this.config]);
            } else if (!this.config.dcDefErrFunc) {

            }
        }catch(error){
            this.config.errorHandler.func.apply(this.config.errorHandler.ctx, [this.xhr.response, this.config]);
        }
    };
    __ZRSAjaxTransport.prototype.getResponseJSON = function () {
        var output = this.xhr.response || this.xhr.responseText; //for ie9
        if (typeof output !== 'object') {
            output = JSON.parse(output);
        }
        return output;
    };
    var ZRSAjax = new __ZRSAjax();
    ZRSAjax.requestWithNoBody.forEach(function (method) {
        __ZRSAjax.prototype[method] = function (url, data, config) {
            var conf = config || {};
            conf.method = method;
            conf.url = url;
            conf.data = data;
            return this.sendReqWithNoBody(conf);
        };
    });
    ZRSAjax.requestWithBody.forEach(function (method) {
        __ZRSAjax.prototype[method] = function (url, data, config) {
            var conf = config || {};
            conf.method = method;
            conf.url = url;
            conf.data = data;
            return this.sendReqWithBody(conf);
        };
    });
    win.ZRSAjax = ZRSAjax;
    //ignorei18n_end
//    }
})(window);
