//$Id$
//$$ This script contains both scripts for creating the database and for importing a table.

var sampleTableGrid;

function setColListVisible(set)
{ //No I18N
    $("colListTR").style.display = (set) ? "" : "none"; //No I18N
}

 function searchDatabases()
 {
   var text = ZDBSearchUtil.getSearchValue($("ZDBDBSEARCHBOX"));
   updateState("ZDBListDatabases","SCRITERIA",text);
   resetNavigationState("ZDBListDatabases");
   refreshSubView("ZDBListDatabases");
 }

function editConnections(dbId,el)
{
  var dbNode = $('ZDBNAME_' + dbId);
  var dbName = ZDBUtil.getText(dbNode);
  var desc = '';
  var descEl = $('ZDBDESC_' + dbId);
  if(descEl != null)
  {
    desc = ZDBUtil.getText(descEl);
  }
  if(!ZDBLazyLoadUtil.loadSnippet("RENAMEDB_DLG","/ZDBEditConnections.cc",this,"APPENDTODOC"))
  {
    return;
  }
  var dlg = $('ZDBEditConnections');
  dlg.style.display = 'block';
  var dbNameFld = $('ZDBDBNameTxtFld');
  var dbDescFld = $('ZDBDBObjDescTxtFld');
  dbNameFld.value = dbName;
  dbDescFld.value = desc;
  var parEl = DOMUtils.getParentWithAttrValue(el,"class","ZRSDBList ZRSDBHighlight");//NO I18N
  parEl.isDialogOpen = true;
  dlg.parEl = parEl;
  ZDBDialogUtil.showDialog(dlg,{TITLE:ZDBI18NMap.g('zrpt.common.home.js.renamedb'),ADDFRAME:true,MODAL:true,DONTREMOVE:true,
							  									ONENTER:submitRenameDB,ORIGNAME:dbName,ORIGDESC:desc,
							  									NAMEFLD:dbNameFld,DESCFLD:dbDescFld,DBID:dbId,
							  									CALLOUT:true,SRCEL:el,ONCLOSE:ZDBCreateDB.removeHighlight});
  $('ZDBDBRENAMEOPTSTATUS').className = 'mcLoaded';
  dbNameFld.select();
}

function submitRenameDB_NewLayout(el)
{
	var elVal = el.value;
    var dbId = ZDBClientUI.dbId;
	 var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?";//NO I18N
		var params = "&ZDBACTION=" + "EDITDBDETAILS" + "&DBNAME=" + encodeURIComponent(elVal)  +//NO I18N
		"&DBID=" + dbId;//NO I18N

	  AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:updateDBDetails,
	                       ONFAILUREFUNC:updateDBDetFailure,OPSTATUSID:"ZDBDBRENAMEOPTSTATUS",//NO I18N
	                       DBID:dbId});
}


function adminTakeOverFromExp(dbId)
{
	 ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.common.js.admintakeover.msg'),"ZDBYESNO",//NO I18N
			 {ONCLICK:confirmAdminTakeOver,DBID:dbId},ZDBI18NMap.g('zrpt.common.js.admintakeover.title'));    //No I18N
}

function confirmAdminTakeOver(clickType,requestOptions)
{
	if(clickType != "YES")
	{
		return;
	}

	var params = "&DBTOCOPY="+requestOptions["DBID"];//No I18N
  	AjaxAPI.sendRequest({URL:"/ZDBAdminActionMI.ma?ZDBACTION=ADMINTAKEOVERFROMEXP"+params, METHOD:"POST",
        ONSUCCESSFUNC:handleAdminTakeOverSchSuccess,OPSTATUSID:"ZDBMainLoader"});      //No I18N
}

function handleAdminTakeOverSchSuccess(response, requestOptions)
{
	ZDBDialogUtil.closeDialog();
	ZDBMsgBox.showSuccess(response.responseText);
}

function submitRenameDB()
{
  var dlg = ZDBDialogUtil.focusDialog;
  var origName = dlg.params["ORIGNAME"];
  var origDesc = dlg.params["ORIGDESC"];
  var curName = dlg.params["NAMEFLD"].value;
  var curDesc = dlg.params["DESCFLD"].value;
  curName = curName.replace(/\u00a0/g," ");
  if(origName == curName && origDesc == curDesc)
  {
    ZDBDialogUtil.closeDialog();
    return;
  }
  var action = "EDITDBDETAILS"; //NO I18N
  if(origName == curName)
  {
    action = "EDITDBDESC"; //NO I18N
  }
  var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?"; //NO I18N
  var params = "&ZDBACTION=" + action + "&DBNAME=" + encodeURIComponent(curName) + //NO I18N
               "&DESC=" + encodeURIComponent(curDesc) + "&DBID=" + dlg.params["DBID"]; //NO I18N
  AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:updateDBDetails,
                       ONFAILUREFUNC:updateDBDetFailure,OPSTATUSID:"ZDBDBRENAMEOPTSTATUS",  //NO I18N
                       DBID:dlg.params["DBID"]});
}

function copyDBFromDB(dbId , dbName , desc)
{
  if(!ZDBLazyLoadUtil.loadSnippet("COPYDB_DLG","/ZDBCopyDB.cc",this,"APPENDTODOC",null,copyDBFromDB,[dbId,dbName,desc]))
{
    return;
  }
  var dlg = $('ZDBCopyDBDetails');
  dlg.style.display = 'block';
  var dbNameFld = $('ZDBDBCPNameTxtFld');
  var dbDescFld = $('ZDBDBCPObjDescTxtFld');
  var dbCopyDataFld = $('ZDBDBCPDataChkBox');
  dbCopyDataFld.checked = true;
  dbNameFld.value = dbName+ZDBI18NMap.g("zrpt.common.js.copy");
  dbDescFld.value = desc;
  ZDBDialogUtil.showDialog(dlg,{TITLE:ZDBI18NMap.g('zrpt.homepage.db.copydb.js.dlgTtl'),ADDFRAME:true,MODAL:true,DONTREMOVE:true,
                                        ONENTER:submitCopyDB,ORIGNAME:dbName,ORIGDESC:desc,
                                                  NAMEFLD:dbNameFld,DESCFLD:dbDescFld,DBID:dbId,COPYDATA:dbCopyDataFld,
                                                  REDIRECTTONEWDB:"true"});
  $('ZDBDBCOPYOPTSTATUS').className = 'mcLoaded';
  dbNameFld.select();
}
 
function submitCopyDB()
{
	var dlg = ZDBDialogUtil.focusDialog;
	  var origName = dlg.params["ORIGNAME"];
	  var origDesc = dlg.params["ORIGDESC"];
	  var curName = dlg.params["NAMEFLD"].value.trim();
	  var curDesc = dlg.params["DESCFLD"].value.trim();
	  var copyDataCB = dlg.params["COPYDATA"];
	  var url = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma";	//NO I18N
	  var params = "ZDBACTION=COPYDATABASE&DBNAME=" + encodeURIComponent(curName) + "&DESCRIPTION=" + encodeURIComponent(curDesc) + //NO I18N
	      "&DBTOCOPY=" + dlg.params["DBID"];	//NO I18N
	  if(copyDataCB && copyDataCB.checked == true)
  {
	      params += "&COPYDATA=true";	//NO I18N
  }
  else
  {
	      params += "&COPYDATA=false";	//NO I18N
	  }

	  AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:"hanCopyDBSucess",
	                       OPSTATUSID:"ZDBDBCOPYOPTSTATUS",	//NO I18N
	                       DBID:dlg.params["DBID"] ,REDIRECTTONEWDB:dlg.params["REDIRECTTONEWDB"] ,DBNAME:encodeURIComponent(curName) ,ACTION:"COPYDATABASE"});//NO I18N

}


function hanCopyDBSucess(response, requestOptions)
{  
    var newDB = requestOptions["REDIRECTTONEWDB"];
    var params = response.getResponseParams();
    ZDBDialogUtil.closeDialog();
    if(newDB == "true")
    {
         var url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + params["NEWDBID"];// No I18N
         window.location.href = url;
    }
    else
    {
        ZRSHomepageListing.updateList(response, requestOptions);
    }
}

function updateDBDetails(response, requestOptions)
{
  var dbId = requestOptions["DBID"];
 
  var params = response.getResponseParams();
  if(ZDBClientUI.dbId)
  {
    ZDBNavigation.updateDBDetails(params);
  }
  else
  {
  	var dbName = params["DBNAME"];
    $('ZDBNAME_' + dbId).innerHTML = ZDBEscapeUtil.escSplCharAsHTMLWithSpaceEncode(dbName);
    var descEl = $('ZDBDESC_' + dbId);
    if(descEl != null)
    {
      descEl.innerHTML = ZDBEscapeUtil.encodeForHtml(params["DESC"]);
      
    }
    else if(params["DESC"] != "")
    {
      var descParEl = '<p class="dbDescription" id="ZDBDESC_'+dbId+'">'+ZDBEscapeUtil.encodeForHtml(params["DESC"])+'</p>';//No I18N
      var par = jQuery("#ZDBNAME_"+dbId).parent("div");        //No I18N
      jQuery(descParEl).insertAfter(par); //No I18N
    }
    var myDBList = ZRSHomepageListing.dbInfos.MYDBS;
    if(myDBList){
        updateNamespace:
        for(var namespace in myDBList){
            var dbsInNamespace = myDBList[namespace];
            for(var i=0,len = dbsInNamespace.length; i<len; i++){
                if(dbsInNamespace[i][1] == dbId){
                    dbsInNamespace[i][0] = dbName;
                    dbsInNamespace[i][2] = params.DESC;
                    break updateNamespace;
                }
            }
        }
    } 
    typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.pushChanges(ZRCRMPlus.RENAMEDATABASE, dbId, dbName);//NO I18N
  }
  ZDBDialogUtil.closeDialog();
}

function updateDBDetFailure(response, requestOptions)
{
  var errCode = response.getResponsePart("ERRORCODE");
  errCode = trimAll(errCode);
  if(errCode == "META_DBNAME_DUPLICATE")
  {
    var dlg = ZDBDialogUtil.focusDialog;
    showCustomMessage(response.getResponsePart("STATUS_MESSAGE"), dlg.params["NAMEFLD"]);
    dlg.params["NAMEFLD"].select();
  }
  else
  {
    ZDBDialogUtil.closeDialog();
    AjaxAPI.onFailureFunc(response,requestOptions);
  }
}

function ZDBTestConnection(frm)
{
	document.getElementById("testCheckbox").value="true";
	this.submitCreateDB(frm);
	return false;
}

function submitCreateDB(frm)
{
	if(ZDBGlobal.IS_MOBILE && !ZDBLazyLoadUtil.loadJsAlone("zdbjs/gridcore/ZRScroller.js","APPENDTODOC",submitCreateDB,[frm]))
    {
        return;
    }
	if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBGridList","import/js/ZDBImport.js","zdbjs/dbconnectivity/ZDBDBConnection.js","zdbjs/odatajs/ODataPage.js"],"APPENDTODOC",submitCreateDB,[frm]))
	  {
	    return false;
	  }
  if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC", submitCreateDB,[frm])){
   	return false;
  }

    if(ZDBGlobal.ISNEWLAYOUT && ZDBGlobal.LANDINGPAGE == "ZDBHome" && ZRTour.tourCalled == 2)
    {
        ZRTour.endTour(true);
        ZRTour.tourCalled = 3;
    }

  var opt = $("ZDBOPTIONINP").value;
  var location = opt;
  if(opt == "inhousedb")
  {
	  ZDBDBConnection.showLocDBsAndTBsList(frm);
	  return false;
  }
  if(opt == "cloud")
  {
	  submitCloudDB(frm);
	  return false;
  }
  if(opt == "remote")
  {
	  RDBPage.getDatabases();
	  return false;
  }
  hideCustomMessage();
  if(opt == "import")
  {
    frm.setAttribute("useiframe","true");
    frm.action = frm.getAttribute("actionurl");

    var importType = $("ZDBFILETYPE").value;
    var isWeb = $("ZDBWEBOPT").checked;
    if(isWeb)
        {
            showHideUrlParamDiv(false);
            location = "web"; //No I18N
        }
    if($("ZDBFTPOPT")){
    	var isFTP = $("ZDBFTPOPT").checked;
    	location = "ftp"; //No I18N
    }
    var isPaste = $("ZDBPASTEOPT").checked;
    var isFile = $("ZDBFILEOPT").checked;
    var importTypes = ["CSV","XLS","HTML","JSON","XML","ODATA"]; //No I18N
    
    location = (isFile)?"file":location; //No I18N
    location = (isPaste)?"paste":location; //No I18N

    var isImpTypeMatched = importTypes.indexOf(importType) > -1;
      
    if(isWeb && importType != "GSHEET" && importType != "ZDOCS" && (!ZDBImport.isExternalFile(importType)))
        {frm.URL.value = frm.URL.value == "Type your URL"?"":frm.URL.value;//No I18N
    }
    if(isFile && isImpTypeMatched)
    {
    	if(isFileUploadSample()){
    		frm.ZDBFILENAME.value = "Sample Data"; //No I18N
    }
    	else{
    	      frm.ZDBFILENAME.value = frm.FILENAME.value;
    	      //frm.setAttribute("useiframe","true");	
    	      if(!ZDBImport.isValidFileExtension(frm.FILENAME.value))
    {
    	        alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.unsupportedImportFileFormat"));
    	        isPaste = true;
    	        locationSelected('PASTEDATA');
    	        return false;
    	      }
    		}
    }
    else if(isPaste && isImpTypeMatched)
    {
    	if(importType == "XLS")
  		{
    		importType = "CSV";    //No I18N
                $("ZDBFILETYPE").value = "CSV";    //No I18N
  }
      frm.ZDBFILENAME.value = " the data you have pasted";
}
    else if (isWeb && isImpTypeMatched)
    {
      frm.ZDBFILENAME.value = frm.URL.value;
      if(!ZDBImport.isValidFileExtension(frm.URL.value))
{
        alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.unsupportedImportFileFormat"));
        return false;
      }
      if(importType == "ODATA")
  {
          odataImport(frm);
          return false;
      }
  }
    else if (isFTP && isImpTypeMatched)
  {
      var ftpProtocol = "ftp"; //No I18N
      if(frm.FTPPROTOCOL.value!="ftp" && ftpProtocol!="sftp"){
    	  ftpProtocol = "ftps"; //No I18N
      }
      frm.ZDBFILENAME.value = ftpProtocol + "://"+frm.FTPHOST.value+'/'+frm.FTPPATH.value;
  }
    frm.reloadCount = 0;//$$ Test this!!.- Add this to test cases.
}
  else
  {
  	var actionName = {"template" : "CREATEDBFROMTEMPLATE", //No I18N
				 "scratch"	: "CREATEDBFROMSCRATCH", //No I18N
				 "remote" : "CREATEREMOTECONNECTION", //No I18N
				 "remotedb" : "CREATEDBFROMREMOTE", //No I18N
				 "enterdata" : "CREATEDBFROMENTERDATA" //No I18N
				};
  	var act = actionName[opt] ? actionName[opt] : "CREATEDB";
  	if(opt == "template" && $("CDBDATA") != null)
{
    	 frm.COPYDATA.value = (frm.CDBDATA.checked == true) ? "true" : "false";
}

    if($("XMLTODB"))
{
    	var xmlToDb =$("XMLTODB").value;
    	if(xmlToDb!=null && xmlToDb !="")
    {
    	frm.action = "/ZDBDatabaseActionMI.ma?ZDBACTION=" + encodeURIComponent("CREATEDBFROMXMLTEMPLATE"); //No I18N
    	}
    }
else
	  {
   frm.action = "/ZDBDatabaseActionMI.ma?ZDBACTION=" + encodeURIComponent(act);
}
    frm.setAttribute("useiframe","false");
    frm.removeAttribute("enctype");
	  }
  ZDBImport.setEncoding(frm, "import");
  var fileOpts = getFileOptsForImport(location,frm);
  AjaxAPI.submit(frm); 
  enableFileUpload();
   	return false;
  }

function odataImport(frm)
  {
        if (!ODataPage.validateConnDet(frm))
  {
	  return false;
  }
        $("ZDBNextDBBtn").setAttribute("stepno", "1");
        
        frm.ZDBFILENAME.value = frm.URL.value;
        
        var dbId = ZDBClientUI.dbId;
        
        if(dbId == undefined)
  {
            if (!ZDBLazyLoadUtil.loadSnippet("ODATA_TABLE_EDIT_DLG", "/ZROData.cc", this, "APPENDTODOC"))
        {
                return;
        }
    }
        var conndetails = {};
        
        var respHandlerRootUrl = "handleRootURL"; //No I18N
        var respHandlerTableUrl = "handlTableURL"; //No I18N
    
        conndetails["ODATAURL"] = $("ZDBInputURL").value; 
        conndetails["USERNAME"] = $("ZDBUSERNAME").value;
        conndetails["PASSWORD"] = $("ZDBPASSWORD").value;

        if(dbId == undefined)
        {
            conndetails["DATABASENAME"] = $("IDBNAME1").value;
            //conndetails["DESCRIPTION"] = $("IDESCRIPTION").value;
        }
        else
        {

            conndetails["DBID"] = dbId;
            respHandlerRootUrl = "handleRootURLExistingDB"; //No I18N
            respHandlerTableUrl = "handleTableURLExistingDB"; //No I18N
        }
        if(ODataPage.isRoot(conndetails["ODATAURL"]))
    {
            var params = "ZDBACTION=TESTANDFETCHODATATABLES&ODATAFEEDURL=" + encodeURIComponent(JSON.stringify(conndetails)); //No I18N
            AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ELEMENT: frm, ONSUCCESSFUNC: respHandlerRootUrl, ONFAILUREFUNC: "ODataPage.handleFailure",  OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});
    	}
        else
        {
            if($("ITABLENAME"))
            {
                var tableName = $("ITABLENAME").value;
                ZDBUtil.setNamedChildEls($("ITABLENAME"), $("ITABLENAME"), "name");
                if (!ZDBValidator.checkValidInput(tableName))
    	      {
                    showCustomMessage(ZDBUtil.getAttribute($("ITABLENAME"), "errormsg"), $("ITABLENAME"));
    	        return false;
    	      }
                conndetails["TABLENAME"] = tableName;
            }
            var params = "ZDBACTION=SHOWPREVIEWODATA&ODATAFEEDURL=" + encodeURIComponent(JSON.stringify(conndetails)); //No I18N
            params = params + "&QUERYTYPE=" + 1; //No I18N
            if(dbId != undefined)
            {
                params = params + "&DBID=" + ZDBClientUI.dbId;//No I18N   
            }
            params += "&FILETYPE=CSV&LOCATION=CLOUDDATABASE"; //No I18N
            
            AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ELEMENT: frm, ONSUCCESSFUNC: respHandlerTableUrl, ONFAILUREFUNC: "handleFailure", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});
        }
    	}

function handleRootURL(response,responseOption)
{
    ODataPage.showODataDetails($("ZDBCreateFrm"),response,responseOption);
    }

function handlTableURL(response,responseOption)
    {
    ODataPage.showODataTableDetails($("ZDBCreateFrm"),response,responseOption);
  		}

function handleRootURLExistingDB(response,responseOption)
    {
    if (!ZDBLazyLoadUtil.loadSnippet('CREATE_ODATA_TABLE_DLG', "/ZROData.cc", this, 'APPENDTODOC',null,handleRootURLExistingDB, [response, responseOption]))
      {
        return;
      }
    ZDBInlineDialog.closeDialog();
    ODataPage.showCreateODataTable();                                                                               
    $("ODATAURL").value = responseOption.ELEMENT.URL.value;
    $("ODATA_USERNAME").value = responseOption.ELEMENT.USERNAME.value;
    $("ODATA_PASSWORD").value = responseOption.ELEMENT.PASSWORD.value;
    ODataPage.showSelectTablesPage(response,responseOption);
    }

function handleTableURLExistingDB(response,responseOption)
{
    if (!ZDBLazyLoadUtil.loadSnippet('CREATE_ODATA_TABLE_DLG', "/ZROData.cc", this, 'APPENDTODOC',null,handleTableURLExistingDB, [response, responseOption]))
    {
        return;
      }
    ZDBInlineDialog.closeDialog();
    ODataPage.showCreateODataTable();                          //ZROData.jsp loaded in a tab
    $("TABLEARRAY").value = responseOption.ELEMENT.TABLENAME.value;
    $("ODATAURL").value = responseOption.ELEMENT.URL.value;
    $("ODATA_USERNAME").value = responseOption.ELEMENT.USERNAME.value;
    $("ODATA_PASSWORD").value = responseOption.ELEMENT.PASSWORD.value;
    ODataPage.handlePreviewScript(response,responseOption);
    }

function handleFailure(response, requestOptions)
  {
    var errCode = response.getResponsePart("ERRORCODE");
    var errMsg = response.getResponsePart("STATUS_MESSAGE");
    errCode = trimAll(errCode);
    if(errCode!=null)
    {
        if('Not a Valid URL' == errCode || 'Not a Valid OData URL' == errCode)
    	{
            ZDBAlertAPI.showErrorMsg(errMsg);
    }
else
{
            ZDBAlertAPI.showErrorMsg(errMsg, null, errCode);
}
  }
}

function submitCloudDB(frm)
{
	var fileType = frm.FILETYPE.value;
	/*An issue occurs when frm.LOCATION reamains as PASTEDATA
	and it is sent with Cloud Drive  Import Request*/
	if(frm.LOCATION.value=="PASTEDATA"){
		frm.LOCATION.value = "WEB"; // No I18N
	}	
	frm.setAttribute("useiframe","true");
	frm.action = frm.getAttribute("actionurl");
	frm.DOCNAME.value = frm.ZDBExtIntInput.value;
//		importStepValUpdate(); Already done - not needed again
	frm.reloadCount = 0;// $$ Test this!!.- Add this to test cases.
	frm.encoding =  "application/x-www-form-urlencoded"; // No I18N
        //In case of Edge frm.LOCATION.value is returned as undefined
	frm.action = (frm.LOCATION.value == '' || frm.LOCATION.value == undefined) ? frm.action + "&LOCATION=WEB" : frm.action;
	var fileOpts = getFileOptsForImport("cloud"); //NO I18N
	AjaxAPI.submit(frm,fileOpts);
	return false;
}

function hideURLTip(el)

  {

    if(el.getAttribute("tipShown") == "true")

    {

      el.value="";

      el.setAttribute("tipShown","false");
      el.style.color="black"; //No I18N
      el.style.fontStyle="normal";//No I18N
      el.style.fontSize="12px";     //No I18N
    }

  }



  function showURLTip(el)

  {

    if(el.value == "" &&  el.getAttribute("tipShown") == "false")

    {

      var tip = el.getAttribute("tipValue");

      el.value= (tip != null)? tip :ZDBI18NMap.g("zrpt.common.js.search");

      el.setAttribute("tipShown","true");
      el.style.color="grey"; //No I18N
      el.style.fontStyle="italic";//No I18N
      el.style.fontSize="11px";//No I18N


    }

  }


function closeCreateConnectionDialog() {
alert("Connection Created successfully. You can use it to create a new remote database."); //No I18N
	ZDBFullPageDialog.closeDialog();
}

function handleErrorDuringImportAdwordsData(response,requestOptions)
{
  showImpErrorMsg(response,requestOptions,"adwordsclientlistform",false);  //No I18N
}

function handleErrorDuringExistImport(response,requestOptions)
{
  endImportProgress(response,requestOptions);
  enableCilckNext();
  showImpErrorMsg(response,requestOptions,"ZDBEXCreateFrm",false);
}

function showImpErrorMsg(response,requestOptions,frmName,isCreateDB)
{
  var errCode = response.getResponsePart("ERRORCODE");
  var errMsg = response.getResponsePart("STATUS_MESSAGE");
  errCode = trimAll(errCode);
  if(errCode != null)
  {
    if(frmName == "ZDBEXCreateFrm" && errCode == "IMPORT_FK_CONSTRAINT_WARNING")
    {
        var tableName = $("importExTableName").innerHTML;
        var msgInfo = ZDBUtil.replaceAll(errMsg,'\n','').split(",");
        var fullErrMsg = ZDBI18NMap.f('zrpt.toolbar.import.js.import_warning',tableName);
        if(msgInfo[0].trim() == "true")
        {
            fullErrMsg += ZDBI18NMap.f('zrpt.toolbar.import.js.delcascadealert');
            var listOption1 = "";
            var childTables = errMsg.substring(errMsg.indexOf('[')+1,errMsg.indexOf(']'));
            var list1 = childTables.split(",");
            for(var i = 0; i < list1.length ; i++)
            {
                listOption1 += "<li>" + list1[i] + "</li>";
            }
            fullErrMsg += "<ul>" + listOption1 + "</ul>";
        }
        if(msgInfo[1].trim() == "true")
        {
            fullErrMsg += ZDBI18NMap.f('zrpt.toolbar.import.js.setemptyalert');
            var listOption2 = "";
            childTables = errMsg.substring(errMsg.lastIndexOf('[')+1,errMsg.lastIndexOf(']'));
            var list2 = childTables.split(",");
            for(var i = 0; i < list2.length; i++)
            {
                listOption2 += "<li>" + list2[i] + "</li>";
            }
            fullErrMsg += "<ul>" + listOption2 + "</ul>";
        }
        fullErrMsg += ZDBI18NMap.f('zrpt.toolbar.import.js.truncateaddconfirm');
        ZDBAlertAPI.showMsg(fullErrMsg, "ZDBYESNO",{ONCLICK:this.confirmImport});      //No I18N
    }
    else if(errCode == "SSH_UNKNOWN_HOSTKEY" || errCode == "SSH_HOSTKEY_CHANGED"){
    	var replace = (errCode=="SSH_HOSTKEY_CHANGED"); //No I18N
    	var onclick = (!replace)?this.addAndConfirmImport:this.replaceAndConfirmImport;
    	if(frmName=="ZDBCreateFrm"){
    		ZDBAlertAPI.showMsg(errMsg, "ZDBYESNO",{ONCLICK:onclick});      //No I18N
    	}
    	else{
    		ZDBAlertAPI.showMsg(errMsg, "ZDBYESNO",{ONCLICK:onclick});      //No I18N
    	}
    	setSSHFingerPrint(errMsg);
    }
    else if(errCode == "GOOGLE_AUTH_REQUIRED" || errCode == "GSHEETS_NOT_FOUND" || errCode =="GSHEETS_NOAUTH_HEADER_INFO")
    {
        var gType;
        if(frmName =="ZDBCreateFrm")
        {
            gType="createdb"; //No I18N
        }
        else if(frmName == "ZDBEXCreateFrm")
        {
            gType="existimport"; //No I18N
        }
        ZDBGoogleInteg.authGUser(errCode,errMsg,gType);
    }
    else if(errCode == "IMPORT_UNAUTHORIZED_ACCESS_ERROR")
	{
    		var msg = ZDBI18NMap.g("zrpt.common.import.url.js.unauthorized_access_errmsg");
    		var ftpOpt = ( $("ZDBFTPOPT") ) ? ($("ZDBFTPOPT")):($("ZDBEXFTPOPT"));
    		var isFTP = (ftpOpt)?(ftpOpt.checked):false;
    		var msgEl = (isFTP)?($(frmName).FTPPASSWORD):($(frmName).PASSWORD);
            if(frmName == "ZDBEXCreateFrm")
              {
           	 		showAUTHURLInp(true,"existImport");//No I18N
              }
              else
              {
            		showAUTHURLInp(true);
              }
            showCustomMessage(msg,msgEl);
        return;
	}
    else if(errCode == "IMPORT_INVALID_CREDENTIAL_ERROR")
	{
		var msg = ZDBI18NMap.g("zrpt.common.import.url.js.invalid_credential_errmsg");
		var ftpOpt = ( $("ZDBFTPOPT") ) ? ($("ZDBFTPOPT")):($("ZDBEXFTPOPT"));
		var isFTP = (ftpOpt)?(ftpOpt.checked):false;
		var msgEl = (isFTP)?($(frmName).FTPPASSWORD):($(frmName).PASSWORD);
             if(frmName == "ZDBEXCreateFrm"){
            		 showAUTHURLInp(true,"existImport");//No I18N
              }
              else{
            		 showAUTHURLInp(true);//No I18N
			  }
             showCustomMessage(msg,msgEl);
	return;
	}

    else if(errCode == "UNABLE_TO_GET_FILE")
	{
      showCustomMessage(errMsg,$(frmName).FTPPATH);//No I18N
	  return;
	}
    else if(errCode == "UNABLE_TO_CONNECT_TO_THE_SPECIFIED_PORT")
	{
      showCustomMessage(errMsg,$(frmName).FTPPORT);//No I18N
	  return;
	}
    else if(errCode == "IMPORT_URL_COMMUNICATION_FAILURE"){
		var msg = ZDBI18NMap.g(errMsg);
		var ftpOpt = ( $("ZDBFTPOPT") ) ? ($("ZDBFTPOPT")):($("ZDBEXFTPOPT"));
		var isFTP = (ftpOpt)?(ftpOpt.checked):false;
		var msgEl = (isFTP)?($(frmName).FTPHOST):($(frmName).ZDBInputURL);
		showCustomMessage(msg,msgEl);
    }
    //
       else
    {
        var els = DOMUtils.getChildElsWithAttr($(frmName),"errorcodeprefix","*");
        for(var i =0,j = els.length; i < j; i++)
        {
          if(errCode.indexOf(els[i].getAttribute("errorcodeprefix")) == 0)
          {
            var msg = response.getResponsePart("STATUS_MESSAGE");
            if('IMPORT_FILE_EXCEEDS_SIZE_LOCAL' == errCode)
            {
              var toolLink = $("ZDBCSVUPLOADERLINK").innerHTML;
              msg = msg.replace("our Upload Tool",toolLink);
            }
            showCustomMessage(msg,els[i],null);
            return;
          }
        }
        if('META_DBOBJECT_NAME_DUPLICATED' == errCode && isCreateDB)
        {
            showCustomMessage(response.getResponsePart("STATUS_MESSAGE"),$("ZDBCreateFrm").TABLENAME);
            return;
        }
	if('EXISTIMPORT_INVALID_FILESELECTION' == errCode)
        {
            showCustomMessage(response.getResponsePart("STATUS_MESSAGE"),$("ZDBEXCreateFrm").FILETYPE);
            return;
        }

        AjaxAPI.onFailureFunc(response,requestOptions);
    }
  }

}

function setSSHFingerPrint(errMsg){
	var fingerPrint = errMsg.split("\n");
	fingerPrint = fingerPrint[4];
	jQuery('[name="SSHFINGERPRINT"]').val(fingerPrint); //NO I18N
}

function showHideReset()
{
   var showResetLink = false;
   var urlParams = jQuery($("URLPARAMS")).children();
   for(var i=0;i<urlParams.length;i++)
        {
            var paramName = jQuery($("URLPARAMS")).find("#ZRURLPARAMNAME")[i].value;
            var paramValue = jQuery($("URLPARAMS")).find("#ZRURLPARAMVALUE")[i].value
            if(paramName!="" || paramValue!="")
                {
                    showResetLink=true;
                    break;
                }
        }
        if(showResetLink==true)
        {
            $("RESETPARAMS").style.display="table-caption";
            $("PARAMRESETDIV").style.paddingBottom="0px";//No I18N
        }
        else
        {
            $("RESETPARAMS").style.display="none";
            $("PARAMRESETDIV").style.paddingBottom="15px";//No I18N
        }

}


function showHideUrlParamDiv(displayDiv)
{
    var urlinfoDiv = $("URLINFO");
    var isVisible = urlinfoDiv.style.display;
    var displayPropValue = (isVisible =="block") || (displayDiv==false || displayDiv===null)? "none" : "block";//No I18N
    urlinfoDiv.style.display = displayPropValue;
    changeParamCount();
    var linkElement = $("ADDPARAMLINK");
    if(displayPropValue == "block" && jQuery($("URLPARAMS")).children().size()==0)
    {
        addUrlParamDiv();
    }
    if(displayPropValue == "block")
    {
        jQuery(linkElement).find("[elname='moreRLessIcon']").removeClass("ZRSMoreIcon").addClass("ZRSLessIcon");//No I18N
        $("PARAMCOUNT").style.display = "none";
        showHideReset();
    }
    else
    {
       var urlParams = jQuery($("URLPARAMS")).children();
        for(var i=0,j=0;i<urlParams.length;i++,j++)
        {
        if(!(jQuery($("URLPARAMS")).find("#ZRURLPARAMNAME")[j].value.trim().length && jQuery($("URLPARAMS")).find("#ZRURLPARAMVALUE")[j].value.trim().length))//No I18N
            {
                var divToBeRemoved=urlParams[i];
                jQuery(divToBeRemoved).remove();
                j=j-1;
            }
        }
        changeParamCount();
        jQuery(linkElement).find("[elname='moreRLessIcon']").removeClass("ZRSLessIcon").addClass("ZRSMoreIcon");//No I18N

    }

}
function addUrlParamDiv()
{
   var clone = $("PARAMS").cloneNode(true);
   if(jQuery($("URLPARAMS")).children().size() >= 20)
   {
       alert(ZDBI18NMap.g('zrpt.common.url.js.alertonparamcount'));
       return;
   }
   clone.style.display="block";
   clone.querySelectorAll('[id="ZRURLPARAMNAME"]')[0].name = "URLPARAMNAME";
   clone.querySelectorAll('[id="ZRURLPARAMVALUE"]')[0].name = "URLPARAMVALUE";
   clone.querySelectorAll('[id="ZRURLPARAMTYPE"]')[0].name = "URLPARAMTYPE";
   $("URLPARAMS").appendChild(clone);
   showHideReset();
}

function removeUrlParamDiv(divToBeRemoved)
{
    if(jQuery($("URLPARAMS")).children().size() > 1)
    {
        jQuery(divToBeRemoved).parent().remove();
        showHideReset();
    }
    else
    {
        jQuery($("URLPARAMS")).empty();
        changeParamCount();
        showHideUrlParamDiv();
    }
}

function changeParamCount()
{
    $("PARAMCOUNT").style.display="table-cell";
    if(jQuery($("URLPARAMS")).children().size()==1)
    {
        $("PARAMCOUNT").innerHTML = "("+jQuery($("URLPARAMS")).children().size()+ " " +ZDBI18NMap.g('zrpt.common.url.js.singleparamspecified')+")";
    }
    else if(jQuery($("URLPARAMS")).children().size()>1)
    {
        $("PARAMCOUNT").innerHTML = "("+jQuery($("URLPARAMS")).children().size() + " " +ZDBI18NMap.g('zrpt.common.url.js.moreparamspecified')+")";
    }
    else
    {
        $("PARAMCOUNT").style.display="none";
    }
}
function resetUrlParam()
{
    jQuery('#URLPARAMS input').attr('value','');//No I18N
    showHideReset();
}
function confirmImport(clickType)
{
    if(clickType != "YES")
    {
        return;
    }
    $("URLPARAMALERT").innerHTML ="false";
    ZDBImport.submitExistImportForm($("ZDBEXCreateFrm"),null,false);
}

function addAndConfirmImport(clickType){
	if(clickType != "YES"){
		return;
	}
	jQuery('[name="ADDSSHKEY"]').val("ADD"); //NO I18N
	submitCreateDB($("ZDBCreateFrm"));
	jQuery('[name="ADDSSHKEY"]').val("CHECK"); //NO I18N
}
function addAndConfirmExistImport(clickType){
	if(clickType != "YES"){
		return;
	}
	jQuery('[name="ADDSSHKEY"]').val("ADD"); //NO I18N
	ZDBImport.submitExistImportForm($("ZDBEXCreateFrm"),null,false);
	jQuery('[name="ADDSSHKEY"]').val("CHECK"); //NO I18N
}

function replaceAndConfirmImport(clickType){
	if(clickType != "YES"){
		return;
	}
	jQuery('[name="ADDSSHKEY"]').val("REPLACE"); //NO I18N
	submitCreateDB($("ZDBCreateFrm"));
	jQuery('[name="ADDSSHKEY"]').val("CHECK"); //NO I18N
}
function replaceAndConfirmExistImport(clickType){
	if(clickType != "YES"){
		return;
	}
	jQuery('[name="ADDSSHKEY"]').val("REPLACE"); //NO I18N
	ZDBImport.submitExistImportForm($("ZDBEXCreateFrm"),null,false);
	jQuery('[name="ADDSSHKEY"]').val("CHECK"); //NO I18N
}

function handleErrorDuringCreateDB(response,requestOptions)
{
  endImportProgress(response,requestOptions);
  enableCilckNext();
  if($("IMPORTFREEZE")!=null)
  {
  document.body.removeChild($("IMPORTFREEZE"));
  document.body.removeChild($("ZDBMainLoader_new"));
  }
  showImpErrorMsg(response,requestOptions,"ZDBCreateFrm",true);
}

function handleCloudDBError(response,requestOptions)
{
  showImpErrorMsg(response,requestOptions,"ZDBCreateFrm",true);  //NO I18N
}

function handleExistImport(response,requestOptions)
{
  endImportProgress(response,requestOptions);
  enableCilckNext();
  window.curStep = window.curStep + 1 ;
  $("zdbExImportTableTitle").innerHTML = ZDBI18NMap.f('zrpt.toolbar.import.js.sametable',window.curStep,window.totStep);
  var params = response.getResponseParams();
  if(params["DBID"] != null)
  {
    showDataSheet(response,requestOptions);
  }
  else
  {
    $("ZDBCREATEDBOPTSTATUS").className="mcLoaded";
    uploadFile(response,requestOptions, "existImport");
  }
  response.invokeScripts();
}

function addJoinDiv(showDropDown)
{
ZDBCreateDB.count = 0;
if(jQuery("#EnclosingDiv").find(".disableJoinIconNew").length>0)
{
  setTimeout(ZDBCreateDB.blink, 80);
  ZDBCreateDB.count = 0;
  return;
}
var ele = jQuery("#JoinTemplateDIV").clone();//No I18N
ele.find("#ENCDIV")[0].className="ENCDIV";
ele.find("#LEFTLABEL")[0].style.display="none";
ele.find("#RIGHTLABEL")[0].style.display="none";
ele.find("#JOINDIV")[0].className="disableJoinIconNew marginTop14";
ele.find("#JOINDIV")[0].setAttribute("blocked","true");
ele.find("#LEFTCOLHEAD").css("display","block");//No I18N
ele.find("#RIGHTCOLHEAD").css("display","block");//No I18N
jQuery("#ZDBImportFileWithRelation").find("#COLUMNLISTDROPDOWN")[0].style.top="42px";
jQuery(ele).find(".inlinePropComboSel")[0].style.background="white";//No I18N
jQuery(ele).find(".inlinePropComboSel")[0].style.border="1px solid #7fbbee";//No I18N
jQuery(ele).find(".inlinePropComboSel")[0].style.boxShadow = "0 0 5px #a8d3f5";//No I18N
jQuery("#ZDBImportFileWithRelation").find("#FKCOLDROPDOWN")[0].style.top="42px";
jQuery(ele).find(".inlinePropComboSel")[1].style.background="white";//No I18N
jQuery(ele).find("#REMOVEJOIN")[0].style.marginTop = "14px";//No I18N
ele.attr('id',"JOINLIST");//No I18N
ele.css("display","block");//No I18N
ele.insertBefore("#ADDJOINLINK");//No I18N
hideDropdown("click");//No I18N
jQuery("#EnclosingDiv").scrollTop(jQuery("#ADDJOINLINK").offset().top);//No I18N
}

function showRelations(response)
{
    if($("ZDBImportFileWithRelation") !=null)
        {
            $("ZDBImportFileWithRelation").parentNode.removeChild($("ZDBImportFileWithRelation"));
        }
    var fix = "";
    var div = document.createElement("div");
    div.id = "ZDB" + fix + "ImportFileWithRelation";
    div.style.left=jQuery("#ZDBMAINEL").width()+"px";
    div.style.top=parseInt(jQuery("#ZDBMAINEL").position().top)+parseInt(jQuery("#ZDBTABTPL").height())+parseInt(1)+"px";
    div.style.width="947px";
    div.style.marginRight="25px";//No I18N
    div.style.float="left";//No I18N
    div.style.tabindex = "-1";
    ev.addEscHandle(ZDBCreateDB.showprevformonEsc);
    jQuery(div).append($("IM_JOIN_TABLES").innerHTML);
    var enclosingdiv = document.createElement("div");
    enclosingdiv.setAttribute("id","EnclosingDiv");
    enclosingdiv.style.borderRight = "1px inset rgb(204, 204, 204)";//No I18N
    enclosingdiv.style.float="left";//No I18N
    jQuery(div).append(enclosingdiv);
    var addJoindiv = ZDBUtil.getCachedRef(ZDBImport,"ADDJOIN").cloneNode(true);
    addJoindiv.style.display="block";
    addJoindiv.setAttribute("id","ADDJOINLINK");
    var impHelp = $("HELPTEXT").cloneNode(true);
    impHelp.setAttribute("id","HELPTEXTV");
    jQuery(jQuery(impHelp).find("#ZRSVideoDemoHelp")).css("display","none");// No I18N
    jQuery(jQuery(impHelp).find("#ZRSSnapShotTour")).css("display","none");  // No I18N
    impHelp.style.display="block";

    var clone = ZDBUtil.getCachedRef(ZDBImport,"RELATION").cloneNode(true);
    clone.style.display="block";
    clone.querySelectorAll("#CreateWithLookupLink")[0].setAttribute("id","ZDBImportTableCreateWithLookupLink");//No I18N
    clone.querySelectorAll("#LOADINGDIV")[0].setAttribute("id","ZDBIMPORTWITHLOOKUPOPSTATUS");//No I18N
    clone.querySelectorAll("#LOADINGDIVLABEL")[0].setAttribute("id","ZDBIMPORTWITHLOOKUPOPSTATUSLABEL");//No I18N
    jQuery(div).append(impHelp);
    jQuery(div).append(clone);
    var freezelayer = jQuery(document.createElement("div"));
    var joindialog = jQuery(div);
    joindialog.attr("class","relatetabledialog");//No I18N
    freezelayer.attr("class","freezeLayer");//No I18N
    freezelayer.attr("ID","IMPORTFREEZE");//No I18N
    //freezelayer.css("top",parseInt(jQuery("#ZDBMAINEL").position().top)+"px");//No I18N
    freezelayer.css("top",parseInt(jQuery("#ZDBMAINEL").position().top)+parseInt(1)+"px");//No I18N
    //freezelayer.css("top",parseInt(jQuery("#ZDBMAINEL").position().top)+parseInt(1)+"px");//No I18N
    //freezelayer.css("left","251px");
    //freezelayer.css("opacity",'0.45');//No I18N
    freezelayer.css("z-index",jQuery(div).attr("z-index"));//No I18N
    jQuery(document.body).append(freezelayer);
    jQuery(document.body).append(div);
    var jsonObj = JSON.parse(response.responseText);
    var template = ZDBUtil.getCachedRef(ZDBImport,"JoinTemplate").cloneNode(true);
    template.setAttribute("id","JoinTemplateDIV")
    jQuery(div.querySelectorAll("div#COLUMNLISTDROPDOWN1")[0]).attr("id","COLUMNLISTDROPDOWN");//No I18N
    jQuery(div.querySelectorAll("div#COLtemplate")[0]).append(jsonObj.NEWCOLSCOMBO[0]);
    jQuery(div.querySelectorAll("div#FKCOLDROPDOWN1")[0]).attr("id","FKCOLDROPDOWN");//No I18N
    jQuery(div.querySelectorAll("div#FKtemplate")[0]).html(jsonObj.FKCOMBO[0]);
    jQuery(div).append(template);
    if(jsonObj.IDENTIFIEDJOINS)
    {
          for(var i=0;i<jsonObj.IDENTIFIEDJOINS.length;i++)
          {
             var clone = template.cloneNode(true);
             clone.setAttribute("id","JOINLIST")
             clone.style.display="block";
             clone.querySelectorAll("#COLUMNLIST")[0].setAttribute("value",jsonObj.IDENTIFIEDJOINS[i][0]);
             selectColumnValue(clone.querySelectorAll("#COLUMNLIST")[0],jsonObj.IDENTIFIEDJOINS[i][0]);
             clone.querySelectorAll("#FKCol")[0].setAttribute("value",jsonObj.IDENTIFIEDJOINS[i][1]);
             selectColumnValue(clone.querySelectorAll("#FKCol")[0],jsonObj.IDENTIFIEDJOINS[i][1]);
             ZDBUtil.getCachedRef(ZDBImport,"EnclosingDiv").appendChild(clone);
             jQuery("#EnclosingDiv").append(clone); //No I18N
          }
    }
    jQuery("#EnclosingDiv").append(addJoindiv);//No I18N
    $("EnclosingDiv").style.width="655px";
    $("EnclosingDiv").style.height="285px";
    $("EnclosingDiv").style.overflow="auto";
    $("EnclosingDiv").style.marginBottom="30px";//No I18N
    if(jsonObj.IDENTIFIEDJOINS.length==0)
    {
    addJoinDiv();
    if(jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0] !=undefined)
        {
    jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0].innerHTML = ZDBI18NMap.g('zrpt.home.import.js.customJoinTablesDesc');//No I18N
        }
    }
    else
        {
            if(jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0] !=undefined)
        {
            jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0].innerHTML = ZDBI18NMap.g('zrpt.home.import.js.joinTablesDesc');//No I18N
        }
        }
        var w =document.body.offsetWidth-parseInt($("ZDBImportFileWithRelation").offsetWidth);
joindialog.animate({left: w+'px'}).show().focus();//No I18N
if(jsonObj.IDENTIFIEDJOINS.length==0)
    {
    if(jQuery("#ZDBImportFileWithRelation").find("#zdbImportTableDesc")[0] !=undefined)
        {
        jQuery("#ZDBImportFileWithRelation").find("#zdbImportTableDesc")[0].innerHTML = ZDBI18NMap.g('zrpt.home.import.js.customJoinTablesDesc');//No I18N
        }
    }
    else
        {
            if(jQuery("#ZDBImportFileWithRelation").find("#zdbImportTableDesc")[0] !=undefined)
        {
            jQuery("#ZDBImportFileWithRelation").find("#zdbImportTableDesc")[0].innerHTML = ZDBI18NMap.g('zrpt.home.import.js.joinTablesDesc'); //No I18N
        }
    }
        window.joinFrm = $("EnclosingDiv").cloneNode(true);
}
function selectColumnValue(element,value)
{
    if(element.id =="FKCol")
        {
            var list = jQuery("#ZDBImportFileWithRelation").find("#FKCOLDROPDOWN")[0].querySelectorAll(".RefFilterList");//No I18N
            for(i=0;i<list.length;i++)
        {
            if(list[i].getAttribute("FkValue") == value)
                {
                    element.setAttribute("subtype",list[i].getAttribute("subtype"));
                    element.setAttribute("colID",list[i].getAttribute("FkValue"));
                    element.setAttribute("value",list[i].getAttribute("FkValue"));
                    if(list[i].parentNode.querySelectorAll(".RefTblName")[0]!=undefined)
                        {
                    element.innerHTML = list[i].parentNode.querySelectorAll(".RefTblName")[0].innerHTML+"."+list[i].innerHTML;
                        }
                        else
                            {
                                element.innerHTML = list[i].innerHTML;
                            }

                }
        }
        }
        else
        {
        var list = jQuery("#ZDBImportFileWithRelation").find("#COLUMNLISTDROPDOWN")[0].querySelectorAll(".RefFilterList");//No I18N
    for(i=0;i<list.length;i++)
        {
            if(list[i].getAttribute("value") == value)
                {
                    element.setAttribute("subtype",list[i].getAttribute("subtype"));
                    element.setAttribute("colID",list[i].getAttribute("value"));
                    element.setAttribute("value",list[i].getAttribute("value"));
                    if(list[i].parentNode.querySelectorAll(".RefTblName")[0]!=undefined)
                        {
                    element.innerHTML = list[i].parentNode.querySelectorAll(".RefTblName")[0].innerHTML+"."+list[i].innerHTML;
                        }
                        else
                            {
                                element.innerHTML = list[i].innerHTML;
                            }

                }
        }
    }

}
function clearColSearch(element)
{
    var val = "";
    var keyfound = false;
    var list = element.parentNode.parentNode.parentNode.querySelectorAll(".RefFilterList");//No I18N
    for(i=0;i<list.length;i++)
    {
          list[i].parentNode.style.display="block";
    }
    for(i=0;i<list.length;i++)
        {
          if((list[i].innerHTML.toUpperCase()).indexOf(val.toUpperCase())!=-1)
          {
            list[i].style.display="block";
            list[i].parentNode.style.display="block";
            keyfound=true;
          }
          else
          {
            list[i].style.display="none";

          }
        }
        if(element.id!="COLUMNLISTCOLSEARCH")
        {
        for(i=0;i<list.length;i++)
        {
        if(jQuery(list[i].parentNode).find("li:visible").length<=1)
            {
              list[i].parentNode.style.display="none";
            }
        }
        }
            if(keyfound)
                {
                    jQuery(element.parentNode.parentNode).find(".widgetFieldSearch")[0].style.display ="none";
                }
                else
                    {
                        jQuery(element.parentNode.parentNode).find(".widgetFieldSearch")[0].style.display ="block";
                    }
}
function searchColName(element)
{
    var val = element.value == "Search Columns" ? "" :element.value;//No I18N
    var keyfound = false;
    var list = element.parentNode.parentNode.parentNode.querySelectorAll(".RefFilterList");//No I18N
    var parentList = element.parentNode.parentNode.parentNode.querySelectorAll(".refColUi");//No I18N

    for(i=0;i<parentList.length;i++)
    {
          parentList[i].style.display="none";
    }
    for(i=0;i<list.length;i++)
        {
          if((list[i].innerHTML.toUpperCase()).indexOf(val.toUpperCase())!=-1)
          {
            list[i].style.display="block";
            list[i].parentNode.style.display="block";
            keyfound=true;
          }
          else
          {
            list[i].style.display="none";

          }
        }
        if(element.id!="COLUMNLISTCOLSEARCH")
        {
        for(i=0;i<list.length;i++)
        {
        if(jQuery(list[i].parentNode).find("li:visible").length<=1)
            {
              list[i].parentNode.style.display="none";
            }
        }
        }
            if(keyfound)
                {
                    jQuery(element.parentNode.parentNode).find(".widgetFieldSearch")[0].style.display ="none";
                }
                else
                    {
                        jQuery(element.parentNode.parentNode).find(".widgetFieldSearch")[0].style.display ="block";
                    }
}
function changeColumn(element)
{
    var joinDiv = jQuery("[elname='CurrentParent']").parents().find("#ENCDIV")[0];//No I18N
    if(jQuery("[elname='CurrentParent']")[0].querySelectorAll("#COLUMNLIST").length>0)
    {

            jQuery("[elname='CurrentParent']")[0].querySelectorAll("#COLUMNLIST")[0].innerHTML=element.innerHTML;
            jQuery("[elname='CurrentParent']")[0].querySelectorAll("#COLUMNLIST")[0].setAttribute("value",element.getAttribute("value")); //No I18N
            jQuery("[elname='CurrentParent']")[0].querySelectorAll("#COLUMNLIST")[0].setAttribute("subtype",element.getAttribute("subtype"));//No I18N
    }
    else
        {
            jQuery("[elname='CurrentParent']")[0].querySelectorAll("#FKCol")[0].innerHTML=element.parentNode.querySelectorAll(".RefTblName")[0].innerHTML+"."+element.innerHTML;//No I18N
            jQuery("[elname='CurrentParent']")[0].querySelectorAll("#FKCol")[0].setAttribute("colID",element.getAttribute("FkValue"));//No I18N
            jQuery("[elname='CurrentParent']")[0].querySelectorAll("#FKCol")[0].setAttribute("value",element.getAttribute("FkValue")); //No I18N
            jQuery("[elname='CurrentParent']")[0].querySelectorAll("#FKCol")[0].setAttribute("subtype",element.getAttribute("subtype"));//No I18N
        }
    jQuery("[elname='CurrentParent']").removeAttr('elname');//No I18N
    $("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN")[0].style.display="none";
    $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN")[0].style.display="none";
    validateCurrJoin(joinDiv);
}
function showDropDown(element,event)
{
    jQuery("[elname='CurrentParent']").removeAttr('elname');//No I18N
    element.style.border="0px solid #d0d0d0";//No I18N
    element.style.boxShadow="none";//No I18N
    if(element.querySelectorAll("#FKCol").length>0)
        {
        if($("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN")[0].style.display =="none")
        {
            element.setAttribute("elname", "CurrentParent");
            hideDropdown("click");  //No I18N
                $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN")[0].style.display="block";
                var searchBox = $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLCOLSEARCH")[0];
                $("FKCOLDROPDOWN").style.top=parseInt(jQuery(element).offsetParent().position().top)+parseInt(jQuery(element).offsetParent().height())+'px';//No I18N
                $("FKCOLDROPDOWN").style.left =parseInt(jQuery(element).offsetParent().position().left)+'px';//No I18N
                $(searchBox).setAttribute("tipshown","false");
                 $(searchBox).value="";
                 ZDBSearchUtil.handleBlur($(searchBox));
                 searchColName(searchBox);
                 var keyFoundinQuery = false;
                 hideQuerytable($("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN")[0].querySelectorAll(".divLink")[0]);
                 var list = $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN")[0].querySelectorAll(".RefFilterList");
                 var selectedVal = jQuery(element).find("#FKCol").attr("value");//No I18N
                 var scrollTop = jQuery("#FKCOLDROPDOWN").scrollTop();//No I18N
                 jQuery(jQuery("#FKCOLDROPDOWN").find("#FKtemplate")[0]).scrollTop(0);//No I18N
                 for (i=0;i<list.length;i++)
                    {
                        if(selectedVal == list[i].getAttribute("FkValue"))
                            {
                               scrollTop = jQuery(list[i]).position().top;
                               $(list[i]).className = $(list[i]).className.replace("RefFilterList_hover","");
                               $(list[i]).className = $(list[i]).className+ " RefFilterList_hover";//No I18N
                               if(list[i].parentNode.parentNode.getAttribute("id").lastIndexOf("QUERYLIST")!=-1){keyFoundinQuery  = true;}
                            }
                            else
                                {
                                    $(list[i]).className = $(list[i]).className.replace("RefFilterList_hover","");
                                }
                    }
                    if(keyFoundinQuery)
                    {
                    showQuerytable($("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN")[0].querySelectorAll(".divLink")[0],"click");
                    }
                 jQuery(jQuery("#FKCOLDROPDOWN").find("#FKtemplate")[0]).scrollTop(scrollTop-parseInt(100));//No I18N
                 jQuery(document.body).click(function(event){
                    var t=jQuery(event.target);
                    if(t==undefined)
                    {
                        t= $("EnclosingDiv");
                    }
                 if(!((t.attr("class")=="RefFilterTbl refListExpand") || t.attr("class")==("rankingsearchForm_clone") || t.attr("class")==("fieldsSearchEl") || t.attr("id")=="ZDBSearchButton"))
                 {if($("EnclosingDiv")!=undefined){
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                      list[i].style.display = "none";
                        }
                    }
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                      list[i].style.display = "none";
                        }
                    }
                    }
                    jQuery(document.body).unbind("click");//No I18N
                 }
               jQuery("[elname='CurrentParent']").removeAttr('elname');  //No I18N
          });
          jQuery("#ZDBImportFileWithRelation").keyup(function(event){//No I18N
              if(event.keyCode == 27)
                  {
		var t=jQuery(event.target);
            if(t==undefined)
                {
                    t= $("EnclosingDiv");
                }
                 if(!((t.attr("class")=="RefFilterTbl refListExpand") || t.attr("class")==("rankingsearchForm_clone") || t.attr("class")==("fieldsSearchEl") || t.attr("id")=="ZDBSearchButton"))
                 {if($("EnclosingDiv")!=undefined){
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                        list[i].style.display = "none";
                        }
                    }
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                      list[i].style.display = "none";
                        }
                    }
                    }
                    jQuery(document.body).unbind("keyup");//No I18N
                 }

                  ZDBUtil.stopEventBubble(event);

                  }
              jQuery("[elname='CurrentParent']").removeAttr('elname');//No I18N
          });
                 ZDBUtil.stopEventBubble(event);
                 jQuery("#ZDBImportFileWithRelation").focus();//No I18N

                 jQuery("#EnclosingDiv").bind('scroll', function(event) { hideDropdown(event) //No I18N
                     jQuery("#EnclosingDiv").unbind("scroll");//No I18N
                 });
              jQuery(searchBox).focus();
        {
            var tip = $(searchBox).getAttribute("tipValue");
            var val= (tip != null)? tip :ZDBI18NMap.g("zrpt.common.js.search");
            $(searchBox).setAttribute("tipShown","true");
            {
                $(searchBox).className = "tipTextColor";
            }
            jQuery($(searchBox)).css("color","#888").attr("value",val); //No I18N
        }
        $(searchBox).selectionStart = $(searchBox).selectionEnd =0;


        }
        else
            {
                $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN")[0].style.display="none";
            }
        }
        else
            {
                if($("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN")[0].style.display =="none")
        {
                element.setAttribute("elname", "CurrentParent");
                hideDropdown("click");//No I18N
                $("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN")[0].style.display="block";
                var searchBox = $("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTCOLSEARCH")[0];//No I18N
                $("COLUMNLISTDROPDOWN").style.top=parseInt(jQuery(element).offsetParent().position().top)+parseInt(jQuery(element).offsetParent().height())+'px';//No I18N
                $("COLUMNLISTDROPDOWN").style.left=parseInt(jQuery(element).offsetParent().position().left)+'px';//No I18N
                $(searchBox).setAttribute("tipshown","false");
                 $(searchBox).value="";
                 ZDBSearchUtil.handleBlur($(searchBox));
                 searchColName(searchBox);
                 var list =$("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN")[0].querySelectorAll(".RefFilterList");
                 var selectedVal = jQuery(element).find("#COLUMNLIST").attr("value");//No I18N
                 var scrollTop = jQuery("#COLUMNLISTDROPDOWN").scrollTop();//No I18N
                 jQuery(jQuery("#COLUMNLISTDROPDOWN").find("#COLtemplate")[0]).scrollTop(0);//No I18N
                 for (i=0;i<list.length;i++)
                    {
                        if(selectedVal == list[i].getAttribute("value"))
                            {
                               scrollTop = jQuery(list[i]).position().top;
                               $(list[i]).className = $(list[i]).className.replace("RefFilterList_hover","");
                               $(list[i]).className = $(list[i]).className+ " RefFilterList_hover";//No I18N
                            }
                            else
                                {
                                    $(list[i]).className = $(list[i]).className.replace("RefFilterList_hover","");
                            }
                    }
                 jQuery(jQuery("#COLUMNLISTDROPDOWN").find("#COLtemplate")[0]).scrollTop(scrollTop - parseInt(100));//No I18N
                 jQuery(document.body).click(function(event){
		var t=jQuery(event.target);
                if(t==undefined)
                    {
                        t= $("EnclosingDiv");
                    }
                 if(!((t.attr("class")=="RefFilterTbl refListExpand") || t.attr("class")==("rankingsearchForm_clone") || t.attr("class")==("fieldsSearchEl") || t.attr("id")=="ZDBSearchButton"))
                 {
                    if($("EnclosingDiv")!=undefined){
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                      list[i].style.display = "none";
                        }
                    }
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                      list[i].style.display = "none";
                        }
                    }
                    }
                    jQuery(document.body).unbind("click");//No I18N
                 }

                  jQuery("[elname='CurrentParent']").removeAttr('elname');//No I18N

          });
          jQuery("#ZDBImportFileWithRelation").keyup(function(event){//No I18N
              if(event.keyCode == 27)
                  {
		var t=jQuery(event.target);
                if(t==undefined)
                    {
                        t= $("EnclosingDiv");
                    }
                 if(!((t.attr("class")=="RefFilterTbl refListExpand") || t.attr("class")==("rankingsearchForm_clone") || t.attr("class")==("fieldsSearchEl") || t.attr("id")=="ZDBSearchButton"))
                 {if($("EnclosingDiv")!=undefined){
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                      list[i].style.display = "none";
                        }
                    }
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                      list[i].style.display = "none";
                        }
                        }}
                    jQuery(document.body).unbind("keyup");//No I18N
                 }

                  ZDBUtil.stopEventBubble(event);

                  }
              jQuery("[elname='CurrentParent']").removeAttr('elname');//No I18N
          });
                 jQuery("#ZDBImportFileWithRelation").focus();//No I18N
                 ZDBUtil.stopEventBubble(event);

                 jQuery("#EnclosingDiv").bind('scroll', function(event) { hideDropdown(event) //No I18N
                     jQuery("#EnclosingDiv").unbind("scroll");//No I18N
                 });
                 jQuery(searchBox).focus();
        {
            var tip = $(searchBox).getAttribute("tipValue");
            var val= (tip != null)? tip :ZDBI18NMap.g("zrpt.common.js.search");
            $(searchBox).setAttribute("tipShown","true");
            {
                $(searchBox).className = "tipTextColor";
            }
            jQuery($(searchBox)).css("color","#888").attr("value",val); //No I18N
        }
        $(searchBox).selectionStart = $(searchBox).selectionEnd =0;
        }
        else
            {
                $("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN")[0].style.display="none";
            }
            }
}
function hideDropdown(event)
{
    var t=jQuery(event.target);
    if(t==undefined)
        {
            t= $("EnclosingDiv");
        }
                 if(!((t.attr("class")=="RefFilterTbl refListExpand") || t.attr("class")==("rankingsearchForm_clone") || t.attr("class")==("fieldsSearchEl") || t.attr("id")=="ZDBSearchButton"))
                 {
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN");
                    for (i=0;i<list.length;i++)
                    { if(list[i].style.display!="none")
                            {
                      list[i].style.display = "none";
                            }
                    }
                    var list =$("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                            {
                      list[i].style.display = "none";
                            }
                    }
                    ZDBUtil.stopEventBubble(event);
                 }
                 ZDBToolTip.hide();
}

function validateCurrJoin(element,fromSwap)
{
    jQuery(element).find("#JOINDIV")[0].setAttribute("isError","false");
    jQuery(element).find("#JOINDIV")[0].setAttribute("blocked","false");
    jQuery(element).find("#JOINDIV")[0].setAttribute("errorMsg",'');
    var joinslist = jQuery(element).find("#COLUMNLIST")[0];
    var joinslist2 = jQuery(element).find("#FKCol")[0];
     var  childColList=[];
     joinslist.parentNode.parentNode.style.border = "0px solid #d0d0d0";
     joinslist.parentNode.parentNode.style.boxShadow = "none";//No I18N
        joinslist2.parentNode.parentNode.style.border = "0px solid #d0d0d0";
     var leftType = jQuery(element).find("#JOINDIV")[0].className.indexOf("left")!=-1?joinslist2.getAttribute("subtype"):joinslist.getAttribute("subtype");
     var rightType = jQuery(element).find("#JOINDIV")[0].className.indexOf("left")!=-1?joinslist.getAttribute("subtype"):joinslist2.getAttribute("subtype");
     var flag = true;
     var canbelookedup=canbeJoined(leftType,rightType);
     if(!canbelookedup)
        {
            if(leftType != "" && rightType !="")
                        {
            jQuery(element).find("#JOINDIV")[0].className="errorOnJoinIcon";
            jQuery(element).find("#LEFTLABEL")[0].style.display ="block";
            jQuery(element).find("#LEFTLABEL")[0].style.visibility ="hidden";
            jQuery(element).find("#RIGHTLABEL")[0].style.display ="block";
            jQuery(element).find("#RIGHTLABEL")[0].style.visibility ="hidden";
            jQuery(element).find("#JOINDIV")[0].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.invalidreference'));
            if(!(leftType == null || rightType == null || leftType == "" || rightType == "") )
                        {
                            jQuery(element).find("#JOINDIV")[0].setAttribute("isError",'true');
            ZDBToolTip.show(jQuery(element).find("#JOINDIV")[0],"mouseover");//No I18N
                        }
                        }
            flag=false;
        }
      else
      {
          if(jQuery(element).find("#JOINDIV")[0].className=="errorOnJoinIcon")
        {
            jQuery(element).find("#JOINDIV")[0].className="rightJoinIconNew";
            if((jQuery(element).find("#RIGHTLABEL")[0].innerHTML).indexOf("Parent")!=-1)
            {
            jQuery(element).find("#JOINDIV")[0].className="rightJoinIconNew";
            }
            else
                {
                    jQuery(element).find("#JOINDIV")[0].className="leftJoinIconNew";
                }

        }
        jQuery(element).find("#LEFTLABEL")[0].style.visibility ="visible";
        jQuery(element).find("#RIGHTLABEL")[0].style.visibility ="visible";
        if(element.className!="ENCDIV")
            {
        jQuery(element).find("#JOINDIV")[0].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.swaprelationtip'));
            }

      }



      var leftlist = jQuery("#EnclosingDiv").find("#COLUMNLIST");//No I18N
      var rightlist = jQuery("#EnclosingDiv").find("#FKCol");//No I18N
      var cnt=0;
      for(i=0;i<leftlist.length;i++)
        {
            var joinType = jQuery(leftlist[i]).parents().find("#JOINDIV")[0].className;
            var value = joinType.indexOf("left")!=-1?rightlist[i].getAttribute("value"):leftlist[i].getAttribute("value");
            if(joinType.indexOf("disable")!=-1 && element.className!="ENCDIV")
                {continue;}
            childColList[i]= value;
            var currJoinType=jQuery(element).find("#JOINDIV")[0].className;
            var currChild  = currJoinType.indexOf("right")!=-1 || currJoinType.indexOf("disable")!=-1?joinslist.getAttribute("value"):joinslist2.getAttribute("value");
            if(currChild==value)
                {cnt++;}
        }
        if(cnt>1)
            {
            //if(element.className!="ENCDIV")
            {
            jQuery(element).find("#JOINDIV")[0].className="errorOnJoinIcon";
            jQuery(element).find("#LEFTLABEL")[0].style.display ="block";
            jQuery(element).find("#RIGHTLABEL")[0].style.display ="block";
            jQuery(element).find("#LEFTLABEL")[0].style.visibility ="hidden";
            jQuery(element).find("#RIGHTLABEL")[0].style.visibility ="hidden";
            }
            jQuery(element).find("#JOINDIV")[0].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.multiplerelationship'));
            jQuery(jQuery(element).find("#JOINDIV")[0]).attr("isError",'true');//No I18N
            ZDBToolTip.show(jQuery(element).find("#JOINDIV")[0],"mouseover");//No I18N
            flag=false;
            }
             if((leftType == null || rightType == null || leftType == "" || rightType == "") )
                {
                    if(element.className!="ENCDIV" || fromSwap)
                        {
                        jQuery(element).find("#JOINDIV")[0].className="errorOnJoinIcon";
                        jQuery(element).find("#LEFTLABEL")[0].style.display ="block";
                        jQuery(element).find("#LEFTLABEL")[0].style.visibility ="hidden";
            jQuery(element).find("#RIGHTLABEL")[0].style.display ="block";
                        jQuery(element).find("#RIGHTLABEL")[0].style.visibility ="hidden";

                         jQuery(element).find("#JOINDIV")[0].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.nolookupcolchoosed'));
                         jQuery(jQuery(element).find("#JOINDIV")[0]).attr("isError",'true');//No I18N
                   ZDBToolTip.show(jQuery(element).find("#JOINDIV")[0],"mouseover");//No I18N
                        }
                   flag=false;
                }

        if(flag )
         {
             ZDBToolTip.hide();
             if(element.className=="ENCDIV" || jQuery(element).find("#JOINDIV")[0].className.indexOf("disable")!=-1)
                        {
                        addNewJoin(jQuery(element).find("#JOINDIV")[0]);
                        jQuery(element).find("#JOINDIV")[0].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.swaprelationtip'));
                        }
         }
         else
        {
        if(element.className=="ENCDIV" && jQuery(element).find("#JOINDIV")[0].className.indexOf("disable")!=-1)
            {
                jQuery(element).find("#JOINDIV")[0].setAttribute("blocked","true");
                        }
         }

     }


function validatejoin(isCreate)
{
    var importedTableColList = jQuery("#EnclosingDiv").find("#COLUMNLIST");//No I18N
    var existingColList = jQuery("#EnclosingDiv").find("#FKCol");//No I18N
    var joindiv = jQuery("#EnclosingDiv").find("#JOINDIV");//No I18N
    var flag=false;
    var  childColList=[];
    var tableList =[];
    for(i=0;i<importedTableColList.length;i++)
    {
        if(jQuery(joindiv[i].parentNode.parentNode.parentNode).find("#ENCDIV")[0].className=="ENCDIV" && joindiv[i].className.indexOf("error")==-1)
        {
            continue;
        }
     var leftType = joindiv[i].className.indexOf("right")!=-1?importedTableColList[i].getAttribute("subtype"):existingColList[i].getAttribute("subtype");
     var rightType = joindiv[i].className.indexOf("right")!=-1?existingColList[i].getAttribute("subtype"):importedTableColList[i].getAttribute("subtype");
     var canbelookedup=canbeJoined(leftType,rightType);

     if(!canbelookedup)
        {
            joindiv[i].className="errorOnJoinIcon";
            jQuery(joindiv[i].parentNode.parentNode).find("#LEFTLABEL")[0].style.visibility ="hidden";
            jQuery(joindiv[i].parentNode.parentNode).find("#RIGHTLABEL")[0].style.visibility ="hidden";

            joindiv[i].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.invalidreference'));
            jQuery(joindiv[i]).attr("isError",'true');//No I18N
            ZDBToolTip.show(joindiv[i],"mouseover");
            flag=true;
        }
      else
      {
          if(joindiv[i].className=="errorOnJoinIcon")
        {
            joindiv[i].className="rightJoinIconNew";
            if((jQuery(joindiv[i].parentNode.parentNode).find("#RIGHTLABEL")[0].innerHTML).indexOf("Parent")!=-1)
            {
            joindiv[i].className="rightJoinIconNew";
            }
            else
                {
                    joindiv[i].className="leftJoinIconNew";
                }

        }
        jQuery(joindiv[i].parentNode.parentNode).find("#LEFTLABEL")[0].style.visibility ="visible";
        jQuery(joindiv[i].parentNode.parentNode).find("#RIGHTLABEL")[0].style.visibility ="visible";

        joindiv[i].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.swaprelationtip'));

      }
      var child =joindiv[i].className.indexOf("right")!=-1?importedTableColList[i].getAttribute("value"):existingColList[i].getAttribute("value");
     if(joindiv[i].className.indexOf("disable")==-1)
         {
     var joinedTable = existingColList[i].getAttribute("value").split("\.")[0];
      if(jQuery.inArray(joinedTable,tableList)>-1)
         {
            joindiv[i].className="errorOnJoinIcon";
            jQuery(joindiv[i].parentNode.parentNode).find("#LEFTLABEL")[0].style.visibility ="hidden";
            jQuery(joindiv[i].parentNode.parentNode).find("#RIGHTLABEL")[0].style.visibility ="hidden";
            joindiv[i].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.multiplerelationshipbetweenametable'));
            jQuery(joindiv[i]).attr("isError",'true');//No I18N
            ZDBToolTip.show(joindiv[i],"mouseover");
            flag=true;
         }
         else
         {
         tableList[i]=joinedTable;
         }
        if(jQuery.inArray(child,childColList)>-1)
         {
            joindiv[i].className="errorOnJoinIcon";
            jQuery(joindiv[i].parentNode.parentNode).find("#LEFTLABEL")[0].style.visibility ="hidden";
            jQuery(joindiv[i].parentNode.parentNode).find("#RIGHTLABEL")[0].style.visibility ="hidden";
            joindiv[i].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.multiplerelationship'));
            joindiv[i].setAttribute("isError",'true');
            ZDBToolTip.show(joindiv[i],"mouseover");
            flag=true;
         }
         else
         {
         childColList[i]=child;
         }
         }
         if((leftType == null || rightType == null || leftType == "" || rightType == "") && isCreate )
         {
             joindiv[i].className="errorOnJoinIcon";
            jQuery(joindiv[i].parentNode.parentNode).find("#LEFTLABEL")[0].style.visibility ="hidden";
            jQuery(joindiv[i].parentNode.parentNode).find("#RIGHTLABEL")[0].style.visibility ="hidden";

            joindiv[i].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.nolookupcolchoosed'));
            joindiv[i].setAttribute("isError",'true');
            ZDBToolTip.show(joindiv[i],"mouseover");
            flag=true;
         }


     }
     if(!flag)
         {
             ZDBToolTip.hide();
         }
     return flag;

}
function canbeJoined(child,parent)
{
      if(child == parent)
      {
        return true;
      }
      if((child  == ZDBConst.DECIMAL_NUMBER || child == ZDBConst.CURRENCY || child == ZDBConst.PERCENT) && (parent == ZDBConst.NUMBER || parent == ZDBConst.POSITIVE_NUMBER))
      {// parent - NUMBER/POSITIVE_NUMBER
       // child - DECIMAL_NUMBER/CURRENCY/PERCENT
        return true;
      }
      if(child == ZDBConst.NUMBER && parent == ZDBConst.POSITIVE_NUMBER)
      {// NUMBER to POSITIVE_NUMBER
        return true;
      }
      if((parent == ZDBConst.DECIMAL_NUMBER || parent == ZDBConst.CURRENCY || parent == ZDBConst.PERCENT) &&
         (child == ZDBConst.DECIMAL_NUMBER || child == ZDBConst.CURRENCY || child == ZDBConst.PERCENT || child == ZDBConst.AUTO_NUMBER))
      {// Within DECIMAL_NUMBER/CURRENCY/PERCENT
        return true;
      }
      return false;
}
function relateTablesOnImport()
{
var flag=validatejoin(true);
if(!flag)
    {
        var JOINSXML = "<JOINS>";
        var leftjoins= jQuery("#EnclosingDiv").find("#COLUMNLIST");//No I18N
        var rightjoins= jQuery("#EnclosingDiv").find("#FKCol");//No I18N
        var joindiv = jQuery("#EnclosingDiv").find("#JOINDIV");//No I18N
        for(i=0;i<leftjoins.length;i++)
        {
          var jointype = joindiv[i].className.indexOf("left")!=-1?"left":"right";//No I18N
          if(joindiv[i].className.indexOf("left")!=-1 || joindiv[i].className.indexOf("right")!=-1)
              {
                JOINSXML +="<J"+i+" FieldName=\""+encodeURIComponent(ZDBEscapeUtil.encodeForXML(leftjoins[i].getAttribute("value")))+"\" ReferredColumn=\""+rightjoins[i].getAttribute("value")+"\" JoinType="+"\""+jointype+"\"/>"; //No I18N
              }
        }
        JOINSXML+="</JOINS>";
        $("JOINSLIST").value = decodeURIComponent(JOINSXML);
var list = jQuery("#EnclosingDiv").find(".ENCDIV"); //No I18N
for(var i=0;i<list.length;i++)
{

list[i].parentNode.parentNode.removeChild(list[i].parentNode);

}
list=jQuery("#EnclosingDiv").find(".selecteddisableJoinIconNew"); //No I18N
for(var i=0;i<list.length;i++)
{
list[i].parentNode.parentNode.parentNode.parentNode.removeChild(list[i].parentNode.parentNode.parentNode);
}

var params = "JOINSLIST=" + JOINSXML;//No I18N
$('ZDBIMPORTWITHLOOKUPOPSTATUS').className = 'mcLoading';
$('ZDBIMPORTWITHLOOKUPOPSTATUSLABEL').style.display = 'inline';
ZDBIMPORTWITHLOOKUPOPSTATUSLABEL
AjaxAPI.sendRequest({URL:"/ZDBImportData.ve?ZDBACTION=VALIDATEJOINS",  //No I18N
            ONSUCCESSFUNC:closeJoinDialog,PARAMETERS:params
            });


     }
    else
    {
        return;
    }

}
function closeJoinDialog(response)
{
$('ZDBIMPORTWITHLOOKUPOPSTATUS').className = 'mcLoaded';
$('ZDBIMPORTWITHLOOKUPOPSTATUSLABEL').style.display = 'none';
var jsonObj = JSON.parse(response.getResponsePart("ERROR_MESSAGE"));
if(jsonObj!=null)
    {
            for(var i=0;i<jsonObj.ERRORS.length;i++)
            {
            var colID=jsonObj.ERRORS[i][0];
            var ErrorMsg=jsonObj.ERRORS[i][1];
            var leftCollist=jQuery("#EnclosingDiv").find("#FKCol"); //No I18N
            var rightCollist=jQuery("#EnclosingDiv").find("#FKCol"); //No I18N
            for(j=0;j<leftCollist.length;j++)
                {
                    var ele = leftCollist[j];
                    if((ele.getAttribute("colID")).indexOf(jsonObj.ERRORS[i][0])!=-1)
                    {
                    var joindiv=ele.parentNode.parentNode.parentNode.parentNode.querySelectorAll("#JOINDIV")[0]
                    if(joindiv.className.lastIndexOf("right")!=-1)
                        ele = rightCollist[j];
                    joindiv.className="errorOnJoinIcon";
                    jQuery(joindiv.parentNode.parentNode).find("#LEFTLABEL")[0].style.visibility ="hidden";
                    jQuery(joindiv.parentNode.parentNode).find("#RIGHTLABEL")[0].style.visibility ="hidden";
                    joindiv.setAttribute("isError","true");
                    joindiv.setAttribute("blocked","false");
                    var error = "<br/><strong>" + ZDBI18NMap.f('zrpt.home.import.js.ColModErr',ZDBEscapeUtil.encodeForHtml(ele.innerHTML))+"</strong><br/>";//No I18N
                    error+=ErrorMsg;
                    joindiv.setAttribute("errorMsg",error);
                    var tip = ZDBI18NMap.f('zrpt.home.import.js.ColModErrTip',ZDBEscapeUtil.encodeForHtml(ele.innerHTML));
                    joindiv.setAttribute("tip",tip);
                    ZDBToolTip.show(joindiv,"mouseover");//No I18N
	            }
                }
            }
    }
    else
        {
            var wid = jQuery(document.body).width();

var joincount = jQuery("#EnclosingDiv").find("#JOINLIST").length; //No I18N
if(joincount==0)
    {
        addJoinDiv();
    }

document.body.removeChild($("IMPORTFREEZE"));
if(joincount>0)
    {
        if(jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0]!=undefined)
    {
        jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0].innerHTML = ZDBI18NMap.g('zrpt.home.import.js.joinTablesDesc');//No I18N
    }
        $("ZDBJOINTABLE").style.marginRight = "473px";//No I18N
if(joincount>1)
    {
        $("ZDBJOINTABLE").innerHTML =joincount + " "+ZDBI18NMap.g("zrpt.newtable.import.js.lookupsSaved");
    }
    else
        {
            $("ZDBJOINTABLE").innerHTML =joincount + " "+ZDBI18NMap.g("zrpt.newtable.import.js.lookupSaved");
        }
}
else
    {
        $("ZDBJOINTABLE").innerHTML =ZDBI18NMap.g("zrpt.newtable.import.js.defineLookup");
        if(jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0]!=undefined)
        {
            jQuery("#ZDBImportFileWithRelation").find("zdbImportTableDesc")[0].innerHTML = ZDBI18NMap.g('zrpt.home.import.js.customJoinTablesDesc');//No I18N
        }
        $("ZDBJOINTABLE").style.marginRight = "473px";//No I18N
        $("JOINSLIST").value = "";

    }
    jQuery("#ZDBImportFileWithRelation").animate({left:wid}).hide(); //No I18N
    window.joinFrm = $("EnclosingDiv").cloneNode(true);
     }
    }
function showQuerytable(element,event)
{
    jQuery(element.parentNode).find("#QUERYLIST")[0].style.display="block";
    var list = jQuery(element.parentNode).find("#QUERYLIST")[0].querySelectorAll(".refColUi");//No I18N
    for(i=0;i<list.length;i++)
    {
          list[i].style.display="block";
    }
        element.style.display= "none";
        ZDBUtil.stopEventBubble(event);
}

function hideQuerytable(element)
{
    if(element!=undefined)
    {
    jQuery(element.parentNode).find("#QUERYLIST")[0].style.display="none";
    element.style.display= "block";
    }
}

function swapparentchild(element)
{
    var joinDiv = jQuery(element).parents().find("#ENCDIV")[0];
    if(element.className.indexOf("leftJoinIconNew")!=-1)
        {
        jQuery(joinDiv).find("#LEFTLABEL")[0].style.display="none";
                jQuery(joinDiv).find("#RIGHTLABEL")[0].style.display="none";
                jQuery(joinDiv).find("#JOINDIV")[0].className="selecteddisableJoinIconNew";
                jQuery(joinDiv).find("#JOINDIV")[0].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.addrelation'));
                ZDBToolTip.show(element,"mouseover");       //No I18N
        }
        else if(element.className.indexOf("rightJoinIconNew")!=-1)
            {

                jQuery(joinDiv).find("#RIGHTLABEL")[0].innerHTML = "Child";//No I18N
                jQuery(joinDiv).find("#LEFTLABEL")[0].innerHTML = "Parent";//No I18N
                element.className="leftJoinIconNew";
                jQuery(joinDiv).find("#JOINDIV")[0].setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.removerelationtip'));
                ZDBToolTip.show(element,"mouseover");//No I18N
            }
            else if(element.className.indexOf("disableJoinIconNew")!=-1 && joinDiv.className.indexOf("ENCDIV")==-1)
                {
                     validateCurrJoin(joinDiv,true);
                }
                else if(element.className.indexOf("error")!=-1)
                {if(jQuery(joinDiv).find("#JOINDIV")[0].getAttribute("errorMsg")!=null && jQuery(joinDiv).find("#JOINDIV")[0].getAttribute("errorMsg")!="")
                {
ZDBUtil.showRefErr(jQuery(joinDiv).find("#JOINDIV")[0].getAttribute("errorMsg"),"Error on Saving");//No I18N
ZDBDialogUtil.focusDialog.style.left="500px";
ZDBDialogUtil.focusDialog.style.top="202px";
                        }
                }
}

function showremoveicon(ele)
{
    if(ele.querySelectorAll("#ENCDIV")[0].className=="")
    {
        ele.querySelectorAll("#REMOVEJOIN")[0].style.display = "block";

    }
    else
        {
            ele.querySelectorAll("#REMOVEJOIN")[0].style.display = "block";
            ele.querySelectorAll("#REMOVEJOIN")[0].style.marginTop = "14px";//No I18N
        }

}
function addNewJoin(ele)
{
    jQuery(ele.parentNode.parentNode.parentNode).find("#RIGHTLABEL")[0].innerHTML = "Parent";//No I18N
    jQuery(ele.parentNode.parentNode.parentNode).find("#LEFTLABEL")[0].innerHTML = "Child";//No I18N
    jQuery(ele.parentNode.parentNode.parentNode).find("#RIGHTLABEL")[0].style.display="block";
    jQuery(ele.parentNode.parentNode.parentNode).find("#LEFTLABEL")[0].style.display="block";
    ele.className="rightJoinIconNew";
    ele.setAttribute("tip",ZDBI18NMap.g('zrpt.home.import.js.swaprelationtip'));
    ele.setAttribute("blocked","false");
    ele.parentNode.parentNode.parentNode.querySelectorAll("#ENCDIV")[0].className="";
    ele.parentNode.parentNode.parentNode.querySelectorAll("#LEFTLABEL")[0].className="LEFTLABEL";
    ele.parentNode.parentNode.parentNode.querySelectorAll("#RIGHTLABEL")[0].className="RIGHTLABEL";
    jQuery(ele.parentNode.parentNode.parentNode).find(".inlinePropComboSel")[0].style.background="#f3f3f2";//No I18N
    jQuery(ele.parentNode.parentNode.parentNode).find(".inlinePropComboSel")[1].style.background="#f3f3f2";//No I18N
    jQuery(ele.parentNode.parentNode.parentNode).find(".inlinePropComboSel")[0].style.border = "0px solid #d0d0d0";
    jQuery(ele.parentNode.parentNode.parentNode).find(".inlinePropComboSel")[0].style.boxShadow = "none";//No I18N
    jQuery(ele.parentNode.parentNode.parentNode).find(".inlinePropComboSel")[1].style.border = "0px solid #d0d0d0";
    jQuery("#ZDBImportFileWithRelation").find("#FKCOLDROPDOWN")[0].style.top="26px";
    jQuery("#ZDBImportFileWithRelation").find("#COLUMNLISTDROPDOWN")[0].style.top="26px";
    jQuery(ele.parentNode.parentNode.parentNode).find("#REMOVEJOIN")[0].style.marginTop="0px";//No I18N
    ele.parentNode.parentNode.parentNode.querySelectorAll("#JOINDIV")[0].className="rightJoinIconNew";
    ele.parentNode.parentNode.parentNode.querySelectorAll("#LEFTCOLHEAD")[0].style.display="none";
    ele.parentNode.parentNode.parentNode.querySelectorAll("#RIGHTCOLHEAD")[0].style.display="none";
}


function removejoin(element)
{
    if(element.parentNode.parentNode.childNodes.length>2)
        {
        element.parentNode.parentNode.removeChild(element.parentNode);
        }
        else
            {
                element.parentNode.parentNode.removeChild(element.parentNode);
                addJoinDiv();
            }
    validatejoin(false);
}

function handleCreateDBResp(response,requestOptions)
{
  endImportProgress(response,requestOptions);
  enableCilckNext();
  var params = response.getResponseParams();
  var enterData = params["ENTERDATA"];
  window.curStep = window.curStep+1;
  if(enterData == null && !params["DBID"])
  /// DBID is not defined at this stage for import
  /// Assumption: DBID is not given the value zero
  {
    changeTitle();
  }
  if(params["DBID"] != null)
  {
    showDataSheet(response,requestOptions);
  }
  else
  {
    $("ZDBCREATEDBOPTSTATUS").className="mcLoaded";
    uploadFile(response,requestOptions);
  }
  response.invokeScripts();
  if(window.importType == 'import'){
  	var subModule = "step"+window.curStep;//NO I18N
  }
  resetSFTPAuthType();
  if($("IMPORTFREEZE")!=null && $("ZDBMainLoader_new")!=null)
{
  document.body.removeChild($("IMPORTFREEZE"));
  document.body.removeChild($("ZDBMainLoader_new"));
  }
}

function showDataSheet(response,requestOptions)
{

  var params = response.getResponseParams();
  if((window.ZDBClientUI == null) || (window.ZDBClientUI.getExistingTab("NewTable") == null))
  {
    var url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + params["DBID"];//No I18N
    var objId = params["OBJID"];
    if(objId != null)
    {
      url += "&OBJID=" +objId;
    }
    var enterData = params["ENTERDATA"];
    if(enterData != null)
    {
      url += "&VIEWACTION=ENTERDATA";
    }
    window.location.href = url;
  }
  else
  {
    ZDBDialogUtil.closeDialog();
    var tab = ZDBClientUI.getExistingTab("NewTable");
    ZDBClientUI.fetchView(params["OBJID"],params["DBID"],params["TABLENAME"],"Table");
    ZDBNavigation.refreshExplorer();
    ZDBClientUI.removeTab(tab);
  }
}


function importReport(response,requestOptions)
{
  var params = response.getResponseParams();
  ZDBClientUI.sampleView = params["AUTOGENDLGSTATUS"] == "NOTPRESENT" ? true:false;
  ZDBClientUI.hideSheetList = params["IM_HIDESHEETLIST"];
 var delimiters = [',', '\t', ';', ' ','|']; /// Careful - The order must be synchronized with the values in the JAVA file.
                                               /// Why shoudn't I send the character instead of index?
  var delimName = ['COMMA', 'TAB', 'SEMICOLON', 'SPACE', 'PIPE'];

  var delimMap = new Object();
  var len = delimiters.length;
  for(var i=0;i<len;++i) //assumption mapping is proper
  {
    delimMap[delimiters[i]] = delimName[i];
  }

  var delimiter = delimMap[params["DELIMITER"]]; /// Validation?
  var quoteIndex = params["QUOTED"];
  ///Assumption only three values
  var quoted;
  switch(quoteIndex)
  {
    case 1:
      {
        quoted = "SINGLE QUOTE";
        break;
      }
    case 2:
      {
        quoted = "DOUBLE QUOTE";
        break;
      }
    default:
      {
        quoted = "NONE";
        break;
      }
  }
      var importReportDIV = document.createElement("div");
      var imDIV = ZDBUtil.getCachedRef(ZDBImport,"im_div")
      importReportDIV.setAttribute("id", "importReportDIV");
      importReportDIV.setAttribute("isDialog", "true");
      importReportDIV.innerHTML = imDIV.innerHTML;

      imDIV.style.display = "block";
		  if(ZDBCreateDB.isInHomePage())
	      {
			  importReportDIV.style.padding="0 0 25px";
	      }
		  else
	      {
			  importReportDIV.style.padding="25px 0";
	      }
		  importReportDIV.className = "importReportDIV";

      //After importing the table, the new values should be listed in the child table's look up column. For that, tableid of the table needed. The Starting point for that changes.

      var tableIdDiv = document.createElement("div");
      tableIdDiv.setAttribute("name", "TABLEID");
      tableIdDiv.setAttribute("id", "TABLEID");
      tableIdDiv.style.display = 'none';
      var query = requestOptions["PARAMETERS"];
      var parameters = query.split("&");
      for (var j = 0; j < parameters.length; j++)
      {
        var pair = parameters[j].split("=");
        if (pair[0] == 'TABLEID')
        {
          tableIdDiv.setAttribute("TABLEID", pair[1]);
          tableIdDiv.innerHTML = pair[1];
          break;
        }
      }
      importReportDIV.appendChild(tableIdDiv);

      // code end for look up col values changes
      if(!ZDBCreateDB.isInHomePage())
      {
        ZDBInlineDialog.closeDialog();
        ZDBInlineDialog.showDialog(importReportDIV,{MODAL:true, DONTREMOVE:false, ONCLOSE:ZDBCreateDB.gotoSheetView, REQPARAMS:response.getResponseParams()});
        $("ZRImpReport").className="";
      }
      else
      {
        ZDBFullPageDialog.closeDialog();
        ZDBFullPageDialog.showDialog(importReportDIV,{MODAL:true, DONTREMOVE:false,ONCLOSE:ZDBCreateDB.gotoSheetView, REQPARAMS:response.getResponseParams()});
      }
      ZDBClientUI.modified= false;

      fillReport(response);
      if(window.importType == 'import'){
    	  	var subModule = "step"+window.curStep;//NO I18N
      }
      return;
}

function fillReport(response)
{
    var reportInfo = ["IM_CREATEUP","IM_TABLENAME", "IM_TOTAL", "IM_SUCCESS", "IM_WARN", "IM_FAIL", "IM_SKIPDETAIL", "IM_TOTALCOL", "IM_SUCCESSCOL", "IM_DBNAME","IM_OBJID"];
    var reportLen = reportInfo.length;
    var params = response.getResponseParams();

    for(var i=0;i<reportLen;++i)
    {
        ///PK: You manage it! ID and VALUES exist!
         if(reportInfo[i] == 'IM_TABLENAME' || reportInfo[i] == 'IM_DBNAME')
         {
          $(reportInfo[i]).innerHTML = ZDBEscapeUtil.encodeForHtml(params[reportInfo[i]]);
         }
         else
         {
          $(reportInfo[i]).innerHTML = params[reportInfo[i]];
         }
    }

    if(params["IM_ABORTED"] == 'true')
    {
  		jQuery("#IM_TITLE").html(ZDBI18NMap.g('zrpt.common.import.js.importaborted')).addClass("importError");//No I18N
    	jQuery("#importErrDetailsHdr").html(ZDBI18NMap.g('zrpt.common.import.js.errdetails'));//No I18N
        $("importWarnSuccessTable").style.display = "none";
        $("ZDBImpSchSettingsLnk").style.display="none";
        return false;
    }
    $("importWarnSuccessTable").style.display = ZDBUtil.visibleTableStyle;
    // Assumption: both names are present
    var warnCnt = parseInt(params["IM_WARN"]);
    var failCnt = parseInt(params["IM_FAIL"]);

    $("IM_WARNTR").style.display = (warnCnt == 0) ? "none": ZDBUtil.visibleTrStyle;
    $("IM_FAILTR").style.display = (failCnt == 0) ? "none": ZDBUtil.visibleTrStyle;

    if((warnCnt + failCnt) < 1)
    {/// No Error or Warning
        $("importErrDetailsHdr").style.display = "none";
        $("importErrDetails").style.display = "none";
    }
    else
    {
    	jQuery("#importErrDetailsHdr").html((warnCnt > 0 && failCnt > 0) ? ZDBI18NMap.g('zrpt.common.import.js.errwarndetails') : //No I18N
    																									 (warnCnt > 0 ? ZDBI18NMap.g('zrpt.common.import.js.warndetails') :
    																										 				   ZDBI18NMap.g('zrpt.common.import.js.errdetails')));
    }

    var schLink = $("ZDBImpSchSettingsLnk");
    schLink.style.display= (params["IM_SCHEDULE_ALLOWED"] == "true")?"":"none";
    schLink.setAttribute("isGsheet",params["IM_SCHEDULE_ISGSHEET"]);
    schLink.setAttribute("fileType",params["IM_FILETYPE"]);
    schLink.setAttribute("ISFROMGDRIVE",params["IM_ISFROMGDRIVE"]);
    schLink.setAttribute("LOCALFILE",params["IM_LOCAL_FILENAME"]);
    schLink.setAttribute("GDRIVE_FORMAT",params["IM_GDRIVE_FORMAT"]);
    schLink.setAttribute("isZDocs",params["IM_SCHEDULE_ISZDOCS"]);
    schLink.setAttribute("isExtDrive",params["IM_SCHEDULE_ISEXTDRIVE"]);
    schLink.setAttribute("isOnPremiseDB",params["IM_SCHEDULE_ISONPREMISEDB"]);
    schLink.setAttribute("CONNECTIONID",params["CONNECTIONID"]);
    schLink.setAttribute("FILESUBTYPE",params["IM_SCHEDULE_FILESUBTYPE"]);
    schLink.setAttribute("LOCATION",params["LOCATION"]);
    var clsBtn = $("ZDBImportReportCloseBtn");
    if(clsBtn!=null){
    	clsBtn.setAttribute("LOCATION",params["LOCATION"]);
    }
    if(params["IM_SCHSHEETLIST"] != null && params["IM_SCHSHEETLIST"].length > 0)
    {
      schLink.setAttribute("ZDBSHEETLIST",params["IM_SCHSHEETLIST"]);
    }
    schLink.setAttribute("ALLOW_SCHEDULE_INTERVAL_IN_MINUTES",params["ALLOW_SCHEDULE_INTERVAL_IN_MINUTES"]);
    if(params["IMPORTPROPERTIES"] != null)
    {
      schLink.setAttribute("IMPORTPROPERTIES",params["IMPORTPROPERTIES"]);
      schLink.setAttribute("URLPROPERTIES",params["URLPROPERTIES"]);
    }

}

function storeChildDiv(childId, forWhat)
{
  var prefix = "";
  if(forWhat == "existImport")
  {
      if( (childId != "GSheetDlg") && (childId != "ScheduledGSheets") && (childId!="DocsDlg"))
      {
        prefix = "EX";
      }
  }
  var child = $("ZDB" + prefix + childId);
  if(child)
  {
    child.parentNode.removeChild(child);
    if(!window.divData[prefix + childId])
    {
        window.divData[prefix + childId] = child;
    }
  }
}

function storeAllReferences(forWhat)
{
  var props = ["FILEINP", "URLINP", "PASTEINP", "FTPINP" ,"GSHEETINP","ZSHEETINP","EXTFILEINP","import", "template", "scratch", "remote", "remotedb", "enterdata", "GSheetDlg","ScheduledGSheets","DocsDlg","CREATEDIALOG", "GOOGLEINTEGCREATEDB", "ZDBGADDemo", "cloud", "CLOUDDIALOG", "inhousedb", "IMPINTOTHISTBL"]; //No I18N
  var isStore = false;
  if(window.divData == null)
  {
    window.divData = new Object();
    window.divData.isExist = false;
    window.divData.isNew = false;
  }

  if(forWhat == undefined && window.divData.isNew == false)
  {
    window.divData.isNew = true;
    isStore = true;
  }
  /*Why I have not combined this with the previous if? */
  if(forWhat != undefined && forWhat == 'existImport' && window.divData.isExist == false)
  {
    window.divData.isExist = true;
    isStore = true;
  }


  if(isStore)
  {
      var propLen = props.length;

      for(var i=0;i<propLen;++i)
      {
          storeChildDiv(props[i], forWhat);
      }
  }
}


function setDialogPosition(left, top)
{
  var dialog = $("_DIALOG_LAYER");
  dialog.style.position="absolute";
  dialog.style.left=left;
  dialog.style.top=top;
}

function showTableDialog(location,impOpts)
{
  storeAllReferences();
  var dlg = window.divData.CREATEDIALOG.cloneNode(true);
  window.divData.location = location;
   ZDBInlineDialog.showDialog(dlg,{MODAL:true,VIEW:ZDBClientUI.selectedTab.view});
   if(location != "inhousedb")
   {
  	 $("importNote").style.display = "";
  	 var impDesc = (impOpts === 'cloud') ? ZDBI18NMap.g('zrpt.newtable.import.js.clouddesc') : ZDBI18NMap.g('zrpt.newtable.import.js.importcsvdesc');	//No I18N
       $("zdbImportTableDesc").innerHTML = impDesc;
       if(impOpts == 'cloud' && $("zdbImportDBHelp"))
       {
	   		$("ZRSHelplink").setAttribute("href", ZDBI18NMap.g('zrpt.links.js.cldimphelp'));
  	  	$("ZRSVideoDemoHelp").style.display = 'none'; // No I18N
		  	$("ZRSSnapShotTour").style.display = 'none';  // No I18N
  	 }
   }
   else
   {
  	 return;
   }
  location == undefined ? "PASTEDATA" : location;   //No I18N
  if(location == "PASTEDATA")
  {
	  $("ZDBFILETYPE").value = "CSV";  // No I18N
  }
  locationSelected(location);
    
     locationSelected(location);   
    
}

function showDatabaseDialog(selectedOption)
{
        if(ZDBGlobal.ISNEWLAYOUT && ZDBGlobal.LANDINGPAGE == "ZDBHome" && ZRTour.tourCalled == 1)
        {
            ZRTour.endTour(true);
            ZRTour.tourCalled = 2;
        }
        
	var productName = ZDBGlobal.PRODUCT_NAME ;

	if(ZDBGlobal.IS_ONPREMISE_BUILD&&selectedOption=='cloud'){
        ZRCloudInteg.loadUI();
		return;
	}
        if(selectedOption=='import' || selectedOption=='cloud'){
                if(!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/db/ImportSample.js"],"APPENDTODOC",showDatabaseDialog,[selectedOption]))
                {
                        return;
                }
        }	
	window.importType = selectedOption;
	  var checkROMode = ZDBClientUI.readOnlyMode;
	  if(checkROMode)
	  {
	  	ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.javaerr.common.js.ro_mode"));
	  	return;
	  }
    storeAllReferences();
    var dlg = window.divData.CREATEDIALOG.cloneNode(true);
    ZDBFullPageDialog.showDialog(dlg,{MODAL:true});
    window.curStep = 1;
    window.totStep = 2;
    if(selectedOption == "import")
    {
      $("zdbImportDBTitle").innerHTML = ZDBI18NMap.f('zrpt.home.import.step1.js.createdb',window.curStep,window.totStep);
      $("zdbImportDBDesc").innerHTML = ZDBI18NMap.g('zrpt.home.import.js.importdescription.new');
      $("importNote").style.display = "";
      ZDBUtil.setFocus('IDBNAME1');//No I18N
    }
    else if(selectedOption == "enterdata")
    {
      $("zdbImportDBTitle").innerHTML = ZDBI18NMap.g('zrpt.home.import.step1.js.createdbenterdata');
      $("zdbImportDBDesc").innerHTML = ZDBI18NMap.g('zrpt.home.import.js.enterdatarightdesc.new');
      ZDBUtil.setFocus('IDBNAME4');//No I18N
    }
    else if(selectedOption == 'template')
    {
      $('zdbImportDBTitle').innerHTML = ZDBI18NMap.g('zrpt.home.import.step1.js.createdbtemplate');
      $("zdbImportDBDesc").innerHTML = ZDBI18NMap.g('zrpt.home.import.js.dbtempdesc.new');
      ZDBUtil.setFocus('IDBNAME2');//No I18N
      AjaxAPI.sendRequest({URL:"/ZDBListDBTemplates.cc",METHOD:"GET",ONSUCCESSFUNC:"updateTemplates",
                                 OPSTATUSID:"ZDBTemplateLoadIndicator"});//No I18N
    }
    else if(selectedOption == 'scratch')
    {
      $('zdbImportDBTitle').innerHTML = ZDBI18NMap.g('zrpt.home.import.step1.js.createdbblank');
      $("zdbImportDBDesc").innerHTML = ZDBI18NMap.g('zrpt.home.import.js.blankdbdesc.new');
      ZDBUtil.setFocus('IDBNAME3');//No I18N
    }

    else if(selectedOption == 'remote')
    {
      window.totStep = 2;
      $('zdbImportDBTitle').innerHTML = ZDBI18NMap.f('zrpt.home.import.step1.js.createdbremote',window.curStep,window.totStep);
      $("zdbImportDBDesc").innerHTML = ZDBI18NMap.g('zrpt.home.import.js.remotedbdesc');
      ZDBUtil.setFocus('IDBNAME6'); //No I18N
      $("remoteDBImportNote").style.display = "";
    }


    else if(selectedOption == 'google')
    {
      $('zdbImportDBTitle').innerHTML = ZDBI18NMap.g('zrpt.home.import.step1.js.googleimport');
    }
    else if(selectedOption == 'cloud')
    {	
  	  $('zdbImportDBTitle').innerHTML = ZDBI18NMap.f('zrpt.home.import.step1.js.createdb',window.curStep,window.totStep);
  	  $('zdbImportDBDesc').innerHTML = ZDBI18NMap.g('zrpt.home.import.js.dbclouddesc.new');
  	  $("importNote").style.display = "";
  	  if($("zdbImportDBHelp"))
  	  {
  		  $("ZRSHelplink").setAttribute("href", ZDBI18NMap.g('zrpt.links.js.cldimphelp'));
    	  $("ZRSVideoDemoHelp").style.display = 'none'; // No I18N
          if ($('#ZRSSnapShotTour')!= null) {//for onpremise case, this element will not be available. so page loading issue occurrs
    	  $("ZRSSnapShotTour").style.display = 'none';  // No I18N
    	  }    	  }
  	  ZDBUtil.setFocus('IDBNAME1');//No I18N
    }
    else if(selectedOption == 'inhousedb')
    {
    	//$("remoteDBImportNote").style.display = "";
    	$('zdbImportDBTitle').innerHTML = ZDBI18NMap.g('zrpt.databasedata.import.js.step1.dbconnectionsetting');
    	$("zdbImportDBDesc").innerHTML = ZDBI18NMap.g('zrpt.databasedata.import.js.step1.description');
    	$("ZRSHelplink").setAttribute("href",ZDBI18NMap.g('zrpt.links.help.js.localdb'));
    	jQuery("#ZDBTestDBBtn").show(); // No I18N
    }
    else if (selectedOption == 'sdp-integ')
    {
        $('zdbImportDBTitle').innerHTML = ZDBI18NMap.g('zrpt.home.import.js.sdpinteg');
        $("zdbImportDBDesc").innerHTML = ZDBI18NMap.f('zrpt.home.import.js.sdpintegdesc.new',ZDBGlobal.PRODUCT_NAME);
        var formhtml = jQuery("#ZDBImportFile"); // No I18N
        helpLink  = ZDBI18NMap.f('zrpt.links.js.sdpinteghelp',ZDBGlobal.DID);
        jQuery("#ZDBCreateDBCntTd").html(""); // No I18N
        var div1 = jQuery("<div class='openfont12'></div>").html(ZDBI18NMap.f("zrpt.home.import.js.sdpinteghelp",ZDBI18NMap.g('zrpt.links.embed.js.sdpmspvideo'),helpLink)); // No I18N
        var div2 = jQuery("<div class='openfont12'></div>").html(ZDBI18NMap.f("zrpt.home.import.js.sdpinteg.1",ZDBGlobal.PRODUCT_NAME));
        var div3 = jQuery("<div class='openfont12'></div>").html(ZDBI18NMap.f("zrpt.home.import.js.sdpinteg.2",productName,ZDBGlobal.PRODUCT_NAME,ZDBGlobal.PRODUCT_NAME,ZDBGlobal.PRODUCT_NAME));        var imageDiv = jQuery("<div style='height: 123px;margin-left:152px'></div>");
        var imageDiv = jQuery("<div style='height: 123px; margin: 40px 0 15px 152px;'></div>");
        var sdpIcon = jQuery("<div class='sdpintegdlg sdpicon'><img src='/themes/common/images/sdp_logo.png' width='200'></div>");
        var arrow = jQuery("<div class='sdpintegdlg connect'><img src='/themes/common/images/connector.png' width='200'></div>");
        var imgZR = jQuery("<div class='sdpintegdlg aplusicon'><img src='/themes/common/images/prodlogo.png' width='200'></div>");
        imageDiv.append(sdpIcon);
        imageDiv.append(arrow);
        imageDiv.append(imgZR);
        jQuery("#ZDBCreateDBCntTd").append(imageDiv); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(div1); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(div2); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(div3); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(formhtml); // No I18N
        jQuery("#ZDBImportFile .borderright").css({ // No I18N
          "width": "100%", // No I18N
          "text-align": "center", // No I18N
          "max-width": "100%", // No I18N
          "border": "none" // No I18N
        });
        jQuery("#ZDBNextDBBtn").hide(); // No I18N
        jQuery("#ZDBCancelDBBtn").html(ZDBI18NMap.g('zrpt.common.js.closebtn')); // No I18N
    }
    else if (selectedOption == 'sdp-msp-integ')
    {
        $('zdbImportDBTitle').innerHTML = ZDBI18NMap.g('zrpt.home.import.js.sdpmspinteg');
        $("zdbImportDBDesc").innerHTML = ZDBI18NMap.f('zrpt.home.import.js.sdpmspintegdesc.new',ZDBGlobal.PRODUCT_NAME);
        var formhtml = jQuery("#ZDBImportFile"); // No I18N
        helpLink  = ZDBI18NMap.f('zrpt.links.js.sdpinteghelp',ZDBGlobal.DID);
        jQuery("#ZDBCreateDBCntTd").html(""); // No I18N
        var div1 = jQuery("<div class='openfont12'></div>").html(ZDBI18NMap.f("zrpt.home.import.js.sdpmspinteghelp",ZDBI18NMap.g('zrpt.links.embed.js.sdpmspvideo'),helpLink)); //No I18N
        var div2 = jQuery("<div class='openfont12'></div>").html(ZDBI18NMap.f("zrpt.home.import.js.sdpmspinteg.1",ZDBGlobal.PRODUCT_NAME));
        var div3 = jQuery("<div class='openfont12'></div>").html(ZDBI18NMap.f("zrpt.home.import.js.sdpmspinteg.2",productName,ZDBGlobal.PRODUCT_NAME,ZDBGlobal.PRODUCT_NAME,ZDBGlobal.PRODUCT_NAME));
        var imageDiv = jQuery("<div style='height: 123px; margin: 40px 0 15px 152px;'></div>");
        var sdpIcon = jQuery("<div class='sdpintegdlg sdpmspicon'><img src='/themes/common/images/sdpmsp_logo.png' width='220'></div>");
        var arrow = jQuery("<div class='sdpintegdlg connect'><img src='/themes/common/images/connector.png' width='200'></div>");
        var imgZR = jQuery("<div class='sdpintegdlg aplusicon'><img src='/themes/common/images/prodlogo.png' width='200'></div>");
        imageDiv.append(sdpIcon);
        imageDiv.append(arrow);
        imageDiv.append(imgZR);
        jQuery("#ZDBCreateDBCntTd").append(imageDiv); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(div1); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(div2); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(div3); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(formhtml); // No I18N
        jQuery("#ZDBImportFile .borderright").css({ // No I18N
          "width": "100%", // No I18N
          "text-align": "center", // No I18N
          "max-width": "100%", // No I18N
          "border": "none" // No I18N
        });
        jQuery("#ZDBNextDBBtn").hide(); // No I18N
        jQuery("#ZDBCancelDBBtn").html(ZDBI18NMap.g('zrpt.common.js.closebtn')); // No I18N
    }
    else if (selectedOption == 'scp-integ')
    {
        $('zdbImportDBTitle').innerHTML = ZDBI18NMap.g('zrpt.home.import.js.scpinteg');
        $("zdbImportDBDesc").innerHTML = ZDBI18NMap.f('zrpt.home.import.js.scpintegdesc.new',ZDBGlobal.PRODUCT_NAME);
        var formhtml = jQuery("#ZDBImportFile"); // No I18N
        jQuery("#ZDBCreateDBCntTd").html(""); // No I18N
        var div1 = jQuery("<div class='openfont12'></div>").html(ZDBI18NMap.f("zrpt.home.import.js.scpinteg.1",ZDBGlobal.PRODUCT_NAME));
        var div2 = jQuery("<div class='openfont12'></div>").html(ZDBI18NMap.f("zrpt.home.import.js.scpinteg.2",productName,ZDBGlobal.PRODUCT_NAME,ZDBGlobal.PRODUCT_NAME,ZDBGlobal.PRODUCT_NAME));
        var imageDiv = jQuery("<div style='height: 123px; margin: 40px 0 15px 152px;'></div>");
        var sdpIcon = jQuery("<div class='sdpintegdlg scpicon'><img src='/themes/common/images/scp_logo.png' width='200'></div>");
        var arrow = jQuery("<div class='sdpintegdlg connect'><img src='/themes/common/images/connector.png' width='200'></div>");
        var imgZR = jQuery("<div class='sdpintegdlg aplusicon'><img src='/themes/common/images/prodlogo.png' width='200'></div>");
        imageDiv.append(sdpIcon);
        imageDiv.append(arrow);
        imageDiv.append(imgZR);
        jQuery("#ZDBCreateDBCntTd").append(imageDiv); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(div1); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(div2); // No I18N
        jQuery("#ZDBCreateDBCntTd").append(formhtml); // No I18N
        jQuery("#ZDBImportFile .borderright").css({ // No I18N
          "width": "100%", // No I18N
          "text-align": "center", // No I18N
          "max-width": "100%", // No I18N
          "border": "none" // No I18N
        });
        jQuery("#ZDBNextDBBtn").hide(); // No I18N
        jQuery("#ZDBCancelDBBtn").html(ZDBI18NMap.g('zrpt.common.js.closebtn')); // No I18N
    }
    if($("zdbImportDBHelp"))
    {
    	$("zdbImportDBHelp").style.display = (selectedOption == "import" || selectedOption == "cloud" || selectedOption == "inhousedb") ? "block" : "none";//NO I18N
    }

    showSelectedOption(selectedOption);
    if(selectedOption == 'import' || selectedOption == 'cloud')
    {
    	ZDBImport.setFileType(selectedOption);
	setFileTypeLabel(selectedOption);
    }
    if(selectedOption == 'import'){
    	var subModule = "step"+window.curStep;//NO I18N
    }
    ZDBUtil.setIfGAppsUser();
    var handler = ZDBGlobal.ISNEWLAYOUT ? ZRSHomeHandler : ZRSHomepageListing;
    if(selectedOption=='import' || selectedOption == 'cloud'){
        handler.autoDatabaseName("ZDBIMPORTTBODY"); //No I18N
    }
    if(selectedOption == "enterdata" ||  selectedOption == 'template' ||selectedOption == 'scratch'){
        handler.autoDatabaseName("ZDBCreateDBContainer"); //No I18N
    }
    
    if(ZDBGlobal.ISNEWLAYOUT && ZDBGlobal.LANDINGPAGE == "ZDBHome" && ZRTour.tourCalled == 2)
    {
        setTimeout(function(){
            ZRTour.fileStep1Tour();
        },400);
    }
}

function updateTemplates(response,requestOptions)
{
  $("ZDBTemplatesHolder").innerHTML = response.getOnlyHtml();
}

var opts = ["scratch","remote","remotedb","template","import"]; //No I18N

function showSelectedOption(selectedOpt)
{
   var viewCont = $("ZDBCreateDBContainer");
   var content = ((selectedOpt === "import" || selectedOpt === "cloud")) ? divData["import"] : divData[selectedOpt];	//No I18N
//   var content = divData[selectedOpt];
   if(content){
	   viewCont.innerHTML = content.innerHTML;
	   }
   if(selectedOpt == "import")
   {
	 locationSelected("LOCALDRIVE");//No I18N
   }
   $("ZDBOPTIONINP").value= selectedOpt;
   $("ZDBSaveNextDBBtn").style.display = (selectedOpt === "remote") ? "" : "none";
   $("ZDBNextDBBtn").style.display = (selectedOpt === "import" || selectedOpt === "inhousedb")? "":"none";//No I18N
   $("ZDBCreateDBBtn").style.display = (selectedOpt === "import" || selectedOpt === "remote" || selectedOpt === "sdp-integ" || selectedOpt === "sdp-msp-integ" || selectedOpt === "scp-integ")? "none":"";//No I18N

   if(selectedOpt == "google")
   {
      $("ZDBNextDBBtn").style.display = "none";
      $("ZDBCreateDBBtn").style.display = "none";
      $("ZDBCancelDBBtn").style.display = "none";
   }
   if(selectedOpt == "template" && $("CDBDATA") != null)
   {
       $("CDBDATA").checked="true";
   }
   if(selectedOpt == "cloud")
   {
	   locationSelected("GSHEET");  // No I18N
   }
   if(selectedOpt == "inhousedb")
   {
	   $("ZDBCreateDBBtn").style.display = "none";
   }
}


function transferInputDet(name,prefix,suffix)
{
  var orig = $(prefix + name);
  var second = $(suffix + name);
  if((orig == null) || (second == null))
  {
    return;
  }
  if(orig.type == "radio")
  {
    second.checked = orig.checked;
  }
  else
  {
    second.value = orig.value;
  }

}

function showCreateDB(forWhat)
{
  window.prevDBFrm.style.display ="none";
  $("ZDBCreateDBCntTd").appendChild(window.prevDBFrm);
  var importVia = window.divData["importVia"];
  var fileType = window.divData["fileType"];
  if (fileType == "CSV" || ((fileType == "XLS") && (importVia == "PASTEDATA" )))
  {
    $("ZDBPASTEOPT").checked = (importVia == "PASTEDATA");
    $("ZDBFILEOPT").checked = (importVia == "LOCALDRIVE");
    $("ZDBWEBOPT").checked = (importVia == "WEB");
    if($("ZDBFTPOPT")){
    	$("ZDBFTPOPT").checked = (importVia == "FTP");
    }
    $("ZDBFILETYPE").value = "CSV";    // No I18N
  }
  if(sampleTableGrid != null)
  {
    ZDBDataGrid.removeInstance(sampleTableGrid.ID);
    sampleTableGrid = null;
  }
  window.impFrm.parentNode.removeChild(window.impFrm);
  window.prevDBFrm.style.display="block";
  window.impFrm = window.prevDBFrm;
  window.curStep = window.curStep -1;
  changeTitle();
}

function showCreateDBFromWeb(forWhat)
{
  window.homeFrm.style.display ="none";
  $("ZDBCreateDBCntTd").appendChild(window.homeFrm);
  var importVia = window.divData["importVia"];
  if(sampleTableGrid != null)
  {
    ZDBDataGrid.removeInstance(sampleTableGrid.ID);
    sampleTableGrid = null;
  }
  window.impFrm.parentNode.removeChild(window.impFrm);
  window.homeFrm.style.display ="block";
  $("ZDBPASTEOPT").checked = (importVia == "PASTEDATA");
  $("ZDBFILEOPT").checked = (importVia == "LOCALDRIVE");
  if($("ZDBFTPOPT")){
	  $("ZDBFTPOPT").checked = (importVia == "FTP")
  }

  $("ZDBWEBOPT").checked = (importVia == "WEB") || (importVia == "GSHEET") || (importVia == "ZDOCS") ||ZDBImport.isExternalFile(importVia) ; //No I18N
  window.curStep = window.curStep -1;
  changeTitle();
}

function uploadFile(response,request, forWhat)
{
  var fix = "";
  if(forWhat == "existImport")
  {
    fix = "EX";
  }
  if ($("ZDB" + fix + "CreateFrm"))
  {
    window.homeFrm = $("ZDB" + fix + "ImportFile");
  }
  window.prevDBFrm = $("ZDB" + fix + "ImportFile"); // Default All form present in the ZDBImportFile Div
  var div = document.createElement("div");
  div.id = "ZDB" + fix + "ImportFile";
  div.style.width="100%";
  div.style.height="100%";
  div.innerHTML = response.getOnlyHtml();


  div.style.visibility ="hidden";
  $("ZDB" + fix + "CreateDBCntTd").appendChild(div);
  if(forWhat != "existImport")
  {
      transferInputDet("DBNAME","I","F");
      transferInputDet("TABLENAME","I","F");
      transferInputDet("DESCRIPTION","I","F");
      transferInputDet("TAGS");
  }
  window.impFrm = div;
  //window.zdbFileLocationOption = $("ZDB" + fix + "FILEOPT").checked;
  div.style.visibility="visible";
  if ($("ZDB" + fix + "CreateFrm"))
  {
    //GSHEETHOTFIX:
    //check for gdrive csv
    var fileName =  "";
    var fileExtension =  "";
    if($("ZDB"+fix+"FILETYPE").value== "GSHEET")
    {
    fileName = $("ZDBExtIntInput").value;
    fileExtension = ZDBImport.getFileExtension(fileName).toUpperCase();
    if($("ISFROMGDRIVE").value=="false")
    {
      fileExtension="";
    }
    }
    if(forWhat == "existImport" &&
        ($("ZDBEXFILETYPE").value  == "HTML" || ( (($("ZDBEXFILETYPE").value == "XLS")||($("ZDBEXFILETYPE").value == "GSHEET") || (($("ZDBEXFILETYPE").value == "ZDOCS" || ZDBImport.isExternalFile($("ZDBEXFILETYPE").value) )  && ($("ZDBFILESUBTYPE").value=="XLS" ||$("ZDBFILESUBTYPE").value=="XLSX"   || $("ZDBFILESUBTYPE").value=="HTML")))   && (!$("ZDBEXPASTEOPT").checked) //No I18N
          && fileExtension!="CSV" && fileExtension!="TSV" && fileExtension!="TXT" ))) //No I18N
    {
      var frm = $('ZDBHTMLTableFrm');
      frm.setAttribute("onsuccessfunc","handleExistImport");
      frm.setAttribute("opstatusid","ZDBCREATEDBOPTSTATUS");
    }
  }
  window.prevDBFrm.parentNode.removeChild(window.prevDBFrm);
}

function isTopCommentValid(frm)
{
    var skipTop = frm["SKIPTOP"].value;
    var comment = frm["COMMENTCHAR"].value;

    if(!(skipTop == "" || ZDBValidator.isPositive(skipTop,true,true)))
    {
    	showCustomMessage(ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.skipTopRowsInputErr"), $("SKIPTOP"));  // No I18N
        return false;
    }
    if(comment && !/^.?$/.test(comment))
    {
    	showCustomMessage(ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.commentCharInputErr"), $("COMMENTCHAR"));  // No I18N
        return false;
    }
    return true;
}

function isANCTypeUnique(colHeads)
{
	var colLen = colHeads.length;
	var autoCnt = 0;
	var typeList;
	var colObj;
	for(var i=0; i < colLen;  i++)
	{
    colObj = colHeads[i];
    if(colObj.objType != ZDBConst.COLHEAD)
    {
      continue;
    }
    typeList = colObj.dataType;
    if(typeList[typeList.selectedIndex].value == ZDBDesignGridConst.AUTO_NUMBER)
    {
      ++autoCnt;
    }
    if(autoCnt > 1)
    {
      return false;
    }
	}
	return true;
}


function isDateFieldOK(rowObj, frm)
{
    var dataTypes = rowObj.values;
    var colLen = dataTypes.length;
    var dateColumnPresent = false;
    var colObj, dList, selType;
    for(var i=0;i<colLen;++i)
    {
        colObj = dataTypes[i].colObj;
        if(colObj.objType != ZDBConst.COLHEAD)
        {
          continue;
        }
        dList = colObj.dataType;
        selType = dList[dList.selectedIndex].value;
        if(selType == "9" || selType == "22")
        ///PK Checking date value. I should have some other way to do it
        {
            dateColumnPresent = true;
            if(frm["DATEFORMAT"].value == "")
            {
                ////ZDBAlertAPI.showMsg("You must select the date format");
                showCustomMessage(ZDBI18NMap.g("zrpt.common.import.custommsg.js.wrongDtFmtSel"), ZDBUtil.getParentWithTagName(frm["DATEFORMAT"],"div"));  // No I18N
                return false;
            }

        }
    }
    if(!dateColumnPresent && frm["DATEFORMAT"].value == "MILLI")
    {
        showCustomMessage(ZDBI18NMap.g("zrpt.common.import.custommsg.js.milliDateFormatErr"), ZDBUtil.getParentWithTagName(frm["DATEFORMAT"],"div"));
        return false;
    }
    return true;
}


function getDataTypeRow(isExist)
{
  var rowData = sampleTableGrid.rowData;
  var index = ZDBDataGrid.getFirstRowIndex(rowData, false);
  if(isExist)
  {
    return rowData[index+1];
  }
  else
  {
    return rowData[index];
  }

}

function refreshSampleForm(frmEl)
{
  var frm = frmEl.form;
  var elName = frmEl.name;
  frm["IMPORTUPDATEFIELD"].value = elName;
  var forExist = frm.getAttribute("ISEXISTIMPORT") ? true : false;
  if(!isTopCommentValid(frm))
  {
    return false;
  }
  if(frm["SKIPTOP"].value == "")
  {
    frm["SKIPTOP"].value = 0;
  }
  if(elName == "ZOHO_DECIMAL_SEP" || elName == "ZOHO_THOUSAND_SEP" )
  {
      var thousandSep = frm["THOUSANDSEP"].value;
      var decimalSep = frm["DECIMALSEP"].value;
      if( (thousandSep == 1 && decimalSep == 1 ) || (thousandSep == 2 && decimalSep == 0 ) )
      {
         var msg = ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.separatorsAreSame");
         showCustomMessage(msg, frmEl);
         return false;
      }
  }

  var imAction = "SAMPLEVIEW";
  if(!isDateFieldOK(getDataTypeRow(forExist), frm))
  {
    return false;
  }
  if(forExist)
  {
    imAction += "EX";
  }
  $("IMPORTACTION").value =imAction
  $("TABLECONFIG").value ="";
  frm.setAttribute("onsuccessfunc","showSampleTable");
  frm.setAttribute("opstatusid","ZDBSAMPLETABLEOPSTATUS");
  AjaxAPI.submit(frm);
  return true;
}

function handleImportError(response,request)
{
   var msg = response.getResponsePart("STATUS_MESSAGE");
   if(msg == "REUPLOADFILE")
   {
     var frm = document.forms["UploadFile"];
     if(frm.reloadCount < 2)
     {
        frm.reloadCount++;
        AjaxAPI.submit(frm);
        return;
     }
     msg = ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.importFailed");
     ZDBAlertAPI.showMsg(msg);
   }
   var errorNumCode = response.getResponsePart("ERRORNUMCODE");
   if(errorNumCode == 7286)
       {
           ZDBImport.defineRelationship();
           setTimeout(function(){return true},200);
           var err = JSON.parse(response.getResponsePart("ERROR_MESSAGE"));
            for(var i=0;i<err.ERRORS.length;i++)
            {
            var colID=err.ERRORS[i][0];
            var ErrorMsg=ZDBEscapeUtil.decodeForHtml(err.ERRORS[i][1]);
            var list=jQuery("#EnclosingDiv").find("#FKCol"); //No I18N
            for(j=0;j<list.length;j++)
                {
                    var ele = list[j];
					//console.log(ele.getAttribute("colID"));
                    if((ele.getAttribute("colID")).indexOf(err.ERRORS[i][0])!=-1)
                    {
                    var joindiv=ele.parentNode.parentNode.parentNode.parentNode.querySelectorAll("#JOINDIV")[0]
                    joindiv.className="errorOnJoinIcon";
                    jQuery(joindiv.parentNode.parentNode).find("#LEFTLABEL")[0].style.visibility ="hidden";
                    jQuery(joindiv.parentNode.parentNode).find("#RIGHTLABEL")[0].style.visibility ="hidden";
                    joindiv.setAttribute("isError","true");
                    joindiv.setAttribute("blocked","false");
                    joindiv.setAttribute("tip",ErrorMsg);
                    ZDBToolTip.show(joindiv,"mouseover");//No I18N
	            }
                }
            }
       }
   else if(errorNumCode == 10001)
   {
     ZDBAlertAPI.showMsg(msg+ ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.wantToOverride"), "ZDBYESNO",{ONCLICK:handleCanOverRideException});
   }
   else
   {
     AjaxAPI.onFailureFunc(response,request);
   }
}

function handleCanOverRideException(clickType)
{
  if(clickType != "YES")
  {
    return;
  }
  else
  {
    ZDBImport.importTable(true, true);
  }
}

function locationSelected(locationType, forWhat)
{
  hideCustomMessage();
  ZDBClientUI.modified = false;
  var prefix = "";
  if(forWhat == "existImport")
  {
    prefix = "EX";	//No I18N
  }

  var locFile = window.divData[prefix + "FILEINP"];
  var locPaste = window.divData[prefix + "PASTEINP"];
  var web = window.divData[prefix + "URLINP"];
  var dbox=window.divData[prefix+"EXTFILEINP"];
  var ftp = window.divData[prefix+"FTPINP"];

  var toAppend, toRemove1, toRemove2, toRemove3, toRemove4;
  if(forWhat == "existImport" && !(ZDBImport.isExternalFile($("ZDB"+prefix+"FILETYPE").value)))
  {
	$('ZDB' + prefix + 'DataLocation').style.display = '';
  }
  if(locationType == "LOCALDRIVE")
  {
	$("ZDB" + prefix + "OPTIONINP").value = "import"; //No I18N
    if($("ZDB" + prefix + "FILEOPT").disabled==true){return;} // Code used when Radio Button is Disabled
    $("ZDB" + prefix + "FILEOPT").checked = true;
    toAppend = locFile;
    toRemove1 = locPaste;
    toRemove2 = web;
    toRemove3=dbox;
    toRemove4=ftp;
  }
  else if (locationType == "PASTEDATA")
  {
	  $("ZDB" + prefix + "OPTIONINP").value = "import"; //No I18N
    ZDBClientUI.modified = true;
    if($("ZDB" + prefix + "PASTEOPT").disabled==true){return;}
    $("ZDB" + prefix + "PASTEOPT").checked = true;
    toAppend = locPaste;
    toRemove1 = locFile;
    toRemove2 = web;
    toRemove3=dbox;
    toRemove4=ftp;
  }
  else if (locationType == "FTP")
  {
	  if($("ZDB"+prefix+"FTPOPT")!=null){
		  $("ZDB" + prefix + "OPTIONINP").value = "import"; //No I18N
		  if($("ZDB" + prefix + "FTPOPT").disabled==true){return;}
		  $("ZDB" + prefix + "FTPOPT").checked = true;
		  toAppend = ftp;
		  toRemove1 = locFile;
		  toRemove2 = web;
		  toRemove3 = dbox;
		  toRemove4 = locPaste;
          protocolSelected(jQuery('[name=FTPPROTOCOL]')); //NO I18N
	  }
	  else{
		  $("ZDB" + prefix + "OPTIONINP").value = "import"; //No I18N
		  if($("ZDB" + prefix + "FTPOPT").disabled==true){return;}
		  $("ZDB" + prefix + "PASTEOPT").checked = true;
		  toAppend = locPaste;
		  toRemove1 = locFile;
		  toRemove2 = web;
		  toRemove3 = dbox;
		  toRemove4 = ftp;
	  }
  }
  else if (locationType == "WEB")
  {
    if($("ZDB" + prefix + "WEBOPT").disabled==true){return;}
    $("ZDB" + prefix + "WEBOPT").checked = true;
    if(ZDBImport.isExternalFile($("ZDB"+prefix+"FILETYPE").value))
    {
        toAppend=dbox;
        toRemove3=web;
    }
    else
    {
    	$("ZDB" + prefix + "OPTIONINP").value = "import"; //No I18N
        toAppend = web;
        toRemove3=dbox;
    }
    toRemove1 = locPaste;
    toRemove2 = locFile;
    toRemove4 = ftp;
  }
  else if(ZDBImport.isExternalFile(locationType))
  {
	  toAppend=dbox;
	  $("ZDB" + prefix + "OPTIONINP").value = "cloud"; //No I18N
	  toRemove1 = locFile;
	  toRemove2 = locPaste;
	  toRemove3 = web;
	  toRemove4 = ftp;
	  $('ZDB' + prefix + 'DataLocation').style.display = 'none';
	  if(forWhat == "existImport")
	  {
		  $("ZDBEXWEBOPT").checked =true;
	  }
  }
  if(locationType != "GSHEET")
  {
      $("ISFROMGDRIVE").value="false";
      $("ISGDRIVECSV").value="false";
  }
  window.divData["importVia"] = locationType;
  $("ZDB" + prefix + "IMPORTTBODY").appendChild(toAppend); // Prefix?
  toRemove2.parentNode ? toRemove2.parentNode.removeChild(toRemove2) : "Do Nothing"; //No I18N
  toRemove3.parentNode ? toRemove3.parentNode.removeChild(toRemove3) : "Do Nothing"; //No I18N
  toRemove1.parentNode ? toRemove1.parentNode.removeChild(toRemove1) : "Do Nothing";  // No I18N
  toRemove4.parentNode ? toRemove4.parentNode.removeChild(toRemove4) : "Do Nothing"; //No I18N
  if(ZDBImport.isExternalFile(locationType))
  {
	  if(locationType==="DROPBOX")
	  {
		  $("ZDBExtDriveName").innerHTML= ZDBI18NMap.g("zrpt.common.external.js.dropbox");//NO I18N
	  }
	  else if(locationType==="BOX")
	  {
		  $("ZDBExtDriveName").innerHTML= ZDBI18NMap.g("zrpt.common.external.js.box");//NO I18N
	  }
	  else if(locationType==="ONEDRIVE")
	  {
		  $("ZDBExtDriveName").innerHTML= ZDBI18NMap.g("zrpt.common.external.js.skydrive");//NO I18N
	  }
	  else if(locationType==="ZDOCS")
	  {
		  $("ZDBExtDriveName").innerHTML= ZDBI18NMap.g("zrpt.common.external.js.zdocs");//NO I18N
	  }
	  else if(locationType==="GSHEET")
	  {
		  $("ZDBExtDriveName").innerHTML= ZDBI18NMap.g("zrpt.common.external.js.gdrive");//NO I18N
	  }
	  var elt = $("ZDBExtIntInput");
	  elt.value=elt.getAttribute("tipvalue");
	  elt.setAttribute("tipShown","true");
	  jQuery('#ZDBEXTERNALOPTSTATUS').hide();//NO I18N
  }
  else
  {
	  changeImportNote(forWhat);
	  importStepValUpdate(forWhat);
	  changeTitle();
          if(locationType=="WEB" )
            {
                showHideUrlParamDiv(false);
            }
  }




}

function importStepValUpdate(forWhat,subtype)
{
  var prefix = "";
  if(forWhat == "existImport")
  {
    prefix = "EX";
  }
  var fileType = $("ZDB" + prefix + "FILETYPE").value;

   if ( fileType == "CSV")
   {
   	window.totStep = 2;
   }
   else if(fileType == "XLS")
   {
	   var pasteOpt = $("ZDB" + prefix + "PASTEOPT").checked;
   	   window.totStep = (pasteOpt) ? 2 : 3;
   }
   else if(fileType == "HTML")
   {
   	window.totStep = 3;
   }
   else if(fileType == "JSON" || fileType == "XML")
   {
   	window.totStep = 2;
   }
   else if(fileType == "ZDOCS" || ZDBImport.isExternalFile(fileType))
   {
	   var fileSubtype=$("ZDBFILESUBTYPE").value;
	   if(fileSubtype=="XLS" || fileSubtype=="HTML"|| fileSubtype=="XLSX" || fileSubtype == "GSHEET")
		   window.totStep = 3;
	   else
		   window.totStep = 2;
   }
   else if(fileType == "GSHEET")
   {
    window.totStep = (subtype === "csv") ? 2 : 3;  //No I18N
   }

}

function showSampleTable(response,request)
{
  var jsonObj = JSON.parse(response.responseText);
  dg = invokeSampleTableScripts(jsonObj);
  addSampleTableToView(dg,true);
  if(ZDBImport.isCreatePending)
  {
    ZDBImport.isCreatePending = false;
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.import.zdbalertmsg.js.importConfirm"),
                        "ZDBYESNO",{ONCLICK:processCreateTable});
  }
}
function refreshJoinCount(response)
{
    var jsonObj = JSON.parse(response.responseText);
    if(jsonObj.IDENTIFIEDJOINS)
    {
        $("ZDBJOINTABLE").style.display="block";
        $("JOINSLIST").value="";
        if($("ZDBImportFileWithRelation") !=null)
                 {$("ZDBImportFileWithRelation").parentNode.removeChild($("ZDBImportFileWithRelation"));}
        if(jsonObj.IDENTIFIEDJOINS.length==1)
            {
                $("ZDBJOINTABLE").innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.suggestLookup',jsonObj.IDENTIFIEDJOINS.length);
                $("ZDBJOINTABLE").style.marginRight = '473px';//No I18N
            }
        else if(jsonObj.IDENTIFIEDJOINS.length>0)
            {
                $("ZDBJOINTABLE").innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.suggestLookups',jsonObj.IDENTIFIEDJOINS.length);
                $("ZDBJOINTABLE").style.marginRight = '473px';//No I18N
            }
        else
            {
                 $("ZDBJOINTABLE").innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.defineLookup');
                 $("ZDBJOINTABLE").style.marginRight = '473px';//No I18N
                 $("JOINSLIST").value="";
                 var div = document.createElement("div");
                 div.innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.defineLookup');
                 div.id = "ZDBMaxMinSidebar";
                var joindialog = jQuery(div);
                joindialog.attr("class","rec movableAddNewTabGreen");//No I18N
                jQuery(div).bind('click', function(){ZDBCreateDB.showRelDialog();});
            }
    }
    else if($("ZDBJOINTABLE")!=undefined)
  {
            $("ZDBJOINTABLE").style.display="none";
  }
}

function invokeSampleTableScripts(jsonObj)
{
  var dg = new ZDBDataGrid();
  if(jsonObj.grid_param)
  {
	for(key in jsonObj.grid_param)
	{
		dg[key] = jsonObj.grid_param[key];
	}
  }

  dg.init();

  if(jsonObj.JSONNodePath)
  {
	  dg.setJSONNodePath(jsonObj.JSONNodePath);
  }
  if(jsonObj.colHead)
  {
	  dg.setColumnHeaders(jsonObj.colHead);
  }
  if(jsonObj.refreshRows)
  {
	  dg.refreshRows(jsonObj.refreshRows);
  }
  if(jsonObj.csvConfig)
  {
	  setDefaultCSVConfig.apply(dg,jsonObj.csvConfig);
  }
  if(jsonObj.IDENTIFIEDJOINS)
    {
        $("ZDBJOINTABLE").style.display="block";
        if($("ZDBImportFileWithRelation") !=null)
                 {$("ZDBImportFileWithRelation").parentNode.removeChild($("ZDBImportFileWithRelation"));}
        if(jsonObj.IDENTIFIEDJOINS.length==1)
            {
                $("ZDBJOINTABLE").innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.suggestLookup',jsonObj.IDENTIFIEDJOINS.length);
                $("ZDBJOINTABLE").style.marginRight = '473px';//No I18N
            }
        else if(jsonObj.IDENTIFIEDJOINS.length>0)
            {
                $("ZDBJOINTABLE").innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.suggestLookups',jsonObj.IDENTIFIEDJOINS.length);
                $("ZDBJOINTABLE").style.marginRight = '473px';//No I18N
            }
        else
            {
                 $("ZDBJOINTABLE").innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.defineLookup');
                 $("ZDBJOINTABLE").style.marginRight = '473px';//No I18N
                 $("JOINSLIST").value="";
                 var div = document.createElement("div");
                 div.innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.defineLookup');
                 div.id = "ZDBMaxMinSidebar";
                var joindialog = jQuery(div);
                joindialog.attr("class","rec movableAddNewTabGreen");//No I18N
                jQuery(div).bind('click', function(){ZDBCreateDB.showRelDialog();});
  }
  }
    else if($("ZDBJOINTABLE")!=undefined)
  {
            $("ZDBJOINTABLE").style.display="none";
  }
  return dg;
}

function processCreateTable(clickType, params)
{
        if(clickType == "YES")
        {
            ZDBImport.importTable(false); ///PK: should be button? ZDBImport.refreshElement
        }
        else
        {
          ZDBImport.isCreatePending = false;
        }
}


function addSampleTableToView(dg,isPreviewVisible)
{
        if(dg.isForImport)
        {
            dg.reorderDisabled = true;
            dg.updateNavigationDisabled = true;
        }
        var colHeads = dg.colHeaders;
        var colLen = colHeads.length;
        var holder = $("SampleTableHolder");
        holder.style.visibility = 'hidden';
        var oldGrid = window.sampleTableGrid;
        if((oldGrid != null) && (oldGrid.gArea.parentNode == holder))
        {
            holder.replaceChild(dg.gArea,oldGrid.gArea);
            ZDBDataGrid.removeInstance(oldGrid.ID);
        }
        else
        {
            holder.appendChild(dg.gArea);
        }

        dg.resizeGrid(holder.offsetWidth+2,154);
        if(ZDBGlobal.IS_MOBILE)
        {
            if(!dg.scroller)
            {
                var opts = {"V_SCROLL_ELS" : [dg.rhArea], "H_SCROLL_ELS" : [dg.chArea]};
                dg.scroller = new ZRScroller(dg.dArea,opts);
            }
        }
        sampleTableGrid = dg;

        /*OK double work!*/
        resetDuplicateHeads(dg);
        dg.existImport = dg.originalColInfo ? true : false;

        if(dg.originalColInfo)
        {
            setDatatypeEditor(dg, false);
        }
        else
        {
            setDatatypeEditor(dg, true);
        }
        setIgnoreImportCheckBox(dg);

        dg.showTable();
        if(isPreviewVisible)
        {
            holder.style.visibility  = 'visible';
        }
        else
        {
            holder.style.visibility = 'hidden';
        }
        dg.selectable = false;
        var len = colHeads.length;
        var curHead;
        for(var i=0;i<len;++i)
        {
            curHead = colHeads[i];
            if(curHead.objType == ZDBConst.COLHEAD)
            {
                resetColIndex(curHead);
            }
        }
        if($("HEADERHELP")!=undefined)
        {$("HEADERHELP").style.marginLeft ="367px";}//No I18N
        if(colLen>5)
            {
                dg.resizeGrid(holder.offsetWidth-28,154);
            }
            else
                {
                    dg.resizeGrid(646,156);
                    if($("HEADERHELP")!=undefined)
                    {$("HEADERHELP").style.marginLeft ="89px";}//No I18N
                }
        dg.updatePreviewGridColumnWidth();
        if(ZDBGlobal.ISNEWLAYOUT && ZDBGlobal.LANDINGPAGE == "ZDBHome" && ZRTour.tourCalled == 3)
        {
            ZRTour.fileStep2Tour(); //step 2 called
        }
    }

  function getIndex(colHeads, colHead)
  {
    /* case-insensitive*/
    /* colHead only*/
    var len = colHeads.length;
    var valueToFind = colHead.displayName.toUpperCase();
    for(var i=0;i<len;++i)
    {
        if(colHeads[i] != colHead && colHeads[i].displayName.toUpperCase() == valueToFind)
        {
            return i;
        }
    }
    return -1;
  }

  function getNewName(oldName)
  {
    /// just adding _dup with name
    ///  Assumption: colname is going to have _dup when the user just wants to play ;-)
    return oldName + "_dup";

  }


  function resetDuplicateHeads(gridObj)
  {
    var colHeads = gridObj.colHeaders;
    var colLen = colHeads.length;
    for(var i=0;i<colLen;++i)
    {
        var curColHead = colHeads[i];
        if(curColHead.objType !== ZDBConst.COLHEAD)
        {
          continue;
        }

        var idx = getIndex(colHeads, curColHead);
        var curName = curColHead.displayName;
        if(curName.toUpperCase() == "__ZDBID")
        {
            idx = i;
        }

        while(idx >= 0)
        {
            curName = getNewName(curName);
            if(!colHeads[idx].setValue(curName))
            {
                continue;
            }
            idx = getIndex(colHeads, curColHead);
        }
    }
  }

  function onDataTypeChange(event)
  {
    var list = window.event ? window.event.srcElement : event.target;
    var selIndex = list.selectedIndex;
    var dObj = list.cellObj;

    if(list[selIndex].getAttribute("zdbDisabled") == "true")
    {
        ZDBMsgBox.showHintMsg(ZDBI18NMap.g("zrpt.common.import.hintmsg.js.lookUpColChoosingNotPosErr"));
        list.selectedIndex = dObj.colObj.previousIndex;
        return false;
    }
    dObj.originalValue = list[list.selectedIndex].value;
  }

  function onColListChange(list)
  {
    var selIndex = list.selectedIndex;
    var dObj = list.cellObj
    var colObj = dObj.colObj;
    if(list[selIndex].getAttribute("zdbDisabled") == "true")
    {
        // Sadly, this is to handle IE bug
        ////ZDBAlertAPI.showMsg("You have already mapped the column [" + list[selIndex].value + "]");
        alert(ZDBI18NMap.f("zrpt.common.browser.alert.js.existImpColMapErr", list[selIndex].value));
        list.selectedIndex = dObj.colObj.previousIndex;
        return false;
    }
    else
    {
        // dObj.originalValue = list[list.selectedIndex].value;
        var dg = colObj.parGrid;
        var opt = list[selIndex];
        if(selIndex != 0) //  other than "NEW" field
        {
            setDisableFlag(dg, selIndex, true);
            opt.setAttribute("zdbDisabled", "false");
            opt.removeAttribute("disabled");
            /// I should have reused my setCheck ;'-)
        }
        setDisableFlag(dg, colObj.previousIndex, false);
        colObj.previousIndex = selIndex;
        var curDisplay = opt.value;
        if(selIndex == 0)
        {
                var colInfo = dg.originalColInfo;
                var colInfoLen = colInfo.length;
                for(var i=0;i<colInfoLen;++i)
                {
                  if(colInfo[i][1] == curDisplay)
                  {
                    curDisplay = getNewName(curDisplay);
                    i = 0;
                  }
                }
        }
        setUniqueColumnName(colObj, curDisplay) ;///colObj.setValue(opt.value);
        importReset(colObj);
        setForExistColumn(colObj, (selIndex == 0));
    }
  }

  function setUniqueColumnName(colObj, curName)
  {
         while(!colObj.setValue(curName))
         {
            curName = getNewName(curName);
         }
  }


  function setForExistColumn(colObj, isEnable)
  {
    var dataTypeList = colObj.dataType;
    if(isEnable == true)
    {
        setEnableListItem(false, dataTypeList, "defaultvaltype", "REFCOL", optionNotSupported);
        setEnableListItem(false, dataTypeList, "defaultvaltype", "RELCOL", optionNotSupported);//No I18N
        setEnableListItem(false, dataTypeList, "defaultvaltype", "AUTO_NUMBER", optionNotSupported);
        dataTypeList.removeAttribute("disabled");
        dataTypeList.selectedIndex = getDataIndex(dataTypeList, "defaultvaltype", colObj.defaultType);
        colObj.isEditable = true;
    }
    else
    {
        setEnableListItem(true, dataTypeList, "defaultvaltype", "REFCOL");
        var colDataType = colObj.colList[colObj.previousIndex].getAttribute("dataType");
        if(colDataType.toLowerCase() == "boolean")
        {
            colDataType = "YES/NO DECISION"; //PK: Release hack
        }else if(colDataType == "GEO" || colDataType == "GEO_NUM") //NO I18N
    	{
        	colDataType =  colObj.defaultType;
    	}
        if(colDataType == "DATE_AS_DATE")
        {
            colDataType = "DATE"; //No I18N
        }
        var index = getDataIndex(dataTypeList, "defaultvaltype", colDataType);
        dataTypeList.selectedIndex = index;
        dataTypeList.setAttribute("disabled", "true");
        colObj.isEditable = false;

    }
  }


  function setDisableFlag(dg, listIndex, isOn)
  {
    var colHeads = dg.colHeaders;
    var len = colHeads.length;

    for(var i=0;i<len;++i)
    {
        if(colHeads[i].objType != ZDBConst.COLHEAD)
        {
          continue;
        }
        var list = colHeads[i].colList;
        list[listIndex].setAttribute("zdbDisabled", (isOn ? "true" : "false"));
        if(isOn)
        {
            list[listIndex].setAttribute("disabled","true");
        }
        else
        {
            list[listIndex].removeAttribute("disabled");
        }
    }
  }



  function setIgnoreImportCheckBox(dg)
  {
    var colHeads = dg.colHeaders;
    var colLen = colHeads.length;
    var check = document.getElementById("importCheck").cloneNode(true);
    check.removeAttribute("id");

    for(var i=0;i<colLen;++i)
    {
        var curCol = colHeads[i];
        if(curCol.objType != ZDBConst.COLHEAD)
        {
          continue;
        }
        curCol.isEditable = true;
        curCol["importReset"] = importReset;
        curCol["importNode"] = check.cloneNode(true);
        curCol["importNode"].colObj = curCol;
        curCol["importNode"].setAttribute("checked","true");
        importReset(curCol,dg);
        curCol.cellEl.style.textAlign = "left";
    }

  }
  function setCheck(elObj, event)
  {
    var colObj = elObj.colObj;
    if(elObj.getAttribute("checked") == "true")
    {
        elObj.className = "unchecked";
        elObj.setAttribute("checked","false");
        if(colObj.colList)
        {
            setDisableFlag(colObj.parGrid, colObj.previousIndex, false);
            colObj.colList.selectedIndex = 0; //for New
            onColListChange(colObj.colList, event);
                colObj.colList.setAttribute("disabled","true");
        }
        colObj.isEditable = false;
        colObj.dataType.setAttribute("disabled","true");
    }
    else
    {
        elObj.className = "colHeadChecked";
        elObj.setAttribute("checked","true");
        if(colObj.colList)
        {
         onColListChange(colObj.colList, event);
         colObj.colList.removeAttribute("disabled");

         var idx = getIndex(colObj.parGrid.colHeaders, colObj);
         var curName = colObj.displayName;
         while(idx >= 0)
         {
            curName = getNewName(curName);
            if(!colObj.setValue(curName))
            {
                continue;
            }
            idx = getIndex(colObj.parGrid.colHeaders, colObj);
         }
        importReset(colObj);

        }
        colObj.isEditable = true;
        colObj.dataType.removeAttribute("disabled");
    }

    ZDBUtil.clearTextSelection(event);
    return false;
  }


  function importReset(colObj, gridObj)
  {
    var hiddenColList = (gridObj != null && gridObj.hiddenColList != null) ? gridObj.hiddenColList: [];
    if(colObj && colObj.displayNode && colObj.displayNode.firstChild)
    {
        if(colObj.colList)
        {
          colObj.colList.options[0].value = colObj.displayName;
        }

        var colEl = colObj.cellEl;
        var chk = colObj.importNode;
        for(var j = 0; j < hiddenColList.length; j++)
        {
            if(hiddenColList[j] == colObj.displayName)
            {
                colObj.importNode.className = "unchecked";
                colObj.importNode.setAttribute("checked","false");
            }
        }
        colObj.checkNode.style.display = "block";
        colObj.checkNode.appendChild(colObj.importNode);
    }
  }


  function resetColIndex(colObj)
  {
    var list = colObj.colList;
    if(list)
    {
        var index = getDataIndex(list, "value", colObj.displayName, true);
        if(index < 0)
        {
            index = 0;
        }
        list.selectedIndex = index;
        onColListChange(list);
    }
  }


  function  setColumnListEditor(dg)
  {
    var colListRow = ZDBDataGrid.getFirstRowObj(dg.rowData, false);
    var sel = document.createElement("select");
    sel.style.width = "99%";
    sel.style.height = "19px";
    sel.className = "normalFont12";
    var opt = document.createElement("option");
    var colInfo = dg.originalColInfo;
    var colInfoLen = colInfo.length;
    var colHeaders = dg.colHeaders;
    for(var i=-1;i<colInfoLen;++i)
    {
        var newOpt = opt.cloneNode(false);
        var value, disValue, dataType;
        if(i==-1)
        {
            disValue = ZDBI18NMap.g("zrpt.table.existimport.step2.js.selColNewCol");
            value = "(New)";
            dataType = "PLAIN TEXT";
        }
        else
        {
            disValue = colInfo[i][1];
            dataType = colInfo[i][3];
            value = disValue;
        }
        newOpt.setAttribute("value",value);
        newOpt.setAttribute("dataType", dataType);
	newOpt.innerHTML = ZDBEscapeUtil.encodeForHtml(disValue);
        sel.appendChild(newOpt);
    }

      var len = colHeaders.length;
      for(var i=0;i<len;++i)
      {
        var dObj = colListRow.values[i];
        var colObj = dObj.colObj;
        if(colObj.objType != ZDBConst.COLHEAD)
        {
          continue;
        }
        var dCell = dObj.cellEl;

        var list = sel.cloneNode(true);
        colObj.previousIndex = 0;
        list.onchange = function (event){onColListChange(this, event)};
        list.cellObj = dObj;
        list[0].setAttribute("value", colObj.displayName);
        colObj.colList = list;

        /*CSS class*/
        list.style.display = "block";
        dCell.innerHTML = "";
        dCell.appendChild(list);
      }
  }


function removeListItem(list, attributeName, value)
{
    /// No error checking!

    var listOptions = list.options;
    var listLen = listOptions.length;
    for(var i=listLen-1; i > -1; --i)
    {
        var curOption = listOptions[i];
        if(curOption.getAttribute(attributeName).toUpperCase() == value.toUpperCase())
        {
            curOption.parentNode.removeChild(curOption);
        }
    }
}

function optionNotSupported(event)
{
        /// ZDBAlertAPI.showMsg("This TYPE can not be taken for a new column");
        var option = window.event ? window.event.srcElement : event.target;
        var list = option.parentNode;
        var dObj = list.cellObj;
        var colObj = dObj.colObj;
        list.selectedIndex = dObj.colObj.previousIndex;
        return false;
}

function setEnableListItem(enable, list, attributeName, value, onclickFn)
{
    var options = list.options;
    var optLength = options.length;
    for(var i=0;i<optLength;++i)
    {
        var curOption = options[i];
        if(curOption.getAttribute(attributeName).toUpperCase() == value.toUpperCase())
        {
            curOption.setAttribute("zdbDisabled", (enable ? "false" : "true"));
            if(enable)
            {
                curOption.removeAttribute("disabled");

            }
            else
            {
                curOption.setAttribute("disabled","true");
            }
        }
     }
}
function showprevform()
{
    var wid = jQuery(document.body).width();
    jQuery("#ZDBImportFileWithRelation").animate({left:wid}).hide();//No I18N
    document.body.removeChild($("IMPORTFREEZE"));
    ev.escKeyPressStack.pop();
    ZDBToolTip.hide();
}


function setDatatypeEditor(dg, forNewImport)
  {
    var rowData = dg.rowData;
    var dataIndex = ZDBDataGrid.getFirstRowIndex(rowData, false);
    var dataTypeRow;
    if(forNewImport)
    {
        dataTypeRow = rowData[dataIndex];
    }
    else
    {
        setColumnListEditor(dg);
        dataTypeRow = dg.rowData[dataIndex+1]; ///assumption second row exists and it is data types
    }


    var len = dataTypeRow.values.length;
    var dataTypeList = document.getElementById('IMPORT_DATATYPE');
    dataTypeList = dataTypeList.cloneNode(true);
    dataTypeList.removeAttribute("id");

    if(forNewImport)
    {
          removeListItem(dataTypeList,"defaultvaltype","REFCOL");
          removeListItem(dataTypeList,"defaultvaltype","RELCOL");//NO I18N
    }


    var dObj, dCell;
    for(var i=0;i<len;++i)
    {
      dObj = dataTypeRow.values[i];
      if(dObj.colObj.objType != ZDBConst.COLHEAD)
      {
        continue;
      }
      var dCell;
      dCell = dObj.cellEl;

      var list = dataTypeList.cloneNode(true);
      list.onchange = ZDBImport.onDataTypeChange;
      /*CSS class*/
      list.style.width = "100%";
      list.style.display = "block";
      dCell.innerHTML = "";
      dCell.appendChild(list);
      dObj.colObj.dataType = list;
      dObj.colObj.colInfo ={};
      list.cellObj = dObj;
     if(dObj.originalValue == ZDBConst.GEO || dObj.originalValue== ZDBConst.GEO_NUM )
     {
       var colInf = dObj.colInfo;
     }
      var selIndex  = getDataIndex(list, "defaultvaltype", dObj.displayValue);
      if(selIndex < 0)
      {
        selIndex  = getDataIndex(list, "display", dObj.displayValue);  /// Too many hells - have fun!
        if(selIndex < 0)
        {
         selIndex = 0;
        }
      }
      list[selIndex].selected = true;
      dObj.colObj.defaultType = list[selIndex].getAttribute("defaultvaltype");
    }
  }



function setDefaultCSVConfig(delimiter, encapsulator, commentChar, isHeaderPresent, dateObj,thousandSep,decimalSep,fileName)
{
  /*
    Warning: delimiter, encapsulator, isHeaderPresent and dateFormat values depends on the server
    and must be handled as defined
  */
  if(dateObj.isValidDateFormat == "false")
  {
    var msg = ZDBI18NMap.g("zrpt.common.import.custommsg.js.dateFmtHlp");
    showCustomMessage(msg, $("DATEFORMAT"));
    ZDBImport.canProceed = false;
    return;
  }
  ZDBImport.canProceed = true;
  var delimiters = ',\t; |';
  var encapsulators = '\'"';
  var thousandSeparator = ',. \'';
  var decimalSeparator = '.,';

  var delimIndex = delimiters.indexOf(delimiter);
  delimIndex = (delimIndex < 0) ? 0 : delimIndex;
  var encapIndex = encapsulator ? (encapsulators.indexOf(encapsulator)+1) : 0; ///Assumption: fixed encap
  var headerIndex = (isHeaderPresent == 'true') ? 0 : 1;
  var thousandSepIndex = thousandSep ? (thousandSeparator.indexOf(thousandSep)+1) : 0;
  var decimalSepIndex = decimalSeparator.indexOf(decimalSep);

  var delimiterObj = document.getElementById("DELIMITER"); /// method to set Value?
  ZDBImport.curForm = delimiterObj.form;
  var encapsulatorObj = document.getElementById("QUOTED");
  var commentObj = document.getElementById("COMMENTCHAR");
  var headerObj = document.getElementById("FIRSTROWISFIELDS");
  var thousandSepObj = document.getElementById("THOUSANDSEP");
  var decimalSepObj = document.getElementById("DECIMALSEP");
  var fileNameObj = document.getElementById("FILENAME");

  if(commentChar == '#') // I think I got a problem here. UTF-8?
  {
    commentObj.value = commentChar;
    commentObj.previousValue = commentChar;
  }
  if(fileName != null && fileName !='')
  {
     fileNameObj.value = fileName;
  }
  delimiterObj.selectedIndex = delimIndex;
  encapsulatorObj.selectedIndex = encapIndex;
  headerObj.selectedIndex = headerIndex;
  thousandSepObj.selectedIndex = thousandSepIndex;
  decimalSepObj.selectedIndex = decimalSepIndex;
  var importFromDB = $("ImportLocalDatabaseForm");
  if(!importFromDB)
  {
  setImportDate(dateObj);
}
}

function setImportDate(dateObj)
{
  var dateEl = document.getElementById("DATEFORMAT");
  /*
  var dateIndex = getDataIndex(dateObj, "value", dateFormat, false);
  dateObj.selectedIndex = dateIndex < 0 ? 0 : dateIndex;
  */

  dateEl.value = (dateObj.dateFormat) ? dateObj.dateFormat : ""; //PK: handle it in the server
  if(dateObj.isMultiDate == 'true')
  {
    var msg = ZDBI18NMap.g('zrpt.common.import.custommsg.js.dtFmtConfirm');
    showCustomMessage(msg, ZDBUtil.getParentWithTagName(dateEl,"DIV"));
  }
  if(dateEl.value)
  {
   ZDBImport.setOnDateDiv(ZDBImport.getSampleDate(dateEl.value), dateObj.dateFormat);
  }
  else
  {
   ZDBImport.setOnDateDiv(ZDBI18NMap.g('zrpt.common.import.step2.js.noDtCol'), "NODATE");
  }

}

function enableOption(elem,forWhat) //Changing this idea
{
   var opt = elem.value;
   var prefix = "";
   if(forWhat == "existImport")
  {
    prefix = "EX";
  }
   toggleClientInfoDiv(0);//this is to hide all for oncloud version.
   if(ZDBGlobal.IS_ONPREMISE_BUILD)
   {
	   if(opt == "GSHEET")
	   {
		   toggleClientInfoDiv(1);
	   }
	   else if(opt == "BOX")
	   {
		   toggleClientInfoDiv(2);
	   }
	   else if (opt == "ONEDRIVE")
	   {
		   toggleClientInfoDiv(3);
	   }
	   else if(opt == "DROPBOX")
	   {
	        toggleClientInfoDiv(4);
	   }
   }


   if(opt == "GSHEET"|| opt =="ZDOCS" || ZDBImport.isExternalFile(opt))
   {
        locationSelected(opt,forWhat);
   }
   else if(opt == "ODATA")
   {
       if(prefix != "EX")
       {
       $("ZDB"+prefix+"PASTEOPT").disabled = true;
        $("ZDB"+prefix+"FILEOPT").disabled = true;
        if($("ZDB"+prefix+"FTPOPT"))
        {
            $("ZDB"+prefix+"FTPOPT").disabled = true;
        }
        $("ZDB"+prefix+"WEBOPT").disabled = false;
       locationSelected("WEB",forWhat); //No I18N
       $(prefix +"IMPNOTEDESC").innerHTML="";
       changeImportNote(forWhat);
       //$("ADDPARAMLINK").style.display="none";
    }
   }
   else
   {
        $("ZDB"+prefix+"PASTEOPT").disabled = false;
        $("ZDB"+prefix+"FILEOPT").disabled = false;
        $("ZDB"+prefix+"WEBOPT").disabled = false;
        if($("ZDB"+prefix+"FTPOPT")!=null){
        	$("ZDB"+prefix+"FTPOPT").disabled = false;
        }
        if($("ZDB"+prefix+"PASTEOPT").checked)
        {
            locationSelected("PASTEDATA",forWhat); //No I18N
        }
        if($("ZDB"+prefix+"FILEOPT").checked)
        {
            locationSelected("LOCALDRIVE",forWhat); //No I18N
        }
        if($("ZDB"+prefix+"WEBOPT").checked)
        {
            locationSelected("WEB",forWhat); //No I18N
        }
        if($("ZDB"+prefix+"FTPOPT")!=null){
        	if($("ZDB"+prefix+"FTPOPT").checked)
        	{
        		locationSelected("FTP",forWhat); //No I18N
        	}
        }
        changeImportNote(forWhat);
    }
   window.divData["fileType"] = opt;

    if(!(opt=="ZDOCS" || ZDBImport.isExternalFile(opt)))
    {
        importStepValUpdate(forWhat);
        changeTitle();
    }
}
//below method is for onpremise gadget integ.
function toggleClientInfoDiv(divNo)
	{
		jQuery("#"+divNo+"_cp_clinfo").show();
		for (i = 1; i < 5; i++) {
			if( i != divNo)
			{
				jQuery("#"+i+"_cp_clinfo").hide();
			}
		}
	}

function changeImportNote(forWhat)
{
  var prefix = "";
  if(forWhat == "existImport")
  {
    prefix = "EX";
  }
  var helpId="";
  var isFTP = false;
  var helpUrl="";
  var opts = ["PASTEOPT","WEBOPT","FILEOPT","FTPOPT"]; //NO I18N
  for(var i =0; i < opts.length;i++)
  {
	if($("ZDB"+ prefix + opts[i])!=null){
		if($("ZDB"+ prefix + opts[i]).checked){helpId = opts[i];helpUrl =opts[i];break;}
	}
  }
  if(helpId == "FTPOPT"){
	  isFTP = true;
  }
  if(($("ZDBAUTHURL")!=undefined && $("ZDBAUTHURL").className=="inputSelected") || (helpId == "WEBOPT"))//No I18N
  {
    helpId +="_" +"AUTH_DESC";//No I18N
  }
  helpId +="_" + $("ZDB"+ prefix +"FILETYPE").value;
  helpUrl += "_" + $("ZDB"+ prefix +"FILETYPE").value + "_LINK";//No I18N
  var parentdiv = ZDBUtil.getParentWithTagName($("ZDB"+prefix+"InputURL"),"div")//No I18N
  if(parentdiv!=null && $(helpUrl)!=null)
  {
    $("SAMPLEURLLINK").innerHTML=$(helpUrl).innerHTML;
  }
  if($("ZDB"+ prefix +"FILETYPE").value!="ZDOCS" && !(ZDBImport.isExternalFile($("ZDB"+ prefix +"FILETYPE").value)) && $(helpId) != null)
  {
    if(!helpId.indexOf("PASTEOPT"))
      {
        if(helpId=="PASTEOPT_HTML")
        {
          $(prefix +"IMPNOTEDESC2").innerHTML =ZDBI18NMap.g("zrpt.home.import.step1.htmlpaste.js.html.note");
        }
        else
        {
          $(prefix +"IMPNOTEDESC2").innerHTML = "";
        }
      }
    $(prefix +"IMPNOTEDESC").innerHTML = $(helpId).innerHTML;
    if(parentdiv!=null)
    {
      $("SAMPLEURLLINK").setAttribute("CURPREFIX",prefix);
    }
  }
  if(isFTP){
	  changeFTPFilePathHelp($("ZDB"+ prefix +"FILETYPE").value);
  }
}
function fillURL(el)
{
    var prefix = $("SAMPLEURLLINK").getAttribute("CURPREFIX");
     $("ZDB"+prefix+"InputURL").setAttribute("tipShown","false");
     $("ZDB"+prefix+"InputURL").style.color="black"; //No I18N
     $("ZDB"+prefix+"InputURL").style.fontStyle="normal";//No I18N
     $("ZDB"+prefix+"InputURL").style.fontSize="12px";     //No I18N
     $("ZDB"+prefix+"InputURL").value = el.getAttribute("href");
     jQuery("ZDB"+prefix+"InputURL").focus();//No I18N
}
function showAUTHURLInp(show,forWhat)
{
    hideCustomMessage();
    $("ZDBAUTHURLINP").style.display=show? "block":"none";
    $("ZDBAUTHURL").className=show?"inputSelected":"inputDeselected";
    $("ZDBUNAUTHURL").className=show?"inputDeselected":"inputSelected";
    changeImportNote(forWhat);
    if(!show)
    {
        $("ZDBUSERNAME").value="";
        $("ZDBPASSWORD").value="";
    }
}

function showODataAUTHURLInp(show)
{
    hideCustomMessage();
    $("ZDBODATAAUTHURLINP").style.display=show? "block":"none";
    $("ZDBODATAAUTHURL").className=show?"inputSelected":"inputDeselected";
    $("ZDBODATAUNAUTHURL").className=show?"inputDeselected":"inputSelected";
    if(!show)
    {
        $("ODATA_USERNAME").value="";
        $("ODATA_PASSWORD").value="";
    }
}

function submitHtmlForm(frm,forWhat)
{
    var fileType = $("ZDBIMPFILETYPE").value;
    var isFromGDrive = "false";
    var gDrive_Format = fileType;
    var fileSubType;
    if($("ZDBFILESUBTYPE"))
    {
        fileSubType=$("ZDBFILESUBTYPE").value;
    }
    if($("ZDBACTION").value == "CREATETABLEFROMGDRIVE")
    {
        $("ZDBACTION").value = "CREATETABLE";// No I18N
    }
    if(fileType == "GSHEET")
    {
        isFromGDrive = $("ISFROMGDRIVE").value;
        gDrive_Format = $("ZDBGDRIVEFORMAT").value;
    }
    var ret = false;
    if(fileType == "HTML"  || ((fileType=="ZDOCS" || ZDBImport.isExternalFile(fileType)) && fileSubType=="HTML") || (isFromGDrive == "true" && (gDrive_Format.toUpperCase()=="HTM" || gDrive_Format.toUpperCase()=="HTML") ))
    {
        ret = ZDBImport.getSelectTables();
    }
    else if(fileType == "XLS"  || ((fileType=="ZDOCS" || ZDBImport.isExternalFile(fileType)) && (fileSubType=="XLS" || fileSubType=="XLSX")) || (fileType == "GSHEET") || fileType == "XLSX")
    {
        ret = ZDBXLSImport.getSelectSheet();
        $("IMPORTHIDDENROWS").value = $("ZDBHiddenRows").checked;
        $("IMPORTHIDDENCOLS").value = $("ZDBHiddenCols").checked;
        var tblNo=0;
        var i=0;
          while($("ZDBWorkSheet_"+i))
          {
             if($("ZDBWorkSheet_"+i).checked)
             {
                  tblNo++;
             }
             i++;
             
          }
        if(tblNo>1)
        {
            $('ZDBCREATEDBOPTSTATUS').className = 'mcLoading';
            handleMultiSheetImport();
            if($("LOCATION").value == "LOCALDRIVE")
            {
            window.totStep = 3;
            }
            else
            {
                window.totStep=4;
            }
            window.curStep = window.curStep +1;
            changeTitle();
            return;
        }
    }
    else
    {
        alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.unKnownFile"));
    }
    if(ret)
    {
        AjaxAPI.submit(frm);
        return false;
    }
    else
    {
        return false;
    }
}

function handleMultiSheetImport()
{
    if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/clouddbjs/CloudDBPage.js","APPENDTODOC",handleMultiSheetImport,[]))
    {
    return;
    }
  //var par = window.impFrm.parentNode;
  loadSelectedMultipleTblNames();
  //var multisheetdiv = $("ZRMultiSheetImport");
  //window.impFrm.parentNode.removeChild(window.impFrm); 
  //par.appendChild(multisheetdiv);
$("ENCDIV").style.display = "none";
$('ZDBCREATEDBOPTSTATUS').className = 'mcLoaded';
if($("LOCATION").value == "LOCALDRIVE" || $("FIRSTROWISFIELDS").value!="true")
{
        ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'showAlert(this.form)', 'onclick');
        $("ZRRDBCreateBtn").style.display ="";
        $("ZRCloudDBNextBtn").style.display ="none";
        ZDBUtil.setAttribute($("ZRRDBCreateBtn"), 'createMultiTable(this.form)', 'onclick');
var frm = $("ZDBHTMLTableFrm")
         frm.repeatinterval.options[0].selected = "true";
        CloudDBPage.toggleSchedulePeriod("none", frm); //No I18N
}
  $("ZRMultiSheetImport").style.display="block";


}
function gotoImpSettings(frm)
{
        $("ZRSettings").style.display = "";
        $("SchSettings").style.display = "none";
        ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'showSyncSettings(this.form)', 'onclick');
        $("ZRRDBCreateBtn").style.display ="none";
        $("ZRCloudDBNextBtn").style.display ="";
        ZDBUtil.setAttribute($("ZRCloudDBPrevBtn"), 'gotoTableSelection(this.form)', 'onclick');
        window.curStep = window.curStep -1;
        changeTitle();
}
function gotoTableSelection(frm)
{
  $("ENCDIV").style.display = "";
  window.curStep = window.curStep -1;
  window.totStep = 3;
  changeTitle();
  $("ZRMultiSheetImport").style.display="none";
}

function validatemultipletablenames()
    {
        var reportsTableArray = ZDBUtil.getAttribute($("MultipleTblList"), "reportsTableArray").split(',');
        for (i = 0; i < reportsTableArray.length; i++)
        {
            var str = reportsTableArray[i];
            str = str.trim();
            if (!((str.length != 0) && (str.length <= 100)))
            {
                showCustomMessage(ZDBI18NMap.f("zrpt.newtable.import.tblname.js.errmsg", 100), $(reportsTableArray[i]));
                CloudDBPage.editRepTblName($(reportsTableArray[i]));
                return false;
            }
        }
        for (i = 0; i < reportsTableArray.length; i++)
        {
            var str = reportsTableArray[i];
            str = str.trim();
            var existingtablnames = $("ZDBTABLENAMELIST").getAttribute("tablenames").split('\,');
            if (existingtablnames.indexOf(str)!=-1)
            {
                showCustomMessage(ZDBI18NMap.f("zrpt.newtable.import.js.dbobject_name_duplicated","Table",str), $(reportsTableArray[i]));
                CloudDBPage.editRepTblName($(reportsTableArray[i]));
                return false;
            }
        }
        for (i = 0; i < reportsTableArray.length; i++)
        {
            for (j = i + 1; j < reportsTableArray.length; j++)
            {
                if (reportsTableArray[i] === reportsTableArray[j])
                {
                    showCustomMessage(ZDBI18NMap.g("zrpt.databasedata.multipletable.js.validate"), $(reportsTableArray[i]));
                    CloudDBPage.editRepTblName($(reportsTableArray[i]));
                    return false;
                }
            }
        }
        return true;
    }
function showSyncSettings(frm)
{
    hideCustomMessage();
    if(!validatemultipletablenames())
    {return;}
    $('ZDBCREATEDBOPTSTATUS').className = 'mcLoading';
    
        $("ZRSettings").style.display = "none";
        $("SchSettings").style.display = "";
        
        CloudDBPage.toggleSchedulePeriod($("repeatinterval").value,frm)

        ZDBUtil.setAttribute($("ZRCloudDBNextBtn"), 'showAlert(this.form)', 'onclick');
        $("ZRRDBCreateBtn").style.display ="";
        $("ZRCloudDBNextBtn").style.display ="none";
        ZDBUtil.setAttribute($("ZRRDBCreateBtn"), 'createMultiTable(this.form)', 'onclick');
        ZDBUtil.setAttribute($("ZRCloudDBPrevBtn"), 'gotoImpSettings(this.form)', 'onclick');

        var impOptionSelect = $("ZDBSCHIMPORTTYPE");
        impOptionSelect.style.display= "";
        jQuery(impOptionSelect).empty();
        var permLevel = "1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$" //DB owners have all permissions
        var perms = permLevel.split("$");
        impOptionSelect = ZDBImport.setImportOption(impOptionSelect, perms);
        $("ZDBSCHIMPORTTYPE").options[1].selected = "true";
        if($("ZDBSCHIMPORTTYPE").options[2])
            {
                $("ZDBSCHIMPORTTYPE").options[2].disabled = true;
            }
            if($("ZDBSCHIMPORTTYPE").options[3])
            {
                $("ZDBSCHIMPORTTYPE").options[3].disabled = true;
            }
        window.curStep = window.curStep +1;
	changeTitle();
                    $('ZDBCREATEDBOPTSTATUS').className = 'mcLoaded';
}
function handleMultiTableResponse(response,requestOptions)
    {
        var params={};
        params = JSON.parse(response.responseText);
        var str;
        if(params['OBJID'])
        {
            str = ZDBI18NMap.g('zrpt.common.js.table');
        }
        else
        {
            str = ZDBI18NMap.g('zrpt.common.js.database');
        }
    ZDBDialogUtil.closeDialog();
             if(ZDBClientUI.selectedTab == null)
             {
                var url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" +params['DBID'];//No I18N
                window.location.href = url;
             }
             else if(!params['OBJID'])
             {
                var tab = ZDBClientUI.selectedTab;
                ZDBNavigation.refreshExplorer();
                ZDBClientUI.removeTab(tab);
                ZDBClientUI.selectTab(ZDBNavigation.explorerTab);
               
             }
       
    };
function showAlert(response,requestOptions)
    {
        var params={};
        params = JSON.parse(response.responseText);
        $("SchSettings").style.display = "none";
        $("ZRSettings").style.display = "none";
        $("ZRCloudDBNextBtn").style.display="none";
        $("ZRRDBCreateBtn").style.display ="none";
        $("ZRCloudDBPrevBtn").style.display="none";
        $('ZRCloudDBCmpltOk').style.display = "";
	$('ZRCloudDBCancelBtn').style.display = "none";
        var msg = ZDBI18NMap.g("zrpt.databasedata.import.js.multisheet.complete");
        var msgnode = $('ZRCloudDBSetupCompMsg').cloneNode(true);
        msgnode.innerHTML = msg;
        msgnode.style.display='inline-block';
        jQuery("#ShowCloudDBCmplt").empty();  //No I18N
        $('ZRCloudDBCmpltOk').setAttribute("DBID",params['DBID']);
        $("ShowCloudDBCmplt").style.display= "";
        $("ShowCloudDBCmplt").appendChild(msgnode);
        if($("zdbImportTableTitle"))
	{
		$("zdbImportTableTitle").innerHTML = ZDBI18NMap.g('zrpt.home.import.step1.js.multitable.success.title');
                $("zdbImportTableDesc").innerHTML = "";
	}
	else if ($("zdbImportDBTitle"))
	{
		$("zdbImportDBTitle").innerHTML = ZDBI18NMap.g('zrpt.home.import.step1.js.multitable.success.title');
                $("zdbImportDBDesc").innerHTML = "";
	}
       }
function createMultiTable(frm)
{   
        hideCustomMessage();
    if(!validatemultipletablenames())
         {return;}
    frm.action = frm.action.replace("ZDBImportData.cc","ZDBImportData.ve");
    frm.setAttribute("actionurl",frm.getAttribute("actionurl").replace("ZDBImportData.cc","ZDBImportData.ve"));
    $("ZDBACTION").value="CREATEMULTITABLE";//No I18N
    frm.setAttribute("onsuccessfunc","showAlert");
    $("MultipleTblList").value = ZDBUtil.getAttribute($("MultipleTblList"), "reportstablearray");//No I18N
    var schedulerName = CloudDBPage.getSchedulerName(frm);
    var schFailWarnCount = $("sch_failure_count").value;  
    var repeatType = $("repeatinterval")[$("repeatinterval").selectedIndex].value;
    var list = repeatType == "daily" ? "ZDB_DLY_TIMEZONE_SEARCH" : repeatType == "weekly" ? "ZDB_WLY_TIMEZONE_SEARCH" : "ZDB_MLY_TIMEZONE_SEARCH";//No I18N
    $("SCHEDULERNAME").value=schedulerName;  //No I18N
    $("SCHEDULETIMEZONE").value = encodeURIComponent($(list + "_ZRTimezoneList").getAttribute("selectedTimeZone"));//No I18N
    $("ZDBSCHFAILWARNCOUNT").value = schFailWarnCount;   //No I18N
    $("QUOTED").value = 2;
    frm.setAttribute("opstatusid","ZDBCREATETABLEOPTSTATUS");
    AjaxAPI.submit(frm); 
}
function loadSelectedMultipleTblNames()
    {
        var selectedTablesArray = [];
	var reportsTableArray = [];
        var selectedSchemaArray = [];
        var i=0;
        var tblNo=0;
          while($("ZDBWorkSheet_"+i))
          {
             if($("ZDBWorkSheet_"+i).checked)
             {
                reportsTableArray[tblNo]=$("ZDBWorkSheet_"+i).parentNode.children[1].innerHTML.replace('&nbsp;','');
                selectedTablesArray[tblNo]=$("ZDBWorkSheet_"+i).parentNode.children[1].innerHTML.replace('&nbsp;','');
                selectedSchemaArray[tblNo]=$("ZDBWorkSheet_"+i).parentNode.children[1].innerHTML.replace('&nbsp;','');
                tblNo++;
             }
                i++;
            }
        //var selectedTablesArrayStr =jQuery("#ZDBSHEETLIST");
        //selectedTablesArray = jQuery("#ZDBSHEETLIST");
	//var selectedSchemaArray =  jQuery("#ZDBSHEETLIST");//ZDBUtil.getAttribute($("MultipleTblList"), "selectedSchemaArray").split(',');
        var selectedTbls = $("SelectedTblsFinal");
        var reportstbls = $("ReportsTables");
        jQuery(reportstbls).empty();
        jQuery(selectedTbls).empty();
        for (i = 0; i < selectedTablesArray.length; i++)
        {
            var tblDiv = document.createElement("span");
            ZDBUtil.setAttribute(tblDiv,selectedTablesArray[i]+"_tbl","id");
            //tblDiv.innerHTML = (selectedSchemaArray[i] && selectedSchemaArray[i]!='null')?(selectedSchemaArray[i]+'.'+selectedTablesArray[i]):selectedTablesArray[i]; //No I18N
tblDiv.innerHTML = selectedTablesArray[i];
	    //reportsTableArray.push(tblDiv.innerHTML);	
            tblDiv.className = "zrdbSelectedTblFinal";
            tblDiv.style.display = "block";
            selectedTbls.appendChild(tblDiv);
            var reportstblDiv = document.createElement("div");
            var reportstblnameDiv = document.createElement("span");
            //reportstblnameDiv.innerHTML = ZDBEscapeUtil.encodeForHtml((selectedSchemaArray[i] && selectedSchemaArray[i]!='null')?(selectedSchemaArray[i]+'.'+selectedTablesArray[i]):selectedTablesArray[i]); //No I18N
            reportstblnameDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(selectedTablesArray[i]);
            ZDBUtil.setAttribute(reportstblDiv,"CloudDBPage.editRepTblName(this,event)","onclick");
            reportstblDiv.appendChild(reportstblnameDiv);
            reportstblDiv.className = "zrdbSelectedTbl";
            reportstblDiv.style.display = "block";
            ZDBUtil.setAttribute(reportstblDiv,selectedTablesArray[i],"orgTbl");
            ZDBUtil.setAttribute(reportstblDiv,selectedTablesArray[i],"id");
            ZDBUtil.setAttribute(reportstblDiv,"CloudDBPage.highLytPar(this)","onmouseover");
            ZDBUtil.setAttribute(reportstblDiv,"CloudDBPage.dehighLytPar(this)","onmouseout");
            reportstblDiv.style.paddingLeft="0px";//No I18N
            var reportstbleditDiv = document.createElement("div");
            reportstbleditDiv.className = "zrdbEditRepTbl";
            reportstblDiv.appendChild(reportstbleditDiv);
            reportstbls.appendChild(reportstblDiv);
        }
        
        reportsTableArray = selectedTablesArray.slice();
        ZDBUtil.setAttribute($("MultipleTblList"), reportsTableArray.toString(), "reportsTableArray");
    }

function changeTitle()
{
	if($("zdbImportTableTitle"))
	{
            if($("ZDBFILETYPE") && $("ZDBFILETYPE").value=="ODATA")
            {
                $("zdbImportTableTitle").innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.importodata',window.curStep);
            }
            else
            {
		$("zdbImportTableTitle").innerHTML = ZDBI18NMap.f('zrpt.newtable.import.js.importcsv',window.curStep,window.totStep);
	}
	}
	else if ($("zdbImportDBTitle"))
	{
            if($("ZDBFILETYPE") && $("ZDBFILETYPE").value=="ODATA")
            {
                $("zdbImportDBTitle").innerHTML = ZDBI18NMap.f('zrpt.home.import.step1.js.createdbodata',window.curStep);
            }
            else
            {
		$("zdbImportDBTitle").innerHTML = ZDBI18NMap.f('zrpt.home.import.step1.js.createdb',window.curStep,window.totStep);
	}
	}
	else if ($("zdbExImportTableTitle"))
	{
		$("zdbExImportTableTitle").innerHTML = ZDBI18NMap.f('zrpt.toolbar.import.js.sametable',window.curStep,window.totStep);
	}
}

function showHomeFrmExistImp()
{
	window.homeFrm.style.display ="none";
	$("ZDBEXCreateDBCntTd").appendChild(window.homeFrm);
	var importVia = window.divData["importVia"];
	var fileType = window.divData["fileType"];
	$("ZDBEXPASTEOPT").checked = (importVia == "PASTEDATA");
	$("ZDBEXFILEOPT").checked = (importVia == "LOCALDRIVE");
	if($("ZDBEXFTPOPT")){
		$("ZDBEXFTPOPT").checked = (importVia == "FTP");
	}
	$("ZDBEXWEBOPT").checked = (importVia == "WEB")||(importVia == "GSHEET")||(importVia=="ZDOCS")|| ZDBImport.isExternalFile(importVia); //No I18N
	window.impFrm.parentNode.removeChild(window.impFrm);
	window.homeFrm.style.display ="block";
	$("CHECKFORALERT").value = "true";
	window.impFrm = window.homeFrm;
	window.curStep = window.curStep -1;
	changeTitle();
}

function showPrevFrmExistImp()
{
  window.prevDBFrm.style.display ="none";
  $("ZDBEXCreateDBCntTd").appendChild(window.prevDBFrm);
  var importVia = window.divData["importVia"];
  var fileType = window.divData["fileType"];
  if (fileType == "CSV" || ((fileType == "XLS") && (importVia == "PASTEDATA" )))
  {
    $("ZDBEXFILETYPE").value = "CSV";    // No I18N
    $("ZDBEXPASTEOPT").checked = (importVia == "PASTEDATA");
    $("ZDBEXFILEOPT").checked = (importVia == "LOCALDRIVE");
    $("ZDBEXWEBOPT").checked = (importVia == "WEB");
    if($("ZDBEXFTPOPT")){
    	$("ZDBEXFTPOPT").checked = (importVia == "FTP");
    }
  }
  window.impFrm.parentNode.removeChild(window.impFrm);
  window.prevDBFrm.style.display ="block";
  $("CHECKFORALERT").value = "true";
  window.impFrm = window.prevDBFrm;
  window.curStep = window.curStep -1;
  changeTitle();
}

function tableSelected(tblNo)
{
  $("scraptbl_" + tblNo).checked = true;
}



function hideMsg()
{


}

function showMoreImportOptions()
{
	jQuery("#ZDBHOMEMOREIMPOPTS").slideToggle("slow", function()  // No I18N
	{
		var link = $("ZDBMOREIMPOPTSLINK");
		if(link.getAttribute("mode") == "more")  // No I18N
		{
			link.innerHTML = ZDBI18NMap.g("zrpt.common.import.custommsg.js.less_imp_opts");
			link.setAttribute("mode", "less");   // No I18N
		}
		else
		{
			link.innerHTML = ZDBI18NMap.g("zrpt.common.import.custommsg.js.more_imp_opts");
			link.setAttribute("mode", "more");  // No I18N
		}
	});  // No I18N

}

var ZDBCreateDB = new function()
{
  this.changeWindowURL = function(dbId,objId)
  {
    window.url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + dbId; ///PK:global fun! //No I18N
    if(objId != null)
    {
      url += "&OBJID=" +objId;
    }
    setTimeout( "window.location.href = window.url;", 0 ); // jshint ignore:line
  }
  this.handleDropDownClose =function()
    {
    var list = $("ZDBImportFileWithRelation").querySelectorAll("#FKCOLDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                      list[i].style.display = "none";
                        }
                    }
                    var list = $("ZDBImportFileWithRelation").querySelectorAll("#COLUMNLISTDROPDOWN");
                    for (i=0;i<list.length;i++)
                    {
                        if(list[i].style.display!="none")
                        {
                        list[i].style.display = "none";
                        }
                    }
    }
    this.count=0;
    this.blink = function()
{
  var dlg = jQuery(jQuery("#EnclosingDiv").find(".disableJoinIconNew")[0]).parents().find(".ENCDIV")[0];//No I18N
  if(ZDBCreateDB.count<4)
        {
            if((ZDBCreateDB.count%2)!=0)
            {

                dlg.style.border="1px solid #cccccc";
            }
            else
            {
                dlg.style.border="0px solid #cccccc";
            }
            ZDBCreateDB.count++;
            setTimeout(ZDBCreateDB.blink,60);
        }
        else
        {
            dlg.style.border="0px solid #cccccc";
        }
}
this.showRelDialog = function()
{
    ZDBImport.defineRelationship();
}
  this.gotoSheetView = function(dialog,flag)
  {
    ZDBClientUI.TBLLIST = null;    // To clear the cache for look up column list in edit design mode.
    var div = document.getElementById("TABLEID");
    //To clear the cache of look up column values in the child table
    if(div != null || div != undefined)
    {
      var tableId = div.innerHTML;
      AllowedValPopup.cache['T_'+tableId] = null;
    }
    var params = dialog.params["REQPARAMS"];
    if((params["IM_ABORTED"] == 'true') || (flag == "DONT_FETCH_SHEET"))
    {
      return true;
    }
    if(ZDBCreateDB.isInHomePage())
    {
      ZDBCreateDB.changeWindowURL(params["DBID"],params["IM_OBJID"]);
    }
    else
    {
      var objId = params["IM_OBJID"];
      var tab = window.ZDBClientUI.getExistingTab(objId);
      if(tab != null)
      {
        ZDBClientUI.fetchView(objId,params["DBID"],tab.view.displayName,"Table",tab);
      }
      else
      {
        tab = ZDBClientUI.selectedTab;
        ZDBClientUI.fetchView(params["IM_OBJID"], params["DBID"],
                              params["TABLENAME"],"Table",tab);
        ZDBNavigation.refreshExplorer();
      }
    }
    return true;
  }



  this.showConnections = function(response,requestOptions)
  {
  	 jQuery("#connections_list").html(response.responseText); //No I18N
  	 return false;
  }

  this.showDatabases = function(response,requestOptions)
  {
  	 jQuery("#db_list").html(response.responseText); //No I18N
  	 return false;
  }

  this.isInHomePage = function()
  {
    return (window.ZDBClientUI == null) || (window.ZDBClientUI.selectedTab == null);
  }

  this.showOptions = function(el)
  {
	  if(ZDBGlobal.IS_ONPREMISE_BUILD){
	      jQuery(el).find('.backupDBIcon').css('display','none');
	  }else{
		  jQuery(el).find('.backupDBIcon').css('display','inline-block'); //No I18N 
	  } 
	  jQuery(el).addClass('ZRSDBHighlight'); // No I18N
  }

  this.hideOptions = function(el)
  {
	  if(el.isDialogOpen){return;}
	  jQuery(el).removeClass('ZRSDBHighlight'); // No I18N
  }
  this.showprevformonEsc=function()
{

var wid = jQuery(document.body).width();
jQuery("#ZDBImportFileWithRelation").animate({left:wid}).hide(); //No I18N
if($("IMPORTFREEZE")!=null)
{
document.body.removeChild($("IMPORTFREEZE"));
}
ev.escKeyPressStack.pop();
ZDBToolTip.hide();




}

  this.removeHighlight = function(dlg)
  {
	  var el = dlg.bodyContent.parEl;
	  if(!el)
	  {
		  return true;
	  }
	  el.isDialogOpen = false;
	  ZDBCreateDB.hideOptions(el);
	  return true;
  }

  this.showDBInfo = function(el)
  {
	  jQuery(el).find('ul').show();
  }

  this.hideDBInfo = function(el)
  {
	  jQuery(el).find('ul').hide();
  }
  this.showExpDBInfo = function(el)
  {
	  jQuery(el).find('div').show();
  }
  this.hideExpDBInfo = function(el)
  {
	  jQuery(el).find('div').hide();
  }

}


function changePort(selectedProtocol){
	var port = jQuery('[name="FTPPORT"]'); //NO I18N
	var ports = {"ftp":21,"ftpes":21,"ftps":990,"sftp":22}; //No I18N
	port.val(ports[selectedProtocol]);
}

function changeFTPFilePathHelp(fileType){
	var helpEl = $("FTPPATHHELP");
	fileType = fileType.toLowerCase();
	var fileTypeHelpKeys = {
			"csv" : "zrpt.home.import.step1.filepathhelp.csv", //No I18N
			"xls" : "zrpt.home.import.step1.filepathhelp.xls", //No I18N
			"html" : "zrpt.home.import.step1.filepathhelp.html", //No I18N
			"json" : "zrpt.home.import.step1.filepathhelp.json", //No I18N
			"xml" : "zrpt.home.import.step1.filepathhelp.xml" //No I18N
	}
	var i18nKey = fileTypeHelpKeys[fileType]; //No I18N
	var tipEl = document.getElementById(i18nKey);
	var tip = (tipEl)?tipEl.getAttribute("value"):'';
	helpEl.setAttribute("tip",tip);
}

function protocolSelected(el){
	var selectedProtocol = (el instanceof jQuery)?(el.val()):((el)?el.options[el.selectedIndex].value:"ftp"); //NO I18N
	changePort(selectedProtocol);
	var toShow = jQuery('[name="AUTHTYPE"]');//NO I18N
	if(selectedProtocol=="sftp"){
		if(toShow){
			toShow.show();
			authTypeSelected("PASSWORD"); //NO I18N
		}
	}
	else{
		if(toShow){
			toShow.hide();
			authTypeSelected("PASSWORD"); //NO I18N
		}
	}
}

function authTypeSelected(authType){
	var passwordDiv = jQuery('[name="FTPPASSWORDDIV"]');//NO I18N
	var passwordEl = jQuery('[name="FTPPASSWORD"]');//NO I18N
	var saved = $("ZDBEXCreateFrm") || $("ZDBCreateFrm") ;
	if(authType=="PASSWORD"){
		passwordEl.prop("disabled",false); //NO I18N
		passwordDiv.show();
		changeFTPUserNote(saved,"PASSWORD"); //NO I18N
	}
	else{
		passwordDiv.hide();
		passwordEl.prop("disabled",true); //NO I18N
		changeFTPUserNote(saved,"KEY"); //NO I18N
	}
}

function resetSFTPAuthType(){
	selectedAuthType = null;
}

function changeFTPUserNote(saved,sftpAuthType){
	var noteEl = jQuery("#FTPUSERNAMENOTE"); //NO I18N
	if(sftpAuthType=="KEY"){
		if(saved){
			noteEl.html(ZDBI18NMap.g("zrpt.common.sftp.keyauth.js.alert"));
		}
		else{
			noteEl.html(ZDBI18NMap.g("zrpt.common.sftp.keyauth.js.schalert"));
		}
	}
	else{
		if(saved){
			noteEl.html(ZDBI18NMap.g("zrpt.common.url.js.alert"));
		}
		else{
			noteEl.html(ZDBI18NMap.g("zrpt.common.basicauth.js.schalert"));
		}
		noteEl.html();
	}
}

function getSelectedAuthType(){
	  var pwdEl = (jQuery('[name="SFTPAUTHTYPE"]').eq(0)) ? jQuery('[name="SFTPAUTHTYPE"]').eq(0) : null; //No I18N
	  var keyEl = (jQuery('[name="SFTPAUTHTYPE"]').eq(1)) ? jQuery('[name="SFTPAUTHTYPE"]').eq(1) : null; //No I18N
	  var selectedAuthType = ( (pwdEl)?(pwdEl.is(':checked')):false)?"KEY":"PASSWORD"; //NO I18N
	  return selectedAuthType;
}

function getFileOptsForImport(location,frm){
	  	
	  if(location=="file" && isFileUploadSample()){
		  disableFileUpload();
	  }
	  return;
}

function disableCilckNext(){
	var button = document.getElementById("ZDBNextDBBtn");
	button = (button)?button:document.getElementById("ZDBEXNextDBBtn");
	if(button){
		button.disabled = 'disabled'; //No I18N
	}
}
function enableCilckNext(){
	var button = document.getElementById("ZDBNextDBBtn");
	button = (button)?button:document.getElementById("ZDBEXNextDBBtn");
	if(button){
		button.disabled = false;
	}
}

function initFunctionOnImport(initFunc){
	return function(){
		disableCilckNext();
		initFunc();
	}	
}

function onScriptErrorOnImport(){
	endImportProgress();
	enableCilckNext();
	enableFileUpload();
}

function clickSampleURL(){
	var el = document.getElementById("SAMPLEURLLINK");
	var toClick = el.getElementsByTagName("a")[0];
	//console.log("clicking clild el");
	toClick.click();
}

function disableFileUpload(fileField){
	if(!fileField){
		var fileField = (document.getElementById("ZDBImportFileNameFld"))?
				document.getElementById("ZDBImportFileNameFld"):document.getElementById("ZFILENAME");
	}
	if(fileField){
		fileField.disabled = true;
	}
}

function enableFileUpload(fileField){
	if(!fileField){
		var fileField = (document.getElementById("ZDBImportFileNameFld"))?
				document.getElementById("ZDBImportFileNameFld"):document.getElementById("ZFILENAME");
	}
	if(fileField){
		fileField.disabled = false;
	}	
}

function isFileUploadSample(){
	var fileField = (document.getElementById("ZDBImportFileNameFld"))?
			document.getElementById("ZDBImportFileNameFld"):document.getElementById("ZFILENAME");
	var isSample = fileField && fileField.getAttribute('SampleShown');
	return isSample && isSample!='false';
}

function endImportProgress(response,requestOptions){
	if(requestOptions["PROGRESSENDFUNC"]){
		requestOptions.fn("PROGRESSENDFUNC")(response,requestOptions); //No I18N
	}	
}

function setFileTypeLabel(selectedOption){
  if(selectedOption == "import")
  {
    $("ZDBFILETYPELBL").innerHTML = ZDBI18NMap.f("zrpt.newtable.import.js.filetype");
  }
  if(selectedOption == "cloud")
  {
    $("ZDBFILETYPELBL").innerHTML = ZDBI18NMap.f("zrpt.newtable.import.js.cloudtype");
  }
}


//ended
