//$Id$

//ZDBDialogUtil properties
//                        ADDFRAME:true
//						   FRAMETYPE:default,infoTheme etc.,
//                        MODAL:true
//                        DONTREMOVE:true ( Which donot destroy the content in the dialog body) 
//                        TITLE:'title of the dialog'
//                        LEFT:leftPos,TOP:topPos  ( DON'T GIVE ANY px or % )
//							ZDBDialogUtil.positionCenter(dlg) to position the dialog to the center of the body.
//                        ONCLOSE:function to eval onClose ( Where you can pass the params which is attached to the dialog. Also the eval function should return true)
//                        NOESC:true ( Esc event will not close the dialog. You can handle it by your own )
//						   ACTIONBUTTONS:"the button that sends actions to server should be passed as a single element or an array of an jQuery Object to this param. For now input element alonw is supported

//                        isDialog="true" to be added in the main DIV of your dialog template which needs to be draggable
// 						  Also give the className "newDlgTitleStyle" for the TD's in the title bar <TR>
//						
//                    	Example How to call : ZDBDialogUtil.showDialog(viewUDDiv,{TITLE:'View Underlying Data', ADDFRAME:true, ONCLOSE:ZDBVUDataAPI.viewUDDlgClosed, PLHOLDER:viewUDDiv.gridHolder, EXTRAPARAMS:extraParams});
//						Example of How to use ACTIONBUTTONS : 
//									var btns = jQuery(div).find("input#yourButtonID")
//									ZDBDialog.showDialog(div, {TITLE:'Add Column', ADDFRAME:true, ACTIONBUTTONS:btns});
//									on clicking Ok or the button passed if the execution is successful automatically the button will be activated
//									on clickin Ok or the button passed if the execution fails custom handling must be done.

var ZDBDialogUtil = new function()
{
    this.i = 0;
    this.zCounter = 2000;
    this.zStartIndex = 2000;
    this.blinkCounter = 0;
    this.intervalID = null;
    this.dialogs = new Array();
    this.openedDialog = 0;
    this.btnsMonitored = [];
  
    this.showFullPageDialog = function(div, params)
    {
        var dlg = this.getDocumentAppendedDlg(div,params);
        jQuery(dlg.dlgTitleBar).unbind("mousedown"); // No I18N
        dlg.className="fullPageDialogue";
        var holderEl = params["HOLDEREL"] ? params["HOLDEREL"] : $("ZDBViewEl");
        this.setHgtNWidth(holderEl,params["MINWIDTH"]);
        dlg.style.display="none";
        dlg.style.visibility="";
//        jQuery(dlg).animate({width:"toggle",opacity:"toggle"},250);
        MenuUtil.animate(jQuery(dlg),{width:"toggle",opacity:"toggle"},250); //NO I18N
        return dlg;
    }
    this.setHgtNWidth = function(holderEl,minWidth)
    {
         var focusDlg = ZDBDialogUtil.focusDialog;
        var bodyContent = focusDlg.bodyContent;
        // dlg positioning
        var hgt = holderEl.offsetHeight*.87;
        var wdth = holderEl.offsetWidth*.5;
        minWidth = minWidth ? minWidth : wdth;
        bodyContent.style.height = hgt+"px";
        bodyContent.style.width = wdth+"px";
        focusDlg.style.right="1px"; //NO I18N
        focusDlg.style.top=ZDBUtil.getObjTop(holderEl)+"px";
        focusDlg.style.left="";    
    }
    this.showDialog = function(div, params)
    {
        var dlg = this.getDocumentAppendedDlg(div,params);
        dlg.style.visibility = "visible";
        return dlg;
        //ev.addEscHandle(ZDBDialogUtil.whichEvent);
        //ev.addEnterHandle(ZDBDialogUtil.whichEvent);
    }
    this.getDocumentAppendedDlg = function(div, params)
    {
        for(prop in params)
        {
            /// Why this fun?
            params[prop.toUpperCase()] = params[prop];
        /// Are you not adding too many of it? OK, max will be double the number ;-)
        }
        var dlg = div;
        if(params["ADDFRAME"])
        {
            dlg = this.createDialog(params); 
            dlg.dlgBodyDIV.innerHTML="";
            if(div!=null)
            {
                dlg.dlgBodyDIV.appendChild(div);
                dlg.bodyContent = div;
            }
        }
		
        if(dlg.bodyContent==null)
        {
        	var param,parent;
        	if(params["USEREACT"]){
        		param = "data-elname";//NO I18N
        		dlg.bodyContent = dlg;
        	}
        	else{
        		param = "elname";//NO I18N
        	}
            ZDBUtil.setNamedChildEls(dlg,dlg,param); // I need the dlgBodyContent even it is your own dlg...CURSOR ISSUE.
        }
		
        ZDBDialogUtil.openedDialog++;
        ZDBDialogUtil.dialogs[ZDBDialogUtil.openedDialog-1]=dlg;
        ZDBDialogUtil.zCounter =ZDBDialogUtil.zCounter + 5;
        
        if(params["DLGBODY"])
        {
        	dlg.dlgBody.className = params["DLGBODY"];
        }
        
        if(params["TITLE"])
        {
        	if(dlg.bodyContent && !params.DESC)
	    		{
        		dlg.dlgTitle.style.width = (parseInt(dlg.bodyContent.style.width) - 30) + "px";
	    		}
        	dlg.dlgTitle.innerHTML = ZDBEscapeUtil.encodeForHtml(params["TITLE"]);
        }
        if(params["HELPDOC"])
        {
            if(!ZDBClientUI.isCustomDomain && !ZDBGlobal.IS_OP_OEM)
                {
                    dlg.dlgHelp.href = ZDBEscapeUtil.encodeForHtml(params["HELPDOC"]);
                    dlg.dlgHelpIcon.style.display="";
                }
        }
       
        if(params["HELPVIDEO"])
        {
        	if(!ZDBClientUI.isCustomDomain && ZDBGlobal.isZDomain && !ZDBGlobal.IS_MOBILE)
            {
                dlg.dlgVideo.setAttribute('onclick',ZDBEscapeUtil.encodeForHtml(params["HELPVIDEO"]));
                dlg.dlgVideoIcon.style.display="";
                if(params["HELPDOC"]){
                dlg.dlgVideoIcon.className="videoWithHelp videoIcon videoIconbg";
                }
                else{
                	dlg.dlgVideoIcon.className="videoWithoutHelp videoIcon videoIconbg";	
                }
            }
        }
       
        
        if(dlg.dlgDesc && params.DESC)
        {
//          var descEl = jQuery(dlg.dlgDesc);
//          descEl.show().attr('tip', ZDBEscapeUtil.encodeForHtml(params.DESC)); // No I18N
        }

        ZDBDialogUtil.currentViewObj = params["VIEW"];

        if(params["TITLECLASS"] && dlg.dlgIcon)
        {
            dlg.dlgIcon.className = params["TITLECLASS"];
            dlg.setIconClass = function(className)
            {
                dlg.dlgIcon.className = className;
            }
        }
        
        dlg.params = params;		
		
        dlg.style.position="absolute";
        dlg.style.visibility = "hidden";
        dlg.style.display="block";
        document.body.appendChild(dlg);
      	var callout = params.CALLOUT;
      	if(callout)
      	{
      		jQuery(dlg.dlgTitleBar).unbind("mousedown"); // No I18N
      		//jQuery(dlg.closeBtn).hide();
      		ZDBDialogUtil.calloutPosition(dlg);
      	}
        else
        {

                jQuery(dlg.dlgTitleBar).mousedown(function(event){ZDBDialogUtil.dragDialog(this, event);});
                ZDBDialogUtil.positionCenter(dlg);	
        }
            
        ZDBDialogUtil.focusDialog = dlg;
        dlg.view = params["VIEW"];
        dlg.style.zIndex=ZDBDialogUtil.zCounter;
        if(params["ZINDEX"])
        {
            dlg.style.zIndex = params["ZINDEX"];
        }
        if(params["RESIZE"])
        {
            dlg.maxBtn.style.display ='';
            dlg.resizeEls.style.display = '';
            dlg.corner.style.display = '';
            dlg.resizeLR.style.height = (dlg.offsetHeight - 20)+"px";
            dlg.resizeTB.style.width = (dlg.offsetWidth - 20)+"px";
        }
        if(params["ADDFRAME"] || params["SHADOW"])
        {
            var el=jQuery(dlg).children("[elname='ZRDlgShadow']")[0];
            el= (el !=null) ? el :dlg; 
            ZDBMenu.addShadow(el);
        }
	
        if(params["MODAL"])
        {
            this.freezeBackground(ZDBDialogUtil.dialogs[ZDBDialogUtil.openedDialog-1]);
        }
        
//        jQuery(dlg).keydown(ZDBDialogUtil.whichEvent);
        
        if(params.NOFOCUS !== true)
        {
          ZDBDialogUtil.setElementIndex(dlg);
        }
        
        if(params["ACTIONBUTTONS"]){
            var btns = params["ACTIONBUTTONS"];
        	if(((btns instanceof Array) && (btns instanceof Object) && (btns.length > 0)) || (btns instanceof HTMLElement) || (btns instanceof jQuery)){
                if(btns instanceof jQuery){
                        btns = btns.toArray();
                }
                this.btnsMonitored = this.btnsMonitored.concat(btns);
                btns = jQuery(btns)[0];
                var curClick = btns.getAttribute('onclick') || '';
                var newClick = 'ZDBDialogUtil.btnDisabler(event);' + curClick; //NO I18N
                btns.setAttribute('onclick', newClick);
            }
        }
        ZDBUtil.attachEvent(document, 'keydown', ZDBDialogUtil.whichEvent)
        return dlg;
    }
	
	this.btnDisabler = function(event){
		// if(!ZDBDialogUtil.dontDisableBtn){
			var el = event.srcElement || event.target;
			if(el.disabled == true || el.style.pointerEvents == 'none')
				return;
			if(el.tagName === "INPUT"){
				el.disabled = true;
			}
			else{
				if(el.style.pointerEvents){
					el.style.pointerEvents = "none";//NO I18N
				}
			}
			var curClick = el.getAttribute('onclick');
    		var newClick = curClick.replace('ZDBDialogUtil.btnDisabler(event);', '');
    		el.setAttribute('onclick', newClick);
		// }
		// else{
		// 	console.log("dont diable btn set to false");
		// 	ZDBDialogUtil.dontDisableBtn = false;
		// }
	}
	
	this.calloutPosition = function(dlg)
	{
		var params = dlg.params;
		var left=0, top =0;
		var arrowClassName = null;
		var dlgHeight = jQuery(dlg).height();
		var dlgWidth = jQuery(dlg).width();
		var windowEl = jQuery(window);
		var winHeight = windowEl.height();
		var winWidth = windowEl.width();
		if(winWidth > dlgWidth && winHeight > dlgHeight)
		{
			var el = jQuery(params.SRCEL);
			var elOffset = el.offset();
			var elWidth = el.width();
			var elHeight = el.height();
			
			var curTop = winHeight - elOffset.top;
			var curLeft = winWidth - elOffset.left;
			
			var size = 0.2; //place arrow two percent of the callout
			var size50 = 0.5; //place arrow at the center of the callout
			var size75 = 0.75; //place arrow at the 75 percent of the callout
			var pointerSize = 11; // arrow height
			var extraSpace = 20;
			var specialCase = params.SCASE;
			var manualPos = params.MANUALPOS;
			var viewNameEditCase = params.VIEWNAMEEDIT;
			if(!manualPos){
				if(curTop > (dlgHeight - (dlgHeight * size) + extraSpace) && curLeft > (dlgWidth + elWidth + pointerSize + extraSpace) && winWidth > dlgWidth + extraSpace + elOffset.left){
					manualPos = "RIGHT20";//NO I18N
				}
				else if(curTop > (dlgHeight - (dlgHeight * size50) + extraSpace) && curLeft > (dlgWidth + elWidth + pointerSize + extraSpace) && winWidth > dlgWidth + extraSpace + elOffset.left){
					manualPos = "RIGHT50";//NO I18N
				}
				else if(curTop > (dlgHeight - (dlgHeight * size50) + extraSpace) && curLeft > (dlgWidth + elWidth + pointerSize + extraSpace) && !(winWidth > dlgWidth + extraSpace + elOffset.left)){
					manualPos = "RIGHT75";//NO I18N
				}
				else if(curTop > (dlgHeight + elHeight + pointerSize + extraSpace) && curLeft > (dlgWidth + elWidth/2 - (dlgWidth * size) + extraSpace) && elOffset.left > dlgWidth * size && winWidth > dlgWidth + extraSpace + elOffset.left){
					manualPos = "BOTTOM20";//NO I18N
				}
				else if(curTop > (dlgHeight +elHeight + pointerSize + extraSpace) && curLeft > (dlgWidth + elWidth/2 - (dlgWidth * size50) + extraSpace) && elOffset.left > dlgWidth * size50 && winWidth > dlgWidth + extraSpace + elOffset.left){
					manualPos = "BOTTOM50";//NO I18N
				}
				else if(curTop > (dlgHeight + elHeight + pointerSize + extraSpace) && curLeft > (dlgWidth + elWidth/2 - (dlgWidth * size75) + extraSpace) && elOffset.left > dlgWidth * size75 && !(winWidth > dlgWidth + extraSpace + elOffset.left)){
					manualPos = "BOTTOM75";//NO I18N
				}
				else if(curTop > (dlgHeight - (dlgHeight * size) + extraSpace) && elOffset.left > (dlgWidth + pointerSize + extraSpace) && winWidth > dlgWidth + extraSpace + elOffset.left){
					manualPos = "LEFT20";//NO I18N
				}
				else if(curTop > (dlgHeight - (dlgHeight * size50) + extraSpace) && elOffset.left > (dlgWidth + pointerSize + extraSpace) && winWidth > dlgWidth + extraSpace + elOffset.left){
					manualPos = "LEFT50";//NO I18N
				}
				else if(curTop > (dlgHeight - (dlgHeight * size50) + extraSpace) && elOffset.left > (dlgWidth + pointerSize + extraSpace) && !(winWidth > dlgWidth + extraSpace + elOffset.left)){
					manualPos = "LEFT75";//NO I18N
				}
				else if(elOffset.top > dlgHeight + pointerSize + extraSpace && curLeft > (dlgWidth + elWidth/2 - (dlgWidth * size) + extraSpace ) && winWidth > dlgWidth + extraSpace + elOffset.left){
					manualPos = "TOP20";//NO I18N
				}
				else if(elOffset.top > dlgHeight + pointerSize + extraSpace && curLeft > (dlgWidth + elWidth/2 - (dlgWidth * size50) + extraSpace ) && winWidth > dlgWidth + extraSpace + elOffset.left){
					manualPos = "TOP50";//NO I18N
				}
				else if(elOffset.top > dlgHeight + pointerSize + extraSpace && curLeft > (dlgWidth + elWidth/2 - (dlgWidth * size50) + extraSpace ) && !(winWidth > dlgWidth + extraSpace + elOffset.left)){
					manualPos = "TOP75";//NO I18N
				}
			}
			dlg.ArrowBefore.style.top = "";
			dlg.ArrowBefore.style.left = "";
			dlg.ArrowAfter.style.top = "";
			dlg.ArrowAfter.style.left = "";
			if(specialCase)
			{
				//Position bottom - Arrow @80%
				arrowClassName = "ZRSPointerTop"; // No I18N
				top = elOffset.top + elHeight + pointerSize;
				left = elOffset.left + elWidth/2 - dlgWidth * 0.80;
				dlg.ArrowBefore.style.left = dlgWidth * 0.80  +"px";
				dlg.ArrowAfter.style.left = dlgWidth * 0.80 + "px";
			}
			else if(viewNameEditCase) {
				// for view name edit case
				arrowClassName = "ZRSPointerTop"; // No I18N
				top = params["TOP"] + 20;
				left = params["LEFT"] - (dlgWidth/2);
				dlg.ArrowBefore.style.left = elOffset.left + dlgWidth * 0.20  +"px";
				dlg.ArrowAfter.style.left =  elOffset.left + dlgWidth * 0.20 + "px";
			}
			else if(manualPos == "NOARROW"){
				arrowClassName = "ZRSPointerNoArrow";//NO I18N
				var bounds = el[0].getBoundingClientRect();
				top = bounds.top + bounds.height - 1;
				left = bounds.left + 2; //for Borders
			}
			else if(manualPos == "RIGHT20")
			{//Position right side - Arrow @20%
				arrowClassName = "ZRSPointerLeft"; // No I18N
				top = elOffset.top - dlgHeight * size;
				left = elOffset.left + elWidth + pointerSize;
				var pointerPos = 0;
				if(top < 0)
				{
					top = 10;
					pointerPos = elOffset.top + elHeight/2 - 10;
				}
				else
				{
					var position = dlgHeight * size + elHeight/2;
					pointerPos = (position > dlgHeight) ? dlgHeight/2 : position;
				}
				dlg.ArrowBefore.style.top = pointerPos + "px";
				dlg.ArrowAfter.style.top = pointerPos + "px";
			}
			else if(manualPos == "RIGHT50")
			{//Position right side - Arrow @50%
				arrowClassName = "ZRSPointerLeft"; // No I18N
				top = elOffset.top - dlgHeight * size50;
				left = elOffset.left + elWidth + pointerSize;
				var pointerPos = 0;
				if(top < 0)
				{
					top = 10;
					pointerPos = elOffset.top + elHeight/2 - 10;
				}
				else
				{
					var position = dlgHeight * size50 + elHeight/2;
					pointerPos = (position > dlgHeight) ? dlgHeight/2 : position;
				}
				dlg.ArrowBefore.style.top = pointerPos + "px";
				dlg.ArrowAfter.style.top = pointerPos + "px";
			}
			else if(manualPos == "RIGHT75"){
				//Position right side - Arrow @75%
				arrowClassName = "ZRSPointerLeft"; // No I18N
				top = elOffset.top - dlgHeight * size75;
				left = elOffset.left + elWidth + pointerSize;
				var pointerPos = 0;
				if(top < 0)
				{
					top = 10;
					pointerPos = elOffset.top + elHeight/2 - 10;
				}
				else
				{
					var position = dlgHeight * size75 + elHeight/2;
					pointerPos = (position > dlgHeight) ? dlgHeight/2 : position;
				}
				dlg.ArrowBefore.style.top = pointerPos + "px";
				dlg.ArrowAfter.style.top = pointerPos + "px";
			}
			else if(manualPos == "LEFT20")
			{//Position left - Arrow @20%
				arrowClassName = "ZRSPointerRight"; // No I18N
				top = elOffset.top - dlgHeight * size;
				left = elOffset.left - dlgWidth - pointerSize;
				var pointerPos = 0;
				if(top < 0)
				{
					top = 10;
					pointerPos = elOffset.top + elHeight/2 - 10;
				}
				else
				{
					var position = dlgHeight * size + elHeight/2;
					pointerPos = (position > dlgHeight) ? dlgHeight/2 : position;
				}
				dlg.ArrowBefore.style.top = pointerPos + "px";
				dlg.ArrowAfter.style.top = pointerPos + "px";
			}
			else if(manualPos == "LEFT50")
			{//Position left - Arrow @50%
				arrowClassName = "ZRSPointerRight"; // No I18N
				top = elOffset.top - dlgHeight * size50;
				left = elOffset.left - dlgWidth - pointerSize;
				var pointerPos = 0;
				if(top < 0)
				{
					top = 10;
					pointerPos = elOffset.top + elHeight/2 - 10;
				}
				else
				{
					var position = dlgHeight * size50 + elHeight/2;
					pointerPos = (position > dlgHeight) ? dlgHeight/2 : position;
				}
				dlg.ArrowBefore.style.top = pointerPos + "px";
				dlg.ArrowAfter.style.top = pointerPos + "px";
			}
			else if(manualPos == "LEFT75"){
				//Position left - Arrow @75%
				arrowClassName = "ZRSPointerRight"; // No I18N
				top = elOffset.top - dlgHeight * size75;
				left = elOffset.left - dlgWidth - pointerSize;
				var pointerPos = 0;
				if(top < 0)
				{
					top = 10;
					pointerPos = elOffset.top + elHeight/2 - 10;
				}
				else
				{
					var position = dlgHeight * size75 + elHeight/2;
					pointerPos = (position > dlgHeight) ? dlgHeight/2 : position;
				}
				dlg.ArrowBefore.style.top = pointerPos + "px";
				dlg.ArrowAfter.style.top = pointerPos + "px";
			}
			else if(manualPos == "BOTTOM20")
			{//Position bottom - Arrow @20%
				arrowClassName = "ZRSPointerTop"; // No I18N
				top = elOffset.top + elHeight + pointerSize;
				left = elOffset.left + elWidth/2 - dlgWidth * size;
				dlg.ArrowBefore.style.left = dlgWidth * size  +"px";
				dlg.ArrowAfter.style.left = dlgWidth * size + "px";
			}
			else if(manualPos == "BOTTOM50")
			{//Position bottom - Arrow @50%
				arrowClassName = "ZRSPointerTop"; // No I18N
				top = elOffset.top + elHeight + pointerSize;
				left = elOffset.left + elWidth/2 - dlgWidth * size50;
				dlg.ArrowBefore.style.left = dlgWidth * size50  +"px";
				dlg.ArrowAfter.style.left = dlgWidth * size50 + "px";
			}
			else if(manualPos == 'BOTTOM75'){
				//Position bottom - Arrow @75%
				arrowClassName = "ZRSPointerTop"; // No I18N
				top = elOffset.top + elHeight + pointerSize;
				left = elOffset.left + elWidth/2 - dlgWidth * size75;
				dlg.ArrowBefore.style.left = dlgWidth * size75  +"px";
				dlg.ArrowAfter.style.left = dlgWidth * size75 + "px";
			}
			else if(manualPos == "TOP20")
			{//Position top - Arrow @20%
				arrowClassName = "ZRSPointerBottom"; // No I18N
				top = elOffset.top - dlgHeight - pointerSize;
				left = elOffset.left - dlgWidth * size;
				var position = dlgWidth * size + elWidth/2;
				var pointerPos = (position > dlgWidth) ? dlgWidth/2 : position;
				dlg.ArrowBefore.style.left = pointerPos +"px";
				dlg.ArrowAfter.style.left = pointerPos + "px";
			}
			else if(manualPos == "TOP50")
			{//Position top - Arrow @50%
				arrowClassName = "ZRSPointerBottom"; // No I18N
				top = elOffset.top - dlgHeight - pointerSize;
				left = elOffset.left - dlgWidth * size50;
				var position = dlgWidth * size50 + elWidth/2;
				var pointerPos = (position > dlgWidth) ? dlgWidth/2 : position;
				dlg.ArrowBefore.style.left = pointerPos +"px";
				dlg.ArrowAfter.style.left = pointerPos + "px";
			}
			else if(manualPos == "TOP75"){
				//Position top - Arrow @75%
				arrowClassName = "ZRSPointerBottom"; // No I18N
				top = elOffset.top - dlgHeight - pointerSize;
				left = elOffset.left - dlgWidth * size75;
				var position = dlgWidth * size50 + elWidth/2;
				var pointerPos = (position > dlgWidth) ? dlgWidth/2 : position;
				dlg.ArrowBefore.style.left = pointerPos +"px";
				dlg.ArrowAfter.style.left = pointerPos + "px";
			}
		}
		if(!arrowClassName)
		{//Position center - if there is no space to show the callout - worst case scenario in embed
		    ZDBDialogUtil.positionCenter(dlg);
		    return;
		}
		dlg.dlgTable.className = "dlgBorder font12 " + arrowClassName;
		dlg.ArrowBefore.className= arrowClassName+"Before";
		dlg.ArrowAfter.className= arrowClassName+"After";
		
		dlg.style.left = parseInt(left) + "px";
		dlg.style.top = parseInt(top) + "px"; 
	}
	
	this.fixedCalloutPosition = function(menu, source, options){
		if(menu.parentElement != document.body){
			//append menu to body
			document.body.appendChild(menu);
		}
		if(!options){
			options = {};
		}
		// get menu width and height if not included in options
		options.menuWidth = options.menuWidth || menu.offsetWidth;
		options.menuHeight = options.menuHeight || menu.offsetHeight;
		// get source width and height if not included in options
		options.sourceWidth = options.sourceWidth || source.offsetWidth;
		options.sourceHeight = options.sourceHeight || source.offsetHeight;
		// get bounding client rectangle for soruce
		var sourceBounds = source.getBoundingClientRect();
		// get window bounds
		var windowEl = jQuery(window);
		var winHeight = windowEl.height(), winWidth = windowEl.width();
		var pointerSize = 11; // arrow height
		var actualWidth = pointerSize + options.menuWidth, actualHeight = pointerSize + options.menuHeight;
		var checkHeight = false, checkWidth = false, arrowClassName = false;
		options.arrowWidth = options.arrowWidth != undefined ? options.arrowWidth : 0.8;
		options.arrowHeight = options.arrowHeight != undefined ? options.arrowHeight : 0.2;
		options.marginLeft = options.marginLeft || 0;
		options.marginTop = options.marginTop || 0;
		var order = options.order || ["RIGHT","BOTTOM","LEFT","TOP"];
		for(var i=0; i<order.length; i++){
			switch(order[i]){
				case "RIGHT" :
					checkHeight = (winWidth - sourceBounds.right) > actualWidth && winHeight > options.menuHeight;
					if(checkHeight){
						menu.style.left = sourceBounds.right + pointerSize + "px";
					}
					break;
				case "BOTTOM" :
					checkWidth = (winHeight - sourceBounds.bottom) > actualHeight && winWidth > options.menuWidth;
					if(checkWidth){
						menu.style.top = sourceBounds.bottom + pointerSize + "px";
					}
					break;
				case "LEFT" : 
					checkHeight = sourceBounds.left > actualWidth && winHeight > options.menuHeight;
					if(checkHeight){
						menu.style.left = sourceBounds.left - actualWidth+ "px";
					}
					break;
				case "TOP" : 
					checkWidth = sourceBounds.top > actualHeight && winWidth > options.menuWidth;
					if(checkWidth){
						menu.style.top = sourceBounds.top - actualHeight + "px";
					}
					break;
			}
			if(checkWidth || checkHeight){
				break;
			}
		}
		
		if(checkWidth){
			// consider for right end arrow initially
			arrowClassName = order[i] === "BOTTOM" ? "ZRSPointerTop" : "ZRSPointerBottom";
			var leftCalc = options.menuWidth * options.arrowWidth ;
			var leftArrow = leftCalc - (pointerSize / 2);
			var curLeft = sourceBounds.left - options.marginLeft + (options.sourceWidth / 2);
			var menuLeft = curLeft - leftArrow;
			if(menuLeft < 0){
				menuLeft = 0;
				leftArrow = curLeft;
			}
			menu.ArrowBefore.style.top = "";
			menu.ArrowAfter.style.top = "";
			menu.ArrowBefore.style.left = options.arrowWidth * 100 + "%";
			menu.ArrowAfter.style.left = options.arrowWidth * 100 + "%";
			menu.style.left = menuLeft + "px";
		}
		else if(checkHeight){
			// consider for top end arrow initially
			arrowClassName = order[i] === "RIGHT" ? "ZRSPointerLeft" : "ZRSPointerRight";
			var topCalc = options.menuHeight * options.arrowHeight ;
			var topArrow = topCalc - (pointerSize / 2);
			var curTop = sourceBounds.top - options.marginTop + (options.sourceHeight / 2);
			var menuTop = curTop - topArrow;
			if(menuTop < 0){
				menuTop = 0;
				topArrow = curLeft;
			}
			menu.ArrowBefore.style.left = "";
			menu.ArrowAfter.style.left = "";
			menu.ArrowBefore.style.top = options.arrowHeight * 100 + "%";
			menu.ArrowAfter.style.top = options.arrowHeight * 100 + "%";
			menu.style.top = menuTop + "px";
			
		}
		else{//Position center - if there is no space to show the callout - worst case scenario in embed
		    ZDBDialogUtil.positionCenter(menu);
		    return;
		}
		menu.dlgTable.className = "dlgBorder font12 " + arrowClassName;
		menu.ArrowBefore.className= arrowClassName+"Before";
		menu.ArrowAfter.className= arrowClassName+"After";
	}
	
    this.setFocusDialog = function(el)
    {
        var dlg = (el.getAttribute("isDialog") == "true")? el:DOMUtils.getParentWithAttr(el, "isDialog");
        if(dlg == ZDBDialogUtil.focusDialog)
        {
            return;	
        }        
        ZDBDialogUtil.focusDialog  = ZDBDialogUtil.openedDialog > 1 ? ZDBDialogUtil.dialogs[ZDBDialogUtil.openedDialog-1] : dlg;
    }

    this.positionCenter = function(el)
     {
		var dlg = el;
		var adjustElTop = (self['pageYOffset']) ? self['pageYOffset']
				: document.documentElement.scrollTop;

		var posX, postopY,posbottomY;
		if (ZDBGlobal.IS_MOBILE) {
			if (dlg.params) {
				posX = (dlg.params.LEFT) ? dlg.params.LEFT
						: ((window.innerWidth / 2) - ((dlg.offsetWidth) * 0.50));
				postopY = (dlg.params.TOP) ? dlg.params.TOP : ((dlg.params.BOTTOM) ? null : ((window.innerHeight / 2) - ((dlg.offsetHeight) * 0.50))
						+ adjustElTop );
				posbottomY = (dlg.params.BOTTOM) ? dlg.params.BOTTOM : ((window.innerHeight / 2) - ((dlg.offsetHeight) * 0.50)) ;
						
			} else {
				posX = ((window.innerWidth / 2) - ((dlg.offsetWidth) * 0.50));
				postopY = ((window.innerHeight / 2) - ((dlg.offsetHeight) * 0.50))
						+ adjustElTop;
				posbottomY =  postopY;
			}
		} else {
			if (dlg.params) {
				posX = (dlg.params.LEFT) ? dlg.params.LEFT : ((jQuery(window).width() / 2) - ((dlg.offsetWidth) * 0.50));
				postopY = (dlg.params.TOP) ? dlg.params.TOP :( (dlg.params.BOTTOM) ? null : ((jQuery(window).height())/2 - ((dlg.offsetHeight) * 0.50))
						+ adjustElTop );
                                posX = posX < 0 ? 10 : posX;
                                postopY = postopY < 0 ? 10 : postopY;
				posbottomY = (dlg.params.BOTTOM) ? dlg.params.BOTTOM : ((jQuery(window).height())/2 - ((dlg.offsetHeight) * 0.50)) ;
		
			} else {// Its executes only when the loading DIV comes along with
					// the dialog.
				posX = ((jQuery(window).width() / 2) - ((dlg.offsetWidth) * 0.50));
				postopY = ((jQuery(window).height() / 2) - ((dlg.offsetHeight) * 0.50))
						+ adjustElTop;
				posbottomY =  postopY;
			}
		}
		if(dlg.dlgTable){dlg.dlgTable.className = "dlgBorder font12";}
		if(dlg.ArrowBefore){dlg.ArrowBefore.className = "";}
		if(dlg.ArrowAfter){dlg.ArrowAfter.className = "";}
		dlg.style.left = posX + "px";
		dlg.style.top = postopY !== null ? postopY + "px" :"unset";
		dlg.style.bottom = postopY !== null ? null : posbottomY + "px"; // NO I18N
	}
    
    this.freezeBackground = function(dlg, freezeLayerClass)
    {
        if(dlg.freezeLayer == null)
        {
            var freezeLayer = document.createElement("DIV");
            freezeLayer.className = freezeLayerClass ? freezeLayerClass : "freezeLayer";
            freezeLayer.style.zIndex = parseInt(dlg.style.zIndex)-1;
            // freezeLayer.addEventListener("scroll", ZDBD});
            //freezeLayer.style.backgroundColor = "#000";
            dlg.freezeLayer = freezeLayer;
        }
        document.body.appendChild(dlg.freezeLayer);
        if(dlg.params && dlg.params.CALLOUT)
    	{
        	dlg.freezeLayer.onclick = ZDBDialogUtil.closeCallout;
    	}
        else
    	{
        	ZDBUtil.attachEvent(dlg.freezeLayer,(ZDBGlobal.IS_MOBILE) ? 'touchmove' : 'click',ZDBDialogUtil.alertModalDlfEffect,true);
                //added for VUD case in Dashboard - Mobile device
    	}
    }
	
    this.alertModalDlfEffect = function(ev)
    {
        var dlg = ZDBDialogUtil.focusDialog;
        ZDBDialogUtil.blinkCounter=0;
        ZDBDialogUtil.intervalID = setTimeout(ZDBDialogUtil.blinkEffect, 100);
        ZDBUtil.stopEventBubble(); 
        //in mobile device the event is triggering for scroll in Dashboard
    }
  
    this.blinkEffect = function(ev)
    {
        var dlg = ZDBDialogUtil.focusDialog;
        var shadowDiv=jQuery(dlg).children("[elname='ZRDlgShadow']")[0];
        dlg = (shadowDiv) ? shadowDiv : dlg;
        if(dlg==null){
            return;
        }
        var orgClass = dlg.getAttribute("orgClass");
        var effectClass = dlg.getAttribute("effectClass");
        var className = "ZRSShadow"; // No I18N
        orgClass = (orgClass==null)?(dlg.shadowAdded==true) ? className : "normalTitleStyle" : orgClass; // No I18N
        effectClass = (effectClass==null)?(dlg.shadowAdded==true) ? "modalBlinkEffect1 shadowAdded" : "modalBlinkEffect1": effectClass;   // No I18N
        if(ZDBDialogUtil.blinkCounter<3)
        {
            if((ZDBDialogUtil.blinkCounter%2)!=0)
            {
                dlg.className=orgClass;
            }
            else
            {
                dlg.className=effectClass;
            }
            ZDBDialogUtil.blinkCounter++;
            setTimeout(ZDBDialogUtil.blinkEffect,100);
        }
        else
        {
            dlg.className=orgClass;
        }
    }
	
    this.createDialog = function(params)
    {
    	var dlg;
    	if(params['USEREACT']){
    		var dlg = createAndAppendReactContainer();//NO I18N
    		dlg.setAttribute("isDialog","true");
    		var dialogTemplateFac = React.createFactory(DialogTemplate);
    		ReactDOM.render(dialogTemplateFac(),dlg);
    		ZDBUtil.setNamedChildEls(dlg,dlg,"data-elname");
    		return dlg;
    	}
    	else{
    		dlgID = (params["FRAMETYPE"]!=null)?params["FRAMETYPE"]:"ZDBDialogTemplate";
            dlg = $(dlgID).cloneNode(true);
            dlg.id="";
            ZDBUtil.setNamedChildEls(dlg,dlg,"elname");		
            return dlg;
    	}
    }
	
    this.whichEvent = function(event)
    {
    	if(document.screenGrabberOpen){
    		return;
    	}
        var keyCode = (BROWSER.IE)?window.event.keyCode:event.which;
        if(!ZDBDialogUtil.focusDialog)
        {
        	return;
        }
        switch(keyCode)
        {
            case KEY.ESC: {
                if(!ZDBDialogUtil.focusDialog.params["NOESC"])
                {
                	if($("extDriveIFrame")==null)
                	{
                		ZDBDialogUtil.closeDialog();
                		ZDBUtil.stopEventBubble(event);
                	}
                    else if(!($("extDriveIFrame")==null))
                    {
                        ZDBDialogUtil.closeDialog();
                        ZDBUtil.stopEventBubble(event);
                    }
                    else
                    {
                        jQuery('#overlay').css("display", "none"); //NO I18N
                        jQuery("#ZDBEXTERNALOPTSTATUS").css("display","none"); //NO I18N
                        jQuery("#ZDBExtDriveIframeDialog").css("display", "none");  //NO I18N
                        jQuery("#extDriveIFrame").remove();//NO I18N
                    }
                    return true;
                }
                if(ZDBDialogUtil.focusDialog.params["ONESC"])
                {
                    ZDBDialogUtil.focusDialog.params["ONESC"].call(window, ZDBDialogUtil.focusDialog.params["ESCARGS"]);  
                }
                break;
            }
		
            case KEY.ENTER: {
                if(ZDBDialogUtil.focusDialog.params["ONENTER"])
                {
                    ZDBDialogUtil.focusDialog.params["ONENTER"].apply(window, [this, event, ZDBDialogUtil.focusDialog.params["ENTERARGS"]]);
                }
                break;
            }
            default:{
                return true;
            }
        }
    
   
    }
  
    this.dragDialog = function(el,ev)
    {
        ZDBDialogUtil.setFocusDialog(el);
        var whichDialog =  ZDBDialogUtil.focusDialog;
        whichDialog.style.cursor="move";
        
        if(BROWSER.IE)
        {
            this.diffLeft = window.event.clientX + document.body.scrollLeft - parseInt(ZDBUtil.getObjLeft(whichDialog));
            this.diffTop = window.event.clientY + document.body.scrollTop - parseInt(ZDBUtil.getObjTop(whichDialog));
        } 
        else ///PK:Shibu to check if (BROWSER.NETSCAPE || BROWSER.OPERA) 
        {
            this.diffLeft = ev.pageX - parseInt(ZDBUtil.getObjLeft(whichDialog));
            this.diffTop =  ev.pageY - parseInt(ZDBUtil.getObjTop(whichDialog));
        }
        ZDBUtil.stopEventBubble(ev);
        
        document.onmousemove = ZDBDialogUtil.moveDialog;
        document.onmouseup = ZDBDialogUtil.releaseDialog;

    }
	
    this.moveDialog = function(ev)
    {
        var whichDialog = ZDBDialogUtil.focusDialog;
        if (BROWSER.IE) 
        {
            var left = window.event.clientX + document.body.scrollLeft - ZDBDialogUtil.diffLeft;
            var top = window.event.clientY + document.body.scrollTop - ZDBDialogUtil.diffTop;
            left = (left >= 0) ? left : 0;
            top = (top >= 0) ? top : 0;
            whichDialog.style.left = left+"px";
            whichDialog.style.top = top+"px";     
        } 
        else ///PK: if (BROWSER.NETSCAPE || BROWSER.OPERA) 
        {
            whichDialog.style.left = ((ev.pageX - ZDBDialogUtil.diffLeft > 0) ? ev.pageX- ZDBDialogUtil.diffLeft : 0) + "px";
            whichDialog.style.top = (( ev.pageY - ZDBDialogUtil.diffTop > 0) ?  ev.pageY - ZDBDialogUtil.diffTop : 0) + "px";
        }
        if(whichDialog.iframe!=null)
        {
            whichDialog.iframe.style.left = whichDialog.style.left;
            whichDialog.iframe.style.top = whichDialog.style.top;
        }
		
        ZDBUtil.stopEventBubble(ev);
    }

    this.releaseDialog = function(ev)
    {
        var whichDialog = ZDBDialogUtil.focusDialog;
        whichDialog.style.cursor = "default";
        document.onmousemove = null;
        document.onmouseup = null;
        ZDBUtil.stopEventBubble(ev);
    }
    
    this.closeReactDialog = function(whichDialog,arg){
    	if((whichDialog.params["ONCLOSE"])&&(!whichDialog.params["ONCLOSE"](whichDialog,arg)))
        {
            return true;
        }
    	document.body.removeChild(whichDialog.freezeLayer);
    	var dialogIndex = jQuery.inArray( whichDialog, ZDBDialogUtil.dialogs);
    	ZDBDialogUtil.dialogs.splice(dialogIndex, 1);
	    ZDBDialogUtil.openedDialog--;
	    ZDBUtil.detachEvent(document, 'keydown', ZDBDialogUtil.whichEvent);
//	    jQuery(whichDialog).unbind("keydown",ZDBDialogUtil.whichEvent);//NO I18N
	    if(ZDBDialogUtil.openedDialog !=0)
	    {
	        ZDBDialogUtil.focusDialog = ZDBDialogUtil.dialogs[ZDBDialogUtil.openedDialog-1];
	    }
	    else
	    {
	        ZDBDialogUtil.focusDialog=null; // means no dialog opened.
	        document.onkeydown= null;
	    }
	    
    	if(whichDialog.params["DONTREMOVE"])
        {
    		whichDialog.style = null;
    		whichDialog.style.display = "none";
    		whichDialog.ArrowAfter.style = null;
    		whichDialog.ArrowAfter.className = null;
    		whichDialog.ArrowBefore.style = null;
    		whichDialog.ArrowBefore.className = null;
        }
    	else{
    		document.body.removeChild(whichDialog);
    	    ReactDOM.unmountComponentAtNode(whichDialog.bodyContent);
        	ReactDOM.unmountComponentAtNode(whichDialog);
    	}
    }
	
    this.closeDialog = function(closeBtn, ev, arg)
    {
        hideCustomMessage();
        ZDBMenuUtil.closeMenu();
        var whichDialog = null;
        if(!closeBtn)
        {
            whichDialog = ZDBDialogUtil.focusDialog;
        }
        else
        {
            whichDialog = DOMUtils.getParentWithAttr(closeBtn, "isDialog");//NO I18N
        }
        if(whichDialog && (jQuery(whichDialog).find(this.btnsMonitored).length > 0) && (this.btnsMonitored.length > 0)){
            this.btnsMonitored = this.enableButtons(this.btnsMonitored);
        }
         
        if(whichDialog &&  whichDialog.params['USEREACT']){
    		return this.closeReactDialog(whichDialog,arg);
    	}
        if(whichDialog != null &&  whichDialog.dialogStatus && whichDialog.dialogStatus > 0)
        { //Closing the inline dialog before closing the main dialog. 
            ZDBInlineDialog.closeDialog();
        }
        if(whichDialog)
        {
            this.closeThisDialog(whichDialog, arg);
        }
        if(ev)
        {
        	ZDBUtil.stopEventBubble(ev);
        }
        if(ZDBClientUI.modified)
        {
            ZDBClientUI.modified=false;
        }
		if((jQuery(whichDialog).find(this.btnsMonitored).length > 0) && (this.btnsMonitored.length > 0)){
        	this.btnsMonitored = this.enableButtons(this.btnsMonitored);
        }
    }
    
    this.enableButtons = function(els, bindDisabler){
    	for(var i=0; i<els.length; i++){
    		if(els[i].tagName === "INPUT"){
    			els[i].disabled = false;
    		}
    		else{
    			els[i].style.pointerEvents = "";
    		}
    		if(bindDisabler){
    			var curClick = els[i].getAttribute('onclick') || '';
        		var newClick = 'ZDBDialogUtil.btnDisabler(event);' + curClick;//NO I18N
	    		els[i].setAttribute('onclick', newClick);
    		}
    	}
    	els = [];
    	return els;
    }

    this.closeThisDialog = function(whichDialog,arg)
    {
        if((whichDialog.params["ONCLOSE"])&&(!whichDialog.params["ONCLOSE"](whichDialog,arg)))
        {
            return true;
        }
        if(whichDialog.bodyContent!=null)
        {
            whichDialog.bodyContent.style.overflow="";
        }
//        jQuery(whichDialog).unbind("keydown",ZDBDialogUtil.whichEvent);//NO I18N
        if(whichDialog.params["DONTREMOVE"] && whichDialog.params["ADDFRAME"])
        {
            $("ZDBDialogHiddenDiv").appendChild(whichDialog.bodyContent);
        }
        else if(whichDialog.params["DONTREMOVE"])
        {
            $("ZDBDialogHiddenDiv").appendChild(whichDialog);
            whichDialog.dontRemoveDlg = true;
        }
        
        var dialogIndex = jQuery.inArray( whichDialog, ZDBDialogUtil.dialogs);
        try
        {
            if(ZDBDialogUtil.dialogs[dialogIndex].freezeLayer)
            {
                document.body.removeChild(ZDBDialogUtil.dialogs[dialogIndex].freezeLayer);
            }
        }
        catch(e)
        {
        /// Be Brilliant ;-)
        }
    
        ZDBMenu.removeIframe(whichDialog);

        if(whichDialog.dontRemoveDlg!=true)
        {
            if(whichDialog.params["ANIMATE"]==true)
            {
                MenuUtil.animate(jQuery(whichDialog),{width:"toggle",opacity:"toggle"},250,function(){ //NO I18N
                    this.remove();
                    ZDBDialogUtil.dialogs.splice(dialogIndex, 1);
                });
            }
            else
            {
                whichDialog.parentNode.removeChild(whichDialog);
                ZDBDialogUtil.dialogs.splice(dialogIndex, 1);
            }
        }
    
        ZDBDialogUtil.openedDialog--;
        if(ZDBDialogUtil.openedDialog !=0)
        {
            ZDBDialogUtil.focusDialog = ZDBDialogUtil.dialogs[ZDBDialogUtil.openedDialog-1];
        }
        else
        {
            ZDBUtil.detachEvent(document, 'keydown', ZDBDialogUtil.whichEvent);
            ZDBDialogUtil.focusDialog=null; // means no dialog opened.
            document.onkeydown= null;
        }
        //event.stopPropagation();
    }							   
}

ZDBDialogUtil.setElementIndex = function(dlg)
{
  	if(dlg.params.IOS != null) 
  	{
  		 return;
  	}
    try
    {
        var firstFocusElement = null;
        var nodes =  dlg.getElementsByTagName("*");
        var nodesLen = nodes.length;
        var focusEls = ["INPUT", "SELECT", "TEXTAREA"]; //No I18N
        var curIndex = 0;
        for(var i=0;i<nodesLen;++i)
        {
            try
            {
                var curNode = nodes[i];
                if(curNode.tagName && ZDBUtil.indexOf(focusEls,curNode.tagName.toUpperCase()) >=0)
                {
                    var elType = (curNode.getAttribute("type") + "").toUpperCase();
                    if(elType != "HIDDEN" && elType != "BUTTON")
                    {
                        curNode.setAttribute("tabindex",curIndex++);
                        curNode.tabIndex = curIndex;
                        if(!firstFocusElement)
                        {
                            firstFocusElement  = curNode;
                        }
                    }
                }
            }
            catch(e)
            {
            //PK: Let me try the next one!
            }
        }
    }
    catch(e)
    {
    ///PK: Let me not worry about this, now!
    }
    firstFocusElement && ZDBUtil.setFocus(firstFocusElement, true);
}


ZDBDialogUtil.attachResizeEvt = function(el,resizeType,event)
{
    var dlg = ZDBDialogUtil.focusDialog;	
    dlg.action = 'RESIZE' + resizeType;
    document.onmousemove = ZDBDialogUtil.drawLine;
    document.onmouseup = ZDBDialogUtil.resize;
    ZDBUtil.stopEventBubble(event);
}
  
ZDBDialogUtil.drawLine = function(event)
{
    var dlg = ZDBDialogUtil.focusDialog;
    var vLine = dlg.vLine;
    var hLine = dlg.hLine;
    var leftPos = ZDBUtil.getObjLeft(dlg,false);
    var topPos = ZDBUtil.getObjTop(dlg,false);
    var curPos = ZDBUtil.getCursorPos(event);
    var curStyle = "default"; //No I18N
    var width = (curPos.x - leftPos < ZDBConst.DLG_MIN_WIDTH ) ? ZDBConst.DLG_MIN_WIDTH : curPos.x - leftPos;
    var height = (curPos.y - topPos < ZDBConst.DLG_MIN_HEIGHT ) ? ZDBConst.DLG_MIN_HEIGHT : curPos.y - topPos;
    dlg.width = width;
    dlg.height = height;    
    var action = dlg.action;
    if(action == 'RESIZELR')
    {
        ZDBUtil.setElPos(vLine,[dlg.offsetHeight,'1','0',width]);
        vLine.style.display ='';
        curStyle = (width == ZDBConst.DLG_MIN_WIDTH) ? "default" : "e-resize"; //No I18N
    }
    else if(action == 'RESIZETB')
    {
        ZDBUtil.setElPos(hLine,['1',dlg.offsetWidth,height,'0']);
        hLine.style.display ='';
        curStyle = (height == ZDBConst.DLG_MIN_HEIGHT) ? "default" : "n-resize"; //No I18N
    }
    else if(action == 'RESIZEALL')
    {
        ZDBUtil.setElPos(vLine,[height,'1','0',width]);
        ZDBUtil.setElPos(hLine,['1',width,height,'0']);
        vLine.style.display ='';
        hLine.style.display ='';
        curStyle = (height == ZDBConst.DLG_MIN_HEIGHT && width == ZDBConst.DLG_MIN_WIDTH) ? "default" : "se-resize"; //No I18N
    }
    document.body.style.cursor = curStyle;
    dlg.style.cursor = curStyle;
    ZDBUtil.stopEventBubble(event);
}
  
ZDBDialogUtil.resize = function(event)
{
    document.body.style.cursor = "default";
    var dlg = ZDBDialogUtil.focusDialog;
    dlg.vLine.style.display = "none";
    dlg.hLine.style.display = "none";
    var action = dlg.action;
    var nWidth = dlg.width;
    var nHeight = dlg.height;
    ZDBDialogUtil.initContants();
    if(action == "RESIZELR")
    {
        nHeight = dlg.bodyContent.offsetHeight + ZDBDialogUtil.titleBarHeight;
    }
    else if(action == "RESIZETB")
    {
        nWidth = dlg.bodyContent.offsetWidth;
    }
    dlg.resizeLR.style.height = nHeight - 20 +"px";
    dlg.resizeTB.style.width = nWidth - 20 +"px";
    dlg.resizeTB.style.top = nHeight + "px";
    ZDBUtil.setElPos(dlg,[nHeight,nWidth]);
    ZDBUtil.setElPos(dlg.bodyContent,[nHeight - (ZDBDialogUtil.titleBarHeight),nWidth]);
    
    if(dlg.bodyContent.gridHolder != null && (!ZDBDialogUtil.focusDialog.view.dialogStatus || ZDBDialogUtil.focusDialog.view.dialogStatus < 1))
    {
        ZDBDialogUtil.resizeVUDGrid(dlg,nHeight,nWidth);
    }
      else if(dlg.bodyContent.editGridHolder != null)
      {
        ZDBInlineDialog.resizeDialog();
        ZDBDialogUtil.resizeEditDesignDialog(dlg, nHeight, nWidth);
      }
    else if(ZDBDialogUtil.focusDialog.view.dialogStatus > 0)
    {
        ZDBInlineDialog.resizeDialog();
        ZDBDialogUtil.resizeVUDGrid(dlg,nHeight ,nWidth);
    }
    ZDBDialogUtil.releaseDialog(event);
    ZDBMenu.resizeIframe(dlg);
    dlg.action = null;
}
  
ZDBDialogUtil.resizeEditDesignDialog = function(dlg, nHeight, nWidth)
{
  var otherHeight = ZDBDialogUtil.toolbarHeight + ZDBDialogUtil.titleBarHeight;
  nHeight = nHeight - otherHeight;
  dlg.bodyContent.editGridHolder.style.width = nWidth + "px";
  dlg.bodyContent.editGridHolder.style.height = nHeight + "px";
  var gridObj = dlg.gridObj;
  gridObj.resizeGrid(nWidth, nHeight);
  ZDBInlineDialog.resizeDialog();
}

ZDBDialogUtil.resizeVUDGrid = function(dlg,nHeight,nWidth)
{
	var otherHeight = ZDBDialogUtil.toolbarHeight + ZDBDialogUtil.titleBarHeight;
	nHeight = nHeight - otherHeight;
    var action = dlg.action;
    var vudDlg = dlg.bodyContent;
    if(action != null && action == "RESIZELR")
    { 
    	nHeight = vudDlg.gridHolder.offsetHeight;
    }
    vudDlg.gridHolder.style.width = nWidth+"px";
    vudDlg.gridHolder.style.height = nHeight+"px";
    vudDlg.gridObj.resizeGrid(nWidth,nHeight);
}
  
ZDBDialogUtil.minMaxDlg = function(action)
{
    var dlg = ZDBDialogUtil.focusDialog;
    var dispMode = "none"; //No I18N
    var height = width = left = 0;
    var top=0;
    if(action == "max")
    {
        dlg.width = dlg.offsetWidth; 
        dlg.height = dlg.offsetHeight;
        dlg.top = dlg.style.top; 
        dlg.left = dlg.style.left;
      
        height = jQuery(window).height();
        width = jQuery(window).width();
        top = jQuery(window).scrollTop();
        // for Mobile App case, where VUD is aligned to Top for Max mode
        // making it as a common code
        left = 0;
        dispMode = "none"; //No I18N
    }
    else if(action == "min")
    {
        height = dlg.height;
        width = dlg.width;
        top = dlg.top;
        left = dlg.left;
        dispMode = "";
    }
    dlg.maxBtn.style.display = dispMode;
    dlg.minBtn.style.display = (dispMode == "") ? "none" : "";
    dlg.resizeLR.style.display = dispMode;
    dlg.resizeTB.style.display = dispMode;
    dlg.corner.style.display = dispMode;
    ZDBDialogUtil.initContants();
    ZDBUtil.setElPos(dlg,[height,width,top,left]);
    ZDBUtil.setElPos(dlg.bodyContent,[height - (ZDBDialogUtil.titleBarHeight) ,width]);
    
    if(dlg.bodyContent.editGridHolder != null)
    {
      ZDBDialogUtil.resizeEditDesignDialog(dlg, height, width);
      dlg.isMaximized = (action === "max"); //No I18N
    }
    else if(ZDBDialogUtil.focusDialog.view.dialogStatus && ZDBDialogUtil.focusDialog.view.dialogStatus > 0)
    {
        ZDBInlineDialog.resizeDialog();
        ZDBDialogUtil.resizeVUDGrid(dlg,height,width);
    }
    else if(dlg.bodyContent.gridHolder != null)
    {
        ZDBDialogUtil.resizeVUDGrid(dlg,height,width);
    }
}

ZDBDialogUtil.initContants = function()
{
	if(ZDBDialogUtil.toolbarHeight)
	{
		return;
	}
	ZDBDialogUtil.toolbarHeight = 38;
	ZDBDialogUtil.titleBarHeight = 40;

}
