//$Id $
ZADynamicDrillList = new function()
{
  this.dynamicDrillDownJS =   function(event,TypeParam) 
  {
	    var src =ZDBUtil.getSourceElement(event);
		var view  = ZDBClientUI.getViewObj(src, "view");
		var absPos = ZDBUtil.getElementAbsolutePos(src);
		if((!(ZDBGlobal.isDynDrillEnabled)) ||(view.editMode) || !view.permissions.drilldown)
			{
				return ;
			}
		var dynCompType;var extraParams = null; 
			if(TypeParam === "LABELDRILL")
			{
				extraParams =  view.lblcriteria;
				dynCompType = "LABELDYNDRILL";           // NO I18N
			}
			else
			{
				extraParams =  view.clrCriteria;
				dynCompType = "CHARTDYNDRILL";           // NO I18N
			}
		if(!view.zrsDrillObj)
		{
			view.zrsDrillObj={};
			view.zrsDrillObj.drillLevel = 0;
			view.zrsDrillObj[dynCompType]={};
		}
		
		if(view.zrsDrillObj[dynCompType])
		{
			
			if((view.zrsDrillObj[dynCompType].listEl !== null && view.zrsDrillObj[dynCompType].listEl !== undefined) && jQuery(view.zrsDrillObj[dynCompType].listEl).is(':visible'))
			{
				return;
			}
			else if ( view.zrsDrillObj[dynCompType].fetchStatus ===2 || view.zrsDrillObj[dynCompType].fetchStatus === "loading")
		   {
			if(view.zrsDrillObj && view.zrsDrillObj[dynCompType].listEl)
			{
				var src =ZDBUtil.getSourceElement(event);
				var comp = view.zrsDrillObj[dynCompType].listEl;
				comp.setAttribute("criteria",extraParams);
				ZADynamicDrillList.compReset(comp);
				ZADynamicDrillList.showdynDrillComp(comp,view,src);
				return;
			}
		   }
		  else if(view.zrsDrillObj[dynCompType].fetchStatus === 1)
		  {
			return ;   
		  }
		}
		else
		{
			view.zrsDrillObj[dynCompType]={};
		}
		view.zrsDrillObj[dynCompType].fetchStatus = 1;		
	    ZADynamicDrillList.constructdeforDummyDrillComp.call(view , event, extraParams,dynCompType);

	}
  
  this.getDefDrillDet = function(dynCompType,view)
  {
	  var lbldrillarr = view["lblDrillarr"];
	  var clrdrillarr = view["clrDrillarr"];
	  var lbldrillchck = lbldrillarr!= null && lbldrillarr != undefined && lbldrillarr.length != 0;
	  var clrdrillchck = clrdrillarr != null && clrdrillarr != undefined && clrdrillarr.length != 0 ;
      if(!lbldrillchck && !clrdrillchck)
	  {
		  return null ;
	  }
	  if(!(ZDBGlobal.isDynDrillEnabled))
	  {
		return ;
	  }
	 if(dynCompType === "LABELDYNDRILL")
	 {
		return lbldrillarr;
	 }
	else if(dynCompType === "CHARTDYNDRILL")
	{
	    if(view.drillDet.isClrDynDrillable && (clrdrillarr!==  null && clrdrillarr !== undefined && clrdrillarr.length !==0) )
		{
		return clrdrillarr;
	    }
		else if (view.drillDet.isClrDynDrillable )
		{
			return lbldrillarr;
		}
		else return  null;
	}
  }
  this.constructdeforDummyDrillComp = function(event,criteria,dynCompType)
  {
	   var view = this;
	   var src =ZDBUtil.getSourceElement(event);
	   var defDrillDet = ZADynamicDrillList.getDefDrillDet(dynCompType,view);
	   var  inidynview= new DynamicDrillView(null,view,dynCompType) ;
	   var  inicontroller=new DynamicDrillController(null,inidynview,dynCompType);
	   
	   var MoreDrillList= document.createElement("ul");//NO I18N
	   MoreDrillList.setAttribute("class","refColUi");//NO I18N
	   MoreDrillList.style.cssText += ZDBGlobal.IS_MOBILE ?  "margin-top: 2px !important ; text-indent :0px" : "text-indent :0px" ; //NO I18N
	   MoreDrillList.style.paddingTop = ZDBGlobal.IS_MOBILE ? MoreDrillList.style.paddingTop : "3px"; // NO I18N
	   MoreDrillList.style.minWidth=  200 + "px";//NO I18N
	   var otherdrillCheck = false;
	   if(defDrillDet != null && defDrillDet.length > 0)
	   {
	    for(var i =0 ;i<defDrillDet.length ; i++) 
		  {
			  var val =  defDrillDet[i];
			  var defdrillcheck = val["DefDrillCol"];
			  if(view.drillDet.isdynDrillreq === false)
			  {
			   if(defdrillcheck === "false" || val["otheropspresent"] === true)
			   {
				otherdrillCheck=true;
				var colElem =  inidynview.constructsuggesteddrillMenu(val,val.TABLE_NAME);
				MoreDrillList.appendChild(colElem);
				inidynview.moreDrillColDiv.removeAttribute("class");
				inidynview.moreDrillColDiv.style.cssText+="padding-left:0px!important ;min-height:0px;"; //NO I18N    
				inidynview.moreDrillColDiv.appendChild(MoreDrillList);
				inidynview.outer.Seperator.style.display="block";
				inidynview.moreDrillColDiv.style.display="block";
			   }
			   if(defdrillcheck === "true")
			   {
		        inidynview.constructsuggesteddrillMenu(val,val.TABLE_NAME,true)
			   }
			  }
			  else
			  {
			   if(defdrillcheck === "false")
			   {
				continue ;
			   }
			  inidynview.constructsuggesteddrillMenu(val,val.TABLE_NAME,true);  
			  }
		   }
	     inidynview.sortandAppendsuggestedDrill(false);
	   }
	     inidynview.outer.setAttribute("criteria",criteria);
		 var srcElem = ZDBUtil.getSourceElement(event);
		 if(view.drillDet.isdynDrillreq === false)
		 {
		   if(otherdrillCheck === false)
		    {
			   
			   inidynview.outer.Seperator.style.display = "none";
			   inidynview.moreDrillColDiv.style.display = "none";
			   inidynview.moreDrillColDiv = null;
			}
		   inidynview.loadingDiv.style.display = "none";
		   ZADynamicDrillList.showdynDrillComp(inidynview.outer,view,src);
		   inidynview.outer.setAttribute("criteria",criteria);
		   if(view.zrsDrillObj[dynCompType])
			{
				view.zrsDrillObj[dynCompType].listEl = inidynview.outer;
				view.zrsDrillObj[dynCompType].fetchStatus = 2;
			}
		   inidynview.outer.setAttribute("loaded","true");
		   return ;
		 }
	
		 ZADynamicDrillList.showdynDrillComp(inidynview.outer,view,src);
		 view.zrsDrillObj[dynCompType].listEl = inidynview.outer;
		 view.zrsDrillObj[dynCompType].fetchStatus = "loading";
	   
		ZADynamicDrillList.dynamicDrillDownJSState.call(view , event, criteria,dynCompType,inidynview,inicontroller);
  }
  this.dynamicDrillDownJSState = function(event, criteria,dynCompType,inidynview,inicontroller) 
  {
		
	    var viewCtx = this.viewCtx;
	    var xml = ZDBAnalysisConfig.getCurrentConfig(this, true,null,true);        
	    var viewParams = this.getViewParams();    
	    var oLap = this.overlap ? "&OVERLAP=true" : ""; // NO I18N
	    var parViewId = this.parentViewId;
	    var clickType = (dynCompType === "LABELDYNDRILL") ? "&CLICKTYPE=LABELCLICK" : "&CLICKTYPE=CHARTCLICK";     // NO I18N
	    var daoKey = this["DaoKey"];  // NO I18N
	    daoKey = (daoKey!== null && daoKey !== undefined) ? "&DAOKEY="+daoKey : "";   // NO I18N
	    oLap = ""; // handle overlap in next milestone
	
	    var url = "/ZADrillFields.ve?"//NO I18N
	                    +viewParams 
	                    + oLap     
	                    + clickType 
	                    + daoKey ;
	                   
		var view = this;
		var src = ZDBUtil.getSourceElement(event);
		//var opstatusid = (dynCompType === "LABELDYNDRILL") ? "LabelmoreDrillColDiv" : "ChartmoreDrillColDiv"; //NO I18N
		var loadingDiv = inidynview.outer.loadingDiv;
		AjaxAPI.sendRequest({
			URL : url,
			POSTBODY : xml,
			REQUESTHEADERS : {
			"Content-type" : "text/xml;charset=utf-8"},// NO I18N
	        ONSUCCESSFUNC : ZADynamicDrillList.handleDynDrillFieldsReq,
			VIEW : view,
			CRITERIA : criteria,
			SOURCEEL : src,
			COMPTYPE : dynCompType,
			EVENT : event,
			OPSTATUSID : loadingDiv,
			DYNAMICDRILLVIEW:inidynview,
			DYNAMICCONTROLLER:inicontroller,
			MAINOBJ         :ZADynamicDrillList
		});
		
	};

this.handleDynDrillFieldsReq = function(response, requestOptions) {
	        var _this = requestOptions["MAINOBJ"];
			var dynCompType=requestOptions["COMPTYPE"];
			var srcElem =requestOptions["SOURCEEL"];
			var view = requestOptions["VIEW"];
			var jsonResp = JSON.parse(response.responseText);
			var criteria = requestOptions["CRITERIA"];
			var event = requestOptions["EVENT"];
			var data = jsonResp["base"];
			view=requestOptions["VIEW"];
			var colDet = data.colDet;
			
	        var inidynview = requestOptions["DYNAMICDRILLVIEW"];
	        var inicontroller = requestOptions["DYNAMICCONTROLLER"];
			model=new ZAFieldsAdapterModel(data,view,"DrillDown");  //NO I18N
			inidynview.moreDrillColDiv.style.cssText+="padding-top: 0px;padding-bottom: 0px";// NO I18N
		    dynview= inidynview.initDrillView(model);
			controller= inicontroller.initdrillController(model);
			var basetblobjId = data["basetblObjId"];
			dynview.outer.setAttribute("loaded","true");
			if(jQuery.isEmptyObject(colDet))
			{
				if(view.zrsDrillObj[dynCompType])
				{
				view.zrsDrillObj[dynCompType].fetchStatus = 2;
			    }
				return ;
			}
			if(basetblobjId !== undefined)
			{
				model.setBaseTable(basetblobjId);
			}
			else
			{
			model.setBaseTable(data.relDet[0].parent);
			}
			dynview.outer.setAttribute("criteria",criteria);
			if(view.zrsDrillObj[dynCompType])
		    {
			view.zrsDrillObj[dynCompType].fetchStatus = 2;
		    }
			 var moreDrillColDiv = dynview.moreDrillColDiv;
		}
this.sendDynamicDrillDownReq = function(event,view,dynCompType,submenuEl) {		
    	var op;		
    	var source = ZDBUtil.getSourceElement(event);
    	var parentElem = DOMUtils.getSelfOrParentWithAttrValue(source,"drillCol","true");  // NO I18N
    	var compelName = ZDBGlobal.IS_MOBILE || true ? "DynDrillMobComp" : "DynDrillComp" ; // NO I18N
    	var comp=DOMUtils.getSelfOrParentWithAttrValue(source,"elname",compelName);  // NO I18N
    	
    	if(source.getAttribute("submenuel"))
    	{
    		var subMenusrc= comp.submenu.colsrc;
    		submenuEl=DOMUtils.getSelfOrParentWithAttrValue(submenuEl,"listel","true");// NO I18N
    	   op =submenuEl.getAttribute("operation");
    	   src=subMenusrc;
    	}
    	else
    	{
    	src=parentElem;
        op= parentElem.getAttribute("operation");
    	}
    	if(op === null || op == undefined || op === "null")
        {
    		ZDBUtil.stopEventBubble(event);
    		return;
        }
    	var criteria = comp.getAttribute("criteria");
    	var view = view;
    	var dispVal = criteria;
    	ZDBAnalysisView.setBreadCrumb(view, dispVal);
    	var extraParams = {
    		DCCID : src.getAttribute("COLUMNID"),
    		DCAOT : src.getAttribute("ADDONTYPE"),                  //NO I18N
    		DCOP  :  op,                    
    		DCTID : src.getAttribute("PARENT_OBJ_ID")
    	};
    	new ZRSDrillDown(criteria, view, "LABELDRILL", null, dispVal, extraParams); //NO I18N
        view.refreshView();
    	ZRSDrillDown.disableSettings(view);
    	ZRSMenu.closeAllMenu();
 }
this.compReset= function(comp)
    {
    	comp.sliderelBottom=0;
    	var ShowMoreContainer= comp.dynview.ShowMoreOrLess;
    	var SearchField = comp.dynview.SearchField;
    	var searchBox = comp.drillSearchBx;
    	var SubMenu = comp.submenu;
		 if(SubMenu !== null && SubMenu !== undefined)
		 {
		  var datecolumn = SubMenu.colsrc;
		  var subfuncMarker = datecolumn.subfuncMarker;
		  if(subfuncMarker !== null && subfuncMarker !== undefined)
		  {
		   subfuncMarker.style.backgroundPosition="0px -2706px"; // NO I18N
		  }
		  if(datecolumn !== null && datecolumn !== undefined)
		  {
		   datecolumn.setAttribute("subMenuexpanded","false");
		  }
		 }
    	if(searchBox)
    	{
    	 searchBox.value = ZDBI18NMap.g("zrpt.chart.dyndrilldown.js.SearchDrillCol");
    	}
    	jQuery(searchBox).css("color","#888"); // NO I18N
    	var SearchIcon =   DOMUtils.getFirstMatchingChild( SearchField,"div","id","ZDBDynDrillSearchButton"); // NO I18N
    	var showMoreIcon =  DOMUtils.getFirstMatchingChild( ShowMoreContainer,"a","id","ZAShowMoreLessFields"); // NO I18N
    	var evtype = ZDBGlobal.IS_MOBILE ? "touchend" : "click"; // NO I18N
    	if(SearchIcon.getAttribute("elType")==="ClearSearch")
    	{
    		jQuery(SearchIcon).trigger(evtype);
    	}
    	if(showMoreIcon.getAttribute("showMore") == "true")
    	{
    	 jQuery(showMoreIcon).trigger(evtype);
    	}
    	jQuery(SearchIcon).trigger(evtype);
    	if(comp.submenu)
    	{
    		comp.submenu.style.display = "none";
    	}
    }  
this.showdynDrillComp = function(component,view,src)
{
	view.currentDlg = component;
    var srcLeft = src.srcMenu.pointX;
    var srcTop = src.srcMenu.pointY;
    var isIPhone = BROWSER.IS_MOBILE_PHONE ; 
    component.style.display = "block";
    component.style.visibility = "hidden";
    document.body.appendChild(component);
    component.iniHeight =component.iniHeight ? component.iniHeight : component.offsetHeight
    var compHGt = component.iniHeight  ;
    var compwth = component.offsetWidth ;
    component.style.visibility = "";
    var dashDiv = (view.viewCtx.dashView) ? view.viewCtx.dashView.dashDiv : null ;
    var isDashBoard = dashDiv ? true :false ;
    
    var dashChild = isDashBoard ? view.viewCtx.dashChildDiv : null ; 
    
    
    var outerDiv = isDashBoard ? (BROWSER.IS_MOBILE_PHONE  &&  view.viewCtx.dashView.viewCtx.isStandAlone() ? dashChild : window) : view.viewComp; 
    var outerDivLeft = outerDiv != window ? ZDBUtil.getObjLeft(outerDiv) : 0; 
    var outerDivTop = outerDiv != window ? ZDBUtil.getObjTop(outerDiv,true) : document.body.scrollTop; 
    var outerDivCentre = outerDiv != window ? ZDBUtil.getObjTop(outerDiv,true) + (outerDiv.offsetHeight)/2 : document.body.scrollTop + (window.innerHeight)/2; var outerDivBottom = outerDiv != window ? ZDBUtil.getObjTop(outerDiv) + (outerDiv.offsetHeight) : document.body.scrollTop + window.innerHeight; 
    
    
    var cmpHgt = ZDBGlobal.IS_MOBILE ? 320 : 300 ; 
    
    var top = document.body.offsetHeight -srcTop > cmpHgt ? srcTop :(srcTop < cmpHgt ? (document.body.offsetHeight - 200)/2 : null); 
    var bottom =top === null ? document.body.offsetHeight -srcTop -5:null ; 
    var prntDiv = null ;
    
    if( ZDBGlobal.IS_MOBILE && isDashBoard &&  view.viewCtx.dashView.viewCtx.isStandAlone()) 
    { 
        var top = outerDivBottom- document.body.scrollTop-srcTop > cmpHgt ? srcTop + document.body.scrollTop 
                  :(srcTop + document.body.scrollTop - outerDivTop < cmpHgt ? (outerDivCentre - 100 ) : null); 
        var bottom =top === null ? document.body.scrollHeight -(srcTop + document.body.scrollTop) - 10:bottom ; 
    } 
    var chckwidth = outerDiv != window ? outerDiv.offsetWidth : window.innerWidth ; 
    var xchck = (srcLeft - outerDivLeft) + compwth ; 
    var left = xchck > chckwidth ? (srcLeft - compwth < outerDivLeft ? (chckwidth - compwth)/2 :srcLeft - compwth ):srcLeft ;
    
	 var remvfunc = function(event){
        var srcElem = ZDBUtil.getSourceElement(event);
        var isdlgparent = DOMUtils.getSelfOrParentWithAttrValue(srcElem, "isdialog", "true"); //NO I18N
        if(isdlgparent)
        {
         return ;
        }
        ZDBDialogUtil.closeDialog()
       }; 
     
    var onorientationchange = function(event)
   	{
	   setTimeout(function()
	   {
		     var top = ZDBGlobal.IS_MOBILE && isDashBoard &&  view.viewCtx.dashView.viewCtx.isStandAlone() ? 
	         		  document.body.scrollTop + (window.offsetHeight - cmpHgt)/2 :(document.body.offsetHeight - cmpHgt)/2 ;
	         var left = (document.body.offsetWidth - compwth)/2
	         dlg.params["LEFT"] = left;
	         dlg.params["TOP"] = top;
	         dlg.params["BOTTOM"]=null ;
	         ZDBDialogUtil.positionCenter(dlg); 
        },200);
   	 }
    var onclosefn = function(){
    	if(ZDBGlobal.IS_MOBILE && !(BROWSER.IS_MOBILE_PHONE && view.viewCtx.dashView))
    	{
         window.removeEventListener("orientationchange" ,onorientationchange);
    	}
     return true ;		  
    }
	ZRSMenu.closeAllMenu();
	var dlg = ZDBDialogUtil.showDialog(component,{TITLE:ZDBI18NMap.g('zrpt.common.js.drilldowndyndrillJSTitle'),DONTREMOVE:true, MODAL : true ,ADDFRAME:true,VIEW:view,DLGBODY:"MobDynDrillDialogbdy",NOFOCUS:true,TOP:top,LEFT :left,BOTTOM : bottom });// NO I18N
	dlg.orientfn = onorientationchange ;
	if(ZDBGlobal.IS_MOBILE && !(BROWSER.IS_MOBILE_PHONE && view.viewCtx.dashView))
	{
	window.addEventListener("orientationchange" ,onorientationchange);
	}
	dlg.dlgTitleBar.style.cssText +=  "background-color : rgba(0, 0, 0, 0) ;padding : 9px 10px 8px 10px";// NO I18N
	var evtype = ZDBGlobal.IS_MOBILE ? "touchend" : "click"; // NO I18N
	jQuery(dlg.freezeLayer).bind(evtype,remvfunc)
	component.dlg = dlg ;
	var isloaded =component.getAttribute("loaded");
	this.dlg = dlg ;
	dlg.setAttribute("id","DyndrillDialog");
	dlg.comp = component ;
}
}


