//$Id$
//NOTE: Do not include any embed mode related methods in this file
var ZDBHeader = new function()
{
  this.showUpgradeBarBasedOnState = function()
    {
        if(getCookie("SHOW_UPGRADEBAR")==null){
            setCookie('SHOW_UPGRADEBAR', "true", null,'/');
            }
        if($("ZDBUpgradeBar") != null){
            $("ZDBUpgradeBar").style.display = (getCookie("SHOW_UPGRADEBAR")=="false") ? "none" : ""; //No I18N
        }
        jQuery("#ZDBMainContainer").css("top", jQuery("#ZDBHeader").outerHeight(true));//No I18N
        ZRUserAnalyticsAttacher.attachUAToTopBanner();
    }

    this.showNotification = function()
    {
      if(getCookie("SHOW_NOTIFICATION") == null || getCookie("SHOW_NOTIFICATION") == "null") //No I18N
      {
    	  ZDBMsgBox.showHintMsg(ZDBI18NMap.f("zrpt.header.nofication.js.ie",ZDBGlobal.PRODUCT_NAME),"notification",25000); //No I18N
        setCookie('SHOW_NOTIFICATION', "false", null,'/'); //No I18N
      }
    }

    this.hideUpgradeBar = function()
    {
        $("ZDBUpgradeBar").style.display = "none";
        setCookie('SHOW_UPGRADEBAR', "false", null,'/');
        document.body.prevClientHeight = 0;
        var placeHolder = document.getElementById("ZDBPLACEHOLDER");
        if(placeHolder)
        {//This check is in assumption that PLACEHOLDER will not be available in Home Page
            ZDBClientUI.resizeAllDInst();
        }
        else if(jQuery('#ZDBHomeContainer').length)
        {//HomePage Resize
            ZRSHomeUtil.resizeHolders(); 
        }
        else
        {
            ZDBClientUI.resizeMain();
        }
    }

  this.hideBannerForPaid = function(el,event)
  {
        ZDBHeader.hideUpgradeBar();
        var connVer = el.getAttribute("currentVer");
        var url = "/ZDBUserAction.ma?ZDBACTION=HIDEBANNER&CONNECTORVER="+connVer; //No I18N
        AjaxAPI.sendRequest({URL:url, ONFAILUREFUNC:ZDBHeader.blogPostDummyFunction});

  }

  this.blogPostDummyFunction = function(response, requestOptions)
  {
  }

  this.logoutAction = function()
  {
      setCookie('SHOW_UPGRADEBAR', null, null,'/');      //No I18N
      setCookie('SHOW_NOTIFICATION', null, null,'/');      //No I18N
      setCookie("APPCHECKSHOWN",null);//NO I18N
  }

	this.triggerLogoLink = function(el)
	{

		var redirectUrl = el.getAttribute("redirectURL");
		if(redirectUrl!=null && redirectUrl!=""){window.location = redirectUrl;}
	}
  
  this.reload = function()
  {
	  window.location.reload();
  }
  
  this.showDatabases = function(el, event, fromSearch)
  {
        var menu = jQuery("#ZRSDBMenu"); //No I18N
        if(menu.is(':visible'))
		{
            ZDBHeader.closeDBList(event);
  		    return;
		}
        if(ZDBHeader.dbList) {
	       ZDBHeader.showDBMenu(ZDBHeader.dbList, 1 , null, event, true);
           event.stopPropagation();
           return;
        }
        AjaxAPI.sendRequest({URL:"/ZDBListDatabases.ve?ZDBACTION=SHOWDATABASES",
                            EVENT:event,METHOD:"GET",//No I18N
                            ONSUCCESSFUNC:ZDBHeader.createDBMenu});
  }
  
  this.createDBMenu = function(response, requestOptions)
  {
	  ZDBHeader.dbList = (ZDBHeader.dbList) ?  ZDBHeader.dbList : JSON.parse(response.responseText);
	  var event = requestOptions.EVENT;
	  ZDBHeader.showDBMenu(ZDBHeader.dbList, 1 , null, event);
  }
  
  //menuType : 1 - New menu;  2 - Drop and add menulist(search) 3 - Append new menulist in the opened menu  
  //dbTypeInt && SearchType:  0 - All Databases;  1 - My Databases;  2 - Shared Databases

  this.dbType = {1 : '', 2 : ZDBI18NMap.g("zrpt.header.dblistmenu.js.shared")}; //No I18N
  
  this.showDBMenu = function(dbList, menuType, seachInfo, event, isAlreadyAvail)
  {
	  var menuEl = jQuery("#ZRSDBMenu"); //No I18N
	  var dbListParentEl = jQuery("#ZRSALLDBList"); //No I18N
	  var ulEl = dbListParentEl.find("ul"); //No I18N
	  var listEl = jQuery("<li><div class='ZRSDBMenuItem ZRSBorderBottom'><a class='fLeft ellipsis' style='width:200px;'></a><span class='gray ellipsis'></span></div></li>");
	  var anchorEl = listEl.find("a");
	  var searchBox = $("ZRSDBSearchBox");  //No I18N
	  var searchComp = jQuery("#ZRSDBSearchComp"); //No I18N
	  
	  var dbSize = dbList.length;
	  dbSize = (dbSize > 25) ? 25 : dbSize;
	  if(!isAlreadyAvail) {
          if(menuType != 3)
          {
              ulEl.empty();
          }

          for(var i = 0; i < dbSize; i++)
          {
              var dbId = dbList[i][0];
              var dbName = ZDBEscapeUtil.encodeForHtml(dbList[i][1]);
              var dbTypeInt = dbList[i][2];
              anchorEl.html(dbName).attr('href',ZDBGlobal.REPORTS_CONTEXT_NAME+'/ZDBDataSheetView.cc?DBID='+dbId); //No I18N		  
              anchorEl.next().html(ZDBHeader.dbType[dbTypeInt]);
              listEl.attr('tip', dbList[i][1]); //No I18N
              listEl.attr('DBID', dbId); //No I18N
              var menuItem = listEl.clone();
              if(ZDBClientUI.dbId == dbId)
              {
                  menuItem.find('div').addClass('ZRSMenuHover'); //No I18N
                  menuItem.find('a').removeAttr('href'); //No I18N
              }
              menuItem.appendTo(ulEl);		   
          }
      }
	  var listEls = ulEl.find('li');
	  var listSize = listEls.size();
	  if(listSize > 10)
	  {
		  dbListParentEl.css({'height' : '310px', 'overflow-y' : 'scroll','overflow-x' : 'hidden'}); //No I18N
		  searchComp.show();
	  }
	  else
	  {
	  	var searchValue = ZDBSearchUtil.getSearchValue(searchBox);
		  var searchType = searchBox.searchType;
		  if(searchValue == null && searchType == 0)
		  {
		  	searchComp.hide();  //No I18N
		  }
		  dbListParentEl.css({'height' : '', 'overflow-y' : 'hidden','overflow-x' : 'hidden'}); //No I18N
	  }
	  
	  if(menuType == 1)
	  {
		  var srcEl = jQuery('#ZRSDBInfo'); //No I18N
		  menuEl.show();
		  ZRSMenu.position(menuEl, srcEl, 5, event);
		  var top = srcEl[0].offsetTop +srcEl[0].offsetHeight ;
		  menuEl.css({top:top + 10});
		  if(ZDBGlobal.ISNEWLAYOUT) {
                    menuEl.css({"top": top}); //No I18N
                  }
		  searchBox.searchType = 0;
		  jQuery(searchBox).val("").focus(); //No I18N		  
		  
		 if(!isAlreadyAvail) {
            jQuery(document).bind("click",ZDBHeader.closeDBList); //No I18N
            jQuery(document).bind("keyup",ZDBHeader.keyHandling); //No I18N
         }
	  }
	  if(menuType != 3)
	  {
	  	dbListParentEl.scrollTop(0);
	  }
	  var tooltipTime = 0;
	  listEls.hover(
		  function(event)
		  {
			  var el = jQuery(this);
			  el.addClass('ZRSMenuHover'); //No I18N
			  var anchor = el.find('a')[0];
			  if(anchor.scrollWidth > anchor.clientWidth)
			  {
				  tooltipTime = setTimeout(
						  function()
						  {
							  ZDBToolTip.show(el, event);
						  },1000,el,event);
			  }
		  },
		  function(event)
		  {
			  jQuery(this).removeClass('ZRSMenuHover'); //No I18N
			  clearTimeout(tooltipTime);
			  ZDBToolTip.hide(this,event);
		  }); //No I18N
  }
  
  this.keyHandling = function(event)
  {
    if (!event)
    {
    	event = window.event;
		}
		if (event.keyCode == 27) //Escape key
		{
			ZDBHeader.closeDBList(event, true);
			return;
		}
		else if (event.keyCode == 13) //Enter key
		{
			ZDBHeader.searchDatabases(event, null);
			return false;
		}
		else
		{
			var searchEl = $('ZRSDBSearchBox');
			var value = ZDBSearchUtil.getSearchValue(searchEl);
			var clearIcon = jQuery("#ZRSDBMenu").find('.ZRSSearchClearIcon'); //No I18N
			if (value == null || value == "")
			{
				clearIcon.hide(); // No I18N
			}
			else
			{
				clearIcon.show(); // No I18N
			}
		}
		return true;
	}
  
  this.closeDBList = function(event, isClose)
  {
	  var tarEl = event ? ZDBUtil.getSourceElement(event) : null;
	  if(tarEl && !isClose)
	  {
		  var el = jQuery(tarEl);
		  var searchEl = el.closest("[id='ZRSDBSearchComp']"); //No I18N
		  var searchMenu = el.closest("[id='ZRSDBSearchMenu']"); //No I18N
		  if(searchEl.size() > 0 || searchMenu.size() > 0)
		  {
			  return;
		  }
	  }
	  jQuery('#ZRSDBMenu').hide(); //No I18N	  
	  ZDBHeader.resetSearch();

  }

  var loadOnScroll = 0
  var lastScrollTime = 0;
  var currentScrollTime = 0;
  this.scrollDBList = function(event)
  {
	
  	var dbListParentEl = jQuery("#ZRSALLDBList"); //No I18N
  	if(dbListParentEl.scrollTop() + dbListParentEl.innerHeight() >= dbListParentEl[0].scrollHeight) //check scroll end. 
  	{
  		var lastEl_dbId = dbListParentEl.find('li:last').attr('DBID'); //No I18N  		
  		var index = ZDBHeader.getIndex(lastEl_dbId);
  		
  		//passing param in settimeout function(below commented funciton) is not working in ie9
  		//setTimeout(ZDBHeader.searchDatabases, 200, event, index + 1);
  		currentScrollTime = (new Date()).getTime();
  		if(lastScrollTime == 0 || ((currentScrollTime - lastScrollTime)>200)){
  			lastScrollTime = currentScrollTime;
	  		loadOnScroll = setTimeout(
					  function()
					  {
					  	ZDBHeader.searchDatabases(event, index + 1);
					  },200,event, index + 1);
  		}
  	}  	
  }
  
  this.getIndex = function(searchId)
  {
  	var size = ZDBHeader.dbList.length;
		for(var i = 0; i < size; i++)
		{
			var dbId = ZDBHeader.dbList[i][0];
			if(dbId == searchId)
			{
				return i;
			}
		}
		return size;
  }
  
  this.searchDatabases = function(event, index)
  {
	  
	  var searchBox = $('ZRSDBSearchBox');
	  var searchValue = ZDBSearchUtil.getSearchValue(searchBox);
	  var searchType = searchBox.searchType;
	  var searchDBList = [];
	  var size = ZDBHeader.dbList.length;
	  var i = 0;
	  var menuType = 2;
	  if(index)
  	{
	  	i = index;
	  	menuType = 3;
  		clearTimeout(loadOnScroll);
  	}
	  for(; i < size && searchDBList.length <= 25; i++)
	  {
		  var dbName = ZDBHeader.dbList[i][1];
		  var dbType = ZDBHeader.dbList[i][2];
		  var allowSearch = (searchType == 0 || searchType ==  dbType)
		  if(allowSearch)
		  {
		  	if(searchValue == null || dbName.toLowerCase().indexOf(searchValue.toLowerCase()) > -1)
	  		{
		  		searchDBList.push(ZDBHeader.dbList[i]);
	  		}			  
		  }
	  }
	  ZDBHeader.showDBMenu(searchDBList, menuType, [searchValue, searchType], event);
  }
  
  this.showDBSearchMenu = function(el,event)
  {
	  var menuEl = ZDBContentCache.appendAndGet("DBSearch_Menu","GridMenu",document.body);  //No I18N
	  ZRSMenu.showMenu(event, el, menuEl, 5);	  
  }
  
  this.setSearchType = function(el, searchType, event)
  {
	  var textBox = jQuery("#ZRSDBSearchBox"); //No I18N
	  textBox[0].searchType = searchType;
	  var tipValue = jQuery(el).attr('tipValue'); //No I18N
	  textBox.attr("tipvalue", tipValue); //No I18N 
	  if(textBox.attr("tipshown").toString()==="true") //No I18N 
	  {
	  	textBox.attr("value", tipValue); //No I18N  
	  }
	  jQuery('#ZRSDBSearchMenu').find("span").removeClass("sortTickMenu"); //No I18N  
	  jQuery(el).find("span:first").addClass("sortTickMenu"); //No I18N
	  ZDBHeader.searchDatabases(event, null);
  }
  
  this.clearSearch=function(el, event)
  {
  	jQuery('#ZRSDBSearchBox').val("").focus();  //No I18N
		jQuery(el).hide(); //No I18N    
		ZDBHeader.searchDatabases(event, null);
		ZDBUtil.stopEventBubble(event);
  }
  
  this.resetSearch = function()
  {
	  var textBox = jQuery('#ZRSDBSearchBox'); //No I18N
	  var defaultTip =textBox.attr("defaulttip"); //No I18N
	  textBox.attr("tipvalue", defaultTip); //No I18N 
	  if(textBox.attr("tipshown").toString()==="true") //No I18N 
	  {
	  	textBox.attr("value", defaultTip); //No I18N  
	  }
	  textBox.siblings('.ZRSSearchClearIcon').hide(); //No I18N
	  var searchMenu = jQuery('#ZRSDBSearchMenu'); //No I18N
	  if(searchMenu.size() > 0) //if search menu not opened. menu will not be attached to the document
  	{
	  	searchMenu.find("span").removeClass("sortTickMenu"); //No I18N
	  	searchMenu.find("li:first span:first").addClass("sortTickMenu"); //No I18N
  	}
  }
  
}
