//$Id$

var ZRSHomeUtil = new function()
{

}

jQuery(window).mousemove(function(event){
    ZRSHomeUtil.curMouseEvent = event;
})

jQuery.fn.hasVerticalScrollBar = function() {
    return this.get(0).scrollHeight > this.height();
}

ZRSHomeUtil.handleFooter = function()
{
    var className = "ZRSFooter"; // NO I18N
    if($("ZRSFooter")){
    $("ZRSFooter").className = className;
    var homeContainer = jQuery("#ZDBHomeContainer"); // NO I18N
    if(homeContainer.length>0)
    {
    	className = (!homeContainer.hasVerticalScrollBar()) ? "ZRSFooterFixed" : className; //No I18N
    }
    $("ZRSFooter").className = className;
    }
}

//Handling Tip
ZRSHomeUtil.handleShowDBOptsTip = function(el,event)
{
    ZRSHomeUtil.showDBOptsTip(el,event);
}

ZRSHomeUtil.showDBOptsTip = function(el,event)
{
    jQuery(el).find("div.ZDBDBOptsTip").stop(true,true).fadeIn(300);
}

//DB Options Slide Show Params
ZRSHomeUtil.currentPage = 1;
ZRSHomeUtil.initDBOptsVariables = function()
{
ZRSHomeUtil.wrapper = jQuery("#ZDBDBOptsDiv");//No I18N
ZRSHomeUtil.opts = jQuery("ul.DBCreateOpts li:visible");//No I18N
ZRSHomeUtil.single = ZRSHomeUtil.opts.filter(':first');//No I18N
ZRSHomeUtil.singleWidth = ZRSHomeUtil.single.outerWidth(true);
}

ZRSHomeUtil.initializeSlideShowVar = function()
{
    //DB Options Slide Show Params
    ZRSHomeUtil.visible = Math.ceil(ZRSHomeUtil.wrapper.innerWidth() / ZRSHomeUtil.singleWidth);
    ZRSHomeUtil.pages = Math.ceil(ZRSHomeUtil.opts.length / ZRSHomeUtil.visible);
    ZRSHomeUtil.handleSlideNavigButtons();
}

ZRSHomeUtil.handleSlideNavigButtons = function ()
{
    var dbOptsDiv = $("ZRSDBCreateOptsHldr");
    if(!dbOptsDiv){
    	//For CRMPlus trail expired user case, $("ZRSDBCreateOptsHldr") element will not be included in jsp/jspf.
    	return;
    }
    var dbListArrow = dbOptsDiv.getElementsByClassName("arrow")[0];
    var moreOptDisp;
    var isImpDataContShown = ZDBUtil.hasClass(dbOptsDiv,  "toggleImpOptions");
    if(!isImpDataContShown) {
        if(ZRSHomeUtil.pages > 1) {
            moreOptDisp = "block";
            dbListArrow.addEventListener("click", ZRSHomeUtil.listDBOpts, false);
        }
        else {
            moreOptDisp = "none";
            dbListArrow.removeEventListener("click", ZRSHomeUtil.listDBOpts, false);
            var moreOptEl = dbListArrow.children[0];
            if(moreOptEl.className == "ZRSCloseDBList") {
               ZDBUtil.removeClass(dbOptsDiv, "expandDBOpts");
                ZRSHomeUtil.calculateExpDBHeight(dbOptsDiv, false);
                moreOptEl.className = "ZRSDropDBList";
                $("ZDBDatabaseList").style.display = "block";
                ZRSHomeUtil.footerDisplayTransition("block");
            }
        }
         dbListArrow.style.display = moreOptDisp;
    }
   
    
}
ZRSHomeUtil.listDBOpts = function (e) {
    var tarEl = e.target;
    var dbOptsDiv = $("ZRSDBCreateOptsHldr");
    var listDBOpts = (e.tagName == "a") ? tarEl.children[0] : tarEl;
    var databaseList = $("ZDBDatabaseList");
    var footer = $("ZRSFooter");
    var dbList = dbOptsDiv.getElementsByClassName("DBCreateOpts")[0];
    if (listDBOpts.className == "ZRSDropDBList")
    {
        
        databaseList.style.display = "none";
        footer.style.display = "none";
        ZDBUtil.addClass(dbOptsDiv, "expandDBOpts");
        ZRSHomeUtil.calculateExpDBHeight(dbOptsDiv, true);
        listDBOpts.className = "ZRSCloseDBList";
    }
    else if (listDBOpts.className == "ZRSCloseDBList") {
        ZDBUtil.removeClass(dbOptsDiv, "expandDBOpts");
        ZRSHomeUtil.calculateExpDBHeight(dbOptsDiv, false);
        listDBOpts.className = "ZRSDropDBList";
        databaseList.style.display = "block";
        ZRSHomeUtil.footerDisplayTransition("block");
    }
}

ZRSHomeUtil.setDBOptsWidth = function()
{
    var homeContWidth = $("ZDBHomeContainer").offsetWidth;//No I18N
    var margin = 50;
    var dbOptsWidth = homeContWidth - (margin * 2);
    dbOptsWidth = dbOptsWidth - (dbOptsWidth % ZRSHomeUtil.singleWidth) + 30;
    var dbOptsActWidth = ZRSHomeUtil.opts.length * ZRSHomeUtil.singleWidth + 30;
    dbOptsWidth = (dbOptsActWidth < dbOptsWidth) ? dbOptsActWidth : dbOptsWidth;
    var arrowWidth = jQuery(".arrow").outerWidth(true);//No I18N
    jQuery("#ZDBDBOptsDiv").css({opacity: 0.0, visibility: 'visible'}).width(dbOptsWidth).animate({opacity: 1.0}, 500);//No I18N
    var arrowMargin = 10;//10px Extra Space for better visibility
    jQuery("#ZDBDBOptsDiv").parent().width(dbOptsWidth + ((arrowWidth + arrowMargin) * 2));//No I18N
    ZRSHomeUtil.visible = Math.floor(ZRSHomeUtil.wrapper.innerWidth() / ZRSHomeUtil.singleWidth);
    ZRSHomeUtil.pages = Math.ceil(ZRSHomeUtil.opts.length / ZRSHomeUtil.visible);
    ZRSHomeUtil.handleSlideNavigButtons();
}

ZRSHomeUtil.JSONImportDBListConstr = function (ConnList) {
    ZRSHomeUtil.createDBOpts(ConnList);
    ZRSHomeUtil.initDBOptsVariables();
    ZRSHomeUtil.setDBOptsWidth();
}
ZRSHomeUtil.initialSetUp = function(zuid)
{
    ZRSHomeUtil.showRHideDBCreateOpts(zuid);
    ZRSHomeUtil.initDBOptsVariables();
    var homeContainer = jQuery("#ZDBHomeContainer");//No I18N
    homeContainer.css("margin-left", jQuery("#ZDBMinMaxSidebar").outerWidth(true)); //2px  //No I18N
    jQuery("#ZDBMainContainer").css("top", jQuery("#ZDBHeader").outerHeight(true));//No I18N
    $('ZRSFooter').style.opacity = 9 ;
    ZRSHomeUtil.handleFooter();
    if(typeof ZDBVersionCheck != "undefined") {
        ZDBVersionCheck.checkVersionChange(); }
    var selectedTab = jQuery("#ZDBHomeTabs li.buttonSelected");//No I18N
    var loading = jQuery(".ZRSFillLoading");//No I18N
    selectedTab.append(loading);
    loading.width('0%');
    loading.show().animate({width: '100%'}, 100);
    
    
}

ZRSHomeUtil.resizeHolders = function()
{
    ZRSHomeUtil.initDBOptsVariables();
    var homeContainer = jQuery("#ZDBHomeContainer");//No I18N
    homeContainer.css("margin-left", jQuery("#ZDBMinMaxSidebar").outerWidth(true)); //2px//No I18N
    jQuery("#ZDBMainContainer").css("top", jQuery("#ZDBHeader").outerHeight(true));//No I18N
    ZRSHomeUtil.handleFooter();
    //Slideshow Reset to First Page and calculated new widths
    ZRSHomeUtil.wrapper.filter(':not(:animated)').css("visibility","hidden").scrollLeft(0);//No I18N
    ZRSHomeUtil.currentPage=1;    
    ZRSHomeUtil.setDBOptsWidth();
    if(!ZDBClientUI.readOnlyMode){
        var dbOptsDiv = ZDBUtil.getElWithTagNAttrWithVal(homeContainer[0], "id", "ZRSDBCreateOptsHldr", "div");
        if(dbOptsDiv){
        	var toModHeight = dbOptsDiv.getElementsByClassName("ZRSCloseDBList");
        	if(toModHeight.length) {
        		ZRSHomeUtil.calculateExpDBHeight(dbOptsDiv, true);
        	}
        }
    }
}

ZRSHomeUtil.handleWindowResize = function()
{
    if (ZRSHomeUtil.windowResizeTimeout != null)
    {
        clearTimeout(ZRSHomeUtil.windowResizeTimeout);
    }
    ZRSHomeUtil.windowResizeTimeout = setTimeout("ZRSHomeUtil.resizeHolders()", 500);
    return true;
}

ZRSHomeUtil.hideSideBar = function()
{
    var pos = 31;  //Top of ZDBSidebar when fully visible
    var id = setInterval(hideRecentItems,10);
    function hideRecentItems() 
    {
        var sideBar = document.getElementById("ZDBSidebar");    //No I18N
        if (sideBar.offsetLeft == -279) 
        {
            ZRSHomepageListing.slideAnimation = false;  // is set to indicate the slide animation is over
            ZRSHomepageListing.isReItmsVisible = false;
            document.body.removeEventListener("mousemove",ZRSHomepageListing.recentItemsSlide);    //No I18N
            clearInterval(id);
        } 
        else 
        {
            pos -= 10; 
            sideBar.style.left = pos + "px";    //No I18N
        }
    }
}

ZRSHomeUtil.showSideBar = function()
{
    var pos = -279; //Top of ZDBSidebar when fully hidden
    var id = setInterval(showRecentItems,10);
    function showRecentItems() 
    {
        var sideBar = document.getElementById("ZDBSidebar");    //No I18N
        if (sideBar.offsetLeft == 31) 
        {
            ZRSHomepageListing.isReItmsVisible = true;
            ZRSHomepageListing.slideAnimation = false;  // is set to indicate the slide animation is over
            clearInterval(id);
        } 
        else 
        { 
            pos += 10; 
            sideBar.style.left = pos + "px"; //No I18N
        }
    }
}

ZRSHomeUtil.showImportDlgInfo = function(elt)
{
	var parentElt = ZDBUtil.getParentWithAttr(elt, "connectorId");//No I18N
	var connectorId= parentElt.getAttribute("connectorId");
	if(ZRSHomeUtil.impInfoDlg && ZRSHomeUtil.impInfoDlg[connectorId])
	{
		var title = ZDBI18NMap.f("zrpt.conn.js.demo.title", ZRSHomeUtil.getConnectorName(connectorId));
		ZDBDialogUtil.showDialog(ZRSHomeUtil.impInfoDlg[connectorId],{TITLE:title, ADDFRAME:true,MODAL:true}); // No I18N
	}
	else
	{
		AjaxAPI.sendRequest({
		    URL:"/ZDBImportInfoDlg.cc"+"?CONNECTORID="+connectorId, // No I18N
		    ONSUCCESSFUNC:ZRSHomeUtil.showConnectorInfoDlg,
		    CONNECTORID:connectorId,
            METHOD:"GET",//No I18N
		    OPSTATUSID: "ZDBMainLoader" //No I18N
		});
	}
}

ZRSHomeUtil.showConnectorInfoDlg = function (response, requestOptions)
{
    var connectorId = requestOptions["CONNECTORID"];
    var div = document.createElement("div");
    div.innerHTML = response.responseText;
    if (ZRSHomeUtil.impInfoDlg == null)
    {
        ZRSHomeUtil.impInfoDlg = new Object();
        ZRSHomeUtil.impInfoDlg[connectorId] = div;
    }
    var title = ZDBI18NMap.f("zrpt.conn.js.demo.title", ZRSHomeUtil.getConnectorName(connectorId));
    ZDBDialogUtil.showDialog(div, {TITLE: title, ADDFRAME: true, MODAL: true}); // No I18N
}

ZRSHomeUtil.getConnectorName = function (cntrId)
{
    var cntrNameJSON =
            {
                "0": "zrpt.connector.js.sf",
                "1": "zrpt.connector.js.zp",
                "2": "zrpt.connector.js.gad",
                "3": "zrpt.connector.js.ga",
                "4": "zrpt.connector.js.zbt",
                "5": "zrpt.connector.js.zendesk",
                "6": "zrpt.connector.js.creator",
                "18": "zrpt.connector.js.surveymonkey",
                "20": "zrpt.connector.js.teamwork",
                "22": "zrpt.connector.js.zohodesk",
                "25": "zrpt.connector.js.sfdesk",
                "28": "zrpt.connector.js.twdesk",
                "30": "zrpt.connector.js.zpeople" , 
                "36": "zrpt.connector.js.twitter" 
                	
            }
    var cntrName = (cntrNameJSON[cntrId]) ? ZDBI18NMap.g(cntrNameJSON[cntrId]) : "";
    return cntrName;
}

ZRSHomeUtil.toggleDBCreateOpts = function (zuid, el)
{
    var key = zuid + "_SHOW_DB_CREATE_OPTS";//No I18N
    var impOpContainer = $("ZRSDBCreateOptsHldr");
    var dbExpOption = $("ZDBDBOptsDiv").getElementsByClassName("arrow")[0];
    var dataBaseList = $("ZDBDatabaseList");
    var hasImpOptClss = ZDBUtil.hasClass(impOpContainer, "toggleImpOptions");//No I18N
    if (hasImpOptClss) {
        ZDBUtil.removeClass(impOpContainer, "toggleImpOptions");//No I18N
    }
    else {
        ZDBUtil.addClass(impOpContainer, "toggleImpOptions");//No I18N
    }

    var impYourDataOpt = ZDBUtil.getElWithTagNAttrWithVal(el, "elname", "moreRLessIcon", "div"); //No I18N
    var hasMoreIcon = ZDBUtil.hasClass(impYourDataOpt, "ZRSMoreIcon"); //No I18N
    if (hasMoreIcon)
    {
        impYourDataOpt.className = "ZRSLessIcon";//No I18N
        ZRSHomeUtil.initDBOptsVariables();
        ZRSHomeUtil.setDBOptsWidth();
        window.localStorage.setItem(key, true);
        if(ZRSHomeUtil.pages > 1) {
            dbExpOption.style.display = "block"; }
        if (dbExpOption.children[0].className == "ZRSCloseDBList")
        {
            dataBaseList.style.display = "none";
        }

    }
    else
    {
        impYourDataOpt.className = "ZRSMoreIcon";//No I18N
        window.localStorage.setItem(key, false);
        dbExpOption.style.display = "none";
        if (dbExpOption.children[0].className == "ZRSCloseDBList")
        {
            dataBaseList.style.display = "block";
        }
    }
//            ZRSHomeUtil.calculateDBListHeight(zuid);
   var displayFooter = (hasMoreIcon && dbExpOption.children[0].className == "ZRSCloseDBList") ? "none" : "block";
   ZRSHomeUtil.footerDisplayTransition(displayFooter);
}
 
 ZRSHomeUtil.footerDisplayTransition= function(displayFooter) {
      var delayMillis = 600;
    setTimeout(function () {
        ZRSHomeUtil.handleFooter();
        
        $("ZRSFooter").style.display = displayFooter;
    }, delayMillis);
 }

ZRSHomeUtil.showRHideDBCreateOpts = function(zuid) 
{ 
 
	var urlStr = window.location.href;    
	var isUserComingfromDataSheetview = urlStr.indexOf("home=true");//No I18N
	var key=zuid+"_SHOW_DB_CREATE_OPTS";//No I18N
	var showDbCreateOpts=window.localStorage.getItem(key); 
	var totalDBCount=parseInt(jQuery("#ZRSCreateDBBtn").attr("createdDBCount"));//No I18N
        var impDBHldr = jQuery("#ZRSDBCreateOptsHldr");//No I18N
	if(totalDBCount<1 || (ZDBGlobal.IS_SAS_BUILD && CrmPlusImpl.isLoadedInCrmplus()))
	{   
		
		jQuery("#ZRSCreateDBBtn").hide();//No I18N
		jQuery("#ZRSCreateOptsHeader").children("h1").show();//No I18N
		jQuery("#ZRSDBCreationOptions").removeClass("toggleCreateOpts");//No I18N
		impDBHldr.removeClass("toggleImpOptions"); //No I18N
	}	
	
	else if(isUserComingfromDataSheetview != -1){
		
		var btn=jQuery("#ZRSCreateDBBtn").show();//No I18N
		jQuery("#ZRSDBCreationOptions").addClass("toggleCreateOpts");//No I18N
		impDBHldr.removeClass("toggleImpOptions"); //No I18N
		btn.find("[elname='moreRLessIcon']").attr("class","ZRSLessIcon");//No I18N
   
    
	}
	
	else
	{
		var btn=jQuery("#ZRSCreateDBBtn").show();//No I18N
		jQuery("#ZRSDBCreationOptions").addClass("toggleCreateOpts");//No I18N
		
		if(showDbCreateOpts=="true") 
		{
			impDBHldr.removeClass("toggleImpOptions"); //No I18N
			btn.find("[elname='moreRLessIcon']").attr("class","ZRSLessIcon");//No I18N
        
		}
		else
		{
                        impDBHldr.find(".arrow.forward").hide();
			btn.find("[elname='moreRLessIcon']").attr("class","ZRSMoreIcon");//No I18N
        
		}
	}
}     
   

ZRSHomeUtil.validateDBName = function(el)
{
	var dbName = jQuery(el).val();
	AjaxAPI.sendRequest({
        URL:"/ZDBDatabaseActionMI.ma?ZDBACTION=VALIDATEDBNAME&ZOHO_DBNAME="+ dbName, //No I18N
        ONFAILUREFUNC:ZRSHomeUtil.validateDBFailure,METHOD:"GET",//No I18N
        ELEMENT: el
	}); 
}

ZRSHomeUtil.validateDBFailure = function(response, requestOptions)
{
	var inputFld = requestOptions.ELEMENT;
	jQuery(inputFld).addClass("inputError");//No I18N
	
	 var errCode = response.getResponsePart("ERRORCODE");
     var errMsg = response.getResponsePart("STATUS_MESSAGE");
     errCode = trimAll(errCode);
     if(errCode === "META_DBNAME_DUPLICATE")
     {
         showCustomMessage(errMsg, inputFld);
         return;
     }
     else
     {
         AjaxAPI.onFailureFunc(response,requestOptions);
     }
}

ZRSHomeUtil.CreateDBImportTemplate = function () {
    // I18N content as attribute 
    var viedoTip = ZDBI18NMap.g("zrpt.common.js.videodemo");
    var helpTip = ZDBI18NMap.g("zrpt.common.js.help");
    var snapShotTourTip = ZDBI18NMap.g("zrpt.common.js.snapshot_NEW");

        var dbTemp = ZDBUtil.templateCreator(createDBTemp, "liContainer");    //No I18N
        return dbTemp;

}

ZRSHomeUtil.createDBOpts = function(enabledConns) {
//ignorei18n_start
	ZRSHomeUtil.importOptions ={
    //MOTITLE and MODESCRIP - mouse over title and description
    "FileImport" : {//No I18N
        "TITLE" : "zrpt.common.importopt.js.files",//No I18N
        "IMAGECLASS" : "importnew",//No I18N
        "MODESCRIP" : "zrpt.home.import.js.importdescription.new",//No I18N
        "VIDEOURL" : "zrpt.links.embed.js.importvideo", //No I18N
        "HELPLINK" : "zrpt.links.js.importhelp", //No I18N
        "SNAPSHOTTOUR" : "zrpt.links.js.snapshot", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.common.importopt.js.files"), ZDBI18NMap.g("CSV"), ZDBI18NMap.g("TSV"), ZDBI18NMap.g("Files")],
        "attrs": {//No I18N
            "onclick" : "showDatabaseDialog('import');",//No I18N
            "hasDemo" : "true",//No I18N
            "videoUrl" : "zrpt.links.js.importvideo"//No I18N
        }
    },
    "ImportFromCloud" : {//No I18N
         "TITLE" : "zrpt.common.importopt.js.cloudstr",//No I18N
        "IMAGECLASS" : "cloudnew",//No I18N
        "MODESCRIP" : "zrpt.home.import.js.dbclouddesc.new",//No I18N
        "VIDEOURL" : "zrpt.links.embed.import.js.cloudstorage", //No I18N
        "HELPLINK" : "zrpt.links.js.cldimphelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.common.importopt.js.cloudstr"),ZDBI18NMap.g("zrpt.common.importopt.js.files"), ZDBI18NMap.g("CSV"), ZDBI18NMap.g("TSV"), ZDBI18NMap.g("Files")],
        "attrs": {//No I18N
            "onclick" : "showDatabaseDialog('cloud');",//No I18N
            "hasDemo" : "true",//No I18N
            "videoUrl" : "zrpt.links.js.importvideo"//No I18N
        }
    },
    "CloudDB" : {//No I18N
         "TITLE" : "zrpt.common.importopt.js.cloud",//No I18N
        "IMAGECLASS" : "cloudDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromdbdesc.js.newimport",         //No I18N
        "HELPLINK" : "zrpt.links.js.clouddbimport", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.common.importopt.js.cloud"), ZDBI18NMap.g("zrpt.pricing.currentplan.js.database")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "CloudDBPage.showCreateCloudDB",//No I18N
            "lzname" : "CREATE_CLOUDDB_DLG",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "zdbjs/clouddbjs/CloudDBPage.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "ImportFromLocalDatabases" : {//No I18N
         "TITLE" :  "zrpt.schsettings.js.localdatabase",//No I18N
        "IMAGECLASS" : "localDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromdbdesc.js.new",//No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.schsettings.js.localdatabase"), ZDBI18NMap.g("zrpt.pricing.currentplan.js.database")],
        "attrs": {//No I18N
             "onclick" : "window.open('" + ZDBI18NMap.g('zrpt.links.js.uploadTool') + "');",//No I18N
            "type" : "localdb",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
    "qbDesktop" : {
         "TITLE" :  "zrpt.qbdesktop.js.databasename",//No I18N
        "IMAGECLASS" : "qbDesktopDB",//No I18N
        "MODESCRIP" : "zrpt.qbdesktop.home.import.js.createsetupdesc",//No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.qbdesktop.js.databasename"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.finance')],
        "attrs": {//No I18N
        	"onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRQBDesktopInteg.fetchQBooksNewDBImpDlg",//No I18N
            "lzname" : "QBDeskImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
     },
     "zohoCRM" : {//No I18N
         "TITLE" : "zrpt.connector.js.zcrm",//No I18N
        "IMAGECLASS" : "zcrmDB",//No I18N
        "MODESCRIP" : "zrpt.crm.home.import.js.createzohocrmdatadesc",//No I18N
        "HELPLINK" : "zrpt.links.js.crmanaltyicshelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.zcrm"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g('zrpt.connector.js.crm')],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZDBCRMInteg.fetchZCRMNewDBImpDlg",//No I18N
            "lzname" : "ZCRMImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "ZohoProjectsImport" : {//No I18N
        "TITLE" : "zrpt.connector.js.zp",//No I18N
        "IMAGECLASS" : "projectsDB",//No I18N
        "MODESCRIP" : "zrpt.zproj.home.import.js.createzohoprjdatadesc.new",//No I18N
        "VIDEOURL" : "zrpt.links.js.ZProjImpVideo", //No I18N
        "HELPLINK" : "zrpt.links.js.prjconnectorhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.zp"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.projnbugtrk")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZDBZProjectsInteg.fetchZPInitialData",//No I18N
            "lzname" : "ZProjImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
    "ZohoPeopleImport" : {//No I18N
      	 "TITLE" : "zrpt.connector.js.zpeople", //No I18N
      	 "IMAGECLASS" : "zpeopleDB", //No I18N
           "MODESCRIP" : "zrpt.home.importdatafromzohopeople.js.new",//No I18N
           "HELPLINK" : "zrpt.links.js.zpeopleconnectorhelp", //No I18N
           "TAGS": [ZDBI18NMap.g("zrpt.connector.js.zpeople"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.hr")],
           "attrs": {//No I18N
               "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
               "func" : "ZPeopleInteg.showZPeopleHomeDlg",//No I18N
               "lzname" : "ZPeopleImpDlg",//No I18N
               "mode" : "true",//No I18N
               "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
               "lazyload" : "true",//No I18N
               "hasDemo" : "false"//No I18N
           }    	 
       },
     "ZendeshImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.zendesk",//No I18N
        "IMAGECLASS" : "zendeskDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromzendeskdesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.zendeskshelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.zendesk"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.helpdesk')],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRZendeskInteg.showDBDetailsDlg",//No I18N
            "lzname" : "ZRZendeskImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "TWImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.teamwork",//No I18N
        "IMAGECLASS" : "tw",//No I18N
        "MODESCRIP" : "zrpt.connector.tw.js.home.import.desc",//No I18N
        "HELPLINK" : "zrpt.links.js.teamworkanalyticshelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.tw.js.dispname"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.projnbugtrk")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRTWInteg.showTrailInfo",//No I18N
            "lzname" : "TWImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "ZohoBooks" : {//No I18N
         "TITLE" : "zrpt.connector.js.zbooksorinvinteg",//No I18N
        "IMAGECLASS" : "zbooksDB",//No I18N
        "MODESCRIP" : "zrpt.zbooks.home.import.js.createzohobooksdatadesc",//No I18N
        "HELPLINK" : "zrpt.links.js.zbookshelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.zbooksorinvinteg"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.finance')],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRZBooksInteg.fetchZBooksNewDBImpDlg",//No I18N
            "lzname" : "ZBooksImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
    "SFDeskImport" : {//No I18N
        "TITLE" : "zrpt.connector.js.sfdesk",//No I18N
       "IMAGECLASS" : "sfdeskDB",//No I18N
       "MODESCRIP" : "zrpt.home.importdatafromsfdeskdesc.js.new",//No I18N
       "HELPLINK" : "zrpt.links.sfdeskshelp", //No I18N
       "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.sfdesk"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.helpdesk')],
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "ZRSFDeskInteg.showDBDetailsDlg",//No I18N
           "lzname" : "ZRSFdeskImpDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
       "StripeImport" : {//No I18N
        "TITLE" : "zrpt.connector.js.stripe",//No I18N
       "IMAGECLASS" : "stripeIcon",//No I18N
        "BETA": "true",//No I18N
       "MODESCRIP" : "zrpt.stripe.home.import.js.analyze",//No I18N
       "HELPLINK" : "zrpt.links.js.stripeconnectorhelp", //No I18N
       "TAGS": [ZDBI18NMap.g("zrpt.common.js.stripe"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.finance')],
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "ZRStripeConnector.fetchStripeImpDlgFromHome",//No I18N
           "lzname" : "StripeImpDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
   
    "TWDeskImport" : {//No I18N
       "TITLE" : "zrpt.connector.js.twdesk",//No I18N
      "IMAGECLASS" : "twdeskDB",//No I18N
      "MODESCRIP" : "zrpt.home.importdatafromtwdeskdesc.js.new",//No I18N
      "HELPLINK" : "zrpt.links.js.twdesk", //No I18N
      "TAGS": [ZDBI18NMap.g("zrpt.connector.js.twdesk"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.helpdesk')],
      "attrs": {//No I18N
          "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
          "func" : "ZRTWDeskInteg.showDBDetailsDlg",//No I18N
          "lzname" : "ZRTWdeskImpDlg",//No I18N
          "mode" : "true",//No I18N
          "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
          "lazyload" : "true",//No I18N
          "hasDemo" : "false"//No I18N
      }
  },
  
     "CreatorImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.creator",//No I18N
        "IMAGECLASS" : "creatorDB",//No I18N
        "MODESCRIP" : "zrpt.home.import.js.importfromcreatordesc.new",//No I18N
        "HELPLINK" : "zrpt.links.js.creatorhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.creator"), ZDBI18NMap.g("zoho apps")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRCreatorInteg.showDBDetsDlg",//No I18N
            "lzname" : "ZRCreatorImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "ZDeskImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.zohodesk",//No I18N
        "IMAGECLASS" : "zohoDeskDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromzdeskdesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.zohodeskhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.zohodesk"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.helpdesk')],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRZDeskInteg.showDBDetailsDlg",//No I18N
            "lzname" : "ZRZDeskImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
    "GoogleAnalyticsImportNew" : {//No I18N
        "TITLE" : "zrpt.connector.js.ga",//No I18N
       "IMAGECLASS" : "gAnalytics",//No I18N
       "MODESCRIP" : "zrpt.home.importdatafromgoogleanalyticsdesc.js.new",//No I18N
       "HELPLINK" : "zrpt.links.js.gahelp", //No I18N
       "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.ga"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.sales")],
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "ZRGoogleAnalyticsIntegration.showDBDetailsDlg",//No I18N
           "lzname" : "ZRGAnalImpDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
     "GoogleAdWordsImport" : {//No I18N
        "TITLE" : "zrpt.connector.js.gad",//No I18N
        "IMAGECLASS" : "gAdwords",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromgoogleadwordsidesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.gadhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.gad"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.sales")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRGADInteg.chkDemoDlg",//No I18N
            "lzname" : "ZRGADImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "SalesForceImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.sf",//No I18N
        "IMAGECLASS" : "salesforceDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromsfdesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.sfdemohelp", //No I18N
        "VIDEOURL" : "zrpt.links.js.salesForceImpVideo", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.sf"), ZDBI18NMap.g('zrpt.connector.js.crm')],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRSFIntegration.showDBDetailsDlg",//No I18N
            "lzname" : "ZRSFImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "QBooks" : {//No I18N
         "TITLE" : "zrpt.connector.js.quickbooks",//No I18N
        "IMAGECLASS" : "quickBooksDB",//No I18N
        "MODESCRIP" : "zrpt.qbooks.home.import.js.createquickbooksdatadesc",//No I18N
        "HELPLINK" : "zrpt.links.js.qbooksconnectorhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.quickbooks"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.finance')],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRQBooksInteg.fetchQBooksNewDBImpDlg",//No I18N
            "lzname" : "QBooksImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "XeroImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.xero",//No I18N
        "IMAGECLASS" : "xeroDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromxerodesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.xeroconnectorhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.xero"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.finance')],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRXeroInteg.fetchXeroImpDlgFromHome",//No I18N
            "lzname" : "ZRXeroImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
    
    
     "MSCRMImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.mscrm",//No I18N
        "IMAGECLASS" : "mscrmDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafrommscrmdesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.mscrmdemohelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.mscrm"), ZDBI18NMap.g('zrpt.connector.js.crm')],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRMSCRMIntegration.fetchMscrmoImpDlgFromHome",//No I18N
            "lzname" : "ZRMSCRMImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
    "TwitterImport" : {//No I18N
        "TITLE" : "zrpt.connector.js.twitter",//No I18N
       "IMAGECLASS" : "twitterDB",//No I18N
       "MODESCRIP" : "zrpt.home.importdatafromtwitterdesc.js.new",//No I18N
       "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.twitter")],
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "ZRTwitterInteg.showDBDetailsDlg" ,//No I18N
           "lzname" : "ZRTwitterImpDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js,thirdparty/js/zohocomponents.js", //No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
   
    
     "FBImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.facebook",//No I18N
        "IMAGECLASS" : "facebookDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromfbdesc.js.new",//No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.facebook"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.sales")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRFBIntegration.showDBDetailsDlg" ,//No I18N
            "lzname" : "ZRSFImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "MailChimpImport" : {//No I18N
         "TITLE" :"zrpt.connector.js.mchimp",//No I18N
        "IMAGECLASS" : "mChimDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafrommailchimpdesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.mchimphelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.mchimp"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.sales")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRMChimpIntegration.showDBDetailsDlg",//No I18N
            "lzname" : "ZRSFImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "RecruitImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.recruit",//No I18N
        "IMAGECLASS" : "recruitDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromrecruitdesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.recruithelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.recruit"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g('zrpt.topbar.appgroup.js.hr')],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRRecruitIntegration.showDBDetailsDlg",//No I18N
            "lzname" : "ZRSFImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
    "ZCampaignsImport": {//No I18N
         "TITLE" : "zrpt.connector.js.zcampaigns",//No I18N
        "IMAGECLASS" : "zCampaignsDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromzcampaignsdesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.zcampaignshelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.zcampaigns"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.sales")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRZCampaignsIntegration.showDBDetailsDlg",//No I18N
            "lzname" : "ZRZCampImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
    }
},
     "BugTrackerImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.zbt",//No I18N
        "IMAGECLASS" : "bugtrackerDB",//No I18N
        "MODESCRIP" : "zrpt.zproj.home.import.js.createzbugtracker.new",//No I18N
        "HELPLINK" : "zrpt.links.js.bugconnectorhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.zbt"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.projnbugtrk")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZDBZProjectsInteg.fetchZBTInitialData",//No I18N
            "lzname" : "ZProjImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "ContactImport" : {//No I18N
         "TITLE" : "zrpt.connector.js.contact",//No I18N
        "IMAGECLASS" : "consantContDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromcontactdesc.js.new",//No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.contact"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.sales")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRContactIntegration.showDBDetailsDlg",//No I18N
            "lzname" : "ZRSFImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "SurveyMonkeyImport" : {//No I18N
        "TITLE" : "zrpt.connector.js.surveymonkey",//No I18N
        "IMAGECLASS" : "surveyMonkeyDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromsmdesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.surveymonkeyhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.surveymonkey"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.sales")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRSMInteg.showDBDetailsDlg",//No I18N
            "lzname" : "ZRSMImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        	}
        },
    "ZohoSurveyImport" : {//No I18N
        "TITLE" : "zrpt.connector.js.zohosurvey",//No I18N
        "IMAGECLASS" : "zohoSurveyDB",//No I18N
        "MODESCRIP" : "zrpt.home.importdatafromsurveydesc.js.new",//No I18N
        "HELPLINK" : "zrpt.links.js.zohosurveyhelp", //No I18N
        "BETA": "true",//No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.connector.js.zohosurvey"), ZDBI18NMap.g("zoho apps"), ZDBI18NMap.g("zrpt.topbar.appgroup.js.sales")],
        "attrs": {//No I18N
            "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
            "func" : "ZRSurveyInteg.showDBDetailsDlg",//No I18N
            "lzname" : "ZRSurveyImpDlg",//No I18N
            "mode" : "true",//No I18N
            "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
            "lazyload" : "true",//No I18N
            "hasDemo" : "false"//No I18N
        	}
    },

    "SurveyGizmoImport" : {//No I18N
        "TITLE" : "zrpt.connector.js.surveygizmo",//No I18N
       "IMAGECLASS" : "surveygizmoDB",//No I18N
       "MODESCRIP" : "zrpt.home.importdatafromsurveygizmodesc.js.new",//No I18N
       "HELPLINK" : "zrpt.links.js.surveygizmohelp", //No I18N
       "TAGS" : [ZDBI18NMap.g('zrpt.connector.js.surveygizmo'), ZDBI18NMap.g("zrpt.topbar.appgroup.js.sales")],
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "ZRSurveyGizmoInteg.showDBDetailsDlg",//No I18N
           "lzname" : "ZRSurveyGizmoImpDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
   
    "HubSpotImport" : {//No I18N
       "TITLE": "zrpt.connector.js.hubspot",//No I18N
       "IMAGECLASS" : "hubspotimp",//No I18N
       "MODESCRIP" : "zrpt.home.importdatafromhubspotdesc.js.new",//No I18N
       "TAGS": [ZDBI18NMap.g('zrpt.connector.js.hubspot'), ZDBI18NMap.g('zrpt.connector.js.crm')],
       "HELPLINK" : "zrpt.links.js.hubspothelp", //No I18n
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "ZRHubSpotInteg.fetchHubSpotImpDlgFromHome",//No I18N
           "lzname" : "ZRHubSpotImpDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "ZRIntegConnectors,import/js/ZDBImportSchedule.js",//No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
    "JiraSoftInteg" : {//No I18N
       "TITLE": "zrpt.connector.js.jira",//No I18N
       "IMAGECLASS" : "jirasoft-integ",//No I18N
       "MODESCRIP" : "zrpt.home.import.js.jira.new",//No I18N
       "HELPLINK" : "zrpt.common.js.help", //No I18N,
       "OP" : "true", //No I18N
       "TAGS" : [],
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "JIRAInteg.appLinkConfigDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "zrop/js/JIRAInteg.js,zrop/js/RESTAPIConn.js,connector/js/ZRConnector.js",//No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false",//No I18N
           "connectorId": 28
       }
   },
    "JiraSDInteg" : {//No I18N
       "TITLE": "zrpt.connector.js.jiraservicedesk",//No I18N
       "IMAGECLASS" : "jirasd-integ",//No I18N
       "MODESCRIP" : "zrpt.home.import.js.jira.sd.new",//No I18N
       "HELPLINK" : "zrpt.common.js.help", //No I18N,
       "OP" : "true", //No I18N
       "TAGS" : [],
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "JIRAInteg.appLinkConfigDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "zrop/js/JIRAInteg.js,zrop/js/RESTAPIConn.js,connector/js/ZRConnector.js",//No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false",//No I18N
           "connectorId": 29
       }
   },
    "SDPInteg" : {//No I18N
       "TITLE": "zrpt.home.import.js.sdpinteg.tile",//No I18N
       "IMAGECLASS" : "sdp-integ",//No I18N
       "MODESCRIP" : ZDBI18NMap.f('zrpt.home.import.js.sdpintegdesc.new',ZDBGlobal.PRODUCT_NAME),//No I18N
       "VIDEOURL" : "zrpt.links.embed.sdpmspvideo", //No I18N
       "HELPLINK" : "zrpt.links.js.sdpinteghelp", //No I18N,
       "OP" : "true", //No I18N
       "TAGS" : [],
       "attrs": {//No I18N
           "onclick" : "showDatabaseDialog('sdp-msp-integ');",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
    "OPMInteg" : {//No I18N
       "TITLE": "zrpt.home.import.js.opminteg.tile",//No I18N
       "IMAGECLASS" : "opm_integ",//No I18N
       "MODESCRIP" : ZDBI18NMap.f('zrpt.home.import.js.opmintegdesc.new',ZDBGlobal.PRODUCT_NAME),//No I18N
       "VIDEOURL" : "zrpt.links.embed.apmopmvideo", //No I18N
       "HELPLINK" : "zrpt.links.js.opminteghelp", //No I18N
       "OP" : "true", //No I18N
       "TAGS" : [],
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "OPMInteg.fetchOPMIntegDialog",//No I18N
           "lzname" : "OPMIntegDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "zrop/js/zropscript.js,zrop/js/OPMInteg.js",//No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
    "APMInteg" : {//No I18N
       "TITLE": "zrpt.home.import.js.apminteg.tile",//No I18N
       "IMAGECLASS" : "apm_integ",//No I18N
       "MODESCRIP" : ZDBI18NMap.f('zrpt.home.import.js.apmintegdesc.new',ZDBGlobal.PRODUCT_NAME),//No I18N
       "VIDEOURL" : "zrpt.links.embed.apmopmvideo", //No I18N
       "OP" : "true", //No I18N
       "TAGS" : [],
       "HELPLINK" : "zrpt.links.js.apminteghelp", //No I18N
       "attrs": {//No I18N
           "onclick" : "ZDBLoadJsAlone.loadJs(this, event);",//No I18N
           "func" : "APMInteg.fetchAPMIntegDialog",//No I18N
           "lzname" : "APMIntegDlg",//No I18N
           "mode" : "true",//No I18N
           "lzjs" : "zrop/js/zropscript.js,zrop/js/APMInteg.js",//No I18N
           "lazyload" : "true",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
    "SDPMSPInteg" : {//No I18N
       "TITLE": "zrpt.home.import.js.sdpmspinteg.tile",//No I18N
       "IMAGECLASS" : "sdpmsp-integ",//No I18N
       "TAGS" : [],
       "MODESCRIP" : ZDBI18NMap.f('zrpt.home.import.js.sdpmspintegdesc.new',ZDBGlobal.PRODUCT_NAME),//No I18N
       "VIDEOURL" : "zrpt.links.embed.sdpmspvideo", //No I18N
       "HELPLINK" : "zrpt.links.js.sdpmspinteghelp", //No I18N
       "OP" : "true", //No I18N
       "attrs": {//No I18N
           "onclick" : "showDatabaseDialog('sdp-msp-integ');",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
    "SCPInteg" : {//No I18N
       "TITLE": "zrpt.home.import.js.scpinteg.tile",//No I18N
       "IMAGECLASS" : "scp-integ",//No I18N
       "MODESCRIP" : ZDBI18NMap.f('zrpt.home.import.js.scpintegdesc.new',ZDBGlobal.PRODUCT_NAME),//No I18N
       "TAGS" : [],
       "HELPLINK" : "zrpt.links.js.scpinteghelp", //No I18N
       "OP" : "true", //No I18N
       "attrs": {//No I18N
           "onclick" : "showDatabaseDialog('scp-integ');",//No I18N
           "hasDemo" : "false"//No I18N
       }
   },
     "DatabaseFromTemplate" : {//No I18N
         "TITLE" : "zrpt.home.dbtemplatebr.js.new",//No I18N
        "IMAGECLASS" : "templateDB",//No I18N
        "MODESCRIP" : "zrpt.home.import.js.dbtempdesc.new",//No I18N
        "HELPLINK" : "zrpt.links.js.createtemplatedbhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.home.dbtemplatebr.js.new"), ZDBI18NMap.g("zrpt.pricing.currentplan.js.database")],
        "attrs": {//No I18N
            "onclick" : "showDatabaseDialog(\'template\');",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "BlankDatabase" : {//No I18N
         "TITLE" : "zrpt.home.js.createblankdb",//No I18N
        "IMAGECLASS" : "blankDB",//No I18N
        "MODESCRIP" : "zrpt.home.import.js.blankdbdesc.new",//No I18N
        "HELPLINK" : "zrpt.links.js.createblankdbhelp", //No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.home.js.createblankdb"), ZDBI18NMap.g("zrpt.pricing.currentplan.js.database")],
        "attrs": {//No I18N
            "onclick" : "showDatabaseDialog(\'scratch\');",//No I18N
            "hasDemo" : "false"//No I18N
        }
    },
     "EnterDataRightAway" : {//No I18N
         "TITLE" :  "zrpt.home.import.step1.js.createdbenterdata",//No I18N
        "IMAGECLASS" : "enterDataDB",//No I18N
        "MODESCRIP" : "zrpt.home.import.js.enterdatarightdesc.new",//No I18N
        "TAGS" : [ZDBI18NMap.g("zrpt.home.import.step1.js.createdbenterdata"), ZDBI18NMap.g("zrpt.pricing.currentplan.js.database")],
        "attrs": {//No I18N
            "onclick" : "showDatabaseDialog(\'enterdata\');",//No I18N
            "hasDemo" : "false"//No I18N
        }
    }
 }
//ignorei18n_end
    var dbOptCont = document.createElement("ul");
    dbOptCont.className = "DBCreateOpts ZRSRespContainer";
    var createDBTemp = ZDBUtil.templateCreator("_importOptsTemp"); //No I18N
    for(var conn in enabledConns)
    {
		var createDBCopy = createDBTemp.cloneNode(true);
		var childEls = createDBCopy.querySelectorAll(".zdbIcon, .optName, .dbNameFont, .dbDescription, .videoDemo, .helpCenter, .snapShotTour");//No I18N
        var impOpt = ZRSHomeUtil.importOptions[conn];
        createDBCopy.id = conn;
        createDBCopy.className = "importTile";
        for(var attr in impOpt["attrs"])
        {
            createDBCopy.setAttribute(attr, impOpt["attrs"][attr]);
        }
        
        for (var j = 0; j < childEls.length; j++)
        {
            var el = childEls[j];
            var className = el.className;
            switch (className)
            {
                case "zdbIcon": { //No I18N
                        ZDBUtil.addClass(el, impOpt["IMAGECLASS"]);
                        if(impOpt["OP"]){
                       		ZDBUtil.swapClass(el,"zdbIcon","zropintegicon"); //No I18N
                       	}
                        break;
                }
                case "optName":{ //No I18N
                        if (enabledConns[conn]["Beta"]) {
                            var betaTag = document.createElement("div");
                            betaTag.className = "betaTag";
                            var par = el.parentNode;
                            createDBCopy.insertBefore(betaTag, par);
                        }
                        if(conn == "QBooks" || conn == "StripeImport") {
                            break;
                        }
                        var titleEl = document.createTextNode(ZDBI18NMap.g(impOpt["TITLE"]));
                        el.appendChild(titleEl);
                        break;
                } 
                case "dbNameFont": { //No I18N
                         var moTitleEl = document.createTextNode(ZDBI18NMap.g(impOpt["TITLE"]));
                        el.appendChild(moTitleEl);
                        break;
                }
                case "dbDescription": { //No I18N
                        if(conn != "ImportFromLocalDatabases") {
                            var moDescEl = document.createTextNode(ZDBI18NMap.g(impOpt["MODESCRIP"]));
                            el.appendChild(moDescEl);   
                        }
                        else {
                            el.innerHTML = ZDBI18NMap.g(impOpt["MODESCRIP"]);
                        }
                        break;
                }
                case "videoDemo": { //No I18N
                    if (conn == "FileImport" || impOpt["VIDEOURL"] && ZDBGlobal.isZDomain) {
                            var videolink = ZDBI18NMap.g(impOpt["VIDEOURL"]);
                            var onClickAttr = "ZDBClientUI.showVideo(\'" + videolink + "\'), event.stopPropagation();"; //No I18N
                            el.setAttribute("onclick", onClickAttr);
                    } else {
                        el.style.display = "none";
                    }
                    break;
                }
                case "helpCenter": { //No I18N
                       if(impOpt["HELPLINK"]){     
                            var hrefLink = ZDBI18NMap.g(impOpt["HELPLINK"]);
                            el.setAttribute("href",hrefLink );
                        }else {
                            el.style.display = "none";
                        }
                         break;
                }
                case "snapShotTour" : { //No I18N
                       if(impOpt["SNAPSHOTTOUR"]){     
                            var snapShotLink = ZDBI18NMap.g(impOpt["SNAPSHOTTOUR"]);
                            el.setAttribute("href",snapShotLink );
                        } else {
                            el.style.display = "none";
                        }
                         break;
                }
                
        }
    }
        dbOptCont.appendChild(createDBCopy);
    }
    var dbOptsDiv = $("ZDBDBOptsDiv");
    if(dbOptsDiv){
    	//For CRMPlus trail expired user case, $("ZDBDBOptsDiv") element will not be included in jsp/jspf.
    	dbOptsDiv.appendChild(dbOptCont);
    }
}

ZRSHomeUtil.calculateExpDBHeight = function(dbOptsDiv, toSet) {
    if(toSet) {
        dbOptsDiv.style.height = ZRSHomeUtil.pages * ZRSHomeUtil.single.outerWidth()+ "px"; 
    }
    else {
        dbOptsDiv.style.height = 160 + "px";
    }

}

ZRSHomeUtil.calculateDBListHeight = function(zuid) {
    var mainContainer = $("ZDBMainContainer").offsetHeight;
    var key=zuid+"_SHOW_DB_CREATE_OPTS";//No I18N
    var ToShowImpOpts = window.localStorage.getItem(key,true);
    var importOpts = (ToShowImpOpts == "true") ? 180 : 0;  // import options height
    var footer = $("ZRSFooter").offsetHeight;
    var extraSpace = 178;
    var dbListParCont = $("ZDBDBListParEl");
    var dbListParHeight = mainContainer - (importOpts + footer + extraSpace);
    dbListParCont.style.height = dbListParHeight + "px";
}

