//$Id$
/****************************************** Recent Items Code ****************************************/
//ignorei18n_start
var ZRSHomepageListing = new function () {};
//Constants    
//RecentItemsConstants
ZRSHomepageListing.viewname = 0;
ZRSHomepageListing.viewid = 1;
ZRSHomepageListing.viewtype = 2;
ZRSHomepageListing.databasename = 3;
ZRSHomepageListing.databaseid = 4;
ZRSHomepageListing.modifiedtime = 5;
ZRSHomepageListing.recentitemlength;
//myDbConstants ["DatabaseName","DatabaseId","DatabaseDesc","CreatedTime","IsDefault","isRemoteDB","zsoid"]
ZRSHomepageListing.myDbDatabaseName = 0;
ZRSHomepageListing.myDbDatabaseId = 1;
ZRSHomepageListing.myDbDatabaseDesc = 2;
ZRSHomepageListing.myDbCreatedTime = 3;
ZRSHomepageListing.myDbIsDefault = 4;
ZRSHomepageListing.myDBIsRemoteDB = 5;
ZRSHomepageListing.myDbZsoId = 6;
//sharedDbConstants ["DatabaseName","DatabaseId","DatabaseDesc","CreatedTime","OwnerZUID","IsDefault","ownerzsoid"]
ZRSHomepageListing.sharedDbDatabaseName = 0;
ZRSHomepageListing.sharedDbDatabaseId = 1;
ZRSHomepageListing.sharedDbDatabaseDesc = 2;
ZRSHomepageListing.sharedDbCreatedTime = 3;
ZRSHomepageListing.sharedDbOwnerZUID = 4;
ZRSHomepageListing.sharedDbIsDefault = 5;
ZRSHomepageListing.sharedDBZsoId = 6;
ZRSHomepageListing.isReItmsVisible = false;   //To check visibility status of Recent Items navigation
ZRSHomepageListing.slideAnimation = false;    //To check whether slide animation is active or not
//Setting Service Org in Homepage
ZRSHomepageListing.ZSOID = undefined;
ZRSHomepageListing.currentlyRenderedDBInfoList = null;
ZRSHomepageListing.ifSharedDatabaseRequestSent = false;
ZRSHomepageListing.dbInfos = {};
ZRSHomepageListing.databaseShareInfo = {};
ZRSHomepageListing.SharedEmailJson = {};
ZRSHomepageListing.sharedUserInfo = {};
ZRSHomepageListing.currentDefaultDBInfo = {};
ZRSHomepageListing.emptyDBS=true; //To check whether to refresh when all databases are deleted
/*
 Below variable has been used to identify if request sent for shared should 
 be used for construction of Shared Database or just to store the results in the client. 
 */
//    this.buildShared = false;
//    this.nameForAdminsOrg = undefined;

ZRSHomepageListing.onDocumentReady = function () {
    ZDBGlobal.initializeFontInfo();
    ZRSHomepageListing.sendHomepageInfoRequest();
};

ZRSHomepageListing.sendHomepageInfoRequest = function () {
//    AjaxAPI.sendRequest({
//        //this request includes following APIS - MYDBLIST/SHAREDDBLIST, RECENTITEMS, IMPORTDBOPTS
//        URL: '/reportsapi/HOMEPAGEREQUESTS', 
//        ONSUCCESSFUNC: ZRSHomepageListing.loadHomePage,
//        OPSTATUSID: "ZDBHomePageLoader"
//    });
    ZRSAjax.get('/reportsapi/HOMEPAGEREQUESTS', null,
        {
            successHandler: {
                func: ZRSHomepageListing.loadHomePage,
                ctx: ZRSHomepageListing
            },
            loader: 'ZDBHomePageLoader'
        }
    );
};

ZRSHomepageListing.loadHomePage = function (responseList) {
    ZDBUtil.show($("ZDBMainContainer"));
    ZDBUtil.show($("ZDBHeader"));
    ZROrg.handleLoadOrgDetails(responseList);
    if (!ZDBClientUI.readOnlyMode && responseList["ENABLEDCONNECTORS"])
    {
        ZRSHomeUtil.JSONImportDBListConstr(responseList["ENABLEDCONNECTORS"]);
    }
    ZRSHomepageListing.refactorServerResponse(responseList);
    ZRSHomepageListing.renderDBListing();
    ZRSHomepageListing.showSideBar(responseList["RECENTVIEWLIST"]);
    typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.onloadChanges('{"IMPORTDBOPTS":true,"MYDBLIST":true}');//NO I18N
    var loadingEl = $("ZDBHomePageLoader");
    if (loadingEl) {
        loadingEl.parentNode.removeChild(loadingEl);
    }
    window.addEventListener("hashchange", ZRSHomepageListing.handleUIOnHashChange, false);
};


ZRSHomepageListing.sendSharedDBListReq = function (renderWhenResponseReceived) {
//    AjaxAPI.sendRequest({
//        URL: '/reportsapi/SHAREDDBLIST', 
//        ONSUCCESSFUNC: ZRSHomepageListing.saveSharedDetails,
//        RENDERRESPONSE: renderWhenResponseReceived
//    });
    ZRSAjax.get('/reportsapi/SHAREDDBLIST', null, {
        successHandler: {
            func: ZRSHomepageListing.saveSharedDetails,
            ctx: ZRSHomepageListing
        },
        RENDERRESPONSE: renderWhenResponseReceived
    });
};

ZRSHomepageListing.saveSharedDetails = function (resp, requestOptions) {
    var renderWhenResponseReceived = requestOptions.RENDERRESPONSE;
    typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.onloadChanges('{"SHAREDDBLIST":true}', "zrpt.home.shareddb");//NO I18N
    ZRSHomepageListing.refactorServerResponse(resp);
    if (renderWhenResponseReceived) {
        var databaseInfo = ZRSHomepageListing.getOwnedAndSharedDatabaseInfo();
        ZRSHomepageListing.currentlyRenderedDBInfoList = databaseInfo[1];
        if (ZRSHomepageListing.currentlyRenderedDBInfoList) {
            ZRSHomepageListing.renderDataToTab("SHARED", 0, ZRSHomepageListing.currentlyRenderedDBInfoList.length > 20 ? 20 : ZRSHomepageListing.currentlyRenderedDBInfoList.length);
        } else {
            if (!databaseInfo[0]) {
                ZRSHomepageListing.changeDBListHash('MYDBS');
                ZRSHomepageListing.handleUIOnHashChange();
            } else {
                ZRSHomepageListing.changeDBListHash('SHARED');
                ZRSHomepageListing.handleUIOnHashChange();
            }
        }
    }
};

ZRSHomepageListing.refactorServerResponse = function (serverResponse) {
    var myDBS = serverResponse.MYDBS;
    var sharedDBS = serverResponse.SHARED;
    var values, curDBInfo, curZSOID;
    if (myDBS) {
        values = myDBS.values;
        ZRSHomepageListing.dbInfos.MYDBS = ZRSHomepageListing.dbInfos.MYDBS ? ZRSHomepageListing.dbInfos.MYDBS : {};
        for (var i = 0, len = values.length; i < len; i++) {
            curDBInfo = values[i];
            curZSOID = ZRSHomepageListing.myDbZsoId;
            ZRSHomepageListing.dbInfos.MYDBS = ZRSHomepageListing.dbInfos.MYDBS ? ZRSHomepageListing.dbInfos.MYDBS : {};
            ZRSHomepageListing.dbInfos.MYDBS[curDBInfo[curZSOID]] = ZRSHomepageListing.dbInfos.MYDBS[curDBInfo[curZSOID]] ? ZRSHomepageListing.dbInfos.MYDBS[curDBInfo[curZSOID]] : [];
            ZRSHomepageListing.dbInfos.MYDBS[curDBInfo[curZSOID]].push(curDBInfo);
        }
    }
    if (sharedDBS) {
        values = sharedDBS.values;
        ZRSHomepageListing.dbInfos.SHARED = ZRSHomepageListing.dbInfos.SHARED ? ZRSHomepageListing.dbInfos.SHARED : {};
        for (var i = 0, len = values.length; i < len; i++) {
            curDBInfo = values[i];
            curZSOID = ZRSHomepageListing.sharedDBZsoId;
            ZRSHomepageListing.dbInfos.SHARED[curDBInfo[curZSOID]] = ZRSHomepageListing.dbInfos.SHARED[curDBInfo[curZSOID]] ? ZRSHomepageListing.dbInfos.SHARED[curDBInfo[curZSOID]] : [];
            ZRSHomepageListing.dbInfos.SHARED[curDBInfo[curZSOID]].push(curDBInfo);
        }
    }
};

ZRSHomepageListing.showSideBar = function (responseList) {

    // constructing an Array for className for View Type Icons Shown
    var viewNames = ["Tables", "TabularReports", "Charts", 
        "Pivots", "SummaryViews", "EditDesign", "QueryTables", 
        "Dashboards"]; 
    var list = document.createElement("ul");
    ZRSHomepageListing.recentitemlength = (responseList.values.length < 16) ? responseList.values.length : 15; //Listing Recent Items Maximum 15 by count.
    for (var i = 0; i < ZRSHomepageListing.recentitemlength; i++) {
        // values:["viewName","viewId","viewType","databaseName","databaseId","modifiedtime"]
        var viewName = responseList.values[i][ZRSHomepageListing.viewname] + " (" + responseList.values[i][ZRSHomepageListing.databasename] + ")"; 
        var tempEl = ZRSHomepageListing.responseListTemplate();
        ZDBUtil.setNamedChildEls(tempEl, tempEl, "elname", false);
        var objectID = responseList.values[i][ZRSHomepageListing.viewid];
        var dataBaseID = responseList.values[i][ZRSHomepageListing.databaseid];
        tempEl.viewNameAndDBname.setAttribute('href', ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + dataBaseID + "&OBJID=" + objectID); 
        tempEl.viewIcon.setAttribute('class', viewNames[responseList.values[i][ZRSHomepageListing.viewtype]] + 'Nav navIconSpan'); 
        tempEl.viewNameAndDBname.setAttribute('title', viewName); 
        tempEl.displayValue.innerHTML = ZDBEscapeUtil.encodeForHtml(viewName);
        list.appendChild(tempEl);
    }
    if ($("ZRSRecentListHolder")) {
        $("ZRSRecentListHolder").appendChild(list);
        if (ZRSHomepageListing.recentitemlength > 0)
        {
            ZRSHomepageListing.showHideRecentItems();
        }
    }
    typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.onloadChanges('{"RECENTITEMS":true}');//NO I18N
};

ZRSHomepageListing.responseListTemplate = function () {
    var node = document.createElement("li");
    var viewNameAndDBname = document.createElement("a");
    viewNameAndDBname.setAttribute("elname", "viewNameAndDBname");
    viewNameAndDBname.setAttribute('class', "blue");
    var viewIcon = document.createElement("span");
    viewIcon.setAttribute('id', "viewIcon");
    viewIcon.setAttribute("elname", "viewIcon");
    viewNameAndDBname.appendChild(viewIcon);
    var displayValue = document.createElement("span");
    displayValue.setAttribute('elname', "displayValue");
    viewNameAndDBname.appendChild(displayValue);
    node.appendChild(viewNameAndDBname);
    return node.cloneNode(true);
};


ZRSHomepageListing.showHideRecentItems = function ()
{
    var MaxMinSidebar = document.getElementById("ZDBMaxMinSidebar");    
    MaxMinSidebar.style.display = "block";  
    if (BROWSER.IS_MOBILE) //Added to avoid touch issue in mobile devices
        MaxMinSidebar.addEventListener("touchstart", ZRSHomepageListing.recentItemsAnimation);  
    else
        MaxMinSidebar.addEventListener("mousemove", ZRSHomepageListing.recentItemsSlide);     
};

ZRSHomepageListing.recentItemsAnimation = function (event)    // Recent Items Slide Animation for Mobile Devices
{
    if (!ZRSHomepageListing.isReItmsVisible)
    {
        event.stopPropagation();
        document.getElementById("ZDBSidebar").style.animationName = "show";    
        setTimeout(function ()
        {
            ZRSHomepageListing.isReItmsVisible = true;
            document.body.addEventListener("touchstart", function (event) 
            {
                var test = ((event.target.getAttribute("id") === "ZDBSidebar") || document.getElementById("ZDBSidebar").contains(event.target));   
                if (!test && ZRSHomepageListing.isReItmsVisible)
                {
                    document.getElementById("ZDBSidebar").style.animationName = "hide";    
                    setTimeout(function ()
                    {
                        ZRSHomepageListing.isReItmsVisible = false;
                        document.body.removeEventListener("touchstart", ZRSHomepageListing.recentItemsAnimation);   
                    }, 500);
                }
            });
        }, 500);
    }
};

ZRSHomepageListing.recentItemsSlide = function ()    // Recent Items Slide Animation
{
    if (!ZRSHomepageListing.isReItmsVisible && !ZRSHomepageListing.slideAnimation)
    {
        ZRSHomepageListing.slideAnimation = true;   // is set to indicate the slide animation is in process
        ZRSHomeUtil.showSideBar();
        document.body.addEventListener("mousemove", function (event)  
        {
            var isSidebarEle = ((event.target.getAttribute("id") === "ZDBSidebar") || document.getElementById("ZDBSidebar").contains(event.target) || (event.target.getAttribute("id") === "ZDBMaxMinSidebar"));    
            if (ZRSHomepageListing.isReItmsVisible && !ZRSHomepageListing.slideAnimation && !isSidebarEle)
            {
                ZRSHomepageListing.slideAnimation = true;   // is set to indicate the slide animation is in process
                ZRSHomeUtil.hideSideBar();
            }
        });
    }
};


/****************************** Database listing **************************************/

ZRSHomepageListing.renderDataToTab = function (tabType, start, end) {
    $("noMyDatabase").style.display = "none";
    $("NoDatabase").style.display = "none";
//    console.trace();
    ZRSHomepageListing.selectAppropriateDBListTab(tabType);
    var baseTemp = ZRSHomepageListing.getDatabaseListItemTemplate(tabType);
    var isLoadedInCrmplusFrame = typeof CrmPlusImpl !== 'undefined' && CrmPlusImpl.isLoadedInCrmplus();
    var shareInfo = '', sharedByInfo = '';
    var appendDiv = document.createElement("div");
    appendDiv.className = "cloned";
    for (var i = start; i < end; i++) {
        var curDatabaseInfo = ZRSHomepageListing.currentlyRenderedDBInfoList[i];
        var template = baseTemp.cloneNode(true);
        template.removeAttribute("id");
        var isdefaultDB = curDatabaseInfo[tabType === "MYDBS" ? ZRSHomepageListing.myDbIsDefault : ZRSHomepageListing.sharedDbIsDefault];

        var dbId = curDatabaseInfo[tabType === "MYDBS" ? ZRSHomepageListing.myDbDatabaseId : ZRSHomepageListing.sharedDbDatabaseId];
        var dbAssociatedSOID = curDatabaseInfo[tabType === "MYDBS" ? ZRSHomepageListing.myDbZsoId : ZRSHomepageListing.sharedDBZsoId];
        if (isdefaultDB) {
            ZRSHomepageListing.currentDefaultDBInfo.dbId = dbId;
            ZRSHomepageListing.currentDefaultDBInfo.tabType = tabType;
            ZRSHomepageListing.currentDefaultDBInfo.zsoid = dbAssociatedSOID;
        }
        var defaultIconStyle = (isdefaultDB) ? 'width:20px;background-position:-65px -611px;' : '';
        var defaultIconTip = (isdefaultDB) ? ZDBI18NMap.g("zrpt.dashboard.js.removedefault")
                : ZDBI18NMap.g("zrpt.dashboard.js.makedefault");
        ZDBUtil.setNamedChildEls(template, template, "elname", true);
        template.setAttribute("dbId", dbId);
        template.setAttribute("class", "cloned");
        var dbname = template.dbName;
        dbname.setAttribute("href", ZDBGlobal.REPORTS_CONTEXT_NAME
                + "/ZDBDataSheetView.cc?DBID=" + dbId);
        dbname.innerHTML = ZDBEscapeUtil.encodeForHtml(curDatabaseInfo[tabType === "MYDBS" ? ZRSHomepageListing.myDbDatabaseName : ZRSHomepageListing.sharedDbDatabaseName]);
        dbname.setAttribute("id", "ZDBNAME_" + dbId);
        if (typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.getCurrentPortalAdminSOID() != dbAssociatedSOID && isLoadedInCrmplusFrame) {
            dbname.setAttribute("target", "_blank");
        }
        template.createdTime.innerHTML = curDatabaseInfo[tabType === "MYDBS" ? ZRSHomepageListing.myDbCreatedTime : ZRSHomepageListing.sharedDbCreatedTime];
        template.description.innerHTML = ZDBEscapeUtil.encodeForHtml(curDatabaseInfo[tabType === "MYDBS" ? ZRSHomepageListing.myDbDatabaseDesc : ZRSHomepageListing.sharedDbDatabaseDesc]);
        template.description.setAttribute("id", "ZDBDESC_" + dbId);
        var defaultDb = template.defaultDb;
        defaultDb.setAttribute("isdefaultDB", isdefaultDB);
        defaultDb.setAttribute("tip", defaultIconTip);
        defaultDb.setAttribute("style", defaultIconStyle);
        if (tabType === "MYDBS") {
            template.renameDBIcon.setAttribute("dbId", dbId);
            template.backupDBIcon.setAttribute("dbId", dbId);
            var dbInfo = template.dbInfo;
            dbInfo.setAttribute("id", "ZDBSHAREINFO_" + dbId);
            if (curDatabaseInfo[ZRSHomepageListing.myDBIsRemoteDB]) {
                template.backupDBIcon.style.display = "none";
                template.copyDBIcon.setAttribute("isRemoteDB", "true");
            }
            if (!ZRSHomepageListing.databaseShareInfo.hasOwnProperty(dbId))
            {
                ZRSHomepageListing.databaseShareInfo[dbId] = null;
                shareInfo = shareInfo + "," + dbId.toString();
            } else if (ZRSHomepageListing.databaseShareInfo[dbId])
            {
                var sharedUsers = ZRSHomepageListing.databaseShareInfo[dbId]["sharedUsers"];
                var dbOwners = ZRSHomepageListing.databaseShareInfo[dbId]["dbOwners"];
                var isPublic = ZRSHomepageListing.databaseShareInfo[dbId]["isPublic"] ? ZDBI18NMap.g("zrpt.common.js.yes") : ZDBI18NMap.g("zrpt.common.js.no"); 
                var prevInfo = "";
                dbInfo.insertAdjacentHTML('afterbegin', "<li><span class=\"createdUserStyle\">" + ZDBI18NMap.g("zrpt.share.home_page.js.shared_user") + "</span> <span class=\"createdUserOption\">" + sharedUsers + "</span></li>" +
                        "<li><span class=\"createdUserStyle\">" + ZDBI18NMap.g("zrpt.share.home_page.js.db_owner") + " </span><span class=\"createdUserOption\">" + dbOwners + "</span></li>" +
                        "<li><span class=\"createdUserStyle\">" + ZDBI18NMap.g("zrpt.share.home_page.js.is_public") + " </span><span class=\"createdUserOption\">" + isPublic + "</span></li>" + prevInfo);
            }
        }
        if (tabType === "SHARED") {
            template.sharedByEmail.setAttribute('id', 'sharedByEmail_' + dbId);
            if (!ZRSHomepageListing.SharedEmailJson.hasOwnProperty(dbId)) {
                template.sharedByEmail.innerHTML = '';
                ZDBUtil.addClass(template.sharedByEmail, 'loadingdots');
                ZRSHomepageListing.SharedEmailJson[dbId] = null
                sharedByInfo = sharedByInfo + ',' + dbId;
            } else if (ZRSHomepageListing.SharedEmailJson[dbId]) {
                template.sharedByEmail.innerHTML = ZRSHomepageListing.SharedEmailJson[dbId];
            }
        }
        appendDiv.appendChild(template);
        template.style.display = "";
    }
    var el = $("ZDBListDatabases_Tbl");
    ZDBUtil.removeElementsByClassName(el, "cloned");
    el.insertBefore(appendDiv, el.childNodes[0] ? el.childNodes[0] : null);
    el.setAttribute('listtype', tabType);
    if (shareInfo.length > 1)
    {
        ZRSHomepageListing.fetchShare(shareInfo.substring(1));
    }
    if (sharedByInfo.length > 1) {
        ZRSHomepageListing.fetchSharedByInfo(sharedByInfo.substring(1));
    }
    ZRSHomepageListing.updateDBListNavigation(tabType, start, end);
    ZRSHomeUtil.handleFooter();
};

ZRSHomepageListing.updateDBListNavigation = function (tabType, start, end) {
    var renderDataLength = ZRSHomepageListing.currentlyRenderedDBInfoList.length;
    var searchBox = $("ZDBDBSEARCHBOX");
    var ZRSDBNavigation = document.getElementById('ZRSDBNavigation');
    if (ZRSDBNavigation) {
        ZRSDBNavigation.parentNode.removeChild(ZRSDBNavigation);
    }
    ZDBSearchUtil.dntBlur = false;
    if (renderDataLength > 20) {
        var ZRSDBNavigation = document.createElement("div");
        ZRSDBNavigation.setAttribute("id", "ZRSDBNavigation");
        ZRSDBNavigation.setAttribute("class", "ZRSDBNavigation cloned");
        var parNavi = document.createElement("div");
        parNavi.setAttribute("class", "parNavi");
        ZRSDBNavigation.appendChild(parNavi);
        if (start - 20 >= 0) {
            var ZRSDBNavPre = document.createElement("div");
            ZRSDBNavPre.setAttribute("class", "ZRSDBNavPre");
            ZRSDBNavPre.onclick = function () {
                ZRSHomepageListing.renderDataToTab(tabType, start - 20, start);
            }
            parNavi.appendChild(ZRSDBNavPre);
        }
        var ZRSDBNavTxt = document.createElement("div");
        ZRSDBNavTxt.setAttribute("class", "ZRSDBNavTxt");
        parNavi.appendChild(ZRSDBNavTxt);
        ZRSDBNavTxt.innerHTML = (start + 1) + " - " + end + " " + ZDBI18NMap.g("zrpt.share.home_page.js.of") + " " + renderDataLength;  
        if (renderDataLength > end) {
            var ZRSDBNavNext = document.createElement("div");
            ZRSDBNavNext.setAttribute("class", "ZRSDBNavNext");
            ZRSDBNavNext.onclick = function () {
                ZRSHomepageListing.renderDataToTab(tabType, end, end + 20 <= renderDataLength ? end + 20 : renderDataLength);
            }
            parNavi.appendChild(ZRSDBNavNext);
        }
        var searchHolder = document.getElementById('ZDBHomeTabs').querySelector('.ZRSDBSearchFld');
        searchHolder.parentNode.insertBefore(ZRSDBNavigation, searchHolder.nextSibling ? searchHolder.nextSibling : null);
        if ((end - start) > 10) {
            var databaseList = document.getElementById('ZDBListDatabases_Tbl');
            var bottomList = ZRSDBNavigation.cloneNode(true);
            bottomList.setAttribute('style', 'position:relative;margin:14px auto;left:14px;');
            if (bottomList.querySelector('.ZRSDBNavPre')) {
                var el = bottomList.querySelector('.ZRSDBNavPre');
                el.onclick = function () {
                    ZRSHomepageListing.renderDataToTab(tabType, start - 20, start);
                }
            }
            if (bottomList.querySelector('.ZRSDBNavNext')) {
                var el = bottomList.querySelector('.ZRSDBNavNext');
                el.onclick = function () {
                    ZRSHomepageListing.renderDataToTab(tabType, end, end + 20 <= renderDataLength ? end + 20 : renderDataLength);
                }
            }
            databaseList.insertBefore(bottomList, databaseList.children[0].nextSibling ? databaseList.children[0].nextSibling : null);
        }
    } else if (searchBox.value !== ZDBI18NMap.g("zrpt.home.js.dbsearch")) {
        //to show "8 matches found" text when matched count is less than 20 for the search param.
        var ZRSDBNavigation = document.createElement("div");
        ZRSDBNavigation.setAttribute("id", "ZRSDBNavigation");
        ZRSDBNavigation.setAttribute("class", "ZRSDBNavigation cloned");
        var ZRSDBNavTxt = document.createElement("div");
        ZRSDBNavTxt.setAttribute("class", "parNavi ZRSDBNavTxt");
        ZRSDBNavTxt.setAttribute('style', 'float:none;');
        ZRSDBNavTxt.innerText = (renderDataLength) + " " + ((renderDataLength == 1) ? ZDBI18NMap.g("zrpt.home.js.matchfound") : ZDBI18NMap.g("zrpt.home.js.matchesfound"));
        ZRSDBNavigation.appendChild(ZRSDBNavTxt);
        var searchHolder = document.getElementById('ZDBHomeTabs').querySelector('.ZRSDBSearchFld');
        searchHolder.parentNode.insertBefore(ZRSDBNavigation, searchHolder.nextSibling ? searchHolder.nextSibling : null);
    }
};

ZRSHomepageListing.getDatabaseListItemTemplate = function (tabType) {
    return tabType === "MYDBS" ? $("MyDatabasesTemplate").cloneNode(true) : tabType === "SHARED" ? $("SharedTemplate").cloneNode(true) : null;
};

ZRSHomepageListing.getOwnedAndSharedDatabaseInfo = function () {
    var myDBSForZsoid = null, sharedDBSForZsoid = null;
    if (ZRSHomepageListing.ZSOID === -1) {
        if (ZRSHomepageListing.dbInfos.MYDBS) {
            myDBSForZsoid = [];
            for (var namespace in ZRSHomepageListing.dbInfos.MYDBS) {
                var curNamespaceDBInfos = ZRSHomepageListing.dbInfos.MYDBS[namespace];
                curNamespaceDBInfos.forEach(function (dbInfo) {
                    myDBSForZsoid.push(dbInfo);
                });
            }
        }
        if (ZRSHomepageListing.dbInfos.SHARED) {
            sharedDBSForZsoid = [];
            for (var namespace in ZRSHomepageListing.dbInfos.SHARED) {
                var curNamespaceDBInfos = ZRSHomepageListing.dbInfos.SHARED[namespace];
                curNamespaceDBInfos.forEach(function (dbInfo) {
                    sharedDBSForZsoid.push(dbInfo);
                });
            }
        }
    } else {
        myDBSForZsoid = ZRSHomepageListing.dbInfos.MYDBS ? ZRSHomepageListing.dbInfos.MYDBS[ZRSHomepageListing.ZSOID] ? ZRSHomepageListing.dbInfos.MYDBS[ZRSHomepageListing.ZSOID] : null : null;
        sharedDBSForZsoid = ZRSHomepageListing.dbInfos.SHARED ? ZRSHomepageListing.dbInfos.SHARED[ZRSHomepageListing.ZSOID] ? ZRSHomepageListing.dbInfos.SHARED[ZRSHomepageListing.ZSOID] : null : null;
    }
    return [myDBSForZsoid, sharedDBSForZsoid];
};

ZRSHomepageListing.renderDBListing = function (isOrgChange)
{
    var orgInfo = ZROrg.getDefaultOrg(ZDBGlobal.canShowCreateSchemaOpt);
    setCookie("org-selected", undefined);  // NO I18N
    setCookie("orgname", undefined);  // NO I18N
    var defaultZsoid = parseFloat(orgInfo[0]);
    ZRSHomepageListing.ZSOID = defaultZsoid;
    var isAdmin = orgInfo[1];
    var sharedRequestSent = false;
    var dbInfos = ZRSHomepageListing.getOwnedAndSharedDatabaseInfo();
    var myDBSForZsoid = dbInfos[0], sharedDBSForZsoid = dbInfos[1];
    var hashValue = window.location.hash.replace('#', '');
    hashValue = hashValue ? hashValue : 'MYDBS';
    if (hashValue === 'MYDBS' && (!isAdmin && (myDBSForZsoid === null || myDBSForZsoid === undefined))) {
        hashValue = 'SHARED';
    }
    hashValue = isOrgChange ? isAdmin ? 'MYDBS' : 'SHARED' : hashValue;
    document.getElementById('ZDBListDatabases_Tbl').innerHTML = '';
    if (!ZRSHomepageListing.dbInfos.SHARED) {
        var renderWhenResponseReceived = hashValue === 'SHARED';
        sharedRequestSent = true;
        ZRSHomepageListing.sendSharedDBListReq(renderWhenResponseReceived);
    } else {
        typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.onloadChanges('{"SHAREDDBLIST":true}');
    }
    if(hashValue !== 'MYDBS' && hashValue !== 'SHARED' && (hashValue === 'CREATEDB' && typeof CrmPlusLib === "undefined")){
        hashValue = 'MYDBS';
    }
    if ((hashValue === 'MYDBS' && myDBSForZsoid !== null && myDBSForZsoid.length > 0) || (hashValue === 'SHARED' && sharedDBSForZsoid !== null && sharedDBSForZsoid.length > 0)) {
        var data = (hashValue === 'MYDBS') ? myDBSForZsoid : sharedDBSForZsoid;
        window.location.hash = hashValue;
        ZRSHomepageListing.currentlyRenderedDBInfoList = data;
        ZRSHomepageListing.selectAppropriateDBListTab(hashValue);
        ZRSHomepageListing.renderDataToTab(hashValue, 0, data.length > 20 ? 20 : data.length);
    } else if(hashValue === 'CREATEDB' && typeof CrmPlusLib !== "undefined") {
        typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.selectHash(hashValue);
    } else if (!sharedRequestSent) {
        window.location.hash = hashValue;
        ZRSHomepageListing.selectAppropriateDBListTab(hashValue);
        var ZRSDBNavigation = document.getElementById('ZRSDBNavigation');
        if (ZRSDBNavigation) {
            ZRSDBNavigation.parentNode.removeChild(ZRSDBNavigation);
        }
        ZRSHomepageListing.handleEmptyDBList(hashValue);
    }
    var createDBCnt = $("ZRCreateDBCnt");
    if (!ZDBClientUI.readOnlyMode && isAdmin) {
        if (createDBCnt) {//For CRMPlus trail expired user case, $("ZRCreateDBCnt") element will not be included in jsp/jspf.
            if (ZDBGlobal.canShowCreateSchemaOpt)
            {
                createDBCnt.style.display = "none";
                //$('ZRSGettingStarted').style.marginTop = '-10px';
            } else
            {
                createDBCnt.style.display = "";
                //$('ZRSGettingStarted').style.marginTop = '27px';
            }
        }
    } else {
        //$('ZRSGettingStarted').style.marginTop = '-10px';
        if (createDBCnt) {
            createDBCnt.style.display = "none";
        }
    }
    ZRSHomeUtil.resizeHolders();
};

ZRSHomepageListing.fetchSharedByInfo = function (dbIdsStr) {
    var params = "ZOHO_DBIDS=" + dbIdsStr; 
//    AjaxAPI.sendRequest({
//        URL: "/reportsapi/SHAREDDBINFO", 
//        PARAMETERS: params,
//        ONSUCCESSFUNC: ZRSHomepageListing.handleFetchSharedByInfoResp
//    });
    
    ZRSAjax.get('/reportsapi/SHAREDDBINFO', params, {
        successHandler: {
            func: ZRSHomepageListing.handleFetchSharedByInfoResp,
            ctx: ZRSHomepageListing
        },
        noLoader: true
    });
};

ZRSHomepageListing.handleFetchSharedByInfoResp = function (shareInfo, requestOptions) {
    for (var dbId in shareInfo) {
        var user = shareInfo[dbId];
        var sharedUsersEmail = user["sharedBy"]; 
        ZRSHomepageListing.SharedEmailJson[dbId] = sharedUsersEmail;
        ZRSHomepageListing.sharedUserInfo[dbId] = user;
        // var prevInfo = "";    
        var elsharedByEmail = $("sharedByEmail_" + dbId);
        if (elsharedByEmail != null)
        {
            elsharedByEmail.innerHTML = "";
            ZDBUtil.removeClass(elsharedByEmail, "loadingdots");
            elsharedByEmail.innerHTML = (sharedUsersEmail) ? sharedUsersEmail : "";
        }
    }
    var searchBox = $("ZDBDBSEARCHBOX");
    if (requestOptions.UPDATESEARCH && searchBox.value !== ZDBI18NMap.g("zrpt.home.js.dbsearch")) {
        ZRSHomepageListing.searchDatabases(searchBox);
    }
};

ZRSHomepageListing.fetchShare = function (dbIdsStr) {
    var params = "ZOHO_DBIDS=" + dbIdsStr; 
//    AjaxAPI.sendRequest({
//        URL: "/reportsapi/DBDETAILS", 
//        PARAMETERS: params,
//        ONSUCCESSFUNC: ZRSHomepageListing.handleFetchDbDetailsResp
//    });
    
    ZRSAjax.get('/reportsapi/DBDETAILS', params, {
        successHandler: {
            func: ZRSHomepageListing.handleFetchDbDetailsResp,
            ctx: ZRSHomepageListing
        },
        noLoader: true
    });
};

ZRSHomepageListing.handleFetchDbDetailsResp = function (shareDetResp) {
    for (var dbId in shareDetResp) {
        var shareInfo = shareDetResp[dbId];
        var sharedUsers = shareInfo["sharedUsers"];
        var dbOwners = shareInfo["dbOwners"];
        var isPublic = shareInfo["isPublic"] ? ZDBI18NMap.g("zrpt.common.js.yes") : ZDBI18NMap.g("zrpt.common.js.no"); 
        ZRSHomepageListing.databaseShareInfo[dbId] = {};
        ZRSHomepageListing.databaseShareInfo[dbId]["sharedUsers"] = shareInfo["sharedUsers"];
        ZRSHomepageListing.databaseShareInfo[dbId]["dbOwners"] = shareInfo["dbOwners"];
        ZRSHomepageListing.databaseShareInfo[dbId]["isPublic"] = shareInfo["isPublic"];
        //var prevInfo = "";
        if ($("ZDBSHAREINFO_" + dbId))
        {
            $("ZDBSHAREINFO_" + dbId).innerHTML = "";
            $("ZDBSHAREINFO_" + dbId).insertAdjacentHTML('afterbegin', "<li><span class=\"createdUserStyle\">" + ZDBI18NMap.g("zrpt.share.home_page.js.shared_user") + "</span> <span class=\"createdUserOption\">" + sharedUsers + "</span></li>" +
                    "<li><span class=\"createdUserStyle\">" + ZDBI18NMap.g("zrpt.share.home_page.js.db_owner") + " </span><span class=\"createdUserOption\">" + dbOwners + "</span></li>" +
                    "<li><span class=\"createdUserStyle\">" + ZDBI18NMap.g("zrpt.share.home_page.js.is_public") + " </span><span class=\"createdUserOption\">" + isPublic + "</span></li>");
        }
    }
};

ZRSHomepageListing.changeDBListHash = function (el)
{
    var listType = el.getAttribute ? el.getAttribute("listtype") : el;
    window.location.hash = listType;
};

ZRSHomepageListing.handleUIOnHashChange = function ()
{
    var hashValue = window.location.hash.replace("#", "");
    var databasesToRender = null;
    var dbInfos = ZRSHomepageListing.getOwnedAndSharedDatabaseInfo();
    if (hashValue === "MYDBS") {
        databasesToRender = dbInfos[0];
    }
    else if (hashValue === "SHARED") {
        databasesToRender = dbInfos[1];
    }
    else if(hashValue === 'CREATEDB' && typeof CrmPlusLib !== "undefined"){
        typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.selectHash(hashValue);
    }
    else{
        return;
    }
    $("noMyDatabase").style.display = "none";
    $("NoDatabase").style.display = "none";
    var searchBox = $("ZDBDBSEARCHBOX");
    if (searchBox.value !== ZDBI18NMap.g("zrpt.home.js.dbsearch")) {
        ZDBSearchUtil.clearSearch(searchBox.parentNode.querySelector('[elname="ZRSSearchIcon"]'));
//        searchBox.value = ZDBI18NMap.g("zrpt.home.js.dbsearch");
        searchBox.blur();
//        ZRSHomepageListing.searchDatabases(searchBox);
    }
    ZRSHomepageListing.selectAppropriateDBListTab(hashValue);
    if (databasesToRender && databasesToRender.length > 0) {
        ZRSHomepageListing.currentlyRenderedDBInfoList = databasesToRender;
        ZRSHomepageListing.renderDataToTab(hashValue, 0, databasesToRender.length > 20 ? 20 : databasesToRender.length);
    } else {
        var ZRSDBNavigation = document.getElementById('ZRSDBNavigation');
        if (ZRSDBNavigation) {
            ZRSDBNavigation.parentNode.removeChild(ZRSDBNavigation);
        }
        ZRSHomepageListing.handleEmptyDBList(hashValue);
    }
    typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.selectHash(hashValue);
};


ZRSHomepageListing.handleEmptyDBList = function (hashValue) {
    if (hashValue === "SHARED") {
        var dbList = document.getElementById('ZDBListDatabases_Tbl');
        dbList.setAttribute('listtype', hashValue);
        var noDatabase = $("NoDatabase");
        noDatabase.style.display = "";
        var noShare = noDatabase.children[0];
        noShare.style.display = "";
        //noShare.style["font-weight"]="900";
        noShare.innerHTML = ZDBI18NMap.g("zrpt.home.js.nosharedb");
        noDatabase.children[1].style.display = "none";
        noShare.setAttribute("class", "dbNameFont noShare");
        ZRSHomeUtil.handleFooter();
    } else if (hashValue === "MYDBS") {
        var dbList = document.getElementById('ZDBListDatabases_Tbl');
        dbList.setAttribute('listtype', hashValue);
        var noDatabase = $("NoDatabase");
        noDatabase.style.display = "";
        var noShare = noDatabase.children[0];
        noShare.style.display = "";
        //noShare.style["font-weight"]="500";
        noShare.innerHTML = ZDBI18NMap.g("zrpt.home.js.dbnotselect");
        if (ZDBGlobal.IS_SAS_BUILD)
        {
            noDatabase.children[1].style.display = "";
        }
        noShare.setAttribute("class", "dbNameFont noShare");
        ZRSHomeUtil.handleFooter();
    }
};

ZRSHomepageListing.selectAppropriateDBListTab = function (hashValue) {
    var dbList = document.getElementById('ZDBListDatabases_Tbl');
    var curListType = dbList.getAttribute('listtype');
    window.location.hash = hashValue;
    if (curListType === hashValue) {
        return;
    } else {
        dbList.innerHTML = '';
        var homeTabs = document.getElementById('ZDBHomeTabs');
        var listTypes = homeTabs.querySelectorAll('[listtype]');
        var listType = homeTabs.querySelector('[listtype="' + hashValue + '"]');
        if (listType) {
            for (var i = 0, len = listTypes.length; i < len; i++) {
                listTypes[i].className = (listTypes[i] == listType) ? "buttonSelected" : "buttonDeselected";
                var loader = listTypes[i].querySelector('.ZRSFillLoading');
                if (loader) {
                    loader.parentNode.removeChild(loader);
                }
            }
            ZRSHomepageListing.loadFilling(listType);
        }
    }
};

ZRSHomepageListing.loadFilling = function (tab) {
    var span = document.createElement('span');
    span.setAttribute('id', 'ZRSLoading');
    span.className = 'ZRSFillLoading';
    span.setAttribute('style', 'width: 0%; display: none;');
    tab.appendChild(span);
    span = jQuery(span);
    span.show().animate({width: '100%'}, 100);
};

// /**************************** Database Auto Naming **********************************/
ZRSHomepageListing.autoDatabaseName = function (el) {
    var autoName = ZDBI18NMap.g("zrpt.common.js.database") + " - ";
    autoName = autoName.replace(/\b\w/g, function (l) {
        return l.toUpperCase();
    });
    var number = 1;
    var arr = [];
    if(ZRSHomepageListing.dbInfos.MYDBS){
        for(var namespace in ZRSHomepageListing.dbInfos.MYDBS){
            var curNamespaceDBs = ZRSHomepageListing.dbInfos.MYDBS[namespace];
            curNamespaceDBs.forEach(function(db){
                var dbName = db[ZRSHomepageListing.myDbDatabaseName];
                var subDbName = dbName.substring(0, 11);
                if(subDbName == autoName){
                    var int = parseInt(dbName.substring(11));
                    if(!isNaN(int)){
                        arr.push(int);
                    }
                }
            });
        }
    }
//    if (ZRSHomepageListing.dbInfos.MYDBS && ZRSHomepageListing.dbInfos.MYDBS[ZRSHomepageListing.ZSOID]) {
//        for (var i = 0; i < ZRSHomepageListing.dbInfos.MYDBS[ZRSHomepageListing.ZSOID].length; i++) {
//            var databaseName = ZRSHomepageListing.dbInfos.MYDBS[ZRSHomepageListing.ZSOID][i][ZRSHomepageListing.myDbDatabaseName];
//            var isDatabase = databaseName.substring(0, 11);
//            if (isDatabase == autoName)
//            {
//                var int = parseInt(databaseName.substring(11));
//                arr.push(int);
//            } else {
//                continue;
//            }
//        }
//    }
    while (arr.indexOf(number) != -1) {
        number++;
    }
    $(el).children[1].value = autoName + number;
};

ZRSHomepageListing.updateList = function (response, requestOptions)
{
    var completedActionName = requestOptions["ACTION"];
    if (completedActionName === 'COPYDATABASE') {
        var params = response.getResponseParams();
        var dbId = params['NEWDBID'];
        var dbName = requestOptions['DBNAME'];
        typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.pushChanges(ZRCRMPlus.COPYDATABASE, dbId, dbName);
//        AjaxAPI.sendRequest({
//            URL: '/reportsapi/MYDBLIST', 
//            ONSUCCESSFUNC: ZRSHomepageListing.myDataBasesListing
//        });
        
        ZRSAjax.get('/reportsapi/MYDBLIST', 
            null,
            {
                successHandler: {
                    func: ZRSHomepageListing.myDataBasesListing,
                    ctx: ZRSHomepageListing
                }
            }
        );
    } else if (completedActionName === "MOVEDBTOTRASH") {
        var dbId = requestOptions["DBID"];
        typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.pushChanges(ZRCRMPlus.DELETEDATABASE, dbId);
        var myDBList = ZRSHomepageListing.dbInfos.MYDBS;
        var dbsInNamespace;
        if (myDBList) {
            updateNamespace:
                for (var namespace in myDBList) {
                dbsInNamespace = myDBList[namespace];
                for (var i = 0, len = dbsInNamespace.length; i < len; i++) {
                    if (dbsInNamespace[i][1] == dbId) {
                        dbsInNamespace.splice(i, 1);
                        break updateNamespace;
                    }
                }
            }
        }
        if(dbsInNamespace && !dbsInNamespace.length) {
            ZDBUtil.removeAllChildren($("ZDBListDatabases_Tbl"));
        }
        ZRSHomepageListing.changeDBListHash('MYDBS');
        ZRSHomepageListing.handleUIOnHashChange();
    }
    var searchBox = $("ZDBDBSEARCHBOX");
    if (searchBox.value !== ZDBI18NMap.g("zrpt.home.js.dbsearch")) {
        searchBox.value = "";
        jQuery(searchBox.previousElementSibling).removeClass("ZRSSearchClearIcon").addClass("ZRSSearchIcon").show();
        ZDBSearchUtil.showTipString(searchBox);
        searchBox.blur();
    }
};

ZRSHomepageListing.myDataBasesListing = function (jsonResp) {
    delete ZRSHomepageListing.dbInfos.MYDBS;
    ZRSHomepageListing.refactorServerResponse(jsonResp);
    ZRSHomepageListing.changeDBListHash('MYDBS');
    ZRSHomepageListing.handleUIOnHashChange();
};


ZRSHomepageListing.handleSearchFocus = function () {
    var hash = window.location.hash;
    hash = hash.replace('#', '');
    var dbIds = '';
    var sharedDBInfoForCurZSOID = ZRSHomepageListing.getOwnedAndSharedDatabaseInfo()[1];
    if (hash === "SHARED" && sharedDBInfoForCurZSOID) {
        var sharedDBInfos = sharedDBInfoForCurZSOID;
        sharedDBInfos.forEach(function (db) {
            if (!ZRSHomepageListing.SharedEmailJson.hasOwnProperty(db[ZRSHomepageListing.sharedDbDatabaseId])) {
                dbIds += ',' + db[ZRSHomepageListing.sharedDbDatabaseId];

            }
        });

    }
    dbIds = dbIds.substring(1);
    if (dbIds) {
//        AjaxAPI.sendRequest({
//            URL: "/reportsapi/SHAREDDBINFO",  
//            PARAMETERS: "ZOHO_DBIDS=" + dbIds,  
//            ONSUCCESSFUNC: ZRSHomepageListing.handleFetchSharedByInfoResp,
//            UPDATESEARCH: true
//        });
        ZRSAjax.get('/reportsapi/SHAREDDBINFO', 'ZOHO_DBIDS=' + dbIds, {
            successHandler: {
                func: ZRSHomepageListing.handleFetchSharedByInfoResp,
                ctx: ZRSHomepageListing
            },
            UPDATESEARCH: true,
            noLoader: true
        });
    }
};

ZRSHomepageListing.searchDatabases = function (el) {
    var value = el.value;
    var hash = window.location.hash;
    hash = hash.replace('#', '');
    var dbInfo = ZRSHomepageListing.getOwnedAndSharedDatabaseInfo();
    var searchSpace = hash === "MYDBS" ? dbInfo[0] : dbInfo[1];
    if (searchSpace) {
        var resultantInfo = [];
        for (var i = 0, len = searchSpace.length; i < len; i++) {
            var curDB = searchSpace[i];
            var curDBId = curDB[hash === "MYDBS" ? ZRSHomepageListing.myDbDatabaseId : ZRSHomepageListing.sharedDbDatabaseId];
            var sharedByInfo = ZRSHomepageListing.SharedEmailJson[curDBId];
            sharedByInfo = sharedByInfo ? sharedByInfo : '';
            var curDBName = curDB[hash === "MYDBS" ? ZRSHomepageListing.myDbDatabaseName : ZRSHomepageListing.sharedDbDatabaseName];
            var curDBDesc = curDB[hash === "MYDBS" ? ZRSHomepageListing.myDbDatabaseDesc : ZRSHomepageListing.sharedDbDatabaseDesc];
            curDBDesc = curDBDesc ? curDBDesc : '';
            if (curDBName.toLowerCase().indexOf(value.toLowerCase()) > -1 || 
               (curDBDesc.toLowerCase().indexOf(value.toLowerCase()) > -1) || 
               sharedByInfo.toLowerCase().indexOf(value.toLowerCase()) > -1) {
                resultantInfo.push(curDB);
            }
        }
        if (resultantInfo.length > 0) {
            ZRSHomepageListing.currentlyRenderedDBInfoList = resultantInfo;
            ZRSHomepageListing.renderDataToTab(hash, 0, ZRSHomepageListing.currentlyRenderedDBInfoList.length > 20 ? 20 : ZRSHomepageListing.currentlyRenderedDBInfoList.length);
        } else {
            var el = $("ZDBListDatabases_Tbl");
            ZDBUtil.removeElementsByClassName(el, "cloned"); 
            var noDatabase = $("NoDatabase");
            noDatabase.style.display = "";
            var noShare = noDatabase.children[0];
            noShare.style.display = "";
            //noShare.style["font-weight"]="900"; 
            noDatabase.children[0].innerHTML = hash === "MYDBS" ? ZDBI18NMap.g("zrpt.home.js.nomatchdb") : ZDBI18NMap.g("zrpt.home.js.nomatchsharedb");
            noDatabase.children[1].style.display = "none";
            var ZRSDBNavigation = document.getElementById('ZRSDBNavigation');
            if (ZRSDBNavigation) {
                ZRSDBNavigation.parentNode.removeChild(ZRSDBNavigation);
            }
            ZRSHomeUtil.handleFooter();
        }
    }
};

function trashDB(el)
{
    var dbId = DOMUtils.getParentWithAttr(el, "dbid").getAttribute("dbid");
    var dbName = document.getElementById("ZDBNAME_" + dbId).innerText; 
    var parEl = DOMUtils.getParentWithAttrValue(el, "class", "ZRSDBList ZRSDBHighlight");
    parEl.isDialogOpen = true;
    ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.home.errmsg.js.del_db", ZDBEscapeUtil.encodeForHtml(dbName)), "ZDBYESNO", 
            {ONCLICK: trashDataBase, DBID: dbId, CALLOUT: true, SRCEL: el, PAREL: parEl});
}

function makeDBDefault(el)
{
    var dbId = DOMUtils.getParentWithAttr(el, "dbid").getAttribute("dbid"); 
    var listType = jQuery("#ZDBHomeTabs li.buttonSelected")[0].getAttribute("listtype"); 
    var toMakeDefault = !(el.getAttribute('isdefaultDB') == 'true');

    //For manipulating Client Start Default DB
    if (ZRSHomepageListing.currentDefaultDBInfo.dbId && ZRSHomepageListing.dbInfos[ZRSHomepageListing.currentDefaultDBInfo.tabType]
            && ZRSHomepageListing.dbInfos[ZRSHomepageListing.currentDefaultDBInfo.tabType][ZRSHomepageListing.currentDefaultDBInfo.zsoid]) {
        var dbsInZSOID = ZRSHomepageListing.dbInfos[ZRSHomepageListing.currentDefaultDBInfo.tabType][ZRSHomepageListing.currentDefaultDBInfo.zsoid];
        dbsInZSOID.forEach(function (dbInfo) {
            if (ZRSHomepageListing.currentDefaultDBInfo.dbId == dbInfo[ZRSHomepageListing.currentDefaultDBInfo.tabType === "MYDBS" ? ZRSHomepageListing.myDbDatabaseId : ZRSHomepageListing.sharedDbDatabaseId]) {
                dbInfo[ZRSHomepageListing.currentDefaultDBInfo.tabType === "MYDBS" ? ZRSHomepageListing.myDbIsDefault : ZRSHomepageListing.sharedDbIsDefault] = false;
            }
        });
    }
    if (toMakeDefault) {
        var myDBList = ZRSHomepageListing.dbInfos[listType];
        if (myDBList) {
            updateNamespace:
                    for (var namespace in myDBList) {
                var dbsInNamespace = myDBList[namespace];
                for (var i = 0, len = dbsInNamespace.length; i < len; i++) {
                    if (dbsInNamespace[i][1] == dbId) {
                        dbsInNamespace[i][listType === "MYDBS" ? ZRSHomepageListing.myDbIsDefault : ZRSHomepageListing.sharedDbIsDefault] = true;
                        ZRSHomepageListing.currentDefaultDBInfo.dbId = dbsInNamespace[i][listType === "MYDBS" ? ZRSHomepageListing.myDbDatabaseId : ZRSHomepageListing.sharedDbDatabaseId];
                        ZRSHomepageListing.currentDefaultDBInfo.zsoid = dbsInNamespace[i][listType === "MYDBS" ? ZRSHomepageListing.myDbZsoId : ZRSHomepageListing.sharedDBZsoId];
                        ZRSHomepageListing.currentDefaultDBInfo.tabType = listType;
                        break updateNamespace;
                    }
                }
            }
        }
    }
    var parentEl = jQuery("#ZDBListDatabases_Tbl");
    var addDefaultDB = true;
    var elem = jQuery(el);
    var dbName = encodeURIComponent(elem.parent().siblings("a").html());
    if (elem.attr("isdefaultDB") == "false")
    {
        elem.css("width", "20px").css("background-position", "-65px -611px").attr("isdefaultDB", "true").attr("tip", ZDBI18NMap.g("zrpt.common.home.js.removedefaultdb"));
    } else
    {
        elem.css("width", "").css("background-position", "-158px -74px").attr("isdefaultDB", "false").attr("tip", ZDBI18NMap.g("zrpt.common.home.js.makedefaultdb"));
        addDefaultDB = false;
    }
    ZDBToolTip.hide();
    ZDBToolTip.show(el);
    parentEl.find(".defaultDBIcon").not(el).attr("isdefaultDB", "false").css("width", "").attr("tip", ZDBI18NMap.g("zrpt.common.home.js.makedefaultdb"));
    AjaxAPI.sendRequest({URL: "/ZDBDatabaseActionMI.ma?ZDBACTION=ADDRDELDEFAULTDB", 
        PARAMETERS: "&DBID=" + dbId + "&DBNAME=" + dbName + "&ISADDDEFAULTDB=" + addDefaultDB, 
        "ISADDDEFAULTDB": addDefaultDB});
}

function trashDataBase(clickType, requestOptions)
{
    if (clickType === "NO")
    {
        var parEl = requestOptions.PAREL;
        parEl.isDialogOpen = false;
        ZDBCreateDB.hideOptions(parEl);
        return;
    }
    var dbId = requestOptions.DBID;
    var url = ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma"; 
    AjaxAPI.sendRequest({URL: url, PARAMETERS: "ZDBACTION=MOVEDBTOTRASH&DBID=" + dbId, 
        ONSUCCESSFUNC: ZRSHomepageListing.updateList, OPSTATUSID: "DBAccessChange_" + dbId, DBID: dbId, ACTION: "MOVEDBTOTRASH"});
}


function renameDB(el)
{
    var dbId = DOMUtils.getParentWithAttr(el, "dbid").getAttribute("dbid");
    var dbNode = $('ZDBNAME_' + dbId);
    var dbName = ZDBUtil.getText(dbNode);
    var desc = '';
    var descEl = $('ZDBDESC_' + dbId);
    if (descEl != null)
    {
        desc = ZDBUtil.getText(descEl);
    }
    if (!ZDBLazyLoadUtil.loadSnippet("RENAMEDB_DLG", "/ZDBRenameDB.cc", this, "APPENDTODOC"))
    {
        return;
    }
    var dlg = $('ZDBRenameDBDetails');
    dlg.style.display = 'block';
    var dbNameFld = $('ZDBDBNameTxtFld');
    var dbDescFld = $('ZDBDBObjDescTxtFld');
    dbNameFld.value = dbName;
    dbDescFld.value = desc;
    var parEl = DOMUtils.getParentWithAttrValue(el, "class", "ZRSDBList ZRSDBHighlight");
    parEl.isDialogOpen = true;
    dlg.parEl = parEl;
    ZDBDialogUtil.showDialog(dlg, {TITLE: ZDBI18NMap.g('zrpt.common.home.js.renamedb'), ADDFRAME: true, MODAL: true, DONTREMOVE: true,
        ONENTER: submitRenameDB, ORIGNAME: dbName, ORIGDESC: desc,
        NAMEFLD: dbNameFld, DESCFLD: dbDescFld, DBID: dbId,
        CALLOUT: true, SRCEL: el, ONCLOSE: ZDBCreateDB.removeHighlight});
    $('ZDBDBRENAMEOPTSTATUS').className = 'mcLoaded';
    dbNameFld.select();
}

function initJSONForCopyDBAndRenameDB(dbId, el, type) {
    var jsonInfo = {
        dbName: ZDBUtil.getText($('ZDBNAME_' + dbId)),
        desc: '',
        descEl: $('ZDBDESC_' + dbId),
        dbNameFieldSize: fieldSizeClass.DBNAME,
        dbDescFieldSize: fieldSizeClass.DBDESCRIPTION,
        dbID: dbId,
        EL: el,
        dlgname: type,
        isRemoteDB: el.getAttribute("isRemoteDB")
    };
    if (jsonInfo.descEl != null)
    {
        jsonInfo.desc = ZDBUtil.getText(jsonInfo.descEl);
    }
    var idArray;
    var i18nInfo = ZDBI18NMap.m("zrpt.dialoginfo.copyrename");
    if (type === "COPYDB") {
        jsonInfo['IdArray'] = ["ZDBCopyDBDetails", "ZDBDBCPNameTxtFld", "ZDBDBCPObjDescTxtFld", "ZDBDBCOPYOPTSTATUS", "ZDBDBCPDataChkBox"];
    } else {
        jsonInfo['IdArray'] = ["ZDBRenameDBDetails", "ZDBDBNameTxtFld", "ZDBDBObjDescTxtFld", "ZDBDBRENAMEOPTSTATUS"];
    }
    jsonInfo['i18nInfo'] = i18nInfo;
    var holder = (type === "COPYDB") ? ZRBaseComponentsUtils.getContainer("COPYDBDIV", document.body) : ZRBaseComponentsUtils.getContainer("RENAMEDBDIV", document.body);
    var factory = React.createFactory(FullPageDialog);
    var dlg = ReactDOM.render(factory({dlgName: type, jsonInfo: jsonInfo}), holder);
    holder.jsonInfo = jsonInfo;
    return holder;
}

function copyDBWithReact(el, event) {
    if (!loadReact(copyDBWithReact, [el, event])) {
        return;
    }
    if (!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/react/ZRCopyAndRenameDialog.js"], "APPENDTODOC", copyDBWithReact, [el, event])) {
        return;
    }
    var parWtdbID = DOMUtils.getParentWithAttr(el, "dbid");
    var dbId = parWtdbID.getAttribute("dbid");
    var dlg = initJSONForCopyDBAndRenameDB(dbId, el, "COPYDB");
    dlg.style.display = 'block';
    var dbNameFld = $('ZDBDBCPNameTxtFld');
    var dbDescFld = $('ZDBDBCPObjDescTxtFld');
    var dbCopyDataFld = $('ZDBDBCPDataChkBox');
    var parEl = parWtdbID.listdbtd;
    //var parEl = DOMUtils.getParentWithAttrValue(el,"class","ZRSDBList ZRSDBHighlight");
    parEl.isDialogOpen = true;
    dlg.parEl = parEl;
    dlg.setAttribute("isDialog", "true");
    dlg.className = "ZRSShadow";
    ZDBDialogUtil.showDialog(dlg, {TITLE: ZDBI18NMap.g('zrpt.homepage.db.copydb.js.dlgTtl'), ADDFRAME: false, MODAL: true,
        ONENTER: submitCopyDB, ORIGNAME: dlg.jsonInfo.dbName, ORIGDESC: dlg.jsonInfo.desc, NAMEFLD: dbNameFld, DESCFLD: dbDescFld,
        DBID: dbId, COPYDATA: dbCopyDataFld, REDIRECTTONEWDB: "false", DONTREMOVE: true, THISELEMENT: el,
        CALLOUT: true, SRCEL: el, ONCLOSE: ZDBCreateDB.removeHighlight, USEREACT: true});
    $('ZDBDBCOPYOPTSTATUS').className = 'mcLoaded';
    dbNameFld.select();
}

function renameDBWithReact(el, event) {
    if (!loadReact(renameDBWithReact, [el, event])) {
        return;
    }
    if (!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/react/ZRCopyAndRenameDialog.js"], "APPENDTODOC", renameDBWithReact, [el, event])) {
        return;
    }
    var dbId = DOMUtils.getParentWithAttr(el, "dbid").getAttribute("dbid");
    var dlg = initJSONForCopyDBAndRenameDB(dbId, el, "RENAMEDB");
    dlg.style.display = 'block';
    var dbNameFld = $('ZDBDBNameTxtFld');
    var dbDescFld = $('ZDBDBObjDescTxtFld');
    var parEl = DOMUtils.getParentWithAttrValue(el, "class", "ZRSDBList ZRSDBHighlight");
    parEl.isDialogOpen = true;
    dlg.parEl = parEl;
    dlg.setAttribute("isDialog", "true");
    dlg.className = "ZRSShadow";
    ZDBDialogUtil.showDialog(dlg, {TITLE: ZDBI18NMap.g('zrpt.common.home.js.renamedb'), ADDFRAME: false, MODAL: true, DONTREMOVE: true,
        ONENTER: submitRenameDB, ORIGNAME: dlg.jsonInfo.dbName, ORIGDESC: dlg.jsonInfo.desc,
        NAMEFLD: dbNameFld, DESCFLD: dbDescFld, DBID: dbId,
        CALLOUT: true, SRCEL: el, ONCLOSE: ZDBCreateDB.removeHighlight, USEREACT: true});
    $('ZDBDBRENAMEOPTSTATUS').className = 'mcLoaded';
    dbNameFld.select();
}
ZDBLazyLoadFuncMap.lazyLoadFuncMap["copyDBWithReact"] = copyDBWithReact;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["renameDBWithReact"] = renameDBWithReact;
//ignorei18n_end
