//$Id$
/*
 GeoChart object contains function to create MapObject specific to the map lirary used. Should be exposed to the user of library.
 */
$ZC.GeoChart = {
    _mapObjFactory: $ZC._GeoChart._getMapObjectFactroy(),
    getMapObj: function(container, map) {
        if (!isUndefined(window.L) && map instanceof L.Map) {
            return new(this._mapObjFactory.leaflet())(container, map);
        } else if (!isUndefined(window.mapboxgl) && map instanceof mapboxgl.Map) {
            return new(this._mapObjFactory.mapbox())(container, map);
        } else {
            return new(this._mapObjFactory.svgmap())(container, map);
        }
    }
};