//$Id$
getGeoDefaultOptions = function(type,source,userProp)
{
	var options;
	switch(type){
		case "geoscatter"://NO I18N
		case "geobubble"://NO I18N
		case "geobubblepie"://NO I18N
		case "geopie"://NO I18N
                         var genType = type.replace("geo","");//NO I18N
			 options = $ZC.getDefaultOptions(genType, source, userProp);
                         if (type == "geopie" || type == "geobubblepie") {//NO I18N
                            options.dataindex = 1;
                            options.startAngle = 0;
                            options.endAngle = 2 * Math.PI;
                            options.fillOpacity = 0.65;
                            options.datalabels.showAs = "y";//NO I18N
                            options.strokeColor = "rgba(0,0,0,0.4)";//NO I18N
                            options.strokeWidth = 1;
                            options.outerPadding = 0.02;
                            options.hoveroptions = {
                                "innerFillColor": "transparent",//NO I18N
                                "innerStrokeColor": "transparent",//NO I18N
                                "outerFillColor": "transparent",//NO I18N
                                "outerStrokeWidth": 3//NO I18N
                            };
                        } 
                        if(type == "geobubblepie" || type == "geobubble"){//NO I18N
                            options.minSize = "2.75%";//NO I18N
                            options.maxSize = "15%"//NO I18N
                        }
			 $ZC.setDefaultOptions(type, source, userProp,options,true);
                        break;
		case "geofilled"://NO I18N
                    options = {
                        "marker": {//NO I18N
                        },
                        "hoveroptions": {//NO I18N
                        },
                        "datalabels": {//NO I18N
                             "showAs": "y" //x,y,percent//NO I18N
                        },
                        "animation": {//NO I18N
                        },
                        "gradients": {//NO I18N
                        }
                    };
                    $ZC.setDefaultOptions(type, source, userProp,options,true);        
                break;
       	}
}