//$Id$
/*
 * this file contains methods to extract the required forms of data from the user input
 */
$ZC.mapdataset = function(chartDataset, data) {
    var latLngArray = data.geo.latlngArray;
    var featureArray = data.geo.featureArray;
    // chartDataset.getX = function(d){
    //     return this.getLng(d);
    // },
    // chartDataset.getY = function(d,yaxiscolumnorder,range){
    //      return this.getLat(d);
    // }
    chartDataset.getActualX = function(d) {
        return d[this.xidx];
    },
        chartDataset.getLng = function(d) {
            return latLngArray[d[this.geocolumnidx]] == null ? null : latLngArray[d[this.geocolumnidx]][0];
        },
        chartDataset.getLat = function(d) {
            return latLngArray[d[this.geocolumnidx]] == null ? null : latLngArray[d[this.geocolumnidx]][1];
        },
        chartDataset.getLngLat = function(d) {
            return latLngArray[d[this.geocolumnidx]] == null ? null : [latLngArray[d[this.geocolumnidx]][1], latLngArray[d[this.geocolumnidx]][0]];
        },
        chartDataset.getLatLng = function(d) {
            return latLngArray[d[this.geocolumnidx]] == null ? null :
                (latLngArray[d[this.geocolumnidx]][0] instanceof Array ? null : [ latLngArray[d[this.geocolumnidx]][0] == null ? 0 : latLngArray[d[this.geocolumnidx]][0] , latLngArray[d[this.geocolumnidx]][1] == null ? 0 : latLngArray[d[this.geocolumnidx]][1] ]);
        }
        chartDataset.getFeature = function(d) {
            return featureArray[d[this.geocolumnidx]] == null ? null :
                featureArray[d[this.geocolumnidx]] instanceof Array ? null :featureArray[d[this.geocolumnidx]];
        } 
        // to replace json string to json object, as we need it as json object to handle events
        chartDataset.updateFeature = function(d,feature){
                featureArray[d[this.geocolumnidx]]=feature;
        }
        chartDataset.getCentroid = function(d)
        {
            return featureArray[d[this.geocolumnidx]] == null ? null : featureArray[d[this.geocolumnidx]].centroid;
        } 
        chartDataset.getId = function(d)
        {
            return featureArray[d[this.geocolumnidx]] == null ? null : featureArray[d[this.geocolumnidx]].id;
        }
    return chartDataset;
}