//$Id$
/**
 * 
 */

var ODataPage = new function ()
{
    this.editorGlobal;
    this.isRoot = function(url)
    {
        var ss = url;
        var diff = (ss.substring(0, ss.indexOf(".svc")).length+5)-ss.length;
        if (diff==0 || diff==1)
        {
            return true;
        }
        return false;
    }
    
    this.showCreateCloudDB = function (element)
    {
        var lzName = element.getAttribute("lzName");
        var lzOper = (element.getAttribute("lzOper")) ? element.getAttribute("lzOper") : "APPENDTODOC"; //No I18N
        var lzJs = element.getAttribute("lzJs");
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZROData.cc", this, lzOper))
        {
            return;
        }
        ODataPage.showCreateODataDlg();
    };
    
    this.showCreateODataDlg = function ()
    {

        var odataDlg = ZDBUtil.getCachedRef(this, "ZRODataDialog");
        ZDBFullPageDialog.showDialog(odataDlg, {MODAL: true,DONTREMOVE:false});
        $("ZRODataInlineDlgBar").style.display = "none";
        ODataPage.loadNewTblSettings(odataDlg);

    };
    
    this.showODataDetails = function (frm,resp,respOpt)
    {
        ODataPage.showCreateODataDlg();
        
        if(frm.DBNAME)
        {
            $("IDBNAME1").value = frm.DBNAME.value;
            $("IDESCRIPTION").value = frm.DESCRIPTION.value;
        }
        else if(typeof(ZDBClientUI.dbId) != "undefined")
        {
            $("DBID").value = ZDBClientUI.dbId;
        }
            
        $("ODATAURL").value = frm.URL.value; 
        $("ODATA_USERNAME").value = frm.USERNAME.value;
        $("ODATA_PASSWORD").value = frm.PASSWORD.value;
        
        ODataPage.showSelectTablesPage(resp,respOpt);
    }
    
    this.showODataTableDetails = function (frm,resp,respOpt)
    {  
        ODataPage.showCreateODataDlg();
        if(frm.DBNAME)
        {   
            $("IDBNAME1").value = frm.DBNAME.value;
            $("IDESCRIPTION").value = frm.DESCRIPTION.value;
        }
        else if(typeof(ZDBClientUI.dbId) != "undefined")
        {
            $("DBID").value = ZDBClientUI.dbId;
        }
        $("ODATAURL").value = frm.URL.value; 
        $("ODATA_USERNAME").value = frm.USERNAME.value;
        $("ODATA_PASSWORD").value = frm.PASSWORD.value;
        ODataPage.handlePreviewScript(resp,respOpt);
    }
    
    this.loadNewTblSettings = function (odataDlg)
    {
        if (!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js", "APPENDTODOC", ODataPage.loadNewTblSettings,[odataDlg]))
        {
            return;
        }
        hideCustomMessage();
        ZDBUtil.setAttribute($("ODataImport"), "false", "isExistImp");
        ZDBUtil.setAttribute($("ZRODataNextBtn"), 1, "stepNo");
        ODataPage.enableOptForStep();
        ODataPage.enableInitialPage(odataDlg);
        var impOptionSelect = $("ZDBSCHIMPORTTYPE");
        jQuery(impOptionSelect).empty();
        var permLevel = "1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$1$" //DB owners have all permissions
        var perms = permLevel.split("$");
        impOptionSelect = ZDBImport.setImportOption(impOptionSelect, perms);
    };
    this.enableInitialPage = function (frm)
    {
        hideCustomMessage();
        $("MultipleTblList").style.display = "";
        $("ODATAURL").value = ""; //No I18N
        $("ODATA_USERNAME").value = ""; //No I18N
        $("ODATA_PASSWORD").value = ""; //No I18N
    };
    this.enableOptForStep = function (dir)
    {
        var stepNo = ZDBUtil.getAttribute($("ZRODataNextBtn"), "stepNo");
        if(!ODataPage.isRoot($("ODATAURL").value) && stepNo==2 && dir=="R")
        {
            $("ZRODataNextBtn").setAttribute("stepNo",1);
            stepNo = 1;
            $("COUNT").value="0";
        }
        else if(!ODataPage.isRoot($("ODATAURL").value) && stepNo==2)
        {
            $("ZRODataNextBtn").setAttribute("stepNo",3);
            stepNo = 3;
            $("COUNT").value="1";
        }
        var count = parseInt($("COUNT").value);
        if (ZDBUtil.getAttribute($("ODataImport"), "isExistImp") == "false")
        {
            $("ZRODataTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",(parseInt(stepNo)-count));
            $("ZRODataInlineTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",(parseInt(stepNo)-count));
        }
        if(dir == "R" && ZDBUtil.getAttribute($("ODataImport"), "isExistImp") == "false" && ZDBUtil.getAttribute($("ODataImport"), "isExistingDB") == "false" && stepNo == 1)
        {
                showDatabaseDialog('import');   //No I18N
                $("ZDBFILETYPE").value="ODATA";   //No I18N
                $("ZDBFILEOPT").disabled=true;
                $("ZDBPASTEOPT").disabled=true;
                if($("ZDBFTPOPT"))
                {
                    $("ZDBFTPOPT").disabled=true;
                }
                locationSelected('WEB');  //No I18N
        }
        else if(stepNo==1 && dir == "R" && ZDBUtil.getAttribute($("ODataImport"), "isExistingDB") == "true" && ZDBUtil.getAttribute($("ODataImport"), "isexistingtbl") == "false")
        {
            var tbl= $("ZRTblName").value;
            ZDBInlineDialog.closeDialogByType($("ZRODataPrevBtn"));
            ZDBImport.newImportedTable($("ZDBImportTableInExistDBLink"));
            $("ZDBFILETYPE").value="ODATA";   //No I18N
            $("ZDBFILEOPT").disabled=true;
            $("ZDBPASTEOPT").disabled=true;
            if($("ZDBFTPOPT"))
            {
                $("ZDBFTPOPT").disabled=true;
            }
            locationSelected('WEB');  //No I18N
            $("ITABLENAME").value=tbl;
        }
        else if (stepNo == 1) 
        {  
            $("ZRODataTitle").innerHTML = ZDBI18NMap.g("zrpt.home.js.connectodata");
            $("ZRODataDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step1.descriptionodata");
            $("ZRODataInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.home.js.connectodata");
            $("ZRODataInlineDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step1.descriptionodata");
            $("ODataDataSource").style.display = "";
            $("ZRSettings").style.display = "none";
            $("PreviewGrid").style.display = "none";
            $("SchSettings").style.display = "none";
            $("ZRODataPrevBtn").style.display = "none";
            $("ZRODataNextBtn").style.display = "";
            ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
            $("ZRODataNextBtn").className='buttonCompBoxBg';
            $("ZRODataCreateBtn").style.display = "none";
            $("ZRODataImportBtn").style.display = "none";
             $("ZRODataCancelBtn").style.display = "";
            //$("ZRRDBCreateBtn").style.display = "none";
            $("ZDBJOINTABLE").style.display="none";
            $("OnImpError").style.display="none";
            if(ZDBClientUI.selectedTab == null)
            {
                $("ZRODataTitleStep").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.stepone");
            }
            $("ShowCloudDBCmplt").style.display = "none";
            $('ZRODataCmpltOk').style.display = "none";

            
        }
        if (stepNo == 2) 
        {

        
            $("ZRODataTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step2.dbdataselect");
            $("ZRODataDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step2.description.odata");
            $("ZRODataInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step2.dbdataselect");
            $("ZRODataInlineDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step2.description.odata");
            $("ODataDataSource").style.display = "none";
            
            
            	$("SelectTablesToImport").style.display = "";
            	$("ZRODataNextBtn").style.display = "";
            	ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
                $("ZRODataNextBtn").className='buttonCompBoxBg';
            	//$("ZRRDBCreateBtn").style.display = "none";
            
            //$("MultipleTableImport").style.display = "inline-block";
            $("ZRSettings").style.display = "none";
            $("PreviewGrid").style.display = "none";
            $("SchSettings").style.display = "none";
            $("ZRODataPrevBtn").style.display = "";
            $("ZRODataCreateBtn").style.display = "none";
             $("ZRODataCancelBtn").style.display = "";
            $("ZDBJOINTABLE").style.display="none";
            if (ZDBUtil.getAttribute($("ODataImport"), "isExistImp") == "true")
            {
                $("DataSourceDetails").style.display = "";
                $("ZRODataPrevBtn").style.display = "none";
                //$("MultipleTableImport").style.display = "none";
                $("ZRODataTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",1);
                $("ZRODataInlineTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",1);
                $("ZRODataInlineTitleStep").style.display="inline-block";
            }
            $("OnImpError").style.display="none";
            $("ZRODataTitleStep").style.display = "inline-block";
            $("ShowCloudDBCmplt").style.display = "none";
             $('ZRODataCmpltOk').style.display = "none";
             $("ZRODataImportBtn").style.display = "none";
        }
        if (stepNo == 3) 
        {
            $("ZRODataTitle").innerHTML = ZDBI18NMap.f('zrpt.databasedata.import.js.step3.dbpreviewdata.odata', ZDBGlobal.PRODUCTNAME);
            $("ZRODataDesc").innerHTML = ZDBI18NMap.f('zrpt.databasedata.import.js.step3.description.odata', ZDBGlobal.PRODUCTNAME);
            $("ZRODataInlineTitle").innerHTML = ZDBI18NMap.f("zrpt.databasedata.import.js.step3.dbpreviewdata", ZDBGlobal.PRODUCTNAME);
            $("ZRODataInlineDesc").innerHTML = ZDBI18NMap.f("zrpt.databasedata.import.js.step3.description.odata", ZDBGlobal.PRODUCTNAME);
            $("ODataDataSource").style.display = "none";
            $("SelectTablesToImport").style.display = "none";
            $("DataSourceDetails").style.display = "none";
            $("ZRSettings").style.display = "";
            $("ZRTblNameDiv").style.diplay = "";
            $("ZRExistTblNameDiv").style.display = "none";
            $("SchSettings").style.display = "none";
            $("ZRODataPrevBtn").style.display = "";
            $("ZRODataNextBtn").style.display = "";
             $("ZRODataCancelBtn").style.display = "";
            ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
            $("ZRODataNextBtn").className='buttonCompBoxBg';
            $("ZRODataCreateBtn").style.display = "none";
            $("OnImpError").style.display="";
            if (!ODataPage.isRoot($("ODATAURL").value))
            {
                $("PreviewGrid").style.display = "";
            } 
            else
            {
                $("PreviewGrid").style.display = "none";
            }
            if (ZDBUtil.getAttribute($("ODataImport"), "isExistImp") == "true")
            {
                //$("ZRDBNameDiv").style.display = "none";
                //$("ZRDBDesc").style.display = "none";
                $("ZRODataCreateBtn").style.display = "none";
                $("ZRODataImportBtn").style.display = "";
                ZDBUtil.setAttribute($("ZRODataImportBtn"), 'ODataPage.submitODataForm(this.form)', 'onclick');
                $("ZRODataNextBtn").style.display = "none";
                $("SchSettings").style.display = "";
                $("SchImportType").style.display = "block";
                $("SchCanAddNewCol").style.display = "none";
                $("SchTimeZone").style.display = "none";
                $("ZRExistTblName").innerHTML = ZDBClientUI.selectedTab.view.displayName;
                $("ZRTblNameDiv").style.display = "none";
                $("ZRExistTblNameDiv").style.display = "";
                $("ZRODataTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",2);
                $("ZRODataInlineTitleStep").innerHTML=ZDBI18NMap.f("zrpt.databasedata.import.js.stepno",2);
                $("ZRODataInlineTitleStep").style.display="inline-block";
            }
            if($("JOINNEEDED").value == "true")
            {
                $("ZDBJOINTABLE").style.display="";
            }
            else
            {
                $("ZDBJOINTABLE").style.display="none";
            }
            $("ShowCloudDBCmplt").style.display = "none";
             $('ZRODataCmpltOk').style.display = "none";
        }
        if (stepNo == 4) 
        {

            $("ZRODataTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step4.syncsettings");
            $("ZRODataDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step4.description");
            $("ZRODataInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step4.syncsettings");
            $("ZRODataInlineDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.step4.description");
            $("ODataDataSource").style.display = "none";
            $("SelectTablesToImport").style.display = "none";
            $("DataSourceDetails").style.display = "none";
            $("ZRSettings").style.display = "none";
            $("PreviewGrid").style.display = "none";
            $("SchSettings").style.display = "";
//            $("SchImportType").style.display = "block";
//            $("SchCanAddNewCol").style.display = "block";
            $("SchTimeZone").style.display = "block";
            $("ZRODataPrevBtn").style.display = "";
            $("ZRODataNextBtn").style.display = "none";
            $("ZRODataCreateBtn").style.display = "";
            ZDBUtil.setAttribute($("ZRODataCreateBtn"), 'ODataPage.submitODataForm(this.form)', 'onclick');
             $("ZRODataCancelBtn").style.display = "";
            $("ZDBJOINTABLE").style.display="none";
            $("OnImpError").style.display="none";
            $("ShowCloudDBCmplt").style.display = "none";
             $('ZRODataCmpltOk').style.display = "none";
             $("ZRODataImportBtn").style.display = "none";
        }
        if(stepNo == 5)
        {

            $("ZRODataTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.setupcomplete.odata");
            $("ZRODataDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.setupcmplt.desc.odata");
            $("ZRODataInlineTitle").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.setupcomplete.odata");
            $("ZRODataInlineDesc").innerHTML = ZDBI18NMap.g("zrpt.databasedata.import.js.setupcmplt.desc.odata");
            $("ODataDataSource").style.display = "none";
            $("SelectTablesToImport").style.display = "none";
            $("DataSourceDetails").style.display = "none";
            $("ZRSettings").style.display = "none";
            $("PreviewGrid").style.display = "none";
            $("SchSettings").style.display = "none";
            $("SchTimeZone").style.display = "none";
            $("ZRODataPrevBtn").style.display = "none";
            $("ZRODataNextBtn").style.display = "none";
            $("ZRODataCreateBtn").style.display = "none";
            $("ZRODataCancelBtn").style.display = "none";
            $("ZDBJOINTABLE").style.display="none";
            $("OnImpError").style.display="none";
            $("ShowCloudDBCmplt").style.display = "";
            $("ZRODataTitleStep").style.display = "none";
            $("ZRODataInlineTitleStep").style.display = "none";
            $('ZRODataCmpltOk').style.display = "";
            $("ZRODataImportBtn").style.display = "none";
        }

    };
    this.gotoNextStep = function (frm)
    {
        hideCustomMessage();
        var stepNo = ZDBUtil.getAttribute($("ZRODataNextBtn"), "stepNo");
        if(stepNo == null)
        {
            stepNo = 1;
        }
        //ZDBUtil.setAttribute($("ZRODataNextBtn"), '', 'onclick');
        //$("ZRODataNextBtn").className='buttonCompBoxBg alpha';
        if (stepNo == 1)
        {
            if(ZDBUtil.getAttribute($("ODataImport"), "isExistingTbl") == "true")
            {
                var host = frm.ODATAEXISTURL.value;
                if (!ZDBValidator.checkValidInput(host))
                {
                    showCustomMessage(ZDBUtil.getAttribute(frm.ODATAEXISTURL, "errormsg"), frm.ODATAEXISTURL);
                    ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
                    $("ZRODataNextBtn").className='buttonCompBoxBg';
                    return false;
                }
                if(!ODataPage.isRoot($("ODATA_URL_EX").value))
                {
                    ODataPage.getPreviewForExistImport($("ZRODataNextBtn"));
                }
                else
                {
                    showCustomMessage("Give the table url", frm.ODATAEXISTURL); //No I18N
                    ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
                    $("ZRODataNextBtn").className='buttonCompBoxBg';
                }
            }

        } else if (stepNo == 2)
        {
            if (!ODataPage.isRoot($("ODATAURL").value))
            {
                if ($("ODataImport").getAttribute("isExistImp") == "true")
                {
                    ODataPage.getPreviewForExistImport($("ZRODataNextBtn"));
                } else
                {
                    ODataPage.showPreview($("ZRODataNextBtn"));
                }
            } else
            {

                ODataPage.showZRSettingsPage();
            }
        } 
        else if (stepNo == 3)
        {
            ODataPage.validateNames($("ZRODataNextBtn"),frm);
        }
    };

    this.incValueByOne = function (el, attr)
    {
        var val = el.getAttribute(attr);
        val++;
        ZDBUtil.setAttribute(el, val, attr);
    };

    this.decValueByOne = function (el, attr)
    {
        var val = el.getAttribute(attr);
        val--;
        ZDBUtil.setAttribute(el, val, attr);
    };

    this.gotoPrevStep = function ()
    {
        hideCustomMessage();
        ODataPage.decValueByOne($("ZRODataNextBtn"), "stepNo"); //No I18N
        ODataPage.enableOptForStep('R'); //No I18N
    };

    
    this.testDataSourcegetTables = function (frm)
    {   
        if ($("ODataImport").getAttribute("isExistingTBL") == "true")
            {
                if(!ODataPage.isRoot($("ODATA_URL_EX").value))
                {
                    ODataPage.getPreviewForExistImport($("ZRODataNextBtn"));
                }
                else
                {
                    showCustomMessage("Give the table url", frm.ODATAEXISTURL); //No I18N
                    ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
                    $("ZRODataNextBtn").className='buttonCompBoxBg';
                }
            }
    };
    
    this.showContent = function (frm, response, requestOptions)
    {
        $("IDBNAME1").value = frm.DBNAME.value;
        $("ODATAURL").value = frm.ODATAURL.value; 
        $("ODATA_USERNAME").value = frm.ODATAUSERNAME.value;
        $("ODATA_PASSWORD").value = frm.ODATAPASSWORD.value;
        ODataPage.showSelectTablesPage(response,requestOptions);
    }

    this.validateConnDet = function (odataFrm)
    {
        ZDBUtil.setNamedChildEls(odataFrm, odataFrm, "name");
        if(odataFrm.DBNAME)
        {
            var dbname = odataFrm.DBNAME.value;
            if (!ZDBValidator.checkValidInput(dbname))
            {
                showCustomMessage(ZDBUtil.getAttribute(odataFrm.DBNAME, "errormsg"), odataFrm.DBNAME);
                return false;
            }
        }

        var host = odataFrm.URL.value;
        if (!ZDBValidator.checkValidInput(host))
        {
            showCustomMessage(ZDBUtil.getAttribute(odataFrm.URL, "errormsg"), odataFrm.URL);
            return false;
        }
        return true;
    };


    this.showSelectTablesPage = function (response, requestOptions)
    {
        var result = JSON.parse(response.responseText);
        var tables = result.tableList;
        ODataPage.refreshPage($("ZRODataDialog"));
        ODataPage.loadTableNames(tables);
        if (result.scheduleDetails != null)
        {
            var schDet = [];
            schDet = result.scheduleDetails;
            ODataPage.setExistScheduleDet(schDet, result.schWarnMailCount, result.scheduleTimeZone, result.displayTimeZone, $("ZRODataDialog"));
        }
        else
        {
            ODataPage.setDefaultScheduleDet($("ZRODataDialog"));
        }
        ODataPage.incValueByOne($("ZRODataNextBtn"), "stepNo"); //No I18N
        ODataPage.enableOptForStep();
    };

    this.refreshPage = function (frm)
    {
        //jQuery($("TableNames_Single")).empty();
        jQuery($("SelectTbls")).empty();
        jQuery($("SelectedTables")).empty();
        $("SelectAllTbls").className = "zrcheckbox";
        ZDBUtil.setAttribute($("SelectAllTbls"), "false", "selected");
        ZDBUtil.setAttribute($("MultipleTblList"), 0, "totTables");
        ZDBUtil.setAttribute($("MultipleTblList"), 0, "selectedTables");
        var selectedTablesArray = [];
        var reportsTableArray = [];
        ZDBUtil.setAttribute($("MultipleTblList"), selectedTablesArray.toString(), "selectedTablesArray");
        ZDBUtil.setAttribute($("MultipleTblList"), reportsTableArray.toString(), "reportsTableArray");
        $("repeatinterval").options[0].selected = "true";
        ODataPage.toggleSchedulePeriod("none", frm); //No I18N
        if($("ZDBSCHIMPORTTYPE").options[1])
        {
            $("ZDBSCHIMPORTTYPE").options[1].selected = "true";
        }
        ODataPage.showMatchColList($("ZDBSCHIMPORTTYPE"));

        $("ZDBCANADDNEWCOLUMN").checked = false;
    };

    this.loadTableNames = function (tableList)
    {
        ZDBUtil.setAttribute($("MultipleTblList"), tableList.length, "totTables");
        for (var i = 0; i < tableList.length; i++)
        {
            ODataPage.loadMultipleTblList(tableList[i]);
        }
    };

    this.loadMultipleTblList = function (tbEl)
    {
        var selectTbl = $("SelectTbls");
        var tblDiv = document.createElement("span");
        tblDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(tbEl);
        tblDiv.className = "zrcheckbox";
        tblDiv.onclick = ODataPage.selectTables;
        ZDBUtil.setAttribute(tblDiv, "false", "added");
        ZDBUtil.setAttribute(tblDiv, "false", "selected");
        selectTbl.appendChild(tblDiv);
    };
    this.selectTables = function (event)
    {
        var el = window.event ? window.event.srcElement : event.target;
        var attrVal = ZDBUtil.getAttribute(el, "selected");
        var status = (attrVal == "true") ? "false" : "true";
        ODataPage.selectDBTables(el, status);
    };

    this.selectDBTables = function (el, attrVal)
    {
        var added = ZDBUtil.getAttribute(el, "added");
        ZDBUtil.setAttribute(el, attrVal, "selected");
        var selectedTblCont = $("SelectedTables");
        var selectedTablesArray = [];
        if (ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray") != "")
            selectedTablesArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray").split(',');
        if (attrVal == "true" && added == "false")
        {
            el.className = "zrcheckboxsel";
            ZDBUtil.setAttribute(el, "true", "added");
            var selectedTbl = document.createElement("div");
            var selectedTblClose = document.createElement("input");
            selectedTblClose.setAttribute("type", "button");
            selectedTblClose.className = "zrdbRemoveSelTbl";
            selectedTbl.innerHTML = el.innerHTML;
            selectedTbl.setAttribute("value",el.innerHTML);
            selectedTblClose.onclick = ODataPage.removeSelectedTables;
            selectedTbl.appendChild(selectedTblClose);
            selectedTbl.selectTbl = el;
            selectedTbl.className = "zrdbSelectedTbl";
            el.selectedTbl = selectedTbl;
            ODataPage.incValueByOne($("MultipleTblList"), "selectedTables"); //No I18N
            if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0)
            {
                ODataPage.incValueByOne($("MultipleTblList"), "matchedTablesSelectedCont"); //No I18N
            }
            selectedTablesArray.push(el.innerHTML);
            ZDBUtil.setAttribute($("MultipleTblList"), selectedTablesArray.toString(), "selectedTablesArray");
            selectedTblCont.appendChild(selectedTbl);
        } else if (attrVal == "false" && added == "true")
        {
            el.className = "zrcheckbox";
            ZDBUtil.setAttribute(el, "false", "added");
            ODataPage.decValueByOne($("MultipleTblList"), "selectedTables"); //No I18N
            if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0)
            {
                ODataPage.decValueByOne($("MultipleTblList"), "matchedTablesSelectedCont"); //No I18N
            }
            
            selectedTablesArray.splice(selectedTablesArray.indexOf(el.innerHTML), 1);
            ZDBUtil.setAttribute($("MultipleTblList"), selectedTablesArray.toString(), "selectedTablesArray");
            var selectedTbl = el.selectedTbl;
            jQuery(selectedTbl).remove();
        }
        var selectAllEl = $("SelectAllTbls");
        if ((ZDBUtil.getAttribute($("MultipleTblList"), "selectedTables") == ZDBUtil.getAttribute($("MultipleTblList"), "totTables")) || (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0 && ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") == ZDBUtil.getAttribute($("MultipleTblList"), "matchedTablesSelectedCont")))
        {
            selectAllEl.className = "zrcheckboxsel";
            ZDBUtil.setAttribute(selectAllEl, "true", "selected");
        } else
        {
            selectAllEl.className = "zrcheckbox";
            ZDBUtil.setAttribute(selectAllEl, "false", "selected");
        }
        if(selectedTablesArray.length> 0)
	{
	    	  $("ZRODataRemoveAll").style.visibility = "visible";
	}
	else
	{
	    	  $("ZRODataRemoveAll").style.visibility = "hidden";
	}

    };
    this.removeSelectedTables = function (event)
    {
        var srcEl = window.event ? window.event.srcElement : event.target;
        var el = jQuery(srcEl).parent("div").get(0);        //No I18N
        el.selectTbl.className = "zrcheckbox";
        ODataPage.decValueByOne($("MultipleTblList"), "selectedTables"); //No I18N
        if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0 && jQuery(el.selectTbl).is(":visible") && (ZDBUtil.getAttribute(el.selectTbl, "selected") == "true"))
            ODataPage.decValueByOne($("MultipleTblList"), "matchedTablesSelectedCont"); //No I18N
        ZDBUtil.setAttribute(el.selectTbl, "false", "added");
        ZDBUtil.setAttribute(el.selectTbl, "false", "selected");
        var selectedTablesArray = [];
        selectedTablesArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray").split(',');
        selectedTablesArray.splice(selectedTablesArray.indexOf(ZDBUtil.getAttribute(el,"value")), 1);
        ZDBUtil.setAttribute($("MultipleTblList"), selectedTablesArray.toString(), "selectedTablesArray");
        jQuery(el).remove();
        var selectAllTbl = $("SelectAllTbls");
        if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") && !jQuery(el.selectTbl).is(":visible") && (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") == ZDBUtil.getAttribute($("MultipleTblList"), "matchedTablesSelectedCont")))    //No I18N
        {
            selectAllTbl.className = "zrcheckboxsel";
            ZDBUtil.setAttribute(selectAllTbl, "true", "selected");
        } else
        {
            selectAllTbl.className = "zrcheckbox";
            ZDBUtil.setAttribute(selectAllTbl, "false", "selected");
        }
        if(selectedTablesArray.length <= 0)
	{
	    $("ZRODataRemoveAll").style.visibility = "hidden";
	}
    };
    this.selectAllTables = function (el)
    {
        var selected = ZDBUtil.getAttribute(el, "selected");
        var selectTblCont = $("SelectTbls");
        var selectTblList = jQuery(selectTblCont).children(":visible");        //No I18N
        el.className = (selected == "true") ? "zrcheckbox" : "zrcheckboxsel";
        var status = (selected == "true") ? "false" : "true";
        ZDBUtil.setAttribute(el, status, "selected");
        for (var i = 0; i < selectTblList.length; i++)
        {
            var selectTbl = selectTblList[i];
            ODataPage.selectDBTables(selectTbl, status);
        }
    };
    this.removeAllTables = function ()
    {
        var selectedTblCont = $("SelectedTables");
        var selectedTbl = selectedTblCont.getElementsByTagName("div");
        for (var i = selectedTbl.length; i > 0; i--)
        {
            var selectTbl = selectedTbl[0].selectTbl;
            ODataPage.selectDBTables(selectTbl, "false");
        }
    };
    this.searchTables = function (searchEl)
    {
        ZDBUtil.setAttribute($("MultipleTblList"), 0, "matchedCount");
        ZDBUtil.setAttribute($("MultipleTblList"), 0, "matchedTablesSelectedCont");
        var value = ZDBSearchUtil.getSearchValue(searchEl);
        value = (value) ? value.toLowerCase() : "";
        var selectTbl = $("SelectTbls");
        var tblsList = selectTbl.getElementsByTagName("span");
        if (selectTbl.getElementsByTagName("div"))
            jQuery(selectTbl.getElementsByTagName("div")).remove();
        var tblDiv = document.createElement("div");
        tblDiv.innerHTML = ZDBI18NMap.g("zrpt.databasedata.js.no_matching_tables");
        tblDiv.className = "noData";
        selectTbl.appendChild(tblDiv);
        for (var i = 0; i < tblsList.length; i++)
        {
            var tblEl = tblsList[i];
            var tblName = tblEl.innerHTML;
            var matched = ((tblName.toLowerCase().indexOf(value)) > -1);
            tblEl.style.display = (matched || (value == null) || (value == "")) ? "block" : "none";
            if (matched || (value == null) || (value == ""))
                ODataPage.incValueByOne($("MultipleTblList"), "matchedCount"); //No I18N
            if ((ZDBUtil.getAttribute(tblEl, "selected") == "true") && (matched || (value == null) || (value == "")))
                ODataPage.incValueByOne($("MultipleTblList"), "matchedTablesSelectedCont"); //No I18N
        }
        if (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0)
            jQuery(tblDiv).remove();
        var selectAllEl = $("SelectAllTbls");
        if ((ZDBUtil.getAttribute($("MultipleTblList"), "selectedTables") == ZDBUtil.getAttribute($("MultipleTblList"), "totTables")) || (ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") > 0 && ZDBUtil.getAttribute($("MultipleTblList"), "matchedCount") == ZDBUtil.getAttribute($("MultipleTblList"), "matchedTablesSelectedCont")))
        {
            selectAllEl.className = "zrcheckboxsel";
            ZDBUtil.setAttribute(selectAllEl, "true", "selected");
        } else
        {
            selectAllEl.className = "zrcheckbox";
            ZDBUtil.setAttribute(selectAllEl, "false", "selected");
        }
    };
    this.checkKeyAndSearch = function (el, ev)
    {
        ODataPage.searchTables(el);
        return true;
    };
    this.showPreview = function (el)
    {
        var conndetails = {};

        if ($("DBID").value != -10)
        {
            conndetails["DBID"] = $("DBID").value;
        }

        conndetails["ODATAURL"] = $("ODATAURL").value;
        conndetails["USERNAME"] = $("ODATA_USERNAME").value;
        conndetails["PASSWORD"] = $("ODATA_PASSWORD").value;

        var params = "ZDBACTION=SHOWPREVIEWODATA&ODATAFEEDURL=" + encodeURIComponent(JSON.stringify(conndetails)); //No I18N
            params = params + "&QUERYTYPE=" + 1; //No I18N
        
        params += "&FILETYPE=CSV&LOCATION=CLOUDDATABASE"; //No I18N
        if($("DBID").value != -10)
        {
            params+="&DBID="+ZDBClientUI.dbId; //No I18N
        }
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ELEMENT: el, ONSUCCESSFUNC: "ODataPage.handlePreviewScript", ONFAILUREFUNC: "ODataPage.handleFailure", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});

    };
    this.setDateFormat = function (jsonObj)
    {
        if (jsonObj.csvConfig)
        {
            var csvconfig = jsonObj.csvConfig;
            if (csvconfig[4].dateFormat != null && csvconfig[4].dateFormat != "")
            {
                $("ZOHO_DATE_FORMAT").value = csvconfig[4].dateFormat;
            }
        }
    };
    this.validateQuery = function (query)
    {
        if (query == "")
        {
            ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
            $("ZRODataNextBtn").className='buttonCompBoxBg';
            ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.querytable.errmsg.js.noSQLQueryErr"), null, null);
            return false;
        } else if (query.substr(0, 6).toLowerCase() != "select") //No I18N
        {
            ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
            $("ZRODataNextBtn").className='buttonCompBoxBg';
            ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.querytable.errmsg.js.onlySelQueriesAllowed"), null, null);
            return false;
        }
        return true;
    };
    this.handlePreviewScript = function (response, requestOptions)
    {
        if (!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList", "APPENDTODOC", ODataPage.handlePreviewScript, [response, requestOptions]))
        {
            return
        }
        jQuery($("SampleTableHolder")).empty();
        $("PreviewGrid").style.display = "block";
        var responseString = JSON.parse(response.responseText);
        var filename = responseString.FILENAME;
        $("FILENAME").setAttribute("value", filename);
        var sampleTblScript = responseString.SAMPLETBLSCRIPT;
        var previewGrid = invokeSampleTableScripts(JSON.parse(sampleTblScript));
        $("ZDBJOINTABLE").style.marginRight = "400px";//No I18N
        if(JSON.parse(sampleTblScript).IDENTIFIEDJOINS)
        {
            $("JOINNEEDED").value = "true";
        }
        else
        {
            $("JOINNEEDED").value = "false";
        }
        ODataPage.setDateFormat(JSON.parse(sampleTblScript));
        addSampleTableToView(previewGrid, true);
        if (ZDBUtil.getAttribute($("ODataImport"), "isExistImp") == "false")
        {
            ZDBImport.setExistColumnList(previewGrid);
        }

        ODataPage.showZRSettingsPage();
    };
    this.showZRSettingsPage = function ()
    {
        jQuery($("ZRSelectedMultipleTbls")).empty();
        if (!ODataPage.isRoot($("ODATAURL").value) || ZDBUtil.getAttribute($("ODataImport"), "isExistingTbl")=="true")
        {
            $("ZRTblNameDiv").style.display = "";
            $("ZRMultipleTblNames").style.display = "none";
            var tableName = $("ODATAURL").value.substring($("ODATAURL").value.indexOf(".svc/")+5);
            if(tableName.indexOf("?")!=-1)
            {
                tableName = tableName.substring(0,tableName.indexOf("?"));
            }
            if(ZDBUtil.getAttribute($("ODataImport"), "isExistingDB")=="true")
            {
                $("ZRTblName").value = $("TABLEARRAY").value;
            }
            else
            {
                $("ZRTblName").value = tableName;   
            }

            if($("ZDBSCHIMPORTTYPE").options[2])
            {
                $("ZDBSCHIMPORTTYPE").options[2].disabled = false;
            }
            if($("ZDBSCHIMPORTTYPE").options[3])
            {
                $("ZDBSCHIMPORTTYPE").options[3].disabled = false;
            }
            if($("ZDBSCHIMPORTTYPE").options[1])
            {
                $("ZDBSCHIMPORTTYPE").options[1].selected = "true";
            }
        } 
        else
        {
            $("JOINNEEDED").value = "false";
            if (ZDBUtil.getAttribute($("MultipleTblList"), "selectedTables") == 0)
            {
                ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.databasedata.multipletbl.js.notableselected.odata"), null, null);
                ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
                $("ZRODataNextBtn").className='buttonCompBoxBg';
                return false;
            }
            $("ZRTblNameDiv").style.display = "none";
            $("ZRMultipleTblNames").style.display = "";
            $("PreviewGrid").style.display = "none";
            ODataPage.loadSelectedMultipleTblNames();
            $("ZDBSCHIMPORTTYPE").options[1].selected = true;
            ODataPage.showMatchColList($("ZDBSCHIMPORTTYPE"));
            if($("ZDBSCHIMPORTTYPE").options[2])
            {
                $("ZDBSCHIMPORTTYPE").options[2].disabled = true;
            }
            if($("ZDBSCHIMPORTTYPE").options[3])
            {
                $("ZDBSCHIMPORTTYPE").options[3].disabled = true;
            }
            $("ZDBSCHIMPORTTYPE").options[1].selected = "true";
            
        }
        
        ODataPage.incValueByOne($("ZRODataNextBtn"), "stepNo"); //No I18N
        ODataPage.enableOptForStep();
        
        if ($("DBID").value != -10)
        {
            if (ZDBUtil.getAttribute($("ODataImport"), "isExistImp") != "true" && !ODataPage.isRoot($("ODATAURL").value))
            {
                $("ZRTblName").focus();
            }
        }
        else
        {
            $("SelectedTblsFinal").focus();
        }
    };
    this.loadSelectedMultipleTblNames = function ()
    {
        var selectedTablesArray = [];
        var selectedTablesArrayStr = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray");
        selectedTablesArray = selectedTablesArrayStr.split(',');
        var selectedTbls = $("SelectedTblsFinal");
        var reportstbls = $("ReportsTables");
        jQuery(reportstbls).empty();
        jQuery(selectedTbls).empty();
        for (i = 0; i < selectedTablesArray.length; i++)
        {
            var tblDiv = document.createElement("span");
            ZDBUtil.setAttribute(tblDiv,selectedTablesArray[i]+"_tbl","id");
            tblDiv.innerHTML = selectedTablesArray[i];
            tblDiv.className = "zrdbSelectedTblFinal";
            tblDiv.style.display = "block";
            selectedTbls.appendChild(tblDiv);
            var reportstblDiv = document.createElement("div");
            var reportstblnameDiv = document.createElement("span");
            reportstblnameDiv.style.display="inline-block";
            reportstblnameDiv.style.textOverflow="ellipsis"; //No I18N
            reportstblnameDiv.style.overflow="hidden";
            reportstblnameDiv.style.whiteSpace="nowrap"; //No I18N
            reportstblnameDiv.style.maxWidth="260px"; //No I18N
            reportstblnameDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(selectedTablesArray[i]);
            ZDBUtil.setAttribute(reportstblDiv,"ODataPage.editRepTblName(this,event)","onclick");
            reportstblDiv.appendChild(reportstblnameDiv);
            reportstblDiv.className = "zrdbSelectedTbl";
            reportstblDiv.style.display = "block";
            ZDBUtil.setAttribute(reportstblDiv,selectedTablesArray[i],"orgTbl");
            ZDBUtil.setAttribute(reportstblDiv,selectedTablesArray[i],"id");
            ZDBUtil.setAttribute(reportstblDiv,"ODataPage.highLytPar(this)","onmouseover");
            ZDBUtil.setAttribute(reportstblDiv,"ODataPage.dehighLytPar(this)","onmouseout");
            reportstblDiv.style.paddingLeft="0px";//No I18N
            var reportstbleditDiv = document.createElement("div");
            reportstbleditDiv.className = "zrdbEditRepTbl";
            reportstblDiv.appendChild(reportstbleditDiv);
            reportstbls.appendChild(reportstblDiv);
        }
        var reportsTableArray = [];
        reportsTableArray = selectedTablesArray.slice();
        ZDBUtil.setAttribute($("MultipleTblList"), reportsTableArray.toString(), "reportsTableArray");
    };

    this.validateNames = function (el,frm)
    {
        var params = "";
        var importparams = {};
        if (ZDBUtil.getAttribute($("ODataImport"), "isExistImp") == "false")
        {
            if (!ODataPage.isRoot($("ODATAURL").value))
            {
                if (!ZDBValidator.checkValidInput($("ZRTblName").value) || !ZDBValidator.checkLength($("ZRTblName").value,$("ZRTblName")))
                {
                    showCustomMessage(ZDBUtil.getAttribute($("ZRTblName"), "errormsg"), $("ZRTblName"));
                    ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
                    $("ZRODataNextBtn").className='buttonCompBoxBg';
                    return false;
                }
            } 
            else
            {
                if(!ODataPage.validatemultipletablenames())
                {
                     ZDBUtil.setAttribute($("ZRODataNextBtn"), 'ODataPage.gotoNextStep(this.form)', 'onclick');
                     $("ZRODataNextBtn").className='buttonCompBoxBg';
                    return false;
                }
                
            }
            if ($("DBID").value == -10)
            {
                importparams["DBNAME"] = $("IDBNAME1").value;
                importparams["DESCRIPTION"] = $("IDESCRIPTION").value;
            } 
            else
            {
                params += "DBID=" + $("DBID").value; //No I18N
                if (!ODataPage.isRoot($("ODATAURL").value))
                {
                    
                        importparams["DATAFETCHTYPE"] = 1;
                        var singletable = {};
                        singletable["ONPREMISETBNAME"] = ">>>DummyTableName<<<";    //No I18N
                        singletable["ZOHOREPORTSTBNAME"] = $("ZRTblName").value;
                        importparams["SINGLETABLEORQUERY"] = singletable;
                   
                } 
                else
                {
                    importparams["DATAFETCHTYPE"] = 3;
                    var multipleTable = [];
                    var selectedTablesArray = [];
                    selectedTablesArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray").split(',');
                    var reportsTableArray = [];
                    reportsTableArray = ZDBUtil.getAttribute($("MultipleTblList"), "reportsTableArray").split(',');
                    for (i = 0; i < selectedTablesArray.length; i++)
                    {
                        var tablenames = {};
                        tablenames["ONPREMISETBNAME"] = ZDBEscapeUtil.decodeForHtml(selectedTablesArray[i]);
                        tablenames["ZOHOREPORTSTBNAME"] = reportsTableArray[i];
                        multipleTable.push(tablenames);
                    }
                    importparams["MULTIPLETABLE"] = multipleTable;
                }
            }
            params += "&TABLEDETAILS=" + encodeURIComponent(JSON.stringify(importparams)); //No I18N
        }
        params += "&ZDBACTION=VALIDATETABLENAMESODATA"; //No I18N
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ELEMENT:frm, ONSUCCESSFUNC: "ODataPage.showSyncSettings", ONFAILUREFUNC: "ODataPage.handleFailure", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});
    };
    this.showSyncSettings = function (response, requestOptions)
    {
        ODataPage.incValueByOne($("ZRODataNextBtn"), "stepNo"); //No I18N
        ODataPage.enableOptForStep();
        ODataPage.toggleSchedulePeriod($("repeatinterval").value,requestOptions['ELEMENT'])
    };
    this.showMatchColList = function (element)
    {
        var matchCol = jQuery(element).siblings("[id='MatchingColumns']")[0];
        if (element.value == "UPDATEADD" || element.value == "DELETEUPDATEADD")
        {
            matchCol.style.display = "block";
        } else
        {
            matchCol.style.display = "none";
        }
    };

    this.toggleSchedulePeriod = function (optValue, frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        frm.schedule_periodic.style.display = "none";
        frm.schedule_daily.style.display = "none";
        frm.schedule_weekly.style.display = "none";
        frm.schedule_monthly.style.display = "none";
        if (optValue != "none")
        {
            var enableDiv;
            if(optValue == "periodic")
            {
                enableDiv = frm.schedule_periodic;
            }
            else if (optValue == "daily")
            {
                enableDiv = frm.schedule_daily;
            } else if (optValue == "weekly") //No I18N
            {
                enableDiv = frm.schedule_weekly;
            } else if (optValue == "monthly") //No I18N
            {
                enableDiv = frm.schedule_monthly;
            }
            enableDiv.style.display = "";
            frm.sch_failure_warning.style.display = "";
            if(frm.SchImportType && frm.SchCanAddNewCol)
            {
                frm.SchImportType.style.display = "";
                frm.SchCanAddNewCol.style.display = "";
            }
        } else
        {
            frm.sch_failure_warning.style.display = "none";
            if(frm.SchImportType && frm.SchCanAddNewCol)
            {
                frm.SchImportType.style.display = "none";
                frm.SchCanAddNewCol.style.display = "none";
            }
        }
    };
    this.submitODataForm = function (frm)
    {

        var params = "";
        var conndetails = {};
        var importparams = {};
        var isExistImp = false;
        if (ZDBUtil.getAttribute($("ODataImport"), "isExistImp") == "false")
        {
            ZDBUtil.setAttribute($("ZRODataCreateBtn"), '', 'onclick');

            if ($("DBID").value != -10)
            {
                conndetails["DBID"] = $("DBID").value;
            }
            
            conndetails["ODATAURL"] = $("ODATAURL").value;            
            conndetails["USERNAME"] = $("ODATA_USERNAME").value;
            conndetails["PASSWORD"] = $("ODATA_PASSWORD").value;          
            if ($("DBID").value == -10)
            {
                importparams["DBNAME"] = $("IDBNAME1").value;
                importparams["DESCRIPTION"] = $("IDESCRIPTION").value;
                params = "ZDBACTION=CREATEDATASRCDBANDTBLODATA"; //No I18N
            }
            else
            {
                importparams["DBNAME"] = $("IDBNAME1").innerHTML;
                 params = "ZDBACTION=CREATEDATASRCANDTBLODATA"; //No I18N
                 params += "&DBID=" + ZDBClientUI.dbId; //No I18N
            }
            params += "&ODATAFEEDURL=" + encodeURIComponent(JSON.stringify(conndetails)); //No I18N
        } 
        else
        {
            ZDBUtil.setAttribute($("ZRODataImportBtn"), '', 'onclick');
            params = "ZDBACTION=EXISTIMPORTODATA"; //No I18N
            params += "&CONNECTIONID=" + $("ExistImpConnectionId").innerHTML; //No I18N
            params += "&OBJID=" + $("ExistImpObjId").innerHTML; //No I18N
            params += "&DBID=" + ZDBClientUI.dbId; //No I18N
            params+="&EXISTTBLNAME="+ZDBClientUI.selectedTab.view.displayName; //No I18N
            $("ODATAURL").value = $("ODATA_URL_EX").value;
            isExistImp = true;
        }
        if (!ODataPage.isRoot($("ODATAURL").value))
        {
            importparams["DATAFETCHTYPE"] = 1;
            var singletable = {};            
            var odataURL = $("ODATAURL").value;
            singletable["ONPREMISETBNAME"] = odataURL.substring(odataURL.indexOf(".svc")+5); //No I18N          
            
            
            if (ZDBUtil.getAttribute($("ODataImport"), "isExistImp") == "false")
            {
                singletable["ZOHOREPORTSTBNAME"] = $("ZRTblName").value;
            }
            importparams["SINGLETABLEORQUERY"] = singletable;

            var fieldXML = "<Fields ";    //No I18N
            var typeXML = "<FieldType ";  //No I18N
            var countryXML = "<FieldCountry ";    //No I18N
            var jsonNodeXML = "<JSONNodePath ";    //No I18N
            var fieldNullableXML = "<FIELDNULLABLE "; //No I18N
            var colHeaders = sampleTableGrid.colHeaders;
            var colLen = colHeaders.length;
            var countries = sampleTableGrid.currencyCountries;
            var isSelColExist = false;
            var checked;
            var dataType;
            var curHead;
            var index = 0;
            var isExist = false;
            var row = getDataTypeRow(isExist);
            if (!isANCTypeUnique(colHeaders))
            {
                return false;
            }
            for (var i = 0; i < colLen; i++)
            {
                curHead = colHeaders[i];
                if (curHead.objType !== ZDBConst.COLHEAD)
                {
                    continue;
                }
                checked = curHead["importNode"].getAttribute("checked");    //No I18N
                if (!isSelColExist && checked == "true")
                {
                    isSelColExist = true;
                }

                dataType = (checked == "true") ? curHead.dataType[curHead.dataType.selectedIndex].value : -2; ///PK: Skip column

                if (curHead.status == ZDBConst.CLEAR)
                {
                    fieldXML += "F" + index + "=\"" + ZDBEscapeUtil.encodeForXML(curHead.displayName) + "\" ";    //No I18N
                    typeXML += "F" + index + "=\"" + dataType + "\" ";   //No I18N
                    countryXML += "FC" + index + "=\"" + countries[index] + "\" ";    //No I18N
                    fieldNullableXML += "F" + index + "=\"" + ZDBEscapeUtil.encodeForXML(curHead.isNullable) + "\" ";    //No I18N
                    ++index;
                }
            }

            fieldXML += "/>";
            typeXML += "/>";
            countryXML += "/>";
            jsonNodeXML += "/>";
            fieldNullableXML += "/>";
            if (!isSelColExist)
            {
                alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.selCol2ProceedImport"));
                return false;
            }
            var tabConfig = "<data>\n" + fieldXML + "\n" + typeXML + "\n" + countryXML + "\n" + fieldNullableXML + "\n"; //No I18N
            tabConfig += "</data>";
            params += "&TABLECONFIG=" + tabConfig //No I18N
                    + "&ZOHO_DATE_FORMAT=" + $("ZOHO_DATE_FORMAT").value //No I18N
                    + "&FILENAME=" + $("FILENAME").value //No I18N
                    + "&JOINSLIST="+$("JOINSLIST").value;//No I18N
            if ($("ZDBSCHIMPORTTYPE").value == "UPDATEADD" || $("ZDBSCHIMPORTTYPE").value == "DELETEUPDATEADD")
            {
                var matchCols = new Array();
                var matchList = document.getElementsByName("ZOHO_MATCHING_COLUMNS");
                var count = 0;

                for (var i = 0, j = matchList.length; i < j; i++)
                {
                    if (matchList[i].checked)
                    {
                        matchCols[count] = matchList[i].value;
                        count++;
                    }
                }
                if(count == 0)
                {
                    showCustomMessage(ZDBI18NMap.g("zrpt.common.matchingcol.js.errmsg"), matchList[0]);
                    return;
                }
                params += "&MATCHINGCOLS=" + matchCols.toString(); //No I18N
            }
        }
        else
        {
            importparams["DATAFETCHTYPE"] = 3;
            var multipleTable = [];
            var selectedTablesArray = [];
            selectedTablesArray = ZDBUtil.getAttribute($("MultipleTblList"), "selectedTablesArray").split(',');
            var reportsTableArray = [];
            reportsTableArray = ZDBUtil.getAttribute($("MultipleTblList"), "reportsTableArray").split(',');
            for (i = 0; i < selectedTablesArray.length; i++)
            {
                var tablenames = {};
                tablenames["ONPREMISETBNAME"] = ZDBEscapeUtil.decodeForHtml(selectedTablesArray[i]);
                tablenames["ZOHOREPORTSTBNAME"] = reportsTableArray[i];
                multipleTable.push(tablenames);
            }
            importparams["MULTIPLETABLE"] = multipleTable;
        }
        params += "&TABLEDETAILS=" + encodeURIComponent(JSON.stringify(importparams)); //No I18N
        params += "&ZOHO_ON_FORMAT_ERROR=" + $("OnImportError").value; //No I18N
        params += "&SCHEDULEIMPORTTYPE=" + $("ZDBSCHIMPORTTYPE").value;//No I18N
        params += "&CANADDNEWCOLUMN=" + $("ZDBCANADDNEWCOLUMN").checked;//No I18N
        if (ZDBUtil.getAttribute($("ODataImport"), "isExistImp") == "false")
        {
            var schedulerName = ODataPage.getSchedulerName(frm);
            var schFailWarnCount = $("sch_failure_count").value;  
            var repeatType = $("repeatinterval")[$("repeatinterval").selectedIndex].value;
            var list = repeatType == "daily" ? "ZDB_DLY_TIMEZONE_SEARCH" : repeatType == "weekly" ? "ZDB_WLY_TIMEZONE_SEARCH" : "ZDB_MLY_TIMEZONE_SEARCH";//No I18N
            params += "&SCHEDULERNAME=" + schedulerName;  //No I18N
            params += "&SCHEDULETIMEZONE=" + encodeURIComponent($(list + "_ZRTimezoneList").getAttribute("selectedTimeZone"));//No I18N
            params += "&ZDBSCHFAILWARNCOUNT=" + schFailWarnCount;   //No I18N
        }
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ELEMENT: frm, ONSUCCESSFUNC: "ODataPage.showAlert", ONFAILUREFUNC: "ODataPage.handleFailure",ISEXISTIMP:isExistImp,OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});
    };
    this.onTextChange = function (el)
    {
        var parent = jQuery(el).parent("div").get(0); //No I18N
        var index = jQuery(parent).index();
        var reportsTableArray = ZDBUtil.getAttribute($("MultipleTblList"), "reportsTableArray").split(',');
        reportsTableArray[index] = el.value;
        ZDBUtil.setAttribute($("MultipleTblList"), reportsTableArray, "reportsTableArray");
    };
    this.validatemultipletablenames = function ()
    {
        var reportsTableArray = ZDBUtil.getAttribute($("MultipleTblList"), "reportsTableArray").split(',');
        for (i = 0; i < reportsTableArray.length; i++)
        {
            var str = reportsTableArray[i];
            str = str.trim();
            if (!((str.length != 0) && (str.length <= parseInt($("ZRTblName").getAttribute("zdbfieldlength")))))
            {
                showCustomMessage(ZDBI18NMap.f("zrpt.newtable.import.tblname.js.errmsg", $("ZRTblName").getAttribute("zdbfieldlength")), $(reportsTableArray[i]));
                ODataPage.editRepTblName($(reportsTableArray[i]));
                return false;
            }
        }
        for (i = 0; i < reportsTableArray.length; i++)
        {
            for (j = i + 1; j < reportsTableArray.length; j++)
            {
                if (reportsTableArray[i] === reportsTableArray[j])
                {
                    showCustomMessage(ZDBI18NMap.g("zrpt.databasedata.multipletable.js.validate"), $(reportsTableArray[i]));
                    ODataPage.editRepTblName($(reportsTableArray[i]));
                    return false;
                }
            }
        }
        return true;
    };
    this.getSchedulerName = function (frm)
    {
        var repeatType = frm.repeatinterval[frm.repeatinterval.selectedIndex].value;
        var schedulerName = "none";    //No I18N
        if (repeatType == "periodic")
        {
            schedulerName = frm.periodicinterval[frm.periodicinterval.selectedIndex].value;
        } else if (repeatType == "daily") //No I18N
        {
            var hourVal = frm.ZDB_DLY_HRS_INT.value;
            var minVal = frm.ZDB_DLY_MINS_INT.value;
            var timeInMin = parseInt(hourVal * 60) + parseInt(minVal);
            schedulerName = timeInMin + "_" + repeatType;
        } else if (repeatType == "weekly") //No I18N
        {
            var hourVal = frm.ZDB_WLY_HRS_INT.value;
            var minVal = frm.ZDB_WLY_MINS_INT.value;
            var timeInMin = parseInt(hourVal * 60) + parseInt(minVal);
            var schDay = frm.weeklyinterval[frm.weeklyinterval.selectedIndex].value;
            schedulerName = timeInMin + "_" + repeatType + "_" + schDay;
        } else if (repeatType == "monthly") //No I18N
        {
            var hourVal = frm.ZDB_MLY_HRS_INT.value;
            var minVal = frm.ZDB_MLY_MINS_INT.value;
            var timeInMin = parseInt(hourVal * 60) + parseInt(minVal);
            var schDate = frm.monthlyinterval[frm.monthlyinterval.selectedIndex].value;
            schedulerName = timeInMin + "_" + repeatType + "_" + schDate;
        } else if (repeatType == "minutes") //No I18N
        {
            schedulerName = frm.lessthanhourinterval[frm.lessthanhourinterval.selectedIndex].value;
        }
        return schedulerName;
    };
    
    this.showAlert = function(response,requestOptions)
    {
        var params={};
        params = JSON.parse(response.responseText);
        var name = params['NAME'];
        var emailid = params['EMAILID'];
        var sourcename = params['CLOUDSOURCENAME'];
        var str;
        if(params['OBJID'])
        {
            str = ZDBI18NMap.g('zrpt.common.js.table');
        }
        else
        {
            str = ZDBI18NMap.g('zrpt.common.js.database');
        }
        var msg = ZDBI18NMap.f('zrpt.databasedata.odata.setup.js.sucess',ZDBEscapeUtil.encodeForHtml(sourcename),ZDBEscapeUtil.encodeForHtml(name),ZDBEscapeUtil.encodeForHtml(str));
        $("ZRODataNextBtn").setAttribute("stepNo",5);
        ODataPage.enableOptForStep();
        var msgnode = $('ZRODataSetupCompMsg').cloneNode(true);
        msgnode.innerHTML = msg;
        msgnode.style.display='inline-block';
        jQuery("#ShowCloudDBCmplt").empty();  //No I18N  
        $("ShowCloudDBCmplt").appendChild(msgnode);
        $('ZRODataCmpltOk').setAttribute("DBID",params['DBID']);
        if(params['OBJID'])
        {
            $('ZRODataCmpltOk').setAttribute("OBJID",params['OBJID']);
        }
        $('ZRODataCancelBtn').style.display="none";
    };
    this.switchView = function(el)
    {
             ZDBInlineDialog.closeDialogByType(el);
             if(ZDBClientUI.selectedTab == null)
             {
                var url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + el.getAttribute('DBID');//No I18N
                window.location.href = url;
             }
             else if(!el.getAttribute('OBJID'))
             {
                var tab = ZDBClientUI.selectedTab;
                ZDBNavigation.refreshExplorer();
                ZDBClientUI.removeTab(tab);
                ZDBClientUI.selectTab(ZDBNavigation.explorerTab);
                if(!$('ZDBEXPLORERDATASOURCE_TITEM'))
                {
                    window.location.reload();
                }
                if($('DatasourceBack'))
                {
                    ZRConnector.refreshDataSourcesDlg($('DatasourceBack'));
                }
             }
         }
         
         
         
    this.showCreateODataTable = function ()
    {
        var tabs = ZDBClientUI.tabOrderList;
        var len = tabs.length;
        for(i=0;i<len;i++)
        {
            var tab = tabs[i];
            var cloudDBView = tab.view.clouddbview;
            if(cloudDBView && tab.view.dialogStatus && tab.view.dialogStatus>0)
            {
                ZDBClientUI.removeTab(ZDBClientUI.selectedTab);
                ZDBClientUI.selectTab(tab);
                return;
            }
        }
        ODataPage.loadExistingConnections();
    };

    this.loadExistingConnections = function ()
    {
        var odataDlg = ZDBClientUI.$("ZRODataDialog");
        ZDBUtil.setNamedChildEls(odataDlg, odataDlg, "id");
        ODataPage.showCreateODataTableDlg(odataDlg);

        $("DBID").value = ZDBClientUI.dbId;

        ZDBUtil.setAttribute($("ODataImport"), "true", "isExistingDB");
    };
         
         
    this.showCreateODataTableDlg = function (odataDlg)
    {
        var checkROMode = ZDBClientUI.readOnlyMode;
        if (checkROMode)
        {
            ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.javaerr.common.js.ro_mode"));
            return;
        }
        var onclose = ODataPage.removeObj;
        ZDBInlineDialog.showDialog(odataDlg, {MODAL: true, DONTREMOVE: false, TITLE: ZDBI18NMap.f("zrpt.databasedata.import.js.step1.dbconnectionsetting.odata"),ONCLOSE:onclose});
        ZDBClientUI.selectedTab.view.clouddbview = odataDlg;
        $("ZRODataTitleBar").style.display = "none";
        $("ODataImport").setAttribute("qa", true);
        ODataPage.loadNewTblSettings(odataDlg);
        //$("ExistingConnection").style.display = "block";
        ODataPage.editMode(odataDlg);
    };
    this.fillConnSettingsForm = function (value, frm)
    {
        if (value == -10)
        {
            ODataPage.enableInitialPage(frm);
            ODataPage.editMode(frm);
            return;
        }
        var element = document.getElementById(value);

        $("ODATAURL").value = element.getAttribute("hostname");
        $("ODATA_USERNAME").value = element.getAttribute("username");
        $("ODATA_PASSWORD").value = element.getAttribute("password");
        ODataPage.readOnlyMode();
    };

    this.readOnlyMode = function ()
    {
        $("ODATA_URL").setAttribute("readonly", true);
        $("ODATA_URL").setAttribute("class", "scratchsearchfield alpha");
        $("ODATA_USERNAME").setAttribute("readonly", true);
        $("ODATA_USERNAME").setAttribute("class", "scratchsearchfield alpha");
        $("ODATA_PASSWORD").setAttribute("readonly", true);
        $("ODATA_PASSWORD").setAttribute("class", "scratchsearchfield alpha");
    };

    this.editMode = function ()
    {
        $("ODATA_URL").removeAttribute("readonly");
        $("ODATA_URL").setAttribute("class", "scratchsearchfield");
        $("ODATA_USERNAME").removeAttribute("readonly");
        $("ODATA_USERNAME").setAttribute("class", "scratchsearchfield");
        $("ODATA_PASSWORD").removeAttribute("readonly");
        $("ODATA_PASSWORD").setAttribute("class", "scratchsearchfield");

    };

    this.showExistImpDialog = function (connId)
    {
        var params = "ZDBACTION=FETCHTABLESFOREXISTIMPODATA&CONNECTIONID=" + connId + "&OBJID=" + ZDBClientUI.selectedTab.view.objId; //No I18N
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ONSUCCESSFUNC: "ODataPage.cntShowExistImpDialog", OPSTATUSID: "ZDBMainLoader"});
    };
    this.cntShowExistImpDialog = function (response, requestOptions)
    {
        var lzName = "ODATA_TABLE_EDIT_DLG"; //No I18N
        var lzOper = "APPENDTODOC"; //No I18N
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZROData.cc", this, lzOper))
        {
            return;
        }
        var odataDlg = ZDBClientUI.$("ZRODataDialog");
        var clouddbExistImpDlg = odataDlg.cloneNode(true);
        var onclose = ODataPage.removeObj;
        ZDBInlineDialog.showDialog(clouddbExistImpDlg, {MODAL: true, DONTREMOVE: false, TITLE: ZDBI18NMap.f("zrpt.common.import.js.existimport_dlg_title"),ONCLOSE:onclose});
        ZDBClientUI.selectedTab.view.clouddbview = clouddbExistImpDlg;
        $("ZRODataTitleBar").style.display = "none";      
        
        $("ZDBODATAINP").style.display = "none";
        $("ZDBODATAEXINP").style.display = "inline";
        
        ZDBUtil.setAttribute($("ODataImport"), "true", "isExistImp");
        ZDBUtil.setAttribute($("ODataImport"), "true", "isExistingDB");
        ZDBUtil.setAttribute($("ODataImport"), "true", "isExistingTBL");
        
       //--->>> ZDBUtil.setAttribute($("ZRDBDiv"), "display:none;", "style");
        ZDBUtil.setAttribute($("ZRODataNextBtn"), 0, "stepNo");
        var params = JSON.parse(response.responseText);
        $("ODATA_URL_EX").value = params.ODATAURL;
        var impOptionSelect = $("ZDBSCHIMPORTTYPE");
        jQuery(impOptionSelect).empty();
        var permLevel = ZDBClientUI.selectedTab.view.permLevel;
        var perms = permLevel.split("$");
        impOptionSelect = ZDBImport.setImportOption(impOptionSelect, perms);
        ODataPage.showSelectTablesPage(response, requestOptions);
        var datafetchtype = params.DATAFETCHTYPE;

        $("ExistImpConnectionId").innerHTML = params.CONNECTIONID;
        $("ExistImpObjId").innerHTML = params.OBJID;
        var matchColumns = params.MATCHCOLS;
        ZDBImport.setExistColumnList(ZDBClientUI.selectedTab.view);
        if (matchColumns != null && matchColumns != "")
        {
            var matchColList = matchColumns.split(',');
            var view = ZDBClientUI.selectedTab.view;
            ZDBImport.setCheckListColumn(view, matchColList);
        }
        var importTypes = $("ZDBSCHIMPORTTYPE").getElementsByTagName("option");
        for(var i=0;i<importTypes.length;i++)
        {
            var curOption = importTypes[i];
            if(curOption.value == params.SCHEDULEIMPORTTYPE)
            {
                curOption.selected = true;
                break;
            }
        }
        ODataPage.showMatchColList($("ZDBSCHIMPORTTYPE"));
        $("OnImportError").value = params.ONIMPERROR;
        
        
        if (params.CANADDNEWCOLUMN == 0)
        {
            $("ZDBCANADDNEWCOLUMN").checked = false;
        } else
        {
            $("ZDBCANADDNEWCOLUMN").checked = true;
        }
    };

    this.getPreviewForExistImport = function (el)
    {
        var query;
        var params = "CONNECTIONID=" + $("ExistImpConnectionId").innerHTML; //No I18N 
        var odataURL = $("ODATA_URL_EX").value;
        //var endIndex = odataURL.indexOf(".svc/")!=-1?odataURL.indexOf(".svc/")+5:-1;
        params = params + "&TABLEURL=" + odataURL;//No I18N 
        params = params + "&OBJID=" + ZDBClientUI.selectedTab.view.objId;//No I18N
        params = params+"&DBID="+ZDBClientUI.dbId; //No I18N
        params += "&FILETYPE=CSV&LOCATION=ODATA&ZDBACTION=SHOWPREVIEWFOREXISTIMPODATA"; //No I18N
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ELEMENT: el, ONSUCCESSFUNC: "ODataPage.handlePreviewScript", ONFAILUREFUNC: "ODataPage.handleFailure", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS")});
    };
    this.setDefaultScheduleDet = function (frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        frm.repeatinterval.options[0].selected = "true";
        ODataPage.toggleSchedulePeriod("none", frm); //No I18N
        frm.ZDB_DLY_HRS_INT.value = 0;
        frm.ZDB_DLY_MINS_INT.value = 0;
        frm.sch_failure_count.value = ZDBConst.DEFAULT_SCH_FAILURE_COUNT;
        frm.weeklyinterval.value = 1;
    };

    this.setExistScheduleDet = function (schDet, count, scheduleTimeZone, displayTimeZone, frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        var perTime = schDet[0];
        var perUnit = schDet[1];
        var calFreq = schDet[2];
        var calTime = schDet[3];
        var calDay = schDet[5];
        var calDate = schDet[6];
        frm.schedule_periodic.style.display = "none";
        frm.schedule_daily.style.display = "none";
        frm.schedule_weekly.style.display = "none";
        frm.schedule_monthly.style.display = "none";
        frm.sch_failure_warning.style.display = "";
        frm.sch_failure_count.style.display = "";
        if (count == "null")
        {
            count = ZDBConst.DEFAULT_SCH_FAILURE_COUNT;
        }
        frm.sch_failure_count.value = count;
        var repeatIntElem = frm.repeatinterval;

        if (calFreq == "daily")
        {
            repeatIntElem.value = calFreq;
            frm.schedule_daily.style.display = "";
            var hr = ZDBFunctions.floor(calTime / 60);
            var min = calTime % 60;
            frm.ZDB_DLY_HRS_INT.value = hr;
            frm.ZDB_DLY_MINS_INT.value = min;
            frm.ZDB_DLY_TIMEZONE.innerHTML = ZDBI18NMap.f("zrpt.schsettings.js.usertimeZone", displayTimeZone);
            ZDBUtil.setAttribute(frm.ZDB_DLY_TIMEZONE_SEARCH_ZRTimezoneList, scheduleTimeZone, "selectedTimeZone");
        } else if (calFreq == "weekly") //No I18N
        {
            repeatIntElem.value = calFreq;
            frm.schedule_weekly.style.display = "";
            var hr = ZDBFunctions.floor(calTime / 60);
            var min = calTime % 60;
            frm.ZDB_WLY_HRS_INT.value = hr;
            frm.ZDB_WLY_MINS_INT.value = min;
            frm.weeklyinterval.value = calDay;
            frm.ZDB_WLY_TIMEZONE.innerHTML = ZDBI18NMap.f("zrpt.schsettings.js.usertimeZone", displayTimeZone);
            ZDBUtil.setAttribute(frm.ZDB_WLY_TIMEZONE_SEARCH_ZRTimezoneList, scheduleTimeZone, "selectedTimeZone");
        } else if (calFreq == "monthly") //No I18N
        {
            repeatIntElem.value = calFreq;
            frm.schedule_monthly.style.display = "";
            var hr = ZDBFunctions.floor(calTime / 60);
            var min = calTime % 60;
            frm.ZDB_MLY_HRS_INT.value = hr;
            frm.ZDB_MLY_MINS_INT.value = min;
            frm.monthlyinterval.value = calDate;
            frm.ZDB_MLY_TIMEZONE.innerHTML = ZDBI18NMap.f("zrpt.schsettings.js.usertimeZone", displayTimeZone);
            ZDBUtil.setAttribute(frm.ZDB_MLY_TIMEZONE_SEARCH_ZRTimezoneList, scheduleTimeZone, "selectedTimeZone");
        } else if (calFreq == null) 
        {
            if(jQuery(repeatIntElem).find('option[value="periodic"]').length>0)
            {
                repeatIntElem.value = "periodic"; //No I18N
                frm.schedule_periodic.style.display = "";
                var hrs = perTime+"_hours"; //No I18N
                frm.periodicinterval.value = hrs;
            }
            else
            {
                ODataPage.stopScheduling(false, frm);
            }
        } else
        {
            ODataPage.stopScheduling(false, frm);
        }
    };

    this.stopScheduling = function (resize,frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        frm.repeatinterval.value = "none"; //No I18N
        frm.sch_failure_warning.style.display = "none";
        ODataPage.toggleSchedulePeriod("none",frm);   //No I18N
        frm.sch_failure_count.value = ZDBConst.DEFAULT_SCH_FAILURE_COUNT;
    };

    this.refreshODataTbl = function (el, connId,objId,isConnector)
    {
        ZDBDialogUtil.closeDialog(el);
        var params = "&OBJID=" + objId + "&CONNECTIONID=" + connId + "&ZDBACTION=REFETCHODATATBL"; //No I18N
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ONSUCCESSFUNC: "ODataPage.showRefetchSucessAlert", OPSTATUSID: $("ZDBCREATEDBOPTSTATUS"),ISCONNECTOR:isConnector,ELEMENT:el,CONNECTIONID:connId,OBJID:objId});
    };

    this.showRefetchSucessAlert = function (response, requestOptions)
    {
        ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.schimport.custommsg.js.refetchStarted"));
        if(requestOptions["ISCONNECTOR"])
        {
            ZRConnector.handleODataModSyncResp(response, requestOptions);
        }
    };

    this.editSetup = function (connectionId, element)
    {
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?&CONNECTIONID=" + connectionId + "&DBID=" + ZDBClientUI.dbId + "&ZDBACTION=EDITCONNECTIONODATA", ONSUCCESSFUNC: "ODataPage.showEditDlg", ELEMENT: element, OPSTATUSID: "ZDBMainLoader"});
    };

    this.showEditDlg = function (response, requestOptions)
    {
        if(!$("ZDBODATAINP"))
        {
            var lzName = "ODATA_TABLE_EDIT_DLG"; //No I18N
            var lzOper = "APPENDTODOC"; //No I18N
            if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZROData.cc", this, lzOper))
            {
                return;
            }
        }
        var formel = document.createElement("form");
        formel.setAttribute("style", "width:590px;align:right;");
        var editDlg = $("ZDBODATAINP");
        editDlg.style.display="";
        var result = JSON.parse(response.responseText);
        formel.setAttribute("id", result.CONNECTIONID);
        formel.setAttribute("qa", true);
        formel.appendChild(editDlg);
        var btns = ZDBClientUI.$("ZREditConnBts").cloneNode(true);
        btns.style.display = "";
        formel.appendChild(btns);
        ZDBDialogUtil.showDialog(formel, {MODAL: true, ADDFRAME: true, DONTREMOVE: true, SHADOW: true, TITLECLASS: 'schedule', TITLE: ZDBI18NMap.g('zrpt.databasedata.edit.js.connection.odata')}); // NO I18N
        formel.ZRODataSaveBtn.setAttribute("onclick", "ODataPage.saveConnection(this.form)");
        ODataPage.setConnectionDet(formel, response);
        ODataPage.editMode();
    };
    this.setConnectionDet = function (editDlg, response)
    {

        var result = JSON.parse(response.responseText);
        if(result.USERNAME!="")
        {
            showODataAUTHURLInp(true);
        }
        else
        {
            showODataAUTHURLInp(false);
        }
        ZDBUtil.setNamedChildEls(editDlg, editDlg, "id");
        editDlg.ODATAURL.value = result.ODATAURL;
        editDlg.ODATAUSERNAME.value = result.USERNAME;
        editDlg.ODATAPASSWORD.value = result.PASSWORD;
    };
    this.saveConnection = function (frm)
    {
        var host = frm.ODATAURL.value;
        if (!ZDBValidator.checkValidInput(host))
        {
            showCustomMessage(ZDBUtil.getAttribute(frm.URL, "errormsg"), frm.URL);
            return false;
        }
        var connectionId = frm.getAttribute("id");
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        var conndetails = {};
        conndetails["ODATAURL"] = frm.ODATAURL.value;
        conndetails["USERNAME"] = frm.ODATAUSERNAME.value;
        conndetails["PASSWORD"] = frm.ODATAPASSWORD.value;
        var params = "CONNECTIONID=" + connectionId;//No I18N  
        params += "&ODATAFEEDURL=" + encodeURIComponent(JSON.stringify(conndetails));//No I18N  
        params += "&ZDBACTION=SAVEEDITODATA";//No I18N  
        params += "&DBID=" + ZDBClientUI.dbId;//No I18N  
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ONSUCCESSFUNC: "ODataPage.showSaveSucessAlert", OPSTATUSID: frm.ZREDITSTATUS, ELEMENT: frm});
    };
    this.showSaveSucessAlert = function (response, requestOptions)
    {
        var resp = JSON.parse(response.responseText);
        var el = requestOptions.ELEMENT;
        if(resp.connchanged === false)
        {
            ZDBDialogUtil.closeDialog(el);
            ZDBMsgBox.showInfo(ZDBI18NMap.g('zrpt.databasedata.edit.js.nochanges'));
            return;
        }
        var elId = "-12_" + el.getAttribute("id");
        var obj = ZRConnector.connJson[elId];
        obj.connname = resp.connname;
        obj.storedconnname = resp.storedconnname;
        $("storedConnName").innerHTML = ZDBEscapeUtil.encodeForHtml(obj.storedconnname);
        $("connName").innerHTML = ZDBEscapeUtil.encodeForHtml(obj.connname);
        jQuery($(elId)).find("[id='ConnSubName']")[0].innerHTML = ZDBEscapeUtil.encodeForHtml(obj.storedconnname);
        jQuery($(elId)).find("[id='ConnMainName']")[0].innerHTML = ZDBEscapeUtil.encodeForHtml(obj.connname);
        ZDBDialogUtil.closeDialog(el);
        ZDBMsgBox.showSuccess(ZDBI18NMap.g('zrpt.databasedata.edit.js.sucess'));
    };

    this.showSyncEdit = function (connectionId)
    {
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?&CONNECTIONID=" + connectionId + "&DBID=" + ZDBClientUI.dbId + "&ZDBACTION=FETCHSYNCDETODATA", ONSUCCESSFUNC: "ODataPage.cntshowSyncEdit", OPSTATUSID: "ZDBMainLoader"});
    };

    this.cntshowSyncEdit = function (response, requestOptions)
    {
        var lzName = "ODATA_TABLE_EDIT_DLG"; //No I18N
        var lzOper = "APPENDTODOC"; //No I18N
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZROData.cc", this, lzOper))
        {
            return;
        }
        var formel = document.createElement("form");
        var editDlg = ZDBClientUI.$("SchTimeZone").cloneNode(true);
        ZDBUtil.setAttribute(editDlg,"margin-top:0px","style");
        formel.appendChild(editDlg);
        var btns = ZDBClientUI.$("ZREditConnBts").cloneNode(true);
        btns.style.display = "";
        formel.appendChild(btns);
        ZDBDialogUtil.showDialog(formel, {MODAL: true, ADDFRAME: true, DONTREMOVE: false, SHADOW: true, TITLECLASS: 'schedule', TITLE: ZDBI18NMap.g('zrpt.databasedata.edit.js.sync.odata')}); // NO I18N
        ZDBUtil.setNamedChildEls(formel, formel, "id");
        formel.ZREditConnBts.setAttribute("style", "margin-top: 10px; margin-left: 160px;");
        formel.ZRODataSaveBtn.setAttribute("onclick", "ODataPage.saveSync(this.form)");
        var result = JSON.parse(response.responseText);
        formel.setAttribute("id",result.CONNECTIONID);
        if (result.scheduleDetails != null)
        {
            var schDet = [];
            schDet = result.scheduleDetails;
            ODataPage.setExistScheduleDet(schDet, result.schWarnMailCount, result.scheduleTimeZone, result.displayTimeZone, formel);
        } else
        {
            ODataPage.setDefaultScheduleDet(formel);
        }
    };

    this.saveSync = function (frm)
    {
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        var schedulerName = ODataPage.getSchedulerName(frm);
        var schFailWarnCount = frm.sch_failure_count.value;
        var repeatType = frm.repeatinterval.value;
        var timeZone = repeatType == "daily" ? frm.ZDB_DLY_TIMEZONE_SEARCH_ZRTimezoneList.getAttribute("selectedTimeZone") : repeatType == "weekly" ? frm.ZDB_WLY_TIMEZONE_SEARCH_ZRTimezoneList.getAttribute("selectedTimeZone") : frm.ZDB_MLY_TIMEZONE_SEARCH_ZRTimezoneList.getAttribute("selectedTimeZone");//No I18N
        var params;
        params = "SCHEDULERNAME=" + schedulerName;  //No I18N
        params += "&SCHEDULETIMEZONE=" + timeZone;//No I18N
        params += "&ZDBSCHFAILWARNCOUNT=" + schFailWarnCount;   //No I18N
        var connectionId = frm.getAttribute("id");
        params += "&CONNECTIONID=" + connectionId;//No I18N  
        params += "&DBID=" + ZDBClientUI.dbId;//No I18N  
        params += "&ZDBACTION=SAVESYNCODATA";//No I18N  
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ONSUCCESSFUNC: "ODataPage.showSaveSyncSucessAlert", OPSTATUSID: frm.ZREDITSTATUS, ELEMENT: frm});
    };
    this.showSaveSyncSucessAlert = function (response, requestOptions)
    {
        var el = requestOptions.ELEMENT;
        var elId = "-12_" + el.getAttribute("id");
        var obj = ZRConnector.connJson[elId];
        var resp = JSON.parse(response.responseText);
        obj.schtype = resp.schtype;
        obj.nextschtime = resp.nextschtime;
        obj.timezone = resp.timezone;
        if(elId == ZRConnector.curConnector)
        {
            $("connSchType").innerHTML = obj.schtype;
            $("connNextSchTime").innerHTML = obj.nextschtime;
            $("connTimeZone").innerHTML = obj.timezone;
        }
        $(elId + "_connSchTime").innerHTML = obj.nextschtime;
        ZDBDialogUtil.closeDialog(el);
        ZDBMsgBox.showSuccess(ZDBI18NMap.g('zrpt.odatadata.syncedit.js.sucess'));
    };
    this.deleteConnector = function (connectionId, parEl)
    {
        var params;
        params = "CONNECTIONID=" + connectionId;//No I18N  
        params += "&DBID=" + ZDBClientUI.dbId;//No I18N  
        params += "&ZDBACTION=DELETECONNECTORODATA";//No I18N  
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params, ELEMENTID: parEl, ONSUCCESSFUNC: "ZRConnector.showRespMsg", OPSTATUSID: "ZDBMainLoader"});
    };
    this.handleFailure = function (response, requestOptions)
    {
        if($("ZRODataCreateBtn")){
        ZDBUtil.setAttribute($("ZRODataCreateBtn"), 'ODataPage.submitODataForm(this.form)', 'onclick');
        }
        else if($("ZRODataImportBtn")){
        ZDBUtil.setAttribute($("ZRODataImportBtn"), 'ODataPage.submitODataForm(this.form)', 'onclick');
        }
        var errCode = response.getResponsePart("ERRORCODE");
        var errMsg = response.getResponsePart("STATUS_MESSAGE");
        errCode = trimAll(errCode);
        if(errCode!=null)
        {
            if('DBNAME_DUPLICATE' == errCode || 'META_DBNAME_DUPLICATE' == errCode)
            {
                showCustomMessage(errMsg, $("ZRDBName"));
                return;
            }
            else if('META_DBOBJECT_NAME_DUPLICATED' == errCode && !ODataPage.isRoot($("ODATAURL").value))
            {
                showCustomMessage(errMsg,$("ZRTblName"));
                return;
            }
            else if('META_DBOBJECT_NAME_DUPLICATED' == errCode && ODataPage.isRoot($("ODATAURL").value))
            {
                var str = errMsg;
                str=str.trim();
                var tblNameDet = response.getResponsePart("OTHER_DETAILS");
                var tblName = tblNameDet.substring(2,tblNameDet.length-2);
                if($(tblName))
                {
                    showCustomMessage(errMsg,$(tblName));
                    ODataPage.editRepTblName($(tblName));
                }
                else
                {
                     showCustomMessage(errMsg,$("ReportsTables"));
                }
            }
            else if('NO_TABLE_EXISTS_IN_DATA_SOURCE' == errCode)
            {
                if($("DBTYPE").value!=2)
                {
                    showCustomMessage(errMsg,$("CONN_CloudDBNAME"));
                }
                else
                {
                    showCustomMessage(errMsg,$("SID"));
                }
            }
            else if('IMPORT_FILE_NUMBER_OF_FIELDS_EXCEEDS_SIZE' == errCode && ODataPage.isRoot($("ODATAURL").value))
            {
                var tblNameDet = response.getResponsePart("OTHER_DETAILS");
                var tblName = tblNameDet.substring(2,tblNameDet.length-2);
                errMsg = errMsg.substring(1,errMsg.length-2);///to remove punctuation
                var msg = errMsg+" "+ZDBI18NMap.f("zrpt.databasedata.js.intable",tblName);
                ZDBAlertAPI.showErrorMsg(msg);
            }
            else if('Not a Valid URL' == errCode || 'Not a Valid OData URL' == errCode)
            {
                ZDBAlertAPI.showErrorMsg(errMsg);
            }
            else
            {
                ZDBAlertAPI.showErrorMsg(errMsg, null, errCode);
            }
        }
    };
    this.showModEdit = function(objId)
    {
        var params = "ZDBACTION=SHOWMODEDITODATA"; //No I18N
        params+="&OBJID="+objId; //No I18N
        params+="&DBID="+ZDBClientUI.dbId;//No I18N
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params,ONSUCCESSFUNC: "ODataPage.showModEditDlg",OPSTATUSID: "ZDBMainLoader",OBJID:objId});
    };
    this.showModEditDlg = function(response, requestOptions)
    {
        if (!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js", "APPENDTODOC", ODataPage.showModEditDlg,[response, requestOptions]))
        {
            return;
        }
        if (!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList", "APPENDTODOC", ODataPage.showModEditDlg,[response, requestOptions]))
        {
            return;
        }
        var lzName = "ODATA_TABLE_EDIT_DLG"; //No I18N
        var lzOper = "APPENDTODOC"; //No I18N
        if (!ZDBLazyLoadUtil.loadSnippet(lzName, "/ZROData.cc", this, lzOper))
        {
            return;
        }
        var formel = document.createElement("form");
        formel.setAttribute("style", "width:495px;align:right;");
        var importtype = $("SchImportType").cloneNode(true);
        ZDBUtil.setNamedChildEls(importtype,importtype,"id");
        jQuery(importtype.ZDBSCHIMPORTTYPE).empty();
        var result = JSON.parse(response.responseText);
        var permLevel = result.GRIDOBJ.perm[0];
        var perms = permLevel.split("$");
        var impOptionSelect = importtype.ZDBSCHIMPORTTYPE;
        impOptionSelect = ZDBImport.setImportOption(importtype.ZDBSCHIMPORTTYPE, perms);
        var addcolumn = $("SchCanAddNewCol").cloneNode(true);
        formel.setAttribute("id",requestOptions["OBJID"]);
        formel.setAttribute("qa", true);
        var desc = document.createElement("div");
        desc.className="gray";
        desc.innerHTML=ZDBI18NMap.g("zrpt.databasedata.modedit.js.txt");
        formel.appendChild(desc);
        formel.appendChild(importtype);
        formel.appendChild(addcolumn);
        var btns = ZDBClientUI.$("ZREditConnBts").cloneNode(true);
        btns.style.display = "";
        btns.style.marginLeft = "150px"; //No I18N
        formel.appendChild(btns);
        formel.ZRODataSaveBtn.setAttribute("onclick", "ODataPage.saveModImportSettings(this.form)");
        var colheads = [];
        var colArr = result.GRIDOBJ.colHead;
        for(var i=0;i<colArr.length;++i)
        {
            var c = colArr[i];
            var colHeader = new ZDBColHeader(this,c[0],c[1],c[2],c[3],c[4],c[5],c[6],c[7],c[8],c[9],c[10],c[11], c[12], c[13],c[14],c[15],false, ZDBConst.CLEAR, c[16], c[17], c[18], c[19], c[20], c[21], c[22], c[23], c[24],c[25], c[26],c[27],c[28],c[29],c[30],c[31],c[32],c[33],c[34],c[35],c[36],c[37],c[38],c[39],c[40],c[41],c[42],c[43],c[44],c[45],c[46],c[47],c[48],c[49],c[50]);
            colheads[i] = colHeader;
        }
        var dg = {};
        dg["colHeaders"] = colheads;
        ZDBImport.setExistColumnList(dg,formel);
        if(result.MATCHCOLS!=null && result.MATCHCOLS!="")
        {
            var matchColList = result.MATCHCOLS.split(',');
            ZDBImport.setCheckListColumn(dg,matchColList,formel);
        }
        ZDBUtil.setNamedChildEls(formel,formel,"id");
        formel.ZDBSCHIMPORTTYPE.value = result.SCHEDULEIMPORTTYPE;
        ODataPage.showMatchColList(formel.ZDBSCHIMPORTTYPE);
        if (result.CANADDNEWCOLUMN)
        {
            formel.ZDBCANADDNEWCOLUMN.checked = true;
        } 
        else
        {
            formel.ZDBCANADDNEWCOLUMN.checked = false;
        }
        ZDBDialogUtil.showDialog(formel, {MODAL: true, ADDFRAME: true, DONTREMOVE: false, SHADOW: true, TITLECLASS: 'schedule', TITLE: ZDBI18NMap.g('zrpt.databasedata.edit.js.syncimport.odata')}); // NO I18N
    };
    
    this.saveModImportSettings = function(el)
    {
        ZDBUtil.setNamedChildEls(el,el,"id");
        var params = "SCHEDULEIMPORTTYPE=" +el.ZDBSCHIMPORTTYPE.value;//No I18N
        params += "&CANADDNEWCOLUMN=" + el.ZDBCANADDNEWCOLUMN.checked;//No I18N
        if (el.ZDBSCHIMPORTTYPE.value == "UPDATEADD" || el.ZDBSCHIMPORTTYPE.value == "DELETEUPDATEADD")
        {
            var matchCols = new Array();
            var matchList = jQuery(el).find("[name='ZOHO_MATCHING_COLUMNS']");
            var count = 0;

            for (var i = 0, j = matchList.length; i < j; i++)
            {
                if (matchList[i].checked)
                {
                    matchCols[count] = matchList[i].value;
                    count++;
                }
            }
            if(count == 0)
            {
                showCustomMessage(ZDBI18NMap.g("zrpt.common.matchingcol.js.errmsg"),matchList[0]);
                return;
            }
            params += "&MATCHINGCOLS=" + matchCols.toString(); //No I18N
        }
        params+="&ZDBACTION=SAVEMODEDITODATA"; //No I18N
        params+="&OBJID="+el.getAttribute("id"); //No I18N
        AjaxAPI.sendRequest({URL: "/ZRODataAction.ma?", PARAMETERS: params,ONSUCCESSFUNC: "ZRConnector.handleModEditResp",OPSTATUSID: el.ZREDITSTATUS,ELEMENT:el});
    };
    
    this.highLytPar = function(el)
    {
        var parid = el.getAttribute("orgTbl");
        var parEl = $(parid+"_tbl");
        parEl.className = "zrdbSelectedTblFinalHover";
        var child =  jQuery(el).children()[0];
        child.style.maxWidth="240px"; //No I18N
    };
    
    this.dehighLytPar = function(el)
    {
        var parid = el.getAttribute("orgTbl");
        var parEl = $(parid+"_tbl");
        parEl.className = "zrdbSelectedTblFinal";
        var child =  jQuery(el).children()[0];
        child.style.maxWidth="260px"; //No I18N
    };
    
    this.editRepTblName = function(element,event)
    {
        jQuery(element).unbind("click"); //No I18N
        element.onclick = "";
        element.style.backgroundColor="#FFFFFF";
        var el =  jQuery(element).children()[0];
        var icon = jQuery(element).children()[1];
        icon.style.display="none";
        var inputTabEl = $("repTblEdit").cloneNode("true"); 
        inputTabEl.originalValue = ZDBEscapeUtil.decodeForHtml(el.innerHTML);
        el.style.display = "none";
        inputTabEl.style.paddingleft = "-5px"; //No I18N
        inputTabEl.style.width = jQuery(element).width()-10+ "px";
        inputTabEl.style.height = jQuery(element).height()-2+ "px";//border reduced
        inputTabEl.value = inputTabEl.originalValue;
        inputTabEl.style.display = "";
        ZDBUtil.setTimeout(ZDBUtil.setFocus, null, [inputTabEl], 5);
        element.appendChild(inputTabEl);
        if(event){
       ZDBUtil.stopEventBubble(event);
        }
       ODataPage.highLytPar(element);
    };
    
    this.resetTblName = function(el,frm)
    {
        var parel = jQuery(el).siblings()[0];
        var icon = jQuery(el).siblings()[1];
        var pardiv = jQuery(parel).parent()[0];
        if((el.value).trim() !="")
        {
            parel.innerHTML = ZDBEscapeUtil.encodeForHtml(el.value);
        }
        else
        {
            parel.innerHTML = ZDBEscapeUtil.encodeForHtml(el.originalValue);
        }
        el.style.display = "none";
        icon.style.display = "";
        parel.style.display="inline-block";
        jQuery(pardiv).bind("click", function(event){ ODataPage.editRepTblName(this,event)});
        ZDBUtil.setAttribute(pardiv,'ODataPage.editRepTblName(this,event)','onclick');
        ZDBUtil.setAttribute(pardiv,el.value,"id");
        pardiv.style.backgroundColor="";
        jQuery(el).remove();
        var index = jQuery(parel).parent().index();
        ZDBUtil.setNamedChildEls(frm, frm, "id");
        var reportsTableArray = ZDBUtil.getAttribute(frm.MultipleTblList, "reportsTableArray").split(',');
        reportsTableArray[index] = ZDBEscapeUtil.decodeForHtml(parel.innerHTML);
        ZDBUtil.setAttribute(frm.MultipleTblList, reportsTableArray, "reportsTableArray");
        ODataPage.dehighLytPar(pardiv);
    };
    
    this.removeObj = function()
    {
        hideCustomMessage();
        var tab = ZDBClientUI.selectedTab;
        if(tab.view.clouddbview)
        {
            tab.view.clouddbview = null;
        }
    }
    
    this.showDataSourcesDlg = function()
    {
        var view = ZDBClientUI.selectedTab.view;
        var connId = view.connectionId;
        ODataPage.showDataSourcesDlgInExp("-12_" + connId);
//        var id = "-11_" + connId;
//        ZRConnector.changeClass($(id));
    }
    
    this.showDataSourcesDlgInExp = function(elId)
    {
    	if(ZRConnector.isDlgOpened)
    	{
            ZDBNavigation.selectExplorer();
    		return;
    	}
    	ZRConnector.isDlgOpened = true;
        var params = "&DBID=" + ZDBClientUI.dbId; // No I18N
        AjaxAPI.sendRequest({
                URL:"/ZRDataSources.cc?ZDBACTION=FETCHDATASOURCES", // No I18N
    			METHOD:"GET", //No I18N
                PARAMETERS:params,
                ONSUCCESSFUNC:ODataPage.handleDataSourcePage,
                OPSTATUSID:"ZDBMainLoader", // No I18N
                ELEMENTID:elId 
            });
    };
    
    this.handleDataSourcePage = function(response,requestOptions)
    {
        ZDBNavigation.selectExplorer();
        ZRConnector.successDataSourcesDlg(response,requestOptions);
        ZRConnector.changeClass($(requestOptions["ELEMENTID"]), null, 'switch');//No I18N
    }
    this.getDatabaseType = function(servicename,frm){
        var toReturn;
        if(servicename==1){
           toReturn=3//PostgreSQL for Redshift
        }else if(servicename==2){
           toReturn=1//MSSQL for Azure
        }else if(servicename==5){
            toReturn=3//PostgreSQL for Heroku
        }
        else if(servicename == 4){
        	toReturn=0  //MySQL for Google Cloud SQL	
        }
        else{
            if(frm==undefined){
                toReturn = $("DBTYPE").value;
            }else{
                toReturn=frm.DBTYPE.value
            }
        }
        return toReturn;
}
};

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ODataPage.showCreateCloudDB"] = ODataPage.showCreateCloudDB;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ODataPage.showCreateODataTable"] = ODataPage.showCreateODataTable;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ODataPage.showExistImpDialog"] = ODataPage.showExistImpDialog;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ODataPage.showDataSourcesDlg"] = ODataPage.showDataSourcesDlg;
