//$Id$
//ignorei18n_start
var DBSettingsSlideShowComponent = React.createClass({
    displayName: 'DBSettingsSlideShowComponent',

    openPricing: function (event) {
        if (ZDBGlobal.IS_ONPREMISE_BUILD) {
            zroptopbar.upgradePlan(event);
        } else {
            var dbURL = ZDBGlobal.upgradeLink;
            window.open(dbURL, '_blank');
        }
    },
    getEmbedURL: function (jsonObj) {
        var url = this.getSlideURL(jsonObj);
        var embedURL = '<iframe frameborder=0 width="' + jsonObj.width + '" height="' + jsonObj.height + '" allowFullScreen="true" src="' + url + '"></iframe>';
        return embedURL;
    },
    getPublishURL: function (jsonObj) {
        var url = this.getSlideURL(jsonObj);
        return url;
    },
    getSlideURL: function (jsonObj) {
        var url = window.location.protocol + "//" + window.location.host + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBSlideshow.cc?SLIDEID=" + jsonObj.slideID;
        url += "&SLIDEKEY=" + jsonObj.slideKey + "&INTERVAL=" + jsonObj.slideInterval;
        url += "&AUTOPLAY=" + jsonObj.autoPlay + "&INCLUDETITLE=" + jsonObj.includeTitle;
        url += "&INCLUDEDESC=" + jsonObj.includeDesc;
        return url;
    },
    // componentDidUpdate : function(){
    //     if(this.props.jsonInfo.CREATEOREDITSLIDESHOW)
    //         this.refs.createDialog.refs.slideName.focus();
    // },
    render: function () {
        var jsonInfo = this.props.jsonInfo;
        var slideshowNotPossible = jsonInfo.slideShowNotPossible;
        var showCreateComp, showFreeze;
        if (!slideshowNotPossible) {
            var slides = Object.keys(jsonInfo.SLIDES);
            showCreateComp = jsonInfo.CREATEOREDITSLIDESHOW ? "ZRDBSlideshowCreate showSlideshowCreate" : "ZRDBSlideshowCreate";
            showFreeze = jsonInfo.CREATEOREDITSLIDESHOW ? "block" : "none";
        }
        return React.createElement(
            'div',
            { id: 'ZRDBSettingsBodyContentDiv' },
            React.createElement(
                'div',
                { id: 'ZRDBSettingsBodyContentInnerDiv' },
                slideshowNotPossible ? React.createElement(
                    'div',
                    { onClick: this.openPricing, className: 'ZRDBWarnText ZRDBTextAlignCenter' },
                    ZDBI18NMap.f("zrpt.dbsettings.bodycontent.js.backupnotallowed", ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow"))
                ) : React.createElement(
                    'div',
                    { style: { width: 'inherit', height: '100%' } },
                    React.createElement(TitleNDesc, { title: ZDBI18NMap.g("zrpt.common.share.shareview.js.manageslideshows"), desc: ZDBI18NMap.g("zrpt.common.share.shareview.js.manageslideshowdesc") }),
                    React.createElement(SlideShowListingComponent, { rerenderComp: this.props.rerenderComp, jsonInfo: this.props.jsonInfo, disableHolder: this.props.disableHolder, enableHolder: this.props.enableHolder, getEmbedURL: this.getEmbedURL, getPublishURL: this.getPublishURL, showToolTips: this.props.showToolTips, hideToolTips: this.props.hideToolTips }),
                    React.createElement(CreateSlideShowComponent, { rerenderComp: this.props.rerenderComp, ref: 'createDialog', showComp: showCreateComp, jsonInfo: this.props.jsonInfo, showToolTips: this.props.showToolTips, hideToolTips: this.props.hideToolTips, getEmbedURL: this.getEmbedURL, getPublishURL: this.getPublishURL, disableHolder: this.props.disableHolder, enableHolder: this.props.enableHolder }),
                    React.createElement('div', { className: 'freezeLayer', style: { position: "absolute", zIndex: "200", "display": showFreeze } })
                )
            )
        );
    }
});

var CreateSlideShowComponent = React.createClass({
    displayName: 'CreateSlideShowComponent',


    getNewSlideName: function () {
        var slides = this.props.jsonInfo.SLIDES;
        var slidesKeys = Object.keys(slides);
        var template = ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow") + ' ';
        var curIndex = 1;
        var slideNames = [];
        var returnSlideName = '';
        slidesKeys.forEach(function (slideKey) {
            var curSlideName = slides[slideKey][0];
            if (curSlideName.indexOf(template) === 0) slideNames.push(slides[slideKey][0]);
        });
        while (true) {
            var curCompleteTemp = template + curIndex;
            if (slideNames.indexOf(curCompleteTemp) === -1) {
                returnSlideName = curCompleteTemp;
                break;
            }
            curIndex++;
        }
        return returnSlideName;
    },
    componentDidMount: function () {
        this.refs.slideName.value = this.getNewSlideName();
        document.body.addEventListener('keyup', this.closeCreateSlideShow);
    },
    componentWillUnmount: function () {
        document.body.removeEventListener('keyup', this.closeCreateSlideShow);
    },
    componentDidUpdate: function (prevProps, prevState) {
        // console.log('update');
        var jsonInfo = this.props.jsonInfo;
        var createOrEditState = jsonInfo.CREATEOREDITSLIDESHOWSTATE;
        if (createOrEditState && createOrEditState.editMode) {
            editableSlide = createOrEditState.editableSlide;
            editableSlideInfo = jsonInfo.SLIDES[editableSlide];
            this.refs.slideName.value = editableSlideInfo[0];
        } else {
            this.refs.slideName.value = this.getNewSlideName();
        }
        if (this.slideName) {
            this.refs.slideName.value = this.slideName;
        }
        this.refs.slideName.select();
    },
    changeSlideName: function (event) {
        this.slideName = event.target.value;
    },
    closeCreateSlideShow: function (event) {
        if (event && event.type == "keyup") {
            if (event.keyCode != KEY.ESC) {
                return;
            }
        }
        var parent = this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE && this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE.parent;
        if (parent) {
            parent.style.backgroundColor = '';
        }
        delete this.props.jsonInfo.CREATEOREDITSLIDESHOW;
        delete this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE;
        delete this.slideName;
        this.props.rerenderComp(this.props.jsonInfo);
    },
    changePrivateLink: function (event) {
        var target = event.target;
        var id = target.getAttribute("id");
        var createState = this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE;
        if (createState.PRIVATELINK && id == "ZRSlideshowWithLogin" || !createState.PRIVATELINK && id == "ZRSlideshowWithoutLogin") {
            createState.PRIVATELINK = !createState.PRIVATELINK;
        }
        this.props.rerenderComp(this.props.jsonInfo);
    },
    validateSlideShowBeforeRequest: function (slideName, viewIds, currentSlideId) {
        var slides = this.props.jsonInfo.SLIDES;
        var slidesKey = Object.keys(slides);
        var viewIdArr = viewIds && viewIds.split(",") || [];
        for (var i = 0, len = slidesKey.length; i < len; i++) {
            if (currentSlideId != slidesKey[i]) {
                var currentSlide = slides[slidesKey[i]];
                if (slideName.toLowerCase() === currentSlide[0].toLowerCase()) {
                    ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.publish.slideshow.js.already_exists"));
                    this.refs.slideName.select();
                    this.refs.slideName.scrollIntoView();
                    return false;
                }
            }
        }
        if (slideName.length > 100 || slideName.trim().length === 0) {
            ZDBMsgBox.showError(ZDBI18NMap.g(slideName.length > 100 ? "zrpt.common.share.shareview.js.slideshow_name_exceeded_length" : "zrpt.common.share.shareview.js.slideshow_name_cannot_empty"));
            this.refs.slideName.select();
            this.refs.slideName.scrollIntoView();
            return false;
        }
        var slideNameRegex = /^[a-zA-Z0-9\s]+$/g;
        var regexMatch = slideName.match(slideNameRegex);
        if (!regexMatch) {
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.share.shareview.js.slideshownamespecialchar"));
            this.refs.slideName.select();
            this.refs.slideName.scrollIntoView();
            return false;
        }
        if (viewIdArr.length > 500) {
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.viewidrule"));
            return false;
        }
        if (viewIdArr.length === 0) {
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.viewlength"));
            return false;
        }
        return true;
    },
    saveSlideShow: function () {
        var jsonInfo = this.props.jsonInfo;
        var createOrEditSlideShowState = jsonInfo.CREATEOREDITSLIDESHOWSTATE;
        this.saveNewSlide(createOrEditSlideShowState.editMode);
    },
    handleSaveSuccess: function (response, requestOptions) {
        this.props.enableHolder(requestOptions.DOMNODE);
        var jsonInfo = this.props.jsonInfo;
        var slideID = jsonInfo.CREATEOREDITSLIDESHOWSTATE.editableSlide;
        var viewId = requestOptions.VIEWIDS;
        var slideAddInfo = jsonInfo.SLIDEADDINFO || {};
        viewId = viewId.split(",");
        slideAddInfo[slideID] = viewId;
        jsonInfo.SLIDEADDINFO = slideAddInfo;
        var slideInfo = jsonInfo.SLIDES[slideID];
        slideInfo = [this.refs.slideName.value, jsonInfo.CREATEOREDITSLIDESHOWSTATE.PRIVATELINK, slideInfo[2], viewId.length];
        jsonInfo.SLIDES[slideID] = slideInfo;
        this.closeCreateSlideShow();
        ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.common.toolbar.share.zdbalertmsg.js.slideshowsaved"));
    },
    handleSaveFailure: function (response, requestOptions) {
        this.props.enableHolder(requestOptions.DOMNODE);
        ZRBaseComponentsUtils.commonErrorHandler(["7196", "7319", "7309", "7301", "6063", "6054", "6055", "6056", "6057"], ["SLIDENAME_ALREADY_EXISTS", "OBJID_NOT_BELONGS_TO_DB", "SECURITY_NEEDS_LOGIN", "NOT_PERMITTED_OPERATION", "SLIDESHOW_NOT_ALLOWED", "PUBLISHCNT_VIOLATION", "REGENERATE_VIOLATION", "SHAREDUSR_PUBLISHCNT_VIOLATION", "SHAREDUSR_REGENERATE_VIOLATION"], response);
    },
    saveNewSlide: function (isEdit) {
        var slideName = this.refs.slideName.value.trim();
        var privateLink = this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE.PRIVATELINK;
        var viewIds = this.refs.MultiViewsListLoaderComp.getSelectedViewsByOrder();
        if (!this.validateSlideShowBeforeRequest(slideName, viewIds, isEdit ? this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE.editableSlide : false)) {
            return;
        }
        var domNode = this.props.disableHolder();
        var params = "DBID=" + ZDBClientUI.dbId + "&SLIDENAME=" + slideName + "&PRIVATELINK=" + privateLink + "&VIEWIDS=" + viewIds;
        params += isEdit ? "&SLIDEID=" + this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE.editableSlide : "";
        //        AjaxAPI.sendRequest({
        //            URL:"/reportsapi/" + (isEdit ? "EDITSLIDESHOW" : "ADDSLIDESHOW"),
        //            PARAMETERS:params,
        //            ONSUCCESSFUNC:(isEdit) ? this.handleSaveSuccess : this.handleSaveNewSuccess,
        //            ONFAILUREFUNC:(isEdit) ? this.handleSaveFailure : this.handleSaveNewFailure,
        //            DOMNODE: domNode,
        //            VIEWIDS: viewIds,
        //            OPSTATUSID: "ZDBMainLoader"
        //        });

        ZRSAjax.post('/reportsapi/' + (isEdit ? 'EDITSLIDESHOW' : 'ADDSLIDESHOW'), params, {
            successHandler: {
                func: isEdit ? this.handleSaveSuccess : this.handleSaveNewSuccess,
                ctx: this
            },
            failureHandler: {
                func: isEdit ? this.handleSaveFailure : this.handleSaveNewFailure,
                ctx: this
            },
            errorHandler: {
                func: isEdit ? this.handleSaveFailure : this.handleSaveNewFailure,
                ctx: this
            },
            DOMNODE: domNode,
            VIEWIDS: viewIds
        });
    },
    handleSaveNewSuccess: function (responseJSON, requestOptions) {
        this.props.enableHolder(requestOptions.DOMNODE);
        var newSlideInfo = responseJSON.newSlide;
        var viewIds = requestOptions.VIEWIDS;
        var jsonInfo = this.props.jsonInfo;
        var slides = jsonInfo.SLIDES || {};
        var newSlideId = newSlideInfo[0];
        var slidesAddInfo = jsonInfo.SLIDEADDINFO || {};
        slides[newSlideId] = newSlideInfo.slice(1);
        slidesAddInfo[newSlideId] = viewIds.split(",");
        jsonInfo.SLIDEADDINFO = slidesAddInfo;
        jsonInfo.SLIDES = slides;
        this.closeCreateSlideShow();
        ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.common.toolbar.share.zdbalertmsg.js.slideshowadded"));
    },
    handleSaveNewFailure: function (response, requestOptions) {
        this.props.enableHolder(requestOptions.DOMNODE);
        ZRBaseComponentsUtils.commonErrorHandler(["7196", "7319", "7309", "7301", "6063", "6054", "6055", "6056", "6057"], ["SLIDENAME_ALREADY_EXISTS", "OBJID_NOT_BELONGS_TO_DB", "SECURITY_NEEDS_LOGIN", "NOT_PERMITTED_OPERATION", "SLIDESHOW_NOT_ALLOWED", "PUBLISHCNT_VIOLATION", "REGENERATE_VIOLATION", "SHAREDUSR_PUBLISHCNT_VIOLATION", "SHAREDUSR_REGENERATE_VIOLATION"], response);
    },
    slideKeyRegenerator: function (loader) {
        var jsonInfo = this.props.jsonInfo;
        loader.className = "mcLoading";
        var slideID = jsonInfo.CREATEOREDITSLIDESHOWSTATE.editableSlide;
        var domNode = this.props.disableHolder();
        //        AjaxAPI.sendRequest({
        //            URL:"/reportsapi/REGENERATESLIDEKEY",
        //            PARAMETERS:"DBID=" + ZDBClientUI.dbId + "&SLIDEID=" + slideID,
        //            ONSUCCESSFUNC:this.handleSlideKeySuccess,
        //            ONFAILUREFUNC:this.handleSlideKeyFailure,
        //            DOMNODE: domNode,
        //            SLIDEID: slideID,
        //            LOADER: loader,
        //            OPSTATUSID: "ZDBMainLoader"
        //        });
        ZRSAjax.post('/reportsapi/REGENERATESLIDEKEY', 'DBID=' + ZDBClientUI.dbId + '&SLIDEID=' + slideID, {
            successHandler: {
                func: this.handleSlideKeySuccess,
                ctx: this
            },
            failureHandler: {
                func: this.handleSlideKeyFailure,
                ctx: this
            },
            errorHandler: {
                func: this.handleSlideKeyFailure,
                ctx: this
            },
            DOMNODE: domNode,
            SLIDEID: slideID,
            LOADER1: loader
        });
    },
    handleSlideKeySuccess: function (responseJson, requestOptions) {
        requestOptions.LOADER1.className = "mcLoaded";
        var newSlideKey = responseJson.newKey;
        this.props.enableHolder(requestOptions.DOMNODE);
        var slideId = requestOptions.SLIDEID;
        var slideInfo = this.props.jsonInfo.SLIDES[slideId];
        slideInfo[2] = newSlideKey;
        this.props.jsonInfo.SLIDES[slideId] = slideInfo;
        this.props.rerenderComp(this.props.jsonInfo);
    },
    handleSlideKeyFailure: function (response, requestOptions) {
        this.props.enableHolder(requestOptions.DOMNODE);
        ZRBaseComponentsUtils.commonErrorHandler([], [], response);
    },
    render: function () {
        var jsonInfo = this.props.jsonInfo;
        var createOrEditState = jsonInfo.CREATEOREDITSLIDESHOWSTATE;
        var privateLink, editMode, editableSlide, editableSlideInfo;
        if (createOrEditState) {
            privateLink = createOrEditState.PRIVATELINK;
            editMode = createOrEditState.editMode;
            editableSlide = createOrEditState.editableSlide;
            editableSlideInfo = jsonInfo.SLIDES[editableSlide];
        }
        return React.createElement(
            'div',
            { className: this.props.showComp, onKeyUp: this.closeCreateSlideShow },
            React.createElement(
                'div',
                { className: 'ZRDBMarginLeft40 ZRDBMarginTop25', style: { width: "calc(100% - 40px)", height: "calc(100% - 25px)" } },
                React.createElement(
                    'ul',
                    null,
                    React.createElement(
                        'li',
                        null,
                        React.createElement(TitleNDesc, { title: ZDBI18NMap.g(editMode ? "zrpt.common.share.shareview.js.editslideshow" : "zrpt.dbsettings.slideshow.js.createnew") })
                    ),
                    React.createElement(
                        'li',
                        { style: { marginTop: "-45px", paddingBottom: "20px" } },
                        React.createElement(
                            'label',
                            { className: 'ZRDBSettingsGeneralSettingsLabel ZRMandatory', style: { width: "200px" } },
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.name"),
                            ':*'
                        ),
                        React.createElement('input', { ref: 'slideName', type: 'text', style: { margin: '5px 0' }, onChange: this.changeSlideName })
                    ),
                    React.createElement(
                        'li',
                        { style: { paddingBottom: "15px" } },
                        React.createElement(
                            'label',
                            { className: 'ZRDBSettingsGeneralSettingsLabel', style: { width: "200px" } },
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.access_permission"),
                            ':',
                            React.createElement('div', { className: 'ZRSHelpIcon',
                                'data-tip': ZDBI18NMap.g("zrpt.dbsettings.slideshow.login.js.help"),
                                'data-noencode': 'true',
                                style: { verticalAlign: "middle", margin: "-2px 0px 0px 5px" },
                                onMouseOut: this.props.hideToolTips, onMouseMove: this.props.showToolTips })
                        ),
                        React.createElement(
                            'div',
                            { style: { height: '40px' } },
                            React.createElement(CustomRadio, { id: 'ZRSlideshowWithLogin', onClick: this.changePrivateLink, checked: !privateLink,
                                holderClassName: 'customRadio', className: 'iconbg customRadioBtn',
                                text: ZDBI18NMap.g("zrpt.common.share.shareview.js.withlogin") }),
                            React.createElement(CustomRadio, { id: 'ZRSlideshowWithoutLogin', onClick: this.changePrivateLink,
                                holderClassName: 'customRadio', className: 'iconbg customRadioBtn ZRDBMarginLeft8', checked: privateLink,
                                text: ZDBI18NMap.g("zrpt.common.share.shareview.js.withoutlogin") })
                        )
                    ),
                    React.createElement(
                        'li',
                        null,
                        React.createElement(
                            'label',
                            { className: 'ZRDBSettingsGeneralSettingsLabel' },
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.select_views")
                        )
                    ),
                    React.createElement('li', { style: { paddingBottom: "11px" } }),
                    React.createElement(
                        'li',
                        null,
                        React.createElement(MultiViewsListLoader, { ref: 'MultiViewsListLoaderComp',
                            jsonInfo: this.props.jsonInfo,
                            viewListContainerStyle: { float: 'left', border: '1px solid #CCCCCC', width: '44%' },
                            viewListSelectedContainerStyle: { float: 'left', 'marginLeft': '10px', border: '1px solid #CCCCCC', width: '44%' },
                            viewListContainerHeaderClass: 'ZRDBSlideshowContainerHeader',
                            viewListSelectedContainerHeaderClass: 'ZRDBSlideshowSelectedContainerHeader',
                            viewListSelectedContainer: 'ZRDBSlideshowSelectedContainer',
                            showToolTips: this.props.showToolTips, hideToolTips: this.props.hideToolTips })
                    ),
                    React.createElement(
                        'li',
                        { style: { display: editMode ? "" : "none" } },
                        React.createElement(
                            'div',
                            { style: { marginBottom: '30px', textAlign: 'center', marginTop: '-8px', display: editMode ? "none" : "" } },
                            React.createElement(
                                'span',
                                { className: 'ZRSlideCreationSuccess' },
                                ZDBI18NMap.g("zrpt.publish.slideshow.js.success")
                            )
                        ),
                        React.createElement(SlideInfoDisplayer, { editableSlide: editableSlide, editableSlideInfo: editableSlideInfo, getEmbedURL: this.props.getEmbedURL, getPublishURL: this.props.getPublishURL, privateLink: privateLink, slideKeyRegenerator: this.slideKeyRegenerator })
                    ),
                    React.createElement(
                        'div',
                        { style: { clear: 'both', paddingTop: '10px', marginBottom: '50px' } },
                        React.createElement('input', { type: 'button', className: 'ZRDBMarginLeft5',
                            value: ZDBI18NMap.g("zrpt.dialoginfo.backup.js.save"),
                            onClick: this.saveSlideShow, ref: 'saveSlideshow' }),
                        React.createElement('input', { className: 'ZRDBMarginLeft5', type: 'button',
                            onClick: this.closeCreateSlideShow, ref: 'closeSlideshow',
                            value: ZDBI18NMap.g("zrpt.dialoginfo.js.cancelbtn") })
                    )
                )
            )
        );
    }
});

var SlideInfoDisplayer = React.createClass({
    displayName: 'SlideInfoDisplayer',

    componentWillMount: function () {
        this.setState({
            mode: "publish"
        });
    },
    componentDidMount: function () {
        this.setAppropriateClasses();
    },
    componentDidUpdate: function () {
        this.setAppropriateClasses();
        this.resetUnsavedInfo();
    },
    setAppropriateClasses: function () {
        var mode = this.state.mode;
        var isPublish = mode === "publish";
        this.refs.embedTab.className = isPublish ? "zrSlideTab ellipsis" : "zrSlideTab ellipsis selected";
        this.refs.publishTab.className = isPublish ? "zrSlideTab ellipsis selected" : "zrSlideTab ellipsis";
        this.refs.linkHolder.className = isPublish ? "zrSlideInfoHolder" : "zrSlideInfoHolder embed";
        this.refs.embedSettings.style.display = isPublish ? "none" : "";
        this.refs.linkTextArea.value = isPublish ? this.getPublishURL() : this.getEmbedURL();
    },
    resetUnsavedInfo: function () {
        this.refs.autoPlay.checked = true;
        this.refs.includeDesc.checked = true;
        this.refs.includeTitle.checked = true;
        this.refs.slideInterval.value = '25';
    },
    changeMode: function (event) {
        var mode = event.target.getAttribute("data-mode");
        this.resetUnsavedInfo();
        this.setState({
            mode: mode
        });
    },
    getEmbedURL: function () {
        var editableSlide = this.props.editableSlide;
        if (editableSlide) {
            var json = this.getURLJson();
            return this.props.getEmbedURL(json);
        } else {
            return '';
        }
    },
    getPublishURL: function () {
        var editableSlide = this.props.editableSlide;
        if (editableSlide) {
            // var slideInfo = jsonInfo.SLIDES[editableSlide];
            var json = this.getURLJson();
            return this.props.getPublishURL(json);
        } else {
            return '';
        }
    },
    getURLJson: function (slideID) {
        var jsonObj = {
            slideInterval: this.refs.slideInterval.value,
            autoPlay: this.refs.autoPlay.checked,
            slideID: this.props.editableSlide,
            slideKey: this.props.editableSlideInfo[2],
            includeTitle: this.refs.includeTitle.checked,
            includeDesc: this.refs.includeDesc.checked,
            width: this.refs.width.value,
            height: this.refs.height.value
        };
        return jsonObj;
    },
    checkNProceedForSlideInterval: function () {
        var slideInterval = this.refs.slideInterval;
        var slideIntervalValue = slideInterval.value;
        slideIntervalValue = parseInt(slideIntervalValue);
        if (isNaN(slideIntervalValue) || slideIntervalValue < 10 || slideIntervalValue > 300) {
            ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.intervalsetfail"));
            return;
        }
        ZDBMsgBox.hideError();
        this.commonStateHandler();
    },
    checkNProceedForSlideWidthNHeight: function (event) {
        var target = event.target;
        var value = target.value;
        value = parseInt(value);
        value = isNaN(value) ? target.defaultValue : value;
        value = value ? value : '600'; //for ie9 since defaultValue wont work
        target.value = value;
        this.commonStateHandler();
    },
    commonStateHandler: function () {
        this.refs.linkTextArea.value = this.state.mode === "publish" ? this.getPublishURL() : this.getEmbedURL();
    },
    preventDefault: function (event) {
        event.preventDefault();
    },
    clickHandler: function (event) {
        event.preventDefault();
        ZDBClientUI.copyToClipboard(event.target.value, "zrcopyclid2");
        event.target.select();
    },
    regenerateSlideKey: function (event) {
        this.props.slideKeyRegenerator(this.refs.ZRSlideRegen);
    },
    render: function () {
        return React.createElement(
            'div',
            { className: 'zrSlideInfoHolder', ref: 'linkHolder' },
            React.createElement(
                'div',
                { className: 'ZRUrlHolder' },
                React.createElement(
                    'div',
                    { className: 'contents' },
                    React.createElement(
                        'div',
                        { id: 'zrcopyclid2', className: 'zr-copy-to-clipboard-notifier', style: { display: "none", opacity: "1" } },
                        ZDBI18NMap.g("zrpt.common.share.shareview.js.copied_to_clipboard")
                    ),
                    React.createElement(
                        'div',
                        { className: 'font12' },
                        ZDBI18NMap.g("zrpt.publish.slideshow.js.settings_not_saved")
                    ),
                    React.createElement(
                        'div',
                        { ref: 'slideTabs', className: 'ZRDBMarginTop10 zrSlideTabHolder' },
                        React.createElement(
                            'div',
                            { onClick: this.changeMode, 'data-mode': 'embed', ref: 'embedTab', className: 'zrSlideTab ellipsis', style: { margin: "0px 5px 0px 8px" } },
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.embedurl")
                        ),
                        React.createElement(
                            'div',
                            { onClick: this.changeMode, 'data-mode': 'publish', ref: 'publishTab', className: 'zrSlideTab ellipsis' },
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.publishurl")
                        ),
                        React.createElement(
                            'div',
                            { className: 'fRight' },
                            React.createElement(
                                'span',
                                { className: 'mcLoaded', ref: 'ZRSlideRegen' },
                                '\xA0'
                            ),
                            React.createElement(
                                'a',
                                { className: 'ZRSLink', onClick: this.regenerateSlideKey, style: { display: this.props.privateLink ? "" : "none" } },
                                ZDBI18NMap.g("zrpt.publish.slideshow.js.regenerate_random_key")
                            )
                        )
                    ),
                    React.createElement(
                        'div',
                        { className: 'ZRDBMarginTop10', style: { width: "98%" } },
                        React.createElement(
                            'div',
                            null,
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.url"),
                            ':'
                        ),
                        React.createElement('textarea', { style: { width: "100%", height: "65px", boxSizing: "border-box" }, spellCheck: 'false', defaultValue: '', ref: 'linkTextArea', onKeyUp: this.preventDefault, onKeyDown: this.preventDefault, onClick: this.clickHandler }),
                        React.createElement(
                            'div',
                            { style: { width: "100%" }, className: 'ZRDBPaddingTop10' },
                            React.createElement(
                                'fieldset',
                                { className: 'zrSlideFieldSet' },
                                React.createElement(
                                    'legend',
                                    { className: 'ZRDBMarginLeft5' },
                                    ZDBI18NMap.g("zrpt.publish.slideshow.js.urloptions"),
                                    ':'
                                ),
                                React.createElement(
                                    'div',
                                    { style: { lineHeight: "40px" } },
                                    React.createElement(
                                        'div',
                                        { className: 'dInlineBlock', style: { marginLeft: "2%" } },
                                        React.createElement(
                                            'span',
                                            null,
                                            ZDBI18NMap.g("zrpt.publish.slideshow.js.slideinterval")
                                        ),
                                        React.createElement('input', { type: 'number', className: 'zrSlideNumberInput', defaultValue: '25', min: '10', max: '300', ref: 'slideInterval', onChange: this.checkNProceedForSlideInterval }),
                                        React.createElement(
                                            'span',
                                            null,
                                            ZDBI18NMap.g("zrpt.publish.js.interval_secs")
                                        )
                                    ),
                                    React.createElement(
                                        'div',
                                        { className: 'dInlineBlock', style: { marginLeft: "2%" } },
                                        React.createElement('input', { type: 'checkbox', defaultChecked: 'true', ref: 'autoPlay', onChange: this.commonStateHandler }),
                                        React.createElement(
                                            'span',
                                            null,
                                            ZDBI18NMap.g("zrpt.publish.slideshow.js.autoplay")
                                        )
                                    ),
                                    React.createElement(
                                        'div',
                                        { className: 'dInlineBlock', style: { marginLeft: "2%" } },
                                        React.createElement('input', { type: 'checkbox', defaultChecked: 'true', ref: 'includeTitle', onChange: this.commonStateHandler }),
                                        React.createElement(
                                            'span',
                                            null,
                                            ZDBI18NMap.g("zrpt.publish.slideshow.js.includetitle")
                                        )
                                    ),
                                    React.createElement(
                                        'div',
                                        { className: 'dInlineBlock', style: { marginLeft: "2%" } },
                                        React.createElement('input', { type: 'checkbox', defaultChecked: 'true', ref: 'includeDesc', onChange: this.commonStateHandler }),
                                        React.createElement(
                                            'span',
                                            null,
                                            ZDBI18NMap.g("zrpt.publish.slideshow.js.includedescription")
                                        )
                                    )
                                )
                            ),
                            React.createElement(
                                'fieldset',
                                { className: 'zrSlideFieldSet', style: { marginTop: "10px" }, ref: 'embedSettings' },
                                React.createElement(
                                    'legend',
                                    { className: 'ZRDBMarginLeft5' },
                                    ZDBI18NMap.g("zrpt.publish.slideshow.js.embedsize"),
                                    ':'
                                ),
                                React.createElement(
                                    'div',
                                    { style: { lineHeight: "40px" } },
                                    React.createElement(
                                        'div',
                                        { className: 'dInlineBlock', style: { marginLeft: "2%" } },
                                        React.createElement(
                                            'span',
                                            null,
                                            ZDBI18NMap.g("zrpt.publish.slideshow.js.width")
                                        ),
                                        React.createElement('input', { type: 'number', className: 'zrSlideNumberInput', defaultValue: '800', ref: 'width', onBlur: this.checkNProceedForSlideWidthNHeight, style: { width: "45px" } })
                                    ),
                                    React.createElement(
                                        'div',
                                        { className: 'dInlineBlock', style: { marginLeft: "2%" } },
                                        React.createElement(
                                            'span',
                                            null,
                                            ZDBI18NMap.g("zrpt.publish.slideshow.js.height")
                                        ),
                                        React.createElement('input', { type: 'number', className: 'zrSlideNumberInput', defaultValue: '600', ref: 'height', onBlur: this.checkNProceedForSlideWidthNHeight, style: { width: "45px" } })
                                    )
                                )
                            )
                        )
                    )
                )
            )
        );
    }
});

var MultiViewsListLoader = React.createClass({
    displayName: 'MultiViewsListLoader',

    getInitialState: function () {
        return this.updateState();
    },
    componentWillMount: function () {
        if (!this.state.viewList || typeof el === "string") {
            this.sendViewsListReq();
        }
    },
    componentWillReceiveProps: function (nextProps) {
        var newState = this.updateState();
        this.setState(newState);
    },
    updateState: function () {
        var jsonInfo = this.props.jsonInfo;
        var viewList = jsonInfo.viewList || ZDBExpViewHandler.getViewResp() || null;
        var selectedList, selectedViews, selectedViewTypes;
        if (viewList && viewList.length > 0) {
            selectedViews = jsonInfo.CREATEOREDITSLIDESHOWSTATE && jsonInfo.CREATEOREDITSLIDESHOWSTATE.SELECTEDVIEWS || [];
            selectedList = [];
            if (selectedViews.length > 0) {
                for (var i = 0; i < viewList.length; i++) {
                    var viewListVal = viewList[i];
                    var index = ZRBaseComponentsUtils.arrayContains(selectedViews, viewListVal[0]);
                    if (index > -1) {
                        selectedList[index] = viewListVal;
                    }
                }
            }
            selectedViewTypes = this.updateSelectedViewTypes(selectedList);
        }
        return {
            viewList: viewList,
            selectedList: selectedList || [],
            selectedViews: selectedViews || [],
            selectedViewSort: this.state && this.state.selectedViewSort || null,
            selectedViewTypes: selectedViewTypes || null,
            selectedViewSearchTypes: this.state && this.state.selectedViewSearchTypes || ['All']
        };
    },
    componentDidUpdate: function (prevProps, prevState) {
        var selectionHolder = this.refs.selectedViewHolder;
        var divs = selectionHolder.querySelectorAll(".ZRViewListView");
        for (var i = 0, len = divs.length; i < len; i++) {
            divs[i].style.top = i * 34 + "px";
        }
        this.props.jsonInfo.viewList = this.state.viewList;
    },
    getViewsList: function () {
        return this.state.viewList;
    },

    //UI related methods start

    removeAllSelectedView: function (event) {
        if (this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE) {
            this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE.SELECTEDVIEWS = [];
        }
        this.setState({
            selectedViews: [],
            selectedList: [],
            selectedViewTypes: []
        });
    },
    removeSelectedView: function (event) {
        var viewID;
        if (typeof event === "object") {
            var target = event.target;
            viewID = DOMUtils.getElOrParentWithAttr(target, "data-viewid").getAttribute("data-viewid");
        } else {
            viewID = event;
        }
        if (this.state.selectedViews) this.state.selectedViews.splice(this.state.selectedViews.indexOf(viewID), 1);
        for (var i = 0; this.state.selectedList && i < this.state.selectedList.length; i++) {
            var viewList = this.state.selectedList[i];
            if (viewList[0] == viewID) {
                this.state.selectedList.splice(i, 1);
            }
        }
        this.checkboxSelected = false;
        var selectedViewTypes = this.updateSelectedViewTypes(this.state.selectedList);
        if (this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE) {
            this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE.SELECTEDVIEWS = this.state.selectedViews.slice(0);
        }
        this.setState({
            selectedViews: this.state.selectedViews,
            selectedList: this.state.selectedList,
            selectedViewTypes: selectedViewTypes
        });
    },
    sendViewsListReq: function () {
        var jsonInfo = this.props.jsonInfo;
        var createOrEditSlideShowState = jsonInfo.CREATEOREDITSLIDESHOWSTATE;
        jsonInfo.viewList = null;
        createOrEditSlideShowState.SELECTEDVIEWS = [];
        this.setState({
            viewList: null,
            selectedViews: [],
            selectedList: [],
            selectedViewSort: null,
            selectedViewTypes: null
        });
        ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/VIEWLIST', {
            ZOHO_FOLDERLIST: false
        }, {
            successHandler: {
                func: this.renderViews,
                ctx: this
            },
            failureHandle: {
                func: this.renderViewsFailure,
                ctx: this
            },
            noLoader: true
        });
        //        AjaxAPI.sendRequest({
        //        URL:"/reportsapi/db/"+ZDBClientUI.dbId+"/VIEWLIST",
        //        PARAMETERS:"ZOHO_FOLDERLIST=false",
        //        ONSUCCESSFUNC:this.renderViews,
        //        ONFAILUREFUNC:this.renderViewsFailure
        //        });
    },
    getSelectedViews: function () {
        return this.state.selectedViews;
    },
    renderViews: function (response) {
        this.setState({
            viewList: response.viewListValues
        });
    },
    renderViewsFailure: function () {
        this.setState({
            viewList: ZDBI18NMap.g("zrpt.common.js.noviewsavailable"),
            selectedViews: [],
            selectedList: [],
            selectedViewSort: null
        });
    },
    addViewToSlide: function (event) {
        var target = event.target;
        var viewID = DOMUtils.getElOrParentWithAttr(target, "data-viewid").getAttribute("data-viewid");
        // var className = (target.className === "ZDBPDFCheckedAll ZRIconBase")?
        // 'ZDBPDFUncheck ZRIconBase':'ZDBPDFCheckedAll ZRIconBase';
        var selectedIndex = ZRBaseComponentsUtils.arrayContains(this.state.selectedViews, viewID);
        if (selectedIndex == -1) {
            if (!this.state.selectedViews) {
                this.state.selectedViews = [];
            }
            this.state.selectedViews.push(viewID);
            var viewToAssign;
            for (var i = 0; i < this.state.viewList.length; i++) {
                var viewListVal = this.state.viewList[i];
                if (viewListVal[0] == viewID) {
                    viewToAssign = viewListVal;
                    break;
                }
            }
            if (!this.state.selectedList) {
                this.state.selectedList = [];
            }
            this.state.selectedList.push(viewToAssign);
            if (this.state.selectedViews.length == this.state.viewList.length) {
                this.checkboxSelected = true;
            }
            var selectedViewTypes = this.updateSelectedViewTypes(this.state.selectedList);
            if (this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE) {
                this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE.SELECTEDVIEWS = this.state.selectedViews.slice(0);
            }
            this.setState({
                selectedViews: this.state.selectedViews,
                selectedList: this.state.selectedList,
                selectedViewTypes: selectedViewTypes
            });
        } else {
            this.removeSelectedView(viewID);
        }
    },
    checkNPushToSelectedViews: function (value) {
        var slideId = value[0];
        if (this.state.selectedViews.indexOf(slideId) >= 0) return;
        this.state.selectedViews.push(slideId);
        this.state.selectedList.push(value);
    },
    selectAllViews: function (event) {
        // delete this.state.selectedViews;
        // delete this.state.selectedList;
        // var selectedViews = [];
        // var selectedList = [];
        var searchStr = this.state.searchStr && this.state.searchStr.toLowerCase();
        // var matchLen = 0;
        this.state.viewList.forEach(function (value) {
            if (searchStr) {
                var viewName = value[1].toLowerCase();
                if (viewName.indexOf(searchStr) === 0) {
                    // matchLen += 1;
                    this.checkNPushToSelectedViews(value);
                }
            } else {
                this.checkNPushToSelectedViews(value);
            }
        }.bind(this));
        var selectedViewTypes = this.updateSelectedViewTypes(this.state.selectedList);
        if (this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE) {
            this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE.SELECTEDVIEWS = this.state.selectedViews.slice(0);
        }
        this.setState({
            selectedViews: this.state.selectedViews,
            selectedList: this.state.selectedList,
            selectedViewTypes: selectedViewTypes
        });
    },
    selectViewsByType: function (event) {
        var type = DOMUtils.getElOrParentWithAttr(event.target, "data-type").getAttribute("data-type");
        if (type === "All") {
            this.checkboxSelected = !this.checkboxSelected;
            if (this.checkboxSelected) this.selectAllViews();else this.removeAllSelectedView();
        }
    },
    searchViewList: function (event) {
        var value = event.target.value;
        if (value !== null && value !== undefined) {
            this.setState({
                searchStr: value
            });
        }
        event.stopPropagation();
    },
    clearSearch: function () {
        this.setState({
            searchStr: null
        });
    },
    sortViewsList: function (event) {
        ZDBUtil.removeClass(this.refs.sortIcon, "selected");
        ZRBaseComponentsUtils.unmountComponentAtNode("ZRViewSortMenu");
        var sortType = DOMUtils.getElOrParentWithAttr(event.target, "data-userData") || event;
        sortType = sortType.getAttribute("data-userData");
        var viewTypes = [],
            viewTypeToViews = {},
            key,
            views,
            newViewListVals = [];
        switch (sortType) {
            case 'ASC':
                this.state.viewList.sort(function (a, b) {
                    var val1 = a[1].toUpperCase();
                    var val2 = b[1].toUpperCase();
                    return val1 < val2 ? -1 : val1 > val2 ? 1 : 0;
                });
                break;
            case 'DSC':
                this.state.viewList.sort(function (a, b) {
                    var val1 = a[1].toUpperCase();
                    var val2 = b[1].toUpperCase();
                    return val1 < val2 ? 1 : val1 > val2 ? -1 : 0;
                });
                break;
            case 'ASCV':
                this.state.viewList.forEach(function (arr) {
                    var valType = arr[2];
                    if (viewTypes.indexOf(valType) < 0) viewTypes.push(valType);
                    viewTypeToViews[valType] = viewTypeToViews[valType] ? viewTypeToViews[valType] : [];
                    viewTypeToViews[valType].push(arr);
                });
                viewTypes.sort();
                for (key in viewTypeToViews) {
                    views = viewTypeToViews[key];
                    views.sort(function (a, b) {
                        var val1 = a[1].toUpperCase(),
                            val2 = b[1].toUpperCase();
                        return val1 < val2 ? -1 : val1 > val2 ? 1 : 0;
                    });
                }
                viewTypes.forEach(function (viewType) {
                    var viewTypeViews = viewTypeToViews[viewType];
                    viewTypeViews.forEach(function (view) {
                        newViewListVals.push(view);
                    });
                });
                this.state.viewList = newViewListVals;
                break;
            case 'DSCV':
                this.state.viewList.forEach(function (arr) {
                    var val = arr[1],
                        valType = arr[2];
                    if (viewTypes.indexOf(valType) < 0) viewTypes.push(valType);
                    viewTypeToViews[valType] = viewTypeToViews[valType] ? viewTypeToViews[valType] : [];
                    viewTypeToViews[valType].push(arr);
                });
                viewTypes.sort(function (a, b) {
                    var val1 = a.toUpperCase(),
                        val2 = b.toUpperCase();
                    return val1 < val2 ? 1 : val1 > val2 ? -1 : 0;
                });
                for (key in viewTypeToViews) {
                    views = viewTypeToViews[key];
                    views.sort(function (a, b) {
                        var val1 = a[1].toUpperCase(),
                            val2 = b[1].toUpperCase();
                        return val1 < val2 ? 1 : val1 > val2 ? -1 : 0;
                    });
                }
                viewTypes.forEach(function (viewType) {
                    var viewTypeViews = viewTypeToViews[viewType];
                    viewTypeViews.forEach(function (view) {
                        newViewListVals.push(view);
                    });
                });
                this.state.viewList = newViewListVals;
                break;
        }
        this.setState({
            viewList: this.state.viewList,
            selectedViewSort: [sortType]
        });
    },
    positionSubMenus: function (event) {
        var target = event.target;
        var holder = document.getElementById("ZRViewSortMenu").children[0];
        var targetBounds = target.getBoundingClientRect();
        var targetParentBounds = target.parentNode.getBoundingClientRect();
        var left = targetBounds.left - targetParentBounds.left + "px";
        var top = targetParentBounds.height + "px";
        holder.style.left = left;
        holder.style.top = top;
    },
    showSortViewMenu: function (event) {
        ZDBToolTip.hide(null, true);
        var target = DOMUtils.getElOrParentWithAttr(event.target, "data-sortIcon");
        ZDBUtil.addClass(target, "selected");
        var menuItems = [[{ value: ZDBI18NMap.g("zrpt.common.js.sortasc"), clickEvtHand: this.sortViewsList, addData: "ASC" }, { value: ZDBI18NMap.g("zrpt.common.js.sortdsc"), clickEvtHand: this.sortViewsList, addData: "DSC" }, { value: ZDBI18NMap.g("zrpt.common.js.sortascviewtype"), clickEvtHand: this.sortViewsList, addData: "ASCV" }, { value: ZDBI18NMap.g("zrpt.common.js.sortdscviewtype"), clickEvtHand: this.sortViewsList, addData: "DSCV" }]];
        var holder = ZRBaseComponentsUtils.getContainer("ZRViewSortMenu", DOMUtils.getParentWithAttrValue(target, "class", this.props.viewListContainerHeaderClass));
        var factory = React.createFactory(ReactMenu);
        ReactDOM.render(factory({ MenuBatches: menuItems, srcEl: target,
            customPositionFunc: this.positionSubMenus,
            closeFunc: this.closeSortViewMenu,
            showSelectedTick: true,
            selected: this.state.selectedViewSort,
            tickStyle: { position: "absolute", top: "8px", width: "7%", height: "13px", padding: "0px", marginLeft: "1px" }
        }), holder);
    },
    closeSortViewMenu: function (srcEl) {
        ZDBUtil.removeClass(srcEl, "selected");
    },
    showSelectByTypeMenu: function (event) {
        var menuItems = this.getMenuItemsWithViewTypes(this.selectSpecificViewType, true);
        var holder = ZRBaseComponentsUtils.getContainer("ZRViewSelectMenu", DOMUtils.getParentWithAttrValue(event.target, "class", this.props.viewListContainerHeaderClass));
        var factory = React.createFactory(ReactMenu);
        ReactDOM.render(factory({
            MenuBatches: menuItems,
            srcEl: event.target,
            showSelectedTick: true,
            selected: this.state.selectedViewTypes,
            customPositionFunc: this.positionViewSelectMenu,
            tickStyle: { position: "absolute", top: "8px", width: "7%", height: "13px", padding: "0px", marginLeft: "1px" }
        }), holder);
    },
    positionViewSelectMenu: function (event) {
        var target = event.target;
        var parent = DOMUtils.getParentWithAttrValue(target, "class", this.props.viewListContainerHeaderClass);
        var parentBounds = parent.getBoundingClientRect();
        var holder = document.getElementById("ZRViewSelectMenu").children[0];
        holder.style.left = "-1px";
        holder.style.top = parentBounds.height + "px";
    },
    selectSpecificViewType: function (event) {
        ZRBaseComponentsUtils.unmountComponentAtNode("ZRViewSelectMenu");
        var target = DOMUtils.getElOrParentWithAttr(event.target, "data-userdata");
        var typeSelected = target.getAttribute("data-userData");
        var alreadySelected = this.state.selectedViews || [];
        var alreadySelectedMeta = this.state.selectedList || [];
        var alreadySelectedViewtypes = this.state.selectedViewTypes || [];
        if (alreadySelectedViewtypes.indexOf(typeSelected) > -1) {
            this.removeSelectedSpecificViewTypes(typeSelected);
            return;
        }
        for (var i = 0, len = this.state.viewList.length; i < len; i++) {
            var curView = this.state.viewList[i];
            if (this.state.selectedViews.indexOf(curView[0]) > -1) {
                continue;
            }
            if (typeSelected === curView[2]) {
                alreadySelected.push(curView[0]);
                alreadySelectedMeta.push(curView);
            }
        }
        alreadySelectedViewtypes.push(typeSelected);
        this.setState({
            selectedViews: alreadySelected,
            selectedList: alreadySelectedMeta,
            selectedViewTypes: alreadySelectedViewtypes
        });
    },
    removeSelectedSpecificViewTypes: function (typeSelected) {
        var alreadySelectedMeta = this.state.selectedList || [];
        var alreadySelectedViewtypes = this.state.selectedViewTypes || [];
        var newSelectedMeta = [];
        if (alreadySelectedViewtypes.indexOf(typeSelected) != -1) {
            for (var i = 0, len = alreadySelectedMeta.length; i < len; i++) {
                var curViewMeta = alreadySelectedMeta[i];
                if (curViewMeta[2] === typeSelected) {
                    alreadySelectedMeta[i] = null;
                    this.state.selectedViews.splice(this.state.selectedViews.indexOf(curViewMeta[0]), 1);
                } else {
                    newSelectedMeta.push(curViewMeta);
                }
            }
            alreadySelectedViewtypes.splice(alreadySelectedViewtypes.indexOf(typeSelected), 1);
            this.setState({
                selectedViews: this.state.selectedViews,
                selectedList: newSelectedMeta,
                selectedViewTypes: alreadySelectedViewtypes
            });
        }
    },
    updateSelectedViewTypes: function (selectedViewMeta) {
        var viewTypes = ["Table", "QueryTable", "AnalysisView", "Pivot", "SummaryView", "Report", "Dashboard"];
        var alreadySelectedViewTypes = [];
        for (var i = 0, len = viewTypes.length; i < len; i++) {
            if (ZDBExpViewHandler.getTypeViewList(viewTypes[i]).length !== 0 && ZDBExpViewHandler.getTypeViewList(viewTypes[i]).length === this.getSelViewTypeLen(selectedViewMeta, viewTypes[i])) alreadySelectedViewTypes.push(viewTypes[i]);
        }
        return alreadySelectedViewTypes;
    },
    getSelViewTypeLen: function (selectedViewMeta, type) {
        var viewTypeLen = 0;
        if (selectedViewMeta) {
            for (var i = 0, len = selectedViewMeta.length; i < len; i++) {
                var viewType = selectedViewMeta[i][2];
                if (viewType == type) viewTypeLen++;
            }
        }
        return viewTypeLen;
    },
    //    showSearchByTypeMenu : function(event){
    //        var menuItems = this.getMenuItemsWithViewTypes(this.selectSearchType,false);
    //        menuItems = menuItems[0];
    //        menuItems.unshift({value:ZDBI18NMap.g("zrpt.pivot.condFormat.js.allPrefix"),clickEvtHand:this.selectSearchType,addData:"All"});
    //        menuItems = [menuItems];
    //        var holder = ZRBaseComponentsUtils.getContainer("ZRSearchSubMenu", DOMUtils.getParentWithAttrValue(event.target,"class",this.props.viewListContainerHeaderClass));
    //        var factory = React.createFactory(ReactMenu);
    //        ReactDOM.render(factory({
    //            MenuBatches:menuItems,
    //            srcEl:event.target,
    //            showSelectedTick:true,
    //            selected:this.state.selectedViewSearchTypes,
    //            customPositionFunc:this.positionSearchSubMenu,
    //            tickStyle:{position:"absolute",top:"8px",width:"7%",height:"13px",padding:"0px",marginLeft:"1px"}
    //        }),holder);
    //    },
    selectSearchType: function (event) {
        ZRBaseComponentsUtils.unmountComponentAtNode("ZRSearchSubMenu");
        var target = DOMUtils.getElOrParentWithAttr(event.target, "data-userData");
        var selectedSearchType = target.getAttribute("data-userData");
        var newState = null;
        if (this.state.selectedViewSearchTypes.indexOf(selectedSearchType) < 0) {
            if (selectedSearchType == "All") {
                newState = ['All'];
            } else {
                var curSearchState = this.state.selectedViewSearchTypes;
                if (curSearchState.indexOf('All') > -1) curSearchState.splice(curSearchState.indexOf('All'), 1);
                this.state.selectedViewSearchTypes.push(selectedSearchType);
                newState = this.state.selectedViewSearchTypes;
            }
            this.setState({
                selectedViewSearchTypes: newState
            });
        } else {
            if (selectedSearchType == 'All') {
                return;
            }
            this.removeSelectedViewSearchType(selectedSearchType);
        }
    },
    removeSelectedViewSearchType: function (selectedSearchType) {
        this.state.selectedViewSearchTypes.splice(this.state.selectedViewSearchTypes.indexOf(selectedSearchType), 1);
        if (!this.state.selectedViewSearchTypes.length) this.state.selectedViewSearchTypes.push('All');
        this.setState({
            selectedViewSearchTypes: this.state.selectedViewSearchTypes
        });
    },
    positionSearchSubMenu: function (event) {
        var target = DOMUtils.getParentWithAttrValue(event.target, "class", "ZRSSearchIconLeft");
        var parent = DOMUtils.getParentWithAttrValue(target, "class", this.props.viewListContainerHeaderClass);
        var parentBounds = parent.getBoundingClientRect();
        var holder = document.getElementById("ZRSearchSubMenu").children[0];
        holder.style.left = target.getBoundingClientRect().left - parentBounds.left + 'px';
        holder.style.top = parentBounds.height + "px";
    },
    getMenuItemsWithViewTypes: function (handler, showIcon) {
        var menuItems = [];
        if (ZDBExpViewHandler.getTypeViewList("Table").length) menuItems.push({ value: ZDBI18NMap.g("zrpt.databasedata.connname.js.tablecols"), clickEvtHand: handler, addData: "Table", iconClass: showIcon ? "TablesNav ZRIconBase" : '' });
        if (ZDBExpViewHandler.getTypeViewList("QueryTable").length) menuItems.push({ value: ZDBI18NMap.g("zrpt.metadata.constant.js.qry_tbl"), clickEvtHand: handler, addData: "QueryTable", iconClass: showIcon ? "QueryTablesNav ZRIconBase" : '' });
        if (ZDBExpViewHandler.getTypeViewList("AnalysisView").length) menuItems.push({ value: ZDBI18NMap.g("zrpt.metadata.constant.js.chart"), clickEvtHand: handler, addData: "AnalysisView", iconClass: showIcon ? "AnalysisViewsNav ZRIconBase" : '' });
        if (ZDBExpViewHandler.getTypeViewList("Pivot").length) menuItems.push({ value: ZDBI18NMap.g("zrpt.metadata.constant.js.pivots"), clickEvtHand: handler, addData: "Pivot", iconClass: showIcon ? "PivotsNav ZRIconBase" : '' });
        if (ZDBExpViewHandler.getTypeViewList("SummaryView").length) menuItems.push({ value: ZDBI18NMap.g("zrpt.metadata.constant.js.summary_views"), clickEvtHand: handler, addData: "SummaryView", iconClass: showIcon ? "SummaryViewsNav ZRIconBase" : '' });
        if (ZDBExpViewHandler.getTypeViewList("Report").length) menuItems.push({ value: ZDBI18NMap.g("zrpt.metadata.constant.js.tabular_reports"), clickEvtHand: handler, addData: "Report", iconClass: showIcon ? "ReportsNav ZRIconBase" : '' });
        if (ZDBExpViewHandler.getTypeViewList("Dashboard").length) menuItems.push({ value: ZDBI18NMap.g("zrpt.metadata.constant.js.dashboards"), clickEvtHand: handler, addData: "Dashboard", iconClass: showIcon ? "DashboardsNav ZRIconBase" : '' });
        return [menuItems];
    },
    addActiveState: function (event) {
        if (!this.draggedDiv) {
            var target = DOMUtils.getElOrParentWithAttr(event.target, "data-viewid");
            ZDBUtil.addClass(target, "active");
        }
    },
    removeActiveState: function (event) {
        if (!this.draggedDiv) {
            var target = DOMUtils.getElOrParentWithAttr(event.target, "data-viewid");
            ZDBUtil.removeClass(target, "active");
        }
    },
    startDivDragging: function (event) {
        event.preventDefault();
        var target = DOMUtils.getElOrParentWithAttr(event.target, "data-viewid");
        ZDBUtil.addClass(target, "dragging");
        this.draggedDiv = target;
        document.body.addEventListener("mousemove", this.dragDiv);
        document.body.addEventListener("mouseup", this.stopDivDragging);
    },
    stopDivDragging: function (event) {
        var target = this.draggedDiv;
        ZDBUtil.removeClass(target, "dragging");
        target.removeEventListener("mousemove", this.dragDiv);
        var targetTop = Math.ceil(parseFloat(target.style.top));
        if (targetTop % 34 !== 0) {
            var children = target.parentNode.querySelectorAll("div.ZRViewListView");
            for (var i = 0, len = children.length; i < len; i++) {
                if (children[i] === target) {
                    var top = i * 34;
                    target.style.top = top + "px";
                    break;
                }
            }
        }
        this.draggedDiv = null;
        document.body.removeEventListener("mousemove", this.dragDiv);
        document.body.removeEventListener("mouseup", this.stopDivDragging);
    },
    dragDiv: function (event) {
        var minTop = 0,
            maxTop = (this.state.selectedViews.length - 1) * 34;
        var target = this.draggedDiv;
        var targetParentNode = target.parentNode;
        var targetParentHeight = targetParentNode.offsetHeight;
        var targetScrollHeight = targetParentNode.scrollHeight;
        var parentScrollTop = targetParentNode.scrollTop;
        var holderTop = this.refs.selectedViewHolder.getBoundingClientRect().top;
        var resultTop = event.clientY - holderTop - 17;
        resultTop = Math.ceil(resultTop < minTop ? 0 : resultTop > maxTop ? maxTop : resultTop);
        var curTop = Math.ceil(parseFloat(target.style.top)) - parentScrollTop;
        var siblingToAffect, func;
        if (resultTop < curTop) {
            siblingToAffect = target.previousSibling;
            func = "add";
        } else if (resultTop > curTop) {
            siblingToAffect = target.nextSibling;
            func = "sub";
        }
        if (siblingToAffect) {
            var siblingTop = Math.ceil(parseFloat(siblingToAffect.style.top)) - parentScrollTop;
            if (targetScrollHeight > targetParentHeight) {
                if (func == "add" && resultTop <= 34) {
                    var scrollTop = targetParentNode.scrollTop;
                    scrollTop -= 3;
                    scrollTop = scrollTop > 0 ? scrollTop : 0;
                    targetParentNode.scrollTop = scrollTop;
                } else if (func == "sub" && resultTop >= targetParentHeight - 50) {
                    var scrollTop = targetParentNode.scrollTop;
                    scrollTop += 7;
                    scrollTop = scrollTop < targetScrollHeight ? scrollTop : targetScrollHeight;
                    targetParentNode.scrollTop = scrollTop;
                }
            }
            // console.log("resultTop: ", resultTop);
            // console.log("siblingTop: ", siblingTop);
            if (func == "sub" && resultTop >= siblingTop || func == "add" && resultTop <= siblingTop) {
                siblingToAffect.parentNode.insertBefore(target, func === "add" ? siblingToAffect : siblingToAffect.nextSibling);
                target.style.top = siblingTop + parentScrollTop + "px";
                siblingToAffect.style.top = (func === "add" ? siblingTop + parentScrollTop + 34 : siblingTop + parentScrollTop - 34) + "px";
            } else {
                target.style.top = resultTop + parentScrollTop + 'px';
            }
        }
    },
    getSelectedViewsByOrder: function () {
        var selectionHolder = this.refs.selectedViewHolder;
        var divs = selectionHolder.querySelectorAll(".ZRViewListView");
        var viewIds = '';
        for (var i = 0, len = divs.length; i < len; i++) {
            viewIds += divs[i].getAttribute("data-viewid") + ",";
        }
        viewIds = viewIds.substring(0, viewIds.length - 1);
        return viewIds;
    },
    stopPropgationOfEvent: function (event) {
        if (event) {
            event.stopPropagation();
            event.nativeEvent.stopImmediatePropagation();
        }
    },
    //UI related methods End
    render: function () {
        var viewsList = this.state.viewList;
        var viewsListDiv;
        if (!viewsList) {
            viewsListDiv = React.createElement(
                'div',
                null,
                React.createElement(
                    'div',
                    { className: 'zdbLoading', style: { position: "initial", margin: "auto", width: "93px", marginTop: "15%" } },
                    React.createElement(
                        'div',
                        { className: 'loadingImage', style: { backgroundPosition: "10px 5px", padding: "9px 36px" } },
                        ZDBI18NMap.g("zrop.common.js.loading")
                    )
                )
            );
        } else if (typeof viewsList === "string") {
            viewsListDiv = React.createElement(
                'div',
                null,
                viewsList
            );
        } else if (typeof viewsList === "object" && viewsList) {
            viewsListDiv = React.createElement(
                'div',
                null,
                viewsList.map(function (view) {
                    var chkBoxClass = ZRBaseComponentsUtils.arrayContains(this.state.selectedViews, view[0]) != -1 ? "ZDBPDFCheckedAll ZRIconBase" : "ZDBPDFUncheck ZRIconBase";
                    var iconClass = view[2] + "sNav ZRIconBase";
                    var searchStr = this.state.searchStr;
                    var viewName = view[1];
                    if (searchStr && viewName.toLowerCase().indexOf(searchStr.toLowerCase()) === 0 && (!this.state.selectedViewSearchTypes || this.state.selectedViewSearchTypes && (this.state.selectedViewSearchTypes[0] == 'All' || this.state.selectedViewSearchTypes.indexOf(view[2]) > -1)) || !searchStr) {
                        return React.createElement(
                            'div',
                            { key: view[0], 'data-viewid': view[0], className: 'ZRViewListView', onClick: this.addViewToSlide },
                            React.createElement('span', { className: chkBoxClass }),
                            React.createElement('span', { className: iconClass }),
                            React.createElement(
                                'div',
                                { className: 'ZRMultiViewListText' },
                                viewName
                            )
                        );
                    }
                }.bind(this))
            );
        }
        var selectedList = this.state.selectedList;
        // if(this.state.searchStr){
        //     this.checkboxSelected = (selectedList && selectedList.length) === (this.state.matchLen) ? true : false;
        // }
        // else {
        this.checkboxSelected = (selectedList && selectedList.length) === (viewsList && viewsList.length) ? true : false;
        // }
        var checkboxClass = this.checkboxSelected ? "ZDBPDFChecked ZRIconBase" : "ZDBPDFUncheck ZRIconBase";
        return React.createElement(
            'div',
            { ref: 'ViewsContainer', id: this.props.containerID, style: { height: '228px' } },
            React.createElement(
                'div',
                { id: this.props.viewListContainerID,
                    style: this.props.viewListContainerStyle,
                    className: this.props.viewListContainerClass },
                React.createElement(
                    'div',
                    { style: { height: '26px' },
                        className: this.props.viewListContainerHeaderClass },
                    React.createElement('span', { className: checkboxClass, 'data-type': 'All', onClick: this.selectViewsByType,
                        style: { width: '18px', height: '20px', float: 'left', margin: "0", marginTop: '3px' } }),
                    React.createElement('span', { className: 'dropDownMenu fLeft', style: { width: "16px", height: "16px", padding: "0px", margin: '7px 0px 0px -1px' }, onClick: this.showSelectByTypeMenu }),
                    React.createElement('span', { ref: 'refresher', className: 'fLeft iconbg tRefreshIcon', style: { marginLeft: '8px', marginTop: '2px' },
                        onMouseEnter: this.props.showToolTips, onClick: this.sendViewsListReq,
                        onMouseLeave: this.props.hideToolTips,
                        'data-tip': ZDBI18NMap.g("zrpt.common.js.refresh") }),
                    React.createElement('span', { className: 'fLeft shortcutSortSettings', ref: 'sortIcon', style: { margin: "2px 0px 0px 3px" }, onClick: this.showSortViewMenu, 'data-sortIcon': 'true',
                        onMouseEnter: this.props.showToolTips, onMouseLeave: this.props.hideToolTips, 'data-tip': ZDBI18NMap.g("zrpt.common.js.sortviewlist") }),
                    React.createElement(CustomSearchComp, { ref: 'customSearch',
                        inputChangeHandler: this.searchViewList,
                        placeholder: ZDBI18NMap.g("zrpt.common.js.searchviews"),
                        holderStyle: { width: '164px', height: "21px", float: "right", marginTop: "2px" },
                        inputStyle: { width: '115px', float: "left", margin: "0" },
                        clearSearch: this.clearSearch
                    })
                ),
                React.createElement(
                    'div',
                    { style: { height: '200px', overflowY: 'auto' } },
                    viewsListDiv
                )
            ),
            React.createElement(
                'div',
                { id: this.props.viewListSelectedContainerID,
                    style: this.props.viewListSelectedContainerStyle,
                    className: this.props.viewListSelectedContainerClass },
                React.createElement(
                    'div',
                    { style: { height: '26px' },
                        className: this.props.viewListSelectedContainerHeaderClass },
                    React.createElement(
                        'span',
                        { style: { marginLeft: '5px' } },
                        ZDBI18NMap.g("zrpt.common.share.shareview.js.selectedviewsheader")
                    ),
                    React.createElement(
                        'span',
                        { style: { marginRight: '8px', display: selectedList.length > 0 ? '' : 'none' }, className: 'fRight ZRSLink',
                            onClick: this.removeAllSelectedView },
                        ZDBI18NMap.g("zrpt.export.multiple.js.removeall")
                    )
                ),
                React.createElement(
                    'div',
                    { ref: 'selectedViewHolder', className: this.props.viewListSelectedContainer, style: { height: '200px', overflowY: 'auto', position: "relative", overflowX: "hidden" } },
                    !selectedList ? React.createElement('div', null) : selectedList.map(function (view, index) {
                        var iconClass = view[2] + "sNav ZRIconBase";
                        return React.createElement(
                            'div',
                            { key: view[0], 'data-viewid': view[0], className: 'ZRViewListView', style: { top: index * 34 + 'px' }, onMouseEnter: this.addActiveState, onMouseLeave: this.removeActiveState, onMouseDown: this.startDivDragging },
                            React.createElement('span', { className: iconClass }),
                            React.createElement(
                                'span',
                                { className: 'ZRMultiViewListText' },
                                view[1]
                            ),
                            React.createElement('span', { className: 'close', onClick: this.removeSelectedView })
                        );
                    }.bind(this))
                )
            )
        );
    }
});

var SlideShowListingComponent = React.createClass({
    displayName: 'SlideShowListingComponent',

    componentWillMount: function () {
        this.setState({
            searchStr: ""
        });
    },
    showCreateSlideShowComponent: function () {
        this.props.jsonInfo.CREATEOREDITSLIDESHOW = true;
        this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE = { PRIVATELINK: false, SELECTEDVIEWS: [], editMode: false, editableSlide: null };
        this.props.rerenderComp(this.props.jsonInfo);
    },
    deleteSingleSlide: function (event) {
        this.clearCheckBox();
        var targetLi = DOMUtils.getElOrParentWithAttr(event.target, "data-slideKey");
        var slideKey = targetLi.getAttribute("data-slideKey");
        this.deleteSlideHandler(slideKey, event.target);
    },
    deleteMultipleSlide: function (event) {
        var inputBoxes = this.refs.slideLists.querySelectorAll("input[type='checkbox']:checked");
        if (inputBoxes.length > 0) {
            var slideKeys = DOMUtils.getElOrParentWithAttr(inputBoxes[0], "data-slideKey").getAttribute("data-slideKey");
            for (var i = 1, len = inputBoxes.length; i < len; i++) {
                var key = DOMUtils.getElOrParentWithAttr(inputBoxes[i], "data-slideKey").getAttribute("data-slideKey");
                slideKeys += "," + key;
            }
            this.deleteSlideHandler(slideKeys);
        } else {
            ZDBMsgBox.showError(ZDBI18NMap.f("zrpt.common.emailsch.js.noviewselopt", ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow"), ZDBI18NMap.g("zrpt.dbsettings.colormodel.js.deleteKey")));
        }
    },
    deleteSlideHandler: function (slides, srcEl) {
        ZDBToolTip.hide(null, true);
        var dlgOpts = { ONCLICK: this.deleteSlideConfirm, SLIDEIDS: slides };
        if (srcEl) {
            dlgOpts.CALLOUT = true;
            dlgOpts.SRCEL = srcEl;
            var parent = DOMUtils.getParentWithAttr(srcEl, "data-slideKey");
            var iconParent = DOMUtils.getParentWithAttrValue(srcEl, "class", "ZRSlideActionBtns");
            ZDBUtil.addClass(iconParent, "fix");
            parent.style.backgroundColor = "#efefee";
        }
        ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.js.deletecommon", ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.label")), "ZDBYESNO", dlgOpts);
    },
    deleteSlideConfirm: function (clickType, requestOptions) {
        var srcEl = requestOptions.SRCEL;
        if (srcEl) {
            var parent = DOMUtils.getParentWithAttr(srcEl, "data-slideKey");
            parent.style.backgroundColor = "";
            var iconParent = DOMUtils.getParentWithAttrValue(srcEl, "class", "ZRSlideActionBtns fix");
            ZDBUtil.removeClass(iconParent, "fix");
        }
        if (clickType == "NO") {
            return;
        }
        var slides = requestOptions.SLIDEIDS;
        var domNode = this.props.disableHolder();
        //        AjaxAPI.sendRequest({URL:"/reportsapi/DELETESLIDESHOW",
        //        PARAMETERS:"SLIDEID="+slides+"&DBID="+ZDBClientUI.dbId,
        //        ONSUCCESSFUNC:this.handleDeleteSlideSucc,
        //        DOMNODE:domNode,
        //        ONFAILUREFUNC:this.handleDeleteSlideFailure,
        //        OPSTATUSID:"ZDBMainLoader",
        //        SLIDES:slides
        //        });
        ZRSAjax.post('/reportsapi/DELETESLIDESHOW', 'SLIDEID=' + slides + '&DBID=' + ZDBClientUI.dbId, {
            successHandler: {
                func: this.handleDeleteSlideSucc,
                ctx: this
            },
            failureHandler: {
                func: this.handleDeleteSlideFailure,
                ctx: this
            },
            errorHandler: {
                func: this.handleDeleteSlideFailure,
                ctx: this
            },
            DOMNODE: domNode,
            SLIDES: slides
        });
    },
    handleDeleteSlideSucc: function (response, requestOptions) {
        this.props.enableHolder(requestOptions.DOMNODE);
        var deletedSlides = requestOptions.SLIDES;
        deletedSlides = deletedSlides.split(",");
        var slideJSON = this.props.jsonInfo.SLIDES;
        for (var i = 0, len = deletedSlides.length; i < len; i++) {
            delete slideJSON[deletedSlides[i]];
        }
        this.refs.deleteBtn.refs.BASEINPUTCOMPONENT.style.display = 'none';
        this.props.jsonInfo.SLIDES = slideJSON;
        this.props.rerenderComp(this.props.jsonInfo);
    },
    handleDeleteSlideFailure: function (response, requestOptions) {
        this.props.enableHolder(requestOptions.DOMNODE);
        ZRBaseComponentsUtils.commonErrorHandler(["6063"], ["SLIDESHOW_NOT_ALLOWED"], response);
    },
    selectAllCheckboxChange: function (event) {
        var checkedState = event.target.checked;
        var checkBoxes = this.refs.slideLists.querySelectorAll("input[type='checkbox']");
        var parent;
        for (var i = 0, len = checkBoxes.length; i < len; i++) {
            var checkbox = checkBoxes[i];
            checkbox.checked = checkedState;
            parent = DOMUtils.getParentWithAttr(checkbox, "data-slidekey");
            parent.style.backgroundColor = checkedState ? "#efefee" : '';
        }
        this.refs.deleteBtn.refs.BASEINPUTCOMPONENT.style.display = checkedState ? "" : "none";
    },
    handleCheckBoxChange: function (event) {
        var target = event.target;
        var checkedInputBoxes = this.refs.slideLists.querySelectorAll("input[type='checkbox']:checked");
        var inputBoxes = this.refs.slideLists.querySelectorAll("input[type='checkbox']");
        this.refs.deleteBtn.refs.BASEINPUTCOMPONENT.style.display = checkedInputBoxes.length > 0 ? "" : "none";
        this.refs.selectAllCheckbox.checked = inputBoxes.length === checkedInputBoxes.length;
        var parent = DOMUtils.getParentWithAttr(target, "data-slidekey");
        parent.style.backgroundColor = target.checked ? "#efefee" : '';
    },
    clearCheckBox: function () {
        this.refs.selectAllCheckbox.checked = false;
        var checkBoxes = this.refs.slideLists.querySelectorAll("input[type='checkbox']"),
            parent;
        for (var i = 0, len = checkBoxes.length; i < len; i++) {
            var target = checkBoxes[i];
            target.checked = false;
            parent = DOMUtils.getParentWithAttr(target, "data-slidekey");
            parent.style.backgroundColor = '';
        }
        this.refs.deleteBtn.refs.BASEINPUTCOMPONENT.style.display = "none";
    },
    showSlideInfo: function (event) {
        ZDBToolTip.hide(null, true);
        this.clearCheckBox();
        var targetLi = DOMUtils.getElOrParentWithAttr(event.target, "data-slideKey");
        var slideKey = targetLi.getAttribute("data-slideKey");
        var cont = ZRBaseComponentsUtils.getContainer("SlideInfoHolder", document.body);
        var factory = React.createFactory(SlideShowInfoViewer);
        targetLi.style.backgroundColor = "#efefee";
        var iconParent = DOMUtils.getParentWithAttrValue(event.target, "class", "ZRSlideActionBtns");
        ZDBUtil.addClass(iconParent, "fix");
        var dlg = ReactDOM.render(factory({ getEmbedURL: this.props.getEmbedURL, getPublishURL: this.props.getPublishURL, slideID: slideKey, slidesInfo: this.props.jsonInfo.SLIDES[slideKey] }), cont);
        ZDBDialogUtil.showDialog(cont, { TITLE: ZDBI18NMap.g("zrpt.common.share.shareview.js.copyslideurl"), ADDFRAME: true, MODAL: true,
            CALLOUT: true, DONTREMOVE: false, SRCEL: event.target, isDialog: "false", ONCLOSE: this.unmountThisCompNClose });
    },
    unmountThisCompNClose: function (dlg, args) {
        ZRBaseComponentsUtils.unmountComponentAtNode("SlideInfoHolder");
        dlg.params.ONCLOSE = null;
        var icon = dlg.params.SRCEL;
        var parent = DOMUtils.getElOrParentWithAttr(icon, "data-slideKey");
        var iconParent = DOMUtils.getParentWithAttrValue(icon, "class", "ZRSlideActionBtns fix");
        parent.style.backgroundColor = "";
        ZDBUtil.removeClass(iconParent, "fix");
        ZDBDialogUtil.closeDialog();
    },
    editSlide: function (event) {
        ZDBToolTip.hide(null, true);
        this.clearCheckBox();
        var targetLi = DOMUtils.getElOrParentWithAttr(event.target, "data-slideKey");
        var slideKey = targetLi.getAttribute("data-slideKey");
        var slideInfo = this.props.jsonInfo.SLIDEADDINFO;
        targetLi.style.backgroundColor = "#efefee";
        if (slideInfo && slideInfo[slideKey]) {
            this.setEditStateForSlide(slideKey, slideInfo[slideKey], targetLi);
        } else {
            var domNode = this.props.disableHolder();
            //            AjaxAPI.sendRequest({
            //            URL:"/reportsapi/INDIVIDUALSLIDEINFO",
            //            PARAMETERS:"SLIDEID="+ slideKey + "&DBID="+ZDBClientUI.dbId,
            //            ONSUCCESSFUNC:this.handleEditSlideSuccess,
            //            ONFAILUREFUNC:this.handleEditSlideFailure,
            //            SLIDEKEY:slideKey,
            //            DOMNODE: domNode,
            //            OPSTATUSID: "ZDBMainLoader",
            //            PARENT: targetLi
            //            });
            ZRSAjax.get('/reportsapi/INDIVIDUALSLIDEINFO', 'SLIDEID=' + slideKey + '&DBID=' + ZDBClientUI.dbId, {
                successHandler: {
                    func: this.handleEditSlideSuccess,
                    ctx: this
                },
                failureHandler: {
                    func: this.handleEditSlideFailure,
                    ctx: this
                },
                errorHandler: {
                    func: this.handleEditSlideFailure,
                    ctx: this
                },
                SLIDEKEY: slideKey,
                DOMNODE: domNode,
                PARENT: targetLi
            });
        }
    },
    handleEditSlideSuccess: function (response, requestOptions) {
        this.props.enableHolder(requestOptions.DOMNODE);
        var viewInfo = response.views;
        this.setEditStateForSlide(requestOptions.SLIDEKEY, viewInfo, requestOptions.PARENT);
    },
    handleEditSlideFailure: function (response, requestOptions) {
        this.props.enableHolder(requestOptions.DOMNODE);
    },
    setEditStateForSlide: function (editableSlide, viewInfo, parent) {
        var knownSlideInfo = this.props.jsonInfo.SLIDES[editableSlide];
        this.props.jsonInfo.CREATEOREDITSLIDESHOW = true;
        this.props.jsonInfo.CREATEOREDITSLIDESHOWSTATE = {
            PRIVATELINK: knownSlideInfo[1],
            SELECTEDVIEWS: viewInfo.slice(0),
            editMode: true,
            editableSlide: editableSlide,
            parent: parent
        };
        var slideAddInfo = this.props.jsonInfo.SLIDEADDINFO;
        slideAddInfo = slideAddInfo || {};
        slideAddInfo[editableSlide] = viewInfo.slice(0);
        this.props.jsonInfo.SLIDEADDINFO = slideAddInfo;
        this.props.rerenderComp(this.props.jsonInfo);
    },
    setSearchState: function (event) {
        this.setState({
            searchStr: event.target.value
        });
    },
    clearSearchState: function (event) {
        this.clearCheckBox();
        this.setState({
            searchStr: ""
        });
    },
    render: function () {
        var jsonInfo = this.props.jsonInfo;
        var slides = jsonInfo.SLIDES;
        var slideKeys = Object.keys(slides);
        var slideLen = slideKeys.length;
        return React.createElement(
            'div',
            null,
            React.createElement(
                'div',
                { style: { width: "90%", height: "30px" } },
                React.createElement(
                    'div',
                    { className: 'fLeft' },
                    React.createElement(InputComponent, { onClick: this.showCreateSlideShowComponent,
                        className: 'newBtn greenBtn', type: 'button',
                        value: ZDBI18NMap.g("zrpt.common.share.shareview.js.createslideshow") }),
                    React.createElement(InputComponent, { ref: 'deleteBtn', style: { display: "none" },
                        className: 'newBtn', type: 'button', onClick: this.deleteMultipleSlide,
                        value: ZDBI18NMap.g("zrpt.common.emailsch.js.delete") })
                ),
                React.createElement(
                    'div',
                    { className: 'fRight' },
                    React.createElement(SearchComponent, { placeholder: ZDBI18NMap.g("zrpt.publish.slideshow.js.search"),
                        holderStyle: { marginTop: "5px", visibility: slideLen < 5 ? 'hidden' : 'visible' },
                        inputStyle: { width: "130px" },
                        inputChangeHandler: this.setSearchState,
                        clearSearch: this.clearSearchState })
                )
            ),
            React.createElement(
                'div',
                null,
                slideLen === 0 ? React.createElement(
                    'div',
                    { className: 'bold tCenter ZRDBMarginTop30' },
                    ZDBI18NMap.g("zrpt.publish.slideshow.js.no_slideshow_available")
                ) : React.createElement(
                    'div',
                    { style: { clear: "both", width: "90%", height: "35px" } },
                    React.createElement(
                        'ul',
                        { className: 'DBUserSettingsTitleUL' },
                        React.createElement(
                            'li',
                            { style: { paddingBottom: "0px" } },
                            React.createElement(
                                'span',
                                { style: { marginLeft: "5px", width: "3%" } },
                                React.createElement('input', { type: 'checkbox', onChange: this.selectAllCheckboxChange, ref: 'selectAllCheckbox' })
                            ),
                            React.createElement(
                                'span',
                                { style: { width: "35%" } },
                                ZDBI18NMap.g("zrpt.publish.slideshow.js.name")
                            ),
                            React.createElement(
                                'span',
                                { style: { width: "35%" } },
                                ZDBI18NMap.g("zrpt.publish.slideshow.js.access_permission")
                            )
                        )
                    ),
                    React.createElement(
                        'ul',
                        { className: 'DBSlideList', ref: 'slideLists' },
                        function (slides) {
                            var resultantLis = [];
                            for (var i = 0, len = slideLen; i < len; i++) {
                                var slideName = slides[slideKeys[i]][0];
                                if (!this.state.searchStr || slideName.toLowerCase().indexOf(this.state.searchStr.toLowerCase()) === 0) {
                                    resultantLis.push(React.createElement(
                                        'li',
                                        { key: i, style: { padding: "8px 0px" }, 'data-slideKey': slideKeys[i], onDoubleClick: this.editSlide },
                                        React.createElement(
                                            'span',
                                            { style: { marginLeft: "5px", width: "3%" } },
                                            React.createElement('input', { type: 'checkbox', onChange: this.handleCheckBoxChange })
                                        ),
                                        React.createElement(
                                            'span',
                                            { style: { width: "35%" } },
                                            slideName
                                        ),
                                        React.createElement(
                                            'span',
                                            { style: { width: "25%" } },
                                            slides[slideKeys[i]][1] ? ZDBI18NMap.g("zrpt.common.share.shareview.js.withoutlogin") : ZDBI18NMap.g("zrpt.common.share.shareview.js.withlogin")
                                        ),
                                        React.createElement(
                                            'span',
                                            { className: 'ZRSlideActionBtns' },
                                            React.createElement('span', { className: 'iconbg embedIcon clearFloat', onClick: this.showSlideInfo, 'data-tip': ZDBI18NMap.g("zrpt.publish.slideshow.geturl.js.title"), onMouseEnter: this.props.showToolTips, onMouseLeave: this.props.hideToolTips }),
                                            React.createElement('span', { className: 'iconbg ZRDBVarRenIcon clearFloat', style: { marginLeft: "13px" }, onClick: this.editSlide, 'data-tip': ZDBI18NMap.g("zrpt.publish.slideshow.edit.js.title"), onMouseEnter: this.props.showToolTips, onMouseLeave: this.props.hideToolTips }),
                                            React.createElement('span', { className: 'iconbg ZRDBVarDelIcon clearFloat', style: { marginLeft: "13px" }, onClick: this.deleteSingleSlide, 'data-tip': ZDBI18NMap.g("zrpt.publish.slideshow.delete.js.title"), onMouseEnter: this.props.showToolTips, onMouseLeave: this.props.hideToolTips })
                                        )
                                    ));
                                }
                            }
                            if (resultantLis.length > 0) return resultantLis;else return React.createElement(
                                'div',
                                { className: 'bold tCenter ZRDBMarginTop30' },
                                ZDBI18NMap.f("zrpt.common.js.searchnomatch", ZDBI18NMap.g("zrpt.dbsettings.slideshow.js.slideshow"))
                            );
                        }.bind(this)(slides)
                    )
                )
            )
        );
    }
});

var SlideShowInfoViewer = React.createClass({
    displayName: 'SlideShowInfoViewer',

    getEmbedURL: function () {
        var slideInfo = this.props.slidesInfo;
        var jsonObj = {
            slideInterval: this.refs.embedSlideInterval.value,
            autoPlay: this.refs.embedAutoPlay.checked,
            slideID: this.props.slideID,
            slideKey: slideInfo[2],
            includeTitle: this.refs.embedIncludetitle.checked,
            includeDesc: this.refs.embedIncludeDesc.checked,
            width: this.refs.embedWidth.value,
            height: this.refs.embedHeight.value
        };
        return this.props.getEmbedURL(jsonObj);
    },
    getPublishURL: function () {
        var slideInfo = this.props.slidesInfo;
        var jsonObj = {
            slideInterval: this.refs.publishSlideInterval.value,
            autoPlay: this.refs.publishAutoPlay.checked,
            slideID: this.props.slideID,
            slideKey: slideInfo[2],
            includeTitle: this.refs.publishIncludeTitle.checked,
            includeDesc: this.refs.publishIncludeDesc.checked
        };
        return this.props.getPublishURL(jsonObj);
    },
    componentDidMount: function () {
        this.updateURLs();
    },
    componentDidUpdate: function () {
        this.updateURLs();
    },
    updateURLs: function () {
        this.refs.embedURLText.value = this.getEmbedURL();
        this.refs.publishURLText.value = this.refs.opentab.href = this.getPublishURL();
    },
    generalStateChanger: function () {
        this.updateURLs();
    },
    selectValNCopy: function (event) {
        event.preventDefault();
        var target = event.target;
        target.selectionStart = target.selectionEnd = 0;
        ZDBClientUI.copyToClipboard(target.value, "zrcopyclid");
        target.select();
        this.handleClassChange(event);
    },
    preventDefault: function (event) {
        event.preventDefault();
        event.target.select();
        this.handleClassChange(event);
    },
    handleClassChange: function (event) {
        ZDBUtil.removeClass(this.refs.publishURLHolder, "zdbHighlightSnippetHolder");
        ZDBUtil.removeClass(this.refs.embedURLHolder, "zdbHighlightSnippetHolder");
        ZDBUtil.addClass(event.target.parentNode, "zdbHighlightSnippetHolder");
    },
    render: function () {
        return React.createElement(
            'div',
            { style: { width: "505px", height: "211px" } },
            React.createElement(
                'div',
                { id: 'zrcopyclid', className: 'zr-copy-to-clipboard-notifier', style: { display: "none", opacity: "1" } },
                ZDBI18NMap.g("zrpt.common.share.shareview.js.copied_to_clipboard")
            ),
            React.createElement(
                'div',
                { className: 'zdbSnippetHolder zdbHighlightSnippetHolder', style: { padding: "0px 10px 10px 0px" }, ref: 'publishURLHolder' },
                React.createElement(
                    'div',
                    { style: { paddingTop: "5px" } },
                    React.createElement(
                        'span',
                        { className: 'zdbSlideshowText' },
                        ZDBI18NMap.g("zrpt.publish.slideshow.js.link")
                    ),
                    React.createElement(
                        'a',
                        { className: 'ZRSLink', ref: 'opentab', style: { display: "inline-block", paddingBottom: "5px", float: "right", paddingTop: "3px" }, href: this.getPublishURL, target: '_blank' },
                        ZDBI18NMap.g("zrpt.publish.slideshow.js.open_newtab")
                    )
                ),
                React.createElement('input', { style: { width: "475px", marginLeft: "10px" }, type: 'text', onKeyDown: this.preventDefault, onKeyUp: this.preventDefault, ref: 'publishURLText', defaultValue: '', onClick: this.selectValNCopy }),
                React.createElement('br', null),
                React.createElement(
                    'div',
                    { className: 'toggleSettings' },
                    React.createElement(
                        'div',
                        null,
                        React.createElement(
                            'span',
                            { style: { marginLeft: "12px", marginRight: "2px" } },
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.slideinterval")
                        ),
                        React.createElement('input', { ref: 'publishSlideInterval', style: { width: "50px" }, className: 'textInput', defaultValue: '25', min: '10', type: 'number', onChange: this.generalStateChanger }),
                        React.createElement(
                            'span',
                            { className: 'gray', style: { marginLeft: "1px" } },
                            ZDBI18NMap.g("zrpt.publish.js.interval_secs")
                        ),
                        React.createElement(
                            'label',
                            { style: { display: "inline", verticalAlign: "middle", marginLeft: "25px", cursor: "pointer" } },
                            React.createElement('input', { ref: 'publishAutoPlay', style: { verticalAlign: "middle", cursor: "pointer" }, defaultChecked: 'true', type: 'checkbox', onChange: this.generalStateChanger }),
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.autoplay")
                        )
                    ),
                    React.createElement(
                        'div',
                        { style: { marginTop: "5px" } },
                        React.createElement(
                            'label',
                            { style: { display: "inline", verticalalign: "middle", marginLeft: "12px", cursor: "pointer" } },
                            React.createElement('input', { ref: 'publishIncludeTitle', style: { verticalAlign: "middle", cursor: "pointer" }, spellCheck: 'false', defaultChecked: 'true', type: 'checkbox', onChange: this.generalStateChanger }),
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.includetitle")
                        ),
                        React.createElement(
                            'label',
                            { style: { display: "inline", verticalAlign: "middle", marginLeft: "95px", cursor: "pointer" } },
                            React.createElement('input', { ref: 'publishIncludeDesc', style: { verticalAlign: "middle", cursor: "pointer" }, defaultChecked: 'true', type: 'checkbox', onChange: this.generalStateChanger }),
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.includedescription")
                        )
                    )
                )
            ),
            React.createElement(
                'div',
                { className: 'zdbSnippetHolder', style: { marginTop: "10px", padding: "0px 10px 10px 0px" }, ref: 'embedURLHolder' },
                React.createElement(
                    'div',
                    { className: 'zdbSlideshowText' },
                    ZDBI18NMap.g("zrpt.publish.slideshow.js.embed"),
                    ':'
                ),
                React.createElement('input', { style: { width: "475px", marginLeft: "10px" }, type: 'text', spellCheck: 'false', onKeyDown: this.preventDefault, onKeyUp: this.preventDefault, ref: 'embedURLText', defaultValue: '', onClick: this.selectValNCopy }),
                React.createElement('br', null),
                React.createElement(
                    'div',
                    { className: 'toggleSettings' },
                    React.createElement(
                        'div',
                        null,
                        React.createElement(
                            'span',
                            { style: { marginLeft: "12px" } },
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.width"),
                            ':'
                        ),
                        React.createElement('input', { ref: 'embedWidth', className: 'textInput', style: { width: "45px" }, defaultValue: '800', type: 'number', onChange: this.generalStateChanger }),
                        React.createElement(
                            'span',
                            { style: { marginLeft: "15px" } },
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.height")
                        ),
                        React.createElement('input', { ref: 'embedHeight', className: 'textInput', style: { width: "45px" }, defaultValue: '600', type: 'number', onChange: this.generalStateChanger }),
                        React.createElement(
                            'span',
                            { style: { marginLeft: "40px", marginRight: "2px" } },
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.slideinterval"),
                            ':'
                        ),
                        React.createElement('input', { ref: 'embedSlideInterval', className: 'textInput', style: { width: "45px" }, defaultValue: '25', min: '10', type: 'number', onChange: this.generalStateChanger }),
                        React.createElement(
                            'span',
                            { className: 'gray', style: { marginLeft: "1px" } },
                            ZDBI18NMap.g("zrpt.publish.js.interval_secs")
                        )
                    ),
                    React.createElement(
                        'div',
                        { style: { marginTop: "5px" } },
                        React.createElement(
                            'label',
                            { style: { display: "inline", verticalAlign: "middle", marginLeft: "12px", cursor: "pointer" } },
                            React.createElement('input', { ref: 'embedIncludetitle', style: { verticalAlign: "middle", cursor: "pointer" }, defaultChecked: 'true', type: 'checkbox', onChange: this.generalStateChanger }),
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.includetitle")
                        ),
                        React.createElement(
                            'label',
                            { style: { display: "inline", verticalAlign: "middle", marginLeft: "20px", cursor: "pointer" } },
                            React.createElement('input', { ref: 'embedIncludeDesc', style: { verticalAlign: "middle", cursor: "pointer" }, defaultChecked: 'true', type: 'checkbox', onChange: this.generalStateChanger }),
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.includedescription")
                        ),
                        React.createElement(
                            'label',
                            { style: { display: "inline", verticalAlign: "top", marginLeft: "10px", cursor: "pointer" } },
                            React.createElement('input', { ref: 'embedAutoPlay', style: { verticalAlign: "top", cursor: "pointer" }, defaultChecked: 'true', type: 'checkbox', onChange: this.generalStateChanger }),
                            ZDBI18NMap.g("zrpt.publish.slideshow.js.autoplay")
                        )
                    )
                )
            )
        );
    }
});
//ignorei18n_end