 //$Id$
var ZDBMetaDataChange = new function()
{
  this.showDataTypeChangeDlg = function(element, event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var colHead = gridObj.getSelectedColHead();
    if(colHead == null)
    {
      ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selCol2ChngDataType"));
      return;
    }
    var type = colHead.type;
    var lookupType = colHead.lookupType;
    if(type == "REFCOL" || lookupType == ZDBConst.REFCOL)
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.toolbar.errmsg.js.remLookup2ChngDataType",ZDBEscapeUtil.encodeForHtml(colHead.displayName)));
      return false;
    }
       
    if(!ZDBClientUI.checkAskSave(gridObj, ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.saveConfirm2ChngDataType")+" '" + ZDBEscapeUtil.encodeForHtml(colHead.displayName) + "'",this))
    {
      return;
    }    
    if(!ZDBLazyLoadUtil.loadSnippet("DATATYPECHANGE_DLG","/ZDBDataTypeChange.cc",this,"APPENDTODOC"))
    {
      return;
    }
    var defType = type;
    if(type == "GEO" || type == "GEO_NUM")
    {
        defType = colHead.geoRoleName;
    }
    gridObj.addSelectedCol(colHead);
    gridObj.selectColumn();
    var el = ZDBUtil.getCachedRef(this,"ZDBPopUpDataTypeChangeDlg");
    el.style.display = "block";
    var txtFld = ZDBUtil.getCachedRef(this,'ZDBPopUpColName');
    var typeTd = ZDBUtil.getCachedRef(this,'ZDBPopUpDataTypeTD');
    txtFld.innerHTML = colHead.getDispNameForHtml();
    if(this.popupDataTypeEl == null)
    {
      this.popupDataTypeEl = ZDBMetaDataChange.loadDataTypeList(typeTd,0);
      this.popupDataTypeEl.onkeypress = this.listChangeEnableDisableSettings;
      this.popupDataTypeEl.onchange = this.listChangeEnableDisableSettings;
    }
    var index = getDataIndex(this.popupDataTypeEl,'defaultvaltype',defType);
    if(index > -1)
    {  
      this.popupDataTypeEl.origVal = this.popupDataTypeEl[index].value;
      if(this.popupDataTypeEl.origVal == ZDBConst.GEO || this.popupDataTypeEl.origVal == ZDBConst.GEO_NUM )
      {
          this.popupDataTypeEl.origGeorole =  this.popupDataTypeEl[index].getAttribute("georole");
      }
      this.popupDataTypeEl[index].selected = true;
    }
    var title = ZDBI18NMap.g("zrpt.column.changedatatype.js.dlgTtl",el);
    el.gridObj = gridObj;
    ZDBDialogUtil.showDialog(el,{TITLE:title,HELPDOC:ZDBI18NMap.g("zrpt.column.changedatatype.js.helplink"),HELPVIDEO:"ZDBClientUI.showVideo('"+ZDBI18NMap.g('zrpt.querytable.column.changedatatype.js.helpvideolink')+"');",ADDFRAME:true,MODAL:true,CALLOUT:true,SRCEL:colHead.cellEl}); //No I18N
    $("ZDBCDTDateFrmt").style.display = "none";
    $("ZDBTYPECHANGEOPTSTATUS").className = "mcLoaded";    
    ZDBUtil.getCachedRef(el,"ZDBPopUpTypeChange_ABORT").checked=true;          
    jQuery("#PopUpDataTypeChangeSettings").addClass("alpha"); //No I18N
    ZDBUtil.getCachedRef(el,"ZDBPopUpTypeChange_DEFAULT").disabled=true;
    ZDBUtil.getCachedRef(el,"ZDBPopUpTypeChange_EMPTY").disabled=true;    
    ZDBUtil.getCachedRef(el,"ZDBPopUpTypeChange_ABORT").disabled=true;
  }
  
  this.showChangeLookupColDlg = function(element,event)
  {
    if(!ZDBLazyLoadUtil.loadSnippet("DATATYPECHANGE_DLG","/ZDBDataTypeChange.cc",this,"APPENDTODOC"))
    {
      return;
    }
    
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var selColHead = gridObj.getSelectedColHead();
    if(selColHead == null)
    {
      ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.toolbar.table.changetolookup.errmsg.js.selCol2change"));
      return;
    }
    if(selColHead.formula || selColHead.type == 'REFCOL' || selColHead.type == 'AUTO_NUMBER' || selColHead.lookupType == ZDBConst.REFCOL || selColHead.lookupType == ZDBConst.RELCOL)
    {
      ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.toolbar.table.changetolookup.errmsg.js.lookupcol"));
      return;
    }
    
    var el = ZDBUtil.getCachedRef(this,"ZDBChangeToLookupDlg");
    el.style.display = "block";
    
    var txtFld = ZDBUtil.getCachedRef(this,'ZDBChangeLookupColName');
    txtFld.innerHTML = selColHead.getDispNameForHtml();
    txtFld.value = selColHead.colId;
    
    var typeTd = ZDBUtil.getCachedRef(this,'ZDBLookupColList');
    ZDBMetaDataChange.loadLookupCols(typeTd, gridObj);
    
    var title = ZDBI18NMap.g("zrpt.common.lookup.js.changetolookup",el);
    el.gridObj = gridObj;
    
    var opStatus = ZDBUtil.getCachedRef(this,'ZDBCNGLOOKUPCOLOPTSTATUS');
    opStatus.className = "mcLoaded"; 

    var piiCheckBox_ChgLkp = ZDBUtil.getCachedRef(el,"piiCheckBox_ChgLkp");
    if(ZDBGlobal.isPIIEnabled)
    {
      piiCheckBox_ChgLkp.style.display = "";
      var piiCheckbox = ZDBUtil.getCachedRef(el,"isPII_ChgLkp");
      ZDBMetaDataChange.addRemoveAsPiiColumn(piiCheckbox, selColHead.isPii);
    }
    else
    {
      piiCheckBox_ChgLkp.style.display = "none";
    }
    var okBtn = el.querySelector("#ZDBChngToLookupColOkBtn")
    ZDBDialogUtil.showDialog(el,{TITLE:title,HELPDOC:ZDBI18NMap.g("zrpt.common.lookup.js.changetolookuphelplink"),HELPVIDEO:"ZDBClientUI.showVideo('"+ZDBI18NMap.g('zrpt.common.lookup.js.changetolookuphelpvideolink')+"');",ADDFRAME:true,MODAL:true,CALLOUT:true,SRCEL:selColHead.cellEl,ACTIONBUTTONS:okBtn}); //No I18N
    if($("ZDBLookupCol_ABORT"))
    {
    	ZDBUtil.getCachedRef(el,"ZDBLookupCol_ABORT").checked=true;
    }
    if($("ZDBNoCascade"))
    {
    	document.getElementById("ZDBNoCascade").checked=true;
    }
    ZDBMetaDataChange.lookupOptChange($("ZDBNoCascade"),false);
    if(gridObj.type=='QueryTable' || gridObj.isSystemTable || gridObj.disablePhysicalLookup)
    {
        jQuery("#ZDBErrOnconversion").hide();//NO I18N
        jQuery("#ZDBFKConstraintChange").hide();//NO I18N
        if(gridObj.isSystemTable)
        {
        jQuery("#ZDBShowChangeSysTableInfo").show();//NO I18N
        $("ZDBLUConnectorName").innerHTML = selColHead.connName;
    }
    else
    {
            jQuery("#ZDBShowChangeSysTableInfo").hide();//NO I18N
        }
    }
    else
    {
        jQuery("#ZDBErrOnconversion").show();//NO I18N
        jQuery("#ZDBFKConstraintChange").show();//NO I18N
        jQuery("#ZDBShowChangeSysTableInfo").hide();//NO I18N
    }
  }

  this.showEditLookupColDlg = function(element,event)
  {
    if(!ZDBLazyLoadUtil.loadSnippet("DATATYPECHANGE_DLG","/ZDBDataTypeChange.cc",this,"APPENDTODOC"))
    {
      return;
    }
    
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var selColHead = gridObj.getSelectedColHead();

    

    if(selColHead == null)
    {
      ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.toolbar.table.changetolookup.errmsg.js.selCol2change"));
      return;
    }

    var el = ZDBUtil.getCachedRef(this,"ZDBEditLookupDlg");
    el.style.display = "block";
    
    var txtFld = ZDBUtil.getCachedRef(this,'ZDBEditLookupColName');
    txtFld.innerHTML = selColHead.getDispNameForHtml();
    txtFld.value = selColHead.colId;
    
    var parentFld = ZDBUtil.getCachedRef(this,'ZDBEditLookupParentColName');
    parentFld.innerHTML = selColHead.sysRefCol;
    parentFld.value = selColHead.sysRefCol;
    

    var typeTd = ZDBUtil.getCachedRef(this,'ZDBEditLookupColList');
    ZDBMetaDataChange.loadLookupCols(typeTd, gridObj,selColHead);
    
    var title = ZDBI18NMap.g("zrpt.common.lookup.js.editlookup",el);
    el.gridObj = gridObj;
    
    var opStatus = ZDBUtil.getCachedRef(this,'ZDBEDITCOLOPTSTATUS');
    opStatus.className = "mcLoaded"; 
    
    ZDBDialogUtil.showDialog(el,{TITLE:title,ADDFRAME:true,MODAL:true});
    if($("ZDBLookupColOnEdit_ABORT"))
    {
    	ZDBUtil.getCachedRef(el,"ZDBLookupColOnEdit_ABORT").checked=true;
    }
    var consoption = (selColHead.refColConstriant==="ON-DELETE-CASCADE"?"ZDBConstCascadeEdit":selColHead.refColConstriant==="ON-DELETE-SET-NULL"?"ZDBConstSetNullEdit":"ZDBNoCascadeEdit");//No I18N
    if(consoption === "ZDBNoCascadeEdit")
    {
        ZDBMetaDataChange.lookupOptChange($(consoption),true);
    }
    if($("ZDBNoCascadeEdit")) //SAS build only have ZDBNoCascadeEdit element. Ref(ZDBDataTypeChange.jsp)
    {
    	ZDBUtil.getCachedRef(el,consoption).checked=true;
    }
    var piiCheckBox_ChgLkp = ZDBUtil.getCachedRef(el,"piiCheckBox_EdtLkp");
    if(ZDBGlobal.isPIIEnabled)
    {
      piiCheckBox_ChgLkp.style.display = "";
      var piiCheckbox = ZDBUtil.getCachedRef(el,"isPII_EdtLkp");
      ZDBMetaDataChange.addRemoveAsPiiColumn(piiCheckbox, selColHead.isPii);
    }
    else
    {
      piiCheckBox_ChgLkp.style.display = "none";
    }
    //ZDBUtil.getCachedRef(el,"ZDBEditLookupColList").style.display="none"; 
    if(gridObj.isSystemTable || (selColHead.lookupType == ZDBConst.RELCOL && gridObj.disablePhysicalLookup))
    {
        jQuery("#ZDBEditErrOnconversion").hide();//NO I18N
        jQuery("#ZDBEditFKConstraintChange").hide();//NO I18N
    }
    else
    {
        jQuery("#ZDBEditErrOnconversion").show();//NO I18N
        jQuery("#ZDBEditFKConstraintChange").show();//NO I18N
    }
  }
  this.lookupOptChange = function(el,isFromEdit)
  {
      var editstr = isFromEdit?"OnEdit":"";//No I18N
      var disableConvOpt=false;
      if(el)
      {
    	  disableConvOpt = el.value === "2" ? true:false;
      }
      if($("ZDBLookupCol"+editstr+"_EMPTY")!==null && $("ZDBLookupCol"+editstr+"_EMPTY")!==undefined)
      {
      $("ZDBLookupCol"+editstr+"_EMPTY").disabled = disableConvOpt;
      $("ZDBLookupCol"+editstr+"_ABORT").disabled = disableConvOpt;
      }
      else if($("ZDBD_EMPTY")!==null && $("ZDBD_EMPTY")!==undefined)
      {
          $("ZDBD_EMPTY").disabled = disableConvOpt;
          $("ZDBD_ABORT").disabled = disableConvOpt;
      }
  }
  this.submitChangeToLookup = function(element,event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var txtFld = ZDBUtil.getCachedRef(this,'ZDBChangeLookupColName');
    var colId = txtFld.value;
    var dlgBody = ZDBUtil.getParentWithAttributeValue(element,"elname","dlgBodyDiv"); //No I18N
    var piiCheckbox = dlgBody.querySelector('[id^="isPII"]'); //No I18N
    var isPii = (ZDBGlobal.isPIIEnabled) ? ZDBUtil.hasClass(piiCheckbox,"ZRSChecked") : false; //No I18N
    var index = gridObj.lookupEl.selectedIndex;
    var isValid = ZDBMetaDataChange.validateLookupcolumn(gridObj,index); 
    if(!isValid)
    {
      ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored, true);
      return;
    }
    var parentObjId = DOMUtils.getParentWithAttr(gridObj.lookupEl[index], "objId").getAttribute("objId");
    var objIdsToDropCache = [parentObjId, gridObj.objId];
    var optType="";
    var fkConstraint="2";  // No action on this (child) table default value is 2
    if($("ZDBLookupCol_EMPTY") || $("ZDBLookupCol_ABORT"))
    {
    	var optEty = $("ZDBLookupCol_EMPTY");
        var optAbt = $("ZDBLookupCol_ABORT");
        var optType = (optEty.checked) ? optEty.value : optAbt.value;
    }
     if($("ZDBConstCascade") || $("ZDBConstSetNull") || $("ZDBNoCascade"))
     {
     	var constCascade = $("ZDBConstCascade");
    var constSetNull = $("ZDBConstSetNull");
    var noCascade = $("ZDBNoCascade");
    var fkConstraint = (constSetNull.checked) ? constSetNull.value : (noCascade.checked) ? noCascade.value : constCascade.value;
     }    
    var xmlData = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n<T FIELDID=\"" + colId + //No I18N
                   "\" FKCONSTRAINT=\"" + fkConstraint + "\" REFERREDCOLUMN=\"" + ZDBEscapeUtil.encodeForXML(gridObj.lookupEl[index].value) + "\"" + //No I18N
                   " PII=\"" + isPii + "\" REFERREDCOLUMNOPT=\"" + optType + "\" ___oper=\"" + ZDBConst.MODIFIED + "\"/></data>"; //No I18N
    var url = CommAPI.DESIGNURL + "&" + gridObj.getGridDetailsAsParams() + "&DATAVIEW="; //No I18N
    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                       OPSTATUSID:"ZDBCNGLOOKUPCOLOPTSTATUS", ONSUCCESSFUNC:ZDBMetaDataChange.handleCreateLookupSuccess, //No I18N
                       ONFAILUREFUNC:ZDBMetaDataChange.handleCreateLookupFailure,
                       VIEWCTX:gridObj.viewCtx, OBJIDSTODROPCACHE : objIdsToDropCache};
    AjaxAPI.sendRequest(ajaxOptions);  
  }

  this.handleCreateLookupFailure = function(response, requestOptions){
    ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored,true);
    AjaxAPI.onFailureFunc(response, requestOptions);
  }


  this.submitEditLookup = function(element,event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var curcolheader = gridObj.selectedCols[0]!==undefined?gridObj.selectedCols[0]:gridObj.getSelectedColHead();
    var refCol = curcolheader.refDispCol;
    var dlgBody = ZDBUtil.getParentWithAttributeValue(element,"elname","dlgBodyDiv"); //No I18N
    var piiCheckbox = dlgBody.querySelector('[id^="isPII"]'); //No I18N
    var isPii = (ZDBGlobal.isPIIEnabled) ? ZDBUtil.hasClass(piiCheckbox,"ZRSChecked") : false; //No I18N
    var selob = document.getElementById('ZDBEditLookupColList');
    var selObj = selob.firstChild;
    var i;
    for (i=0; i<selObj.options.length; i++) {
    var ref = selObj.options[i].value.split(/\./);
    if(curcolheader.lookupType == 14 || !curcolheader.parGrid.disablePhysicalLookup)
    {
        if (("C_"+ref[2])== refCol) {
          selObj.options[i].selected=true;
            }
    }
    }
    
    var txtFld = ZDBUtil.getCachedRef(this,'ZDBEditLookupColName');
    var colId = txtFld.value;
    var index = gridObj.lookupEl.selectedIndex;
    var optType="";
    var fkConstraint="2"; // No action on this (child) table default value is 2
    if($("ZDBLookupColOnEdit_EMPTY") || $("ZDBLookupColOnEdit_ABORT"))
    {
    	var optEty = $("ZDBLookupColOnEdit_EMPTY");
        var optAbt = $("ZDBLookupColOnEdit_ABORT");
        var optType = (optEty.checked) ? optEty.value : optAbt.value;
    }
    if($("ZDBConstCascadeEdit") || $("ZDBConstSetNullEdit") || $("ZDBNoCascadeEdit"))
    {
    	var constCascade = $("ZDBConstCascadeEdit");
        var constSetNull = $("ZDBConstSetNullEdit");
        var noCascade = $("ZDBNoCascadeEdit");
        var fkConstraint = (constSetNull.checked) ? constSetNull.value : (noCascade.checked) ? noCascade.value : constCascade.value;
    }
    var xmlData = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n<T FIELDID=\"" + colId + //No I18N
                   "\" FKCONSTRAINT=\"" + fkConstraint + "\" REFERREDCOLUMN=\"" + ZDBEscapeUtil.encodeForXML(gridObj.lookupEl[index].value) + "\"" + //No I18N
                   " PII=\"" + isPii + "\" REFERREDCOLUMNOPT=\"" + optType + "\" ___oper=\"" + ZDBConst.MODIFIED + "\"/></data>"; //No I18N
    var url = CommAPI.DESIGNURL + "&" + gridObj.getGridDetailsAsParams() + "&DATAVIEW="; //No I18N
    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                       OPSTATUSID:"ZDBEDITCOLOPTSTATUS", ONSUCCESSFUNC:ZDBMetaDataChange.handleSuccess, //No I18N
                       VIEWCTX:gridObj.viewCtx};
    AjaxAPI.sendRequest(ajaxOptions);  
  }
  
  this.showSysTableLookupInfo = function(element,event)
  {
    if(!ZDBLazyLoadUtil.loadSnippet("DATATYPECHANGE_DLG","/ZDBDataTypeChange.cc",this,"APPENDTODOC"))
    {
      return;
    }
    
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var selColHead = gridObj.getSelectedColHead();

    

    if(selColHead == null)
    {
      ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.toolbar.table.changetolookup.errmsg.js.selCol2change"));
      return;
    }
    
    var el = ZDBUtil.getCachedRef(this,"ZDBSysLookupInfo");
    el.style.display = "block";
    
    var txtFld = ZDBUtil.getCachedRef(this,'ZDBSysLookupColName');
    txtFld.innerHTML = selColHead.getDispNameForHtml();
    
    var refTxtFld = ZDBUtil.getCachedRef(this,'ZDBSysLookupRelColName');
    refTxtFld.innerHTML = selColHead.sysRefCol;

    var title = ZDBI18NMap.g("zrpt.common.lookup.js.syslookupinfo.title",el);
    el.gridObj = gridObj;
    
    var opStatus = ZDBUtil.getCachedRef(this,'ZDBEDITCOLOPTSTATUS');
    opStatus.className = "mcLoaded"; 
    
    ZDBUtil.getCachedRef(this,"ZDBShowSysTableInfo").style.display = (element.getAttribute("isSysCol") === 'false') ? 'none': ZDBUtil.visibleTrStyle;
    
    ZDBDialogUtil.showDialog(el,{TITLE:title,ADDFRAME:true,MODAL:true});
  }
  
  this.validateLookupcolumn = function(gridObj,index)
  {
    if(index == 0)
    {
      showCustomMessage(ZDBI18NMap.g('zrpt.toolbar.clmproperities.custommsg.js.selLookUp'), gridObj.lookupEl);
      gridObj.lookupEl.focus();
      return false;
    }
    var src = gridObj.lookupEl[index];
    var subtype = src.getAttribute("subtype");
    var lookupType = src.getAttribute("lookupType");
    if(subtype == "9" || subtype == "22" || lookupType == "14")
    {
      var msg = (subtype == "9" || subtype == "22" ) ? ZDBI18NMap.g("zrpt.common.tbleditdesign.showinfo.js.dateLookUpErr"):(lookupType == "20")?ZDBI18NMap.g("zrpt.common.tbleditdesign.showinfo.js.multiLookUpErr"):ZDBI18NMap.g("zrpt.common.tbleditdesign.showinfo.js.multiLookUpErr");
      showCustomMessage(msg, gridObj.lookupEl);
      gridObj.lookupEl.focus();
      return false;
    }
    return true;
  }
  
  this.removeLookupCol = function(element,event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    if(!ZDBClientUI.checkAskSave(gridObj, ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.saveConfirm2DelCols"),this))
    {
      return;
    }
    var selColHead = gridObj.getSelectedColHead();
    if(selColHead == null || selColHead.lookupType != ZDBConst.REFCOL && selColHead.lookupType != ZDBConst.RELCOL)
    {
      ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.toolbar.table.changetolookup.errmsg.js.selCol2change"));
      return;
    }
    var msg = ZDBI18NMap.f("zrpt.common.zdbalertmsg.js.removelookupcolumn",ZDBEscapeUtil.encodeForHtml(selColHead.displayName));
    ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK:ZDBMetaDataChange.removeLookup,GRIDOBJ:gridObj,COLID:selColHead.colId}); //No I18N
  
  }
  

  this.listChangeEnableDisableSettings = function(event,src)
  {
    var src = src==null ? ZDBUtil.getSourceElement(event) : src;      
    if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js","APPENDTODOC",ZDBMetaDataChange.listChangeEnableDisableSettings,[event,src]))
    {
     	return;
    }    
    jQuery("#PopUpDataTypeChangeSettings").addClass("alpha"); //No I18N
    $("ZDBPopUpTypeChange_DEFAULT").disabled = true;
    $("ZDBPopUpTypeChange_EMPTY").disabled = true;
    $("ZDBPopUpTypeChange_ABORT").disabled = true;
    
    if(!src.selectedIndex)
    {
        return;
    }
    var selType = src[src.selectedIndex].value;
    src.selType = selType;
    var origType = src.origVal;
    hideCustomMessage();
    $("ZDBCDTDateFrmt").style.display = (selType == ZDBConst.DATE || selType == ZDBConst.DATE_AS_DATE) ? "" : "none";
    if(selType == ZDBConst.DATE || selType == ZDBConst.DATE_AS_DATE)
    {
      $("ZDBCDTDateFrmtBox").value = ZDBConst.DEFAULT_DATE_FORMAT;
      $("ZDBCDTDateFrmtSample").value = "(" + ZDBConst.DEFAULT_DATE_FORMAT + ")";
      $("ZDBCDTSampleDateFrmt").value = ZDBImport.getSampleDate(ZDBConst.DEFAULT_DATE_FORMAT);
      var msg = ZDBI18NMap.g('zrpt.common.import.custommsg.js.dtFmtConfirm');
      showCustomMessage(msg, $("ZDBCDTSampleDateFrmt"));
    }
    if(selType == ZDBConst.GEO || selType == ZDBConst.GEO_NUM)
    {
      var georole = src[src.selectedIndex].getAttribute("georole");
      var gridObj =  ZDBUtil.getPropertyFromEl(src, 'gridObj','object');
      var colHead = gridObj.getSelectedColHead(); ///PK: Colhead - non-null
      colHead.extraInfo = colHead.extraInfo || {};
      colHead.extraInfo["GEOR"] = georole;
    }
    if(!ZDBValidator.isLossLess(origType,selType))
    {
      jQuery("#PopUpDataTypeChangeSettings").removeClass("alpha"); //No I18N
      $("ZDBPopUpTypeChange_DEFAULT").disabled = false;
      $("ZDBPopUpTypeChange_EMPTY").disabled = false;
      $("ZDBPopUpTypeChange_ABORT").disabled = false;
    }
  }
this.isRolesame = function(src)
{
    var origRole = src.origGeorole;
    var selGeorole = src[src.selectedIndex].getAttribute("georole");
    return origRole == selGeorole;
}
  this.submitPopUpChangeDatatype = function(element, event)
  {
	var dataTypeDlg = ZDBUtil.getCachedRef(this,"ZDBPopUpDataTypeChangeDlg");
    var src = $("ZDBPopUpDataTypeTD").childNodes[0];
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var colHead = gridObj.getSelectedColHead(); ///PK: Colhead - non-null
    var selType = src[src.selectedIndex].value;
    src.selType = selType;
    src.header = colHead;
    var origType = src.origVal;
    var dtNtchanged = origType == selType ? ((selType == ZDBConst.GEO || selType == ZDBConst.GEO_NUM)  ? this.isRolesame(src) : true) : false;
    if( dtNtchanged && !dataTypeDlg.formatApplied)
    {
      ZDBDialogUtil.closeDialog();
      return;
    }
    if(colHead.formula != null)
    {
      if(!ZDBValidator.formulaColDataTypeChg(origType,selType))
      {
        ZDBMsgBox.showInfo(ZDBI18NMap.g('zrpt.common.datatypechange.showinfo.js.typeMisMatch4FormulaCol'));
        return;
      }
    }
    var dateFormatVal = null;
    if(selType == ZDBConst.DATE || selType == ZDBConst.DATE_AS_DATE)
    {
      var dateFormat = $("ZDBCDTDateFrmtBox");
      dateFormatVal = dateFormat.value;
      colHead.newDateFormat = dateFormatVal;
    }
    if(!ZDBValidator.isLossLess(origType,selType))
    {
      src.dateFormat = dateFormatVal;
      gridObj.submitOptionDlg(src);
    }
    else
    {
      var extraParams = (dataTypeDlg.formatApplied) ? ZDBSheetFormat.constructFormatOptsAsParams(dataTypeDlg.formatColDet) : null;
      ZDBMetaDataChange.changeDataType(colHead,selType,null,extraParams);
      return;
    }
  }
  this.markAsPIIDialog = function(element,event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var selectedCols = gridObj.selectedCols;
    var isPII = (element.getAttribute("isPII") == "true") ? true : false;
    var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
    var dlgEl = ZDBUtil.templateCreator("_piiDialog"); //No I18N
    dlgEl.gridObj = gridObj;
    if(selectedCols.length == 0 && lastFocusCell != null)
    {
      gridObj.addSelectedCol(lastFocusCell.colObj);
      gridObj.setColHighLight(true);
    }
    if(!ZDBMetaDataChange.checkSelCols(gridObj.selectedCols))
    {
      var errmsg = (isPII) ? "zrpt.common.toolbar.table.zdbalertmsg.js.markaspiicolerror" : "zrpt.common.toolbar.table.zdbalertmsg.js.unmarkaspiicolerror"; // No I18N
      ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g(errmsg));
      return;
    }
    if(isPII)
      var msg = (selectedCols.length == 1) ? ZDBI18NMap.f("zrpt.common.toolbar.table.zdbalertmsg.js.markaspiicolconfirm",ZDBEscapeUtil.encodeForHtml(selectedCols[0].displayName))
                                         : ZDBI18NMap.g("zrpt.common.toolbar.table.zdbalertmsg.js.markaspiicolsconfirm");
    else
      var msg = (selectedCols.length == 1) ? ZDBI18NMap.f("zrpt.common.toolbar.table.zdbalertmsg.js.removeaspiicolconfirm",ZDBEscapeUtil.encodeForHtml(selectedCols[0].displayName))
                                         : ZDBI18NMap.g("zrpt.common.toolbar.table.zdbalertmsg.js.removeaspiicolsconfirm");
    var title = ZDBI18NMap.g("zrpt.common.toolbar.table.zdbalertmsg.js.markaspii");
    dlgEl.querySelector("#ZDBMSG").innerText = msg; //No I18N
    ZDBDialogUtil.showDialog(dlgEl,{TITLE:title,HELPDOC:ZDBI18NMap.g("zrpt.links.js.markaspii.helpdoc"),ADDFRAME:true,MODAL:true});
  }
  this.markAsPII = function(element,event)//(clickType, requestOptions)
  {
    ZDBDialogUtil.closeDialog();
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var isPii = !gridObj.selectedCols[0].isPii;
    var selectedCols = [];
    if(gridObj.selectedCols.length > 0)
    {
      selectedCols = gridObj.selectedCols
    }
    else
    {
      selectedCols.push(gridObj.cellObj.colObj);
    }
    var xmlData = ZDBMetaDataChange.genXMLForSelectedCols(selectedCols,"markAsPII",{PII: isPii}); //No I18N
    var url = CommAPI.DESIGNURL+ "" + gridObj.getGridDetailsAsParams()+ "&DATAVIEW=";
    var loadingTxt = (isPii) ? "zrpt.common.toolbar.js.markaspiiCols" : "zrpt.common.toolbar.js.removeaspiiCols"; //No I18N
    var loadDiv = gridObj.viewCtx.getLoadIndicator(ZDBI18NMap.g(loadingTxt));

    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                      OPSTATUSID:loadDiv, ONSUCCESSFUNC:ZDBMetaDataChange.markAsPiiSuccess,
                      ONFAILUREFUNC:ZDBMetaDataChange.deleteColsFailure,
                       VIEWCTX:gridObj.viewCtx,GRIDOBJ:gridObj};
    AjaxAPI.sendRequest(ajaxOptions); 
  }
  this.markAsPiiSuccess = function(response,requestOptions)
  {
    ZDBTableGrid.placeDataSheet(response,requestOptions);
    var gridObj = requestOptions["GRIDOBJ"];
    var isPii = !gridObj.selectedCols[0].isPii;
    for(var i = 0; i < gridObj.selectedCols.length; i++)
    {
      gridObj.selectedCols[i].isPii = isPii;
    }
  }
  this.checkSelCols = function(selCols)
  {
    var count = 0;
    var i = 0;
    while(i < selCols.length)
    {
      if(selCols[i].isPii)
      {
        count++;
      }
      i++;
    }
    if(count == 0 || count == selCols.length)
      return true;
    else 
      return false;
  }
  this.addRemoveAsPiiColumn = function(piiCheckbox, isPii)
  {
    (isPii) ? ZDBUtil.addClass(piiCheckbox,"ZRSChecked") : ZDBUtil.removeClass(piiCheckbox,"ZRSChecked"); //No I18N
  }
  this.setUserFlag = function(el,className)
  {
    var isUserSet = (ZDBUtil.hasClass(el,className)) ? "true" : "false";
    ZDBUtil.setAttribute(el,isUserSet,"isUserSet");
  }
  this.enableDisablePiiCheckBox = function(el,opt)
   {
      var isPiiColumn = false;
      if(opt)
        isPiiColumn = (opt.getAttribute("pii") == "true") ? true : false;
      if(!isPiiColumn)
        ZDBUtil.toggleClass(el,'ZRSChecked');  //No I18N
      ZDBMetaDataChange.setUserFlag(el,'ZRSChecked');  //No I18N
   }
}

ZDBMetaDataChange.loadLookupEl = function(gridObj, typeTd)
  {
    if(ZDBClientUI.lookupEl != null && typeTd.childNodes.length > 0)
    {
      ZDBUtil.removeAllChildren(typeTd);
    }
    typeTd.appendChild(gridObj.lookupEl);
    ZDBClientUI.lookupEl = gridObj.lookupEl;
  }
  
ZDBMetaDataChange.loadLookupCols = function(typeTd, gridObj,selColHead)
  {
    var params = "DBID=" + gridObj.dbId+"&OBJID=" + gridObj.objId;//NO I18N
    AjaxAPI.sendRequest({URL:CommAPI.SHOWFKCOLSURL,PARAMETERS:params,
                         ONSUCCESSFUNC:"ZDBMetaDataChange.showCombo",
                         OBJID:gridObj.objId,GRIDOBJ:gridObj,TYPETD:typeTd,SELECTEDCOL:selColHead});
  }
  

ZDBMetaDataChange.deleteCols = function(clickType, requestOptions)
  {
    if(clickType == "NO")
    {
      return;
    }
    var gridObj= requestOptions["GRIDOBJ"];
    var el = requestOptions["EL"];
    var ev = requestOptions["EV"];
    var skipFC = requestOptions["SKIPFC"];
    var selectedCols = [];
    if(gridObj.selectedCols.length > 0)
    {
      selectedCols = gridObj.selectedCols
    }
    else
    {
      selectedCols.push(gridObj.cellObj.colObj);
    }
    var xmlData = ZDBMetaDataChange.genXMLForSelectedCols(selectedCols,"deleteCols"); //No I18N
    var url = CommAPI.DESIGNURL + "&SKIPFILTERCRITERIACHECK=" + skipFC + gridObj.getGridDetailsAsParams() + "&DATAVIEW="; // No I18N

    var loadDiv = gridObj.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.toolbar.js.delCols"));

    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},
                      OPSTATUSID:loadDiv, ONSUCCESSFUNC:ZDBMetaDataChange.handleSuccessRemCol,
                      ONFAILUREFUNC:ZDBMetaDataChange.deleteColsFailure,
                       VIEWCTX:gridObj.viewCtx,EL:el,EV:ev,GRIDOBJ:gridObj};
    AjaxAPI.sendRequest(ajaxOptions);
  }

  ZDBMetaDataChange.deleteColsFailure = function(response,requestOptions)
  {
    var errCode = response.getResponsePart("ERRORCODE");
    errCode = trimAll(errCode);
    if(errCode == "COLUMN_PRESENT_IN_FILTER_CRITERIA")
    {
      var el = requestOptions["EL"];
      var ev = requestOptions["EV"];
      var gridObj = requestOptions["GRIDOBJ"];
      var msg = ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.deletecolwithfiltercriteria");
      ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK:ZDBMetaDataChange.deleteCols,EL:el,EV:ev,GRIDOBJ:gridObj,SKIPFC:true}); // No I18N
    }
    else
    {
      AjaxAPI.onFailureFunc(response,requestOptions);
    }
  }
  
  ZDBMetaDataChange.genXMLForSelectedCols = function(selectedCols,opType,opValue)
  {
    var xmlData = "";
    for(var i = 0; i < selectedCols.length; i++)
    {
      var header = selectedCols[i];
      if(opType == "deleteCols")
      {
        xmlData = xmlData + "\n" + "<T FIELDID=\"" + header.colId + "\" ___oper=\"" + ZDBConst.DELETED + "\"/>";
      }
      else 
      {
        xmlData = xmlData + "\n" + "<T FIELDID=\"" + header.colId +"\" "; //No I18N
          if(opType == "markAsPII")
          {
            xmlData += " PII=\"" + opValue.PII + "\" "; //No I18N
          }
        xmlData += "___oper=\"" + ZDBConst.MODIFIED + "\"/>"; //No I18N
      }
    }
    xmlData = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>" + xmlData + "\n</data>";
    return xmlData;               
  }
  
  ZDBMetaDataChange.changeDataType = function(header, destType, option,extraParams)
  {
    var gridObj =  header.parGrid;
    var xmlData = ZDBMetaDataChange.genXMLForDataTypeChg(header, destType, option);
    var url = CommAPI.DESIGNURL + "&" + gridObj.getGridDetailsAsParams() + "&DATAVIEW=";
    var dateFormat = header.newDateFormat;
    if(dateFormat && dateFormat != "")
    {
      url = url +"&DATEFORMAT=" + dateFormat;
    }
    if(extraParams)
    {
      url+=extraParams;
    }
    var objIdsToDropCache = [gridObj.objId];

     url = url + "&dataTypechange=" +'changeDataType'; //No I18N
    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},
                       OPSTATUSID:gridObj.viewCtx.getLoadIndicator(), 
                       ONSUCCESSFUNC:ZDBMetaDataChange.handleSuccess,
                       ONFAILUREFUNC:ZDBMetaDataChange.handleFailure,
                       COLHEADER:header,DESTTYPE:destType,OPTION:option,
                       VIEWCTX:gridObj.viewCtx, OBJIDSTODROPCACHE:objIdsToDropCache};
    AjaxAPI.sendRequest(ajaxOptions);
  }
  
ZDBMetaDataChange.handleSuccess = function(response,requestOptions)
{
    ZDBDialogUtil.closeDialog();
    ZDBClientUI.clearCache();
    ZDBTableGrid.placeDataSheet(response,requestOptions);
    var resp = JSON.parse(response.responseText);
    if(resp.refErrors){//On error, we have to stop processing. Here failure was sent as success message. This should be handled properly.
    	return;
    }
    var objIds = requestOptions["OBJIDSTODROPCACHE"];
    if(objIds)
    {
	    for(var i=0; i<objIds.length && objIds; i++)
	    {
	    	ZDBClientUtil.deleteJsonForObjId(objIds[i]);
	    }
    }
    ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.common.datatypechange.showinfo.js.success"));
}

ZDBMetaDataChange.handleSuccessRemCol = function(response,requestOptions)
{
	ZDBTableGrid.placeDataSheet(response,requestOptions);
	var objId = requestOptions["VIEWCTX"].tab.view.objId;
	ZDBClientUtil.deleteJsonForObjId(objId);
}

ZDBMetaDataChange.handleCreateLookupSuccess = function(response,requestOptions)
{
    ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.common.lookup.js.lookupsuccess"));
    ZDBMetaDataChange.handleSuccess(response,requestOptions);
}
  
ZDBMetaDataChange.handleFailure = function(response, requestOptions)
{
  var formulaEl = requestOptions["PAREL"];
  var errCode = response.getResponsePart("ERRORCODE");
  errCode = trimAll(errCode);
  if(formulaEl && (errCode == "DERIVED_FIELD_FORMULA_PARSE_ERROR" ||
     errCode == "DERIVED_FIELD_UNKNOWN_FUNCTION" ||
     errCode == "DERIVED_FIELD_INVALID_FORMULA" ||  //No I18N
     errCode == "FORMULA_INVOLVES_CIRCULAR_DEPENDENCY" ||  //No I18N
     errCode == "DERIVED_FIELD_CONVERT_NOT_SUPP" ||        //No I18N
     errCode == "DERIVED_FIELD_CONVERT_TO_DATE_ERROR" ||   //No I18N
     errCode == "DERIVED_FIELD_STR_TO_DATE_INVALID_FORMAT")) //No I18N
  {
      showCustomMessage(response.getResponsePart("STATUS_MESSAGE"),formulaEl,null);
      ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored,true);
      formulaEl.focus();
      return;
  }
  else if(errCode == "DRILLDOWN_CHANGEDATATYPE_NOTALLOWED")
  {
    var msg = ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.dtchangenotallowed");
    var colHeader = requestOptions["COLHEADER"];
    var destType = requestOptions["DESTTYPE"];
    var option = requestOptions["OPTION"];
    ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK:ZDBMetaDataChange.continueSendDTypeChange,COLHEADER:colHeader,DESTTYPE:destType,OPTION:option}); // No I18N
    return;
  }
  else if(errCode=="ZR_FORMULA_ASSC_CHILD_ERROR")
      {
         var params = requestOptions["PARAMETERS"]; 
         var gridObj= requestOptions["GRIDOBJ"]; 
         var parel=requestOptions["PAREL"]; 
         var opStatusID=requestOptions["OPSTATUSID"];
         var innerHtml = ZDBEscapeUtil.decodeForHtml(response.getResponsePart("STATUS_MESSAGE"));
         ZDBAlertAPI.showMsg(innerHtml,"ZDBYESNO",{ONCLICK:ZDBDerivedField.adDerivedFieldFnInChildTable,GRIDOBJ:gridObj,PARAMETERS:params,PAREL:parel,OPSTATUSID:opStatusID}); // No I18N
         return;
      }
      else if(errCode=="INCOMPATIBLE_LOOKUP_ON_DATATYPE_CONVERSION")
      {
         ZDBAlertAPI.showMsg(ZDBEscapeUtil.decodeForHtml(response.getResponsePart("STATUS_MESSAGE")));
         return;
      }
  ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored,true);
  AjaxAPI.onFailureFunc(response, requestOptions);
}
ZDBMetaDataChange.continueSendDTypeChange = function(clickType, requestOptions)
  {
    if(clickType == "NO")
    {
      // ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored,true);
      return;
    }
    var colHeader = requestOptions["COLHEADER"];
    var destType = requestOptions["DESTTYPE"];
    var option = requestOptions["OPTION"];
    var extraParams ="&DELETE_INVALID_DRILLFLOW="+"true"; //NO I18N
    ZDBMetaDataChange.changeDataType(colHeader,destType,option,extraParams);
  }
  
ZDBMetaDataChange.loadDataTypeList = function(typeTd,dlgType)
  {
    var dataTypeEl = document.getElementById('DATATYPE').cloneNode(true);
    dataTypeEl.removeAttribute("id");
    dataTypeEl.removeAttribute("name");
    dataTypeEl.style.display = "block";
    dataTypeEl.onkeydown = null;
    dataTypeEl.onkeypress = null;
    dataTypeEl.onchange = null;
    dataTypeEl.onblur = null;
    var nodeList = dataTypeEl.getElementsByTagName("option");
    for(var i = nodeList.length - 1; i >= 0; i--)
    {
      var node = nodeList.item(i);
      var type = node.getAttribute("type");
      var value = node.getAttribute("value");
      if(type != null)
      {
        if(type == 'lookup' || (dlgType == 1 && type == 'autonumber'))
        {
          node.parentNode.removeChild(node);
        }
      }
      if(ZDBClientUI.isRemoteDB && (dlgType == 1) && (value == '7' || value == '8'))
      {
        node.parentNode.removeChild(node);
      }
    }
    if(dlgType == 1)
    {
      var grpNode = dataTypeEl.getElementsByTagName("optgroup");
      for(i = grpNode.length - 1; i >= 0; i--)
      {
        var node = grpNode[i];
        var type = node.getAttribute('type');
        if(type != null &&(type == 'text' || type == 'others' || type == 'geo'))
        {
          node.parentNode.removeChild(node);
        }
      }
    }
    typeTd.appendChild(dataTypeEl);
    if(dataTypeEl)
    {
    	dataTypeEl.style.width = "250px";      
    }

    switch(dlgType)
    {
      case 0: //Datatype change dialog - right click popup menu
      {
        dataTypeEl.id ="ZDBDataTypeSelect_Dlg";
        return dataTypeEl;
      }
      case 1: //Formula column dialog
      {
        dataTypeEl.id ="ZDBDataTypeSelect_formula";
        dataTypeEl.style.width = '165px';
        dataTypeEl.onchange = ZRFormulaColumn.resetColFormatsOnDTChange;
        return dataTypeEl;
      }
      case 2: // Add column dialog
      {
       //$$ Need to return the dataTypeEl and use in the place, no need to have the reference
        ZDBClientUI.dataTypeEl = dataTypeEl;
        ZDBClientUI.dataTypeEl.setAttribute("qaid","ZDBDataTypeSelect_AddDlg");
        ZDBClientUI.dataTypeEl.id = "ZDBDataTypeSelect_AddDlg";
        ZDBClientUI.dataTypeEl.onchange = ZDBGridOper.onDataTypeChangeFormatOpts;
      }
    }
  }

ZDBMetaDataChange.deleteColumns = function(element, event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    var selectedCols = gridObj.selectedCols;
    var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
    if(selectedCols.length == 0 && lastFocusCell != null)
    {
      gridObj.addSelectedCol(lastFocusCell.colObj);
      gridObj.setColHighLight(true);
    }
    if(!ZDBClientUI.checkAskSave(gridObj, ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.saveConfirm2DelCols"),this))
    {
      return;
    }
    if(selectedCols.length == 0 && gridObj.curCellPos == null)
    {
      ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.common.toolbar.errmsg.js.selCol2DelCol"));
      return false;
    }
    var msg = (selectedCols.length == 1) ? ZDBI18NMap.f("zrpt.common.toolbar.table.zdbalertmsg.js.delColConfirm",ZDBEscapeUtil.encodeForHtml(selectedCols[0].displayName))
                                         : ZDBI18NMap.g("zrpt.common.toolbar.table.zdbalertmsg.js.delColsConfirm");
        
    ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK:ZDBMetaDataChange.deleteCols,GRIDOBJ:gridObj,EL:element,EV:event,SKIPFC:false});  // No I18N
  }
  
ZDBMetaDataChange.showCombo = function(response, requestOptions)
  {
    var objId = requestOptions["OBJID"];
    var div = document.createElement("div");
    div.innerHTML = response.getOnlyHtml();
    var lookupEl = div.childNodes[0].cloneNode(true);
    var nodeList = lookupEl.getElementsByTagName("optgroup");
    var length = nodeList.length;
    var toRemove;
    for(var i=0 ; i<length; i++)
    {
      var grpNode = nodeList.item(i);
      var curObjId = grpNode.getAttribute("objId");
      if(curObjId == objId)
      {
        toRemove = grpNode;
      }
    }
    if(toRemove != null && toRemove != undefined)
    {
      lookupEl.removeChild(toRemove);
    }
    lookupEl.style.width = "250px";
    lookupEl.setAttribute("id","FKCol");
    lookupEl.setAttribute("onChange","ZDBMetaDataChange.appendPtable(this)");
    lookupEl.setAttribute("onClick","ZDBMetaDataChange.resetTexttoOrig(this)");
     
    
    var gridObj= requestOptions["GRIDOBJ"];
    var typeTd = requestOptions["TYPETD"];
    var selColHead = requestOptions["SELECTEDCOL"];
    gridObj.lookupEl = lookupEl;
    ZDBMetaDataChange.loadLookupEl(gridObj, typeTd);
    if(typeTd.id == "ZDBEditLookupColList")
    {
    var el = ZDBUtil.getCachedRef(this,"ZDBEditLookupDlg");
    if(selColHead.lookupType == ZDBConst.REFCOL || selColHead.parGrid.disablePhysicalLookup != true)
    {
    ZDBUtil.getCachedRef(el,"ZDBEditLookupParentInfo").style.display="none";
    ZDBUtil.getCachedRef(el,"ZDBEditLookupParentColInfo").style.display="block"; 
    var parentFld = ZDBUtil.getCachedRef(this,'ZDBEditLookupParentColName');
    parentFld.innerHTML = selColHead.sysRefCol;
    parentFld.value = selColHead.sysRefCol;
    }
    else
    {
    ZDBUtil.getCachedRef(el,"ZDBEditLookupParentColInfo").style.display="none"; 
    ZDBUtil.getCachedRef(el,"ZDBEditLookupParentInfo").style.display="table-row"; 
    var parentTable = selColHead.sysRefCol.split('.')[0];
    while(parentTable.indexOf('&nbsp;') > -1)
                        {
                          parentTable = parentTable.replace('&nbsp;',' ');
                        }
    var opt = jQuery("#FKCol").find("optgroup[label='"+ZDBEscapeUtil.decodeForHtml(parentTable)+"']").find("option");//NO I18N
	    	 for(var i=0; i<opt.length; i++)
	    	 {
                     var colName = selColHead.sysRefCol.split('\.')[1];
                        while(colName.indexOf('&nbsp;') > -1)
                        {
                          colName = colName.replace('&nbsp;',' ');
                        }     
                        colName=ZDBEscapeUtil.decodeForHtml(colName);
	    		 if(opt[i].textContent == colName){
	    			  jQuery("#FKCol")[0].selectedIndex = opt[i].index;
              if(ZDBGlobal.isPIIEnabled)
              {
                var isPii = (opt[i].getAttribute("pii") == "true") ? true : false;
                var piiCheckbox = ZDBUtil.getCachedRef(el,"isPII_EdtLkp");
                ZDBMetaDataChange.addRemoveAsPiiColumn(piiCheckbox, isPii);
              }
	    		 }
	    	 }
    }
    }
  }
  ZDBMetaDataChange.appendPtable=function(el)
  {
      ZDBMetaDataChange.resetTexttoOrig(el);
      var opt = el.options[el.selectedIndex];
      var optGroup = opt.parentNode;
      var optGroupLabel = optGroup.getAttribute("label");
      var objType = optGroup.getAttribute("objIdtype");
      var viewType = ZDBClientUI.selectedTab.view.type;
      var colObj = ZDBClientUI.selectedTab.view.getSelectedColHead();
      if(objType==6 || viewType==="QueryTable") //For query tables
      {
	$("ZDBConstCascade").disabled=true;
        $("ZDBConstSetNull").disabled=true;
        $("ZDBNoCascade").checked =true;
        $("ZDBLookupCol_EMPTY").disabled=true;
        $("ZDBLookupCol_ABORT").disabled=true;
      }
      else
      {
    	if($("ZDBConstCascade"))
    	{
    		$("ZDBConstCascade").disabled=false;
    	}
    	if($("ZDBConstSetNull"))
    	{
    		$("ZDBConstSetNull").disabled=false;
    	}
      }
      if(ZDBGlobal.isPIIEnabled)
      {
        var dlgBody = ZDBUtil.getParentWithAttributeValue(el,"elname","dlgBodyDiv"); //No I18N
        var piiCheckbox = dlgBody.querySelector('[id^="isPII"]'); //No I18N
        if(piiCheckbox.getAttribute("isUserSet") == "false")
        {
          var isPii = (opt.getAttribute("pii") == "true") ? true : false;
          ZDBMetaDataChange.enableDisablePiiCheckBox(piiCheckbox,opt);
          ZDBMetaDataChange.addRemoveAsPiiColumn(piiCheckbox, isPii);
        }
      }
      var optionText = opt.text;
      opt.originalText = optionText;
      var timer = setTimeout(function(){
          if(el.optQueue===null || el.optQueue===undefined){el.optQueue=new Array();}
          el.optQueue.push(opt);
          if(optionText!=="-- NONE --")
          {opt.text = optGroupLabel + "." + optionText;}
      },50);
      
   }
   ZDBMetaDataChange.resetTexttoOrig=function(el)
   {
     if(el===null || el.optQueue===null || el===undefined || el.optQueue === undefined){return;}
     while(el.optQueue.length>0)
     {
        var opt = el.optQueue[el.optQueue.length - 1];
        opt.text = (opt.originalText!==null)?opt.originalText:opt.text;
        el.optQueue.pop();
     }
        
    }
ZDBMetaDataChange.genXMLForDataTypeChg = function(header, destType, option)
{
    var optionStr = "";
    if(option)
    {
      optionStr = "DATATYPEOPT=\"" + option.toUpperCase() + "\"";
    }
    var xmlData = "<T FIELDID=\"" + header.colId + "\" DATATYPE=\"" + destType + "\"" +
                  " " + optionStr + " ___oper=\"" + ZDBConst.MODIFIED + "\" ";
    if(destType == ZDBConst.GEO || destType == ZDBConst.GEO_NUM)
    {
         xmlData +="GEOROLE=\""+header.extraInfo["GEOR"]+"\""; //No I18N
    }
    xmlData += " />";
    xmlData = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n" + xmlData + "\n</data>";
    return xmlData;
}

ZDBMetaDataChange.removeLookup = function(clickType, requestOptions)
  {
    if(clickType == "NO")
    {
      return;
    }
    var gridObj= requestOptions["GRIDOBJ"];
    var objIdsToDropCache = [gridObj.objId];
    var colId= requestOptions["COLID"];    
    var xmlData = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n<T FIELDID=\"" + colId + //No I18N
                   "\" REFERREDCOLUMN=\"" + //No I18N
                   "\" ___oper=\"" + ZDBConst.MODIFIED + "\"/></data>"; //No I18N
    var url = CommAPI.DESIGNURL + "&" + gridObj.getGridDetailsAsParams() + "&DATAVIEW="; //No I18N
    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                       OPSTATUSID:"ZDBCNGLOOKUPCOLOPTSTATUS", ONSUCCESSFUNC:ZDBMetaDataChange.handleSuccess, //No I18N
                       VIEWCTX:gridObj.viewCtx, OBJIDSTODROPCACHE:objIdsToDropCache};
    AjaxAPI.sendRequest(ajaxOptions);
  }

