/*$Id$*/
var SharingModule_Model = {
    permissions: [{
            permHead: 'checkAllRead', // No I18N
            permTitle: 'zrpt.explorer.share.shareview.js.readopts', // No I18N
            perms: [{
                    id: 'readAccess', // No I18N
                    title: 'zrpt.explorer.share.shareview.js.readaccess', // No I18N
                    checked: 'checked', // No I18N
                    disabled: 'disabled', // No I18N
                    name: 'read' // No I18N
                    // extraOpts: {
                    //     name: 'zrpt.share.esd.js.vud_change_cols', // No I18N
                    //     action: 'showColumns' // No I18N
                    // }
                },
                { id: 'exportData', title: 'zrpt.explorer.share.shareview.js.exportdata', name: 'export' }, // No I18N
                {
                    id: 'vud', // No I18N
                    title: 'zrpt.explorer.share.shareview.js.vud', // No I18N
                    name: 'vud', // No I18N
                    extraOpts: {
                        name: 'zrpt.share.esd.js.vud_change_cols', // No I18N
                        action: 'showVUD' // No I18N
                    }
                },
                {
                    id: 'drilldown', // No I18N
                    title: 'zrpt.explorer.share.shareview.js.dd', // No I18N
                    name: 'drillDown', // No I18N
                    extraOpts: {
                        name: 'zr.share.js.change_drill', // No I18N
                        action: 'showDrillDown' // No I18N
                    }
                }
            ]
        },
        {
            permHead: 'checkAllWrite', // No I18N
            permTitle: 'zrpt.explorer.share.shareview.js.writeopts', // No I18N
            perms: [
                { id: 'addRow', title: 'zrpt.explorer.share.shareview.js.addrow', name: 'addRow' }, // No I18N
                { id: 'modifyRow', title: 'zrpt.explorer.share.shareview.js.modrow', name: 'modifyRow' }, // No I18N
                { id: 'deleteRow', title: 'zrpt.explorer.share.shareview.js.delrow', name: 'deleteRow' }, // No I18N
                { id: 'deleteAll', title: 'zrpt.explorer.share.shareview.js.delall', name: 'deleteAll' } // No I18N
            ],
        },
        {
            permHead: 'checkAllImport', // No I18N
            permTitle: 'zrpt.explorer.share.shareview.js.impopts', // No I18N
            perms: [
                { id: 'onlyAppend', title: 'zrpt.explorer.share.shareview.js.onlyappendrows', name: 'appendRows' }, // No I18N
                { id: 'deleteAllAndAddNew', title: 'zrpt.explorer.share.shareview.js.delallrows', name: 'deleteAndAdd' }, // No I18N
                { id: 'addUpdate', title: 'zrpt.explorer.share.shareview.js.addorupdate', name: 'addUpdate' }, // No I18N
                { id: 'addNewReplaceExisting', title: 'zrpt.explorer.share.shareview.js.addnewreplace', name: 'addReplaceDelete' } // No I18N
            ],
        },
        {
            permHead: 'checkAllShare', // No I18N
            permTitle: 'zrpt.explorer.share.shareview.js.shareopts', // No I18N
            perms: [
                { id: 'shareView', title: 'zrpt.explorer.share.shareview.js.shareviewperm', name: 'shareView' } // No I18N
            ]
        }
    ],
    shareParams: {
        dbId: '',
        objIds: [],
        sharedColumnIds: [],
        users: [
            { zaid: '-1', emailIds: [] }
        ],
        groupIds: [],
        permissions: {
            // Read Options
            read: true,
            export: false,
            vud: false,
            colsModified: false,
            drillDown: false,

            // Write Options
            addRow: false,
            modifyRow: false,
            deleteRow: false,
            deleteAll: false,

            // Import Options
            appendRows: false,
            deleteAndAdd: false,
            addUpdate: false,
            addReplaceDelete: false,

            // Share Options
            shareView: false
        },
        filterCriteria: '',
        inheritParentCriteria: false,
        drillTypeIndex: 4,
        defVudCols: [],
        defDrillCols: []
            /*
            sendMail: false,
            sendCopy: false,
            mailSubject: '',
            mailMessage: ''
            */
    },
    updateViewPermParams: {
        objId: '',
        users: [
            { zaid: '-1', emailIds: [] }
        ],
        groupIds: [],
        permissions: {},
        drillTypeIndex: 4,
        filterCriteria: '',
        inheritParentCriteria: false,
        defVudCols: [],
        defDrillCols: [],
        sharedColumnIds: []
    },
    removeParams: {
        objId: '',
        users: [
            { zaid: '-1', emailIds: [] }
        ],
        groupIds: []
    },
    defaultPerms: {
        // Read Options
        read: true,
        export: false,
        vud: false,
        colsModified: false,
        drillDown: false,

        // Write Options
        addRow: false,
        modifyRow: false,
        deleteRow: false,
        deleteAll: false,

        // Import Options
        appendRows: false,
        deleteAndAdd: false,
        addUpdate: false,
        addReplaceDelete: false,

        // Share Options
        shareView: false,

        colsModified: false
    }
};

ZRSHTMLTemplateStrings['__shareBody1__sharingmodule__model'] = SharingModule_Model.shareBody1;
ZRSHTMLTemplateStrings['__shareFooter1__sharingmodule__model'] = SharingModule_Model.shareFooter1;
ZRSHTMLTemplateStrings['__permContainer__sharingmodule__model'] = SharingModule_Model.permContainer;
ZRSHTMLTemplateStrings['__permTemplate__sharingmodule__model'] = SharingModule_Model.permTemplate;
ZRSHTMLTemplateStrings['__existingSharedDetails__sharingmodule__model'] = SharingModule_Model.existingSharedDetails;
ZRSHTMLTemplateStrings['__editPermDialog__sharingmodule__model'] = SharingModule_Model.editPermDialog;