// $Id$ 
var ZRSHeader_Model = {
    homepage : {
        headerClass : "ZRHeader topbar-colors",      //NO I18N
        domainURL: ZDBGlobal.DOMAINURL,
        domainLogo: (!ZDBGlobal.isLogoRebrand && ZDBGlobal.currentTheme.indexOf("theme2")>=0) ? ZDBGlobal.domainLogoWhite : ZDBGlobal.DOMAINLOGO,
        headerZApps: ZDBGlobal.HEADERZAPPS,
        homeLinkCond: {
            condition: ZDBGlobal.LANDINGPAGE !== 'ZDBHome' && ZDBGlobal.ENABLEHOMELINK, //NO I18N
            data:{
                homeLink: ZDBGlobal.REPORTS_CONTEXT_NAME + ZDBGlobal.CONTEXTPATH + '/ZDBHome.cc?home=true',     //NO I18N
                homeLinkTip: ZDBGlobal.DOMAINHEADERHME
            }
        },
        databaseListCond: {
            condition: ZDBGlobal.LANDINGPAGE !== 'ZDBHome' && !ZDBGlobal.ISPUBLICUSER && ZDBClientUI.dbName, //NO I18N
            data: {
                dbName: ZDBClientUI.dbName,
                dbDesc: ZDBClientUI.dbDesc,
                cpDBItem: ZDBGlobal.CPDBITEM,
                showCopyDBLink: ZDBGlobal.ENABLECOPYDBLINK,
                showAdminTakeOverLink: ZDBGlobal.ENABLEADMINTAKEOVERLINK,
                adminTakeOverLink: ZDBGlobal.ADMINTAKEOVERLINK,
                dbListSearchText: ZDBI18NMap.g("zrpt.home.js.dbsearch")
            }
        },
        databaseListOnly: {
            condition: ZDBGlobal.LANDINGPAGE !== 'ZDBHome' && ZDBGlobal.ISPUBLICUSER && ZDBClientUI.dbName, //NO I18N
            data: {
                dbName: ZDBClientUI.dbName,
                dbDesc: ZDBClientUI.dbDesc,
            }
        },
        tryOtherEdition: {
            condition: ZDBGlobal.ENABLESUBSCRIPTIONLLINK && !ZDBClientUI.readOnlyMode && !ZDBGlobal.ISPUBLICUSER && ZDBGlobal.ISTRIALALLOWED,
            data: {
                text: ZDBI18NMap.g("zrpt.topbar.js.tryothereditions")
            }
        },
        storeDets:{
            condition: ZDBGlobal.ENABLESUBSCRIPTIONLLINK && !ZDBClientUI.readOnlyMode && !ZDBGlobal.ISPUBLICUSER && !ZDBGlobal.ISCRMULTIMATEUSER,
            data: {
                text: ZDBGlobal.SUBSCRIPTIONTEXT
            }
        },
        userDets:{
            condition: ZDBGlobal.ENABLESUBSCRIPTIONLLINK && !ZDBClientUI.readOnlyMode && !ZDBGlobal.ISPUBLICUSER,
            data: {
                settingsText: ZDBI18NMap.g('zrpt.common.import.moreorless.js.Settings')
            }
        },
        notification:{
            condition: !ZDBClientUI.readOnlyMode && !ZDBGlobal.ISPUBLICUSER,
            data:{
                notificationText: ZDBI18NMap.g('zr.notification.js.title')
            }
        },
        helpLink:{
            condition: ZDBGlobal.ENABLEHELPLINK,
            data:{
                helpText: ZDBI18NMap.g('zrpt.common.js.help')
            }
        },
        notSignedIn:{
            condition: ZDBGlobal.ISPUBLICUSER,
            data: {
                link: ZDBGlobal.REPORTS_CONTEXT_NAME + ZDBGlobal.CONTEXTPATH + '/login/login.jsp?serviceurl=' + (ZDBGlobal.LANDINGPAGE ? '/ZDBHome.cc': '/ZDBDataSheetView.cc?DBID=' + ZDBGlobal.DBID),     //NO I18N
                text: ZDBGlobal.HEADERSIGNINTEXT
            }
        },
        signedIn:{
            condition: !ZDBGlobal.ISPUBLICUSER,
            data: {
                photoURL: ZDBGlobal.CONTACTSSERVERURL + '/file?t=user&ID='+ ZDBGlobal.zuID +'&fs=thumb'     //NO I18N
            }
        }
    },
    
    //ignorei18n_start
    zohoapps : {
        marketing: ZDBI18NMap.g('zrpt.topbar.appgroup.js.sales'),
        help: ZDBI18NMap.g('zrpt.topbar.appgroup.js.helpdesk'),
        business: ZDBI18NMap.g('zrpt.topbar.appgroup.js.business'),
        financeTitle: ZDBI18NMap.g('zrpt.topbar.appgroup.js.finance'),
        email: ZDBI18NMap.g('zrpt.topbar.appgroup.js.collaboration'),
        hrTitle: ZDBI18NMap.g('zrpt.topbar.appgroup.js.hr'),
        salesNMarketing: [
            {
                link: 'https://crm.zoho.' + ZDBGlobal.ZAPPSTLD + '/crm/ShowHomePage.do',
                appText: 'CRM',
                appIcon: 'ZAppIcon ZAppIcon-crm'
            },
            {
                link: 'https://pagesense.zoho.' + ZDBGlobal.ZAPPSTLD,
                appText: 'PageSense',
                appIcon: 'ZAppIcon ZAppIcon-pagesense'
            },
            {
                link: 'https://forms.zoho.' + ZDBGlobal.ZAPPSTLD + '?src=topbar',
                appText: 'Forms',
                appIcon: 'ZAppIcon ZAppIcon-forms'
            },
            {
                link: 'https://sign.zoho.' + ZDBGlobal.ZAPPSTLD,
                appText: 'Sign',
                appIcon: 'ZAppIcon ZAppIcon-sign'
            },
            {
                link: 'https://social.zoho.' + ZDBGlobal.ZAPPSTLD + '/index.do',
                appText: 'Social',
                appIcon: 'ZAppIcon ZAppIcon-social'
            },
            {
                link: 'https://salesiq.zoho.' + ZDBGlobal.ZAPPSTLD + '/home.do',
                appText: 'SalesIQ',
                appIcon: 'ZAppIcon ZAppIcon-salesiq'
            },
            {
                link: 'https://survey.zoho.' + ZDBGlobal.ZAPPSTLD + '/home.do',
                appText: 'Survey',
                appIcon: 'ZAppIcon ZAppIcon-survey'
            },
            {
                link: 'https://campaigns.zoho.' + ZDBGlobal.ZAPPSTLD + '/start.do',
                appText: 'Campaigns',
                appIcon: 'ZAppIcon ZAppIcon-campaigns'
            },
            {
                link: 'https://sites.zoho.' + ZDBGlobal.ZAPPSTLD + '/index',
                appText: 'Sites',
                appIcon: 'ZAppIcon ZAppIcon-sites'
            },
            {
                link: 'https://cm.zoho.' + ZDBGlobal.ZAPPSTLD + '/index.do?src=topbar',
                appText: 'ContactManager',
                appIcon: 'ZAppIcon ZAppIcon-contactmanager'
            },
            {
                link: 'https://motivator.zoho.' + ZDBGlobal.ZAPPSTLD + '/index.html',
                appText: 'Motivator',
                appIcon: 'ZAppIcon ZAppIcon-motivator'
            }
        ],
        helpDesk: [
            {
                link: 'https://support.zoho.' + ZDBGlobal.ZAPPSTLD + '/support/ShowHomePage.do',
                appText: 'Desk',
                appIcon: 'ZAppIcon ZAppIcon-desk'
            },
            {
                link: 'https://assist.zoho.' + ZDBGlobal.ZAPPSTLD,
                appText: 'Assist',
                appIcon: 'ZAppIcon ZAppIcon-assist'
            },
            {
                link: 'https://www.site24x7.' + ZDBGlobal.ZAPPSTLD + '?src=topbar',
                appText: 'Site24x7',
                appIcon: 'ZAppIcon ZAppIcon-site24x7'
            }
        ],
        businessProcess: [
            {
                link: 'https://reports.zoho.' + ZDBGlobal.ZAPPSTLD + '/ZDBHome.cc',
                appText: 'Reports',
                appIcon: 'ZAppIcon ZAppIcon-reports'
            },
            {
                link: 'https://creator.zoho.' + ZDBGlobal.ZAPPSTLD + '/userhome/dashboard',
                appText: 'Creator',
                appIcon: 'ZAppIcon ZAppIcon-creator'
            },
            {
                link: 'https://flow.zoho.' + ZDBGlobal.ZAPPSTLD,
                appText: 'Flow',
                appIcon: 'ZAppIcon ZAppIcon-flow'
            }
        ],
        finance: [
            {
                link: 'https://books.zoho.' + ZDBGlobal.ZAPPSTLD + '/Home.jsp',
                appText: 'Books',
                appIcon: 'ZAppIcon ZAppIcon-books'
            },
            {
                link: 'https://inventory.zoho.' + ZDBGlobal.ZAPPSTLD + '/home',
                appText: 'Inventory',
                appIcon: 'ZAppIcon ZAppIcon-inventory'
            },
            {
                link: 'https://invoice.zoho.' + ZDBGlobal.ZAPPSTLD + '/Home.jsp',
                appText: 'Invoice',
                appIcon: 'ZAppIcon ZAppIcon-invoice'
            },
            {
                link: 'https://subscriptions.zoho.' + ZDBGlobal.ZAPPSTLD + '/home',
                appText: 'Subscriptions',
                appIcon: 'ZAppIcon ZAppIcon-subscriptions'
            },
            {
                link: 'https://expense.zoho.' + ZDBGlobal.ZAPPSTLD + '/home',
                appText: 'Expense',
                appIcon: 'ZAppIcon ZAppIcon-expense'
            }
        ],
        emailNCollaboration: [
            {
                link: 'https://mail.zoho.' + ZDBGlobal.ZAPPSTLD + '/biz/index.do',
                appText: 'Mail',
                appIcon: 'ZAppIcon ZAppIcon-mail'
            },
            {
                link: 'https://cliq.zoho.' + ZDBGlobal.ZAPPSTLD + '/index.do',
                appText: 'Cliq',
                appIcon: 'ZAppIcon ZAppIcon-cliq'
            },
            {
                link: 'https://docs.zoho.' + ZDBGlobal.ZAPPSTLD + '/index.do',
                appText: 'Docs',
                appIcon: 'ZAppIcon ZAppIcon-docs'
            },
            {
                link: 'https://projects.zoho.' + ZDBGlobal.ZAPPSTLD + '/portals.do',
                appText: 'Projects',
                appIcon: 'ZAppIcon ZAppIcon-projects'
            },
            {
                link: 'https://sprints.zoho.' + ZDBGlobal.ZAPPSTLD,
                appText: 'Sprints',
                appIcon: 'ZAppIcon ZAppIcon-sprints'
            },
            {
                link: 'https://bugtracker.zoho.' + ZDBGlobal.ZAPPSTLD + '/portals.do',
                appText: 'BugTracker',
                appIcon: 'ZAppIcon ZAppIcon-bugtracker'
            },
            {
                link: 'https://connect.zoho.' + ZDBGlobal.ZAPPSTLD + '/',
                appText: 'Connect',
                appIcon: 'ZAppIcon ZAppIcon-connect'
            },
            {
                link: 'https://meeting.zoho.' + ZDBGlobal.ZAPPSTLD + '/meeting',
                appText: 'Meeting',
                appIcon: 'ZAppIcon ZAppIcon-meeting'
            },
            {
                link: 'https://vault.zoho.' + ZDBGlobal.ZAPPSTLD + '/online/main',
                appText: 'Vault',
                appIcon: 'ZAppIcon ZAppIcon-vault'
            },
            {
                link: 'https://showtime.zoho.' + ZDBGlobal.ZAPPSTLD + '/',
                appText: 'ShowTime',
                appIcon: 'ZAppIcon ZAppIcon-showtime'
            },
            {
                link: 'https://notebook.zoho.' + ZDBGlobal.ZAPPSTLD,
                appText: 'Notebook',
                appIcon: 'ZAppIcon ZAppIcon-notebook'
            }
        ],
        hr: [
            {
                link: 'https://recruit.zoho.' + ZDBGlobal.ZAPPSTLD + '/ats/Dashboard.do',
                appText: 'Recruit',
                appIcon: 'ZAppIcon ZAppIcon-recruit'
            },
            {
                link: 'https://people.zoho.' + ZDBGlobal.ZAPPSTLD + '/people',
                appText: 'People',
                appIcon: 'ZAppIcon ZAppIcon-people'
            },
        ]
        //ignorei18n_end
    },
    
    tryotherplans: {
        header: ZDBI18NMap.g('zrpt.topbar.js.tryothereditions'),
        compareEditionText: ZDBI18NMap.g('zrpt.topbar.js.compare_editions'),
        upgradeLink: ZDBGlobal.upgradeLink,
        upgradeText: ZDBI18NMap.g('zrpt.pricing.currentplan.js.upgrade'),
        plans :[
            {
                planName: ZDBI18NMap.g('zrpt.topbar.js.standard_edition'),
                planID: '7203',
                tryNowText: ZDBI18NMap.g('zrpt.topbar.js.trynow')
            },
            {
                planName: ZDBI18NMap.g('zrpt.topbar.js.prof_edition'),
                planID: '7204',
                tryNowText: ZDBI18NMap.g('zrpt.topbar.js.trynow')
            },
            {
                planName: ZDBI18NMap.g('zrpt.topbar.js.prof_plus_edition'),
                planID: '7205',
                tryNowText: ZDBI18NMap.g('zrpt.topbar.js.trynow')
            }
        ]
    },
    
    signOutLinkMenu: {
        profilePhoto: ZDBGlobal.USERPROFILEPHOTO,
        firstLetter: ZDBGlobal.USERFULLNAME.substr(0,1).toUpperCase(),
        changeText: ZDBI18NMap.g('zrpt.schsettings.js.change'),
        userFullName: ZDBEscapeUtil.encodeForHtml(ZDBGlobal.USERFULLNAME),
        userFullName_attr: ZDBEscapeUtil.encodeForHtmlAttr(ZDBGlobal.USERFULLNAME),
        userEmail: ZDBEscapeUtil.encodeForHtml(ZDBGlobal.emailID),
        userEmail_attr: ZDBEscapeUtil.encodeForHtmlAttr(ZDBGlobal.emailID),
        userZuidText: ZDBI18NMap.g('zr.org.js.user_id'),
        userZuid: ZDBGlobal.zuID,
        iamURL: ZDBGlobal.IAMURL,
        accountText: ZDBI18NMap.g('zrpt.header.signout.js.account'),
        logoutURL: ZDBGlobal.LOGOUTURL,
        signoutText: ZDBI18NMap.g('zrpt.login.js.signout'),
        enableLayoutSelection: {
            condition: ZDBGlobal.IS_NEW_LAYOUT_ENABLED,
            data: {
                layoutText: ZDBI18NMap.g("zrpt.chartview.setting.js.Layout"),
                themeText: ZDBI18NMap.g("zrpt.header.signout.js.theme"),
                oldlayout: ZDBI18NMap.g("zrpt.header.signout.js.oldlayout"),
                newlayout: ZDBI18NMap.g("zrpt.header.signout.js.newlayout"),
                optiondisplay: (ZDBGlobal.LANDINGPAGE == "ZDBDataSheetView") ? "display:inline-block;" : "display:none;", //NO I18N
                layout1class: ZDBGlobal.ISNEWLAYOUT ? "radioDeSelected" : "radioSelected", //NO I18N
                layout2class: ZDBGlobal.ISNEWLAYOUT ? "radioSelected" : "radioDeSelected", //NO I18N
                layer1class: (ZDBGlobal.tabLayer == "1") ? "radioSelected" : "radioDeSelected", //NO I18N
                layer2class: (ZDBGlobal.tabLayer == "1") ? "radioDeSelected" : "radioSelected", //NO I18N
            }
        }
    }
};

ZRSHTMLTemplateStrings["__homepage__zrsheader__model"] = ZRSHeader_Model.homepage;
ZRSHTMLTemplateStrings["__zohoapps__zrsheader__model"] = ZRSHeader_Model.zohoapps;
ZRSHTMLTemplateStrings["__tryotherplans__zrsheader__model"] = ZRSHeader_Model.tryotherplans;
ZRSHTMLTemplateStrings["__signOutLinkMenu__zrsheader__model"] = ZRSHeader_Model.signOutLinkMenu;
