//$Id$
  ZDBNavigation.moreTabs = [];
  ZDBNavigation.restructureTabHolder = function(tab, tabHeaderWidth) {
      var tabHolder = ZDBClientUI.ZRSTabHolder;
      var tabPar = tabHolder.parentElement;
      if(tab) {
            tabHolder.appendChild(tab);
      }
      ZDBNavigation.resizeTabHolderWidth(tabHolder);
      ZDBNavigation.moveToMoreTabs(tabPar, tab, (tabPar.scrollWidth > tabPar.offsetWidth));
      tabPar.scrollLeft = tabPar.scrollWidth ;
  }
  
  ZDBNavigation.resizeTabHolderWidth = function(tabHolder) {
      var tabHldrChldrnWidth = 0;
      var tabHolderChldrn = tabHolder.children;
      var tabCount = tabHolderChldrn.length;
      var tabPar = tabHolder.parentElement;
      var tabWidth = 150 - ((tabPar.scrollWidth > tabPar.offsetWidth + 150) ? (tabCount*5) : 0);
      for(var i = 0; i < tabCount; i++) {
            tabHolderChldrn[i].tabHeader.style.width = tabWidth - 5 + "px";
            tabHldrChldrnWidth = tabHldrChldrnWidth + tabWidth + 51;
      }
      tabHolder.style.width = tabHldrChldrnWidth + "px";

  }
  ZDBNavigation.moveToMoreTabs = function(tabParent, tb, toShow) {
      if(tb) {
          ZDBNavigation.moreTabs.push(tb);
      }
      ZDBNavigation.showHideTabNavigButtons(tabParent,true, toShow);
  }
  
  ZDBNavigation.showHideTabNavigButtons = function(tabParent, adjustButtonPos, toShowButtons) {
      var leftNavig = tabParent.nextElementSibling;
      var rightNavig = leftNavig.nextElementSibling;
      var moreTab = rightNavig.nextElementSibling;
      if(adjustButtonPos) {
        leftNavig.style.left = tabParent.offsetLeft + tabParent.offsetWidth - 5 + "px";
        rightNavig.style.left = tabParent.offsetLeft + tabParent.offsetWidth + 20 + "px";
        moreTab.style.left = tabParent.offsetLeft + tabParent.offsetWidth + 50 + "px";
      }
      leftNavig.style.display = (toShowButtons) ? "block" : "none";
      rightNavig.style.display = (toShowButtons) ? "block" : "none";
      moreTab.style.display = (toShowButtons) ? "block" : "none";
      if(toShowButtons) {
          leftNavig.style.opacity = (tabParent.scrollLeft > 0) ? 1 : 0.4;
          rightNavig.style.opacity = (tabParent.scrollLeft + tabParent.offsetWidth < tabParent.scrollWidth) ? 1 : 0.4;
          ZDBUtil.addClass(tabParent, "tabparent-border");
      }
      else {
          ZDBUtil.removeClass(tabParent, "tabparent-border");
      }
  }
  ZDBNavigation.scrollTab = function(type) {
      var tabParent = ZDBClientUI.ZRSTabHolder.parentElement;
      var scrollPos = (type == "left") ? tabParent.scrollLeft - 350 : tabParent.scrollLeft + 350;//No I18N
      if(browser_ie || window.BROWSER.SAFARI) {
          jQuery(tabParent).animate({scrollLeft : scrollPos}); //added jquery to support all the browsers. As the css scroll-behaviour : smooth is supported only for chrome and firefox
      }else {
//          document.querySelector("#ZRSTabParent").scroll({left: scrollPos, behaviour: 'smooth'});
          tabParent.scrollLeft = scrollPos; }
  }
  ZDBNavigation.pushToHistory = function(objId, dispName) {
      if(objId < 0) { return; }
      var url = "ZDBDataSheetView.cc?DBID=" + ZDBClientUI.dbId + ((objId == "Explorer") ? "" : "&OBJID="+objId);//No I18N
      history.pushState(objId, dispName, url);
  }
  
  ZDBNavigation.listOpenedViews = function(el, event)
    {
          var tabs = ZDBNavigation.moreTabs;
          var len = tabs.length;
          var moreTabEl = DOMUtils.getSelfOrParentWithAttrValue(el, "menuParent", "true"); //No I18N
          jQuery(document.body).unbind("click").bind("click", function(){ //No I18N
              jQuery(document.body).unbind("click");   //No I18N
          });
          var menu =ZDBContentCache.appendAndGet("Tab_List","GridMenu", moreTabEl);
          if(!dom(menu).first('.ZRSMenuTopAfter')) {
            dom(menu).prepend(dom.new('span', { attributes: { class: "ZRSMenuTopAfter", style: 'right: 5px' } })); // No I18N
            dom(menu).prepend(dom.new('span', { attributes: { class: "ZRSMenuTopBefore", style: 'right: 4px' } })); // No I18N
          }
          var ulEl = jQuery(menu).children('ul'); //No i18N
          ulEl.empty();
    //      menu.style.height = (len > 15) ? "390px" : "auto";   
          menu.style.width="265px";
          var openedView =  ZDBUtil.templateCreator("_openedViewTemp"); //No i18N
          for(var i=len-1; i>=0; i--)
          {
              var tab = tabs[i];
              openedView.viewName.innerText = tab.view.displayName;
              openedView.viewIcon.className = "viewTypeIcon" + " " + tab.view.type;
              var viewEl = openedView.cloneNode(true);
              viewEl.setAttribute('tip', tab.view.displayName); //No i18N
              viewEl.setAttribute('objId', tab.view.objId);
              viewEl.tabRef = tab;
              viewEl.style.display = "list-item"; //No i18N
              tab.listItem = viewEl;
              ulEl.append(viewEl);
          }
          var jMenu = jQuery(menu);
    //      ZDBUtil.setTooltipForMenuItems(ulEl, event);      
          ZRSMenu.showMenu(event, el, menu);
          var reduceLeft = $("ZRSingleLayoutNavTD").offsetWidth + 1;
          jMenu.css({"top":el.offsetHeight + "px", "left": "unset", "right": "-4px" });//No i18N
          var toShowCloseAll = (len > 1) ? "block" : "none"; //No i18N
          jMenu.find(".closeAllOpnViews").css("display", toShowCloseAll); //No i18N
          menu.removeEventListener("keyup", ZDBNavigation.closeOpenedViewsList);
          menu.addEventListener("keyup", ZDBNavigation.closeOpenedViewsList);
      }

ZDBNavigation.closeOpenedViewsList = function(e) {
   if(e.keyCode == 13 || e.keyCode == 27) { 
        $("ZDBOpenedViewList").style.display = "none";
   }
}

ZDBNavigation.allowDrop = function(event) {
    event.preventDefault();
//    console.log(event.target, event.clientX);
}

ZDBNavigation.moveTheTab = function (ev) {
    var tab = DOMUtils.getSelfOrParentWithAttrValue(event.target, "partab", "tab");//No i18N
    tab.className = tab.className + " ZRSDraggedTab";  //No i18N
    var tab = DOMUtils.getSelfOrParentWithAttrValue(event.target, "partab", "tab");//No i18N
    tab.style.left = ev.clientX;
}

ZDBNavigation.drop = function(event) {
    event.preventDefault();
    var dropTab = DOMUtils.getSelfOrParentWithAttrValue(event.target, "partab", "tab");//No i18N
    var parHolder = dropTab.parentElement;
    var draggedTab = parHolder.getElementsByClassName("ZRSDraggedTab")[0];
    parHolder.insertBefore(draggedTab, dropTab);
    var dropIndex = ZDBNavigation.moreTabs.indexOf(dropTab);
    var removeIndex = ZDBNavigation.moreTabs.indexOf(draggedTab);
    ZDBNavigation.moreTabs.splice(removeIndex, 1);
    ZDBNavigation.moreTabs.splice(dropIndex - 1, 0, draggedTab);
    ZDBUtil.removeClass(draggedTab, "ZRSDraggedTab");
}

ZDBNavigation.closeAllOpenedViews = function(el, event) {
	var jEl = jQuery(el);
	var openedViews = jEl.siblings("ul").find("li"); //No i18N
	for(var i = 0 ; i < openedViews.length; i++) {
		ZDBTabHandler.removeSelectedTab(openedViews[i].tabRef,event);
	}
}
  
    window.onpopstate = function(event) {
        if(event.state){
            var objId = event.state;
            if(objId == "Explorer")//No I18n
            { 
                    ZDBClientUI.selectTab(ZDBNavigation.explorerTab, true);
                    return;
            }
            if(ZDBClientUI.openedViewsObjId.indexOf(objId) > -1) {
                for(var i = ZDBClientUI.tabOrderList.length - 1; i >= 0; i--) {
                    var tab = ZDBClientUI.tabOrderList[i];
                    if(tab.view.objId == objId) {
                        ZDBClientUI.ZRSTabHolder.parentElement.scrollLeft = tab.offsetLeft;
                        ZDBClientUI.selectTab(tab, true);
                        break;
                    }
                }
            } else {
                var viewInfo = ZDBExpViewHandler.fetchViewListInfo(objId);
                if(!viewInfo) {
                    StatusMsgAPI.showMsg("ObjId is not available in this Database",false);//No I18N
                    var previousObjId = ZDBClientUI.selectedTab.view.objId;
                    var url = "ZDBDataSheetView.cc?DBID=" + ZDBClientUI.dbId + ((previousObjId == "Explorer") ? "" : "&OBJID="+previousObjId);//No I18N
                    history.replaceState(previousObjId, ZDBClientUI.selectedTab.view.displayName, url);
                    return;
                }
                ZDBClientUI.fetchView(objId, ZDBClientUI.dbId, viewInfo[ZDBExpViewHandler.VIEW_NAME], viewInfo[ZDBExpViewHandler.VIEW_TYPE], null);
            }
        }

    }
