//$Id$

var ZDBNavigation = new function()
{
	
  this.showDBSettings = function(element,event){
      ZDBNavigation.displayDBSettings(element,event); 
  }
  
  this.displayDBSettings=function(element,event)
  {
          element.style.pointerEvents = 'none';//NO I18N
	  //document.querySelector("#ZRDBSettingsLoading").style.display="";
	  if(!loadReact(ZDBNavigation.showDBSettings,[element,event])){
		  return;
	  }
	  if(!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/react/ZRDBSettings.js"],"APPENDTODOC",ZDBNavigation.showDBSettings,[element,event],"ZDBMainLoader")){
		  return;
	  }
	  if(!ZDBLazyLoadUtil.loadCssOnly(["ZRDBSettings.css","CSSLIST_GRIDSTYLES"], "APPENDTODOC", ZDBNavigation.showDBSettings,[element,event],"ZDBMainLoader")){
		            return;
	  }
	  ZRDBSettings.getDBInfo(element);
  }

  this.displaySlideSettings = function(element, action){
    if(!loadReact(ZDBNavigation.displaySlideSettings,[element,action])){
      return;
    }
    if(!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/react/ZRDBSettings.js","zdbjs/react/ZRSlideshow.js"],"APPENDTODOC",ZDBNavigation.displaySlideSettings,[element,action], "ZDBMainLoader")){
      return;
    }
    if(!ZDBLazyLoadUtil.loadCssOnly(["ZRDBSettings.css","ZDBSlideshowDialog.css"], "APPENDTODOC", ZDBNavigation.displaySlideSettings,[element,action], "ZDBSecondaryLoader")){
      return;
    }
    ZRDBSettings.getSlideInfo(element, action);
  }
  
  this.setToolTipForElements = function()
  {
      jQuery(ZDBClientUI.Objects_TBODY).find("span[elname='folderNameEl'],span[elname='fullnameParent']").on("mouseover",function(event){ZDBToolTip.checkLengthAndShow(this, event, 'NAVIG');}).on("mouseout",function(){ZDBToolTip.hide()});//NO I18N  
  }

  this.openTrash = function()
  {
	  var tab = $("ZDBTABCONT").getElementsByClassName("TrashTabObj")[0]; //No I18N
	  if(!tab)
	  {
		  if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisViewList","zdbjs/ui/ZDBTrash.js"],"APPENDTODOC",ZDBNavigation.openTrash))
		  {
		  	return;
		  }
		  ZDBTrash.fetchTrashObjectsListForDB(false); 
	  }
	  else
	  {
		  ZDBClientUI.selectTab(tab);
	  }
	  
  }
  
  this.fetchDBConnectionJs = function(el,event){
	  if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/dbconnectivity/ZDBDBConnection.js","APPENDTODOC",ZDBNavigation.fetchDBConnectionJs,[el,event]))
	  {
	  	return;
	  }
	  ZDBDBConnection.fetchConnectionList();
	  ZDBMenu.showExplorerLocalDBConnListPopup(el, event)
  }
  
  this.showImportPopup = function(el, event){
	  if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js","APPENDTODOC",ZDBNavigation.showImportPopup,[el,event]))
	  {
	  	return;
	  }
	  ZDBImport.showImportPopup(el, event);
  }
  
  this.showExportMenu = function(el,event,contentName,moduleName){
	  if(!ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare","APPENDTODOC",ZDBNavigation.showExportMenu,[el,event,contentName,moduleName]))
	  {
	  	return;
	  }
	  ZDBExport.showExportMenu(el,event,contentName,moduleName);
  }
  
  this.showExportSubMenu = function(el, event, menuName, moduleName){
	  if(!ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare","APPENDTODOC",ZDBNavigation.showExportSubMenu,[el,event,menuName,moduleName]))
	  {
	  	return;
	  }
	  ZDBExport.showExportSubMenu(el,event,menuName,moduleName);
  }
  
  this.showExportPopup = function(el,event,contentName,moduleName){
	  if(ZDBGlobal.IS_ONPREMISE_BUILD && (contentName == "Email_Menu" || contentName == "DSB_Email_Menu")) 
	    {
		  var IsConfigured = zroptopbar.isMailConfigured();	
	        if(!IsConfigured)
	        {
	          ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrop.mail.notify.js.errorMsg",ZROPConst.MALTABADDR));
	          return;
	        }
	    }
	  if(!ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare","APPENDTODOC",ZDBNavigation.showExportPopup,[el,event,contentName,moduleName]))
	  {
	  	return;
	  }
	  ZDBExport.showExportPopup(el,event,contentName,moduleName);
  }
  
  this.showDepListForQT = function(el, event){
	  if(!ZDBLazyLoadUtil.loadJsAlone("sqltable/js/ZDBQTDependencyList.js","APPENDTODOC",ZDBNavigation.showDepListForQT,[el,event]))
	  {
	  	return;
	  }
	  ZDBQTDependencyList.showDependencyList(el,event);
  }
  
  this.toggleSelection = function(el,selection)
  {
        var viewList = $("ZDBDBVIEWS");
        ZDBNavigation.expandOrMinimizeAllViews(viewList, true);
        ZDBNavigation.selection(el, 'ZRSelectAllViews', viewList, selection); //No I18N
  }
  
  this.selection = function(el,selectAllEl,parentEl,isSelectAll)
  {
    var selection = el.checked; //No I18N
    // #reference - for new layout the checkboxes is visible only on hover 
    var parEl = ZDBUtil.getParentWithAttributeValue(el,"id","ZDBVIEWLISTDIV");    //No I18N
    var inputList;
    var jParEl = jQuery(parentEl);
    if(ZDBClientUI.selectedTab.className == "ExplorerObj tabSelected" && parEl) {
       inputList = jParEl.find("[elname = viewEl] input:checkbox:not(:disabled)");   // selection usecase for newlayout in search mode has been removed. need to added later
    }
    else {
         inputList = jParEl.find("input:checkbox:visible:not(:disabled)");
    }
    if(isSelectAll)
    {
      inputList.prop("checked",selection); //No I18N
      // #reference - for new layout
      if(selection){
    	  inputList.parents("[elname = viewEl]:visible").addClass("viewSelect"); //No i18N
      }
      else{
    	  inputList.parents("[elname = viewEl]:visible").removeClass("viewSelect"); //No i18N
      }
    }
    else
    {
      var origLen = inputList.length;
      var selectedEl = inputList.filter(":checked").length; //No I18N
      selectAllEl = $(selectAllEl);
      selectAllEl.checked = (origLen === selectedEl);
    }
  }

  this.fetchObjectsListForDB = function(navigType, savePref, firstFolderId, refreshEl)
  {
    var params = "DBID=" + ZDBClientUI.dbId + "&NAVIGTYPE=" + navigType;
    var url = (savePref)? "/ZDBDatabaseActionMI.ma?ZDBACTION=SAVENAVIGPREF":"/ZDBListObjectsForDB.cc?";//No I18N 
    var loadingDiv = ZDBNavigation.explorerTab.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.loadingdiv.js.loading")); //No i18N
  	loadingDiv = (refreshEl) ? refreshEl : $("ZR_Nav_Refresh");
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
                               ONSUCCESSFUNC:this.handleViewsListResp,
                               DBID:ZDBClientUI.dbId,"AUTOGENFOLDERID":firstFolderId, //No I18N 
                               OPSTATUSID:loadingDiv});
  }  
  this.handleViewsListResp = function(response,requestOptions)
  {
	if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/autogen/ZDBSampleViews.js",this,ZDBNavigation.handleViewsListResp,[response,requestOptions]))
	{
	 	return;
	}
	ZDBClientUI.responseHolder.innerHTML = response.getOnlyHtml();
        ZDBExpViewHandler.clrExpViewHandlerVar();
        ZDBExpViewHandler.valueFetch(ZDBClientUI.dbId,ZDBNavigation.navSelect.value);
    }
    this.autoGenerationTag = function()
    {
	var autoGenResult = $('AutoGenResult');
        if(autoGenResult == null) {
            return;
        }
	var msg = autoGenResult.getAttribute("message");
        var firstFolderId = autoGenResult.getAttribute("folderId");
        var comingFrom = autoGenResult.getAttribute("comingfrom");
        var objId = autoGenResult.getAttribute("OBJID");
        if(msg != "SUCCESS" &&  msg != "CREATEDBEFORE" && msg != "NOMESSAGE")
        {
            ZDBAlertAPI.showMsg(msg, "ZDBERROR");  //No I18N 
        }
        else if(msg == "CREATEDBEFORE")
        {
            var create = true;
            ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.autoGenDuplicationAlert"), "ZDBYESNO", //No I18N 
            {ONCLICK:ZDBSampleViews.createSampleViews,CREATEAGAIN:create},ZDBI18NMap.g('zrpt.common.zdbalertmsg.js.autoGenDuplicationAlertDlgTtl'),null,null,null,objId);
        }
        else if(msg != "NOMESSAGE")
        {
            var successMessage = comingFrom == "ANALYZECOL" ? ZDBI18NMap.g("zrpt.common.showinfo.js.autoGen4ColSuccess") : ZDBI18NMap.g("zrpt.common.showinfo.js.autoGenSuccess"); //No I18N 
            ZDBMsgBox.showInfo(successMessage);
        }
        if(firstFolderId != null & firstFolderId != -1)
        {
            ZDBExpViewHandler.opnFrstGenView(firstFolderId);
            if (ZDBNavigation.navSelect.value == "Folder") {
            ZDBNavigation.insertAutoGenHeaderBefore(firstFolderId);
        }
    }
    }
  
  this.getClassforViewBy = function()
  {
	  var navType = (ZDBNavigation.navSelect.value).toUpperCase();
	  classesByViewType = {ALL:'viewByTypesIcon',RELATED:'viewByRVIcon',FOLDER:'viewByFolderIcon'};//No i18N
	  return classesByViewType[navType];
  }

  this.insertAutoGenHeaderBefore =  function(firstFolderId)
  {
        for (var key in ZDBNavigation.tBody) 
       {
            var autoGenList = ZDBUtil.getElsWithTagNAttrWithVal(ZDBNavigation.tBody[key], "foldId", firstFolderId, "li"); //No i18N
            var parEl = autoGenList[0].parentNode;
            var autoGenTr = $("ZDBAutoGenHead").cloneNode(true);
            parEl.insertBefore(autoGenTr, autoGenList[0]);
            ZDBUtil.show(autoGenTr);
            autoGenTr.setAttribute("id", " "); //No i18N
            if (key == "rightPanel")
           {
                autoGenTr.innerText = ZDBI18NMap.g("zrpt.common.js.autoGenRepSeparator");
           }
           
       }
    }
this.updateDBObjectList = function()
  {
    var listEl  = document.getElementById("ZDBListObjectsForDB_CT");
    listEl.style.display="block";
    
    var replace = (ZDBClientUI["ObjectsList"] == null) || (ZDBClientUI.swipeArea.curComp == ZDBClientUI["ObjectsList"]);                                                      
    ZDBClientUI["ObjectsList"] = listEl;
    ZDBClientUI.arr = ZDBExpViewHandler.getfolderCount();
        
    if(replace)
    {
      ZDBClientUI.replaceInSwipeArea(ZDBClientUI["ObjectsList"]);
    }
    ZDBNavigation.highlightSelectedInNavList();
    ZDBNavigation.navSelect.value =  ZDBClientUI["Objects_TBODY"].getAttribute("navigType");  //No I18N  
    ZDBNavigation.viewListBody.className = ZDBClientUI["Objects_TBODY"].className;
    var trash = $("TrashObjectListContainer");
    if(trash)
    {
    	ZDBTrash.resizeTrashListSize();
    }
    // var showTrash = (ZDBNavigation.viewsCountByType[0] > 0 || ZDBNavigation.viewsCountByType[1] > 0); // #reference - index[0]: Table, index[1]: QueryTable
    // if(!ZDBClientUI.isDBOwner && !showTrash){
    // 	jQuery("#ZDBNavigationBarTD #ZRSTrash").hide(); //No i18N
    // }
    
    var display = (ZDBNavigation.navSelect.value == "Folder" && ZDBClientUI.folderPerm)? "":"none"; //No I18N
    // TODO :: Need to enable/disable create folder in menu items
    //ZDBNavigation.createFldLnk.style.display= display;    
        ZDBNavigation.newFldLnk.style.display = "";
        var toAdjSwipe = (display == "none"); //No I18N
        ZDBNavigation.adjustSwipeAreaHeight(toAdjSwipe);

      }
	this.adjustSwipeAreaHeight = function(addHeight)
	{
            var currNavType = ZDBNavigation.navSelect.value;
	    if(ZDBNavigation.navType == currNavType){
	        ZDBClientUI.resizeSwipe();
	    }
	    
            ZDBNavigation.navType = currNavType;
	}

  this.initializeExplorerView = function(selectTab)
  {
        if(ZDBClientUI.standAlone)
        {
          return;
        }
        var viewObjId= "Explorer";
        var tab = ZDBClientUI.createEmptyTab();
        var viewName = ZDBI18NMap.g("zrpt.common.toolbar.js.explorer");
        this.rightExplorerView = $("ZDBEXPDIV");
        // #reference - for new layout
        this.viewListBody = $("ZDBDBVIEWS");
        this.navSelect = $("ZDBSELECTEXPVIEW");
        this.newFldLnk = $("ZDBNEWFOLDERLNK");
        this.createNimportOpt=$("ZRCreateNimportOpt");
        this.rdbLinkTablesOpt=$("ZRRDBLinkTables");
        this.rightExplorerView.appendChild(tab.viewCtx.loadIndicator);
        this.rightExplorerView.parentNode.removeChild(this.rightExplorerView);
        this.rightExplorerView.style.display="";
        this.tBody = {};
        this.tBody["leftPanel"] = ZDBClientUI.Objects_TBODY;
        this.tBody["rightPanel"] = ZDBNavigation.viewListBody;
        ZDBUtil.removeAllChildren(ZDBNavigation.viewListBody);
        var view = new DummyView(viewObjId,viewName,"Explorer",this.rightExplorerView); //No I18N 
        view.setScrollPosition = function(set){
        if(set)
        {
            view.expScrollPos = ZDBClientUI.viewList.scrollTop;
        }
        else
        {
           ZDBClientUI.viewList.scrollTop = (view.expScrollPos) ? view.expScrollPos : "0";
        }         
      };
    view.dbId = ZDBClientUI.dbId;    
    ZDBClientUI.initializeTab(tab,view,this.rightExplorerView);
    tab.tabClose.style.visibility= "hidden";
    ZDBClientUI.selectTab(tab);
    ZDBNavigation.viewsCountByType =[0,0,0,0,0,0,0];
    ZDBNavigation.explorerTab = tab;
    ZDBNavigation.searchType="All"; //No i18N
  }
  
  this.getElsFromtBody = function (selector, attr, selectorVal, tag)  // with single selector value ex: objId
  {
      var tBody = ZDBNavigation.tBody;
      var parentEls =(tBody.leftPanel) ? [tBody.leftPanel, tBody.rightPanel] : [tBody.rightPanel];
      var els = ZDBUtil.iterativeFind(parentEls, selector, attr, selectorVal, tag);
      return els;
      
  }
    this.getElsFromtBodyWithMultiSelVal = function (attr, selectorVal, tag)  // for multiple selector values ex: group of objIds [id1, id2, id3, ....]
  {                      
      var tBody = ZDBNavigation.tBody;
      var elArray = [];
      for(var key in tBody)
      {
          var el = ZDBUtil.getElsWithTagNAttrWithVals(tBody[key], attr, selectorVal, tag);
          elArray = elArray.concat(el);
      }
      return elArray;
      
  }
  
    this.getElsFromtBodyWithMultiSelVal = function (attr, selectorVal, tag)  // for multiple selector values ex: group of objIds [id1, id2, id3, ....]
  {                         
      var tBody = ZDBNavigation.tBody;
      var elArray = [];
      for(var key in tBody)
      {
          var el = ZDBUtil.getElsWithTagNAttrWithVals(tBody[key], attr, selectorVal, tag);
          elArray = elArray.concat(el);
      }
      return elArray;
      
  }
  this.createViewsFromLeftSide = function(rightExpViewUl)
  {
        var parentEl;
        var navigtype = ZDBNavigation.navSelect.value;
        var secRow = ZDBNavigation.rightExplorerView.getElementsByClassName("secondRow")[0];
        ZDBUtil.show(secRow);
        var toolBarSep = ZDBNavigation.rightExplorerView.getElementsByClassName("toolbarSeparator")[0];
        ZDBUtil.show(toolBarSep);
        ZDBUtil.hide(ZDBNavigation.createNimportOpt);
        ZDBUtil.hide(ZDBNavigation.rdbLinkTablesOpt);
        ZDBUtil.show(ZDBNavigation.viewListBody);
        var elsToShow = rightExpViewUl.querySelectorAll(".ViewDesc, input, .viewSeparator, [elname = viewEl] .viewTypeIcon"); //No I18N
        for (var i = 0; i < elsToShow.length; i++) {
            var isFoldDesc = ZDBUtil.hasClass(elsToShow[i].parentNode, "ZDBfolderEl");
            var isViewTypeIcon = ZDBUtil.hasClass(elsToShow[i], "viewTypeIcon");
            if (isFoldDesc && !elsToShow[i].innerText || isViewTypeIcon && (navigtype == "All")) {
                ZDBUtil.hide(elsToShow[i]);
            }
            else {
                ZDBUtil.show(elsToShow[i]);
           }
        }
        ZDBNavigation.viewListBody.appendChild(rightExpViewUl);
        ZDBUtil.show(rightExpViewUl);
        ZDBClientUI.resizeRightExplorerView();
        jQuery(ZDBNavigation.viewListBody).find("input:checkbox:not(:disabled)").bind("click", function () {
            ZDBNavigation.selection(this, "ZRSelectAllViews", rightExpViewUl, false); //No I18N
        });
  }
 
  this.showCreateFolderDlg = function(comingFrom)
  {
    if(!ZDBLazyLoadUtil.loadSnippet("CREATE_FOLDER_DLG","/ZDBCreateFolder.cc?",this,"APPENDTODOC"))
    {
      return;
    }
    var el = ZDBUtil.getCachedRef(this, "ZDBCREATEFOLDERDLG");
    el.style.display = "block";
    var title = ZDBI18NMap.g("zrpt.common.newfolder.js.dlgTtl");
    ZDBDialogUtil.showDialog(el,{TITLE:title,ADDFRAME:true,MODAL:true,DONTREMOVE:true,COMINGFROM:comingFrom,ONENTER:ZDBNavigation.submitCreateFolder,ACTIONBUTTONS:el.querySelector("#ZDBFOLDERDLGOKBTN")});//NO I18N
    $("ZDBFOLDERNAME").value = "";
    $("ZDBFOLDERDESC").value = "";
    $("ZDBMAKEFOLDERDEF").checked = false; //No I18N
    $("ZDBFOLDEROPTSTATUS").className="mcLoaded";
  }
  
  this.submitCreateFolder = function(el)
  {
    
    var dlg = ZDBDialogUtil.focusDialog;
    var comingFrom = dlg.params["COMINGFROM"].toString();
    var els = DOMUtils.getChildElsWithAttr(dlg,"elname","*");
    if(!validateFormElements(els,dlg))
    {
       return;
    }
    var folderName = $("ZDBFOLDERNAME").value;
    var folderDesc = $("ZDBFOLDERDESC").value;    
    var isMakeDef = $("ZDBMAKEFOLDERDEF").checked; //No I18N
    var defFolderParams = "&MAKEDEF="+isMakeDef; //No I18N
    if(comingFrom!=="ZDBFolderListCombo")
    {
        defFolderParams += "&REFRESHUI=true"; //No I18N
    }
    var dbId = ZDBClientUI.dbId
    var url ="/ZDBDatabaseActionMI.ma?"; //No I18N
    var params = "&ZDBACTION=SAVEFOLDER&FOLDERNAME=" + encodeURIComponent(folderName) +  //No I18N 
                 "&FOLDERDESC=" + encodeURIComponent(folderDesc) + "&DBID=" + dbId+defFolderParams; //No I18N
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:ZDBNavigation.createFolderResp,ONFAILURECLEANUPFUNC:ZDBNavigation.enableCreateFolderBtns,
                         OPSTATUSID:"ZDBFOLDEROPTSTATUS","FOLDERNAME":folderName,"FOLDERDESC":folderDesc,"MAKEDEF":isMakeDef,"COMINGFROM":comingFrom});//No I18N
  }
  
  this.enableCreateFolderBtns = function(){
      ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored,true);
  }
  
  this.createFolderResp = function(response, requestOptions)
  {
    ZDBDialogUtil.closeDialog();
    var params = response.getResponseParams();
    var folderInfo = params["FOLDERINFO"];
    var comingFrom = requestOptions["COMINGFROM"];
    if(comingFrom  == "ZDBFolderListCombo")
    {
        ZDBNavigation.loadFolderList("ZDBFolderItemList","ZDBFOLDERLISTOPTSTATUS",params["FOLDERID"]);//No I18N
  }
    else if(comingFrom == "ZDBTemplateFolderListCombo")
    {
        ZDBNavigation.loadFolderList("ZDBTemplateFolderItemList","ZDBTEMPLATEFOLDERLISTOPTSTATUS",params["FOLDERID"]);//No I18N
    }
    else
    { 
        ZDBExpViewHandler.createElInExpView(folderInfo);
    }
  
  }  
    this.getAllViewsFromFolder = function()
    {
    	var objsList = new Array();
    	var folderId = ZDBNavigation.folder.getAttribute("foldId");    
        var folderViewsCount = ZDBExpViewHandler.getfolderChild(folderId).length;
        var el = ZDBNavigation.folder;
        while( folderViewsCount != 0) {
            el = ZDBUtil.nextMatchedSibling(el,"ZDBViewListEl");//No I18N
            if (el) {
                objsList.push(el);
            }
            folderViewsCount--;
        }
        return objsList;
    }
  this.menu = function(event)
  {
    if(!event)
    {
      event = window.event;
    }
    var el = ZDBUtil.getSourceElement(event);
    var view = ZDBClientUI.getViewObj(el,"view");//No I18N
    ZDBNavigation.element = DOMUtils.getParentWithAttr(el,"objId");
    var viewId = ZDBNavigation.element.getAttribute("objId");
    var viewDet = ZDBExpViewHandler.fetchViewListInfo(viewId);
    var viewType = viewDet[ZDBExpViewHandler.VIEW_TYPE];
    var contentName = (ZDBGlobal.newShareEnabled && !BROWSER.isIE9 == 1) ? "View_New_Option_Menu" : "View_Option_Menu"; // No I18N
    var menu = ZDBContentCache.appendAndGet(contentName,"GridMenu",document.body);
    ZDBUtil.setNamedChildEls(menu,menu);
    menu.view = view;
    $("ZREditViewOpt").style.display = (viewType == "Report" || viewType == "Table") ? "none" : "";
    ZDBClientUI.arr = ZDBExpViewHandler.getfolderCount();
    var display = (ZDBNavigation.navSelect.value == "Folder" && ZDBClientUI.folderPerm && ZDBClientUI.arr.length > 1) ? '' : 'none'; //No I18N
    $("ZDBFolderMove").style.display = display;
    $('ZDBFolderSeparator').style.display=display;
    
    var isDBOwner = ZDBClientUI.isDBOwner;
    $("ZDBNavShareView").style.display = (isDBOwner) ? "" :"none"; //No I18N
    $("ZDBNavEditShareView").style.display = (isDBOwner) ? "" :"none"; //No I18N
    $('ZDBShareSeparator').style.display = (isDBOwner) ? "" :"none"; //No I18N
    menu.parentTr = ZDBNavigation.element;
    if(jQuery(el).parents("#ZDBNavigationBarTD").length)
      {
          jQuery(menu).attr("isLeftNavItem","true"); //No I18N
      }
    ZRSMenu.showMenu(event,null,menu,1,ZDBNavigation.deHighlightParent);
    var parentTr = ZDBNavigation.element;
    parentTr.menuOpened=true;
    ZDBNavigation.parentTr = parentTr;
    ZDBUtil.stopEventBubble(event);
  }
  
  this.showDesignView = function(el, event)
  {
	  var objId = ZDBNavigation.element.getAttribute("objId");
	  var viewDet = ZDBExpViewHandler.fetchViewListInfo(objId);
	  var viewType = viewDet[ZDBExpViewHandler.VIEW_TYPE];
	  var dispName = viewDet[ZDBExpViewHandler.VIEW_NAME];

	  // To remove template notifications.
	  ZDBClientUI.isChartViewed = false;
	  if (jQuery(ZDBNavigation.element).children().find('span').hasClass("zr-op-newLeft")) {
		  ZDBClientUI.isChartViewed = true;
		  jQuery(ZDBNavigation.element).children().find('span.zr-op-newLeft').remove(); //NO I18N
		  ZDBGlobal.templateNotifyObjIds = ZDBClientUI.removeObjId(objId);
		  ZDBTemplateList.showNewIconNotification(ZDBGlobal.templateNotifyObjIds);
	  }
	    
	  if(viewType == "Table")
	  {
		  //Uncomment after getting SYSTEMTABLE info.
//		  if(!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/tabledesign/ZDBDesignGrid.js"],"APPENDTODOC",ZDBNavigation.showDesignView,[el, event],"ZDBMainLoader")){
//			  return;
//		  }
//		  var tab = ZDBClientUI.getExistingTab(objId);
//		  if(tab != null)
//	      {
//			var view = tab.view;
//			ZDBClientUI.selectTab(tab);
//	    	if(view.type != "TableDesign")
//	    	{
//	    		ZDBDesignGrid.showDesignView(event,true);
//	    	}
//	      }
//		  else
//		  {
//			  ZDBDesignGrid.showDesignView(event,true);
//		  }
	  }
	  else if(viewType == "QueryTable")
	  {
		  var tab = ZDBClientUI.getExistingTab(objId);
		  if(tab != null)
	      {
	    	var view = tab.view;
	    	ZDBClientUI.selectTab(tab);
	    	if(!view.editMode)
	    	{
	    		ZDBSQLTable.showDesign(el,true);
	    	}
	      }
		  else
		  {
			  ZDBSQLTable.showDesign(el,true);
		  }
	  }
	  else if(viewType == "Pivot" || viewType == "SummaryView" || viewType == "AnalysisView" || viewType == "Dashboard")
	  {
		  var tab = ZDBClientUI.getExistingTab(objId);
		  if(tab != null)
	      {
	    	var view = tab.view;
	    	ZDBClientUI.selectTab(tab);
	    	if(!view.editMode)
	    	{
	    		ZDBClientUI.typeDefns[viewType].fetchView(objId,tab.viewCtx,true);
	    	}
	      }
		  else
		  {
			  var tab = ZDBClientUI.createUpdateDummyTab(objId,dispName,viewType);
			  ZDBClientUI.typeDefns[viewType].fetchView(objId,tab.viewCtx,true);
		  }
	  }
  }
  
  this.openViewFromExpMenu = function(el, event)
  {
	  var objId = ZDBNavigation.element.getAttribute("objId");
      ZDBNavigation.expScrollPos = ZDBNavigation.element.scrollTop;
	  var tab = ZDBClientUI.getExistingTab(objId);

	  // To remove template notifications.
	  ZDBClientUI.isChartViewed = false;
	  if (jQuery(ZDBNavigation.element).children().find('span').hasClass("zr-op-newLeft")) {
		  ZDBClientUI.isChartViewed = true;
		  jQuery(ZDBNavigation.element).children().find('span.zr-op-newLeft').remove(); //NO I18N
		  ZDBGlobal.templateNotifyObjIds = ZDBClientUI.removeObjId(objId);
		  ZDBTemplateList.showNewIconNotification(ZDBGlobal.templateNotifyObjIds);
	  }
	  
      if(tab != null)
      {
        ZDBClientUI.selectTab(tab);
        return;
      }
	  var viewDet = ZDBExpViewHandler.fetchViewListInfo(objId);
	  var viewType = viewDet[ZDBExpViewHandler.VIEW_TYPE];
	  var dispName = viewDet[ZDBExpViewHandler.VIEW_NAME];
	  ZDBClientUI.fetchView(objId,null,dispName,viewType,null);
  }
  this.showViewOptionsSubMenu = function(element, event, menuName, moduleName)
  {
        var menuEl = ZDBContentCache.appendAndGet(menuName,moduleName,document.body);
        var tempMoveList = ZDBContentCache.appendAndGet("Folder_Temp_MoveList",moduleName,document.body);
        
        var optionList = $("ZDBFolderListItemBody");
        ZDBUtil.removeAllChildren(optionList);
        ZDBUtil.removeNonElements(optionList);
        var trList = $("ZDBFolderListItem");
        if(ZDBNavigation.navSelect.value == "Folder" && ZDBClientUI.folderPerm && ZDBClientUI.arr.length > 1)
        {
          var curTr = ZDBNavigation.parentTr;
          var curObjId = curTr.getAttribute("objId");
          var parentFoldId = ZDBExpViewHandler.getviewListData(curObjId, ZDBExpViewHandler.FOLD_ID);
          optionList.style.display="";
          $("ZDBFolderMove").style.display="";
          $("ZDBFolderSeparator").style.display="";
          ZDBClientUI.arr = ZDBExpViewHandler.getfolderCount();
          var expArr = ZDBClientUI.arr;
//          expArr.sort(function(before,next)
//          {// Folder names sort by ascending order in Explorer (Move view to another folder).
//            //Note: return value is less than 0; make sure "before" comes before "next" else "before" comes after "next"
//            return (before.getAttribute("folderName").toLowerCase() > next.getAttribute("folderName").toLowerCase()) ? 1 : -1; 
//          });
          for(var i=0;i<expArr.length;i++)
          { 
            var tr = trList.cloneNode(true);
            tr.id = "";
            tr.style.display="";
            var folderId = expArr[i];
            var folderName = ZDBExpViewHandler.getFoldListData(folderId, ZDBExpViewHandler.FOLD_NAME);
            if(folderId != parentFoldId)
            { 
              ZDBUtil.setNamedChildEls(tr,tr);
              tr.folderNameEl.innerHTML = ZDBEscapeUtil.encodeForHtml(folderName);
              tr.folderNameEl.setAttribute("folderId",folderId);
              tr.folderNameEl.setAttribute("title",folderName);
              optionList.appendChild(tr);
            }
          }
          if(expArr.length > 11)
          {
            var div = $("ZDBFolderListDiv");
            div.style.height = "200px";
            div.style.width = "190px";
          }
        }
        else
        {
          $("ZDBFolderMove").style.display="none";          
          $("ZDBFolderSeparator").style.display="none";
        }
        if(jQuery(element).parents("#ZDBNavigationBarTD").length)
        {
            jQuery(menuEl).attr("isLeftNavItem","true"); //No I18N
        }
        return ZDBPopUpMenu.subMenuEl(element,event,menuEl,false);        
  }
  
  this.highlightParent = function(el)
  {
      var viewId = el.getAttribute("objId");
      var ViewDetails = ZDBExpViewHandler.fetchViewListInfo(viewId);
  if(el==null){return;}
  var parentTR = DOMUtils.getParentWithAttr(el,"listParentTR");
  parentTR.className = parentTR.className.replace("trHighLight","");
  parentTR.className = parentTR.className + " trHighLight";
  }
  
  this.deHighlightParent = function()
  {
  ZDBNavigation.parentTr.menuOpened = false;
  ZDBNavigation.deHighlightListItem(ZDBNavigation.parentTr);
  }
  
  this.highlightListItem = function(el)
  {
        if(el.getAttribute("type")){
            return;
        }
	var optionsBtn = jQuery(el).find("[elname='optionsBtn']").get(0);
//        var DefFoldIcon = el.getElementsByClassName("defaultFolder")[0];
        if(!optionsBtn){
            return;
        }
        el.optionsBtn = optionsBtn;
        var isDBOwner = ZDBClientUI.isDBOwner;
        var viewId = el.getAttribute("objId");
        if(viewId != null){
        	var isAllowed = ZDBExpViewHandler.getviewListData(viewId, ZDBExpViewHandler.VIEWOWNER);
        	if(!isAllowed)
        	{
            	el.optionsBtn.style.display = "none";
        	}
        }
        else{
        	if(!isDBOwner)
        	{
            	el.optionsBtn.style.display = "none";
//                DefFoldIcon.style.display = "none";
        	}
        }
        
        
    var detIcon = jQuery(el).find("[elname='detIcon']").get(0);
    
    if(detIcon){
      detIcon.onmouseover = ZDBToolTip.showViewDet;
    }
    if(isAllowed)
    {
    	optionsBtn.onclick = ZDBNavigation.menu;
    }
    else if(jQuery(el).hasClass("ZDBfolderEl") && isDBOwner){
		optionsBtn.onclick = ZDBNavigation.folderMenu;
//                DefFoldIcon.onclick = ZDBNavigation.makeFolderDefault;
	}
    jQuery(el).addClass("viewHighLight"); // No I18N
  }
  
  this.deHighlightListItem = function(el)
  {
    if(el.menuOpened==true){return;}
    jQuery(el).removeClass("viewHighLight"); // No I18N
    if(el == ZDBNavigation.parentTr)
    {
      el.menuOpened = false;
      var isViewEl = el.getAttribute("objId");
      ZDBNavigation.parentTr = null;
    }
      
  }
  this.renameViewDlg = function(event)
  {
    ZDBNavigation.removeAutoGenTr();
    if(!ZDBLazyLoadUtil.loadSnippet("RENAME_VIEW_DLG","/ZDBRenameView.cc?",this,"APPENDTODOC"))
    {
      return;
    }
    var viewId, el = ZDBUtil.getCachedRef(this, "ZDBRenameViewDetails");
    var title = ZDBI18NMap.g("zrpt.common.renameview.js.dlgTtl",el);
    el.style.display = "block";
    ZDBDialogUtil.showDialog(el,{TITLE:title,ADDFRAME:true,MODAL:true,ONENTER:ZDBNavigation.submitViewRenameDlg});
    $("ZDBVIEWRENAMEOPTSTATUS").className="mcLoaded";
    var element = ZDBNavigation.element;
    var viewName = ZDBUtil.getCachedRef(this, "ZDBViewRenameTxtFld");
    var viewDesc = ZDBUtil.getCachedRef(this, "ZDBViewDescTxtFld");
    viewId = ZDBNavigation.element.getAttribute("objId");
    var viewInfo = ZDBExpViewHandler.fetchViewListInfo(viewId);
    viewName.value = viewInfo[ZDBExpViewHandler.VIEW_NAME];
    viewName.origVal = viewInfo[ZDBExpViewHandler.VIEW_NAME];
    viewDesc.value = viewInfo[ZDBExpViewHandler.VIEW_DESC];
    viewDesc.origVal = viewInfo[ZDBExpViewHandler.VIEW_DESC];
    viewName.select();
  }

  this.getERDiagram = function(element,event) {
	    if(!ZDBLazyLoadUtil.loadCssOnly("ERDStyle.css", this, 
    		  ZDBNavigation.getERDiagram,[element,event])){
      	  return;
        }
	    if(!ZDBLazyLoadUtil.loadJsAlone("ERDGJS","APPENDTODOC",ZDBNavigation.getERDiagram,[element,event]))
	    {
	        return;
	    }
		var jsonData = null;
		var ERDViewEl = null;
		var ERD=null;
		var title=null;
		var erdtitle=null;
		var desc=null;
		var tableobjid=null;
		var tableName=null;
		var dbid=null;
		var chartobjid=null;
		var erdgtype=element.getAttribute("erdgtype");
		var view;
		var sendJsonRequest = function(element,event) {
			try
			{
			if(element.disableClickFlag)
			{
					return;
			}
			disableERDClickFunc(element);	
			if(erdgtype=="chart")
			{
		        var chartName=ZDBEscapeUtil.encodeForHtml(ZDBClientUI.selectedTab.tabHeader.innerHTML);
				title=chartName;
				erdtitle=ZDBEscapeUtil.encodeForHtml(ZDBI18NMap.g("zrpt.common.erdg.js.chart.title")+' '+chartName); //No I18N
			    desc=ZDBEscapeUtil.encodeForHtml(ZDBI18NMap.g("zrpt.common.erdg.js.chart.desc")+" '"+chartName+"'");   //No I18N
				view = ZDBClientUI.getViewObj(element, "view"); // No I18N	
				var joinInfoDiv = view.joinInfoDIV
				var params = "ZDBACTION=CREATECHARTERD"; // No I18N
				params += "&DBID=" + ZDBClientUI.dbId; // No I18N
				if (ZDBGlobal.integrated) {
					params += "&INTEGRATIONMODE=true"; // No I18N
				}
				params += "&PARENTVIEWID=" + view.parentViewId; // No I18N
				if (!ZDBUtil.isNewView(view)) {
					chartobjid=view.objId;
					params += "&OBJID=" + chartobjid; // No I18N
				}
				params += view.viewCtx.getAdditionalParams();

				var xml = ZDBAnalysisConfig.getConfig(view, true);

				AjaxAPI.sendRequest({
					URL : ZDBGlobal.CTX + "/ZDBCreateERD.ma?" + params, //No I18N
					REQUESTHEADERS : {
						"Content-type" : "text/xml;charset=utf-8"//No I18N
					}, // No I18N
					POSTBODY : xml,
					ANALYSISVIEW : view,
					ONSUCCESSFUNC : getERDOutline,
					ONFAILUREFUNC:handleERDRequestFailure,
					PLHOLDER : ZDBAnalysisView.joinInfoDIV.joinHolder,
					FIELDDIV : element,
					OPSTATUSID : view.viewCtx.getLoadIndicator(ZDBI18NMap
							.g("zrpt.common.loadingdiv.js.loading")),
				    "ELEMENT":element   //No I18N
				}); // No I18N				
		    }
			else if (erdgtype=="database"){
			view =ZDBNavigation.explorerTab; // No I18N
			var dbName = ZDBUtil.getText($("ZDBEXDBNAME"));
			title=dbName;   //No I18N
			erdtitle=ZDBEscapeUtil.encodeForHtml(ZDBI18NMap.g("zrpt.common.erdg.js.database.title")+' '+dbName); //No I18N
			desc=ZDBEscapeUtil.encodeForHtml(ZDBI18NMap.g("zrpt.common.erdg.js.database.desc")+" '"+dbName+"'");  //No I18N
			dbid = ZDBClientUI.dbId;
			var params = "DBID=" + dbid; // No I18N
			var url = "/ZDBCreateERD.ma?ZDBACTION=CREATEDATABASEERD";// NO I18N
			AjaxAPI.sendRequest({
				URL : url,
				PARAMETERS : params,
				ONSUCCESSFUNC : getERDOutline,
				ONFAILUREFUNC:handleERDRequestFailure,
				OPSTATUSID : view.viewCtx.getLoadIndicator(ZDBI18NMap
						.g("zrpt.common.loadingdiv.js.loading")),
              "ELEMENT":element    //No I18N
			});
			}
			else if(erdgtype=="table" || erdgtype=="querytable")
			{
				view = ZDBClientUI.getViewObj(element, "view"); // No I18N
                                if(view == null)
                                {
                                    view = ZDBClientUI.getViewObj(element, "gridObj");   // No I18N
                                }
				
				if(erdgtype=="querytable" && ZDBUtil.isViewModified(view))
			    {
			         ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.erdg.js.saveBeforeViewQueryTableERDG"));
			         enableERDClickFunc(element);
			         return;
			    }
				else{
				var gridObj = ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
			    if(gridObj.modified != 0)
			    {
			         ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.erdg.js.saveBeforeViewERDG"));
			         enableERDClickFunc(element);
			         return;
			    }
				}
				tableobjid=view.objId;
			    tableName=ZDBExpViewHandler.getviewListData(tableobjid,ZDBExpViewHandler.VIEW_NAME);
				title=tableName;  //No I18N
			     if(erdgtype=="querytable")
			    {
			    	erdtitle=ZDBEscapeUtil.encodeForHtml(ZDBI18NMap.g("zrpt.common.erdg.js.querytable.title")+' '+tableName); //No I18N
				    desc=ZDBEscapeUtil.encodeForHtml(ZDBI18NMap.g("zrpt.common.erdg.js.querytable.desc")+" '"+tableName+"'");  //No I18N
			    }
			    else
			    {
			    	erdtitle=ZDBEscapeUtil.encodeForHtml(ZDBI18NMap.g("zrpt.common.erdg.js.table.title")+' '+tableName); //No I18N
				    desc=ZDBEscapeUtil.encodeForHtml(ZDBI18NMap.g("zrpt.common.erdg.js.table.desc")+" '"+tableName+"'");  //No I18N	
			    }
				var params = "ZDBACTION=CREATETABLEERD"; // No I18N
				params += "&DBID=" + ZDBClientUI.dbId; //No I18N
			    params += "&OBJID=" + tableobjid; //No I18N				
				var url ="/ZDBCreateERD.ma?"; //No I18N
				AjaxAPI.sendRequest({
					URL : url,
					PARAMETERS : params,
					ONSUCCESSFUNC : getERDOutline,
					ONFAILUREFUNC:handleERDRequestFailure,
					OPSTATUSID : view.viewCtx.getLoadIndicator(ZDBI18NMap
							.g("zrpt.common.loadingdiv.js.loading")),
                  "ELEMENT":element   //No I18N
				});
			}
			}
			catch(err)
			{
				handleERDRequestFailure(response,requestOptions);
			}
		};
		var getERDOutline = function(response, requestOptions) {
			try{
			jsonData = JSON.parse(response.responseText.trim());
			var dbId = ZDBClientUI.dbId;
			var params = ""; // No I18N
			AjaxAPI.sendRequest({
				URL : "/ZDBERDG.cc",// No I18N
        METHOD: "GET",// No I18N
				ONSUCCESSFUNC : appendERDData,
				ONFAILUREFUNC:handleERDRequestFailure,
				OPSTATUSID : view.viewCtx.getLoadIndicator(ZDBI18NMap
						.g("zrpt.common.loadingdiv.js.loading")),
                  "ELEMENT":element   //No I18N
			}); // No I18N
			}
			catch(err)
			{
				handleERDRequestFailure(response,requestOptions);
			}
		};
		
		var appendERDData = function(response, requestOptions) {
			try
			{
			var element=requestOptions["ELEMENT"];
    var erdg=new ERDG();
    erdg.addERDOutline(response.responseText.trim());
    erdg.addOrUpdateJSON(jsonData);
    erdg.drawImage();
	ZDBInlineDialog.showDialog(erdg.ERDGViewEl,{TABTITLE: ''+title,TITLE: ''+erdtitle,DESC:''+desc,INLINECONTAINER:"ZDBInlineERDGDIV"}); //No I18N
    erdg.addOtherTools();
    if(erdgtype=="table" || erdgtype=="querytable")
    {
    	erdg.focusTable(tableName);
    }
          enableERDClickFunc(element);
      	}
      	catch(err)
			{
				handleERDRequestFailure(response,requestOptions);
			}
		};


		var disableERDClickFunc=function(element)
		{
			element.disableClickFlag=true;
			//element.style.opacity="0.3";
		}
		var enableERDClickFunc=function(element)
		{
			element.disableClickFlag=false;
			//element.style.opacity="1";
		}

		var handleERDRequestFailure=function(response,requestOptions)
		{
			var element = requestOptions["ELEMENT"];
			enableERDClickFunc(element);
			var errmsg=response.getResponsePart("STATUS_MESSAGE");
			if(errmsg==null)
			{
			 errmsg="Unable to get the ER Diagram for the specific request";   //No I18N
			}
			ZDBAlertAPI.showMsg(errmsg);
			throw errmsg;
		}
		ZDBToolTip.hide();
		sendJsonRequest(element,event);
	    //enableERDClickFunc(element);
	}

  this.renameSelView = function()
  {
    var objId = "";
    var objBody = $("ZDBEXPTBODY");
    var els = objBody.getElementsByTagName("input");
    var count = 0;
    for(i=0;i<els.length;i++)
    {
      var el = els[i];
      if(el.getAttribute("type") != "checkbox" || !el.checked)
      {
        continue;
      }
      var elToDel = DOMUtils.getParentWithAttr(el,"parentViewId");
      ZDBNavigation.element = elToDel;
      objId = elToDel.getAttribute("objId");
      ZDBNavigation.removeAutoGenTr();
      count++;
    }
    if(count < 1)
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.selView2Rename"));
      return;
    }
    else if(count > 1)
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.multiViewRenameErr"));
      return;
    }
    ZDBNavigation.renameViewDlg();
  }
  
  this.deleteView = function()
  {
    ZDBNavigation.removeAutoGenTr();
    ZDBClientUI.trashObject(ZDBNavigation.element);
  }

  this.deleteSelViews = function()
  {
    var objsToDropCache = [];
    var selIdArr = ZDBNavigation.getSelectedViewIdsInExplorer();
    if(!selIdArr.length)
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.selView2Del"));
      return;
    }
    for(i=0;i<selIdArr.length;i++)
    {
      var viewType = ZDBExpViewHandler.getviewListData(selIdArr[i], ZDBExpViewHandler.VIEW_TYPE);
      if(viewType == "Table" || viewType == "QueryTable")
      {
    	  objsToDropCache.push(selIdArr[i]);
    	  dropFieldsCache = true;
      }
      var objIdsStr = selIdArr.join(",") ;
      var dropFieldsCache = (objsToDropCache.length > 0);
      ZDBNavigation.removeAutoGenTr();
    }
        var delWithTable = ZDBI18NMap.f("zrpt.common.analysis.js.delTblWithDepViewConfirm", "table");
        var delWithoutTable = ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.delViewsConfirm");
        var confirmMsg = (dropFieldsCache) ? delWithTable : delWithoutTable;
    var params = "OBJIDS=" + objIdsStr + "&ZDBACTION=DELETESELECTEDVIEWS&REFRESHUI=true" //No I18N 
    + "&DBID=" + ZDBClientUI.dbId+"&NAVIGTYPE="+ZDBNavigation.navSelect.value; //No I18N

        ZDBAlertAPI.showMsg(confirmMsg, "ZDBYESNO", {ONCLICK: this.deleteViews, PARAMS: params, DROPFIELDSCACHE: dropFieldsCache, OBJIDS: objsToDropCache, CHILDIDS: selIdArr}); //No I18N 
  }

  this.deleteViews = function(clickType, requestOptions)
  {
    if(clickType == "NO")
    {
      return;
    }
    var params = requestOptions["PARAMS"];
    var dropFieldsCache = requestOptions["DROPFIELDSCACHE"];
    var objsToDropCache = requestOptions["OBJIDS"];
    var childIds = requestOptions["CHILDIDS"];
    AjaxAPI.sendRequest({URL:"/ZDBDatabaseActionMI.ma?",PARAMETERS:params,DROPFIELDSCACHE:dropFieldsCache,OBJIDS:objsToDropCache,CHILDIDS:childIds,
                               ONSUCCESSFUNC:ZDBNavigation.handleDelSelViewsResp,
                               OPSTATUSID:"ZDBMainLoader"}); //No I18N 
  }

  this.handleDelSelViewsResp = function(response,requestOptions)
  {
    var params = response.getResponseParams();
        var objsToDel = params["OBJSTODEL"];//No I18N
        objsToDel = (objsToDel) ? objsToDel.split(",") : "";
    var dropFieldsCache = requestOptions["DROPFIELDSCACHE"];//No I18N
    var objsToDropCache = requestOptions["OBJIDS"];
    	var trashViewDiv = jQuery("#ZDBTABTPL.TrashTabObj")[0]; //No I18N
    	if(trashViewDiv)
    	{
    		ZDBTrash.fetchTrashObjectsListForDB(trashViewDiv);
    	}
    	ZDBClientUI.TBLLIST = null;
        jQuery("#ZRSelectAllViews").attr("checked",false); //No I18N
        for (var i = 0; i < objsToDel.length; i++) {
            ZDBExpViewHandler.removeElFromExpView(objsToDel[i], "");
  	  	}
  	  	ZDBNavigation.closeOpenedTabs();

    if(dropFieldsCache)
    {
    	for(var i=0; i<objsToDropCache.length; i++)
  	  	{
    		ZDBClientUtil.deleteJsonForObjId(objsToDropCache[i]);
  	  	}
    }
  }
  
  this.submitViewRenameDlg = function()
  {
    var txtFld = $('ZDBViewRenameTxtFld');
    var viewName = txtFld.value;
    var origViewName = txtFld.origVal;    
    
    var dlg = ZDBDialogUtil.focusDialog;
    var els = DOMUtils.getChildElsWithAttr(dlg,"elname","*")
    if(!validateFormElements(els,dlg))
    {
      return;
    }
            
    var descEl = $('ZDBViewDescTxtFld');
    var viewDesc = descEl.value;
    var origViewDesc = descEl.origVal;
    if(origViewName == viewName && viewDesc == origViewDesc)
    {
      ZDBDialogUtil.closeDialog();
      return;
    }
    ZDBNavigation.renameView(viewName,viewDesc, txtFld);
  } 
  
  this.renameView = function(displayName,desc, txtFld)
  {
    var element = ZDBNavigation.element;
    var objId = (!element) ? txtFld.getAttribute("objId") : element.getAttribute("objId");  
    var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?";
    var params = "&ZDBACTION=RENAMEOBJECT&DISPNAME=" + encodeURIComponent(displayName) + //No I18N 
                 "&DESCRIPTION=" + encodeURIComponent(desc) + "&OBJID=" + objId; //No I18N 
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:ZDBNavigation.renameObject,
                         ONFAILUREFUNC:ZDBNavigation.handleRenameFailure,
                         OPSTATUSID:"ZDBVIEWRENAMEOPTSTATUS", "OBJID": objId}); //No I18N 
  }
  
  this.renameObject = function(response, requestOptions)
  {
    ZDBDialogUtil.closeDialog();
    var params = response.getResponseParams();
    var displayName = params["DISPNAME"];
    var desc = params["DESCRIPTION"];
    var objId = requestOptions["OBJID"];
    var designModTime = params["DESIGNMODTIME"];
    var tab = ZDBClientUI.getExistingTab(objId);
    if(tab != null)
    {
      ZDBClientUI.updateDisplayName(tab,displayName,desc);
      tab.view.designModTime = designModTime;  
    }
    ZDBNavigation.renameObj(displayName,objId,desc);
  }
  
  this.renameObj = function(displayName,obId,desc)
  {
	  var displayDesc = (desc) ? desc : ZDBI18NMap.g("zrpt.common.js.NO_DESC");
      ZDBExpViewHandler.updateviewListData(obId, ZDBExpViewHandler.VIEW_NAME, displayName);
        var parentTr = ZDBNavigation.getElsFromtBody("attrAndVal", "objId", obId, "li"); //No i18N
        for (var i = 0; i < parentTr.length; i++) {
              var anchorEl = parentTr[i].getElementsByTagName("a");
                anchorEl[0].innerText = displayName;
                anchorEl[0].setAttribute("tip", displayName); //No i18N
            
            if (desc != null)
            {
                ZDBExpViewHandler.updateviewListData(obId, ZDBExpViewHandler.VIEW_DESC, desc);
                var descEl = parentTr[i].getElementsByClassName("ViewDesc")[0];
                if(descEl) {
                    descEl.innerHTML = ZDBEscapeUtil.encodeForHtml(displayDesc);
                }
            }
        }
      var objType= ZDBExpViewHandler.getviewListData(obId, ZDBExpViewHandler.VIEW_TYPE);
       if(objType == "Table" || objType == "QueryTable")
      {
    	  ZDBClientUtil.deleteJsonForObjId(obId);
      }

      jQuery('[elname = ZRNavigationViewList]').find("[objId ="+obId+"] .ZDBExpData").text(displayName).attr("tip", displayName);  //No i18N
    }    

  this.handleRenameFailure = function(response, requestOptions)
  {
    var errCode = response.getResponsePart("ERRORCODE");
    errCode = trimAll(errCode);
    if(errCode == "META_DBOBJECT_NAME_DUPLICATED")
    {
      ZDBMsgBox.showInfo(response.getResponsePart("STATUS_MESSAGE"));
    }
    else
    {
      AjaxAPI.onFailureFunc(response,requestOptions);
    }
  }
  
  this.moveTo = function(el)
  {
    ZDBNavigation.removeAutoGenTr();
    var folderId = el.getAttribute("folderId");
    var objId = ZDBNavigation.element.getAttribute("objId");
    var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?";
    var params = "&ZDBACTION=MOVETOFOLDER&OBJID=" + objId +"&FOLDERID="+folderId; //No I18N 
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:ZDBNavigation.moveResponse,OBJID:objId,FOLDERID:folderId, "NAVIGEL":ZDBNavigation.element,OPSTATUSID:"ZDBMainLoader"});

  }
  
  this.moveResponse = function(response,requestOptions)
  {
    var folderId = requestOptions["FOLDERID"];
    var objId = requestOptions["OBJID"];
    ZDBExpViewHandler.moveViewListToFolder(folderId, objId);
    var foldList = ZDBNavigation.getElsFromtBody("attrAndVal", "foldId", folderId, "li"); //No i18N
    var openFolders = ZDBNavigation.getNavigState("Folder");//No i18N
    var isFoldOpen = (openFolders.indexOf(folderId) >= 0);
    var folderState = (isFoldOpen || ZDBUtil.hasClass(ZDBNavigation.tBody.leftPanel, "inSearchMode") ) ? "" : "none"; //No i18N
    var viewList = ZDBNavigation.getElsFromtBody("attrAndVal", "objId", objId, "li"); //No i18N
    for(var i=0;i<viewList.length;i++){
    	var insertPosition = foldList[i];
    	jQuery(viewList[i]).insertAfter(insertPosition).css("display", folderState);
    }
    ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.common.showinfo.js.viewMovingInfo"));
  }

  this.openFolder = function(folder)
  {
      if(folder==null){return;}
           jQuery(folder).find(".foldNavIcon").attr("class","foldNavIcon foldCloseIcon"); //No i18N
           ZDBNavigation.folderOpenClose(folder);
  }
    
  this.folderMenu = function(event)
  {
    if(!event)
    {
      event = window.event;
    }
    var el = ZDBUtil.getSourceElement(event);
    ZDBNavigation.folder = DOMUtils.getParentWithAttr(el,"foldId");
    var contentName = (ZDBGlobal.newShareEnabled && !BROWSER.isIE9 == 1) ? "Folder_New_Option_Menu" : "Folder_Option_Menu"; // No I18N
    var menu = ZDBContentCache.appendAndGet(contentName,"GridMenu",document.body); 
    ZDBUtil.setNamedChildEls(menu,menu);
    var parentTr = ZDBNavigation.folder; 
    var display = (ZDBNavigation.folder.getAttribute("foldId") == ZDBExpViewHandler.defaultFolderId) ? "none" : ""; //No I18N
    menu.ZDBDeleteFolderWithViewOpts.style.display = display;
    menu.ZDBMakeFolderDefOpt.style.display = display;
    ZDBClientUI.arr = ZDBExpViewHandler.getfolderCount();
    display = (ZDBClientUI.arr.length > 1) ? "" : "none"; //No I18N
    $("ZDBFolderMoveAbove").style.display = display;
    $("ZDBFolderMASep").style.display = display;
    var menuEl = jQuery(menu);
    if(menuEl.attr("isEnableDisable") == "true")
    {
      ZDBMenu.enableDisableMenuItems(ZDBClientUI.selectedTab.view,menuEl.find("li a"),false);
    }
    if(jQuery(el).parents("#ZDBNavigationBarTD").length)
    {
          jQuery(menu).attr("isLeftNavItem","true");  //No I18N
    }
    ZRSMenu.showMenu(event,null,menu,1,ZDBNavigation.deHighlightParent);
    ZDBPopUpMenu.hideSeparator(menu);
    parentTr.menuOpened=true;
    ZDBNavigation.parentTr = parentTr;  
    ZDBUtil.stopEventBubble(event);
  }
  
  this.makeFolderDefault = function(el)
  {
      var folderId = ZDBNavigation.folder.getAttribute("foldId");
      var params = "FOLDERID=" + folderId + "&ZDBACTION=MAKEDEFAULT&REFRESHUI=true" //No I18N
        + "&DBID=" + ZDBClientUI.dbId; //No I18N
        AjaxAPI.sendRequest({URL:"/ZDBDatabaseActionMI.ma?",PARAMETERS:params,
                                   ONSUCCESSFUNC:ZDBNavigation.makeFolderDefaultResp,
                                   FOLDERID:folderId,
                                   OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }
  this.makeFolderDefaultResp = function(response, requestOptions)
  {
      ZDBExpViewHandler.makeFolderDefaultUpdate(requestOptions["FOLDERID"]);
  }
  
  this.showFolderOptionsSubMenu = function(element, event, menuName, moduleName)
  {
    var tempList = ZDBContentCache.appendAndGet("Folder_Temp_List",moduleName,document.body);
    var menuEl = ZDBContentCache.appendAndGet(menuName,moduleName,document.body);
        var optionList = $("ZDBFolderListItemBodyMA");
        ZDBUtil.removeAllChildren(optionList);
        ZDBUtil.removeNonElements(optionList);
        var trList = $("ZDBFolderTempListItem");
        var parentTr = ZDBNavigation.folder;
        var moveable = false;
        ZDBClientUI.arr = ZDBExpViewHandler.getfolderCount();
        var expArr = ZDBClientUI.arr;

        for(var i=0;i<expArr.length;i++)
        { 
          var tr = trList.cloneNode(true);
          tr.id = "";
           var folderId = expArr[i];
          var folderName = ZDBExpViewHandler.getFoldListData(folderId, 1);
         
          if((folderId != parentTr.getAttribute("foldId")))
          { 
            ZDBUtil.setNamedChildEls(tr,tr);
            tr.folderNameEl.innerHTML = ZDBEscapeUtil.encodeForHtml(folderName);
            tr.folderNameEl.setAttribute("folderId",folderId);
            tr.folderNameEl.setAttribute("title",folderName);
            tr.folderNameEl.onclick=ZDBNavigation.moveAbove;
            optionList.appendChild(tr);
            moveable = true;
          }
        }
        if(ZDBClientUI.arr.length > 11)
        {
          var div = $("ZDBFolderListDivMA");
          div.style.height = "200px";
          div.style.width = "190px";
        }        
        $("ZDBFolderListDivMA").style.display = (moveable) ? "" : "none"; //No I18N
       return ZDBPopUpMenu.subMenuEl(element,event,menuEl,false);
  }
   
  this.renameFolderDlg = function()
  {
    ZDBNavigation.removeAutoGenTr();
    if(!ZDBLazyLoadUtil.loadSnippet("RENAME_FOLDER_DLG","/ZDBRenameFolder.cc?",this,"APPENDTODOC"))
    {
      return;
    }
    var dlg = ZDBUtil.getCachedRef(this, "ZDBRENAMEFOLDERDLG");
    dlg.style.display = "block";
    var title = ZDBI18NMap.g("zrpt.common.folder.js.renameFolderDlgTtl",dlg);
    ZDBDialogUtil.showDialog(dlg,{TITLE:title,ADDFRAME:true,MODAL:true,ONENTER:ZDBNavigation.submitRenameFolder});
    var el = ZDBNavigation.folder; 
    var foldId =  el.getAttribute("foldId");
    $("ZDBFOLDERRENAME").value = ZDBExpViewHandler.getFoldListData(foldId, ZDBExpViewHandler.FOLD_NAME);
    $("ZDBFOLDERREDESC").value = ZDBExpViewHandler.getFoldListData(foldId, ZDBExpViewHandler.FOLD_DESC);
    $("ZDBFOLDERREOPTSTATUS").className="mcLoaded";
  }
  
  this.updateNavigState = function(folderId,toRemove,type)
  {
      var foldersOpened = ZDBNavigation.getNavigState(type);
      if(foldersOpened==null)
          {
              foldersOpened = new Array();
          }
      var len = foldersOpened.length;var position = null;
      for(var i=0; i<len; i++)
          {
              if(foldersOpened[i]==folderId)
                  { 
                      position = i;
                      break;
                  }
          }
          
      if(toRemove==true && position!=null)
          {
              foldersOpened.splice(position,1);//removes 1 element at the specified position of a array.
          }
          else if(toRemove==false && position==null)
           {
               foldersOpened.splice(len,0,folderId);
           }
           ZDBNavigation.saveNavigState(foldersOpened,type);
  }



  this.getNavigState = function(type)
  {
    var dbId = ZDBClientUI.dbId;
    var key=dbId+"_"+type+"_OPENED"; //No I18N
    var foldersOpened = ZDBUtil.getValueFromLocal(key);//No I18N
    if(foldersOpened==null){return null;}
    foldersOpened = foldersOpened.split(",");
    return foldersOpened;
  }
  
  this.saveNavigState = function(foldersOpened,type)
  {
      var dbId = ZDBClientUI.dbId;
      if(foldersOpened!=null)
          {
              var valueList = foldersOpened.valueOf();
              var key=dbId+"_"+type+"_OPENED"; //No I18N
              if(valueList=="")
                  {
                       ZDBUtil.deleteValueFromLocal(key);//No I18N
                  }
                  else
                      {
                       ZDBUtil.setValueToLocal(key,valueList);//No I18N
                      }
          }
  }
  
    this.manageFolderState = function()
    {
        var className = ZDBNavigation.getClassforViewBy();
        var rightPanelViewBy = ZDBUtil.getElWithTagNAttrWithVal(ZDBNavigation.rightExplorerView,"id", "ZRExpViewByOptn", "span");//No i18N
        rightPanelViewBy.className = "tIconbg " + className;
        $("ZRViewMenu").className = "tIconbg " + className;
        var navigType = ZDBNavigation.navSelect.value;
        if(navigType == "Related"){
            return;
        }
        var attrValue = (navigType == "All")?"type":"foldId" ;  //No i18N
        var foldList = ZDBNavigation.getElsFromtBody("attr", attrValue, null, "li"); //No i18N
        var foldToOpen = (navigType == "All") ? ["Table"] : ZDBNavigation.getFoldToOpenByDefault(); //No i18N
        var foldersOpened = ZDBNavigation.getNavigState(navigType);
        if(foldersOpened==null){
            if(foldToOpen==null){
                return;
            }
            foldersOpened = foldToOpen;
        }
        
        var openFolds = new Array();
        var openFoldEls = new Array();
        for(var j = 0; j < foldList.length;j++)
        {
            var foldAttrVal = foldList[j].getAttribute(attrValue);
            if(foldersOpened.indexOf(foldAttrVal) != -1){
                openFoldEls.push(foldList[j]);
                if(openFolds.indexOf(foldAttrVal) == -1){
                    openFolds.push(foldAttrVal);
                }   
            }
        }
        (navigType == "All")?ZDBNavigation.openTypesAtInitial(openFoldEls):ZDBNavigation.openFoldersAtInitial(openFoldEls); //No i18N
        ZDBNavigation.saveNavigState(openFolds,navigType);
    }
    this.getFoldToOpenByDefault = function(){
    	var firstFoldId = jQuery(ZDBNavigation.viewListBody).find('.ZDBfolderEl:first-child').attr("foldId"); //No i18N
    	foldToOpen = (ZDBExpViewHandler.defaultFolderId) ? ZDBExpViewHandler.defaultFolderId : firstFoldId;
    	return [foldToOpen];
    }
    this.openTypesAtInitial = function(typeEls)
    {
        for(var i = 0; i < typeEls.length; i++)
        {
            var type = typeEls[i].getAttribute("type");
            var childElsLength = ZDBExpViewHandler.getTypeViewList(type).length;
            var foldNav = typeEls[i].getElementsByClassName("foldNavIcon")[0];
            foldNav.className = "foldNavIcon foldOpenIcon";
            jQuery(typeEls[i]).nextAll("[elname = viewEl]").slice(0,childElsLength).show(); //No i18N
        }
    }
    this.openFoldersAtInitial = function(folderEls)
    {
        for(var i = 0; i < folderEls.length; i++)
        {
            var folderId = folderEls[i].getAttribute("foldId");
            var childElsLength = ZDBExpViewHandler.getfolderChild(folderId).length;
            var foldNav = folderEls[i].getElementsByClassName("foldNavIcon")[0];
            foldNav.className = "foldNavIcon foldOpenIcon";
            jQuery(folderEls[i]).nextAll("[elname = viewEl]").slice(0,childElsLength).show(); //No i18N
        }
    }
  this.openFolderWithFolderId = function(folderId)
  {
    if(folderId==null){return;}
    var swipe = ZDBNavigation.viewListBody;
    var folder = DOMUtils.getFirstMatchingChild(swipe,"li","foldId",folderId);//No I18N
    ZDBNavigation.openFolder(folder);
  }


  this.getAllFolders = function()
  {
      //Cache the folder list
      var swipe = ZDBNavigation.viewListBody;
      var folders = DOMUtils.getNodes(swipe,"foldId");//No I18N
      var len = folders.length;
      var folder = null;var folderId = null;
      var foldersMap = new Object();
      for(var i=0; i<len; i++)
          {
              folder = folders[i];
              folderId = folder.getAttribute("foldId");
              foldersMap["ID_"+folderId] = folder;
          }
          
      return foldersMap;
  }
  
  this.folderOpenClose = function(el)
  {
    var status = jQuery(el).find(".foldNavIcon").hasClass("foldOpenIcon"); //No I18N
    var display = (status) ? "none" : ""; //No I18N
    var toggleFoldClass = (status) ? "foldCloseIcon" : "foldOpenIcon"; //No I18N
    var foldId = el.getAttribute("foldId"); //No i18N
    var folder;
    var childList;
    if(foldId == "" || !foldId) // #reference - navigType: All
    {
        var typeOfView =  el.getAttribute("type"); //No i18N
         // #reference - folder: corresponding type folder Li 
        folder = ZDBNavigation.getElsFromtBody("attrAndVal", "type", typeOfView, "li"); //No I18N
        childList = ZDBExpViewHandler.getTypeViewList(typeOfView); // #reference - childList: respective child element Ids
        ZDBNavigation.updateNavigState(typeOfView,status,ZDBNavigation.navSelect.value); //No I18N
    }
    else // #reference - navigType: Folder
    {
        // #reference - folder: corresponding folder Li
        folder = ZDBNavigation.getElsFromtBody("attrAndVal", "foldId", foldId, "li"); //No I18N
        childList = ZDBExpViewHandler.getfolderChild(foldId); // #reference - childList: respective child element Ids
        if(!childList){return;}
        ZDBNavigation.updateNavigState(foldId,status,ZDBNavigation.navSelect.value); //No I18N
    }
    // #reference - hiding the immediate child elements through slicing
        for(var i=0; i<folder.length; i++){
            var foldEl = folder[i];
           jQuery(foldEl).nextAll("[elname = viewEl]").slice(0,childList.length).css("display", display); //No I18N  
           var foldNav = foldEl.getElementsByClassName("foldNavIcon")[0]; //No I18N
           foldNav.setAttribute("class","foldNavIcon "+toggleFoldClass); //No I18N
        }

  }
  
  this.submitRenameFolder = function()
  {
    var dlg = ZDBDialogUtil.focusDialog;
    var els = DOMUtils.getChildElsWithAttr(dlg,"elname","*");
    if(!validateFormElements(els,dlg))
    {
       return;
    }
    var folderName = $("ZDBFOLDERRENAME").value;
    var folderDesc = $("ZDBFOLDERREDESC").value; 
    var folderId = ZDBNavigation.folder.getAttribute("foldId");   
    
    var dbId = ZDBClientUI.dbId;
    var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?";
    var params = "&ZDBACTION=RENAMEFOLDER&FOLDERNAME=" + encodeURIComponent(folderName) + //No I18N 
                 "&FOLDERDESC=" + encodeURIComponent(folderDesc) + "&FOLDERID=" + folderId + "&DBID=" + dbId; //No I18N 
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,ONSUCCESSFUNC:ZDBNavigation.renameFolderResp,ONFAILUREFUNC:ZDBNavigation.handleFolderRenameFailure,
                         OPSTATUSID:"ZDBFOLDERREOPTSTATUS","FOLDERNAME":folderName,"FOLDERDESC":folderDesc,"FOLDERID":folderId}); //No I18N 
  }

  this.renameFolderResp = function(response, requestOptions)
  {
    var folderId = requestOptions["FOLDERID"];
    var folderName = requestOptions["FOLDERNAME"];
    var folderDesc = requestOptions["FOLDERDESC"];
    
    for(var key in ZDBNavigation.tBody)
    {
      var li = ZDBUtil.find(ZDBNavigation.tBody[key], "class", null, "ZDBfolderEl", "li"); //No i18N
      for(var i = 0; i < li.length; i++)
      {
           var foldList = jQuery(li[i]);
        if(foldList.attr("foldId") == folderId)
        {
          ZDBExpViewHandler.updateFoldListData(folderId, ZDBExpViewHandler.FOLD_NAME, folderName);
          ZDBExpViewHandler.updateFoldListData(folderId, ZDBExpViewHandler.FOLD_DESC, folderDesc);
          foldList.find(".ZDBExpData").text(folderName);
            foldList.find(".ViewDesc").text(folderDesc);
            if(folderDesc && key == "rightPanel")
            {
            	foldList.find(".ViewDesc").css("display","block"); //No i18N
            }
            else{
            	foldList.find(".ViewDesc").hide();
            }
        }
      }
    }       
    ZDBDialogUtil.closeDialog();
  }

  this.removeObjects = function(objIds,objType)
  {
    var listEls = [ZDBClientUI["ObjectsList"],this.viewListBody];
    if(listEls[0] == null)//It will be null in the case of integrated.
    {
      return;
    }
    
    for(var n =0; n < listEls.length;n++)
    {
      var childEls = listEls[n].getElementsByTagName("li");
      for(var k = 0; k < objIds.length; k++)
      {
        var objId = objIds[k];
        for(var i=childEls.length -1;i > -1; i--)
        {     
          if(childEls[i].getAttribute("objid") == objId)
          {
            childEls[i].parentNode.removeChild(childEls[i]);
            break;
          }
        }
      }
    }

  }

  this.handleFolderRenameFailure = function(response, requestOptions)
  {
    var errCode = response.getResponsePart("ERRORCODE");
    errCode = trimAll(errCode);
    if(errCode == "META_FOLDER_NAME_DUPLICATED")
    {
      ZDBMsgBox.showInfo(response.getResponsePart("STATUS_MESSAGE"));
    }
    else
    {
      AjaxAPI.onFailureFunc(response,requestOptions);
    }
  }


  this.setNavigationType = function(opt)
  {
    if(opt != null)
    {
        if(ZDBNavigation.navSelect.value == opt) {
            return;
        }
        else {
            ZDBNavigation.navSelect.value = opt;
        }
    }
    var params = "DBID=" + ZDBClientUI.dbId + "&NAVIGTYPE=" + ZDBNavigation.navSelect.value; //No i18N
    var url = "/ZDBDatabaseActionMI.ma?ZDBACTION=SAVENAVIGPREF";//No I18N 
    var loadingDiv = ZDBNavigation.explorerTab.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.loadingdiv.js.loading")); //No i18N
  	   AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
                               ONSUCCESSFUNC:this.handleNavigStChange,
                               DBID:ZDBClientUI.dbId, //No I18N 
                               OPSTATUSID:loadingDiv});   
  }
  
  this.handleNavigStChange = function(response, requestOptions)
  {
      ZDBExpViewHandler.switchNavigationType(ZDBNavigation.navSelect.value);  
  }
  
  this.clearSearchState = function(searchSpace)
  {
      var elsDisplay = searchSpace.querySelectorAll("[elname = viewEl], .viewSeparator, .ZDBfolderEl"); //No I18N
      var toDisplay = (ZDBNavigation.navSelect.value == "Related") ? "block" : "none"; //No I18N
      for(var i = 0; i < elsDisplay.length; i++ ) {
          var elName = elsDisplay[i].getAttribute("elname");
          elsDisplay[i].style.display = (elName == "viewEl") ? toDisplay : "block";
      }
      ZDBNavigation.manageFolderState();
  }
  this.refreshExplorer = function(el, fromSearch)
  {
    ZDBNavigation.removeAutoGenTr();
    ZDBExpViewHandler.clrExpViewHandlerVar();
    ZDBExpViewHandler.valueFetch(ZDBClientUI.dbId, ZDBNavigation.navSelect.value);//No I18N
    if(!fromSearch)
    {
    	var trashViewDiv = jQuery("#ZDBTABTPL.TrashTabObj")[0]; //No I18N
    	if(trashViewDiv)
    	{
    		ZDBTrash.fetchTrashObjectsListForDB(trashViewDiv);
    	}
    }
  }
 
  this.showCreateOpts = function(){
	  if(ZDBClientUI.isRemoteDB)
	    {
	    jQuery(ZDBNavigation.rdbLinkTablesOpt).show();
	    }
	    else
	    {
	        jQuery(ZDBNavigation.createNimportOpt).show();
	    }
            var expRightView = jQuery(ZDBNavigation.rightExplorerView );
	    expRightView.find(".toolbarSeparator, .secondRow").hide();
	    jQuery(ZDBNavigation.viewListBody).hide();
  }
  
  this.showViewByOpts = function(el,event,fromExplorer)
  {
      var menu = ZDBContentCache.appendAndGet("Nav_ViewBy_Menu","GridMenu",document.body);
      var menuEl = jQuery(menu);
      if(fromExplorer)
      {
      	ZRSMenu.showMenu(event,el,menu,2);
        menuEl.children('span').hide(); //No I18N
			}
      else
      {
          ZRSMenu.showMenu(event,el,menu,5);
          menuEl.children('span').show(); //No I18N
          var top = menuEl.position().top;
         	var left = menuEl.position().left;
         	menuEl.css({top:top + 14,left:left - 9});
			}
  }
  
	
  this.highlightSelectedInNavList = function()
  {
    var tab = ZDBClientUI.selectedTab;
    if(tab == null || tab.view instanceof DummyView)
    {
      return;
    }
    var objId = tab.view.objId;
    var viewSelectedInNav = $("ZRViewSelectedInNav");
    if(viewSelectedInNav){
        viewSelectedInNav.id = "";
    }	    
    var li = jQuery(ZDBClientUI["ObjectsList"]).find("li[objId='" + objId + "']").get(0); //No i18N
    if(li){
        li.setAttribute("id","ZRViewSelectedInNav");
    }
    ZDBNavigation.selectedElement = li;
    }

  this.minMaxLayout = function(iconTD)
  {
    var layoutMode = iconTD.getAttribute("layoutMode")
    var tabsHolderParent = $("TABSHOLDERPARENT");
    var navigationBarTD = $("ZDBNavigationBarTD");
	var header = $("ZDBHEADER");
    var icon = $("ZDBShowHideNavigIcon");
		
    var view= ZDBClientUI.selectedTab.view;
    if(layoutMode=="normal")
    {
      tabsHolderParent.className="normal";
      navigationBarTD.style.display = "none";
      header.style.display = "none";
      iconTD.setAttribute("layoutMode","max");
      ZDBClientUI.layoutMode="max";
      ZDBNavigation.changeNavigationState(true);
      icon.style.visibility = "hidden";
  	  $("ZR_UnHideNavPanel").style.display="none"; //No I18N
    }
    else
    {
      tabsHolderParent.className="max";
      navigationBarTD.style.display = "";
			header.style.display = "";			
      iconTD.setAttribute("layoutMode","normal");
      ZDBClientUI.layoutMode="normal";
      ZDBNavigation.changeNavigationState(false);
      ZDBNavigation.showOrHideNavIcon(view);
      $("ZR_UnHideNavPanel").style.display=""; //No I18N
  	  ZDBMenu.resizeTitleNDesc(view.toolbar);
    }
   
    view.layoutModeChanged();
    document.body.prevClientWidth =0;
    ZDBClientUI.resizeAllDInst();
    var trash = jQuery("#TrashObjectListContainer"); //No I18N
    if(trash.length > 0)
    {
    	ZDBTrash.resizeTrashListSize();
    }
  }

  this.changeNavigationState = function(hidden)
  {
      var icon = $("ZR_UnHideNavPanel");
			if(!hidden)
       {
           if(ZDBNavigation.hiddenState) 
           {
            icon.className ="navUnHideOpt";
            jQuery(icon).parent().attr("class","navHidden");//No I18N
            jQuery("#ZDBNavigationBarTD").show().css({"position":"absolute","z-index":"10000","box-shadow":"0px 4px 10px #666666","left":"-256px"});//No I18N
            ZDBNavigation.isNavHiddenForEditDesign=false;
           }
          else
         {
           var view =ZDBClientUI.selectedTab.view;
           var viewType=(ZDBClientUI.selectedTab.view.type).toLowerCase();
           if(!(view.editMode && (viewType=="analysisview" || viewType=="pivot" || viewType=="summaryview"))) 
           {
            icon.className ="navHideOpt";
            jQuery("#ZDBNavigationBarTD").stop(true,true).css({"position":"","z-index":"","box-shadow":""}).show(); //No I18N
            jQuery("#showNavPermanent").hide(); //No I18N
           }
         }
       }
       else
       {
           ZDBNavigation.isNavHiddenForEditDesign=false;
           jQuery("#ZDBNavigationBarTD").stop(true,true).hide(); //No I18N
           jQuery("#ZRFieldListTD").hide();  //No I18N
       }  
  }
  
  this.moveAbove = function()
  {
    var folderId = this.getAttribute("folderId");
    var dbId = ZDBClientUI.dbId;
    var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?";
    var params = "&ZDBACTION=MOVEFOLDERABOVE&DBID=" + dbId  //No I18N 
    + "&MOVEFOLDER=" + ZDBNavigation.folder.getAttribute("foldId") //No I18N 
    + "&MOVEABOVE="+folderId //No I18N 
    + "&NAVIGTYPE=" + ZDBNavigation.navSelect.value; //No I18N 
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
                         ONSUCCESSFUNC:ZDBNavigation.handleViewsListResp,
                         FOLDERID:folderId,OPSTATUSID:"ZDBMainLoader"}); //No I18N 
  }
  
  this.renameDB = function(el)
  {
    if(!ZDBLazyLoadUtil.loadSnippet("RENAMEDB_DLG","/ZDBRenameDB.cc",this,"APPENDTODOC"))
    {
      return;
    }
    var renameDBDiv = ZDBUtil.getCachedRef(this, 'ZDBRenameDBDetails');
    renameDBDiv.style.display = 'block';
    var dbNameFld = $('ZDBDBNameTxtFld');
    var dbDescFld = $('ZDBDBObjDescTxtFld');
    var dbName = ZDBUtil.getText($("ZDBEXDBNAME"));
    var desc = ZDBUtil.getText($("ZDBEXDBDESC"));
    var dbId = ZDBClientUI.dbId;
    dbNameFld.value = dbName.trim();
    dbDescFld.value = desc.trim();
    ZDBDialogUtil.showDialog(renameDBDiv,{TITLE:ZDBI18NMap.g('zrpt.common.home.js.renamedb'),ADDFRAME:true,MODAL:true,DONTREMOVE:true,
                                          ONENTER:submitRenameDB,ORIGNAME:dbName,ORIGDESC:desc,CALLOUT:true,SRCEL:el,
                                          NAMEFLD:dbNameFld,DESCFLD:dbDescFld,DBID:dbId});
    $('ZDBDBRENAMEOPTSTATUS').className = 'mcLoaded';                     
    dbNameFld.select();
  } 
  this.setEditable = function(el){
	  var dbNameEl = jQuery(el);
	  var inEditMode = dbNameEl.siblings(".setEditable"); //No I18N 
	  if(!inEditMode.length){ return;}
	  dbNameVal = dbNameEl.text();
	  dbNameEl.removeClass("showDBEdit").addClass("setDBEdit"); //No I18N 
	  var inpSize = dbNameVal.trim().length;
	  inEditMode.val(dbNameVal.trim());
	  var inpWidth = dbNameEl.width();
	  dbNameEl.siblings(".fLeft").hide(); //No I18N 
		var dbNameLen = dbNameEl.html(inEditMode);
		inEditMode.width(inpWidth).show().focus();
  }
  this.showEditable = function(el)
  {
	  var editableEl = jQuery(el);
	  if(!editableEl.has("input").length) {
		  editableEl.removeClass("setDBEdit").addClass("showDBEdit"); //No I18N 		  
	  }
  }
  this.hideEditable = function(el)
  {
	  var editableEl = jQuery(el);
	  if(!editableEl.has("input").length) {
		  editableEl.removeClass("setDBEdit, showDBEdit"); //No I18N 		  
	  }
  }
  
  this.updateDBDetails = function(params)
    {
        var dbName = ZDBEscapeUtil.encodeForHtml(params["DBNAME"]);
        var dbdesc=ZDBEscapeUtil.encodeForHtml(params["DESC"]);
        $("ZDBDBNAME").innerText = dbName;
        $("ZDBEXDBNAME").innerText = dbName;
        $("ZDBEXDBDESC").innerHTML = dbdesc;
        typeof ZRCRMPlus !== 'undefined' && ZRCRMPlus.pushChanges(ZRCRMPlus.RENAMEDATABASE, ZDBClientUI.dbId, dbName);//NO I18N
    }
  
    this.getExplorerData=function()
    {
        var exptab=jQuery("#ZDBTABTPL.ExplorerObj")[0];
        return jQuery(exptab.view.tab.comp);
    }
  
  this.loadFolderList = function(spanId,opStatusId,folderId)
  {
    folderId = folderId != null ? folderId : ZDBExpViewHandler.defaultFolderId;
    var params = "DBID=" + ZDBClientUI.dbId+"&SPANID=" + spanId;
    var url = ZDBGlobal.CTX + "/ZDBFolderListComboMI.ma?"
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
                         ONSUCCESSFUNC:"ZDBNavigation.showFolderListCombo","SPANID":spanId,"FOLDERID":folderId, //No I18N 
                         OPSTATUSID:opStatusId});
  }
  
  this.showFolderListCombo = function(response, requestOptions)
  {
    var div = document.createElement("div");
    div.innerHTML = response.getOnlyHtml();
    var spanId = requestOptions["SPANID"];
    var folderId = requestOptions["FOLDERID"];
    var folderEl = div.getElementsByTagName("select")[0].cloneNode(true);
    var divEl = div.getElementsByTagName("option");
    if(folderId != -1)
    {
            for(var i=0,j=divEl.length;i<j;i++)
            {
               var el = div.getElementsByTagName("option")[i];
               if(el.value == folderId)
               {
                  folderEl.selectedIndex = divEl.length-2;
               }
            }
    }
    folderEl.value = folderId;
    folderEl.style.width = '250px'; //No I18N
    if(spanId == 'ZDBTemplateFolderItemList')
    {
      folderEl.style.width = '100%'; //No I18N
    }
    var span = ZDBUtil.getCachedRef(this,spanId);
    ZDBUtil.removeAllChildren(span);
    span.appendChild(folderEl); 
  }
  
  this.selectFolder = function(spanId)
  {
      if($(spanId).value == "newFolder")
      {
        ZDBNavigation.showCreateFolderDlg(spanId);
      }
  }

  this.deleteFolderAndViews = function()
  {
    var folderId = ZDBNavigation.folder.getAttribute("FoldId");
    var folderName = ZDBExpViewHandler.getFoldListData(folderId, ZDBExpViewHandler.FOLD_NAME);
    var childIds = ZDBExpViewHandler.getfolderChild(folderId);
    var tableNames = "";
    for(var i =0; i < childIds.length; i++) {
        var viewInfo = ZDBExpViewHandler.fetchViewListInfo(childIds[i]);
        var type = viewInfo[ZDBExpViewHandler.VIEW_TYPE];
        if(type == "Table" || type == "QueryTable") {
            var name = viewInfo[ZDBExpViewHandler.VIEW_NAME];
            var sep = " \n -  ";
            tableNames = tableNames + sep + name;
        }
    }
    var delWithTable = ZDBI18NMap.f("zrpt.common.analysis.js.foldDelTblWithDepViewConfirm", "table", ZDBEscapeUtil.encodeForHtml(tableNames), "table");
    var delWithoutTable = ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.delFolderWithViewsConfirm");
    var confirmMsg = (tableNames != "") ? delWithTable : delWithoutTable;
    ZDBAlertAPI.showMsg(confirmMsg,
                        "ZDBYESNO",{ONCLICK:ZDBNavigation.deletefolderViews, FOLDERID: folderId,FOLDERNAME: folderName}); //No I18N 
  }
  
  this.deletefolderViews = function(clickType,requestOptions)
  {
    if(clickType != "YES")
    {
      return;
    }
    var params = "FOLDERID=" + requestOptions["FOLDERID"] + "&ZDBACTION=DELETEFOLDERANDVIEWS&REFRESHUI=true" //No I18N 
    + "&DBID=" + ZDBClientUI.dbId //No I18N 
    + "&NAVIGTYPE=" + ZDBNavigation.navSelect.value; //No I18N 
    AjaxAPI.sendRequest({URL:"/ZDBDatabaseActionMI.ma?",PARAMETERS:params,
                               ONSUCCESSFUNC:ZDBNavigation.handleDelFolderAndViewsResp,
                               FOLDERID:requestOptions["FOLDERID"],FOLDERNAME:requestOptions["FOLDERNAME"],
                               OPSTATUSID:"ZDBMainLoader"}); //No I18N 
  }
  
  this.handleDelFolderAndViewsResp = function(response,requestOptions)
  {
        var folderId = requestOptions["FOLDERID"];
    var params = response.getResponseParams();
        var objsToDel = params["OBJSTODEL"];
        objsToDel = (objsToDel && objsToDel != "null") ? objsToDel.split(",") : []; //No i18N
        ZDBExpViewHandler.removeFoldRelViews(folderId, objsToDel);
      var trashViewDiv = jQuery("#ZDBTABTPL.TrashTabObj")[0]; //No I18N
	  if(trashViewDiv)
	  {
	  	ZDBTrash.fetchTrashObjectsListForDB(trashViewDiv);
	  }
      ZDBNavigation.closeOpenedTabs();
    }
  
  this.closeOpenedTabs = function()
  {
    var childNodes = ZDBClientUI.$$("ZDBTABCONT").childNodes;    
    var tbody = ZDBClientUI["Objects_TBODY"];
    var trList = tbody.getElementsByTagName("li");
    for(var i = 0; i < childNodes.length; i++)
    {
      var child = childNodes[i];
      var childObjId = child.view.objId;
      if((childObjId == "Explorer") || (childObjId < 0))
      {
        continue;
      }
      var toClose = true;
      for(var j = 0; j < trList.length; j++)
      {
        var objId = trList[j].getAttribute("objId");
        if(childObjId == objId)
        {
          toClose = false;
          break;
        }
      }
      if(toClose)
      {
        ZDBClientUI.removeTab(child);        
        i--;
      }
    }
  }
  
  this.shareThisViewFromExplore = function()
  { 
	  if(ZDBGlobal.IS_ONPREMISE_BUILD)
      {
        var IsConfigured = zroptopbar.isMailConfigured();   
        if(!IsConfigured)
        {
          ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrop.mail.notify.js.errorMsg",ZROPConst.MALTABADDR));
          return;
        }
      }
    ZDBNavigation.removeAutoGenTr();
    ZDBSecuritySettings.showShareDetails(ZDBNavigation.element,'ShareThisViewFromExpMode'); //No i18N
  }

//  this.showExportSubMenu = function(element, event, menuName, moduleName)
//  {
//      ZDBNavigation.removeAutoGenTr();
//      ZDBExport.showExportSubMenu(ZDBNavigation.element, event,'Single_View_Export_Menu','GridMenu',true);//No I18N
//  }

  this.editSharedDetailsFromExplore = function()
  {
    ZDBNavigation.removeAutoGenTr();
    ZDBSecuritySettings.showShareDetails(ZDBNavigation.element,'EditFromExpMode'); //No i18N
  }

  this.getAutoGenTr = function(parentEl)
    {
        var liList = parentEl.getElementsByTagName("li");
        for(var i=0,j=liList.length; i< j;i++)
        {
            if(liList[i].getAttribute("newreportstr") == "true")
            {
               return liList[i];
            }
        }
        return null;
    }

    this.removeAutoGenTr = function()
    {
        for(var key in ZDBNavigation.tBody)
        {
            var liList = ZDBUtil.find(ZDBNavigation.tBody[key], "tag", null, null, "li"); //No i18N
            for(var i=0,j=liList.length; i< j;i++)
            {
                var el = liList[i];
                if(el.getAttribute("newreportstr") == "true")
                {
                   el.parentNode.removeChild(el);
                   break;
                }
            }
        }
        var autoGenResult = $('AutoGenResult');
        if(!autoGenResult){ return;}
        autoGenResult.setAttribute("comingfrom", "NONE");  //No i18N
        autoGenResult.setAttribute("message", "NOMESSAGE");  //No i18N
        autoGenResult.setAttribute("folderId", -1);  //No i18N
        
    }

    this.getSelectedViewIdsInExplorer = function()
    {
        var objIds = [];
        var views = $("ZDBVIEWLISTS").getElementsByClassName("viewSelect");  //No i18N
        for(var i = 0, j = views.length; i < j; i++) {
            var objId = views[i].getAttribute("objId");  //No i18N
            objIds.push(objId);
        }
       return objIds;
    }

    this.getViewIdsFromFolder = function () {
        var views = this.getAllViewsFromFolder();
        var objIds = [];
        for (var i = 0; i < views.length; i++) {
            var view = views[i];
            objIds.push(DOMUtils.getElOrParentWithAttr(view, 'objId').getAttribute('objId')); //No I18N
        }
        return objIds;
    };

    this.unCheckAndDeselectAllSelectedViews = function()
    {
    	var selectedEls = ZDBNavigation.viewListBody.getElementsByClassName("viewSelect"); //No I18N
        while( selectedEls.length ) {
            var view = selectedEls[0];
            view.getElementsByTagName("input")[0].checked = false; //No I18N\
            ZDBUtil.removeClass(view, "viewSelect"); //No i18N
        }
        jQuery("#ZRSelectAllViews").attr("checked",false);  // No I18N
    }
    
    this.showOrHide = function(el,setForcefully)
    {
       if(setForcefully!=null && el!=null){el.setAttribute("ishidden",setForcefully.toString());}
       var isHidden = (el.getAttribute("ishidden")=="true");
       var navigationBarTD = $("ZDBNavigationBarTD");
       var view = ZDBClientUI.selectedTab.view;
       var dbId = ZDBClientUI.dbId;
       if(isHidden)
           {
               ZDBNavigation.fixNavBar(jQuery("#showNavPermanent").get(0));//No I18N
               return;
           }
           else if(ZDBNavigation.isNavHiddenForEditDesign && view.editMode)
           {
               return;
           }
           else
           {
               jQuery("#ZDBNavigationBarTD").css({"position":"absolute","z-index":"10000","box-shadow":"0px 4px 10px #666666","left":"-256px"});//No I18N
                el.className ="navUnHideOpt"; //No I18N
                jQuery(el).parent().attr("class","navHidden");//No I18N
                ZDBNavigation.isNavHiddenForEditDesign=false;
                jQuery(document.body).unbind("mouseover"); //No I18N
                 window.localStorage.setItem(dbId+"_SHOW_NAV_BAR","false");//No I18N
           }
       el.setAttribute("isHidden",(!isHidden).toString());
       view.layoutModeChanged();
       document.body.prevClientWidth =0;
       ZDBNavigation.hiddenState = !isHidden;
       var viewType = (view.type).toLowerCase();
       if(!view instanceof DummyView && (viewType=="analysisview" || viewType=="pivot" || viewType=="summaryview"))
           {
               view.eModeHelper.showFieldsIfNeeded(view);
           }
       ZDBClientUI.resizeAllDInst();
    }
    
    
    this.popOutNavigation=function(el)
    { 
    if(((ZDBNavigation.isNavHiddenForEditDesign && ZDBClientUI.selectedTab.view.editMode) || ZDBNavigation.hiddenState) && !ZDBNavigation.popOut)
        {
    ZDBNavigation.popOut=true;
    if(!ZDBClientUI.selectedTab.view.editMode)
        {
            jQuery("#showNavPermanent").show(); //No I18N
        }
        else
        {
            jQuery("#showNavPermanent").hide(); //No I18N
        }
        ZDBClientUI.resizeSwipe();
       jQuery("#ZDBNavigationBarTD").stop(true,true).delay(500).animate({left:'0px'},'fast',function(){//No I18N
       jQuery(document.body).bind("mouseover",function(event) {
        var targetEl=jQuery(event.target);
        var isNavBarsChild=((targetEl.attr("isLeftNavItem")) || targetEl.parents("[isLeftNavItem]").length);//No I18N
        ZDBNavigation.popInNavigation(!isNavBarsChild);
        });
    }); 
    }
    
   
    }
    
    this.popInNavigation=function(hideNav)
    {
        if(hideNav)
        {
        if(ZDBNavigation.isNavHiddenForEditDesign)
        {
            var view =ZDBClientUI.selectedTab.view;
            var viewType=(ZDBClientUI.selectedTab.view.type).toLowerCase();
            if(view.editMode && (viewType=="analysisview" || viewType=="pivot" || viewType=="summaryview"))
                {
                    ZDBAnalysisEditViewMode.showFieldsNHideNav(view,true);
                }
                else 
                {
                    var el=jQuery("#showNavPermanent").get(0); //No I18N
                    ZDBNavigation.fixNavBar(el);
                 }
        }
        else
        {
        var navBar=jQuery("#ZDBNavigationBarTD"); //No I18N
        navBar.stop(true,true);//No I18N
        navBar.css({"left":"0px"}).animate({left:'-256px'},'fast'); //No I18N
        jQuery("#ZRFieldListTD").hide(); //No I18N
        }
        ZDBNavigation.popOut=false;
        jQuery(document.body).unbind("mouseover"); //No I18N
        }
    }
    
    this.fixNavBar=function(el,event)
    {
        var view =ZDBClientUI.selectedTab.view;
        var viewType=(ZDBClientUI.selectedTab.view.type).toLowerCase();
        if(!(view.editMode && (viewType=="analysisview" || viewType=="pivot" || viewType=="summaryview"))) 
        {
        jQuery(el).hide();
        jQuery("#ZR_UnHideNavPanel").parent().attr("class","navShown");//No I18N
        jQuery("#ZR_UnHideNavPanel").attr("ishidden",false).attr("class","navHideOpt"); //No I18N
        ZDBNavigation.hiddenState=false;
        jQuery("#ZDBNavigationBarTD").stop().css({"position":"","z-index":"","box-shadow":""}); //No I18N
        ZDBNavigation.popOut=false;
        document.body.prevClientWidth =0;
        var tab = ZDBClientUI.selectedTab;
        if(tab)
    	{
        	var view = tab.view; 
        	ZDBMenu.resizeTitleNDesc(view.toolbar); //Toolbar title resize
    	}        
        ZDBClientUI.resizeAllDInst();
        jQuery(document.body).unbind("mouseover"); //No I18N
        ZDBUtil.stopEventBubble(event);
        var dbId = ZDBClientUI.dbId;
        window.localStorage.setItem(dbId+"_SHOW_NAV_BAR","true"); //No I18N
    }
    }
    
    this.applyInterval = function(interval){
    	var intervalInMilliSeconds = interval * 1000;
    	setInterval(this.refreshView, intervalInMilliSeconds);
    }
    
    this.refreshView = function(){
    	var view = ZDBClientUI.selectedTab.view;
    	if(view.type == "Dashboard"){
    		ZDBDashboardAPI.refreshViews(document.getElementById("ZDBViewEl"));
    	}else{
    		view.refreshView();
    	}
    }
    
    this.listTabs = function(el, event)
    {
      var tabs = ZDBClientUI.$$("ZDBTABCONT").childNodes;
      var len = tabs.length;
      var menu =ZDBContentCache.appendAndGet("Tab_List","GridMenu", document.body);
      var ulEl = jQuery(menu).children('ul'); //No i18N
      ulEl.empty();
      var listEl = jQuery("<li style='line-height:26px;'><a class='ZRShowInputOnHover ellipsis' style='max-width:235px;' onclick='ZDBClientUI.selectTabFromList(this);'><span class='tabIcon' style='padding: 3px 5px 5px 20px'></span><span></span><input onclick='ZDBClientUI.removeTabFromList(this,event);' type='button' class='close' style='display:none; position: absolute; top: 2px; left: 240px;'></a></li>"); 
      for(var i=0; i< len; i++)
      {
        ZDBNavigation.createList(listEl.clone(),tabs[i],ulEl);    
      }
      menu.style.height = (len > 15) ? "390px" : "auto";   
      menu.style.width="255px";
      ZDBUtil.setTooltipForMenuItems(ulEl, event);	  
      ZRSMenu.showMenu(event, el, menu, 1);
      var position=jQuery(menu).position();
      jQuery(menu).css({"top":position.top+5,"left":position.left+6});//No i18N
    }
    
    this.createList=function(li,tab,ulEl)
    {
        var spanEls = jQuery(li).find("span"); //No i18N
        if(!tab.view) {
        	return;
        }
        var dispName = tab.view.displayName;
        if(tab.view.type == "NewOption") {
        	var className = (dispName == ZDBI18NMap.g("zrpt.common.js.newReport")) ? "NewOption AnalysisView" : "NewOption Table";    //No I18N
        	li.children().addClass(className + "Obj ");
        }
        else {
        	li.children().addClass(tab.view.type + "Obj ");
        }
        spanEls[1].innerHTML= ZDBEscapeUtil.encodeForHtml(dispName);
        if((tab==ZDBClientUI.selectedTab))
      	{
        	jQuery(spanEls[1]).css("font-weight","bold"); //No i18N
      	}
        li.attr('tip', dispName); //No i18N
        li[0].tabRef = tab;
        tab.listItem = li[0];
        ulEl.append(li);
     }
}

ZDBNavigation.showOrHideNavToggleIcon = function()
    {
        var icon = (ZDBNavigation.toggleIcon==null)?$("ZDBShowHideNavigIcon"):ZDBNavigation.toggleIcon;
        ZDBNavigation.toggleIcon = icon;
        var view = ZDBClientUI.selectedTab.view;
    }

ZDBNavigation.showOrHideNavIcon = function(view,modeChanged)
{
    var icon = (ZDBNavigation.toggleIcon==null)?$("ZDBShowHideNavigIcon"):ZDBNavigation.toggleIcon;
    ZDBNavigation.toggleIcon = icon;
    if(view==null){return;}
    var viewType = view.type.toLowerCase();
    var visibility = ((viewType == "analysisview" ||  viewType == "pivot" || viewType == "summaryview" || viewType == "dashboard"))?(view.editMode==true)?"hidden":"visible":"visible"; //No I18N
    icon.style.visibility = visibility;

    if(modeChanged==true && (viewType == "analysisview" ||  viewType == "pivot" || viewType == "summaryview"))
        {
            view.layoutModeChanged();
            document.body.prevClientWidth =0;
            ZDBClientUI.resizeAllDInst();
        }

}

ZDBNavigation.handleLayoutMode = function()
{
    ZDBAnalysisEditViewMode.hideOrShow(ZDBClientUI.selectedTab.view,"show");//No I18N
}
ZDBNavigation.showSearchByOpts=function(el,event)
{
            var menu = ZDBContentCache.appendAndGet("Nav_SearchBy_Menu","GridMenu",document.body);
            var menuEl=jQuery(menu);
            var list=menuEl.find("[isViewType='true']"); //No I18N
            for(var i=0;i<7;i++)
            {
                if(ZDBNavigation.viewsCountByType[i]==0)
                {
                    jQuery(list[i]).hide();
}
                else
                {
                    jQuery(list[i]).show();
                }
            }
            menuEl.find("span").removeClass("sortTickMenu");    //No I18N  
            menuEl.find("#Search"+ZDBNavigation.searchType).addClass("sortTickMenu");   //No I18N
            ZRSMenu.showMenu(event,el,menu,5,ZDBNavigation.searchOptsClose);
}

ZDBNavigation.searchViewsList=function(type)
{
        ZDBNavigation.searchType=type;
        var tipValue=ZDBI18NMap.g("zrpt.leftpanel.search.js."+type.toLowerCase());
        var textBox=jQuery("#ZDBObjSearchTxtFld"); //No I18N
        textBox.attr("tipvalue",tipValue);//No I18N 
        if(textBox.attr("tipshown").toString()==="true") //No I18N 
        {
            textBox.attr("value",tipValue); //No I18N  
        }
        ZDBSearchUtil.searchDBObjects();
}

ZDBNavigation.manageNavState=function()
{
    var dbId = ZDBClientUI.dbId;
    var showNavBar=window.localStorage.getItem(dbId+"_SHOW_NAV_BAR");//No I18N
    if(showNavBar && showNavBar=="false")
        {
            ZDBNavigation.showOrHide(jQuery("#ZR_UnHideNavPanel").get(0));//No I18N
        }
}

ZDBNavigation.selectExplorer=function(el, event)
{
    var explorerTab=jQuery("#ZDBTABCONT .ExplorerObj")[0];
    ZDBClientUI.selectTab(explorerTab);
}

ZDBNavigation.invokeResize=function()
{
       var view = ZDBClientUI.selectedTab.view;
       view.layoutModeChanged();
       document.body.prevClientWidth =0;
       ZDBClientUI.resizeAllDInst();
}

// ------------ Expand and minimise option in bulk ---------------------//

ZDBNavigation.expandOrMinimizeAllViews = function (expParHolder, toExpand, el)
{
    var folder = ZDBUtil.find(expParHolder, "class", null, "ZDBfolderEl", null);//No I18n
    var foldIcon, toolTip;
    if(el) {
        var toOpen = ZDBUtil.hasClass(el, "expExpandIcon");//No I18n
        if (toOpen) {
            el.className = "iconbg expCollapseIcon";//No I18n
            toolTip = ZDBI18NMap.g("zrpt.chartview.js.collapseAll");//No I18n
        } else {
            ZDBNavigation.viewListBody.children[0].scrollTop = 0; // only for new layout - SAFARI Fix
            el.className = "iconbg expExpandIcon";//No I18n
            toolTip = ZDBI18NMap.g("zrpt.chartview.js.expAll");//No I18n
        }
        el.setAttribute("tip", toolTip);
    }
    foldIcon = (toOpen || toExpand) ? "foldCloseIcon" : "foldOpenIcon";//No I18n
    for (var i = 0; i < folder.length; i++) {
        var foldEl = folder[i];
        var closedFold = foldEl.getElementsByClassName(foldIcon)[0];
        if (closedFold) {
            ZDBNavigation.folderOpenClose(foldEl);
        }
    }
}


//Triggering Navigation panel functionalities

		jQuery(function(){
			jQuery("#ZR_Nav_Refresh").click(function(){ZDBNavigation.refreshExplorer(this);});//No I18N
			jQuery("#ZR_MovableAddNewTab, #ZRNewTab").bind("click",function(event){ZDBMenu.showExploreNewPopup(this,event);});//No I18N
			jQuery("#ZR_CreateFolderIco").bind("mouseover",function(event){ZDBToolTip.show(this,event);});//No I18N
			jQuery("#ZR_CreateFolderIco").bind("mouseout",function(){ZDBToolTip.hide(this);});//No I18N
			//jQuery("#ZRNewTab").bind("click",function(event){ZDBMenu.showExploreNewPopup(this,event);});//No I18N
      jQuery("#ZR_UnHideNavPanel").bind("click",function(){ZDBNavigation.showOrHide(this)});//No I18N
      jQuery("#ZR_UnHideNavPanel").bind("mouseenter",function(){ZDBNavigation.popOutNavigation(this)});//No I18N
		});

		ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBNavigation.editSharedDetailsFromExplore"] = ZDBNavigation.editSharedDetailsFromExplore;
		ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBNavigation.shareThisViewFromExplore"] = ZDBNavigation.shareThisViewFromExplore;
