//$Id$

var ev = new function()
{
	this.escKeyPressStack = new Array();	
	this.enterKeyPressStack = new Array();	
};// jshint ignore:line

jQuery(document).keydown(function (e) {
	ev.keyDown(e);
});

ev.keyDown = function(event)
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
		case KEY.ESC:
			if(ev.escKeyPressStack.length <= 0){	return;}
			var func = ev.escKeyPressStack.pop();		
			func.apply(this,[event]);
			ZDBUtil.stopEventBubble(event);
			break;
		case KEY.ENTER:
			if(ev.enterKeyPressStack.length <= 0){	return;}
			var func = ev.enterKeyPressStack.pop();		
			func.apply(this,[event]);
			ZDBUtil.stopEventBubble(event);
			break;
		 default:break;
	}
};

ev.addEscHandle = function(callFunc)
{
    ev.escKeyPressStack.push(callFunc);
};

ev.addEnterHandle = function(callFunc)
{
    ev.enterKeyPressStack.push(callFunc);
};

ev.removeEscHandle = function()
{
    ev.escKeyPressStack.pop();
};

ev.removeEnterHandle = function()
{
    ev.enterKeyPressStack.pop();
};
