//$Id$
var BROWSER = new function()
{
    this.NETSCAPE = 0;
    this.FIREFOX = 0;
    this.OPERA = 0;
    this.IE = 0;
    this.SAFARI = 0;
    this.MOZILA = 0;
    this.CHROME = 0;
    this.NONIE = 1;
    this.WEBKIT = 0;
    this.IE11AndAbove=0; //IE 11 and Edge browsers
    this.isIE9 = 0;
    this.EDGE = 0;
    var agent=navigator.userAgent.toLowerCase();
    this.IPHONE = ((agent.indexOf('iphone') != -1));
    this.IPAD = ((agent.indexOf('ipad') != -1));
    this.ANDROID = ((agent.indexOf('android') != -1));
    this.ANDROID_PHONE = ((agent.indexOf('android') != -1) && (agent.indexOf('mobile') != -1));
    this.IS_MOBILE = (this.IPHONE || this.IPAD || this.ANDROID);
    this.IS_MOBILE_PHONE = (this.ANDROID_PHONE || this.IPHONE);
    this.browserNdVersion = "";
    this.detect = function()
    {
        var agent = navigator.userAgent;
        var uaLen = agent.length;
        var vendor = navigator.vendor;
        var operaObject = window.opera;
        var versionSub = "";
        if(operaObject)
        {
            this.OPERA = 1;
        }
        else if(agent.indexOf("Edge") > -1)
        {
        	this.EDGE = 1;
          this.IE=1;
        	this.IE11AndAbove = 1;
        	versionSub="Edge/"; //NO I18N
        	this.browserNdVersion ="IE ";//NO I18N
        }
        else if(agent.indexOf("Chrome") > -1)
        {
            this.CHROME = 1;
            versionSub = "Chrome/";
            this.browserNdVersion ="Chrome ";//NO I18N
        }
        else if(agent.indexOf("Firefox") > -1)
        {
            this.FIREFOX = 1;
            versionSub = "Firefox/";
            this.browserNdVersion ="Firefox ";//NO I18N
        }
        else if(agent.indexOf("Trident/") > -1)
        {
            //From IE 11, the MSIE param will not be present in user agent, and the version will be in rv param
            this.IE = 1;
            versionSub = (agent.indexOf("MSIE ") > -1) ? "MSIE " : "rv:"; //No i18N
            this.IE11AndAbove=(agent.indexOf("MSIE ") > -1)? 0 : 1;
            this.browserNdVersion ="IE ";//NO I18N
            if(!this.IE11AndAbove){
              var version = parseInt(agent.substring(agent.indexOf(versionSub), uaLen).match(/[0-9\.]+/)[0]);
              this.isIE9 = (version == 9);
            }
        }
        else if(vendor.indexOf("Apple") > -1)
        {
            this.SAFARI = 1;
            versionSub = "Version/";
            this.browserNdVersion ="Safari ";//NO I18N
        }
        else
        {
           versionSub = "Unknown Browser";//No i18N
        }
        this.VERSION = agent.substring(agent.indexOf(versionSub), uaLen).match(/[0-9\.]+/)[0];
        this.browserNdVersion += this.VERSION;
    };
    this.detectBrowserNdVersion = function(){
    	var userAgent = navigator.userAgent;
    	if(userAgent.indexOf("Safari") > -1){
    		if(userAgent.indexOf("Chrome") > -1){
    			//Chrome;
    			this.browserNdVersion = userAgent.substring(userAgent.indexOf("Chrome"), userAgent.indexOf("Chrome") + 11).replace("/", " ");
    		}
    		else{
    			//Safari;
    			this.browserNdVersion = userAgent.substring(userAgent.indexOf("Safari"), userAgent.indexOf("Safari") + 10).replace("/", " ");
    		}
    	}
    	else if(userAgent.indexOf("Firefox") > -1){
    		//Firefox;
    		this.browserNdVersion = userAgent.substring(userAgent.indexOf("Firefox"), userAgent.indexOf("Firefox") + 10).replace("/", " ");
    	}
    	else if(userAgent.indexOf("Trident") > -1){
    		if(userAgent.indexOf("rv") > -1){
    			//IE11;
    			this.browserNdVersion = userAgent.substring(userAgent.indexOf("rv"), userAgent.indexOf("rv") + 7).replace("rv:", "IE ");
    		}
    		else if(userAgent.indexOf("MSIE") > -1){
    			//IE10 and below;
    			this.browserNdVersion = userAgent.substring(userAgent.indexOf("MSIE"), userAgent.indexOf("MSIE") + 9).replace("MSIE", "IE");
    		}
    	}
    	else if(userAgent.indexOf("EDGE") > -1){
    		//EDGE;
    		this.browserNdVersion = userAgent.substring(userAgent.indexOf("Edge"), userAgent.indexOf("Edge") + 9).replace("/", " ");
    	}
    };
    this.detect();
    this.detectBrowserNdVersion();
    this.NONIE = !this.IE;
    this.WEBKIT = (this.SAFARI || this.CHROME);
};


/*
var PLATFORM = new function()
{
  var platformStr = navigator.platform.toLowerCase();
  this.WINDOWS = platformStr.indexOf("win") > -1;
  this.LINUX = platformStr.indexOf("linux") > -1;
  this.MAC = platformStr.indexOf("mac") > -1;
}*/


var ZDBGlobal = new function()
{
    this.CTX="";
    this.isGlobalSet = false;
    this.dataCell = null;
    this.row = null;    
    this.cellDIV = null;
    this.colDIV = null;
    this.colHead = null;
    this.rowHead = null;
    this.integrated = false;
    this.curMouseOverCell = null;
    
    this.moveDIV = null;
    this.moveIn = null; //one should be enough
    this.isMove = false;
    this.resizeDIV = null;
    this.focusDIV = null;
    this.highlightDIV = null;
    this.isResize = false;
    this.optionDIV = null; //should have not used as a global reference?
    this.textFilterDIV = null;
    this.onPremise=false;
    this.freezeIcon = null;
    this.ascIcon = null;
    this.descIcon = null;
    
    this.cellWidth = 70;
    this.dataAreaWidth = 500;
    this.dataAreaHeight = 10 * this.cellHeight;
    
    this.columnVisible = 12;
    this.columnId=1;
    this.columnPos=11;
    this.columnWidth=10;
    this.columnFreeze=false;
    this.columnSortOrder=14;
    this.columnSortIndex=15;
    this.columnGrouped=16;
    this.columnSection=21;
    this.columnParentViewId=26;
    this.columnTobeListed=33;
    this.columnDisplay=2;
    
    this.fbBtnPos1=0;
    this.fbBtnPos2=0;
    this.fbBtnPos3=0;
    this.fbBtnPos4=0;

    this.stdCellWidth = 150; // I should use these values
    this.stdCellHeight = (BROWSER.IS_MOBILE) ? 26 : 22;
    this.stdColHeight = 26;
    this.stdEditGridCellHeight = 42;
    this.emailRegex=/^[\w\W]+@[\w\W]+$/i;
    this.webpageURLRegex=/^(http(s?)\:\/\/)?([A-Za-z0-9-]{1,63}\.)+[A-Za-z]{2,6}((\/)[a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;=`]*)?(\?([a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;`]+=[a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;`]+&)*([a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;`]+=[a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;]+&?)?)?$/i;//No I18N
    this.webpageURLRegexWithHTTP=/^(http(s?)\:\/\/)([A-Za-z0-9-]{1,63}\.)+[A-Za-z]{2,6}((\/)[a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;=`]*)?(\?([a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;`]+=[a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;`]+&)*([a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;`]+=[a-zA-Z0-9-\._~:\/#\[\]@!$&'\(\)*\+,;]+&?)?)?$/i;//No I18N
    this.domainNameRegex=/^([A-Za-z0-9-]{1,63}\.)+[A-Za-z]{2,6}$/i;
     this.getScrollThickness = function()
     {
         var sampleDiv = document.getElementById('ZDBSampleDiv');
         var sampleDivFDS = document.getElementById('ZDBSampleDivForDataSheet');
         return (jQuery(sampleDiv).is(':visible') != false ? (sampleDiv.offsetHeight - sampleDiv.clientHeight):( jQuery(sampleDivFDS).is(':visible') != false ? (sampleDivFDS.offsetHeight - sampleDivFDS.clientHeight) : 0 )); //No I18N
     };
   
    this.scrollThick = this.getScrollThickness();
    
    this.isMac = (navigator.userAgent.indexOf('Mac OS X') != -1);
    
    if(BROWSER.IE)
    {
        this.wait = 25;
        /// this.styleDiff = 0;
        //// this.scrollThick = 17; value set at someother place
    }
    else
    {
        this.wait = 5;
        ////this.styleDiff = -2;
        //// this.scrollThick = 15; value set at someother place
    }
    
    
    this.dateCnt = 0;
    this.filterOptions = [];
    this.filterDisplay = [];
    this.dervFieldNameCnt = 0;
    this.qryTblDataLimitShown = {};
    this.promoCodeDiscount = 0;

    this._ZVER_="1";

    this.getDropSpace = function()
    {
        if(this.dropSpace!=null && this.dropSpace.parentNode!=null){return this.dropSpace;}
        this.dropSpace = document.createElement("div");
        this.dropSpace.className = "zdbBlankField";
        document.body.appendChild(this.dropSpace);
        return this.dropSpace;
    };
    
    this.troubleshooting = false;
};
var ZROPConst = new function()
{
  this.MALTABADDR = '/ZROPSettings.cc#mailtab';		// No I18N
  this.LICENSETABADDR = '/ZROPSettings.cc#licencetab';		// No I18N
};

var ZDBConst = new function()
{
  this.NONE = this.NOTSET = null;
  this.BROWSER_HANDLE_YES = true;
  this.BROWSER_HANDLE_NO = false;
  
  this.ASC = 1;
  this.DESC = 2;
  this.CLEAR = -1;
  this.CREATED = 1;
  this.MODIFIED = 2;
  this.DELETED = 3;

  /*Col, Row Type*/

  var types = ['DUMMY','DATA','SUMMARY','SECTION','FILLER', 'ROWHEAD','COLHEAD','PIVOTHEAD', 'FILTER','OPTION','CRITERIA']; //No I18N
  for(var i=0;i<types.length;++i)
  {
    this[types[i]] = i;
  }
  
  this.BLANK = 10;
  this.TEXT = 11;
  this.UP = 12;
  this.DOWN = 13;
  
  
  /*Filter Constants*/
  
  // I am going to use the CLEAR defined above in the 
  // context of Filter also, bad?
  
  this.EQUAL = 2;
  this.NOTEQUAL = -2;
  this.LESS = 3;
  this.LESSEQUAL = 4;
  this.GREATER = 5;
  this.GREATEREQUAL = 6;
  this.START = 7;
  this.NOTSTART = -7;
  this.END = 8;
  this.NOTEND = -8;
  this.CONTAIN = 9;
  this.NOTCONTAIN = -9; //does not contain instead of not contains?
  this.BETWEEN = 10;
  this.NOTBETWEEN = -10;

  /* Title constants */
  this.SORTASC = "Sort Ascending";
  this.SORTDESC = "Sort Descending";
  this.REMOVESORT = "Remove Sort";
  this.GROUPCOLUMN = "Group Column";
  this.UNGROUPCOLUMN = "UnGroup Column";

  this.GROUPSTART=1;
  this.GROUPEND=2;
  this.GROUPBOTH=3;
  this.GROUPMIDDLE=0;
  this.GROUPNONE = undefined;
  this.READONLY={read:1,exportPerm:0,vud:0,add:0,modify:0,deletePerm:0,deleteAll:0,appendImport:0,updateImport:0,truncateImport:0,deleteupdateadd:0,share:0,vudShowSelCol:1,drilldown:0,dbOwner:0,grpMember:0,designModify:0,createTable:0,createChildReports:0};
  this.ALLPERMS={read:1,exportPerm:1,vud:1,add:1,modify:1,deletePerm:1,deleteAll:1,appendImport:1,updateImport:1,truncateImport:1,deleteupdateadd:1,share:1,vudShowSelCol:1,drilldown:1,dbOwner:1,grpMember:1,designModify:1,createTable:1,createChildReports:1};

  /* Data Type SubType ID(s) as in UserDefinedTypes.xml - $$ This should have
     been from server */
  this.PLAIN = 1;
  this.MULTI_LINE = 2;
  this.EMAIL = 3;
  this.NUMBER = 4;
  this.POSITIVE_NUMBER = 5;
  this.DECIMAL_NUMBER = 6;
  this.CURRENCY = 7;
  this.PERCENT = 8;
  this.DATE = 9;
  this.BOOLEAN = 10;
  this.REFCOL = 14;
  this.AUTO_NUMBER = 18;
  this.URL = 19;  
  this.RELCOL = 20;
  this.GEO = 21;
  this.DATE_AS_DATE=22;
  this.GEO_NUM = 23;
  this.COLNAME_MAX_LENGTH = 100;  
  this.DBOBJECT_NAME_MAX_LENGTH = 100;
  this.TITLE_MAX_LENGTH = 100;
  this.DESCRIPTION_MAX_LENGTH = 250;
  
  this.DEFAULT_CURRENCY_FORMAT = 'en;US;';
  this.DEFAULT_DATE_FORMAT = "dd MMM, yyyy HH:mm:ss";
  
  this.NEEDSAVE = "<i>Need to Save</i>"; //No I18N
  this.DLG_MIN_WIDTH = 630;
  this.DLG_MIN_HEIGHT = 250;
  
  this.DECISEPSYMBOL = ['.',','];
  this.DEFAULT_DECISEPSYMBOL = '.';
  this.DYNAMIC_COL_NAME = 'C_DUMMY'; //No I18N
  this.DEFAULT_1HR_SCH_FAILURE_COUNT = '10';    //No I18N
  this.DEFAULT_SCH_FAILURE_COUNT = '5'; //No I18N
//  this.SINGLEVIEWLAYOUT='2';
//  this.TABLAYOUT="1";
  this.SVGNAMESPACE = "http://www.w3.org/2000/svg";   //No I18N
  this.XLINKNAMESPACE = "http://www.w3.org/1999/xlink";   //No I18N
};

var ZDBDesignGridConst = new function()
{
// ZDBDesignGridConst is used in metadata/DataTypeInclude.jspf
};

var ZDBImportConst = new function()
{
    // these are the supported file formats in GDrive Import
    this.GDRIVE_FILE_EXTNS = ['csv','tsv','txt','xls','xlsx','htm','html','zip'];   //No I18N
    this.GDRIVE_CSV_EXTNS = ['csv','tsv','txt'];        //No I18N
};

function ZDBInitializeUserAnalytics(namespace, emailID, module, limit){
	if(ZDBGlobal.isUserAnalyticsEnabled){
		window.ZRUserAnalytics_Options = {
				   USERANALYTICSID: namespace,
				   ZUID : ZDBGlobal.zuID,
				   EMAILID : emailID,
				   MODULE: module,						
				   ADDITIONALPARAMS:{},
				   LIMIT:limit
		};
		ZRUserAnalytics.initialize();
		ZRUserAnalyticsObject.timers[module] = new ZRUserAnalyticsTimer(module);//NO I18N
		ZRUserAnalyticsObject.timers[module].startTimer();//NO I18N
	}
}

function lazyLoadJSAndCssFiles(){
    if(!ZDBGlobal.isDevelopmentMode){
        var jsUrlsList1 = ["ZDBGridList", "ZDBAnalysisViewList","ChartTPVendors", "ZRJSChartsList", "ZRDashboardView", "ZAVMFilterList", "ZAAnalysisFields"];	//NO I18N
        var jsUrlsList2 = [ "ZDBAnalysisEditList", "ZDBDashEdit", "ZDBChartSetting", "ZRQueryEditor", "ZDBExportNShare"];//NO I18N
	var cssUrls = ["CSSLIST_QUERYEDITOR", "CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES", "CSSLIST_DASHBOARDSTYLES", "CSSLIST_VMFILTERSTYLES", "CSSLIST_DASHBOARDLAYOUTSTYLES"];	//NO I18N
            if(!ZDBLazyLoadUtil.loadJsAlone(jsUrlsList1,"APPENDTODOC",lazyLoadJSAndCssFiles))
        {
          return;
        }
            if(!ZDBLazyLoadUtil.loadJsAlone(jsUrlsList2,"APPENDTODOC",lazyLoadJSAndCssFiles))
        {
          return;
        }
            if(!ZDBLazyLoadUtil.loadCssOnly(cssUrls, "APPENDTODOC", lazyLoadJSAndCssFiles)){
            return;
        }
            if(!ZFontload.preLoadFonts(ZDBGlobal.fontFamilyArr, lazyLoadJSAndCssFiles))
        {
            return;
        }
        loadReact();
    }
}

function lazyLoadJSAndCssFilesHome(){
    if(!ZDBGlobal.ISNEWLAYOUT){
        loadReact();
    }
}

function loadReact(func,args){
    var reactToLoad = (ZDBGlobal.isQAEnabled)?"thirdparty/js/react-with-addons":"thirdparty/js/react";//NO I18N
    reactToLoad = (ZDBGlobal.isDevelopmentMode || ZDBGlobal.isQAEnabled)?reactToLoad + ".js": reactToLoad + ".min.js";//NO I18N
    var reactDom = (ZDBGlobal.isDevelopmentMode || ZDBGlobal.isQAEnabled)?"thirdparty/js/react-dom.js":"thirdparty/js/react-dom.min.js";//NO I18N
    reactToLoad += "," + reactDom + ",zdbjs/react/ZRBaseComponents.js";
    if(!ZDBLazyLoadUtil.loadJsAlone(reactToLoad,"APPENDTODOC",func,args)){
        return false;
    }
    return true;
}

ZDBGlobal.fontFamilyArr = ["'ProximaNovaRgRegular'"]; //add your Default fonts

ZDBGlobal.changeToOnlyOldDashboardLayout = function(dashboardState)
{
	AjaxAPI.sendRequest({URL:"/ZDBUserAction.ma?ZDBACTION=CHANGEDASHBOARDLAYOUT", //No I18N
        PARAMETERS:"&OLDDASHBOARDLAYOUTONLY="+dashboardState,  //No I18N
        ONSUCCESSFUNC:ZDBHeader.reload,ONFAILUREFUNC:ZDBHeader.reload});
};


	
    ZDBGlobal.changeLayout = function()
    {
        var layout = ZDBGlobal.ISNEWLAYOUT ? 1 : 2;
        AjaxAPI.sendRequest({
            URL:"/ZDBUserAction.ma?ZDBACTION=CHANGELAYOUT", //No I18N
            PARAMETERS:"&LAYOUT="+layout,  //No I18N
            ONSUCCESSFUNC:ZDBHeader.reload,
            ONFAILUREFUNC:ZDBHeader.reload
            });
    };


ZDBGlobal.changeTabLayerPosition = function(el)
    {
        if(ZDBUtil.hasClass(el, "radioSelected")) {
            return;
        }
        var tabLayer= el.getAttribute("value");//No I18N
        AjaxAPI.sendRequest({
            URL:"/ZDBUserAction.ma?ZDBACTION=TABLAYERSWITCH", //No I18N
            PARAMETERS:"&TABLAYER="+tabLayer,  //No I18N
            ONSUCCESSFUNC:ZDBHeader.reload,
            ONFAILUREFUNC:ZDBHeader.reload
            });
    };
    
    ZDBGlobal.changeTheme = function(el)
    {
        if(ZDBUtil.hasClass(el, "theme-selected")) {
            return;
        }
        var theme = el.className;
        var par = DOMUtils.getParentWithAttrValue(el, "class", "theme-options"); //NO I18N
        var existing = par.querySelector(".theme-selected"); //NO I18N
        ZDBUtil.removeClass(existing, "theme-selected");
        ZDBUtil.addClass(el, "theme-selected");
        if(ZDBGlobal.isDevelopmentMode) {
            $("ZRThemeCss").setAttribute('href', '/themes/colors/styles/'+theme+'.css');
        }
        else{
            $("ZRThemeCss").setAttribute('href', ZDBLazyLoadUtil.moduleCSSURLs[theme+'.css']);
        }
        
        var logo = $("ZDBMainHeader").getElementsByTagName("img")[0];
        logo.src = (!ZDBGlobal.isLogoRebrand && theme.indexOf("theme2")>=0) ? ZDBGlobal.domainLogoWhite : ZDBGlobal.DOMAINLOGO;
        ZDBGlobal.currentTheme = theme;
        
        AjaxAPI.sendRequest({
            URL:"/ZDBUserAction.ma?ZDBACTION=CHANGETHEME", //No I18N
            PARAMETERS:"&THEME="+theme //No I18N
        });
    }
    
    ZDBGlobal.showHideThemeOptions = function(el)
    {
        var par = el.parentNode;
        ZDBUtil.removeClass(par, "tab-options-visible"); //NO I18N
        par.getElementsByClassName("theme-options")[0].style.display = "";
        ZDBUtil.toggleClass(par, "theme-options-visible"); //NO I18N
    }
    
    ZDBGlobal.showHideTabOptions = function(el)
    {
        var par = el.parentNode;
        ZDBUtil.removeClass(par, "theme-options-visible"); //NO I18N
        ZDBUtil.toggleClass(par, "tab-options-visible"); //NO I18N
        par.getElementsByClassName("theme-options")[0].style.display = "none";
    }
    
    ZDBGlobal.userOptionSelected = function(el, option) 
    {
        var cont = $("tablayercont"); //NO I18N
        cont.style.display = "block";
        document.addEventListener("click", ZDBGlobal.closeOptionMenu, true);
    }
    
    ZDBGlobal.closeOptionMenu = function(e)
    {
        if(DOMUtils.getSelfOrParentWithAttrValue(e.target, "elname", "optionsHolderMenu")) {
            return;
        }
        $("themecont").style.display = "none";
        if($("tablayercont")) {
            $("tablayercont").style.display = "none";
        }
        document.removeEventListener("click", ZDBGlobal.closeOptionMenu, true);
    }
    

function addPlaceHolder(el){ //for placeholders in IE9
	el.placeholder = el.getAttribute("placeholder");
	el.onfocus = function(){
		if(this.value == this.placeholder){
			this.value = "";
			el.style.opacity= "1";
		}
	};
	el.onblur = function(){
		if(this.value.length == 0)
		{
			this.value = this.placeholder;
			el.style.opacity = '0.5';
		}
	};
	el.onblur();
}

ZDBGlobal.showFeedBack = function(el, event){
	  if(!ZDBLazyLoadUtil.loadJsAlone('ZRScreenGrabber','APPENDTODOC',ZDBGlobal.showFeedBack,[el,event],"ZDBMainLoader")){
		  return;
	  }
          if(!ZDBLazyLoadUtil.loadJsAlone('zdbjs/header/ZRFeedbackDlg.js','APPENDTODOC',ZDBGlobal.showFeedBack,[el,event],"ZDBMainLoader")){
		  return;
	  }
	  if(!ZDBLazyLoadUtil.loadCssOnly("ui.zscreengrabber.css", "APPENDTODOC", 
			  ZDBGlobal.showFeedBack,[el, event],"ZDBMainLoader")){//NO I18N
	    	return;
	  }
	  ZDBScreenGrabber.showFeedBack(el,event);
}

ZDBGlobal.handleFeedback = function(el,event){
  if(!ZDBLazyLoadUtil.loadJsAlone('zdbjs/header/ZRSFeedbackHandler.js','APPENDTODOC',ZDBGlobal.handleFeedback,[el,event],"ZDBMainLoader")){
      var dom = ZRSStringTemplateCreator.createTemplateForData('feedbackForm','commonComponents');//No I18N
      document.body.appendChild(dom);
      return;
  }
  // For Screenshot
  // if(!ZDBLazyLoadUtil.loadJsAlone('ZRScreenGrabber','APPENDTODOC',ZDBGlobal.handleFeedback,[el,event],"ZDBMainLoader")){
  //     return;
  // }
  // if(!ZDBLazyLoadUtil.loadCssOnly("ui.zscreengrabber.css", "APPENDTODOC",ZDBGlobal.handleFeedback,[el, event],"ZDBMainLoader")){
  //     return;
  // }
  ZRSFeedbackHandler.showForm();
}

ZDBGlobal.dragMouseDown = function(event) {
  event = event || window.event;
  // get the mouse cursor position at startup:
  ZDBGlobal.fbBtnPos3 = event.clientX;
  ZDBGlobal.fbBtnPos4 = event.clientY;
  document.onmouseup = ZDBGlobal.closeDragElement;
  // call a function whenever the cursor moves:
  document.onmousemove = ZDBGlobal.elementDrag;
}

ZDBGlobal.elementDrag = function(event) {
  event = event || window.event;
  var elmnt = document.getElementById("feedbackBtn");
  elmnt.setAttribute("noClick","true");
  // calculate the new cursor position:
  ZDBGlobal.fbBtnPos1 = ZDBGlobal.fbBtnPos3 - event.clientX;
  ZDBGlobal.fbBtnPos2 = ZDBGlobal.fbBtnPos4 - event.clientY;
  ZDBGlobal.fbBtnPos3 = event.clientX;
  ZDBGlobal.fbBtnPos4 = event.clientY;
  // set the element's new position:
  elmnt.style.top = (elmnt.offsetTop - ZDBGlobal.fbBtnPos2) + "px";
  elmnt.style.left = (elmnt.offsetLeft - ZDBGlobal.fbBtnPos1) + "px";
  ZDBUtil.stopEventBubble(event);
}

ZDBGlobal.closeDragElement = function() {
  /* stop moving when mouse button is released:*/
  document.onmouseup = null;
  document.onmousemove = null;
}


ZDBGlobal.toggleTryNewEdition = function(el){
    var dlg = jQuery('#tryNewEditionsCont'); //No I18N
    if(!dlg[0] && ZDBGlobal.ISNEWLAYOUT && ZDBGlobal.LANDINGPAGE == "ZDBHome"){
        ZRSHomeHandler.initializeDOM("tryotherplans", "zrsheader");//NO I18N
        dlg = jQuery('#tryNewEditionsCont');//NO I18N
    }
    if(!dlg[0] && ZDBGlobal.ISNEWLAYOUT && ZDBGlobal.LANDINGPAGE == "ZDBDataSheetView"){
        var dom = ZRSStringTemplateCreator.createTemplateForData("tryotherplans", "zrsheader"); //NO I18N
        document.body.appendChild(dom);
        dlg = jQuery('#tryNewEditionsCont');//NO I18N
    }
    var freezeLayer = jQuery('<div id="tryNewEditionFreezeLayer" class="freezeLayer"></div>');
    if(ZDBGlobal.ISNEWLAYOUT){
        var parentPos = el.getBoundingClientRect();
        var dlgWidth = dlg.outerWidth();
        var top = parentPos.top + parentPos.height;
        var left = parentPos.left - (dlgWidth / 2) + (parentPos.width / 2);
        dlg.css({top:top, left: left});
    }
    freezeLayer.click(function(){
        dlg.fadeOut();
        freezeLayer.remove();
        if(ZDBGlobal.ISNEWLAYOUT)
            dlg.remove();
    });
    jQuery(document.body).append(freezeLayer);
    dlg.fadeIn();
};

ZDBGlobal.tryPlan = function(planId){
    var params = "&ZDBACTION=ENABLETRIAL&PLANID=" + planId; //No I18N
    AjaxAPI.sendRequest({URL:"/ZDBPricing.ve?", PARAMETERS:params, OPSTATUSID:"ZDBMainLoader", ONSUCCESSFUNC: ZDBGlobal.refreshUI}); // No I18N
};

ZDBGlobal.refreshUI = function(response, request){
    jQuery('#tryNewEditionsCont').fadeOut(); // No I18N
    jQuery('#tryEdition').remove(); // No I18N
    jQuery('#tryNewEditionFreezeLayer').remove(); //No I18N
    ZDBMsgBox.showHintMsg('Trial enabled successfully ', 'success'); //No I18N
};

ZDBGlobal.isClrPltEnabled = function()
{
    return (!ZDBGlobal.integrated);
};

ZDBGlobal.initializeFontInfo = function(){
    ZDBGlobal.defaultFontsize = 13;
    ZDBGlobal.defaultFont = "Proxima Nova"; //No I18N
    
    if(ZDBGlobal.fontFolder=="f1")
    {
        ZDBGlobal.defaultFont = "Arial"; //No I18N
        ZDBGlobal.defaultFontsize = 12;
    }
    else if(ZDBGlobal.fontFolder=="f3")
    {
        ZDBGlobal.defaultFont = "Lato"; //No I18N
    }
};
