//$Id$
var ZAVMFilterEdit = new function ()
{
    this.compLstByAot = {"categorical":[{"COMP": "sbox","DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.sbox"),"DESC": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.sbox.desc"),"TIP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.sbox.tip")}, {"COMP": "msbox","DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.msbox"),"DESC": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.msbox.desc"), "TIP":ZDBI18NMap.g("zrpt.VMFilters.dlg.js.msbox.tip")}], //No I18N
                         "absdatecategorical":[{"COMP": "dr","DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.dr"),"DESC": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.dr.desc"), "TIP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.dr.tip")}, {"COMP":"ap","DISP":ZDBI18NMap.g("zrpt.VMFilters.dlg.js.ap"),"DESC":ZDBI18NMap.g("zrpt.VMFilters.dlg.js.ap.desc"), "TIP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.ap.tip")}, {"COMP":"rp","DISP":ZDBI18NMap.g("zrpt.VMFilters.dlg.js.rp"),"DESC":ZDBI18NMap.g("zrpt.VMFilters.dlg.js.rp.desc"), "TIP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.rp.tip")},{"COMP":"sp","DISP":ZDBI18NMap.g("zrpt.VMFilters.dlg.js.sp"),"DESC":ZDBI18NMap.g("zrpt.VMFilters.dlg.js.sp.desc"), "TIP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.sp.tip")}],//No I18N
                         "number":[{"COMP":"slider","DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.slider"),"DESC": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.slider.desc"), "TIP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.slider.tip")}, {"COMP":"numCombo","DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.numCombo"),"DESC": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.numCombo.desc"), "TIP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.numCombo.tip")}],//No I18N
                         "numberOpTypes":[{"COMP":"SUM","DISP":"Sum"},{"COMP":"MAX","DISP":"Maximum [Max]"},{"COMP":"MIN","DISP":"Minimum [Min]"},{"COMP":"AVG","DISP":"Average [Avg]"},{"COMP":"STD","DISP":"Standard Deviation [Std]"},{"COMP":"COUNT","DISP":"Count"},{"COMP":"DC","DISP":"Distinct Count"},{"COMP":"CONTINUOUS","DISP":"Actual Values"}],//No I18N
                         "uitype":[{"COMP": "sbox", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.sbox")}, {"COMP": "msbox", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.msbox")}],//No I18N
                         "behavior":[{"COMP": "false", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.ListAllVals")}, {"COMP": "true", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.ListRelaventValues")}],//No I18N
                         "actSubtype":[{"COMP": "100", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.years")},{"COMP": "108", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.quartersyears")},{"COMP": "101", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.months_and_years")},{"COMP": "109", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.weeks_and_years")},{"COMP": "105", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.fulldate")},{"COMP": "106", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.datetime")}],//No I18N
                         "seaSubtype":[{"COMP": "108", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.quarters")},{"COMP": "101", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.months")},{"COMP": "109", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.weeks")},{"COMP": "102", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.weekdays")},{"COMP": "103", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.daysofmonths")},{"COMP": "104", "DISP": ZDBI18NMap.g("zrpt.VMFilters.dlg.js.hours")}],//No I18N
                        };
                        
    this.uiType = {sbox: 4, msbox: 2,
        dr: 1, rp: {sbox: 4, msbox: 2}, ap: {sbox: 4, msbox: 2}, sp: {sbox: 4, msbox: 2}, slider: 6, numCombo: 2};
    
    this.operation = {sbox: "GROUPBY", msbox: "GROUPBY", //No I18N
        dr: "ABS", rp: "PF", ap: "ABS", sp: "REL", numCombo: "CONTINUOUS", slider: "SUM"};//No I18N

    this.subType = {sbox: "1", msbox: "1", //No I18N
        dr: "107", rp: "100", ap: "100", sp: "108", slider: "2", numCombo: "1"};//No I18N

    this.defaultFormsnDlg = {
        categorical: ["categoricalCompForm", "ZDBCatChooseValDlg"], //No I18N
        absdatecategorical: ["absdatecategoricalCompForm", "ZDBDateCompDlg"], //No I18N
        number: ["numberCompForm", "ZDBNumRangesSliderDlg"]//No I18N
    };

    this.defaultCompOption = {
        categorical: "sbox", //No I18N
        absdatecategorical: "dr", //No I18N
        number: "slider"//No I18N
    };

    this.hintTxt = {
        sbox: ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.snglEx"),
        msbox: ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.multiEx"),
        rp: ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.rpEx"),
        ap: ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.apEx"),
        sp: ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.spEx"),
        numCombo: ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.numEx")
    };

    this.compTypeDefn = [
        ["GROUPBY", 4, "sbox"], //No I18N
        ["GROUPBY", 2, "msbox"], //No I18N
        ["ABS", 1, "dr"], //No I18N
        ["PF", 2, "rp"], //No I18N
        ["ABS", 2, "ap"], //No I18N
        ["REL", 2, "sp"], //No I18N
        ["PF", 4, "rp"], //No I18N
        ["ABS", 4, "ap"], //No I18N
        ["REL", 4, "sp"], //No I18N
        ["SUM", 6, "slider"], //NO I18N
        ["MAX", 6, "slider"], //NO I18N
        ["MEDIAN",6,"slider"], //NO I18N
        ["STATS_MODE", 6, "slider"], //NO I18N
        ["MIN", 6, "slider"], //NO I18N
        ["AVG", 6, "slider"], //NO I18N
        ["STD", 6, "slider"], //NO I18N
        ["COUNT", 6, "slider"], //NO I18N
        ["DC", 6, "slider"], //NO I18N
        ["CONTINUOUS", 6, "slider"], //NO I18N
        ["CONTINUOUS", 2, "numCombo"], //NO I18N
        ["CONTINUOUS", 4, "numCombo"]//NO I18N
    ];
    
    this.tempFldExclPrms = {"DISPLAYNAME": true, "LABEL": true, "DISPLAYCRITERIA": true, "CRITERIA": true, //NO I18N
        "DEFAULTDISPLAYCRITERIA": true, "DEFAULTCRITERIA": true, "CASCADELIST": true, //NO I18N
        "REL_OPERATION": true, "REL_SUBTYPE": true, "REL_NR": true, "REL_CRITERIA": true, "REL_DISPCRITERIA": true}; //NO I18N
    
    this.tempHolderProps = {"LABEL": true,"COMPTYPE": true, "DISPLAYCRITERIA": true, "CRITERIA": true, //NO I18N
        "DEFAULTDISPLAYCRITERIA": true, "DEFAULTCRITERIA": true, "NR":true, "CASCADELIST": true, //NO I18N
        "RELROW_PRESENT": true, "REL_ADDONTYPE":true, "REL_OPERATION": true, "REL_SUBTYPE": true, "REL_NR": true, "REL_CRITERIA": true, "REL_DISPCRITERIA": true, //NO I18N
        "UITYPE": true, "SUBTYPE": true, "OPERATION": true, "ISALLVAL": true, "INCLUDETIME":true//NO I18N
    }
    
    
    //drop component
    
    this.dropField = function(field, droppedArea)
    {
        var view = ZDBClientUI.getViewObj(field,"view");
        this.constructComponent(field, droppedArea);
        if(view.type=="Dashboard")
        {
            ZDBDashboardUF.updateAddedFields(view);
            ZDBEditModeSelect.validateDashboard(view);
        }
    }
    
    
    //constructe and update components
    
    this.constructComponent = function(field, droppedArea)
    {
        var compEl = ZAVMFilterEdit.getCompEl();
        droppedArea.appendChild(compEl);
        var label = ZAVMFilterEdit.updateDropComponentValues(field, compEl);
        var addonType = field.getAttribute("ADDONTYPE");
        var view = ZDBClientUI.getViewObj(compEl, "view");//No I18N
        var inputComp = ZAVMFilterEdit[addonType.toLowerCase() + "Component"](compEl);//No I18N
        var compElContainer = DOMUtils.getFirstMatchingChild(compEl,"*","elname","compElContainer");
        compElContainer.appendChild(inputComp);
        ZDBUtil.setNamedChildEls(compEl, compEl);
        compEl.compLabel.innerHTML = ZDBEscapeUtil.encodeForHtml(label + ":");
        compEl.compLabel.setAttribute("data-tip",label);//for tooltip
        ZAVMFilterEdit.setDefaultValue(compEl);
        compEl.style.cursor = "default";//No I18N
        compEl.onmouseover = ZAVMFilter.showCompOptions;
        compEl.onmouseout = ZAVMFilter.hideCompOptions;
        ZDBUtil.attachEvent(compEl,'onClick',ZAVMFilter.switchComponentFocus);
        ZAVMFilterEdit.placeCompEl(droppedArea, compEl);
        this.orderVMFiltersList(view);
        ZAVMFilter.placeVMFilterDefinition(view);
        ZDBAnalysisView.showRefreshDiv(view);
        if(compEl.getAttribute("UITYPE") == "6")
        {
            ZDBAnalysisFilter.sendFilterFieldInfo(compEl);
        }
    }
    
    
    //editComponent
    
    this.editComponent = function(el)
    {
        var timeLineComp = DOMUtils.getSelfOrParentWithAttr(el, "isTimeLineComp");//NO I18N
        if (timeLineComp)
        {
            ZRTimelineFilter.showTimeLineCompEditDlg(timeLineComp);
            return;
        }
        var view = ZDBClientUI.getViewObj(el, "view")
        var field = DOMUtils.getSelfOrParentWithAttr(el, "column_id");//No I18N
        var addonType = field.getAttribute("ADDONTYPE"); 
        var dlg = ZAVMFilterEdit.showDlg(view, addonType);
        dlg.field = field;
        dlg.elnameSet = false;
        ZDBUtil.setNamedChildEls(dlg, dlg);
        ZAVMFilterEdit.oldDlgBody = null;
        var form = dlg.getElementsByTagName("FORM")[0];
        var isListCreated =  dlg.compTypeSlc.getAttribute("isListCreated");
        var listDetObj = ZAVMFilterEdit["compLstByAot"];
        if(!isListCreated)
        {
            ZAVMFilterEdit.constructList(dlg.compTypeSlc,addonType,listDetObj[[addonType.toLowerCase()]]);
            if(addonType == "NUMBER")
            {
                ZAVMFilterEdit.constructList(dlg.funcType,"operation",listDetObj["numberOpTypes"]);//No I18N
            }
        } 
        this.updateTemObjValues(dlg.modifyProps, field);
        this.updateFormAttributes(field,form);//update attributes (tempObj to form), and showValueDlg also called inside this function
    }
    
    
    //showing dialogue
    
    this.showDlg = function(view, addonType)//initializing dialogue and appending component dialogue.
    {
        var dlgBody = ZAVMFilterEdit.getDlgId(1, addonType).cloneNode(true);
        var dialogue = $("ZDBVMFilterTabFrame");
        ZDBUtil.removeElementsByClassName(dialogue, "zmenu");//No I18N
        ZDBUtil.setNamedChildEls(dialogue, dialogue);
        dialogue.wizardContentHolder.innerHTML = "";
        dialogue.wizardContentHolder.appendChild(dlgBody);
        var dlgTitle = ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.steps");
        var focusDlg = ZDBDialogUtil.showDialog(dialogue, {MODAL: true, ADDFRAME: true, SHADOW: false, VIEW: view, TITLE: dlgTitle, HELPDOC: ZDBI18NMap.g("zrpt.VMFilters.dlg.js.helpLink"), DONTREMOVE: true, ONCLOSE: ZAVMFilterEdit.cancelOnEsc});
        focusDlg.dlgTitle.innerHTML = dlgTitle;
        focusDlg.style.visibility = "hidden";
        this.focusDlg = focusDlg;
        if(addonType == "NUMBER" || addonType == "CATEGORICAL")
        {
            focusDlg.style.height = "500px";//No I18N
        }
        else
        {
            focusDlg.style.height = "570px";//No I18N
        }
        var top = focusDlg.offsetTop;
        if(top != 0)
        {
            top = top/2;
            focusDlg.style.top = top+"px";//No I18N
        }
        focusDlg.modifyProps = new Object();
        ZAVMFilterEdit.modifyProps = focusDlg.modifyProps;//ZDBDialogUtil.focusDialog can changed in many place like add newRange
        return focusDlg;
    }
    

    //get and set values for dlg, based on comptype
    
    this.showValueDlg = function(form)
    {
        var dlg = ZDBDialogUtil.focusDialog;
        var field = dlg.field;
        var view = dlg.view;
        var compType = dlg.modifyProps.comptype;
        var operation = dlg.modifyProps.operation;
        var addonType = field.getAttribute("ADDONTYPE");
        var isListCreated = dlg.uitypeEl ? dlg.uitypeEl.getAttribute("isListCreated") : false;
        if(addonType == "CATEGORICAL" && ZAVMFilterEdit.oldDlgBody)
        {
            ZAVMFilterEdit.updateUitypeDependentEls(ZAVMFilterEdit.uiType[compType],view);
            return;
        }
        var dlgBody = ZAVMFilterEdit.getDlgId(2, compType).cloneNode(true);
        if(ZAVMFilterEdit.oldDlgBody)
        {
        	form.removeChild(ZAVMFilterEdit.oldDlgBody);
        	ZAVMFilterEdit.resetDlgAttr(field);
        }
        ZAVMFilterEdit.oldDlgBody = dlgBody;
        form.appendChild(dlgBody);
        dlg.elnameSet = false;
        ZDBUtil.setNamedChildEls(dlg, dlg);
        var listDetObj = ZAVMFilterEdit["compLstByAot"];
        if(addonType == "ABSDATECATEGORICAL" && compType != "dr")
        {
            if(!dlg.uitypeEl.getAttribute("isListCreated"))
            {
                ZAVMFilterEdit.constructList(dlg.uitypeEl,"uitype",listDetObj["uitype"]);//No I18N
            }
            if(compType == "ap")
            {
                ZAVMFilterEdit.constructList(dlg.actSubFuncEl,"subtype",listDetObj["actSubtype"]);//No I18N
            }
            else if(compType == "sp")
            {
                ZAVMFilterEdit.constructList(dlg.seaSubFuncEl,"subtype",listDetObj["seaSubtype"]);//No I18N
            }
        }
        if(dlg.cascadeList)
        {
            ZAVMFilterEdit.constructList(dlg.cascadeList,"behavior",listDetObj[["behavior"]]);//No I18N
        }
        if(compType == "dr")
        {
            this.setIncludeTimeTick(field);
        }
        this.updateDlgElements(addonType, compType, operation);
        var uiType = dlg.modifyProps.uitype;
        var filterOption = (dlg.modifyProps.isallval)=="true" ? "allValues" : "selectedValues";//No I18N
        ZDBUtil.setRadioSelectedValue(form,"filterOption",filterOption);//No I18N
        this.updateFilterEls(dlg,compType,filterOption,form);
        this.updateUitypeDependentEls(uiType);
    }
    
    
    this.resetDlgAttr = function (field)
    {
    	var dlg = ZDBDialogUtil.focusDialog;
    	var compType = dlg.modifyProps.comptype;
    	var addonType = field.getAttribute("ADDONTYPE");
    	var nr = field.getAttribute("NR");
    	var rel_nr = field.getAttribute("REL_NR");
    	var uiType = ZAVMFilterEdit.uiType[compType];
    	var isAllVal = "true";//No I18N
    	var props = this.tempHolderProps;
    	if(addonType == "ABSDATECATEGORICAL" && compType != "dr")
    	{   
            var value = dlg.uitypeEl.getAttribute("value");
            uiType = value ? value == "sbox" ? 4 : 2 : 4;//No I18N
    	}
        if(compType == "numCombo" || compType == "rp")
    	{
            isAllVal = "false";//No I18N
    	}
        for(prop in props)
    	{
            prop = prop.toLowerCase();
            dlg.modifyProps[prop] = "";
    	}
    	dlg.modifyProps.comptype = compType;
    	dlg.modifyProps.uitype = uiType;
    	dlg.modifyProps.subtype = ZAVMFilterEdit.subType[compType];
    	dlg.modifyProps.operation = ZAVMFilterEdit.operation[compType];
    	dlg.modifyProps.isallval = isAllVal;
    	dlg.modifyProps.nr = nr;
    	dlg.modifyProps.rel_nr = rel_nr;
    	dlg.modifyProps.cascadelist = "false"; //No I18N
    	dlg.modifyProps.relrow_present = "false"; //No I18N
    	
    }

    
    //dialogue dependent functions
    
    //updating values drop field to original field(component)
    this.updateDropComponentValues = function (field,compEl)
    {
        var value = "";
        var params = ZDBAnalysisConfig.VMFILTERPARAMS;
        for (var i = 0, j = params.length; i < j; i++)
        {
            if (field.getAttribute(params[i]) != null)
            {
                value = field.getAttribute(params[i].toLowerCase());
                if (!this.tempHolderProps[params[i]])
                {
                    value = value.toString();
//                    value = value.toLowerCase();
                }
            } else
            {
                value = "";
            }
            compEl.setAttribute(params[i], value);
        }
        
        var view = ZDBClientUI.getViewObj(compEl, "view");//No I18N
        var addonType = field.getAttribute("ADDONTYPE");
        var label = field.getAttribute("DISPLAYNAME");
        compEl.setAttribute("ADDONTYPE",addonType);//for uppercase
        var compType = ZAVMFilterEdit.defaultCompOption[addonType.toLowerCase()];
        if (addonType == "NUMBER" && view.type != "Dashboard")
        {
            ZDBAnalysisFilter.setBestFilterFunction(compEl, view);
        }
        else
        {
           compEl.setAttribute("OPERATION", ZAVMFilterEdit.operation[compType]);
        }
        compEl.setAttribute("OPERATION",compEl.getAttribute("OPERATION").toUpperCase());//for uppercase
        var counter = 0; 
        var labelValue = label; 
        while(!this.getLabelValue(view,compEl,label))
        {
            counter++;
            label = labelValue.trim() + counter;
        }
        var subType = ZAVMFilterEdit.subType[compType];
        var uiType = (addonType == "ABSDATECATEGORICAL" && compType !="dr") ? ZAVMFilterEdit.uiType["sbox"] : ZAVMFilterEdit.uiType[compType];//No I18N
        compEl.setAttribute("ORIGCOLNAME",ZAVMFilterEdit.getOrigColName(null, compEl));
        compEl.setAttribute("COMPTYPE",compType);
        compEl.setAttribute("UITYPE",uiType);
        compEl.setAttribute("SUBTYPE", subType);
        compEl.setAttribute("ISALLVAL", "true");
        compEl.setAttribute("CASCADELIST", false);
        compEl.setAttribute("RELROW_PRESENT", false);
        compEl.setAttribute("REL_SUBTYPE","100");
        compEl.setAttribute("REL_OPERATION","PF");
        compEl.setAttribute("INCLUDETIME",false);
        compEl.setAttribute("VIEWTYPE", "VMFILTERCRITERIA");
        compEl.setAttribute("IS_VALID_COL",true);
        compEl.setAttribute("WIDTH", compEl.offsetWidth);
        compEl.setAttribute("DROPPOSITION", parseInt(field.style.left) + "," + parseInt(field.style.top));
        compEl.setAttribute("COMPSIZE", parseInt(field.offsetWidth) + "," + parseInt(field.offsetHeight));
        return label;
    }
    
    //while opening dlg (updating component to tempObj)
    this.updateTemObjValues = function(tempObj,component)
    {
        var props = ZAVMFilterEdit.tempHolderProps;
        var prop;
        for(prop in props)
        {
            prop = prop.toLowerCase();
            tempObj[prop] = component.getAttribute(prop) ? component.getAttribute(prop) : "";
        }
    }
    
    //while finishing the dlg (updating tempObj to component)
    this.updateCompAttributes = function(tempObj,component)
    {
        var props = ZAVMFilterEdit.tempHolderProps;
        var value = "";
        var prop;
        for(prop in props)
        {
            prop = prop.toLowerCase();
            value = tempObj[prop];
            component.setAttribute(prop,value);
        }
    }

    
    //while editing the dlg
    
    this.updateFormAttributes = function(getField,setField)//getField component, setField form
    {
        var dlg = ZDBDialogUtil.focusDialog;
        var label = dlg.modifyProps.label;
        var compType = dlg.modifyProps.comptype;
        var operation = dlg.modifyProps.operation;
        var uiType = dlg.modifyProps.uitype;
        var defCrt = dlg.modifyProps.defaultdisplaycriteria;
        var cascadeVal = dlg.modifyProps.cascadelist;
        var isAllVal = dlg.modifyProps.isallval;
        var orgColumn = getField.getAttribute("ORIGCOLNAME");
        var addonType = getField.getAttribute("ADDONTYPE");
        var subType = getField.getAttribute("SUBTYPE");
        compType = compType != "" ? compType : ZAVMFilterEdit.getCompTypeFor(operation, uiType);
        var comptypeEl = dlg.compTypeSlc;
        ZAVMFilterEdit.updateSelItem(comptypeEl,compType,"comptype");//No I18N      
        setField["label"].value = label;
        dlg.origColName.setAttribute("title",orgColumn);//for tooltip
        dlg.origColName.innerHTML = ZAVMFilterEdit.trimOrigColName(orgColumn);
        getField.setAttribute("ORIGCOLNAME",orgColumn);
        dlg.style.visibility = "visible";
        setField["label"].focus();
        if(addonType == "ABSDATECATEGORICAL" && compType != "dr")
        {
            ZAVMFilterEdit.updateSelItem(dlg.uitypeEl, uiType == "4" ? "sbox" : "msbox");//No I18N
        }
        if(compType == "dr")
        {
            ZAVMFilterEdit.setIncludeTimeTick(getField);
        }
        if(isAllVal == "true")
        {
            if(compType == "ap")
            {
                ZAVMFilterEdit.updateSelItem(dlg.actSubFuncEl, subType, "subtype");//No I18N
            }
            else if(compType == "sp")
            {
                ZAVMFilterEdit.updateSelItem(dlg.seaSubFuncEl, subType, "subtype");//No I18N
            }
        }
        setField["defaultValues"].value = defCrt;
        ZAVMFilterEdit.updateSelItem(dlg.cascadeList, cascadeVal, "cascadelist");//No I18N
    }


    //getting and validating label value, while dropping the component
    
    this.getLabelValue = function(view,field,label)
    {
        var VMFiltersList = view.VMFiltersList;
        var len = VMFiltersList.length;
        var compEl;
        for (var i = 0; i < len; i++)
        {
            compEl = VMFiltersList[i];
            var existLabel = compEl.getAttribute("LABEL");
            if (existLabel.toUpperCase() == label.toUpperCase())
            {
                return false;
            }
        }
        
        field.setAttribute("LABEL",label);
        return true;
        
    }
    
    
    this.updateDlgElements = function(addonType, compType, operation)
    {
    	var dlg = ZDBDialogUtil.focusDialog;
        var uiTypeEl = dlg.UIOptHolder;
        var funcTypeEl = dlg.funcType;
        var caseEl = dlg.cascadeList;
        var uiType = dlg.modifyProps.uitype;
        var cascadelist = dlg.modifyProps.cascadelist;
        //uitype
        if (addonType == "ABSDATECATEGORICAL" && compType != "dr")
        {
            uiTypeEl.style.display="block";//No I18N
        }
        else
        {
            uiTypeEl.style.display = "none";//No I18N
        }
        //operation 
        if(addonType == "NUMBER")
        {
            var isDisabled = false;
            if(compType == "numCombo")
            {
                operation = "CONTINUOUS";//No I18N
                isDisabled = true;
            }
          ZAVMFilterEdit.updateSelItem(funcTypeEl, operation, "operation");//No I18N
          funcTypeEl.parentElement.style.display = "block";//No I18N
          jQuery(funcTypeEl).zselectbox("setAttribute", "disabled", isDisabled); //No I18N
        }
        else
        {
            funcTypeEl.parentElement.style.display = "none";//No I18N
        }
        (caseEl) ? caseEl.value = cascadelist : null;
    }
    
    
    //all values or selected values only         
        
    this.updateFilterEls = function(dlg,compType,filterOption,form)
    {
        if(filterOption == "selectedValues" && compType != "slider" )
        {
            this.sendFilterReq(null,dlg.view,form)
        }
        if (compType == "ap" && dlg.modifyProps.relrow_present.toString() == "true")
        {
            form.RelDtSelect.checked = true;
            ZAVMFilterEdit.showHideRelFilterList(form.RelDtSelect, true);
        }
    }
    
    
    //sending request for fetching filterValues
    
    this.sendFilterReq = function(el,view,form)
    {
      var dlg = ZDBDialogUtil.focusDialog;
      var field = dlg.field;
      var form = form ? form : el.form;
      var compType = dlg.modifyProps.comptype;
      dlg.modifyProps.isallval = "false";//No I18N
      this.setFilterNavEl(field, dlg,compType);
      ZDBAnalysisFilter.selectFilterField(dlg.view, field,field.filterNav.firstElementChild,field.filterNav);
    }    

    
    //animation for filterValues dlg
    
    this.handleSlcValOnly = function()
    {
        var dlg = ZDBDialogUtil.focusDialog; 
        jQuery(dlg.subFuncNavDiv).slideUp("slow");//No I18N
        jQuery(dlg.VMFilterNavDiv).slideDown("slow");//No I18N
        dlg.modifyProps.isallval = "false";
        dlg.field.filterNav.setAttribute("navdiv","true");//No I18N  //for qa
    }
    
    this.handleAllValue = function()
    {
        var dlg = ZDBDialogUtil.focusDialog; 
        jQuery(dlg.VMFilterNavDiv).slideUp("slow");//No I18N
        jQuery(dlg.subFuncNavDiv).slideDown("slow");//No I18N
        dlg.modifyProps.isallval = "true";
    }

    this.selectionAllOrSelec = function(isAll, el)
    {
        var dlg = ZDBDialogUtil.focusDialog; 
        if(isAll == "true")//No I18N
        {
            ZAVMFilterEdit.handleAllValue();
            ZAVMFilterEdit.updateSubtype(dlg, "true", dlg.modifyProps.comptype);//No I18N
        }
        else
        {
            ZAVMFilterEdit.updateSubtype(dlg, "false", dlg.modifyProps.comptype);//No I18N
            ZAVMFilterEdit.sendFilterReq(el);
        }
    }

    
    this.setFilterNavEl = function(field,dlgBody,compType)
    {
       var loading = dlgBody.filterLoadingIco;
       var filterNav = dlgBody.VMFilterNav;
        if(compType == "dr")
        {
           filterNav = dlgBody.dateRangeArea;
        }
       field.filterNav = filterNav;
       field.filterNav.filterLoading = loading;
    }
   


    //for selected items
    
    this.updateSlcCount = function(filterEl)
    {
        var count = filterEl.selItemHolder.childElementCount;
        filterEl.sclCountEl.innerText = count;
    }


    //while cliking count icon
    
    this.showHideSlcItemsHolder = function(el,firstTime)
    {
        var selection = el.getAttribute("sel");
        if(selection == "false")
        {
            ZDBAnalysisFilter.showSclItemsHolder(el,firstTime);
            el.setAttribute("sel","true");
        }
        else
        {
            ZDBAnalysisFilter.hideSclItemsHolder(el,firstTime);  
            el.setAttribute("sel","false");
        }
    }


//    6. Submit/Cancel handling

    this.finishDlg = function(el){
        ZAVMFilterEdit.validateNUpdateFilter(el,el.form);
    }


    this.getCompTypeFor = function (operation, uiType)
    {
        var compTypeDefn = ZAVMFilterEdit.compTypeDefn;
        var i = 0;
        var len = compTypeDefn.length;
        for (i = 0; i < len; i++)
        {
            if (compTypeDefn[i][0] == operation && compTypeDefn[i][1] == uiType)
            {
                return compTypeDefn[i][2];//returns the compType
            }
        }
    }


    this.getOrigColName = function (view, field)
    {

        if(view == null)
        {
            view = ZDBClientUI.getViewObj(field, "view")
        }
        var dispName = "";
        var ftIte = DOMUtils.getFirstMatchingChild(view.analysisFieldHolder, "*", "id", "ZDBFieldsIterationTable");//No I18N
        if (ftIte != null)//&& view.joinLinkDiv)
        {
            dispName = field.getAttribute("DISPLAYNAME");
            if (ftIte.getAttribute("isMultiTable") == "true") //No I18N
            {
                var tableName = this.getParentTableName(field);
                dispName = tableName + "." + dispName;
            }
        }
        return dispName;//ZAVMFilterEdit.trimOrigColName(dispName);
    }


    this.trimOrigColName = function (dispName)
    {
        if (!dispName)
        {
            return '';
        }
        if (dispName.length > 20)
        {
            dispName = dispName.substring(0, 15) + "..";
        }
        return dispName;
    }
 
 
    this.getParentTableName = function (field)
    {
        var fieldsEl = $("ZDBFieldsIterationTable");
        var colId = field.getAttribute("COLUMN_ID");
        var el = DOMUtils.getFirstMatchingChild(fieldsEl, "div", "column_id", colId); //No I18N
        var tableHead = ZDBUtil.getParentWithAttributeValue(el, "fieldtab", "true");//NO I18N
        var tableName = tableHead.getAttribute("displayname");
        return tableName;
    }

    this.setIncludeOthers = function (view)
    {
        var cr = ZDBDialogUtil.focusDialog.modifyProps.criteria;
        if (cr != "" && cr != null)
        {
            var index = cr.indexOf(ZAVMFilter.OTHERS_CR_KEY);
            if (index < 0)
            {
                $("inclOthers").checked = false;
            }
        }
    }

    this.setIncludeTimeTick = function (field)
    {
        var el = $("isTimeInclude");
        var par = el.parentNode;
        ZDBUtil.setNamedChildEls(par, par);
        el.checked = (field.getAttribute("INCLUDETIME") == "true");
    }


    this.getDlgId = function (step, name)
    {
        
        if (ZAVMFilterEdit.VMFilterDlgsInitialized)
        {
            return ZAVMFilterEdit.VMFilterDlgs[step - 1][name.toLowerCase()];
        }
        var catChooseValDlg = rem$("ZDBCatChooseValDlg");
        var VMFilterDlgs = [
            {categorical: rem$("ZDBCatCompDlg"), number: rem$("ZDBNumCompDlg"), absdatecategorical: rem$("ZDBDateCompDlg"), timelinecomp: rem$("ZDBTimeLineCompDlg"), addnewrangedlg: rem$("ZDBAddNewRangeDialog")}, //addontype is the name here
            {sbox: catChooseValDlg, msbox: catChooseValDlg, autofill: catChooseValDlg,
                dr: rem$("ZDBDateRangesDlg"), rp: rem$("ZDBRelPeriodDlg"), ap: rem$("ZDBActualPeriodDlg"), sp: rem$("ZDBSeasonalPeriodDlg"),
                slider: rem$("ZDBNumRangesSliderDlg"), numcombo: rem$("ZDBNumRankDlg")
            }//value of the selected option is the name here
        ];
        ZAVMFilterEdit.VMFilterDlgs = VMFilterDlgs;
        ZAVMFilterEdit.VMFilterDlgsInitialized = true;
        return VMFilterDlgs[step - 1][name.toLowerCase()];
    }


    this.initCalender = function (calenderHolder, showTime)
    {
        if (calenderHolder.initialized) {
            return;
        }
        ZDBCalender.showCalender(calenderHolder.fromValue.getAttribute("id"), calenderHolder.fromValue.getAttribute("id"), showTime);//No I18N
        ZDBCalender.showCalender(calenderHolder.toValue.getAttribute("id"), calenderHolder.toValue.getAttribute("id"), showTime);//No I18N
        calenderHolder.initialized = true;
    }


    this.setIncludeTime = function (el)
    {
        el.checked = (el.checked) ? true : false;
        var ZDBDateRangesDlg = $("ZDBDateRangesDlg");
        ZDBUtil.setNamedChildEls(ZDBDateRangesDlg, ZDBDateRangesDlg);
        if (ZDBDateRangesDlg.selectedValues.checked)
        {
            var fromVal = ZDBValidator.ValUserFltrDtFormat(ZDBDateRangesDlg.fromValue, el.checked);
            var toVal = ZDBValidator.ValUserFltrDtFormat(ZDBDateRangesDlg.toValue, el.checked);
            if (el.checked)
            {
                toVal = toVal.replace("00:00:00", "23:59:59");
            }
            ZDBDateRangesDlg.fromValue.value = fromVal;
            ZDBDateRangesDlg.toValue.value = toVal;
            var dlgBody = ZDBUtil.getParentWithAttributeValue(el, "valuedlg", "true");//NO I18N
            dlgBody.initialized = false;
            ZAVMFilterEdit.initCalender(dlgBody, el.checked);
        }
        ZDBDialogUtil.focusDialog.modifyProps.includeTime = el.checked;
    }


    this.checkNInitCalender = function (view, el,field)
    {
        var dlgBody = $("ZDBDateRangesDlg");
        var includeTime = $("isTimeInclude").checked;
        dlgBody.elnameSet = false;
        ZDBUtil.setNamedChildEls(dlgBody, dlgBody);
        //  this if check is for reverting the changed values back when the date format is changed and not finished
        if (!includeTime)
        {
            var fromDt = dlgBody.fromValue.value.trim();
            var toDt = dlgBody.toValue.value.trim();
            if (fromDt.length > 11)
            {
                dlgBody.fromValue.value = fromDt.substring(0, 11);
            }
            if (toDt.length > 11)
            {
                dlgBody.toValue.value = toDt.substring(0, 11);
            }
        }
        ZAVMFilterEdit.setIncludeTime($("isTimeInclude"));
        dlgBody.initialized = false;
        ZAVMFilterEdit.initCalender(dlgBody, includeTime);
    }
    
    
    this.addOptionToSBox = function (selectbox, opt)
    {
        opt = document.createElement("OPTION");
        selectbox.options.add(opt);
    }
    

    this.validateNUpdateFilter = function (el, form, view)
    {
        if (view == null)
        {
            view = ZDBClientUI.getViewObj(el, "view");//No I18N
        }
        var dlg = ZDBDialogUtil.focusDialog;
        var field = dlg.field;
        var addonType = field.getAttribute("ADDONTYPE");
        var compType = dlg.modifyProps.comptype;
        var labelField = form.label;
        if (addonType == "ABSDATECATEGORICAL" && compType == "dr")
        {
            if (!ZAVMFilterEdit.validateNUpdateRange(field, form))
            {
                return;
            }
        }
        
        if (!ZAVMFilterEdit.validateLabel(view, labelField, null, field)) 
        {
            return;
        }
        
        dlg.modifyProps.label = labelField.value.trim();
        
        //validating filter selection
        var filterOption = ZDBUtil.getRadioSelectedValue(form,"filterOption");//No I18N
        var filterEl = DOMUtils.getFirstMatchingChild(dlg,null,"filterel","true");//No I18N
        var isAllVal = dlg.modifyProps.isallval;
        var criteria = dlg.modifyProps.criteria;
        var rel_criteria = dlg.modifyProps.rel_criteria;
        if(filterOption == "selectedValues" && compType != "dr" && compType != "slider")
        {
            if(criteria == "")
            {
                ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.emptySelectedValues"));
                return;
            }
        }
        
        //actual inside, relative 
        if(compType == "ap" && form.RelDtSelect.checked)
        {
            var relFilterEl = DOMUtils.getFirstMatchingChild(dlg,"*","relVMFilterNav","true");//No I18N
            relFilterEl = DOMUtils.getFirstMatchingChild(relFilterEl,"*","filterel","true");
            if(rel_criteria == "")
            {
                ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.emptySelectedValues"));
                return;
            }
        }
        
        
        //validating default value(s)
        
        var defVal = form.defaultValues.value != "" && form.defaultValues.value != null;//form.defaultValues.getAttribute("seldefcr");
        if (defVal)
        {
            if(isAllVal == "true")
            {
                ZAVMFilterSearch.validateDefValue(el, view, form);
            }
            else
            {
                ZAVMFilterSearch.updateTheSelList(form.defaultValues);
                if(!ZAVMFilterEdit.validateNSetDefaultValue(field,form.defaultValues))
                {
                    return;
                }
                this.updateValuesNCloseDlg(view, form, filterEl, relFilterEl);
            }
        }
        else
        {
            dlg.modifyProps.defaultcriteria = "";
            dlg.modifyProps.defaultdisplaycriteria = "";
            this.updateValuesNCloseDlg(view, form, filterEl, relFilterEl);
        }

    }

    this.updateValuesNCloseDlg = function(view, form, filterEl, relFilterEl)
    {
        var dlg = ZDBDialogUtil.focusDialog;
        var field = dlg.field;
        this.updateCompAttributes(dlg.modifyProps,field);
        this.applyToVMFilterEl(view,relFilterEl);
        ZAVMFilterEdit.focusDlg = null;
        ZDBDialogUtil.focusDialog.field = null;
        ZDBDialogUtil.closeDialog();
        this.applyDefaultValue(field);
        ZDBAnalysisView.showRefreshDiv(view);
    }
    
    //components extra updations
    this.applyToVMFilterEl = function(view,relFilterEl)
    {
        
        var dlg = ZDBDialogUtil.focusDialog;
        var field = dlg.field;
        var form = dlg.getElementsByTagName("FORM")[0];
        var isAllVal = dlg.modifyProps.isallval;
        var compType = dlg.modifyProps.comptype;
        var label = dlg.modifyProps.label.trim();
        var uiType = dlg.modifyProps.uitype;
        var addonType = field.getAttribute("ADDONTYPE");
        if(compType == "slider")
        {
            ZDBAnalysisFilter.sendFilterFieldInfo(field);
        }
        
        if(isAllVal == "false" && compType != "slider")
        {
            var criteria = dlg.modifyProps.criteria;
            var dispCriteria = dlg.modifyProps.displaycriteria;
            if (compType != "dr" && compType != "slider")
            {
                this.inclOthers = $("inclOthers").checked;
                var crDet = this.checkOthersNsetCriteria(this.inclOthers, criteria, dispCriteria, ZAVMFilter.OTHERS_KEY);
                field.setAttribute("CRITERIA", crDet[0]);
                field.setAttribute("DISPLAYCRITERIA", crDet[1]);
            }
        }
        if(!(field.oldCompType) || field.oldCompType != compType || field.oldUiType != uiType )
        {
            field.compElContainer.innerText = "";
            var inputComp = ZAVMFilterEdit[addonType.toLowerCase() + "Component"](field);//No I18N
            field.compElContainer.appendChild(inputComp);
            field.filterHead=inputComp.getAttribute("elname")=="filterHead"?inputComp:DOMUtils.getFirstMatchingChild(inputComp,"DIV","elname","filterHead");//NO I18N
            
        }    
        field.oldCompType = compType; 
        field.oldUiType = uiType;
        if(compType == "dr")
        {
            var form = dlg.getElementsByTagName("FORM")[0];
            if(field.dateMenuEl)
            {
                var formEl = DOMUtils.getFirstMatchingChild(field.dateMenuEl,"INPUT","elname","fromValue");//No I18N
                var toEl = DOMUtils.getFirstMatchingChild(field.dateMenuEl,"INPUT","elname","toValue");//No I18N
                formEl.initialized = false;
                toEl.initialized = false;
            }
            if(isAllVal == "true")
            {
                field.setAttribute("MINDATE", "01 Jan 1000");//No I18N
                field.setAttribute("MAXDATE", "30 Dec 9999");//No I18N
            }
        }
        if((compType == "ap" || compType == "sp") && isAllVal=="true")
        {
            var value = form["subFunction"].getAttribute("value");//No I18N
            var subType = value ? value : ZAVMFilterEdit.subType[compType];
            field.setAttribute("SUBTYPE", subType);
        }
        if(compType != "dr" && compType != "slider" && isAllVal=="true" && field.filterNav)
        {
            field.setAttribute("CRITERIA","");//NO I18N
            field.setAttribute("DISPLAYCRITERIA","");//NO I18N
        }
        field.compElContainer.removeAttribute("selval");
        field.compElContainer.removeAttribute("displayval");
        field.compElContainer.removeAttribute("dispselval");
        field.compLabel.innerHTML = ZDBEscapeUtil.encodeForHtml(label + ":");
        field.compLabel.setAttribute("data-tip", ZDBEscapeUtil.encodeForHtml(label));
        field.setAttribute("VMFilterFetchStatus", "0");
    }
    

    this.applyDefaultValue = function (compEl)
    {
        var dispDivs = DOMUtils.getChildElsWithAttr(compEl.compElContainer, "elname", "displaySelected"); //NO I18N
        var dispDiv = dispDivs[0];
        if (dispDiv)
        {
    		var uiType = compEl.getAttribute("UITYPE");
        	var isAllVal = compEl.getAttribute("ISALLVAL");
        	var defaultCr = compEl.getAttribute("DEFAULTCRITERIA");
        	var defaultdisCr = compEl.getAttribute("DEFAULTDISPLAYCRITERIA");
        	var criteria = compEl.getAttribute("CRITERIA");
        	var displayCr = compEl.getAttribute("DISPLAYCRITERIA");
            if(isAllVal != "true")
            {
                var isDefCrNCrEqual = (ZAVMFilter.isCrEqual(defaultCr, criteria) || ZAVMFilter.isCrEqual(defaultdisCr, displayCr));
            }
            var defDispCrit = (isDefCrNCrEqual) ? "" : defaultdisCr;
            var displayStr = (uiType == 2) ? ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.all") : ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select");
            var dispVal = (defDispCrit == "") ? displayStr : defDispCrit; //NO I18N
            dispDiv.value = dispVal;
            dispDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(dispVal);
        }
    }
    
    
    this.updateSliderRanges = function (response, requestOptions)
    {
        var div = document.createElement("div");
        div.innerHTML = response.responseText;
        ZDBUtil.setNamedChildEls(div, div);
        var minValue = div.fromValue.getAttribute("origVal");//NO I18N
        var minDispValue = div.fromValue.getAttribute("dispValue");//NO I18N
        var maxValue = div.toValue.getAttribute("origVal");//NO I18N
        var maxDispValue = div.toValue.getAttribute("dispValue");//NO I18N
        var field = requestOptions["FIELDEL"];
        //var slider = field.slider;
        var slider = DOMUtils.getChildElsWithAttr(field, "elname", "slider")[0]; //NO I18N
        var minValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "minValue")[0];  //No I18N
        var maxValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "maxValue")[0];  //No I18N
        minValueEl.style.width = ZASliderComp.calcWidth(minDispValue) + "px";
        minValueEl.value = minDispValue;
        minValueEl.setAttribute("value", minDispValue)
        maxValueEl.style.width = ZASliderComp.calcWidth(maxDispValue) + "px";
        maxValueEl.value = maxDispValue;
        maxValueEl.setAttribute("value", maxDispValue)
        minValueEl.setAttribute("origVal", minValue);
        maxValueEl.setAttribute("origVal", maxValue);
        slider.setAttribute("MINVAL", minValue);
        slider.setAttribute("MAXVAL", maxValue);
        field.setAttribute("MINVAL", minValue);
        field.setAttribute("MAXVAL", maxValue);
        field.setAttribute("MINDISPVAL", minDispValue);
        field.setAttribute("MAXDISPVAL", maxDispValue);
    }


    this.checkOthersNsetCriteria = function (inclOthers, criteria, dispCriteria)
    {
        var othersStr = ZAVMFilter.OTHERS_CR_KEY;
        var othersDispStr = ZAVMFilter.OTHERS_KEY;
        if (criteria == null || criteria == "") {
            return "";
        }
        criteria = criteria.replace(/,$/g, '');
        dispCriteria = dispCriteria.replace(/,$/g, '');

        var crArr = criteria.split(",");
        var dispCrArr = dispCriteria.split(",");

        if (inclOthers)
        {
            if (jQuery.inArray(othersStr, crArr) < 0)
            {
                crArr.push(othersStr);
                dispCrArr.push(othersDispStr);
            }
        } else
        {
            var othersIdx = crArr.indexOf(othersStr);
            var othersDispIdx = dispCrArr.lastIndexOf(othersDispStr);
            if (othersIdx > -1)
            {
                crArr.splice(othersIdx, 1);
                dispCrArr.splice(othersDispIdx, 1);
            }
        }
        return new Array(crArr.join(",") + ",", dispCrArr.join(",") + ",");
    }


    this.placeCompEl = function (droppedArea, compEl)
    {
        ZDBAnalysisView.addFieldInDropArea(droppedArea, compEl);
    }

    this.validateNSetDefaultValue = function (field, defaultValueField)
    {
        var defaultValue = defaultValueField.value;
        defaultValue = ZAVMFilterUtil.trimCommaAtEnd(defaultValue);
        var dlg = ZDBDialogUtil.focusDialog;
        var compType = dlg.modifyProps.comptype;
        var filterOption = ZDBUtil.getRadioSelectedValue(defaultValueField.form,"filterOption");//No I18N
        var isAllVal = filterOption == "allValues" ? true : false;//No I18N
        if (defaultValue == "" || (compType == "dr") || (compType == "slider"))
        {
        	dlg.modifyProps.defaultcriteria = "";
        	dlg.modifyProps.defaultdisplaycriteria = "";
            ZAVMFilter.removeVariableAttributes(field);
            return true;
        }

        //validating variable
        var hasVariable = false;
        var defStrArr = this.getDefStrArray(defaultValue);
        var size = defStrArr.length;
        var pos = -1, varCount = 0;
        for (var i = 0; i < size; i++)
        {
            var defValue = defStrArr[i];
            var isVarPattern = ZAVMFilter.VAR_REGEX_PATTERN.exec(defValue);
            if (isVarPattern != null)
            {
                pos = i;
                varCount++;
                hasVariable = true;
            }
        }
        if (varCount > 1)
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.onlyOneVarAllowed"),
                    defaultValueField);
            $("customAlertMessage").style.width = "auto";
            $("_CUSTOMALERTFRAME").style.width = "auto";
            return false;
        }
        if (!hasVariable)
        {
            ZAVMFilter.removeVariableAttributes(field);
        }

        //checking others in default field
        var otherspos = defaultValue.indexOf(ZAVMFilter.OTHERS_KEY);
        this.inclOthers = $("inclOthers") ?  $("inclOthers").checked : null;//bcz others Element moved to ListSeletedValue inside. 
        if (otherspos > -1 && (isAllVal || !this.inclOthers))
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.invalidDateValue"), defaultValueField);
            $("customAlertMessage").style.width = "auto";
            $("_CUSTOMALERTFRAME").style.width = "auto";
            return false;
        }
        defaultValue = ZAVMFilterUtil.trimCommaAtEnd(defaultValue);
        var addonType = field.getAttribute("ADDONTYPE");
        var uiType = dlg.modifyProps.uitype;
        if (uiType != 2 && defStrArr.length > 1)
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.onlyOneAllowed"), defaultValueField);
            return false;
        }
        if (!isAllVal)
        {
            return this.isValidDefCriteria(field, defStrArr, defaultValueField, pos);
        }
        return true;
    }

    this.isValidDefCriteria = function (field, defStrArr, defaultValueField, varPos)
    {
        var arrList = ZAVMFilterSearch.defArrList;
        var defCr = "";
        var defValue = "";
        var variableName = "", variableValue = "";
        if (varPos != -1) {
            variableName = defStrArr[varPos];
        }
        var errMsg = ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.invalidDateValue");
        for (var j = 0; j < defStrArr.length && defStrArr[i] != ""; j++)
        {
            var val = defStrArr[j];
            var matched = false;
            if (j == varPos)
            {
                var jsonData = JSON.parse($("varInfo").getAttribute("variableInfo"));
                variableName = val;
                var defaultVal = val.substring(2, val.length - 1);
                variableValue = jsonData[defaultVal];
                if (variableValue == undefined)
                {
                    errMsg = ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.invalidVariable");
                } else
                {
                    defCr = defCr + val + ",";
                    defValue = defValue + val + ",";
                    matched = true;
                }
            } else
            {
                var varPatternData = false;
                if (val.length > 12 && val.indexOf("--D--" + ZAVMFilter.START_VAR_PATTERN) == 0 &&
                        val.indexOf(ZAVMFilter.END_VAR_PATTERN + "--D--") == val.length - 6)
                {
                    varPatternData = true;
                    val = val.substring(5, val.length - 5);
                }
                for (var i = 0; i < arrList.length; i++)
                {
                    var arr = arrList[i];
                    if ((val.toLowerCase() == arr[1].toLowerCase()))
                    {
                        if (defCr.indexOf(arr[0] + ',') < 0)
                        {
                            defCr += (arr[0] != ZAVMFilter.OTHERS_CR_KEY) ? ZDBUtil.replaceStr(arr[0], "$", "--S--") + "," : //NO I18N
                                    arr[0] + ",";
                            var tempdispVal = (arr[1].indexOf("--C--") > 0 || varPatternData) ?
                                    "\"" + ZDBUtil.replaceStr(arr[1], "--C--", ",") + "\"" : arr[1]; //NO I18N
                            defValue += tempdispVal + ",";
                        } else if (varPatternData && val == variableName) // one of data is same as variable name
                        {
                            defCr += ZDBUtil.replaceStr(arr[0], "$", "--S--") + ",";    //NO I18N
                            defValue += "\"" + ZDBUtil.replaceStr(arr[1], "--C--", ",") + "\"" + ","; //No I18N
                        }
                        matched = true;
                        break;
                    }
                }
            }
            if (!matched)
            {
                showCustomMessage(errMsg, defaultValueField);
                $("customAlertMessage").style.width = "auto";
                $("_CUSTOMALERTFRAME").style.width = "auto";
                return false;
            }
        }
        var dlg = ZDBDialogUtil.focusDialog;
        defValue = ZAVMFilterUtil.trimCommaAtEnd(defValue);
        dlg.modifyProps.defaultcriteria = defCr;
        dlg.modifyProps.defaultdisplaycriteria = defValue;
        defaultValueField.setAttribute("selDefCr", defCr);
        if (varPos != -1)
        {
            var varCr = ZAVMFilterEdit.getVariableCriteria(defCr, variableName, variableValue);
            field.setAttribute("VALUEOFVAR", varCr[0]);
            field.setAttribute("DISPVALUEOFVAR", ZAVMFilterUtil.trimCommaAtEnd(varCr[1]));
            field.setAttribute("VARIABLEVALUE", variableValue);
            var cr = field.getAttribute("CRITERIA");
            if (cr.indexOf(variableValue + ",") >= 0) {
                field.setAttribute("VARVALINCRITERIA", true);
            } else {
                field.setAttribute("VARVALINCRITERIA", false);
            }
        } else
        {
            ZAVMFilter.removeVariableAttributes(field);
        }
        return true;
    }

    //enclose --C-- and variable pattern data in double quotes
    this.replaceWithQuotes = function (cr, hasOthersCr)
    {
        if (cr == ZAVMFilter.OTHERS_CR_KEY && hasOthersCr)
        {
            cr = ZAVMFilter.OTHERS_KEY;
        } else
        {
            var isVarPatternData = (cr.indexOf("--S--{") == 0 &&
                    cr.indexOf(ZAVMFilter.END_VAR_PATTERN) == cr.length - 1) ? true : false;
            if (cr.indexOf("--C--") >= 0 || isVarPatternData)
            {
                cr = "\"" + ZDBUtil.replaceStr(cr, "--C--", ",") + "\""; //NO I18N
            }
        }
        return cr;
    }

    // replace variable criteria and variable display criteria
    this.getVariableCriteria = function (crStr, varName, varValue)
    {
        var varCrArr = [];
        var valExists = false;
        var escVarValue = varValue
        escVarValue = ZDBUtil.replaceStr(escVarValue, "$", "--S--"); //NO I18N
        if (crStr.indexOf(escVarValue + ",") >= 0) {
            valExists = true;
        }
        var varCr = "", dispVarCr = "";
        var hasOthersCr = (crStr.indexOf(ZAVMFilter.OTHERS_CR_KEY+",") >= 0);
        crStr = ZAVMFilterUtil.trimCommaAtEnd(crStr);
        var crStrArr = crStr.split(",");
        for (var i = 0; i < crStrArr.length; i++)
        {
            var crStrVal = crStrArr[i];
            if (crStrVal == varName)
            {
                if (varValue != "" && !valExists)
                {
                    varCr += varValue + ",";
                    var dispVarVal = ZAVMFilterEdit.replaceWithQuotes(varValue, hasOthersCr);
                    dispVarCr += dispVarVal + ",";
                }
            } else
            {
                varCr += crStrVal + ",";
                dispVarVal = ZAVMFilterEdit.replaceWithQuotes(crStrVal, hasOthersCr);
                dispVarCr += dispVarVal + ",";
            }
        }
        varCr = ZDBUtil.replaceStr(varCr, "--S--", "$"); //NO I18N
        varCr = varCr.substring(0, varCr.length - 1);
        dispVarCr = ZDBUtil.replaceStr(dispVarCr, "--S--", "$"); //NO I18N
        dispVarCr = ZDBUtil.replaceStr(dispVarCr, "--NULL--", "Unknown"); //NO I18N
        varCrArr.push(varCr);
        varCrArr.push(dispVarCr);
        return varCrArr;
    }

    this.getDefStrArray = function (defStr)
    {
        var index1 = 0;
        var addStep1 = 2;
        while (index1 != -1)
        {
            if (index1 == 0 && defStr.indexOf("\"") == 0)
            {
                index1 = 0;
                addStep1 = 1;
            } else
            {
                index1 = defStr.indexOf(",\"", index1);
                addStep1 = 2;
            }
            if (index1 == defStr.length || index1 == -1) {
                break;
            }
            var index2 = 0;
            if (defStr.indexOf("\"", index1 + addStep1) == defStr.length - 1)
            {
                index2 = defStr.indexOf("\"", index1 + addStep1);
            } else
            {
                index2 = defStr.indexOf("\",", index1 + addStep1);
                index2 = (index2 == -1) ? defStr.lastIndexOf("\"") : index2;
            }
            var str = defStr.substring(index1 + addStep1 - 1, index2 + 1);
            var modifiedStr = ZDBUtil.replaceStr(defStr.substring(index1 + addStep1, index2), ",", "--C--"); //NO I18N
            index1 = index2;
            if ((str.indexOf("\"" + ZAVMFilter.START_VAR_PATTERN) == 0 &&
                    str.indexOf(ZAVMFilter.END_VAR_PATTERN + "\"") == str.length - 2))
            {
                defStr = defStr.replace(str, "--D--" + modifiedStr + "--D--");
            } else
            {
                defStr = defStr.replace(str, modifiedStr);
            }
        }
        var defArr = defStr.split(",");
        return defArr;
    }


    this.categoricalComponent = function (field)
    {
        var id = "ZAVMFilterType_" + field.getAttribute("UITYPE"); //NO I18N
        var inputComp = $(id).cloneNode(true);
        inputComp.id = "";
        return inputComp;
        //PENDING: "VALUESALLOWED","DROPPOSITION" + Handling Auto Filling component.
    }


    this.absdatecategoricalComponent = function (field)
    {
        var id = "ZAVMFilterType_" + field.getAttribute("UITYPE");//NO I18N
        var compType = field.getAttribute("COMPTYPE");
        var inputComp;
        if (compType == "dr")
        {
            inputComp = ZAVMFilterEdit.getDateRangesLimit(null, null, id);
            return inputComp;
        }
        inputComp = $(id).cloneNode(true);
        return inputComp;
    }
    
    
    this.getDateRangesLimit = function (form, view, id)
    {
        var dummyCalenderComp = $(id).cloneNode(true);
        var inputComp = dummyCalenderComp.cloneNode(true);
        inputComp.id = "";
        document.body.appendChild(inputComp);
        ZAVMFilterUtil.clearIDNSetupCalender(dummyCalenderComp, inputComp);
        return inputComp;
    }
    

    this.numberComponent = function (field)
    {
        var id = "ZAVMFilterType_" + field.getAttribute("UITYPE");//NO I18N
        var inputComp = $(id).cloneNode(true);
        inputComp.id = "";
        return inputComp;
    }
    

    this.getCompEl = function ()
    {
        var compEl = ZDBAnalysisView.VMFilterFieldTpl.cloneNode(true);
        return compEl;
    }


    this.cancelOnEsc = function (dlg)
    {
        var view = dlg.params["VIEW"];
        var field = dlg.field;
        var defList = $("defList");
        if (defList) {
            defList.parentNode.removeChild(defList);
        }
        ZAVMFilterEdit.focusDlg = null;
        ZDBDialogUtil.focusDialog.field = null;
        return true;
    }


    this.cancel = function (el, remDlg, dlgName)
    {
        var view = ZDBClientUI.getViewObj(el, "view");//NO I18N
        ZDBDialogUtil.focusDialog.modifyProps = null;
        ZDBDialogUtil.focusDialog.field = null;
        ZAVMFilterEdit.focusDlg = null;
        ZDBDialogUtil.closeDialog();        
    }
    
    
    this.validateLabel = function (view, labelField, value, field)
    {
        var label = value ? value : labelField.value;
        label = label.trim();
        if (label == "" || label == null)
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.emptyLabel"), labelField);
            return false;
        } else if (label.length > 100)
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.exeededLabel"), labelField);
            $("customAlertMessage").style.width = labelField.parentNode.offsetWidth / 2 + "px";
            $("_CUSTOMALERTFRAME").style.width = labelField.parentNode.offsetWidth / 2 + "px";
            return false;
        }
        var VMFiltersList = view.VMFiltersList;
        var len = VMFiltersList.length;
        var compEl = null;
        for (var i = 0; i < len; i++)
        {
            compEl = VMFiltersList[i];
            var existLabel = compEl.getAttribute("LABEL");
            if (existLabel.toUpperCase() == label.toUpperCase() && (compEl != field))
            {
                showCustomMessage(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.duplicated"), labelField);
                return false;
            }
        }
        return true;
    }


    this.validateNUpdateRange = function (fieldToSet, form)
    {
        var filterOption = ZDBUtil.getRadioSelectedValue(form,"filterOption");//No I18N
        var isAllValue = filterOption == "allValues" ? "true" : "false";//No I18N
        var includeTime = (form.includeTime.checked) ? true : false;
        var dlg = ZDBDialogUtil.focusDialog; 
        dlg.modifyProps.includetime = includeTime.toString()
        if (isAllValue == "true")
        {
        	dlg.modifyProps.criteria = "";
            dlg.modifyProps.displaycriteria = "";
            return true;
        }
        ZDBUtil.setNamedChildEls(form,"name")
        var minDate = form["minDateLimitEl"];
        var maxDate = form["maxDateLimitEl"];
        var fromDt = ZDBValidator.ValUserFltrDtFormat(minDate, includeTime);
        var toDt = ZDBValidator.ValUserFltrDtFormat(maxDate, includeTime);
        if (includeTime)
        {
            toDt = toDt.replace("00:00:00", "23:59:59");
        }
        if (fromDt == "false" || toDt == "false")
        {
            return false;
        }
        minDate.value = fromDt;
        maxDate.value = toDt;
        if ((new Date(fromDt) > new Date(toDt)) && (isAllValue != "true"))
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.FromDtLarge"), minDate); // need I18N
            return false;
        }
        if (isAllValue == "false")
        {
            fieldToSet.setAttribute("MINDATE", fromDt);
            fieldToSet.setAttribute("MAXDATE", toDt);
        }
        var criteria = "B " + fromDt.trim() + "-" + toDt.trim() + ",";//No I18N
        var displayCriteria = fromDt + ' to ' + toDt; //NO I18N
        dlg.modifyProps.criteria = criteria;
        dlg.modifyProps.displaycriteria = displayCriteria;
        return true;
    }


    this.reOrderField = function (view, droppedArea, dragged)
    {
        dragged.style.position = "";
        dragged.style.top = "";
        dragged.style.left = "";
        ZDBAnalysisView.addFieldInDropArea(droppedArea, dragged);
        view.setModified();
        ZAVMFilterEdit.orderVMFiltersList(view);
        view.setModified();
    }


    this.removeVMFilterField = function (view, dragged, showRefreshDiv)
    {
        if (!view.editMode)
        {
            return;
        }
        ZDBUtil.removeFromSet(view.VMFiltersList, dragged);
        if (dragged.getAttribute("isTimeLineComp") == "true")
        {
            ZRTimelineFilter.removeTimeLineComp(view);
        }
        if (dragged.parentNode != null)
        {
            dragged.parentNode.removeChild(dragged);
        }
        (showRefreshDiv == true) ? ZDBAnalysisView.showRefreshDiv(view) : view.setModified();
    }


    this.orderVMFiltersList = function (view)
    {
        var VMFilterDropArea = view.VMFilterDropArea;
        ZDBUtil.removeNonElements(VMFilterDropArea);
        var VMFilterFields = VMFilterDropArea.childNodes;
        var len = VMFilterFields.length;
        var VMFiltersList = view.VMFiltersList;
        VMFiltersList.clear();
        for (var i = 0; i < len; i++)
        {
            var child = VMFilterFields[i];
            if ((child.getAttribute) && ((child.getAttribute("column_id") != null) || (child.getAttribute("isTimeLineComp") == "true")))
            {
                child.setAttribute("POSITION", i + 1);
                if (child.getAttribute("isTimeLineComp") != "true")
                {
                    (VMFiltersList.push(child));
                }
            }
        }
    }


    this.hideDefString = function (el)
    {
        ZAVMFilterSearch.updateTheSelList(el);
        if (el.getAttribute("selDefCr") != "[NONE]")
        {
            return;
        }
        if (el.getAttribute("TIPSHOWN") == "true")
        {
            el.value = "";
            el.setAttribute("selDefCr", "");
            el.setAttribute("TIPSHOWN", "false");
        }
    }
    
    
    this.showDefString = function (el)
    {
        if ((el.value.trim() == "") && (el.getAttribute("tipShown") == "false"))
        {
            el.value = "";
            el.setAttribute("selDefCr", "[NONE]")
            el.setAttribute("TIPSHOWN", "true");
        }

    }
    
    
    this.showToolTip = function (el, event)
    {
//        var view = ZDBClientUI.getViewObj(el, "view"); //No I18N
        var dlg = ZDBDialogUtil.focusDialog;
        var addonType = dlg.field.getAttribute("ADDONTYPE");
        var compType = dlg.compTypeSlc.getAttribute("value");
        var form = dlg.getElementsByTagName("FORM")[0];
        var uiType = (addonType == "ABSDATECATEGORICAL" && compType != "dr") ? form["uitype"].value : ZAVMFilterEdit.uiType[compType];//No I18N
        var attr = "tip"; //No I18N 
        if (uiType == 2)
        {
            el.setAttribute(attr, ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.msDefaultValuesDesc")); //No I18N
        }
        if (uiType == 4)
        {
            el.setAttribute(attr, ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.ssDefaultValuesDesc")); //No I18N
        }
        ZDBToolTip.show(el, event);

    }

    this.confirmAndUnCheck = function (el)
    {
        var view = ZDBClientUI.getViewObj(el, "view"); //NO I18N
        var msg = (!el.checked) ? ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.selectOthers") : ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.deSelectOthers");
        ZDBAlertAPI.showMsg(msg, "ZDBYESNO", {ONCLICK: ZAVMFilterEdit.chekOrUnchekOthers, ELEMENT: el}, null, null, null, view);//NO I18N
    }
    this.chekOrUnchekOthers = function (clickType, reqOpts, event, view)
    {
        var el = reqOpts["ELEMENT"];
        if (clickType == "YES")
        {
            el.checked = (el.checked) ? false : true;
        }
    }
    this.showHideRelFilterList = function (el, focusToTop)
    {
        var relDtEl = ZDBUtil.getParentWithAttributeValue(el, "elname", "RelValueDet");//NO I18N
        var isTransition = document.documentMode && document.documentMode < 9 ? false : true;
        ZDBUtil.setNamedChildEls(relDtEl, relDtEl);
//        var view = ZDBClientUI.getViewObj(el, "view");
        var dlg = ZDBDialogUtil.focusDialog;
        var view = dlg.view;
        var field = dlg.field;
        dlg.modifyProps.relrow_present = el.checked;
        if (!el.checked)
        {
            ZDBAnalysisFilter.clearSelected(DOMUtils.getFirstMatchingChild(relDtEl,null,"elname","resetFilter"),view);//No I18N
            isTransition ? jQuery(relDtEl.relSelectedValuesDiv).slideUp('slow') : relDtEl.relSelectedValuesDiv.style.display = "none";//NO I18N
            dlg.modifyProps.rel_addontype="";
            dlg.modifyProps.rel_operation="";
            dlg.modifyProps.rel_subtype="";
            dlg.modifyProps.rel_criteria="";
            dlg.modifyProps.rel_dispcriteria="";
            return;
        }
        var rel_subtype = (focusToTop) ? field.getAttribute("REL_SUBTYPE") : 100;
        dlg.modifyProps.rel_addontype = el.getAttribute("ADDONTYPE");
        dlg.modifyProps.rel_operation = el.getAttribute("OPERATION");
        dlg.modifyProps.rel_subtype = rel_subtype;
        if (isTransition)
        {
            jQuery(relDtEl.relSelectedValuesDiv).slideDown('slow').scrollTop(100);//NO I18N
            var dlgFrstBx = ZDBUtil.getParentWithAttributeValue(relDtEl, "dlgFirstBox", "true"); //NO I18N
            if (!focusToTop && dlgFrstBx.offsetHeight > 150)//!focusToTop && 
            {
                jQuery(dlgFrstBx).animate({scrollTop: dlgFrstBx.scrollHeight}, 1000);
            }
            
        } else
        {
            relDtEl.relSelectedValuesDiv.style.display = "";
        }
        relDtEl.relVMFilterNav.filterEl = null;
        filterNav = dlg.relVMFilterNav;
        filterNav.filterLoading = dlg.RelfilterLoadingIco;
        ZDBAnalysisFilter.selectnReplaceFilterField(view, field, relDtEl.relDefaultNav, false, relDtEl.relVMFilterNav);
    }
    
    this.constructList = function(el,type,datas)
    {
        var size = datas.length;
        jQuery(el).data("zselectbox") && jQuery(el).zselectbox("destroy"); //No I18N
        jQuery(el).zselectbox({
                dropdownList : {width:"100",appendTo:jQuery("#ZDBVMFilterTabFrame")} //No I18N
            });
            jQuery(el).zselectbox("setAttribute","dropdownEl","true");//No I18N
        for(var i=0; i < size ; i++)
        {
            var comp = datas[i]["COMP"];
            var dispVal = datas[i]["DISP"];
            var desc = datas[i]["DESC"];
            var tip = datas[i]["TIP"];
            var obj = jQuery(el).zselectbox('addOption', [{ //No I18N
                label: dispVal,
                description: desc,
                value: comp,
                customAttributes: {
                    title: tip,
                    "data-title-inner-html": "<b class='tipHeader'>"+dispVal+":</b><br><span>#title#</span>",//No I18N
                    "qaName": comp,//No I18N
                    "elName": comp,//No I18N
                    "class": "listColorCls",//No I18N
                    }
                    
                }]);
        }
        
        jQuery(el).on("zselectboxbeforedropdownlistopen", function(event, data){
            
            ZAVMFilterEdit.updateCascadeEl();   
       
        });

        jQuery("#ZDBVMFilterTabFrame").ztooltip({//No I18N
                displayType: 'callout',//NO I18N
                position: 'auto',//NO I18N
                className: "comptypeListTip",//NO I18N
                showDelay: 10,
                reshowDelay: 10,
                hideDelay: 0,
                pauseOnMouseOver: "true",
        });
        
        jQuery(el).zselectbox("setAttribute", "selectedIndex", 0);//No I18N
        jQuery(el).on("zselectboxchange",function(event,data)
        {
            var dlg = ZDBDialogUtil.focusDialog;
            var selVal = data.selectedValue;
            el.setAttribute("value", selVal);
            if(type == "operation")
            {
                dlg.modifyProps.operation = selVal;
            }
            else if(type == "uitype")
            {
                ZAVMFilterEdit.updateUitypeDependentEls(ZAVMFilterEdit.uiType[selVal]);
            }
            else if(type == "subtype")
            {
                dlg.modifyProps.subtype = selVal;
            }
            else if(type == "behavior")
            {
                dlg.modifyProps.cascadelist = selVal;
            }
            else
            {
                dlg.modifyProps.comptype = selVal;
                ZAVMFilterEdit.showValueDlg(el.form,null,true);
            }
        }); 
        el.setAttribute("isListCreated","true");
    }
    
    this.updateSelItem = function(el,value,type)
    {
        jQuery(el).zselectbox("setValue",value);//No I18N
        el.setAttribute("value",value);
        ZDBDialogUtil.focusDialog.modifyProps[type] = value;
        if(type == "comptype")//not for number operation
        {
           ZAVMFilterEdit.showValueDlg(el.form);
        }
        else if(type == "uitype")
        {
            ZAVMFilterEdit.updateUitypeDependentEls(ZAVMFilterEdit.uiType[value]);
        }
    }
    
    this.updateUitypeDependentEls = function(uiType)
    {
        var dlg = ZDBDialogUtil.focusDialog;
        var view = dlg.view;
        var compType = dlg.modifyProps.comptype;
        var defExampleTxt = dlg.defExampleTxt;
        var defValsHeading = dlg.defValsHeading;
        dlg.modifyProps.uitype = uiType;
        var defVal = uiType==2 ? ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.defaultValues") : ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.defaultValue"); //NO I18N
        defExampleTxt.placeholder = this.hintTxt[compType];
        defValsHeading.innerHTML = defVal;
    }
        
    this.VMFTooltip = function(el,title,title2,header,header2)
    {
        jQuery(el).ztooltip({
                customAttributes: {
                    title: title,
                    "data-title-inner-html": "<b class='tipHeader'>"+header+":</b><br><span>#title#</span><br><br><b class='tipHeader'>"+header2+":</b><br><span>#title2#</span>",//No I18N   
                }});
    }
    
    
    
    this.setDefaultValue = function (compEl)
    {
        var dispDivs = DOMUtils.getChildElsWithAttr(compEl.compElContainer, "elname", "displaySelected"); //NO I18N
        var uiType = compEl.getAttribute("UITYPE");
        var dispDiv = dispDivs[0];
        if (dispDiv)
        {
            var isDefCrNCrEqual = ((ZAVMFilter.isCrEqual(compEl.getAttribute("DEFAULTCRITERIA"), compEl.getAttribute("CRITERIA")) || ZAVMFilter.isCrEqual(compEl.getAttribute("DEFAULTDISPLAYCRITERIA"), compEl.getAttribute("DISPLAYCRITERIA"))) && compEl.getAttribute("ISALLVAL") != "true");
            var defDispCrit = (isDefCrNCrEqual) ? "" : compEl.getAttribute("DEFAULTDISPLAYCRITERIA");
            var displayStr = (uiType == 2) ? ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.all") : ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select");
            var dispVal = (defDispCrit == "") ? displayStr : defDispCrit; //NO I18N
            if (uiType == 2) {
                dispDiv.value = dispVal;
            } else {
                dispDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(dispVal);
            }
        }
    }
    
    this.updateSubtype = function (dlg, isAll, comptype)
    {
        
        if (comptype=="ap" || comptype=="sp")
        {
            var form = dlg.getElementsByTagName("FORM")[0];
            var subtype = form["subFunction"].value;
            if (isAll == "false")
            {
                var funDiv = DOMUtils.getFirstMatchingChild(dlg.VMFilterNav, "a", "noeffect", "true");//NO I18N
                var subtype = (funDiv) ? funDiv.getAttribute("SUBTYPE") : dlg.modifyProps.subtype;
            }
            dlg.modifyProps.subtype = subtype;
        }
 
    }
    
    this.updateCascadeEl = function()
    {
        var dlg = ZDBDialogUtil.focusDialog;
        var subtype = dlg.modifyProps.subtype;
        var comptype = dlg.modifyProps.comptype;
        var relaventOpt = DOMUtils.getChildElsWithAttr(dlg,"elName","true")[0]; //No I18N
        if(relaventOpt && comptype == "numCombo" && subtype=="1")
        {
            relaventOpt.style.display="block";//No I18N
        }
        else if(relaventOpt && comptype == "numCombo" && subtype!="1")
        {
            relaventOpt.style.display="none";//No I18N
            ZAVMFilterEdit.updateSelItem(dlg.cascadeList,"false","cascadelist");//No I18N
        } 
    
    }
    
    
    ZDBLazyLoadUtil.loadJsAlone("thirdparty/js/zohocomponents.js",this,null)//No I18N
    ZDBLazyLoadUtil.loadCssOnly("CSSLIST_ZOHOCOMPONENTS", "APPENDTODOC"); //No I18N
    
}
