/**
 *
 * @param includeDisabled
 */

$ZC.DataProcessor.prototype.findXCategories = function(includeDisabled) {

    var processor = this,
        categoriesStore = processor.categoriesStore,
        processedseriesData = processor.processedseriesData,
        dataset = processor.dataset;

    var XCat = categoriesStore.x;

    processedseriesData.forEach(function(d, i) {
        var disabled = d.disabled && !includeDisabled,
            curdata = d.data;
        if (!disabled && curdata != null && curdata.constructor == Array) {
            curdata.map(function(subgroup, j) {
                if (subgroup != null && subgroup.constructor == Array) {
                    return subgroup.map(function(dataPoint) {
                        var xVal = dataset.getX(dataPoint);
                        ((xVal != null) && (XCat.indexOf(xVal) == -1)) ? XCat.push(xVal) : null;
                    })
                }
            })
        }
    });
    return XCat;
};

