//$Id$
var docEle = d3_select(document.documentElement),
    clickedTime,
    previousChartObj,
    clickArguments,
    clickedElement,
    docTapFunction = function(chartObj) {
        if ($Browser.isTouchDevice && ((!chartObj && clickArguments && previousChartObj) || (previousChartObj && previousChartObj != chartObj))) {
            var container = previousChartObj.container.node();
            if (document.body.contains(container) && (container.style.display != "none")) {
                clickArguments[4] = true;

                previousChartObj.eventHandler.tapOldInfo = null;
                previousChartObj.eventHandler.mouseOut.apply(clickedElement, clickArguments);
            }
        }
    };
$ZC.documentTapEvent = docTapFunction;

if ($Browser.isTouchDevice) {
    var callPlotMouseOut = function(){
        var now = new Date().getTime();
        if (!clickedTime || ((now - clickedTime) > 500)) {
            docTapFunction();
        }
    };

    var docTapHandlers = {
        "tap" : callPlotMouseOut,
        "taphold" : callPlotMouseOut,
        "dbltap" : callPlotMouseOut
    };
    attachevents(docEle, {}, docTapHandlers, {preventDefault: false});

    docEle
        .on('touchmove', function() {
            docTapFunction();
        });
}