//$Id$
function arcInnerTween(element, arc, innerRadius, outerRadius) {
    element.attrTween("d", function(d, i) {
        var interpolateOuterRadius = d3.interpolate(outerRadius[0], outerRadius[1]);
        var interpolateInnerRadius = d3.interpolate(innerRadius[0], innerRadius[1]);

        return function(t) {
            arc.outerRadius(interpolateOuterRadius(t));
            arc.innerRadius(interpolateInnerRadius(t));
            return arc(d);
        };
    });
}
