//$Id$
$ZC.plot.rendererConf = function() {
    var renderer = {};
    renderer.params = {};
    
    renderer.xscale = function(_) {
        if (!arguments.length) {
            return renderer.params.xscale;
        }
        renderer.params.xscale = _;
        return renderer;
    };
    
    renderer.yscale = function(_) {
        if (!arguments.length) {
            return renderer.params.yscale;
        }
        renderer.params.yscale = _;
        return renderer;
    };
    
    renderer.stacked = function(_) {
        if (!arguments.length) return renderer.params.stacked;
        renderer.params.stacked = _;
        return renderer;
    };
    
    renderer.datasetIndex = function(_) {
        if (!arguments.length) {
            return renderer.params.datasetIndex;
        }
        renderer.params.datasetIndex = _;
        return renderer;
    };
    
    renderer.axisrotated = function(_) {
        if (!arguments.length) {
            return renderer.params.axisrotated;
        }
        renderer.params.axisrotated = _;
        return renderer;
    };
    
    renderer.commonPlotOptions = function(_) {
        if (!arguments.length) {
            return renderer.params.commonPlotOptions;
        }
        renderer.params.commonPlotOptions = _;
        return renderer;
    };
    
    renderer.color = function(_) {
        if (!arguments.length) {
            return renderer.params.color;
        }
        renderer.params.color = _;
        return renderer;
    };
    
    renderer.chartObj = function(_) {
        if (!arguments.length) {
            return renderer.params.chartObj;
        }
        renderer.params.chartObj = _;
        return renderer;
    };
    
    renderer.notes = function(_) {
        if (!arguments.length) {
            return renderer.params.notesArray;
        }
        renderer.params.notesArray = _;
        return renderer;
    };
    
    renderer.updateLabelArrayAndLabelQueue = function(la, lq) {
        if (!arguments.length) {
            return [renderer.params.labelArray, renderer.params.labelQueue];
        }
        renderer.params.labelArray = la;
        renderer.params.labelQueue = lq;
        return renderer;
    };
    
    renderer.hasNegValue = function(_) {
        if (!arguments.length) {
            return renderer.params.hasNegValue;
        }
        renderer.params.hasNegValue = _;
        return renderer;
    };
    
    renderer.dataset = function(_) {
        if (!arguments.length) {
            return renderer.params.dataset;
        }
        renderer.params.dataset = _;
        return renderer;
    };
    
    renderer.yaxiscolumnorder = function(_) {
        if (!arguments.length) {
            return renderer.params.yaxiscolumnorder;
        }
        renderer.params.yaxiscolumnorder = _;
        return renderer;
    };

    renderer.threshold = function(_) {
        if (!arguments.length) {
            return renderer.params.threshold;
        }
        renderer.params.threshold = _;
        return renderer;
    };

    renderer.thresholdType = function(_) {
        if (!arguments.length) {
            return renderer.params.thresholdType;
        }
        renderer.params.thresholdType = _;
        return renderer;
    };

    renderer.colorOverlay = function(_) {
        if (!arguments.length) {
            return renderer.params.colorOverlay;
        }
        renderer.params.colorOverlay = _;
        return renderer;
    };
    
    return renderer;
};