//$Id$
function getSVGsymbol(type) {
    return function(size) {
        switch (type) {
            case "asterisk":
                return "M0 0 C" + (-size * 0.284) + " " + (-size * 0.994) + " " + (size * 0.284) + " " + (-size * 0.994) + " 0 0 C" + (size * 0.73) + " " + (-size * 0.76) + " " + (size * 1.2) + " " + (-size * 0.277) + " 0 0 C" + (size * 1.008) + " " + (size * 0.142) + " " + (size * 0.703) + " " + (size * 0.703) + " 0 0 C" + (size * 0.27) + " " + (size * 0.923) + " " + (-size * 0.284) + " " + (size * 0.923) + " 0 0 C" + (-size * 0.712) + " " + (size * 0.66) + " " + (-size * 0.923) + " " + (size * 0.234) + " 0 0 C" + (-size * 0.98) + " " + (-size * 0.284) + " " + (-size * 0.745) + " " + (-size * 0.73) + " 0 0";
            case "bean":
                return "M0 " + (size * 0.5) + " A" + (size * 0.25) + " " + (size * 0.5) + " 0 0 1 0 " + (-size * 0.5) + " A" + (size * 0.15) + " " + (size * 0.25) + " 0 0 1 1 0 A" + (size * 0.15) + " " + (size * 0.25) + " 0 0 1 0 " + (size * 0.5) + "";
            case "butterfly":
                return "M0 " + (-size * 0.25) + " C0 " + (-size * 0.25) + " " + (size) + " " + (-size) + " " + (size * 0.3) + " " + (size * 0.25) + " " + (size * 0.6) + " " + (size * 0.8) + " 0 " + (size * 0.4) + " 0 " + (size * 0.4) + " M0 " + (-size * 0.25) + " C0 " + (-size * 0.25) + " " + (-size) + " " + (-size) + " " + (-size * 0.3) + " " + (size * 0.25) + " " + (-size * 0.6) + " " + (size * 0.8) + " 0 " + (size * 0.4) + " 0 " + (size * 0.4) + " M0 " + (-size * 0.25) + " L" + (size * 0.1) + " " + (-size * 0.7) + " M0 " + (-size * 0.25) + " L" + (-size * 0.1) + " " + (-size * 0.7) + "";
            case "clover":
                return "M0 0 C" + (-size * 0.2) + " " + (-size) + " " + (size) + " " + (-size * 0.15) + " 0 0 " + (size) + " " + (size * 0.25) + " " + (-size * 0.2) + " " + (size) + " " + (-size * 0.05) + " " + (size * 0.05) + " " + (-size * 0.7) + " " + (size * 0.6) + " " + (-size * 0.7) + " " + (-size * 0.6) + " 0 " + (-size * 0.05) + " Z";
            case "cloverFour":
                return "M" + (-size * 0.1) + " " + (-size * 0.1) + " C" + (-size * 0.5) + " " + (-size * 0.8) + " " + (size * 0.5) + " " + (-size * 0.8) + " " + (size * 0.1) + " " + (-size * 0.1) + " " + (size * 0.8) + " " + (-size * 0.5) + " " + (size * 0.8) + " " + (size * 0.5) + " " + (size * 0.1) + " " + (size * 0.1) + " " + (size * 0.5) + " " + (size * 0.8) + " " + (-size * 0.5) + " " + (size * 0.8) + " " + (-size * 0.1) + " " + (size * 0.1) + " " + (-size * 0.8) + " " + (size * 0.5) + " " + (-size * 0.8) + " " + (-size * 0.5) + " " + (-size * 0.1) + " " + (-size * 0.1) + " " + (-size * 0.5) + " " + (-size * 0.8) + " " + (size * 0.5) + " " + (-size * 0.8) + " " + (size * 0.1) + " " + (-size * 0.1) + "";
            case "cross":
                return "M" + (-size / 2) + " " + (-size * 0.2) + " L" + (-size * 0.2) + " " + (-size * 0.2) + " L" + (-size * 0.2) + " " + (-size / 2) + " L" + (size * 0.2) + " " + (-size / 2) + " L" + (size * 0.2) + " " + (-size * 0.2) + " L" + (size / 2) + " " + (-size * 0.2) + " L" + (size / 2) + " " + (size * 0.2) + " L" + (size * 0.2) + " " + (size * 0.2) + " L" + (size * 0.2) + " " + (size / 2) + " L" + (-size * 0.2) + " " + (size / 2) + " L" + (-size * 0.2) + " " + (size * 0.2) + " L" + (-size / 2) + " " + (size * 0.2) + " Z";
            case "diamond":
                return "M" + (-size * 0.4) + " 0 L0 " + (-size / 2) + " L" + (size * 0.4) + " 0 L0 " + (size / 2) + " Z";
            case "ellipse":
                return "M" + (-size * 0.5) + " 0 A" + (size * 0.5) + " " + (size * 0.35) + " 0 0 1 " + (size * 0.5) + " 0 A" + (size * 0.5) + " " + (size * 0.35) + " 0 0 1 " + (-size * 0.5) + " 0";
            case "gear":
                return "M" + (-size * 0.134) + " " + (-size * 0.541) + " L" + (-size * 0.127) + " " + (-size * 0.696) + " " + (size * 0.131) + " " + (-size * 0.696) + " " + (size * 0.138) + " " + (-size * 0.547) + " " + (size * 0.282) + " " + (-size * 0.47) + " " + (size * 0.393) + " " + (-size * 0.571) + " " + (size * 0.598) + " " + (-size * 0.39) + " " + (size * 0.494) + " " + (-size * 0.282) + " " + (size * 0.531) + " " + (-size * 0.134) + " " + (size * 0.699) + " " + (-size * 0.134) + " " + (size * 0.699) + " " + (size * 0.138) + " " + (size * 0.539) + " " + (size * 0.138) + " " + (size * 0.474) + " " + (size * 0.279) + " " + (size * 0.575) + " " + (size * 0.386) + " " + (size * 0.369) + " " + (size * 0.578) + " " + (size * 0.286) + " " + (size * 0.474) + " " + (size * 0.131) + " " + (size * 0.531) + " " + (size * 0.131) + " " + (size * 0.696) + " " + (-size * 0.127) + " " + (size * 0.696) + " " + (-size * 0.127) + " " + (size * 0.531) + " " + (-size * 0.276) + " " + (size * 0.467) + " " + (-size * 0.39) + " " + (size * 0.575) + " " + (-size * 0.574) + " " + (size * 0.379) + " " + (-size * 0.47) + " " + (size * 0.279) + " " + (-size * 0.524) + " " + (size * 0.138) + " " + (-size * 0.7) + " " + (size * 0.138) + " " + (-size * 0.7) + " " + (-size * 0.138) + " " + (-size * 0.528) + " " + (-size * 0.138) + " " + (-size * 0.47) + " " + (-size * 0.282) + " " + (-size * 0.568) + " " + (-size * 0.383) + " " + (-size * 0.396) + " " + (-size * 0.568) + " " + (-size * 0.275) + " " + (-size * 0.463) + " " + (-size * 0.134) + " " + (-size * 0.541) + " Z";
            case "heart":
                return "M0 " + (-size * 0.2) + " C" + (size * 0.7) + " " + (-size * 0.7) + " " + (size * 0.7) + " " + (size * 0.2) + " 0 " + (size * 0.45) + " " + (-size * 0.7) + " " + (size * 0.2) + " " + (-size * 0.7) + " " + (-size * 0.7) + " 0 " + (-size * 0.2) + "Z";
            case "star":
                return "M0 " + (-size * 0.5) + " L" + (size * 0.122) + " " + (-size * 0.12) + " L" + (size * 0.5) + " " + (-size * 0.12) + " L" + (size * 0.197) + " " + (size * 0.12) + " L" + (size * 0.306) + " " + (size * 0.5) + " L0 " + (size * 0.274) + " L" + (-size * 0.306) + " " + (size * 0.5) + " L" + (-size * 0.197) + " " + (size * 0.12) + " L" + (-size * 0.5) + " " + (-size * 0.12) + " L" + (-size * 0.122) + " " + (-size * 0.12) + " Z";
            case "malteseCross":
                return "M" + (-size * 0.38) + " " + (-size * 0.5) + " A" + (size * 0.38) + " " + (size * 0.1) + " 0 0 1 " + (size * 0.38) + " " + (-size * 0.5) + " L" + (size * 0.2) + " " + (-size * 0.2) + " L" + (size * 0.5) + " " + (-size * 0.38) + " A" + (size * 0.1) + " " + (size * 0.38) + " 0 0 1 " + (size * 0.5) + " " + (size * 0.38) + " L" + (size * 0.2) + " " + (size * 0.2) + " L" + (size * 0.38) + " " + (size * 0.5) + " A" + (size * 0.38) + " " + (size * 0.1) + " 0 0 1 " + (-size * 0.38) + " " + (size * 0.5) + " L" + (-size * 0.2) + " " + (size * 0.2) + " L" + (-size * 0.5) + " " + (size * 0.38) + " A" + (size * 0.1) + " " + (size * 0.38) + " 0 0 1 " + (-size * 0.5) + " " + (-size * 0.38) + " L" + (-size * 0.2) + " " + (-size * 0.2) + " Z";
            case "square":
                return "M" + (-size * 0.5) + " " + (-size * 0.5) + " L" + (size * 0.5) + " " + (-size * 0.5) + " " + (size * 0.5) + " " + (size * 0.5) + " " + (-size * 0.5) + " " + (size * 0.5) + " Z";
            case "triangle-up":
                return "M" + (-size * 0.5) + " " + (size * 0.285) + " L0 " + (-size * 0.43) + " " + (size * 0.5) + " " + (size * 0.285) + " Z";
            case "triangle-down":
                return "M0 " + (size * 0.43) + " " + (-size * 0.5) + " " + (-size * 0.285) + " " + (size * 0.5) + " " + (-size * 0.285) + " Z";
            case "triangle-right":
                return "M" + (-size * 0.5) + " " + (-size * 0.43) + " " + (size * 0.285) + " 0 " + (-size * 0.5) + " " + (size * 0.43) + " Z";
            case "triangle-left":
                return "M" + (size * 0.5) + " " + (size * 0.43) + " " + (-size * 0.285) + " 0 " + (size * 0.5) + " " + (-size * 0.43) + " Z";
            case "arrow":
                return "M" + (-size * 0.5) + " " + (size * 0.2) + " L0 " + (-size * 0.5) + " " + (size * 0.5) + " " + (size * 0.2) + " " + (size * 0.25) + " " + (size * 0.2) + " " + (size * 0.25) + " " + (size * 0.5) + " " + (-size * 0.25) + " " + (size * 0.5) + " " + (-size * 0.25) + " " + (size * 0.2) + " Z";
            case "rocket":
                return "M" + (-size * 0.5) + " " + (size * 0.5) + " L0 " + (-size * 0.5) + " " + (size * 0.5) + " " + (size * 0.5) + " 0 " + (size * 0.25) + " " + (-size * 0.5) + " " + (size * 0.5) + " Z";
            case "nylon":
                return "M" + (-size / 2) + " " + (-size / 4) + " L" + (-size / 4) + " " + (-size / 4) + " L" + (-size / 4) + " " + (-size / 2) + " M" + (-size / 4) + " 0 L" + (-size / 4) + " " + (size / 4) + " L0 " + (size / 4) + " M0 " + (-size / 4) + " L" + (size / 4) + " " + (-size / 4) + " L" + (size / 4) + " 0 M" + (size / 4) + " " + (size / 2) + " L" + (size / 4) + " " + (size / 4) + " L" + (size / 2) + " " + (size / 4);
            case "waves":
                return "M" + (-size) + " 0 C" + (-size * 7 / 8) + " " + (-size / 4) + " " + (-size * 5 / 8) + " " + (-size / 4) + " " + (-size / 2) + " 0 C" + (-size * 3 / 8) + " " + (-size / 4) + " " + (-size / 8) + " " + (-size / 4) + " 0 0 C" + (size / 8) + " " + (size / 4) + " " + (size * 3 / 8) + " " + (size / 4) + " " + (size / 2) + " 0 C" + (size * 5 / 8) + " " + (-size / 4) + " " + (size * 7 / 8) + " " + (-size / 4) + " " + (size * 3 / 4) + " 0";
            case "woven":
                return "M" + (-size / 4) + " " + (-size / 4) + " L" + (size / 4) + " " + (size / 4) + " M" + (size / 4) + " " + (-size / 4) + " L" + (size / 2) + " " + (-size / 2) + " M" + (-size / 4) + " " + (size / 4) + " L" + (-size / 2) + " " + (size / 2) + " M" + (size / 4) + " " + (size * 3 / 4) + " L" + (size * 3/ 4) + " " + (size / 4);
            case "crosses":
                return "M " + (-size / 4) + " " + (-size / 4) + " L" + (size / 4) + "," + (size / 4) + " M" + (-size / 4) + "," + (size / 4) + " L" + (size / 4) + "," + (-size / 4);
            case "caps":
                return "M" + (-size / 4) + " " + (size / 4) + " L0 " + (-size / 4) + " " + (size / 4) + " " + (size / 4);
            case "hexagons":
                return "M" + (-size / 2) + " 0 L" + (-size / 4) + " 0 M" + (size / 2) + " 0 L" + (size / 4 ) + " " + (-size / 2) + " L0 " + (-size / 2) + " L" + (-size / 4) + " 0 L0 " + (size / 2) + " L" + (size / 4) + " " + (size / 2) + "Z";
            case "line":
            case "horizontal-line":
                return "M" + (-size * 0.5) + " 0 L" + (size * 0.5) + " 0";
            case "diagonal-line-right":
                return "M" + (-size * 3 / 4) + " " + (-size / 4) + " L" + (-size / 4) + " " + (-size * 3 / 4) + " M" + (-size / 2) + " " + (size / 2) + " L" + (size / 2) + " " + (-size / 2) + " M" + (size / 4) + " " + (size * 3 / 4) + " L" + (size * 3 / 4) + " " + (size / 4);
            case "vertical-line":
                return "M0 " + (-size / 2) + " L0 " + (size / 2);
            case "hexagon":
                return "M" + (size * 0.433) + " " + (size * 0.25) + " L" + (0 * size) + " " + (size * 0.5) + " L" + (size * -0.433) + " " + (size * 0.25) + " L" + (size * -0.433) + " " + (size * -0.26) + " L" + (0 * size) + " " + (size * -0.5) + " L" + (size * 0.433) + " " + (size * -0.26) + " Z";
            case "diagonal-line-left":
                return "M" + (-size * 3 / 4) + " " + (-size / 2) + " L" + (-size / 4) + " " + (size / 2) + " M" + (-size / 4) + " " + (-size / 2) + " L" + (size / 4) + " " + (size / 2) +" M" + (size / 4) + " " + (-size / 2) + " L" + (size * 3 / 4) + " " + (size / 2);
            case "oval":
                return "M" + (-size / 2) + " 0 A" + (size / 2) + " " + (size / 2) + " 0 0 1 0 " + (-size / 2) + " A" + (size / 2) + " " + (size / 2) + " 0 0 1 " + (-size / 2) + " 0";
            default: //circle
                return "M" + (-size / 2) + " 0 A" + (size / 2) + " " + (size / 2) + " 0 0 1 " + (size / 2) + " 0 A" + (size / 2) + " " + (size / 2) + " 0 0 1 " + (-size / 2) + " 0";
        }
    };
}

function addSVGmarker(parentElement, id, markeroptions, extraParams) {
    var color = extraParams.color,
        DIM = 10,
        marker,
        sw = extraParams.strokeWidth,
        img = extraParams.imageSize,
        tran = extraParams.transform,
        symbolpath = getSVGsymbol(markeroptions.symbol || extraParams.symbol),
        hasImage = ((markeroptions.imageUrl != null && markeroptions.imageUrl !== "")),
        size = validateNullVal(markeroptions.size, validateNullVal(sw, 1)),
        outersize = size * extraParams.symbolSize.outer,
        innersize = size * extraParams.symbolSize.inner,
        transform = ((tran != null) ? ("translate(" + tran[0] + "," + tran[1] + ")") : null),
        imgSize = ((id != null) ? size : outersize) * ((img != null) ? img : DIM);
    if (id != null) { //if id is not null create marker element else create path/image element
        var defs = $ZCG.patternSVG.select("defs");
        marker = appendEle(defs, "marker", [1], "#", "id", id);
        marker
            .attr({
                "id": id,
                "orient": 0,
                "viewBox": (-size * DIM / 2) + " " + (-size * DIM / 2) + " " + (size * DIM) + " " + (size * DIM),
                "markerUnits": "userSpaceOnUse",
                "markerWidth": size * DIM,
                "markerHeight": size * DIM
            });
    } else {
        marker = parentElement;
    }
    
    var outermarkerpath = appendEle(marker, "path", [1], ".", "class", "outer");
    outermarkerpath
        .attr({
            "d": symbolpath(hasImage ? imgSize : (outersize * DIM)),
            "transform": transform
        })
        .style({
            "fill": function() {
                if (hasImage) {
                    var conf = {
                        "name": markeroptions.imageUrl,
                        "width": imgSize,
                        "height": imgSize,
                        "x": -imgSize / 2,
                        "y": -imgSize / 2
                    };
                    return "url(" + getDefsLocation() + "#" + effects.get(svg_patterns,"imageFill", conf) + ")";
                }
                return markeroptions.outerFillColor || color;
            },
            "fill-opacity": markeroptions.outerFillOpacity,
            "stroke": markeroptions.outerStrokeColor || color,
            "stroke-opacity": markeroptions.outerStrokeOpacity,
            "stroke-width": markeroptions.outerStrokeWidth,
            "stroke-dasharray": getDashArray(markeroptions.outerDashStyle, markeroptions.outerStrokeWidth),
            "stroke-linecap": getLineCap(markeroptions.outerLineCap, markeroptions.outerDashStyle)
        });
    
    var innermarkerpath = appendEle(marker, "path", ((!hasImage) ? [1] : []), ".", "class", "inner");
    innermarkerpath
        .attr({
            "d": symbolpath(innersize * DIM),
            "transform": transform
        })
        .style({
            "fill": markeroptions.innerFillColor || color,
            "fill-opacity": markeroptions.innerFillOpacity,
            "stroke": markeroptions.innerStrokeColor || color,
            "stroke-opacity": markeroptions.innerStrokeOpacity,
            "stroke-width": markeroptions.innerStrokeWidth,
            "stroke-dasharray": getDashArray(markeroptions.innerDashStyle, markeroptions.innerStrokeWidth),
            "stroke-linecap": getLineCap(markeroptions.innerLineCap, markeroptions.innerDashStyle)
        });
    return marker;
}

function getMarkerSize(chart) { // For area, line, scatter charts - if marker is enabled, the top markers will be clipped. To avoid this, calculate the marker size and increase the clip area
    var DIM = {
        left: 0,
        top: 0,
        right: 0,
        bottom: 0
    };
    if (!chart.isAxisCategory) {
        return DIM;
    }
    // If minrange and maxrange of the axes is specified, don't consider the marker size
    var xaxis = chart.systemConf.chart.axes.xaxis,
        yaxes = chart.systemConf.chart.axes.yaxis;
    var cXmin = (xaxis.minRange != null && xaxis.minRange !== ""),
        cXmax = (xaxis.maxRange != null && xaxis.maxRange !== ""),
        cYmin = yaxes.some(function(d) {
            return (d.minRange != null && d.minRange !== "");
        }),
        cYmax = yaxes.some(function(d) {
            return (d.maxRange != null && d.maxRange !== "");
        });
    if (cXmin && cXmax && cYmin && cYmax) {
        return DIM;
    }
    var rotated = chart.axes.rotated,
        seriesTypes = chart.dataset.seriesTypes,
        commonPlotoptions = chart.systemConf.chart.plot.plotoptions,
        canvasarea = chart.canvasarea;
    
    var ms = d3_max(chart.seriesdata.map(function(d, i) {
            var plotoptions = d.plotoptions,
                markerSize = 0,
                cName = chart.chartTypes[i].name;
            var gvp = $ZC.utils.getValueOfPlotOptions((plotoptions ? plotoptions.marker : null), commonPlotoptions[cName].marker);
            if (/(area|arearange|line)/.test(cName) && gvp("enabled") && datacount_based_intelligence(chart, "marker") && dimension_based_intelligence(chart, "marker", mathMin(canvasarea.width, canvasarea.height))) {
                var size = gvp("size");
                markerSize = validateNullVal(size, validateNullVal((plotoptions ? plotoptions.strokeWidth : commonPlotoptions[cName].strokeWidth), 1));
            } else if (cName === "scatter") {
                markerSize = validateNullVal(gvp("size"), 2);
            }
            return markerSize * 10;
        })) / 2;
    return {
        left: (rotated ? cYmin : cXmin) ? DIM.left : ms,
        top: (rotated ? cXmax : cYmax) ? DIM.top : ms,
        right: (rotated ? cYmax : cXmax) ? DIM.right : ms,
        bottom: (rotated ? cXmin : cYmin) ? DIM.bottom : ms
    };
}

function blinkSVGsymbols(ele, blinkConf, repeat) {
    var count = defined(repeat) ? (repeat - 1) : (blinkConf.repeat || Infinity);
    if (!ele.node() || !count) {
        ele
            .style({
                "transform": null,
                "opacity": null
            })
        return;
    }
    var isFade = (blinkConf.type === "fade");
    var dur = blinkConf.duration,
        ease = blinkConf.easingType || (isFade ? "linear-in-out" : "linear");
    var dur1 = dur,
        del1 = (isFade ? 500 : 0),
        dur2 = (isFade ? 0 : dur),
        del2 = (dur1 + del1),
        start = isFade ? {
                "transform": "scale(1)",
                "opacity": 0
            } : {
                "transform": "scale(0)"
            },
        end = isFade ? {
                "transform": "scale(0)",
                "opacity": 1
            } : {
                "transform": "scale(1)"
            };
    ele.transition(); //Stop all the transitions. This will help to switch the blink type.
    ele
        .style(end)
        .transition()
        .delay(del1)
        .duration(dur1)
        .ease(ease)
        .style(start)
        .transition()
        .delay(del2)
        .duration(dur2)
        .ease(ease)
        .style(end)
        .each("end", function() {
            blinkSVGsymbols(ele, blinkConf, count);
        });
}