//$Id$

var zropmisc = new function(){}

function openLink(link, newPage, fullpage, dontclose) {
  if (dontclose != 'true') {
  jQuery("#closebtn").trigger('click'); //No I18N
  }
  if (newPage == 'true') {
    window.open(link);
  } else if (fullpage == 'true') {
    showFullPageDialog(link);
  } else if (fullpage == 'iframe') { //No I18N
    showFullPageIFrame(link);
  } else {
    zropmisc.showDialog(link);
  }
}

zropmisc.showDialog=function(url, callBackFunction) {
  jQuery.get(url, function(result) {
    var div = document.createElement("div");
    div.setAttribute("isDialog", "true");
    ZDBMenu.addShadow(div);
    $result = jQuery(result);
    $result.appendTo(jQuery(div));
    $result.find('script').appendTo(jQuery(div));
    ZDBDialogUtil.showDialog(div, {
      MODAL: true
    });
    jQuery(div).css({
      "top": "13%" //No I18N
    });
    if (callBackFunction != undefined){
        callBackFunction();
    }
  }, 'html'); //No I18N
}

function showFullPageDialog(url) {
  jQuery.get(url, function(result) {
    var div = document.createElement("div");
    div.setAttribute("isDialog", "true");
    $result = jQuery(result);
    $result.appendTo(jQuery(div));
    $result.find('script').appendTo(jQuery(div));
    ZDBDialogUtil.showDialog(div, {
      MODAL: true
    });
    div.style.position = "static";
    div.style.zIndex = ZDBDialogUtil.zCounter;
  }, 'html'); //No I18N
}

function hideMsg() {
  jQuery('#zrop-notifications').hide(); //NO I18N
}

function showStatusMsg(msg, status) {
  jQuery('#zrop-notifications').removeClass('zrop-success zrop-warning zrop-error'); //No I18N
  jQuery('#zrop-notifications').addClass('zrop-' + status); //No I18N
  jQuery('#zrop-notifications').html(msg); //NO I18N
  jQuery('#zrop-notifications').show(200).delay(5000).fadeOut(); //No I18N
}

function showInfo(el) {
  jQuery(el).find('ul').show();
}

function SortByKey(a, b) {
  var aName = a.key.toLowerCase();
  var bName = b.key.toLowerCase();
  return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
}

function SortByVal(a, b) {
  var aName = a.value.toLowerCase();
  var bName = b.value.toLowerCase();
  return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
}

function hideInfo(el) {
  jQuery(el).find('ul').hide();
}

function loadContactSupport(el, event, type) {
  if(!ZDBLazyLoadUtil.loadJsAlone('/zrop/js/zropscript.js,/zrop/js/zropsupport.js,/thirdparty/js/jquery-ui-1.10.4.min.js,/thirdparty/js/html2canvas.min.js,/zdbjs/ZRScreenGrabber/ui.utils.js,/zdbjs/ZRScreenGrabber/jquery.i18n.js,/zdbjs/ZRScreenGrabber/ui.zscreengrabber.js,/zdbjs/ZRScreenGrabber/ZDBScreenGrabber.js','APPENDTODOC',loadContactSupport,[el,event , type],"ZDBMainLoader",true)){ //No I18N
    return;
  }
  if(!ZDBLazyLoadUtil.loadCssOnly("/themes/common/styles/f2/ui.zscreengrabber.css", "APPENDTODOC", loadContactSupport,[el, event , type],"ZDBMainLoader",true)){//NO I18N
      return;
  }
  if (type == undefined){type = 'null'}//No I18N
  zropmisc.showDialog('/ZROPContactSupport.cc?type='+type, afterContactSupportLoad);//No I18N
}

function afterContactSupportLoad(){
  ZROPSupport.afterLoad();
}

function afterTroubleshootLoad(){
  var $dialog = jQuery("#ZROPTroubleshootDlg").parent(); //No I18N
  $dialog.animate({top: "-=50"});//No I18N
}

function afterAboutLoad(){
  var $dialog = jQuery("#ZROPAboutDlg").parent(); //No I18N
  $dialog.animate({top: "-=50"});//No I18N
}
