@echo off 
rem This script is called from pgsql\bin folder which accepts 2 arguments
rem first one  - file_to_be_copied (along with the path)
rem second one - filename alone
rem
rem set file_to_be_copied=%1
rem for %%i in ("%file_to_be_copied%") do set pg_xlog_dir=%%~dpi

set CACL_CMD="%SystemRoot%\system32\icacls.exe"

set enable_backup=false
if exist "incremental_backup" set enable_backup=true
if exist "full_backup" set enable_backup=true

if "%enable_backup%"=="true" (
mkdir wal_archive
GOTO CHANGEPERMISSION

:CONTINUE
copy "%1" "wal_archive\%2"

GOTO END
) else (
GOTO END
)

:CHANGEPERMISSION
	rem icacls.exe will be present in the %SystemRoot%\system32 directory.	
	IF NOT EXIST "%SystemRoot%\system32\icacls.exe" GOTO CHANGEPERMISSION_USING_CACL
	%CACL_CMD% wal_archive /grant *S-1-5-11:(NP)(RX)
	%CACL_CMD% wal_archive /T /grant:r *S-1-5-11:(OI)(CI)F
	%CACL_CMD% wal_archive /T /C /grant *S-1-5-11:(OI)(CI)(F)
	GOTO CONTINUE

:CHANGEPERMISSION_USING_CACL
	rem In windows xp 32-bit, we need to use cacls.exe instead of cacls.exe
	set CACL_CMD="%SystemRoot%\system32\cacls.exe"
	set SID=S-1-5-11
	"..\..\bin\ConvertSIDTOAccountName.exe" > "..\tmp\accName.txt"
	IF %ERRORLEVEL% NEQ 0 GOTO SidLookUpErrorMsg
	set /p ACCOUNT_NAME= < "..\tmp\accName.txt"
	%CACL_CMD% wal_archive /E /G "%ACCOUNT_NAME%":R
	%CACL_CMD% wal_archive /E /T /C /G "%ACCOUNT_NAME%":F
	GOTO CONTINUE

:END