//$Id$
var ZRGoogleAnalyticsIntegration = new function()
{
	
	this.showDemoDlg = true;
	this.selectedColsMap = {};
	this.renamedModules = {};
	this.insideDB = false;
	
	this.initialize = function()
	{
		if(!ZRGoogleAnalyticsIntegration.initializeDone)
        {
			ZRGoogleAnalyticsIntegration.showDemoDlg = $("GANAL_SHOW_DEMO").value;
			ZRGoogleAnalyticsIntegration.hiddenHolder = $("GANALHIDDENHOLDER");
			ZRGoogleAnalyticsIntegration.wizardHolder = $("GANALWIZARDHOLDER");
			ZRGoogleAnalyticsIntegration.demoDlg =  $("GAnalDemoDlg");
			ZRGoogleAnalyticsIntegration.hiddenHolder.appendChild(ZRGoogleAnalyticsIntegration.demoDlg);
			ZRGoogleAnalyticsIntegration.dbDetailsDlg = $("GAnalDBDetailsDlg");
			ZRGoogleAnalyticsIntegration.hiddenHolder.appendChild(ZRGoogleAnalyticsIntegration.wizardHolder);
			ZRGoogleAnalyticsIntegration.hiddenHolder.appendChild(ZRGoogleAnalyticsIntegration.dbDetailsDlg);
			ZRGoogleAnalyticsIntegration.moduleHolders = [];
			ZRGoogleAnalyticsIntegration.initializeDone = true;
        }
	}
	
	this.setDlgTitle = function()
    {
        var title = "";
        var desc = "";
        switch(ZRGoogleAnalyticsIntegration.step)
        {
            case 1:
                title = ZDBI18NMap.g('zrpt.ganalinteg.js.demo.title');
                break;
            case 2:
                title = ZDBI18NMap.g('zrpt.ganalinteg.js.title.step2');
                desc = ZDBI18NMap.g('zrpt.ganalinteg.js.title.step2.desc');                     
                break;
            case 3:
            	title = ZDBI18NMap.g('zrpt.ganalinteg.js.title.step2');
                desc = ZDBI18NMap.g('zrpt.ganalinteg.js.title.step2.desc');
                break;
            case 4:
            	title = ZDBI18NMap.g('zrpt.ganalinteg.js.title.step2');
                desc = ZDBI18NMap.g('zrpt.ganalinteg.js.title.step2.desc');
                break;
            case 5:
            	title = ZDBI18NMap.g('zrpt.ganalinteg.js.dbsuccess.title');
                desc = ZDBI18NMap.g('zrpt.ganalinteg.js.dbsuccess.desc');
                break;
        }
        $("GANALIMPORTDLGTITLE").innerHTML = title;
        $("GANALIMPORTDLGDESC").innerHTML = desc;
    }
	
	this.dlgCloseActivity = function()
    {
		switch(ZRGoogleAnalyticsIntegration.step)
        {
        case 1:
            break;
        case 2:
            {
                hideCustomMessage();
                ZRGoogleAnalyticsIntegration.cancelActivity();
                break;
            }
        case 3:
            {
        		ZRGoogleAnalyticsIntegration.profilesListDlg.parentNode.removeChild(ZRGoogleAnalyticsIntegration.profilesListDlg);
        		ZRGoogleAnalyticsIntegration.cancelActivity();
                break;
            }
        case 4:
        	{
        	ZRGoogleAnalyticsIntegration.modelDetsDlg.parentNode.removeChild(ZRGoogleAnalyticsIntegration.modelDetsDlg);
    		ZRGoogleAnalyticsIntegration.cancelActivity();
            break;
        	}
        case 5:
            {
             var dlg = ZRGoogleAnalyticsIntegration.successInfoDlg;
             dlg.parentNode.removeChild(dlg);
             
             window.url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + ZRGoogleAnalyticsIntegration.destDBID; //No I18N
             setTimeout( "window.location.href = window.url;", 0);// jshint ignore:line
             break
            }
        }
        return true;
    }
	
	this.cancelActivity = function()
	{
		jQuery("#GAnalAuthSucessMsg").css({"border":"1px","background-color":"rgb(150,255,65,0.4)","font-weight":"bold"});//NO I18N
		if(jQuery('#GAnalAuthSucessMsg').length)
		{
			$("GANALDBDetailsSubmit").className="buttonCompBoxBg alpha";
		}
		if(jQuery('#AUTHSUCCESS').length)
		{
			$("AUTHSUCCESS").style.display = "none";
			$("GAAuthDisclaimer").style.display="block";
		}
        jQuery("#GANALDBDetailsSubmit").unbind('click'); //No I18N
	}
	
	this.showInsideDBDetailsDlg = function()
	{
		ZRGoogleAnalyticsIntegration.insideDB = true;
		ZRGoogleAnalyticsIntegration.showDBDetailsDlg();
	}
	
	this.showDBDetailsDlg = function()
	{
		if(!ZDBLazyLoadUtil.loadSnippet("GANAL_IMPORT_DLG","/ZRGoogleAnalyticsDBDetailsDlg.cc",this,"APPENDTODOC"))
        {
            return;
        }
		delete ZDBLazyLoadUtil.loadedSnippets.GANAL_IMPORT_DLG;
		ZRGoogleAnalyticsIntegration.isExpiredUser = $("GANAL_EXPIRED_USER").value
		if(ZRGoogleAnalyticsIntegration.isExpiredUser === "true")
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganalinteg.js.userexpiredmsg"));
        		return;
		}
		ZRGoogleAnalyticsIntegration.isFreshUser = $("GANAL_FRESH_USER").value;
		if(ZRGoogleAnalyticsIntegration.isFreshUser == "true")
        {
	        	var infoDlg =  $("GATrialInfo");
	        	infoDlg.style.display = "" ;
	        	ZDBDialogUtil.showDialog(infoDlg,{TITLE:ZDBI18NMap.g("zrpt.ganalinteg.js.title_trial"), ADDFRAME:true,MODAL:true,DONTREMOVE:true});
        }
        else
        {
        		ZRGoogleAnalyticsIntegration.initializeAndShowDBDetailsDlg();
        }
	}
	
	this.initializeAndShowDBDetailsDlg = function()
	{
		ZRGoogleAnalyticsIntegration.initialize();
		ZRGoogleAnalyticsIntegration.initFuncs();
		if(ZRGoogleAnalyticsIntegration.showDemoDlg == "true")
        {
            ZDBDialogUtil.showDialog(ZRGoogleAnalyticsIntegration.demoDlg,{TITLE:ZDBI18NMap.g('zrpt.ganalinteg.js.demo.title'),
                    ADDFRAME:true,DONTREMOVE:true, MODAL:true});
        }
		else
		{
			ZRGoogleAnalyticsIntegration.showGAnalDBDetailsDlg();
		}
	}
	
	this.initFuncs = function()
    {
        jQuery("#GANALSKIPDEMO").click(function(){ZRMChimpIntegration.submitDemoDlg(); }); //No I18N 
        jQuery("#GANALDBCancel").click(function(){ZDBInlineDialog.closeDialogByType(this); });  //NO I18N
    }
	
	this.submitDemoDlg = function()
	{
		if($("ZDBShowDemoCheck").checked)
        {
			ZRGoogleAnalyticsIntegration.showDemoDlg = false;
            var url = "/ConnectorAction.ma?ZDBACTION=DONTSHOWDEMODLG&CONNECTORID=34"; //No I18N
            AjaxAPI.sendRequest({URL:url});
        }
        ZDBDialogUtil.closeDialog();
        ZRGoogleAnalyticsIntegration.showGAnalDBDetailsDlg();
	}
	
	this.modifyPropsForExistImport = function()
	{
		$("GAnalDlgTitle").className = " "; //No I18n
		jQuery("#GAnalDlgTitle").css("padding", "25px 25px 0px 25px"); //No I18n
		jQuery("#GAnalDlgTitle h1").css("font-size", "19px"); //No I18n
		jQuery('#genDetails').hide();  //No I18n
	}
	
	this.showGAnalDBDetailsDlg = function()
	{
		ZRGoogleAnalyticsIntegration.step = 2;
//		ZRGoogleAnalyticsIntegration.hiddenHolder.appendChild(ZRGoogleAnalyticsIntegration.demoDlg);
		ZRGoogleAnalyticsIntegration.hiddenHolder.innerHTML = "";
		ZRGoogleAnalyticsIntegration.wizardHolder.appendChild(ZRGoogleAnalyticsIntegration.dbDetailsDlg);
		if(ZRGoogleAnalyticsIntegration.insideDB)
		{
			ZDBInlineDialog.showDialog(ZRGoogleAnalyticsIntegration.wizardHolder,{ADDFRAME:true,DONTREMOVE:true, MODAL:true,ONCLOSE:ZRGoogleAnalyticsIntegration.dlgCloseActivity,TITLE:ZDBI18NMap.g("zrpt.connector.js.ga")});
			ZRGoogleAnalyticsIntegration.modifyPropsForExistImport();
		}
		else
		{
	        ZDBUtil.setFocus("GANALDATABASENAME",true); //No I18N
	        ZDBFullPageDialog.showDialog(ZRGoogleAnalyticsIntegration.wizardHolder,{ADDFRAME:true,DONTREMOVE:true, MODAL:true,
	        								ONCLOSE:ZRGoogleAnalyticsIntegration.dlgCloseActivity});
		}
		ZRGoogleAnalyticsIntegration.setDlgTitle();
	}

	
	this.authorizeUser = function()
	{
		var w = 918;
        var h = 732;
        var left = Number((screen.width/2)-(w/2));
        var top = Number((screen.height/2)-(h/2));
        ZRGoogleAnalyticsIntegration.reAuthState = $("GANAL_REAUTH").value;
        document.open($("GANAL_AUTH_URL").value,'ReportsWindow', 'width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);
	}
	
	this.authCompletion = function(mailId, error)
	{
		ZRGoogleAnalyticsIntegration.mailId = mailId;
		if(error === "null")
		{
			if(ZRGoogleAnalyticsIntegration.reAuthState === "false")
			{
				$("GANALDBDetailsSubmit").className = "buttonCompBoxBg";
				jQuery("#GANALDBDetailsSubmit").unbind("click").click(function(){ZRGoogleAnalyticsIntegration.fetchProfiles(this.form);}); //No I18N 
		        var respDiv = jQuery("#AUTHSUCCESS");// No I18N
		        jQuery(respDiv).show("slow");   // No I18N
		        setTimeout(function(){jQuery("#GAnalAuthSucessMsg").css({"border":"0px","background-color":"white","font-weight":"400"});},5000);
		        $("GAAuthDisclaimer").style.display="none";
			}
			else
			{
				var conndbInfoid = $("CONNDBINFOID").value;
	            var parameters = "&DBID=" +ZDBClientUI.dbId + "&CONNDBINFOID=" + conndbInfoid + "&EMAIL=" + encodeURIComponent(mailId);  //NO I18N
	            AjaxAPI.sendRequest({URL:"/GoogleAnalyticsAction.ma?&ZDBACTION=GANALREAUTH"+parameters, METHOD:"POST", 
	                ONSUCCESSFUNC:ZRGoogleAnalyticsIntegration.successReAuth,ONFAILUREFUNC:ZRGoogleAnalyticsIntegration.errorOnReAuth,OPSTATUSID:"ZDBMainLoader"}); //No I18N
			}
		}
		else
		{
			if(error !== "access_denied")
			{
				ZRGoogleAnalyticsIntegration.errorFromGadgets(error);
			}
		}
	}
	
	this.errorFromGadgets = function(error)
	{
		ZDBAlertAPI.showMsg(error);
	}
	
	this.errorOnAuth = function(response)
	{
		var errCode = response.getResponsePart("ERRORCODE");
        var errMsg = response.getResponsePart("STATUS_MESSAGE");
        errCode = trimAll(errCode);
        ZDBAlertAPI.showMsg(errMsg);
	}
	
	this.fetchProfiles = function()
	{
		ZRGoogleAnalyticsIntegration.dbName = $("GANALDATABASENAME").value;
		ZRGoogleAnalyticsIntegration.dbDesc = $("GANALDATABASEDESC").value;
		var params = "&EMAILID=" + encodeURIComponent(ZRGoogleAnalyticsIntegration.mailId);  //No I18N
		jQuery("#GANALDBDetailsSubmit").unbind('click'); //No I18N
		var loader = $("GANALLOADER");
        hideCustomMessage();
        AjaxAPI.sendRequest({URL:"/ZRGoogleAnalyticsProfilesDlg.cc?&ZDBACTION=FETCHPROFILES"+params, METHOD:"GET",   //NO I18N
            ONSUCCESSFUNC:ZRGoogleAnalyticsIntegration.showProfilesDlg ,ONFAILUREFUNC:ZRGoogleAnalyticsIntegration.errorOnAuth, OPSTATUSID: loader}); 
	}
	
	this.searchProfiles = function(event)
    {
	    	var searchFieldElem = $("GAnalSearchProfiles");
	    	var containerDivId = searchFieldElem.getAttribute("searchDivId");
	    	var attr = "search"; //No I18N
	    	var basedOnTag = "input"; //No I18N
	    	ZDBClientUtil.searchAndDisplay(containerDivId,basedOnTag,attr,searchFieldElem,$("GAnalNoProfilesMsg"));  
	    	ZRGoogleAnalyticsIntegration.hideProfiles();
    }
	
	this.resetFields = function()
	{	
		jQuery("#GANAL_CUSTOM_DLG input[id^='GA_CUSTOM_']").each(function (i, el) { //No I18n
			var id = jQuery(el).data("id"); //No I18n
			var column = jQuery("#GANAL_CUSTOM_DLG #GA_COLUMN_"+CSS.escape(id)); //No I18n
			var groupId = jQuery(el).data("groupid"); //No I18n
			column.show();
			jQuery("#GANAL_CUSTOM_DLG #GroupHolder_"+groupId).show(); //No I18n
		});
		jQuery("#GANAL_CUSTOM_DLG #GANAL_noFields").hide(); //No I18n
	}
	
	this.searchFieldsNew = function(event)
	{
		ZRGoogleAnalyticsIntegration.resetFields();
		jQuery("#GANAL_CUSTOM_DLG input[id^='GA_CUSTOM_DIMENSION_']").each(function (i, el) { //No I18n
			var text = jQuery("#GANAL_CUSTOM_DLG #ZCSearchFields").val().toLowerCase(); //No I18n
			var colName = jQuery(el).data("uiname").toLowerCase(); //No I18n
			var id = jQuery(el).data("id"); //No I18n
			var groupId = jQuery(el).data("groupid"); //No I18n
			
			var column = jQuery("#GANAL_CUSTOM_DLG #GA_COLUMN_"+CSS.escape(id)); //No I18n
			if((colName.indexOf(text) == -1) && (id.toLowerCase().indexOf(text) == -1))
			{
				column.hide();
			}
			else
			{
				column.show();
			}
		});
		
		
		jQuery("#GANAL_CUSTOM_DLG input[id^='GA_CUSTOM_METRIC_']").each(function (i, el) { //No I18n
			var text = jQuery("#GANAL_CUSTOM_DLG #ZCSearchFields").val().toLowerCase(); //No I18n
			var colName = jQuery(el).data("uiname").toLowerCase(); //No I18n
			var id = jQuery(el).data("id"); //No I18n
			var groupId = jQuery(el).data("groupid"); //No I18n
			
			var column = jQuery("#GANAL_CUSTOM_DLG #GA_COLUMN_"+CSS.escape(id)); //No I18n
			if((colName.indexOf(text) == -1) && (id.toLowerCase().indexOf(text) == -1))
			{
				column.hide();
			}
			else
			{
				column.show();
			}
		});
		
		var groupsVisibility = {};
		
		jQuery("#GANAL_CUSTOM_DLG ul[id^='GA_UL_DIMENSION_']").each(function(i, el) { //No I18n
			var id = el.id;
			var text = jQuery("#GANAL_CUSTOM_DLG #ZCSearchFields").val().toLowerCase(); //No I18n
			var groupId = jQuery(el).data('groupid'); //NO I18n
			if((jQuery(el).find("label:visible").length === 0)) //No I18n
			{
				jQuery(el).find("#GA_NO_DIMENSION").show(); //No I18n
				groupsVisibility[groupId] = false;
			}
			else
			{
				jQuery(el).find("#GA_NO_DIMENSION").hide(); //No I18n
				groupsVisibility[groupId] = true;
			}
			if(text == "")
			{
				jQuery(el).find("#GA_NO_DIMENSION").hide(); //No I18n
			}
		});
		
		jQuery("#GANAL_CUSTOM_DLG ul[id^='GA_UL_METRIC_']").each(function(i, el) { //No I18n
			var id = el.id;
			var text = jQuery("#GANAL_CUSTOM_DLG #ZCSearchFields").val().toLowerCase(); //No I18n
			var groupId = jQuery(el).data('groupid'); //NO I18n
			if((jQuery(el).find("label:visible").length === 0)) //No I18n
			{
				jQuery(el).find("#GA_NO_METRIC").show(); //No I18n
				groupsVisibility[groupId] = (groupsVisibility[groupId] | false);
			}
			else
			{
				jQuery(el).find("#GA_NO_METRIC").hide(); //No I18n
				groupsVisibility[groupId] = (groupsVisibility[groupId] | true);
			}
			if(text == "")
			{
				jQuery(el).find("#GA_NO_METRIC").hide(); //No I18n
			}
		});
		
		var visibleCount = 0;
		Object.keys(groupsVisibility).forEach(function(groupId) {
			var show = groupsVisibility[groupId];
			if(show)
			{
				jQuery('#GANAL_CUSTOM_DLG #GroupHolder_'+groupId).show(); //No I18n
				visibleCount += 1;
			}
			else
			{
				jQuery('#GANAL_CUSTOM_DLG #GroupHolder_'+groupId).hide(); //No I18n
			}
		});
		
		if(visibleCount === 0)
		{
			jQuery("#GANAL_CUSTOM_DLG #GANAL_noFields").show(); //No I18n
		}
	}
	
	this.showDBDetailsDlgFrmProfilesListDlg = function()
	{
		ZRGoogleAnalyticsIntegration.profilesListDlg.parentNode.removeChild(ZRGoogleAnalyticsIntegration.profilesListDlg);           
		ZRGoogleAnalyticsIntegration.showGAnalDBDetailsDlg();
        jQuery("#GANALDBDetailsSubmit").unbind("click").click(function(){ ZRGoogleAnalyticsIntegration.fetchProfiles(this.form);}); //No I18N
	}
	
	this.showProfilesDlg = function(response)
	{
		ZRGoogleAnalyticsIntegration.step = 3;
        var div = document.createElement("div");
        div.innerHTML = response.responseText;
        ZRGoogleAnalyticsIntegration.profilesListDlg = div;
        ZRGoogleAnalyticsIntegration.hiddenHolder.appendChild(ZRGoogleAnalyticsIntegration.dbDetailsDlg);
        ZRGoogleAnalyticsIntegration.wizardHolder.appendChild(ZRGoogleAnalyticsIntegration.profilesListDlg);
        ZRGoogleAnalyticsIntegration.setDlgTitle();
        $("GANALDATABASENAME").value = ZRGoogleAnalyticsIntegration.dbName;
		$("GANALDATABASEDESC").value = ZRGoogleAnalyticsIntegration.dbDesc;
		if(ZRGoogleAnalyticsIntegration.insideDB)
		{
			ZRGoogleAnalyticsIntegration.modifyPropsForExistImport();
		}
        $("GAnalNext").onclick=function () { ZRGoogleAnalyticsIntegration.fetchModelDetails(this.form);};
        jQuery("#GAnalPrevious").unbind("click").click(function(){ZRGoogleAnalyticsIntegration.showDBDetailsDlgFrmProfilesListDlg();});  //NO I18N
        jQuery("#GAnalCancel").unbind("click").click(function(){ZRGoogleAnalyticsIntegration.cancelActivity();});  //NO I18N
        ZRGoogleAnalyticsIntegration.refreshProfiles()
        $('GAnal_accounts').onchange=function() { ZRGoogleAnalyticsIntegration.refreshProfiles() };
        $('GAnal_webproperties').onchange=function() { ZRGoogleAnalyticsIntegration.refreshProperties() };
	}
	
	this.hideProfiles = function()
	{
		var selProp = jQuery("#GAnal_webproperties").val(); //NO I18n
		jQuery(".GAnal_profile").each(function(i) { //NO I18n
			var propId = jQuery(this).data("webpropid"); //NO I18n
			if(propId != selProp)
			{
				jQuery(this).hide();
			}
		});
	}
	this.refreshProperties = function()
	{
		var selProp = jQuery("#GAnal_webproperties").val(); //NO I18n
		var selAccount = jQuery("#GAnal_accounts").val(); //NO I18n
		jQuery(".GAnal_profile").each(function(i) { //NO I18n
			var propId = jQuery(this).data("webpropid"); //NO I18n
			var accountId = jQuery(this).data("accountid"); //NO I18n
			if(propId == selProp && accountId == selAccount)
			{
				jQuery(this).show();
			}
			else
			{
				jQuery(this).hide();
			}
		});
		
		jQuery('.GAnal_profileRadio').attr('checked', false); //NO I18n
	}
	this.refreshProfiles = function()
	{
		var selAccount = jQuery("#GAnal_accounts").val(); //NO I18n
		var selPropIndex = 0;
		jQuery("#GAnalSearchProfiles").val(""); //NO I18n
		jQuery(".GAnal_property").each(function(i) { //NO I18n
			var accountId = jQuery(this).data('accountid'); //NO I18n
			if(accountId != selAccount)
			{
				jQuery(this).hide();
			}
			else
			{
				selPropIndex = i
				jQuery(this).show();
			}
		});
		jQuery('#GAnal_webproperties').get(0).selectedIndex = selPropIndex; //NO I18n
		ZRGoogleAnalyticsIntegration.refreshProperties()
	}
	
	this.fetchModelDetails = function(form)
	{
		$("GAnalNext").disabled = true; //No I18n
		ZRGoogleAnalyticsIntegration.dbName = $("GANALDATABASENAME").value;
		ZRGoogleAnalyticsIntegration.dbDesc = $("GANALDATABASEDESC").value;
		ZRGoogleAnalyticsIntegration.selectedProfile = ZRGoogleAnalyticsIntegration.getSelectedProfile(form, "GANALPROFILESCONTAINER");   //NO I18N
		if(ZRGoogleAnalyticsIntegration.selectedProfile.length == 0)
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganal.js.noprofile.selected"));
		}
		else
		{
			var selectedProfileButton = $("GAnalProfile_" + ZRGoogleAnalyticsIntegration.selectedProfile);
			ZRGoogleAnalyticsIntegration.selectedProfileName = selectedProfileButton.getAttribute('profilename');
			ZRGoogleAnalyticsIntegration.timezone = selectedProfileButton.getAttribute('timezone');
			var params = "&EMAILID=" + encodeURIComponent(ZRGoogleAnalyticsIntegration.mailId) + //No I18n
				"&PROFILEID=" + ZRGoogleAnalyticsIntegration.selectedProfile + "&EXISTIMPORT=" + ZRGoogleAnalyticsIntegration.insideDB; //No I18n
			if(ZRGoogleAnalyticsIntegration.insideDB)
			{
				params += "&DBID=" + ZDBClientUI.dbId; //NO I18n
			}
			var loader = $("GANALLOADER");
			AjaxAPI.sendRequest({URL:"/ZRGoogleAnalyticsModelDetsDlg.cc?&ZDBACTION=FETCHMODELDETS" + params, METHOD:"GET",   //NO I18N
	            ONSUCCESSFUNC:ZRGoogleAnalyticsIntegration.showModelDlg ,ONFAILUREFUNC:ZRGoogleAnalyticsIntegration.errorOnAuth, OPSTATUSID: loader}); 
		}
	}
	
	this.loadMetricsAndDimensions = function()
	{
		var metricHolder = $("GANALMETRICHOLDER");
		metricHolder.innerHTML="";
		var dimensionHolder = $("GANALDIMENSIONHOLDER");
		dimensionHolder.innerHTML="";
		var firstTime = true;
		
		var moduleDets = ZRGoogleAnalyticsIntegration.modulesDets;
		for(var moduleId in moduleDets)
		{
			var module = moduleDets[moduleId];
			var ul = document.createElement("ul");
			var label = document.createElement("li");
			jQuery(label).css('margin-top', '5px'); //No I18n
			jQuery(label).css('margin-bottom', '5px'); //No I18n
			jQuery(label).css('width', '100%'); //No I18n
			jQuery(label).css('font-size', '14px'); //No I18n
			jQuery(label).css('font-family', 'Proxima Nova'); //No I18n
			jQuery(label).addClass('labelBlock'); //No I18n
			label.innerHTML = "Metrics:" //No I18n
			ul.appendChild(label)
			ul.id = "GANAL_METRIC_UL_" + ZRGoogleAnalyticsIntegration.getModuleElementId(moduleId); //NO I18n
			jQuery(ul).hide();
			module.metrics.forEach(function(metric) {
				var li = ZRGoogleAnalyticsIntegration.createColumnElement(metric);
	    			ul.appendChild(li);
			});
			
			metricHolder.appendChild(ul);
			
			ul = document.createElement("ul");
			label = document.createElement("li");
			jQuery(label).css('margin-top', '5px'); //No I18n
			jQuery(label).css('margin-bottom', '5px'); //No I18n
			jQuery(label).css('width', '100%'); //No I18n
			jQuery(label).css('font-size', '14px'); //No I18n
			jQuery(label).addClass('labelBlock'); //No I18n
			jQuery(label).css('font-family', 'Proxima Nova'); //No I18n
			label.innerHTML = "Dimensions:"; //No I18n
			ul.appendChild(label)
			ul.id = "GANAL_DIMENSION_UL_" + ZRGoogleAnalyticsIntegration.getModuleElementId(moduleId); //NO I18n
			jQuery(ul).hide();
			module.dimensions.forEach(function(dimension) {
				var li = ZRGoogleAnalyticsIntegration.createColumnElement(dimension);
	    			ul.appendChild(li);
			});
			
			dimensionHolder.appendChild(ul);
			firstTime = false;
		}
	}
	
	this.selectModule = function(moduleId)
	{
		ZRGoogleAnalyticsIntegration.loadMetricsAndDimensions();
		var prevSelModuleId = jQuery(".GANAL_selected").data("id"); //No I18n
		jQuery(".GANAL_selected").removeClass("GANAL_selected"); //No I18n
		jQuery("#GANAL_LI_"+ZRGoogleAnalyticsIntegration.getModuleElementId(moduleId)).addClass("GANAL_selected"); //No I18n
		jQuery("#GANAL_METRIC_UL_" + ZRGoogleAnalyticsIntegration.getModuleElementId(moduleId)).show(); //No I18n
		jQuery("#GANAL_DIMENSION_UL_" + ZRGoogleAnalyticsIntegration.getModuleElementId(moduleId)).show(); //No I18n
	}
	
	this.createModuleElement = function(module, selected)
	{
		var li = document.createElement("li");
		var div = document.createElement("div"); 
		var label = document.createElement("label");
		var input = document.createElement("input");
		var spanEdit = document.createElement("span");
		var spanDelete = document.createElement("span");
		input.type = "checkbox";
		input.checked = module.checked;
		input.id = "GANAL_MODULE_" + ZRGoogleAnalyticsIntegration.getModuleElementId(module.moduleId);
		div.id = "GANAL_MODULEDIV_" + ZRGoogleAnalyticsIntegration.getModuleElementId(module.moduleId);
		div.appendChild(input);
		div.setAttribute("tip", module.moduleUiName);
		div.setAttribute("showTipAtCursorPos", true);
		label.appendChild(document.createTextNode(module.moduleUiName));
		jQuery(spanEdit).addClass("renameIcon");
		jQuery(spanEdit).addClass("editModuleIcon");
		jQuery(spanDelete).addClass("renameIcon");
		jQuery(spanDelete).addClass("deleteModuleIcon");
		div.appendChild(label);
		if(module.isCustomModule)
		{
			div.appendChild(spanEdit);
			div.appendChild(spanDelete);
			jQuery(spanEdit).hide();
			jQuery(spanDelete).hide();
			jQuery(spanEdit).on('click', function() {
				ZRGoogleAnalyticsIntegration.showCreateCustomModuleDlg(true, module);
			});
			jQuery(spanDelete).on('click', function() {
				ZRGoogleAnalyticsIntegration.deleteCustomModule(module.moduleId);
			});
		}
		
		jQuery(div).on('mousemove', function(event) {
			ZDBToolTip.show(this, event);
			if(module.isCustomModule)
			{
				jQuery(spanEdit).show();
				jQuery(spanDelete).show();
				jQuery(label).css("width", "90px"); //NO I18n
			}
		})
		jQuery(div).on('mouseout', function(event) {
			ZDBToolTip.hide(this);
			if(module.isCustomModule)
			{
				jQuery(spanEdit).hide();
				jQuery(spanDelete).hide();
				jQuery(label).css("width", "120px"); //No I18n
			}
		})
		
		jQuery(input).on('change', function(event) {
			if(this.checked)
			{
				ZRGoogleAnalyticsIntegration.modulesDets[module.moduleId].checked = true;
			}
			else
			{
				ZRGoogleAnalyticsIntegration.modulesDets[module.moduleId].checked = false;
			}
		});
		
		li.appendChild(div);
		li.id = "GANAL_LI_" + ZRGoogleAnalyticsIntegration.getModuleElementId(module.moduleId);
		jQuery.data(li, "id", module.moduleId); //No I18n
		if(selected) jQuery(li).addClass("GANAL_selected");
		jQuery(li).on('click', function() {
			ZRGoogleAnalyticsIntegration.selectModule(module.moduleId);
		});
		return li;
	}
	
	this.getModuleElementId = function(moduleId)
	{
		return moduleId.replace(/ /g, "")
	}
	
	this.createColumnElement = function(column)
	{
		var li = document.createElement("li");
		var div = document.createElement("div");
		var label = document.createElement("label");
		var input = document.createElement("input");
		input.type = "checkbox";
		input.id = "GANAL_COLUMN_" + CSS.escape(column.columnId);
		input.disabled = true;
		input.checked = column.checked;
		jQuery.data(input, "id", column.columnId); //No I18n
		div.appendChild(input);
		label.appendChild(document.createTextNode(column.columnUiName));
		div.appendChild(label);
		li.appendChild(div);
		li.id = "GANAL_LI_" + column.columnId;
		return li;
	}
	
	this.refreshModules = function()
	{
		var moduleHolder = $("GANALMODULEHOLDER");
		moduleHolder.innerHTML = ""
		var modulesDets = ZRGoogleAnalyticsIntegration.modulesDets;
		var ul = document.createElement("ul");
		var firstModuleId;
		var selected = true;
		var customModuleCount = 0;
		
        for(moduleId in modulesDets)
        	{
        		var module = modulesDets[moduleId];
    			if(!module.isCustomModule)
        		{
            		var li = ZRGoogleAnalyticsIntegration.createModuleElement(module, selected);
            		if(selected) {
            			selected = false;
            			firstModuleId = moduleId;
            		}
            		ul.appendChild(li);
        		}
    			else
    			{
    				customModuleCount++;
    			}
        	}
        if(customModuleCount > 0)
        {
        		var custLi = document.createElement("li");
        		jQuery(custLi).css("margin-top", "10px"); //NO I18n
        		jQuery(custLi).css("margin-bottom", "3px"); //NO I18n
        		jQuery(custLi).css("margin-left", "10px"); //NO I18n
        		jQuery(custLi).css("font-size", "14px"); //NO I18n
        		jQuery(custLi).html("Custom Modules:"); //NO I18n
        		ul.appendChild(custLi);
            for(moduleId in modulesDets)
	    	    	{
	    	        	var module = modulesDets[moduleId];
	    	        	if(module.isCustomModule)
	    	    		{
	    	    			
	    	        		var li = ZRGoogleAnalyticsIntegration.createModuleElement(module, selected);
	    	        		if(selected) {
	    	        			selected = false;
	    	        			firstModuleId = moduleId;
	    	        		}
	    	        		ul.appendChild(li);
	    	    		}
	    	    	}
        }
        
        moduleHolder.appendChild(ul);
        ZRGoogleAnalyticsIntegration.selectModule(firstModuleId);
	}
	
	this.showModelDlg = function(response)
	{
		ZRGoogleAnalyticsIntegration.step = 4;
        var div = document.createElement("div");
        div.innerHTML = response.responseText;
        ZRGoogleAnalyticsIntegration.modelDetsDlg = div;
        ZRGoogleAnalyticsIntegration.hiddenHolder.appendChild(ZRGoogleAnalyticsIntegration.profilesListDlg);
        ZRGoogleAnalyticsIntegration.wizardHolder.appendChild(ZRGoogleAnalyticsIntegration.modelDetsDlg);
        ZRGoogleAnalyticsIntegration.setDlgTitle();
        ZRGoogleAnalyticsIntegration.loadDefaultModules();
        ZRGoogleAnalyticsIntegration.refreshModules();
        ZRConnector.changeSchTimeToCurrentTime();
        $("GANAL_ProfileName").value = ZRGoogleAnalyticsIntegration.selectedProfileName;
        $("GAnalModelCreate").onclick=function () { ZRGoogleAnalyticsIntegration.createDB(this.form);};
        jQuery("#GAnalModelCancel").unbind("click").click(function(){ZRGoogleAnalyticsIntegration.cancelActivity();});  //NO I18N
        jQuery('.GA-module').hide();   //NO I18N
	}
	
	this.loadDefaultModules = function()
	{
		ZRGoogleAnalyticsIntegration.modulesDets = JSON.parse($("GANAL_DefaultModules").value);
		ZRGoogleAnalyticsIntegration.customModuleLimit = $("GANAL_CustomModuleLimit").value;
	}
	
	this.loadSelectedModules = function()
	{
		ZRGoogleAnalyticsIntegration.modulesDets = JSON.parse($("GANAL_SelectedModules").value);
		ZRGoogleAnalyticsIntegration.customModuleLimit = $("GANAL_CustomModuleLimit").value;
	}
	
	this.deleteModule = function(clickType, requestOptions)
	{
		if(clickType == "NO")
		{
			return;
		}
		delete ZRGoogleAnalyticsIntegration.modulesDets[requestOptions["MODULEID"]];
		ZRGoogleAnalyticsIntegration.refreshModules();
	}
	
	this.deleteCustomModule= function(moduleId)
	{
		ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.ganalinteg.js.moddeleteconfirm", moduleId), "ZDBYESNO", {ONCLICK: this.deleteModule, MODULEID: moduleId}); //No I18n
	}

	
	
	
	this.showCreateCustomModuleDlg = function(isEdit, module)
	{
		this.collapseAllGroups();
		ZRGoogleAnalyticsIntegration.profileName = $("GANAL_ProfileName").value;
		var div = document.getElementById("CustomModuleDlg").cloneNode(true);
		div.id = "GANAL_CUSTOM_DLG";
		div.style.display = 'inline-block';
		ZRGoogleAnalyticsIntegration.isEditModule = isEdit;
		var title;
		if(isEdit)
		{
			title = ZDBI18NMap.g("zrpt.ganalinteg.js.editcustommodule"); //No I18n
			ZRGoogleAnalyticsIntegration.editModuleId = module.moduleId;
			var moduleText = jQuery(div).find("#GANAL_CustomModuleName").val(module.moduleUiName);
			var metrics = module.metrics;
			metrics.forEach(function(metric) {
				var columnId = CSS.escape(metric.columnId);
				var inputEl = jQuery(div).find("#GA_CUSTOM_METRIC_"+columnId);
				jQuery(inputEl).attr('checked', true) //No I18n
				var groupId = jQuery(inputEl).data('groupid'); //No I18n
				var groupEl = jQuery(div).find("#GANAL_GROUP_"+groupId);
				if(jQuery(groupEl).attr('data-collapsed') === "true")
				{
					jQuery(groupEl).click();
				}
				
			});
			var dimensions = module.dimensions;
			dimensions.forEach(function(dimension) {
				var columnId = CSS.escape(dimension.columnId);
				var inputEl = jQuery(div).find("#GA_CUSTOM_DIMENSION_"+columnId);
				jQuery(inputEl).attr('checked', true); //No I18n
				var groupId = jQuery(inputEl).data('groupid'); //No I18n
				var groupEl = jQuery(div).find("#GANAL_GROUP_"+groupId);
				if(jQuery(groupEl).attr('data-collapsed') === "true")
				{
					jQuery(groupEl).click();
				}
			});
		}
		else
		{
			if(ZRGoogleAnalyticsIntegration.getCustomModules().length >= ZRGoogleAnalyticsIntegration.customModuleLimit)
			{
				ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.ganalinteg.js.custommodulelimit", ZRGoogleAnalyticsIntegration.customModuleLimit)); //No I18n
				return;
			}
			title = ZDBI18NMap.g("zrpt.ganalinteg.js.createcustommodule") //No I18n
		}
        ZDBDialogUtil.showDialog(div, {MODAL:true, ADDFRAME:true, SHADOW:true, TITLE:title});  
	}
	
	this.showDateString = function(el)
	{
	    if((el.value == "" ) && (el.getAttribute("tipShown") == "false"))
	    {
	    	var dateType = el.getAttribute("elname");
	    	el.value= (dateType == "fromValue")?ZDBI18NMap.g("zrpt.home.ga.js.from") : ZDBI18NMap.g("zrpt.home.ga.js.to"); //NO I18N

	    	var inputVal = (dateType == "fromValue")?"From":"To"; //NO I18N
	    	el.setAttribute("inputVal",inputVal);
	    }
	}
	
	this.expandGroup = function(el, div)
	{
		if(jQuery(el).attr('data-collapsed') === "true")
		{
			var groupId = jQuery(el).data('groupid'); //No I18n
			this.slide(jQuery(el.parentElement.nextElementSibling));
			
			jQuery(el).removeClass('ZRSMoreIcon'); //No I18n
			jQuery(el).addClass('ZRSLessIcon'); //No I18n
			jQuery(el).attr('data-collapsed', "false"); //No I18n
		}
		else
		{
			var groupId = jQuery(el).data('groupid'); //No I18n
			this.slide(jQuery(el.parentElement.nextElementSibling));
			jQuery(el).removeClass('ZRSLessIcon'); //No I18n
			jQuery(el).addClass('ZRSMoreIcon'); //No I18n
			jQuery(el).attr('data-collapsed', "true"); //No I18n
		}
	}
	
	this.collapseAllGroups = function()
	{
		jQuery("span[id^='GANAL_GROUP_']").each(function(i, el) { //No I18n
			if(jQuery(el).attr('data-collapsed') === "false") //No I18n
				jQuery(el).click();
		});
	}
	
	this.expandAllGroups = function() 
	{
		jQuery("span[id^='GANAL_GROUP_']", "#GANAL_CUSTOM_DLG").each(function(i, el) { //No I18n
			if(jQuery(el).attr('data-collapsed') === "true") //No I18n
				jQuery(el).click();
		});
	}
	this.toggleAllGroups = function(el)
	{
		if(el.checked)
		{
			this.expandAllGroups();
			jQuery("#GANAL_CUSTOM_DLG #GAnalExpPlus").html("-"); //No I18n
			jQuery("#GANAL_CUSTOM_DLG #GAnalExpText").html("Collapse All"); //No I18n
		}
		else
		{
			this.collapseAllGroups();
			jQuery("#GANAL_CUSTOM_DLG #GAnalExpPlus").html("+"); //No I18n
			jQuery("#GANAL_CUSTOM_DLG #GAnalExpText").html("Expand All"); //No I18n
		}
	}

	this.enableCustomDate = function(val)
	{
		if(val == '100')
	    {
			var months = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
	         $("ganalcustomperiod").style.display = 'inline';
	         var curDate = new Date();
	         var curDay = curDate.getDate();
	         curDay = (curDay == 31) ? (curDay - 1) : curDay ;
	         var mon = curDate.getMonth() == 0 ? "Dec" : months[(curDate.getMonth() - 1)];  // No I18N
	         var year = curDate.getMonth() == 0 ? curDate.getFullYear() - 1 : curDate.getFullYear();
	         $("ZDBGAnalFromDate").value = curDay + " " + mon + " " + year;
	     }
	     else
	     {
	    	 $("ganalcustomperiod").style.display = 'none';
	     }
	}

	this.initCalender = function(inputEl)
	{
	    hideCustomMessage();
	    var curDate = new Date();
	    var toDate = curDate.getFullYear();
	    var fromDate = toDate-2;
	    var format = "%d %b %Y ";//NO I18N

	    Calendar.setup(
	    {
	      inputField     :    inputEl,      // id of the input field
	      ifFormat       :    format,       // format of the input field
	      showsTime      :    false,            // will display a time selector
	      button         :    inputEl,   // trigger for the calendar (button ID)
	      singleClick    :    true,           // double-click mode
	      weekNumbers    :    false,
	      range          :    [fromDate,toDate],
	      step           :    1,                // show all years in drop-down boxes (instead of every other year as default)
	      onClose        :    function(){
	          this.hide();this.destroy();
	      }
	    }
	    ); 
	    inputEl.initialized = true;
	}
 
	this.closeDateDialog = function(evt)
	{
		if(evt.keyCode == 27)
		{
			ZDBGoogleInteg.showDateString(evt);
		}
	}
	
	this.slide = function(el) 
	{
		el.slideToggle();
	}
	
	this.validateModName = function(modName){
        var isValid = false;
        
        var regex = /^[A-Za-z0-9._,\/\-:;| ]*$/;
        isValid = regex.test(modName);
        return isValid;
    }
	
	this.checkMetDimLimit = function(event)
	{
		var dimensions = ZRGoogleAnalyticsIntegration.getSelectedDimensionsForCustomModule();
		var metrics = ZRGoogleAnalyticsIntegration.getSelectedMetricsForCustomModule();
		
		if((dimensions!== null && Object.keys(dimensions).length) > 7 || (metrics !==null && Object.keys(metrics).length > 10))
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganalinteg.js.dimmetlimit")); //No I18n
			event.preventDefault();
		}
	}
	
	this.validateDimMet = function() 
	{
		var loader = $("GANALMODELLOADER");
		var moduleName = jQuery("#GANAL_CUSTOM_DLG #GANAL_CustomModuleName").val().trim(); //No I18n
		var moduleLength = 50;
		if(!ZRGoogleAnalyticsIntegration.validateModName(moduleName))
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganal.js.modulename.invalid")); //No I18n
			return;
		}
		if(moduleName.length < 1)
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganalinteg.js.entermodulename")); //No I18n
			jQuery("#GANAL_CUSTOM_DLG #GANAL_CustomModuleName").focus(); //NO I18n
			return;
		}
		if(moduleName.length > moduleLength)
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganalinteg.js.modulenametoolong")); //No I18n
			return;
		}
		var modulesDets = ZRGoogleAnalyticsIntegration.modulesDets;
		for(moduleId in modulesDets)
		{
			var module = modulesDets[moduleId];
			if((module.moduleUiName.toUpperCase() === moduleName.toUpperCase()))
			{
				if(ZRGoogleAnalyticsIntegration.isEditModule && (ZRGoogleAnalyticsIntegration.editModuleId.toUpperCase() === moduleName.toUpperCase()))
				{
					break;
				}
				ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.ganalinteg.js.modulenameexists", moduleName)); //No I18n
				return;
			}
		}
		var dimensions = ZRGoogleAnalyticsIntegration.getSelectedDimensionsForCustomModule();
		var metrics = ZRGoogleAnalyticsIntegration.getSelectedMetricsForCustomModule();
		if(metrics === null)
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganalinteg.js.selectmetric")); //No I18N
			return;
		}
		else if(dimensions === null)
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganalinteg.js.selectdimension")); //No I18N
			return;
		}
		var metricsStr = JSON.stringify(Object.keys(metrics));
		var dimensionsStr = JSON.stringify(Object.keys(dimensions));
		if(metrics != null && dimensions != null) 
		{
			var params = "&EMAIL=" + encodeURIComponent(ZRGoogleAnalyticsIntegration.mailId) + "&PROFILEID=" + ZRGoogleAnalyticsIntegration.selectedProfile + //No I18N
				"&DIMENSIONS=" + dimensionsStr + "&METRICS=" + metricsStr; //No I18N
			AjaxAPI.sendRequest({URL:"/GoogleAnalyticsAction.ma?ZDBACTION=VALIDATEMDCOMBINATION", PARAMETERS:params, 
				METHOD:"GET", ONSUCCESSFUNC:ZRGoogleAnalyticsIntegration.handleValidCombination, OPSTATUSID:"ZDBMainLoader"}); //No I18N
		}
		
	}
	
	this.getSelectedMetricsForCustomModule = function()
	{
		var selectedMetrics = {};
		jQuery("input[id^='GA_CUSTOM_METRIC_']").each(function (i, el) { //No I18N
	         if(el.checked) 
	        	 {
	        	 	selectedMetrics[jQuery(el).data('id')] = jQuery(el).data('uiname'); //No I18N
	        	 }
	     });
		
		if(Object.keys(selectedMetrics).length == 0) 
		{
			return null;
		}
		
		return selectedMetrics;
	}
	
	this.getSelectedDimensionsForCustomModule = function()
	{
		var selectedDimensions = [];
		jQuery("input[id^='GA_CUSTOM_DIMENSION_']").each(function (i, el) { //No I18N
	         if(el.checked) 
	        	 {
	        	 	selectedDimensions[jQuery(el).data('id')] = jQuery(el).data('uiname'); //No I18N
	        	 }
	     });
		
		if(Object.keys(selectedDimensions).length == 0) 
		{
			return null;
		}
		
		return selectedDimensions;
	}
	
	this.createColumnDetsArray = function(columns)
	{
		var columnDets = []
		Object.keys(columns).forEach(function(columnId){
			var column = new Object();
			column.columnId = columnId;
			column.columnUiName = columns[columnId];
			column.checked = true;
			columnDets.push(column);
		});
		return columnDets;
	}
	
	this.handleValidCombination = function(response, reponseText)
	{
		var dimensions = ZRGoogleAnalyticsIntegration.getSelectedDimensionsForCustomModule();
		var metrics = ZRGoogleAnalyticsIntegration.getSelectedMetricsForCustomModule();
		var moduleName = jQuery("#GANAL_CUSTOM_DLG #GANAL_CustomModuleName").val(); //NO I18n
		var module = new Object();
		module.moduleId = moduleName;
		module.moduleUiName = moduleName;
		module.metrics = ZRGoogleAnalyticsIntegration.createColumnDetsArray(metrics);
		if(module.metrics === null)
		{
			return;
		}
		module.checked = true;
		module.isCustomModule = true;
		module.dimensions = ZRGoogleAnalyticsIntegration.createColumnDetsArray(dimensions);
		if(module.dimensions === null)
		{
			return;
		}
		if(ZRGoogleAnalyticsIntegration.isEditModule)
		{
			if(moduleName != ZRGoogleAnalyticsIntegration.editModuleId)
			{
				if(ZRGoogleAnalyticsIntegration.isEditSetup)
				{
					ZRGoogleAnalyticsIntegration.renamedModules[ZRGoogleAnalyticsIntegration.editModuleId] = moduleName;
				}
				delete ZRGoogleAnalyticsIntegration.modulesDets[ZRGoogleAnalyticsIntegration.editModuleId];
			}
		}
		ZRGoogleAnalyticsIntegration.modulesDets[module.moduleId] = module
		ZRGoogleAnalyticsIntegration.refreshModules();
		ZDBDialogUtil.closeDialog();
	}
	
	this.getCustomModules = function()
	{
		var modulesDets = ZRGoogleAnalyticsIntegration.modulesDets;
		var customModules = [];
		for(moduleId in modulesDets)
		{
			var module = modulesDets[moduleId];
			if(module.isCustomModule)
			{
				customModules.push(moduleId)
			}
		}
		return customModules;
	}
	
	this.createDB = function(form)
	{
		$("GAnalModelCreate").disabled=true; //No I18n
		var loader = $("GANALMODELLOADER");
		var selectedCols = ZRGoogleAnalyticsIntegration.getSelectedDimensionsAndMetrics();
		if(Object.keys(selectedCols).length == 0)
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganal.js.nomodule.selected"));
			return;
		}
		var customModules = JSON.stringify(ZRGoogleAnalyticsIntegration.getCustomModules());
		var isNewDB = ZRGoogleAnalyticsIntegration.insideDB;
		if(selectedCols === "{}")
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganal.js.nomodule.selected"));
			return;
		}
		var params = "&DATABASENAME=" + ZRGoogleAnalyticsIntegration.dbName + //No I18N
		 "&DATABASEDESC=" + ZRGoogleAnalyticsIntegration.dbDesc + "&SELECTEDCOLS=" + selectedCols + "&CUSTOMMODULES=" + customModules//NO I18N
		 + "&PROFILEID=" + ZRGoogleAnalyticsIntegration.selectedProfile + "&PROFILENAME=" + encodeURIComponent(ZRGoogleAnalyticsIntegration.selectedProfileName) //NO I18N
		 + "&SCHEDULETIME=" + ZRConnector.getSchTime()   //NO I18N
		 + "&CLEANUPMONTHS=" + ZRConnector.getCleanupMonths() + "&FROMDATE=" + ZRGoogleAnalyticsIntegration.getFetchStartDate(form) //NO I18N
		 + "&EMAIL=" + encodeURIComponent(ZRGoogleAnalyticsIntegration.mailId)  //NO I18N
		 + "&TIMEZONE=" + ZRGoogleAnalyticsIntegration.timezone; //NO I18N
		if(isNewDB)
		{
			params += "&EXISTIMPORT=" + isNewDB; //No I18n
			params += "&DBID=" + ZDBClientUI.dbId; //No I18n
		}
		AjaxAPI.sendRequest({URL:"/ZRGoogleAnalyticsDBSuccDlg.cc?&ZDBACTION=GANALCREATEDB", PARAMETERS:params, METHOD:"POST",//No I18N
			ONSUCCESSFUNC:ZRGoogleAnalyticsIntegration.showSuccessDBDlg, OPSTATUSID:loader}); 
	}
	
	this.showSuccessDBDlg = function(response,responseText)
    {
		ZRGoogleAnalyticsIntegration.step = 5;
        var div = document.createElement("div");
        div.innerHTML = response.responseText;
        ZRGoogleAnalyticsIntegration.successInfoDlg = div;
        ZRGoogleAnalyticsIntegration.modelDetsDlg.parentNode.removeChild(ZRGoogleAnalyticsIntegration.modelDetsDlg);
        ZRGoogleAnalyticsIntegration.wizardHolder.appendChild(ZRGoogleAnalyticsIntegration.successInfoDlg);    
        ZRGoogleAnalyticsIntegration.setDlgTitle();
        ZRGoogleAnalyticsIntegration.isEditSetup = false;
        ZRGoogleAnalyticsIntegration.destDBID = $("GANALDBID").value;
    }
	
	this.getSelectedProfile = function(form, div)
	{
		var selProfile = "";
	    jQuery('div#' + div + ' input[type=radio]').each(function() {//NO I18N
	    	if ($(this).checked){
	    		selProfile = selProfile + jQuery(this).attr('value')  //No I18N
	          }
	       });
	    return selProfile;
	}
	
	this.checkIfColumnSelected = function(columnId)
	{
		return $("GANAL_COLUMN_"+columnId).checked;
	}
	
	this. checkIfModuleSelected = function(moduleId)
	{
		return $("GANAL_MODULE_"+ZRGoogleAnalyticsIntegration.getModuleElementId(moduleId)).checked;
	}
	
	this.getSelectedDimensionsAndMetrics = function()
	{
		var selectedCols = {};
		var modulesDets = ZRGoogleAnalyticsIntegration.modulesDets;
		
		for(var moduleId in modulesDets)
		{
			var module = modulesDets[moduleId];
			var columns = [];
			
			if(!ZRGoogleAnalyticsIntegration.checkIfModuleSelected(module.moduleId))
			{
				continue;
			}
			
			module.metrics.forEach(function(metric){
				columns.push(metric.columnId);
			});
			module.dimensions.forEach(function(dimension){
				columns.push(dimension.columnId);
			});
			selectedCols[moduleId] = columns;
		}
		return JSON.stringify(selectedCols);
	}
	
	this.getFetchStartDate = function(form)
	{
		var dateType = form.ganalimpperiod.value;
	    var date = ""; 
	    if(dateType == '100')
	    {
	    	var fromDate = form.ZDBGAnalFromDate.value;
	    	if(!ZDBValidator.isValidDateFound(fromDate))
	    	{
	    		ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.home.ga.js.emptydatevalue")); //No I18N
	    		ZDBUtil.setFocus(frm.ZDBGAFromDate);
	    		return;
	    	}
	    	var startDate = new Date(fromDate);
	    	var today = new Date();
	    	var month = startDate.getMonth() + 1;
	    	month = month > 9 ? month : "0" + month;
	    	var day = startDate.getDate();
	    	day = day < 10 ? "0" + day : day;
	    	date = startDate.getFullYear() + "-" + month + "-" + day; // No I18N   
	    	if(startDate > today)
	    	{
	    		ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.home.ga.js.invaliddatevalue")); //No I18N
	    		return;
	    	}
	    	return date;
	    }
	    else 
	    {
	    	var curDate = new Date();
	    	fromDate = new Date();
	    	var days = 30 * dateType;
	    	fromDate.setMilliseconds(curDate.getMilliseconds() - days * 24*60*60*1000);
	    	month = fromDate.getMonth() + 1;
	    	month = month > 9 ? month : "0" + month;
	    	day = fromDate.getDate();
	        day = day < 10 ? "0" + day : day;
	    	date = fromDate.getFullYear() + "-" + month + "-" + day; // No I18N
	    	return date;
	    }
	}
	
	this.getFetchEndDate = function()
	{
		var toDate = new Date();
	    month = toDate.getMonth()  + 1; 
	    mon = month > 9 ? month : "0" + month;
	    day = toDate.getDate();
	    day = day < 10 ? "0" + day : day;
	    date = toDate.getFullYear() + "-" + mon + "-" + day; // No I18N
	    return date;
	}
	
	/* ###################################################################################################
     * ############################## Import Flow Completed ###############################
     * ###################################################################################################*/
	
	this.showEditFieldsDlg = function(connDBInfoId)
    {
        this.renamedModules = {};
		AjaxAPI.sendRequest({URL:"/ZRGoogleAnalyticsEditFieldsDlg.cc?ZDBACTION=GANALEDITSETUP&DBID="+ZDBClientUI.dbId+"&CONNDBINFOID="+connDBInfoId,
			METHOD:"GET", //No I18n
            ONSUCCESSFUNC:ZRGoogleAnalyticsIntegration.handleShowEditFieldsDlgSucc,
            ONFAILUREFUNC:ZRGoogleAnalyticsIntegration.handleShowEditFieldsDlgFail,
            OPSTATUSID:"ZDBMainLoader"}); //No I18N
    }
	
	this.handleShowEditFieldsDlgSucc = function(response, responseText)
	{
		var div = document.createElement("div");
        div.innerHTML = response.responseText;
        document.body.appendChild(div);
        ZDBDialogUtil.closeDialog();
        ZDBDialogUtil.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true,
                              TITLE:ZDBI18NMap.g('zrpt.ganal.js.editfield.title')});     //NO I18N
        jQuery("#GANALEditFieldSubmit").click(function(){ZRGoogleAnalyticsIntegration.submitEditFieldsDets(this.form);}); //No I18N
        ZRGoogleAnalyticsIntegration.isEditSetup = true;
        ZRGoogleAnalyticsIntegration.selectedProfile = $("GANAL_ProfileId").value;
        ZRGoogleAnalyticsIntegration.mailId = $("GANAL_EmailId").value;
        ZRGoogleAnalyticsIntegration.loadSelectedModules();
        ZRGoogleAnalyticsIntegration.refreshModules();
        ZRConnector.setSchDetails();
        ZRGoogleAnalyticsIntegration.toggleCleaupDiv();
	}
	
	this.toggleSelectedMods = function()
	{
		var modsStr = $("GANALMODS").value;
		var mods = modsStr.substring(1, modsStr.length-1).split(",");
		for(var i = 0; i < mods.length; i++)
		{
			var modName = mods[i].trim();
			var el = $("GA_MODULE_" + modName + "_INPUT");
			if(!el.checked)
			{
				$("GA_MODULE_" + modName + "_DIMENSION_METRICS").style.display = 'none';
			}
		}
	}
	
	this.toggleCleaupDiv = function()
	{
		var cleanupOptions = $("CLEANUPSELECT")
		for (var i = 0; i < cleanupOptions.options.length; i++) 
		{
			if (cleanupOptions.options[i].value === $("GANALCLEANUP").value)
			{
				cleanupOptions.options[i].selected = true;
		        return;
		    }
		}
	}
	
	this.handleShowEditFieldsDlgFail = function(response, reponsetext)
	{
		var errCode = response.getResponsePart("ERRORCODE");
        var errMsg = response.getResponsePart("STATUS_MESSAGE");
        errCode = trimAll(errCode);
        ZDBAlertAPI.showMsg(errMsg);
	}
	
	this.submitEditFieldsDets = function(form)
	{
		var loader = $("GANALEDITFIELDOPTSTATUS");
		var selectedCols = ZRGoogleAnalyticsIntegration.getSelectedDimensionsAndMetrics();
		var renamedCols = JSON.stringify(ZRGoogleAnalyticsIntegration.renamedModules);
		if(selectedCols === "{}")
		{
			ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.ganal.js.nomodule.selected"));
		}
		var params =  "&SCHEDULETIME=" + ZRConnector.getSchTime(form) + "&SCHTIMEZONE="+ ZRConnector.getSchTimeZone() //No I18N  
		  + "&DBID=" + form.ZOHO_DBID.value + "&CONNDBINFOID=" + form.ZOHO_CONNDBINFOID.value + "&CONNECTORID=30"  //NO I18N
		  +"&SELECTEDCOLS=" + selectedCols + "&CLEANUPMONTHS=" + ZRConnector.getCleanupMonths() + "&RENAMEDMODS=" + renamedCols; //No I18N
		AjaxAPI.sendRequest({URL:"/GoogleAnalyticsAction.ma?&ZDBACTION=SAVEEDITSETTINGS", PARAMETERS:params,  //No I18N 
			METHOD:"POST", ONSUCCESSFUNC:ZRGoogleAnalyticsIntegration.handleSubmitFieldDetSucc,OPSTATUSID: loader}); //No I18n
	}
	
	this.handleSubmitFieldDetSucc = function(response, requestOptions)
	{
		ZRConnector.alertIfNeeded(response,requestOptions);
		ZRConnector.updateSchTypeNTime(response, requestOptions);
		ZRGoogleAnalyticsIntegration.renamedModules = {};
	}
	
	this.showReAuthDlg = function(connDBInfoId)
	{
		AjaxAPI.sendRequest({URL:"/ZRGoogleAnalyticsValidity.cc?ZDBACTION=GANALVALIDITY&DBID="+ZDBClientUI.dbId+"&CONNDBINFOID="+connDBInfoId, 
            				METHOD:"GET", ONSUCCESSFUNC:ZRGoogleAnalyticsIntegration.handleReAuthDlgSucc, OPSTATUSID:"ZDBMainLoader"}); //No I18N
	}
	
	this.handleReAuthDlgSucc = function(response, responseText)
	{
		var div = document.createElement("div");
        div.innerHTML = response.responseText;
        document.body.appendChild(div);
        ZDBDialogUtil.closeDialog();
 
        ZDBDialogUtil.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true,
                              TITLE:ZDBI18NMap.g('zrpt.ganalinteg.js.auth.title')});
	}
	
	this.successReAuth = function(response, responseText)
	{
		var respDiv = jQuery("#GAnalReAuthDlg").find("[elname='respDiv']");    // No I18N
        respDiv.html(ZDBI18NMap.g("zrpt.ganalinteg.js.reauthsuccessmsg"));//NO I18N
        var params = response.getResponseParams();
        $("GAnalAccountName").innerHTML = params["reauth_email"];
        jQuery(respDiv).show("slow");   // No I18N
        $("validityState").style.color="green"; // NO I18N
        $("validityState").innerHTML="Active";//NO I18N
        jQuery('#GAnalHelpText').hide();  //NO I18N
        setTimeout(function(){respDiv.hide("slow");},5000);
	}
	
	this.errorOnReAuth = function(response, reponsetext)
	{
		var errCode = response.getResponsePart("ERRORCODE");
        var errMsg = response.getResponsePart("STATUS_MESSAGE");
        errCode = trimAll(errCode);
        if(errCode === "GANAL_NO_PERMISSIONS_ERROR")
        {
            var respDiv = jQuery("#GAnalReAuthDlg").find("[elname='respDiv1']");    // No I18N
            jQuery(respDiv).show("slow");   // No I18N
            jQuery("#GAnalMsgFailHeader").html(ZDBI18NMap.g("zrpt.ganalinteg.js.diffacc"));//NO I18N
            jQuery("#GAnalErrorMsg").html(ZDBI18NMap.g("zrpt.ganal.js.auth.nopermission"));//NO I18N
            setTimeout(function(){respDiv.hide("slow");},10000);
            return;
        }
        else
        {
             ZDBAlertAPI.showMsg(errMsg);
        }
	}
	
}
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRGoogleAnalyticsIntegration.showDBDetailsDlg"] = ZRGoogleAnalyticsIntegration.showDBDetailsDlg;//NO I18N
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRGoogleAnalyticsIntegration.showInsideDBDetailsDlg"] = ZRGoogleAnalyticsIntegration.showInsideDBDetailsDlg; // No I18n