//$Id$

var ZRTwitterInteg = new function()
{
	 this.isAuthenticated = false;
	 this.twitterDomain = "";
	 this.isNewDB = "true";
	 this.index=0;
	 this.userIdsArray=[];
	 
	 
     this.initialize = function()
     {
         if(ZRTwitterInteg.initialized === true)
         {
        	 return;
         }     
         ZRTwitterInteg.showDemoDlg = jQuery("#TWITTERWIZARDHOLDER").attr("showDemoDlg"); //No i18N
         ZRTwitterInteg.hiddenHolder = $("TWITTERHIDDENHOLDER");
         ZRTwitterInteg.wizardHolder = $("TWITTERWIZARDHOLDER");
         ZRTwitterInteg.demoDlg =  $("TwitterDemoDlg");
         ZRTwitterInteg.dbDetailsDlg = $("TwitterUserDetailsDlg");
    	 ZRTwitterInteg.initElsNFunctions();
         ZRTwitterInteg.initialized = true;
        
     };
     
     
     
     this.initElsNFunctions = function()
     {
    	
		 jQuery("#TWITTERSKIPDEMO").click(function(){ZRTwitterInteg.submitTwitterDemoDlg();}) ; //No I18N
		 jQuery("#TwitterAuthorizeButton").click(function(){ZRTwitterInteg.state="auth";ZRTwitterInteg.requestToken();}); //No I18N

     };
     
     
     
     this.requestToken = function()
     {
	    	AjaxAPI.sendRequest({URL:"/ZRTwitterAction.ma?&ZDBACTION=TWITTERREQUESTTOKEN", METHOD:"POST", 
	            ONSUCCESSFUNC:ZRTwitterInteg.authorizeUser,ONFAILUREFUNC:ZRTwitterInteg.showErrorMessage});
     };
     
     
     this.authorizeUser=function(response)
     {

  	   var w = 918;
  	   var h = 732;
  	   var left = Number((screen.width/2)-(w/2));
       var top = Number((screen.height/2)-(h/2));
       var requestToken = response.responseText;
       var authenticateURL="https://api.twitter.com/oauth/authenticate?oauth_token="+requestToken;//NO I18N
  	   window.open(authenticateURL,'ReportsWindow', 'width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);//NO I18N
     };
     
     
     
     this.storeOAuthTokenAndVerifier = function(oauth_token, oauth_verifier)
 	 {
    	// called from Redirect page
    	 
    	 
    	 if(oauth_token==="null"||oauth_verifier==="null"){
    		 return;
    	 }
 	 
    	 var params="&OAUTH_TOKEN="+oauth_token+"&OAUTH_VERIFIER="+oauth_verifier;//No I18N
    	 if(ZRTwitterInteg.state==="auth")
    		 {
	    	AjaxAPI.sendRequest({URL:"/ZRTwitterAction.ma?&ZDBACTION=TWITTERACCESSTOKEN"+params, METHOD:"POST", 
	            ONSUCCESSFUNC:ZRTwitterInteg.authSuccess,ONFAILUREFUNC:ZRTwitterInteg.showErrorMessage,OPSTATUSID:"TWITTERAUTHOPTSTATUS"});//No I18N
    		 }
    	 else
    		 {
    		 //reauthentication
    		 params+="&CONNDBINFOID="+$("CONNDBINFOID").value+"&DBID=" + ZDBClientUI.dbId;//No I18N
 	    	AjaxAPI.sendRequest({URL:"/ZRTwitterAction.ma?&ZDBACTION=TWITTERACCESSTOKEN"+params, METHOD:"POST", 
	            ONSUCCESSFUNC:ZRTwitterInteg.updateSuccess,ONFAILUREFUNC:ZRTwitterInteg.showErrorMessage,OPSTATUSID:"ZDBMainLoader"});//No I18N
    		 }
 	 };
 	 
 	 
     this.storeAccessToken = function(response)
  	 {

    	 var respArr=JSON.parse(response.responseText);
 		
     	 if(ZRTwitterInteg.state=="auth")
     		 {
     		 $("ACCESSTOKEN").value=respArr[0];
         	 $("ACCESSTOKENSECRET").value=respArr[1];
         	 $("AUTHENTICATEDUSERNAME").value=respArr[2];
         	 $("AUTHENTICATEDUSERID").value=respArr[3];
         	 $("TIMEZONE").value=respArr[4];
       	  
     		 }
  	 };
  	 
  	this.authSuccess=function(response)
 	{
 		$("TwitterDBDetsSubmit").className = "buttonCompBoxBg";
    	 ZRTwitterInteg.isAuthenticated = true;
    	 ZRTwitterInteg.storeAccessToken(response); 
  		jQuery("#TwitterDBDetsSubmit").unbind("click").click(function(){ ZRTwitterInteg.showSchSettingsDlg(this.form,response);}); //No I18N 
  		var respDiv = jQuery("#TWITTERAUTHSUCCESS");// No I18N
	    jQuery(respDiv).show("slow"); // No I18N
	
 	}; 

	this.updateSuccess = function(response,requestOptions)
	{
			if(response != null)
			{
			$("TwitterScreenName").innerHTML = response.responseText;//twitteraccessToken action response '_' seperated
			}

			 var respDiv = jQuery("#TwitterLoginDetailsDlg").find("[elname='respDiv']");    // No I18N
	         respDiv.html(ZDBI18NMap.f("zrpt.conn.js.reauthsuccessmsg",ZDBI18NMap.g("zrpt.connector.js.twitter")));//NO I18N
	         jQuery(respDiv).show("slow");   // No I18N
	         $("validityState").style.color="green"; // NO I18N
	         $("validityState").innerHTML="Active";//NO I18N
	         if($("TwitterRevNote"))
	       	 {
	         $("TwitterRevNote").style.display="none";//NO I18N
	         }
	         setTimeout(function(){respDiv.hide("slow");},5000);    
	         
	};
	
	
	 this.showSchSettingsDlg = function(frm,response)
	    {
		 if(!validateForm(frm))
	        {
	         return;
	        }
	        hideCustomMessage();
	        var isNewDB =   ZRTwitterInteg.Z_isNewDB
	        var params =  "&ISNEWDB=" + isNewDB+"&TIMEZONE="+ $("TIMEZONE").value+"&ACCESSTOKEN="+ $("ACCESSTOKEN").value+"&ACCESSTOKENSECRET="+ $("ACCESSTOKENSECRET").value;;//No I18N
	        params+="&AUTHENTICATEDUSERNAME="+$("AUTHENTICATEDUSERNAME").value+"&AUTHENTICATEDUSERID="+$("AUTHENTICATEDUSERID").value;//NO I18N
			if(isNewDB == "true")
	        {
	        params += "&DATABASENAME=" + encodeURIComponent(frm.TWITTERDBNAME.value) + "&DATABASEDESC=" + encodeURIComponent(frm.TWITTERDBDESC.value) //No I18N
	        }
	        else
	        {
	        params += "&DBID=" + ZDBClientUI.dbId;//No I18N
	        }
	        if(ZRTwitterInteg.isAuthenticated)
	        {
	        	AjaxAPI.sendRequest({URL:"/ZRTwitterSchDlg.cc?ZDBACTION=VALIDATEDBNAME"+params, METHOD:"POST", 
	                ONSUCCESSFUNC:ZRTwitterInteg.showTwitterScheduleDlg,ONFAILUREFUNC:ZRTwitterInteg.errorOnSubDBDetails, OPSTATUSID:"TWITTERCREATEDBOPTSTATUS"}); //No I18N
	        }
	        else
	        {
	        	alert("Not Authenticated");//NO I18N
	        }
	    };
        
	    
	    this.showTwitterScheduleDlg = function (response)
	    {
	    	ZRTwitterInteg.step = 2;
	    	var div = document.createElement("div");
	        div.innerHTML = response.responseText;
	        ZRTwitterInteg.schSettingsDlg=div; 
	        ZRTwitterInteg.hiddenHolder.appendChild(ZRTwitterInteg.dbDetailsDlg);
	        ZRTwitterInteg.wizardHolder.appendChild(div);
	        document.getElementById("sfHelpTxt").innerHTML = ZDBI18NMap.f("zrpt.twitter.js.maxhandlesmesg",$("MAX_ALLOWED_USERS").value  ); //No i18n
	        
	        $("TwitterCreate").onclick=function () { ZRTwitterInteg.submitCreateDB(this.form);};
	        jQuery("#TwitterCreatePrevious").click(function(){ZRTwitterInteg.showDBDetsDlgFromSchDlg();}); //No I18N
	        ZDBUtil.setFocus("tokencontainer",true); //No I18N
	        ZRTwitterInteg.setDlgTitle();
	        ZRConnector.changeSchTimeToCurrentTime();
	        ZRTwitterInteg.addAuthenticatedUser();
	    };
	    
	    
	    this.submitCreateDB = function(form)
	    {
	    	if(ZRTwitterInteg.userIdsArray.length==0)
	    		{
	    		showCustomMessage(ZDBI18NMap.g("zrpt.twitter.js.emptyusermesg"), $("tokencontainer-ztokenfield-container"));//No I18N
	    		return;
	    		}
	    	var needReports = "";
			if(form.NEEDREPORTS && form.NEEDREPORTS.checked == false)
			{
				needReports = "&NEEDREPORTS=true";  	//No I18N
			}
			var isNewDB = form.ISNEWDB.value;
	        var params = 	"&ISNEWDB=" + isNewDB + needReports//NO I18N
	        				+"&TIMEZONE="+ encodeURIComponent(form.TWITTERTIMEZONE.value) //NO I18N
	        				+"&SCHEDULETIME=" + ZRConnector.getSchTime() //NO I18N
	        				+"&ACCESSTOKEN="+form.ACCESSTOKEN.value //NO I18N
	        				+"&ACCESSTOKENSECRET="+form.ACCESSTOKENSECRET.value //NO I18N
	        				+"&AUTHENTICATEDUSERNAME="+form.AUTHENTICATEDUSERNAME.value //NO I18N
	        				+"&AUTHENTICATEDUSERID="+form.AUTHENTICATEDUSERID.value //NO I18N
	        				+"&USERSIDS="+JSON.stringify(ZRTwitterInteg.userIdsArray) //NO I18N
	        				+"&ZOHO_SELECTED_MODULES="+ ZRConnector.getSelectedModulesAlone(form, "TwitterModContainer") //NO I18N
	        				+"&SCHTIMEZONE="+ ZRConnector.getSchTimeZone() ; //No I18N
	        
	        
	        if(isNewDB == "true")
	        {
	        	params += "&DATABASENAME=" + encodeURIComponent(form.TWITTERDBNAME.value) + "&DATABASEDESC=" + encodeURIComponent(form.TWITTERDBDESC.value) //No I18N
	        }
	        else
	        {
	        	params += "&DBID=" + ZDBClientUI.dbId;//No I18N
	        }
	       
	        AjaxAPI.sendRequest({URL:"/ZRTwitterInitialInfoDlg.cc?&ZDBACTION=TWITTERCREATEDB"+params, METHOD:"POST",
	                ONSUCCESSFUNC:ZRTwitterInteg.showSuccessDBDlg, OPSTATUSID:"TWITTERCREATEOPTSTATUS"}); //No I18N
	    };
	    
	    
	    this.showDBDetsDlgFromSchDlg = function ()
	    {
	    	this.isAuthenticated = false;
	    	ZRTwitterInteg.cancelActivity();
	    	ZRTwitterInteg.schSettingsDlg.parentNode.removeChild(ZRTwitterInteg.schSettingsDlg);
	    	ZRTwitterInteg.showTwitterDBDetailsDlg();
	    };

	   
	    
	    this.addAuthenticatedUser=function()
	    {
	    	ZRTwitterInteg.index=-1;
	    	ZRTwitterInteg.userIdsArray=[];
	    	params="&QUERYSTRING="+$("AUTHENTICATEDUSERID").value;//NO I18N
	    	
	    	params+="&ACCESSTOKEN="+$("ACCESSTOKEN").value;//NO I18N
	    	params+="&ACCESSTOKENSECRET="+$("ACCESSTOKENSECRET").value;//NO I18N

	    	ZRTwitterInteg.constructTwitterHandlesListItems("importSchedule");//No I18N
	    	ZRTwitterInteg.displayAuthUser();
		  
	    }
	    
   
     this.submitTwitterDemoDlg = function()
     	{
     	if($("ZDBZDShowDemoCheck").checked)
         {
     		ZRTwitterInteg.showDemoDlg = false;
             var url = "/ConnectorAction.ma?ZDBACTION=DONTSHOWDEMODLG&CONNECTORID=36"; //No I18N
             AjaxAPI.sendRequest({URL:url,ONSUCCESSFUNC:ZRTwitterInteg.showTwitterImpDlg}); 
         }
     	else
     	{
     		ZRTwitterInteg.showTwitterImpDlg();
     	}
     	
     	};
     
     this.showTwitterImpDlg = function(isNewDB)
     {
     	ZDBDialogUtil.closeDialog();
     	ZRTwitterInteg.showDlgBasedOnSelection();
     }
     
     
     
     this.showDlgBasedOnSelection = function()
     {
    	 
     	ZRTwitterInteg.showTwitterDBDetailsDlg();	
     	if(ZRTwitterInteg.isNewDB==="true")
     	{

     	ZDBFullPageDialog.showDialog(ZRTwitterInteg.wizardHolder,{ADDFRAME:true,DONTREMOVE:true, MODAL:true,ONCLOSE:ZRTwitterInteg.handleDlgClose});
     	}
     	else
    	{
     		
    		ZDBInlineDialog.showDialog(ZRTwitterInteg.wizardHolder,{ADDFRAME:true,DONTREMOVE:true,MODAL:true,TITLE:ZDBI18NMap.f("zrpt.conn.js.setupdlg.title",ZDBI18NMap.g("zrpt.connector.js.twitter")),ONCLOSE:ZRTwitterInteg.handleTwitterDlgClose});
            $("TwitterDlgTtlBar").className = "";//No I18N
            $("TwitterDlgTtlBar").style.padding = "25px 25px 0px";//No I18N
            $("TwitterGenInfo").style.width = "40%";//No I18N
            $("TWITTERWIZARDHOLDER").style.minWidth = "1141px";//No I18N
    	}
    	ZRTwitterInteg.setDlgTitle();
     };
     
     
     
     this.showTwitterDBDetailsDlg = function()
     {
     	ZRTwitterInteg.step = 1;
     	ZRTwitterInteg.wizardHolder.appendChild(ZRTwitterInteg.dbDetailsDlg);
     	ZRTwitterInteg.setDlgTitle();
     };
     
     
     
     this.showDBDetailsDlg=function(el,isNewDB)
     {
    	  ZRTwitterInteg.Z_el=el;
          ZRTwitterInteg.Z_isNewDB=isNewDB;
          ZRTwitterInteg.isNewDB=isNewDB;
          
          
    	 if(!ZDBLazyLoadUtil.loadSnippet("ZRTWITTER_IMPORT_DLG","/ZRTwitterDBDetsDlg.cc?ISNEWDB="+isNewDB,this,"APPENDTODOC"))
         {    
         	return;
         }

         delete ZDBLazyLoadUtil.loadedSnippets.ZRTWITTER_IMPORT_DLG;
         var productName = ZRTwitterInteg.isNewDB ? ZDBGlobal.PRODUCT_NAME : ZDBGlobal.PRODUCTNAME;
         ZRTwitterInteg.isUserExpired = $("TWITTER_IS_EXPIRED_USER").value;
         ZRTwitterInteg.isNotAnSFUser = $("TWITTER_IS_NOT_USER").value;
         ZRTwitterInteg.isReportsUser = $("TWITTER_IS_REPORTS_USER").value;
         if(ZRTwitterInteg.isUserExpired === "true")
         {
         	ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.conn.js.userexpired.msg",ZDBI18NMap.f("zrpt.connector.js.twitter"),ZDBGlobal.PRODUCTNAME));
         	return;
         }   
         else if(ZRTwitterInteg.isReportsUser !=="true" && ZRTwitterInteg.isNotAnSFUser === "true")
         {
         	ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.conn.js.otherservice.freeuser",ZDBI18NMap.g("zrpt.connector.js.twitter"),ZDBGlobal.PRODUCT_NAME));
         	return;
         }
         else if(ZRTwitterInteg.isNotAnSFUser ==="true")
         {
         	var infoDlg =  $("TwitterTrialInfo")
         	infoDlg.style.display = "" ;
         	ZDBDialogUtil.showDialog(infoDlg,{TITLE: ZDBI18NMap.f("zrpt.conn.js.title_trial",ZDBGlobal.PRODUCT_NAME,ZDBI18NMap.g("zrpt.connector.js.twitter")), ADDFRAME:true,MODAL:true,DONTREMOVE:true});
         }
         else
         {
         	ZRTwitterInteg.initializeAndShowDBDlg();
         }
    	   
     };
     
     
     
     this.initializeAndShowDBDlg = function(isNewDB)
     {
         ZDBDialogUtil.closeDialog();
         ZRTwitterInteg.initialize();

         if(ZRTwitterInteg.showDemoDlg === "true")
 	 	  {
         	ZDBDialogUtil.showDialog(ZRTwitterInteg.demoDlg,{TITLE:ZDBI18NMap.f("zrpt.conn.js.demo.title",ZDBI18NMap.g("zrpt.connector.js.twitter")),
         						ADDFRAME:true,DONTREMOVE:false, MODAL:true});
         	ZDBUtil.setFocus("TWITTERSKIPDEMO",true); //No I18N
 	 	  }
         else
         {
        	 
         	ZRTwitterInteg.showDlgBasedOnSelection();
          }
     	
     };
    
    
     this.setDlgTitle = function()
     {
             var title = "";
             var desc = "";
             switch(ZRTwitterInteg.step)
             {
                 case 1:
                     title = ZDBI18NMap.f("zrpt.conn.js.setupdlg.step1.title",ZDBI18NMap.g("zrpt.connector.js.twitter"));
                     desc = ZDBI18NMap.f('zrpt.conn.js.createdbdesc',ZDBI18NMap.g('zrpt.connector.js.twitter'));                      
                     break;
                 case 2:
                     title = ZDBI18NMap.f("zrpt.conn.js.setupdlg.step2.title",ZDBI18NMap.g("zrpt.connector.js.twitter"));
                     desc = ZDBI18NMap.f('zrpt.conn.js.twitterscheduledlgdesc',ZDBI18NMap.g('zrpt.connector.js.twitter')) ;
                     break;
                 case 3:
                     title = ZDBI18NMap.f("zrpt.conn.js.dbsuccess.title",ZDBI18NMap.g("zrpt.connector.js.twitter"));
                     desc =  ZDBI18NMap.f("zrpt.conn.js.dbsuccess.desc",ZDBI18NMap.g("zrpt.connector.js.twitter"));
                     break;   
             }
            $("zdbImpTwitterDlgTitle").innerHTML = title;
            $("zdbImpTwitterDlgDesc").innerHTML = desc;
     };
     
     
     
     this.errorOnSubDBDetails = function(response,reponsetext)
     {
         var errCode = response.getResponsePart("ERRORCODE");
         var errMsg = response.getResponsePart("STATUS_MESSAGE");
         errCode = trimAll(errCode);
         if(errCode === "META_DBNAME_DUPLICATE")
         {
             showCustomMessage(errMsg, $("TWITTERDBNAME"));
             return;
         }
         else
         {
              ZDBAlertAPI.showMsg(errMsg);
         }
     };
   
     this.handleTwitterDlgClose = function(el, event)
     {

     	if(ZRTwitterInteg.isNewDB == "true")
     	{
     		ZDBInlineDialog.closeDialogByType(el,event);
     	}
     	else
     	{
     		ZRTwitterInteg.handleDlgClose();
     		ZDBInlineDialog.closeDialog();
     	}
     }

     
     this.showSuccessDBDlg = function(response,responseText)
     {

       ZRTwitterInteg.step = 3;
       var div = document.createElement("div");
       div.innerHTML = response.responseText;
       ZRTwitterInteg.successInfoDlg = div;
       ZRTwitterInteg.schSettingsDlg.parentNode.removeChild(ZRTwitterInteg.schSettingsDlg);
       ZRTwitterInteg.wizardHolder.appendChild(ZRTwitterInteg.successInfoDlg);    
       ZRTwitterInteg.setDlgTitle();
       ZDBDialogUtil.positionCenter(ZDBDialogUtil.focusDialog);
     };
     
     
     this.cancelActivity = function() 
     { 
     	jQuery("#TwitterAuthSuccessMsg").css({"border":"1px","background-color":"rgb(150,255,65,0.4)","font-weight":"bold"});//NO I18N
     	if($("TWITTERAUTHSUCCESS"))
     	{
     		$("TWITTERAUTHSUCCESS").style.display = "none";
     	}
     	if($("TwitterDBDetsSubmit"))
     	{
     		$("TwitterDBDetsSubmit").className="buttonCompBoxBg alpha";
     		jQuery("#TwitterDBDetsSubmit").unbind('click'); //No I18N
     	}
     };
     
     

     this.handleDlgClose = function()
     {
     	ZRConnector.removeTimeZoneComponent();
         var step = ZRTwitterInteg.step;
         switch(step)
         {
             case 1:
             {
                 // Need to re-append the current step div in the hiddenHolder.
             	ZRTwitterInteg.cancelActivity(); 
             	break;
                      
             }
             case 2:
             {      

                 var dlg = ZRTwitterInteg.schSettingsDlg;
                 dlg.parentNode.removeChild(dlg); 
                 ZRTwitterInteg.cancelActivity();
                 break;
             }           
             case 3:
             {
             	var dbId = $("ZDBTwitterDBId").value; 
             	var dlg = ZRTwitterInteg.successInfoDlg;
             	dlg.parentNode.removeChild(dlg);
 				window.url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + dbId; //No I18N            	
 				setTimeout( "window.location.href = window.url;", 0);// jshint ignore:line
             	break; 
             }            
         }
         return true;
     };
     
     
     this.showEditLoginDlg = function(conndbinfoid)
     {
         
         AjaxAPI.sendRequest({URL:"/ZRTwitterValidity.cc?ZDBACTION=TWITTERVALIDITY&DBID="+ZDBClientUI.dbId+"&CONNDBINFOID="+conndbinfoid,
             METHOD:"GET",ONSUCCESSFUNC:ZRTwitterInteg.handleShowEditLoginDlgSucc, OPSTATUSID:"ZDBMainLoader"}); //No I18N
         
     };
     
     this.handleShowEditLoginDlgSucc = function(response,responseText)
     {
     	var div = document.createElement("div");
         div.innerHTML = response.responseText;
         document.body.appendChild(div);
         ZDBDialogUtil.closeDialog();
         ZDBDialogUtil.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true, 
                               TITLE:ZDBI18NMap.f("zrpt.conn.js.reauth.title",ZDBI18NMap.g("zrpt.connector.js.twitter"))});
	        
     };
     
     
     
     this.showEditSchDlg = function(conndbinfoid)
     {
        
       AjaxAPI.sendRequest({URL:"/ZRTwitterEditSchDlg.cc?DBID="+ZDBClientUI.dbId+"&CONNDBINFOID=" + conndbinfoid,
                        ONSUCCESSFUNC:ZRTwitterInteg.handleShowEditSchDlgSucc,
                        OPSTATUSID:"ZDBMainLoader"}); //No I18N
         
     };
     
     
     
     this.handleShowEditSchDlgSucc = function(response,responseText)
     {
     	var div = document.createElement("div");
     	div.innerHTML = response.responseText;
         document.body.appendChild(div);
         ZDBDialogUtil.closeDialog();
         ZDBDialogUtil.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true,
         			ONCLOSE:ZRConnector.removeTimeZoneComponent,TITLE:ZDBI18NMap.f("zrpt.conn.js.edit.setup",ZDBI18NMap.g("zrpt.connector.js.twitter"))});
         jQuery("#TwitterEditSchSubmit").click(function(){ ZRTwitterInteg.submitEditSchDets(this.form);}); //No I18N
         ZRTwitterInteg.allowedUsers=$("MAX_ALLOWED_USERS").value
         ZRTwitterInteg.constructTwitterHandlesListItems("editSchedule");//No I18N
         var params="&CONNDBINFOID="+$("CONNDBINFOID").value;//No I18N
         ZDBUtil.setFocus("tokencontainer",true); //No I18N
         ZRConnector.setSchDetails();
         document.getElementById("sfHelpTxt").innerHTML = ZDBI18NMap.f("zrpt.twitter.js.maxhandlesmesg",$("MAX_ALLOWED_USERS").value  ); //No i18n
         ZRTwitterInteg.displayUsersInPresentInTheConnector();
    };
     
     
     this.getResponseURL=function(state)
     {
    	 var responseURL=$("SERVER_URL").value;
    	 var params="/ZRTwitterAction.ma?&ZDBACTION=SEARCHTWITTERUSERS&SUBREQUEST=XMLHTTP&_ZVER_=59";//No I18N
    	 queryString=$("tokencontainer-ztokenfield-input").value;
    	 params+="&QUERYSTRING="+queryString //NO I18N
    	 if(state!=="editSchedule")
    		 {
    	 params+="&ACCESSTOKEN="+$("ACCESSTOKEN").value;//NO I18N
		 params+="&ACCESSTOKENSECRET="+$("ACCESSTOKENSECRET").value;//NO I18N
    		 }
    	 else
    		 {
    		 params+="&CONNDBINFOID="+$("CONNDBINFOID").value+"&DBID=" + ZDBClientUI.dbId ;//No I18N
    		 }

    	 return  responseURL+params;
     };
     
     
     
     this.constructTwitterHandlesListItems=function(state)
     {
    	 ZRTwitterInteg.maxAllowedUsers=parseInt($("MAX_ALLOWED_USERS").value)

    	 jQuery("#tokencontainer").ztokenfield({  														//No I18N
    		 
    		
    		 dataMapping: {
         value: "screen_name",																	//No I18N  
         text: "name",																 //No I18N
         image: "imageURL", //No I18N
         itemIdentifier:"screen_name",															//No I18N
         informativeText:"@screen_name"	,													//No I18N
         customValues:"user_id"	,													//No I18N
         

    	},
        dataSource: {
             "URL": function(){ return ZRTwitterInteg.getResponseURL(state);},									//No I18N
             "type": "GET",																					//No I18N
             queryParam: function(params){
            

                    return {
                        "QUERYSTRING" : params.QUERYSTRING,																//No I18N  
                        "PAGENUMBER" : params.pages,																//No I18N  
                    };
              },
              success: function(data,params){
            		 
                    return {
                        "results": data	,																				 //No I18N
                        "more":true																						//NO I18N
                    };
                },
               
        },
        className:"twitterTokenField",//No I18N

        isResponsePaginated: true,
       
                   
        search: {
      	   by: "screen_name,name",																			//No I18N
      	minKeywordLength: 1,
        },
        
      	
      	placeholder:ZDBI18NMap.g("zrpt.connector.js.twitter.searchandaddplaceholder"),																			//No I18N
      	
        dropdownList: {
            showNoResultsMessage: true,
            sortResults:false,
            width:400,
            contentType:"image-text-desc"	,																				//No I18N
            menuClassName:"twitterMenuClass",																					//No I18N
        },
        messages: {
            noResults: ZDBI18NMap.f("zrpt.connector.js.twitter.noresutlmsg","#query#")	,																//No I18N
            serverError:ZDBI18NMap.g("zrpt.connector.js.twitter.validusernamemsg"),																//No I18N			
        },
        maxAllowedValues:ZRTwitterInteg.maxAllowedUsers,
        tokens:
        {
        	contentType:'image-text',//No I18N
        },
    	tokenremove:function(orgEvent,ui)
    	{
    		 var tokens = jQuery("#tokencontainer").ztokenfield("getAllValues");//No I18N
    		 

        	 ZRTwitterInteg.addUsersToArray(tokens);
    	},
    	tokenadd:function(orgEvent,ui)
    	{
    		 var tokens = jQuery("#tokencontainer").ztokenfield("getAllValues");//No I18N
   
      	 ZRTwitterInteg.addUsersToArray(tokens);
    	}
        
          });
    	
    	
     };
    
     this.displayAuthUser=function()
     {
    	 ZRTwitterInteg.displayUsersFromJSONArray($("AUTHENTICATEDUSERJSONARRAY").value);
     };
     this.displayUsersInPresentInTheConnector=function()
     {
    	 ZRTwitterInteg.displayUsersFromJSONArray($("USERJSONARRAYFORCONNECTOR").value);
     };
     
     

     this.displayUsersFromJSONArray=function(response)
     {
    	 var users;
    		 users=JSON.parse(response);
    	
    	 ZRTwitterInteg.userIdsArray=[];
    	 jQuery("#tokencontainer").ztokenfield("addTokens",users);//No I18N
    	 for(var i=0;i<users.length;i++){

        	 ZRTwitterInteg.userIdsArray[i]=users[i].user_id;
    	 }
  
     };
     
     
     
   
    this.addUsersToArray=function(tokens)
    {
    	ZRTwitterInteg.userIdsArray=[];
    	for(var i=0;i<tokens.length;i++)
    		{
    	ZRTwitterInteg.userIdsArray[i]=tokens[i].user_id;
    		}
    };
    
    
     this.submitEditSchDets = function(frm)
     {
       
    	 if(ZRTwitterInteg.userIdsArray.length==0)
 		{
 		showCustomMessage(ZDBI18NMap.g("zrpt.twitter.js.emptyusermesg"), $("tokencontainer-ztokenfield-container"));//No I18N
 		return;
 		}
    	 
    	 var params = "&SCHEDULETIME=" + ZRConnector.getSchTime() + "&DBID=" + ZDBClientUI.dbId + "&CONNDBINFOID=" + frm.CONNDBINFOID.value //No I18N
       +"&USERSIDS="+JSON.stringify(ZRTwitterInteg.userIdsArray) +"&CONNECTORID=" + $("CONNECTORID").value + "&ZOHO_SELECTED_MODULES="+ ZRConnector.getSelectedModulesAlone(frm, "TwitterModContainer") + "&SCHTIMEZONE="+ ZRConnector.getSchTimeZone(); //No I18N
       AjaxAPI.sendRequest({URL:"/ConnectorAction.ma?&ZDBACTION=SAVEEDITSETTINGS"+params, METHOD:"POST",
               ONSUCCESSFUNC:ZRTwitterInteg.handleSubmitEditSchSucc,OPSTATUSID:"TWITTEREDITSCHOPTSTATUS"}); //No I18N
     };
     
     
     this.handleSubmitEditSchSucc = function(response, requestOptions)
     {
     	ZDBDialogUtil.closeDialog();
     	ZDBMsgBox.showSuccess(response.responseText);
     	ZRConnector.updateSchTypeNTime(response, requestOptions);
     };
     
     this.showErrorMessage = function(response,reponsetext)
     {

         var errCode = response.getResponsePart("ERRORCODE");
         var errMsg = response.getResponsePart("STATUS_MESSAGE");
         //errCode = trimAll(errCode);
         ZDBAlertAPI.showMsg(errMsg);
         
     };
     
};

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRTwitterInteg.showDBDetailsDlg"] = ZRTwitterInteg.showDBDetailsDlg;//NO I18N
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRTwitterInteg.showImportDetailsDlg"] = ZRTwitterInteg.showImportDetailsDlg;//NO I18N
ZDBLazyLoadUtil.loadCssOnly("CSSLIST_ZOHOCOMPONENTS", "APPENDTODOC"); // No I18N