//$Id$

var ZPeopleInteg = new function()
{

	this.initialize = function()
	{     
		ZPeopleInteg.showDemoDlg = jQuery("#ZPeopleDemoHOLDER").attr("showDemoDlg"); //No i18N
		ZPeopleInteg.wizardHolder = $("ZPeopleDemoHOLDER");
		ZPeopleInteg.dbDetailsDlg = $("ZPeopleDBDetailsDlg");	
		ZPeopleInteg.demoDlg =  $("ZPeopleDemoDlg");
	};

	this.connectorID = 30;
	this.fetchPeopleImpDlgFromHome = function()
	{
		ZPeopleInteg.showZPeopleHomeDlg(false);
	}
	this.fetchZPeopleInsideDB = function()
	{
		ZPeopleInteg.showZPeopleHomeDlg(true);
	}
	
	this.showZPeopleHomeDlg = function(isInDB)
	{
		ZPeopleInteg.isInsideDB = isInDB;
        if(!ZDBLazyLoadUtil.loadSnippet("ZRPEOPLE_IMPORT_DLG","/ZRPeopleDBDetsDlg.cc?ZDBACTION=ZPEOPLEINITIALFETCH&ISINDBMODE="+ZPeopleInteg.isInsideDB,this,"APPENDTODOC"))
        {    
        	return;
        }
        delete ZDBLazyLoadUtil.loadedSnippets.ZRPEOPLE_IMPORT_DLG;
        
        ZPeopleInteg.isUserExpired = $("ZPEOPLE_IS_EXPIRED_USER").value;
        ZPeopleInteg.isFreshUser = $("ZPEOPLE_IS_NOT_USER").value;
        ZPeopleInteg.isReportsUser = $("ZPEOPLE_IS_REPORTS_USER").value;
        if(ZPeopleInteg.isUserExpired === "true")
        {
        	ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.conn.js.userexpired.msg",ZDBI18NMap.f("zrpt.connector.js.zpeople"),ZDBGlobal.PRODUCTNAME));
        	return;
        }   
        else if(ZPeopleInteg.isReportsUser !== "true" && ZPeopleInteg.isFreshUser === "true")
        {
        	ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.conn.js.otherservice.freeuser",ZDBI18NMap.g("zrpt.connector.js.zpeople"),ZDBGlobal.PRODUCT_NAME));
        	return;
        }
        else if(ZPeopleInteg.isFreshUser === "true")
        {
        	var infoDlg =  $("ZPeopleTrialInfo");
        	infoDlg.style.display = "" ;
        	if(ZPeopleInteg.isInsideDB)
        	{
            	$("ZPEOPLENewUserOkBtn").setAttribute('onclick','ZPeopleInteg.initializeAndShowDBDetsDlg(ZPeopleInteg.showZPeopleImpDlgInDB)');
        	}
        	else
        	{
        		$("ZPEOPLENewUserOkBtn").setAttribute('onclick','ZPeopleInteg.initializeAndShowDBDetsDlg(ZPeopleInteg.showZPeopleImpDlg)');
        	}
        	ZDBDialogUtil.showDialog(infoDlg,{TITLE:ZDBI18NMap.f("zrpt.conn.js.title_trial",ZDBGlobal.PRODUCT_NAME,ZDBI18NMap.g("zrpt.connector.js.zpeople")), ADDFRAME:true,MODAL:true,DONTREMOVE:true});
        }
        else
        {
        	if(ZPeopleInteg.isInsideDB)
        	{
        		ZPeopleInteg.initializeAndShowDBDetsDlg(ZPeopleInteg.showZPeopleImpDlgInDB);
        	}
        	else
        	{
        		ZPeopleInteg.initializeAndShowDBDetsDlg(ZPeopleInteg.showZPeopleImpDlg);
        	}
        }
	};	
	
	this.showZPeopleImpDlg = function()
    {
        ZDBDialogUtil.closeDialog();
        ZPeopleInteg.showPeopleDetsDlg();
        if($("ZPOrgNames").value=="_dummy")
        {
            ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.people.js.noorgs")); //No I18N
            return;
        }
        ZDBFullPageDialog.showDialog(ZPeopleInteg.wizardHolder,{ADDFRAME:true, MODAL:true,ONCLOSE:ZPeopleInteg.handleDlgClose});
        ZRConnector.changeSchTimeToCurrentTime();
        ZPeopleInteg.setDlgTitle();
        ZPeopleInteg.setCurView();
        jQuery("#ZCDBDetsSubmit").click(function(){ ZPeopleInteg.submitDBDetails(false,this.form);}); //No I18N
    }	
	
    this.showZPeopleImpDlgInDB = function()
    {
    	ZDBDialogUtil.closeDialog();
    	ZPeopleInteg.showPeopleDetsDlg();
    	if($("ZPOrgNames").value=="_dummy")
    	{
	        ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.people.js.noorgs")); //No I18N
	        return;
    	}
		ZDBInlineDialog.showDialog(ZPeopleInteg.wizardHolder,{ADDFRAME:true,DONTREMOVE:true, MODAL:true,ONCLOSE:ZPeopleInteg.handleDlgClose,TITLE:ZDBI18NMap.f("zrpt.conn.js.setupdlg.title",ZDBI18NMap.g("zrpt.connector.js.zpeople"))});
    	ZRConnector.changeSchTimeToCurrentTime();
    	ZPeopleInteg.setDlgTitle();
    	ZPeopleInteg.setCurView();
        if($("ZPPLFieldsSearch"))
        {
        	$("ZPPLFieldsSearch").style.paddingLeft = "151px";//No I18N
        }
        jQuery("#ZCDBDetsSubmit").click(function(){ ZPeopleInteg.submitDBDetails(true,this.form);}); //No I18N
    }

    this.submitDBDetails = function(isInDB,form)
    {
    	ZPeopleInteg.isInsideDB=isInDB;
        if(!validateForm(form))
        {
          return;
        }
    	if($("ZPOrgNames").value=="_dummy")
    	{
	        ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.people.js.noorgs")); //No I18N
	        return;
    	}
        var isValidated = ZPeopleInteg.validateViewNFieldsSelection(form);
        if(!isValidated)
        {
        	return;
        }     
        hideCustomMessage();
        var selCols = ZPeopleInteg.getSelectedCols(form, 'ZPPLViewContainer'); //No I18N
        var params = "&ORGID="+encodeURIComponent($("ZPOrgNames").value) + "&SCHTIMEZONE="+ ZRConnector.getSchTimeZone()  //No I18N
        	+ "&SCHEDULETIME=" + ZRConnector.getSchTime() + "&SELECTEDCOLS="+selCols+"&ISINDBMODE="+ZPeopleInteg.isInsideDB; //No I18N        
		if(ZPeopleInteg.isInsideDB)
		{
			params = params+"&DBID="+ZDBClientUI.dbId;  //No I18N 
		}
		else
		{
			params = params+"&DATABASENAME=" + encodeURIComponent(form.ZPEOPLEDBNAME.value) +"&DATABASEDESC=" + encodeURIComponent(form.ZPPLDBDESC.value);  //No I18N
		}
        AjaxAPI.sendRequest({URL:"/ZRPeopleInitialInfoDlg.cc?&ZDBACTION=ZPPLCREATEDB",
        	PARAMETERS:params,
        	ONSUCCESSFUNC:ZPeopleInteg.showSuccessDBDlg,
            ONFAILUREFUNC:ZPeopleInteg.handleZPImportFailure,
        	OPSTATUSID:"ZPPLCREATEDBOPTSTATUS"}); //No I18N        
    };
   
    
	this.handleZPImportFailure = function(response, requestOptions) 
	{
		var errCode = response.getResponsePart("ERRORCODE");
		var errMsg = response.getResponsePart("STATUS_MESSAGE");
		errCode = trimAll(errCode);
		if (errCode != null) 
		{
			AjaxAPI.onFailureFunc(response, requestOptions);
		}
	}

    this.loadPeopleForms = function(elt)
    {
        var selectedVal = elt.value;
        if(selectedVal == "_dummy")
        {
            return;
        }

        var params = "&ORGID=" + selectedVal; // No I18N
        AjaxAPI.sendRequest({
                URL:"/ZRPeopleViews.cc?ZDBACTION=ZPPLFETCHVIEWS", // No I18N
                METHOD :"GET",	 //No I18N
                PARAMETERS:params,
                ONSUCCESSFUNC:ZPeopleInteg.loadViewsResp,
                OPSTATUSID:"LOADVIEWS" // No I18N
            });
    };
    
    this.loadViewsResp = function(response,requestOptions)
    {
    	var viewsDiv = response.getOnlyHtml();
    	var viewHolderDiv = $("ZPPLVIEWSHOLDER");
    	viewHolderDiv.innerHTML = viewsDiv;
    	jQuery("#ZPPLViewContainer").find("[tab]").click(function(){ZPeopleInteg.showFieldsContainer(this);}); //No I18N
    	ZPeopleInteg.setCurView();
    };
    
    this.setCurView = function()
    {
    	if($("ZPPLCURVIEW"))
    	{
    		ZPeopleInteg.curModule = $("ZPPLCURVIEW").value;
    		$("ZPPLSearchFields" ).setAttribute("searchDivId",""+ZPeopleInteg.curModule+"FieldsContainer");
    	}
    };

    this.setDlgTitle = function()
    {
            var title = "";
            var desc = "";
            switch(ZPeopleInteg.step)
            {
                case 1:
                    title = ZDBI18NMap.f("zrpt.conn.js.setupdlg.title",ZDBI18NMap.g("zrpt.connector.js.zpeople"));
                    desc = ZDBI18NMap.f('zrpt.conn.js.createdbdesc',ZDBI18NMap.g('zrpt.connector.js.zpeople')) ;                     
                    break;
                case 2:
                    title = ZDBI18NMap.f("zrpt.conn.js.dbsuccess.title",ZDBI18NMap.g("zrpt.connector.js.zpeople"));
                    desc =  ZDBI18NMap.f("zrpt.conn.js.dbsuccess.desc",ZDBI18NMap.g("zrpt.connector.js.zpeople"));
                    break;
            }
            $("zdbImpZCDlgTitle").innerHTML = title;
            $("zdbImpZCDlgDesc").innerHTML = desc;
    };
    
    this.handleDlgClose = function()
    {
        var step = ZPeopleInteg.step;
        switch(step)
        {
            case 1:
            {
            	break;
            }        
            case 2:
            {
            	var dbId = $("ZDBZPPLDBId").value; 
            	ZDBDialogUtil.closeDialog();
            	window.url = ZDBGlobal.CTX + ZDBGlobal.REPORTS_CONTEXT_NAME + "/ZDBDataSheetView.cc?DBID=" + dbId; //No I18N
            	setTimeout( "window.location.href = window.url;", 0);// jshint ignore:line
            	break; 
            }            
        }
        ZRConnector.removeTimeZoneComponent();
        return true;
    };

    this.showPeopleDetsDlg = function()
    {
    	ZPeopleInteg.step = 1;
        ZDBUtil.setFocus("ZPEOPLEDBNAME",true); //No I18N
        jQuery("#ZPPLViewContainer").find("[tab]").click(function(){ZPeopleInteg.showFieldsContainer(this);}); //No I18N
    };

    this.showFieldsContainer = function(el)
    {
      if(ZPeopleInteg.curModule === el.id)
      {
          return;
      }

      if(ZPeopleInteg.curModule !== null)
      {
        jQuery("#" +ZPeopleInteg.curModule + "FieldsContainer").hide(); //No I18N
        var module = $(el.id + "FieldsContainer");
        $("ZPPLSearchFields" ).setAttribute("searchDivId",""+module.id);
        $("ZPPLSearchFields").value="";
        $("ZPPLSearchFields").setAttribute("tipshown","false");
        ZDBSearchUtil.showTipString($("ZPPLSearchFields"));
        ZPeopleInteg.searchFields();
        $("ZPPLEmptyFieldsMsg").style.display="none";
        module.scrollTop=0;
        $(""+el.id).className="moduleTabSelected overFlowEllipsis";
        $(ZPeopleInteg.curModule).className = "moduleTab overFlowEllipsis";
        jQuery(module).show();
        ZPeopleInteg.curModule = el.id;
      }
    };

    this.searchFields = function()
    {
    	var searchFieldElem = $("ZPPLSearchFields");
    	var containerDivId = searchFieldElem.getAttribute("searchDivId");
    	var attr = "dispval"; //No I18N
    	var basedOnTag = "input"; //No I18N
    	ZDBClientUtil.searchAndDisplay(containerDivId,basedOnTag,attr,searchFieldElem,$("ZPPLEmptyFieldsMsg"));
    };
    
    this.initializeAndShowDBDetsDlg = function(func)
    {  
        ZDBDialogUtil.closeDialog();
        ZPeopleInteg.initialize();
        if(ZPeopleInteg.showDemoDlg === "true")
	 	{
        	$("ZPPLSKIPDEMO").setAttribute('onclick','ZPeopleInteg.submitPeopleDemoDlg('+func+')');
        	ZDBDialogUtil.showDialog(ZPeopleInteg.demoDlg,{TITLE:ZDBI18NMap.f("zrpt.conn.js.demo.title",ZDBI18NMap.g("zrpt.connector.js.zpeople")),
        						ADDFRAME:true,DONTREMOVE:true, MODAL:true});
        	ZDBUtil.setFocus("ZPPLSKIPDEMO",true); //No I18N
	 	}
        else
    	{
        	func();
    	}   	
    }
    
    this.submitPeopleDemoDlg = function(func)
    {
    	if($("ZPPLShowDemoCheck").checked)
        {
    		ZPeopleInteg.showDemoDlg = false;
            var url = "/ConnectorAction.ma?ZDBACTION=DONTSHOWDEMODLG&CONNECTORID=30"; //No I18N
            AjaxAPI.sendRequest({URL:url,ONSUCCESSFUNC:func});
        }
    	else
    	{
    		func();
    	}
    }
    
    this.checkViewDispVal = function(form, elem) 
    {
      if(!elem.checked)
      {
    	  ZPeopleInteg.deselectAllFields(form, elem);
    	  return;
      }
      var elemArr = jQuery("#ZPPLViewContainer :checkbox");//No I18N
      var isDuplicatePresent = false;
      for(var i=0; i<elemArr.length; i++)
      {
        var ite = elemArr[i];
        if(ite.checked === true && ite.getAttribute("dispVal") === elem.getAttribute("dispVal") && ite.value !== elem.value)
        {
        	isDuplicatePresent = true;
        	ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.conn.js.samefieldnamemsg",ZDBGlobal.PRODUCT_NAME,ZDBI18NMap.g("zrpt.connector.js.zpeople")),"ZDBYESNO",{ONCLICK:ZPeopleInteg.confirmSameViewCheck,ELEMENT:elem,FORM:form});    //No I18N
        	break;
        }
      }
      
      if(!isDuplicatePresent)
      {
    	  ZPeopleInteg.selectFirstFiveFields(form,elem);
      }
    };
    
    this.checkDispVal = function(elem,mod,isSubFormFld,form) 
    {
      jQuery("#"+mod+" :checkbox").prop("checked",true); //NO I18N
      if(!elem.checked)
      {
    	  if(isSubFormFld)
    	  {
    		  ZPeopleInteg.deselectAllFields(form, elem);
    		  $("ZPPL"+elem.value+"FieldsContainer").style.display = 'none';//No I18N
    	  }
    	  return;
      }
      var mod = elem.name;
      var elemArr = document.getElementsByName(mod);
      for(var i=0; i<elemArr.length; i++)
      {
        var ite = elemArr[i];
        if(ite.checked === true && ite.getAttribute("dispVal") === elem.getAttribute("dispVal") && ite.value !== elem.value)
        {
        	ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.conn.js.samefieldnamemsg",ZDBGlobal.PRODUCT_NAME,ZDBI18NMap.g("zrpt.connector.js.zpeople")),"ZDBYESNO",{ONCLICK:ZPeopleInteg.confirmSameFieldCheck,ELEMENT:elem,ISSFFIELD:isSubFormFld,FORM:form});    //No I18N
            return;
        }
      }
      
	  if(isSubFormFld)
	  {
		  jQuery("#ZPPL"+elem.value+"FieldsContainer").fadeIn(1000, function() {this.style.display=''});
		  ZPeopleInteg.selectFirstFiveFields(form,elem);
	  }
    };

    this.confirmSameFieldCheck =  function(clickType, requestOptions)
    {
    	if(clickType === "NO")
    	{
    		requestOptions.ELEMENT.checked = false;
    	}
    	else
    	{
    		 if(requestOptions.ISSFFIELD)
    		 {
    			  jQuery("#PPL"+requestOptions.ELEMENT.value+"FieldsContainer").fadeIn(1000, function() {this.style.display=''});
    			  ZPeopleInteg.selectFirstFiveFields(requestOptions.FORM,requestOptions.ELEMENT);
    		 }
    	}
	};    

	this.selectFirstFiveFields = function(form, el)//Selecting first 20 fields
	{
		   
	       if (el.checked)
	       {
	    	   var val = jQuery(el).attr('value');// No I18N
	    	   var fieldArr = ZPeopleInteg.getFieldArr(val);
	 		   if(fieldArr == undefined || fieldArr.length == 0)
			   {
				  return;
			   }
	 		   else if(fieldArr.length == undefined)
	 	       {
	 	    	  fieldArr.checked = true;
	 	    	 ZPeopleInteg.handleSubFormFieldsSel(form, fieldArr);
	 	       }
	 		   else
	 		   {
	 	    	  for (var i=0; i<fieldArr.length; i++)
		    	  {
		    		  if((fieldArr[i].getAttribute("isdisable")) == "false")
		    		  {
		    		  	fieldArr[i].checked = true;
		    		  }
		    		  ZPeopleInteg.handleSubFormFieldsSel(form, fieldArr[i]);
		    	  }		   
	 		   }
	       }
	};

    this.confirmSameViewCheck =  function(clickType, requestOptions)
    {
    	if(clickType === "NO")
    	{
    		requestOptions.ELEMENT.checked = false;
    		ZPeopleInteg.deselectAllFields(requestOptions.FORM,requestOptions.ELEMENT);
    		return;
    	}
    	ZPeopleInteg.selectFirstFiveFields(requestOptions.FORM,requestOptions.ELEMENT);
	};

    this.getSelectedCols = function(form, div)
	{
	  	var selCols="{";
	    jQuery('div#' + div + ' input[type=checkbox]').each(function() {//NO I18N
	       if ($(this).checked) 
	       {
	    	var val = jQuery(this).attr('value');//No I18N
	      	selCols += ZPeopleInteg.getSelectedColStr(jQuery(this).attr('modId'),ZPeopleInteg.getFieldArr(val)) + "," ;//NO I18N
	       }
	    });
	    selCols = selCols.substring(0, selCols.length - 1);
	    selCols += "}";
	    return selCols;
	};
	  
	this.getSelectedColStr = function(mod,fieldArr)
	{
		var isFirst = true;
		var isFirstSFFld = true;
		var usrStr = "";
		var sfFieldsStr = "";
		if(fieldArr == undefined || fieldArr.length == 0)
		{
			usrStr = "";
		}
		else if(fieldArr.length == undefined)
		{
			usrStr = fieldArr.value;
		}
		else
		{
			for (var i=0; i<fieldArr.length; i++)
			{
				if (fieldArr[i].checked === true)
				{
					
					if(fieldArr[i].getAttribute("issubformfld") == 'true')
					{
						sfFieldsStr += (isFirstSFFld ? "," : "") + ZRConnector.getSelectedColStr(fieldArr[i].value,ZPeopleInteg.getFieldArr(fieldArr[i].value)) + "," ;//NO I18N
						isFirstSFFld = false;
						continue;
					}
					
					if(isFirst)
					{
						isFirst = false;
					}
					else
					{
						usrStr += ",";
					}
					usrStr += "\"" +  fieldArr[i].value + "\"";
				}
			}
		}
		var json = "\"" + mod  + "\":[" + usrStr + "]" + sfFieldsStr;
		return (sfFieldsStr != "") ? json.substring(0, json.length - 1) : json;
	};

	this.validateViewNFieldsSelection = function(form)
	{
		  var viewSel = false;
		  var fieldSel = true;
	      jQuery('div#ZPPLViewContainer input[type=checkbox]').each(function() {//NO I18N
	          if ($(this).checked) {
	        	  var val = jQuery(this).attr('value');// No I18N
	       	    if(!ZPeopleInteg.checkFields($(this), ZPeopleInteg.getFieldArr(val)))
	       	    {
	       	    	fieldSel = false;
	       	    	return false;
	       	    }
	         	viewSel = true;
	          }
	       });
	      
	      if(!fieldSel)
	      {
	    	  return false;
	      }
	      
	      if(!viewSel)
	      {
	    	  ZDBAlertAPI.showErrorMsg(ZDBI18NMap.g("zrpt.creator.js.noviewselected"));
	    	  return false;
	      }
	      return true;
	};
	
	this.checkFields = function(el, fieldArr)
	{
		  var fieldSel = false;
		  if(fieldArr == undefined || fieldArr.length == 0)
		  {
			  ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.creator.js.nofieldavailable",el.getAttribute("dispVal")));
			  return false;
		  }
		  else if(fieldArr.length == undefined)
	      {
	    	  if(fieldArr.checked && fieldArr.getAttribute("issubformfld") != 'true')
	    	  {
	    		  fieldSel = true;
	    	  }
	      }
	      else
	      {
	    	  for (var i=0; i<fieldArr.length; i++)
	    	  {
	    		  //check subform fields too
	    		  if (fieldArr[i].checked === true)
	    		  {
	    			  if(fieldArr[i].getAttribute("issubformfld") == 'true' && !ZPeopleInteg.checkFields(fieldArr[i], ZPeopleInteg.getFieldArr(fieldArr[i].value)))
	    			  {	
	    				  fieldSel = false;
	    				  return false;
	    			  }
	    		  }
	    	  }
	    	  for (var i=0; i<fieldArr.length; i++)
	    	  {
	    		  //check subform fields too
	    		  if (fieldArr[i].checked === true)
	    		  {
	    			  if(fieldArr[i].getAttribute("issubformfld") != 'true')
	    			  {
	    				  fieldSel = true;
	    				  break;
	    			  }
	    		  }
	    	  }
	      };
	      
	      if(!fieldSel)
	      {
	    	  ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.creator.js.nofieldselected", el.getAttribute("dispVal")));
	    	  return false;
	      }
	      return true;
	};

    this.showSuccessDBDlg = function(response,responseText)
    {
    	ZPeopleInteg.step = 2;
    	var div = document.createElement("div");
    	div.innerHTML = response.responseText;
    	ZPeopleInteg.successInfoDlg = div.firstElementChild;
    	ZPeopleInteg.dbDetailsDlg.parentNode.insertBefore(ZPeopleInteg.successInfoDlg, ZPeopleInteg.dbDetailsDlg);
    	ZPeopleInteg.dbDetailsDlg.parentNode.removeChild(ZPeopleInteg.dbDetailsDlg);
    	ZPeopleInteg.setDlgTitle();
    };
    
    this.deselectAllFields = function(form, el)
    {   
	       if (!el.checked)
	       {
	    	   var val = jQuery(el).attr('value');// No I18N
	    	   var fieldArr = ZPeopleInteg.getFieldArr(val);
	 		   if(fieldArr == undefined)
			   {
				  return;
			   }
	 		   else if(fieldArr.length == undefined)
	 	       {
	 	    	  fieldArr.checked = false;
	 	    	 ZPeopleInteg.handleSubFormFieldsDesel(form, fieldArr);
	 	       }
	 		   else
	 		   {
	 	    	  for (var i=0; i<fieldArr.length; i++)
		    	  {
		    		  fieldArr[i].checked = false;
		    		  ZPeopleInteg.handleSubFormFieldsDesel(form, fieldArr[i]);
		    	  }		   
	 		   }
	       }
	  };
	  
	    this.showEditSetupDlg = function(conndbinfoid)
	    {
	      AjaxAPI.sendRequest({URL:"/ZRPeopleEditSetupDlg.cc?ZDBACTION=ZPPLEDITSETUP&DBID="+ZDBClientUI.dbId+"&CONNDBINFOID="+conndbinfoid,
              METHOD :"GET", 	//No I18N
              ONSUCCESSFUNC:ZPeopleInteg.handleShowEditSetupDlgSucc,
              ONFAILUREFUNC:ZPeopleInteg.handleProjectsEditSetupFail,
              OPSTATUSID:"ZDBMainLoader"}); //No I18N
	    };
	    
	    this.handleShowEditSetupDlgSucc = function(response,responseText)
	    {
	    	var div = document.createElement("div");
	        div.innerHTML = response.responseText;
	        document.body.appendChild(div);
	        ZDBDialogUtil.closeDialog();

	        ZDBDialogUtil.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true,
	                              ONCLOSE:ZRConnector.removeTimeZoneComponent,TITLE:ZDBI18NMap.f("zrpt.conn.js.edit.setup",ZDBI18NMap.g("zrpt.connector.js.zpeople"))});     
	        ZPeopleInteg.setCurView();
	        $("ZPPLFieldsSearch").style.paddingLeft = "164px"; //No I18N
	    	jQuery("#ZPPLViewContainer").find("[tab]").click(function(){ZPeopleInteg.showFieldsContainer(this);}); //No I18N
	        jQuery("#ZPPLEditSetupSubmit").click(function(){ ZPeopleInteg.submitEditSetup(this.form);}); //No I18N
	    	ZRConnector.setSchDetails();
	    };
	    
		this.handleProjectsEditSetupFail = function(response, requestOptions) 
		{
			var errCode = response.getResponsePart("ERRORCODE");
			var errMsg = response.getResponsePart("STATUS_MESSAGE");
			errCode = trimAll(errCode);
			if (errCode != null) 
			{
				var div = document.createElement("div");
				div.innerHTML = errMsg;
				var msg = div.textContent || div.innerText;
				ZDBAlertAPI.showMsg(msg);
			}
		}
		
	    this.submitEditSetup = function(frm)
	    {
	      if(!validateForm(frm))
	      {
	        return;
	      }
	      
	      var isValidated = ZPeopleInteg.validateViewNFieldsSelection(frm);
	      if(!isValidated)
	      {
	      	return;
	      }         
	      hideCustomMessage();
	      var selCols = ZPeopleInteg.getSelectedCols(frm, 'ZPPLViewContainer');//No I18N
	      var params = "&SCHEDULETIME=" + ZRConnector.getSchTime(frm) + "&DBID=" + frm.ZOHO_DBID.value //No I18N
	                    	+ "&CONNDBINFOID=" + $("CONNDBINFOID").value +"&CONNECTORID=" + $("CONNECTORID").value + "&SCHTIMEZONE="+ ZRConnector.getSchTimeZone()+"&SELECTEDCOLS="+selCols; //No I18N
	      
	      AjaxAPI.sendRequest({URL:"/ConnectorAction.ma?&ZDBACTION=SAVEEDITSETTINGS",PARAMETERS:params,
										ONSUCCESSFUNC:ZPeopleInteg.handleSubmitEditSetupSucc,OPSTATUSID:"ZPPLEDITSETUPOPTSTATUS"}); //No I18N
	    };
	    
	    this.handleSubmitEditSetupSucc = function(response, requestOptions)
	    {
	      ZDBDialogUtil.closeDialog();
	      ZDBMsgBox.showSuccess(response.responseText);
	      ZRConnector.updateSchTypeNTime(response, requestOptions);
	    };
	  
	  this.handleSubFormFieldsDesel = function(form, el)
	  {
		  if(el.getAttribute("issubformfld") == 'true')
		  {
			  ZPeopleInteg.deselectAllFields(form, el);
		  }
	  };
	  
	  this.getFieldArr = function(val)
	  {
		  return DOMUtils.getChildElsWithAttr($("ZPPL"+val+"FieldsContainer"),'name',val);//No I18N
	  };

	  this.handleSubFormFieldsSel = function(form, el)
	  {
		  if(el.getAttribute("issubformfld") == 'true')
		  {
			  ZPeopleInteg.selectFirstFiveFields(form, el);
		  }
	  };

}
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZPeopleInteg.showZPeopleHomeDlg"]=ZPeopleInteg.fetchPeopleImpDlgFromHome; //No I18N
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZPeopleInteg.fetchZPeopleInsideDB"] = ZPeopleInteg.fetchZPeopleInsideDB;
