//$Id$

var ZDBDStructure = new function()
{
	this.pageXStartPos;
	this.pageYStartPos;
	
	this.touchStartEvent = function(event)
	{
		this.pageXStartPos = event.pageX || event.changedTouches[0].pageX;
		this.pageYStartPos = event.pageY || event.changedTouches[0].pageY;
		event.stopPropagation();
	}
	
	this.touchEndEvent = function(event)
	{
                var pageX = event.pageX || event.changedTouches[0].pageX;//changedTouches for android phone
                var pageY = event.pageY || event.changedTouches[0].pageY;
                var XDiff = Math.abs(pageX - this.pageXStartPos);
                var yDiff = Math.abs(pageY - this.pageYStartPos);
		if(XDiff < 10 && yDiff < 10)//touch x & y diff can vary upto 20px (to hadle high resolution phones)
		{
			ZDBDStructure.showModalDiv(event);
		}
		event.stopPropagation();
	}
	
	this.stopEventPropagation = function(event)
	{
		event.stopPropagation();
	}
	
	this.checkNHideModalDiv = function(event)
	{
	    setTimeout(
	    		function(){
	    			var modalDiv = document.body.modalDiv;
	    		    var dashRow = modalDiv.dashRow;
	    		    var objTop = ZDBUtil.getObjTop(dashRow);
	    		    var dashRowHgt = dashRow.clientHeight;
	    		    var screenHgt = window.innerHeight || document.documentElement.clientHeight;
	    		    var maxScrollTop = objTop + ((dashRowHgt)*0.10);
	    		    var minScrollTop = objTop +  ((dashRowHgt)*0.90) - screenHgt;
	    			var currentScrollTop = document.body.scrollTop;
	    			if((currentScrollTop > maxScrollTop) || (currentScrollTop < minScrollTop))
	    			{
	    				ZDBDStructure.hideModalDiv(event);
	    			}
	    		}
	    ,100);
	}
        
        this.reComputeScrollTopForFocussedViews = function()
        {
            var modalDiv = document.body.modalDiv;
            if(!modalDiv || !modalDiv.dashDiv)
            {
                return;
            }
	     var scrollTopVal = ZDBDStructure.getComputedScrollTop(modalDiv);
	     document.body.scrollTop = scrollTopVal;
	     if(ZDBDialogUtil.focusDialog &&  ZDBDialogUtil.focusDialog.orientfn )
	     {
	    	ZDBDialogUtil.focusDialog.orientfn();
	     }
        }
        
        this.getComputedScrollTop = function(modalDiv)
        {
            var dashRow = modalDiv.dashRow;
	    var dashDiv = modalDiv.dashDiv;
            var DashboardToolbar = $("DashboardToolbar");
            var toolBarHgt = 0;
            if(DashboardToolbar)
            {
                    toolBarHgt = DashboardToolbar.offsetHeight;
            }
            var availHgt = ZDBDashboardMobile.height + toolBarHgt;
            var dashRowPos = ZDBUtil.getObjTop(dashRow);
	          var scrollTopVal =  dashRowPos - ((availHgt - dashDiv.offsetHeight)/2);
            return scrollTopVal;
        }
	
	this.showModalDiv = function(event)
	  {
	      var srcEl = ZDBUtil.getSourceElement();
	      var dashRow = DOMUtils.getSelfOrParentWithAttrValue(srcEl,"isdashboardrowdiv","true");//NO I18N
	      var dashDiv = DOMUtils.getSelfOrParentWithAttrValue(srcEl,"isdashboarddiv","true");//NO I18N
	      if(!dashDiv || dashDiv.getAttribute("eltype")!="VIEW")
          {
	    	  return;
          }
          
	      var mainContent = DOMUtils.getSelfOrParentWithAttrValue(dashRow,"elname","mainContent");//NO I18N
	      
	      var modalDiv = (document.body.modalDiv) ? document.body.modalDiv : document.createElement("div");
	      if(!document.body.modalDiv)
	      {
	        modalDiv.style.backgroundColor = "black";
	        modalDiv.style.opacity = "0.4";
	        modalDiv.style.height = "100%";
	        modalDiv.style.width = "100%";
	        modalDiv.style.position = "absolute";
	        modalDiv.style.top = "0px";
	        modalDiv.style.left = "0px";
	        modalDiv.style.zIndex = "1000";
	        document.body.modalDiv = modalDiv;
	        mainContent.appendChild(modalDiv);
	      } 
	      modalDiv.style.display = "";
	      modalDiv.dashRow = dashRow;
	      modalDiv.dashDiv = dashDiv;
	      
              var computedScrollTop = ZDBDStructure.getComputedScrollTop(modalDiv);
	      jQuery(document.body).animate({scrollTop:computedScrollTop},"slow"); //No I18N
              
	      dashDiv.style.zIndex = "1100";
	      dashRow.style.zIndex = "1100";
	      ZDBUtil.detachEvent(dashRow, "touchstart", ZDBDStructure.touchStartEvent, true);
	      ZDBUtil.detachEvent(dashRow, "touchmove", ZDBDStructure.stopEventPropagation, true);
	  	  ZDBUtil.detachEvent(dashRow, "touchend", ZDBDStructure.touchEndEvent, true);
	      ZDBUtil.attachEvent(dashRow, "touchend",ZDBDStructure.checkNHideModalDiv,true);
	      ZDBUtil.attachEvent(modalDiv, "touchstart",ZDBDStructure.hideModalDiv,true);
	      
	      var view = ZDBClientUI.getViewObj(dashDiv.dlgBody, "view");
	      var viewType = view.type;
	      var isGridView = (viewType == "Table") || (viewType == "QueryTable") || (viewType == "Report") || (viewType == "Pivot") || (viewType == "SummaryView");//No I18N
	      if(isGridView)
          {
	    	  view = (viewType == "Pivot" || viewType == "SummaryView") ? view.gridObj : view;//No I18N
	    	  if(!view.scroller && !view.scrollDisabled)
	          {
	    		  var opts = {"V_SCROLL_ELS" : [view.rhArea], "H_SCROLL_ELS" : [view.chArea,view.fArea1],
	                      "ONSCROLLDOWN_LAZYLOAD" : function(){ZDBGridScroll.addRowsToGrid(view,false,false,ZDBCallBack.dummyCallBack);},  //No I18N
	                      "ONSCROLLUP_LAZYLOAD" : function(){ZDBGridScroll.addRowsToGrid(view,true,false,ZDBCallBack.dummyCallBack)},  //No I18N
	                      "ONSCROLL_START" : function(){ZDBGridScroll.showRowNavigComp(view);ZDBGridScroll.positionIpadNavComp(view);view.clearScrollTimeout();}, //No I18N
	                     // "ONTOUCH_START" : function(){},	//No I18N
	                      "ONSCROLL_STOPS" : function(){ZDBGridScroll.positionIpadNavComp(view,true);}}; //No I18N
	    		  view.scroller = new ZRScroller(view.dArea,opts);
	              ZDBGridScroll.positionIpadNavComp(view);
                view.setRowNavigComp(false);
	              view.finalAdjustments();
	          }
          else
            ZDBGridScroll.showRowNavigComp(view);
	    	  view.scroller.disableScrollInDash = false;
          }
          
	      ZDBUtil.stopEventBubble();
	  } 
	  
	  this.hideModalDiv = function(event)
	  {
	      var modalDiv = document.body.modalDiv;
	      var dashRow = modalDiv.dashRow;
	      var dashDiv = modalDiv.dashDiv;
	      modalDiv.style.display = "none";
	      dashDiv.style.zIndex = "";
	      dashRow.style.zIndex = "";
	      var view = ZDBClientUI.getViewObj(dashDiv.dlgBody, "view");
	      if(view.scroller)
	      {
	    	  view.scroller.disableScrollInDash = true;
	      }
	      ZDBUtil.detachEvent(dashRow, "touchend",ZDBDStructure.checkNHideModalDiv,true);
	      ZDBUtil.detachEvent(modalDiv, "touchstart",ZDBDStructure.hideModalDiv,true);
	      ZDBUtil.attachEvent(dashRow, "touchstart", ZDBDStructure.touchStartEvent, true);
	      ZDBUtil.attachEvent(dashRow, "touchmove", ZDBDStructure.stopEventPropagation, true);
      	  ZDBUtil.attachEvent(dashRow, "touchend", ZDBDStructure.touchEndEvent, true);
          delete(modalDiv.dashRow);
          delete(modalDiv.dashDiv);
          $ZC.documentTapEvent();
      	  ZRSMenu.closeAllMenu();
      	  event.stopPropagation();
	  }
	
  this.updateStructInfo = function(view,isViewModified,dontRemoveEmpty, toQ, isDashGlobalFiltersApplied)
  {
    view = ZDBClientUI.selectedTab.view;
    var dashChilds = [];
    view.dashChilds = dashChilds;
    var dashDiv = view.dashDiv;
    dashDiv.isDashDiv = true;
    ZDBUtil.removeNonElements(dashDiv);
    var childNodes = dashDiv.childNodes;
    dashDiv.dashRows = [];
    var emptyRows= [];
    ZDBDashboardAPI.showInstructionIfNeeded(view);
    var childCount = 0;
    var totalMultiColors = ZDBDThemes.getMultiColorCount(view.theme);
    if(toQ){
    	view.dashQ.reset();
    }
    var gridCount = 0;
    for(var r=0,len = childNodes.length; r < len;r++)
    {
      if(childNodes[r].getAttribute("isDashboardRowDIV") !== "true")
      {
        continue;
      }
      var dashRow = childNodes[r];
      var tr = jQuery(dashRow).find(".table-row")[0];
      ZDBUtil.removeNonElements(tr);
      dashRow.tr = tr;
      var cols = tr.childNodes;
      var rowEmpty = true;
      for(var c=0,cLen= cols.length; c < cLen; c++)
      {
        var curCol = cols[c];
        ZDBUtil.removeNonElements(curCol);
        var colChilds = curCol.childNodes;
        if(colChilds.length > 0)
        {
          for(var ir=0,irLen = colChilds.length; ir < irLen;ir++)
          {
            var dashChild= colChilds[ir];
            dashChild.isDashChild = true;
            if(dashChild.getAttribute("isUFElement")==="true")
            {
              dashChild.isUFEl = true;
              curCol.isUFEL = true;
            }
            else if(BROWSER.IS_MOBILE_PHONE)
            {
            	ZDBUtil.attachEvent(dashRow, "touchstart", ZDBDStructure.touchStartEvent, true);
            	ZDBUtil.attachEvent(dashRow, "touchmove", ZDBDStructure.stopEventPropagation, true);
            	ZDBUtil.attachEvent(dashRow, "touchend", ZDBDStructure.touchEndEvent, true);
            }
            dashChilds.push(dashChild);
            var isView = dashChild.getAttribute('eltype') === 'VIEW';//NO I18N
            if(isView) {
                ZDBUtil.setNamedChildEls(dashChild,dashChild);
                var isValidFilterCriteria = dashChild.getAttribute("isValidFilterCriteria");
                var isViewSharedForSharedUser = dashChild.getAttribute("isViewShared");
                if (toQ && isValidFilterCriteria != "false" && isViewSharedForSharedUser != "false") {
                    if(dashChild.getAttribute("excludeDashGlobalFilters") != "true" || !isDashGlobalFiltersApplied)
                    {
                    	var viewType = parseInt(dashChild.getAttribute('viewTypeVal'));
                    	if(viewType ==  ZDBClientViewAPI.TYPE_PIVOT || viewType == ZDBClientViewAPI.TYPE_SUMMARY || viewType == ZDBClientViewAPI.TYPE_TABLE || viewType == ZDBClientViewAPI.TYPE_QUERYTABLE || viewType == ZDBClientViewAPI.TYPE_REPORT)
                    	{                	
                    		if(dashChild.view || (dashChild.ctx && dashChild.ctx.view))
                    		{
                    			var childView = dashChild.view || dashChild.ctx.view;
                    			childView = childView.gridObj ? childView.gridObj : childView;
                    			if(childView.gArea && childView.gArea.parentNode)
                    			{
                    				childView.gArea.gridObj.viewCtx.getLoadIndicator().className = "zdbLoading";//No I18N
                    				childView.gArea.parentNode.removeChild(childView.gArea);
                    				if(view.gridRender)
                    				{
                    				delete view.gridRender;
                    				}
                    			}
                    			gridCount++;
                    		}
                    	}
                    	view.dashQ.push({func: ZDBDashboardAPI.fetchCurChildView, args: [dashChild, view], viewType: viewType});
                    }
                }
                dashChild.setAttribute('themeMultiColorType', childCount % totalMultiColors);
                childCount++;
            } else {
                ZDBDashboardAPI.updateDashChild(dashChild, view);
          } 
            }     
          rowEmpty = false;
        }
        curCol.isDashCol = true;
        dashChilds.push(curCol);
      }

      if(rowEmpty && (!dontRemoveEmpty))
      {
        emptyRows.push(dashRow);
      }
      else
      {
        dashRow.isDashRow = true;
        dashChilds.push(dashRow);
        dashDiv.dashRows.push(dashRow);
      }
    }
    if(gridCount > 0)
    	{
    	ZDBReportDashUtil.maintainReportCount(view,gridCount);
    	}
    for(var i=0,len = emptyRows.length;i <len;i++)
    {
      var cols = emptyRows[i].tr.childNodes;
      for(var j=0,cLen= cols.length;j < cLen;j++)
      {
        ZDBUtil.removeFromSet(dashChilds,cols[j]);
      }
      emptyRows[i].parentNode.removeChild(emptyRows[i]);
    }
    ZDBDashboardAPI.modeHelper.structureChanged(view);
    if(isViewModified)
    {
      ZDBDPlacer.cleanDashboard(view);
      view.setModified();
    }
  }

this.getDashViewConfig = function(view)
{
    var childNodes = view.dashDiv.childNodes;
    var rowCount = 0;
    var xml= "";
    var isEmpty=true;       
    var dashDivWidth = view.dashDiv.clientWidth;
    for(r=0,rowLen = childNodes.length;r< rowLen;r++)
    {
      if(childNodes[r].tr == null)
      {
        continue;
      }
      rowCount++;
      var cols = childNodes[r].tr.childNodes;
      xml+="\n\t<ZDBDashboardRow columns='"+cols.length+"'>"; //No I18N
      var colLengths = this.validateColLength(cols,dashDivWidth);
      for(var c=0,cLen = cols.length;c < cLen; c++)
      {
        var dashChilds = cols[c].childNodes;
        var colWidth = colLengths[c];
        xml += "\n\t\t<ZDBDashboardColumn views='"+dashChilds.length+"' colwidth='"+colWidth/dashDivWidth+"'>";    //No I18N
        var innerColIdx = 0;
        for(var ir =0, irLen = dashChilds.length;ir < irLen;ir++)
        {
            isEmpty = false;
            if(dashChilds[ir].innerColIdx !== 1)
            	{
            		innerColIdx = 0;
                }
            xml += this.getRowConfig(dashChilds[ir],view,innerColIdx,colWidth);
            innerColIdx++;
        }
        xml+="\n\t\t</ZDBDashboardColumn>";   //No I18N
      }
      xml+="\n\t</ZDBDashboardRow>";  //No I18N
    }
    xml += ZDBDThemes.getConfig(view);
    view.rowCount = rowCount;
    return isEmpty ? null : xml;
}
  
this.validateColLength =  function(cols,dashDivWidth)
{
    if(cols.length === 1)
        {
            return [dashDivWidth];
        }
    var minWidth,maxWidth,firstCol,secondCol,firstSegWidth,secondSegWidth;
    minWidth = dashDivWidth * 0.25;
    maxWidth = dashDivWidth * 0.75;
    firstCol = cols[0];
    secondCol = cols[1];
    firstSegWidth = firstCol.offsetWidth;
    secondSegWidth = secondCol.offsetWidth;
    if(firstSegWidth < minWidth)//not necessary handled in resize
        {
            firstSegWidth = minWidth;
        }
    else if(firstSegWidth > maxWidth)
        {
            firstSegWidth =  maxWidth;
        }
    secondSegWidth = (firstCol.childNodes.length === 0 && secondSegWidth > minWidth && secondSegWidth < maxWidth)?secondSegWidth:dashDivWidth - firstSegWidth;
    return [firstSegWidth,secondSegWidth];
}

  this.genConfig = function(view)
  {
     var sendCompleteInfo = (view.permissions.designModify == 1 && ZDBUtil.isViewModified(view));
    return  ZDBDStructure.getDashBoardCurrentConfig(view,false,sendCompleteInfo);
  }
  
  this.getDashBoardCurrentConfig = function(view,sendDynFltrConfig,sendCompConf)//,comp,sendUFConfig)
  {
    sendCompConf = (sendCompConf)?true:false;
    var sendCompleteInfo = (view.permissions.designModify == 1 && ZDBUtil.isViewModified(view))|| sendCompConf;
    var dashViewDet = sendCompleteInfo? ZDBDStructure.getDashViewConfig(view) :"";
      var xml = "<ZDBDashboard rows='"+view.rowCount+"' viewConf='"+sendCompleteInfo+"'"   //No I18N
        + " csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>"   //No I18N
       + dashViewDet +"\n"+ ZDBDashboardUF.getDashBoardDynFltrConfig(view,sendCompleteInfo,sendDynFltrConfig)+//No I18N
        "\n</ZDBDashboard>";   //No I18N

        return xml;
  }


  this.getRowConfig = function(dashChildEl,view,colIdx,colWidth)
  {
      var attrs = ["objid","eltype","showtitle", //No I18N
                   "desc","showVMfilter","excludeDashGlobalFilters","tlColumnMapping","sbox","expenable","vud"];// No I18N
      var configMap={};
      for(var i=0,len=attrs.length;i<len;i++)
      {
        configMap[attrs[i]] = dashChildEl.getAttribute(attrs[i]);
      }
      var dashDiv = view.dashDiv;
      var dashDivWidth = dashDiv.clientWidth;
      //ie9 haslayout=true to get clientWidth
      var disp = view.vmfEditModeHeader.style.display;
      var isUF = configMap.eltype==="USERFILTERS";//NO I18N
      var columnPadding = (view.editMode)?2*0.0066*dashDivWidth : 0.0099 * dashDivWidth;
      var maxInnerColWidth = (colWidth - (columnPadding + 2));
      view.vmfEditModeHeader.style.display = "";
      view.vmfEditModeHeader.style.display = disp;
      //for ie9 haslayout
      var innerColWidth =  (dashChildEl.offsetWidth + (view.theme.getMargin() * 2));
      configMap.innercolwidth = innerColWidth/dashDivWidth;
      configMap.objheight = dashChildEl.dlgBody.offsetHeight/innerColWidth;
      configMap.objheight = isNaN(configMap.objheight)?0:configMap.objheight;
      configMap.lp = ZDBDStructure.getLegendPos(dashChildEl);
      configMap.innercolspan = colIdx || 0;
      var elType = dashChildEl.getAttribute("eltype");
      if(elType == "HTML")
      {
        configMap["text"] = dashChildEl.dlgBody.innerHTML;
      }
      var xml = "";
      if(!isUF)
      {
          var objView = ZDBClientUI.getViewObj(dashChildEl, "view");//No I18N
          if(objView.type === 'WIDGET')
          {
        	  objView.objId = (view.isSaveAs)?ZDBClientUI.curDummyViewId--:objView.objId;
              if(ZDBUtil.isViewModified(objView))
              {
                xml = WidgetUtils.getConfig(objView.objId,objView);
                view.widgetIdMap[""+objView.objId] = dashChildEl;
                configMap.objid = objView.objId;
                configMap.widgetcinfo = true;
              }
              var dashChildEl_offsetWidth = dashChildEl.offsetWidth + (view.theme.getMargin() * 2);
              configMap.innercolwidth = ((dashChildEl_offsetWidth > maxInnerColWidth)?maxInnerColWidth:dashChildEl_offsetWidth) / dashDivWidth;
              configMap.pvid = objView.parentViewId;
              configMap.widget = true;
          }
      } else {
        configMap.objheight = (isNaN(configMap.objheight)) ? 0 : configMap.objheight;
      }
      return "\n\t\t\t<ZDBDashboardInnerView "    //No I18N
      +ZDBEscapeUtil.genXMLAttrs(configMap,true) +">"+xml+"</ZDBDashboardInnerView>\n";    //No I18N
  }

  this.getLegendPos = function(dashChild)
  {
     var childView = dashChild.ctx ? dashChild.ctx.view : null;
//     var isMapChart = childView.graphSelected.match(/^(MAPSCATTER|MAPBUBBLE|MAPAREA|MAPPIE|MAPPIEBUBBLE)$/);
     var lgSupported  = ((childView != null) && (childView.supportsLegend) && (childView.supportsLegend()) && !(childView.graphSelected.match(/^(MAPSCATTER|MAPBUBBLE|MAPAREA|MAPPIE|MAPPIEBUBBLE)$/)));
     if(lgSupported)
     {
	  var lgPos = dashChild.getAttribute("lp");
	  if((lgPos== null) || (lgPos == ""))
	  {
            lgPos=childView.legendPos;
	  }
	  if(lgPos == "RIGHT"){lgPos="DEF";}
	  return lgPos;
      }
      return null;
  }
}
