//$Id$

var ZDBDashboardUF = new function()
{

    this.getDashBoardDynFltrConfig = function(view,sendCompleteInfo,sendDynFltrConfig)//,comp,sendUFConfig)
    {
        var xmlBuf = new ZDBStrBuf();
        xmlBuf.sTag("zadata")//No I18N
        .attr("csrftoken",(getCookie("CSRF_TOKEN")))//No I18N
        .a(">\n<dbobj ");//No I18N
        xmlBuf.attr(" dispname",view.displayName); // NO I18N
        xmlBuf.attr("desc",view.description)//No I18N
        .a(">\n"); //NO I18N
        xmlBuf.a("<dcdet") //NO I18N
        .attr("cinfo",sendCompleteInfo) // NO I18N
        .a(">\n"); // NO I18N
        if(sendCompleteInfo)
        {
            ZDBDashboardUF.getVMFilterConfig(xmlBuf,view.VMFiltersList);
            ZDBDashboardUF.getTimelineConfig(xmlBuf,view);
        }
        xmlBuf.eNTag("dcdet");//No I18N

        if(sendDynFltrConfig)
        {
            ZAVMFilter.getAllVMFilterCriteria(view,xmlBuf);
        }
        xmlBuf.eNTag("dbobj");//No I18N
        xmlBuf.eNTag("zadata");//No I18N
        return xmlBuf.toString();
    }
    this.getVMFilterConfig = function(xmlBuf,vmfList)
    {
        ZDBAnalysisConfig.getXMLRowForVMFilterConfig(vmfList,xmlBuf,
            ZDBAnalysisConfig.VMFILTERPARAMS,
            ZDBAnalysisConfig.VMFILTERXMLPARAMS,"zavmf");//No I18N
    }
    this.getTimelineConfig = function(xmlBuf,view)
    {
        var comp = view.timelineComp;
        if(!view.timeLineCompEnabled)
          {
            return;
          }
        ZDBAnalysisConfig.getRow(comp,xmlBuf,ZDBAnalysisConfig.ZRTLPARAMS,ZDBAnalysisConfig.ZRTLXMLPARAMS,"zrtl"); //NO I18N
    }

    this.getDashDynFltrConfig = function(viewCtx)
    {
    	var dashView = viewCtx.dashView;
    	if(dashView.dashLayout && viewCtx.dashChildDiv.$node.properties.excludeDashUF == "1"){
    		return ""
    	}
    	if(viewCtx.dashChildDiv.getAttribute("excludeDashGlobalFilters") == "true")
    	{
    		return "";
    	}
        var xmlBuf = new ZDBStrBuf();                    
          var sendCompleteInfo = (dashView.permissions.designModify == 1&& ZDBUtil.isViewModified(dashView))
          if(sendCompleteInfo)
          {
              ZDBDashboardUF.getVMFilterConfig(xmlBuf,dashView.VMFiltersList);
              ZDBDashboardUF.getTimelineConfig(xmlBuf,dashView);
          }
          ZAVMFilter.getAllVMFilterCriteria(dashView,xmlBuf);        
        xmlBuf.a(ZRTimelineFilter.getAllTimelineFilterCr(dashView, viewCtx));
        return xmlBuf.toString();

    }



    this.showTableListHTML = function(response,requestOptions)
    {
//        ZDBContentCache.appendAndGet("Filter_List_User","GridMenu",document.body);
        var view = requestOptions["VIEW"]; //No I18N
        var div = document.createElement("div");
        div.innerHTML = response.getOnlyHtml();
        div.view = view;
        ZDBUtil.setNamedChildEls(div,view,"analysisel");
        document.body.appendChild(div);
        ZDBAnalysisCaching.cacheDashFieldsNavPanel(view.type);
        ZDBDashboardUF.setVMFilterPosition(view);
        ZDBDashboardUF.updateAddedFields(view);
        ZDBUtil.attachEvent(document,'keydown',ZDBDashboardUF.checkKeyNClose,true);
        ZDBDashboardUF.constructDashUFFields(view);
    }
    
    this.constructDashUFFields = function(view)
    {
    	var parentViewId = ZDBDashboardUF.getViewsWithUniqueParentViewId(view);
        ZDBDashboardUF.checkNSendDashFieldsRequest(view, parentViewId, null, null, null);
    }
    
    this.getViewsWithUniqueParentViewId = function(view, isUniqueValReq)
    {
    	var dashViews = ZDBDashboardAPI.viewsInDashboard(view);
    	var parentViewIdArr = [];
    	var viewId = (dashViews[0].getAttribute("parentViewId") != "null" && dashViews[0].getAttribute("parentViewId") != "") ? dashViews[0].getAttribute("parentViewId") : dashViews[0].getAttribute("objId");//NO I18N
    	parentViewIdArr.push(viewId);
    	var addViewToArray;
        for(var i=1; i<dashViews.length; i++)
        {
        	addViewToArray = true;
        	viewId = (dashViews[i].getAttribute("parentViewId") != "null" && dashViews[i].getAttribute("parentViewId") != "") ? dashViews[i].getAttribute("parentViewId") : dashViews[i].getAttribute("objId");//NO I18N
        	if(isUniqueValReq && parentViewIdArr.indexOf(viewId) >=0)
        	{
        		addViewToArray = false;
        	}
        	if(addViewToArray)
        	{
        		parentViewIdArr.push(viewId);
        	}
        }
        return parentViewIdArr.join();
    }
// for new dashboard layout $#Dash#$
//    this.getViewsWithUniqueParentViewId_new = function(dashboard, isUniqueValReq){
//    	var views = ZRDashboardLayoutAPI.viewsInDashboard(dashboard);
//    	var parentViewId = [];
//    	for(var i=0, j=views.length; i<j; i++){
//    		var view = views[i];
//    		var _parentId = view.parentViewId == null ? view.objId : view.parentViewId;
//    		if((isUniqueValReq && parentViewId.indexOf(_parentId) < 0) || !isUniqueValReq){
//    			parentViewId.push(_parentId);
//    		}
//    	}
//    	return parentViewId.join();
//    }
    
    this.checkNSendDashFieldsRequest = function(view, parentViewId, updateFields, updateTimeline, tholdProp)
    {
    	var dbId = view.dbId;
    	var jsonData = ZDBAnalysisCaching.tblColInfo.data;
		var parentViewArr = parentViewId.split(",");
		var parentViewIdSendReq = "";
		var jsonCached, i;
		var ZDBFieldsIterationTable = $("ZDBFieldsIterationTable");
        var navFieldLoader;
        var toUpdateNavFields = false;
        if(ZDBFieldsIterationTable)
        {
        	navFieldLoader = DOMUtils.getFirstMatchingChild(ZDBFieldsIterationTable, "div", "elname","filterLoading");//NO I18N
        	toUpdateNavFields = true;
        }
        if(updateFields !== null) {
            toUpdateNavFields = updateFields;
        }
        var toUpdateTimeline = (updateTimeline === null) ? true : updateTimeline;
    	for(i=0; i<parentViewArr.length; i++)
    	{
    		jsonCached = ZDBClientUtil.getJsonRelModelIdForObjId(parentViewArr[i]);
			if(!jsonCached)
			{
				parentViewIdSendReq = parentViewIdSendReq + ((parentViewIdSendReq == "") ? "" : ",") + parentViewArr[i];
			}
		}
		if(parentViewIdSendReq == "")
		{
			if(toUpdateNavFields)
			{
				ZDBDashboardUF.designClientFromJSON(view, jsonData);
			}
			return;
    	}
        ZDBDashboardUF.sendGetDBDetailsRequest(dbId,parentViewIdSendReq, "ZDBDashboardUF.handleJSONDataResp",view,navFieldLoader,toUpdateNavFields, toUpdateTimeline, tholdProp);//No I18N

    }
    
    this.sendGetDBDetailsRequest = function(dbId,parentViewIdSendReq,onSuccFunc,view,navFieldLoader,toUpdateNavFields, toUpdateTimeline, tholdProp){
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBGetDBDetAsJSON.ma?DBID="+dbId+"&PARENTVIEWID="+parentViewIdSendReq+"&ZDBACTION="+"GETDBDETAILSASJSON",                            
            ONSUCCESSFUNC:onSuccFunc,
            VIEW:view,
            OPSTATUSID : navFieldLoader,
            TOUDPATENAVFIELDS:toUpdateNavFields,
            UDPATETIMELINE:toUpdateTimeline,
            THOLDOBJ:tholdProp});
    }   
    this.updateJSONTableInfo =function(jsonResp)
    {
        var relCount = ZDBAnalysisCaching.tblColInfo.relCount;
        var relKey;
		
		for(var tblKeys in jsonResp)
		{
			relKey = "r"+relCount;//NO I18N
			ZDBAnalysisCaching.tblColInfo.data[relKey] = jsonResp[tblKeys];
			ZDBAnalysisCaching.tblColInfo.relModelInfo[relKey] = Object.keys(jsonResp[tblKeys].tableDet);
			ZDBAnalysisCaching.tblColInfo.relCount = ++relCount;
		}
    }   
    this.handleJSONDataResp = function(response, requestOptions)
    {
    	if(!ZDBLazyLoadUtil.loadJsAlone(["ZAAnalysisFields"],"APPENDTODOC",ZDBDashboardUF.handleJSONDataResp,[response,requestOptions]))
        {
          return;
        }
    	var jsonResp = JSON.parse(response.responseText);
        var tholdObj = requestOptions["THOLDOBJ"];
    	var view = requestOptions["VIEW"];
                    ZDBDashboardUF.updateJSONTableInfo(jsonResp);
                    
	var jsonData = ZDBAnalysisCaching.tblColInfo.data;
		if(requestOptions["TOUDPATENAVFIELDS"])
                {
                    ZDBDashboardUF.designClientFromJSON(view, jsonData);
                }
		else if(requestOptions["UDPATETIMELINE"])
		{
                    ZRTimelineFilter.updateDateColsForThisView(view);
		}
                else if(tholdObj)
                {
                    tholdObj.handleTholdValues();
                }
    }
    this.designClientFromJSON = function(view, jsonData)
    {
    	var dashViews = ZDBDashboardAPI.viewsInDashboard(view);
    	var objIds = []; 
    	var sortedDashViews = ZDBDashboardUF.getDashViewsSortedForUF(view, dashViews);
    	var isJsonAvailable;
    	for(var i=0; i<sortedDashViews.length; i++)
        {
    		isJsonAvailable = false;
    		var viewDet = {};
    		viewDet.objId = sortedDashViews[i].getAttribute("objId");
    		viewDet.viewType = sortedDashViews[i].getAttribute("viewtype");
    		viewDet.parentViewId = sortedDashViews[i].getAttribute("parentViewId");
    		for(var relModelId in jsonData)
			{
				if(ZDBAnalysisCaching.tblColInfo.data[relModelId].tableDet[viewDet.parentViewId] || ZDBAnalysisCaching.tblColInfo.data[relModelId].tableDet[viewDet.objId])
				{
					isJsonAvailable = true;
					break;
				}
			}
			viewDet.relModelId = relModelId;
			if(isJsonAvailable)
        	{
				objIds.push(viewDet);
        	}
        }
    	var clientModel = new ZAFieldsAdapterModel(jsonData, view);//NO I18N
    	var clientView = new ZAFieldsView(clientModel);
    	if(!clientView){
    		return;
    	}
    	var clientController = new  ZAFieldsController(clientModel, clientView);
    	clientController.updateBaseTableForDashBoard(objIds);
    }

//for new dashboard layout $#Dash#$    
//    this.designClientFromJSON_new = function(dashboard, jsonData){
//    	var views = ZRDashboardLayoutAPI.viewsInDashboard(dashboard);
//    	var objIds = [];
//    	var sortedViews = ZDBDashboardUF.getDashViewsSortedForUF(views);
//    	var isJsonAvailable;
//    	for(var i=0, j=sortedViews.length; i<j; i++){
//    		var view = sortedViews[i]
//    		isJsonAvailable = false;
//    		var viewDet = {};
//    		viewDet.objId = view.objId;
//    		viewDet.viewType = view.type;
//    		viewDet.parentViewId= view.parentViewId;
//    		for(var relModelId in jsonData){
//    			if(ZDBAnalysisCaching.tblColInfo.data[relModelId].tableDet[viewDet.parentViewId] || ZDBAnalysisCaching.tblColInfo.data[relModelId].tableDet[viewDet.objId])
//				{
//					isJsonAvailable = true;
//					break;
//				}
//    		}
//    		viewDet.relModelId = relModelId;
//    		if(isJsonAvailable){
//    			objIds.push(viewDet);
//    		}
//    	}
//    	var clientModel = new ZAFieldsAdapterModel(jsonData, dashboard);
//    	var clientView = new ZAFieldsView(clientModel);
//    	if(!clientView){
//    		return;
//    	}
//    	var clientController = new  ZAFieldsController(clientModel, clientView);
//    	clientController.updateBaseTableForDashBoard(objIds);
//    }
    
    this.getDashViewsSortedForUF = function(view, dashViews)
    {
    	var viewTypeArray = ["AnalysisView","Pivot","SummaryView", "WIDGET", "Table", "QueryTable", "Report"];//NO I18N
    	var sortedDashViews = [];
    	for(var i=0; i<viewTypeArray.length; i++)
    	{
    		var views = DOMUtils.filterElements(dashViews,"DIV","viewtype",viewTypeArray[i]);//NO I18N
    		sortedDashViews = sortedDashViews.concat(views);
    	}
    	return sortedDashViews;
    }
    
    this.getDashViewsSortedForUF_new = function(views)
    {
    	var _srt = {
			AnalysisView : [],
			Pivot : [],
			SummaryView : [],
			WIDGET : [],
			Table : [],
			QueryTable : [],
			Report : []
    	};
    	
    	for(var i=0, j=views.length; i<j; i++){
    		var view = views[i];
    		_srt[view.type].push(view);
    	}
    	return [].concat(_srt.AnalysisView,_srt.Pivot,_srt.SummaryView,_srt.WIDGET,_srt.Table,_srt.QueryTable,_srt.Report);
    }

    this.checkKeyNClose = function(event)
    {
        if(event == null)
        {
            event = window.event;
        }
        if(event.keyCode==27)
        {
            var btn = $("ZDBDashFieldsListCloseBtn");
            ZDBDashboardUF.closeDashFieldsList(btn);
        }
    }

    this.quickAddOrRemoveUF = function(el)
    {
        var view = ZDBClientUI.getViewObj(el,"view");
        var field = DOMUtils.getParentWithAttr(el,"column_id");
        var dropArea = view.VMFilterDropArea;
        if(field==null){
            return;
        }
        //If already field present and only one field. then removing.
        var matchedFieldsInList = ZDBDashboardUF.matchedFieldsInList(field,view);
        if(matchedFieldsInList!=false)
        {
            var fieldCount = matchedFieldsInList.length;
            if(fieldCount>1)
            {
                ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.analysis.js.duplicateFieldEntry",fieldCount));
                el.className = "ZDBDNDFieldChecked";
                return;
            }
            ZAVMFilter.removeComponent(matchedFieldsInList[0]); //removes only when one field is matched
            el.className = "ZDBDNDFieldUncheck";
            return;
        }
        //If no field dropped yet, then dropping
        ZAVMFilterEdit.dropField(field,dropArea);
    }

    this.matchedFieldsInList = function(el,view)//return false else return fieldexist count in the view (Note: Filter fields not include)
    {
        var field = el;
        var fieldCount = 0;
        var matchedFieldsInList = new Array();
        view = ZDBClientUI.getViewObj(el,"view");
        if(field.getAttribute("column_id") == null)
        {
            field = DOMUtils.getParentWithAttr(field,"column_id");
        }
        var no_droppedFields = view.VMFiltersList.length;

        if(no_droppedFields<1)
        {
            return false;
        }

        for(var i=0; i<no_droppedFields; i++)
        {
            var fieldExist = (field.getAttribute("column_id")==view.VMFiltersList[i].getAttribute("column_id"));
            if(fieldExist==true && !(view.VMFiltersList[i].getAttribute("VIEWTYPE")=="FILTERAXIS"))
            {
                matchedFieldsInList[fieldCount] = view.VMFiltersList[i];
                fieldCount++
            }
        }

        return (fieldCount>0)?matchedFieldsInList:false;
    }

    this.updateAddedFields = function(view)//dashboard Left panel list status will be updated.
    {
        var fieldHolder = $("ZDBFieldsIterationTable");
        //When list is not openined, fieldholder will be undefined. Below code Will be updated while opening the list.
        if(!fieldHolder)
        {
          return;
        }
        var fieldList = fieldHolder.getElementsByTagName("DIV");
        var no_droppedFields = view.VMFiltersList.length;
        var no_fields = fieldList.length;
        var className = "";
            DROPLISTFOR: for(var i=0; i<no_fields; i++)
            {
                var curFieldListEl = fieldList[i];

                if(curFieldListEl.getAttribute("column_id") == null || curFieldListEl.getAttribute("column_id") == ""){
                    continue;
                }
                className = "ZDBDNDFieldUncheck"; //No I18N
                ZDBUtil.setNamedChildEls(curFieldListEl,curFieldListEl);
                for(var j=0; j<no_droppedFields; j++)
                {
                    if((curFieldListEl.getAttribute("column_id")==view.VMFiltersList[j].getAttribute("column_id"))  //No I18N
                        && !(view.VMFiltersList[j].getAttribute("VIEWTYPE")=="FILTERAXIS"))//No I18N
                        {
                        className="ZDBDNDFieldChecked"; //No I18N
                        continue;
                    }
                }
                if(curFieldListEl.fieldTitle)
                {
                    curFieldListEl.fieldTitle.style.fontWeight = (className=="ZDBDNDFieldChecked")?"bold":"normal"; //No I18N
                }
                curFieldListEl.checkMark.className = className;
            }

    }

    this.setVMFilterPosition = function(view)
    {
        //It shows the fields, droparea and modal div behind that
        var dashFields = $("ZDBDashFields");//This is a static content for all the views.
        dashFields.style.top = ZDBUtil.getObjTop($("ZDBMAINEL"))+"px";
        dashFields.style.left = "0px";
        ZDBDashboardUF.setdashFieldsDimension();
        dashFields.style.display = "";
        var dashboardVMFilterFields = view.VMFilterFields;
        var VMFilterDropArea = view.VMFilterDropArea;
        var dummy = dashboardVMFilterFields.cloneNode(true);
        dashboardVMFilterFields.dummy = dummy;
        var orgParent = dashboardVMFilterFields.parentNode;
        var coordinates = jQuery(dashboardVMFilterFields).offset();
        dashboardVMFilterFields.style.width = (jQuery(dashboardVMFilterFields).width())+"px";
        document.body.appendChild(dashboardVMFilterFields);
        VMFilterDropArea.className = "VMFilterDropAreaInBody";
        VMFilterDropArea.parentNode.className = "VMFilterDropAreaHolderInBody";
        dashboardVMFilterFields.view = view;
        dashboardVMFilterFields.style.position = "absolute";
        dashboardVMFilterFields.style.left = coordinates.left+"px";
        dashboardVMFilterFields.style.top = coordinates.top+"px";
        dashboardVMFilterFields.style.zIndex = "98";
        orgParent.appendChild(dummy);
        dummy.style.visibility = "hidden";
        //$#Dash#$ view.showModalDiv(); 
        //$#Dash#$ var modalDiv = view.ModalDiv;
        /*$#Dash#$ Comment For New Layout*/
        view.viewCtx.showModalDiv(view,"alpha"); //No I18N
        var modalDiv = view.viewCtx.resizeModalDiv;
        /*$#Dash#$ Comment For New Layout*/
        modalDiv.onclick = function(){
            ZDBDashboardUF.resetVMFilterPosition(view);
        }
    }

    this.setdashFieldsDimension = function()
    {
        var dashFields = $("ZDBDashFields");
        var baseHeight = $("ZDBMAINEL").offsetHeight;
        var fieldsHolder = DOMUtils.getFirstMatchingChild(dashFields , "DIV","zaFieldsScroll","true"); //No I18N
        var top = ZDBUtil.getObjTop(fieldsHolder,true,dashFields);
        var fieldsHolderHeight = (baseHeight - top)-20;
        fieldsHolder.style.height = fieldsHolderHeight+"px";
    }

    this.closeDashFieldsList = function(el)
    {
        var view = ZDBClientUI.getViewObj(el,"view");
        ZDBDashboardUF.resetVMFilterPosition(view);
    }

    this.resetVMFilterPosition = function(view)
    {
        var dashboardVMFilterFields = view.VMFilterFields;
        view.VMFilterFields.view = view;
        if(dashboardVMFilterFields.dummy==null){
            return;
        }
        var dashFields = $("ZDBDashFields");
        dashFields.style.display = "none";
        var VMFilterDropArea = view.VMFilterDropArea;
        var dummy = dashboardVMFilterFields.dummy;
        var orgParent = dummy.parentNode;
        orgParent.removeChild(dummy);
        dashboardVMFilterFields.dummy = null;
        orgParent.appendChild(dashboardVMFilterFields);
        VMFilterDropArea.className = "VMFilterDropAreaStyle";
        VMFilterDropArea.parentNode.className = "VMFilterDropAreaHolder";
        dashboardVMFilterFields.style.width = "";
        dashboardVMFilterFields.style.position = "";
        dashboardVMFilterFields.style.left = "";
        dashboardVMFilterFields.style.top = "";
        dashboardVMFilterFields.style.zIndex = "";
        var mainHolder = $("ZDBDashFields");
        mainHolder.parentNode.removeChild(mainHolder);
        //$#Dash#$ view.hideModalDiv(); 
        //$#Dash#$ var modalDiv = view.ModalDiv;
        /*$#Dash#$ Comment For New Layout*/
        view.viewCtx.hideModalDiv(view);
        var modalDiv = view.viewCtx.resizeModalDiv;
        /*$#Dash#$ Comment For New Layout*/
        modalDiv.onClick = null;
        ZDBUtil.detachEvent(document,'keydown',ZDBDashboardUF.checkKeyNClose,true);
    }

    this.refreshFields = function(parDiv , level,search)
    {
        var view = ZDBClientUI.getViewObj(parDiv,"view"); //No I18N
        var viewType = view.type;
        var layoutMode = $("ZR_MinMaxIcon").getAttribute("layoutMode");
        if(layoutMode != "normal")
        {
            ZDBNavigation.minMaxLayout($("ZR_MinMaxIcon"));
        }
        //$#Dash#$  if(ZRDashboardLayoutAPI.viewsInDashboard(view).length == 0)
        if(ZDBDashboardAPI.viewsInDashboard(view).length == 0)//$#Dash#$ comment for New Layout
        	{
        		return;
        	}
        if(ZDBAnalysisCaching.isFieldsListCached[viewType])
        {
            var div = document.createElement("div");
            div.appendChild(ZDBAnalysisCaching.getCachedNavPanel(viewType));
            div.view = view;
            ZDBUtil.setNamedChildEls(div,view,"analysisel");
            document.body.appendChild(div);
            ZDBDashboardUF.setVMFilterPosition(view);
            ZDBDashboardUF.updateAddedFields(view);
            ZDBUtil.attachEvent(document,'keydown',ZDBDashboardUF.checkKeyNClose,true);
            ZDBDashboardUF.constructDashUFFields(view);
        }
        else
        {
        	var params = "";
            if(ZDBGlobal.integrated)
            {
                params += "&INTEGRATIONMODE=true"; //No I18N
            }
            var holder = $("ZDBDashFields");

            params += "&DBID=" + view.dbId; //No I18N
            //      if(!ZDBUtil.isNewView(view))
            //      {
            params += "&OBJID=" + view.objId; //No I18N
//          }
          params += "&VIEWTYPE=" + viewType;//No I18N
          params += view.viewCtx.getAdditionalParams();
          var xml = ZDBDStructure.getDashBoardCurrentConfig(view,false);//$#Dash#$ Comment for New Layout
          //$#Dash#$ var xml ="";
            AjaxAPI.sendRequest({
                URL:ZDBGlobal.CTX + "/ZDBDashFields.cc?ZDBACTION=DASHFIELDS&"+params, //No I18N
                REQUESTHEADERS:{
                    "Content-type":"text/xml;charset=utf-8"//No I18N
                }, //No I18N
                POSTBODY:xml,
                ONSUCCESSFUNC:ZDBDashboardUF.showTableListHTML,
                FIELDDIV:parDiv,
                VIEW:view,
                OPSTATUSID:view.viewCtx.getLoadIndicator()
            });
        }
        
  }
 
 // makes to scroll the UF list dashnoard along with the dashboard
   this.checkNScrollUFList = function(el,event)
  {
     var curList = ZAVMFilterUtil.curList;
     if(curList && curList.style.display == "")
     {
       var component = curList.component;
        var view = ZDBClientUI.getViewObj(component,"view");//NO I18N
//        ZAVMFilter.setOptListTopNLeft(view,curList,component);
        ZAVMFilter.positionOptionList(curList,component.filterHead,view);
     }
     else
     {
      return;
     }
  }
 
}
