//$Id$
var ZDBDomainRebrand = new function()
{
  this.forgotPwdSuccess = function(response,requestOpt)
  {
    $("forgotPwdDiv").style.display = "none";
    $("forgotPwdConfDiv").style.display = "";
    $("ZDBErrorPanel").style.visibility = "hidden";
  }
  
  this.signInOrUpSuccess = function(response,requestOpt)
  {
    var resp = JSON.parse(response.responseText);
    if(resp.result == "success")
    {
       if(resp.AUTHTOKEN)
       {
         setCookie("authtoken", resp.AUTHTOKEN, null, "/");   //No I18N
         if(resp.ISMOBILEDEVICE!=null && resp.ISMOBILEDEVICE == "true"){
        	 location.reload();
             return;
         }
       }
       //var prefix = "/";//getCurProtoAndHostPrefix();
       if(window.serviceURLToForward.indexOf("?") < 0)
       {
          window.serviceURLToForward +="?";
       }
       var serverURL = window.location.protocol +"//"+ window.location.host;
       var reloadURL= "";
       if(resp.redirect_url){
         reloadURL= resp.redirect_url;
       }
       else{
         reloadURL= serverURL + "/oauthorize?zacode="+resp.ticket+"&state="+serverURL+"/ZDBHome.cc";   // No I18N
       }
       window.location.href = reloadURL;
       //window.location.href = reloadURL;
    }
    else if(resp.result == "failure")
    {
       if(resp.isExpired == "true")
       {
    	 var reloadURL = resp.reDirectUrl;
    	 window.location.href= reloadURL;
       }
       else if(resp.cause == "INVALID_CREDENTIALS")
       {
       		if(resp.showDigest == "true"){
                var iamDigestURL = $("ZDBIAMDigestURL").value; //No I18N
       			var digestURL = iamDigestURL + resp.digest;
                $("captchaImage").style.display = ""; //No I18N
                $("ZDBDigestImg").src = digestURL; //No I18N
                $("captchaValId").value = ""; //No I18N
                $("ZDBDigest").value = resp.digest; //No I18N
                ZDBUtil.setAttribute($("captchaValId"), "isNotEmpty", "validatemethod");
            }
		   ZDBDomainRebrand.showErrorMsg("Username and Password do not match");//No I18N
       }
       else
       {
         ZDBDomainRebrand.showErrorMsg(resp.cause);//No I18N
       }
    }
  }

  this.handleCaptchFailure = function(newDigest)
  {
    $("ZDBDigest").value = newDigest; //No I18N
    var iamDigestURL = $("ZDBIAMDigestURL").value; //No I18N
    $("ZDBDigestImg").src = iamDigestURL + newDigest; //No I18N
  }

  this.loginFailed = function(response,requestOpt)
  {
    var respMsg = response.getResponsePart("STATUS_MESSAGE");//No I18N
    ZDBDomainRebrand.showErrorMsg(respMsg);
    var newDigest = response.getResponsePart("DIGEST");
    var errorCode = response.getResponsePart("ERRORCODE");
    errorCode = errorCode.trim();
    if(newDigest != null)
    {
        if($("captchaValId")&&$("captchaImage")){
                $("captchaValId").value = "";
                $("captchaImage").style.display = ""; //No I18N
                ZDBUtil.setAttribute($("captchaValId"), "isNotEmpty", "validatemethod");
        }
      	ZDBDomainRebrand.handleCaptchFailure(newDigest.trim());
    }
  }

  this.showErrorMsg = function(msg)
  {
     if(msg.length < 100)
     {
      $("ZDBErrorPanel").innerHTML =  msg;//No I18N
      $("ZDBErrorPanel").style.visibility = "visible";
     }
     else
     {
      $("ZDBErrorPanel").style.visibility = "hidden";
      alert(msg);
     }
  }

  this.chngPwdSuccess = function()
  {
    ZDBDialogUtil.closeDialog();
    var message = ZDBI18NMap.g("zrpt.common.custdomain.js.pwd_updated");
    var title = ZDBI18NMap.g("zrpt.common.custdomain.js.chngpwd");
    ZDBAlertAPI.showMsg(message,null,null,title,null,null,"status"); //No I18N
  }

  this.chngPwdFailure = function(response,requestOpt)
  {
    var respMsg = response.getResponsePart("STATUS_MESSAGE");//No I18N
    ZDBAlertAPI.showErrorMsg(respMsg);
  }

  this.getUserFullName = function()
  {
	  var userFullNameObj = document.getElementById("ZDBUserFullName");
	  if(userFullNameObj){
		  return userFullNameObj.value;
	  }
  }

  this.getUserName = function()
  {
    var user = ZDBDomainRebrand.getUserFullName();
    return user ? "("+user+")" : "";
  }

  this.isPublicVisitor = function()
  {
    return ZDBDomainRebrand.getUserFullName() == "Public Visitor";  //No I18N
  }

  this.listAllDBs = function()
  {
    var dash = $("ZDBCustomDashboard");
    if(!dash) return;
    dash.style.display = "none";
    $("ZDBDomainHomePageDiv").style.display = "";
  }
  
  this.showPlaceHolder = function(el){
	  el = jQuery(el);
	  var placeHolderExist = el.attr("placeHolderExist");//No I18N
	  if(el.val() == "" && placeHolderExist == "false"){
		  var placeHolderValue = el.attr("placeHolderValue");//No I18N
		  placeHolderValue = placeHolderValue ? placeHolderValue : "";
		  el.val(placeHolderValue);
		  el.addClass("placeHolder");
		  el.attr("placeHolderExist","true");//No I18N
	  }
  }
  
  this.hidePlaceHolder = function(el){
	  el = jQuery(el);
	  var placeHolderExist = el.attr("placeHolderExist");//No I18N
	  if(placeHolderExist == "true"){
		  el.val("");
		  el.removeClass("placeHolder");
		  el.attr("placeHolderExist","false");//No I18N
	  }
  }
  
  this.checkFormValuesModified = function(frm){
	  var isModified = false;
	  var elems = jQuery(frm).find("[existvalue]");
	  elems.each(function(){
		 var curObj = jQuery(this);
		 var objectType = curObj.attr('type');//No I18N
		 var newVal;
		 var oldVal;
		 if(objectType && objectType == "checkbox"){
			 newVal = curObj.is(':checked');//No I18N
			 oldVal = JSON.parse(curObj.attr("existvalue"));//No I18N
		 } else{
			 newVal = curObj.val().trim();
			 oldVal = curObj.attr("existvalue").trim();//No I18N
		 }
		 if(newVal != oldVal){
			 isModified = true;
			 return;
		 }
	  });
	  return isModified;
  }
  
  this.modifyFormValuesModified = function(formName){
	  var elems = jQuery("form[name='"+formName+"']").find("[existvalue]");//No I18N
	  elems.each(function(){
		 var curObj = jQuery(this);
		 var objectType = curObj.attr('type');//No I18N
		 if(objectType && objectType == "checkbox"){
			 curObj.attr("existvalue", curObj.is(':checked'));//No I18N
		 } else if(objectType && objectType == "file" && curObj.attr("existvalue") == "removed"){//No I18N
			 curObj.attr("existvalue", "");//No I18N
		 } else{
			 curObj.attr("existvalue", curObj.val());//No I18N
		 }
	  });
  }
}

var ZDBCustomDomainValidator = new function(){
	this.checkValidDisplayName = function(value, allowblank){
		if(allowblank){
			return allowblank;
		}
		var displayNameRegex=/^[a-zA-Z0-9_ ]+$/i;
		if(displayNameRegex.test(value)){
			return true;
		}
		return false;
	}
	
	this.checkValidUserName = function(value, allowblank){
		if(allowblank){
			return allowblank;
		}
		var displayNameRegex=/^[a-zA-Z0-9_.]+$/i;
		if(displayNameRegex.test(value)){
			return true;
		}
		return false;
	}
}

/* isNeedUserName="true" */
window.addEventListener("load", function()
{
  var head = document.getElementById("ZDBHEADER");
  var dmAdminpage = document.getElementById("ZRDMContainer");
  if(!head) return;
  if(dmAdminpage) return;
  var els = head.getElementsByTagName("a");
  var usr = ZDBDomainRebrand.getUserName();
  for(var i=0; i<els.length; i++)
  {
    var el = els[i];
    var elVal = el.getAttribute("zdbname") || el.innerHTML;
    if(ZDBDomainRebrand.isPublicVisitor())
    {
      el.style.display = "none";
    }
    else if(el.getAttribute("isNeedUserName"))
    {
      el.innerHTML = el.innerHTML +" "+ usr;
      break;
    }
    else if(elVal.search(/home/i) ==0)
    {// select "Home" link
      el.href = "/ZDBHome.cc?home=true";
    }
  }
});

var CustomHomePage = new function() 
{
	this.fetchView = function(el, event) 
	{
		var parEl = DOMUtils.getParentWithAttrValue(el, "class", "customhome"); // No I18N
		var els = DOMUtils.getChildElsWithAttr(parEl, "class", "dm-link-sel"); // No I18N
		var oldSelEl;
		if (els && (oldSelEl = els[0])) {
			oldSelEl.className = oldSelEl.className.replace('dm-link-sel', '');
		}
		el.className = "dm-link-sel";
		ZDBClientUI.fetchViewEl(el, event);
		return false;
	};

	this.resizeCustomDashboardHeader = function() 
	{
		var custParEl = jQuery("div.customhome")[0];
		if (!custParEl || CustomHomePage.alreadyLoaded) {
			return;
		}

		this.tabHolderEl = jQuery(custParEl).children(".dm-home-tabholder")[0];

		var downArrow = (jQuery("div.dm-listarrow", this.tabHolderEl)[0]);
		downArrow.onclick = this.showHiddenViews;
		downArrow.style.visibility = "hidden";

		var allowedLimit = (jQuery("span.dm-topright-el")[0]).offsetLeft;		//Find el-left pos from window
		var tabEls = jQuery(this.tabHolderEl).children(	"div.dm-home-tab,div.dm-separator"); // No I18N
		var tabsWidth = 0;
		var flag = true;
		var prevViewEl = null;		//If last element has separator that will remove
		for ( var i = 0, len = tabEls.length; i < len; i++) 
		{
			var tabEl = tabEls[i];
			tabEl.style.display = "";
			var tabElWidth = tabEl.clientWidth + 20;
			if (flag && ((tabsWidth + tabElWidth) < allowedLimit &&
					(ZDBUtil.getObjLeft(tabEl)+tabElWidth) < allowedLimit) )
			{//tab location from window + tab width + 20   > view all rept
				tabsWidth += tabEl.clientWidth;
				prevViewEl = tabEl;
				continue;
			}
			else
			{
				if (prevViewEl && prevViewEl.className == "dm-separator")
				{
					prevViewEl.style.display = "none";
					prevViewEl = null;
				}
				flag = false;
				tabEl.style.display = "none";
				downArrow.style.visibility = "visible";
			}
		}
		document.onmouseup = function(e)
		{
			if(!e) e=window.event;
			var container = jQuery("div.dm-views-cont1"); // No I18N
			var target = e.target || e.srcElement;
			if (!container.is(target) // if the target of the click isn't the container...
					&& container.has(target).length === 0) // ... nor a descendant of the container
			{
				CustomHomePage.removeViewContainer();
			}
		};
		custParEl.style.visibility = "visible";
		this.removeViewContainer();
	};

	this.showHiddenViews = function()
	{
		var tabHolderEl = CustomHomePage.tabHolderEl;
		var hidTabEls = jQuery(tabHolderEl).children("div.dm-home-tab").not(":visible"); //Geting hiding tab els // No I18N
		var container = jQuery("div.dm-views-cont1 .dm-views-cont1-body")[0];
		if (hidTabEls.length < 0 || jQuery(container).is(":visible"))
		{
			return;
		}
		var left = ZDBUtil.getObjLeft(this);
		for ( var i = 0; i < hidTabEls.length; i++) 
		{
			var el = jQuery("div[objid]", hidTabEls[i])[0];
			var newEl = document.createElement("div");
			var anchEl = jQuery("a", el); // No I18N
			newEl.innerHTML = anchEl.html();
			newEl.setAttribute("objid", el.getAttribute("objid"));
			newEl.onclick = CustomHomePage.clickHiddenel;
			newEl.title = anchEl.attr("title"); // No I18N
			container.appendChild(newEl);
		}
		var parEl = container.parentElement;
		parEl.style.left = (left - 135) + "px";
		parEl.style.top = "30px";
		parEl.style.display = "block";
		CustomHomePage.container = parEl;

	};

	this.clickHiddenel = function(ev) {
		var objid = this.getAttribute("objid");
		var tabHolderEl = CustomHomePage.tabHolderEl;
		var visibleTabEl = jQuery(tabHolderEl).children("div.dm-home-tab").not( ":hidden").last()[0]; // No I18N
		var hidTabEls = jQuery(tabHolderEl).children("div.dm-home-tab").not( ":visible"); // No I18N
		var downArrow = jQuery("div.dm-listarrow", tabHolderEl)[0];
		var vAllRpt = ZDBUtil.getObjLeft(jQuery("span.dm-topright-el")[0]);
		CustomHomePage.alreadyLoaded = true;
		for ( var i = 0; i < hidTabEls.length; i++) {
			var origEl = jQuery("a", hidTabEls[i])[0];
			var origObjid = origEl.parentNode.getAttribute("objid");
			if (origObjid != objid) {
				continue;
			}
			CustomHomePage.fetchView(origEl, ev);
			visibleTabEl.style.display = "none";
			var hidEl = hidTabEls[i];
			hidEl.style.display = "";
			var arrowPos = ZDBUtil.getObjLeft(downArrow) + 20;
			if (arrowPos >= vAllRpt) 
      {
				hidEl.style.width = (hidEl.clientWidth - (arrowPos - vAllRpt)) + "px";
				hidEl.className += " dm-truncate"; // No I18N
				break;
			}
		}
		CustomHomePage.removeViewContainer();
	};

	this.removeViewContainer = function() {
		var hookEl = jQuery("div.dm-views-cont1 .dm-views-cont1-body")[0];
		if (!hookEl) {
			return;
		}
		//ZDBUtil.removeAllChildren(hookEl);
	    var childNodes = hookEl.childNodes;
	    for(var i=childNodes.length -1; i > -1; i--)
	    {
	      if(childNodes[i].tagName == "SPAN" || 
	    		  childNodes[i].className=="dm-views-cont1-body")
	      {
	        continue;
	      }
	      hookEl.removeChild(childNodes[i]);
	    }
		hookEl.parentNode.style.display = "none";
	};
};

var EnableDisableDB = new function()
{
  var CL = {};
  this.loadTbl = function()
  {
    var curObj = this;
    var tblEl = document.getElementById("dblist");
    if(!tblEl) return;
    var trs = tblEl.getElementsByTagName("tr");
    for(var i=1; i<trs.length; i++)
    {
      var tr = trs[i];
      ZDBUtil.setNamedChildEls(tr,tr);
      tr.stat.dbname = tr.dbname.textContent || tr.dbname.innerText;
      tr.stat.onclick = function()
      {
        CL.clickEl = this;
        var val = this.innerHTML == "Enable" ? "Disable" : "Enable";      //No I18N
        if(val == "Disable")
        {
          var c = confirm("Are you sure you want to Deactivate the database? "+           //No I18N
              "If deactivated, your client(s) will no longer have access to this database. Click OK to Deactivate."); //No I18N
          if(c == false)
          {
            return;
          }
        }
        var action = val == "Enable" ? "EnableDomainDB" : "DisableDomainDB";    //No I18N
        var params = "&ZDBACTION="+action+"&DBNAME="+encodeURIComponent(this.dbname)+"&ZDB_CSRF_TOKEN=" + getCookie("CSRF_TOKEN");//NO I18N
        var hidEl = $("iscustomdomain"); 
        if(hidEl.value == "false")
        {
          params += "&DOMAINNAME="+ hidEl.getAttribute("dmname");   //No I18N
        }
        AjaxAPI.sendRequest({
          URL : "/ZDBAdminActionMI.ma",   //No I18N
          PARAMETERS : params,   //No I18N
          ONSUCCESSFUNC:EnableDisableDB.handleSuccess,
          ONFAILUREFUNC:EnableDisableDB.handleFailure
        });
      };
    }
  }

  this.handleSuccess = function(resp, reqOpt)
  {
    var className = (CL.clickEl.innerHTML == "Enable") ? "Disable" : "Enable";    //No I18N
    CL.clickEl.innerHTML = className;
    CL.clickEl.className = className;
  }

  this.handleFailure = function(resp, reqOpt)
  {
    alert("Operation failed. Please try after some times.");    //No I18N
  }
}

var RebrandAdminDialog = new function()
{
	this.dmId = "";
	this.showDialog = function()
	{
		jQuery(window).resize(
	              function()
	              {
	            	  ZRDMClientUI.handleWindowResize();
	              }
	      );
		ZRDMClientUI.initSize();
		ZDBInlineDialog.changeTab($("ZRDMInformationTab"),"ZRControlPanelNav");//No I18N
	}
	
	this.attachEventListener = function()
	{
		var event=event||window.event;
		jQuery("div[elName='ZRDMSettingTab']").off("click");//No I18N
		jQuery("div[elName='ZRDMSettingTab']").on("click", function() {RebrandAdminDialog.changeTab(event,this)});//No I18N
		
		jQuery("div[elName='inlineTabEl']").off("click");//No I18N
		jQuery("div[elName='inlineTabEl']").on("click", function() {RebrandAdminDialog.switchSettingsTab(event,this)});//No I18N
		
		jQuery("div[elName='inlineAdminActionTabEl']").off("click");//No I18N
		jQuery("div[elName='inlineAdminActionTabEl']").on("click", function() {RebrandAdminDialog.changeAdminTab(event,this)});//No I18N
		
		jQuery("#ZRAddNewSSOIP").off("click");//No I18N
		jQuery("#ZRAddNewSSOIP").on("click", function() {RebrandAdminDialog.addNewIPEl(event,this)});//No I18N
		jQuery("span[elName='deleteIPEl']").off("click");//No I18N
		jQuery("span[elName='deleteIPEl']").on("click", function() {RebrandAdminDialog.deleteIP(this);});//No I18N
		
		jQuery("#ZRWhiteLabel").off("click");//No I18N
		jQuery("#ZRSSO").off("click");//No I18N
		jQuery("#ZRWhiteLabel").on("click", function() {RebrandAdminDialog.toggleDomainType(this)});//No I18N
		jQuery("#ZRSSO").on("click", function() {RebrandAdminDialog.toggleDomainType(this)});//No I18N
	    jQuery("#ZRSSO_SAML").off("click");//No I18N
		jQuery("#ZRSSO_SAML").on("click", function() {RebrandAdminDialog.toggleDomainType(this)});//No I18N
                
                
		jQuery("#DM_LAYOUT_ZIP").off("change");//No I18N
		jQuery("#DM_LAYOUT_ZIP").on("change", function() {RebrandAdminDialog.changeFileName(this,'ZRRebrandZIPFileName')});//No I18N
		
		jQuery("#ZRDMInformationSubmit").off("click");//No I18N
		jQuery("#ZRDMProductSubmit").off("click");//No I18N
		jQuery("#ZRDMInformationSubmit").on("click", function() {RebrandAdmin.submitForm(this.form, 'ADDANDUPDATEDM')});//No I18N
		jQuery("#ZRDMProductSubmit").on("click", function() {RebrandAdmin.submitForm(this.form, 'ADDANDUPDATEDMPROPANDFILE')});//No I18N
		
		jQuery("input[elname='fromip']").off({//No I18N
			blur: function(){IPAddressElementHandler.handleElOnBlur(this, true)}
		});
		jQuery("input[elname='toip']").off({//No I18N
			blur: function(){IPAddressElementHandler.handleToIPElOnBlur(this, true)}
		});
		jQuery("input[elname='fromip']").on({//No I18N
			blur: function(){IPAddressElementHandler.handleElOnBlur(this, true)}
		});
		jQuery("input[elname='toip']").on({//No I18N
			blur: function(){IPAddressElementHandler.handleToIPElOnBlur(this, true)}
		});
		
		jQuery("div[showToolTip='true']").off({//No I18N
			mouseover: function(){jQuery("span.QHelpIcon", this).show()},//No I18N
			mouseout: function(){jQuery("span.QHelpIcon", this).hide()}//No I18N
		});
		jQuery("div[showToolTip='true']").on({//No I18N
			mouseover: function(){jQuery("span.QHelpIcon", this).show()},//No I18N
			mouseout: function(){jQuery("span.QHelpIcon", this).hide()}//No I18N
		});
		
		jQuery("[name='HOMEPAGE_VIEWS_CONFIG_TOGGLE']").off("click");//No I18N
		jQuery("[name='HOMEPAGE_VIEWS_CONFIG_TOGGLE']").on("click", function() {HomePageSetting.toggleHPAndListDB(this)});//No I18N
		
		jQuery("#ZRAddNewUser").off("click");//No I18N
		jQuery("span[elName='deleteUserSignupEl']").off("click");//No I18N
		jQuery("#ZRAddNewUser").on("click", function() {DMMultiUserSignUp.showNewUserSignUp(event,this)});//No I18N
		jQuery("span[elName='deleteUserSignupEl']").on("click", function() {DMMultiUserSignUp.deleteUserSignUp(this);});//No I18N
		
		jQuery("div[elName='ZRAddNewDPIP']").off("click");//No I18N
		jQuery("span[elName='deleteDBIPEl']").off("click");//No I18N
		jQuery("div[elName='ZRAddNewDPIP']").on("click", function() {DMDBIPConfigSetting.toggleFromToDBIP(this)});//No I18N
		jQuery("span[elName='deleteDBIPEl']").on("click", function() {DMDBIPConfigSetting.toggleFromToDBIP(this);});//No I18N
		
		jQuery("input[defaultFocus='true']").focus().select();//No I18N
		
		RebrandAdminDialog.dmId = jQuery("#DOMAINID").attr('value');//No I18N
		RebrandAdminDialog.dmName = jQuery("#DOMAINNAME").attr('value');//No I18N	
		RebrandAdminDialog.isSSO = jQuery("#ISSSO").attr('value') == 'true';//No I18N
	}
	
	this.changeTab = function(event, el)
	{
		jQuery("#ZRDMSelSettingTab").removeAttr('id');//No I18N
		el = jQuery(el);
		el.attr('id', "ZRDMSelSettingTab");//No I18N
		var showContentName = el.attr("showContent");//No I18N
		if(showContentName == "ZRDMSettingTab")
		  {
			  RebrandAdminDialog.pageAndProductSetting("ZRDomainRebrandSetting");  //No I18N
		  }
		  else if(showContentName == "ZRDMAdminActionTab")
		  {
			  RebrandAdminDialog.changeAdminTab("ZRDomainRebrandAdminAction", $("TabAdminActionMainDiv").children[0]);  
		  }
		jQuery("#ZRControlPanelNav").attr('class', el.attr("showContent"));//No I18N
		ZDBPricing.setPageHeight();
		jQuery("input[defaultFocus='true']").focus().select();//No I18N
	}
	
	this.changeSettingTab = function(parElId, el)
	{
		var selectedTab = $("ZRRebrandSetTab");
		selectedTab.id = "";
		el.setAttribute("id","ZRRebrandSetTab");
		var classToApply = el.getAttribute("selectionClass");
		jQuery("input[defaultFocus='true']").focus().select();//No I18N
		
		var parentEl = document.getElementById(parElId);
		parentEl.className = classToApply;
		var action = el.getAttribute("action");
		if(action == "GETOBJDETAIL" && !RebrandAdminDialog.hmPageContentLoad)
		{
			var params = "ZDBACTION=" + action + "&DMID=" + this.dmId;//No I18N
			AjaxAPI.sendRequest({URL:"/ZRCustomDomains.cc?"+params,METHOD:"GET",ONSUCCESSFUNC:HomePageSetting.loadDBViews});
		}
	}
	
	this.switchSettingsTab = function(event, el)
	{
		jQuery("#TabSettingMainDiv").attr('class', jQuery(el).attr("selectionClass"));//No I18N
		var selectedTab = $("ZRRebrandSetTab");
		selectedTab.id = "";
		el.setAttribute("id","ZRRebrandSetTab");
		var classToApply = el.getAttribute("selectionClass");
		jQuery("input[defaultFocus='true']").focus().select();//No I18N
		var parentEl = jQuery("#ZRDomainRebrandSetting");//No I18N
		parentEl.attr("class", classToApply);//No I18N
		var action = el.getAttribute("action");
		if(action == "GETOBJDETAIL" && !RebrandAdminDialog.hmPageContentLoad)
		{
			var params = "ZDBACTION=" + action + "&DMID=" + this.dmId;//No I18N
			AjaxAPI.sendRequest({URL:"/ZRCustomDomains.cc?"+params,METHOD:"GET",ONSUCCESSFUNC:HomePageSetting.loadDBViews,OPSTATUSID:"ZDBMainLoader"});
		}
	}
	
	this.pageAndProductSetting = function(parElId)
	{
		var el = $("TabSettingMainDiv").children[0];
		//$("SettingDummy").style.display = "";
		var selectedTab = $("ZRRebrandSetTab");
		selectedTab.id = "";
		el.setAttribute("id","ZRRebrandSetTab");
		var classToApply = el.getAttribute("selectionClass");
		jQuery("input[defaultFocus='true']").focus().select();//No I18N
		
		var parentEl = document.getElementById(parElId);
		parentEl.className = classToApply;
		$("TabSettingMainDiv").className = classToApply;
		var action = el.getAttribute("action");
		if(action == "GETOBJDETAIL" && !RebrandAdminDialog.hmPageContentLoad)
		{
			var params = "ZDBACTION=" + action + "&DMID=" + this.dmId;//No I18N
			AjaxAPI.sendRequest({URL:"/ZRCustomDomains.cc?"+params,METHOD:"GET",ONSUCCESSFUNC:HomePageSetting.loadDBViews});
		}
	}
	
	this.changeAdminTab = function(event, el)
	{
		var selectedTab = $("ZRRebrandAdminTab");
		selectedTab.id = "";
		el.setAttribute("id","ZRRebrandAdminTab");
		var classToApply = el.getAttribute("selectionClass");
		
		var parentEl = document.getElementById("TabAdminActionMainDiv");
		parentEl.className = classToApply;
		jQuery("#ZRDomainRebrandAdminAction").attr("class", classToApply);//No I18N
		var action = el.getAttribute("action");
		if(action == "MULTIUSERSIGNUPCONTENT" && DMMultiUserSignUp.signUpContentLoaded)
		{
			return;
		}else if(action == "GETDBANDIP"){//No I18N
			var searchBox = $("ZDBDBSEARCHBOX");
			if(searchBox.value !== "" && searchBox.value !== searchBox.getAttribute("tipvalue")){
				ZDBSearchUtil.dntBlur = false;
				searchBox.value="";
				ZDBSearchUtil.handleBlur(searchBox);
			}
		}
		var onsuccessfunc = el.getAttribute("successfunc");
		var params = "ZDBACTION=" + action + "&DMID=" + RebrandAdminDialog.dmId;//No I18N
		AjaxAPI.sendRequest({URL:"/ZRCustomDomains.cc?"+params,METHOD:"GET",ONSUCCESSFUNC:onsuccessfunc,OPSTATUSID:"ZDBMainLoader"});
	}
	
	this.toggleDomainType = function(el)
	{
		var dmType = el.value;
		if(dmType == 0)
		{
                        jQuery("#SSO").hide(0);//No I18N
                        jQuery("#ZRSSO_SAMLSetup").hide(0);//No I18N
			jQuery("#ZRSSOSetup").hide(0);//No I18N
		}
		else if(dmType == 1)
		{
                        jQuery("#ZRSSO_SAMLSetup").hide(0);//No I18N
			jQuery("#ZRSSOSetup").show(0);//No I18N
                        jQuery("#SSO").show(0);//No I18N
                        this.constructIPS();
		}   
                else 
                {
                        jQuery("#SSO").hide(0);//No I18N
                        jQuery("#ZRSSOSetup").show(0);//No I18N
                        jQuery("#ZRSSO_SAMLSetup").show(0);//No I18N
                }
	}
	
	this.addNewIPEl = function(event, el)
	{
		el = jQuery(el);
		var lastIPEl = el.parent().find("[elName='IPRangeEl']").last().get(0);
		if(lastIPEl && !IPAddressElementHandler.handleFromToIPEl(lastIPEl))
		{
			return false;
		}
		var lastIPJqueryEl = jQuery(lastIPEl); 
		lastIPJqueryEl.children("[elName='deleteIPEl']").css("display","inline-block");//No I18N
		var textEls = lastIPJqueryEl.find("input[type='text']");
		var fromEl = textEls.first();
		fromEl.attr("validatemethod", "ZDBValidator.isPublicIPAddress");//No I18N

		var toEl = textEls.last();
		toEl.attr("validatemethod", "ZDBValidator.isPublicIPAddress");//No I18N
		var ipRange=jQuery(jQuery("#CustomDMElsTemplate").find("[elName='IPRangeEl']").get(0)).clone(true);//No I18N
		ipRange.insertBefore("#ZRAddNewSSOIP");//No I18N
		ipRange.show(200);
	}
	
	this.changeLogo = function(el, event) {
		el=jQuery(el);
		var logoElBox = el.closest("div[elName='logoElBox']");//No I18N
		logoElBox.find("div[elName='logoPreviewEl']").first().css('display','inline-block');//No I18N
		var imgEl = logoElBox.find("img");//No I18N
		if(BROWSER.IE && BROWSER.VERSION == 9.0){
			//jQuery(imgEl).html("");
			imgEl.attr("src","");//No I18N
			jQuery(imgEl)[0].filters.item("DXImageTransform.Microsoft.AlphaImageLoader").sizingMethod = 'scale';//No I18N
			jQuery(imgEl)[0].filters.item("DXImageTransform.Microsoft.AlphaImageLoader").src = el.val();
		}else{
			var img = event.target.files ? event.target.files[0] : el[0].files[0];
			imgEl.attr("src", URL.createObjectURL(img));//No I18N
		}
		logoElBox.find("div[elName='logoRemoveEl']").first().css('display', 'block');//No I18N
		var paramName = logoElBox.find("div[paramName$='_LOGO']").first().attr('paramName');//No I18N
		jQuery("input[name='"+paramName+"']").attr('value', false);//No I18N
	};
	
	this.removeLogo = function(el, event)
	{
		el=jQuery(el);
		var logoElBox = el.closest("div[elName='logoElBox']");//No I18N
		logoElBox.find("div[elName='logoPreviewEl']").first().css('display', 'none');//No I18N
		logoElBox.find("div[elName='logoRemoveEl']").first().css('display', 'none');//No I18N
		var paramName = el.attr("paramName");//No I18N
		jQuery("input[name='"+paramName+"']").attr('value', true);//No I18N
		var logoElBox = jQuery(el).parent("div[elName='logoElBox']");//No I18N
		var fileObj = logoElBox.find("input[type='file']").first();
		fileObj.val("");
		fileObj.attr("existValue", "removed");//No I18N
		//jQuery(logoElBox.find("input[type='file']").get(0)).val("");//No I18N
	};
	
	this.changeFileName = function(el, elId){
		document.getElementById(elId).value = el.value.replace('C:\\fakepath\\', "");
	}
	
	this.destructIPS = function(){
		jQuery("#ZRIPSSetting").empty();//No I18N
		RebrandAdminDialog.isIPSContruct = false;
	}
	
	this.constructIPS = function(){
		if(RebrandAdminDialog.isIPSContruct == true)
		{
			return;
		}
		var ips = document.getElementsByName("IPS")[0].value;
		if(ips == "")
		{
			RebrandAdminDialog.constructAddIP(); 
			RebrandAdminDialog.isIPSContruct = true;
			return;
		}
		jQuery("#ZRIPSSetting").empty();//No I18N
		var ipsList = ips.split(",");
		var ipsListLen = ipsList.length;
		for(var i = 0; i < ipsListLen; i++)
		{
			var ipAddress = ipsList[i].split("-");
			if(ipAddress.length <= 1)
			{
				continue;
			}
			var fromIp = ipAddress[0];
			var toIp = ipAddress[1];
			var div = $("SSOAppIPRange").getElementsByTagName("div")[0].cloneNode(true);
			var deleteSpan = $("SSOAppIPRange").getElementsByTagName("span")[0].cloneNode(true);
			var addSpan = $("SSOAppIPRange").getElementsByTagName("span")[1].cloneNode(true);
			divIp = div.getElementsByTagName("input");
			divIp[0].value = fromIp;
			divIp[1].value = toIp;
			if(i < ipsListLen)
			{
				div.appendChild(deleteSpan);
			}
			$("ZRIPSSetting").appendChild(div);
		}
		RebrandAdminDialog.constructAddIP();
		//this.isIPSContruct = true;
		//alert(this.isIPSContruct);
	}
	
	this.deleteIP = function(el){
		var div = el.parentElement;
		div.parentNode.removeChild(div);
		var ipRanges = jQuery("#SSOAppIPRange").find("div[elname='IPRangeEl']");//No I18N
		if(ipRanges.length == 1){
			ipRanges.each(function(index){
				var textEls = jQuery(this).find("input[type='text']");
				var fromEl = textEls.first();
				fromEl.attr("validatemethod", "ZDBValidator.isPublicIPAddress");//No I18N
				
				var toEl = textEls.last();
				toEl.attr("validatemethod", "ZDBValidator.isPublicIPAddress");//No I18N
			});
		}
	}
	
  this.isIPRangeValid = function(fromIp, toIp)
  {
    var fromiparr = fromIp.split(".");
    var toiparr = toIp.split(".");
    for(var i=0; i<4; i++)
    {
      var fromippartval = fromiparr[i];
      var toippartval = toiparr[i];
      if(fromippartval > toippartval)
      {
        return false;
      }
      else if(fromippartval < toippartval)
      {
        return true;
      }
    }
    return true;
  }
	
	this.constructAddIP = function()
	{
		var ipRange=jQuery("#CustomDMElsTemplate").find("[elName='IPRangeEl']").get(0).cloneNode(); //No I18N
		jQuery("#CustomDMElsTemplate").append(ipRange);//No I18N
		/*var div = $("SSOAppIPRange").getElementsByTagName("div")[0].cloneNode(true);
		var addSpan = $("SSOAppIPRange").getElementsByTagName("span")[1].cloneNode(true);
		div.appendChild(addSpan);
		var headEl = $("ZRIPSSetting");
		headEl.appendChild(div);*/
	}
	
	this.selectTheme = function(el)
	{
		$("ZRCustomDomainTheme").value = jQuery(el).attr("themename"); 
		jQuery(el).parent().children().removeClass('themeselected');
		jQuery(el).addClass('themeselected');
	}
	
	  this.changeDMConfigHeaderName = function(configHeaderName)
	  {
		  $(ZRDMConfigHdrName).innerHTML = configHeaderName;
		  if(configHeaderName == "Settings")
		  {
			  RebrandAdminDialog.changeSettingTab("ZRDomainRebrandSetting", $("TabSettingMainDiv").children[0]);  
		  }
		  else if(configHeaderName == "Administrative Actions")
		  {
			  //RebrandAdminDialog.changeAdminTab("ZRDomainRebrandAdminAction", $("TabAdminActionMainDiv").children[0]);  
		  }
	  }
}

var RebrandAdmin = new function()
{
	this.submitForm = function(frm, actionName)
	{
		var isModified = ZDBDomainRebrand.checkFormValuesModified(frm);
		if(RebrandAdminDialog.dmId != "" && !isModified){
			ZDBPricing.showStatusMsg(ZDBI18NMap.g('zrpt.common.js.nochanges'), "zdbpsuccessmsg"); //No I18N
			return;
		}
		frm.action = "/ZRCustomDomains.ve?ZDBACTION=" + actionName;
		frm.DMID.value = RebrandAdminDialog.dmId;
		frm.setAttribute("useiframe","true");
		frm.encoding = "multipart/form-data";//No I18N
		frm.setAttribute("ONSUCCESSFUNC", "RebrandAdmin.successFun");
		frm.setAttribute("ONFAILUREFUNC", "RebrandAdmin.failureFun");
		frm.setAttribute("OPSTATUSID", "ZDBMainLoader");
		frm.setAttribute("ZDBACTION", actionName);
		frm.setAttribute("FORMNAME", frm.name);
		frm.setAttribute("DMID", RebrandAdminDialog.dmId);
                if($('customizedLogoutURL'))(jQuery("#ZRSSO_SAMLSetup").is(":visible"))? $('customizedLogoutURL').setAttribute("isnullable","false") :  $('customizedLogoutURL').setAttribute("isnullable","true")   ;//No I18N
                
		if(jQuery("#ZRSSOSetup").is(":visible"))
		{
                    if(RebrandAdminDialog.dmId==1)
                    {
			if(IPAddressElementHandler.handleValidTOIPGreaterThanFromIPEl($("SSOAppIPRange"))){
				this.setIPS();
			}else{
				return false;
			}
                    }
                    else 
                    {
                       frm.setAttribute("SAML_ALGORITHM",$('ALGORITHM').value.toString()); 
                    }
		}
		var dmNameEl = frm.DMNAME;
		if(dmNameEl && RebrandAdminDialog.dmName != dmNameEl.value)
		{
			frm.setAttribute("NOTIFICATIONTYE", "ALERT");
		}
		if(RebrandAdminDialog.dmId && frm.LOGO)
		{
			frm.LOGO.removeAttribute("validatemethod")
		}
		var checkBoxEls = jQuery(frm).find(":checkbox");
        checkBoxEls.each(function(index){
			var elChecked = jQuery(this).prop('checked');//No I18N
			var elName = jQuery(this).attr("elname");//No I18N
			frm[elName].value=elChecked;
		});
        AjaxAPI.submit(frm);
	}
	
	this.updateHomeDBChgOnConfirm = function(clickType,requestOptions){
		if(clickType == "YES")
		{
			RebrandAdmin.updateHomeDBChanges(requestOptions["FORM"], requestOptions["ACTIONNAME"], true);
		}
		return false;
	}
	
	this.sendHomeDBRequestForm = function(frm, actionName){
		var isHomePageConfigChange = false;
		var selectedEl = jQuery("[elName='ValueDisplayElement']");//No I18N
		var currentConfigValue = selectedEl.attr("optionVal");//No I18N
		var existConfigValue = jQuery("[elName='CustomSelectElement']").attr("existConfig");//No I18N
		/*
		 * HomePageSetting.homePageOrListDBVal : Exist checked value. Values are homeDashboardConfig, listDatabase
		 */
		if(HomePageSetting.homePageOrListDBVal == "homeDashboardConfig" && (frm.HOMEPAGE_VIEWS_CONFIG_TOGGLE[1].checked || existConfigValue != currentConfigValue)){
			ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.rebrandadmin.js.frm.homepage.changeconfig.msg'), "ZDBYESNO", //No I18N
					{ONCLICK:RebrandAdmin.updateHomeDBChgOnConfirm, FORM:frm, ACTIONNAME:actionName}, 
					ZDBI18NMap.g('zrpt.rebrandadmin.js.frm.homepage.changeconfig.title'));
		}else{
			this.updateHomeDBChanges(frm, actionName, isHomePageConfigChange);
		}
	}
	
	this.updateHomeDBChanges = function(frm, actionName, isHomePageConfigChange)
	{
		var actionURL = "/ZRCustomDomains.ve?ZDBACTION=" + actionName;//No I18N
		frm.DMID.value = RebrandAdminDialog.dmId;
		var params;
		var isHomeDashboardConfig = frm.HOMEPAGE_VIEWS_CONFIG_TOGGLE[0].checked ? true : false;
		frm.HOMEPAGE_VIEWS_CONFIG.value = isHomeDashboardConfig; 

		var homeDashboardConfigVal = jQuery("[elName='ValueDisplayElement']").attr("optionVal");//No I18N
		var isMultiDBHomeDashboardConfig = homeDashboardConfigVal == "multiDBHomeDashboard" ? true : false;//No I18N
		var isSingleDBHomeDashboardConfig = homeDashboardConfigVal == "singleDBHomeDashboard" ? true : false;//No I18N
		params = ZRSerialize(frm);
		params = params.indexOf("HOMEPAGE_VIEWS_DISABLE_VALLRPT") == -1 ? params + "&HOMEPAGE_VIEWS_DISABLE_VALLRPT=true" : params.replace("HOMEPAGE_VIEWS_DISABLE_VALLRPT=on", "HOMEPAGE_VIEWS_DISABLE_VALLRPT=false");//No I18N
		params = params.indexOf("REMOVE_TOOLBAR") == -1 ? params + "&REMOVE_TOOLBAR=true" : params.replace("REMOVE_TOOLBAR=on", "REMOVE_TOOLBAR=false");//No I18N

		var dbViewsForHP = "";
		var dbObjsForMultiHP = "";
		if(isHomeDashboardConfig){
			if(isMultiDBHomeDashboardConfig){
				var viewList = jQuery("#HDSELECTEDLISTDIV").find("div[name='objListRow']");//No I18N
				var totViewsIdx = (viewList.length) - 1;
				viewList.each(function(index){
					var objId = jQuery(this).attr("rowid");//No I18N
					dbObjsForMultiHP = dbObjsForMultiHP  + objId + ",";
				})
			}else if(isSingleDBHomeDashboardConfig){
				var viewList = jQuery("#SHDSELECTEDLISTDIV").find("div[name=viewName]");//No I18N
				var totViewsIdx = (viewList.length) - 1;
				viewList.each(function(index){
					var viewName = jQuery(this).text();
					dbViewsForHP = dbViewsForHP + viewName + "##";
				})
			}

			if(dbViewsForHP == "" && dbObjsForMultiHP == ""){
				ZDBPricing.showStatusMsg(ZDBI18NMap.g('zrpt.rebrandadmin.js.frm.homepage.noview.config'), "zdbpsuccessmsg"); //No I18N
				return;
			}
		}
		var disableVallRptNewVal =frm.HOMEPAGE_VIEWS_DISABLE_VALLRPT.checked;
		var disableVallRptOldVal = JSON.parse(frm.HOMEPAGE_VIEWS_DISABLE_VALLRPT.getAttribute("existValue"));
		var removeToolbar = frm.REMOVE_TOOLBAR.checked;
		var removeToolbarOldVal = JSON.parse(frm.REMOVE_TOOLBAR.getAttribute("existValue"));
		if(frm.HOMEPAGE_VIEWS.value == dbViewsForHP && frm.HOMEPAGE_VIEWS_ID.value == dbObjsForMultiHP && disableVallRptOldVal == disableVallRptNewVal && removeToolbarOldVal == removeToolbar){
			ZDBPricing.showStatusMsg(ZDBI18NMap.g('zrpt.common.js.nochanges'), "zdbpsuccessmsg"); //No I18N
			return;
		}
		params = params.indexOf("HOMEPAGE_VIEWS") == -1 ? params + "&HOMEPAGE_VIEWS=" + dbViewsForHP : params.replace("HOMEPAGE_VIEWS="+encodeURIComponent(frm.HOMEPAGE_VIEWS.value), "HOMEPAGE_VIEWS="+encodeURIComponent(dbViewsForHP));//No I18N
		params = params.indexOf("HOMEPAGE_VIEWS_ID") == -1 ? params + "&HOMEPAGE_VIEWS_ID=" + dbObjsForMultiHP : params.replace("HOMEPAGE_VIEWS_ID="+encodeURIComponent(frm.HOMEPAGE_VIEWS_ID.value), "HOMEPAGE_VIEWS_ID="+encodeURIComponent(dbObjsForMultiHP));//No I18N
		AjaxAPI.sendRequest({URL:actionURL,PARAMETERS:params,ONSUCCESSFUNC:RebrandAdmin.successFun,ONFAILUREFUNC:RebrandAdmin.failureFun,
			OPSTATUSID:ZDBMainLoader,TORELOADHOMEPAGE:!isHomeDashboardConfig || isHomePageConfigChange,ISHOMEDBOPERATION:true,
			ISHOMEDASHBOARDCONFIG:isHomeDashboardConfig,HOMEPAGE_VIEWS_VAL:dbViewsForHP,HOMEPAGE_VIEWS_ID_VAL:dbObjsForMultiHP});
	}
	
	this.successFun = function(resp, reqOpt)
	{
		var zdbaction = reqOpt["ZDBACTION"];
		var isHomeDBOperation = reqOpt["ISHOMEDBOPERATION"];
		var formName = reqOpt["FORMNAME"];
		var dmId = reqOpt["DMID"];
		if(dmId == "" && zdbaction == "ADDANDUPDATEDM"){
			AjaxAPI.sendRequest({URL:"/ZRCustomDomains.cc?ZDBACTION=WHITELABELREBRANDING", METHOD:"GET", SHOWPAGE:"WhiteLabelRebranding", ONSUCCESSFUNC:ZDBPricing.handleTabResp,
                OPSTATUSID:"ZDBMainLoader"});  //No I18N
		}else if(isHomeDBOperation){
			var toReloadHomepage = reqOpt["TORELOADHOMEPAGE"];
			var isHomeDashboardConfig = reqOpt["ISHOMEDASHBOARDCONFIG"];
			if(toReloadHomepage){
				var params = "ZDBACTION=GETOBJDETAIL&DMID=" + RebrandAdminDialog.dmId;//No I18N
				AjaxAPI.sendRequest({URL:"/ZRCustomDomains.cc?"+params,METHOD:"GET",ONSUCCESSFUNC:HomePageSetting.loadDBViews});
			}
			else if(isHomeDashboardConfig){
				var selectEl = jQuery("div[elname='CustomSelectElement']");//No I18N
				selectEl.attr("existconfig",selectEl.children("span[elName='ValueDisplayElement']").attr("optionVal"));//No I18N
				var homeDashboard = jQuery("form[name='homeDashboard']");//No I18N
				var rmToolbar=homeDashboard.find("input[name='REMOVE_TOOLBAR']").first();
				rmToolbar.attr("existValue", rmToolbar.is(":checked"));//No I18N
				var disableVallRptNewVal=homeDashboard.find("input[name='HOMEPAGE_VIEWS_DISABLE_VALLRPT']").first();
				disableVallRptNewVal.attr("existValue", disableVallRptNewVal.is(":checked"));//No I18N
				var dbViewsForHP = reqOpt["HOMEPAGE_VIEWS_VAL"];
				var dbObjsForMultiHP = reqOpt["HOMEPAGE_VIEWS_ID_VAL"];
				homeDashboard.find("input[name='HOMEPAGE_VIEWS']").first().val(dbViewsForHP);
				homeDashboard.find("input[name='HOMEPAGE_VIEWS_ID']").first().val(dbObjsForMultiHP);
				HomePageSetting.homePageOrListDBVal = jQuery("[name='HOMEPAGE_VIEWS_CONFIG_TOGGLE']:checked").attr("elValue");//No I18N
			}
		}else if(formName){
			ZDBDomainRebrand.modifyFormValuesModified(formName);
		}
		var params = resp.getResponseParams();
	    var message = params["message"];
	    ZDBPricing.showStatusMsg(message, "zdbpsuccessmsg"); //No I18N
	}
	
	this.failureFun = function(resp, reqOpt)
	{
		var respTxt = resp.getResponsePart("STATUS_MESSAGE");
		ZDBAlertAPI.showErrorMsg(respTxt);
	}
	
	this.setIPS = function()
	{
		var ips = "";
		var ipsEl = jQuery("#SSOAppIPRange").find("[elName='IPRangeEl']").get();//No I18N
		var ipsElLen = ipsEl.length;
		if(ipsElLen == 0){
			var ipRange=jQuery(jQuery("#CustomDMElsTemplate").find("[elName='IPRangeEl']").get(0)).clone(true);//No I18N
			var textEls = ipRange.find("input[type='text']");
			var fromEl = textEls.first();
			fromEl.attr("validatemethod", "ZDBValidator.isPublicIPAddress");//No I18N
			var toEl = textEls.last();
			toEl.attr("validatemethod", "ZDBValidator.isPublicIPAddress");//No I18N
			ipRange.show();
			ipRange.insertBefore("#ZRAddNewSSOIP");//NO I18N
		}
		for(var i = 0; i < ipsElLen; i++)
		{
			var fromToEl = ipsEl[i].getElementsByTagName("input");
			if(fromToEl[0].value == "" || fromToEl[1].value == "")
			{
				continue;
			}
			if(i < ipsElLen-1){
				ips = ips + fromToEl[0].value + "-" + fromToEl[1].value + ",";
			}else{
				ips = ips + fromToEl[0].value + "-" + fromToEl[1].value;
			}
		}
		document.getElementsByName("IPS")[0].value = ips;
	}
	
	this.getFirstParentFindAttrVal = function(el, atrName)
	{
		var attrNode = this.getFirstParentFindAttrNode(el, atrName);
		return attrNode.getAttribute(atrName);
	}
	
	this.getFirstParentFindAttrNode = function(el, atrName) 
	{
		var parentEl = el.parentNode;
		var hasAtr = parentEl.hasAttribute(atrName);
		if(hasAtr) 
		{
			return parentEl;
		}
		else
		{
			return RebrandAdmin.getFirstParentFindAttrNode(parentEl, atrName);
		}
	}
	
	this.toggleCheckBoxValue = function(elId, val)
	{
		$(elId).value = val;
	}
}

var SingleHomePageSetting = new function(){
	
	this.shdAddCheckedViews = function(){
		var viewsListFrSelect=jQuery("#VIEWLIST").find("[name='objListRow']"); //No I18N
		var viewCont=jQuery("#VIEWLIST").find("[elName='viewContainer']")[0];//No I18N
		var selectedDivId = jQuery(viewCont).attr('selectedDivId');//No I18N
		var selectedListId=jQuery(viewCont).attr('selectedListId');//No I18N
		var selectAllId = jQuery(viewCont).attr('selectAllId');//No I18N
		viewsListFrSelect.each(function(){
			var viewEl = jQuery(this).children("[name='exportObjID']");//No I18N
			var isViewConfigured = viewEl.attr("ischecked");//No I18N
			if(isViewConfigured == "true")
			{
				SingleHomePageSetting.addRDeleteInSelectedList(viewEl[0],selectedDivId,selectedListId);
			}
		});
		var elemArray =jQuery("#VIEWLIST").find("[name='exportObjID']"); //No I18N
		ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
		this.alterPosition();
	}
	
	this.alterPosition = function()
	{
		var hmPgViewsList = jQuery("[name='HOMEPAGE_VIEWS']").val();//No I18N
		var hpViews = hmPgViewsList ? hmPgViewsList.split('##') : "";
		var prevEl;
		var selectedListDiv = jQuery("#SHDSELECTEDLISTDIV");//No I18N
		for(var i=0,j=hpViews.length; i<j; i++)
		{
			var curEl = selectedListDiv.children("[viewname='"+hpViews[i]+"']").first();//No I18N
			if(i == 0)
			{
				selectedListDiv.prepend(curEl);
			}	
			else
			{
				curEl.insertAfter(prevEl);
			}
			prevEl = curEl;
		}
		var selectedFocusedViewDiv=selectedListDiv.find('.ZDBPDFSelectTR').first();
		var className="ZDBPDFEmptyTR"; //No I18N
		selectedFocusedViewDiv.attr("class",className);//No I18N
		SingleHomePageSetting.selectedIndex = 0;
		selectedListDiv.find("[name='objListRow']").first().attr("class","ZDBPDFSelectTR").focus();//No I18N
	}
	
	this.hdViewsSelectAll = function(elem, containerId, selectedDivId, selectedListId){
		var isChecked = elem.getAttribute("ischecked");//No I18N
		(isChecked === "true")? jQuery(elem).attr({"ischecked":"false","class":"ZDBPDFUncheckAll"}): jQuery(elem).attr({"ischecked":"true","class":"ZDBPDFCheckedAll"}); //No I18N
		isChecked = elem.getAttribute("ischecked");  //No I18N

		var viewsList=jQuery("#"+containerId).find("[name='exportObjID']"); //No I18N
		viewsList.each(function(){
			var isViewChecked=jQuery(this).attr("ischecked"); //No I18N
			if((isViewChecked =="false") && isChecked == "true")
			{
				jQuery(this).attr({"ischecked":"true","class":"ZDBPDFChecked"}); //No I18N
				SingleHomePageSetting.addRDeleteInSelectedList(this,selectedDivId,selectedListId);
			}
			else if((isViewChecked=="true") && isChecked == "false")
			{
				jQuery(this).attr({"ischecked":"false","class":"ZDBPDFUncheck" }); //No I18N
				SingleHomePageSetting.addRDeleteInSelectedList(this,selectedDivId,selectedListId);
			}
		})
	}
	
	this.addRDeleteInSelectedList= function(elem,selectedDivId,selectedListId){
		var isChecked = elem.getAttribute("ischecked");
		var selectedRow= ZDBUtil.getParentWithAttributeValue(elem,"name","objListRow"); //No I18N
		var selectedViewsDiv=jQuery("#"+selectedListId);
		if( isChecked == "true")
		{
			var clonedRow=jQuery(selectedRow).clone();
			jQuery(clonedRow).children("[name='exportObjID']").remove(); //No I18N
			var viewNameEl = jQuery(clonedRow).children("[name='viewName']");//No I18N
			var viewName = viewNameEl.text();
			viewNameEl.text(viewName);
			jQuery(clonedRow).attr("viewName", viewName);//No I18N
			jQuery(clonedRow).attr("selectListDiv", "SHDSELECTEDLISTDIV");//No I18N
			jQuery(clonedRow).find('.MVlistIcon').css({'margin':'3px'});//No I18N

			jQuery(clonedRow).hover(function(){ 
				jQuery(this).children("input").show(); //No I18N
			},function(){ 
				jQuery(this).children("input").hide(); //No I18N
			});
			jQuery(clonedRow).appendTo(selectedViewsDiv);
		}
		else
		{
			var viewName=jQuery(selectedRow).attr("viewName"); //No I18N
			selectedViewsDiv.children("[viewName='"+viewName+"']").remove(); //No I18N
		}
		var rows=selectedViewsDiv.children("[name='objListRow']"); //No I18N
		var lastViewIndex=(rows.length)-1;
		var className="ZDBPDFEmptyTR"; //No I18N
		rows.attr("class",className);//No I18N 
		SingleHomePageSetting.selectedIndex = lastViewIndex;
		var SelectclassName="ZDBPDFSelectTR"; //No I18N
		jQuery(rows[lastViewIndex]).attr("class",SelectclassName).focus();//No I18N
		ZDBMVExportUtil.addRDelRemoveAllOpt(rows.length,selectedDivId,selectedListId);
	}
	
	this.addRemoveViewForHP = function(elem,selectAllId,containerId,selectedDivId,selectedListId,changeSelectAll){
		ZDBMVExportUtil.changeCheckBoxStyle(elem);
		SingleHomePageSetting.addRDeleteInSelectedList(elem,selectedDivId,selectedListId);
		var elemArray =jQuery("#"+containerId).find("[name='exportObjID']"); //No I18N
		if(changeSelectAll==='true')
		{
			ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
		}
	}
	
	this.searchTheValue = function(el, containerId, selectAllId, event){
	    var toBeSearchedFrom=jQuery("#"+containerId);  //No I18N
	    var className="ZDBMVExportClassNew"; //No I18N
	    toBeSearchedFrom.removeClass(className);
	    var value = el.value;
	    if((value === "") || (value==="Search Views")) //No I18N
	    {
	        value = null;
	    }
	    if(value)
	    {
	    	jQuery(el).siblings("[class='ZRSSearchClearIcon']").show(); //No I18N
	        value = value.toLowerCase();
	        if (BROWSER.IE && (BROWSER.VERSION.toString()==="7.0"||BROWSER.VERSION.toString()==="8.0"))
	        { 
	            var key;
	            if (window.event) {
	                key = window.event.keyCode;
	            } else if (ev) {
	                key = ev.which;
	            }
	            //Enter Key
	            if (key===13)
	            {
	            	SingleHomePageSetting.searchAll(toBeSearchedFrom, value);
	            }
	            return;
	        }
	        SingleHomePageSetting.searchAll(toBeSearchedFrom, value);
	    }
	    else
	    {
	        jQuery(el).siblings("[class='ZRSSearchClearIcon']").hide(); //No I18N
	        this.showAllViews(toBeSearchedFrom);
	    }
	}
	
	this.showAllViews = function(containerEl)
	{
		containerEl.find("[elName='viewContainer']").show(); //No I18N
		containerEl.find("[objRowType='true']").show(); //No I18N
	}
	
	this.searchAll = function(toBeSearchedFrom, value){
		var visibleViewsList = jQuery(toBeSearchedFrom).find("div[objRowType='true']");
		visibleViewsList.each(function(){
    		var viewname = jQuery(this).attr("viewname");//No I18N
    		viewname = viewname.toLowerCase();
    		if(viewname.indexOf(value)!==-1){
    			jQuery(this).show();
    		}else{
                jQuery(this).hide();
            }
    	})
	}
	
	this.removeTheView=function(el,selectAllId,containerId,selectedDivId,selectedListId)
    {
		var selectedRow= ZDBUtil.getParentWithAttributeValue(el,"name","objListRow"); //No I18N
        var viewName=jQuery(selectedRow).attr("viewName"); //No I18N
        var relavantEl=jQuery("#"+containerId).find("[viewName='"+viewName+"']")[0]; //No I18N
        var relavantCheckBox = jQuery(relavantEl).find("[name='exportObjID']")[0];
        SingleHomePageSetting.addRemoveViewForHP(relavantCheckBox,selectAllId,containerId,selectedDivId,selectedListId,'true');//No I18N
    }
	
	this.removeAll=function(selectAllId,containerId,selectedDivId,selectedListId)
    {
        var viewsList=jQuery("#"+selectedListId).children("div[name='objListRow']") //No I18N
        if(viewsList.length!=0)
        {
            viewsList.each(function(){
                var viewName=jQuery(this).attr("viewName"); //No I18N
                var relavantEl=jQuery("#"+containerId).find("[viewName='"+viewName+"']")[0]; //No I18N
                var relavantCheckBox = jQuery(relavantEl).find("[name='exportObjID']")[0];
                SingleHomePageSetting.addRemoveViewForHP(relavantCheckBox,selectAllId,containerId,selectedDivId,selectedListId,"true");
            });
        }
    }
	
	this.sortViewsList = function(el, sortType, event){
		ZDBMenuUtil.closeMenu();
		var parentElem=jQuery(el).parents("[elname='sortDropDown']");  //No I18N
        var containerId=parentElem.attr("containerId");  //No I18N
        var viewContainer = jQuery("#"+containerId).children("[elName='viewContainer']");
        var viewList = viewContainer.find("[name='objListRow']");
        if(sortType==="asc") //No I18N
        {
        	HomePageSetting.sortAsc(viewList, "viewName");//No I18N
        }
        else if(sortType==="dsc") //No I18N
        {
        	HomePageSetting.sortDsc(viewList, "viewName");//No I18N
        }
        this.sortingType = sortType;
        viewContainer.empty();
        viewContainer.append(viewList);
		ZDBUtil.stopEventBubble(event);
	}
	
	this.showSortMenu = function(el, event, contentName){
		var newMenu = HomePageSetting.getSubMenu(contentName);
		newMenu.find("span").removeClass("sortTickMenu");    //No I18N  
        newMenu.find("#"+this.sortingType).addClass("sortTickMenu");  //No I18N
		ZDBMVExportUtil.appendMenuInElem(el,newMenu,event);
	}
	
	this.highLightRow = function(el){
		var currEl=jQuery(el); 
		var selectListDiv = currEl.attr("selectListDiv");//No I18N
		var dbViews;
		if(selectListDiv == "SHDSELECTEDLISTDIV")
		{
			dbViews = jQuery("#SHDSELECTEDLISTDIV").find("[objRowType='true']");//No I18N
			SingleHomePageSetting.selectedIndex = dbViews.index(currEl);
		}
		else
		{
			dbViews = jQuery("#VIEWLIST").find("[objRowType='true']");//No I18N
		}
		jQuery(dbViews).attr("class","ZDBPDFEmptyTR"); // No I18N
		jQuery(currEl).attr("class","ZDBPDFSelectTR"); //No I18N 
	}
	
	this.moveDown = function()
	{
		this.startIndex = 0;
		var cLbody = $("SHDSELECTEDLISTDIV");
		ZDBUtil.removeNonElements(cLbody);
		var rows = cLbody.childNodes;
		var len = rows.length;
		if(SingleHomePageSetting.selectedIndex === undefined || SingleHomePageSetting.selectedIndex >= len || SingleHomePageSetting.selectedIndex < 0)
		{
			return;
		}
		else if(SingleHomePageSetting.selectedIndex == len-1)
		{
			var node = cLbody.childNodes[SingleHomePageSetting.selectedIndex];
			cLbody.appendChild(node);
			jQuery(node).focus();
		}
		else
		{
			var node = cLbody.childNodes[SingleHomePageSetting.selectedIndex];
			var before = cLbody.childNodes[SingleHomePageSetting.selectedIndex+1];
			cLbody.insertBefore(before,node); //position reversed;
			jQuery(node).focus();
			++SingleHomePageSetting.selectedIndex;
		}
	}
	
	this.moveUp = function()
	{
		this.startIndex = 0;
		if(SingleHomePageSetting.selectedIndex === undefined || SingleHomePageSetting.selectedIndex <= 0 || (SingleHomePageSetting.selectedIndex < (this.startIndex-1)))
		{
			return;
		}
		var cLbody = $("SHDSELECTEDLISTDIV");
		ZDBUtil.removeNonElements(cLbody);
		var node = cLbody.childNodes[SingleHomePageSetting.selectedIndex];
		var before = cLbody.childNodes[SingleHomePageSetting.selectedIndex-1];
		cLbody.insertBefore(node, before);
		jQuery(node).focus();
		--SingleHomePageSetting.selectedIndex;
	}
}

var HomePageSetting = new function()
{
	this.loadDBViews = function(response, reqParams)
	{
		$("ZRHomePageConfiguration").innerHTML = response.getOnlyHtml();
		var countOfViews=jQuery("#ZDBViewsContainer").find("#viewTypeCount");//No I18N
		var countArr = countOfViews.get(0) ? ZDBUtil.getAttribute(countOfViews.get(0),"countArr") : "";
		var actualConfig = countOfViews.get(0) ? ZDBUtil.getAttribute(countOfViews.get(0),"actualConfigViews").split(",") : "";
		HomePageSetting.viewTypeCount = countArr.split(",");
		HomePageSetting.actualViewsCount = HomePageSetting.viewTypeCount;
		HomePageSetting.selectedViewsCount={
				"Table":actualConfig[0],"QueryTable":actualConfig[1],"AnalysisView":actualConfig[2],"Pivot":actualConfig[3],
				"SummaryView":actualConfig[4],"TabularReports":actualConfig[5],"Dashboard":actualConfig[6] //No I18N
		};
		HomePageSetting.filterViewsConfig={
				"Table":false,"QueryTable":false,"AnalysisView":false,"Pivot":false,//No I18N
				"SummaryView":false,"TabularReports":false,"Dashboard":false //No I18N
		};
		HomePageSetting.searchType = "All";//No I18N
		HomePageSetting.invokeSubMenuContent();
		HomePageSetting.hdAddCheckedViews();
		SingleHomePageSetting.shdAddCheckedViews();
		RebrandAdminDialog.hmPageContentLoad = response.getOnlyHtml();
		RebrandAdminDialog.attachEventListener();
		HomePageSetting.homePageOrListDBVal = jQuery("[name='HOMEPAGE_VIEWS_CONFIG_TOGGLE']:checked").attr("elValue");//No I18N
	}
	
	this.showHideCustomSelectOptions = function(elem, event){
		if(ZDBMenuUtil.curMenuEl)
        {
            ZDBMenuUtil.closeMenu();
        }
		var customSelectElementContainer= ZDBUtil.getParentWithAttributeValue(elem,"elName","CustomSelectElementContainer"); //No I18N
		var selectElOptions =jQuery(customSelectElementContainer).find("[elName='SelectElementOptions']"); //No I18N
		var listItems=selectElOptions.find("li");
		selectElOptions[0].positioned=true;
		var selectedElDispVal = jQuery(elem).text().trim();
		ZRSMenu.showMenu(event,elem,selectElOptions[0],5);
		listItems.each(function(){
			var menuItemEl = jQuery(this);
			menuItemEl.removeClass('ZRSMenuHover');
			menuItemEl.children("span[elname='ZRSSelectedTick']").removeClass("ZRSTicker");//No I18N
    		var elDisplayVal = menuItemEl.attr("elDisplayVal");//No I18N
    		if(elDisplayVal == selectedElDispVal){
    			menuItemEl.addClass("ZRSMenuHover");
    			menuItemEl.children("span[elname='ZRSSelectedTick']").addClass("ZRSTicker");//No I18N
    		}
        });
		listItems.mouseover(function(event){
			var menuItemEl = jQuery(this);
			if(menuItemEl.hasClass('ZRSMenuHover'))
			{
				return;
			}
			var currentHoveredEl = menuItemEl.parents('ul').find('li.ZRSMenuHover');//NO I18N
			currentHoveredEl.removeClass('ZRSMenuHover');
			var anchorEl = menuItemEl.addClass("ZRSMenuHover");
		});
	}
	
	this.invokeSubMenuContent = function()
	{
		if(RebrandAdminDialog.subMenuCont)
		{
			return;
		}
		var path = ZDBGlobal.CONTENTPATH + "/" + encodeURIComponent(jQuery("#LOCALEINFOSTR").attr("value")) + "/FullModeContent.txt"; //No I18N
		AjaxAPI.sendRequest({URL:path,METHOD:"GET",NOSUBREQPARAM:true,MODULENAME:"GridMenu",ONSUCCESSFUNC:this.storeSubMenuContent}); //No I18N
	}
	
	this.storeSubMenuContent = function(response, requestOptions)
	{
		RebrandAdminDialog.subMenuCont = response.responseText;
	}
	
	this.hdAddCheckedViews = function()
    {
    	var selectAllId;
        var viewList=jQuery("#DBVIEWLIST").find("[elName='viewContainer']"); //No I18N
        viewList.each(function(){
        	var viewsListFrSelect=jQuery(this).find("[name='objListRow']"); //No I18
        	var dbName=jQuery(this).attr('dbName');//No I18N
        	var selectedDivId=jQuery(this).attr('selectedDivId');//No I18N
        	var selectedListId=jQuery(this).attr('selectedListId');//No I18N
        	selectAllId = jQuery(this).attr('selectAllId');//No I18N
        	viewsListFrSelect.each(function(){
        		var viewEl = jQuery(this).children("[name='exportObjID']");//No I18N
        		var isViewConfigured = viewEl.attr("ischecked");//No I18N
                if(isViewConfigured == "true")
                {
                	HomePageSetting.addRDeleteInSelectedList(viewEl[0],dbName,selectedDivId,selectedListId,false);//TODO 
                }
            });
        });
        var elemArray =jQuery("#DBVIEWLIST").find("[name='exportObjID']:visible"); //No I18N
        ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
        this.alterPosition();
    }
	
	this.addRDeleteInSelectedList= function(elem,dbName,selectedDivId,selectedListId,incSelectedViewsCnt)
    {
        var isChecked = elem.getAttribute("ischecked");
        var typeOfView=elem.getAttribute("typeOfView");
        var selectedRow= ZDBUtil.getParentWithAttributeValue(elem,"name","objListRow"); //No I18N
        var selectedViewsDiv=jQuery("#"+selectedListId);
        if( isChecked == "true")
        {
            var clonedRow=jQuery(selectedRow).clone();
            jQuery(clonedRow).children("[name='exportObjID']").remove(); //No I18N
            var viewNameEl = jQuery(clonedRow).children("[name='viewName']");//No I18N
            var viewName = viewNameEl.text();
            viewName = "["+dbName+"].["+viewName+"]";
            viewNameEl.text(viewName);
            jQuery(clonedRow).attr("viewName", viewName);//No I18N
            jQuery(clonedRow).attr("selectListDiv", "HDSELECTEDLISTDIV");//No I18N
            
            jQuery(clonedRow).hover(function(){ 
                jQuery(this).children("input").show(); //No I18N
            },function(){ 
                jQuery(this).children("input").hide(); //No I18N
                });
            jQuery(clonedRow).appendTo(selectedViewsDiv);
            if(incSelectedViewsCnt)
            {
            	HomePageSetting.selectedViewsCount[typeOfView]++;
        	}
        }
        else
        {
            var rowId=jQuery(selectedRow).attr("rowId"); //No I18N
            selectedViewsDiv.children("[rowId="+rowId+"]").remove(); //No I18N
            if(incSelectedViewsCnt)
            {
            	HomePageSetting.selectedViewsCount[typeOfView]--;
        	}
        }
        var rows=selectedViewsDiv.children("[name='objListRow']"); //No I18N
        var lastViewIndex=(rows.length)-1;
        var className="ZDBPDFEmptyTR"; //No I18N
        rows.attr("class",className);//No I18N 
        RebrandAdminDialog.selectedIndex = lastViewIndex;
        var SelectclassName="ZDBPDFSelectTR"; //No I18N
        jQuery(rows[lastViewIndex]).attr("class",SelectclassName).focus();//No I18N
        ZDBMVExportUtil.addRDelRemoveAllOpt(rows.length,selectedDivId,selectedListId);
    }
	
	this.alterPosition = function()
	{
		var hmPgViewsList = jQuery("[name='HOMEPAGE_VIEWS_ID']").val();//No I18N
		var hpViews = hmPgViewsList ? hmPgViewsList.split(',') : "";
		var prevEl;
		var selectedListDiv = jQuery("#HDSELECTEDLISTDIV");//No I18N
		for(var i=0,j=hpViews.length; i<j; i++)
		{
			var curEl = selectedListDiv.children("[rowid='"+hpViews[i]+"']").first();//No I18N
			if(i == 0)
			{
				selectedListDiv.prepend(curEl);
			}	
			else
			{
				curEl.insertAfter(prevEl);
			}
			prevEl = curEl;
		}
		var selectedFocusedViewDiv=selectedListDiv.find('.ZDBPDFSelectTR').first();
		var className="ZDBPDFEmptyTR"; //No I18N
		selectedFocusedViewDiv.attr("class",className);//No I18N
		RebrandAdminDialog.selectedIndex = 0;
		selectedListDiv.find("[name='objListRow']").first().attr("class","ZDBPDFSelectTR").focus();//No I18N
	}
	
	this.addRemoveViewForHP = function(elem,selectAllId,containerId,selectedDivId,selectedListId,changeSelectAll)
	{
		ZDBMVExportUtil.changeCheckBoxStyle(elem);
		var dbName = ZDBUtil.getParentWithAttributeValue(elem,"dbRowType","true").getAttribute("dbName"); //No I18N
		HomePageSetting.addRDeleteInSelectedList(elem,dbName,selectedDivId,selectedListId,true);
		var elemArray =jQuery("#"+containerId).find("[name='exportObjID']:visible"); //No I18N
        if(changeSelectAll==='true')
        {
            ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
        }
	}
	
	this.dbOpenClose = function(el, attrName)
	{
		var isFolderOpen = el.getAttribute("isOpen");
		var parEl = DOMUtils.getSelfOrParentWithAttr(el, attrName);
		var viewsInDB = DOMUtils.getChildElsWithAttr(parEl, "elname", "dbObjList")[0];//No I18N
		viewsInDB.style.display = isFolderOpen == "true" ? "none" : "";
		isFolderOpen = isFolderOpen == "true" ? "false" : "true";
		el.setAttribute("isOpen", isFolderOpen);
		el.className = isFolderOpen == "true" ? "folderOpen" : "folderClose";
	}
	
	this.hdViewsSelectAll = function(elem, containerId, selectedDivId, selectedListId)
	{
		var isChecked = elem.getAttribute("ischecked");//No I18N
        (isChecked === "true")? jQuery(elem).attr({"ischecked":"false","class":"ZDBPDFUncheckAll"}): jQuery(elem).attr({"ischecked":"true","class":"ZDBPDFCheckedAll"}); //No I18N
        isChecked = elem.getAttribute("ischecked");  //No I18N
        
        var dbList=jQuery("#"+containerId).find("div[elName='viewContainer']"); //No I18N
        dbList.each(function(){
        	var dbName = jQuery(this).attr("dbName"); //No I18N
            var db = jQuery(this).find("div[name='databaseName']")[0];
            var isDBOpen=jQuery(db).attr("isOpen"); //No I18N
            if((isDBOpen =="false") && isChecked == "true")
            {
            	HomePageSetting.dbOpenClose(db,'dbId');//No I18N
                //ZDBMVExportUtil.addRDeleteInSelectedList(view,selectedDivId,selectedListId,"false");
            }
            var viewsList=jQuery(this).find("[name='exportObjID']:visible"); //No I18N
            for(var i=0;i<viewsList.length;i++)
            {
                var view=viewsList.get(i);
                var isViewChecked=jQuery(view).attr("ischecked"); //No I18N
                if((isViewChecked =="false") && isChecked == "true")
                {
                    jQuery(view).attr({"ischecked":"true","class":"ZDBPDFChecked"}); //No I18N
                    HomePageSetting.addRDeleteInSelectedList(view,dbName,selectedDivId,selectedListId,true);
                }
                else if((isViewChecked=="true") && isChecked == "false")
                {
                    jQuery(view).attr({"ischecked":"false","class":"ZDBPDFUncheck" }); //No I18N
                    HomePageSetting.addRDeleteInSelectedList(view,dbName,selectedDivId,selectedListId,true);
                }
            }
        })
	}
	
	this.hdViewsSpecificSelection = function(elem,evt)
	{
		ZDBMenuUtil.closeMenu();
        elem=jQuery(elem).find("div[ischecked]");
        var isChecked=(elem.attr("ischecked") === "true")?"false":"true"; //No I18N
        var parentElement = "a";//No I18N
        var viewToBeSelected= jQuery(elem).parents(parentElement).attr("elname");//No I18N
        var parentElem=jQuery(elem).parents("div[class='dropDownMenu']");//No I18N
        var containerId=parentElem.attr("containerId"); //No I18N
        var selectedDivId=parentElem.attr("selectedDivId");//No I18N
        var selectedListId=parentElem.attr("selectedListId");//No I18N
        var selectAllId=parentElem.attr("selectAllId");//No I18N
        var viewList=jQuery("#"+containerId).find("[elName='viewContainer']"); //No I18N
        viewList.each(function(){
        	var viewsListFrSelect=jQuery(this).find("[typeOfView="+viewToBeSelected+"]"); //No I18N
        	var dbList=jQuery(this).find("[name='databaseName']").get(0);
        	dbListIsOpen = dbList.getAttribute("isOpen"); //No I18N
        	var dbName = dbList.textContent;
        	var toOpenDB = false;
        	viewsListFrSelect.each(function(){
                var isViewChecked=jQuery(this).attr("ischecked");  //No I18N
                if((isViewChecked ==="false") && isChecked === "true")
                {
                    jQuery(this).attr({"ischecked":"true", "class":"ZDBPDFChecked" }); //No I18N
                    HomePageSetting.addRDeleteInSelectedList(this,dbName,selectedDivId,selectedListId,true);
                    toOpenDB = true;
                }
                else if((isViewChecked==="true") && isChecked === "false")
                {
                    jQuery(this).attr({"ischecked":"false","class":"ZDBPDFUncheck"}); //No I18N
                    HomePageSetting.addRDeleteInSelectedList(this,dbName,selectedDivId,selectedListId,true);
                }
            });
        	if(toOpenDB && dbListIsOpen=="false")
        	{
        		HomePageSetting.dbOpenClose(dbList,'dbId');//No I18N
        	}
        });
        var elemArray =jQuery("#"+containerId).find("[name='exportObjID']:visible"); //No I18N
        ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
        ZDBUtil.stopEventBubble(evt);
	}
	
	this.getSubMenu = function(contentName)
	{
		if(ZDBMenuUtil.curMenuEl)
        {
            ZDBMenuUtil.closeMenu();
        }
		var content = RebrandAdminDialog.subMenuCont; 
		var startIdx = content.indexOf("<!--"+ contentName +"_Start-->");
	    if(startIdx < 0)
	    {
	      throw new Error(contentName + " start is not present"); //No I18N
	    }
	    var endIdx = content.indexOf("<!--"+ contentName +"_End-->",startIdx);
	    if(endIdx <0)
	    { 
	      throw new Error(contentName + " end is not present"); //No I18N
	    }
	    var snippet = content.substring(startIdx,endIdx);
	    //snippet = ZDBContentCache.disableElInSnippet(snippet);
	    var divEl = document.createElement("div");
	    divEl.innerHTML = snippet;
	    
	    var contentEl = null;
	    var childNodes = divEl.childNodes;
	    
	    for(var i=0,len = childNodes.length;i< len;i++)
	    {
	      if(childNodes[i].getAttribute)
	      {
	        contentEl = childNodes[i];
	        contentEl.parentNode.removeChild(contentEl);
	        break;
	      }
	    }
	    if(contentEl == null)
	    {
	      throw new Error(contentName + " has no elements");  //No I18N
	    }
	    return jQuery(contentEl);
	}
	
	this.showSelectViewsSubMenu = function(el, event, contentName)
	{
		var newMenu = HomePageSetting.getSubMenu(contentName);
		this.showRideOpt(newMenu);
		var specificViewSelectAll=jQuery(newMenu).find("div[ischecked]"); //No I18N
		
		this.hideNonFilteredViewType(newMenu);
		
        var index=0;
        for(var i in HomePageSetting.selectedViewsCount)
        {
        	if(HomePageSetting.selectedViewsCount[i].toString()=== HomePageSetting.actualViewsCount[index])
            {
                jQuery(specificViewSelectAll[index]).attr({"ischecked":"true","class":"ZDBPDFChecked iconSize fLeft"}); //No I18N
            }
            else
            {
            	jQuery(specificViewSelectAll[index]).attr({"ischecked":"false","class":"ZDBPDFUncheck iconSize fLeft"});  //No I18N
            }
            index++;
        }
	    ZDBMVExportUtil.appendMenuInElem(el,newMenu,event);
	}
	
	this.hideNonFilteredViewType = function(newMenu)
	{
		var toFilterViews = this.toFilterViews();
		
		if(toFilterViews)
		{
			var index = 0;
			var specificViewSelect=newMenu.find("[isViewType='true']"); //No I18N
			for(var i in HomePageSetting.filterViewsConfig)
			{
				if(!HomePageSetting.filterViewsConfig[i])
		    	{
		    		jQuery(specificViewSelect[index]).hide();
		    	}
				index++;
			}
		}
	}
	
	this.showSearchMenu = function(el, event, contentName)
	{
		var newMenu = HomePageSetting.getSubMenu(contentName);
		this.showRideOpt(newMenu);
		this.hideNonFilteredViewType(newMenu);
		newMenu.find("span").removeClass("sortTickMenu");    //No I18N  
        newMenu.find("#Search"+HomePageSetting.searchType).addClass("sortTickMenu");   //No I18N
		ZDBMVExportUtil.appendMenuInElem(el,newMenu,event);
	}
	
	this.clearSearchBox=function(el,evt)
    {
        var SearchText=jQuery(el).siblings("#ZDBMVObjSearchTxtFld").val("").focus();  //No I18N
        this.searchTheValue(SearchText,SearchText.attr("containerId"),SearchText.attr("selectAllId"));  //No I18N
        ZDBUtil.stopEventBubble(evt);
    }
	
	this.moveDown = function()
	{
		this.startIndex = 0;
		var cLbody = $("HDSELECTEDLISTDIV");
		ZDBUtil.removeNonElements(cLbody);
		var rows = cLbody.childNodes;
		var len = rows.length;
		if(RebrandAdminDialog.selectedIndex === undefined || RebrandAdminDialog.selectedIndex >= len || RebrandAdminDialog.selectedIndex < 0)
		{
			return;
		}
		else if(RebrandAdminDialog.selectedIndex == len-1)
		{
			var node = cLbody.childNodes[RebrandAdminDialog.selectedIndex];
			cLbody.appendChild(node);
			jQuery(node).focus();
		}
		else
		{
			var node = cLbody.childNodes[RebrandAdminDialog.selectedIndex];
			var before = cLbody.childNodes[RebrandAdminDialog.selectedIndex+1];
			cLbody.insertBefore(before,node); //position reversed;
			jQuery(node).focus();
			++RebrandAdminDialog.selectedIndex;
		}
	}
	
	this.moveUp = function()
	{
		this.startIndex = 0;
		if(RebrandAdminDialog.selectedIndex === undefined || RebrandAdminDialog.selectedIndex <= 0 || (RebrandAdminDialog.selectedIndex < (this.startIndex-1)))
		{
			return;
		}
		var cLbody = $("HDSELECTEDLISTDIV");
		ZDBUtil.removeNonElements(cLbody);
		var node = cLbody.childNodes[RebrandAdminDialog.selectedIndex];
		var before = cLbody.childNodes[RebrandAdminDialog.selectedIndex-1];
		cLbody.insertBefore(node, before);
		jQuery(node).focus();
		--RebrandAdminDialog.selectedIndex;
	}
	
	this.toggleHPAndListDB = function(showEl){
		var showEl=jQuery(showEl);
		var elValue=showEl.attr("elValue");//No I18N
		if(elValue == "homeDashboardConfig"){
			jQuery("#ZRListSharedDatabase").hide();//No I18N
			jQuery("#ZRHomeDashboardConfig").show();//No I18N
		}else{
			jQuery("#ZRHomeDashboardConfig").hide();//No I18N
			jQuery("#ZRListSharedDatabase").show();//No I18N
		}
	}
	
	this.toggleHPViewConfig = function(showEl)
	{
		var showEl=jQuery(showEl);
		var elValue=showEl.attr("elName");//No I18N
		if(elValue == "multiDBHomeDashboard"){
			jQuery("#ZDBSingleHomeDBViewsContainer").hide();//No I18N
			jQuery("#ZDBViewsContainer").show();//No I18N
			var displayVal=showEl.attr("elDisplayVal");//No I18N
			var selectedEl = jQuery("[elName='ValueDisplayElement']");//No I18N
			selectedEl.text(displayVal);
			selectedEl.attr("optionVal","multiDBHomeDashboard");//No I18N
		}else if(elValue == "singleDBHomeDashboard"){//No I18N
			jQuery("#ZDBViewsContainer").hide();//No I18N
			jQuery("#ZDBSingleHomeDBViewsContainer").show();//No I18N
			var displayVal=showEl.attr("elDisplayVal");//No I18N
			var selectedEl = jQuery("[elName='ValueDisplayElement']");//No I18N
			selectedEl.text(displayVal);
			selectedEl.attr("optionVal","singleDBHomeDashboard");//No I18N
		}
	}
	
	this.searchTheValue = function(el, containerId, selectAllId, event)
	{
	    var toBeSearchedFrom=jQuery("#"+containerId);  //No I18N
	    var className="ZDBMVExportClassNew"; //No I18N
	    toBeSearchedFrom.removeClass(className);
	    //toBeSearchedFrom.children("div[objRowType='false']").hide(); //No I18N
	    var searchInType=HomePageSetting.searchType;
	    var viewsToBeSearched = HomePageSetting.getViewsForSearch(searchInType,toBeSearchedFrom);
	    var value = el.value;
	    if((value === "") || (value==="Search Views")) //No I18N
	    {
	        value = null;
	    }
	    if(value)
	    {
	    	this.openDb(toBeSearchedFrom);
	        jQuery(el).siblings("[class='ZRSSearchClearIcon']").show(); //No I18N
	        //ZDBMVExportUtil.hideRShowSearchAndSortMenu(el,"hide");  //No I18N
	        value = value.toLowerCase();
	        if (BROWSER.IE && (BROWSER.VERSION.toString()==="7.0"||BROWSER.VERSION.toString()==="8.0"))
	        { 
	            var key;
	            if (window.event) {
	                key = window.event.keyCode;
	            } else if (ev) {
	                key = ev.which;
	            }
	            //Enter Key
	            if (key===13)
	            {
	            	if(searchInType === "All")
	            	{
	            		HomePageSetting.searchAll(viewsToBeSearched,value);
	            	}
	            	else if(searchInType === "Database")
	            	{
	            		HomePageSetting.searchInDatabase(viewsToBeSearched,value,searchInType);
	            	}
	            	else
	            	{
	            		HomePageSetting.searchInViews(viewsToBeSearched,value,searchInType);
	            	}
	            }
	            return;
	        }
	        
	        if(searchInType === "All")
        	{
        		HomePageSetting.searchAll(viewsToBeSearched,value);
        	}
	        else if(searchInType === "Database")
        	{
	        	HomePageSetting.searchInDatabase(viewsToBeSearched,value,searchInType);
        	}
        	else
        	{
        		HomePageSetting.searchInViews(viewsToBeSearched,value,searchInType);
        	} 
	    }
	    else
	    {
	        jQuery(el).siblings("[class='ZRSSearchClearIcon']").hide(); //No I18N
	        //ZDBMVExportUtil.hideRShowSearchAndSortMenu(el,"show"); //No I18N
	        var toFilterViews = this.toFilterViews();
	        if(toFilterViews)
	        {
	        	this.showViewsOnFilteredViewType(containerId);
	        }
	        else
	        {
	        	this.showAllDBsAndViews(toBeSearchedFrom);
	        }
	    }
	    //var elemArray =jQuery("#"+containerId).find("[name='exportObjID']:visible"); //No I18N
	    //ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
	}
	
	this.getViewsForSearch=function(searchInType,toBeSearchedFrom)
	{
	    var viewsToBeSearched;
	    if(searchInType==="All" || searchInType==="Database") //No I18N
	    {
	    	viewsToBeSearched = toBeSearchedFrom.children("div[elName=viewContainer]");//No I18N
	    }
	    else
	    {
	    	viewsToBeSearched = toBeSearchedFrom.find("div[elName=viewContainer]");
	    	viewsToBeSearched.each(function(){
	    		jQuery(this).find("[objRowType='true'][viewType!="+searchInType+"]").hide();
	    	})
	    }
	    return viewsToBeSearched;
	}
	
	this.showSortMenu = function(el, event, contentName)
	{
		var newMenu = HomePageSetting.getSubMenu(contentName);
		newMenu.find("span").removeClass("sortTickMenu");    //No I18N  
        newMenu.find("#"+this.sortingType).addClass("sortTickMenu");  //No I18N
		ZDBMVExportUtil.appendMenuInElem(el,newMenu,event);
	}
	
	this.showFilterViewsSubMenu = function(el, event, contentName)
	{
		var newMenu = HomePageSetting.getSubMenu(contentName);
		this.showRideOpt(newMenu);
		
		var specificViewTypeFilter=jQuery(newMenu).find("div[ischecked]"); //No I18N
		specificViewTypeFilter.each(function(){
			var viewType = jQuery(this).parent().attr("elname");//No I18N
			if(HomePageSetting.filterViewsConfig[viewType] === true)
			{
				jQuery(this).attr({"ischecked":"true","class":"ZDBPDFChecked iconSize fLeft"}); //No I18N
			}
			else
			{
				jQuery(this).attr({"ischecked":"false","class":"ZDBPDFUncheck iconSize fLeft"});  //No I18N
			}
		})
		
		ZDBMVExportUtil.appendMenuInElem(el,newMenu,event);
	}
	
	this.highLightRow = function(el)
	{
		var currEl=jQuery(el); 
		var selectListDiv = currEl.attr("selectListDiv");//No I18N
		var dbViews;
		if(selectListDiv == "HDSELECTEDLISTDIV")
		{
			dbViews = jQuery("#HDSELECTEDLISTDIV").find("[objRowType='true']");//No I18N
			RebrandAdminDialog.selectedIndex = dbViews.index(currEl);
		}
		else
		{
			dbViews = jQuery("#DBVIEWLIST").find("[objRowType='true']");//No I18N
		}
		jQuery(dbViews).attr("class","ZDBPDFEmptyTR"); // No I18N
		jQuery(currEl).attr("class","ZDBPDFSelectTR"); //No I18N 
	}
	
	this.showRideOpt = function(newMenu)
	{
		var specificSearchRSelect=newMenu.find("[isViewType='true']"); //No I18N
        for(var i=0;i<7;i++)
        {
            if(HomePageSetting.actualViewsCount[i]==="0")
            {
                jQuery(specificSearchRSelect[i]).hide();
            }
            else
            {
                jQuery(specificSearchRSelect[i]).show();
            }
        }
	}
	
	this.searchAll = function(databaseToBeSearched, value)
	{
		var toFilterViews = this.toFilterViews();
		databaseToBeSearched.each(function(){
            var dbName = jQuery(this).attr("dbName");//No I18N
            dbName=dbName.toLowerCase();
            var showDB = false;
            if(dbName.indexOf(value)!==-1)
            {
            	var visibleViewsList = jQuery(this).find("div[objRowType='true']");
            	visibleViewsList.each(function(){
            		var viewType = jQuery(this).attr("viewType");//No I18N
            		if(!toFilterViews || HomePageSetting.filterViewsConfig[viewType])
            		{
            			jQuery(this).show();
            		}            		
            	})
            	showDB = true;
            }
            else
            {
                    var views = jQuery(this).find("div[objRowType='true']");
                    views.each(function(){
                    	var viewName = jQuery(this).attr("viewName"); //No I18N
                    	viewName=viewName.toLowerCase();
                    	var viewType = jQuery(this).attr("viewType"); //No I18N
                        if(viewName.indexOf(value)!==-1 && (!toFilterViews || HomePageSetting.filterViewsConfig[viewType]))
                        {
                    		jQuery(this).show();
                    		showDB = true;
                        }
                        else
                        {
                            jQuery(this).hide();
                        }
                    })
            }
            if(showDB)
            {
            	jQuery(this).show();
            }
            else
            {
            	jQuery(this).hide();
            }
        });
	}
	
	this.toFilterViews = function()
	{
		var filterSelectViewsSubMenu = false;
		for(var i in HomePageSetting.filterViewsConfig)
		{
			if(HomePageSetting.filterViewsConfig[i])
			{
				filterSelectViewsSubMenu = true;
				break;
			}
		}
		return filterSelectViewsSubMenu;
	}
	
	this.hdViewsSpecificFilter = function(elem,evt)
	{
		ZDBMenuUtil.closeMenu();
        elem=jQuery(elem).find("div[ischecked]");
        var isChecked = (elem.attr("ischecked") === "true") ? false : true; //No I18N
        var parentElement = "a";//No I18N
        var viewToBeSelected= jQuery(elem).parents(parentElement).attr("elname");//No I18N
        HomePageSetting.filterViewsConfig[viewToBeSelected] = isChecked;
        var parentElem=jQuery(elem).parents("div[class='addToFilter']");//No I18N
        var containerId=parentElem.attr("containerId"); //No I18N
        var selectAllId = parentElem.attr("selectAllId"); //No I18N
        this.showViewsOnFilteredViewType(containerId);
        if(!isChecked && this.toFilterViews())
        {
        	var srchEl = jQuery("#MVListSearch").find("[elname='ZDBViewIconForSearch']");//No I18N
        	this.setViewTypeSearch(srchEl, "All");//No I18N
        }
        var elemArray = jQuery("#"+containerId).find("[name='exportObjID']:visible"); //No I18N
        ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
        ZDBUtil.stopEventBubble(evt);
	}
	
	this.showOrHideViewsOfFilteredViewTypes = function(viewList)
	{
        viewList.each(function(){
        	var viewType = jQuery(this).attr('viewType');//No I18N
        	if(HomePageSetting.filterViewsConfig[viewType])
        	{
        		jQuery(this).show();
        	}
        	else
        	{
        		jQuery(this).hide();
        	}
        })
	}
	
	this.showViewsOnFilteredViewType = function(containerId)
	{
		var containerEl = jQuery("#"+containerId);
        this.openDb(containerEl);
        
        var viewList=containerEl.find("[name='objListRow']"); //No I18N
        this.showOrHideViewsOfFilteredViewTypes(viewList);
        
        var dbList = containerEl.find("[elName='viewContainer']");
        var curHiddenDbCnt = this.hideDBOnAllViewsHidden(dbList);
        var totDbCount = containerEl.attr("dbCount");//No I18N
        
        if(totDbCount == curHiddenDbCnt)
        {
        	this.showAllDBsAndViews(containerEl);
        }
	}
	
	this.openDb = function(containerEl)
	{
        var dbStatus = containerEl.find("[name='databaseName']");
        dbStatus.each(function(){
        	var isOpen = jQuery(this).attr("isOpen");//No I18N
        	if(isOpen == "false")
        	{
        		HomePageSetting.dbOpenClose(this, 'dbId');//No I18N
        	}
        })
	}
	
	this.hideDBOnAllViewsHidden = function(dbList)
	{
        var curHiddenDbCnt = 0;
        dbList.each(function(){
        	jQuery(this).show();
        	var viewListForSpecDB = jQuery(this).find("[name='objListRow']");
        	var isViewVisible = false;
        	viewListForSpecDB.each(function(){
            	 if(jQuery(this).is(':visible'))
            	 {
            		 isViewVisible = true;
            		 return;
            	 }
            })
            if(!isViewVisible)
            {
            	jQuery(this).hide();
            	curHiddenDbCnt++;
            }
        })
        return curHiddenDbCnt;
	}
	
	this.setViewTypeSearch = function(el, searchInType)
	{
		HomePageSetting.searchType=searchInType;
		if(searchInType!=="All" && searchInType!=="Database") //No I18N
        {
            el.attr("class","ZRSMenuIcon "+searchInType+"Icon").show(); //No I18N
        }
        else
        {
            el.hide(); 
        }
	}
	
	this.showAllDBsAndViews = function(containerEl)
	{
		containerEl.find("[elName='viewContainer']").show(); //No I18N
		containerEl.find("[objRowType='true']").show(); //No I18N
	}
	
	this.searchViewsList = function(el, searchInType, event)
	{
		ZDBMenuUtil.closeMenu();
		ZDBUtil.stopEventBubble(event);
		el = jQuery(el).parents("#MVListSearch").find("[elname='ZDBViewIconForSearch']"); //No I18N
		this.setViewTypeSearch(el, searchInType);
	}
	
	this.searchInDatabase = function(databaseToBeSearched,value,searchInType)
	{
		databaseToBeSearched.each(function(){
            var dbName = jQuery(this).attr("dbName");//No I18N
            dbName=dbName.toLowerCase();
            if(dbName.indexOf(value)!==-1)
            {
            	jQuery(this).show();
            }
            else
            {
            	jQuery(this).hide();
            }
        });
	}
	
	this.searchInViews=function(databaseList,value,searchInType)
	{
		databaseList.each(function(){
			var hideDB = true;
            var views = jQuery(this).find("div[objRowType='true'][viewType="+searchInType+"]");
            views.each(function(){
            	var viewName = jQuery(this).attr("viewName"); //No I18N
            	viewName=viewName.toLowerCase();
                if(viewName.indexOf(value)!==-1)
                {
                	hideDB = false;
                    jQuery(this).show();
                }
                else
                {
                    jQuery(this).hide();
                }
            })
            if(hideDB)
            {
            	jQuery(this).hide();
            }
        });
	}
	
	this.sortViewsList = function(el, sortType, event)
	{
		ZDBMenuUtil.closeMenu();
		var parentElem=jQuery(el).parents("[elname='sortDropDown']");  //No I18N
        var divToBeSorted=parentElem.attr("containerId");  //No I18N
        var dbs = jQuery("#"+divToBeSorted).find("div[dbRowType='true']"); //No I18N
        dbs.each(function(){
        	var viewHeader = jQuery(this).find("div[elname=dbObjList]").first();
        	var viewList = jQuery(this).find("div[objRowType]");
        	if(sortType==="asc") //No I18N
            {
            	HomePageSetting.sortAsc(viewList, "viewName");//No I18N
            	viewHeader.remove("div[objRowType]");  //No I18N
            	viewHeader.append(viewList);
            }
            else if(sortType==="dsc") //No I18N
            {
            	HomePageSetting.sortDsc(viewList, "viewName");//No I18N
            	viewHeader.remove("div[objRowType]");  //No I18N
            	viewHeader.append(viewList);
            }
        })
        if(sortType==="asc") //No I18N
        {
        	HomePageSetting.sortAsc(dbs, "dbName");//No I18N
        }
        else if(sortType==="dsc") //No I18N
        {
        	HomePageSetting.sortDsc(dbs, "dbName");//No I18N 
        }
        this.sortingType = sortType;
        jQuery("#"+divToBeSorted).empty();  //No I18N
        jQuery("#"+divToBeSorted).append(dbs);
		ZDBUtil.stopEventBubble(event);
	}
	
	this.sortAsc=function(rows, attrName)
    {
        rows.sort(function(a,b){
            var attrVal1=jQuery(a).attr(attrName).toLowerCase(); 
            var attrVal2=jQuery(b).attr(attrName).toLowerCase(); 
            return (attrVal1<attrVal2)?-1:(attrVal1>attrVal2)?1:0;
        }); 
    }
        
    this.sortDsc=function(rows, attrName)
    {
        rows.sort(function(a,b){
            var attrVal1=jQuery(a).attr(attrName).toLowerCase(); 
            var attrVal2=jQuery(b).attr(attrName).toLowerCase(); 
            return (attrVal1>attrVal2)?-1:(attrVal1<attrVal2)?1:0;
        });
    }
    
    this.removeAll=function(selectAllId,containerId,selectedDivId,selectedListId)
    {
        var viewsList=jQuery("#"+selectedListId).children("div[name='objListRow']") //No I18N
        if(viewsList.length!=0)
        {
            viewsList.each(function(){
                var rowId=jQuery(this).attr("rowid"); //No I18N
                var relavantCheckBox=jQuery("#"+containerId).find("[objId="+rowId+"]")[0]; //No I18N
                HomePageSetting.addRemoveViewForHP(relavantCheckBox,selectAllId,containerId,selectedDivId,selectedListId,"true");
            });
        }
    }
    
    this.removeTheView=function(el,selectAllId,containerId,selectedDivId,selectedListId)
    {
        var selectedRow= ZDBUtil.getParentWithAttributeValue(el,"name","objListRow"); //No I18N
        var rowId=jQuery(selectedRow).attr("rowId"); //No I18N
        var relavantCheckBox=jQuery("#"+containerId).find("[objId="+rowId+"]")[0]; //No I18N
        HomePageSetting.addRemoveViewForHP(relavantCheckBox,selectAllId,containerId,selectedDivId,selectedListId,'true');//No I18N
    }
}

var IPAddressElementHandler = new function()
{
	this.handleValidTOIPGreaterThanFromIPEl = function(el){
		var isToIPRangesCorrect = true;
		var allRanges = jQuery(el).find("[elname='IPRangeEl']");
		allRanges.each(function(){
			var el=jQuery(this);
			var fromIPEl=el.children("[elname='fromip']").get(0);//No I18N
			var toIPEl=el.children("[elname='toip']").get(0);//No I18N

			var isFromIPAddressCorrect = IPAddressUtil.isValidPubliIP(fromIPEl.value);
			var isToIPAddressCorrect = IPAddressUtil.isValidPubliIP(toIPEl.value);
			if(isFromIPAddressCorrect && isToIPAddressCorrect)
			{
				var isToIPAddressCorrect = IPAddressUtil.isValidPublicToIp(fromIPEl.value, toIPEl.value);
				if(!isToIPAddressCorrect)
				{
					showCustomMessage(ZDBI18NMap.g('zrpt.customdomain.js.toipaddress.notgreaterthanfromip'), toIPEl);
					isToIPRangesCorrect = false;
					return false;
				}
			}
		});
		return isToIPRangesCorrect;
	}
	
	this.handleFromToIPEl = function(el)
	{	
		ZDBUtil.setNamedChildEls(el,el);
		var fromip = el.fromip;
		var toip = el.toip;
		
		var isFromIPAddressCorrect = IPAddressUtil.isValidPubliIP(fromip.value);
		if(!isFromIPAddressCorrect)
		{
			fromip.focus();
			return false;
		}
		var isToIPAddressCorrect = IPAddressUtil.isValidPublicToIp(fromip.value, toip.value);
		if(!isToIPAddressCorrect)
		{
			toip.focus();
			return false;
		}
		return true;
	}

	this.handleElOnKeyPress = function(event, el)
	{
		var charCode = event.keyCode ? event.keyCode : event.which;
		if(charCode == 8 || charCode == 9){
			return true;
		}
		value = el.value+String.fromCharCode(charCode);
		if(!IPAddressUtil.canBeValidPublicIP(value))
		{
			event.preventDefault();
		}
		return true;
	}

	this.handleToIPElOnKeyPress = function(event, el)
	{
		var charCode = event.keyCode ? event.keyCode : event.which;
		if(charCode == 8 || charCode == 9){
			return true;
		}
		var toIPElVal = el.value+String.fromCharCode(charCode);
		if(!IPAddressUtil.canBeValidPublicIP(toIPElVal))
		{
			event.preventDefault();
		}
		var fromIPElVal = jQuery(el).closest("div[elBox='fromToIPEl']").find("input[elname='fromip']").first().val();//No I18N

		if(!IPAddressUtil.canBeToIPGreaterThanOrEqualToFromIP(fromIPElVal, toIPElVal))
		{
			event.preventDefault();
		}
		return true;
	}

	this.handleElOnBlur = function(el, skipEmpty)
	{
		var elVal = el.value;
		if(skipEmpty && elVal == "")
		{
			return true;
		}
		var isIPAddressCorrect = IPAddressUtil.isValidPubliIP(elVal);
		if(!isIPAddressCorrect)
		{	
			el.style.borderColor = "#990000";//No I18N
			return false;
		}
		else
		{
			el.style.borderColor = "#D1D1D1";//No I18N
			return true;
		}
	}

	this.handleToIPElOnBlur = function(el, skipEmpty)
	{
		var toIPElVal = el.value;
		if(skipEmpty && toIPElVal == "")
		{
			return true;
		}

		var fromIPEl = jQuery(el).closest("div[elBox='fromToIPEl']").find("input[elname='fromip']").first();//No I18N
		var fromIPElVal = fromIPEl.val();

		if(!IPAddressUtil.isValidPubliIP(fromIPElVal))
		{
			fromIPEl.css("border-color", "#990000");//No I18N
			el.style.borderColor = "#990000";//No I18N
			return false;
		}

		if(!IPAddressUtil.isValidPublicToIp(fromIPElVal, toIPElVal))
		{
			el.style.borderColor = "#990000";//No I18N
			return false;
		}
		else
		{
			el.style.borderColor = "#D1D1D1";//No I18N
			return true;
		}
	}
}

var DMDBIPConfigSetting = new function()
{
	this.searchString = "";
	this.checkKeyAndSearch = function(el,ev)
	{
		if(!ev){ev = window.event};
		if(ev.keyCode == 13 && !$("ZRDatabaseNotPresent"))
		{
			DMDBIPConfigSetting.searchString=el.value;
			DMDBIPConfigSetting.dmIPNextSet(el);
		}
		return true;
	}
	
	this.clearSearch = function(el){
		if(jQuery(el).attr("class")=="ZRSSearchClearIcon")
		{
			ZDBSearchUtil.dntBlur=true;
			var par = jQuery(el.parentNode);
			var jInput = par.children("input");//No I18N
			var inputEl = jInput.get(0);
			if(jInput.val())
			{
				jInput.val("").focus();
			}
		}
		if(DMDBIPConfigSetting.searchString == ""){
			return;
		}
		DMDBIPConfigSetting.searchString="";
		DMDBIPConfigSetting.dmIPNextSet(el);
	}
	
	this.appendDomainDBIP = function(response, requestOptions)
	{
		if($("ZRDomainDBIPList"))
		{
			$("ZRDomainDatabaseList").removeChild($("ZRDomainDBIPList"));
		}
		var div = document.createElement("div");
		div.id = "ZRDomainDBIPList";
		div.innerHTML = response.getOnlyHtml(); 
		$("ZRDomainDatabaseList").appendChild(div);
		RebrandAdminDialog.attachEventListener();
	}
	
	this.dmIPNextSet = function(el)
	{
		var nextSet = el.getAttribute("nextset");
		if(nextSet == null){
			nextSet = "0";
		}
		var action = el.getAttribute("action");
		if(action == null){
			action = "GETDBANDIP";//No I18N
		}
		var params = "ZDBACTION=" + action + "&DMID=" + RebrandAdminDialog.dmId + "&NEXTSET=" + nextSet; //No I18N
		if(DMDBIPConfigSetting.searchString!=""){
			params = params + "&MODE=" +el.getAttribute("mode") + "&PATTERN=" + DMDBIPConfigSetting.searchString;//No I18N
		}
		AjaxAPI.sendRequest({URL:"/ZRCustomDomains.cc?"+params,METHOD:"GET",ONSUCCESSFUNC:DMDBIPConfigSetting.appendDomainDBIP});
	}
	
	this.toggleDB = function(el)
	{
		RebrandAdminDialog.hmPageContentLoad = null;
		var domainName = RebrandAdminDialog.dmName;
		var dbName = el.getAttribute("dbname");
		var action = el.getAttribute("displayaction");
		var params = "DBNAME=" + dbName + "&DMNAME=" + domainName;//No I18N
		AjaxAPI.sendRequest({URL:"/ZRCustomDomains.ve?ZDBACTION=" + action,PARAMETERS:params,ONSUCCESSFUNC:DMDBIPConfigSetting.changeDBStatus, ELEMENT: el});
	}
	
	this.changeDBStatus = function(resp, requestOptions)
	{
		var el = requestOptions["ELEMENT"];
		var params = resp.getResponseParams();
	    var message = params["message"];
	    var displayAction = "";
	    if(message == "ENABLEDOMAINDB")
	    {
	    	displayAction = "DisableDomainDB";//No I18N
	    	var dbIPConfigEl = ZDBUtil.getParentWithAttributeValue(el, "elName", "dbIpConfig");//No I18N
	    	//var dbIPConfigEl = RebrandAdmin.findParentElement(el, "elName", "dbIpConfig");
	    	var divTag = dbIPConfigEl.getElementsByTagName("div");
	    	for(var i = 0, j = divTag.length; i < j; i++)
	    	{
	    		var ipConfigTag = divTag[i].getAttribute("elName") == "ipConfigBox" ? divTag[i] : null;
	    		ipConfigTag != null ? (ipConfigTag.className = "configDBIP dbWLSetListIP") : null;
	    	}
	    	el.className = "activeBtn sliderOn";
	    }
	    else
	    {
	    	displayAction = "EnableDomainDB";//No I18N
	    	var dbIPConfigEl = ZDBUtil.getParentWithAttributeValue(el, "elName", "dbIpConfig");//No I18N
	    	//var dbIPConfigEl = RebrandAdmin.findParentElement(el, "elName", "dbIpConfig");
	    	var divTag = dbIPConfigEl.getElementsByTagName("div");
	    	for(var i = 0, j = divTag.length; i < j; i++)
	    	{
	    		var ipConfigTag = divTag[i].getAttribute("elName") == "ipConfigBox" ? divTag[i] : null;
	    		ipConfigTag != null ? (ipConfigTag.className = "hideConfigDBIP dbWLSetListIP") : null;
	    	}
	    	el.className = "sliderOff deactiveBtn";
	    }
	    el.setAttribute("displayaction", displayAction);
	}
	
	this.configDBIP = function(el)
	{
		var ipConfigBox = jQuery(el).closest("div[elName='ipConfigBox']");//No I18N
		var configIPConfigure = ipConfigBox.find("div[elName='configIPConfigure']");//No I18N
		configIPConfigure.each(function(){
        	jQuery(this).hide();            
        });
		var configIPViewBox = ipConfigBox.find("div[elName='configIPViewBox']");//No I18N
		configIPViewBox.each(function(){
        	jQuery(this).hide();            
        });
		var configIPEditEls = ipConfigBox.find("div[elName='configIPEdit']");//No I18N
		var dpIpRangeElObj = configIPEditEls.find("[elName='DPIPRangeEl'][status='exist'],[elName='DPIPRangeEl'][status='added']");
		if(dpIpRangeElObj.size() < 5){
			var ipRange=jQuery(jQuery("#CustomDMElsTemplate").find("[elName='DPIPRangeEl']").get(0)).clone(true);//No I18N
			var ipEl = configIPEditEls.first().find("div[elName='ZRAddNewDPIP']").first();
			ipRange.insertBefore(ipEl);
			ipRange.show();
		}
		configIPEditEls.first().show();
	}
	
	this.uploadConfigDBIP = function(el)
	{
		var addedIP = "";
		var deletedIP = "";
		var existIP = "";
		var divEl = el.parentElement.getElementsByTagName("div");
		for(var i = 0; i < divEl.length; i++)
		{
			var fromToIPEl = divEl[i].getAttribute("status");
			fromToIPEl = fromToIPEl == null || "" ? "" : fromToIPEl; 
			if(fromToIPEl == "added")
			{
				var fromIPEl = divEl[i].getElementsByTagName("input")[0];
				var toIPEl = divEl[i].getElementsByTagName("input")[1];
				var fromIp = fromIPEl.value;
				var toIp = toIPEl.value;
				if(fromIp == "" && toIp == ""){continue;}
				if(!(IPAddressElementHandler.handleFromToIPEl(divEl[i])))
				{
					return false;
				}
				addedIP = addedIP + fromIp + "-" + toIp + ",";
			}
			else if(fromToIPEl == "deleted")
			{
				var fromIp = divEl[i].getElementsByTagName("input")[0].value;
				var toIp = divEl[i].getElementsByTagName("input")[1].value;
				deletedIP = deletedIP + fromIp + "-" + toIp + ",";
			}
			else if(fromToIPEl == "exist")
			{
				var fromIp = divEl[i].getElementsByTagName("input")[0].value;
				var toIp = divEl[i].getElementsByTagName("input")[1].value;
				existIP = existIP + fromIp + "-" + toIp + ",";
			}
		}
		addedIP = addedIP != "" ? addedIP.substring(0, addedIP.length - 1) : addedIP;
		deletedIP = deletedIP != "" ? deletedIP.substring(0, deletedIP.length - 1) : deletedIP;
		existIP = existIP != "" ? existIP.substring(0, existIP.length - 1) : existIP;
		var newIP = existIP != "" ? existIP + (addedIP != "" ? "," + addedIP : "") : (addedIP != "" ? addedIP : "");
		var dbId = RebrandAdmin.getFirstParentFindAttrVal(el, "dbId");//No I18N
		var URL = "&ZDBACTION=ADDORDELIPRANGE&DBID=" + dbId + "&ADDIPADRESSES=" + addedIP + "&DELIPADRESSES=" + deletedIP;      //No I18N
		var inputEl = el.parentElement.getElementsByTagName("input");
		for(var j = 0; j < inputEl.length; j++)
		{
			var elPret = inputEl[j].getAttribute("elName");
			if(elPret == "pubViewRestric")
			{
				URL = URL + "&PUBLIC_VIEW_RESTRICT=" + inputEl[j].checked;
				break;
			}
		}
		if(addedIP == "" && deletedIP == "" && inputEl[j].checked == JSON.parse(inputEl[j].getAttribute("existValue"))){
			ZDBPricing.showStatusMsg(ZDBI18NMap.g('zrpt.common.js.nochanges'), "zdbpsuccessmsg"); //No I18N
			return;
		}
		inputEl[j].setAttribute("existValue", inputEl[j].checked);
		AjaxAPI.sendRequest({URL:"/ZDBAdminActionMI.ma",PARAMETERS:URL
            , OPSTATUSID:"ZDBMainLoader", ONSUCCESSFUNC:DMDBIPConfigSetting.updateFromToIPAddress, ELEMENT:el, NEWIP:newIP, PUBLICVIEWREST:inputEl[j].checked});      //No I18N
	}
	
	this.updateFromToIPAddress = function(resp, reqOpts)
	{
		var el = reqOpts["ELEMENT"];
		var newIP = reqOpts["NEWIP"];
		var viewRest = reqOpts["PUBLICVIEWREST"];
		var ipRanageEl = ZDBUtil.getParentWithProperty(el, "ipRangesSplit"); //No I18N
		var ipRanageEl = RebrandAdmin.getFirstParentFindAttrNode(el, "ipRangesSplit"); //No I18N
		ipRanageEl.setAttribute("ipRangesSplit", newIP);
		ipRanageEl.setAttribute("restricPublic", viewRest);
		
		var ipConfigBox = jQuery(el).closest("div[elName='ipConfigBox']");//No I18N
		var configIPViewEls = ipConfigBox.find("div[elName='configIPView']");//No I18N
		var ipViewEls = jQuery(configIPViewEls).find("div[elName='DPIPRangeViewEl']");//No I18N
        ipViewEls.each(function(){
        	jQuery(this).remove();
        })
        
        var configDBIPEditEls = ipConfigBox.children("div[elName='configIPEdit']");//No I18N
        configDBIPEditEls.hide();
        var addedDPIPEls = configDBIPEditEls.find("div[status='added']");//No I18N
        addedDPIPEls.each(function(){
        	var curEL = jQuery(this);
        	var fromEl = curEL.children("input[elname='fromip']");//No I18N
        	var toEl = curEL.children("input[elname='toip']");//No I18N
        	var fromIpVal = fromEl.val();
        	if(fromIpVal == "")
        	{
        		curEL.remove();
        		return true;
        	}
        	fromEl.attr('readOnly',true);//No I18N
        	toEl.attr('readOnly',true);//No I18N
        	curEL.attr("status","exist");//No I18N
        	curEL.find("span[elname='deleteDBIPEl']").first().attr("actiontype", "exist");//No I18N
        });
        
		var existDPIPEls = configDBIPEditEls.find("div[status='exist']");
		existDPIPEls.each(function(){
        	var fromIpVal = jQuery(this).children("input[elname=fromip]").val();//No I18N
        	var toIpVal = jQuery(this).children("input[elname=toip]").val();//No I18N
        	
        	var ipViewEl=jQuery(jQuery("#CustomDMElsTemplate").find("[elName='DPIPRangeViewEl']").get(0)).clone(true);//No I18N
            var fromIpViewSpan = ipViewEl.find("span");
            fromIpViewSpan.first().html(fromIpVal);
            fromIpViewSpan.last().html(toIpVal);
            configIPViewEls.append(ipViewEl);
            ipViewEl.show();
        });
		
		var deletedDPIPEls = configDBIPEditEls.find("div[status='deleted']");//No I18N
		deletedDPIPEls.each(function(){
        	var curEL = jQuery(this);
        	curEL.remove();
        });
		
		if(existDPIPEls.length > 0)
		{
			ipConfigBox.find("div[elName='configIPViewBox']").show();
		}
		else
		{
			ipConfigBox.find("div[elName='configIPConfigure']").show();
		}
		ZDBPricing.showStatusMsg(resp.responseText, "zdbpsuccessmsg"); //No I18N
	}
	
	this.removeConfigDBIP = function(el)
	{
		var ipConfigBox = jQuery(el).closest("div[elName='ipConfigBox']");//No I18N
		var configDBIPEditEls = ipConfigBox.children("div[elName='configIPEdit']");//No I18N
		var addedDPIPEls = configDBIPEditEls.find("div[status='added']");
		addedDPIPEls.each(function(){
			jQuery(this).remove();
		});
		var deletedDPIPEls = configDBIPEditEls.find("div[status='deleted']");
		deletedDPIPEls.each(function(){
			jQuery(this).attr("status", "exist");//No I18N
			jQuery(this).find("span[elname='deleteDBIPEl']").first().attr("actiontype", "exist");//No I18N
			jQuery(this).show();
		});
		configDBIPEditEls.hide();
		var dpIpRangeViewEl = ipConfigBox.find("div[elName='DPIPRangeViewEl']");
		if(dpIpRangeViewEl.length > 0)
		{
			ipConfigBox.find("div[elName='configIPViewBox']").show();
		}
		else
		{
			ipConfigBox.find("div[elName='configIPConfigure']").show();
		}
	}
	
	this.toggleFromToDBIP = function(el)
	{
		var actionType = el.getAttribute("actionType");
		if(actionType == "toadd")
		{
			el = jQuery(el);
			var dpIpRangeElObj = el.parent().find("[elName='DPIPRangeEl'][status='exist'],[elName='DPIPRangeEl'][status='added']");
			var lastIPEl = dpIpRangeElObj.last().get(0);
			if(lastIPEl && !IPAddressElementHandler.handleFromToIPEl(lastIPEl))
			{
				return false;
			}
			if(dpIpRangeElObj.size() >= 5){
				ZDBAlertAPI.showErrorMsg("Only 5 IP Address range are allowed");//No I18N
				return;
			}
			var ipConfigBox = jQuery(el).closest("div[elName='ipConfigBox']");//No I18N
			var addEl = ipConfigBox.find("div[elName='ZRAddNewDPIP']").first();
			var ipRange=jQuery(jQuery("#CustomDMElsTemplate").find("[elName='DPIPRangeEl']").get(0)).clone(true);//No I18N
			ipRange.insertBefore(addEl);
			ipRange.show();
		}
		else if(actionType == "added")
		{
			el = jQuery(el);
			el.parent().remove();
		}
		else if(actionType == "exist")
		{
			var delEl = el.parentElement;
			el.setAttribute("actionType", "deleted")
			delEl.setAttribute("status", "deleted");
			delEl.style.display = "none";
		}
	}
}

var DMMultiUserSignUp = new function()
{
	this.totalUser = 1;
	this.showNewUserSignUp = function(event, el)
	{
		var multiuserSignUpEls = jQuery("#ZRMultiUserSignUp").find("[name='MultiUserSignUp']");//No I18N
		if(this.totalUser > 0){
			var allReqValPresent = true;
			multiuserSignUpEls.each(function(){
				var thisEl = jQuery(this).get(0);
				if(!DMMultiUserSignUp.isRequiredValueIsPresent(thisEl)){
					allReqValPresent=false;
					return;
				}
			});
			if(!allReqValPresent){return false;}
		}
		if(this.totalUser == 10)
		{
			ZDBAlertAPI.showErrorMsg("Can add only 10 user at a time", "zdbpsuccessmsg"); //No I18N
			return;
		}
		multiuserSignUpEls.last().find("span[elName='deleteUserSignupEl']").first().css("display", "inline-block");//No I18N
		var userSignupEl=jQuery(jQuery("#CustomDMElsTemplate").find("[elName='MultiUserSignUp']").get(0)).clone(true);//No I18N
		userSignupEl.attr("name","MultiUserSignUp");//No I18N
		userSignupEl.insertBefore("#ZRAddNewUser");//No I18N
		userSignupEl.find("[elname='mailid']").get(0).focus();
		this.totalUser++;
	}
	
	this.isRequiredValueIsPresent = function(el)
	{
		ZDBUtil.setNamedChildEls(el,el);
		if(el.mailid.value=="")
		{
			el.mailid.focus();
			return false;
		}
		if(el.username.value=="")
		{
			el.username.focus();
			return false;
		}
		if(el.password && el.password.value=="")
		{
			el.password.focus();
			return false;
		}
		if(el.displayname.value=="")
		{
			el.displayname.focus();
			return false;
		}
		return true;
	}
	
	this.submitMultiUserSignUp = function()
	{
		var multiUserSignUps = jQuery("#ZRMultiUserSignUp").find("div[elname='MultiUserSignUp']");//No I18N
		var params = "";
		var isValidInputs = true;
		multiUserSignUps.each(function(){
			var usr=jQuery(this);
			var mailidEl = usr.find("input[elname='mailid']").first();
			var usernameEl = usr.find("input[elname='username']").first();
			var passwordEl = usr.find("input[elname='password']").first();
			var displaynameEl = usr.find("input[elname='displayname']").first();
			var password = RebrandAdminDialog.isSSO === true ? "-sso-" : passwordEl.val();//No I18N
			
			if(!ZDBValidator.isEmail(mailidEl.val(),false)){
				showCustomMessage(ZDBI18NMap.g('zrpt.rebrandadmin.js.frm.multiusrsignup.emailaddresserr'), mailidEl.get(0));
				isValidInputs = false;
				return;
			}
			if(!ZDBCustomDomainValidator.checkValidUserName(usernameEl.val(),false)){
				showCustomMessage(ZDBI18NMap.g('zrpt.rebrandadmin.js.frm.multiusrsignup.usernameerr'), usernameEl.get(0));
				isValidInputs = false;
				return;
			}
			if(!RebrandAdminDialog.isSSO && password.trim().length < 8){
				showCustomMessage(ZDBI18NMap.g('zrpt.rebrandadmin.js.frm.multiusrsignup.passworderr'), passwordEl.get(0));
				isValidInputs = false;
				return;
			}
			if(!ZDBCustomDomainValidator.checkValidDisplayName(displaynameEl.val(),false)){
				showCustomMessage(ZDBI18NMap.g('zrpt.rebrandadmin.js.frm.multiusrsignup.displaynameerr'), displaynameEl.get(0));
				isValidInputs = false;
				return;
			}
			
			var usrDet = mailidEl.val()+"$$"+displaynameEl.val()+"$$"+usernameEl.val();
			if(RebrandAdminDialog.isSSO === false)
			{
				usrDet += "$$" + password;
			}
			params += "&userinfo="+encodeURIComponent(usrDet);		//No I18N
		});
		if(params == "" || !isValidInputs) return;
		var captchatVal = $("captchaval").value;
		captchatVal = captchatVal == $("captchaval").getAttribute("placeHolderValue") ? "":captchatVal;
		if(!ZDBValidator.checkValidInput(captchatVal)){
			showCustomMessage(ZDBI18NMap.g('zrpt.rebrandadmin.js.frm.multiusrsignup.captcharequired'), $("captchaval"));
			return;
		}
		
		params += "&digest="+$("ZDBDigest").value+"&captchaval="+captchatVal+"&DOMAINNAME="+RebrandAdminDialog.dmName;	//No I18N
		AjaxAPI.sendRequest({URL:"/ZDBCustomDomainLogin.ma?ZDBACTION=multiusersignup",
			PARAMETERS:params,ONSUCCESSFUNC:DMMultiUserSignUp.multiUserSignUpSuccess,
			ONFAILUREFUNC:DMMultiUserSignUp.multiUserSignUpFailure,OPSTATUSID:"ZDBMainLoader"});				//No I18N
	}
	
	this.multiUserSignUpSuccess = function(resp, reqOpt)
	{
		var respObj = JSON.parse(resp.responseText);
		var el = $("ZRMultiUserSignUp");
		var inps = DOMUtils.getChildElsWithAttr(el,"elname","mailid");		//No I18N
		var failure = "", isSuccessResult = false;
		for( var i in respObj)
		{
			var result = respObj[i][0];
			if(result == "success")
			{
				for(var j=0; j<inps.length; j++)
				{
					if(inps[j].value == i)
					{
						var successEL = ZDBUtil.getParentWithAttributeValue(inps[j], "name", "MultiUserSignUp"); //No I18N
						//var trEl = DOMUtils.getParentWithTagName(inps[j],"MultiUserSignUp");
						el.removeChild(successEL);
						isSuccessResult = true;
						DMMultiUserSignUp.totalUser--;
						break;
					}
				}
			}
			else
			{//failure
				failure += i+"  ::  "+respObj[i][1]+"\n";
			}
		}
		
		if(failure == "")
		{
			var userSignupEl=jQuery(jQuery("#CustomDMElsTemplate").find("[elName='MultiUserSignUp']").get(0)).clone(true);//No I18N
			userSignupEl.attr("name","MultiUserSignUp");//No I18N
			userSignupEl.insertBefore("#ZRAddNewUser");//No I18N
			ZDBMsgBox.showHintMsg("Account Created Successfully", "success");//No I18N
		}
		else
		{
			if(DMMultiUserSignUp.totalUser < 10)
			{
				var divEl = $("ZRMultiUserSignUp").lastElementChild.getElementsByTagName("div");
				for(var i = 0; i < divEl.length; i++)
				{
					if(divEl[i].hasAttribute("elName") && divEl[i].getAttribute("elName") == "ZRAddDelUser")
					{
						divEl[i].style.display = "";
						var addDeleteIcon = divEl[i].getElementsByTagName("div");
						addDeleteIcon[0].style.display = "";
						addDeleteIcon[1].style.display = "none";
					}
				}
			}
			var messg = isSuccessResult ? " and successfully signed up for other email addresses" : "";   //No i18N
			ZDBAlertAPI.showErrorMsg("Following signup failed: \n"+failure+"\n"+messg);   //No I18N
		}
	}
	
	this.multiUserSignUpFailure = function(response, requestOptions)
	{
		var respMsg = response.getResponsePart("STATUS_MESSAGE");//No I18N
	    var newDigest = response.getResponsePart("DIGEST");
	    $("captchaval").value = "";
	    if(newDigest != null)
	    {
	      ZDBDomainRebrand.handleCaptchFailure(newDigest.trim());
	    }
	    ZDBAlertAPI.showErrorMsg("SignUp Failed : " +respMsg); //No I18N
	}
	
	this.deleteUserSignUp = function(el)
	{
		var multiUserSignUp = el.parentElement.parentElement;
		$("ZRMultiUserSignUp").removeChild(multiUserSignUp);
		this.totalUser--;
	}
	
	this.appendSignUpContent = function(response, requestOptions)
	{
		$("ZRDomainMultiUserSignUp").innerHTML = response.getOnlyHtml();
		$("captchaval").setAttribute('size',$("captchaval").getAttribute("placeHolderValue").length);
		RebrandAdminDialog.attachEventListener();
		DMMultiUserSignUp.signUpContentLoaded = true;
	}
	
	this.suggestValues = function(el)
	{
		var userEl = ZDBUtil.getParentWithAttributeValue(el, "name", "MultiUserSignUp"); //No I18N
		ZDBUtil.setNamedChildEls(userEl,userEl);
		userEl.displayname.value = userEl.username.value;
	}
}

var ZRDMClientUI = new function()
{
	this.handleWindowResize = function()
	{
		var height = jQuery(document.body).height();
		var width = jQuery(document.body).width();
		this.dmContainerEl.style.height = (height - this.headerHeight - 3) + "px";
		this.dmSettingEl.style.height = (height - (this.headerHeight + this.dmListElHeight) - this.bottomMargin) + "px";
		$("ZRDMConfigHdrName").style.width = (width - this.leftCntrWidth - this.fixedWidthAddRmv) + "px"; //No I18N
		$("ZRControlPanelNav").style.width = (width - this.leftCntrWidth + this.fixedWidthAddRmv) + "px"; //No I18N
	}
	
	this.initSize = function()
	{
		this.bottomMargin = 20;
		this.fixedWidthAddRmv = 100;
		var height = jQuery(document.body).height();
		var width = jQuery(document.body).width();
		var mainEl = $("ZRDMMainEl").getElementsByTagName("div");
		for(var i = 0; i < mainEl.length; i++)
		{
			if(mainEl[i].hasAttribute("elName")) 
			{
				var elNameAttrVal = mainEl[i].getAttribute("elName");
				if(elNameAttrVal == "ZRDMContainer")
				{
					this.dmContainerEl = mainEl[i];
					this.headerHeight = $("ZDBMainHeader").offsetHeight;
					this.dmContainerEl.style.height = (height - this.headerHeight - 3) + "px";
				}
				else if(elNameAttrVal == "ZRDMListEl")
				{
					this.dmListElHeight = mainEl[i].offsetHeight;
				}
				else if(elNameAttrVal == "ZRDMSetting" && this.dmContainerEl)
				{
					this.dmSettingEl = mainEl[i];
					this.dmSettingEl.style.height = (height - (this.headerHeight + this.dmListElHeight) - this.bottomMargin) + "px";
				}
				else if(elNameAttrVal == "ZRDMHeader")
				{
					this.dmHeaderHeight = mainEl[i].offsetHeight;
				}
				else if(elNameAttrVal == "dlgForm")
				{
					this.dlgForm = mainEl[i];
				}
				else if(elNameAttrVal == "ZRDMLeftContr")
				{
					this.leftCntrWidth = mainEl[i].offsetWidth;
					$("ZRDMConfigHdrName").style.width = (width - this.leftCntrWidth - this.fixedWidthAddRmv) + "px"; //No I18N
					$("ZRControlPanelNav").style.width = (width - this.leftCntrWidth + this.fixedWidthAddRmv) + "px";//No I18N
				}
			}
		}
	}
}

var IPAddressUtil = new function()
{ 
  this.isValidPubliIP = function(value)
  {
    var id = value.split(".");
    var idLen = id.length;
    if(idLen == 4 && id[idLen-1] != "" && this.canBeValidPublicIP(value)){
      return true;
    }
    return false;
  }

  this.canBeValidPublicIP = function(value)
  {
    var pattern = /^([\d]{1,3}|([\d]{1,3}\.|([\d]{1,3}\.[\d]{1,3}|([\d]{1,3}\.[\d]{1,3}\.|([\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}|([\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}\.|([\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}|)))))))$/;
    if(!pattern.test(value))
    {
      return false;
    }
    var id = value.split(".");
    var idLen = id.length;
    if(id[0] == 0 || id[0] == 127 || id[0] == 172 || id[0] == 192 || id[0] > 223 || (id[idLen-1] == "" && id[0] == 10))
    {//Private address,Loopback address,Not an address
      return false;
    }
    for(var i=1; i<idLen; i++)
    {
      if(id[i] > 255)
      {
        return false;
      }
    }
    return true;
  }

  this.isValidPublicToIp = function(fromIP, toIP)
  {
    var toIPId = toIP.split(".");
    var toIPIdLen = toIPId.length;
    if(toIPIdLen == 4 && toIPId[toIPIdLen-1] != "" && this.isToIPGreaterThanOrEqualToFromIP(fromIP, toIP))
    {
      return true;
    }
    return false;
  }

  this.canBeValidPublicToIp = function(fromIP, partialToIP)
  {
    if(!this.canBeValidPublicIP(partialToIP))
    {
      return false;
    }
    return this.canBeToIPGreaterThanOrEqualToFromIP(fromIP, partialToIP);
  }

  this.isValidPublicFromToIP = function(fromIP, toIP)
  {
    if(this.isValidPubliIP(fromIP))
    {
      return this.isValidPublicToIp(fromIP, toIP);
    }
    return false;
  }

  this.isToIPGreaterThanOrEqualToFromIP = function(fromIPVal, toIPVal)
  {
    if(!this.canBeToIPGreaterThanOrEqualToFromIP(fromIPVal, toIPVal))
    {
      return false;
    }
    var idTo = toIPVal.split(".");
    var idToLen = idTo.length;
    var idFrom = fromIPVal.split(".");
    for(var i=0; i<idToLen; i++)
    {
      var idFromPart = Number(idFrom[i]);
      var idToPart = Number(idTo[i]);
      if(idFromPart > idToPart)
      {
        return false;
      }
      else if(idFromPart < idToPart)
      {
        return true;
      }
    }
    return true;
  }

  this.canBeToIPGreaterThanOrEqualToFromIP = function(fromIPVal, toIPVal)
  {
    var idFrom = fromIPVal.split(".");
    var idTo = toIPVal.split(".");
    var idToLen = idTo.length;

    if(idTo[idToLen-1] == "")
    {
      for(var i=0; i<idToLen-1; i++)
      {
        var idFromPart = Number(idFrom[i]);
        var idToPart = Number(idTo[i]);
        if(idFromPart > idToPart)
        {
          return false;
        }
        else if(idFromPart < idToPart)
        {
          return true;
        }
      }
      return true;
    }

    for(var i=0; i<idToLen; i++)
    {
      var idFromPart = Number(idFrom[i]);
      var idToPart = Number(idTo[i]);
      var idFromHundredthDigVal = Math.floor(idFromPart/100);
      var idFromTenthDigVal = Math.floor(idFromPart/10);
      var idToHundredthDigVal = Math.floor(idToPart/100);
      var idToTenthDigVal = Math.floor(idToPart/10);

      if(idFromHundredthDigVal > 0)
      {//From IP: 3 digit
        if(idToHundredthDigVal == 0)
        {//To IP: 1 or 2 digit
          if(idToTenthDigVal == 0)
          {//To IP: 1 digit
            if(idFromHundredthDigVal > idToPart || idToPart > 2)
            {
              return false;
            }
          }
          else if((idFromTenthDigVal > idToPart) || (i == 0 && idToPart > 22) || (i > 0 && idToPart > 25))
          {//To IP: 2 digit
            return false;
          }
        }
        else if(idFromPart > idToPart)
        {//To IP: 3 digit
          return false;
        }
        else if(idFromPart < idToPart)
        {//To IP: 3 digit
          return true;
        }
      }
      else if(idToHundredthDigVal > 0)
      {//From IP: 1 or 2 digit, To IP: 3 digit
        if((i == 0 && idToTenthDigVal > 22) || (i > 0 && idToTenthDigVal > 25))
        {
          return false;
        }
      }
    }
    return true;
  }
}
