//$Id$
/*Export Methods*/



var ZDBExport = new function()

{


  this.toggleCheck = function(element, event, elementID)

  {
    var element = $(elementID);

    if(element.getAttribute("value") == "true")

    {

      element.setAttribute("value","false");

      element.removeAttribute("checked");

    }

    else

    {

      element.setAttribute("value","true");

      element.setAttribute("checked","true");

    }

    ZDBUtil.clearTextSelection();

  }



  this.storeExportRefs = function()

  {

    var props = ["ZDBCSVExportName","EXPORTDELIMITER", "EXPORTRECORDDELIM", "EXPORTQUOTED", "EXPORTHEADERROW", "EXPORTHIDDEN", "EXPORTROWIDS", "CREATEDIALOG"];     //No I18N

    var propsLen = props.length;

    ZDBGlobal.exportDIV = $("exportDIV");

    for(var i=0;i<propsLen;++i)

    {

      ZDBGlobal.exportDIV[props[i]] = $(props[i]);

    }

  }

//  this.changeTab = function(tab,mainTableId)
//  {
//    var parentTable = document.getElementById(mainTableId);
//    var classtoapply = tab.getAttribute("selectionclass");
//    parentTable.className = classtoapply;
//    var focusEl = tab.getAttribute("focusel");
//    ZDBUtil.setFocus($(focusEl),true);
//  }

  this.getExportWhat =
                {
                  "report" : ["view", "base", "data"],      //No I18N
                  "analysis" :["view", "under"],    //No I18N
                  "vud" : ["data"], //No I18N
                  "summary" : ["view", "under", "data"],    //No I18N
                  "pivot" : ["view", "under", "data"],  //No I18N
                  "sheet" : ["view"],    //No I18N
                  "tabledesign" : ["data"] // No I18N
                }


  this.exportAsCSV = function(element,viewType,isEmail,frm)
  {
      var qa;
      try
      {
         qa = $("ZDBCSVExportQAFile").getAttribute("qa");
      }
      catch(e){}
      if(qa != null && qa != undefined && qa != "false")
      {
        var onsuccessfunc = $("ZDBExportCSVForm").getAttribute("onsuccessfunc");
        var onfailurefunc = $("ZDBExportCSVForm").getAttribute("onfailurefunc");
        this.exportData(element,viewType,"CSV",false,isEmail,null,onfailurefunc,onsuccessfunc);   //No I18N
      }
      else
      {
        this.exportData(element,viewType,"CSV",false,isEmail,frm); //No I18N
      }
  }



  this.exportData = function(element,viewType,exportType,isMulti, isEmail, frm,onfailurefunc,onsuccessfunc)

  {
        var prefix = (isMulti) ? "MV" : "" ;    //No I18N

        var outFile = $("ZDB"+ prefix + exportType +"ExportName").value;

        if(outFile.trim() == "")
        {
            var elem = $("ZDB"+ prefix + exportType +"ExportName");
            var par = ZDBUtil.getParentWithAttr(elem,"inlinediv");
            par.scrollTop =0;
            ZDBUtil.setFocus(elem,true)
            showCustomMessage(ZDBI18NMap.g('zrpt.common.pdfexport.zdbalertmsg.js.fileNameErr'),elem);
            return;
        }

        if(exportType == "PDF" && !ZDBPDFExport.validateMargins(prefix))
        {
            return;
        }
        

        var exportParams = this.getExportParams(element, viewType, exportType, isMulti,outFile);

        if(exportParams == "NO_VIEW_SELECTED")
        {
            return ZDBReportMail.handleInlineErrorCode(exportParams,$("MV"+exportType+"EXPORTALL"),"ZDB"+prefix+exportType+"TAB1",prefix+exportType+"MainTable");//No I18N
        }
        else if(exportParams == "NO_COL_SELECTED")
        {
            return ZDBReportMail.handleInlineErrorCode(exportParams,$("EXPORTALL"),"ZDB"+prefix+exportType+"TAB1",prefix+exportType+"MainTable");//No I18N
        }
       else if(exportParams == "IMG_WIDTH_ERR")
       {
            return ZDBReportMail.handleInlineErrorCode("IMG_WIDTH_ERR",$("ZDBMVIMGWidth"),"ZDBIMGTAB1","IMGMainTable");//No I18N
       }
       else if(exportParams == "IMG_HEIGHT_ERR")
       {
            return ZDBReportMail.handleInlineErrorCode("IMG_HEIGHT_ERR",$("ZDBMVIMGHeight"),"ZDBIMGTAB1","IMGMainTable");//No I18N
       }
       else if(exportParams == "NOT_VALID_ZOOMFACTOR")
       {
            return ZDBReportMail.handleInlineErrorCode("NOT_VALID_ZOOMFACTOR",$("ZDBPDFExportZFactor"),"ZDB"+prefix+exportType+"TAB1",prefix+exportType+"MainTable");//No I18N
       }
       else if(exportParams == "PASSWORD_VERIFICATION_FAILED")
    	   {
    	   		return ZDBReportMail.handleInlineErrorCode("PASSWORD_VERIFICATION_FAILED",$("VERIFYPASSWORD"),"ZDB"+prefix+exportType+"TAB1",prefix+exportType+"MainTable");//No I18N
    	   }
       else if(exportParams == "INVALID_PASSWORD")
    	   {
    	   		return ZDBReportMail.handleInlineErrorCode("INVALID_PASSWORD",$("EXPPASSWORD"),"ZDB"+prefix+exportType+"TAB1",prefix+exportType+"MainTable");//No I18N
    	   }

        exportParams = "ZDBACTION=EXPORT&"+exportParams; //No I18N

        var url = ZDBGlobal.CTX + "/export?"+exportParams; //No I18N
        ZDBInlineDialog.closeDialog();
        ZDBExport.exportViaIframe(url,onfailurefunc,onsuccessfunc);
        ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.common.export.js.expsubconf"));
  }

  this.getExportWhatTo = function(exportType, isMulti)
  {
        if((exportType=="CSV" || exportType=="ZSHEET") && !isMulti)
        {
          exportWhat = $("EXPORTWHAT")[$("EXPORTWHAT").selectedIndex].value
        }
        else if(exportType=="HTML" && !isMulti)
        {
          exportWhat = $("ZDBHTMLEXPORTWHAT")[$("ZDBHTMLEXPORTWHAT").selectedIndex].value
        }
        else if(exportType == "XLS")
        {
           exportWhat = $("XLSEXPORTWHAT")[$("XLSEXPORTWHAT").selectedIndex].value
        }
        else
        {
           exportWhat = "view"; //NO I18N
        }

        return exportWhat;
  }

  this.getExportParams = function(element, viewType, exportType, isMulti, outFile,viewId,isEditSchedule,ISNORMALDBEXP)
  {
     
        var viewObj = ZDBClientUI.getViewObj(element,"view");   //No I18N
        if(viewType == "tabledesign")
        {
          viewObj = ZDBClientUI.getViewObj(element,"gridObj");   //No I18N
        }
        var prefix = (isMulti) ? "MV" : "" ;    //No I18N

        var exportWhat = ZDBExport.getExportWhatTo(exportType, isMulti);

        if (ISNORMALDBEXP == null)
            {
              ISNORMALDBEXP=element.getAttribute("ISNORMALDBEXP");
            }
       var objId = viewId ? viewId : (isMulti ? "" : ((exportWhat == "base")? viewObj.parentViewId:viewObj.objId));//No I18N
       var exportParams = objId != "" ? "OBJID="+objId+"&" : ""; //No I18N 
       exportParams += "DBID="+ZDBClientUI.dbId+"&"; //No I18N
       exportParams += "OUTFILE=" + encodeURIComponent(outFile) + "&EXPORTTYPE=" + exportType + "&WHATTO=" + exportWhat; //No I18N

       if(exportWhat == 'under')
       {
            var formId = (exportType=="ZSHEET") ? "ZSheetExportForm" : "ZDBExport"+ prefix + exportType +"Form";//No I18N
            var frm = $(formId);
            viewType = "vud"; // Can I do this here?    //No I18N
            if(frm && frm.VUDTBLOBJID)
            {
                exportParams +="&VUDTBLOBJID="+frm.VUDTBLOBJID.value; //No I18N
            }
       }
       
       var isDashChildNIncludeDashUF=(!isMulti && viewObj.viewCtx.dashChildDiv && viewObj.viewCtx.dashChildDiv.getAttribute("excludeDashGlobalFilters") == "false");
       if((viewType=="sheet" || viewType == "report") && !isEditSchedule && isDashChildNIncludeDashUF)
       {
           var dashViewConfig = ZDBClientUI.getViewObj(ZDBClientUI.placeHolder, "view");
           exportParams += ZDBExport.getConfigOfDashBoardUF(dashViewConfig,viewObj.viewCtx)+"&DASHBOARDID="+dashViewConfig.objId; //No I18N
       }
       
       var passwordParams = (exportType != "ZSHEET") ? ZDBExport.setPasswordParams(exportType, isMulti, isEditSchedule) : "";	//No I18N
       if(passwordParams == "INVALID_PASSWORD" || passwordParams == "PASSWORD_VERIFICATION_FAILED")
    	   {
    	   		return passwordParams;
    	   }
       exportParams += passwordParams;
       
       if(viewType)
       {
           switch(viewType)
           {
             //Please do not use WHICHVIEW parameter that has been sent to server in case of multivew export. This parameter has to be used only in ZDBExportServlet.java and for SingleViewExport
             case "sheet":  //No I18N
                 exportParams += "&WHICHVIEW=SHEET"; //No I18N
                 if(!isEditSchedule){exportParams += "&GRIDID=" + viewObj.ID+"&" + viewObj.getSimpleFilter(false) + viewObj.getDirectFilter();}
             break;

             case "report":  //No I18N
                 exportParams +=((exportWhat == 'base')? "&WHICHVIEW=SHEET" //No I18N
                              : "&WHICHVIEW=REPORT");  //No I18N
                 if(!isEditSchedule){exportParams += "&GRIDID=" + viewObj.ID+"&" + viewObj.getSimpleFilter(false) + viewObj.getDirectFilter();}
                 break;

             case "analysis":    //No I18N
                 exportParams +="&WHICHVIEW=ANALYSIS";//No I18N
                 if(!isEditSchedule)
                 {
                    exportParams += "&CONFIGASXMLINFORM=true&ZAGRIDTYPE=AnalysisSheet"; //No I18N
                    if(exportType == "PDF"){exportParams += "&VIEWTYPE="+viewObj.graphSelected;} //NO I18N
                    exportParams +=ZDBExport.getConfigXmlAsParam(viewObj,"AnalysisSheet");//No I18N                    
                    exportParams +=ZRSDrillDown.getDrillParams(viewObj);                    
                    exportParams += ZDBExport.getBubbleParams(viewObj);
                 } //No I18N
                 break;

             case "vud": //No I18N
                 exportParams +="&WHICHVIEW=ANALYSIS"; //No I18N
                 if(!isEditSchedule)
                 {
                     exportParams += "&CONFIGASXMLINFORM=true&ZAGRIDTYPE=VUDSheet";//No I18N
                     exportParams +=ZDBExport.getConfigXmlAsParam(viewObj,"VUDSheet"); //No I18N                                          
                     if(!(ZDBAnalysisViewAPI.isAnalysisView(viewObj) && exportWhat == "under"))
                     {
                         exportParams += viewObj.getDirectFilter();
                         
                     }
                      exportParams += viewObj.getDrillDet();
                 
                 }
                 break;

             case "summary": //No I18N
                 exportParams +="&WHICHVIEW=SUMMARY";//No I18N
                 if(!isEditSchedule)
                 {
                     exportParams += "&CONFIGASXMLINFORM=true&ZAGRIDTYPE=SummarySheet"; //No I18N
                    if(exportType == "PDF"){exportParams += "&VIEWTYPE="+viewObj.graphSelected;} //NO I18N
                    exportParams +=ZDBExport.getConfigXmlAsParam(viewObj,"SummarySheet");//No I18N
                 }
                 break;

             case "pivot":   //No I18N
                 exportParams +="&WHICHVIEW=PIVOT";//No I18N
                 if(!isEditSchedule)
                 {
                    exportParams += "&CONFIGASXMLINFORM=true&ZAGRIDTYPE=PivotSheet"; //No I18N
                    if(exportType == "PDF"){exportParams += "&VIEWTYPE="+viewObj.graphSelected;} //NO I18N
                    exportParams +=ZDBExport.getConfigXmlAsParam(viewObj,"PivotSheet"); //No I18N
                 }
                 break;

             case "dashboard":   //No I18N
                 exportParams+="&WHICHVIEW=DASHBOARD"; //No I18N
                 exportParams+="&FROMDASHBOARD=true" //NO I18N
                  if(!isEditSchedule)
                 {
                     var zadoList = ZDBExport.getConfigsForDashBoardViews(viewObj,exportParams, ISNORMALDBEXP=="true");
                     exportParams+=zadoList;
		     if(typeof ZRSDrillDown != 'undefined')
		     {
			exportParams +="&DRILLDOWNDET="+ZRSDrillDown.getDrillParamsForDashboard(viewObj); //NO I18N
		     }
                 }
                 break;

             case "multiview"://No I18N
                    break;

             case "tabledesign": // No I18N
                  exportParams += "&WHICHVIEW=TABLEDESIGN"; //No I18N
                  exportParams += "&GRIDID=" + viewObj.ID + "&" + ZDBDesignGrid.getSearchValue(viewObj); //No I18N
                  break;

             default:
                 alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.unknownExpViewType") + viewType);
                 return;
            }
       }

        if(exportType == "CSV")
        {
          var exportOpts = ((isMulti)? ZDBExport.getExportOptions(true,viewType): ZDBExport.getExportOptions(false,viewType));
          if(exportOpts == "NO_VIEW_SELECTED" || exportOpts == "NO_COL_SELECTED")
          {
             return exportOpts;
          }
          exportParams +="&" + exportOpts;
        }
        else if(exportType == "ZSHEET")
        {
        	exportParams += ZRCloudUpload.getExportOptions(viewType);
        }
        else if(exportType == "XLS")
        {
          var exportOpts = ZDBXLSExport.getExportOptions(viewType);
          if(exportOpts == "NO_COL_SELECTED")
          {
             return exportOpts;
          }
          exportParams +="&" + exportOpts;
        }
        else if(exportType == "HTML")
        {
          var exportOpts = ZDBHTMLExport.getExportOptions(isMulti,viewType);
          if(exportOpts == "NO_VIEW_SELECTED" || exportOpts == "NO_COL_SELECTED")
          {
             return exportOpts;
          }
          exportParams +=exportOpts;
        }
        else if(exportType == "IMG")
        {
          var exportOpts = ZDBImgExport.getExportOptions();
          if(exportOpts == "NO_VIEW_SELECTED" || exportOpts  == "IMG_WIDTH_ERR" || exportOpts == "IMG_HEIGHT_ERR")
          {
             return exportOpts;
          }
          exportParams +="&" + exportOpts;
        }
        else
        {
          var exportOpts =   ((isMulti)? ZDBPDFExport.getExportOptions(true,viewType,ISNORMALDBEXP): ZDBPDFExport.getExportOptions(false,viewType,ISNORMALDBEXP));
          //var exportOpts =   ((isMulti)? ZDBPDFExport.getExportOptions(true): ZDBPDFExport.getExportOptions(false,viewType));
          if(exportOpts == "NO_VIEW_SELECTED" || exportOpts == "NO_COL_SELECTED" || exportOpts=="NOT_VALID_ZOOMFACTOR")
          {
             return exportOpts;
          }
          exportParams +="&" + exportOpts;
        }
        if((typeof ZDBQa) == "object")
        {
           exportParams = ZDBExport.addParamsExpQa(prefix,exportType,exportParams);  //Qa purpose
        }

        if(!isMulti && !isEditSchedule)
        {
           exportParams += viewObj.viewCtx.getAdditionalParams();
        }

        return exportParams;
  }

    this.getBubbleParams = function(view)
    {
        return (view.graphSelected === "BUBBLE") ? "&AGGAXIS=" + ZDBAnalysisView.getAggregateAxis(view) : ""; //No I18N
    };
    
   this.addParamsExpQa = function(prefix,exportType,exportParams)
   {
      var id,csvQa;
      try
      {
         id = "ZDB"+prefix+exportType+"ExportQAFile"; //No I18N
         csvQa = $(id).getAttribute("qa");
      }
      catch(e){}

      if(csvQa)
      {
         var qaFile = $(id).getAttribute("fileName");
         var refDir = $(id).getAttribute("refDir");
         var streamFile = $(id).getAttribute("streamFile");
	 var vwdir = $(id).getAttribute("vwdir");

         if(qaFile)
         {
            exportParams += "&QA=true&REFFILENAME="+qaFile; //No I18N
         }
         if(refDir)
         {
            exportParams += "&ZDBQAREFSUBDIR="+refDir;   //No I18N
         }
         if(vwdir == "vwdir")
         {
            exportParams += "&VWDIR="+vwdir; //No I18N
         }
         if(streamFile)
         {
             exportParams += "&QASTREAMCHECK="+streamFile;   //No I18N
         }
         return exportParams;
      }
   }

  this.closeErrMes = function()
  {
      hideCustomMessage();
  }

  
  this.getConfigOfDashBoardUF = function(dashViewObj,viewCtx) //Includes time line filter too
  {
    var xmlBuf = new ZDBStrBuf();
    ZAVMFilter.getAllVMFilterCriteria(dashViewObj,xmlBuf);
    xmlBuf.a(ZRTimelineFilter.getAllTimelineFilterCr(dashViewObj,viewCtx));
    var dashDynf = encodeURIComponent(xmlBuf);
    var zadoList =""; //NO I18N
    if(dashDynf!=null && dashDynf!="")
    {
      var xml = "<crXml OBJID='" + dashViewObj.objId + "' ZAGRIDTYPE='"+dashViewObj.type+"'>\n"+dashDynf+"</crXml>"; //NO I18N
      zadoList +="&ZDBDASHDF="+dashViewObj.objId+"<-ID-SPLIT->"+xml; //NO I18N
    }
    return zadoList;
  }

  this.getConfigXmlAsParam = function(viewObj,type)

  {
    if(viewObj.type == "VUDSheet")
    {
      var conf = viewObj.getConfigAsXML();
      return "&ZADO=" + encodeURIComponent(conf); //No I18N
    }
    else
    {
      return "&ZADO=" + encodeURIComponent(viewObj.getConfigAsXMLForGrid(type));    //No I18N
    }
  }

  this.getConfigsForDashBoardViews = function(viewObj,exportParams, ISNORMALDBEXP)
  {
    var dashDiv = viewObj.dashDiv;
    var dashViews = DOMUtils.getChildElsWithAttr(dashDiv, "eltype", "VIEW"); //NO I18N
    var xmlBuf = new ZDBStrBuf();
    ZAVMFilter.getAllVMFilterCriteria(viewObj,xmlBuf);
    xmlBuf.a(ZRTimelineFilter.getAllTimelineFilterCr(viewObj));
    var dashDynf = encodeURIComponent(xmlBuf);
    var zadoList ="&ZDBDASHDF="; //NO I18N
    var isHTML = (exportParams && (exportParams.indexOf("EXPORTTYPE=HTML") > -1)) || ISNORMALDBEXP;//NO I18N
    var widgetIndex = ($("ZDBGENERATEWIDGET"))?$("ZDBGENERATEWIDGET").selectedIndex:0;//NO I18N
    var includeWidgets = widgetIndex > 0;
    if(dashDynf!=null && dashDynf!="")
    {
      var xml = "<crXml OBJID='" + viewObj.objId + "' ZAGRIDTYPE='"+viewObj.type+"'>\n"+dashDynf+"</crXml>"; //NO I18N
      zadoList +=viewObj.objId+"<-ID-SPLIT->"+xml; //NO I18N
    }
    zadoList += "&ZADO=";   //NO I18N
    for(var i=0;i<dashViews.length;i++)
    {
        var el = dashViews[i];
        var viewType = el.getAttribute("viewtype");
        var objView = (viewType==='WIDGET')?el.view:el.ctx.view;//NO I18N
        var isAnalysisView = ZDBAnalysisViewAPI.isAnalysisView(objView);
        if(isAnalysisView || (viewType === 'WIDGET' && (isHTML || includeWidgets)))
        {
            var viewID = el.getAttribute("objid");
            var zado= encodeURIComponent(objView.getCriteriaAsXMLForGrid(viewType));            
            if(zado.indexOf("zavmf")>0 || zado.indexOf("zalc")>0 || zado.indexOf("zclc")>0 || zado.indexOf("zrtl")>0)
            {
                zadoList+=viewID.toString()+"<-ID-SPLIT->"+zado; //NO I18N
                if(i<dashViews.length-1)
                    {
                        zadoList+="<-DO-Split->";    //NO I18N
                    }
            }
        }
    }
    return zadoList;
  }
  
  this.getConfigsForDashBoardViews_new = function(viewObj,exportParams, ISNORMALDBEXP)
  {
    var dashViews = ZRDashboardLayoutAPI.viewsInDashboard(viewObj);
    var xmlBuf = new ZDBStrBuf();
    ZAVMFilter.getAllVMFilterCriteria(viewObj,xmlBuf);
    xmlBuf.a(ZRTimelineFilter.getAllTimelineFilterCr(viewObj));
    var dashDynf = encodeURIComponent(xmlBuf);
    var zadoList ="&ZDBDASHDF="; //NO I18N
    var isHTML = (exportParams && (exportParams.indexOf("EXPORTTYPE=HTML") > -1)) || ISNORMALDBEXP;//NO I18N
    var widgetIndex = ($("ZDBGENERATEWIDGET"))?$("ZDBGENERATEWIDGET").selectedIndex:0;//NO I18N
    var includeWidgets = widgetIndex > 0;
    if(dashDynf!=null && dashDynf!="")
    {
      var xml = "<crXml OBJID='" + viewObj.objId + "' ZAGRIDTYPE='"+viewObj.type+"'>\n"+dashDynf+"</crXml>"; //NO I18N
      zadoList +=viewObj.objId+"<-ID-SPLIT->"+xml; //NO I18N
    }
    zadoList += "&ZADO=";   //NO I18N
    for(var i=0;i<dashViews.length;i++)
    {
    	var view = dashViews[i];
    	var isAnalysisView = ZDBAnalysisViewAPI.isAnalysisView(view);
    	if(isAnalysisView || (view.viewType === 'WIDGET' && (isHTML || includeWidgets))){
    		var viewId = view.viewId;
    		var zado = encodeURIComponent(view.getCriteriaAsXMLForGrid(view.viewType));
    		if(zado.indexOf("zavmf")>0 || zado.indexOf("zalc")>0 || zado.indexOf("zclc")>0 || zado.indexOf("zrtl")>0){
    			zadoList+=viewID.toString()+"<-ID-SPLIT->"+zado; //NO I18N
    			if(i<dashViews.length-1){
    				zadoList+="<-DO-Split->";    //NO I18N
    			}
    		}
         
    	}
    }
    return zadoList;
  }


  this.getExportOptions = function(isMulti,viewType)

  {

    var prefix = (isMulti) ? "MV" : "" ; //No I18N

    var exportOptions = "MULTIVIEW=" + isMulti; //No I18N

    exportOptions += "&FIELDDELIM=" + encodeURIComponent($(prefix+"FIELDDELIM")[$(prefix+"FIELDDELIM").selectedIndex].value);

    exportOptions += "&RECORDDELIM=" + encodeURIComponent($(prefix+"RECORDDELIM")[$(prefix+"RECORDDELIM").selectedIndex].value);

    exportOptions += "&QUALIFIER=" + encodeURIComponent($(prefix+"QUALIFIER")[$(prefix+"QUALIFIER").selectedIndex].value);

    exportOptions += "&HEADER=" + $(prefix+"HEADER").value; //No I18N

    if(!isMulti)
   {
       exportOptions += "&HIDDEN=" + $("HIDDEN").value; //No I18N
       exportOptions += "&ROWIDS=" + $("ROWIDS").value;   //No I18N
       var showUfCr = (!$("showUFCr")) ? false :$("showUFCr").checked;
       exportOptions+="&SHOWUFCR="+showUfCr.toString();//NO I18N
       
       var showDrillFlow = (!$("showDrillFlow")) ? false :$("showDrillFlow").checked;
       exportOptions+="&SHOWDRILLFLOW="+showDrillFlow.toString();//NO I18N
       
       if(viewType == "sheet" || viewType == "report")
       {
	       var listTbl = $("COLUMNLIST");
	       var selectedCols = ZDBExport.getColsListForExport(listTbl);
	       if(selectedCols=="")
	        {
	            return "NO_COL_SELECTED"; //No I18N
	        }
	      exportOptions+= "&SELECTCOL=" + selectedCols;	//No I18N
       }
   }
   else
   {
       var listTbl = $("CSVSELECTEDLISTDIV");
       var selectedviews=ZDBExport.getViewsListForMV(listTbl);
       if(selectedviews=="NO_VIEW_SELECTED")
        {
            return "NO_VIEW_SELECTED"; //No I18N
        }
      exportOptions+=selectedviews;
     }
    return exportOptions;
  }
  
 this.getColsListForExport = function(listTbl)
 {
	 var allCols = listTbl.querySelectorAll("td[name='COLNAME']");	//No I18N
	 var exportOptions = "";
      for(var i = 0; i < allCols.length; i++)
      {
          if(allCols[i].getAttribute("ischecked") == "true")
          {
            exportOptions += allCols[i].getAttribute("colid") + ","; //No I18N
          }
      }
      exportOptions = exportOptions.slice(0,-1);
      return exportOptions;
 }

 this.getViewsListForMV=function(listTbl)
 {       
    
     var viewsList="";
     var selectedColumns = jQuery(listTbl).children("[name='objListRow']"); // No I18N
     if(selectedColumns.length==0)
         {
            return "NO_VIEW_SELECTED";//No I18N 
         }
     jQuery(selectedColumns).each(function(){
            var rowId=jQuery(this).attr("rowid") // No I18N
            viewsList += "&SELECTOBJID=" +rowId}); // No I18N
     return viewsList;
  }



  this.resetExportForm = function(frm,viewType)
  {
    var frm = document.getElementsByName("ZDBExportForm")[0];
    frm["ZDBCSVExportName"].value = ""; //No I18N
    var exportList = frm["EXPORTWHAT"];
    exportList.selectedIndex = 0;
    var options = exportList.options;
    var optLen = options.length;
    for(var i=0;i<optLen;++i)
    {
      if(options[i].value != "select")
      {
        options[i].removeAttribute("disabled");
      }
      options[i].removeAttribute("selected");
    }
    options[0].setAttribute("selected", "true");
    $("ZDBCSVVIEWTYPE").value = viewType;
    ZDBExport.changeStatus(exportList);
    // The code looks very ugly
    exportList = frm["FIELDDELIM"];
    exportList.selectedIndex = 0;
    exportList = frm["RECORDDELIM"];
    exportList.selectedIndex = 1;
    
//    frm["HEADER"].setAttribute("checked","true");      //No I18N
    frm["HEADER"].checked = true;
//    frm["HEADER"].value = "true";  //No I18N
//    frm["HIDDEN"].removeAttribute("checked")  //No I18N
    frm["HIDDEN"].checked = false;
//    frm["HIDDEN"].value = "false";    //No I18N
    frm["ROWIDS"].removeAttribute("checked")  //No I18N
    frm["ROWIDS"].checked = false;
    frm["ROWIDS"].value = "false";    //No I18N
    exportList = frm["QUALIFIER"];
    exportList.selectedIndex = 1;
  }



  this.setExportOptions = function(listElement, arrOptions)

  {
        var allOptions = {

      view: ZDBI18NMap.g('zrpt.common.export.js.expOpt1'),

      under: ZDBI18NMap.g('zrpt.common.export.js.expOpt2'),

      base: ZDBI18NMap.g('zrpt.common.export.js.expOpt2'),

      data: ZDBI18NMap.g('zrpt.common.export.js.expOpt3'),

      chart: ZDBI18NMap.g('zrpt.common.export.js.expOpt4'),

      dash: ZDBI18NMap.g('zrpt.common.export.js.expOpt5')}

    listElement.innerHTML = ""

    for(var i=0;i<arrOptions.length;++i)

    {

      var newOpt = document.createElement("option");

      newOpt.setAttribute("value", arrOptions[i]);

      newOpt.innerHTML = ZDBEscapeUtil.encodeForHtml(allOptions[arrOptions[i]]);

      listElement.appendChild(newOpt);

    }

  }



  this.setOptionDisabled = function(listElement, indices, disableOn)

  {

    try

    {

      if(indices instanceof Array)

      {

        for(var i=0;i<indices.length;++i)

        {

          disableOn ? listElement.options[indices[i]].setAttribute("disabled","true"):

          listElement.options[indices[i]].removeAttribute("disabled");

        }

      }

      else

      {

        disableOn ? listElement.options[indices].setAttribute("disabled","true"):

        listElement.options[indices].removeAttribute("disabled");

      }

    }

    catch(e)

    {

      return  "Error occured";      //No I18N

    }

  }



  this.exportViaIframe = function(url,onFailureFunc,onSuccessFunc)

  {

    var splitted = splitURL(url);

    var frm = $("ZDBExportIfrForm");

    ZDBUtil.removeAllChildren(frm);

    var paramMap = parseRequestParams(splitted.query);

    for(var i in paramMap)

    {

      var vals = paramMap[i];

      for(var j=0;j< vals.length;j++)

      {

        if(i == "")

        {

          continue;

        }

        var el = document.createElement("input");

        el.setAttribute("type","hidden");

        el.setAttribute("name",i);

        el.setAttribute("value",decodeURIComponent(vals[j]));

        frm.appendChild(el);

      }

    }

    frm.action=splitted.resource;
    if((onFailureFunc != null) && (onFailureFunc.length > 0))
    {
	frm.setAttribute("onfailurefunc",onFailureFunc);
    }
    if((onSuccessFunc != null) && (onSuccessFunc.length > 0))
    {
        frm.setAttribute("onsuccessfunc",onSuccessFunc);
    }
    AjaxAPI.submit(frm);

  }



}

ZDBExport.showHiddenCols = function(whatto, viewType)
{
  if(viewType == "sheet" || viewType == "report" || viewType == "vud")
  {
    return false;
  }
  else if(viewType == "dashboard")
  {
    return true;
  }
  else if(viewType == "analysis" || viewType == "summary" || viewType == "pivot")
  {
    if(whatto == "under")
    {
      return false;
    }
    return true;
  }
}

ZDBExport.changeStatus = function(el)
{
  var val = el.value;
  var type = $("ZDBCSVVIEWTYPE").value;
  var applyShrchrDiv=$("ZDBApplyShrChr");
  if(applyShrchrDiv)
  {
  applyShrchrDiv.disabled =( val == "under") ? true : false; //No I18N
  applyShrchrDiv.checked=false;
  ZDBReportMail.changeEmailIDTxtBox();
  }
  var aplydefaultUF=$("ZDBDefaultUFChr")
  
  if(aplydefaultUF)
      {
          aplydefaultUF.disabled =( val == "under") ? true : false; //No I18N
          aplydefaultUF.checked=false;
      }
  
  $("HEADER").disabled = ZDBExport.showHeader(val,type);
  
  $("HIDDEN").disabled = ZDBExport.showHiddenCols(val,type);
  $("ROWIDS").disabled = ZDBExport.showHiddenCols(val,type);
// ROWIDS is only for CSV and applies the same condition as Hidden columns; So uses the same method.
  var frm = document.getElementsByName("ZDBExportForm")[0];
  frm["HEADER"].value = $("HEADER").checked ? "true" : "false";//No I18N
  frm["HIDDEN"].value = $("HIDDEN").checked ? "true" : "false";//No I18N
  frm["ROWIDS"].value = $("ROWIDS").checked ? "true" : "false";//No I18N
  
  ZDBExport.checkAndLoadTables(el, 'ZDBExportForm' , 'csv'); //No I18N
}

ZDBExport.showHeader = function(whatto, viewType)
{
  if(viewType == "sheet" || viewType == "report" || viewType == "vud")
  {
    return false;
  }
  else if(viewType == "dashboard")
  {
    return true;
  }
  else if(viewType == "analysis" || viewType == "summary" || viewType == "pivot")
  {
    if(whatto == "chart")
    {
        return true;
    }
    return false;
  }
}

ZDBExport.checkAndLoadTables = function(el , formName , fileType)
{
    var view = ZDBClientUI.getViewObj(el,"view");

    var frm = document.getElementsByName(formName)[0];
    ZDBUtil.setNamedChildEls(frm , frm , "elname" , true);

    //var parentDiv = DOMUtils.getParentWithAttr(el,"comboHolder");
    //DOMUtils.getFirstMatchingChild(parentDiv,"tr","invTable","true");
    var holderRow= frm.invtable;
    var isAnalysisView = ZDBAnalysisViewAPI.isAnalysisView(view);

    if(!isAnalysisView ||  el.value != "under")
    {
        holderRow.innerHTML = "";
        return;
    }
    var params = "ZDBACTION=INV_TABLES"; //No I18N
    if(ZDBGlobal.integrated)
    {
        params += "&INTEGRATIONMODE=true"; //No I18N
    }
    params += "&PARENTVIEWID=" + view.parentViewId+"&FILETYPE="+fileType; //No I18N
    if(!ZDBUtil.isNewView(view))
    {
        params += "&OBJID=" + view.objId; //No I18N
    }
    params += view.viewCtx.getAdditionalParams();

    var xml = ZDBAnalysisConfig.getConfig(view,false);


    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZRInvTables.cc?"+params, //No I18N
                                 REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                                 POSTBODY:xml,
                                              ANALYSISVIEW:view ,
                                              ONSUCCESSFUNC:ZDBExport.handleExportTables,
                                              PLHOLDER:holderRow,
                                              OPSTATUSID:frm.ZDBINVTABLELOAD});//
    //OPSTATUSID:view.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.loadingdiv.js.loading"))}); //No I18N


    return true;
}


ZDBExport.handleExportTables = function(response,requestOptions)
{
      var fieldRow = requestOptions["PLHOLDER"];
      fieldRow.innerHTML = response.getOnlyHtml()
      var el = $("VUDTBLOBJID");
       if(el)
       {
            fieldRow.parentNode.style.display = "";
       }
}

ZDBExport.hackedOnEnterMethod = function(event)
{
 $("EXPORTDATA").click();
}

ZDBExport.getExportOptionsData = function(viewObj ,viewType, exportOptions)
{
    var exportOptionsData = new Object();
    var exportWhat = exportOptions[viewType];

    if(viewObj.csvExpView && !viewObj.csvExpView)
    {
        var newExportWhat = new Array();
        var counter=0;
        for(i=0; i<exportWhat.length; i++)
        {
            if(exportWhat[i] != "view")
            {
                newExportWhat[counter++] = exportWhat[i];
            }
        }
        exportWhat = newExportWhat;
    }
    exportOptionsData["FETCHINVTABLES"] = exportWhat.length == 1 && exportWhat[0] == "under";
    exportOptionsData["EXPORTWHAT"] = exportWhat;
    return exportOptionsData;
}

ZDBExport.exportAsCSVMI = function(element,viewType,isEmail,isEditSchedule,viewId,instanceId)
{
    var viewObj = ZDBClientUI.getViewObj(element,"view"); //No I18N
    if(viewType == "tabledesign")
    {
      viewObj = ZDBClientUI.getViewObj(element,"gridObj");
    }
    var exportDIV = $("exportDIV");
    if(exportDIV == null)
    {
        isEditSchedule = isEditSchedule ? isEditSchedule : false;
        var schParam = "";
        if(isEditSchedule)
        {
             schParam = "&ISEDITSCHEDULE="+isEditSchedule+"&INSTANCEID="+instanceId;//No I18N
        }
       AjaxAPI.sendRequest({URL:"/ZDBExportAsCSV.cc?OBJID="+viewId+"&ISEMAIL="+isEmail+"&VIEWTYPE="+viewType+schParam+viewObj.viewCtx.getAdditionalParams(),
    	   ONSUCCESSFUNC:ZDBExport.handleDlgFetchResp,ONFAILUREFUNC:ZDBReportMail.handleEditFailure,"ELEMENT":element,"VIEWTYPE":viewType,"ISEMAIL":isEmail,"ISEDITSCH":isEditSchedule,"VIEWID":viewId,OPSTATUSID:"ZDBMainLoader"}); //No I18N
       return;
    }

    if(viewType == "tabledesign")
    {
//      $('HEADERROW').style.display = 'none';
      $('ROWIDSROW').style.display = 'none';
      $('COLLISTDIV').style.display = 'none';
    }

    /// The dialog should take the proper inputs to reflect the
    /// viewType and what data to be exported
    viewType = viewType.toLowerCase();

    var dialogDIV = document.createElement("div");

    exportDIV.style.display = "block";

    dialogDIV.appendChild(exportDIV);

    var exportViewName = viewObj.title ? viewObj.title : viewObj.displayName;

    var digTitle = (isEmail == "true") ? ZDBI18NMap.g("zrpt.common.email.js.expDlgTtl") : ZDBI18NMap.g("zrpt.common.export.js.expDlgTtl");

    ZDBInlineDialog.showDialog(dialogDIV,{TITLECLASS:'export',"VIEW":viewObj, TITLE:digTitle, ONENTER: ZDBExport.hackedOnEnterMethod}); //No I18N

    var frm = document.getElementsByName("ZDBExportForm")[0];
    ZDBExport.resetExportForm(frm,viewType);
    if(viewType == "sheet" || viewType == "report")
    {
      ZDBMVExportUtil.checkRUnCheckPDFSelectAll('COLUMNLIST','EXPORTALL','COLNAME'); //No I18N
    }
    if(viewType=="vud")
    {
       var hiddenTr = jQuery(frm["HIDDEN"]).closest('tr').hide();//NO I18N
       var rowIdTr = jQuery(frm["ROWIDS"]).closest('tr').hide();//NO I18N
      (viewObj.showHideColsVisible=="true" || viewObj.showHideColsVisible==true) ? hiddenTr.show() : hiddenTr.hide();
      (viewObj.showHideColsVisible=="true" || viewObj.showHideColsVisible==true) ? rowIdTr.show() : rowIdTr.hide();
    }
    frm.view = viewObj;
    $("EXPORTDATA").onclick = function(){ZDBExport.exportAsCSV(element,viewType,false,frm);};
    $("ZDBCSVExportName").value = exportViewName;
    this.addMailSubAndMes(exportViewName, $("CSVMainTable").getAttribute("fullname")); 
    var exportWhat = ZDBExport.getExportWhat[viewType];
    var exportOptionsData = ZDBExport.getExportOptionsData(viewObj , viewType , ZDBExport.getExportWhat);
    exportWhat = exportOptionsData["EXPORTWHAT"];
    ZDBExport.setExportOptions(frm["EXPORTWHAT"],exportWhat);
    if(viewType == "tabledesign" && $("ZDBCSVTAB2")) // For tabledesign export, Email option should not be there.
    {
      $("ZDBCSVTAB2").style.display='none';
      $("ZDBCSVTAB2").removeAttribute('onclick');
    }
    if(isEmail == "true")
    {
        ZDBInlineDialog.changeTab($("ZDBCSVTAB2"),'CSVMainTable'); //No I18N
    }
    else
    {
        ZDBInlineDialog.changeTab($("ZDBCSVTAB1"),'CSVMainTable'); //No I18N
    }
    
    if($("ZDBScheduleDiv"))
    {
        var display=ZDBClientUI.isDBOwner ? "" : "none";
       $("ZDBScheduleDiv").style.display = (viewObj.type == "VUDSheet" || viewObj.viewCtx.dashView) ? "none" : display;//NO I18N
        $("ZDBSaveSubjectTr").style.display = display;
        $("ZDBSaveMessageTr").style.display = display; 
        $("ZDBApplyShrChrTr").style.display = viewObj.type == "VUDSheet" ? "none" : display;
        if($("ZDBDefaultUFChrElem"))
        {
            $("ZDBDefaultUFChrElem").style.display = viewObj.type == "VUDSheet" ? "none" : display;
        }
    }

    if(isEditSchedule)
    {
        ZDBReportMail.fillScheduleDetails(element);
    }
    else
    {
        if(frm.invtable == null)
        {
            ZDBUtil.setNamedChildEls(frm , frm , "elname" , true);
        }
        frm.invtable.innerHTML = "";

        if(exportOptionsData["FETCHINVTABLES"])
        {
            ZDBExport.checkAndLoadTables(frm["EXPORTWHAT"], 'ZDBExportForm','csv'); //No I18N
        }
    }
}

  ZDBExport.handleDlgFetchResp= function(response,requestOptions)
  {
    var div = document.createElement("div");
    div.innerHTML = response.responseText;
    document.body.appendChild(div);
    var el = requestOptions["ELEMENT"];
    var viewType = requestOptions["VIEWTYPE"];
    var isEmail = requestOptions["ISEMAIL"];
    var isEditSchedule = requestOptions["ISEDITSCH"];
    var viewId = requestOptions["VIEWID"];
    ZDBExport.exportAsCSVMI(el,viewType,isEmail,isEditSchedule,viewId);
  }

    ZDBExport.doExport = function(element, fileType)
    {	
    	var isEmail = element.getAttribute('isemail');
        if(ZDBGlobal.IS_ONPREMISE_BUILD && isEmail == "true")
        {
          var IsConfigured = zroptopbar.isMailConfigured();     
          if(!IsConfigured)
          {
            ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrop.mail.notify.js.errorMsg",ZROPConst.MALTABADDR));
            return;
          }
        }
        var ISNORMALDBEXP= element.getAttribute("ISNORMALDBEXP");   
        var operation = isEmail == "true" ? "email":"export"; //No I18N
        var view = ZDBClientUI.getViewObj(element,"view");      //No I18N
        if(!(ZDBClientUI.checkAskImgSave(view,operation,this)))
        {
          return;
        }
        var viewType = view.type;

        ZDBExport.exportAs(element,fileType,ZDBExport.getExportViewType(viewType),isEmail,ISNORMALDBEXP);
        return false; /// You saying,  Handle Click Event @ document level => No need
    }

    ZDBExport.exportTD = function(element, fileType)
    {
        var view = ZDBClientUI.getViewObj(element,"gridObj");      //No I18N
        if(!(ZDBClientUI.checkAskImgSave(view,"export",this)))
        {
          return;
        }
        var viewType = view.type;

        ZDBExport.exportAs(element,fileType,ZDBExport.getExportViewType(viewType),false,"false");
        return false; /// You saying,  Handle Click Event @ document level => No need
    }

    ZDBExport.getExportViewType = function(viewType)
    {
        switch(viewType)
        {
                case "Table":return "sheet";   //No I18N
                case "QueryTable":return "sheet";  //No I18N
                case "Report":return "report"; //No I18N
                case "AnalysisView":return "analysis"; //No I18N
                case "Pivot":return "pivot";   //No I18N
                case "SummaryView":return "summary";   //No I18N
                case "Dashboard" :return "dashboard";  //No I18N
                case "VUDSheet" :return "vud";  //No I18N
                case "TableDesign" : return "tabledesign"; // No I18N
                default:return null;
        }
    }

ZDBExport.exportAs = function(element,fileType,viewTypeShort,isEmail,ISNORMALDBEXP)
{
  var viewObj = ZDBClientUI.getViewObj(element,"view");
  if(viewTypeShort == "tabledesign")
  {
    viewObj = ZDBClientUI.getViewObj(element,"gridObj");
  }
  var viewId = viewObj.objId;
  var lowerFileType = fileType.toLowerCase();

  if('csv' == lowerFileType)
  {
    ZDBExport.exportAsCSVMI(element,viewTypeShort,isEmail,false, viewId);
  }
  else if('xls' == lowerFileType)
  {
    ZDBXLSExport.exportXLSDialog(element,viewTypeShort,isEmail,false,viewId);
  }
  else if('multiviewcsv' == lowerFileType)
  {
    ZDBMVCSVExport.exportMultiViewDialog(element,isEmail,false,viewId);
  }
  else if('pdf' == lowerFileType)
  {
    ZDBPDFExport.exportPDFDialog(element,viewTypeShort,isEmail,ISNORMALDBEXP,false,viewId);
  }
  else if('multiview' == lowerFileType)
  {
    ZDBPDFExport.exportMultiViewDialog(element,viewTypeShort,isEmail,false,null);
  }
  else if('multiviewimg' == lowerFileType)
  {
    ZDBImgExport.exportMultiViewDialog(element,isEmail,false,viewId);
  }
  else if('html' == lowerFileType)
  {
    ZDBHTMLExport.openHTMLExpDlg(element,viewTypeShort,isEmail,false,viewId);
  }
  else if('multiviewhtml' == lowerFileType)
  {
    ZDBHTMLExport.openMVHTMLExpDlg(element,viewTypeShort,isEmail,false,null); 
  }
  else
  {
    alert(ZDBI18NMap.g("zrpt.common.browser.alert.js.unknownExpFileType")+" " + lowerFileType);
  }
}


ZDBExport.showExportPopup = function(el,event,contentName,moduleName)
 {
	if(ZDBGlobal.IS_ONPREMISE_BUILD + ""=="true"  && contentName=="Email_Menu")
    {
		var IsConfigured = zroptopbar.isMailConfigured();
        if(!IsConfigured)
        {
          ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrop.mail.notify.js.errorMsg",ZROPConst.MALTABADDR));
          return;
        }
    }
    var view = ZDBClientUI.getViewObj(el,"view");    //No I18N
    contentName = (view.type == "Dashboard") ? "DSB_" + contentName : contentName;  //No I18N
    ZDBMenu.showModuleMenu(el,event,contentName,moduleName,true,view);
 }

    ZDBExport.getEmbedExportMenuName = function(viewType) {
        switch (viewType) {
            case "Table" :  //No I18N
            case "QueryTable" :  //No I18N
            case "Report" :  //No I18N
                return "Tbl_Embed_Export_Menu";  //No I18N
            case "AnalysisView":   //No I18N
                return "Embed_Export_Menu";  //No I18N
            case "Pivot":  //No I18N
            case "SummaryView":   //No I18N
                return "SumAndPvt_Embed_Export_Menu";  //No I18N
            case "Dashboard":   //No I18N
                return "DSB_Embed_Export_Menu";  //No I18N
        }
    }


    ZDBExport.showExportMenuForEmbed = function(el, event) {
        var view = ZDBClientUI.getViewObj(el,"view");    //No I18N
        var viewType = view.type;
        var menuName = ZDBExport.getEmbedExportMenuName(viewType);
        ZDBMenu.showModuleMenu(el,event,menuName,"GridMenu",true,view)  //No I18N
    }

  ZDBExport.showExportMenu = function(el,event,contentName,moduleName)
  {
    var view = ZDBClientUI.getViewObj(el,"view");   //No I18N
    contentName = (view.type == "Dashboard") ? "DSB_" + contentName : contentName;  //No I18N
    ZDBMenu.showModuleMenu(el,event,contentName,moduleName,true,view);
  }

  ZDBExport.showExportSubMenu = function(element, event, menuName, moduleName)
  {
    var menuEl = ZDBContentCache.appendAndGet(menuName,moduleName,document.body);
    var view = ZDBClientUI.getViewObj(element,"view");//No I18N
    if(menuEl == null)
    {
      return;
    }
    if(view)
    {
      menuEl.view = view;
    }

    var viewType = view.type;
    ZDBExport.enableDisableExpMailSubMenuItems($("ExportImage"),viewType,view);
    ZDBExport.enableDisableExpMailSubMenuItems($("EmailImage"),viewType,view);
    isDynamicMenuItems = true;
    ZRSMenu.showMenu(event,element,menuEl,3);
  }

  ZDBExport.enableDisableExpMailSubMenuItems = function(subMenuItem,viewType,view)
  {
      if(subMenuItem)
      {
            if(viewType == "AnalysisView")
            {
                subMenuItem.style.display = (view.graphSelected == "TABLE_CHART") ? "none" : "";//No I18N
            }
            else
            {
                subMenuItem.style.display = "none";
            }
      }
  }

  ZDBExport.addMailSubAndMes = function(dispName, fullName)
  {
      if($("ZDBMailSubject"))
      {
        $("ZDBMailSubject").value = $("ZDBMailSubject").value == "NOTSET" ? ZDBI18NMap.f("zrpt.common.email.dlg.js.mailSubject",dispName):$("ZDBMailSubject").value;
        $("ZDBMailMessage").value = $("ZDBMailMessage").value == "NOTSET" ? ZDBI18NMap.f("zrpt.common.email.dlg.js.mailMessage",dispName,fullName):$("ZDBMailMessage").value;
        $("ZDBScheduleNameInput").value = ZDBI18NMap.f("zrpt.common.email.dlg.js.scheduleName",dispName);
      }
  }
  
  ZDBExport.showPasswordField = function(el)
  {
	  if(el.checked)
	  {
		  $("PASSWORDINPROW").style.display = "";
//		  $("VERIFYPASSWORDROW").style.display = "";
	  }
	  else
	  {
		  $("PASSWORDINPROW").style.display = "none";
//		  $("VERIFYPASSWORDROW").style.display = "none";
		  $("EXPPASSWORD").value = "";
		  $("VERIFYPASSWORD").value = "";
	  }
  }
  
  ZDBExport.setPasswordParams = function(exportType, isMulti, isEditSchedule)
  {
	if(!ZDBGlobal.isPwdProtectEnabled)
	{
		return "";
	}
	var setPassword = ((exportType == "PDF" || exportType == "HTML") && isMulti) ? (ZDBUtil.getAttribute($("SETPASSWORD"),"ischecked") == "true") : $("SETPASSWORD").checked;	//No I18N
	var params = "";
	
	if(isEditSchedule)
	{
		params = "&SETPASSWORD=" + setPassword;	//No I18N
		return params;
	}
    if(setPassword && !ZDBExport.isPasswordVerified())
    	{
        return "PASSWORD_VERIFICATION_FAILED";	//No I18N
    	}
    
    if(setPassword && !ZDBExport.isValidPassword($("EXPPASSWORD").value))
    	{
        return "INVALID_PASSWORD";	//No I18N
    	}
    
	  if(setPassword)
	  {
		  var password = $("EXPPASSWORD").value;
		  if(!ZDBExport.isValidPassword(password))
		  {
			  return params;
		  }
		  params = "&SETPASSWORD=true&EXPPASSWORD=" + password;	//No I18N
	  }
	  else
	  {
		  params = "&SETPASSWORD=false";		//No I18N
	  }
	  return params;
  }
  
  ZDBExport.isValidPassword = function(password)
  {
//	  var regExp = /(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{6,}/;
//	  if(regExp.test(password))
//	  {
//		  return true;
//	  }
	  if(password.length > 5)
	  {
		  return true;
	  }
	  return false;
  }
  
  ZDBExport.isPasswordVerified = function()
  {
	  var password = $("EXPPASSWORD").value;
	  var verify = $("VERIFYPASSWORD").value;
	  if(password == verify)
	  {
		  return true;
	  }
	  return false;
  }
  
  ZDBExport.validatePassword = function(el)
  {
	  var password = el.value;
	  if(!ZDBExport.isValidPassword(password))
	  {
//		  ZDBUtil.setFocus(el,true);
		  showCustomMessage(ZDBI18NMap.g('zrpt.common.export.js.passworderr'),el);
	  }
  }
  
  ZDBExport.verifyPassword = function(el)
  {
	  if(!ZDBExport.isPasswordVerified())
	  {
//		  ZDBUtil.setFocus(el,true);
		  showCustomMessage(ZDBI18NMap.g('zrpt.common.export.js.verifypassword'),el);
	  }
  }
  
  ZDBExport.togglePwd = function(el)
  {
	  if(ZDBUtil.getAttribute(el,"showpassword") == "false")
	  {
		  $("EXPPASSWORD").type = "text";
		  $("SHOWPWDEXP").innerHTML = ZDBI18NMap.g("zrpt.common.export.js.hidepassword");
		  ZDBUtil.setAttribute(el,"true","showpassword");
	  }
	  else
	  {
		  $("EXPPASSWORD").type = "password";
		  $("SHOWPWDEXP").innerHTML = ZDBI18NMap.g("zrpt.common.export.js.showpassword");
		  ZDBUtil.setAttribute(el,"false","showpassword");
	  }
  }
  

  ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBExport.doExport"]=ZDBExport.doExport;
  ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBExport.exportTD"]=ZDBExport.exportTD;
  ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBExport.showExportMenuForEmbed"]=ZDBExport.showExportMenuForEmbed;
