//$Id$
var ZDBImgExport = new function()
{
  this.submitImgExportForm = function(exportType)
  {
      var form = $("ZDBExportIMGForm");
      var view =  ZDBClientUI.getViewObj(form,"view") || ZDBClientUI.selectedTab.view;
      if(ZDBGlobal.isPwdProtectEnabled)
    	  {
    	  	  var setPassword = (exportType == "PDF" && isMulti) ? (ZDBUtil.getAttribute($("SETPASSWORD"),"ischecked") == "true") : $("SETPASSWORD").checked;	//No I18N
          if(setPassword && !ZDBExport.isPasswordVerified())
          	{
    	        	var elem = $("VERIFYPASSWORD");
    	    		var par = ZDBUtil.getParentWithAttr(elem,"inlinediv");
//    	        par.scrollTop =0;
    	        ZDBUtil.setFocus(elem,true)
    	        showCustomMessage(ZDBI18NMap.g('zrpt.common.export.js.verifypassword'),elem);
    	        return;
          	}
          if(setPassword && !ZDBExport.isValidPassword($("EXPPASSWORD").value))
          	{
          		var elem = $("EXPPASSWORD");
          		var par = ZDBUtil.getParentWithAttr(elem,"inlinediv");
              par.scrollTop =0;
              ZDBUtil.setFocus(elem,true)
              showCustomMessage(ZDBI18NMap.g('zrpt.common.export.js.passworderr'),elem);
              return;
          	}
    	  }
      var additionalParams = view.viewCtx.getAdditionalParams();
      /*if(!validateForm(form)){return false;}*/

       if(($("IMGEXPORTNAME").value).trim() == "")
       {
            return ZDBReportMail.handleInlineErrorCode("NO_FILE_NAME",$("IMGEXPORTNAME"),"ZDBIMGTAB1","IMGMainTable");//No I18N
       }
       else if(!ZDBValidator.isValidImgWidth($("ZDBImgWidth").value,false,true))
       {
            return ZDBReportMail.handleInlineErrorCode("IMG_WIDTH_ERR",$("ZDBImgWidth"),"ZDBIMGTAB1","IMGMainTable");//No I18N
       }
       else if(!ZDBValidator.isValidImgHeight($("ZDBImgHeight").value,false,true))
       {
            return ZDBReportMail.handleInlineErrorCode("IMG_HEIGHT_ERR",$("ZDBImgHeight"),"ZDBIMGTAB1","IMGMainTable");//No I18N
       }
      //AjaxAPI.submit(form);
      var params = this.getImageExportParams(form,exportType,view);
      ZDBExport.exportViaIframe("/ZDBImgExport?"+"ZDBACTION=EXPORTIMG&"+ params + additionalParams,form.getAttribute("onfailurefunc"),form.getAttribute("onsuccessfunc"));//NO I18N
      ZDBInlineDialog.closeDialog();
      ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.common.export.js.expsubconf"));
  }

  this.removeSpecifiedParam = function(params,paramName)
  {
     var paramsCpy = params;
     
     while(paramsCpy.indexOf(paramName) > -1)
     {
        var startIdx = paramsCpy.indexOf(paramName);
        var endIdx = paramsCpy.indexOf("&",startIdx + 5);
       if(endIdx > 0)
       {
          paramsCpy = paramsCpy.substring(0,startIdx) + paramsCpy.substring(endIdx);
       }
       else
       {
          paramsCpy = paramsCpy.substring(0,startIdx);
       }
     }
     return paramsCpy;
  }

  this.getImageExportParams =  function(form,exportType,view,isEditSchedule)
  {
     var params = ZRSerialize(form);
     //$$Need to remove the below hack. This is a last minute fix for the vectorwise build.
     params = ZDBImgExport.removeSpecifiedParam(params,"&BCC="); //No I18N
     params = ZDBImgExport.removeSpecifiedParam(params,"&APPLYSHARECRITERIA="); //No I18N
     params = ZDBImgExport.removeSpecifiedParam(params,"&CANCELMAILONNODATA="); //No I18N
     params = ZDBImgExport.removeSpecifiedParam(params,"&APPLYDEFAULTUF="); //No I18N
     params = ZDBImgExport.removeSpecifiedParam(params,"&SETMAILTIME="); //No I18N
     params = ZDBImgExport.removeSpecifiedParam(params,"&SENDCOPY="); //No I18N
     params +="&DBID="+ZDBClientUI.dbId+"&WHICHVIEW=ANALYSIS&CONFIGASXMLINFORM=true&ZAGRIDTYPE=AnalysisSheet"; //No I18N
     params +="&EXPORTTYPE="+exportType+"&MULTIVIEW=false";
     params +=ZRSDrillDown.getDrillParams(view);
     view = view ? view : ZDBClientUI.selectedTab.view;
     if(!isEditSchedule)
     {
          params +=ZDBExport.getConfigXmlAsParam(view,"AnalysisSheet"); //No I18N
          params += "&VIEWTYPE="+view.graphSelected;//NO I18N
          params += ZDBExport.getBubbleParams(view);
     }
     params += "&IMGEXPORTAS=" + $("IMGEXPORTAS").selectedIndex; //No I18N
     if(ZDBGlobal.integrated)
      {
        params += "&IMGFOOTERLOGO=0";//No I18N
      }
      else
      {
     var pwdOpt = $("ImgPwdLogoOpt");
     if(pwdOpt != null)
     {
       params += "&IMGFOOTERLOGO=" + pwdOpt.selectedIndex; //No I18N
     }
     }

     if((typeof ZDBQa) == "object")
     {
       params = ZDBExport.addParamsExpQa("","Chart",params);   //No I18N
     }

     return params;
  }

  this.exportImageDialog = function(el,isEmail,isEditSchedule,viewId)
  {
    var viewObj = ZDBClientUI.getViewObj(el,"view");    //No I18N
    if(!viewId)
    {
        viewId = viewObj.objId;
    }
    if(!(ZDBClientUI.checkAskImgSave(viewObj,"Export",this)))
    {
      return;
    }
    var imgDlg = $("ZDBImgExportDlg");
    if(imgDlg == null)
    {
      if(isEmail == undefined)
      {
        isEmail = "false";
      }

      AjaxAPI.sendRequest({URL:"/ZDBImgExport.cc?OBJID="+viewId+"&ISEMAIL="+isEmail+viewObj.viewCtx.getAdditionalParams(),
    	  ONSUCCESSFUNC:ZDBImgExport.handleImgDlgFetchResp,ELEMENT:el,ISEMAIL:isEmail,"VIEWID":viewId,"ISEDITSCHEDULE":isEditSchedule,OPSTATUSID:"ZDBMainLoader"}); //No I18N
      return;
    }
    imgDlg.style.display="";
    var dispName = viewObj.title ? viewObj.title : viewObj.displayName;
    var dlgTtl = (isEmail == "true") ? ZDBI18NMap.g('zrpt.email.image.js.dlgTtl') : ZDBI18NMap.g('zrpt.export.image.js.dlgTtl');
    ZDBInlineDialog.showDialog(imgDlg,{TITLECLASS:'export', TITLE:dlgTtl,VIEW:viewObj}); //No I18N
    if(isEditSchedule)
    {
        ZDBReportMail.fillScheduleDetails(el);
    }
    else
    {
        ZDBImgExport.resetImgExportDialog(viewObj,dispName);
        $("ZDBImgExpObjId").value = viewObj.objId;
    }
    if($("ZDBScheduleDiv")) {
         $("ZDBScheduleDiv").style.display = ZDBClientUI.isDBOwner && !viewObj.viewCtx.dashView? "" : "none";
    }
    if(isEmail == "true")
    {
        var display=ZDBClientUI.isDBOwner ? "" : "none";
        ZDBInlineDialog.changeTab($("ZDBIMGTAB2"),'IMGMainTable'); //No I18N
        $("ZDBScheduleDiv").style.display = (ZDBClientUI.isDBOwner && !viewObj.viewCtx.dashView) ? "" : "none";
        $("ZDBSaveSubjectTr").style.display = display;
        $("ZDBSaveMessageTr").style.display = display;
        $("ZDBApplyShrChrTr").style.display = display;
        $("ZDBDefaultUFChrElem").style.display = display;
    }
    else
    {
        ZDBInlineDialog.changeTab($("ZDBIMGTAB1"),'IMGMainTable'); //No I18N
    }

  }

  this.handleImgDlgFetchResp = function(response,requestOptions)
  {
    var div = document.createElement("div");
    div.innerHTML = response.responseText;
    document.body.appendChild(div);
    var el = requestOptions["ELEMENT"];
    var isEmail = requestOptions["ISEMAIL"];
    ZDBImgExport.exportImageDialog(el,isEmail,requestOptions["ISEDITSCHEDULE"],requestOptions["VIEWID"]);
  }

  this.getScript = function(div,isMultiView)
  {
    var scripts = div.getElementsByTagName("script");
    var settings = null;
    var scriptId = (isMultiView) ? "ZDBImgMVPreferences" : "ZDBImgPreferences"; //No I18N
    for(var i=scripts.length -1;i >=0;i--)
    {
      var script = scripts[i];
      if(script.getAttribute("id") == scriptId)
      {
        settings = script.innerHTML;
      }
      script.parentNode.removeChild(script);
    }
    return settings;
  }

  this.exportMultiViewDialog = function(element,isEmail,isEditSchedule)
  {
	  var viewObj = ZDBClientUI.selectedTab.view;
	  var dbId = ZDBClientUI.dbId;
	  if(!(ZDBClientUI.checkAskImgSave(viewObj,"export",this)))
	  {
		  return;
	  }
          AjaxAPI.sendRequest({URL:"/ZDBMultiViewImgExport.cc?DBID="+dbId+"&ISEMAIL="+isEmail+"&ISEDITSCHEDULE="+isEditSchedule,ONSUCCESSFUNC:this.handleDlgFetchResp,//No I18N
			           "ELEMENT":element,"MULTVIEW":"true","ISEMAIL":isEmail,"ISEDITSCHEDULE":isEditSchedule,"VIEWOBJ":viewObj,OPSTATUSID:"ZDBMainLoader"});//No I18N
  }

  this.getExportOptions = function()
  {
	  var isMultiView = true;
	  var listTbl = $("IMGSELECTEDLISTDIV");
	  var exportAs = $("MVIMGEXPORTAS").value;
	  var width = $("ZDBMVIMGWidth").value;
	  var height = $("ZDBMVIMGHeight").value;
	  var includeTitle = $("ZDBMVIMGTitleCBox").checked;
          var includeDesc = $("ZDBMVIMGDescCBox").checked;
	  var exportOptions = "&MULTIVIEW=" + isMultiView+"&EXPORTAS="+exportAs+"&WIDTH="+width//No I18N
		                            +"&HEIGHT="+height+"&TITLE="+includeTitle//No I18N
					    +"&DESCRIPTION="+includeDesc;//No I18N

           if(!ZDBValidator.isValidImgWidth(width,false,true))
           {
                return "IMG_WIDTH_ERR"; //No I18N
           }
           else if(!ZDBValidator.isValidImgHeight(height,false,true))
           {
                return "IMG_HEIGHT_ERR";//No I18N
           }


           var selectedviews=ZDBExport.getViewsListForMV(listTbl);
           if(selectedviews=="NO_VIEW_SELECTED")
	  {
            return "NO_VIEW_SELECTED"; //No I18N
		  }
          exportOptions+=selectedviews;
	  exportOptions += "&IMGEXPORTAS=" + $("MVIMGEXPORTAS").selectedIndex; //No I18N
    var pwdOpt = $("MVImgPwdLogoOpt");
    if(pwdOpt != null)
    {
      exportOptions += "&ZOHO_PWD_LOGO_OPTION=" +pwdOpt.value; //No I18N
      exportOptions += "&IMGFOOTERLOGO=" + pwdOpt.selectedIndex; //No I18N
    }
	  return exportOptions;

  }

  this.handleDlgFetchResp = function(response, requestOptions)
  {
      var div = document.createElement("div");
      div.innerHTML = response.responseText;
      document.body.appendChild(div);
      var element = requestOptions["ELEMENT"];
      var viewObj = requestOptions["VIEWOBJ"];
      var isEmail = requestOptions["ISEMAIL"];
      var isEditSchedule = requestOptions["ISEDITSCHEDULE"];
      var multiViewDIV = $("ZDBMultiViewImageDIV");
      var dbName = $("ZDBDBNAME").innerHTML;
      var listTbl = $("IMGMVLIST"); // No I18N

        var ImgFooterLogo = $('MVImgPwdLogoOpt');
        if(ImgFooterLogo && !ZDBClientUI.isDBOwner)
        {
          ImgFooterLogo.disabled = true;
          ImgFooterLogo.className += ' alpha'; //No I18N
        }

	  multiViewDIV.style.display = "block";
          var displayName = (viewObj.title=="" || viewObj.title == null)?viewObj.displayName:viewObj.title;
          var dlgTtl = (isEmail == "true") ? ZDBI18NMap.g('zrpt.email.multiimage.js.dlgTtl') : ZDBI18NMap.g('zrpt.export.multiimage.js.dlgTtl');
          var viewCount = listTbl.getAttribute("viewCount"); // No I18N
          if(viewCount <= 0)
          {
            ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.mvimgexport.zdbalertmsg.js.noChartErr"));
            multiViewDIV.parentNode.removeChild(multiViewDIV);
            return;
          }
		  ZDBInlineDialog.showDialog(multiViewDIV,{TITLECLASS:'export', TITLE:dlgTtl,VIEW:viewObj}); //No I18N
		  var tab = ZDBClientUI.selectedTab;
          tab.focusedDialog.sortingType="asc";  //No I18N
          tab.focusedDialog.searchType="All";  //No I18N
          if(isEmail==="true" && (!isEditSchedule)) //No I18N
          {
                ZDBMVExportUtil.checkSelectAllOpt("MVIMGEXPORTALL","IMGMVLIST","IMGSELECTEDDIV","IMGSELECTEDLISTDIV");//No I18N
          }
          $("ZDBMVIMGExportName").value = dbName;
          $("ZDBMVIMGEXPORT").onclick = function(){ZDBImgExport.exportData(element,true,false);}
          ZDBExport.addMailSubAndMes(dbName, $("MVIMGMainTable").getAttribute("fullname"));

         if(isEditSchedule)
         {
            ZDBReportMail.fillScheduleDetails(element);
         }


        if(isEmail == "true")
        {
            ZDBInlineDialog.changeTab($("ZDBMVIMGTAB2"),'MVIMGMainTable'); //No I18N
            $("ZDBScheduleDiv").style.display = ZDBClientUI.isDBOwner ? "" : "none";
            $("ZDBSaveSubjectTr").style.display = ZDBClientUI.isDBOwner ? "" : "none";
            $("ZDBSaveMessageTr").style.display = ZDBClientUI.isDBOwner ? "" : "none";
            $("ZDBApplyShrChrTr").style.display = ZDBClientUI.isDBOwner ? "" : "none";
            $("ZDBDefaultUFChrElem").style.display = ZDBClientUI.isDBOwner ? "" : "none";
        }
        else
        {
            ZDBInlineDialog.changeTab($("ZDBMVIMGTAB1"),'MVIMGMainTable'); //No I18N
        }

  }

  this.exportData = function(element, isMultiView,isEmail,dbName)
  {
     var widthEl = $("ZDBMVIMGWidth");
     var heightEl = $("ZDBMVIMGHeight");
     var widthValue = widthEl.value.trim();
     var heightValue = heightEl.value.trim();
     if(isNaN(widthValue) || widthValue=="" || widthValue < 250 || widthValue > 2000)
     {
            var par = ZDBUtil.getParentWithAttr(widthEl,"inlinediv");
            par.scrollTop =0;
            ZDBUtil.setFocus(widthEl,true)

        showCustomMessage(ZDBI18NMap.f("zrpt.common.mvimgexport.custommsg.js.inputParamErr","width",250,2000), widthEl);
        return;
     }

     if(isNaN(heightValue) || heightValue=="" || heightValue < 200 || heightValue > 2000)
     {
            var par = ZDBUtil.getParentWithAttr(heightEl,"inlinediv");
            par.scrollTop =0;
            ZDBUtil.setFocus(heightEl,true)
            showCustomMessage(ZDBI18NMap.f("zrpt.common.mvimgexport.custommsg.js.inputParamErr","height",200,2000), heightEl);
            return;
     }

     ZDBMVExportUtil.exportDataAsZip(element,isMultiView,"IMG","IMGSELECTEDLISTDIV",isEmail,dbName); //No I18N
  }

  this.resetImgExportDialog = function(viewObj,dispName)
  {
    $("IMGEXPORTNAME").value = dispName;
    ZDBExport.addMailSubAndMes(dispName, $("IMGMainTable").getAttribute("fullname"));
    $("ZDBImgWidth").value = 600;
    $("ZDBImgHeight").value = 300;
    $("ImgTitle").checked = true;
    $("ImgDesc").checked = true;
    var ImgFooterLogo = $('ImgPwdLogoOpt');
    if(ImgFooterLogo && !ZDBClientUI.isDBOwner)
    {
      ImgFooterLogo.disabled = true;
    }
  }
}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBImgExport.exportImageDialog"]=ZDBImgExport.exportImageDialog;