//$Id$

var ZDBMVExportUtil = new function()
{
	this.selectAll = function(elem,listName,tbodyId)
	{
		var listTbl = $(tbodyId);
		var elemArray = ZDBUtil.getElsWithTagNAttrWithVal($("COLUMNLIST"),"name","COLNAME","TD");	//No I18N
		var isChecked = elem.getAttribute("ischecked");
		var incHiddenColEl = $("HIDDEN");
		if( isChecked == "true")
		{
			elem.setAttribute("ischecked","false");
			elem.className = "ZDBPDFUncheckAll";
			incHiddenColEl.checked = false;
			incHiddenColEl.value = false;
		}
		else
		{
			elem.setAttribute("ischecked","true");
			elem.className = "ZDBPDFCheckedAll";
			incHiddenColEl.checked = true;
			incHiddenColEl.value = true;
		}

                isChecked = elem.getAttribute("ischecked");
		for(var i=0;i<elemArray.length;i++)
		{
			if( isChecked == "true")
			{
				elemArray[i].setAttribute("ischecked","true");
				elemArray[i].className = "ZDBPDFChecked";
			}
			else
			{
				ZDBUtil.setNamedChildEls(elemArray[i],elemArray[i],"name");
				elemArray[i].setAttribute("ischecked","false");
				elemArray[i].className = "ZDBPDFUncheck";
			}
		}

	}

	this.selectCol = function(elem,selectAllId,listName,tbodyId)
	{
                     ZDBMVExportUtil.changeCheckBoxStyle(elem);
                     ZDBMVExportUtil.checkRUnCheckPDFSelectAll(tbodyId,selectAllId,listName);
                     ZDBMVExportUtil.checkRUnCheckPDFHiddenCol(tbodyId,"HIDDEN",listName);	//No I18N
	}

        
    this.checkRUnCheckPDFSelectAll = function(tbodyId,selectAllId,listName)
    {
        var listTbl = $(tbodyId);
        var elemArray = ZDBUtil.getElsWithTagNAttrWithVal($("COLUMNLIST"),"name","COLNAME","TD");	//No I18N
        var selectAllElem = document.getElementById(selectAllId);
        var selectedAll = true;
        for(var i=0;i<elemArray.length;i++)
        {
                if(elemArray[i].getAttribute("ischecked") == "false")
                {
                        selectedAll = false;
                        break;
                }
        }
        if(selectedAll)
        {
                selectAllElem.setAttribute("ischecked","true");
                selectAllElem.className = "ZDBPDFCheckedAll";
        }
        else
        {
                selectAllElem.setAttribute("ischecked","false");
                selectAllElem.className = "ZDBPDFUncheckAll";
        }
    }
    
    this.checkRUnCheckPDFHiddenCol = function(tbodyId,selectAllId,listName)
    {
        var listTbl = $(tbodyId);
        var elemArray = ZDBUtil.getElsWithTagNAttrWithVal($("COLUMNLIST"),"name","COLNAME","TD");	//No I18N
        var selectAllElem = document.getElementById(selectAllId);
        var selectedAll = true;
        for(var i=0;i<elemArray.length;i++)
        {
                var visibleCol = elemArray[i].getAttribute("isvisiblecolumn");
                if(visibleCol != "false")
                {
                	continue;
                }
                if(elemArray[i].getAttribute("ischecked") == "false")
                {
                        selectedAll = false;
                        break;
                }
        }
        if(selectedAll)
        {
                selectAllElem.setAttribute("ischecked","true");
                selectAllElem.checked = true;
                selectAllElem.value = true;
        }
        else
        {
                selectAllElem.setAttribute("ischecked","false");
                selectAllElem.checked = false;
                selectAllElem.value = false;
        }
    }

	this.changeCheckBoxStyle = function(elem)
	{
		var isChecked = elem.getAttribute("ischecked");
		if( isChecked == "true")
		{
			elem.setAttribute("ischecked","false");
			elem.className = "ZDBPDFUncheck";
		}
		else
		{
			elem.setAttribute("ischecked","true");
			elem.className = "ZDBPDFChecked";
		}
	}
    
        this.multiViewSpecificSelection=function(elem,evt)
    {
        ZDBMenuUtil.closeMenu();
        elem=jQuery(elem).find("div[ischecked]");
        var isChecked=(elem.attr("ischecked") === "true")?"false":"true"; //No I18N
        var viewToBeSelected= jQuery(elem).parents("a").attr("elname");//No I18N
        var parentElem=jQuery(elem).parents("div[class='dropDownMenu']");//No I18N
        var containerId=parentElem.attr("containerId"); //No I18N
        var selectedDivId=parentElem.attr("selectedDivId");//No I18N
        var selectedListId=parentElem.attr("selectedListId");//No I18N
        var selectAllId=parentElem.attr("selectAllId");//No I18N
        var viewsListFrSelect;
        viewsListFrSelect=jQuery("#"+containerId).find("[typeOfView="+viewToBeSelected+"]");//No I18N
        viewsListFrSelect.each(function(){
                   
            var isViewChecked=jQuery(this).attr("ischecked");  //No I18N
            if((isViewChecked ==="false") && isChecked === "true")
            {
                jQuery(this).attr({"ischecked":"true", "class":"ZDBPDFChecked" }); //No I18N
                ZDBMVExportUtil.addRDeleteInSelectedList(this,selectedDivId,selectedListId);
            }
            else if((isViewChecked==="true") && isChecked === "false")
            {
                jQuery(this).attr({"ischecked":"false","class":"ZDBPDFUncheck"}); //No I18N
                ZDBMVExportUtil.addRDeleteInSelectedList(this,selectedDivId,selectedListId);
            }
        });
        var elemArray =jQuery("#"+containerId).find("[name='exportObjID']"); //No I18N
        ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
        ZDBUtil.stopEventBubble(evt);
        
    }
    
    
    
    this.multiViewListSelectAll = function(elem,containerId,selectedDivId,selectedListId)
    {
        var isChecked = elem.getAttribute("ischecked");//No I18N
        (isChecked === "true")? jQuery(elem).attr({"ischecked":"false","class":"ZDBPDFUncheckAll"}): jQuery(elem).attr({"ischecked":"true","class":"ZDBPDFCheckedAll"}); //No I18N
        isChecked = elem.getAttribute("ischecked");  //No I18N
        var viewsList=jQuery("#"+containerId).find("[name='exportObjID']:visible"); //No I18N
        for(var i=0;i<viewsList.length;i++)
        {
            var view=viewsList.get(i);
            var isViewChecked=jQuery(view).attr("ischecked"); //No I18N
            if((isViewChecked =="false") && isChecked == "true")
            {
                jQuery(view).attr({"ischecked":"true","class":"ZDBPDFChecked"}); //No I18N
                ZDBMVExportUtil.addRDeleteInSelectedList(view,selectedDivId,selectedListId,"false");
            }
            else if((isViewChecked=="true") && isChecked == "false")
            {
                jQuery(view).attr({"ischecked":"false","class":"ZDBPDFUncheck" }); //No I18N
                ZDBMVExportUtil.addRDeleteInSelectedList(view,selectedDivId,selectedListId,"false");
            }
        }
    }
        
         
    this.removeAll=function(selectAllId,containerId,selectedDivId,selectedListId)
    {
        var viewsList=jQuery("#"+selectedListId).children("div[name='objListRow']") //No I18N
        if(viewsList.length!=0)
        {
            viewsList.each(function(){
                var rowId=jQuery(this).attr("rowid"); //No I18N
                var relavantCheckBox=jQuery("#"+containerId).find("[objId="+rowId+"]")[0]; //No I18N
                ZDBMVExportUtil.selectRDeselectView(relavantCheckBox,selectAllId,containerId,selectedDivId,selectedListId,"true");
            });
        }
    }
         
         
    this.removeTheView=function(el,selectAllId,containerId,selectedDivId,selectedListId)
    {
        var selectedRow= ZDBUtil.getParentWithAttributeValue(el,"name","objListRow"); //No I18N
        var rowId=jQuery(selectedRow).attr("rowId"); //No I18N
        var relavantCheckBox=jQuery("#"+containerId).find("[objId="+rowId+"]")[0]; //No I18N
        ZDBMVExportUtil.selectRDeselectView(relavantCheckBox,selectAllId,containerId,selectedDivId,selectedListId,"true"); //No I18N
    }
        
    this.selectRDeselectView = function(elem,selectAllId,containerId,selectedDivId,selectedListId,changeSelectAll)
    {
        ZDBMVExportUtil.changeCheckBoxStyle(elem);
        ZDBMVExportUtil.addRDeleteInSelectedList(elem,selectedDivId,selectedListId);
        var elemArray =jQuery("#"+containerId).find("[name='exportObjID']:visible"); //No I18N
        if(changeSelectAll==='true')
        {
            ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
        }
    }
        
    this.changeTheSelectAllStyle=function(selectAllId,elemArray)
    {
        var selectedAll = true;
        for(var i=0;i<elemArray.length;i++)
        {
            if(jQuery(elemArray.get(i)).attr("ischecked")==="false")
            {
                selectedAll = false;
                break;
            }
        }
        if(elemArray.length===0)
        {
            selectedAll = false;
        }
        (selectedAll)?jQuery("#"+selectAllId).attr({"ischecked":"true","class":"ZDBPDFCheckedAll"}):jQuery("#"+selectAllId).attr({"ischecked":"false", "class":"ZDBPDFUncheckAll"});//No I18N
                    
    }
        
    this.addRDeleteInSelectedList= function(elem,selectedDivId,selectedListId)
    {
        var tab = ZDBClientUI.selectedTab;
        var isChecked = elem.getAttribute("ischecked");
        var typeOfView=elem.getAttribute("typeOfView");
        var selectedRow= ZDBUtil.getParentWithAttributeValue(elem,"name","objListRow"); //No I18N
        var selectedViewsDiv=jQuery("#"+selectedListId);
        if( isChecked == "true")
        {
            var clonedRow=jQuery(selectedRow).clone();
            jQuery(clonedRow).children("[name='exportObjID']").remove(); //No I18N
                
            jQuery(clonedRow).hover(function(){ 
                jQuery(this).children("input").show(); //No I18N
            },function(){ 
                jQuery(this).children("input").hide(); //No I18N
                }); //No I18N
            jQuery(clonedRow).appendTo(selectedViewsDiv);
            if(selectedListId!=='IMGSELECTEDLISTDIV') //No I18N
            {
                tab.focusedDialog.selectedViewsCount[typeOfView]++;
            }
               
        }
        else
        {
            var rowId=jQuery(selectedRow).attr("rowId"); //No I18N
            selectedViewsDiv.children("[rowId="+rowId+"]").remove(); //No I18N
            if(selectedListId!=='IMGSELECTEDLISTDIV') //No I18N
            {
                tab.focusedDialog.selectedViewsCount[typeOfView]--;
            }
        }
        var rows=selectedViewsDiv.children("[name='objListRow']"); //No I18N
        var lastViewIndex=(rows.length)-1;
        rows.attr("class","ZDBPDFEmptyTR");//No I18N 
        tab.focusedDialog.selectedIndex=lastViewIndex;
        var SelectclassName="ZDBPDFSelectTR"; //No I18N
        jQuery(rows[lastViewIndex]).attr("class",SelectclassName).focus();//No I18N
        ZDBMVExportUtil.addRDelRemoveAllOpt(rows.length,selectedDivId,selectedListId);
    }
        
        
        
    this.addRDelRemoveAllOpt=function(count,selectedDivId,selectedListId)
    {
        if(count===0) 
        {
            var header=jQuery("#"+selectedDivId).find("div[name='removeAll']").hide(); //No I18N
            header.parent().attr("class","greyColor font12 greybg"); //No I18N
            }
        else if(count===1)
        {
            var header=jQuery("#"+selectedDivId).find("div[name='removeAll']").show(); //No I18N
            header.parent().attr("class","inline normalblackfont12 greybg"); //No I18N
            }
        }
        
            
           
    this.clearSearchBox=function(el,evt)
    {
        var SearchText=jQuery(el).siblings("#ZDBMVObjSearchTxtFld").val("").focus();  //No I18N
        ZDBMVExportUtil.searchTheValue(SearchText,SearchText.attr("containerId"),SearchText.attr("selectAllId"));  //No I18N
        ZDBUtil.stopEventBubble(evt);
    }
        
    this.hideRShowSearchAndSortMenu=function(el,hideRShow)
    {
           
        var viewsListDiv=jQuery(el).attr("viewsListDiv");  //No I18N
        if(hideRShow==="hide")  //No I18N
        {
            jQuery("#"+viewsListDiv).find("[elname='selectDropDown']").hide();  //No I18N
            jQuery("#"+viewsListDiv).find("[elname='sortDropDown']").attr("removeTypeSort","true");  //No I18N
        }
        else
        {
                  
            var containerId=jQuery(el).attr("containerId")    //No I18N
            jQuery("#"+viewsListDiv).find("[elname='selectDropDown']").show();  //No I18N
            if(containerId!=="IMGMVLIST")  //No I18N
            {
                jQuery("#"+viewsListDiv).find("[elname='sortDropDown']").attr("removeTypeSort","false");  //No I18N
            } 
        }
    }
        
    this.multiViewSelectAllMenu=function(el,event,contentName,moduleName,containerId)
    {
        var tab = ZDBClientUI.selectedTab;
        if(ZDBMenuUtil.curMenuEl)
        {
            ZDBMenuUtil.closeMenu();
        }
        var subMenu = ZDBContentCache.getContent(contentName,moduleName);
        var newMenu=jQuery(subMenu);
        if(!newMenu)
        {
            return;
        } 
        if(containerId!=="IMGMVLIST")  //No I18N
        {
            ZDBMVExportUtil.ShowRhideOpt(newMenu);
            var specificViewSelectAll=jQuery(newMenu).find("div[ischecked]"); //No I18N
            var index=0;
            for(var i in tab.focusedDialog.selectedViewsCount)
            {
                if(tab.focusedDialog.selectedViewsCount[i].toString()=== tab.focusedDialog.actualViewsCount[index])
                {
                    jQuery(specificViewSelectAll[index]).attr({"ischecked":"true","class":"ZDBPDFChecked iconSize fLeft"}); //No I18N
                }
                else
                {
                    jQuery(specificViewSelectAll[index]).attr({"ischecked":"false","class":"ZDBPDFUncheck iconSize fLeft"});  //No I18N
                }
                index++;
            }
        }
        ZDBMVExportUtil.appendMenuInElem(el,newMenu,event);
    }
        
        
    this.multiViewSearchMenu=function(el,event,contentName,moduleName,containerId)
    {
        var tab = ZDBClientUI.selectedTab;
        if(ZDBMenuUtil.curMenuEl)
        {
            ZDBMenuUtil.closeMenu();
        }
        var subMenu = ZDBContentCache.getContent(contentName,moduleName);
        var newMenu=jQuery(subMenu);
        if(!newMenu)
        {
            return;
        } 
        if(containerId!=="IMGMVLIST")  //No I18N
        {
            ZDBMVExportUtil.ShowRhideOpt(newMenu);
            newMenu.find("span").removeClass("sortTickMenu");    //No I18N  
            newMenu.find("#Search"+tab.focusedDialog.searchType).addClass("sortTickMenu");   //No I18N
        }
        ZDBMVExportUtil.appendMenuInElem(el,newMenu,event);
    }
            
    this.multiViewSortMenu=function(el,event,contentName,moduleName,containerId)
    {
        var tab = ZDBClientUI.selectedTab;
        if(ZDBMenuUtil.curMenuEl)
        {
            ZDBMenuUtil.closeMenu();
        }
        var subMenu = ZDBContentCache.getContent(contentName,moduleName);
        var newMenu=jQuery(subMenu);
        if(!newMenu)
        {
            return;
        }
        var removeTypeSort=jQuery(el).attr("removeTypeSort"); //No I18N
        if(removeTypeSort==="true")  //No I18N
        {
            newMenu.find("#ViewListAscendingByType").hide();  //No I18N
            newMenu.find("#ViewListDesendingByType").hide();  //No I18N
        }
        else
        {
            newMenu.find("#ViewListAscendingByType").show();  //No I18N
            newMenu.find("#ViewListDesendingByType").show();    //No I18N 
        }
        newMenu.find("span").removeClass("sortTickMenu");    //No I18N  
        newMenu.find("#"+tab.focusedDialog.sortingType).addClass("sortTickMenu");  //No I18N
        ZDBMVExportUtil.appendMenuInElem(el,newMenu,event);
    }
                    
    this.ShowRhideOpt=function(newMenu)
    {
        var tab = ZDBClientUI.selectedTab;
        var specificSearchRSelect=newMenu.find("[isViewType='true']"); //No I18N
        for(var i=0;i<7;i++)
        {
            if(tab.focusedDialog.actualViewsCount[i]==="0")
            {
                jQuery(specificSearchRSelect[i]).hide();
            }
            else
            {
                jQuery(specificSearchRSelect[i]).show();
            }
        } 
    }
        
    this.appendMenuInElem=function(el,newMenu,event)
    {
    		jQuery(el).append(newMenu);
        newMenu.addClass("shadowAdded").show(); //No I18N
        ZDBMenuUtil.curMenuEl=newMenu;
        ZDBMenuUtil.curMenuEl.isExportSpecific="true" //No I18N
        jQuery(document.body).unbind("click").bind("click", function(){ //No I18N
            ZDBMenuUtil.closeMenu();
            jQuery(document.body).unbind("click");   //No I18N
        });
        var menuItem=newMenu.find("li");
        menuItem.mouseover(function()
        {
         ZDBMVExportUtil.setClass(this, 'ZRSMenuHover'); //No I18N
        });
        menuItem.mouseout(function()
        {
         ZDBMVExportUtil.removeClass(this, 'ZRSMenuHover'); //No I18N
        });
        ZDBUtil.stopEventBubble(event);
    }
        
    this.sortViewsList=function(el,sortType,event)
    {
            
        ZDBMenuUtil.closeMenu();
        var tab = ZDBClientUI.selectedTab;
        tab.focusedDialog.sortingType=sortType;
        var parentElem=jQuery(el).parents("[elname='sortDropDown']");  //No I18N
        var divToBeSorted=parentElem.attr("containerId");  //No I18N
        var rows;
        var headerRows;
        var className="ZDBMVExportClassNew"; //No I18N
        if(sortType==="asc") //No I18N
        {
            rows = jQuery("#"+divToBeSorted).children("div[objRowType='true']"); //No I18N
            jQuery("#"+divToBeSorted).removeClass(className); //No I18N
            headerRows = jQuery("#"+divToBeSorted).children("div[objRowType='false']"); //No I18N
            headerRows.hide();
            ZDBMVExportUtil.sortAsc(rows);
            jQuery("#"+divToBeSorted).empty();  //No I18N
            jQuery("#"+divToBeSorted).append(rows).append(headerRows);  //No I18N
        }
                
        if(sortType==="dsc") //No I18N
        {
            rows = jQuery("#"+divToBeSorted).children("div[objRowType='true']"); //No I18N
            jQuery("#"+divToBeSorted).removeClass(className); //No I18N
            headerRows = jQuery("#"+divToBeSorted).children("div[objRowType='false']"); //No I18N
            headerRows.hide();
            ZDBMVExportUtil.sortDsc(rows); 
            jQuery("#"+divToBeSorted).empty();  //No I18N
            jQuery("#"+divToBeSorted).append(rows).append(headerRows);  //No I18N
        }
        if(sortType==="ascByType") //No I18N
        {
            rows = jQuery("#"+divToBeSorted).children("div[name='objListRow']"); //No I18N
            jQuery("#"+divToBeSorted).addClass(className); //No I18N
            headerRows = jQuery("#"+divToBeSorted).children("div[objRowType='false']"); //No I18N
            headerRows.show();
            ZDBMVExportUtil.ascByType(rows);   
            jQuery("#"+divToBeSorted).empty();  //No I18N
            jQuery("#"+divToBeSorted).append(rows);  //No I18N
                   
        }
        if(sortType==="dscByType") //No I18N
        {
            rows = jQuery("#"+divToBeSorted).children("div[name='objListRow']"); //No I18N
            jQuery("#"+divToBeSorted).addClass(className); //No I18N
            headerRows = jQuery("#"+divToBeSorted).children("div[objRowType='false']"); //No I18N
            headerRows.show();
            ZDBMVExportUtil.dscByType(rows);
            jQuery("#"+divToBeSorted).empty();  //No I18N
            jQuery("#"+divToBeSorted).append(rows); //No I18N 
        }
        if(rows.length>=10)
        {
            jQuery("#"+divToBeSorted).css({'overflow':'scroll','overflow-x':'hidden'}); //No I18N
        }
        else
        {
            jQuery("#"+divToBeSorted).css({'overflow':'','overflow-x':''}); //No I18N
        }
        ZDBUtil.stopEventBubble(event);
    }
        
        
    this.sortAsc=function(rows)
    {
        rows.sort(function(a,b){
            var viewName1=jQuery(a).attr("viewname").toLowerCase(); //No I18N
            var viewName2=jQuery(b).attr("viewname").toLowerCase(); //No I18N
            return (viewName1<viewName2)?-1:(viewName1>viewName2)?1:0;
        }); 
    }
        
    this.sortDsc=function(rows)
    {
        rows.sort(function(a,b){
            var viewName1=jQuery(a).attr("viewname").toLowerCase(); //No I18N
            var viewName2=jQuery(b).attr("viewname").toLowerCase(); //No I18N
            return (viewName1>viewName2)?-1:(viewName1<viewName2)?1:0;
        });
    }
        
    this.ascByType=function(rows)
    {
        rows.sort(function(a,b){
            var viewName1=(jQuery(a).attr("objRowType")==="true")?jQuery(a).attr("viewname").toLowerCase():jQuery(a).attr("viewnameforasc").toLowerCase();     //No I18N
            var viewName2=(jQuery(b).attr("objRowType")==="true")?viewName2=jQuery(b).attr("viewname").toLowerCase():jQuery(b).attr("viewnameforasc").toLowerCase(); //No I18N
            
            var viewType1=jQuery(a).attr("viewtype").toLowerCase(); //No I18N
            var viewType2=jQuery(b).attr("viewtype").toLowerCase(); //No I18N
            if(viewType1===viewType2)
            {
                return (viewName1<viewName2)?-1:(viewName1>viewName2)?1:0;
            }
            return (viewType1<viewType2)?-1:(viewType1>viewType2)?1:0;
                
        });
    }
        
    this.dscByType=function(rows)
    {
        rows.sort(function(a,b){
            var viewName1=(jQuery(a).attr("objRowType")==="true")?jQuery(a).attr("viewname").toLowerCase():jQuery(a).attr("viewnamefordsc").toLowerCase();  //No I18N
            var viewName2=(jQuery(b).attr("objRowType")==="true")?jQuery(b).attr("viewname").toLowerCase():jQuery(b).attr("viewnamefordsc").toLowerCase(); //No I18N
            var viewType1=jQuery(a).attr("viewtype").toLowerCase(); //No I18N
            var viewType2=jQuery(b).attr("viewtype").toLowerCase(); //No I18N
            if(viewType1===viewType2)
            {
                return (viewName1>viewName2)?-1:(viewName1<viewName2)?1:0;
            }
            return (viewType1>viewType2)?-1:(viewType1<viewType2)?1:0;
                
        });
    }
        
    this.searchViewsList=function(el,searchInType,event)
    {
        ZDBMenuUtil.closeMenu();
        ZDBUtil.stopEventBubble(event);
        var tab = ZDBClientUI.selectedTab;
        tab.focusedDialog.searchType=searchInType;
        if(searchInType!=="All") //No I18N
        {
          	jQuery(el).parents("#MVListSearch").find("[elname='ZDBViewIconForSearch']").attr("class","ZRSMenuIcon "+searchInType+"Icon").show(); //No I18N
        }
        else
        {
            jQuery(el).parents("#MVListSearch").find("[elname='ZDBViewIconForSearch']").hide();    //No I18N
        }
    }
        
    this.searchInViews=function(viewsToBeSearched,value)
    {
        viewsToBeSearched.each(function(){
            var elem=this;
            var viewName=jQuery(elem).attr("viewName"); //No I18N
                        
            viewName=viewName.toLowerCase();
            if(viewName.indexOf(value)!==-1)
            {
                jQuery(elem).show();
            }
            else
            {
                jQuery(elem).hide();
            }
        });
    }
        
        
this.searchTheValue=function(el,containerId,selectAllId,ev)
{   
    var tab = ZDBClientUI.selectedTab;
    var toBeSearchedFrom=jQuery("#"+containerId);  //No I18N
    var className = "ZDBMVExportClassNew"; //No I18N
    toBeSearchedFrom.removeClass(className); //No I18N
    toBeSearchedFrom.children("div[objRowType='false']").hide(); //No I18N
    var searchInType=tab.focusedDialog.searchType;
    var viewsToBeSearched=ZDBMVExportUtil.getViewsForSearch(searchInType,toBeSearchedFrom);
    var value = el.value;
    if((value === "") || (value==="Search Views")) //No I18N
    {
        value = null;
    }
    if(value)
    {
        jQuery(el).siblings("[class='ZRSSearchClearIcon']").show(); //No I18N
        ZDBMVExportUtil.hideRShowSearchAndSortMenu(el,"hide");  //No I18N
        value = value.toLowerCase();
        if (BROWSER.IE && (BROWSER.VERSION.toString()==="7.0"||BROWSER.VERSION.toString()==="8.0"))
        { 
            var key;
            if (window.event) {
                key = window.event.keyCode;
            } else if (ev) {
                key = ev.which;
            }
            //Enter Key
            if (key===13)
            {
                ZDBMVExportUtil.searchInViews(viewsToBeSearched,value); 
            }
            return;
        }
        ZDBMVExportUtil.searchInViews(viewsToBeSearched,value); 
    }
    else
    {
        jQuery(el).siblings("[class='ZRSSearchClearIcon']").hide(); //No I18N
        ZDBMVExportUtil.hideRShowSearchAndSortMenu(el,"show"); //No I18N
        jQuery("#"+containerId).find("[objRowType='true']").show(); //No I18N
    }
    var elemArray =jQuery("#"+containerId).find("[name='exportObjID']:visible"); //No I18N
    ZDBMVExportUtil.changeTheSelectAllStyle(selectAllId,elemArray);
}
     
this.getViewsForSearch=function(searchInType,toBeSearchedFrom)
{
    var viewsToBeSearched;
    if(searchInType==="All") //No I18N
    {
        viewsToBeSearched=toBeSearchedFrom.children("[objRowType='true']"); //No I18N
    }
    else
    {
        viewsToBeSearched=toBeSearchedFrom.children("[objRowType='true'][viewType="+searchInType+"]"); //No I18N 
        toBeSearchedFrom.children("[objRowType='true'][viewType!="+searchInType+"]").hide(); //No I18N 
    }
    return viewsToBeSearched;
         
}
        
this.checkSelectAllOpt=function(selectAllID,containerId,selectedDivId,selectedListId)
  {
        jQuery("#"+selectAllID).attr({"ischecked":"true","class":"ZDBPDFCheckedAll"}); //No I18N
        var viewsList=jQuery("#"+containerId).find("[name='exportObjID']"); //No I18N
        for(var i=0;i<viewsList.length;i++)
        {
            var view=viewsList.get(i);
            jQuery(view).attr({"ischecked":"true","class":"ZDBPDFChecked"}); //No I18N
            ZDBMVExportUtil.addRDeleteInSelectedList(view,selectedDivId,selectedListId,"false"); //No I18N
        }
  }
       
        this.highLightRow = function(el,listTblId)
        {
                var src = ZDBUtil.findParentWithTagName(el, "tr"); //No I18N
                var rowIndex = src.rowIndex;
                var listTbl = $(listTblId);
                var rows = listTbl.getElementsByTagName("TR"); //No I18N
                ZDBMVExportUtil.clearAllTRStyles(rows);
                rows[rowIndex].className = "ZDBPDFSelectTR"; //No I18N
        }

        this.clearAllTRStyles = function(rows)
        {
                for(var i=1;i<rows.length;++i)
                {
                        if(rows[i].getAttribute("objRowType") === "true") //No I18N
                        {
                                rows[i].className = "ZDBPDFEmptyTR"; //No I18N
                        }
                }

        }
        
        this.setClass=function(el,classToSet)
        {
            jQuery(el).addClass(classToSet);
        }
        
        this.removeClass=function(el,classToRemove)
        {
            jQuery(el).removeClass(classToRemove);
        }


        this.exportDataAsZip = function(element,isMultiView,exportType,listTblId,isEmail,dbName)
        {
           var prefix = isMultiView ? "MV" : "";//No I18N
           var fileName = $("ZDB"+prefix+exportType+"ExportName").value.trim();
	   var onsuccessfunc="";
	   var onfailurefunc="";
           if(fileName == "")
           {
                  var elem = $("ZDB"+ prefix + exportType +"ExportName");
                  var par = ZDBUtil.getParentWithAttr(elem,"inlinediv");
                  par.scrollTop =0;
                  ZDBUtil.setFocus(elem,true)
                   showCustomMessage(ZDBI18NMap.g('zrpt.common.pdfexport.zdbalertmsg.js.fileNameErr'),$("ZDB"+prefix+exportType+"ExportName"));
                   return;
           }
           var selectedViews = jQuery("#"+listTblId).children("[name='objListRow']"); //No I18N
           if(selectedViews.length==0)
            {
                   ZDBAlertAPI.showMsg(ZDBI18NMap.g('zrpt.common.pdfexport.zdbalertmsg.js.noViewErr'));
                   return;
            }
           

	   var qa = $("ZDB"+prefix+exportType+"ExportQAFile").getAttribute("qa");
	   if(qa == "true" || qa == true)
	   {
		onsuccessfunc = $("ZDBExport"+prefix+exportType+"Form").getAttribute("onsuccessfunc");
		onfailurefunc = $("ZDBExport"+prefix+exportType+"Form").getAttribute("onfailurefunc");
	   }

           ZDBExport.exportData(element,"multiview",exportType,isMultiView,isEmail,null,onfailurefunc, onsuccessfunc);//No I18N
        }

    
    this.moveUp = function(itemHolder)
    {
        var tab = ZDBClientUI.selectedTab;
        var selectedIndex=tab.focusedDialog.selectedIndex;
        ZDBPDFExport.startIndex = 0;
        if(selectedIndex == 0)
        {
            return;
        }
        var cLbody = $(itemHolder);
        ZDBUtil.removeNonElements(cLbody);
        var node = cLbody.childNodes[selectedIndex];
        var before = cLbody.childNodes[selectedIndex-1];
        cLbody.insertBefore(node, before);
        jQuery(node).focus();
        --tab.focusedDialog.selectedIndex;
    }

  
    this.moveDown = function(itemHolder)
    {
        var cLbody = $(itemHolder);
        ZDBUtil.removeNonElements(cLbody);
        var rows = cLbody.childNodes;
        var len = rows.length;
        var tab = ZDBClientUI.selectedTab;
        var selectedIndex=tab.focusedDialog.selectedIndex;
        if(selectedIndex >= len || selectedIndex < 0)
        {
            return;
        }
        else if(selectedIndex == len-1)
        {
            var node = cLbody.childNodes[selectedIndex];
            cLbody.appendChild(node);
            jQuery(node).focus();
        }
        else
        {
            var node = cLbody.childNodes[selectedIndex];
            var before = cLbody.childNodes[selectedIndex+1];
            cLbody.insertBefore(before,node); //position reversed;
            jQuery(node).focus();
            ++tab.focusedDialog.selectedIndex;
        }
    }
    
    this.showPasswordField = function(el)
    {
    		var isChecked = el.getAttribute("ischecked");
    	  if(isChecked == "true")
    	  {
    		  $("PASSWORDINPROW").style.display = "";
    	  }
    	  else
    	  {
    		  $("PASSWORDINPROW").style.display = "none";
    		  $("PASSWORDINPROW").value = "";
    		  $("VERIFYPASSWORD").value = "";
    	  }
    }

}

