#!/usr/bin/env bash
if [[ `uname` == 'Linux' ]] ; then
    ISLINUX=true
else
    ISLINUX=false
fi
FILESTOHASH=(js css jpg jpeg png ico svg gif);


FILESTOHASHLENGTH=${#FILESTOHASH[@]}
for(( j=0; j<$FILESTOHASHLENGTH; j++))
do
    echo 'getting files' "${FILESTOHASH[$j]}"
    if [[ $ISLINUX = true ]] ; then
    files=(`find . -regextype posix-extended -regex ".*\.[a-zA-Z0-9]*\.${FILESTOHASH[$j]}"`)
    else
    files=(`find -E ./ -iregex ".*\.[a-zA-Z0-9]*\.${FILESTOHASH[$j]}"`)
    fi
    echo files
    FILESLENGTH=${#files[@]}
    for (( i=0; i<$FILESLENGTH; i++))
    do
        CURRENTFILE=${files[$i]#./}
        CURRENTFILE=${CURRENTFILE#/*}
        echo "****removing hash for: $CURRENTFILE"
        CURRENTFILENAME=${CURRENTFILE%*\.[a-zA-Z0-9]*\.*}
        CURRENTFILEEXT=${CURRENTFILE##*.}
        NEWFILENAME="$CURRENTFILENAME"".""$CURRENTFILEEXT"
        echo "****new file: $NEWFILENAME"
        mv $CURRENTFILE $NEWFILENAME
    done
done

hashrevertimages=(png gif jpg jpeg ico)
hashrevertimageslen=${#hashrevertimages[@]}
for(( i=0; i<$hashrevertimageslen; i++))
do
    currentfileext=${hashrevertimages[$i]}
    # echo $currentfileext
    file=($(grep -rh url*\.*\.[a-zA-Z0-9]*\.$currentfileext themes/common/styles/f2/ZRSAllImagesDef.css))
    fileslen=${#file[@]}
    echo $fileslen;
    for(( j=0; j<$fileslen; j++)); 
    do 
        # echo $currentfileext
        # echo ${file[$j]}
        # if [[ (echo ${files[$j]} | grep -Eq ^url*\.*\.[a-zA-Z0-9]*\.png) ]]; then
        #     echo 'yes'
        # fi
        # echo ${file[$j]}
        hashed=''
        resultantstring=''
        # (echo ${file[$j]} | grep -Eq ^url*\.*\.[a-zA-Z0-9]*\.$currentfileext*) && (echo 'true') || echo 'false'
        # (echo ${file[$j]} | grep -Eq ^url*\.*\.[a-zA-Z0-9]*\.$currentfileext*) && (hashed=${file[$j]};withouthash=${hashed%*\.[a-zA-Z0-9]*\.*};hashedext=${hashed##*.};resultantstring="$withouthash"".""$hashedext";hashed=${hashed////\\/};resultantstring=${resultantstring////\\/};echo "s/$hashed/$resultantstring/gi";sed -i -E "s/$hashed/$resultantstring/g" themes/common/styles/f2/ZRSAllImagesDef1.css) || echo "";
        (echo ${file[$j]} | grep -Eq ^url*\.*\.[a-zA-Z0-9]*\.$currentfileext*) && (hashed=${file[$j]};hashed=${hashed##*/};hashed=${hashed%*[\'|\"]*};hashed=${hashed%.*};resultantstring=${hashed%.*};hashed=${hashed////\\/};resultantstring=${resultantstring////\\/};echo "s/$hashed/$resultantstring/gi";perl -pi -e "s/$hashed/$resultantstring/gi" themes/common/styles/f2/ZRSAllImagesDef.css) || echo "";
        # sed -i -E "s/$hashed/$resultantstring/g" themes/common/styles/f2/ZRSAllImagesDef1.css
        # perl -pi -e "s/$hashed/$resultantstring/gi" themes/common/styles/f2/ZRSAllImagesDef1.css
    done
done