
/* global ZDBTabHandler, ZDBClientUI, ZDBLazyLoadUtil, ZDBInlineDialog, ZDBGlobal, AjaxAPI, ZDBI18NMap, ZDBSecuritySettings, ZDBAlertAPI, ZDBUtil, ZDBConvert, ZDBMsgBox, DOMUtils, ZDBLazyLoadFuncMap */

//$Id$
var ZDBImportMailAttachment = new function()
{
 this.showMailattachmentDetails=function(element)
{
    if(element  && element.getAttribute("type") === "1")
    {ZDBTabHandler.removeSelectedTab(ZDBClientUI.selectedTab);}
     if(!ZDBLazyLoadUtil.loadJsAlone("security/js/ZDBAutoFillContacts.js,security/js/ZDBSecuritySettings.js","APPENDTODOC",ZDBImportMailAttachment.showMailattachmentDetails))
        {
          return;
        }  
    if(!ZDBLazyLoadUtil.loadSnippet("IMPORT_FROM_MAIL_ATTACHMENT","/ZDBMailAttachConf.cc?OBJID="+ZDBClientUI.selectedTab.view.objId,this,"APPENDTODOC"))
    {
      return;
    }
    var mailImportDiv;
    var mailImportDivTemplateDiv = ZDBClientUI.$('ZDBMailAttachmentConfigDiv');
    mailImportDiv=mailImportDivTemplateDiv.cloneNode(true);
    mailImportDiv.setAttribute("id",'ZDBMailAttachmentConfigDiv_'+ZDBClientUI.selectedTab.view.objId);
    mailImportDiv.gridObj = ZDBClientUI.selectedTab.view; 
    ZDBInlineDialog.showDialog(mailImportDiv,{MODAL:true,TITLE:"Import from email attachments"});// No I18N
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX +"/ZDBImportData.ve?ZDBACTION=LOADMAILATTACHCONF&OBJID="+ZDBClientUI.selectedTab.view.objId,METHOD:"POST" ,ELEMENT:element,ONSUCCESSFUNC:ZDBImportMailAttachment.loadMailattachConf,OPSTATUSID:"ZDBMainLoader"}); //No I18N
}
this.loadMailattachConf=function(response,requestOptions)
{
    var result = jQuery.parseJSON(response.responseText);
    $('forwardToEmail').innerText=result["FILE_FORWARDED_TO_EMAIL"];
    $('fileTypeLable').innerText=result["FILETYPE"];
    $('failureNotificationToolTip').setAttribute("data-tip",ZDBI18NMap.g("zrpt.ifma.js.failurenotiftooltip"));
     var fNotification=result["CANADDNEWCOLUMN"];
        fNotification?$('canaddnewcolumn_T').checked=true:$('canaddnewcolumn_F').checked=true;
        $('zdbcontactsholder_1').value=result["WHITELISTEMAILID"].replace(/,/g , "\n");
        var fNotification=result["FAILURENOTIFICATION"];
        fNotification?$('fNotification_T').checked=true:$('fNotification_F').checked=true;
      if(result["hasSettings"])
    {
    $('disableSettings').style.display ="block" ; //No I18N
    }
    else 
    {
    $('disableSettings').style.display ="none" ; //No I18N
    }   
}
this.submitMailattachmentDetails=function(element)
{  
    var emailIds = null;
    var emailIdsInputBox = $('zdbcontactsholder_1');
    var csValue = "";
    if(emailIdsInputBox)
    {
        emailIds =  $("zdbcontactsholder_1").value.trim();
        try
        {
            if(emailIds != "")
            {
                var emailArray = emailIds.split(/[\n,]+/);
                for(var i = 0; i < emailArray.length; i++)
                    {
                    var value = emailArray[i].trim();
                    if(value != "")
                        {
                        if(!ZDBImportMailAttachment.isValidEmail(value, false))	 
                            {	 
                            throw {
                            name: "INVALID_EMAILID", //No I18N
                            message: ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.invalid_email_ids")
                            }
                            }
                            if(csValue != "")
                             {
                             csValue += ",";
                             }
                            csValue += value;
                        }
                    }
            }
        }
        catch(e)
        {
            ZDBAlertAPI.showMsg(e.message);
            return;
        }
    }
    emailIds=csValue;
    if(! ZDBImportMailAttachment.checkWhitelistCount(emailIds)) {return false;   }
    var gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');    //No I18N
       element.setAttribute("canDoImpFromEmail",true);
            var param ="OBJID="+gridObj.objId; //No I18N
            param+="&FAILURENOTIFICATION="+document.querySelector('input[name="fNotification"]:checked').value;   //No I18N
            param+="&WHITELISTEMAILID="+emailIds+"&CANADDNEWCOLUMN="+document.querySelector('input[name="canaddnewcolumn"]:checked').value;   //No I18N
                   AjaxAPI.sendRequest({URL:ZDBGlobal.CTX +"/ZDBImportData.ve?ZDBACTION=SAVEMAILATTACHCONF",METHOD:"POST",PARAMETERS: param,ONSUCCESSFUNC:ZDBImportMailAttachment.showMailAttachConfSuc,ELEMENT:element }); //No I18N
            ZDBInlineDialog.closeDialogByType(element);
}

this.isValidEmail=function(value,allowBlank,strict)
{
    if(!strict)
    {
     value = ZDBConvert.trimData(value);
    }
    if(value === '')
    {
      return allowBlank;	
    }
   var emailRegex=/^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
    if(emailRegex.test(value))
    {
    	return true;
    }
    else
    {
    	return false;
    }
}
this.showMailAttachConfSuc=function(response,requestOptions)
{
    ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.common.pricing.rebranding.js.setting_saved"));
    var el=requestOptions["ELEMENT"];
    var curEl = el;
    while(curEl && (curEl['view'] == null))
    {
    curEl = curEl.parentNode;
    }
    var view=curEl["view"];
    view.canDoImpFromEmail=(el.getAttribute("canDoImpFromEmail")==="true")?true :false;
    var gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object');
    gridObj.sendAndUpdateClientState(true);
 }
 this.deleteMailAttachSettingsAlert = function(el)
 {
    var parEl = DOMUtils.getParentWithAttrValue(el);
    parEl.isDialogOpen = true;
    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.ifma.js.deletesetting"),"ZDBYESNO",{ONCLICK:ZDBImportMailAttachment.deleteMailAttachSettings});   //No I18N
 }
 this.deleteMailAttachSettings=function(clickType,requestOptions)
 {
    if(clickType === "NO")
    {
        return;
    }
    var element=$('ZDBMailAttachmentConfigDiv_'+ZDBClientUI.selectedTab.view.objId);
    var gridObj =  ZDBClientUI.selectedTab.view;
    
    var param ="OBJID="+gridObj.objId; //No I18N
    element.setAttribute("canDoImpFromEmail",false);
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX +"/ZDBImportData.ve?ZDBACTION=DELETEMAILATTACHCONF",METHOD:"POST",PARAMETERS: param,ONSUCCESSFUNC:ZDBImportMailAttachment.showMailAttachConfSuc,ELEMENT:element }); //No I18N
    ZDBInlineDialog.closeDialogByType(element);
 }
 this.checkWhitelistCount= function(emailIds)
{
    var res = emailIds.split(",");
    var i=0;
    if(res=== null || (res.length===1 && res[i]==='') )
    {
        ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.dbsettings.variables.js.emptyemail"));
        return false;
    }
    if(res.length>10 )
    {    
        ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.ifma.js.whitelistId.countexceed"));
        return false;
    }
    return true;
}
this.copyToClipboard = function(elname) 
{     
 ZDBClientUI.copyToClipboard(document.getElementById(elname).innerHTML,null );
}

}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBImportMailAttachment.showMailattachmentDetails"]= ZDBImportMailAttachment.showMailattachmentDetails;