//$Id$
var ZDBExtInteg = new function()
{   
    hideCustomMessage();
    this.getExtIntegFiles=function()
    {           
    	$("ZDBExtIntegButton").disabled=true;
        jQuery('#ZDBEXTERNALOPTSTATUS').show(); //NO I18N
        var filetype=($("ZDBFILETYPE")!=null)?$("ZDBFILETYPE").value:$("ZDBEXFILETYPE").value;
        var sourceList = "";
        if(filetype=="DROPBOX")
        {
               if(!ZDBGlobal.IS_ONPREMISE_BUILD){
           sourceList = "dropbox,box,skydrive,zohodocs,gdrive";	//No I18N
        }
			   else{
                        jQuery.ajax({
                            type: "POST", //No I18N
                            url: "/onpremisezc?action=saveDropBoxClientInfo", //No I18N
                            data: {"dropBoxAplusClientId": jQuery.trim(jQuery("#dropBoxAplusClientId").val()), "dropBoxAplusClientSecret":jQuery.trim(jQuery("#dropBoxAplusClientSecret").val())}, //No I18N
                            dataType: "html" //No I18N
                        })
                        .done(function(data, status){
                          console.log("dropbox - save info success-- status:"+status+"--data:"+data);
                        });
                        sourceList = "dropbox,box,skydrive,gdrive";  //No I18N
                    }
            }
        else if(filetype == "BOX")
        {
				if(!ZDBGlobal.IS_ONPREMISE_BUILD){
        	sourceList = "box,skydrive,zohodocs,gdrive,dropbox";  //No I18N
        }
				else{
					jQuery.ajax({
						type: "POST", //No I18N
						url: "/onpremisezc?action=saveBoxClientInfo", //No I18N
						data: {"boxAplusClientId": jQuery.trim(jQuery("#boxAplusClientId").val()), "boxAplusClientSecret":jQuery.trim(jQuery("#boxAplusClientSecret").val())}, //No I18N
						dataType: "html" //No I18N
					})
					.done(function(data, status){
					  
					});
					sourceList = "box,skydrive,gdrive,dropbox";  //No I18N
				}
            }
        else if(filetype ==="ONEDRIVE")
        {
				if(!ZDBGlobal.IS_ONPREMISE_BUILD){
        	sourceList = "skydrive,zohodocs,gdrive,dropbox,box"; //No I18N
        }
				else{
					jQuery.ajax({
						type: "POST", //No I18N
						url: "/onpremisezc?action=saveOneDriveClientInfo", //No I18N
						data: {"odAplusClientId": jQuery.trim(jQuery("#odAplusClientId").val()), "odAplusClientSecret":jQuery.trim(jQuery("#odAplusClientSecret").val())}, //No I18N
						dataType: "html" //No I18N
					})
					.done(function(data, status){
					  
					});
					sourceList = "skydrive,gdrive,dropbox,box"; //No I18N
				}
            }
        else if(filetype==="ZDOCS")
        {
				if(!ZDBGlobal.IS_ONPREMISE_BUILD){
					sourceList = "zohodocs,gdrive,dropbox,box,skydrive";  //No I18N
				}
				else{
        	sourceList = "zohodocs,gdrive,dropbox,box,skydrive";  //No I18N
        }
            }
        else if(filetype==="GSHEET")
        {
				if(!ZDBGlobal.IS_ONPREMISE_BUILD){
        	sourceList = "gdrive,dropbox,box,skydrive,zohodocs";  //No I18N
        }
				else{
					jQuery.ajax({
						type: "POST", //No I18N
						url: "/onpremisezc?action=saveGdriveClientInfo", //No I18N
						data: {"gdriveAplusClientId": jQuery.trim(jQuery("#gdriveAplusClientId").val()), "gdriveAplusClientSecret":jQuery.trim(jQuery("#gdriveAplusClientSecret").val())}, //No I18N
						dataType: "html" //No I18N
					})
					.done(function(data, status){
					  
					});
					sourceList = "gdrive,dropbox,box,skydrive";  //No I18N
				}
            }
			
			var durl = ZDBGlobal.EXT_LIST_URL+"?";
			if(ZDBGlobal.IS_ONPREMISE_BUILD)
			{
				durl = ZDBGlobal.EXT_LIST_URL+".cc?"; //No I18N
			}
            var authURL =durl+"frameorigin="+ZDBGlobal.REPORTS_SERVER_URL+"&sources=" + sourceList +"&fileMimeTypes="+ZDBGlobal.ALLOWED_GDRIVE_FILETYPES+"&fileExtensions="+ZDBGlobal.ALLOWED_CLOUD_FILETYPES+ "&zservice="+ZDBGlobal.EXT_DRIVE_SERVICE+"&attachLimit=1&serURL="+ZDBGlobal.REPORTS_SERVER_URL+ZDBGlobal.REPORTS_CONTEXT_NAME+"/integ/ExternalIntegRedirect.jsp"; // No I18N
            
        ZDBExtInteg.authService(authURL);
    }
   
    this.authService = function(authURL)
    {
    	hideCustomMessage();
        if(authURL!=null)
        {
            var dlgDiv = document.getElementById("ZDBExtDriveIframeDialog");
            dlgDiv.tabIndex="1";
            dlgDiv.innerHTML="";       
            var dlg = document.createElement("iframe");
            dlg.domain="zohocorpin.com";//NO I18N
            dlg.height="100%";
            dlg.width="100%";
            dlg.style.border="0px";
            dlg.src = authURL;
            dlg.id = "extDriveIFrame";
            dlg.name = "extDriveIFrame";
            dlgDiv.appendChild(dlg);
          	ZDBDialogUtil.showDialog(dlgDiv,{MODAL:true,DONTREMOVE:true});
          	ZDBDialogUtil.positionCenter(dlgDiv);
        }        
        $("ZDBExtIntegButton").disabled=false;
    }

    this.alertAuth=function(response,subtype)
    {
    	hideCustomMessage();
        jQuery('#ZDBEXTERNALOPTSTATUS').hide();//NO I18N
      	ZDBDialogUtil.closeDialog();
        var resp= new Array();
        resp =	JSON.parse(response);
        if(resp!=null)
        {       
            var fileSubtype=subtype.toUpperCase();
            if(resp.dropbox.length!=0)
            {
                var dropboxObj=resp.dropbox;
                var dboxFilePath=dropboxObj[0].filePath;     
                var dboxFileName=dropboxObj[0].docName;
                var fileExtn= dboxFileName.substring(dboxFileName.lastIndexOf('.') + 1);
       
                $("DOCID").value=dboxFilePath;
                $("ZDBFILESUBTYPE").value=fileSubtype;
                $("DOCNAME").value=dboxFileName;
                if( $("ZDBFILETYPE")!=null)
                {
                    $("ZDBFILETYPE").value="DROPBOX";//NO I18N
                    enableOption($("ZDBFILETYPE"));
                    importStepValUpdate();
                }
                else
                {
                    $("ZDBEXFILETYPE").value="DROPBOX";//NO I18N
                    importStepValUpdate("existImport");//NO I18N
                    enableOption($("ZDBEXFILETYPE"),"existImport");//NO I18N
                }
                $("AccountID").value = dropboxObj[0].accountId;
                $("ZDBExtIntInput").setAttribute("tipShown","false");
                $("ZDBExtIntInput").value=decodeURIComponent(dboxFileName);
            }
            else if(resp.box.length!=0)
            {
             
                var boxObj=resp.box;
                var fileName=boxObj[0].docName;
                var boxId=boxObj[0].docId;
              
                $("DOCID").value=boxId;
                $("ZDBFILESUBTYPE").value=subtype.toUpperCase();
                if( $("ZDBFILETYPE")!=null)
                {
                    $("ZDBFILETYPE").value="BOX";//NO I18N
                    importStepValUpdate();
                    enableOption($("ZDBFILETYPE"));
                }
                else
                {
                    $("ZDBEXFILETYPE").value="BOX";//NO I18N
                    importStepValUpdate("existImport");//NO I18N
                    enableOption($("ZDBEXFILETYPE"),"existImport");//NO I18N
                }
                $("DOCNAME").value=fileName;
                $("ZDBExtIntInput").setAttribute("tipShown","false");
                $("ZDBExtIntInput").value=decodeURIComponent(fileName);              
            }
            else if(resp.skydrive.length!=0)
            {
             
                var skyObj=resp.skydrive;
                var fileName=skyObj[0].docName;
                var skyId=skyObj[0].docId;
                $("DOCID").value=skyId;
                $("ZDBFILESUBTYPE").value=subtype.toUpperCase();
                if( $("ZDBFILETYPE")!=null)
                {
                    $("ZDBFILETYPE").value="ONEDRIVE";//NO I18N
                    importStepValUpdate();
                    enableOption($("ZDBFILETYPE"));
                }
                else
                {
                    $("ZDBEXFILETYPE").value="ONEDRIVE";//NO I18N
                    importStepValUpdate("existImport");//NO I18N
                    enableOption($("ZDBEXFILETYPE"),"existImport");//NO I18N
                }
                $("DOCNAME").value=fileName;
                $("ZDBExtIntInput").setAttribute("tipShown","false");
                $("ZDBExtIntInput").value=decodeURIComponent(fileName);   
                $("ZDBExtIntegButton").disabled=false;
            }
            else if(resp.zohodocs.length!==0)
            {
             
                var zdocsObj=resp.zohodocs;
                var fileName=zdocsObj[0].docName;
                var zohodocsId=zdocsObj[0].docId;
                $("DOCID").value=zohodocsId;
                $("ZDBFILESUBTYPE").value=subtype.toUpperCase();
                if( $("ZDBFILETYPE")!==null)
                {
                    $("ZDBFILETYPE").value="ZDOCS";//NO I18N
                    importStepValUpdate();
                    enableOption($("ZDBFILETYPE"));
                }
                else
                {
                    $("ZDBEXFILETYPE").value="ZDOCS";//NO I18N
                    importStepValUpdate("existImport");//NO I18N
                    enableOption($("ZDBEXFILETYPE"),"existImport");//NO I18N
                }
                $("DOCNAME").value=fileName;
                $("ZDBExtIntInput").setAttribute("tipShown","false");
                $("ZDBExtIntInput").value=decodeURIComponent(fileName);   
                $("ZDBExtIntegButton").disabled=false;
            }
            else if(resp.gdrive.length!==0)
            {             
                var gdriveObj=resp.gdrive;
                var fileName=gdriveObj[0].docName;
                var gSheetId=gdriveObj[0].docId;
                $("ZDBGSHEETTYPE").value = gdriveObj[0].docType;
                $("ISFROMGDRIVE").value=(subtype !== "gsheet") ? true : false;
                $("ZDBGDRIVEFORMAT").value=(subtype !== "gsheet") ? subtype : "XLSX";  //No I18N
                $("ISGDRIVECSV").value=(subtype === "csv");
                $("ZDBGSHEETID").value=gSheetId;
                $("ZDBFILESUBTYPE").value=subtype.toUpperCase();
                if( $("ZDBFILETYPE")!==null)
                {
                    $("ZDBFILETYPE").value="GSHEET";//NO I18N
                    importStepValUpdate("",subtype);
                    enableOption($("ZDBFILETYPE"));
                }
                else
                {
                    $("ZDBEXFILETYPE").value="GSHEET";//NO I18N
                    importStepValUpdate("existImport",subtype);//NO I18N
                    enableOption($("ZDBEXFILETYPE"),"existImport");//NO I18N
                }
                $("ZDBGSHEETNAME").value=fileName;
//                $("DOCNAME").value=fileName;	
                $("ZDBExtIntInput").setAttribute("tipShown","false");
                $("ZDBExtIntInput").value=decodeURIComponent(fileName);   
                $("ZDBExtIntegButton").disabled=false;
            }
            changeTitle();
        }
      
    }
   
}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBExtInteg.getExtIntegFiles"]=ZDBExtInteg.getExtIntegFiles;
