//*$Id$*/
var ZDBGoogleInteg = new function()
{
    this.gSheetOrginalList;
    this.gSheetCurrentList;
    this.gSheetsLen;
    this.gNavStartInd;
    this.gNavEndInd;
    this.googleOrgResp;
    this.googleCurResp ;
    this.count = 0;
    this.gAppsEnableAPIDiv;
    this.gAppsEnableAPITitle;


    this.getGoogleDocs = function()
    {
        hideCustomMessage();
        $("ZDBGButton").disabled = true;
        AjaxAPI.sendRequest({
            URL:"/ZDBImportAction.ma?ZDBACTION=ZDBFETCHGDOCS", //No I18N
            ONSUCCESSFUNC:ZDBGoogleInteg.showGoogleSheets,
            ONFAILUREFUNC:ZDBGoogleInteg.showGoogleSheetsFailure,
            OPSTATUSID:"ZDBGSHEETOPTSTATUS" //No I18N
        });
    }
    this.showGoogleSheets = function(response,requestOptions)
    {
        $("ZDBGButton").disabled = false;
        var elt = $("ZDBGSheetCnt");
        if(!elt)
        {
            var dlgElt = window.divData["GSheetDlg"];
            $("ZDBAjaxResponseStore").innerHTML = dlgElt.innerHTML;
            ZDBDialogUtil.showDialog($("ZDBGSheetCnt"),{
            TITLE:ZDBI18NMap.g("zrpt.common.gsheet.js.select.sheet"),
            ADDFRAME:true,
            MODAL:true
        });
        }
        var googleResponse = JSON.parse(response.responseText);
        if(googleResponse.length > 0)
        {
        ZDBGoogleInteg.gSheetOrginalList = googleResponse;
        ZDBGoogleInteg.getGSheetNavLimit(true);
        }
        else
        {
            ZDBGoogleInteg.gSheetOrginalList = googleResponse;
            ZDBGoogleInteg.getGSheetNavLimit(true);
        }
        ZDBGoogleInteg.setLoadingElt("",false);
        if(ZDBClientUI.isGAppUser)
        {
           $("ZDBSigninAsDiffUser_GSheet").style.display = "none";
        }
        else
        {
           $("ZDBSigninAsDiffUser_GSheet").style.display = "";
        }
    }

    this.getGSheetNavLimit = function(isNew)
    {
        var leftNav;
        var rightNav;
        $("ZDBGListBody").innerHTML="";
        if(isNew == true)
        {
            ZDBGoogleInteg.gSheetCurrentList = ZDBGoogleInteg.gSheetOrginalList.slice();
            ZDBGoogleInteg.gNavStartInd = 1;
            ZDBGoogleInteg.gNavEndInd = 10;
        }
        var len =  ZDBGoogleInteg.gSheetsLen = ZDBGoogleInteg.gSheetCurrentList.length;
        if(len == 0)
        {
            var curDiv = $("ZDBNoGSheets").cloneNode(true);
            $("ZDBGListBody").appendChild(curDiv);
            if(isNew == false)
            {
                curDiv.innerHTML=ZDBI18NMap.g("zrpt.common.gsheet.js.no.matching.files");
                $("ZDBSelectedSheetHolder").style.display = "none";
            }
            else
            {
                ZDBGoogleInteg.setLoadingElt(ZDBI18NMap.g("zrpt.common.gsheet.js.select.nofiles"),false); //No I18N
            }
            $("ZDBGNavigation").style.display = "none";
        }
        else
        {
            if(ZDBGoogleInteg.gNavStartInd == 1) {
                leftNav = true;
            }
            else {
                leftNav = false;
            }
            if(ZDBGoogleInteg.gNavEndInd >= len)  {
                rightNav =true;
                ZDBGoogleInteg.gNavEndInd= len;
            }
            else {
                rightNav = false;
            }
            ZDBGoogleInteg.setGSheetNavigation(leftNav,rightNav);
            ZDBGoogleInteg.appendGSheetsInBody();
            if(!isNew)
            {
                ZDBUtil.setRadioSelectedValue($("ZDBGSheetForm"),"GSHEETLIST",ZDBGoogleInteg.selectedDocID,"docid"); //No I18N
            }
        }
    }
    this.setGSheetNavigation = function(leftNav,rightNav)
    {
        var indexStr = ZDBGoogleInteg.gNavStartInd + " - " + ZDBGoogleInteg.gNavEndInd +" "+ZDBI18NMap.g("zrpt.common.gsheet.js.of")+" "+ ZDBGoogleInteg.gSheetsLen; //No I18N
        $("ZDBGSheetNavigation").innerHTML = indexStr;
        var leftNavElt = $("GSheetLeftNav");
        var rightNavElt = $("GSheetRightNav");
        if(leftNav == true)
        {
            leftNavElt.disabled = true;
            leftNavElt.className = "gSheetleftNavDisabled"; //No I18N
        }
        else
        {
            leftNavElt.disabled = false;
            leftNavElt.className = "gSheetleftNavEnabled";
        }
        if(rightNav == true)
        {
            rightNavElt.disabled = true;
            rightNavElt.className = "gSheetRightNavDisabled"; //No I18N
        }
        else
        {
            rightNavElt.disabled = false;
            rightNavElt.className = "gSheetRightNavEnabled"
        }
        $("ZDBGNavigation").style.display ="";
    }
    this.appendGSheetsInBody = function(stin,edin)
    {
        var gSheetBody = $("ZDBGListBody");
        var si = parseInt(ZDBGoogleInteg.gNavStartInd)-1;
        var ei = parseInt(ZDBGoogleInteg.gNavEndInd)-1;
        for(var i = si; i <= ei; i++ )
        {
            var gSheet = ZDBGoogleInteg.gSheetCurrentList[i];
            if(gSheet!= null)
            {
                var sheetName = gSheet["docName"];
                var sheetId = gSheet["docId"];
                var sheetType = gSheet["docType"];
                var divHolder = $("ZDBSheetListTemplate");
                var curDiv = DOMUtils.getFirstChild(divHolder,"id","ZDBGSampleSheetDiv").cloneNode(true); //No I18N
                var inputElt = DOMUtils.getFirstChild(curDiv,"id","ZDBGSheetRadio"); //No I18N
                inputElt.setAttribute("docId", sheetId);
                inputElt.setAttribute("docName", sheetName);
                inputElt.setAttribute("docType", sheetType);


                var sheetNameElt = DOMUtils.getFirstChild(curDiv,"id","ZDBSheetName"); //No I18N
                sheetNameElt.setAttribute("value", sheetName);
                if(sheetName.length>50)
                {
                    sheetName = sheetName.substring(0,50)+"..";
                }
                sheetNameElt.innerHTML = sheetName;
                gSheetBody.appendChild(curDiv);
            }
        }
        $("LoadArea").style.display = "none";
    }

    this.getNextSheetList = function(elt,event)
    {
        var navElt = elt.id;
        if(navElt  == "GSheetLeftNav")
        {
            if((ZDBGoogleInteg.gNavStartInd - 10)<=0){return;}
            ZDBGoogleInteg.gNavStartInd = parseInt(ZDBGoogleInteg.gNavStartInd) - 10;
            ZDBGoogleInteg.gNavEndInd = parseInt(ZDBGoogleInteg.gNavStartInd) +9  ;
        }
        else if(navElt == "GSheetRightNav")
        {
            if(ZDBGoogleInteg.gNavEndInd >= ZDBGoogleInteg.gSheetsLen){return;}
            ZDBGoogleInteg.gNavStartInd = parseInt(ZDBGoogleInteg.gNavStartInd) + 10;
            ZDBGoogleInteg.gNavEndInd = parseInt(ZDBGoogleInteg.gNavStartInd) + 9;
        }
        ZDBGoogleInteg.getGSheetNavLimit();
    }
    this.setLoadingElt = function(text,visible)
    {
        var loadingElt = $("ZDBLoadArea");
        if(loadingElt)
        {
            if(visible == true)
            {
                $("ZDBLoadArea").style.display="";
            }
            else if(visible == false)
            {
                $("ZDBLoadArea").style.display="none";
            }
            var loadElt = $("LoadArea");
            loadElt.style.display="";
            loadElt.innerHTML = text;
            loadElt.setAttribute("value",text);
        }
    }
    this.checkSheetsList = function()
    {
         var loadElt = $("LoadArea");
         var value = loadElt.getAttribute("value");
         var textMsg;
         if(value == "Authenticating")
         {
             textMsg = ZDBI18NMap.g("zrpt.common.gsheet.js.auth.with.google");
         }
         if(value == "NoFiles")
         {
             textMsg = ZDBI18NMap.g("zrpt.common.gsheet.js.no.sheet.available");
         }
         ZDBGoogleInteg.setTextInGListBody(textMsg);
    }
    this.setTextInGListBody = function(textMsg)
    {
        $("ZDBGListBody").innerHTML = "";
        var msgDiv = $("ZDBNoGSheets").cloneNode(true);
        msgDiv.innerHTML = textMsg;
        $("ZDBGListBody").appendChild(msgDiv);
    }
    this.highLightGsheet = function(elt)
    {
        $(elt).className= "trHighLight";
    }
    this.deHighLightGsheet = function(elt)
    {
        var curDiv = DOMUtils.getFirstChild(elt,"id","ZDBGSheetRadio"); //No I18N
        if(!curDiv.checked)
        {
            $(elt).className ="";
        }
    }
    this.selectRadio = function(elt)
    {
        var parent = elt.parentNode;
        var inputElt = DOMUtils.getFirstChild(parent,"id","ZDBGSheetRadio"); //No I18N
        inputElt.checked = true;
        var gSheetName = ZDBEscapeUtil.decodeForHtml($(elt).getAttribute("value"));
        ZDBGoogleInteg.showSelectedGSheetName(inputElt,gSheetName);
    }
    this.onRadioSelect = function(elt)
    {
        var docName = elt.getAttribute("docname");
        ZDBGoogleInteg.showSelectedGSheetName(elt,docName);
    }
    this.showSelectedGSheetName = function(elt,sheetName)
    {
        var partentElt = document.getElementById("ZDBGListBody");
        var divElts = partentElt.getElementsByTagName("div");
        ZDBGoogleInteg.selectedDocID = elt.getAttribute("docid");
        ZDBGoogleInteg.selectedDocType = elt.getAttribute("docType");
        DOMUtils.removeCSSClass(divElts,"trHighLight"); //No I18N
        ZDBGoogleInteg.highLightGsheet(elt.parentNode);
        var selGSheetId = $("ZDBSelectedGSheetName");
        selGSheetId.setAttribute("value", sheetName);
        if(sheetName.length>20)
        {
            sheetName = sheetName.substr(0,20)+"...";
        }
        $("ZDBSelectedSheetHolder").style.display="";
        selGSheetId.innerHTML="";
        selGSheetId.innerHTML=sheetName;
    }
    this.fetchSelectedSheet = function(frm)
    {
    	if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js", this, ZDBGoogleInteg.fetchSelectedSheet,[frm]))
  	  	{
  	  		return;
  	  	}
        var radioElt = ZDBUtil.getSelectedRadioEltWithAttrVal($("ZDBGListBody"),"name","GSHEETLIST"); //No I18N
        var gListBody = $("ZDBGListBody");
        var isRadioPresent = DOMUtils.getFirstChild(gListBody,"id","ZDBGSampleSheetDiv"); //No I18N
        if(isRadioPresent)
        {
            if(!radioElt)
            {
                ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.gsheet.js.select.one.sheet"));
                return;
            }
            var sheetId = radioElt.getAttribute("docId");
            var sheetName = radioElt.getAttribute("docName");
            var sheetType = radioElt.getAttribute("docType");
            var fileExtension = ZDBImport.getFileExtension(sheetName).toUpperCase();
            fileExtension = (sheetType.toLowerCase() == "spreadsheet") ? "" : fileExtension;//No I18N
            ZDBDialogUtil.closeDialog();
            window.totStep = 3;
            $("ISFROMGDRIVE").value = false;
            if(sheetType.toLowerCase() !== "spreadsheet")
            {
                $("ISFROMGDRIVE").value = true;
                $("ZDBGDRIVEFORMAT").value = fileExtension;
                for(var i = 0; i < ZDBImportConst.GDRIVE_CSV_EXTNS.length; i++)
                {
                    var extn = ZDBImportConst.GDRIVE_CSV_EXTNS[i].toUpperCase();
                    if(extn == fileExtension)
                    {
                        $("ZDBGDRIVEFORMAT").value = extn.replace('.','');
                        for(var j = 0; j < ZDBImportConst.GDRIVE_CSV_EXTNS.length; j++)
                        {
                            if(fileExtension == ZDBImportConst.GDRIVE_CSV_EXTNS[j].toUpperCase())
                            {
                                $("ISGDRIVECSV").value = true;
                                window.totStep = 2;
                            }
                        }
                       
                        break;
                    }
                }
            }
            else
            {
               $("ZDBGDRIVEFORMAT").value = "XLSX";     //No I18N
            }
            $("ZDBGSHEETID").value = sheetId;
            $("ZDBGSHEETTYPE").value = sheetType;
            $("ZDBInputGSS").value = sheetName;
            $("ZDBGSHEETNAME").value = sheetName;
            $("ZDBInputGSS").setAttribute("tipShown","false");

        }
        else
        {
            ZDBDialogUtil.closeDialog();
        }
        $("ZDBGButton").disabled = false;
    }
    // Enter Key press -- Have to put in same method
    this.searchGSheetsKeyPress = function(event,searchElt)
    {
        var key;
        if (window.event) {
            key = window.event.keyCode;
        }
        else if (event) {
            key = event.which;
        }
        //Enter Key
        if (key==13)
        {
            ZDBGoogleInteg.getSearchList(searchElt);
        }
        return false;
    }

    this.getSearchList = function(searchElt)
    {
        var searchValue = ZDBSearchUtil.getSearchValue($(searchElt));
        ZDBGoogleInteg.gSheetCurrentList.clear();
        if(ZDBGoogleInteg.gSheetOrginalList == null)
        {
            ZDBGoogleInteg.checkSheetsList();
            return;
        }
        if(searchValue == null)
        {
            ZDBGoogleInteg.gSheetCurrentList = ZDBGoogleInteg.gSheetOrginalList.slice();
        }
        else
        {
            var j=0;
            searchValue = searchValue.toLowerCase();
            for(var i=0;i<ZDBGoogleInteg.gSheetOrginalList.length;i++)
            {
                var curSheet = ZDBGoogleInteg.gSheetOrginalList[i];
                var sheetName = curSheet["docName"].toLowerCase();
                if((sheetName.indexOf(searchValue))>-1)
                {
                    ZDBGoogleInteg.gSheetCurrentList[j] = curSheet;
                    j++;
                }
            }
        }
        ZDBGoogleInteg.gNavStartInd = 1;
        ZDBGoogleInteg.gNavEndInd = 10;
        ZDBGoogleInteg.getGSheetNavLimit(false);
    }


  this.showGoogleContacts = function(el)
  {
    	jQuery("#GoogleContacts").find(".zdbselected").addClass("zdbcontactFilter").removeClass("zdbselected"); // No I18N
    	jQuery("#ZDBAllGoogleContacts").addClass("zdbselected").removeClass("zdbcontactFilter"); // No I18N
      ZDBGoogleInteg.showGoogleContactsDlg(el,true);
  }
  this.showGoogleContactsDlg = function(el,reFetch)
  {
    var menuEl = null;
    var srcEl = null;
    var view = ZDBClientUI.getViewObj(el,"view");
    var processIcon = "ZDBAddUsersProcess";          //No I18N
    if($("GoogleContacts").style.display != "none")
    {
      processIcon = "ZDBUserGContactsProcess";      //No I18N
    }
    if(el != null)
    {
      menuEl = DOMUtils.getParentWithAttr(el,"isMenu");
      srcEl = menuEl.srcEl;
    }
  	jQuery("#GoogleContacts").addClass("ZRSShadow"); // No I18N
    AjaxAPI.sendRequest({URL:"/ZDBSecurityAction.ma?ZDBACTION=ZDBGETGOOGLECONTACTS&REFETCH="+reFetch, METHOD: 'GET',  //No I18N
            ONSUCCESSFUNC:ZDBGoogleInteg.handleShowGoogleContacts,
            ONFAILUREFUNC:ZDBGoogleInteg.handleShowGoogleContactsFailure,
                              SRCEL:srcEl,VIEW:view,
                              OPSTATUSID:processIcon,REFETCH:reFetch});  //No I18N
    }


    this.showSearchedGoogleContactsDlg = function(searchWord,containsCheck,el)
    {
      	var par = jQuery(el).parent();
      	jQuery(par).find(".zdbselected").addClass("zdbcontactFilter").removeClass("zdbselected");
      	jQuery(el).addClass("zdbselected").removeClass("zdbcontactFilter");
        containsCheck = (containsCheck)?true:false;
    AjaxAPI.sendRequest({URL:"/ZDBSecurityAction.ma?ZDBACTION=ZDBGETGOOGLECONTACTS&REFETCH=true&SEARCHSTR="+encodeURIComponent(searchWord)+"&CONTAINSCHECK="+containsCheck, METHOD: 'GET',  //No I18N
            ONSUCCESSFUNC:ZDBGoogleInteg.handleShowSearchedGoogleContacts,
            ONFAILUREFUNC:ZDBGoogleInteg.handleShowGoogleContactsFailure,
                              OPSTATUSID:"ZDBUserGContactsProcess",REFETCH:"true"});  //No I18N
    }

    this.showSearchedGoogleAppUsersDlg = function(searchWord,containsCheck)
    {
        containsCheck = (containsCheck)?true:false;
    AjaxAPI.sendRequest({URL:"/ZDBSecurityAction.ma?ZDBACTION=ZDBFETCHGAPPUSERS&SEARCHSTR="+encodeURIComponent(searchWord)+"&CONTAINSCHECK="+containsCheck, METHOD: 'GET',  //No I18N
            ONSUCCESSFUNC:ZDBGoogleInteg.handleShowSearchedGoogleAppUsers,
            ONFAILUREFUNC:ZDBGoogleInteg.handleShowSearchedGoogleAppUsersFailure,
                              OPSTATUSID:"ZDBGAppUserProcess"});  //No I18N
    }

    this.handleShowSearchedGoogleContacts = function(response,requestOptions)
    {
        $("myGoogleContacts").innerHTML = response.responseText;
    }

    this.handleShowSearchedGoogleAppUsers = function(response,requestOptions)
    {
        $("myGoogleAppUsers").innerHTML = response.responseText;
    }
    // Enter Key press -- Have to put in same method
    this.gContactsSearchKeyPress = function(el, ev, mode)
    {
        var key;
        if (window.event) {
            key = window.event.keyCode;
        } else if (ev) {
            key = ev.which;
        }

        //Enter Key
        if (key==13)
        {
            if(mode == "gcontacts")
            {
              var searchStr = $("searchGContactStr").value;
              ZDBGoogleInteg.showSearchedGoogleContactsDlg(searchStr,true);
            }
            else if(mode == "gappusers")
            {
               var searchStr = $("searchGAppUserStr").value;
               ZDBGoogleInteg.showSearchedGoogleAppUsersDlg(searchStr,true);
            }
        }
    }

    this.handleShowGoogleContacts = function(response,requestOptions)
    {
    var srcEl = requestOptions["SRCEL"];
    var view = requestOptions["VIEW"];

    $("myGoogleContacts").innerHTML = response.responseText;
    if(ZDBClientUI.isGAppUser == true)
    {
       $("ZDBSigninAsDiffUser").style.display = "none";
    }
    else
    {
       $("ZDBSigninAsDiffUser").style.display = "";
    }
    var dlg = $("GoogleContacts");
    if(view != null && view.dialogStatus > 0 && ZDBDialogUtil.focusDialog == null) // View null check is needed as Explorer doesn't have any view
    {
        var parEl = srcEl.parentNode;
        ZDBSecuritySettings.removeChildsWithAttr(parEl,"emailcontactsdlg"); //No I18N
        var dummyDlg = dlg.cloneNode(true);
        dummyDlg.id = "";
        dummyDlg.setAttribute("emailcontactsdlg","true");
        parEl.appendChild(dummyDlg);
        var changeClassEl = dummyDlg.getElementsByTagName("div")[0];
        if(srcEl == $('inlineAddUserFromEl'))
        {
            dummyDlg.style.zIndex = 3;
        }
        changeClassEl.className = srcEl == $('inlineAddUserFromEl') ? "inlineAddUserFromStyle" : "borderwhite";
        dummyDlg.style.display = "block";
        dummyDlg.style.top = ZDBUtil.getObjTop(srcEl,true,parEl)+parEl.offsetHeight+"px";
        dummyDlg.style.left = ZDBUtil.getObjLeft(srcEl,true,parEl);
    }
    else
    {
            if(srcEl == null)
            {
              srcEl = $("ZDBAddUsersFromMenu"); // In all the dialogs, the menu will be popped up from this element
            }
            if(srcEl != null)
            {
              var changeClassEl = dlg.getElementsByTagName("div")[0];
              changeClassEl.className = srcEl == $('inlineAddUserFromEl') ? "inlineAddUserFromStyle" : "borderwhite";
              document.body.appendChild(dlg);
              ZDBMenuUtil.positionEl(dlg,srcEl,false);
            }
            dlg.style.display = "";
            ZDBDialogUtil.focusDialog.attachedEl = dlg;
     }
  }

  //Combine both failure methods
    this.showGoogleSheetsFailure = function(response,requestOptions)
    {
        $("ZDBGButton").disabled = false;
        var errCode = response.getResponsePart("ERRORCODE");    //No I18N
        errCode = trimAll(errCode);
        if(errCode == "GOOGLE_AUTH_REQUIRED")
                {
                    var authURL = ZDBGlobal.GAPP_EMBED_GADGET_URL+"/gdocs?auth=true&zservice="+ZDBGlobal.GAPP_ZSERVICE+"&border=no&serURL="+ZDBGlobal.REPORTS_SERVER_URL+ZDBGlobal.REPORTS_CONTEXT_NAME+"/integ/GResponseRedirect.jsp?gauth_type=sheets"; // No I18N
            ZDBGoogleInteg.authGoogle(authURL);
        }
        else
        {
            var elt = $("ZDBGSheetCnt");
            if(!elt)
            {
                var dlgElt = window.divData["GSheetDlg"];
                $("ZDBAjaxResponseStore").innerHTML = dlgElt.innerHTML;
                ZDBDialogUtil.showDialog($("ZDBGSheetCnt"),{
                TITLE:ZDBI18NMap.g("zrpt.common.gsheet.js.select.sheet"),
                ADDFRAME:true,
                MODAL:true
                });
            }
            var msgDiv = $("ZDBNoGSheets").cloneNode(true);
            msgDiv.innerHTML = ZDBI18NMap.g("zrpt.common.gsheet.js.retrieve");
            $("ZDBGListBody").appendChild(msgDiv);
            $("ZDBGNavigation").style.display = "none";
            ZDBGoogleInteg.setLoadingElt("",false);
        }
    }

    this.handleShowGoogleContactsFailure = function(response,requestOptions)
    {
        var errCode = response.getResponsePart("ERRORCODE");    //No I18N
        errCode = trimAll(errCode);
        if(errCode == "GOOGLE_AUTH_REQUIRED")
        {
          if(ZDBClientUI.isGAppUser == true)
          {
            ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.share.shareview.js.contact_gapp_admin"));
          }
          else
          {
            var authURL = ZDBGlobal.GAPP_EMBED_GADGET_URL+"/gcontacts?auth=true&zservice="+ZDBGlobal.GAPP_ZSERVICE+"&border=no&serURL="+ZDBGlobal.REPORTS_SERVER_URL+ZDBGlobal.REPORTS_CONTEXT_NAME+"/integ/GResponseRedirect.jsp?gauth_type=contacts"; // No I18N
            ZDBGoogleInteg.authGoogle(authURL);
          }
        }
        else
        {
          $("myGoogleContacts").innerHTML = response.responseText;
          var srcEl = $("ZDBAddUsersFromMenu"); // In all the dialogs, the menu will be popped up from this element
          var dlg = $("GoogleContacts");
          document.body.appendChild(dlg);
          ZDBMenuUtil.positionEl(dlg,srcEl,false);
          dlg.style.display = "";
          ZDBDialogUtil.focusDialog.attachedEl = dlg;
        }
    }

    this.revokeGToken = function(el,event)
    {
        var gType = el.getAttribute("gtype");
        if(gType == "sheets")
        {
            $("ZDBSelectedSheetHolder").style.display = "none";
            ZDBGoogleInteg.selectedDocID = null;
        }
        var url = "/ZDBSecurityAction.ma?ZDBACTION=ZDBREVOKEGTOKEN&GTYPE="+gType; //No I18N
            AjaxAPI.sendRequest({URL:url,  //No I18N
            ONSUCCESSFUNC:ZDBGoogleInteg.handleRevokeGToken,
            ONFAILUREFUNC:ZDBGoogleInteg.handleRevokeGTokenFailure,
            GOOGLETYPE:gType,
                              OPSTATUSID:"ZDBUserGContactsProcess"});  //No I18N
    }

    this.handleRevokeGToken = function(response,requestOptions)
    {
        var gType = requestOptions['GOOGLETYPE'];
        var authURL = ZDBGlobal.GAPP_EMBED_GADGET_URL;
        if(gType && gType == "contacts")
        {
            authURL = authURL+"/gcontacts?auth=true&zservice="+ZDBGlobal.GAPP_ZSERVICE+"&border=no&serURL="+ZDBGlobal.REPORTS_SERVER_URL+ZDBGlobal.REPORTS_CONTEXT_NAME+"/integ/GResponseRedirect.jsp"; // No I18N
        }
        else if(gType && (gType == "sheets" || gType == "refetch" || gType =="createdb" || gType =="existimport" || gType == "schDialog"))
        {
            authURL = authURL+"/gdocs?auth=true&zservice="+ZDBGlobal.GAPP_ZSERVICE+"&border=no&serURL="+ZDBGlobal.REPORTS_SERVER_URL+ZDBGlobal.REPORTS_CONTEXT_NAME+"/integ/GResponseRedirect.jsp"; // No I18N
        }
        else if(gType && (gType.toLowerCase() == "gadwords"))
        {
          authURL = authURL + "/zgadwords?&zservice=zreports&serURL="+ZDBGlobal.REPORTS_SERVER_URL+ZDBGlobal.REPORTS_CONTEXT_NAME+"/integ/GResponseRedirect.jsp";  // No I18N
        }
        authURL += "?gauth_type="+gType; //No I18N
        var resp = ""+response.responseText.trim();
        if(resp=="true")
        {
            if(gType.toLowerCase() == "gadwords")
            {
                ZDBGoogleInteg.authGoogleAdwords(authURL);
            }
            else
            {
                ZDBGoogleInteg.authGoogle(authURL);
            }
        }
        else
        {
            ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.share.shareview.js.errInGAuth"));
        }
    }

    this.handleRevokeGTokenFailure = function(response,requestOptions)
    {
        var errCode = response.getResponsePart("ERRORCODE");    //No I18N
        errCode = trimAll(errCode);
       var googleType = requestOptions['GOOGLETYPE'];
        if(errCode == "CONTAINS_SCHEDULED_GSHEETS" || errCode == "CONTAINS_SCHEDULED_GADMODULES")
        {
            if(googleType.toLowerCase() == 'gadwords')
            {
            		ZRGADInteg.showScheduledDB();
            		return;
            }
            else
            {
              schGSheetDlg = $("ZDBSchGSheetDlg");
              if(!schGSheetDlg)
              {
                  schGSheetDlg = window.divData["ScheduledGSheets"];
              }
              $("ZDBAjaxResponseStore").innerHTML = schGSheetDlg.innerHTML;
              dlg = $("ZDBSchGSheetDlg");
              //msg = 'zrpt.common.gsheet.js.scheduled_warning.title'; //No I18N
            }
            var msg = 'zrpt.common.gsheet.js.scheduled_warning.title';  //No I18N
            ZDBDialogUtil.showDialog(dlg,{
            TITLE:ZDBI18NMap.g(msg),
            ADDFRAME:true,
            MODAL:true,
            DONTREMOVE:true
        });
        }
        else
        {
         ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.share.shareview.js.errInGAuth"));
        }
    }

    this.revokeGDocsToken = function(el)
    {
        var gType = el.getAttribute("gtype");
        var url = "/ZDBSecurityAction.ma?ZDBACTION=ZDBREVOKEGDOCSTOKEN&GTYPE=sheets"; //No I18N
            AjaxAPI.sendRequest({URL:url,
            ONSUCCESSFUNC:ZDBGoogleInteg.handleRevokeGToken,
            ONFAILUREFUNC:ZDBGoogleInteg.handleRevokeGTokenFailure,
            GOOGLETYPE:gType
                              });
    }
    this.revokeGDocsTokenAndStopSch =function()
    {
        ZDBDialogUtil.closeDialog();
        var url = "/ZDBSecurityAction.ma?ZDBACTION=ZDBREVOKEGDOCSTOKANDSTOPSCH&GTYPE=sheets"; //No I18N
            AjaxAPI.sendRequest({URL:url,
            ONSUCCESSFUNC:ZDBGoogleInteg.handleRevokeGToken,
            ONFAILUREFUNC:ZDBGoogleInteg.handleRevokeGTokenFailure,
            GOOGLETYPE:"sheets" //No I18N
                              });
    }

    this.showScheduledGAdwordsClients = function(el)
    {
        var dlg = $("ZDBSchGAdwordsClients");
        var isGAdwordsClientsAvail = dlg.getAttribute("isGAdwordsClientsAvailable");
        if(isGAdwordsClientsAvail == "true")
        {
            ZDBGoogleInteg.toggleSchGAdwordsClientsListDiv();
        }
        else if(isGAdwordsClientsAvail == "false")
        {
            var url = "/ZDBGADSchProfiles.cc?"; //No I18N
                AjaxAPI.sendRequest({URL:url,  //No I18N
                ONSUCCESSFUNC:ZDBGoogleInteg.handleShowSchGAdwordsClients,
                Element:el
                });  //No I18N
        }
    }

    this.handleShowSchGAdwordsClients = function(response,requestOptions)
    {
        $("ScheduledGAdwordsClientsHolder").innerHTML = response.responseText;
        $("ZDBSchGAdwordsClients").setAttribute("isGAdwordsClientsAvailable","true");
        ZDBGoogleInteg.toggleSchGAdwordsClientsListDiv();
    }

    this.toggleSchGAdwordsClientsListDiv =function()
    {
        var toggleSpan = $("ZDBShowSchGAdwordsClients");
        var isGAdwordsClientsListed = toggleSpan.getAttribute("isGAdwordsClientsListed");
        var canShow = (isGAdwordsClientsListed == "true")?"false":"true";
        toggleSpan.setAttribute("isGAdwordsClientsListed",canShow);
        if(canShow == "true")
        {
            $("ZDBSchGAdwordsClients").style.display="";
            $("ZDBSchGAdwordsClientsProceed").style.paddingLeft="";
        }
        else if(canShow =="false")
        {
            $("ZDBSchGAdwordsClients").style.display="none";
            $("ZDBSchGAdwordsClientsProceed").style.paddingLeft="55px";  //No I18N
        }
    }
    this.showScheduledGSheets = function(el)
    {
        var isGSheetsAvail = $("ZDBSchGSheets").getAttribute("isGSheetsAvailable");
        if(isGSheetsAvail == "true")
        {
            ZDBGoogleInteg.toggleSchGSheetsListDiv();
        }
        else if(isGSheetsAvail == "false")
        {
            var url = "/ZDBSecurityAction.ma?ZDBACTION=ZDBSHOWSCHEDULEDGSHEETS"; //No I18N
                AjaxAPI.sendRequest({URL:url, METHOD: 'GET',  //No I18N
                ONSUCCESSFUNC:ZDBGoogleInteg.handleShowSchGSheets,
                Element:el
                });  //No I18N
        }
    }

    this.handleShowSchGSheets =function(response,requestOptions)
    {
        var respMsg = response.responseText;
        $("ScheduledGSheetsHolder").innerHTML = respMsg;
        $("ZDBSchGSheets").setAttribute("isGSheetsAvailable","true");
        ZDBGoogleInteg.toggleSchGSheetsListDiv();
    }

    this.toggleSchGSheetsListDiv =function()
    {
        var toggleSpan = $("ZDBShowSchGSheets");
        var isGSheetsListed = toggleSpan.getAttribute("isGSheetsListed");
        var canShow = (isGSheetsListed == "true")?"false":"true";
        toggleSpan.setAttribute("isGSheetsListed",canShow);
        if(canShow == "true")
        {
            $("ZDBSchGSheets").style.display="";
            $("ZDBSchGSheetProceed").style.paddingLeft="";
        }
        else if(canShow =="false")
        {
            $("ZDBSchGSheets").style.display="none";
            $("ZDBSchGSheetProceed").style.paddingLeft="55px"; //No I18N
        }
    }

    this.authGoogleAdwords = function(authURL)
    {
        var dlg = document.createElement("iframe");
        dlg.height = "400px";
        dlg.width = "950px";
        dlg.style.border="0px";
        dlg.style.overflow="hidden";
        dlg.src = authURL;
        dlg.id = "authGoogleIFrame";
        dlg.name = "authGoogleIFrame";
        ZDBDialogUtil.showDialog(dlg,{MODAL:true,DONTREMOVE:false,ZINDEX:20000});
    }


    this.authGoogle = function(authURL)
    {
        var title = ZDBI18NMap.g("zrpt.common.share.shareview.js.authForGoogle");
        var dlgDiv = document.createElement("div");
        dlgDiv.id = "authGoogleDiv";
        dlgDiv.style.zIndex = 1000000;
        dlgDiv.className="gContactsRevokeToken";
        var dlg = document.createElement("iframe");
        dlg.src = authURL;
        dlg.id = "authGoogleIFrame";
        dlg.name = "authGoogleIFrame";
        dlg.className="gContactsRevTokenIframe";
        dlgDiv.appendChild(dlg);
        ZDBDialogUtil.showDialog(dlgDiv,{MODAL:true,ADDFRAME:true,TITLE: title,SHADOW:true,DONTREMOVE:false,ZINDEX:20000});
    }

    this.removeCloseButton = function()
    {
        $("header_color").style.display = "none";
    }

    this.authGoogleResponse = function(gType, mail, isNewDB, connDBInfoId)
    {
    	if(gType == "existimport")
        {
	    	if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js", this, ZDBGoogleInteg.authGoogleResponse,[gType, mail]))
	  	  	{
	  	  		return;
	  	  	}
        }
        ZDBDialogUtil.closeDialog();
        if(gType == "contacts")
        {
            ZDBGoogleInteg.showGoogleContactsDlg(null,false);
        }
        else if (gType == "contactsapi") {
            // For Contacts Picker Component
            Contacts.onGoogleAuthenticationPass();
        }
        else if(gType == "sheets")
        {
            ZDBGoogleInteg.setLoadingElt(ZDBI18NMap.g("zrpt.common.gsheet.js.select.fetching"),true); //No I18N
            ZDBGoogleInteg.getGoogleDocs();
        }
        else if(gType == "refetch")
        {
            ZDBImportSchedule.refreshNow();
        }
        else if(gType == "createdb")
        {
            submitCreateDB($("ZDBCreateFrm"));
        }
        else if(gType == "existimport")
        {
            ZDBImport.submitExistImportForm($("ZDBEXCreateFrm"));
        }
        else if(gType.toLowerCase() == "gadwords")
        {
      	  	ZRGADInteg.downloadClientList(mail, isNewDB, true);  // No I18N
        }
        else if(gType.toLowerCase() == "schdialog")
        {
          ZDBImportSchedule.showScheduleDetailsDlg($("ZDB_IMP_SCHEDULE_MENUITEM"));
        }
        else if(gType.toLowerCase() === "ganalytics")
    	{
        	ZRGAnalInteg.getDBDetailsDlg(true, mail, isNewDB);  // No I18N
    	}
        else if(gType.toLowerCase() === "ganalyticsfromedit")
    	{
        	ZRGAnalInteg.updateAuthTokenStatus(mail, connDBInfoId);
    	}
        else if(gType.toLowerCase() === "gadfromedit")
    	{
        	ZRGADInteg.updateAuthTokenStatus(mail);
    	}
    }

  this.openMyGoogleAppUsers = function(el)
    {
    var menuEl = DOMUtils.getParentWithAttr(el,"isMenu");
    var srcEl = menuEl.srcEl;
    var view = ZDBClientUI.getViewObj(el,"view");
    AjaxAPI.sendRequest({URL:"/ZDBSecurityAction.ma?ZDBACTION=ZDBFETCHGAPPUSERS", METHOD: 'GET',  //No I18N
            ONSUCCESSFUNC:ZDBGoogleInteg.handleShowGoogleAppUsers,
            ONFAILUREFUNC:ZDBGoogleInteg.handleShowGoogleAppUsersFailure,
                         SRCEL:srcEl,VIEW:view,
	                       OPSTATUSID:"ZDBAddUsersProcess"});  //No I18N
    }

    this.handleShowGoogleAppUsers = function(response,requestOptions)
    {
    var srcEl = requestOptions["SRCEL"];
    var view = requestOptions["VIEW"];
    $("myGoogleAppUsers").innerHTML = response.responseText;
    var dlg = $("GoogleAppUsers");
    if(view != null && view.dialogStatus > 0 && ZDBDialogUtil.focusDialog == null) // View null check is needed as Explorer doesn't have any view
    {
        var parEl = srcEl.parentNode;
        ZDBSecuritySettings.removeChildsWithAttr(parEl,"emailcontactsdlg"); //No I18N
        var dummyDlg = dlg.cloneNode(true);
        dummyDlg.id = "";
        dummyDlg.setAttribute("emailcontactsdlg","true");
        parEl.appendChild(dummyDlg);
        var changeClassEl = dummyDlg.getElementsByTagName("div")[0];
        if(srcEl == $('inlineAddUserFromEl'))
        {
            dummyDlg.style.zIndex = 3;
        }
        changeClassEl.className = srcEl == $('inlineAddUserFromEl') ? "inlineAddUserFromStyle" : "borderwhite";
        dummyDlg.style.display = "block";
        dummyDlg.style.top = ZDBUtil.getObjTop(srcEl,true,parEl)+parEl.offsetHeight;
        dummyDlg.style.left = ZDBUtil.getObjLeft(srcEl,true,parEl);
    }
    else
    {
        if(srcEl != null)
        {
          var changeClassEl = dlg.getElementsByTagName("div")[0];
          changeClassEl.className = srcEl == $('inlineAddUserFromEl') ? "inlineAddUserFromStyle" : "borderwhite";
          document.body.appendChild(dlg);
          ZDBMenuUtil.positionEl(dlg,srcEl,false);
        }
        ZDBDialogUtil.focusDialog.attachedEl = dlg;
    }
  }

    this.handleShowGoogleAppUsersFailure = function(response,requestOptions)
    {
    	if(response.getResponsePart("ERRORNUMCODE") == 1016)
    	{
    		ZDBGoogleInteg.fetchOrShowGoogleAppEnableAPIDIV(null, "contacts"); // No I18N
    	}
    	else
    	{
    		ZDBGoogleInteg.showGoogleAppContactFetchFailureDlg();
    	}
    }
    
    this.fetchOrShowGoogleAppEnableAPIDIV = function(el, from, event)
    {
    	if(!ZDBGoogleInteg.gAppsEnableAPIDiv)
		{
    		ZDBGoogleInteg.gAppsEnableAPIDiv = document.createElement("div");
			AjaxAPI.sendRequest({URL:"/ZRGAAppsEnableAPI.cc", 
							ONSUCCESSFUNC:ZDBGoogleInteg.handleGoogleAppEnableAPISuccess,
							ONFAILUREFUNC:ZDBGoogleInteg.showGoogleAppContactFetchFailureDlg,
							OPSTATUSID:"ZDBAddUsersProcess", FROM:from});  //No I18N
		}
		else
		{
			ZDBGoogleInteg.showGoogleAppEnableAPIDlg(from);
		}
    }
    
    this.handleGoogleAppEnableAPISuccess = function(response, requestOptions)
    {
    	
    	ZDBGoogleInteg.gAppsEnableAPIDiv.innerHTML = response.responseText;
    	document.body.appendChild(ZDBGoogleInteg.gAppsEnableAPIDiv);
    	ZDBGoogleInteg.gAppsEnableAPITitle = ZDBI18NMap.g("zrpt.gapps.api.enable.js.note_tit");  // No I18N
    	ZDBGoogleInteg.showGoogleAppEnableAPIDlg(requestOptions.FROM);
    }
    
    this.showGoogleAppEnableAPIDlg = function(from)
    {
    	ZDBDialogUtil.showDialog(ZDBGoogleInteg.gAppsEnableAPIDiv, {MODAL:true, TITLE:ZDBGoogleInteg.gAppsEnableAPITitle, ADDFRAME:true, LEFT:450, TOP:200});  // No I18N
    	$("ZRGAppsEnableNote").innerHTML =  ZDBI18NMap.g("zrpt.gapps.api.enable.js.note_for_gs");
    	if(from == "contacts")
		{
    		$("ZRGAppsEnableNote").innerHTML = ZDBI18NMap.f("zrpt.gapps.api.enable.js.note_for_contact",ZDBGlobal.PRODUCT_NAME);
		}
    	$("ZRGAppsEnableAPIHelp").style.display = "";
    }
    
    this.hideGoogleAppEnableAPIDlg = function()
    {
    	jQuery("#ZRGAppsEnableAPIHelp").hide();  // No I18N
    }
    
    this.showGoogleAppContactFetchFailureDlg = function()
    {
    	ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.share.shareview.js.google_appusers_fetch_failed"));
    }



    this.authGUser = function(errCode,errMsg,gType)
    {
        if(errCode == "GOOGLE_AUTH_REQUIRED")
        {
            var authURL = ZDBGlobal.GAPP_EMBED_GADGET_URL+"/gdocs?auth=true&zservice="+ZDBGlobal.GAPP_ZSERVICE+"&border=no&serURL="+ZDBGlobal.REPORTS_SERVER_URL+ZDBGlobal.REPORTS_CONTEXT_NAME+"/integ/GResponseRedirect.jsp?gauth_type="+gType; // No I18N
            ZDBGoogleInteg.authGoogle(authURL);
        }
        else if(errCode == "GSHEETS_NOT_FOUND")
        {
            ZDBAlertAPI.showMsg(errMsg,"ZDBYESNO",{ONCLICK:ZDBGoogleInteg.confirmRefetchGSheet,GAUTH_TYPE:gType});    //No I18N
        }
        else if(errCode =="GSHEETS_NOAUTH_HEADER_INFO")
        {
            ZDBAlertAPI.showMsg(errMsg);
        }
    }

    this.confirmRefetchGSheet = function(clickType,requestOptions)
    {
        if(clickType != "YES")
        {
            return;
		}
        var gType = requestOptions["GAUTH_TYPE"];
        var url = "/ZDBSecurityAction.ma?ZDBACTION=ZDBREVOKEGTOKEN&GTYPE=sheets"; //No I18N
            AjaxAPI.sendRequest({URL:url,  //No I18N
            ONSUCCESSFUNC:ZDBGoogleInteg.handleRevokeGToken,
            ONFAILUREFUNC:ZDBGoogleInteg.handleRevokeGTokenFailure,
            GOOGLETYPE:gType});  //No I18N
    }

    this.showGoogleLogin = function()
    {
      var authURL = ZDBGlobal.GAPP_EMBED_GADGET_URL + "/zgadwords?zservice=zreports&serURL="+ZDBGlobal.REPORTS_SERVER_URL+ZDBGlobal.REPORTS_CONTEXT_NAME+"/integ/GResponseRedirect.jsp?gauth_type=gadwords"; // No I18N
      ZDBGoogleInteg.authGoogleAdwords(authURL);
    }

  this.closeDialog = function()
  {
    //    var dbId = el.innerHTML;
    if(ZDBCreateDB.isInHomePage())
    {
        var dbId = $("ZDBIMPSCHDBID").innerHTML;
        ZDBCreateDB.changeWindowURL(dbId);
    }
    return true;
  }

  this.showDateString = function(el)
  {
    if((el.value == "" ) && (el.getAttribute("tipShown") == "false"))
    {
      var dateType = el.getAttribute("elname");
      el.value= (dateType == "fromValue")?ZDBI18NMap.g("zrpt.home.ga.js.from") : ZDBI18NMap.g("zrpt.home.ga.js.to"); //NO I18N

      var inputVal = (dateType == "fromValue")?"From":"To"; //NO I18N
      el.setAttribute("inputVal",inputVal);
    }
  }

  this.enableCustomDate = function(val)
  {
      if(val == '100')
      {
          var months = new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
          $("gadcustomeperiod").style.display = 'inline';
          var curDate = new Date();
          var curDay = curDate.getDate();
          curDay = (curDay == 31) ? (curDay - 1) : curDay ;
          var mon = curDate.getMonth() == 0 ? "Dec" : months[(curDate.getMonth() - 1)];  // No I18N
          var year = curDate.getMonth() == 0 ? curDate.getFullYear() - 1 : curDate.getFullYear();
          $("ZDBGAFromDate").value = curDay + " " + mon + " " + year;
      }
      else
      {
          $("gadcustomeperiod").style.display = 'none';
      }

  }

  this.initCalender = function(inputEl)
  {
    hideCustomMessage();
    var curDate = new Date();
    var fromDate = 1000;
    var toDate = curDate.getFullYear();
    var format = "%d %b %Y ";//NO I18N

    Calendar.setup(
    {
      inputField     :    inputEl,      // id of the input field
      ifFormat       :    format,       // format of the input field //NO I18N
      showsTime      :    false,            // will display a time selector
      button         :    inputEl,   // trigger for the calendar (button ID)
      singleClick    :    true,           // double-click mode
      weekNumbers    :   	false,
      range          :    [fromDate,toDate],
      step           :    1,                // show all years in drop-down boxes (instead of every other year as default)
      onClose        :    function(){
          this.hide();this.destroy();
      }
    }
    ); //NO I18N
    inputEl.initialized = true;
  }

  
  this.closeDateDialog = function(evt)
  {
	  if(evt.keyCode == 27)
	  {
		  ZDBGoogleInteg.showDateString(evt);
	  }
  }

}

ZDBLazyLoadFuncMap.lazyLoadFuncMap[	"ZDBGoogleInteg.fetchSetupDetails"] = ZDBGoogleInteg.fetchSetupDetails;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBGoogleInteg.getGoogleDocs"] = ZDBGoogleInteg.getGoogleDocs;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBGoogleInteg.openMyGoogleAppUsers"] = ZDBGoogleInteg.openMyGoogleAppUsers;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBGoogleInteg.showAndEditModuleList"] = ZDBGoogleInteg.showAndEditModuleList;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBGoogleInteg.showGoogleContacts"] = ZDBGoogleInteg.showGoogleContacts;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBGoogleInteg.showGoogleLogin"] = ZDBGoogleInteg.showGoogleLogin;	
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBGoogleInteg.fetchOrShowGoogleAppEnableAPIDIV"] = ZDBGoogleInteg.fetchOrShowGoogleAppEnableAPIDIV;;