//$Id$

var ZDBLegendTools = new function()
{
  this.showLegendMenu = function(el, event, view)    
  {
    ZDBLegendTools.parLegendEl = el;
    ZDBLegendTools.parLegendEl.el = ZDBUtil.getSourceElement(event);
    ZDBLegendTools.parLegendEl.view = view;
    var legendModel = view.chartObj.getLegendModel();
    var menu = ZDBContentCache.appendAndGet("Legend_Menu","GridMenu",document.body);    //No I18N
    menu.view = view;
    ZAComboLegendEdit.showComboInLegendPopup(view, el, true);
    if(legendModel instanceof ZCColorLegendModel || legendModel instanceof ZCPieLegendModel)
    {
      ZRSMenu.showMenu(event,null,menu,1);
      if(el.origValue == null)
      {
        menu.style.display = "none";
      }
      else
      {
        ZDBMenuUtil.clearAndSetPopupPosition(menu,event);
      }
    }
    else
    {
      ZRSMenu.showMenu(event,null,menu,1);
      ZDBMenuUtil.clearAndSetPopupPosition(menu, event);
    }
    ZDBUtil.stopEventBubble(event);
  }
    
  this.setClass = function(el,classname)
  {
    el.className = classname;
  }
  
  this.useNewLegendClr = function()
  {
      var view = ZDBColorPalette.colorPalette.currViewObj;
      var legendParams = ZDBAnalysisConfig.LEGENDCOLORPARAMS;
      var legDetInfo = view.legDetInfo;
      var isMultiY = view.chartSelectedEl.isMultiY;
      var curLegend = ZDBColorPalette.clickedEl;
      var legendRowDiv = null;
      var clrVal = curLegend.getAttribute("colorchange");
      if(clrVal == null)
      {
        return;
      }
      var parEl = ZDBLegendTools.parLegendEl;
      var keyValue = parEl.origValue;
      keyValue = ZDBUtil.replaceStr(keyValue,"--C--",",");  //No I18N
      if(legDetInfo && legDetInfo.length > 0)
      {
        for(var i=0; i < legDetInfo.length; i++)
        {
      	if(!isMultiY && legDetInfo[i][legendParams[1]] == keyValue)
          {
            legendRowDiv = legDetInfo[i];
            break;
          }
          else if(isMultiY && legDetInfo[i][legendParams[0]] == parEl.instId)
          {
            legendRowDiv = legDetInfo[i];
            break;
          }
        }
      }
      if(!legendRowDiv)
      {
      	legendRowDiv = {};
      	legDetInfo[legDetInfo.length] = legendRowDiv;
      }
      legendRowDiv[legendParams[0]] = parEl.instId;
      legendRowDiv[legendParams[1]] = keyValue;
      legendRowDiv[legendParams[2]] = clrVal;
      legendRowDiv[legendParams[3]] = true;
      ZDBLegendTools.parLegendEl = null;
      var chartObj = view.chartObj;
      var data = chartObj.getData();
      var legClrArr = data.legend.colors;
      var userClrArr = data.legend.userColors;
      var changedClr = "#"+ clrVal;
      changedClr = ZCFormatUtil.setTransForLegendClrs(changedClr.split(),legClrArr);
      legClrArr[parEl.index] = changedClr[0];
      userClrArr[parEl.index] = changedClr[0];
      view.setModified();
      chartObj.setLegendModel();
      chartObj.redrawNewChartType();
  }
  
  this.showLegClrPalette = function(clickedEl)
  {
	  var view = ZDBLegendTools.parLegendEl.view;
	  curLegEl = ZDBLegendTools.parLegendEl;
	  var clr = curLegEl.color;
	  var title = curLegEl.value;
	  curLegEl.colorDIV = ZDBLegendTools.parLegendEl.el.parentNode;
	  var callBack = ZDBLegendTools.useNewLegendClr;
	  ZDBColorPalette.showClrPalette(curLegEl.colorDIV, clr, title, view, callBack, null,false,true);
  }

}

