//$Id$
var ZRGettingStarted = new function()
{
    var userPhoneNumber, productName;
    var isGAppUser = false;
    this.gettingStartedDlg = function(response, request)
    {
        var resp = response.gsdetails;
	(resp.isGAppUser == true) ? ZRGettingStarted.gsgappdlg() : ZRGettingStarted.gsreportsdlg(resp);
        
        if(!request.el){
            AjaxAPI.sendRequest({URL:"/ZDBUserAction.ma?ZDBACTION=DELGETSTARTDLGPROP"});
        }
    }
    
    this.gsgappdlg = function()
    {
        if(!ZDBLazyLoadUtil.loadSnippet("ZDBGettingStarted","/ZDBGettingStartedDialog.cc?",this,"APPENDTODOC", null, null, null, "noLoader")) {
            return;
        }
        if(!ZDBLazyLoadUtil.loadCssOnly("gettingstarted_NEW.css", "APPENDTODOC",ZRGettingStarted.gsgappdlg)) {
            return;
        }
        
        isGAppUser = true;
        ZDBFullPageDialog.showDialog($("ZDBGettingStartedDlg"),{DONTREMOVE:true,ONCLOSE:ZRGettingStarted.removeEventAndCloseGs},{"margin-left":"-440px","width":"850px"}); //No I18N
        ZDBUtil.attachEvent(document,"mouseup", ZRGettingStarted.gsFocusLoseAction,false);
    }
    
    this.gsreportsdlg = function(resp)
    {
        if(!ZDBLazyLoadUtil.loadJsAlone("ZRSDatasheet_TEMPLATE","APPENDTODOC", ZRGettingStarted.gsreportsdlg, [resp])) {
            return;
        }

        if(!ZDBLazyLoadUtil.loadCssOnly("ZRGettingStarted_new.css", "APPENDTODOC", ZRGettingStarted.gsreportsdlg, [resp])) {
            return;
        }
        
        userPhoneNumber = resp.userPhoneNumber;
        productName = resp.productName;
        var dynamicgs = {
            welcomeText: (resp.userFirstName == "") ? ZDBI18NMap.f("zrpt.gettingstarted.js.welcometozr", productName) : ZDBI18NMap.f("zrpt.gettingstarted.js.welcome", resp.userFirstName),
            productName: ZDBI18NMap.f("zrpt.login.js.onlineservice", productName),
            onpremise: {
                condition: ZDBGlobal.onPremise && !resp.isMailConfigured,
                data: {
                    mailconfig: ZDBI18NMap.g("zrop.user.mgmt.js.mail.config.now"),
                    mailconfigdesc: ZDBI18NMap.g("zrop.user.mgmt.js.mail.config.now.desc"),
                    config: ZDBI18NMap.g("zrop.user.mgmt.js.config.now")
                }
            },
        }
        
        var mergedjson = ZDBUtil.mergeObjects(dynamicgs, ZRSFeedbackDialogs_Model.gettingStarted);
        ZRSHTMLTemplateStrings["__gettingstarted__zrsfeedbackdialogs__model"] = mergedjson;
        
        var gsdlg = $("ZDBGettingStarted") ? $("ZDBGettingStarted") : ZRSStringTemplateCreator.createTemplateForData("gettingstarted", "zrsfeedbackdialogs"); //No I18N
        document.body.appendChild(gsdlg);
        if(!document.getElementsByClassName("gsiframeholder").length) //for datasheetview
        {
            var gsvideo = ZRSStringTemplateCreator.createTemplateForData("gsvideo", "zrsfeedbackdialogs"); //No I18N
            document.body.appendChild(gsvideo);
        }
        
        var top = (document.body.offsetHeight > 720) ? (document.body.offsetHeight-720)/2 + "px" : "0"; //No I18N
        ZDBFullPageDialog.showDialog(gsdlg,{DONTREMOVE:false,ONCLOSE:ZRGettingStarted.removeEventAndCloseGs,TOP:top,MAXHEIGHT:"720px"},{"margin-left":"-400px","width":"760px"}); //No I18N
        ev.addEnterHandle(ZRGettingStarted.removeEventAndCloseGs);
    }
    
    this.showReqDemoDlg = function(el)
    {
        var reqDemoDlg = $("ZDBDemoRequestFrm") ? $("ZDBDemoRequestFrm") : ZRSStringTemplateCreator.createTemplateForData("reqdemo", "zrsfeedbackdialogs"); //No I18N
        ZDBDialogUtil.showDialog(reqDemoDlg,{TITLE:ZDBI18NMap.g('zrpt.home.feedback.js.requestademo'), ADDFRAME:true, MODAL:true,
                                            DONTREMOVE:true, CALLOUT:true, SRCEL:el, MANUALPOS:"RIGHT75"}); //No I18N
                                        
        var dlg = ZDBUtil.getParentWithAttributeValue(reqDemoDlg, "elname", "ZRDlgShadow"); //No I18N
        dlg.className = "";
        var titlebar = dlg.getElementsByClassName("dlgTitleBar")[0];
        titlebar.className = "reqDemoTitle"; //No I18N
        titlebar.children[4].style.display = "none"; //Close icon
        
        $("ZDBDemoContactNumber").value = (userPhoneNumber == "") ? "" : ("+" + userPhoneNumber);
        $("ZDBDemoContactTime").value = ZRGettingStarted.getDateAndTime();
        
        var freezelayer = document.getElementsByClassName("freezeLayer")[0];
        freezelayer.className = "blackFreezeLayer";
        ev.addEnterHandle(ZRGettingStarted.handleEnterPressForSubmit);
        ev.addEscHandle(ZRGettingStarted.clearFormAndClose);
    }
    
    this.getDateAndTime = function()
    {
        var d = new Date();
        var tomorrow = new Date();
        tomorrow.setDate(d.getDate()+1);
        var time = "10:00 AM - 01:00 PM"; //No I18N
        if(d.getHours() > 12)
        {
            time = "02:00 PM - 05:00 PM"; //No I18N
        }
        var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]; //No I18N
        return (months[tomorrow.getMonth()] + " " + (tomorrow.getDate()) + ", " + time + " " + ZDBGlobal.TimeZone);
    }

    this.showDemoTextarea = function()
    {
        if($("demoTextareaHolder").style.display == "block")
        {
            ZRGettingStarted.hideDemoTextarea();
        }
        else
        {
            $("requestDemoContent").style.height = "330px";
            $("demoArea").style.height = "120px";
            $("demoTextareaHolder").style.display = "block";
            ZDBUtil.getElWithTagNAttrWithVal($("demoTextareaHolder"), "id", "demoRequestFocusEl", "textarea").focus(); //No I18N
        }
    }
    
    this.hideDemoTextarea = function()
    {
        $("requestDemoContent").style.height = "230px";
        $("demoArea").style.height = "20px";
        $("demoTextareaHolder").style.display = "none";
    }
    
    this.submitReqDemoForm = function(formEl)
    {
        var currentFrm = formEl.getAttribute("name");
        if(currentFrm == "demoRequestFrm")
        {
            formEl.SUBJECT.value = "DEMO REQUEST: " + formEl.SUBJECT.value; //No I18N
        }
        return AjaxAPI.submit(formEl);
    }
    
    this.handleEnterPressForSubmit = function()
    {
        if(validateForm($("ZDBDemoRequestFrm"))) 
        { 
            jQuery("#ZDBDemoRequestFrm").submit(); //No I18N
        }
        else
        {
            ev.addEnterHandle(ZRGettingStarted.handleEnterPressForSubmit);
        }
    }
    
    this.clearFormAndClose = function()
    {
        $("ZDBDemoContactNumber").value = "";
        $("ZDBDemoContactTime").value = "";
        $("demoRequestFocusEl").value = "";
        ZRGettingStarted.hideDemoTextarea();
        ZDBDialogUtil.closeDialog();
        ev.removeEnterHandle();
        ev.removeEscHandle();
    }
    
    this.constructMoreMenu = function()
    {
        var menuData = {};
        menuData.divID = 'GSMoreLinksMenu'; //No I18N
        menuData.divStyle = 'display:none'; //No I18N
        menuData.pointerReq = {
            condition : true,
            data : {
                beforePointerClass:'ZRSPointerLeftBefore', //No I18N
                beforePointerStyle:'top:108px', //No I18N
                afterPointerClass:'ZRSPointerLeftAfter', //No I18N
                afterPointerStyle:'top:108px' //No I18N
            }
        };
            
        menuData.menuData = [];
        
        if(ZDBGlobal.isZDomain || ZDBGlobal.isFujiDomain){
            menuData.menuData.push({
                link: ZDBI18NMap.g('zrpt.links.js.videodemo'),
                target: '_blank', //No I18N
                menuText: ZDBI18NMap.g('zrpt.home.productlinks.js.videodemos')
            });
            menuData.menuData.push({
                link: ZDBI18NMap.g('zrpt.links.js.helpindex'),
                target: '_blank', //No I18N
                menuText: ZDBI18NMap.g('zrpt.gettingstarted.js.help.center')
            });
            menuData.menuData.push({
                link: ZDBI18NMap.g('zrpt.links.js.webinar'),
                target: '_blank', //No I18N
                menuText: ZDBI18NMap.g('zrpt.common.js.webinars')
            });
        }
        
        if(ZDBGlobal.IS_SAS_BUILD)
        {
            menuData.menuData.push({
                link:ZDBGlobal.REPORTS_CONTEXT_NAME + '/ZDBSampleDatabases.cc', //No I18N
                target: '_blank', //No I18N
                menuText: ZDBI18NMap.g('zrpt.common.trysampledbs.js.new')
            });
        }
        else
        {
            if(!ZDBGlobal.isSampleDbPopulated)
            {
                menuData.menuData.push({
                    link: 'https://analyticsplusdemo.manageengine.com/ZROPSampleDatabases.cc', //No I18N
                    target: '_blank', //No I18N
                    menuText: ZDBI18NMap.g('zrpt.common.trysampledbs.js.new')
                });
            }
            else
            {
                menuData.menuData.push({
                    onclick: 'ZDBFullPageDialog.closeDialog();openLink("/ZROPSampleDatabases.cc", "false", "true");', //No I18N
                    target: '_blank', //No I18N
                    menuText: ZDBI18NMap.g('zrpt.common.trysampledbs.js.new')
                });
            }
        }
        
        menuData.menuData.push({
            link : 'javascript:void(null)', //No I18N
            onclick: 'ZDBGlobal.showFeedBack(this,event)', //No I18N
            elname: 'contactsupport', //No I18N
            menuText: ZDBI18NMap.g('zrpt.common.home.js.contactsupport')
        });
        
        var menu = ZRSStringTemplateCreator.createTemplateForDynamicData("headerhelpmenu","zrsmenu",false,menuData); //No I18N
        $("ZDBGettingStartedDlg").appendChild(menu);
        $("GSMoreLinksMenu").style.top = $("gsmore").offsetTop - 100 + "px"; //No I18N
        $("GSMoreLinksMenu").style.left = $("gsmore").offsetLeft + 50 + "px"; //No I18N
        menu.style.minWidth = "120px"; //No I18N
        
        ZDBUtil.attachEvent(document, "click", ZRGettingStarted.closeMoreMenu, false);
    }
    
    this.showMoreMenu = function()
    {
        if($("GSMoreLinksMenu") == null || $("GSMoreLinksMenu") == 'undefined')
        {
            ZRGettingStarted.constructMoreMenu();
        }
        $("GSMoreLinksMenu").style.display = "block";
    }
    
    this.closeMoreMenu = function(event){
        var el = (event.target.id == "gsmore");
        if(!el){
            $("GSMoreLinksMenu").style.display = "none";
        }
    }
    
    this.gsFocusLoseAction = function(event) {
        var el = ZDBUtil.getParentWithAttr(event.target,"isGettingStarted") || ZDBClientUI.gsVideoOpened;
        if(!el){
            ZRGettingStarted.removeEventAndCloseGs();
        }
    }

    this.removeEventAndCloseGs = function() {
        ev.removeEnterHandle();
        ev.removeEscHandle();
        ZDBFullPageDialog.currentFullPageDialog.params["ONCLOSE"] = null;
        ZDBFullPageDialog.closeDialog();
        ZDBUtil.detachEvent(document,"mouseup",ZRGettingStarted.gsFocusLoseAction,false);
        ZDBUtil.detachEvent(document, "click", ZRGettingStarted.closeMoreMenu, false);
        if(!isGAppUser && ZDBGlobal.ISNEWLAYOUT && ZDBGlobal.LANDINGPAGE == "ZDBHome")
        {
            ZRSHomeHandler.showImportOpts();
            
            var tourVar = {
                tour_content: ZDBI18NMap.f("zrpt.login.js.onlineservice", productName)
            }

            var tourjson = ZDBUtil.mergeObjects(tourVar, ZRSFeedbackDialogs_Model.productTour);
            ZRSHTMLTemplateStrings["__productTour__zrsfeedbackdialogs__model"] = tourjson;
            if(!$("ZRTour-start")) {
                var tourcont = ZRSStringTemplateCreator.createTemplateForData("productTour", "zrsfeedbackdialogs"); //No I18N
                document.body.appendChild(tourcont);
            }
            
            ZRTour.noActionPerformed = true;
            setTimeout(function() { document.addEventListener("click", ZRTour.startTour, false); }, 100);
            setTimeout(function(){
                if(ZRTour.noActionPerformed) {
                    ZRTour.showHideTourSlideout();
                }
            }, 3000);
        }
    }
    
}
