//$Id$

var ZDBPaymentsAdmin = new function()
{ 

	this.getRadioSelectedValue = function(form,name)
	{
		var radio = form[name];
		var len = radio.length;
		for(var i=0; i<len; i++)
		{
			var opt = radio[i];
			if(opt.checked == true)
			{
			return opt.value;
			}
		}
	}

        this.changeQueryDB = function(el)
        {
              var zuId = el.getAttribute("zuId");
              var queryDB = document.getElementById("queryDB").value;
              var dvip = document.getElementById("DEFAULTNODEID").value;
              var fvip = document.getElementById("FALLBACKNODEID").value;
              var flag = document.getElementById("StatusFlag").value;
	      var errorMsg = "";//No I18N
	      if(dvip == null || dvip == "0")
	      {
		  errorMsg += "Please select DEFAULT CONTROLLER\n";//No I18N
	      }
	      if(fvip == null || fvip == "0")
	      {
		  errorMsg += "Please select FALLBACK CONTROLLER\n";//No I18N
              }
	      if(queryDB == 0 || errorMsg == "")
              {
              alert("ZDBACTION=CHANGEPLAN"+"&ZUID="+zuId+" QueryDB="+queryDB); //No I18N
              AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=CHANGEQUERYDB"+"&QUERYDB="+queryDB+"&ZUID="+zuId+"&DEFAULTNODEID="+dvip+"&FALLBACKNODEID="+fvip+"&FLAG="+flag, METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadUserPlanDetails, OPSTATUSID:"ZDBMainLoader"}); //No I18N
	      }
	      else
	      {
		alert(errorMsg);
	      }
        }

	this.setRadioButtonStatus = function(form, name, val)
	{
		var radio = form[name];
		var len = radio.length;
		for(var i=0; i<len; i++)
		{
			var opt = radio[i];
			if(opt.value == val)
			{
			  opt.checked = true;
			}
      else
      {
			  opt.checked = false;
      }
		}
	}
	
  this.$ = function(elName)
  {
    var el = this[elName];
    if(el == null)
    {
      this[elName] = el = document.getElementById(elName);
    }
    return el;
  }
 
  this.fetchUserDetails = function()
  {
    var formEl = this.$("ZDBPaymentAdminConsole");
    var userOptVar = parseInt(ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "useropt")); //No I18N
    var userInfo = this.$("userid").value;
    if (userInfo == "")
    {
      alert("Enter any of the requested user specific information"); //No I18N
      return;
    }
    AjaxAPI.sendRequest({URL:"/ZDBPricing.cc?ZDBACTION=FETCHUSERINFO"+"&USEROPTION="+userOptVar+"&USERINFO="+userInfo, METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.handleUserInfoLoad, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.handleUserInfoLoad = function()
  {
    this.$("getUserIdDiv").style.display="none";
    this.$("ZDBPaymentAdminContainer").style.display="";
  }

  this.clearFields = function()
  {
    this.$("USERID").value= "";
  }

  this.refreshUserResources = function(el)
  {
    var zuId = el.getAttribute("zuId");
    AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=REFRESHRESOURCECOUNT"+"&ZUID="+zuId, METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadUserResources, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.reloadUserResources  = function(response, requestOptions)
  {
    alert("response :: "+response.responseText); //No I18N
    var respArray = response.responseText.split(",");
    this.$("eRow").innerHTML = respArray[0];
    this.$("eUser").innerHTML = respArray[1];
    this.$("eDb").innerHTML = respArray[2];
    this.$("eQt").innerHTML = respArray[3];
    this.$("eSch").innerHTML = respArray[4];
    this.$("eMailSch").innerHTML = respArray[5];
    this.$("eReprt").innerHTML = respArray[6];
  }

  this.planChange = function(el)
  {
    var reason = document.getElementById("PlanReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var zuId = el.getAttribute("zuId");
    var formEl = this.$("UserPlanConsole");
    var planId = parseInt(ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "PlanId")); //No I18N
    var isTrial = false;
    var isTrialEl = this.$("isTrial");
    if (isTrialEl != null)
    {
      isTrial = isTrialEl.checked;
    }
    var userProfileId =el.getAttribute("profileId");
alert("ZDBACTION=CHANGEPLAN"+"&ZUID="+zuId+"&PLANID="+planId+"&ISTRIAL="+isTrial); //No I18N
		AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=CHANGEPLAN"+"&ZUID="+zuId+"&PLANID="+planId+"&ISTRIAL="+isTrial+"&REASON="+reason, METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadUserPlanDetails, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.downgradeToFree = function(el)
  {
    var reason = document.getElementById("PlanReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var zuId = el.getAttribute("zuId");
    var isTrial = false;
    var isTrialEl = this.$("isTrial");
    if (isTrialEl != null)
    {
      isTrial = isTrialEl.checked;
    }
    
    AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=DOWNGRADETOFREE"+"&ZUID="+zuId+"&ISTRIAL="+isTrial+"&REASON="+reason, METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadUserPlanDetails, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.reloadUserPlanDetails = function(response, requestOptions)
  {
    alert("response :: "+response.responseText); //No I18N
    var respArray1 = response.responseText.split("::");
//    planid, trialStatus, profileId, billingDate, Subscription
    var planArray = respArray1[0]; 
    var respArray = planArray.split(",");
    var val = respArray[0];
    var formEl = this.$("UserPlanConsole");
    ZDBPaymentsAdmin.setRadioButtonStatus(formEl, "PlanId", val);  //No I18N
    var respArray2 = respArray1[1];
    if (respArray2 != null && respArray2.length > 0)
    { 
      var features = respArray2.split(",");
      ZDBPaymentsAdmin.reloadFeatures(features);
    }
  }

  this.updateProfileId = function(el)
  {
    var reason = document.getElementById("PlanReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var zuId = el.getAttribute("zuId");
    var profileId = this.$("profileId").value;
    AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=UPDATEPROFILEID"+"&ZUID="+zuId+"&PROFILEID="+profileId+"&REASON="+reason, METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadUserProfileId, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.reloadUserProfileId = function(response, requestOptions)
  {
    this.$("profileId").value = response.responseText;
    alert("Updated :: "+response.responseText); //No I18N
  }

  this.updateBillingDate = function(el)
  {
    var reason = document.getElementById("PlanReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var zuId = el.getAttribute("zuId");
    var billDate = this.$("nextBillingDate").value;
    AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=UPDATENEXTBILLINGDATE"+"&ZUID="+zuId+"&BILLDATE="+billDate+"&REASON="+reason, METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadUserBillingDate, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.reloadUserBillingDate = function(response, requestOptions)
  {
    this.$("nextBillingDate").value = response.responseText;
    alert("Updated :: "+response.responseText); //No I18N
  }

  this.updatePayPeriod = function(el)
  {
    var reason = document.getElementById("PlanReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var zuId = el.getAttribute("zuId");
    var termOptions = this.$("payPeriod");
    var subscription = (termOptions[termOptions.selectedIndex]).value;
    AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=UPDATEPAYMENTMODE"+"&ZUID="+zuId+"&TERM="+subscription+"&REASON="+reason, METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadUserPayPeriod, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.reloadUserPayPeriod = function(response, requestOptions)
  {
    this.$("payPeriod").value = response.responseText;
    alert("Updated :: "+response.responseText); //No I18N
  }
 
  this.updateUserAddOns = function(el)
  {
    var reason = document.getElementById("AddOnReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var userQty = this.$("userAddOns").value;
    var zuId = el.getAttribute("zuId");
    AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=MODIFYUSERADDONS"+"&ZUID="+zuId+"&USERADDONQTY="+userQty+"&REASON="+reason, METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadUserAddOns, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.reloadUserAddOns = function(response, requestOptions)
  {
    var respStr = response.responseText;
    var addOnResp = respStr.split("::");
    this.$("userAddOns").value = addOnResp[0];
    var planResp= addOnResp[1];
    if (planResp != null && planResp.length > 0)
    {
      var features = planResp.split(",");
      ZDBPaymentsAdmin.reloadFeatures(features);
    }
  }
 
  this.updateRowAddOns = function(el)
  {
    var reason = document.getElementById("AddOnReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var zuId = el.getAttribute("zuId");
    var addOnRowsCB = this.$("ZDBAdonRows");
    var rowName = (addOnRowsCB[addOnRowsCB.selectedIndex]).value;
    var rowQty = this.$("RowAddOnsQty").value;
    alert (zuId +", " + rowName + ", " + rowQty);
    AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=MODIFYROWADDONS"+"&ZUID="+zuId+"&ROWADDONNAME="+rowName+"&ROWADDONQTY="+rowQty+"&REASON="+reason,CURRENTROWADDON:rowName,ROWADDONQTY:rowQty,METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadRowAddOns, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.reloadRowAddOns = function(response, requestOptions)
  {
    var respStr = response.responseText;
    if (respStr.indexOf("Error") != -1)
    {
      this.$("ZDBAdonRows").value = requestOptions["CURRENTROWADDON"];
      this.$("RowAddOnsQty").value = requestOptions["ROWADDONQTY"];
    }
    else
    {
      var addOnResp = respStr.split("::");
      var addOnDetails = addOnResp[0];
      var planResp = addOnResp[1];
      var rowAddOns = addOnDetails.split("_:_"); 
      this.$("ZDBAdonRows").value = rowAddOns[0];
      this.$("RowAddOnsQty").value = rowAddOns[1];
      if (planResp != null && planResp.length > 0)
      {
        var features = planResp.split(",");
        ZDBPaymentsAdmin.reloadFeatures(features);
      }
    }
  }

  this.updateEmailSchedulerAddOns = function(el)
  {
    var reason = document.getElementById("AddOnReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var emailQty = this.$("EmailSchdQty").value;
    var zuId = el.getAttribute("zuId");
    
    var zuId = el.getAttribute("zuId");
    var addOnSchCB = this.$("ZDBAdonSchMail");
    var schName = (addOnSchCB[addOnSchCB.selectedIndex]).value;
    var rowQty = this.$("EmailSchdQty").value;
    alert (zuId +", " + schName + ", " + rowQty);
    
    AjaxAPI.sendRequest({
    	URL:"/ZDBAdminPayments.ma?ZDBACTION=MODIFYEMAILSCHDADDONS"+"&ZUID="+zuId+		//No I18N
    			"&EMAILADDONQTY="+emailQty+"&REASON="+reason+"&EMAILADDON="+schName, 	//No I18N
    	METHOD:"POST", 			//No I18N
    	ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadEmailSchdAddOns, 
    	OPSTATUSID:"ZDBMainLoader"			//No I18N
    }); //No I18N
  };
  
  this.updateAPIUnitsAddOns = function(el)
  {
    var reason = document.getElementById("AddOnReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var emailQty = this.$("APIUnitsQty").value;
    var zuId = el.getAttribute("zuId");
    
    var zuId = el.getAttribute("zuId");
    var addOnSchCB = this.$("ZDBAdonAPIUnits");
    var schName = (addOnSchCB[addOnSchCB.selectedIndex]).value;
    var rowQty = this.$("APIUnitsQty").value;
    alert (zuId +", " + schName + ", " + rowQty);
    
    AjaxAPI.sendRequest({
    	URL:"/ZDBAdminPayments.ma?ZDBACTION=MODIFYEMAILSCHDADDONS"+"&ZUID="+zuId+		//No I18N
    			"&EMAILADDONQTY="+emailQty+"&REASON="+reason+"&EMAILADDON="+schName, 	//No I18N
    	METHOD:"POST", 			//No I18N
    	ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadEmailSchdAddOns, 
    	OPSTATUSID:"ZDBMainLoader"			//No I18N
    }); //No I18N
  }

  this.reloadEmailSchdAddOns = function(response, requestOptions)
  {
    var respStr = response.responseText;
    if(respStr.indexOf("Error") != -1)
	{
    	alert(respStr);
	}
    else
    {
    	alert("Successfully updated");	//No I18N
    }
  };
 
  this.updateConnectors = function(el)
  {
    var reason = document.getElementById("AddOnReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var zuId = el.getAttribute("zuId");
    var connectors = this.$("ZDBAdonCnctr");
    var connectorsVal = new Array();
    ZDBPaymentsAdmin.getSelectedOptions(connectors, connectorsVal);
    var connectorAddOns = "None"; //No I18N
    for ( var i = 0; i < connectorsVal.length; i++)
    {
       connectorAddOns = (connectorAddOns=="None")? connectorsVal[i] : connectorAddOns + ',' + connectorsVal[i];
    }
    alert (connectorAddOns);
    AjaxAPI.sendRequest({URL:"/ZDBAdminPayments.ma?ZDBACTION=MODIFYCONNECTORS"+"&ZUID="+zuId+"&CONNECTOR="+encodeURIComponent(connectorAddOns)+"&REASON="+reason,METHOD:"POST", ONSUCCESSFUNC:ZDBPaymentsAdmin.reloadConnectors, OPSTATUSID:"ZDBMainLoader"}); //No I18N
  }

  this.getSelectedOptions = function(ob, connectorsVal)
  {
     var selOptions = new Array();
     while (ob.selectedIndex != -1)
     {
       connectorsVal.push(ob.options[ob.selectedIndex].value);
       selOptions.push(ob.selectedIndex);
       ob.options[ob.selectedIndex].selected = false; 
     }

     for (var i = 0; i < selOptions.length; i++)
     {
       ob.options[selOptions[i]].selected = true;
     }
  }

  this.reloadConnectors = function(response, requestOptions)
  {
    var respStr = response.responseText;
      var addOnResp = respStr.split("::");
      var addOnDetails = addOnResp[0];
      var planResp = addOnResp[1];
      var connectors = addOnDetails.split(",");
      alert ('Updated connectors' + connectors); //No I18N
      if (planResp != null && planResp.length > 0)
      {
        var features = planResp.split(",");
        ZDBPaymentsAdmin.reloadFeatures(features);
      }
  }

  this.updateBetaBonus = function(el)
  {
    var zuId = el.getAttribute("zuId");
    var betaRow = this.$("betaRows").value;
    var betaUser = this.$("betaUsers").value;
    var bonusRow = this.$("bonusRow").value;
    var bonusUsr = this.$("bonusUsr").value;
    var bonusDB = this.$("bonusDB").value;
    var bonusQt = this.$("bonusQt").value;
    alert (bonusRow + ", " + bonusUsr + ", " + bonusDB + ", " + bonusQt + " :: Beta bonus update has been deprecated, instead use Plan/Feature update");  //No I18N
  }
 
  this.reloadBetaDetails = function(response, requestOptions)
  {
    var betaArray = response.responseText.split("::");
    var respArray1 = betaArray[0];
    var respArray2 = betaArray[1];
    var respArray = respArray1.split(",");
    this.$("betaRows").value = respArray[0];
    this.$("betaUsers").value = respArray[1];
    this.$("bonusRow").value = respArray[2];
    this.$("bonusUsr").value = respArray[3];
    this.$("bonusDB").value =  respArray[4];
    this.$("bonusQt").value =  respArray[5];
    if (respArray2 != null && respArray2.length > 0)
    {
      var features = respArray2.split(",");
      ZDBPaymentsAdmin.reloadFeatures(features);
    }
  }

  this.updateFeatureLimits = function(el)
  {
    var reason = document.getElementById("FeatureReason").value;  //No I18N
    if (!ZDBPaymentsAdmin.validateReason(reason)) 
    { return; }
    var zuId = el.getAttribute("zuId");
    var formEl = this.$("UserFeatureForm");
    var userRows = this.$("rowLimit").value;
    var userUsr = this.$("userLimit").value;
    var userDBs = this.$("dbLimit").value;
    var userQts = this.$("qtLimit").value;
    var userSch = this.$("schCount").value;
    var userAPI = this.$("apiCount").value;
    var userAPIFreq = 20;
    var userMailSch = this.$("mailSchCount").value;
    var userReport = this.$("reportCount").value;
    var userRbrd = ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "rebranding"); //No I18N
    var userBkp = ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "backup"); //No I18N
    var userDbo = ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "dbowner"); //No I18N
    var userDbGrp = ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "dbgroup"); //No I18N
    var userPvtLink = ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "pvtLink"); //No I18N
    var userSlideshow = ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "slideshow"); //No I18N
    var userLivechat = ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "liveChat"); //No I18N
    var importFromEmail= ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "importFromEmail"); //No I18N
    var userAuditLog = ZDBPaymentsAdmin.getRadioSelectedValue(formEl, "auditLog"); //No I18N
    var paymentMode = jQuery("#paymentMode").val();			//No I18N
    var dmlFreqLim = formEl.freq_dmlapi.value || 0;
    var bulkFreqLim = formEl.freq_bulkapi.value || 0;
    var metadataFreqLim = formEl.freq_metadataapi.value || 0;
    var overallLim = formEl.freq_overall_lim.value || 0;

    AjaxAPI.sendRequest({
    	URL : "/ZDBAdminPayments.ma?ZDBACTION=UPDATEFEATURES" + "&ZUID="			//No I18N
			+ zuId + "&USERROWS=" + userRows + "&USERUSERS=" + userUsr				//No I18N
			+ "&USERDBS=" + userDBs + "&USERQTS=" + userQts							//No I18N
			+ "&USERSCH=" + userSch + "&USERRBRD=" + userRbrd						//No I18N
			+ "&USERBKP=" + userBkp + "&USERAPI=" + userAPI							//No I18N
			+ "&USERAPIFREQ=" + userAPIFreq + "&USERDBO=" + userDbo					//No I18N
			+ "&USERMAILSCH=" + userMailSch + "&USERREPORTS="						//No I18N
			+ userReport + "&USERDBGRP=" + userDbGrp + "&USERPVTLINK="				//No I18N
			+ userPvtLink  + "&USERSLIDESHOW=" + userSlideshow + "&REASON=" + reason//No I18N
			+ "&USERDMLFREQLIM="+dmlFreqLim + "&USERBULKFREQLIM="+ bulkFreqLim		//No I18N
			+ "&USERMETADATAFREQLIM=" + metadataFreqLim + "&USEROVERALL_LIM=" + overallLim   //No I18N
			+ "&PAYMENTMODE="+paymentMode + "&USERLIVECHAT="+userLivechat  //No I18N
                        + "&USERIMPORT_FROM_EMAIL="+importFromEmail+ "&USERAUDITLOG="+userAuditLog,	        //No I18N
		METHOD : "POST",															//No I18N
		ONSUCCESSFUNC : ZDBPaymentsAdmin.reloadFeatureInfo,
		OPSTATUSID : "ZDBMainLoader"												//No I18N
    });
  };
 
  this.reloadFeatureInfo = function(response, requestOptions)
  {
    var respArray = response.responseText.split(",");
    ZDBPaymentsAdmin.reloadFeatures(respArray);
  };

  this.reloadFeatures = function(respArray)
  {
    if (respArray != null && respArray.length > 0)
    {
    this.$("rowLimit").value = respArray[0];
    this.$("userLimit").value = respArray[1];
    this.$("dbLimit").value = respArray[2];
    this.$("qtLimit").value = respArray[3];
    this.$("schCount").value = respArray[4];
    var formEl = this.$("UserFeatureForm");
    var rebrand = respArray[5];
    ZDBPaymentsAdmin.setRadioButtonStatus(formEl, "rebranding", rebrand); //No I18N
    var backup = respArray[6];
    ZDBPaymentsAdmin.setRadioButtonStatus(formEl, "backup", backup); //No I18N
    var dbowner = respArray[7];
    ZDBPaymentsAdmin.setRadioButtonStatus(formEl, "dbowner", dbowner); //No I18N
    alert ('update successful'); //No I18N
    }
  }

  this.validateReason = function(reason)
  {
    if (reason == "" || reason == null || (reason.indexOf("PO") < 0 && reason.indexOf("internal") < 0 && reason.indexOf("cancellation") < 0))
    {
      alert("Update the PO number or the actual reason for the proposed admin action for future reference."); //No I18N
      return false;
    }
    return true;
  }

  this.updateQueryStringParameter = function (uri, key, value) 
  {
    var re = new RegExp("([?&])" + key + "=.*?(&|$)", "i");
    var separator = uri.indexOf('?') !== -1 ? "&" : "?";
    if (uri.match(re)) {
    return uri.replace(re, '$1' + key + "=" + value + '$2');
    }
    else {
     return uri + separator + key + "=" + value;
    }
  }

  this.pacTabChange = function(tabEl)
  {
    var tabName = jQuery(tabEl).attr("tab"); //No I18N
    window.location.href = ZDBPaymentsAdmin.updateQueryStringParameter(window.location.href , "TAB" , tabName);
  }
  
  this.calculatePricing = function()
  {
    var planCost = 0;
    var selectedPlan = 0;
    var payTerm = jQuery("#payPeriod").attr("value"); //No I18N
    var formEl = this.$("UserPlanConsole");
    var radio = formEl["PlanId"];
    var len = radio.length;
    for(var i=0; i<len; i++)
    {
      var opt = radio[i];
      if(opt.checked == true)
      {
        planCost = opt.getAttribute("cost");
        selectedPlan = opt.value;
      }
    }
      if (selectedPlan == 1 || selectedPlan == 8)
      {
        jQuery("#payPeriod").attr("value","NULL"); //No I18N
        jQuery("#selectedPlanCost").attr("value","$0"); //No I18N
      }
      else
      {
        var discount = 1;
        if (payTerm == "NULL")
        {
          jQuery("#payPeriod").attr("value","YEAR"); //No I18N
        }
        discount = 0.9;
        jQuery("#selectedPlanCost").attr("value",'$' + planCost*12*discount); //No I18N
      }
  }
  
  this.updatePaymentDesc = function(el){
	  var desc = jQuery("#paymentdescarea").val().trim();   //No I18N
	  var param = desc ? "PAYMENTDESC="+encodeURIComponent(desc):"";		//No I18N
	  var zuid = el.getAttribute("ZUID");
	  AjaxAPI.sendRequest({
    	URL : "/ZDBAdminPayments.ma?ZDBACTION=UPDATEPAYMENTDESC",	//No I18N
		METHOD : "POST",											//No I18N
		PARAMETERS: "ZUID="+zuid+"&"+param,		//No I18N
		ONSUCCESSFUNC : function(resp){
			alert(resp.responseText+"");		//No I18N
		},
		OPSTATUSID : "ZDBMainLoader"								//No I18N
	  });
  };

  this.updatePayMode = function(el){
	  var paymentMode = jQuery("#paymentMode").val();			//No I18N
	  var zuid = el.getAttribute("ZUID");
	  AjaxAPI.sendRequest({
    	URL : "/ZDBAdminPayments.ma?ZDBACTION=UPDATEUSERPAYMENTMODE",	//No I18N
		METHOD : "POST",											//No I18N
		PARAMETERS: "ZUID="+zuid+"&USERPAYMENTMODE="+paymentMode,		//No I18N
		ONSUCCESSFUNC : function(resp){
			alert(resp.responseText+"");						//No I18N
		},
		ONFAILUREFUNC: function(){
			alert("Failed. Try after some times.");	//No I18N
		},
		OPSTATUSID : "ZDBMainLoader"								//No I18N
	  });
  };
  this.setColDBControllers = function(selValue, totalvwcontrollers){                
        var selArray = ["DEFAULTNODEID","FALLBACKNODEID"];//No I18N
        for(var j=0; j < selArray.length; j++)
        {
            for(var i=1; i < document.getElementById(""+selArray[j]).options.length; i++){
                if(i <= totalvwcontrollers){
                    if(selValue <= 1){
                        document.getElementById(""+selArray[j]).options[i].disabled=false;
                    }else{
                        document.getElementById(""+selArray[j]).options[i].disabled=true;
                    }

                }else{
                    if(selValue <= 1){
                        document.getElementById(""+selArray[j]).options[i].disabled=true;
                    }else{
                        document.getElementById(""+selArray[j]).options[i].disabled=false;
                    }
                }
            }
        }

    };
}
