#$Id$

basefile=base_file.scss
themefiles=(theme1.scss theme2.scss)
themes=(light.scss dark.scss)

mkdir -p ../styles

for themefile in ${themefiles[*]}; do
    for file in ${themes[*]}; do
        touch temp.scss
        cat $file $themefile $basefile > temp.scss
        filename=$(basename $file .scss)_$(basename $themefile .scss)
        echo "Generating file: $filename.css"
        sass --sourcemap=none temp.scss ../styles/$filename.css
        rm temp.scss
	done
done

rm -rf .sass-cache