//$Id$
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


function ZDBBackgroundProp(propSetUtil)
{
    var propSetUtil = propSetUtil;
    var backgroundProp = propSetUtil.propSetForm.backgroundProp;
    
    this.setBackgroundPropEls = function()
    {
    	ZDBUtil.setNamedChildEls(backgroundProp, backgroundProp);
        var bgClrProp = propSetUtil.getPropValue(PropSettings.CHART_BACKGROUND_COLOR,PropSettings.STATIC_PROP,PropSettings.COLOR_PROPTYPE); //No I18N
        if(bgClrProp && bgClrProp["TYPE"] == "normal")
        {
            this.setBgColorProp(bgClrProp);
        }
        else
        {
            ZDBBackgroundProp.showBgClr(0, 'd', backgroundProp);//No I18N
        }
        var defClrProp = backgroundProp.defClrProp;
        defClrProp.style.display = propSetUtil.isLegend ? "none" : "";
        this.setBorderPropEls();
        this.setGridLinePropEls();
        this.setDefaultColorPropEls();
    }

    this.setBorderPropEls = function()
    {
        var borderClrProp = propSetUtil.getPropValue(PropSettings.CHART_BORDER,PropSettings.STATIC_PROP,PropSettings.COLOR_PROPTYPE); //No I18N
        var borderTypeProp = propSetUtil.getPropValue(PropSettings.CHART_BORDER, PropSettings.STATIC_PROP, PropSettings.STRING_PROPTYPE);//No I18N
        var chartBorderOutlineProp = propSetUtil.getPropValue(PropSettings.CHART_BORDER_OUTLINE,PropSettings.STATIC_PROP,PropSettings.DOUBLE_PROPTYPE); //No I18N
        borderClrProp = borderClrProp ? borderClrProp : (new ZDBColorObject("borderClr"));//No I18N
        borderTypeProp = borderTypeProp ? borderTypeProp : "Default";//No I18N
        chartBorderOutlineProp = chartBorderOutlineProp ?  chartBorderOutlineProp : "0";//No I18N
        ZDBBackgroundProp.setColorEl(backgroundProp.borderClr, borderClrProp);
        this.setChartBorderOutlineEl(backgroundProp.borderOuterLine,chartBorderOutlineProp);
        this.setStrokeEl(backgroundProp.borderType, borderTypeProp);
    }
    
    this.setGridLinePropEls = function()
    {
        var gridLineClrProp = propSetUtil.getPropValue(PropSettings.CHART_AXIS_GRIDLINE,PropSettings.STATIC_PROP,PropSettings.COLOR_PROPTYPE); //No I18N
        var gridLineTypeProp = propSetUtil.getPropValue(PropSettings.CHART_AXIS_GRIDLINE, PropSettings.STATIC_PROP, PropSettings.STRING_PROPTYPE);//No I18N
        gridLineClrProp = gridLineClrProp ? gridLineClrProp : (new ZDBColorObject("borderClr"));//No I18N
        gridLineTypeProp = gridLineTypeProp ? gridLineTypeProp : "Default";//No I18N
        ZDBBackgroundProp.setColorEl(backgroundProp.gridLineClr, gridLineClrProp);
        this.setStrokeEl(backgroundProp.gridLineType, gridLineTypeProp);
    }

    this.setDefaultColorPropEls = function()
    {
        var modClr = propSetUtil.getPropValue(PropSettings.CHART_DEFAULT_CLR,PropSettings.STATIC_PROP,PropSettings.COLOR_PROPTYPE); //No I18N
        if(!modClr)
    	{
        	var defaultClrProp = "JSDefaultClr"; //No I18N
	        var data = propSetUtil.view.chartObj.getData();
	        var subType = data.ZRCLRPALETTE.SUBTYPE;
	        if(data.legend.colors.length > 0 && subType != "DEF")
            {
                var key = data.ZRCLRPALETTE.KEYS;
                var palette = data.ZRCLRPALETTE.DETAILS[key.CLRS];
                var initClrArr = palette.split(",");
	 	        var PltClr = parseInt("0x"+initClrArr[0].replace("#","")).toString(); // NO I18N
	 	        defaultClrProp = ["normal",PltClr,PltClr];
            }
	        ZDBBackgroundProp.setColorEl(backgroundProp.defaultClr, new ZDBColorObject(defaultClrProp));	        
    	}
        else
        {
        	ZDBBackgroundProp.setColorEl(backgroundProp.defaultClr, modClr);
       	}
    }

    this.setChartBorderOutlineEl = function(strokeEl, propValue)
    {
        ZDBBackgroundProp.showChartBorderOptions(strokeEl.getElementsByTagName("div")[0]);
        strokeEl.elnameSet = false;
        ZDBUtil.setNamedChildEls(strokeEl, strokeEl);
        ZDBBackgroundProp.setBorderStyle(strokeEl[Math.round(propValue)]);
    }

    this.setStrokeEl= function(strokeEl, propValue)
    {
        ZDBBackgroundProp.showStrokeStyleDialog(strokeEl.getElementsByTagName("div")[0]);
        strokeEl.elnameSet = false;
        ZDBUtil.setNamedChildEls(strokeEl, strokeEl);
        ZDBBackgroundProp.setStrokeStyle(strokeEl[propValue]);
    }
    
    this.setBgColorProp = function(bgClrProp)
    {
        ZDBUtil.setNamedChildEls(backgroundProp, backgroundProp);
        var bgClrType = backgroundProp.bgClrType;
        bgClrType.value = bgClrProp["TYPE"] == "normal" ? "n" : "g" ;//No I18N
        if(bgClrType.value == "n")
        {
            ZDBBackgroundProp.showBgClr(1, 'n', backgroundProp);//No I18N
            backgroundProp.normalClr.setAttribute("value",PropSettings.adjustToHex(bgClrProp["STARTCOLOR"]));
            backgroundProp.normalClr.style.backgroundColor = "#" + PropSettings.adjustToHex(bgClrProp["STARTCOLOR"]);
        }
    }
    
    this.setBackgroundProp = function()
    {
        ZDBUtil.setNamedChildEls(backgroundProp, backgroundProp);
        var bgColor = backgroundProp.bgColor;
        var value = (backgroundProp.bgClrType).getAttribute("value");
        if(value == 'n')
        {
            bgColor.setAttribute("type","normal");
            bgColor.setAttribute("STARTCOLOR", parseInt("0x"+backgroundProp.normalClr.getAttribute("value")));
            bgColor.setAttribute("ENDCOLOR", parseInt("0x"+backgroundProp.normalClr.getAttribute("value")));
            propSetUtil.setPropMap(bgColor, new ZDBColorObject('bgColor'), true); //No I18N
        }
        else if(value == 'd')
        {
            propSetUtil.deleteFromPropMap(PropSettings.CHART_BACKGROUND_COLOR);//No I18N
        }
        propSetUtil.setPropMap(backgroundProp.borderOuterLine,"0",true);//No I18N
        propSetUtil.setPropMap(backgroundProp.borderType, "Default", true); //No I18N
        ZDBBackgroundProp.setColorPropVal(backgroundProp.borderClr);
        propSetUtil.setPropMap(backgroundProp.borderClr, new ZDBColorObject('borderClr'), true); //No I18N
        propSetUtil.setPropMap(backgroundProp.gridLineType, "Default", true); //No I18N
        ZDBBackgroundProp.setColorPropVal(backgroundProp.gridLineClr);
        propSetUtil.setPropMap(backgroundProp.gridLineClr, new ZDBColorObject('gridLineClr'), true); //No I18N
        ZDBBackgroundProp.setColorPropVal(backgroundProp.defaultClr);
        var defClrVal = propSetUtil.view.chartObj ? 'JSDefaultClr' : 'defaultClr'; //No I18N
        if(propSetUtil.view.chartObj)
        {
            var data = propSetUtil.view.chartObj.getData();
            var subType = data.ZRCLRPALETTE.SUBTYPE;
            if(data.legend.colors.length > 0 && subType != "DEF")
            {
                var key = data.ZRCLRPALETTE.KEYS;
                var palette = data.ZRCLRPALETTE.DETAILS[key.CLRS];
                var initClrArr = palette.split(",");
	 	        var PltClr = parseInt("0x"+initClrArr[0].replace("#","")).toString(); // NO I18N
	 	        defClrVal = ["normal",PltClr,PltClr];
            }
        }
        propSetUtil.setPropMap(backgroundProp.defaultClr, new ZDBColorObject(defClrVal), true);
    }
    
    return this;
}

ZDBBackgroundProp.setColorEl = function(clrEl, clrProp)
{
    clrEl.setAttribute("value",PropSettings.adjustToHex(clrProp["STARTCOLOR"]));
    clrEl.style.backgroundColor = "#" + PropSettings.adjustToHex(clrProp["STARTCOLOR"]);
}

ZDBBackgroundProp.showBgClr = function(el, value, backgroundProp)
{
    var temp = null;
    if(el == 0 || el == 1 || el ==2)
    {
        temp = el;
    }
    else
    {
        var propSetUtil = ZDBClientUI.getViewObj(el,"propSetUtil");
        backgroundProp = propSetUtil.propSetForm.backgroundProp;
    }
    ZDBUtil.setNamedChildEls(backgroundProp, backgroundProp);
    var bgClrType = backgroundProp.bgClrType;
    var bgClrTypeEls = bgClrType.getElementsByTagName("div");
    el = (temp!=null) ? bgClrTypeEls[temp] : el;
    ZDBAxisProp.setToggleEl(el);
    (el.parentNode).setAttribute("value", el.getAttribute("value"));
    var solidBg = backgroundProp.solidBg;
    value = value ? value : el.getAttribute("value");
    if(value === 'd')
    {
        solidBg.style.display = "none";
    }
    else if(value === 'n')
    {
        solidBg.style.display = "";
    }
    else
    {
        solidBg.style.display = "none";
    }
    ZDBInlineDialog.resizeDlgHeight();
}

ZDBBackgroundProp.setColorPropVal = function(clrEl)
{
    clrEl.setAttribute("type","normal");
    clrEl.setAttribute("startcolor",parseInt("0x"+clrEl.getAttribute("value")));
    clrEl.setAttribute("endcolor",parseInt("0x"+clrEl.getAttribute("value")));
}

ZDBBackgroundProp.setStrokeStyle = function(el)
{
    var parNode = ZDBUtil.getParentWithAttributeValue(el, "propType", PropSettings.STRING_PROPTYPE);//No I18N
    ZDBUtil.setNamedChildEls(parNode, parNode);
    var strokeTypeDiv = parNode.strokeDiv;
    strokeTypeDiv.innerHTML = el.innerHTML;
    var trEl = parNode.parentNode;
    var clrEl = ZDBUtil.getElWithTagNAttrWithVal(trEl, "proptype", PropSettings.COLOR_PROPTYPE, "div");//No I18N
    ZDBUtil.setNamedChildEls(trEl, trEl);

if (trEl.borderDiv)
{
    var borderLayout = trEl.borderDiv.parentNode;
    if (el.getAttribute("elname") == "strokeStyle0")
    {
        borderLayout.className = borderLayout.className + " alpha";
        borderLayout.setAttribute("onmouseover", "this.className='inlinePropCombo alpha'");
        borderLayout.setAttribute("onmouseout", "this.className='inlinePropCombo alpha'");
    }
    else
    {
        borderLayout.className = "inlinePropCombo";
        borderLayout.setAttribute("onmouseover", "this.className='inlinePropCombo'");
        borderLayout.setAttribute("onmouseout", "this.className='inlinePropCombo'");
    }
}
    if(el.getAttribute("elname") == "Default" || el.getAttribute("elname") ==  "strokeStyle0")
    {
        clrEl.className = clrEl.className + " alpha";
        clrEl.setAttribute("onmouseover", "this.className='inlineClrEl alpha'");
        clrEl.setAttribute("onmouseout", "this.className='inlineClrEl alpha'");
    }
    else
    {
        clrEl.className = "inlineClrEl";
        clrEl.setAttribute("onmouseover", "this.className='inlineClrElHover'");
        clrEl.setAttribute("onmouseout", "this.className='inlineClrEl'");
    }
    parNode.setAttribute("propValue", el.getAttribute("elname"));
}

ZDBBackgroundProp.setBorderStyle = function(el)
{
    var selVal = DOMUtils.getChildElsWithAttr(el,"elname",'*')[0]; //No I18N
    var parNode = ZDBUtil.getParentWithAttributeValue(el, "propType", PropSettings.DOUBLE_PROPTYPE);//No I18N
    ZDBUtil.setNamedChildEls(parNode, parNode);
    var borderDiv = parNode.borderDiv;
    borderDiv.innerHTML = selVal.innerHTML;
    parNode.setAttribute("propValue", el.getAttribute("elname"));
}

ZDBBackgroundProp.showStrokeStyleDialog = function(strokeEl,event)
{
    var propSetUtil = ZDBClientUI.getViewObj(strokeEl,"propSetUtil");
    var backgroundProp =propSetUtil.propSetForm.backgroundProp;
    var topParentNode = ZDBUtil.getParentWithTagName(strokeEl, "td");//No I18N
    if(PropSettings.inlineComboOpt)
    {
        var currentParNode = ZDBUtil.getParentWithTagName(PropSettings.inlineComboOpt , "td");//No I18N
        ZDBAxisProp.hideComboOptDialog();
        if(currentParNode == topParentNode)
        {
            currentParNode.selected = false;
            return;
        }
    }
    strokeEl.className = "inlinePropComboSel";
    topParentNode.selected = true;
    ZDBUtil.setNamedChildEls(backgroundProp, backgroundProp);
    var strokeStyles = ZDBUtil.getCloneNode(backgroundProp.strokeStyles);
    strokeStyles.style.display = "";
    PropSettings.inlineComboOpt = strokeStyles;
    topParentNode.appendChild(strokeStyles);
    ZDBAxisProp.attachComboOptEvent(event);
}

ZDBBackgroundProp.showChartBorderOptions = function(borderType,event)
{
    var className = borderType.className;
    var clsNames = className.split(" ");
    if(clsNames[clsNames.length-1] == "alpha")
        {
            return;
        }
    var propSetUtil = ZDBClientUI.getViewObj(borderType,"propSetUtil");
    var backgroundProp =propSetUtil.propSetForm.backgroundProp;
    var topParentNode = ZDBUtil.getParentWithTagName(borderType, "td");//No I18N
    if(PropSettings.inlineComboOpt)
    {
        var currentParNode = ZDBUtil.getParentWithTagName(PropSettings.inlineComboOpt , "td");//No I18N
        ZDBAxisProp.hideComboOptDialog();
        if(currentParNode == topParentNode)
        {
            currentParNode.selected = false;
            return;
        }
    }
    borderType.className = "inlinePropComboSel";
    topParentNode.selected = true;
    ZDBUtil.setNamedChildEls(backgroundProp, backgroundProp);
    var borderStyles = ZDBUtil.getCloneNode(backgroundProp.chartBorderTypes);
    borderStyles.style.display = "";
    PropSettings.inlineComboOpt = borderStyles;
    topParentNode.appendChild(borderStyles);
    ZDBAxisProp.attachComboOptEvent(event);
}
