//$Id$
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


function ZDBMapProp(propSetUtil)
{
    this.mapProp = propSetUtil.propSetForm.mapProp;
    this.propSetUtil = propSetUtil;
    this.setMapPropValues();
   
};

ZDBMapProp.prototype.setDataLabelEl = function(el)
    {
        el.checked = false;
        if(this.propSetUtil.getPropValue(PropSettings.CHART_DATALABEL_EXISTS,  PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE))
        {
            el.checked = true;
            ZDBAxisProp.setPropValOnCheck(el);
        }
};
ZDBMapProp.prototype.setLegendState = function(el)
    {
        var curVal = this.propSetUtil.getPropValue(PropSettings.CHART_MAP_SHOWLEGENDBYDEFAULT,  PropSettings.STATIC_PROP ,PropSettings.STRING_PROPTYPE);
        if(curVal == "true" || !curVal)
        {
           el.checked = true; 
           ZDBMapProp.clickLegendShow(el);
        }
        else
        {
            el.checked = false; 
           ZDBMapProp.clickLegendShow(el);
    } 
}; 
ZDBMapProp.prototype.setMapPropValues = function()
{
    var mapProp = this.mapProp;    
    var propUtil = this.propSetUtil;
    ZDBUtil.setNamedChildEls(mapProp, mapProp);
    mapProp.defClrProp.style.display = this.propSetUtil.isLegend ? "none" : "";
    mapProp.showLegend.style.display = this.propSetUtil.isLegend ? "" : "none";
    mapProp.markerSettingProp.style.display = this.propSetUtil.isScatter ? "" : "none";
    mapProp.defFillOpacityProp.style.display = this.propSetUtil.isScatter ? "none" : "";
    this.setDefaultColorPropEls(mapProp.defaultClr);
    propUtil.fontPropObj = new ZDBFontProp(mapProp, propUtil);
    propUtil.fontPropObj.initFontProp();
    this.setDataLabelEl(mapProp.dataLabelEl);
    this.setSliderEl(mapProp.sliderEl);
    this.setMarkerType(mapProp.selectedMarker);
    this.setLegendState(mapProp.showLegendEle);
    
};

ZDBMapProp.prototype.setDefaultColorPropEls = function(el)
{
    var defaultClrProp = this.propSetUtil.getPropValue(PropSettings.CHART_DEFAULT_CLR,PropSettings.STATIC_PROP,PropSettings.COLOR_PROPTYPE);     
    defaultClrProp = defaultClrProp ? defaultClrProp : (new ZDBColorObject("JSDefaultClr"));//No I18N;//No I18N
    ZDBBackgroundProp.setColorEl(el,defaultClrProp);
}
ZDBMapProp.prototype.setSliderEl = function(el)
{
   var defValue =  this.propSetUtil.getPropValue(PropSettings.CHART_MAP_FILL_OPACITY,PropSettings.STATIC_PROP,PropSettings.STRING_PROPTYPE); 
   if(defValue != null)
   {
       el.style.left = ( Number(defValue.replace("%","")) - 3 )+ "%";
       el.nextElementSibling.value = defValue;
   }
   if(this.propSetUtil.isBubble)
   {
       if( defValue == null)
       {
           el.style.left = "38%";
           el.nextElementSibling.value = "40%";
       }
       d3.select("#defaultVal").attr("style","left:40%;top:3px");//No I18N
       d3.select("#deafultMark").attr("style","font-size:11px;margin-left:74px;margin-top:10px");  //No I18N
   }
};

ZDBMapProp.prototype.setMarkerType= function(el)
{
    var defValue =  this.propSetUtil.getPropValue(PropSettings.CHART_MAP_MARKER_TYPE,PropSettings.STATIC_PROP,PropSettings.STRING_PROPTYPE);    
    if(defValue != null)
    {
        d3.select(el)
                .selectAll("td[propValue='" + defValue + "']") //No I18N
                .attr("isclicked","true") //No I18N
                .style("background","white") //No I18N
                .style("border-right-color","#bfbfbf")//No I18N
                .select("#selectedMarker").style("display","block");//No I18N
            var prevEle = d3.select(el).selectAll("td[propValue='" + defValue + "']").node();//No I18N
            prevEle.previousElementSibling.style.borderRightColor = "#bfbfbf"; //No I18N
    }
    else
    {
        d3.select(el)
                .select("td")//No I18N
                .attr("isclicked","true")//No I18N
                .attr("propvalue","default")//No I18N
                .style("background","white")//No I18N
                .style("border-right-color","#bfbfbf")//No I18N
                .select("#selectedMarker").style("display","block");//No I18N
    }
   
};

ZDBMapProp.prototype.setMapPropMap = function(propSetUtil)
{
    var mapProp = propSetUtil.propSetForm.mapProp;
    ZDBUtil.setNamedChildEls(mapProp, mapProp);
    ZDBBackgroundProp.setColorPropVal(mapProp.defaultClr);
    propSetUtil.setPropMap(mapProp.defaultClr, new ZDBColorObject('defaultClr'), true); //No I18N
    propSetUtil.setPropMap(mapProp.dataLabelEl, "false", true); 
    propSetUtil.setPropMap(mapProp.sliderEl,"65%", true);
    propSetUtil.setPropMap(mapProp.selectedMarker,"default",true);//No I18N
    propSetUtil.setPropMap(mapProp.showLegendEle,"true",true);
};

ZDBMapProp.transMouseMove = function(event){
    event.preventDefault();
    var slider = document.getElementById("transSlider");
    var left = ZDBMapProp.slideTheCursor(slider, event);
    var value = Math.floor(left + 3);
    slider.value = value + "%";
    slider.nextElementSibling.value = value + "%";
    
};

ZDBMapProp.transMouseUp = function(event,el){
    document.removeEventListener("mousemove", this.transMouseMove);
    document.removeEventListener("mouseup", this.transMouseUp);
};

ZDBMapProp.transMouseDown = function(event){
    if (event.target.type == "text") return;
    var slider = document.getElementById("transSlider");
    var left = ZDBMapProp.slideTheCursor(slider,event);
    var value = Math.floor(left + 3);
    slider.value = value + "%";
    slider.nextElementSibling.value = value + "%";
    document.addEventListener("mousemove", this.transMouseMove);
    document.addEventListener("mouseup", this.transMouseUp);
    
};

ZDBMapProp.slideTheCursor = function (el,event)
{
    var slider = el;
    var sliderParent = slider.parentNode;
    var parentBounds = sliderParent.getBoundingClientRect();
    var lowerBound = parentBounds.left,
    higherBound = parentBounds.left + parentBounds.width;
    var previousX = lowerBound + parseFloat(slider.style.left) * parentBounds.width / 100;
    var diff = event.clientX - previousX;
    var diffPerc = diff / parentBounds.width * 100;
    var left = parseFloat(slider.style.left) + diffPerc;
    left = left < 0 ? -3 : left > 100 ? 97 : left - 3;
    left = Math.ceil(left);
    slider.style.left = left + "%";
    return left;
};

ZDBMapProp.cursorOnMarker = function (event)
{
    if(!(event.currentTarget.getAttribute("isclicked") == "true"))
    {
        event.currentTarget.style.backgroundColor = "white";
//        event.currentTarget.style.border = "1px solid #bfbfbf" ;
    }
    
};

ZDBMapProp.cursorOut = function (event)
{
    if(!(event.currentTarget.getAttribute("isclicked") == "true"))
    {
        event.currentTarget.style.backgroundColor = "";
//        event.currentTarget.style.border = "" ;
    }
    
};

ZDBMapProp.setMarker = function (event,el)
{
    //reset the before selected marker type
    var prevEle = d3.select(el.parentElement).selectAll("td[isclicked='true']");//No I18N
    var ele = prevEle.node();
    
    prevEle.style("background","#f0f0f0");//No I18N
    prevEle.style("border-right-color","transparent");//No I18N
    ele.previousElementSibling ? ele.previousElementSibling.style.borderRightColor = "transparent" : null;//No I18N
    prevEle.select("#selectedMarker").style("display","none");//No I18N
    prevEle.attr("isclicked","false");//No I18N
    
    if(!(event.currentTarget.getAttribute("isclicked") == "true"))
    {
        event.currentTarget.style.backgroundColor = "white";
        event.currentTarget.style.borderRightColor = "#bfbfbf";//No I18N
        d3.select(el).select("#selectedMarker").style("display","block");//No I18N
        d3.select(el).attr("isclicked","true");//No I18N
        d3.select(event.currentTarget.previousElementSibling).style("border-right-color","#bfbfbf");//No I18N
        //set the markertype
        var newVal = d3.select(el).attr("propValue");//No I18N
        d3.select(el.parentElement).attr("propValue",newVal);//No I18N
    }
    
};

ZDBMapProp.clickLegendShow = function(el)
{
    el.setAttribute("propValue",el.checked);
};

ZDBMapProp.inputChange = function(event)
{
    var value = event.target.value;
    value = value.replace("%", "");
    if (value.length > 0) {
            value = parseFloat(value);
            if (isNaN(value) || value < 0 || value > 100) {
                    event.target.value = isNaN(value) ? "%" : Math.floor(value/10) + "%";
                    ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.chartview.setting.js.opacityRangeAlert"));
                    return;
            }
    }
    var slider = document.getElementById("transSlider");
    slider.style.left  = Math.floor(value - 3) + "%";
    slider.value = Math.floor(value) + "%";
    slider.nextElementSibling.value = value + "%";
    
};
ZDBMapProp.eventStopper = function(event)
{
    event.stopPropagation();
}



