//$Id$

var ZDBRankingRefFilter = new function()
{
     this.fetchRefColFunction = function(rnkingColCombo,event)
  {
       var fieldElHeader = DOMUtils.getSelfOrParentWithAttrValue(rnkingColCombo ,"FieldElHeader","true"); //ZDBUtil.getSParentWithAttributeValue(rnkingColCombo ,"FieldElHeader","true");//NO I18N
       var view = ZDBClientUI.getViewObj(rnkingColCombo,"view");//NO I18N
       var filterEl = view.filterNav.selectedField.filterEl;//DOMUtils.getSelfOrParentWithAttrValue(fieldElHeader ,"filterel","true");
       var field = filterEl.fieldEl;//view.filterNav.selectedField;
       if(field.fetchStatus == 1){return;}
       var filterNav = view.filterNav;
       ZDBUtil.setNamedChildEls(filterEl.fieldEl.refColList,filterEl);
       if(field.refColList)
        {
            ZDBRankingRefFilter.showRefColFunction(rnkingColCombo,event);
            return;
        }
        field.fetchStatus = 0;
        var paramsXML = "<DBSVParams  COLID='" + field.getAttribute("COLUMN_ID")  + "' ADDONTYPE='"+field.getAttribute("ADDONTYPE")+"' ZAGRIDTYPE='"+view.type +"' REF_COLID='"+ field.getAttribute("REFERREDCOLUMNID")+"' REF_TBLID='"+field.getAttribute("REFERREDTBLID") + "' REF_SUBTYPE='"+field.getAttribute("REFCOLSUBTYPE") + "'  ></DBSVParams>"; //NO I18N
        var doXML = ZDBAnalysisConfig.getCurrentConfig(view,false);
        var xml = "<DBSVRequest csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n"+paramsXML+"\n"+doXML+"</DBSVRequest>"; //NO I18N
        var parentId = field.getAttribute("PARENT_OBJ_ID") != null ? field.getAttribute("PARENT_OBJ_ID").trim() : view.parentViewId ;
        var toSendURL = "/ZARankingFilter.cc?PARENTVIEWID="+parentId+"&ISRANKINGLIST="+true +"&ISINTEGRATED=" + ZDBGlobal.integrated + view.viewCtx.getAdditionalParams(); //NO I18N
        if(!ZDBUtil.isNewView(view))
        {
            toSendURL += "&OBJID=" + view.objId; //NO I18N
        }
        toSendURL += "&VMOD=true"+"&VMFILTER="+(field.getAttribute("VIEWTYPE")=="VMFILTERCRITERIA"); //No I18N
        field.fetchStatus = 1;
        
        AjaxAPI.sendRequest({URL:toSendURL,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},
            POSTBODY:xml,
            ONSUCCESSFUNC:ZDBRankingRefFilter.showRnkngList,
            FIELDEL:field,FILTERNAV:filterNav,FIELDELHEADER:fieldElHeader,VIEW:view});
  }
  
  this.showRnkngList = function(response,requestOptions)
  {
//    var refColList = $("rankingRefColList");
//    refColList.id = "";
var div = document.createElement("div");
    div.innerHTML = response.getOnlyHtml();
    var refColList = DOMUtils.getFirstMatchingChild(div,null ,"elName","refColList");  //NO I18N
    var fieldEl = requestOptions["FIELDEL"];
    var view = requestOptions["VIEW"];
    fieldEl.fetchStatus = 2;
    var fieldElHeader = requestOptions["FIELDELHEADER"];   
    ZDBUtil.setNamedChildEls(fieldElHeader,fieldElHeader,"RefElName");
    fieldEl.elnameSet = false;
    ZDBUtil.setNamedChildEls(refColList,fieldEl,null,true);
//    fieldEl.refColList = refColList;
    var refColFunList = fieldEl.refColFunList;
    ZDBRankingRefFilter.updateRefColDet(fieldEl);
    document.body.appendChild(refColList);
    var RefCompDiv = DOMUtils.getFirstMatchingChild(fieldElHeader,null ,"refelname","RefCompDiv");  //NO I18N 
    ZDBRankingRefFilter.showRefColFunction(RefCompDiv);
    ZDBRankingRefFilter.updateListEvents(refColFunList);
	
  }
  
  this.updateListEvents = function(refColFunList)
  {
      var jQrefColFunList = jQuery(refColFunList);
      var searchForm = $("rankingsearchForm");
      searchForm.id = "";
      var jQsearchForm = jQuery(searchForm);
      var searchInput = jQsearchForm.find('input');
      var jQrefColEls = jQrefColFunList.parents("[elname='refColList']"); //NO I18N
      var searchMisMatch = jQrefColFunList.find("span[elName='searchMismatch']");
      // to expand the selected table-column list
       jQrefColFunList.delegate("div[isExpAllowed='true']", 'click', function(event) //NO I18N
                        {
                            ZAComboList.listExpandContract(jQuery(event.target));
                        });
       // to clear the search field and show the default tables
        searchMisMatch.find("a[elName='clearSearch']").bind("mousedown",function()
                        {
                            ZAComboList.clearSearch(jQrefColEls.get(0));
                            ZDBRankingRefFilter.searchList(jQrefColFunList,searchMisMatch,searchInput);
                        });
         jQrefColEls.find("#ZDBSearchButton").bind("mousedown",function()
                    {
                            ZDBSearchUtil.dntBlur=true;
                            ZAComboList.clearSearch(jQrefColEls.get(0));
                            ZDBRankingRefFilter.searchList(jQrefColFunList,searchMisMatch,searchInput);
                    }); 
       // show/hide subfn list on mouseover of dt element
        jQrefColFunList.find("[listel='true']").mouseenter(function()
                        {
                            if(this.getAttribute("ADDONTYPE")!=="ABSDATECATEGORICAL")
                            {
                                ZAComboList.hideSubFuncList(this);return;
                            }
                             ZAComboList.showSubFuncList(this,"ABS"); //NO I18N
                         });
        // to show tool tip for columns and table els
        jQrefColEls.find("[listel='true']").hover(function(event)
                        {
                            ToolTip.show(event,this);
                        },function(event)
                        {   
                         ToolTip.hide(event,this);
                        });
        // on focusing the search element, key handling for the list should be removed and added on blur
        searchInput.focus(function(){
            ZAComboList.searchFocused = true;
            ZDBUtil.detachEvent(document,'keydown',ZAComboList.checkKeyNContinue,true);
          });
          
        searchInput.blur(function(){
            ZAComboList.searchFocused = false;          
            ZDBUtil.attachEvent(document,'keydown',ZAComboList.checkKeyNContinue,true);
          });
                                    
        jQsearchForm.find("button[elName='searchButton']").click(function()
        {
          ZDBRankingRefFilter.searchList(jQrefColFunList,searchMisMatch,searchInput);
        });
                
        // input box value should be updated on typing, need this bcz of showing the default text on emptying the search box  
        searchInput.change(function()
                        {
                          jQuery(this).attr('searchVal',jQuery(this).val());//NO I18N
                        }).keydown(function()
                        {
                          jQuery(this).change();
                        }).keyup(function(event) 
                        {
                            if (event.which == 13) {
                                event.preventDefault();
//                                jQsearchForm.submit();
                                ZDBRankingRefFilter.searchList(jQrefColFunList,searchMisMatch,this);
                            }
                        });
        
// to make search case insensitive
(function ($) {
  jQuery.expr[':'].Contains = function(a,i,m){
      return (a.textContent || a.innerText || "").toUpperCase().indexOf(m[3].toUpperCase())>=0;
  };}(jQuery));
  }
  
  // search the list for the matching columns
   this.searchList = function(jQrefColFunList,searchMisMatch,searchInput)
  {
      var query = jQuery(searchInput).attr('searchVal');//NO I18N
      if (query === "") 
      {
          jQrefColFunList.find('ul.refColUi li').show();
          searchMisMatch.hide();
          ZAComboList.showOnlyRequiredEls(jQrefColFunList.find('ul.refColUi'));
          return false;
      } 
      else 
      {
          searchMisMatch.hide();
          jQrefColFunList.find('ul.refColUi li').hide();
          var filteredEls = jQrefColFunList.find("a:Contains("+query+")[colNameDisp='true']");
          if(filteredEls.length>0)
          {
              filteredEls.parents('li').show();//NO I18N
              MenuUtil.slideDown(filteredEls.parents('li.RefFilterTbl').addClass('refListExpand').find('ul'),250);//NO I18N
              return false;
          }
          else
          {
              searchMisMatch.css('display','block');//NO I18N
          }
      }
      return false;
  }
  
// expand the corresponding el table and contracts all the other tables list
  
  
  this.updateRefColDet = function(fieldEl)
  {
      
    var filterEl = fieldEl.filterEl;
    ZDBUtil.setNamedChildEls(filterEl,filterEl);
    var dispColName = ZDBRankingRefFilter.getDispName(fieldEl, filterEl);
    var fieldEls = DOMUtils.getChildElsWithAttr(filterEl,"FieldElHeader","true"); //NO I18N
    if(fieldEl.dlgRefEl)
    {
      ZDBRankingRefFilter.updateRefColDetOfEl(fieldEl.dlgRefEl,true,dispColName,filterEl); // this is to update the dialogue element
    }
    for(var i=0;i<fieldEls.length;i++)
    {
      var el = fieldEls[i];
         var isSelected = el.getAttribute("isSelected");
      el["RefElNameSet"] = false;
      ZDBUtil.setNamedChildEls(el,el,"RefElName");
      if(el.getAttribute("AddNewRange")=="true")
      {
        fieldEl.dlgRefEl = el;
      }
      else
      {
        if((el.offsetWidth - el.selField.offsetWidth-20)>0)
          {
              el.refColElHeader.style.width = (el.offsetWidth - el.selField.offsetWidth-15)+"px";
          }
      }
      ZDBRankingRefFilter.updateRefColDetOfEl(el,isSelected,dispColName,filterEl);
    }
 }
 
 this.updateRefColDetOfEl = function(el,isSelected,dispColName,filterEl)
 {
   var tipVal = el.selField ? el.selField.getAttribute("value") : "";
    var refColDisp = el.refColDisp;//DOMUtils.getFirstMatchingChild(el,null ,"refelname","refColDisp");  //NO I18N
    if((isSelected==true || isSelected =="true"))
    {

      refColDisp.innerHTML = ZDBEscapeUtil.encodeForHtml(dispColName);
      refColDisp.setAttribute("value",dispColName);
      ZDBRankingRefFilter.chngSelectedValRef(el,filterEl,dispColName)
        tipVal = tipVal +" by "+ dispColName;//NO I18N      
    }
    if(el.getAttribute("fieldelheader")=="true")
    {
      el.setAttribute("value",tipVal);      
 }
 }
 this.getDispName = function(fieldEl,filterEl)
 {
   var colId = fieldEl.getAttribute("REFERREDCOLUMNID");
   var dispColName = fieldEl.getAttribute("DISPCOLNAME");
   if((dispColName==null || dispColName=="")&& fieldEl.getAttribute("subtype")=="3")
   {
       return ZDBI18NMap.g("zrpt.toolbar.filter.js.none");
    }
  else if(dispColName!=null && dispColName!="")
  {
       return dispColName;
    }
  if(!fieldEl.refColFunList)
    {
      return null;
    }
   var refFuncLst = fieldEl.refColFunList;
   var funEl = DOMUtils.getFirstMatchingChild(refFuncLst,"li","colId",colId); //NO I18N
   var colName = funEl.getAttribute("colName");

   fieldEl.setAttribute("DISPCOLNAME",colName)
   return colName;
 }

  this.resetNHideRefCol = function(fieldElHeader,selected,reset)
  {
    if(reset)
    {
      ZDBRankingRefFilter.resetRefCol(fieldElHeader);
    }
    var refColElHeader = DOMUtils.getFirstMatchingChild(fieldElHeader,"div","refColElHeader","true"); //NO I18N
    refColElHeader.style.display = selected ? "" : "none";
  }

  this.resetRefCol = function(fieldElHeader)
  {
      var view = ZDBClientUI.getViewObj(fieldElHeader,"view");
      var filterEl = DOMUtils.getFirstMatchingChild(ZDBAnalysisFilter.getFilterNav(view),"div","filterel", "true"); //NO I18N
      var refColDispEl = DOMUtils.getChildElsWithAttr(fieldElHeader,"refelname","refColDisp")[0]; //NO I18N
      ZDBRankingRefFilter.resetRefColIfNeeded(filterEl);
      refColDispEl.innerHTML = filterEl.getAttribute("listElcolname");
  }
this.resetRefColIfNeeded= function(filterEl)
  {
    var fieldEl = filterEl.fieldEl;
    if(!fieldEl.filterEl)
    {
       fieldEl.filterEl = filterEl;
    }
    fieldEl.setAttribute("listElcolname",ZDBI18NMap.g("zrpt.common.none"));
    fieldEl.setAttribute("REFERREDCOLUMNID","");
    fieldEl.setAttribute("DISPCOLNAME","");
    fieldEl.setAttribute("REFERREDTBLID","");
    fieldEl.setAttribute("REFCOLADDONTYPE","");
    fieldEl.setAttribute("REFCOLSUBTYPE","");
    fieldEl.setAttribute("REFCOLFUNCTION","");
    ZDBRankingRefFilter.updateRefColDet(fieldEl);
  }

   this.showRefColFunction = function(el,event)
  {
      var view = ZDBClientUI.getViewObj(el,"view");//NO I18N
      var fieldElHeader = DOMUtils.getSelfOrParentWithAttrValue(el ,"FieldElHeader","true");//NO I18N
      var filterEl = DOMUtils.getFirstMatchingChild(ZDBAnalysisFilter.getFilterNav(view),"div","filterel", "true"); //NO I18N
      var listEl = filterEl.fieldEl.refColList;
      var jListEl = jQuery(listEl);
     
      if(jListEl.is(":visible") )
      {
         if(listEl.fieldElHeader != fieldElHeader)
        {
          ZAComboList.closeList(event,true);
          ZDBRankingRefFilter.showRefColFunction(el, event);
        }
        return;
      }
      listEl.fieldElHeader = fieldElHeader; 
      listEl.filterEl = filterEl;
      
      // to maintaing hover of fielEl header tillt he list is open
      jQuery(fieldElHeader).addClass("filterHeaderSel_hover");
      ZDBUtil.setNamedChildEls(filterEl,filterEl);
      ZDBUtil.setNamedChildEls(listEl,listEl);
//    clear the pervious search on opeing the list for next time
      ZAComboList.clearSearch(listEl);
      ZDBSearchUtil.handleBlur(jQuery(listEl).find("#ZDBSearchBox").attr("tipShown","false").get(0));//NO I18N
       jListEl.find('ul.refColUi li').show();
      ZAComboList.hideSubFuncList(listEl.refColDtSubFunc);
      var x = ZDBUtil.getObjLeft(fieldElHeader,false);
      var y = ZDBUtil.getObjTop(fieldElHeader,false)+fieldElHeader.offsetHeight;
      listEl.style.left = x+2+"px";
      listEl.style.top = y+2+"px";
      listEl.style.zIndex = "5000";
      var refColId = filterEl.fieldEl.getAttribute("REFERREDCOLUMNID");
      var refListEl = jListEl.find("li[COLID="+refColId+"]");
      ZDBRankingRefFilter.resetPrevSelectedCol(listEl.refColFunList,refListEl);       
      var jrecolUi = jQuery(listEl.refColUi);
     ZAComboList.showOnlyRequiredEls(jrecolUi,true);
      MenuUtil.slideDown(jListEl,250);
      ZDBRankingRefFilter.setRefColLstHgt(filterEl,fieldElHeader);

      ZAComboList.curList = listEl;
      ZAComboList.returnFileName = this;
      ZDBUtil.attachEvent(document,'keydown',ZAComboList.checkKeyNContinue,true);
      ZDBUtil.attachEvent(document,'click',ZAComboList.closeList,true);
      ZDBUtil.stopEventBubble(event);
//      listEl.listVisible = true;
  }    

  this.setRefColLstHgt = function(filterEl,fieldElHeader)
  {
      var refColFnLst = filterEl.fieldEl.refColFunList;
      var maxDivHgt = (ZDBClientUtil.getInnerHeight(window)- ZDBUtil.getObjTop(fieldElHeader, false))* 0.75;
      var divHgt = refColFnLst.offsetHeight;
      if(divHgt>maxDivHgt)
      {
      refColFnLst.style.height = maxDivHgt+"px";
      refColFnLst.style.overflowY = "auto";//NO I18N
      refColFnLst.style.overflowX = "hidden";//NO I18N
        var searchField = filterEl.fieldEl.refColList.textfield;
        if(searchField)
          {
            searchField.style.width = parseInt(searchField.getAttribute("maximumWdth")) - 20 + "px"; // for scroll
          }
      }
      else
      {
        refColFnLst.style.height = "";
      }
  }

 
  this.setRefColFunDet = function(refColList,event)
  {
      var srcEl = ZDBUtil.getSourceElement(event);
      var el = DOMUtils.getSelfOrParentWithAttr(srcEl, "valFunc"); //NO I18N
      if(!el || el.tagName.toString().toLowerCase() != "li")
      {
        return;
      }
      var func = el.getAttribute("valFunc");
      var isInDialogue = refColList.fieldElHeader.getAttribute("AddNewRange")=="true";
      var view = ZDBClientUI.getViewObj(refColList.fieldElHeader,"view");//NO I18N
      if(func == "" || !func){return;}
      if(isInDialogue)
      {
        
        if(func=="showmoreTables")
          {
            ZDBRankingRefFilter[func](refColList,el,event);
            return;
          }
        var filterNav = ZDBAnalysisFilter.getFilterNav(view);
        filterNav.selectedField.rangeDiv.selField = el;
        ZDBRankingRefFilter.setColNameDisp(refColList, el,isInDialogue);
      }
      else
      {
      ZDBRankingRefFilter[func](refColList,el,event);
  }
  }

  this.showmoreTables = function(refColList,el,event)
  {
	  ZRSDrillDown.showmoreTables(refColList,el,event);
  }
  
  this.setColNameDisp = function(refColList,refListEl,isInDialogue)
  {
      var fieldElHeader = refColList.fieldElHeader;
      var refColDisp = fieldElHeader.refColDisp;
      var colName = refListEl.getAttribute("listElcolname");
      var refTblId = refListEl.getAttribute("refTblId");
      if(isInDialogue)
      {
        var view = ZDBClientUI.getViewObj(fieldElHeader,"view");
        var filterNav = ZDBAnalysisFilter.getFilterNav(view);
        var subFunList = ZDBUtil.getParentWithAttributeValue(refListEl,"SubFunList", "true");//NO I18N
        var refColId =refListEl.getAttribute("colId");
        var subType = refListEl.getAttribute("subType");
        if(subFunList)
        {
          var subFunc = refListEl.getAttribute("value");
          colName = subFunList.parListEl.getAttribute("colName") + " (" +subFunc+ ") ";
          subType = refListEl.getAttribute("subType");
          refColId = subFunList.parListEl.getAttribute("colId");
        }
        filterNav.selectedField.rangeDiv.selField.setAttribute("REFERREDCOLUMNID",refColId);//refColId = refColId? refColId : "";
        filterNav.selectedField.rangeDiv.selField.setAttribute("REFERREDTBLID",refTblId);//refColId = refColId? refColId : "";
        filterNav.selectedField.rangeDiv.selField.setAttribute("subtype",subType);//subType = subType;
      }
      refColDisp.innerHTML = colName;
      refColDisp.setAttribute("value",colName);
  }

  this.checkNThrowRangeExceed = function(fieldEl,cr,refColId,rangeDiv)
  {
      var noRefCol = refColId=="" || refColId == null? true :false;
       var subType = fieldEl.getAttribute("subType");
      if(subType!="3" || noRefCol){return false;}
      var criteria = cr;
      criteria = criteria.replace(/CB/g,"");
      criteria = criteria.replace(/CT/g,"");
      var arr = criteria.split(",");
      var myArr = new Array();
      for(var i=0; i<arr.length; i++)
      {
        if(arr[i]!="")
        {
          myArr.push(parseInt(arr[i]));
        }
      }
      if(Math.max.apply( Math, arr) > 25 && !noRefCol)
      {
         if(rangeDiv)
         {
        	 var rangeDivWidth = jQuery(rangeDiv).width() + "px";//NO I18N
        	 showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.rankingLimitExceed2"), rangeDiv.rangeValue);
    	     $("customAlertMessage").style.width = rangeDivWidth;
    	     $("_CUSTOMALERTFRAME").style.width = rangeDivWidth;
         }
    	 else
    	 {
    		 ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.rankingLimitExceed"));
    	 }
        return true;
      }
      return false;
  }

  this.setColFunction = function(refColList,refListEl,event)
  {
       ZDBUtil.setNamedChildEls(refColList,refColList);
       var filterEl = refColList.filterEl;
       if(ZDBRankingRefFilter.checkNThrowRangeExceed(filterEl.fieldEl,filterEl.fieldEl.getAttribute("criteria"),refListEl.getAttribute("colId")))
       {
          ZAComboList.closeList(event);
          return;
       }
       var fieldElHeader = refColList.fieldElHeader;
       var fieldEl = filterEl.fieldEl;
       var operation = refListEl.getAttribute("operation");
       var addOnType = refListEl.getAttribute("addOnType");
       if(addOnType=='ABSDATECATEGORICAL' && refListEl.getAttribute("subType")=="0")
       {
          var li = jQuery(refColList.refColDtSubFunc).find("li[SUBTYPE="+refListEl.getAttribute("defSubType")+"]");
          ZDBRankingRefFilter.setDtSubFunction(refColList, li.get(0), event);
       }
       var subType = refListEl.getAttribute("subType");
       var colId = refListEl.getAttribute("colId");
       var refTblId = refListEl.getAttribute("refTblId");
       var colName = refListEl.getAttribute("listElcolname");
       fieldEl.setAttribute("REFERREDCOLUMNID",colId);
       fieldEl.setAttribute("REFERREDTBLID",refTblId ? refTblId : "");
       fieldEl.setAttribute("REFCOLFUNCTION",operation);
       fieldEl.setAttribute("REFCOLADDONTYPE",addOnType);
       fieldEl.setAttribute("REFCOLSUBTYPE",subType);
       fieldEl.setAttribute("DISPCOLNAME",colName);
       ZDBRankingRefFilter.updateRefColDet(fieldEl);
       
       ZDBRankingRefFilter.resetPrevSelectedCol(refColList,refListEl);       
       ZDBRankingRefFilter.chngSelectedValRef(fieldElHeader,filterEl,refListEl.getAttribute("value"));
       var view = ZDBClientUI.getViewObj(filterEl,"view");
       ZDBAnalysisView.setModAndShowRefresh(view);
  }
  
  // unselect prev selected and selected the required value
  this.resetPrevSelectedCol = function(refColList,refListEl)
  {
      var jRefColLst = jQuery(refColList);
      var jRefLstEl = jQuery(refListEl);
      var prevSelected = jRefColLst.find(".RefFilterListSelected");
      if(prevSelected.attr("COLID")==jRefLstEl.attr("COLID"))
      {
         return;
      }
      prevSelected.removeClass().addClass("RefFilterList");
      jRefLstEl.removeClass().addClass("RefFilterListSelected");
      var prevDtCol = prevSelected.filter("[ADDONTYPE='ABSDATECATEGORICAL']");//NO I18N
      if(prevDtCol.length >0 && jRefLstEl.get(0) != prevDtCol.get(0))
      {
         var defsubType = prevSelected.attr('defSubType');//NO I18N
         prevDtCol.attr('SUBTYPE',"0");//NO I18N
         ZAComboList.updateDtColName(null, prevDtCol.get(0));
      }   
      var isBaseTbl = jRefColLst.find("li[expand='true']").attr("baseTable")=="true" ? "true" : "false";//NO I18N
      jRefColLst.find("li[expand='true']").removeAttr("expand").attr("displayByDefault", isBaseTbl);//NO I18N
      jRefLstEl.parents("[tableLi='true']").attr("expand", "true").attr("displayByDefault", "true");//NO I18N
  }
  // update dt subfunction
  this.setDtSubFunction = function(refColList,subFunEl,event)
  {
     ZDBUtil.setNamedChildEls(refColList,refColList);
     var filterEl = refColList.filterEl;
     var subFunList = ZDBUtil.getParentWithAttributeValue(subFunEl,"SubFunList", "true");//NO I18N
     if(ZDBRankingRefFilter.checkNThrowRangeExceed(filterEl.fieldEl,filterEl.fieldEl.getAttribute("criteria"),subFunList.parListEl.getAttribute("colId")))
     {
        ZAComboList.closeList(event);
        return;
     }
      var subType = subFunEl.getAttribute("SUBTYPE");
      subFunList.parListEl.setAttribute("SUBTYPE",subType);
      ZAComboList.updateDtColName(subFunEl,subFunList.parListEl);
      
      var func = subFunList.parListEl.getAttribute("valFunc");
      ZDBRankingRefFilter[func](refColList,subFunList.parListEl,event);
      ZAComboList.hideSubFuncList(subFunEl);
      var view = ZDBClientUI.getViewObj(filterEl,"view");
      ZDBAnalysisView.setModAndShowRefresh(view);
  }
  
 

  this.chngSelectedValRef = function(fieldElHeader,filterEl,colName)
  {
     
      var selField = DOMUtils.getFirstMatchingChild(fieldElHeader,"div","refelname","selField"); //NO I18N
      if(!fieldElHeader.selField)
      {
        return;
      }
      var cloneSelFields = DOMUtils.getChildElsWithAttr(filterEl.selItemHolder,"filtervalue",selField.getAttribute("filtervalue")); //NO I18N
      for(var i=0;i<cloneSelFields.length;i++)
      {
        var cloneSelField = cloneSelFields[i];
        var filterName = cloneSelField.getAttribute("displayfiltervalue")
        var refCol = " by "+ ZDBEscapeUtil.encodeForHtml(colName);//NO I18N
        if(colName.toString().toUpperCase() == "NONE")
        {
          refCol = "";
        }
          var aEl = document.createElement("a");
          aEl.className = "RefColDiv";
          var styles = {display : "inline",paddingLeft: "2px"};// NO I18N
          jQuery(aEl).css(styles);
          aEl.value = refCol;
          aEl.innerHTML = refCol;
          filterName+=aEl.value;
          var prevEls = jQuery(cloneSelField).children('a'); //NO I18N
        if(prevEls.length>0)
        {
          prevEls.replaceWith(aEl);
        }
        else
        {
          cloneSelField.appendChild(aEl);//.slice(0,20);
        }
//        }
        cloneSelField.setAttribute("value",filterName);
      }
   }
   
  
  
  
  
  
}
