//$Id$
var ZRFormulaColumn = new function()
{
  this.showAggFormulaDlg = function(el,isEdit)
  {
    var view = ZDBClientUI.getViewObj(el,"view");
    var menu = DOMUtils.getParentWithAttr(el,"filtermenu");
    if(menu)
    {
      var field = menu.fieldDiv;
      el = field;
    }
    var dlg = ZDBUtil.getCachedRef(ZDBDerivedField,"ZDBDERIVEDFIELDDIALOG");
    dlg.gridObj = null;
    dlg.fromReport = true;
    dlg.resetDType = false;
    var title = ZDBI18NMap.g('zrpt.common.formula.js.addaggformula',dlg);
    var okBtn = jQuery(dlg).find("#ZDBDerivedFieldDlgOkBtn");
    ZDBDialogUtil.showDialog(dlg, {TITLE: title, ADDFRAME: true, MODAL: true, SHADOW: true,ACTIONBUTTONS:okBtn});
    dlg.isAggregate = true;
    ZRFormulaColumn.showInsertFieldsMenu(view,el);
    dlg.view = view;
    var formulaEl = $("ZDBExprEditorFormula");
    $('ZRFieldNameLbl').innerHTML = ZDBI18NMap.g('zrpt.add.customformula.js.formulaname')+':'; //No I18N
    var fieldDescLblEl = $('ZRFieldDescLbl');
    fieldDescLblEl.innerHTML = ZDBI18NMap.g('zrpt.add.customformula.js.formuladesc');
    $('ZDBDERVOPTSTATUS').className = 'mcLoaded';
    var colName = '';
    var formula = '';
    var colId = null;
    var desc = '';
    var dataTypeNo = null;
    var tblNameSelectEl = $("ZRTableNameList");
    var index = null;
    dlg.colId = el.getAttribute("column_id");
    dlg.parentObjId = el.getAttribute("parent_obj_id");
    if(isEdit)
    {
      colName = el.getAttribute("displayname");
      formula = el.getAttribute("formula");
      colId = el.getAttribute("column_id");
      desc = el.getAttribute("description");
      var dataType = el.getAttribute("origdatatype");
      dataTypeNo = ZDBUtil.getDataTypeNo(dataType) + '';
      var parentViewId = el.getAttribute("parent_obj_id");
      index = getDataIndex(tblNameSelectEl,'value',parentViewId);
      tblNameSelectEl[index].selected = true;
      formulaEl.focus();
    }
    var funcTypeEl = $('ZDBFunctionType');
    var funcTypeElAgg = $('ZDBFunctionTypeAgg');
    funcTypeEl.style.display = "none";
    funcTypeElAgg.style.display = "";
    ZDBUtil.setValueInSelectBox(funcTypeElAgg, 'value', 'Aggregate'); //No I18N
    ZDBDerivedField.showInsertFnMenuItems(funcTypeElAgg);
    ZDBDerivedField.highLight("#ZRSFunctionsList","trHighLight"); //No I18N
    
    var colNameEl = $("ZDBExprEditorFieldName");
    var fieldDescEl = $("ZDBExprEditorFieldDesc");
    colNameEl.value = colName;
    formulaEl.value = formula;
    formulaEl.colId = colId;
    if(ZDBGlobal.haveFormulaSuggestionFeature){
    	//To initialise the codemirror area and retrieve data about functions
	    if(!ZDBSuggestionHelper.editor){
	    	ZDBSuggestionHelper.initCodemirror(formulaEl);
	    }else{
	    	ZDBSuggestionHelper.editor.setValue(formula);
	    	ZDBSuggestionHelper.editor.setCursor(ZDBSuggestionHelper.editor.posFromIndex(formulaEl.value.length));
	    	if(formulaEl.value){
	    		ZDBSuggestionHelper.editor.showHint();
	    	}
	    }
	    ZDBSuggestionHelper.editor.setOption('isAggregate',true); //No I18N
	    ZDBSuggestionHelper.setFunctions();
    }
    if(ZDBGlobal.haveFormulaSuggestionFeature) ZDBSuggestionHelper.startLinting();
    fieldDescEl.value = (desc) ? desc : "";
    if(desc && desc != "")
    {
    	ZDBUtil.setAttribute($("ZRFieldDescCont"), "false", "shown");
    	ZDBDerivedField.showHideFormulaDesc(fieldDescLblEl,false);
    }
    else
    {
    	ZDBUtil.setAttribute($("ZRFieldDescCont"), "true", "shown");
    	ZDBDerivedField.showHideFormulaDesc(fieldDescLblEl,false);
    }
    index = tblNameSelectEl.selectedIndex;
    var optEl = tblNameSelectEl[index];
    ZDBDerivedField.setValNShowEls(true,[optEl.text,optEl.value],dataTypeNo);
    dlg.origFormulaName = colName.trim();
    dlg.origFormula = formula.trim();
    dlg.origDataTypeNo = dataTypeNo;
    ZRFormulaColumn.showColumnListForTable();
    
    var dataTypeEl = $("ZDBDataTypeSelect_formula");
    dataTypeEl.onchange = ZRFormulaColumn.resetColFormatsOnDTChange;
  }

  this.handleSaveNShowForColDlg = function(clickType,requestOptions)
  {
    if(clickType == "YES")
    {
      requestOptions["HANDLESAVE"] = ZDBClientUI.invokeAfterOption;
      requestOptions["VIEW"].save(requestOptions);
    }
  }

  this.successFunc = function(response, requestOptions)
  {
	var resp = JSON.parse(response.responseText);
    ZRFormulaColumn.designModTime=resp.MODTIME;
    var viewColList = resp.FORMULA_ARRAY;
    var view = requestOptions["VIEW"];
    view.viewColList = viewColList;
    var el = requestOptions["EL"];
    ZRFormulaColumn.showFormulaDlg(el,view);
  }

  this.showInsertFieldsMenu = function(view,el)
  {
	if(ZDBGlobal.haveFormulaSuggestionFeature){ZDBSuggestionHelper.columns = new Array();}
    var formulaEl = document.getElementById("ZDBExprEditorFormula");
    formulaEl.origDispColName = el.getAttribute("displayname");
    var colListElBody = document.getElementById("ZDBDERVFLD_EDITOR_BODY");
    ZDBUtil.removeAllChildren(colListElBody);
    var tableNameSelect = $("ZRTableNameList");
    ZDBUtil.removeAllChildren(tableNameSelect);
    var fieldHolder = view.analysisFieldHolder;
    var fieldList = fieldHolder.getElementsByTagName("DIV");
    var tblName=null;
    var relTables = view.fieldsController.model.relTables.slice();
    var jsonData = ZDBAnalysisCaching.tblColInfo.data;
    for(var relModelId in ZDBAnalysisCaching.tblColInfo.relModelInfo)
	{
		if(jsonData[relModelId].tableDet[view.parentViewId])
		{
			break;
		}
	}
    jsonData = jsonData[relModelId];
    for(var i=0,len=relTables.length;i<len;i++)
    {
        var option = document.createElement("option");
        var tableDet = jsonData.tableDet[relTables[i]];
        tblName = tableDet.displayName;
        var tblId = tableDet.objId;
        option.setAttribute("value",tblId);
        option.innerHTML = ZDBEscapeUtil.encodeForHtml(tblName);
        this.addColumnFieldsRow(colListElBody, formulaEl, relTables[i], jsonData, view.parentViewId);
        tableNameSelect.appendChild(option);
        continue;
    }
    $('ZRTableListRow').style.display = '';
  }
  
  this.addColumnFieldsRow = function(colListElBody, formulaEl, tblId, jsonData, parViewId)
  {
  	var colDet = jsonData.colDet[tblId];
  	var tblName = jsonData.tableDet[tblId].displayName;
  	for(var key in colDet)
  	{
  		var cols = colDet[key];
  		var colName = cols.DISP_NAME;
  		var type = cols.ORIG_DATATYPE;
  		var isAggregate = false;
  		if(cols.DB_FIELD_NAME == ZDBConst.DYNAMIC_COL_NAME)
  		{
  			isAggregate = true;
  		}
  		ZDBDerivedField.addFieldRow(colListElBody, colName, formulaEl, type,parViewId, tblId,isAggregate,tblName);
  	}
  }

  this.showColumnListForTable = function()
  {
    var tableNameSelectEl = $('ZRTableNameList');
    var value = tableNameSelectEl.value;
    var index = tableNameSelectEl.selectedIndex;
    if(ZDBClientUI.selectedTab.view instanceof ZDBAnalysisView)
		{
			$('ZDBFTblName').innerHTML = ZDBEscapeUtil.encodeForHtml(tableNameSelectEl[index].text);
		}
    var colList = jQuery("#ZDBDERVFLD_EDITOR_BODY"); //No I18N
    colList.children().hide();
    colList.children("[parobjid ="+value+"]").show(); //No I18N 
  }

  this.submitAggregateFormula = function()
  {
    var columnName = ($("ZDBExprEditorFieldName").value).trim();
    var columnDesc = ($("ZDBExprEditorFieldDesc").value).trim();
    var dlg = ZDBUtil.getCachedRef(ZDBDerivedField,"ZDBDERIVEDFIELDDIALOG");
    var view = dlg.view;
    var els = DOMUtils.getChildElsWithAttr(dlg,"id","*"); //No I18N
    if(!validateFormElements(els,dlg))
    {
      ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored, true);
      return;
    }
    var formulaEl =  ZDBUtil.getCachedRef(ZDBDerivedField,"ZDBExprEditorFormula");
    var colId = formulaEl.colId;
    var formula = formulaEl.value.trim();
    var dataTypeNo = $('ZDBDataTypeSelect_formula').value;
    if(dlg.origFormulaName == columnName && dlg.origFormula == formula && dlg.origDataTypeNo == dataTypeNo 
    		&& dlg.origFormulaDesc == columnDesc && !dlg.formatApplied)
    {
      ZDBDialogUtil.closeDialog();
      return;
    }
    var parentViewId = $('ZRTableNameList').value;
    parentViewId = (parentViewId == null || parentViewId == "") ? view.parentViewId :parentViewId ;
    var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?"; //No I18N
    var params = "&ZDBACTION=FORMULACOLUMN&ISAGGREGATE=true&FIELDNAME=" + encodeURIComponent(columnName) +  //No I18N
                 "&EXPR=" + encodeURIComponent(formula) + "&PARENTVIEWID=" + parentViewId; //No I18N
    params += '&DATATYPE=' + dataTypeNo; //No I18N
    params += (columnDesc != '') ? ("&DESCRIPTION=" + columnDesc) : "";	//No I18N
    if(dlg.formatApplied)
    {
      params += ZDBSheetFormat.constructFormatOptsAsParams(dlg.formatColDet);
    }
    if(colId != null)
    {
      params += "&COLID=" + colId; //No I18N
    }
    var xml = ZDBAnalysisConfig.getConfig(view,true);
    AjaxAPI.sendRequest({URL:url+params,
                         REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                         POSTBODY:xml,PAREL:formulaEl,
                         VIEW:view,
                         PARENTVIEWID:parentViewId,
                         REFRESHVIEW:true,
                         ONSUCCESSFUNC:ZRFormulaColumn.updateFieldsList,
                         ONFAILUREFUNC:ZRFormulaColumn.handleFailure,
                         OPSTATUSID:"ZRFormulaColumnStatus"}); //No I18N
  }
  
  
  

  this.saveAggFormulaInChildTable=function(clickType, requestOptions)
  {
       if(clickType == "NO")
        {
            return;
        }
    
        var url = requestOptions["URL"]; 
        var postBody= requestOptions["POSTBODY"]; 
        var parel=requestOptions["PAREL"]; 
        var view=requestOptions["VIEW"]; 
        var parentViewId=requestOptions["PARENTVIEWID"]; 
        var extraParams ="&ASSOCCHILD="+"true"; //No I18N
        url+=extraParams;
        AjaxAPI.sendRequest({URL:url,
                         REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                         POSTBODY:postBody,
                         PAREL:parel,
                         VIEW:view,
                         PARENTVIEWID:parentViewId,
                         ONSUCCESSFUNC:ZRFormulaColumn.updateFieldsList,
                         ONFAILUREFUNC:ZRFormulaColumn.handleFailure,
                         OPSTATUSID:"ZRFormulaColumnStatus"}); //No I18N
  }

  this.updateFieldsList = function(response,requestOptions)
  {
    ZDBDialogUtil.closeDialog();
    var needRefresh = requestOptions["REFRESHVIEW"];//No I18N
    var view = requestOptions["VIEW"];//No I18N
    if(needRefresh!=undefined && needRefresh)
        {
            view.refreshView();
        }
    ZDBAnalysisView.sendTblColInfoReq(null, view);
  }

  this.handleFailure = function(response, requestOptions)
  {
    var formulaEl = requestOptions["PAREL"];
    var errCode = response.getResponsePart("ERRORCODE");
    errCode = trimAll(errCode);
    if(errCode == "DERIVED_FIELD_INVALID_FORMULA")
    {
        ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored, true);
        showCustomMessage(response.getResponsePart("STATUS_MESSAGE"),formulaEl,null);
        formulaEl.focus();
        return;
    }
      else if(errCode=="ZR_FORMULA_ASSC_CHILD_ERROR")
      {
        var url = requestOptions["URL"]; 
        var postBody= requestOptions["POSTBODY"]; 
        var parel=requestOptions["PAREL"]; 
        var view=requestOptions["VIEW"]; 
        var parentViewId=requestOptions["PARENTVIEWID"]; 
        ZDBAlertAPI.showMsg(ZDBEscapeUtil.decodeForHtml(response.getResponsePart("STATUS_MESSAGE")),"ZDBYESNO",{ONCLICK:ZRFormulaColumn.saveAggFormulaInChildTable,URL:url,POSTBODY:postBody,PAREL:parel,VIEW:view,PARENTVIEWID:parentViewId}); // No I18N
         return;
      }
    ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored,true);
    AjaxAPI.onFailureFunc(response, requestOptions);
  }

  this.getColumnInfo = function(view)
  {
    if(view.columnInfo != null)
    {
      return view.columnInfo;
    }
    var colInfo = new Array();
    var fieldsList = $("ZDBFieldsIterationTable").getElementsByTagName("div");
    for(var i=0,j=0; i<fieldsList.length; i++)
    {
        if(fieldsList[i].getAttribute("COLUMN_ID"))
        {
          var field = fieldsList[i];
          var displayName = field.getAttribute("displayName");
          var type = field.getAttribute("DTYPE")
          colInfo[j] = [displayName,type];
          j++;
        }
    }
    view.columnInfo = colInfo;
    return view.columnInfo;
  }

  
 this.showSearchByOpts=function(el,event)
{
            var menu = ZDBContentCache.appendAndGet("Formula_SearchBy_Menu","GridMenu",document.body);
            ZRSMenu.showMenu(event,el,menu,5);
}

this.formulaClearSearch=function(el,event)
{
        jQuery(el).hide();
        jQuery(el).siblings("#ZRSFormulaSearchBox").val("").focus(); //No I18N
        var searchInType=ZRFormulaColumn.searchVal[1];
        var listToBeSearched=(searchInType!="AllFormula")?jQuery("#ZRFormulaList li[formulatype='"+searchInType+"']"):jQuery("#ZRFormulaList li"); //No I18N
        listToBeSearched.show();
        ZDBUtil.stopEventBubble(event);
        ZRSMenu.closeAllMenu();
}

this.searchViewsList=function(el,index,type,event)
{
        ZRFormulaColumn.searchVal[index]=type;
        var menuEl=jQuery(el).parents("#ZRSFormulaSearchMenu"); //No I18N
        menuEl.find("span").removeClass("sortTickMenu");    //No I18N  
        menuEl.find("#Search"+ZRFormulaColumn.searchVal[0]).addClass("sortTickMenu");   //No I18N
        menuEl.find("#Search"+ZRFormulaColumn.searchVal[1]).addClass("sortTickMenu");   //No I18N
        ZDBUtil.stopEventBubble(event);
        ZRFormulaColumn.searchFormula(jQuery("#ZRSFormulaSearchBox").get(0)); //No I18N
}
  
  this.searchFormula=function(el)
  {
    var allFormulaList=jQuery("#ZRFormulaList li"); //No I18N
    allFormulaList.hide();
    var value = el.value;
    var searchInField=ZRFormulaColumn.searchVal[0];
    var searchInType=ZRFormulaColumn.searchVal[1];
    if((value === "") || (value==="Search")) //No I18N
    {
        value = null;
        var listToBeSearched=(searchInType!="AllFormula")?jQuery("#ZRFormulaList li[formulatype='"+searchInType+"']"):allFormulaList; //No I18N
        listToBeSearched.show();
        jQuery(el).siblings("#FormulaSearchClear").hide(); //No I18N
    }
    if(value)
    {
        jQuery(el).siblings("#FormulaSearchClear").show(); //No I18N
        value = value.toLowerCase();
        var listToBeSearched=(searchInType!="AllFormula")?jQuery("#ZRFormulaList li[formulatype='"+searchInType+"']"):allFormulaList; //No I18N
        listToBeSearched.each(function(){
              var elem=jQuery(this);
              var show=(searchInField!="AllFields")?((elem.attr(searchInField)).toLowerCase().indexOf(value)!==-1):((elem.attr("formulaName").toLowerCase().indexOf(value)!==-1) || (elem.attr("formula").toLowerCase().indexOf(value)!==-1)); //No I18N
              if(show)
              {
                   elem.show();
              }
              else
              {
                   elem.hide();
              }
      });
    }
  }

  this.showEditFormulasDlg = function(el)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object'); //No I18N
    if(!ZDBClientUI.checkAskSave(gridObj, ZDBI18NMap.g("zrpt.common.js.addingFormCol"),ZRFormulaColumn))
    {
      return false;
    }
    var objId = gridObj.objId;
    var url = ZDBGlobal.CTX +'/ZDBDatabaseActionMI.ma?ZDBACTION=GETFORMULADETAILS&CHECKEMPTY=true&OBJID='+ objId +"&NOCACHE="+new Date().getTime(); //No I18N
    AjaxAPI.sendRequest({URL:url,METHOD:'GET',
                         REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                         GRIDOBJ:gridObj,
                         ONSUCCESSFUNC:ZRFormulaColumn.showEditForDlg,
                         OPSTATUSID:'ZDBMainLoader'}); //No I18N
  }

  this.updateEditFormulaDlg = function(response,requestOptions)
  {
    ZRFormulaColumn.searchVal=["AllFields","AllFormula"]; //No I18N
    var gridObj =  requestOptions["GRIDOBJ"];
    var resp = JSON.parse(response.responseText);
    var dropCache = requestOptions["DROPCACHE"];
    if(resp.refErrors)
	{
    	gridObj.setRefErrors(resp.refErrors);
    	return;
	}
    ZRFormulaColumn.designModTime=resp.MODTIME;
    var arrayList = resp.FORMULA_ARRAY;
    var ul = $('ZRFormulaList');
    var len = arrayList.length;
    if(len == undefined)
    { //For delete column dependency errors are throws in the success function. so the response is an error message instead of an array.
      return;
    }
    ZDBUtil.removeAllChildren(ul);
    var listToClone = $('ZRFRow');
    var aggClassName = "aggIcon aggIconMargin"; //No I18N
    for(var i = 0; i < len; i++)
    {
      var row = arrayList[i];
      var list = listToClone.cloneNode(true);
      list.removeAttribute('id');
      var colDet = new ZRFormulaColDet(row);
      list.colDet = colDet;
      ZDBUtil.setNamedChildEls(list,list);
      list.FColName.innerHTML = ZDBEscapeUtil.encodeForHtml(colDet.displayName);
      list.FColName.setAttribute('value',colDet.displayName);
      list.FColName.setAttribute('tip',colDet.displayName);
      if(colDet.description){list.FColName.setAttribute('tipdesc',colDet.description);}
      list.FColDType.className += " " + ZDBDerivedField.classchange(colDet.type);
      list.FColAggIcon.className = (colDet.colName == ZDBConst.DYNAMIC_COL_NAME) ? aggClassName : '';
      list.Formula.innerHTML = ZDBEscapeUtil.encodeForHtml(colDet.formula);
      list.Formula.setAttribute('value',colDet.formula);
      if(colDet.formula.length<500){
    	  list.Formula.setAttribute('tip',colDet.formula);
      }
      else{
    	  list.Formula.removeAttribute("onmousemove");
		  list.Formula.removeAttribute("onmouseout");
    	  
    	  
      }
      list.FType.innerHTML = colDet.formulaType;
      jQuery(list).attr({'formulaName':colDet.displayName,'formula':colDet.formula,'formulaType':colDet.formulaType}); //No I18N
      ul.appendChild(list);
    }
    var editFormulaDlg = $('ZDBEditFormula');
    editFormulaDlg.refreshGrid = true;
    gridObj.designModTime = ZRFormulaColumn.designModTime;
    editFormulaDlg.gridObj = gridObj;
    if(dropCache)
	{
    	var objId = gridObj.objId;
    	ZDBClientUtil.deleteJsonForObjId(objId);
	}
  }

  this.showEditForDlg = function(response,requestOptions)
  {
    ZRFormulaColumn.updateEditFormulaDlg(response,requestOptions);
    var editFormulaDlg = $('ZDBEditFormula');
    editFormulaDlg.refreshGrid = false;
    ZDBDialogUtil.showDialog(editFormulaDlg,{TITLE:ZDBI18NMap.g("zrpt.common.editformulas.js.dlgTtl"),DESC:ZDBI18NMap.g("zrpt.common.editformulas.js.dlgDesc"),
    																ADDFRAME:true,MODAL:true, SHADOW:true,DONTREMOVE:true,ONCLOSE:ZRFormulaColumn.closeEditFormulasDlg});
    jQuery("#ZRSFormulaSearchBox").val("").blur(); //No I18N
    jQuery("#FormulaSearchClear").hide();//No I18N
  }

  this.closeEditFormulasDlg = function(closeDialog)
  {
    if(closeDialog === true)
    {
      jQuery("#ZRSFormulaSearchMenu").find("span").removeClass("sortTickMenu"); //No I18N
      jQuery("#SearchAllFormula").addClass("sortTickMenu"); //No I18N
      jQuery("#SearchAllFields").addClass("sortTickMenu"); //No I18N
      ZDBDialogUtil.closeDialog();
    }
    var editFormulaDlg = $('ZDBEditFormula');
    if(editFormulaDlg.refreshGrid)
    {
      var gridObj = editFormulaDlg.gridObj;
      if(gridObj.type == "TableDesign")
      {
    	var dlg = ZDBClientUI.selectedTab.focusedDialog;
        dlg.gridObj = gridObj;
        dlg.viewCtx = gridObj.viewCtx;
        ZDBDesignGrid.refreshDesign();
        return true;
      }
      ZDBClientUI.fetchView(gridObj.objId,gridObj.dbId,gridObj.displayName,"Table",ZDBClientUI.selectedTab); //No I18N
    }
    return true;
  }

  this.updateEditForDlg = function(response,requestOptions)
  {
    ZDBDialogUtil.closeDialog();
    ZRFormulaColumn.updateEditFormulaDlg(response,requestOptions);
  }

  this.showEditFormulaDlg = function(el)
  {
	if(ZDBGlobal.haveFormulaSuggestionFeature){
	  if(!ZDBLazyLoadUtil.loadJsAlone(["ZRQueryEditor", "ZDBFormulaSuggestion"],"APPENDTODOC",ZRFormulaColumn.showEditFormulaDlg,[el])) //NO I18N
	    {
	  	  return;
	    }
	    if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_QUERYEDITOR","CSSLIST_FORMULASUGGESTION"],"APPENDTODOC",ZRFormulaColumn.showEditFormulaDlg,[el])){ //NO I18N
	  	  return;
	    }
	}
    if(!ZDBLazyLoadUtil.loadSnippet('ZDBDERIVEDFIELDDLG','/ZDBDerivedField.cc',this,'APPENDTODOC',['ZDBFormulaSuggestion'],ZRFormulaColumn.showEditFormulaDlg,[el]))
    {
      return;
    }
    
    ZDBDerivedField.getParentTableColInfo(el,null,ZRFormulaColumn.callBShowEditFormulaDlg);
    
  }

  this.callBShowEditFormulaDlg = function(response,requestOptions)
  {
    ZDBDerivedField.setRelatedTableColInfo(response);
    var el = requestOptions["EL"];
    ZRFormulaColumn.showEditFormulaDialog(el);
  }

  this.showEditFormulaDialog = function(el)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object');
    var listEl = ZDBUtil.getParentWithTagName(el,'li'); //No I18N
    var colDet = listEl.colDet;
    var isAggregate = (colDet.colName == ZDBConst.DYNAMIC_COL_NAME);
    ZDBDerivedField.showDerivedFieldUI(gridObj,colDet.displayName,colDet.description,colDet.formula,colDet.colId,isAggregate,listEl);
  }

  this.showFormatDlg = function(el,fromFormulaCol)
  {
    if(!ZDBLazyLoadUtil.loadSnippet('FORMAT_COLUMN_DLG','/ZDBFormatColumn.cc',this,'APPENDTODOC',['format/js/ZDBSheetFormatExtn.js'],ZRFormulaColumn.showFormatDlg,[el,fromFormulaCol]))
    {
      return;
    }
    var gridObj = ZDBUtil.getPropertyFromEl(el,'gridObj','object');
    if(fromFormulaCol)
    {
      var aggFormulaDlg = ZDBUtil.getCachedRef(ZDBDerivedField,"ZDBDERIVEDFIELDDIALOG");
      if(aggFormulaDlg.fromReport)
      {
    	  this.showFormatDlgFromEditView(el,true);
    	  return;
      }
      var dtTypeEl = $("ZDBDataTypeSelect_formula");
      var dataType = dtTypeEl[dtTypeEl.selectedIndex].value;
      var colDet = (aggFormulaDlg.formatColDet) ? aggFormulaDlg.formatColDet : new ZDBFormatColHeader(dataType);
    }
    else
    {
      var listEl = ZDBUtil.getParentWithTagName(el,'li'); //No I18N
      var colDet = listEl.colDet;
    }
    ZDBSheetFormatExtn.dataType = colDet.typeNo;
    var dlgFrom = (fromFormulaCol) ? ZDBEditColumnFormat.EDIT_FROM_FORMULA : ZDBEditColumnFormat.EDIT_FROM_TABLE;
    var editFrmtColOpts = new ZDBEditColumnFormat(gridObj.objId,dlgFrom,null);
    ZDBSheetFormatExtn.editFrmtColOpts = editFrmtColOpts;
    ZDBSheetFormatExtn.showFormatDlg(gridObj,colDet,listEl,editFrmtColOpts,el);
    ZDBSheetFormatExtn.enableDisableColumnFormatOpts(ZDBSheetFormatExtn.dataType,gridObj.type);
    ZDBSheetFormatExtn.setValuesInFormatDlg(gridObj,colDet,listEl,editFrmtColOpts,el);
    ZDBSheetFormatExtn.hideTabs();
    ZDBDialogUtil.closeDialog();
    ZDBSheetFormatExtn.showFormatDlg(gridObj,colDet,listEl,editFrmtColOpts,el);
  }
  
  this.resetColFormatsOnDTChange = function(el)
  {
	var aggFormulaDlg = ZDBUtil.getCachedRef(ZDBDerivedField,"ZDBDERIVEDFIELDDIALOG");
	var dataTypeEl = $("ZDBDataTypeSelect_formula");
	var dataType = dataTypeEl[dataTypeEl.selectedIndex].value;
	var defFormatColDet = new ZDBFormatColHeader(dataType);
	aggFormulaDlg.formatColDet = defFormatColDet;
	aggFormulaDlg.resetDType = true;
  }

  this.deleteFormulaColumn = function(el)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(el,'gridObj','object');
    var parEl = ZDBUtil.getParentWithTagName(el,'li'); //No I18N
    var colDet = parEl.colDet;
    var colName = colDet.displayName;
    var msg = ZDBI18NMap.f("zrpt.common.toolbar.table.zdbalertmsg.js.delFormulaConfirm",ZDBEscapeUtil.encodeForHtml(colName));
    var onClickFn = (colDet.colName == ZDBConst.DYNAMIC_COL_NAME) ? ZRFormulaColumn.deleteAggFormula : ZRFormulaColumn.deleteCustomFormula;
    ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK:onClickFn,GRIDOBJ:gridObj,EL:el,COLDET:colDet,SKIPFC:false}); //No I18N
  }

  this.deleteCustomFormula = function(clickType, requestOptions)
  {
    if(clickType == "NO")
    {
      return;
    }
    var gridObj= requestOptions["GRIDOBJ"];
    var el = requestOptions["EL"];
    var skipFC = requestOptions["SKIPFC"];
    var colDet = requestOptions["COLDET"];
    var selectedCols = [colDet];
    var xmlData = ZDBMetaDataChange.genXMLForSelectedCols(selectedCols,"deleteCols"); //No I18N
    var dropCache = true;
    var url = CommAPI.DESIGNURL + "&SKIPFILTERCRITERIACHECK=" + skipFC + gridObj.getGridDetailsAsParams() + "&FORMULADETAILS="; // No I18N
    var loadDiv = gridObj.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.toolbar.js.delCols")); //No I18N
    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                       OPSTATUSID:loadDiv, ONSUCCESSFUNC:ZRFormulaColumn.updateEditFormulaDlg,
                       ONFAILUREFUNC:ZRFormulaColumn.deleteFormulaFailure,
                       VIEWCTX:gridObj.viewCtx,EL:el,GRIDOBJ:gridObj, DROPCACHE: dropCache};
    AjaxAPI.sendRequest(ajaxOptions);
  }

  this.deleteAggFormula = function(clickType, requestOptions)
  {
    if(clickType == "NO")
    {
      return;
    }
    var gridObj= requestOptions["GRIDOBJ"];
    var colDet = requestOptions["COLDET"];
    var dropCache = true;
    var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?"; //No I18N
    var params = "&ZDBACTION=DELETEAGGFORMULA&OBJID=" + gridObj.objId + "&FORMULAID=" + colDet.colId; //No I18N
    var loadDiv = gridObj.viewCtx.getLoadIndicator(ZDBI18NMap.g("zrpt.common.toolbar.js.delCols")); //No I18N
    AjaxAPI.sendRequest({URL:url,
                         PARAMETERS:params,
                         ONSUCCESSFUNC:ZRFormulaColumn.updateEditFormulaDlg,
                         ONFAILUREFUNC:ZRFormulaColumn.deleteFormulaFailure,
                         OPSTATUSID:loadDiv,GRIDOBJ:gridObj, DROPCACHE: dropCache}); //No I18N
  }

  this.handleSuccessFromReportView = function(response,requestOptions)
  {
    ZDBDialogUtil.closeDialog();
    var view = requestOptions["VIEW"];
    view.refreshView();
  }


  this.showFormatDlgFromEditView = function(el,fromEditDlg)
  {
    if(!ZDBLazyLoadUtil.loadSnippet('FORMAT_COLUMN_DLG','/ZDBFormatColumn.cc',this,'APPENDTODOC',['format/js/ZDBSheetFormatExtn.js'],ZRFormulaColumn.showFormatDlgFromEditView,[el,fromEditDlg]))
    {
      return;
    }
    var view = ZDBClientUI.getViewObj(el,"view");
    var menu = DOMUtils.getParentWithAttr(el,"filtermenu");
    if(menu)
    {
      var field = menu.fieldDiv;
      el = field;
    }
    if(fromEditDlg)
    {
    	var dlg = ZDBUtil.getCachedRef(ZDBDerivedField,"ZDBDERIVEDFIELDDIALOG");
    	var parentViewId = dlg.parentObjId;
        var colId = dlg.colId;
        var resetDType = dlg.resetDType;
    }
    else
    {
    	var parentViewId = el.getAttribute("parent_obj_id");
        var colId = el.getAttribute("column_id");
    }
    if(parentViewId && colId && !resetDType)
    {
    	var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?"; //No I18N
        var params = "&ZDBACTION=GETCOLDETAILS&OBJID=" + parentViewId + "&FORMULAID=" + colId; //No I18N
        AjaxAPI.sendRequest({URL:url,
                             PARAMETERS:params,
                             METHOD:"GET",//No I18N
                             ONSUCCESSFUNC:ZRFormulaColumn.showChangeFormatDlg,
                             OPSTATUSID:loadDiv,VIEW:view,PARENTVIEWID:parentViewId}); //No I18N	
    }
    else
    {
    	var dataTypeEl = $("ZDBDataTypeSelect_formula");
    	var dataType = dataTypeEl[dataTypeEl.selectedIndex].value;
    	var colHead = new ZDBFormatColHeader(dataType);
    	ZDBSheetFormatExtn.dataType = colHead.typeNo;
        var editFrmtColOpts = new ZDBEditColumnFormat(null,ZDBEditColumnFormat.EDIT_FROM_REPORTS,view);
        ZDBSheetFormatExtn.editFrmtColOpts = editFrmtColOpts;
        ZDBSheetFormatExtn.showFormatDlg(null,colHead,null,editFrmtColOpts);
        ZDBSheetFormatExtn.enableDisableColumnFormatOpts(ZDBSheetFormatExtn.dataType);
        ZDBSheetFormatExtn.setValuesInFormatDlg(null,colHead,null,editFrmtColOpts);
        ZDBSheetFormatExtn.hideTabs();
    }
    
  }


 this.showChangeFormatDlg =   function(response,requestOptions)
 {
    var resp = JSON.parse(response.responseText);
    var colHead = new ZRFormulaColDet(resp[0]);
    var view = requestOptions["VIEW"];
    var parViewId = requestOptions["PARENTVIEWID"];
    ZDBSheetFormatExtn.dataType = colHead.typeNo;
    var editFrmtColOpts = new ZDBEditColumnFormat(parViewId,ZDBEditColumnFormat.EDIT_FROM_REPORTS,view);
    ZDBSheetFormatExtn.editFrmtColOpts = editFrmtColOpts;
    ZDBSheetFormatExtn.showFormatDlg(null,colHead,null,editFrmtColOpts);
    ZDBSheetFormatExtn.enableDisableColumnFormatOpts(ZDBSheetFormatExtn.dataType);
    ZDBSheetFormatExtn.setValuesInFormatDlg(null,colHead,null,editFrmtColOpts);
    ZDBSheetFormatExtn.hideTabs();
 }


  this.deleteFormulaFailure = function(response,requestOptions)
  {
    var innerHtml = ZDBEscapeUtil.decodeForHtml(response.getResponsePart("STATUS_MESSAGE"));
    var title = ZDBI18NMap.g("zrpt.common.editformulas.js.errorMsgTtl");
    ZDBUtil.showRefErr(innerHtml,title);
  }

  this.deleteAggFormulaFrmReports = function(el)
  {
    var view = ZDBClientUI.getViewObj(el,"view");
    var menu = DOMUtils.getParentWithAttr(el,"filtermenu");
    var fieldEl = menu.fieldDiv;
    var colName = fieldEl.getAttribute("displayname");
    var formulaColId = fieldEl.getAttribute("column_id");
    var currentList = view.currentList;
    var droppedEls = ZDBUtil.getElementsWithAttribute(currentList, "column_id",formulaColId);//No I18N
    var vmFilterList = view.VMFiltersList;
    var droppedElsInVMFilter = ZDBUtil.getElementsWithAttribute(vmFilterList, "column_id",formulaColId);//No I18N
    if(droppedEls.length > 0 || droppedElsInVMFilter.length > 0)
    {
      var message = ZDBI18NMap.f("zrpt.common.toolbar.table.zdbalertmsg.js.removeFromDropArea",ZDBEscapeUtil.encodeForHtml(colName));
      ZDBAlertAPI.showErrorMsg(message);
      return;
    }
    var msg = ZDBI18NMap.f("zrpt.common.toolbar.table.zdbalertmsg.js.delFormulaConfirm",ZDBEscapeUtil.encodeForHtml(colName));
    ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK:ZRFormulaColumn.delAggFormulaFrmReports,VIEW:view,FIELDEL:fieldEl}); //No I18N
  }

  this.delAggFormulaFrmReports = function(clickType, requestOptions)
  {
    if(clickType == "NO")
    {
      return;
    }
    var view = requestOptions["VIEW"];
    var fieldEl = requestOptions["FIELDEL"];
    var colId = fieldEl.getAttribute("column_id");
    var parentViewId = fieldEl.getAttribute("parent_obj_id");
    var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?"; //No I18N
    var params = "&ZDBACTION=DELETEAGGFORMULAFROMANALYTICS&PARENTVIEWID=" + parentViewId + "&FORMULAID=" + colId; //No I18N
    var xml = ZDBAnalysisConfig.getConfig(view,true);
    AjaxAPI.sendRequest({URL:url+params,
                         REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                         POSTBODY:xml,
                         VIEW:view,
                         PARENTVIEWID:view.parentViewId,
                         ONSUCCESSFUNC:ZRFormulaColumn.updateFieldsList,
                         ONFAILUREFUNC:ZRFormulaColumn.deleteFormulaFailure,
                         OPSTATUSID:"ZRFormulaColumnStatus"}); //No I18N
  }

  function ZRFormulaColDet(values)
  {
    this.colId = values[0];
    this.colName = values[1];
    this.displayName = values[2]
    this.formula = values[3];
    this.type = values[4];
    this.typeNo = values[5]
    this.currencyFormat = values[6]
    this.alignment = values[7];
    this.decimalPlaces = values[8];
    this.decimalSeparator = values[9];
    this.thousandSeparator = values[10];
    this.showSymbol = values[11];
    this.showNegativeSign = values[12];
    this.dateFormat = values[13];
    this.userLocale = values[14];
    this.unitsSymbol = values[15];
    this.formulaType = values[16];
    this.description = values[17];
  }

  ZRFormulaColDet.prototype.getDispNameForHtml = function()
  {
    return this.displayName;
  }
}
