//$Id$
var ZDBAnalysisFuncMenu = new function()
{
    // this.showGeoOperations = function(odt,viewType,view)
    // {
    //     if(viewType=="XAXIS")
    //     {
    //         odt=="GEO" ? jQuery(view.dropAreas.YAXIS).find("div[operation='GEO']").length<1 : true; //NO I18N
    //     }
    //     else if(viewType=="YAXIS")
    //     {
    //         jQuery(view.dropAreas.XAXIS).find("div[operation='GEO'][origdatatype='GEO']").length<1;
    //     }
    // }
    this.show = function(el,e)
    {
        if(e == null)
        {
            e = window.event;
        }
        ZRSMenu.closeAllMenu();
        var funcMenuBox = ZDBAnalysisFuncMenu.funcMenuBox;
        var funcMenu=DOMUtils.getParentWithAttr(el,"MenuParent");
        if(el.view==null)
        {
            var view = ZDBClientUI.getViewObj(el,"view");
            el.view = view;
        }

        view = el.view;
        ZDBAnalysisFuncMenu.funcMenuBox.view = view;
        if(funcMenuBox.parentNode != document.body)
        {
            funcMenuBox.style.display="none";
            document.body.appendChild(funcMenuBox);
        }
        funcMenuBox.curGraphField = DOMUtils.getParentWithAttr(el,"VIEWTYPE");
        funcMenuBox.holderDiv = DOMUtils.getParentWithAttr(el,"holder");//NO I18N
        funcMenuBox.dropArea = DOMUtils.getParentWithAttrValue(el,"elname","dropArea");//NO I18N
        var dbColName = funcMenuBox.curGraphField.getAttribute("DBCOLNAME");
        
        ZDBUtil.setNamedChildEls(funcMenuBox,funcMenuBox);
        var tds = funcMenuBox.menuTable.getElementsByTagName("a");
        var dType = funcMenuBox.curGraphField.getAttribute("ADDONTYPE");
        var showValueAs=0;
        var isAggregate = false;
        if(dbColName == ZDBConst.DYNAMIC_COL_NAME)
        {
            if(view.type=="Pivot")
            {
                dType="PIVOT_AGG_FORMULA" //No I18N
            }
            else
            {
                dType="AGG_FORMULA"   //No I18N
            }
            isAggregate = true;
            showValueAs = funcMenuBox.curGraphField.getAttribute("SHOWVALUEAS");
        }
        var viewType = funcMenuBox.curGraphField.getAttribute("VIEWTYPE");
        var allowedOperations = funcMenuBox.holderDiv.getAttribute(dType);
        var subFunctions = funcMenuBox.holderDiv.getAttribute(dType+"SUBFUNCTIONS");
        var currentSelectedOp = funcMenuBox.curGraphField.getAttribute("OPERATION");
        var isSummary = view.type == "SummaryView";
        if(dType=="ABSDATECATEGORICAL")
        {
            if(view.type=="Pivot" && viewType=="TEXTAXIS")
            {
                dType="PIVOT_ABSDATECATEGORICAL"; // NO I18N
            }
            else if(isSummary && viewType=="GROUP")
            {
                dType="SUMMARY_ABSDATECATEGORICAL"; // NO I18N
            }
            else if(ZDBAnalysisView.isDateAggOperation(currentSelectedOp))
            {
                currentSelectedOp="DATE" //NO I18N
            }
        }
        var odt = funcMenuBox.curGraphField.getAttribute("origdatatype");
        var isGeo = odt === "GEO" || odt === "GEO_NUM"; //NO I18N
        dType = isGeo ? "GEO"+dType : dType;//NO I18N
        var hideGeoLst = !ZDBAnalysisView.showGeoOpList(funcMenuBox.curGraphField,view) || !ZDBGlobal.isMapChart;
        if(ZDBAnalysisView.isDateSysOperation(currentSelectedOp))
        {
            currentSelectedOp="YDC" //NO I18N
        }
 
        for(var i =0, j = tds.length; i < j; i++)
        {
            var allowedAxis = (tds[i].getAttribute("ALLOWEDAXIS"));
            var operation=tds[i].getAttribute("OPERATION")
            var showFunction = (tds[i].getAttribute("ADDONTYPE")==dType)
            && ((allowedOperations == null) || (allowedOperations.indexOf(tds[i].getAttribute("OPERATION")) != -1))
            && ((allowedAxis == null) || (allowedAxis.indexOf(viewType) != -1));
            if((isSummary && isAggregate && tds[i].getAttribute("SHOWVALUEAS") != "0")
//      when geoallowed is made false then corresponding functions should not be shown.This can not be 
//      handled at rule or axis prop level as it changes based on the dropped columns.
                    || (hideGeoLst&&tds[i].getAttribute("isGeoCol")=="true")) 
            {
                showFunction = false;
            }
//Median and Mode shouldn't be displayed for VectorWise Users.
            if((ZDBGlobal.IS_VECTORWISE_USER ) && (operation == "MEDIAN" || operation == "STATS_MODE"))
            {
                 showFunction = false;                
            }
//Mode function shouldn't be displayed for Redshift users.            
            if((ZDBClientUI.isRemoteDB) && (operation == "STATS_MODE"))
            {
                showFunction = false;
            }    
            tds[i].parentNode.style.display = showFunction? ZDBUtil.visibleTrStyle:"none";
            tds[i].removeAttribute("SHOWSUBMENU");
            tds[i].selectedFunction = false;
            var ticker = jQuery(tds[i]).siblings("span[elname='ZRSTicker']")[0];;
            
         
            if(dType=="AGG_FORMULA" || dType=="PIVOT_AGG_FORMULA")
            {
                if(showValueAs==tds[i].getAttribute("SHOWVALUEAS"))
                {
                    var selectedTD = tds[i];
                    selectedTD.selectedFunction = true;
                    ticker.className = "ZRSTicker"; 
                }
                else
                {
                   ticker.className = "";  
                }
            }
            else if(operation==currentSelectedOp)
            {
                if(operation=="MEACATEGORY")
                {
                    var curSelectedRangeSize = funcMenuBox.curGraphField.getAttribute("RANGESIZE");
                    if(funcMenuBox.curGraphField.curRangeSize == null)
                    {
                        funcMenuBox.curGraphField.curRangeSize = curSelectedRangeSize;
                    }
                }
                var selectedTD = tds[i];
                selectedTD.selectedFunction = true;
                ticker.className = "ZRSTicker";
            }
            else if (operation==""  && tds[i].getAttribute("ISONLYFORCHART")!=null && tds[i].getAttribute("ISONLYFORCHART")=="true")
            {
                if(view.type!="AnalysisView")
                {
                    tds[i].parentNode.style.display ="none"
                }
                else
                {
                    ticker.className = ""
                }
            }
            else
            {
                ticker.className = "";
            }
 
            if(showFunction)
            {
                ZDBUtil.setNamedChildEls(tds[i],tds[i]);
                var funcDiv = tds[i].funcDiv;
                if(funcDiv!=null)
                {
                    funcDiv.className = (subFunctions==null)?"":(subFunctions.indexOf(tds[i].getAttribute("OPERATION")) != -1)?"subMenuRightArrow" : "";
                    if(funcDiv.className=="subMenuRightArrow")
                    {
                        tds[i].setAttribute("SHOWSUBMENU","true");
                        tds[i].setAttribute("submenu","true");
                        tds[i].setAttribute("specialCase","true");
                        if(dType === "ABSDATECATEGORICAL")
                        {
                            var parEl = tds[i].parentElement;
                            parEl.style.width = (viewType === "SIZEAXIS") ? "" : "50%";
                        }
                    }
                }
            }
        }
 
        var funcMenu=DOMUtils.getParentWithAttr(el,"MenuParent");
        document.body.appendChild(funcMenuBox);
        ZDBAnalysisFuncMenu.positionFuncMenu(el, funcMenuBox, funcMenu,view);
        funcMenuBox.positioned = true;
        jQuery(funcMenuBox).find('a').not("[OPERATION='DUMMY'],[ISONLYFORCHART='true']").css("display","block").css("padding-left", "25px");//NO I18N
        ZRSMenu.showMenu(e,el,funcMenuBox,null,ZDBAnalysisFuncMenu.removeSubMenuAttr);
        if(jQuery(funcMenuBox).find('a:visible').length <= 0){
            ZRSMenu.closeAllMenu();
        }
        ZDBAnalysisView.expandDropField(el);
        ZDBUtil.stopEventBubble(e);
    };

    this.positionFuncMenu = function(el,funcMenuBox,funcMenu,view)
    {
        var dropField=DOMUtils.getParentWithAttr(el,"viewtype");
        var viewArea  = view.viewComp;
        funcMenuBox.style.display = "block";
        var x = ZDBUtil.getObjLeft(dropField)+dropField.offsetWidth+"px"; //NO I18N
        var y = ZDBUtil.getObjTop(funcMenu,false,viewArea)+funcMenu.offsetHeight;
        var fucBoxHgt = funcMenuBox.offsetHeight;
        var isRevHgt = (ZDBUtil.getObjTop(funcMenu,true,viewArea)-viewArea.scrollTop+fucBoxHgt)>=viewArea.offsetHeight;
        funcMenuBox.style.display = "none";
        var adjustLeft = (BROWSER.IE) ? -2 : 3;
        funcMenuBox.style.left=isRevHgt ? x : ZDBUtil.getObjLeft(funcMenu) + adjustLeft + "px";
        funcMenuBox.style.top=isRevHgt? ZDBUtil.getObjTop(el)+viewArea.offsetHeight - (fucBoxHgt+y) + "px":((ZDBUtil.getObjTop(el)-funcMenuBox.dropArea.scrollTop)+el.offsetHeight+3) +"px";
    };

    this.selectOptionMC = function(el,event,dataField,dependentField,menuCount,actOperation)
    {
    	ZRSMenu.closeAllMenu(el);
        var view = ZDBAnalysisFuncMenu.funcMenuBox.view;//el is attached to body
        var curGraphField = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;

        if(curGraphField.getAttribute("CRITERIA") != null)
        {
            curGraphField.setAttribute("CRITERIA","");
        }
        if(ZDBAnalysisFuncMenu.isDependent(curGraphField,view))
        {
            return;
        }

        curGraphField.operation.innerHTML = el.getAttribute("ABBREV");
        if(actOperation==undefined || actOperation==null)
        {
            curGraphField.setAttribute("OPERATION",el.getAttribute("OPERATION"));
        }
        else
        {
            curGraphField.setAttribute("OPERATION",actOperation);
        }

        var showValueAs = el.getAttribute("SHOWVALUEAS");

        showValueAs = (showValueAs==null || showValueAs=="" || showValueAs=="null")?"0":showValueAs; //No I18N

        var gt=view.graphSelected;
        var ugt=view.userGrpSel;

        if(gt=="TABLE_CHART" || ugt=="TABLECHART") //DISABLE TABLE CHART FOR WINDOW FUNCTIONS
        {
            view.graphSelected="BEST";	//No I18N
            view.userGrpSel="BEST";	//No I18N
            view.userSubGrpSel="DEF";	//No I18N
            view.subGraphType="DEF";	//No I18N
        }

        curGraphField.setAttribute("SHOWVALUEAS",showValueAs);
        curGraphField.setAttribute("BASEFIELD",el.getAttribute("BASEFIELD"));
        curGraphField.setAttribute("BASEFIELDFN",el.getAttribute("BASEFIELDFN"));
        curGraphField.setAttribute("BASEFIELDPOS",el.getAttribute("BASEFIELDPOS"));
        if(showValueAs == "4")
        {
        	curGraphField.setAttribute("SUBFUNC",el.getAttribute("SUBFUNC"));
        }
        else if(showValueAs == "5" || showValueAs == "7")
        {
        	curGraphField.setAttribute("LEVEL",el.getAttribute("LEVEL"));
        }
        curGraphField.setAttribute("PREV",el.getAttribute("PREV"));
        curGraphField.setAttribute("NEXT",el.getAttribute("NEXT"));
        curGraphField.setAttribute("NULLCB",el.getAttribute("NULLCB"));
        curGraphField.setAttribute("CENTERCB",el.getAttribute("CENTERCB"));
        curGraphField.setAttribute("TYPEOFCALC",el.getAttribute("TYPEOFCALC"));

        if(el.getAttribute("DTYPE")!=null)
        {
            curGraphField.setAttribute("DTYPE",el.getAttribute("DTYPE"));
        }

        ZDBAnalysisView.showRefreshDiv(view);
        ZDBUtil.stopEventBubble(event);

        view.setModified();
    };

    this.selectOption = function(el,event,dataField,dependentField,menuCount,actOperation)
    {
    	if(ZDBDialogUtil.focusDialog && ZDBDialogUtil.focusDialog.view && ZDBDialogUtil.focusDialog.view.typeValue === ZDBClientViewAPI.TYPE_WIDGET && ZDBDialogUtil.focusDialog.view.curTab != 1)
        {
                WidgetEditor.setColFunDet(el,event);
                var funcMenuBox = ZDBAnalysisView.funcMenuBox;
                var holderDiv = DOMUtils.getSelfOrParentWithAttrValue(funcMenuBox.prevEl, "holder", "true");//NO I18N
                viewType = holderDiv.getAttribute("viewtype");
                if(viewType == "YAXIS")
                {
                	var instKey = WidgetEditor.editor.cinfo.COLUMNS.YAXIS.INSTKEY;
                	WidgetEditor.editor.view.zacf.revert(instKey);
                	WidgetEditor.setInstKeyToFormat(instKey);
                }
                return;
        }
        var view = ZDBAnalysisFuncMenu.funcMenuBox.view;//el is attached to body
        var curGraphField = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;
        var odt= curGraphField.getAttribute("origdatatype");
        var isGeoCol = odt=="GEO" || odt=="GEO_NUM";//NO I18N
        if(curGraphField.getAttribute("CRITERIA") != null)
        {
            curGraphField.setAttribute("CRITERIA","");
        }
        if(ZDBAnalysisFuncMenu.isDependent(curGraphField,view))
        {
            return;
        }
        var dispVal = ZDBAnalysisView.getDateAggDispValue(actOperation);
        curGraphField.operation.innerHTML =dispVal ? dispVal : el.getAttribute("ABBREV");
        if(actOperation==undefined || actOperation==null)
        {
            curGraphField.setAttribute("OPERATION",el.getAttribute("OPERATION"));
        }
        else
        {
            curGraphField.setAttribute("OPERATION",actOperation);
        }
        
        if(el.getAttribute("OPERATION")==="GEO" && !isGeoCol)
        {
            var role = el.getAttribute("GEOROLE");
             curGraphField.setAttribute("GEOROLE",role);
        }
        var showValueAs = el.getAttribute("SHOWVALUEAS");

        showValueAs = (showValueAs==null || showValueAs=="" || showValueAs=="null")?"0":showValueAs;//Checking is it NORMAL?(NORMAL=0)

        if(showValueAs > 0) //DISABLE TABLE CHART FOR WINDOW FUNCTIONS
        {
        var gt=view.graphSelected;
        var ugt=view.userGrpSel;

        if(gt=="TABLE_CHART" || ugt=="TABLECHART") //DISABLE TABLE CHART FOR WINDOW FUNCTIONS
        {
            view.graphSelected="BEST";	//No I18N
            view.userGrpSel="BEST";	//No I18N
            view.userSubGrpSel="DEF";	//No I18N
            view.subGraphType="DEF";	//No I18N
        }
        }
        curGraphField.setAttribute("SHOWVALUEAS",showValueAs);
        curGraphField.setAttribute("BASEFIELD",el.getAttribute("BASEFIELD"));
        curGraphField.setAttribute("BASEFIELDFN",el.getAttribute("BASEFIELDFN"));
        curGraphField.setAttribute("BASEFIELDPOS",el.getAttribute("BASEFIELDPOS"));
        if(showValueAs == "4")
        {
        	curGraphField.setAttribute("SUBFUNC",el.getAttribute("SUBFUNC"));
        }
        else if(showValueAs == "5" || showValueAs == "7")
        {
        	curGraphField.setAttribute("LEVEL",el.getAttribute("LEVEL"));
        }

        if(el.getAttribute("DTYPE")!=null)
        {
            curGraphField.setAttribute("DTYPE",el.getAttribute("DTYPE"));
        }

        if(curGraphField.getAttribute("VIEWTYPE") == "FILTERAXIS")
        {
            curGraphField.filterEl = null;
            var defOperationType = el.getAttribute("DEFOPERATIONTYPE");
            if(defOperationType!=null)
            {
                curGraphField.setAttribute("SUBTYPE",el.getAttribute("DEFOPERATIONTYPE"));
            }
            view.filterNav.selectedField = {};//empty
            view.filterNav.selectedField.functionSelected = curGraphField.getAttribute("OPERATION");
            view.filterNav.selectedField.operationtype = curGraphField.getAttribute("SUBTYPE");
            curGraphField.setAttribute("functionChanged","true");
            if(curGraphField.filterEl)
            {
              ZDBRankingRefFilter.resetRefColIfNeeded(curGraphField.filterEl);
            }
            ZDBAnalysisFilter.selectFilterField(view,curGraphField);
        }
        else
        {
            ZDBAnalysisView.showRefreshDiv(view);
            ZDBUtil.stopEventBubble(event);
        }
        view.zacf.revert(curGraphField.getAttribute('instKey'));
        view.setModified();
        ZRSMenu.closeAllMenu();
    };

    this.showSubMenuIfNeeded = function(event,isDate,menuCount,isRange)
    {
    	event.stopPropagation();
    	var elOnEvent = ZDBUtil.getSourceElement(event);
    	if(elOnEvent.tagName == "LI")
    	{
    		elOnEvent = jQuery(elOnEvent).children("a")[0];
    	}
    	else if(elOnEvent.tagName == "DIV" || elOnEvent.tagName == "SPAN")
    	{
    		elOnEvent = jQuery(elOnEvent).closest("a")[0];	
    	}
    	else if(elOnEvent.tagName == "BODY"){
    		var menu = ZRSMenu.visibleMenu.last();
    		elOnEvent = jQuery(menu).find(".ZRSMenuHover").find("a")[0];
    	}
    	if(!elOnEvent.hasAttribute("submenu"))
    	{
    		ZDBAnalysisFuncMenu.selectOption(elOnEvent, event);
    		return;
    	}
        if(menuCount==undefined)
        {
            menuCount=0;
        }
        event = (window.event != null)? window.event:event;
        var menuEl = DOMUtils.getParentWithAttr(elOnEvent,"SHOWSUBMENU");
        var srcEl = (menuEl!=null)?menuEl:elOnEvent;
        var showSubMenu = srcEl.getAttribute("SHOWSUBMENU");
        var subMenuName = srcEl.getAttribute("SUBMENUID");
        if(showSubMenu==null || subMenuName==null){
            return;
        }
        if((menuCount==1 && (ZDBAnalysisFuncMenu.funcMenuBox.view.type!="Pivot" && ZDBAnalysisFuncMenu.funcMenuBox.view.type!="AnalysisView"))|| isRange)
        {
            return;
        }
        var menuBoxName;
        if((subMenuName=="numSubFunc" || subMenuName == "geoSubFunc" || subMenuName == "geoNumSubFunc") && ZDBAnalysisFuncMenu.funcMenuBox.view.type=="AnalysisView")
        {
            var operation=srcEl.getAttribute("OPERATION");
            if(operation=="SUM" || operation=="COUNT" || operation=="MAX" ||operation=="MIN" || operation == "GEO")
            {
                menuBoxName="ChartMenuBox"; //NO I18N
            }
            else
            {
                menuBoxName="ChartMenuBoxWithDisableMenu"; //NO I18N
            }
        }
        else
        {
            menuBoxName="MenuBox"; //NO I18N
        }
        var subMenu = ZDBAnalysisFuncMenu[subMenuName+menuBoxName];
        if(!subMenu){
        	return;
        }
        ZDBAnalysisFuncMenu.setSelectedSubFunction(srcEl,subMenu,isDate,menuCount);
        if(jQuery(subMenu).is(":visible"))
        {
        	return;
        }
        ZDBAnalysisFuncMenu.showSubMenu(subMenu, srcEl, menuCount);
        subMenu.positioned = true;
        jQuery(subMenu).find('a').not("[OPERATION='DUMMY']").css("display","block").css("padding-left", "25px");//NO I18N
        ZRSMenu.showMenu(event, srcEl, subMenu, 3,ZDBAnalysisFuncMenu.removeZRSMenuHover);
    };

    // to display the submenu of functions of columns dropped (edit mode)
     this.showSubMenu = function(subMenu, srcEl, menuCount, isRange)
    {
        subMenu.srcEl = srcEl;
        subMenu.style.position = "absolute";
        subMenu.style.display = "block";
        document.body.appendChild(subMenu);
        var left = (ZDBUtil.getObjLeft(srcEl)+srcEl.offsetWidth);
        var top = (ZDBUtil.getObjTop(srcEl));
        if((left + (subMenu.offsetWidth + 5)) >= document.body.offsetWidth)
        {
            left = (left - srcEl.offsetWidth) - subMenu.offsetWidth + 2;
        }
        var screenHeight=document.body.offsetHeight;
        var subMenuHeight = subMenu.offsetHeight;
        if(screenHeight > top+subMenuHeight)
        {
            subMenu.style.top= top + 1 +"px";
        }
        else
        {
            subMenu.style.top = top-subMenuHeight+23+"px";
        }
        subMenu.style.left = left+"px";
        subMenu.style.display = "none";
    };

   this.setSelectedSubFunction = function(srcEl,subMenu,isDate,menuCount)
    {
        var showValueAs = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField.getAttribute("showvalueas");
        var operation= ZDBAnalysisFuncMenu.funcMenuBox.curGraphField.getAttribute("operation");
        var key= (isDate!=null && isDate && operation!="COUNT")?"OPERATION":"SHOWVALUEAS"; // NO I18N
        var value=(isDate!=null && isDate &&  operation!="COUNT")?operation:showValueAs; // NO I18N
         var isGeoOnCatCol = srcEl.getAttribute("isCatGeo")==="true" || srcEl.getAttribute("isNumGeo")==="true";
            key =isGeoOnCatCol? "GEOROLE" : key; //No i18N
            value = isGeoOnCatCol ? ZDBAnalysisFuncMenu.funcMenuBox.curGraphField.getAttribute("georole") : value;
        var showMenu=0;
        if(isDate && menuCount==0)
        {
            showMenu=1;
        }
        var menuName=new Array();
        menuName[0]="funcMenuItem"
        menuName[1]="funcSubMenuItem"
        var selMenuName=new Array()
        selMenuName[0]="ZRSTicker"
        selMenuName[1]="ZRSTicker"
        var className;
        ZDBUtil.setNamedChildEls(subMenu,subMenu);
        var tds = subMenu.menuTable.getElementsByTagName("a");
        for(i=0; i<tds.length; i++){
            var ticker = jQuery(tds[i]).siblings("span[elname='ZRSTicker']")[0];
                className = "";
                if(tds[i].getAttribute(key) == value && srcEl.selectedFunction==true){
                    className = selMenuName[showMenu];
                    tds[i].selectedFunction=true;
                }
                else
                {
                    tds[i].selectedFunction=false;
                }

                ticker.className = className;
        }
    };

    // lazy load range setting js files and display dialog
    this.showRangeSettingsDlg = function()
    {
        var view = ZDBAnalysisFuncMenu.funcMenuBox.view;
        if(view.type=="Pivot" || view.type=="AnalysisView")
        {
            var curGraphField = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;
            if(ZDBAnalysisFuncMenu.isDependent(curGraphField, view))
            {
                return;
            }
        }
        if(!ZDBLazyLoadUtil.loadSnippet("RANGE_SIZE", "/ZARange.cc", this,
                        "APPENDTODOC", 'zdbjs/rangesettings/ZARangeEdit.js')) //NO I18N
        {
            return;
        }
        ZARangeEdit.showRangeDialog();
    };

    // for default option. onmouseover the parent of default and check tickmark is properly applied
    this.setDefaultRange = function(el, event)
    {
        var menuCount=0;
        var srcEl;
        var menuListLength = jQuery(ZRSMenu.visibleMenu).length;
        var srcEl;
        if(menuListLength > 1)
        {
        	srcEl = jQuery(ZRSMenu.visibleMenu)[1][0].srcEl;
        }
        else
        {
        	srcEl = el;
        }
        var curGraphField = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;
        var view = ZDBAnalysisFuncMenu.funcMenuBox.view;
        if(ZDBAnalysisFuncMenu.isDependent(curGraphField, view))
        {
            return;
        }
        curGraphField.removeAttribute("RANGESIZE");
        ZDBAnalysisFuncMenu.selectOption(srcEl, event, null, null, menuCount);
    };

    // to show tick mark for the chosen range function
    this.setSelectedRangeSubFunction = function(srcEl, subMenu)
    {
        var op = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField.getAttribute("OPERATION");
        var key = "RANGESIZE"; // NO I18N
        var value = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField.getAttribute(key);

        ZDBUtil.setNamedChildEls(subMenu, subMenu);
        var tds = subMenu.menuTable.getElementsByTagName("a");
        for(var i=0; i<tds.length; i++)
        {
        	var ticker = jQuery(tds[i]).siblings("span[elname='ZRSTicker']")[0];;
            var className = ""; //NO I18N

            if(tds[i].getAttribute("ID") == "editRangeMenu" || tds[i].getAttribute("ID") == "deleteRangeMenu")
            {
                continue;
            }

            var tdVal = tds[i].getAttribute(key);
            if((tdVal == null && value=="" && op=="MEACATEGORY") || (tdVal == value && srcEl.selectedFunction == true && op=="MEACATEGORY") ||
                value>0 && tdVal=="1" && srcEl.selectedFunction == true && op=="MEACATEGORY") //NO I18N
            {
                className = "ZRSTicker"; //NO I18N
                tds[i].selectedFunction = true;
                if(jQuery(tds[i]).children("#addEditRangeMenu")[0]){
                	jQuery(tds[i]).css("padding-left","6px");//NO I18N
                }
            }
            else
            {
                tds[i].selectedFunction = false;
            }
            ticker.className = className;
        }
    };

    // to display sub menu when hovering mouse on default range in drop down menu
    this.showRangeSubMenuIfNeeded = function(event)
    {
        var menuCount=0;
        event.stopPropagation();
        event = (event != null) ? event : window.event;
        var elOnEvent = ZDBUtil.getSourceElement(event);
        if(elOnEvent.tagName == "BODY"){
            var menu = ZRSMenu.visibleMenu.last();
            elOnEvent = jQuery(menu).find(".ZRSMenuHover").find("a")[0];
        }
        var menuEl = DOMUtils.getParentWithAttr(elOnEvent, "SHOWSUBMENU"); //NO I18N
        var srcEl = (menuEl != null) ? menuEl : elOnEvent;
        var subMenuName = srcEl.getAttribute("SUBMENUID");
        var subMenu = ZDBAnalysisFuncMenu[subMenuName+"MenuBox"];
        jQuery(subMenu).find('a').not("[OPERATION='DUMMY']").css("padding-left","25px");//NO I18N
        ZDBAnalysisFuncMenu.setSelectedRangeSubFunction(srcEl, subMenu);
        ZDBAnalysisFuncMenu.showSubMenu(subMenu, srcEl, menuCount, true);
        subMenu.positioned = "true;"//NO I18N
        ZRSMenu.showMenu(event,elOnEvent,subMenu,3,ZDBAnalysisFuncMenu.removeZRSMenuHover);
        jQuery(subMenu).find('a').not("[OPERATION='DUMMY']").bind("mouseover",ZDBToolTip.showTip);//NO I18N
        var value = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField.curRangeSize;
        var addRangeEl = $("addEditRangeMenu");
        var editRangeEl = $("editRangeMenu");
        var delRangeEl = $("deleteRangeMenu");
        var parTd = DOMUtils.getParentWithAttr(addRangeEl, "RANGESIZE"); //NO I18N
        if(value != null && value !="" && value>0)
        {
            if(value.length > 20)
            {
                value = value.substring(0, 17) + "...";
            }
            addRangeEl.innerHTML = ZDBI18NMap.f("zrpt.za.analysis.range.js.editrange", value); //NO I18N
            editRangeEl.style.display = "";
            delRangeEl.style.display = "";

//            parTd.setAttribute("tiptitle", ZDBI18NMap.f("zrpt.za.analysis.range.js.custrange.title", value));
//            parTd.setAttribute("tipdesc1", ZDBI18NMap.g("zrpt.za.analysis.range.js.custrange.desc1"));
        }
        else
        {
            addRangeEl.innerHTML = ZDBI18NMap.g("zrpt.za.analysis.range.js.newrange"); //NO I18N
            editRangeEl.style.display = "none";
            delRangeEl.style.display = "none";

//           parTd.setAttribute("tiptitle", ZDBI18NMap.g("zrpt.za.analysis.range.js.addrange.title"));
//           parTd.setAttribute("tipdesc1", ZDBI18NMap.g("zrpt.za.analysis.range.js.addrange.desc1"));
        }
        
    };

    this.deleteRange = function()
    {
        var curGraphField = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;
        var view = ZDBAnalysisFuncMenu.funcMenuBox.view;
        if(ZDBAnalysisFuncMenu.isDependent(curGraphField, view))
        {
            return;
        }

        ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.za.analysis.range.js.delRange"),    //NO I18N
                        "ZDBYESNO", {ONCLICK:ZDBAnalysisFuncMenu.processDeleteRange}); //NO I18N
    };

    this.processDeleteRange = function(clickType)
    {
        if(clickType == "YES")
        {
            ZDBAnalysisFuncMenu.funcMenuBox.curGraphField.curRangeSize = "";
            ZDBAnalysisFuncMenu.funcMenuBox.curGraphField.removeAttribute("RANGESIZE");
            ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.za.analysis.range.js.rangedeleted")); //NO I18N
            var view = ZDBAnalysisFuncMenu.funcMenuBox.view;
            ZDBAnalysisView.showRefreshDiv(view);
            var addRangeEl = $("addEditRangeMenu");
            var parTd = DOMUtils.getParentWithAttr(addRangeEl, "RANGESIZE"); //NO I18N
            parTd.setAttribute("tiptitle", ZDBI18NMap.g("zrpt.za.analysis.range.js.addrange.title"));
            parTd.setAttribute("tipdesc1", ZDBI18NMap.g("zrpt.za.analysis.range.js.addrange.desc1"));
            view.setModified();
        }
        else
        {
            ZDBMsgBox.showInfo(ZDBI18NMap.g("zrpt.za.analysis.range.js.rangenotdel")); //NO I18N
        }
    };

    this.hideSubMenu = function(menuCount)
    {
        if((menuCount==undefined)|| (menuCount==null) ||(!isNumeric(menuCount)))
        {
            menuCount=0;
        }

        while(ZDBAnalysisFuncMenu.subMenu && ZDBAnalysisFuncMenu.subMenu[menuCount]!= null)
        {
            ZDBMenu.removeIframe(ZDBAnalysisFuncMenu.subMenu[menuCount]);
            ZDBAnalysisFuncMenu.subMenu[menuCount].style.display = "none";
            ZDBAnalysisFuncMenu.subMenu[menuCount] = null;
            ZDBUtil.detachEvent(document,'click',ZDBAnalysisFuncMenu.subMenu[menuCount],false);
            menuCount=menuCount+1;
        }
    };

    this.setGeorole = function(el,event,srcEl)
    {
        var grole = el.getAttribute("GEOROLE");
        srcEl.setAttribute("GEOROLE",grole);
    };
        
    this.showMCDataFieldDlg = function(el,event,isDate,menuCount,showValueAs,srcEl)
    {
        
        var showDialog = el.getAttribute("SHOWDLG");              
        var addonType=srcEl.getAttribute("addontype");
        var operation;

        if((addonType=="PIVOT_ABSDATECATEGORICAL" ||(addonType=="SUMMARY_ABSDATECATEGORICAL")) && childSubMenu!=null)
        {
            operation=childSubMenu.srcEl.getAttribute("OPERATION");

        }
        else if(isDate)
        {
            var actOperation=el.getAttribute("OPERATION");
            if(actOperation!=null)
            {
                operation=actOperation;
                showValueAs=0;
            }
        }
        else
        {
            operation=srcEl.getAttribute("OPERATION");
        }

        if(showDialog!="true")
        {
            srcEl.setAttribute("SHOWVALUEAS",showValueAs);
            ZDBAnalysisFuncMenu.selectOption(srcEl,event,null,null,menuCount,operation);
            return;
        }

        var view = ZDBAnalysisFuncMenu.funcMenuBox.view;


           var selectbox=ZDBAnalysisFuncMenu.basedOnSelectBox;
            selectbox.innerHTML = "";

           ZDBAnalysisFuncMenu.fillDimFields(selectbox,view,"FIELDS:",true); //NO I18N


            if(selectbox.getElementsByTagName("Option").length==0)
            {
                ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.chart.subfunc.zdbalertmsg.js.withoutDependCol"));
                return;
            }

        var dlg=ZDBAnalysisFuncMenu.movingCalcDlg;

        ZDBUtil.setNamedChildEls(dlg,dlg);

        var abbrev = srcEl.getAttribute("ABBREV");
        var curGraphField = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;
        var MOVINGCALC_AVERAGE=0,MOVINGCALC_SUM=1,MOVINGCALC_MAXIMUM=2,MOVINGCALC_MINIMUM=3;

        if(curGraphField.getAttribute("TYPEOFCALC"))
        {

        switch(parseInt(curGraphField.getAttribute("TYPEOFCALC")))
        {
        case MOVINGCALC_AVERAGE:
                        dlg.typeofcalcelement.selectedIndex=MOVINGCALC_AVERAGE;
                        break;
        case MOVINGCALC_SUM:
                        dlg.typeofcalcelement.selectedIndex=MOVINGCALC_SUM;
                        break;
        case MOVINGCALC_MAXIMUM:
                        dlg.typeofcalcelement.selectedIndex=MOVINGCALC_MAXIMUM;
                        break;
        case MOVINGCALC_MINIMUM:
                        dlg.typeofcalcelement.selectedIndex=MOVINGCALC_MINIMUM;
                        break;
        default:
                        dlg.typeofcalcelement.selectedIndex=MOVINGCALC_AVERAGE;
                        break;

        }

        }
        else
        {
            dlg.typeofcalcelement.selectedIndex=0;
        }

        if(curGraphField.getAttribute("centercb"))
        {
        dlg.cvelement.checked=(curGraphField.getAttribute("centercb")=="true" || curGraphField.getAttribute("centercb")=="");
        }
        else
        {
        dlg.cvelement.checked=true;
        }

        if(curGraphField.getAttribute("nullcb"))
        {
        dlg.nvelement.checked=(curGraphField.getAttribute("nullcb")=="true");
        }
        else
        {
        dlg.nvelement.checked=false;
        }

        if(curGraphField.getAttribute("prev"))
        {
            dlg.pselement.value=curGraphField.getAttribute("prev") === '' ? "1" : curGraphField.getAttribute("prev");
        }
        else
        {
            dlg.pselement.value="1";
        }

        if(curGraphField.getAttribute("next"))
        {
            dlg.ntelement.value=curGraphField.getAttribute("next") === '' ? "0" : curGraphField.getAttribute("next");
        }
        else
        {
            dlg.ntelement.value="0";
        }

        var applyButton = dlg.applyButton;
        applyButton.setAttribute("ABBREV",abbrev);
        applyButton.setAttribute("OPERATION",operation);
        applyButton.setAttribute("SHOWVALUEAS",showValueAs);
        ZDBAnalysisFuncMenu.setSelectedValue(selectbox,curGraphField);
        applyButton.curGraphField = curGraphField;

        dlg.style.display = "";

        ZDBDialogUtil.showDialog(dlg,{MODAL:true,ADDFRAME:true,TITLE:ZDBI18NMap.g("zrpt.db.chart.movingcalc.js.dlgtitle"),DONTREMOVE:true});

     };

    this.showDataFieldsDlgIfNeeded = function(el,event,isDate,menuCount)
    {	
        var showValueAs = el.getAttribute("SHOWVALUEAS");
        
        var view = ZDBAnalysisFuncMenu.funcMenuBox.view;
        if(view.type=="Pivot" && showValueAs != "0")
        {
        	var instKey =  ZDBAnalysisFuncMenu.funcMenuBox.curGraphField.getAttribute('instkey');
      	  	if(view.showTotalAs)
      	  	{
      	  		view.showTotalAs[instKey] = null;
      	  	}
        }
         if(menuCount==undefined)
        {
            menuCount=0;
        }
        var showDialog = el.getAttribute("SHOWDLG");
        var menuListLength = jQuery(ZRSMenu.visibleMenu).length;
        var srcEl;
        var childSubMenu=jQuery(ZRSMenu.visibleMenu).find(el).parents("[ismenu='true']")[0];
        if(menuListLength > 1)
        {
        	srcEl = jQuery(ZRSMenu.visibleMenu)[1][0].srcEl;
        }
        else
        {
        	srcEl = el;
        }
              
        if(showValueAs=="8")
        {
            ZDBAnalysisFuncMenu.showMCDataFieldDlg(el,event,isDate,menuCount,showValueAs,srcEl);
            return;
        }
        else if(showValueAs=="10")
        {
            ZDBAnalysisFuncMenu.setGeorole(el,event,srcEl);
            ZDBAnalysisFuncMenu.selectOption(srcEl,event,null,null,menuCount,operation);
            return;
        }

        var addonType=srcEl.getAttribute("addontype");
        var operation;
        if((addonType=="PIVOT_ABSDATECATEGORICAL" ||(addonType=="SUMMARY_ABSDATECATEGORICAL")) && childSubMenu!=null)
        {
            operation=childSubMenu.srcEl.getAttribute("OPERATION");
        }
        else if(isDate)
        {
            var actOperation=el.getAttribute("OPERATION");
            if(actOperation!=null)
            {
                operation=actOperation;
                showValueAs=0;
            }
        }
        else
        {
            operation=srcEl.getAttribute("OPERATION");
        }

        if(showDialog!="true")
        {
            srcEl.setAttribute("SHOWVALUEAS",showValueAs);
            ZDBAnalysisFuncMenu.selectOption(srcEl,event,null,null,menuCount,operation);
            return;
        }

        var selectbox=ZDBAnalysisFuncMenu.dataFieldSelectBox;
        selectbox.innerHTML = "";

        if(view.type=="AnalysisView")
        {

            ZDBAnalysisFuncMenu.fillDimFields(selectbox,view,"FIELDS:"); //NO I18N


            if(selectbox.getElementsByTagName("Option").length==0)
            {
                ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.chart.subfunc.zdbalertmsg.js.withoutDependCol"));
                return;
            }
        }
        else
        {
            var xFields = view.getDroppedFields("XAXIS");
            if(xFields.length>0)
            {
                ZDBAnalysisFuncMenu.fillFields(selectbox,xFields,"Columns:");//To add fields in droparea:Column
            }

            var yFields = view.getDroppedFields("YAXIS");
            if(yFields.length>0)
            {
                ZDBAnalysisFuncMenu.fillFields(selectbox,yFields,"Rows:");//To add fields in droparea:Rows
            }
            if(xFields.length==0 && yFields.length==0){
                ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.pivot.subfunc.zdbalertmsg.js.withoutDependCol"));
                return;
            }
        }




        var dlg=ZDBAnalysisFuncMenu.dataFieldSelectDlg;


        ZDBUtil.setNamedChildEls(dlg,dlg);

        var abbrev = srcEl.getAttribute("ABBREV");
        var curGraphField = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;

        //Select Default Basefield for 100% Group

        if(showValueAs=="9")
        {
            var bfield=curGraphField.getAttribute("BASEFIELD");
            var list=view.currentList;
            var map=new Array(5);
            map['COLORAXIS']=0;
            map['TEXTAXIS']=1;
            map['GROUP']=2;
            map['XAXIS']=3;
            map['YAXIS']=4;
            var dimensions=new Array(5);
            if(bfield==='' || bfield=="null" || bfield==null)
            {
                 for(var i=0; i < list.length; i++)
                 {
                    if(!ZDBAnalysisView.isMeasure(list[i]) && curGraphField!=list[i])
                    {
                        dimensions[map[list[i].getAttribute("viewtype")]]=list[i];
                    }
                 }
            }

            for(var i=0;i<dimensions.length;++i)
            {
                if(dimensions[i]!=null && dimensions[i]!="")
                {
                    ZDBAnalysisFuncMenu.setDefaultBaseField(dimensions[i]);
                    break;
                }
            }

        }
        dlg.functionSelected.innerHTML = abbrev;
        if(ZDBGlobal.newPivotFuncEnabled && view.type == "Pivot" &&   view.type == "Pivot" && showValueAs == "4")
        {
        	dlg.ZRCalcEl.style.display = "";
        	var SUM=1,AVERAGE=2,MAXIMUM=3,MINIMUM=4;

            if(curGraphField.getAttribute("SUBFUNC"))
            {

            switch(parseInt(curGraphField.getAttribute("SUBFUNC")))
            {
            case SUM:
                            dlg.typeofcalcelement.selectedIndex= SUM - 1;
                            break;
            case AVERAGE:
                            dlg.typeofcalcelement.selectedIndex= AVERAGE - 1;
                            break;
            case MAXIMUM:
                            dlg.typeofcalcelement.selectedIndex= MAXIMUM - 1;
                            break;
            case MINIMUM:
                            dlg.typeofcalcelement.selectedIndex= MINIMUM - 1;
                            break;
            default:
                            dlg.typeofcalcelement.selectedIndex= SUM - 1;
                            break;

            }

            }
            else
            {
                dlg.typeofcalcelement.selectedIndex=0;
            }
        }
        else
        {
        	dlg.ZRCalcEl.style.display = "none";
        }
        if(ZDBGlobal.newPivotFuncEnabled && view.type == "Pivot" &&  (showValueAs == "5" || showValueAs == "7"))
        {
        	dlg.ZRLevelEl.style.display = "";
        	var PREV=1,NEXT=2,FIRST=3,LAST=4;

            if(curGraphField.getAttribute("LEVEL"))
            {

            switch(parseInt(curGraphField.getAttribute("LEVEL")))
            {
            case PREV:
                            dlg.levelofcalc.selectedIndex= PREV - 1;
                            break;
            case NEXT:
                            dlg.levelofcalc.selectedIndex= NEXT - 1;
                            break;
            case FIRST:
                            dlg.levelofcalc.selectedIndex= FIRST - 1;
                            break;
            case LAST	:
                            dlg.levelofcalc.selectedIndex= LAST - 1;
                            break;
            default:
                            dlg.levelofcalc.selectedIndex= PREV - 1;
                            break;

            }

            }
            else
            {
                dlg.typeofcalcelement.selectedIndex=0;
            }
        }
        else
        {
        	dlg.ZRLevelEl.style.display = "none";
        }
        dlg.columnSelected.innerHTML = ZDBEscapeUtil.encodeForHtml(curGraphField.getAttribute("title"));
        var applyButton = dlg.applyButton;
        applyButton.setAttribute("ABBREV",abbrev);
        applyButton.setAttribute("OPERATION",operation);
        applyButton.setAttribute("SHOWVALUEAS",showValueAs);
        ZDBAnalysisFuncMenu.setSelectedValue(selectbox,curGraphField);
        applyButton.curGraphField = curGraphField;
        var dialogtitlearray=["","","","","zrpt.db.pivot.subfuncdlg.js.cumulative","zrpt.db.pivot.subfuncdlg.js.difffrom","zrpt.db.pivot.subfuncdlg.js.percof","zrpt.db.pivot.subfuncdlg.js.percofdifffrom","","zrpt.db.pivot.subfuncdlg.js.percofgroupby"]; //NO I18N
        var dialogtitle=ZDBI18NMap.g("zrpt.db.pivot.subfuncdlg.js.dlgtitle");
        dialogtitle=dialogtitle+" "+ZDBI18NMap.g(dialogtitlearray[showValueAs]);
        dlg.style.display = "";
        ZDBDialogUtil.showDialog(dlg,{MODAL:true,ADDFRAME:true,TITLE:dialogtitle,DONTREMOVE:true});
   };


    this.setDefaultBaseField = function(dimensionalField)
    {
           var curGraphField = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;

           curGraphField.setAttribute("BASEFIELD",dimensionalField.getAttribute("COLUMN_ID"));
           curGraphField.setAttribute("BASEFIELDFN",dimensionalField.getAttribute("OPERATION"));
           curGraphField.setAttribute("BASEFIELDPOS",dimensionalField.getAttribute("VIEWTYPE"));

    };

    this.resetDefaultBaseField = function()
    {

        var curGraphField = ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;
        var showValueAs = curGraphField.getAttribute("SHOWVALUEAS");
        var bfield = curGraphField.getAttribute("BASEFIELD");
        if((showValueAs == "0") && (bfield!="null" || bfield!=""))
        {
           curGraphField.setAttribute("BASEFIELD","");
           curGraphField.setAttribute("BASEFIELDFN","");
           curGraphField.setAttribute("BASEFIELDPOS","");
        }
        ZDBDialogUtil.closeDialog();
    };

    this.setSelectedValue = function(selectBox,curGraphField)
    {
        var baseField = curGraphField.getAttribute("BASEFIELD");
        var baseFieldFn = curGraphField.getAttribute("BASEFIELDFN");
        var baseFieldPos = curGraphField.getAttribute("BASEFIELDPOS");
        if((baseField!=null && baseField!="") &&  (baseFieldFn!=null && baseFieldFn!="") && (baseFieldPos!=null && baseFieldPos!=""))
        {
            selectBox.value = baseField+","+baseFieldFn+","+baseFieldPos;
        }

    };


    this.applySubFunctionMC = function(el,event)
    {


        var selectedBaseField = ZDBAnalysisFuncMenu.basedOnSelectBox.value;
        if(selectedBaseField==null || selectedBaseField==""){
            ZDBAlertAPI.showMsg("Kindly select a base field and apply."); //No I18N
            return;
        }


        if(!ZDBMovingCalcUtil.movingCalcValidator(ZDBAnalysisFuncMenu.previous,1) ||
        !ZDBMovingCalcUtil.movingCalcValidator(ZDBAnalysisFuncMenu.next,0) ||
        ZDBMovingCalcUtil.checkBlank(ZDBAnalysisFuncMenu.previous.value,ZDBAnalysisFuncMenu.next.value,ZDBAnalysisFuncMenu.previous) ||
        ZDBMovingCalcUtil.checkZero(ZDBAnalysisFuncMenu.previous.value,ZDBAnalysisFuncMenu.next.value,ZDBAnalysisFuncMenu.previous) ||
        ZDBMovingCalcUtil.checkValue(ZDBAnalysisFuncMenu.previous.value,ZDBAnalysisFuncMenu.previous) ||
        ZDBMovingCalcUtil.checkValue(ZDBAnalysisFuncMenu.next.value,ZDBAnalysisFuncMenu.next))
        {
        return;
        }

        if((ZDBAnalysisFuncMenu.previous.value).trim()==='')
        {
          ZDBAnalysisFuncMenu.previous.value = 1;
        }
        if((ZDBAnalysisFuncMenu.next.value).trim()==='')
        {
            ZDBAnalysisFuncMenu.next.value = 0;
        }

        if(ZDBMovingCalcUtil.checkZero(ZDBAnalysisFuncMenu.previous.value,ZDBAnalysisFuncMenu.next.value,ZDBAnalysisFuncMenu.previous))
        {
            return;
        }

        var baseFieldValues = selectedBaseField.split(",");
        el.setAttribute("BASEFIELD",baseFieldValues[0]);
        el.setAttribute("BASEFIELDFN",baseFieldValues[1]);
        el.setAttribute("BASEFIELDPOS",baseFieldValues[2]);
        el.setAttribute("PREV",""+ZDBAnalysisFuncMenu.previous.value);
        el.setAttribute("NEXT",""+ZDBAnalysisFuncMenu.next.value);
        el.setAttribute("NULLCB",""+ZDBAnalysisFuncMenu.nullchk.checked);
        el.setAttribute("CENTERCB",""+ZDBAnalysisFuncMenu.centerchk.checked);
        el.setAttribute("TYPEOFCALC",""+ZDBAnalysisFuncMenu.TypeOfCalculation.selectedIndex);

        var fieldName = baseFieldValues[0]+"_"+baseFieldValues[1];
        ZDBAnalysisFuncMenu.selectOptionMC(el,event);
        ZDBDialogUtil.closeDialog();
    };


    this.applySubFunction = function(el,event)
    {
        var selectedBaseField = ZDBAnalysisFuncMenu.dataFieldSelectBox.value;
        if(selectedBaseField==null || selectedBaseField==""){
            ZDBAlertAPI.showMsg("Kindly select a base field and apply.");
            return;
        }
        var baseFieldValues = selectedBaseField.split(",");
        el.setAttribute("BASEFIELD",baseFieldValues[0]);
        el.setAttribute("BASEFIELDFN",baseFieldValues[1]);
        el.setAttribute("BASEFIELDPOS",baseFieldValues[2]);
        var selectedOptEl = ZDBAnalysisFuncMenu.dataFieldSelectDlg.typeofcalcelement;
        var subFuncIdx = selectedOptEl.options[selectedOptEl.selectedIndex].getAttribute("subFunc");
        el.setAttribute("SUBFUNC",subFuncIdx);
        var levelOptEl = ZDBAnalysisFuncMenu.dataFieldSelectDlg.levelofcalc;
        var levelIdx = levelOptEl.options[levelOptEl.selectedIndex].getAttribute("level");
        el.setAttribute("LEVEL",levelIdx);
        var fieldName = baseFieldValues[0]+"_"+baseFieldValues[1];
        ZDBAnalysisFuncMenu.selectOption(el,event);
        ZDBDialogUtil.closeDialog();
    };


    this.fillFields = function(selectbox,fields,labelValue)
    {
        var labelEl = document.createElement("optgroup");
        var displayOperation = null;
        labelEl.label = labelValue;
        selectbox.appendChild(labelEl);
        var displayValue = "";
        var fieldName = "";
        var fieldsDropped = "";
        var values = "";
        for(i=0; i<fields.length; i++)
        {
            values = ZDBAnalysisConfig.getKey(fields[i],false);
            if(fieldsDropped.indexOf(values) == -1)
            {
                displayOperation = ZDBEscapeUtil.decodeForHtml(fields[i].operation.innerHTML);
                displayValue = fields[i].getAttribute("title") + " (" + displayOperation  + ")";
                fieldsDropped = fieldsDropped+values+"$$";
                fieldName = fields[i].getAttribute("column_id") + "_" + fields[i].getAttribute("operation");
                ZDBAnalysisFuncMenu.createDataFieldOption(selectbox,displayValue,values);
             }
        }
    };

    this.fillDimFields = function(selectbox,view,labelValue,noOptGroup)
    {

        var axis=new Array("XAXIS","YAXIS","COLORAXIS","TEXTAXIS","GROUP");
        var fields;
        var list=new Array();
        if(!(noOptGroup!=undefined && noOptGroup==true))
        {
        var labelEl = document.createElement("optgroup");
        labelEl.label = labelValue;
        selectbox.appendChild(labelEl);
        }
        for(var i=0;i<axis.length;i++)
        {
            fields = view.getDroppedFields(axis[i]);
            ZDBAnalysisFuncMenu.addDimFields(selectbox,fields,list);
        }
    };

    this.addDimFields=function(selectbox,fields,list)
    {
        var values = "";
        var displayOperation = null;
        var displayValue = "";
        var curGraphField=ZDBAnalysisFuncMenu.funcMenuBox.curGraphField;

        for(var i=0; i<fields.length; i++)
        {
            if(fields[i]!=curGraphField)
            {
                var fieldName = fields[i].getAttribute("column_id") + "_" + fields[i].getAttribute("operation");
                if (!ZDBAnalysisView.isMeasure(fields[i]) && (jQuery.inArray(fieldName, list)==-1))
                {
                    list.push(fieldName);
                    values = ZDBAnalysisConfig.getKey(fields[i],false);
                    displayOperation = ZDBEscapeUtil.decodeForHtml(fields[i].operation.innerHTML);
                    displayValue = fields[i].getAttribute("title") + " (" + displayOperation  + ")";
                    ZDBAnalysisFuncMenu.createDataFieldOption(selectbox,displayValue,values);

                }
            }
        }
    };

    this.createDataFieldOption = function(selectbox,displayValue,values)
    {
        var opt = document.createElement("OPTION");
        opt.text = displayValue;
        opt.value = values;
        selectbox.options.add(opt);
    };

    this.isDependent = function(curGraphField, view)
    {

        if(view.type=="Pivot")
        {
            var viewtype = curGraphField.getAttribute("viewtype");
            if(viewtype=="XAXIS" || viewtype=="YAXIS")
            {
                var curGraphFieldColID = curGraphField.getAttribute("column_id");
                var curGraphFieldOperation = curGraphField.getAttribute("operation");
                var dataFields = view.getDroppedFields("TEXTAXIS");
                var noOfDroppedFields = dataFields.length;
                if(noOfDroppedFields>0)
                {
                    for(var i=0; i<noOfDroppedFields; i++)
                    {
                        if((dataFields[i].getAttribute("BASEFIELD") == curGraphFieldColID) && (dataFields[i].getAttribute("BASEFIELDFN")==curGraphFieldOperation))
                        {
                            ZDBUtil.setNamedChildEls(dataFields[i],dataFields[i])
                            ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.pivot.subfunc.zdbalertmsg.js.dataDependencyPart1")+" <b>"+ZDBEscapeUtil.encodeForHtml(dataFields[i].getAttribute("title"))+"("+dataFields[i].operation.innerHTML+") &nbsp;</b>"+ZDBI18NMap.g("zrpt.common.pivot.subfunc.zdbalertmsg.js.dataDependencyPart2"));
                            return true;
                        }
                    }
                }
            }
        }

        else if(view.type=="AnalysisView")
        {
            var curGraphFieldColID = curGraphField.getAttribute("column_id");
            var curGraphFieldOperation = curGraphField.getAttribute("operation");
            var curGraphFieldAxis=curGraphField.getAttribute("viewtype");
            var axis=new Array("XAXIS","YAXIS","COLORAXIS","TEXTAXIS","GROUP");
            var dataFields;
            var depCount=0;
            var depField;
            var hasDep=false;
            if(!ZDBAnalysisView.isMeasure(curGraphField))
            {

                for(var i=0; i<axis.length; i++)
                {
                    dataFields= view.getDroppedFields(axis[i]);

                    for(var j=0;j<dataFields.length; j++)
                    {
                        if((dataFields[j].getAttribute("BASEFIELD") == curGraphFieldColID) && (dataFields[j].getAttribute("BASEFIELDFN")==curGraphFieldOperation) &&(dataFields[j].getAttribute("BASEFIELDPOS")==curGraphFieldAxis))
                        {
                            depField=dataFields[j];
                            hasDep=true;
                            break; //dep found
                        }
                    }

                    if(hasDep)
                    {
                        break;
                    }
                }

                if(hasDep)
                {

                    //Can remove by reassigning the dependency column into some other axis same column

                    if(curGraphFieldAxis=="YAXIS" || curGraphFieldAxis=="TEXTAXIS")
                    {
                        dataFields= view.getDroppedFields(curGraphFieldAxis);
                        for(var i=0;i<dataFields.length;i++)
                        {
                            if((dataFields[i].getAttribute("column_id") == curGraphFieldColID) && (dataFields[i].getAttribute("operation")==curGraphFieldOperation))
                            {
                                depCount=depCount+1;
                                if(depCount>1)
                                {
                                    return false;
                                }
                            }
                        }
                    }

                    //Check remaining axis

                    for(var i=0; i<axis.length; i++)
                    {
                        if(axis[i]!=curGraphFieldAxis)
                        {
                            dataFields= view.getDroppedFields(axis[i]);

                            for(var j=0;j<dataFields.length; j++)
                            {
                                if((dataFields[j].getAttribute("column_id") == curGraphFieldColID) && (dataFields[j].getAttribute("operation")==curGraphFieldOperation))
                                {
                                    //Change all axis dep
                                    var subDataFields;
                                    for(var k=0;k<axis.length;k++)
                                    {
                                        subDataFields=view.getDroppedFields(axis[k]);
                                        for(var l=0;l<subDataFields.length;l++)
                                        {
                                            if((subDataFields[l].getAttribute("BASEFIELD") == curGraphFieldColID) && (subDataFields[l].getAttribute("BASEFIELDFN")==curGraphFieldOperation))
                                            {
                                                subDataFields[l].setAttribute("BASEFIELDPOS", dataFields[j].getAttribute("viewtype"));

                                            }
                                        }


                                    }
                                    return false;
                                }
                            }

                        }
                    }

                    ZDBUtil.setNamedChildEls(depField,depField);
                    var axis=new Array("XAXIS","YAXIS","COLORAXIS","TEXTAXIS","GROUP");
                    var axisI18NMap = {"XAXIS":"XAxis","YAXIS":"YAxis","COLORAXIS":"ColorAxis","TEXTAXIS":"TextAxis","GROUP":"Group"} //NO I18N
                    ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.chart.subfunc.zdbalertmsg.js.depColumn")+" <b>"+ZDBEscapeUtil.encodeForHtml(depField.getAttribute("title"))+"("+depField.operation.innerHTML+") &nbsp;</b> "+ZDBI18NMap.g("zrpt.common.chart.subfunc.zdbalertmsg.js."+axisI18NMap[depField.getAttribute("viewtype")])); //NO I18N
                    return true;
                }
            }
        }
        return false;
    };
    
    this.removeSubMenuAttr = function()
    {
    	var menu = this;
    	jQuery(ZDBAnalysisFuncMenu.funcMenuBox).find("a").removeAttr('submenu specialCase');//NO I18N
    	jQuery(ZDBAnalysisFuncMenu.funcMenuBox).find('li').removeClass("ZRSMenuHover");
    };
    this.removeZRSMenuHover = function()
    {
    	var menu = this;
    	jQuery(menu).find('li').removeClass('ZRSMenuHover');
    };
};
