//$Id$
var ZAThresholdAction = new function()
{
    this.addThresholdInView = function(view, jsonData)
    {
        jQuery.each(jsonData, function(key, val) {
            if(key !== ZATaskConstants.WMS_KEY)
            {
                var thData = val.data;
                if(!thData || thData === "[]") {
                    return;
                }
                if(val.seriesIdx) // per cell threshold data
                {
                    var serIdx = val.seriesIdx;
                    var seriesData = view.viewJSON.seriesdata.chartdata;
                    seriesData[serIdx].data = JSON.parse(thData);
                }
                else
                {
                    var axis = val.axis;
                    if(view.viewJSON.chart.axes.rotated) {
                        axis = (axis === "YAXIS") ? "XAXIS" : "YAXIS"; //No i18N
                    }
                    var axisIdx = val.axisIdx;
                    var valIdx = val.valIdx;
                    if(axis === "YAXIS") {
                        view.viewJSON.chart.axes.yaxis[axisIdx].threshold.line.values[valIdx] = thData;
                    }
                    else {
                        view.viewJSON.chart.axes.xaxis.threshold.line.values[valIdx] = thData;
                    }
                }
            }
        });
    };
};