//$Id$

var ZAComboList = new function()
{

  this.highLightBorder= function(el,event,status)
        {
            var compElContainer = ZDBUtil.getParentWithAttributeValue(el,"highlightEL","true");//NO I18N
            compElContainer.style.cursor = "default";
            if(status=="mouseLeave" ||status=="mouseOut" )
            {
                compElContainer.className ="";//NO I18N
            }
            else if(status=="mouseOver")
            {
                compElContainer.className ="dComponentHover";//NO I18N
            }
        }
        
        this.hideSubFuncList = function(el)
        {
            if(el.getAttribute("elName") == "refColDtSubFunc")
            {
              subFnLst = el;
            }
            else
            {
              var listEl = ZAComboList.curList;
              if(!listEl || !listEl.refColDtSubFunc)
                {
                  return;
                }
              var subFnLst = listEl.refColDtSubFunc;
            }
            var jsubFnLst = jQuery(subFnLst);
            jQuery(subFnLst.parListEl).removeClass("RefFilterList_hover");
            if(jsubFnLst.is(":visible") && subFnLst.parListEl )
            {
                MenuUtil.slideUp(jsubFnLst,250);
            }

        }
  this.showSubFuncList = function(el,grpOp,selector,hide,containerEl,chartSettings)
  {
      var listEl = ZAComboList.curList;
      var subFnLst = listEl.refColDtSubFunc;
      
    
      var jSubFnLst = jQuery(subFnLst);
      if(grpOp)
      {
        var grpSel = hide ? "[GRPOP!="+grpOp+"]" : "[GRPOP="+grpOp+"]"; //NO I18N
        jSubFnLst.children("ul").hide().children("li[GRPOP]").hide().filter(grpSel).show().parent("ul").show(); //NO I18N
      }
      else
      {
        jSubFnLst.find("li[GRPOP]").show();
      }
      jSubFnLst.find("li").removeClass("RefFilterList_hover");
      var prevSelected = jSubFnLst.find(".RefFilterListSelected");
       prevSelected.removeClass().addClass("RefFilterList");
      if(chartSettings) {
          DrilldownUtil.showSubMenus(el, containerEl, jSubFnLst);
      }
      if(jQuery(el).hasClass("RefFilterListSelected")) // should select sub fun only when the dt column is selected
      {
        ZAComboList.checkTheSelectedValue(el,jSubFnLst,selector);//NO I18N
      }
      
      if(subFnLst.parListEl)
      {
       jQuery(subFnLst.parListEl).removeClass("RefFilterList_hover"); 
      }
      subFnLst.parListEl = el;      
      ZAComboList.setHgtNPositionSubFunList(el, subFnLst);
    
      jQuery(subFnLst.parListEl).addClass("RefFilterList_hover");
      MenuUtil.slideDown(jSubFnLst,250);
  }
  this.setHgtNPositionSubFunList = function(el,subFnLst)
  {
    var listEl = ZAComboList.curList;
      subFnLst.style.display="block";
      subFnLst.style.visibility = "hidden";
      subFnLst.style.height="";
      var x = listEl.refColFunList.offsetWidth;
      var y = ZDBUtil.getObjTop(el,false,listEl)-jQuery(listEl.refColFunList).scrollTop();//NO I18N
      
      subFnLst.style.zIndex = "5000";
      var screenWidth = document.body.offsetWidth;
      var screenHeight = document.body.offsetHeight;        
      
        var maxLstHgt = screenHeight*0.40;//viewArea.offsetHeight * 0.40;
    if(subFnLst.offsetHeight > maxLstHgt)
    {
      subFnLst.style.height = maxLstHgt+"px";
      subFnLst.style.overflowY = "auto";//NO I18N
      subFnLst.style.overflowX = "hidden";//NO I18N
      subFnLst.style.webkitOverflowScrolling = 'touch'; //NO I18N
    }
    else
    {
      subFnLst.style.height = "";
    }
      var isRevHgt = ZDBUtil.getObjTop(el,false)+subFnLst.offsetHeight > screenHeight;
      var isRevWdth = x+ZDBUtil.getObjLeft(listEl)+subFnLst.offsetWidth> screenWidth;
    
      y = isRevHgt ? y+subFnLst.parListEl.offsetHeight-subFnLst.offsetHeight: y;
      x = isRevWdth ? -subFnLst.offsetWidth:x;          
    
    subFnLst.style.left = x+"px";
      subFnLst.style.top = y+"px";
      
    subFnLst.style.display="none";
    subFnLst.style.visibility = "";
    
  }
   this.updateDtColName = function(subFunEl,colEl)
  {
    var colName = colEl.getAttribute("colName");
      if(subFunEl)
      {
      var subFunc = subFunEl.getAttribute("value");
        colName +=  " (" +subFunc+ ") ";
      }
      
      var colNameEl = DOMUtils.getFirstMatchingChild(colEl, "a", "colNameDisp", "true"); //NO I18N
      colNameEl.innerHTML = ZDBEscapeUtil.encodeForHtml(colName);
      colEl.setAttribute("value",colName) // colname with function for on mouse tool tip
      colEl.setAttribute("listElcolname",colName)
      return colName;
  }
  
  this.checkKeyNContinue = function(event,list)
  {
        if(ZAComboList.searchFocused){return;} // if search focused event should be handled by search box
        if(event == null)
        {
            event = window.event;
        }
//       alert("here");
        
        var curList = list ? list : ZAComboList.curList;
        if(!curList)
          {
            return;
          }
        var refColFunList = curList.refColFunList ? jQuery(curList.refColFunList) : jQuery(curList);
        var highlightedColPos = -1;
        var colsList ;
        var hoverEls;
        if(refColFunList.is(":visible"))
        {
            colsList = refColFunList.find("[listEl='true']:visible");
            hoverEls = refColFunList.find(".RefFilterList_hover");
            highlightedColPos = hoverEls.length>0 ? colsList.index(hoverEls.get(0)) : highlightedColPos;
        }
        
        var dtSubFnLst = jQuery(curList.refColDtSubFunc);
        var highlightedSubFnPos = -1;
        var subFnList;
        var subFnHoverEl;
        if(dtSubFnLst.is(":visible"))
        {
            subFnList = dtSubFnLst.find("li[listEl='true']:visible");
            subFnHoverEl = dtSubFnLst.find(".RefFilterList_hover");
            highlightedSubFnPos = subFnHoverEl.length>0 ? subFnList.index(subFnHoverEl.get(0)) : highlightedSubFnPos;
        }           
        
        if(event.keyCode==27)
        {
            if(dtSubFnLst.is(":visible")) 
            {
                ZAComboList.hideSubFuncList(curList.refColDtSubFunc);
                if(curList.getAttribute("elname")=="drillColList")
                {
                  ZAComboList.closeList(event, true);
                }
                jQuery(colsList.get(highlightedColPos)).addClass("RefFilterList_hover");
            }
            else
            {
                ZAComboList.closeList(event, true);
            }
                
        }
        
        else if(event.keyCode==40 || event.keyCode==38 )
        {
            var nextHighLgtEl;
            var prevEl;
            if(dtSubFnLst.is(":visible"))
            {
                var nextPos = (event.keyCode==38) ?  highlightedSubFnPos-1 : highlightedSubFnPos+1;
                nextHighLgtEl = subFnList.get(nextPos);
                prevEl = subFnList.get(highlightedSubFnPos);
                
            }
            else
            {
                var nextColPos = (event.keyCode==38) ? highlightedColPos-1 : highlightedColPos+1;
                nextHighLgtEl = colsList.get(nextColPos);
                prevEl = colsList.get(highlightedColPos);
                
            }
            if(prevEl)
            {
                jQuery(prevEl).removeClass("RefFilterList_hover");
            }
            if(nextHighLgtEl)
            {
                var jhighlightEL = jQuery(nextHighLgtEl)
                if(jhighlightEL.attr("addontype") == "ABSDATECATEGORICAL" && jhighlightEL.attr("submenuel")!="true")
                {
                    ZAComboList.showSubFuncList(jhighlightEL.get(0));
                }
                 if(nextHighLgtEl.getAttribute("expandableList")=="true")
                        {
                            jQuery(nextHighLgtEl).addClass(nextHighLgtEl.getAttribute("expandableClass"));
                            jhighlightEL.addClass("RefFilterList_hover");
                            ZAComboList.checkKeyNContinue(event,list);
                        }
                        else
                        {
                        jhighlightEL.addClass("RefFilterList_hover");
                    }
            }
        }
        
        else if(event.keyCode==37 || event.keyCode==39)
        {
           
                if(event.keyCode==37 && dtSubFnLst.is(":visible"))
               {
                   ZAComboList.hideSubFuncList(curList.refColDtSubFunc);
                   jQuery(colsList.get(highlightedColPos)).addClass("RefFilterList_hover");
               }               
               else if(event.keyCode==39)
               {
                 var curEl = jQuery(colsList.get(highlightedColPos));
                    if(curEl.attr("addontype") == "ABSDATECATEGORICAL" && curEl.attr("submenuel")!="true" )
                    {
                      if(!dtSubFnLst.is(":visible"))
                      {
                       ZAComboList.showSubFuncList(colsList.get(highlightedColPos));
                       subFnList = dtSubFnLst.find("li[listEl='true']:visible");
                      }
                      else
                      {
                        var nextHighLgtEl = subFnList.get(0);
                        if(nextHighLgtEl.getAttribute("expandableList")=="true")
                        {
                            jQuery(nextHighLgtEl).addClass(nextHighLgtEl.getAttribute("expandableClass"));
                            ZAComboList.checkKeyNContinue(event,list);
                        }
                        else
                        {
                            jQuery(nextHighLgtEl).addClass("RefFilterList_hover");
                        }
                      }                        
                    }                   
               }            
        }
        
        else if(event.keyCode==13 || event.keyCode==32)
        {
            var selEl = dtSubFnLst.is(":visible") ? subFnList.get(highlightedSubFnPos) :colsList.get(highlightedColPos); //NO I18N
            var func = selEl.getAttribute("valFunc");
            if(func == "" || !func)
            {
                selEl.click();
                return;
            }
            var file = ZAComboList.returnFileName;
            file[func](curList,selEl,event);
            ZAComboList.closeList(event, true);
        }
  }
    
  this.closeListWithAnimation = function(event,iskeypress)
  {
      ZAComboList.closeList(event,iskeypress,!ZDBGlobal.isQAEnabled);
      ZDBUtil.detachEvent(document, (ZDBGlobal.IS_MOBILE) ? 'touchstart' : 'click', ZAComboList.closeListWithAnimation, false);
      ZDBUtil.detachEvent(document,'keydown',ZAComboList.checkKeyNContinue,false);
  }
  this.closeList = function(event,iskeypress,withAnimation)
  {
      var tarEl = event ? ZDBUtil.getSourceElement(event) : null;
      if(tarEl)
      {
          var clickEl = DOMUtils.getSelfOrParentWithAttrValue(tarEl, "dontCloseList", "true"); //NO I18N
          if(!clickEl) {
              jQuery($("chartDrillDiv")).remove();
          }
      }
      else {
          jQuery($("chartDrillDiv")).remove();
      }
      if(!iskeypress)
      {
        var tarEl = event ? ZDBUtil.getSourceElement(event): null;
        var refEl = tarEl ? DOMUtils.getSelfOrParentWithAttrValue(tarEl,"refcolelheader","true") : null; //NO I18N
        var tblExpEl = tarEl ? DOMUtils.getSelfOrParentWithAttrValue(tarEl, "dontCloseList","true") : null;//NO I18N
        if(tblExpEl !=null || refEl!=null)
         {
             return;
         }
      }
     hideCustomMessage();
    var curList = ZAComboList.curList;
    if(curList)
    {
      if(curList.fieldElHeader)
        {
          jQuery(curList.fieldElHeader).removeClass("filterHeaderSel_hover");
        }
        ZAComboList.hideSubFuncList(curList);
        if(withAnimation)
        {
            MenuUtil.slideUp(jQuery(curList),250,null,withAnimation);
        }
        else
        {
            curList.style.display = "none";
        }
        if(curList.compElContainer && curList.compElContainer.cellObj && curList.compElContainer.cellObj.comboHdr)
        {         
         jQuery(curList.compElContainer.cellObj.comboHdr).hide() 
        }
        jQuery(curList).mouseleave();
    }
    ZDBUtil.detachEvent(document, (ZDBGlobal.IS_MOBILE) ? 'touchstart' : 'click', ZAComboList.closeList, true);
    ZDBUtil.detachEvent(document,'keydown',ZAComboList.checkKeyNContinue,true);
  }
  
  this.checkTheSelectedValue = function(dtEl,jsubFnlistEl,selector)
  {
      selector = selector ? selector : "li[subType="+dtEl.getAttribute('SUBTYPE')+"]"; //NO I18N
      jQuery(jsubFnlistEl).find(selector).removeClass().addClass("RefFilterListSelected");
  }
  
  this.showOnlyRequiredEls = function(refColUi,noAnimation)
{
     refColUi.children().hide();
      var defDisplayEls = refColUi.children("li[displayByDefault='true']");//NO I18N
      defDisplayEls.show();
      var defDisplayTbls = defDisplayEls.filter("li[tableLi='true']"); //NO I18N
      var expandableChild = defDisplayTbls.filter("[expand='true']");//NO I18N
      if(expandableChild.length<1)
      {
          defDisplayTbls = defDisplayTbls.length<1 ? refColUi.children("li[tableLi='true']") : defDisplayTbls; //NO I18N
          expandableChild = jQuery(defDisplayTbls.get(0));//
          expandableChild.show();
      }
      if(expandableChild.hasClass("refListExpand") && !(refColUi.children(".refListExpand").length>1))// to expand the default selected table list
      {
        return;
      }
       //refColUi.children("li").removeClass('refListExpand').find("ul").hide(); // NO I18N
        ZAComboList.listExpandContract(expandableChild,noAnimation);
}
  
  this.clearSearch = function(listEl)
  {
      var jQsearchField = jQuery(listEl).find("#ZDBSearchBox");
      jQsearchField.val('');
      jQsearchField.attr('searchVal','');//NO I18N
      jQuery(listEl.searchMismatch).hide();
  }
  
  this.listExpandContract = function(el,noAnimation)
  {
    var elToExp = jQuery(el).closest("[tableLi='true']");//NO I18N
    var colLstUl = elToExp.find('ul');
    if (colLstUl.is(':visible'))
    {
        elToExp.removeClass('refListExpand');
        noAnimation ? colLstUl.hide() : MenuUtil.slideUp(colLstUl,250);
    }
    else 
    {
        //elToExp.siblings().removeClass('refListExpand').find("ul").hide();
        elToExp.addClass('refListExpand');
        noAnimation ? colLstUl.show() : MenuUtil.slideDown(colLstUl,250);

    }
  }
  
}// jshint ignore:line
