//$Id$
var ToolTip = new function()
{ 
  this.tooltipcontainerDiv  = document.createElement("div"); 
  this.tooltipcontainerDiv.style.cssText="display:none"; // NO I18N
  this.tooltipcontainerDiv.innerHTML = 
   '<div id="ZATooltipTemplate" class="toolTipShadow" style="position:absolute;">\n\
     <div elname="content" style="float:left;">\n\
     </div>\n\
    </div>\n\
    <div id="ZATOOLTIP" class="GraphToolTip" style="display:none;white-space:normal;"> \n\
    </div>\n\
    <div id="TOOLTIPARROW" class="TooltipBottomArrowbefore" style="display:none;">\n\
    </div>\n\
    <div id="TOOLTIPARROW2" class="TooltipBottomArrowafter" style="display:none;">\n\
    </div>'
    
  this.initialize = function()
  {
     if(this.toolTipArea == null)
     {
       document.body.appendChild(ToolTip.tooltipcontainerDiv);
       this.isEvtAttached = false;
       var tooltipTpl =$("ZATooltipTemplate").cloneNode(true);
       tooltipTpl.id = "";
       this.toolTipArea = tooltipTpl;
       ZDBUtil.setNamedChildEls(this.toolTipArea,this.toolTipArea);
       this.toolTipArea.style.display="none";
       this.toolTipArea.content.innerHTML = "";
       this.toolTipEl = $("ZATOOLTIP");
       this.toolTipArea.content.appendChild(this.toolTipEl);
       if(ZDBGlobal.tipZIndex)
       {
         this.toolTipArea.style.zIndex = ZDBGlobal.tipZIndex;
       }
     }
    
  }
 
  this.showAttrVal = function(el,event,attr)
  {
    var toolTipStr = el.getAttribute(attr);
    ToolTip.show(event, el,ZDBEscapeUtil.encodeForHtml(toolTipStr));
  }
  
  this.show = function(event, el, toolTipString, width)
  {
  if(ZDBGlobal.IS_MOBILE)
  {
    return;
  }
    if(event == null){event = window.event;}
//    if(typeof ZDBChartUtil === 'object'  && ToolTip.srcEl)
//    {//Edit formulas tooltip calls this method
//    	ZDBChartUtil.hide(ToolTip.srcEl, null, true);
//    }
    var sourceEl = ZDBUtil.getSourceElement(event);
    var view = ZDBClientUI.getViewObj(sourceEl,"view");
    this.initialize();
    ToolTip.holder = ToolTip.getToolTipHolder(view);
    ToolTip.srcEl = sourceEl;
    ToolTip.toolTipArea.setAttribute("elname","toolTipArea");
    (ToolTip.holder).appendChild(ToolTip.toolTipArea);
    ToolTip.toolTipArea.view = view;
    var isAxis = sourceEl.getAttribute("axistype")!=null;
    var drillLabel= sourceEl.getAttribute("entityType")==="drillarea"; //NO I18N
    ToolTip.isDrillLabel = drillLabel;
    if(ZDBGlobal.IS_MOBILE && ToolTip.isEvtAttached==false)
    {
        ToolTip.isEvtAttached = true;
//        jQuery("#ZDBMAINEL").bind("click", function(event){ZDBChartUtil.checkNhide(event);}); //No I18N
    }
    var comboType = sourceEl.getAttribute("CT");
    if(comboType != null)
    {
        ZAComboChartUtil.setMapElements(el, sourceEl);
    }
	 
    var dontHide = false;
    var overlapPoints = false;
    ToolTip.legendColor = null;
    if(sourceEl.tagName=="AREA")
    {
      var toolTipContent = "";	   
      if(isAxis || (drillLabel && view.editMode)) 
      { 
        sourceEl.style.cursor="default";
          return;
      }
      // for threshold
      if(sourceEl.getAttribute("lineType")!=null)
      {
//        var thEl = ZDBChartUtil.highlightThold(sourceEl,event,view);
        thEl.setAttribute("lineType", sourceEl.getAttribute("lineType"));
        sourceEl.style.cursor="default";
        var tholdText = ZDBEscapeUtil.encodeForHtml(sourceEl.getAttribute("text"));
        var element = sourceEl;
        var content = tholdText;

        var toolTip = this.toolTipEl;
        ToolTip.toolTipEl.className="TooltipBottomArrow";
        ToolTip.setToolTipAttr(toolTip, content,width);
        ToolTip.setToolTipVisible(toolTip);
        ToolTip.legendColor = sourceEl.getAttribute("color");
        this.move(event,thEl);

        if(thEl!=null)
        {
            element = thEl;
        }

        element.onmouseout=ToolTip.hide;
        element.onmousemove = ToolTip.move;
        return;
      }
      var no_of_fields = (sourceEl.getAttribute("s")!=null)?ZDBEscapeUtil.encodeForHtml(sourceEl.getAttribute("s")):0;		
      var snp = "snp"+no_of_fields;
      var values = sourceEl.getAttribute("value").split(",");
      var fieldName = ZDBEscapeUtil.encodeForHtml(el.getAttribute(snp)).split(",");
      var temp = "";
      var percentVal = ZDBEscapeUtil.encodeForHtml(sourceEl.getAttribute("pval"));
      if(drillLabel)
      {
          var text = ZDBEscapeUtil.encodeForHtml(sourceEl.getAttribute("value"));
          toolTipContent = toolTipContent +"<span class='tooltiptext' style='line-height:1;display:block;'><b><i>"+text+"</i></b></span>";
          toolTipContent = toolTipContent +"<span style='color:#D65587; line-height:1;padding-top:10px;padding-bottom:2px;font-style:italic;display:block;font-size:11px'><i>"+ZDBI18NMap.g("zrpt.common.vudtip.js.lbltip")+"</i></span>";
      }
      else
      {
        if(fieldName.length == values.length)
        {
            toolTipContent = "<table cellspacing='0' cellpadding='0' border='0'>";
            for(var i=0; i<fieldName.length; i++)
            {
              if(temp.indexOf(fieldName[i]+"&&")>-1){
                  continue;
              }
              temp = temp + fieldName[i]+"&&";
              var commaEscapedvalues = ZDBEscapeUtil.encodeForHtml(ZDBUtil.replaceStr(values[i],"--C--",","));
              toolTipContent += "<tr><td class='tooltiptext' style='max-width:100px'>"+ZDBUtil.replaceStr(fieldName[i],"--C--",",")+": "+"</td>"+"<td class='tooltiptext' style='max-width:180px'><b>"+commaEscapedvalues+"</b></td>"+"</tr>";//No I18N
            }
            if(percentVal)
            {
               toolTipContent += "<tr><td nowrap='nowrap' class='tooltiptext' style='max-width:100px'>"+ZDBI18NMap.g("zrpt.home.import.step2.js.percent")+": "+"</td>"+"<td nowrap='nowrap' class='tooltiptext' style='max-width:180px'><b>"+percentVal+"%"+"</b></td>"+"</tr>";//No I18N
            }
            toolTipContent = toolTipContent + "</table>";
          }

          var clickMsg = ZDBI18NMap.g("zrpt.common.vudtip.js.lbltip");
          if(view.drillDet.isNextDrillAllowed && !view.editMode)
          {
              if(view.permissions.vud) {
                  clickMsg = ZDBI18NMap.g("zrpt.common.vudtip.js.drilltip");
              }
              toolTipContent += "<span style='color:#D65587; display:block; height:28; line-height:2; font-size:11px'>" + clickMsg + "</span>";
          }
          else if(view.permissions.vud)
          {
              clickMsg = ZDBI18NMap.g("zrpt.common.vudtip.js.datatip");
              toolTipContent += "<span style='color:#D65587; height:28; line-height:2; font-size:11px'>" + clickMsg + "</span>";
          }
          else
          {
              var cursor = "default";
          }

          if(sourceEl.getAttribute("o")==1)
          {
              toolTipContent += "<span class='smallAlert' style='padding-left:20px; height:18px; line-height:1; vertical-align: bottom; font-size:11px'><b>"+ZDBI18NMap.g("zrpt.common.tooltip.js.overlapPoints")+"</b></span>";
              overlapPoints = true;
          }
      }
      element = sourceEl;
      content = toolTipContent;
    }
    else
    {
      element = el;
      content = (toolTipString==null)?ZDBEscapeUtil.encodeForHtml(element.getAttribute("value")):toolTipString;
      if(el.getAttribute("cp")!=null && view.editMode==true)
      {
				if(view.chartArea.blured==true){return;}
        content = content+"<br/><div style='color:#0066CC;line-height:1.7; display:inline-block; height:13px; margin-top:1px;'><b>"+ZDBI18NMap.g("zrpt.common.tooltip.js.colorPalette")+"</b><div>";
      }
    }
    // cHeck for svg chart element onmouseover
    if(!drillLabel && sourceEl.tagName=="AREA")
    {
        var matchedLegend = ZDBChartUtil.matchLegend(element,view);
        ToolTip.legendColor = view.chartHighlighterObj.legendColor;
        if(ToolTip.legendColor == null)
        {
            ToolTip.legendColor = "rgb(0,0,0)"; //No I18N
        }
    }
		
    if(ZDBUtil.getSourceElement(event).tagName=="AREA" )
    {
        if(view.chartArea.blured==true){return;}
        ZDBChartUtil.positionContainer(view);
        var graphSelected = view.graphSelected.toLowerCase();
        var drawnEl = null;

         if(matchedLegend!=null)
         {
              ZDBChartUtil.highlightLegend(matchedLegend,view);
         }

        ToolTip.toolTipEl.className="TooltipBottomArrow";
        if(!view.isNoLegendSelected && !(view.graphSelected=="PIE" && view.subGraphType=="3D"))
        {
          ZDBChartUtil.isLegendHighlight = false;
          drawnEl = ZDBChartUtil.highlightArea(element,event,view);
          if (BROWSER.IE && BROWSER.VERSION == "9.0")
          {
            drawnEl.onmouseout = function(){ZDBChartUtil.hide(drawnEl);}
          }
        }
        //onmouseover for 3D pie charts
        if (view.graphSelected=="PIE" && view.subGraphType=="3D")
        {
            if(view.chartHighlighterObj.legend)
            {
                if (ToolTip.legend != null && ToolTip.legend != view.chartHighlighterObj.legend)
                    {
                        ToolTip.legend.className = "ellipsis normalLegend";
                    }
                ToolTip.legend = view.chartHighlighterObj.legend;
            }
        }
    }
	
    toolTip = this.toolTipEl;
    //cHeck for Legend highlight onmouseover
    var legele = ZDBUtil.getParentWithAttributeValue(el,"legendlist", "true");//NO I18N
    ToolTip.isLegendMousemove = (legele!=null);
    if (ToolTip.isLegendMousemove&&ToolTip.legendColor == null)
    {
         var colordiv = DOMUtils.getChildElsWithAttr(el, "lgelname", "colorDIV"); //No I18N
         ToolTip.legendColor = colordiv[0].style.backgroundColor;
    }

    ToolTip.setToolTipAttr(toolTip, content,width);
    if(drawnEl!=null)
    {
      drawnEl.mapObj = element;
      var criteria = element.getAttribute("criteria");
      if(criteria !== null)
      {
        drawnEl.setAttribute("criteria", criteria);
        if(view.graphSelected=="PIE") {
          view.pieCriteria = criteria;
        }
     }
     else
     {
        drawnEl.setAttribute("criteria", "");
     }
     if(overlapPoints) {
         drawnEl.setAttribute("overlap", "true");
     }
      element = drawnEl;
      view.svgElement = drawnEl;
    }
    else if(drawnEl == null && element.getAttribute("criteria") === null)
    {
        element.setAttribute("criteria", "");
    }
    this.move(event, element, comboType);
    if(drawnEl==null)
    {
      element.onmouseout=ToolTip.hide;
      element.onmousedown=ToolTip.hide;
    }
    if(element.getAttribute("cusrordefault")!= null)
    {
      cursor = "default"; //No I18N
    }
    element.style.cursor = (cursor!=null)?cursor:"pointer";
    element.onmousemove = ToolTip.move;
    ToolTip.setToolTipVisible(toolTip);
    
    ToolTip.toolTipArea.onmousemove = ToolTip.move;
    ToolTip.toolTipArea.onmouseout = ToolTip.hide;
  }

  this.setToolTipAttr = function(toolTip, content,width)
  {   
    var tooltiparrowbefore =$("TOOLTIPARROW");
    var tooltiparrowafter =$("TOOLTIPARROW2");
    toolTip.innerHTML= content;
    toolTip.appendChild(tooltiparrowbefore);
    toolTip.appendChild(tooltiparrowafter);

    toolTip.style.visibility="hidden";
    toolTip.style.width = "";
    this.toolTipArea.style.visibility="hidden";
    toolTip.style.display="";
    this.toolTipArea.style.display="";
    if(width==null)
    {
      width = toolTip.offsetWidth;
      toolTip.style.width = ((width>300)?300+"px":"auto");
    }
    else
    {
       toolTip.style.width = width+"px";
    }
    ToolTip.width=ToolTip.toolTipArea.offsetWidth;
    ToolTip.height=ToolTip.toolTipArea.offsetHeight;
    ToolTip.toolTipArea.style.zIndex="20000";
  }

  this.setToolTipVisible = function(toolTip)
  {
    toolTip.style.visibility="visible";
    this.toolTipArea.style.visibility="visible";
  }

  this.moveTooltip = function(event,el,tooltipCont,extraParams)
  {
	   if(event == null){event = window.event;}
        if(ZDBChartUtil && ToolTip.srcEl)
    	{
            ZDBChartUtil.hide(ToolTip.srcEl, null, true);
    	}
        var sourceEl = ZDBUtil.getSourceElement(event);
        var view = ZDBClientUI.getViewObj(sourceEl,"view");
        this.initialize();
        ToolTip.holder = ToolTip.getToolTipHolder(view);
        ToolTip.srcEl = sourceEl;
        (ToolTip.holder).appendChild(ToolTip.toolTipArea);              
        ToolTip.toolTipArea.view = view;
        el.style.cursor = "pointer";
        var content = tooltipCont;
        ToolTip.legendColor = null;

        ToolTip.toolTipArea.style.visibility="visible";
        this.move(event,el);
        var toolTip = this.toolTipEl;
        var tooltiparrowbefore =$("TOOLTIPARROW");
        var tooltiparrowafter =$("TOOLTIPARROW2");
        toolTip.innerHTML = "";
        toolTip.appendChild(content);
        toolTip.appendChild(tooltiparrowbefore);
        toolTip.appendChild(tooltiparrowafter);
        toolTip.style.visibility="hidden";
        this.toolTipArea.style.visibility="hidden";
        toolTip.style.display="";
        toolTip.style.width = "";
        this.toolTipArea.style.display="";
        ToolTip.toolTipArea.style.zIndex="20000"
        toolTip.style.visibility="";
        this.toolTipArea.style.visibility="";

        if(extraParams!=null)
        {
            ToolTip.funcOnHide = extraParams["ONHIDE"];
        }

        el.onmousemove = ToolTip.move;
        el.onmouseout = ToolTip.hide;
        el.onmousedown=ToolTip.hide;
  }
	
  this.move = function(event, el, comboType)
  {
	if(ZDBMenuUtil.curMenuEl || (ZRSMenu.visibleMenu.length > 0))
    {
      return;
    }    
    var ele = ZDBUtil.getSourceElement(event);
    if(ele==null || ele==undefined){return;}
    var view = ZDBClientUI.getViewObj(ele, "view");
    if(view != null && view.graphSelected == "COMBO")
    {
        ZAComboChartUtil.handleMouseMove(event, comboType);
    }
    if(event == null){event = window.event;}
    var tooltip= $("ZATOOLTIP");
    var arrowbefore =$("TOOLTIPARROW");
    var arrowafter =$("TOOLTIPARROW2");
    arrowbefore.style.borderColor="transparent"; //No I18N
    
    var toolTipHolder = ToolTip.holder;
    var screenWidth = toolTipHolder.offsetWidth;
    var screenHeight = toolTipHolder.offsetHeight;
    var toolTipHolderLeft = ZDBUtil.getObjLeft(toolTipHolder);
    var toolTipHolderTop = ZDBUtil.getObjTop(toolTipHolder);
    
    var posX = event.clientX - toolTipHolderLeft;
    var posY = event.clientY - toolTipHolderTop;
    
    if (ToolTip.legendColor != null || ToolTip.isDrillLabel)
    {
          var halfWidth = ToolTip.width/2;
          var halfHeight = ToolTip.height/2;
          this.adjustX = -halfWidth;
          this.adjustY = -(ToolTip.height + 10);
          tooltip.style.border = "2px solid " + ToolTip.legendColor;
          arrowbefore.style.display = "";
          arrowafter.style.display = "";
          arrowbefore.style.left = "";
          arrowafter.style.left = "";
    }
    if(ToolTip.legendColor != null && !ToolTip.isLegendMousemove)
    {
          arrowbefore.style.bordercolor = ToolTip.legendColor;
          if(posY > ToolTip.height && (posX + halfWidth + 10) < screenWidth)
          { // space available in top and not touches the right side of the screen. show at top
              arrowbefore.style.borderTopColor = ToolTip.legendColor;
              ToolTip.setTooltipArrowClassName(tooltip, arrowbefore, arrowafter, "TooltipBottomArrow"); //No I18N
          }
          else if(posY < (halfHeight - 10))
          {  // top gets hidden. show at bottom
              if((posX + halfWidth + 10) >= screenWidth)
              { // touches the right. show at left side. tool tip will be hidden on top for this case.
                  this.adjustX = -(ToolTip.width + 10);
                  this.adjustY = -halfHeight;
                  arrowbefore.style.borderLeftColor = ToolTip.legendColor;
                  ToolTip.setTooltipArrowClassName(tooltip, arrowbefore, arrowafter, "TooltipRightArrow"); //No I18N
              }
              else
              {
                  this.adjustX = -halfWidth + 10;
                  this.adjustY = 30;
                  arrowbefore.style.borderBottomColor = ToolTip.legendColor;
                  ToolTip.setTooltipArrowClassName(tooltip, arrowbefore, arrowafter, "TooltipTopArrow"); //No I18N
              }
          }
          else if((posX + ToolTip.width + 15) >= screenWidth)
          { // touches the right. show at left side
              this.adjustX = -(ToolTip.width + 10);
              this.adjustY = -halfHeight;
              arrowbefore.style.borderLeftColor = ToolTip.legendColor;
              ToolTip.setTooltipArrowClassName(tooltip, arrowbefore, arrowafter, "TooltipRightArrow"); //No I18N
          }
          else
          { // show at right position
              this.adjustX = 15;
              this.adjustY = -halfHeight;
              arrowbefore.style.borderRightColor = ToolTip.legendColor;
              ToolTip.setTooltipArrowClassName(tooltip, arrowbefore, arrowafter, "TooltipLeftArrow"); //No I18N
          }
      }
      else if (ToolTip.legendColor != null && ToolTip.isLegendMousemove)
      {
          if((posX + halfWidth) >= screenWidth) // tooltip touches right side
          {
              this.adjustX = -ToolTip.width/1.25;
              arrowbefore.style.left = "80%";
              arrowafter.style.left = "80%";
          }
          arrowbefore.style.borderTopColor=ToolTip.legendColor;
          ToolTip.setTooltipArrowClassName(tooltip,arrowbefore,arrowafter,"LegendTooltip");//No I18N
    }
    else if(ToolTip.isDrillLabel)
    {
      ToolTip.setTooltipArrowClassName(tooltip, arrowbefore, arrowafter, "TooltipBottomArrow"); //No I18N
      arrowbefore.style.borderTopColor = "#999999";
      tooltip.style.padding= "6px";
      tooltip.style.border= "2px solid #999999";
    }
    else
    {
        if((posX + ToolTip.toolTipArea.offsetWidth+5) >= screenWidth)
        {
          this.adjustX = -(ToolTip.toolTipArea.offsetWidth);
        }
        else
        {
          this.adjustX = 0;
        }
        if((posY + ToolTip.toolTipArea.offsetHeight)+25 >= screenHeight)
        {
          this.adjustY = - (ToolTip.toolTipArea.offsetHeight + 15);
        }
        else
        {
            this.adjustY = 15;
        }
        tooltip.className = "GraphToolTip";
        tooltip.style.border= "1px solid #d8cc3c";
        arrowbefore.style.display="none";
        arrowafter.style.display="none";
    }
    ToolTip.toolTipArea.style.position="absolute";
    
    if(ZDBGlobal.IS_MOBILE)
    {
    	ToolTip.toolTipArea.style.left=(event.pageX - toolTipHolderLeft + this.adjustX) + "px";
        ToolTip.toolTipArea.style.top=(event.pageY - toolTipHolderTop + this.adjustY) + "px";
    }
    else
    {
        ToolTip.toolTipArea.style.left=(posX + this.adjustX) + "px";
        ToolTip.toolTipArea.style.top=(posY + this.adjustY) + "px";
    }
    
    ToolTip.toolTipArea.style.display = "";
  }

  this.setTooltipArrowClassName = function(tooltip,arrowbefore,arrowafter, className)
  {
       tooltip.className = className;
       arrowbefore.className=className+"before";
       arrowafter.className=className+"after";
  }
  
  this.hide = function()
  {
	
    if(!ToolTip.toolTipArea)
    {
        return;
    }
    ToolTip.toolTipArea.style.display="none";
    if(ToolTip.funcOnHide!=null)
    {
        (ToolTip.funcOnHide)();
    }
    clearTimeout(ToolTip.timeInterval);
  }
  
  this.getToolTipHolder = function(view)
  {
    if(view && view.viewCtx && view.viewCtx.dashChildDiv && !view.viewCtx.dashChildDiv.iPhoneDashTab)
    {
    	var dashView = view.viewCtx.dashChildDiv.ctx.dashView;
        return dashView.dashDiv ? dashView.dashDiv : dashView.mainContent;
        //$#Dash#$ return dashView.viewComp ? dashView.viewComp : dashView.mainContent;
    }
    else
    {
    	return document.body;
    }
  }
}
