//$Id$

var DrillDownSettings = new function()
{
  this.drillCnstByType = {DATE: {drillDlg:"ZDBDATEDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getComboListForDate", //NO I18N
                                 updateDrillFlow:"updateDtDrillFlow"}, //NO I18N
                  DATE_AS_DATE: {drillDlg:"ZDBDATEDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getComboListForDate", //NO I18N
                                 updateDrillFlow:"updateDtDrillFlow"}, //NO I18N
                         PLAIN: {drillDlg:"ZDBCATDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getCatComboList", //NO I18N
                                 updateDrillFlow:"updateCatDrillFlow"}, //NO I18N
                         GEO: {drillDlg:"ZDBCATDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getCatComboList", //NO I18N
                                 updateDrillFlow:"updateCatDrillFlow"}, //NO I18N
                    /*MULTI_LINE: {drillDlg:"ZDBCATDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getCatComboList", //NO I18N
                                 updateDrillFlow:"updateCatDrillFlow"}, //NO I18N*/
                        RELCOL: {drillDlg:"ZDBCATDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getCatComboList", //NO I18N
                                 updateDrillFlow:"updateCatDrillFlow"}, //NO I18N
                        REFCOL: {drillDlg:"ZDBCATDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getCatComboList", //NO I18N
                                 updateDrillFlow:"updateCatDrillFlow"}, //NO I18N
                         EMAIL: {drillDlg:"ZDBCATDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getCatComboList", //NO I18N
                                 updateDrillFlow:"updateCatDrillFlow"}, //NO I18N
                           URL: {drillDlg:"ZDBCATDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getCatComboList", //NO I18N
                                 updateDrillFlow:"updateCatDrillFlow"} //NO I18N
                       /*BOOLEAN: {drillDlg:"ZDBCATDRILLDIALOG", //NO I18N
                                 fetchComboFn:"getCatComboList", //NO I18N
                                 updateDrillFlow:"updateCatDrillFlow"} //NO I18N*/
                          };


  this.allowedDtOp = ["ABS","REL"];//No I18N
  this.defOpForCombo = {"ABS":["REL","108"],"REL":["ABS","108"]};//No I18N
  this.opVsSt = {ABS:["YEAR","ABSQUARTER","ABSMONTH","ABSWEEK","DATE","TIMESTAMP"],REL:["QUARTER","MONTH","WEEK","WEEKDAY","DAY","HOUR"]};//No I18N
  
  
  this.getDrillCnstByType = function(type,prop)
  {
    return DrillDownSettings.drillCnstByType[type][prop];
  }
  
  this.showDrillStngsDlgByColType = function(el,event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object');    
    var selColHead = gridObj.getSelectedColHead();
    var colName = selColHead.getDispNameForHtml();
    var colObj = selColHead.colObj;
    var srcEl = selColHead.cellEl;
    var colId = colObj.colId;
    var type=colObj.type;
    var drillDlg = DrillDownSettings.showDrillSettingsDlg(gridObj,colName,srcEl,colId,type);
    DrillDownSettings.fetchDrillFlow(drillDlg);    
  }
  
  this.showDrillSettingsDlg = function(gridObj,colName,srcEl,colId,type)
  {
    var dlgName = DrillDownSettings.getDrillCnstByType(type, "drillDlg") ;//this.drillDlg[type]; //NO I18N
    var tblId = gridObj.objId;
    var drillDlg = ZDBClientUI.ZDBViewEl.view[dlgName];//ZDBUtil.getCachedRef(DrillDownSettings,dlgName); //No I18N
    ZDBUtil.setNamedChildEls(drillDlg,drillDlg);  
//    var aot = type==="DATE" ?"ABSDATECATEGORICAL" :"CATEGORICAL" ;//DrillDownSettings.typechartaot[type]; //NO I18N
//    var op = type==="DATE" ? "YEAR" : type=="GEO" ? "GEO" : "GROUPBY";//DrillDownSettings.typeVschartop[type]; //NO I18N    
    var aot = GRID_DRILLTYPECONSTS.getAddOnType(type);
     var op = GRID_DRILLTYPECONSTS.getOperation(type);
    jQuery(drillDlg).find("div[elname='DrillColNameDisp']").html(colName).attr({COLUMN_ID:colId,ADDONTYPE:aot,OPERATION:op,COL_DISPNAME:colName,PARENT_OBJID:tblId});
    drillDlg.gridObj = gridObj;
    drillDlg.colId = colId;
    drillDlg.type = type;
    colName = colName.toString().length > 25 ? colName.toString().substr(0, 25)+"..." : colName;
    var title = ZDBI18NMap.g('zrpt.table.drilldown.js.dlgtitle') + " - " +  ZDBEscapeUtil.decodeForHtml(colName);
    ZDBDialogUtil.showDialog(drillDlg,{TITLE:title,ADDFRAME:true,MODAL:true,DONTREMOVE:true,CALLOUT:true,SRCEL:srcEl});
    DrillDownSettings.updateEvents(drillDlg,type);
    return drillDlg;
  }  
  
  this.updateEvents = function(drillDlg,type)
  {    
    if(type=="DATE" || type=="DATE_AS_DATE")
    {
      var selAllEl = jQuery(drillDlg.selectAll);
      var checkBoxEls = jQuery(drillDlg).find("input[EnableDrillFlow='true']");
      selAllEl.click(function()
      {      
        checkBoxEls.prop("checked",this.checked).change(); //NO I18N
      });
      checkBoxEls.change(function(){        
        selAllEl.prop("checked",checkBoxEls.filter("input:checkbox:not(:checked)").length<1);//NO I18N
        
         var drillPathSec = ZDBUtil.getParentWithAttributeValue(this,"drillPathSec", "true");//NO I18N
         var modelDiv = DOMUtils.getFirstMatchingChild(drillPathSec,"div","modelDiv","true");//NO I18N
         var resetFlowLnk = DOMUtils.getFirstMatchingChild(drillPathSec,null,"resetLink","true");//NO I18N
         var resetStart = jQuery(drillPathSec).find("span[resetStart='true']")[0];
         modelDiv.style.display = this.checked ?  "none" : "";
         resetStart.style.display = this.checked ?  "" : "none";
         resetFlowLnk.style.display = this.checked ?  "" : "none";
      });
    }        
  }
  
    
  this.fetchDrillFlow = function(drillDlg,event)
  {
    var gridObj = drillDlg.gridObj;
      var params = "&OBJID="+ gridObj.objId+"&DRILLCOLID="+ drillDlg.colId; //NO I18N
      var url = CommAPI.FETCHDRILLFLOW;
      AjaxAPI.sendRequest({
        URL: url,
        PARAMETERS:params,
        METHOD:"GET", //No I18N
        DRILLDLG:drillDlg,
        ONSUCCESSFUNC:DrillDownSettings.updateDrillDownFlow
        });
  }
  
  
  this.updateDrillDownFlow = function(response,requestOptions)
  {
    var drillDlg = requestOptions["DRILLDLG"];
    var resp = JSON.parse(response.responseText);
    var drillFlow = resp["DRILLFLOW"];//drillFlowEl.getAttribute("drillFlow");
    var enabledOp = resp["ENABLED_OP"];//drillFlowEl.getAttribute("enabledOp");
    DrillDownSettings.updateDrillFlowByType(drillFlow, drillDlg,enabledOp);

  }
     
  this.updateDrillFlowByType = function(drillFlow,drillDlg,enabledOp)
  {
    var jsondrillFlow = JSON.parse(drillFlow);
    DrillDownSettings[DrillDownSettings.getDrillCnstByType(drillDlg.type,"updateDrillFlow")](jsondrillFlow,drillDlg,enabledOp);
  }
  
  this.fetchNUpdateDrillComboList = function(objId,callbkFun,attrs,chartSettings,el)
  {
    var tblView = ZDBClientUI.ZDBViewEl.view;
    if(tblView.drilldownList && !chartSettings)
    {
      if(callbkFun)
      {
        callbkFun.apply(this,attrs);
      }
      return;
    }
    if(tblView.drillLstFetchStat == "1" && !chartSettings)
    {
      return;
    }
    tblView.drillLstFetchStat = "1";
    var params = chartSettings ? ZAChartDrillView.getPrevDrillParams(el) : "&OBJID="+ objId; //NO I18N
    var url = CommAPI.FETCHDRILLCOMBOLIST;
    AjaxAPI.sendRequest({
        URL: url,
        PARAMETERS:params,
        ONSUCCESSFUNC:DrillDownSettings.updateDrillComboListToGrid,
        ONFAILUREFUNC:DrillDownSettings.handleDrillFailure,
        CALLBACKFUN:callbkFun,
        CALLBACKFUNATTRS:attrs,
        CHARTSETTINGS:chartSettings,
        CONTAINEREL:jQuery(el).parent()[0]
    });
  }
  
  this.handleDrillFailure = function(response,requestOptions)
  {
      var view = ZDBClientUI.ZDBViewEl.view;
      view.fetchDrillCols = true;
  }
  
  this.updateDrillComboListToGrid = function(response,requestOptions)
  {
    var tblView = ZDBClientUI.ZDBViewEl.view;
    var el = document.createElement("div");
    el.innerHTML = response.responseText;
    var comboList = DOMUtils.getFirstMatchingChild(el,null ,"elName","drillColList");  //NO I18N
    if(!comboList) 
    {
        tblView.fetchDrillCols = true;
        return;
    }
    comboList.id="";
    var chartSettings = requestOptions["CHARTSETTINGS"];
    if(chartSettings)
    {
        var divEl = document.createElement("div");
        divEl.id = "chartDrillDiv";
        document.body.appendChild(divEl);
        divEl.appendChild(comboList);
    }
    else
    {
        document.body.appendChild(comboList);
    }
    var containerEl = requestOptions["CONTAINEREL"];
    DrillDownSettings.updateDrillListsByType(comboList,tblView,containerEl,chartSettings);
    
    var callbkFun = requestOptions["CALLBACKFUN"];
    if(callbkFun)
    {
      var attrs = requestOptions["CALLBACKFUNATTRS"];
      callbkFun.apply(this,attrs,chartSettings);
    }
    tblView.drillLstFetchStat = "2";
    tblView.fetchDrillCols = true;
  }
  
  this.fetchDrillDownList = function(el,event)
  {
    var compElContainer = DOMUtils.getSelfOrParentWithAttrValue(el,"elname", "compElContainer"); //NO I18N
    if(!ZDBDialogUtil.focusDialog){return;}
      var drillDlg = ZDBDialogUtil.focusDialog.bodyContent;
      var gridObj = drillDlg.gridObj;
      if(!gridObj)
      {
        return;
      }
      var objId = gridObj.objId;
      var attrs = [compElContainer,drillDlg.type,drillDlg.colId,event];
      DrillDownSettings.fetchNUpdateDrillComboList(objId,DrillDownSettings.showComboList,attrs);
 }
 
  
  this.updateDrillListsByType = function(comboList,tblView,containerEl,chartSettings)
  { 
    comboList.id="";
    tblView.drilldownList = comboList;
    ZDBUtil.setNamedChildEls(comboList,comboList); 
    DrillDownSettings.setEventsForComboLst(comboList, containerEl, chartSettings);
    for(var i=0;i<DrillDownSettings.allowedDtOp.length;i++)
    {
      var op = DrillDownSettings.allowedDtOp[i];
      var dtComboList = tblView["dateComboLst"+op] = comboList.cloneNode(true);
      if(!chartSettings) {
          document.body.appendChild(dtComboList);
      }
      ZDBUtil.setNamedChildEls(dtComboList,dtComboList);  
      DrillDownSettings.setEventsForComboLst(dtComboList);
      var subFnLst = dtComboList.refColDtSubFunc;
      var subFnGrp = DOMUtils.getFirstMatchingChild(subFnLst,"li","GRPOP", op).cloneNode(true); //NO I18N
      var jli = jQuery(subFnGrp);
      jli.find("div[secHeader='true']").hide();
      jli.attr({displaybydefault:"true",onclick:"return false;",valfunc:"",allowedDrillFLow:"true"}); //NO I18N
      jli.find("li").attr({valfunc:"setDrillColDtSubFun",addOnType:"ABSDATECATEGORICAL",submenuel:"true"}); //NO I18N
      var firstChild = jQuery(dtComboList.refColUi).find("li:first"); 
      var otherCls = document.createElement("li");
      otherCls.innerHTML = ZDBI18NMap.g('zrpt.table.drilldown.js.othercolumns');
      
      otherCls.className = "DrillColSeperation";
      otherCls.setAttribute("dontCloseList", "true");
      firstChild.after(subFnGrp).next().after(otherCls);
      var jQrefColFunList = jQuery(dtComboList.refColFunList);      
      jQrefColFunList.find("li[valFunc='setColFunction']").attr("valFunc","setDrillColFun"); //NO I18N
    }
  }  
  this.setEventsForComboLst = function(comboList, containerEl, chartSettings)
  {
    var jQrefColFunList = jQuery(comboList.refColFunList);
    jQrefColFunList.delegate("div[isExpAllowed='true']", 'click', function(event) //NO I18N
    {
        ZAComboList.listExpandContract(jQuery(event.target));
    });
    jQrefColFunList.find("[listel='true'][submenuel!='true']").mouseenter(function()
    {
      if(this.getAttribute("ADDONTYPE")!="ABSDATECATEGORICAL")
      {
        ZAComboList.hideSubFuncList(this);
        return;
      }      
      var selector = "li[OPERATION="+this.getAttribute('OPERATION')+"]"; //NO I18N
      var colId = "";
      if(ZDBDialogUtil.focusDialog){
          colId = ZDBDialogUtil.focusDialog.bodyContent.colId;
      }
      var hide = (this.getAttribute("COLID") === colId) ? false : true;
      var grpOp = this.getAttribute("GRPOP");
      ZAComboList.showSubFuncList(this,grpOp,selector,hide,containerEl,chartSettings);
    });

// search is not enabled, as it needs proper searching in date drop down list. below events can be used once it is enabled ; untill then dont delete the below commented code
//      var searchForm = jQrefColFunList.find("div[elname='comboSearch']")[0];
//      searchForm.id = "";
//      var jQsearchForm = jQuery(searchForm);
//      var searchMisMatch = jQrefColFunList.find("span[elName='searchMismatch']");
//      var searchInput = jQsearchForm.find('input');
//      searchInput.focus(function(){
//            ZAComboList.searchFocused = true;
//            ZDBUtil.detachEvent(document,'keydown',ZAComboList.checkKeyNContinue,true);
//          });
//          
//        searchInput.blur(function(){
//            ZAComboList.searchFocused = false;     
//            ZDBUtil.attachEvent(document,'keydown',ZAComboList.checkKeyNContinue,true);
//          });
//                                    
//        jQsearchForm.find("button[elName='searchButton']").click(function()
//        {
//          DrillDownSettings.searchList(jQrefColFunList,searchMisMatch,searchInput);
//        });
//                
//        // input box value should be updated on typing, need this bcz of showing the default text on emptying the search box  
//        searchInput.change(function()
//                        {
//                          jQuery(this).attr('searchVal',jQuery(this).val());//NO I18N
//                        }).keyup(function()
//                        {
//                          jQuery(this).change();
//                        }).keypress(function(event) 
//                        {
//                            if (event.which == 13) {
//                                event.preventDefault();
//                                DrillDownSettings.searchList(jQrefColFunList,searchMisMatch,this);
//                            }
//                        });
//        
//      // to make search case insensitive
//      (function ($) {
//        jQuery.expr[':'].Contains = function(a,i,m){
//            return (a.textContent || a.innerText || "").toUpperCase().indexOf(m[3].toUpperCase())>=0;
//        };}(jQuery));
  }
  
  // search the list for the matching columns
   this.searchList = function(jQrefColFunList,searchMisMatch,searchInput)
  {
      var query = jQuery(searchInput).attr('searchVal');//NO I18N
      if (query === "") 
      {
          jQrefColFunList.find('ul.refColUi li').show();
          searchMisMatch.hide();
          ZAComboList.showOnlyRequiredEls(jQrefColFunList.find('ul.refColUi'));
          return false;
      } 
      else 
      {
          searchMisMatch.hide();
          jQrefColFunList.find('ul.refColUi li').hide();
          var filteredEls = jQrefColFunList.find("a:Contains("+query+")[colNameDisp='true']");
          if(filteredEls.length>0)
          {
              filteredEls.parents('li').show();//NO I18N
              MenuUtil.slideDown(filteredEls.parents('li.RefFilterTbl').addClass('refListExpand').find('ul'),250);//NO I18N
              return false;
          }
          else
          {
              searchMisMatch.css('display','block');//NO I18N
          }
      }
      return false;
  }
  
  this.getComboListForDate = function(compElCtr,colId)
  {        
    var grpEl = DOMUtils.getSelfOrParentWithAttr(compElCtr, "opgrpname"); //NO I18N
    var grpOp  = grpEl.getAttribute("opgrpname");
    var tblView = ZDBClientUI.ZDBViewEl.view;
    var comboList = tblView["dateComboLst"+grpOp];
    if(!comboList)
    {
      ZDBClientUI.ZDBViewEl.view.drilldownList.parentNode.removeChild(ZDBClientUI.ZDBViewEl.view.drilldownList);
      ZDBClientUI.ZDBViewEl.view.drilldownList = null;
      DrillDownSettings.fetchDrillDownList(compElCtr);
    }
    ZDBUtil.setNamedChildEls(comboList,comboList);      
    var jrecolUi = jQuery(comboList.refColUi);
    var prevEls = jQuery(DOMUtils.getSelfOrParentWithAttrValue(compElCtr, "elname", "drillComboEl")).prevAll("div[elname='drillComboEl']");//.andSelf(); //NO I18N
    if(prevEls.length <1)
    {
      jrecolUi.children("li").hide().filter("[GRPOP]").show(); //NO I18N
    }
    else
    {
      jrecolUi.children("li").show();//NO I18N
    }
    var selArr = jQuery.map(prevEls, function(dcomboEl)
    {
      var el = jQuery(dcomboEl).find("div[elname='compElContainer']");
      return "[operation='"+el.attr("DRILLCOLOPERATION")+"']"; //NO I18N
    });
  
      jrecolUi.find("li[listel='true'][submenuel='true']").show().filter(selArr.join(",")).hide();
      
      
      return comboList;
  }

  this.getCatComboList = function(compElCtr,colId,chartSettings)
  {
    var tblView = ZDBClientUI.ZDBViewEl.view;
    var comboList = tblView.drilldownList;
    ZDBUtil.setNamedChildEls(comboList,comboList);
    if(chartSettings) {
        jQuery(comboList).find("li[listel='true']").show(); //NO I18N
    }
    else {
        jQuery(comboList).find("li[listel='true']").show().filter("[colId='"+colId+"']").hide(); //NO I18N
    }
    return comboList;
  }
  
  this.showComboList = function(compElCtr,colType,colId,event,chartSettings)
  {
    var comboList = DrillDownSettings[DrillDownSettings.getDrillCnstByType(colType,"fetchComboFn")]
                                                    (compElCtr,colId,chartSettings);
    comboList.compElContainer = compElCtr;    
    compElCtr.comboList = comboList;
    var jrecolUi = jQuery(comboList.refColUi);
    jQuery(comboList.comboSearch).hide();
//    ZAComboList.clearSearch(comboList);
    var jQrefColFunList = jQuery(comboList.refColFunList);
    var tbls = jQrefColFunList.find("[tableli='true']");
    var parentDiv = jQuery(compElCtr).parent();
    var parentGrpDiv = jQuery(compElCtr).parents("div[drillflowholder='true']"); //No I18N
    if(tbls.length>1)
    {
      jrecolUi.find('li.RefFilterTbl').addClass('refListExpand'); //No I18N
      jrecolUi.find("ul").show();
      if(jQuery(parentGrpDiv[0]).children()[1] != parentDiv[0]) {
          ZAComboList.showOnlyRequiredEls(jrecolUi, true);
      }
      //ZAComboList.showOnlyRequiredEls(jrecolUi, true);
    }
    else
    {
      tbls.find("ul").show();
    }
    var jcomboList = jQuery(comboList);
    comboList.style.display="";
    comboList.style.visibility = "hidden";
    DrillDownSettings.setHgtNWdthForList(comboList,comboList.refColFunList,compElCtr);
    comboList.style.display="none";
    comboList.style.visibility = "";    
    
    // for dt dlg, when same column id with diff opgrp is listed in other columns, sub fun list should be changed
    jQrefColFunList.find("[addOnType='ABSDATECATEGORICAL'][submenuel!='true']").each(function(){
      if(this.getAttribute("colid")==colId && !chartSettings)
      {
        if(this.getAttribute("subType")=="0")
          {
            var grpEl = DOMUtils.getSelfOrParentWithAttr(compElCtr, "opgrpname"); //NO I18N
            var grpOp  = grpEl.getAttribute("opgrpname");
            var defDet = DrillDownSettings.defOpForCombo[grpOp];

            jQuery(this).attr({OPERATION:defDet[0],GRPOP:defDet[0],defSubType:defDet[1]});
          }
      }
      else
      {
        this.removeAttribute("GRPOP");
      }
    });
    
    DrillDownSettings.checkSelectedDrillCol(compElCtr,comboList,jrecolUi,chartSettings);
    ZAComboList.returnFileName = this;    
    MenuUtil.slideDown(jcomboList,250,function()
    {
      ZAComboList.curList = comboList;            
      ZDBUtil.attachEvent(document,'keydown',ZAComboList.checkKeyNContinue,true);
      ZDBUtil.attachEvent(document,'click',ZAComboList.closeList,true);
      ZDBUtil.stopEventBubble(event);
    });
    
  }
  
  this.setHgtNWdthForList = function(comboList,lstEL,compElCtr)
  {
    lstEL.style.height = "";
    var lstHgt = lstEL.offsetHeight;
    var lstWdth = lstEL.offsetWidth;
        
    // set height n width based on window height    
    var screenWidth = document.body.offsetWidth;
    var screenHeight = document.body.offsetHeight;        

    var maxLstHgt = screenHeight*0.40;//viewArea.offsetHeight * 0.40;
    if(lstHgt > maxLstHgt)
    {
      lstHgt =maxLstHgt;
      lstEL.style.height = maxLstHgt+"px";
      lstEL.style.overflowY = "auto";//NO I18N
      lstEL.style.overflowX = "hidden";//NO I18N
      lstEL.style.webkitOverflowScrolling = 'touch'; //NO I18N
    }
    lstEL.style.width =  (lstWdth > screenWidth/2) ? screenWidth/2+"px" : lstWdth+"px";
    var x = ZDBUtil.getObjLeft(compElCtr,false);
    var y = ZDBUtil.getObjTop(compElCtr,false)+compElCtr.offsetHeight;

    var isRevHgt = y+lstHgt > screenHeight;
    var isRevWdth = x+lstWdth> screenWidth;
    var padding = compElCtr.cellObj ? 0 :10;
    y = isRevHgt ? ZDBUtil.getObjTop(compElCtr,false) - lstHgt -padding: y;
    x = isRevWdth ? x-(lstWdth-compElCtr.offsetWidth):x;          
    
    comboList.style.left = x+1+"px";
    comboList.style.top = y-2+"px";
    comboList.style.zIndex = "5000";        
    
  }
  this.checkSelectedDrillCol = function(compElContainer,comboList,jrefcolUi,chartSettings)
  {
    var listEls = jQuery(comboList).find("li[listel='true']");
    var showMoreTables = jQuery(comboList).find("li[valFunc='showmoreTables']");
    listEls.filter("[submenuel!='true'][addontype='ABSDATECATEGORICAL']").each(function(){ZAComboList.updateDtColName(null,this);}); //NO I18N
    listEls.removeClass("RefFilterListSelected RefFilterList").addClass("RefFilterList");
    showMoreTables.removeClass("RefFilterList");
    var aot = chartSettings ? compElContainer.getAttribute("COLADDONTYPE") :
                compElContainer.getAttribute("DRILLCOLADDONTYPE");
    var cid = chartSettings ? compElContainer.getAttribute("COLUMN_ID") :
                compElContainer.getAttribute("DRILLCOLID");
    var op = chartSettings ? compElContainer.getAttribute("OPERATION") :
                compElContainer.getAttribute("DRILLCOLOPERATION");
    if(aot==="ABSDATECATEGORICAL")
      {
        var selectedDtEl = listEls.filter("[operation="+op+"][submenuel='true']"); //NO I18N
        if(selectedDtEl.length>0)
        {
          selectedDtEl.removeClass().addClass("RefFilterListSelected");
        }
        else
        {
          var colEl = listEls.filter("[colid="+cid+"]"); //NO I18N
          var subFnLstEl = jQuery(comboList.refColDtSubFunc).find("li[OPERATION="+op+"]")[0];
          listEls.filter("[submenuel!='true'][colid="+cid+"]").attr("operation",op).attr("SUBTYPE",subFnLstEl.getAttribute("SUBTYPE")).removeClass().addClass("RefFilterListSelected");; //NO I18N
          ZAComboList.updateDtColName(subFnLstEl,colEl[0]);
        }          
      }
      else if(aot==="CATEGORICAL" || aot==="NUMBER")
      {
            var colEl = listEls.filter("[colid="+cid+"]"); //NO I18N
            colEl.removeClass().addClass("RefFilterListSelected"); //NO I18N
      }
      else
      {
          listEls.filter("[colid='']").removeClass("RefFilterList").addClass("RefFilterListSelected");//NO I18N
      }
  }
  
  this.updateDrillDet = function(comboList,event)
  {
    var srcEl = ZDBUtil.getSourceElement(event);
    var listEl = DOMUtils.getSelfOrParentWithAttr(srcEl, "valFunc"); //NO I18N
    if(!listEl || listEl.tagName.toString().toLowerCase() != "li")
    {
      return;
    }
    var func = listEl.getAttribute("valFunc");
    if(!func)
    {
      return;
    }
    DrillDownSettings[func](comboList,listEl,event)        
  }
     
  this.setColFunction = function(comboList,listEl,event)
  {
    var compElContainer = comboList.compElContainer;    
    ZDBUtil.setNamedChildEls(compElContainer,compElContainer,"elname");//NO I18N
    var addOnType = listEl.getAttribute("addOnType");
    var view = ZDBClientUI.getViewObj(compElContainer, "view");
    var chartDrill = true;
    if(addOnType=='ABSDATECATEGORICAL' && listEl.getAttribute("subType")=="0")
    {
        var li;
        if(view && view.type == "AnalysisView")
        {
            var grpOp = listEl.getAttribute("GRPOP");
            grpOp = grpOp ? grpOp : listEl.getAttribute("OPERATION");
            var opr = DrilldownUtil.getDateOperation(compElContainer, listEl);
            li = jQuery(comboList.refColDtSubFunc).find("li[OPERATION="+opr+"]");
        }
        else
        {
            var subType =  listEl.getAttribute("defSubType");
            li = jQuery(comboList.refColDtSubFunc).find("li[SUBTYPE="+subType+"]");
        }

      DrillDownSettings.setDtSubFunction(comboList, li.get(0), event, listEl);
      chartDrill = false;
    }          
    var op = listEl.getAttribute("OPERATION");
    var colId = listEl.getAttribute("colId");
    var refTblId = listEl.getAttribute("refTblId");
    var dispName = listEl.getAttribute("listElcolname");
    
    var prevDrillColId = compElContainer.getAttribute("DRILLCOLID");
    var prevDrillOp = compElContainer.getAttribute("DRILLTBLID");
    if(prevDrillColId===colId && prevDrillOp===op)
    {
      return;
    }
    
    if(view && view.type == "AnalysisView" && chartDrill)
    {
        DrillPath.selectColumn(listEl, refTblId, view);
    }
    else
    {
        DrillDownSettings.setColDetNDispVal(compElContainer, colId,refTblId,addOnType,op,dispName);
        DrillDownSettings.checkNUpdateDesignGridDrillDet(compElContainer);
    }
  }
  
  this.setDrillColFun = function(comboList,listEl,event)
  {
    var compElContainer = comboList.compElContainer;
    ZDBUtil.setNamedChildEls(compElContainer,compElContainer,"elname"); //NO I18N
    var addOnType = listEl.getAttribute("addOnType");
    if(addOnType=='ABSDATECATEGORICAL'  && listEl.getAttribute("subType")=="0")
    {
      var subType =  listEl.getAttribute("defSubType");
      var grpOp = listEl.getAttribute("GRPOP");
      grpOp = grpOp ? grpOp : listEl.getAttribute("OPERATION");
      var li = jQuery(comboList.refColDtSubFunc).find("li[GRPOP="+grpOp+"]").find("li[SUBTYPE="+subType+"]");
      DrillDownSettings.setDtSubFunction(comboList, li.get(0), event);
    }          
    
    var colName = listEl.getAttribute("listElcolname");
    var op = listEl.getAttribute("OPERATION");
    var colId = listEl.getAttribute("colId");
    var refTblId = listEl.getAttribute("refTblId");
    
    DrillDownSettings.setColDetNDispVal(compElContainer, colId,refTblId,addOnType,op,colName);
    
    var drillComboEl = DOMUtils.getSelfOrParentWithAttrValue(compElContainer, "elname", "drillComboEl"); //NO I18N
    drillComboEl.arrowEl.style.display = "none";
    jQuery(drillComboEl).nextAll("div[elname='drillComboEl']").remove(); //NO I18N
  }
    
  
  this.showmoreTables = function(refColList,el,event)
  {
      ZRSDrillDown.showmoreTables(refColList, el, event);
  }

  this.handleSuccess = function()
  {
    ZDBDialogUtil.closeDialog();
  }
  
  this.resetDtDrillDet = function(el,event)
  {
    ZDBDialogUtil.closeDialog();
  }
 
 this.resetDrillDet = function(el,event)
  {
    var drillDlg = ZDBDialogUtil.focusDialog.bodyContent;//ZDBUtil.getCachedRef(DrillDownSettings,"ZDBCATDRILLDIALOG"); //No I18N
    var compElContainer = drillDlg.compElContainer;
    compElContainer.removeAttribute("DRILLCOLID");
    compElContainer.removeAttribute("DRILLTBLID");
    compElContainer.removeAttribute("DRILLCOLADDONTYPE");
    compElContainer.removeAttribute("DRILLCOLOPERATION");
    compElContainer.removeAttribute("DRILLDISPCOLNAME");
    ZDBDialogUtil.closeDialog();
  }
  
this.updateRefToTblView = function()
{
  var tblView = ZDBClientUI.ZDBViewEl.view;
  tblView["DRILLFLOWCOMBOTPL"] = $("DRILLFLOWCOMBOTPL").cloneNode(true);
  tblView["DRILLFLOWCOMBOTPL"].id = "";
  tblView["ZDBDATEDRILLDIALOG"]= $("ZDBDATEDRILLDIALOG").cloneNode(true);
  tblView["ZDBDATEDRILLDIALOG"].id = "";
  tblView["ZDBCATDRILLDIALOG"]= $("ZDBCATDRILLDIALOG").cloneNode(true);
  tblView["ZDBCATDRILLDIALOG"].id = "";

}

// Cat column related

  
  this.updateCatDrillFlow = function(jsondrillFlow,drillDlg,enabledOp)
  {
    var jObj = jsondrillFlow;
    var flowDet = jObj[drillDlg.type];
          if(flowDet.length<1)
          {
            return;
          }
          var compElCntnr = drillDlg.compElContainer;
          ZDBUtil.setNamedChildEls(compElCntnr,compElCntnr);            
          DrillDownSettings.setColDetNDispVal(compElCntnr, flowDet[0],flowDet[1],flowDet[2],flowDet[3],flowDet[4]);
  }
  

  
  this.checkNUpdateDesignGridDrillDet = function(compElContainer)
  {
    var cellObj = compElContainer.cellObj;
    if(cellObj)
    {
      var type = ZDBDesignGrid.getColumnDataTypeForField(cellObj);            
      var colId = cellObj.rowObj.values[cellObj.rowObj.parGrid.getColumnIndex("FIELDID")].originalValue;
//      var aot = type==="DATE" ?"ABSDATECATEGORICAL" :"CATEGORICAL" ;//DrillDownSettings.typechartaot[type]; //NO I18N
//      var op = type==="DATE" ? "YEAR" : type=="GEO"? "GEO":"GROUPBY";//DrillDownSettings.typeVschartop[type]; //NO I18N
     var aot = GRID_DRILLTYPECONSTS.getAddOnType(type);
     var op = GRID_DRILLTYPECONSTS.getOperation(type);
      var pObjId =  cellObj.rowObj.parGrid.objId;
      var name = ZDBDesignGrid.getColumnValue(cellObj, "FIELDNAME"); //NO I18N
      
      var newVal = DrillDownSettings.getCatDrillFlowAsString(colId, aot, op, pObjId, name, compElContainer);
      var dispName=  compElContainer.getAttribute("DRILLDISPCOLNAME");
      cellObj.setValue(newVal, dispName, true, false, false);
      jQuery(cellObj.comboHdr).hide();
    }    
  }
  
  this.getCatDrillFlowAsString = function(colId,aot,op,pObjId,dispName,compElContainer)
  {
    var drillcolId = compElContainer.getAttribute("DRILLCOLID");
    if(drillcolId===null || drillcolId==="")
    {
      return "[]";
    }
    var drillaot =compElContainer.getAttribute("DRILLCOLADDONTYPE");
    var drillop = compElContainer.getAttribute("DRILLCOLOPERATION");
    var drillcolDispName =compElContainer.getAttribute("DRILLDISPCOLNAME");
    var drillParentId = compElContainer.getAttribute("DRILLTBLID");
    var arrJson = [];
      var jsonData = {};
    jsonData["COLUMN_ID"] = colId;
      jsonData["ADDONTYPE"] =  aot;
      jsonData["OPERATION"] =  op;
      jsonData["DRILL_COLID"] =  drillcolId;
      jsonData["DRILLCOL_ADDONTYPE"] =  drillaot;
      jsonData["DRILLCOL_OPERATION"] =  drillop;
      jsonData["COL_DISPNAME"] =  dispName;
      jsonData["DRILLCOL_DISPNAME"] =  drillcolDispName;
      jsonData["PARENT_OBJID"] =  pObjId;
      jsonData["DRILLCOL_PARENTOBJID"] =  drillParentId;
      arrJson.push(jsonData);
      return JSON.stringify(arrJson);
           
  }
  
// Date column related 
this.updateDtDrillFlow = function(jsondrillFlow,drillDlg,enabledOp)
  {
    var jObj = jsondrillFlow;
    var enabledOpArr = (enabledOp==null || !enabledOp)? [] : enabledOp.split(",");
     for(var j in jObj)
      {
        var op = j;
        if(!(jQuery.inArray( op, enabledOpArr)<0))
        {
          jQuery(drillDlg).find("input[EnableDrillFlow='true'][OPERATION='"+op+"']").prop("checked",true).change(); //NO I18N
        }
        DrillDownSettings.updateDtDrillFlowByOp(drillDlg, jObj, op);
    }
  }

  this.updateDtDrillFlowByOp = function(drillDlg,jObj,op)
  {
      var dflow = jObj[op];
      var drillFlowHolder = jQuery(drillDlg).find("div[GRPOPERATION="+op+"][drillFlowHolder='true']");
        drillFlowHolder.children("div[donotdelete!='true']").remove(); //NO I18N
        var drillFlowEnd = drillFlowHolder.find("[elname='DrillFlowEnd']");
        var drillComboTpl = ZDBClientUI.ZDBViewEl.view["DRILLFLOWCOMBOTPL"];
        var lastAot;
        var lastop,lastcolId;
        var clonedComboEL;
        for(var i=0;i<dflow.length;i++)
        {
          var flowDet = dflow[i];
          clonedComboEL = drillComboTpl.cloneNode(true);
          ZDBUtil.setNamedChildEls(clonedComboEL,clonedComboEL);  
          lastAot = flowDet[2];
          lastop = flowDet[3];
          lastcolId = flowDet[0];
          DrillDownSettings.setColDetNDispVal(clonedComboEL.compElContainer, flowDet[0],flowDet[1],flowDet[2],flowDet[3],flowDet[4]);
          drillFlowEnd.before(clonedComboEL);
        }        
        if(lastAot==="ABSDATECATEGORICAL" && DrillDownSettings.opVsSt[op].indexOf(lastop)>=0 && drillDlg.colId==lastcolId)
        {
          clonedComboEL = drillComboTpl.cloneNode(true);        
          ZDBUtil.setNamedChildEls(clonedComboEL,clonedComboEL);  
          clonedComboEL.compElContainer.setAttribute("DRILLCOLID",flowDet[0]);
          drillFlowEnd.before(clonedComboEL);
        }
        
        clonedComboEL.arrowEl.style.display = "none";
  }
  this.setDtSubFunction = function(comboList,SubFnlistEl,event,listEl)
  {
    var subFunList = ZDBUtil.getParentWithAttributeValue(SubFnlistEl,"SubFunList", "true");//NO I18N
    var subType = SubFnlistEl.getAttribute("SUBTYPE");
    var op = SubFnlistEl.getAttribute("OPERATION");
    if(!subFunList.parListEl) {subFunList.parListEl = listEl;}
    subFunList.parListEl.setAttribute("SUBTYPE",subType);
    subFunList.parListEl.setAttribute("OPERATION",op);
    var grpLi = jQuery(SubFnlistEl).closest("li[grpop]")[0];
    subFunList.parListEl.setAttribute("GRPOP", grpLi.getAttribute("grpop"));
    ZAComboList.updateDtColName(SubFnlistEl,subFunList.parListEl);
    var func = subFunList.parListEl.getAttribute("valFunc");
    DrillDownSettings[func](comboList,subFunList.parListEl,event);
    ZAComboList.hideSubFuncList(SubFnlistEl);
    
  }
  
  this.setDrillColDtSubFun = function(comboList,SubFnlistEl,event)
  {
    var drillDlg = ZDBDialogUtil.focusDialog.bodyContent;//ZDBUtil.getCachedRef(DrillDownSettings,"ZDBCATDRILLDIALOG"); //No I18N
    var compElContainer = comboList.compElContainer;
     ZDBUtil.setNamedChildEls(compElContainer,compElContainer,"elname");//NO I18N
    var colName = SubFnlistEl.getAttribute("value");//SubFnlistEl.getAttribute("listElcolname");
    var op = SubFnlistEl.getAttribute("OPERATION");
    
    var colId = drillDlg.colId;//SubFnlistEl.getAttribute("colId"); 
    var tblId = drillDlg.gridObj.objId;
    var addontype = SubFnlistEl.getAttribute("addOnType");
    
    DrillDownSettings.checkNUpdtNxtDtDrillFLow(drillDlg, compElContainer,op);
    DrillDownSettings.setColDetNDispVal(compElContainer, colId,tblId,addontype,op,colName);    
  }
  
  this.checkNUpdtNxtDtDrillFLow = function(drillDlg,compElContainer,selectedOp)
  {
    var drillComboEl = DOMUtils.getSelfOrParentWithAttrValue(compElContainer, "elname", "drillComboEl"); //NO I18N
    drillComboEl.arrowEl.style.display = "";
    var jdrillComboEl =jQuery(drillComboEl);
      jdrillComboEl.nextAll("div[elname='drillComboEl']").remove(); //NO I18N
    var drillFlowHolder = DOMUtils.getSelfOrParentWithAttrValue(compElContainer, "drillFlowHolder", "true"); //NO I18N
    var drillFlowEnd = jQuery(drillFlowHolder).find("[elname='DrillFlowEnd']");
    var drillComboTpl = ZDBClientUI.ZDBViewEl.view["DRILLFLOWCOMBOTPL"];
    
    var clonedComboEL = drillComboTpl.cloneNode(true);       
    ZDBUtil.setNamedChildEls(clonedComboEL,clonedComboEL);  
    clonedComboEL.arrowEl.style.display = "none";
    drillFlowEnd.before(clonedComboEL);
  }

  this.updateRSubmitDtDrillColSel = function(el,event)
  {
    var drillDlg = ZDBDialogUtil.focusDialog.bodyContent;
    var cellObj  = drillDlg.cellObj;
    if(cellObj)
    {
     
     var enabledOpEls = jQuery(drillDlg).find("input:checkbox:checked[EnableDrillFlow='true']");
      var selArr = jQuery.map(enabledOpEls, function(inputEl)
    {
      
      return inputEl.getAttribute("OPERATION");
    });
     var enabledOps = selArr.join(",");
     var newVal = DrillDownSettings.getDtDrillFlowAsString(drillDlg)
     var idx = cellObj.rowObj.parGrid.getColumnIndex(drillDlg.colName + 'OPT'); //No i18N
     cellObj.rowObj.values[idx].setValue(enabledOps,enabledOps,false,false,false);
      drillDlg.cellObj = null;
      cellObj.setValue(newVal, cellObj.displayValue, false, false, false);
      ZDBDialogUtil.closeDialog();
    }
    else
    {
      DrillDownSettings.submitDtDrillColSel(el, event);
    }
  }

  this.submitCatDrillColSel = function(el,event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object');
    var drillDlg = ZDBDialogUtil.focusDialog.bodyContent;//ZDBUtil.getCachedRef(DrillDownSettings,"ZDBCATDRILLDIALOG"); //No I18N     
    var compElContainer = drillDlg.compElContainer;    
    var drillColNameEl = drillDlg.DrillColNameDisp; //No I18N
    var colId = drillColNameEl.getAttribute("COLUMN_ID"); 
    var aot = drillColNameEl.getAttribute("ADDONTYPE");
    var op= drillColNameEl.getAttribute("OPERATION");
    var pObjId = drillColNameEl.getAttribute("PARENT_OBJID");
    var dispName = drillColNameEl.getAttribute("COL_DISPNAME");
          
    var catFlow = DrillDownSettings.getCatDrillFlowAsString(colId, aot, op, pObjId, dispName, compElContainer);
      
    var xmlData = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n"+ //NO I18N
    
    "<T FIELDID=\"" + colId + "\" DRILLDOWN=\'" +ZDBEscapeUtil.encodeForXML(catFlow)+ "\'/>"+"</data>"; //No I18N
                   
   DrillDownSettings.validateNupdateDrillDetails(xmlData, gridObj);    
  }
  
  // if second level is none, uncheck drill path
  this.handleDrillPath = function(drillDlg)
  {
      var jDrillDlg = jQuery(drillDlg);
      var datePaths = jDrillDlg.find("div[drillPathSec='true']"); //actual & seasonal path
      for(var i=0; i<datePaths.length; i++)
      {
          var datePathEl = jQuery(datePaths[i]);
          var containerEls = datePathEl.find("div[elname='compElContainer']");
          var len = containerEls.length;
          if(len <= 2)
          {
              var drillOp = containerEls[len-1].getAttribute("drillcoloperation");
              if(drillOp == null || drillOp == "")
              {
                  var checkBoxEl = datePathEl.find("input:checkbox:checked[EnableDrillFlow='true']");
                  checkBoxEl[0].checked = false;
              }
          }
      }
  }
  
  this.submitDtDrillColSel = function(el,event)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(el, 'gridObj','object');
    var drillDlg = ZDBDialogUtil.focusDialog.bodyContent;
    
    DrillDownSettings.handleDrillPath(drillDlg);
    var enabledOpEls = jQuery(drillDlg).find("input:checkbox:checked[EnableDrillFlow='true']");
    var selArr = jQuery.map(enabledOpEls, function(inputEl)
    {
      return inputEl.getAttribute("OPERATION");
    });
    var dtDrillFlow = DrillDownSettings.getDtDrillFlowAsString(drillDlg);
    var xmlData = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n"; //NO I18N
    xmlData+="<T FIELDID=\"" + drillDlg.colId + "\" DRILLDOWN=\'" + ZDBEscapeUtil.encodeForXML(dtDrillFlow) + "\' DRILLDOWNOPT=\'"+selArr.join(",") +"\'/>"; //NO I18N
    xmlData+="</data>"; //No I18N
    DrillDownSettings.validateNupdateDrillDetails(xmlData, gridObj);
  }
  
  this.validateNupdateDrillDetails = function(xmlData,gridObj)
  {
     var url = CommAPI.VALNUPDATEDRILLDET + "&" + gridObj.getGridDetailsAsParams(); //No I18N
    var ajaxOptions = {
      URL:url,
      POSTBODY:xmlData,
      REQUESTHEADERS:{
        "Content-type":"text/xml;charset=utf-8" }, //No I18N
      ONSUCCESSFUNC:DrillDownSettings.handleSuccess, //No I18N
      VIEWCTX:gridObj.viewCtx
      };
    AjaxAPI.sendRequest(ajaxOptions);  
  }
  
  this.getDtDrillFlowAsString = function(drillDlg)
  {
    var jDrillDlg = jQuery(drillDlg);
    var dtJson = [];
    jDrillDlg.find("div[drillPathSec='true']").each(function()
      {
        var enableOp = {};
        var drillPthSec = jQuery(this);
        if(!drillPthSec.find("input[EnableDrillFlow='true']")[0].checked)
        {
          return;
        }
        enableOp[this.getAttribute("OPGRPNAME")] ="true";
        var flowEls = drillPthSec.find("div[elname='compElContainer']");
        flowEls.each(function(index,el){
          var jel = jQuery(el);
          var nextEl = flowEls[index+1];
          if(!nextEl)
            {
              return;
            }
          var drillColId = nextEl.getAttribute("DRILLCOLID");
          var drillColOp = nextEl.getAttribute("DRILLCOLOPERATION");
          if(drillColId!=null && drillColId!="" && drillColOp!=null && drillColOp!="")
          {
              var jNextEl = jQuery(nextEl);
              var jNextEl = jQuery(nextEl);
            var jsonData = {};
            jsonData["COLUMN_ID"] = jel.attr("DRILLCOLID"); //NO I18N
            jsonData["ADDONTYPE"] =  jel.attr("DRILLCOLADDONTYPE"); //NO I18N
            jsonData["OPERATION"] = jel.attr("DRILLCOLOPERATION") ; //NO I18N
            jsonData["DRILL_COLID"] =  jNextEl.attr("DRILLCOLID"); //NO I18N
            jsonData["DRILLCOL_ADDONTYPE"] =  jNextEl.attr("DRILLCOLADDONTYPE");//NO I18N
            jsonData["DRILLCOL_OPERATION"] =  jNextEl.attr("DRILLCOLOPERATION");//NO I18N
            jsonData["COL_DISPNAME"] =  jel.attr("DISPCOLNAME");//NO I18N
            jsonData["DRILLCOL_DISPNAME"] =  jNextEl.attr("DRILLDISPCOLNAME");//NO I18N
            jsonData["PARENT_OBJID"] =  jel.attr("DRILLTBLID");//NO I18N
            jsonData["DRILLCOL_PARENTOBJID"] =  jNextEl.attr("DRILLTBLID");//NO I18N
            dtJson.push(jsonData);
            }
        });
      });
      return JSON.stringify(dtJson);
  }
  
   this.setColDetNDispVal = function(compElContainer,colId,refTblId,addOnType,op,colName)
  {
    ZDBUtil.setNamedChildEls(compElContainer,compElContainer);  
    jQuery(compElContainer).attr({DRILLCOLID:colId,DRILLTBLID:refTblId ? refTblId : "",DRILLCOLADDONTYPE:addOnType,DRILLCOLOPERATION:op,DRILLDISPCOLNAME:colName});
    compElContainer.displaySelected.innerHTML = ZDBEscapeUtil.encodeForHtml(colName);
    compElContainer.displaySelected.setAttribute("value",ZDBEscapeUtil.encodeForHtmlDispChar(colName));
    compElContainer.displaySelected.setAttribute("tip", ZDBEscapeUtil.encodeForHtmlDispChar(colName));
  }
  
  this.resetDrillFlowByOp = function(response,requestOptions)
  {
    var drillDlg = requestOptions["DRILLDLG"];
    var opGrpName = requestOptions["OPGRPNAME"];
    var jObj = JSON.parse(response.responseText);
    var dflow = JSON.parse(jObj["DRILLFLOW"]);
    DrillDownSettings.updateDtDrillFlowByOp(drillDlg, dflow, opGrpName);
    
  }
  this.resetToDefDrillFlow = function(el,event)
  {
    var grpEl = DOMUtils.getSelfOrParentWithAttr(el,"OPGRPNAME"); //NO I18N
    var opGrpName = grpEl.getAttribute("OPGRPNAME");
    var drillDlg = ZDBDialogUtil.focusDialog.bodyContent;
    var gridObj = drillDlg.gridObj;
      var params = "&OBJID="+ gridObj.objId+"&DRILLCOLID="+ drillDlg.colId+"&FETCHGRPOP="+opGrpName; //NO I18N
      var url = CommAPI.RESETDRILLFLOW;
      AjaxAPI.sendRequest({
        URL: url,
        PARAMETERS:params,
        METHOD:"GET", //No I18N
        DRILLDLG:drillDlg,
        OPGRPNAME:opGrpName,
        ONSUCCESSFUNC:DrillDownSettings.resetDrillFlowByOp
        });
  }
  
}// jshint ignore:line


var GRID_DRILLTYPECONSTS = (function () {

var operations = {
  'DATE':"YEAR",//NO I18N
  'DATE_AS_DATE':"YEAR",//NO I18N
  'PLAIN':"GROUPBY",//NO I18N
  'RELCOL':"GROUPBY",//NO I18N
  'REFCOL':"GROUPBY",//NO I18N
  'EMAIL':"GROUPBY",//NO I18N
  'URL':"GROUPBY",//NO I18N        
  'GEO':"GEO"//NO I18N
};

var aot = {
  'DATE':"ABSDATECATEGORICAL",//NO I18N
  'DATE_AS_DATE':"ABSDATECATEGORICAL",//NO I18N
  'PLAIN':"CATEGORICAL",//NO I18N
  'RELCOL':"CATEGORICAL",//NO I18N
  'REFCOL':"CATEGORICAL",//NO I18N
  'EMAIL':"CATEGORICAL",//NO I18N
  'URL':"CATEGORICAL",//NO I18N        
  'GEO':"CATEGORICAL"//NO I18N
};

return {
  getOperation:function(name) {return operations[name];},
  getAddOnType:function(name) {return aot[name];}
};

})();
