//$Id$

var ZCFormatUtil = new function()
{
    window.FISCALYEAR = function(value, datatype, columnInfo)
    {
            return ZCFormatUtil.getFiscalYearVal(value, datatype, columnInfo);
    };
	
    window.ABSWEEKSHORTEXT = function(value, datatype, columnInfo)
    {
        return ZCFormatUtil.getShortValue(value, datatype, columnInfo);
    };

    window.ABSWEEKMEDIUMEXT = function(value, datatype, columnInfo)
    {
        return ZCFormatUtil.getMediumValue(value, datatype, columnInfo);
    };

    window.ABSWEEKLONGEXT = function(value, datatype, columnInfo)
    {
        return ZCFormatUtil.getLongValue(value, datatype, columnInfo);
    };
    
    window.ABSQUARTERFMT = function(value, datatype, columnInfo) // Don't need all methods .. needs code cleanup
    {
    	 return ZCFormatUtil.getFormattedQuarterVal(value, datatype, columnInfo, "format"); // No I18n
    };
    
    window.ABSQUARTERFMT_AXIS = function(value, datatype, columnInfo) // Don't need all methods .. needs code cleanup
    {
    	 return ZCFormatUtil.getFormattedQuarterVal(value, datatype, columnInfo, "axisformat"); // No I18n
    };
    
    window.ABSQUARTERFMT_TOOLTIP = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.getFormattedQuarterVal(value, datatype, columnInfo, "tooltipformat"); // No I18n
    }
    
    window.ABSQUARTERFMT_LEGEND = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.getFormattedQuarterVal(value, datatype, columnInfo, "legendformat"); //No I18n
    }
    
    window.FORMAT_DATE_TYPE = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatDateType(value, datatype, columnInfo, "format"); //No I18n
    };
    
    window.FORMAT_DATE_TYPE_AXIS = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatDateType(value, datatype, columnInfo, "axisformat"); //No I18n
    };
    
    window.FORMAT_DATE_TYPE_TOOLTIP = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatDateType(value, datatype, columnInfo, "tooltipformat"); // No I18n
    }
    
    window.FORMAT_DATE_TYPE_LEGEND = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatDateType(value, datatype, columnInfo, "legendformat"); // No I18n
    }
    
    window.FORMAT_NUMBER = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatNumber(value, "numeric", columnInfo); //No I18N
    };
    
    window.FORMAT_NUMBER_AXIS = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatNumber(value, "numeric", columnInfo, "axisformat"); //No I18N
    };
    
    window.FORMAT_NUMBER_TOOLTIP = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatNumber(value, datatype, columnInfo, "tooltipformat"); //No I18N
    };
    
    window.FORMAT_NUMBER_DATALABEL = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatNumber(value, datatype, columnInfo, "datalabelsformat"); //No I18N
    };
    
    window.FORMAT_NUMBER_LEGEND = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatNumber(value, datatype, columnInfo, "legendformat"); //No I18N
    };
    
    window.FORMAT_NUMBER_THRESHOLD = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatNumber(value, datatype, columnInfo, "thresholdformat"); //No I18N
    };
    
    window.FORMAT_NUMBER_TARGETLABEL = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatNumber(value, datatype, columnInfo, "targetLabelformat"); //No I18N
    };
    
    window.FORMAT_NUMBER_STACKLABEL = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatNumber(value, datatype, columnInfo, "stackLabelsformat"); //No I18N
    };
    
    window.FORMAT_RANGE_VALUES = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatRangeValues(value, datatype, columnInfo);
    };
    
    window.FORMAT_RANGE_VALUES_AXIS = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatRangeValues(value, datatype, columnInfo, "axisformat"); //No I18N
    };
    
    window.FORMAT_RANGE_VALUES_TOOLTIP = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatRangeValues(value, datatype, columnInfo, "tooltipformat"); //No I18N
    };
    
    window.FORMAT_RANGE_VALUES_LEGEND = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatRangeValues(value, datatype, columnInfo, "legendformat"); //No I18N
    };
    
    window.FORMAT_BOOLEAN_VALUES = function(value, datatype, columnInfo)
    {
    	return ZCFormatUtil.formatBooleanValues(value, datatype, columnInfo);
    };
    
    window.customAnnotationX = function(chartObj, conf, ele)
    {
    	return ZCFormatUtil.customAnnotationX(chartObj, conf, ele);
    };
    
    window.customAnnotationY = function(chartObj, conf, ele)
    {
    	return ZCFormatUtil.customAnnotationY(chartObj, conf, ele);
    };
    
    window.noDataAnnotation = function(chartObj, conf)
    {
    	return ZCFormatUtil.noDataAnnotation(chartObj, conf);
    };
    
    window.LEGEND_MORE_FOOTER = function(count, chartObj)
    {
    	var data = chartObj.dataObject.data;
    	var msgMore = data.legend.expandable.more;
    	return "+ " + count + " " + msgMore;
    };
    
    window.OnToggle = function(el, legendExpanded, chartObj, iterated)
    {
        var par = el.parentNode;
        var hasLegTitle = chartObj.dataObject.data.legend.title.show;
        var legHeader,legSeries,expandable;
        if(!hasLegTitle)
        {
            legSeries = par.childNodes[0];
            expandable = par.childNodes[1];
        }
        else
        {
            legHeader = par.childNodes[0];
            legSeries = par.childNodes[1];
            expandable = par.childNodes[2];
        }
        var legHeaderHeight = legHeader ? legHeader.clientHeight : 0;
        var data = chartObj.dataObject.data;
        var msgMore = data.legend.expandable.more;
        var msgLess = data.legend.expandable.less;
        var chartHeight = chartObj.chartarea.height;

        var totNumLegs = legSeries.childNodes.length;
        if(totNumLegs != 0)
        {
            var eachLegHeight = legSeries.childNodes[0].offsetHeight;
        }
        if(isNaN(eachLegHeight) && !iterated)
        {
            var element = el.childNodes[0].childNodes[1];
            return OnToggle(element, legendExpanded, chartObj, true);
        }
        
        if(!legendExpanded)
        {
            var height = chartHeight * 0.75; //legend height is 75% of the chart height
            height = Math.floor(height/eachLegHeight)*eachLegHeight;
            if(chartObj.systemConf.legend.vAlign == "center")
            {
                legSeries.style.maxHeight = height + "px";  // No I18N
                var noOfLegsInCont = Math.floor((height)/eachLegHeight);
            }
            else
            {
                var noOfLegsInCont = ZCFormatUtil.getitemCount(legSeries, eachLegHeight);
            }
            var num = totNumLegs - noOfLegsInCont;
            return "+ " + num + " " + msgMore;
        }
        else
        {
        var height = chartHeight * 0.90;  //legend height is 90% of the chart height
        if(height + expandable.clientHeight + legHeaderHeight > chartHeight)
        {
            height = chartHeight - (expandable.clientHeight + legHeaderHeight);
        }
        if(height < eachLegHeight)
        {
            height = eachLegHeight;
        }
        height = Math.floor(height/eachLegHeight)*eachLegHeight;
        if(chartObj.systemConf.legend.vAlign == "center")
        {
            legSeries.style.maxHeight = height + "px";  // No I18N
        }
        return msgLess;
        }
    }

    this.getitemCount = function(legSeries, eachLegHeight)
    {
        var numOfLegends = legSeries.childNodes.length;
        var contHeight = legSeries.offsetHeight;
        var contWidth = legSeries.offsetWidth;
        rowsVisible = Math.floor(contHeight / eachLegHeight);
        var count = 0, eachRowWidth = 0;
        for(var j = 0;j<rowsVisible;j++)
        {
            for(var i = count;i<numOfLegends;i++)
            {
                eachRowWidth += legSeries.childNodes[i].offsetWidth;
                if(eachRowWidth > contWidth)
                {
                    break;
                }
            }
            count = i;
            eachRowWidth = 0;
        }
        return count;
    }
    
    window.FOOTER_POINTS_OVERLAP = function(event, metaInfo, chartObj)
    {
    	var data = chartObj.dataObject.data;
    	var overlapDataIndex = ( data && data.metadata && data.metadata.overlapDataIndex) 
    						? data.metadata.overlapDataIndex : -1;
    	if(overlapDataIndex !== -1 && metaInfo.actData[overlapDataIndex] === 1)
        {
            return data.tooltip.footerContentVal + "!!! Points Overlap"; //Need to do i18N  //No I18N
        }
    	return data.tooltip.footerContentVal;
    };
    
    window.adjustFunnelGap = function(funnelHeight,numOfGaps,chartObj)
    {	// Gap should be directly proportional to the funnel height and inversely proportional to num of slabs
    	var numOfSlabs = numOfGaps + 1;
    	var eachSlabHeight = funnelHeight/numOfSlabs;
    	var percent = 0.1 - numOfSlabs/1000; 		 // 1000 - making the value to be less than 10%. Subtracting from 0.1 is to make it inversely proportional
		var gapHeight = eachSlabHeight*percent*3;   // eachHeight is directly proportional to funnel height. percent is inversely proportional to num of slabs.
		var gap = Math.ceil(gapHeight);			   // 3 is just to increase the gap size
		if(gap > 10) 						      // For values greater than 10, the gap value increases exponentially. so the value is assigned with respect to its range.
		{									     // For eg, if gap = 31, its value will be change to 12
			if(numOfGaps == 1)
			{
				gap = Math.floor(gap/3*2);
			}
			var val = gap <= 15 ? 1 : Math.floor(gap / 15);  // val is assigned 1 for values from 11 to 30, 2 for 31 to 45, 3 for 46 to 60 and so on
			gap = 10 + val;
		}
		return gap;
    }
    
    window.HIGHLIGHT_LINE = function(chartObj)
    {
    	var data = chartObj.dataObject.data;
    	var strokeWidth = data.chart.plot.plotoptions.line.strokeWidth;
    	return {"stroke-width": strokeWidth + 2};//NO I18N
    }

//    window.SHOWLEGENDTOOLTIP = function(e, d, i, chartObj) 
//    {
//    	var ele = chartObj.legendarea.element.selectAll("li")[0][i],
//    	legendComponent = chartObj.legend.component,
//    	legendOptions = chartObj.systemConf.legend;
//    	legendComponent.highlightSeries(ele, d, i, legendOptions, chartObj, true);
//    	legendComponent.highlightItem(ele, d, i, legendOptions, true);
//    	if (ele.offsetWidth < ele.scrollWidth) 
//    	{
//    		console.log("asdasd");
//    		//show tooltip
//    	}
//    }
    
    this.formatToThousand = function(value, datatype, formatConf, columnInfo)
    {
    	value = value / 1000;
    	return ZCFormatUtil.formatToUnit(value, datatype, formatConf, columnInfo, 'K');//No I18N
    };
    
    this.formatToMillion = function(value, datatype, formatConf, columnInfo)
    {
    	value = value / 1000000;
    	return ZCFormatUtil.formatToUnit(value, datatype, formatConf, columnInfo, 'M');//No I18N
    };
    
    this.formatToBillion = function(value, datatype, formatConf, columnInfo)
    {
    	value = value / 1000000000;
    	return ZCFormatUtil.formatToUnit(value, datatype, formatConf, columnInfo, 'B');//No I18N
    };
    
    this.formatNumber = function(value, datatype, columnInfo, type)
    {
    	var formatConf = columnInfo[type] ? columnInfo[type] : columnInfo["format"];
    	var unitsFormat = formatConf["unitsFormat"]; //for K, M , B and Auto formats
    	if(unitsFormat)
		{
    		if(unitsFormat == 'K')
    		{
    			return ZCFormatUtil.formatToThousand(value, datatype, formatConf, columnInfo);
    		}
        	else if(unitsFormat == 'M')
    		{
        		return ZCFormatUtil.formatToMillion(value, datatype, formatConf, columnInfo);
    		}
        	else if(unitsFormat == 'B')
    		{
        		return ZCFormatUtil.formatToBillion(value, datatype, formatConf, columnInfo);
    		}
        	else if(unitsFormat == 'A')
    		{
        		return ZCFormatUtil.formatToAuto(value, datatype, formatConf, columnInfo);
    		}
		}
    	else
		{
    		return ZCFormatUtil.generateFormatSpecifier(formatConf, value, columnInfo, datatype);
		}
    };

    this.formatBooleanValues = function(value, datatype, columnInfo)
    {
    	if(value === "true" || value === true)
		{
    		return "Yes"; //No I18N
		}
    	else if(value === "false" || value === false)
		{
    		return "No"; //No I18N
		}
    };
    
	this.formatRangeValues = function(value, datatype, columnInfo, type)
	{
		if(isNaN(value))
		{
			if(value.indexOf(" to ") != -1)
			{
				var valueArr = value.split(" to ");
				return ZCFormatUtil.formatNumber(valueArr[0], "numeric", columnInfo, type) + " to " + //No I18N
					ZCFormatUtil.formatNumber(valueArr[1], "numeric", columnInfo, type);//No I18N
			}
			else if(value.indexOf(" and") != -1)
			{
				var minValue = value.substring(0, value.indexOf(" and"));
				var belowStr = value.substring(value.indexOf(" and")+4);
				return ZCFormatUtil.formatNumber(minValue, "numeric", columnInfo, type) + " and "+ belowStr; //No I18N
			}
			else if(value.lastIndexOf("above ", 0) == 0)
			{
				var maxValue = value.substring(5);
				return "above " + ZCFormatUtil.formatNumber(maxValue, "numeric", columnInfo, type);  //No I18N
			}
			else if(value.lastIndexOf("Other than ", 0) == 0)
			{
				var maxValue = value.substring(10);
				return "Other than " + ZCFormatUtil.formatNumber(maxValue, "numeric", columnInfo, type);  //No I18N
			}
                        else if(value === "DY_TH" && type === undefined)
                        {
                            return value;
                        }
			alert("Unhandled Format Exception"); //No I18N
		}
		else
		{
			return ZCFormatUtil.formatNumber(value, "numeric", columnInfo, type); //No I18N
		}
	};
    
    this.formatToAuto = function(value, datatype, formatConf, columnInfo)
    {
    	//based on value it will be altered
    	if(value >= 1000000000 || value <= -1000000000)
		{
    		return ZCFormatUtil.formatToBillion(value, datatype, formatConf, columnInfo);
		}
    	else if(value >= 1000000 || value <= -1000000)
		{
    		return ZCFormatUtil.formatToMillion(value, datatype, formatConf, columnInfo);
		}
    	else if(value >= 1000 || value <= -1000)
		{
    		return ZCFormatUtil.formatToThousand(value, datatype, formatConf, columnInfo);
		}
    	else
		{
    		return ZCFormatUtil.formatToUnit(value, datatype, formatConf, columnInfo, '');//No I18N
		}
    };
    
    this.formatToUnit = function(value, datatype, formatConf, columnInfo, metric)
    {
    	ZCFormatUtil.addNewValToProp(formatConf, "suffix", metric); //No I18N 
    	return ZCFormatUtil.generateFormatSpecifier(formatConf, value, columnInfo, datatype);
    };
    
    this.generateFormatSpecifier = function(formatConf, value, columnInfo, datatype)
    {
    	return $ZC.generateFormatSpecifier(formatConf, value, columnInfo, datatype);
    };
    
    this.formatValue = function(colInfo, value, datatype)
    {
    	return $ZC.getFormattedValue(colInfo, value, datatype);
    };
    
    this.formatDateType = function(value, datatype, columnInfo, position)
    {
	    var opr = columnInfo["oprType"];
	    var fmt = columnInfo[position]["dateFmt"] || columnInfo["format"]["dateFmt"];
		switch(opr)
		{
		case "MONTH": // No I18n
			return ZCFormatUtil.formatMonth(value, datatype, columnInfo, fmt);
			return val;
		case "QUARTER": // No I18n
			return ZCFormatUtil.formatQuarter(value, datatype, columnInfo, fmt);
		case "WEEK": // No I18n
			return ZCFormatUtil.formatWeek(value, datatype, columnInfo, fmt);
		case "WEEKDAY": // No I18n
			return ZCFormatUtil.formatWeekDay(value, datatype, columnInfo, fmt);
		case "HOUR": // No I18n
			return ZCFormatUtil.formatHour(value, datatype, columnInfo, fmt);
		}
    }
    
    this.formatMonth = function(value, dataType, columnInfo, fmt)
    {
    	if(fmt == "MMMM")
    	{
    		var monthShrtToLong = {"Jan":"January", "Feb":"February", "Mar":"March", "Apr":"April", "May":"May", "Jun":"June", "Jul":"July", "Aug":"August", "Sep":"September", "Oct":"October", "Nov":"November", "Dec":"December"}; // No I18n
    		return monthShrtToLong[value] != null ? monthShrtToLong[value] : value;
    	}
		return value;
    };
    
    this.formatQuarter = function(value, dataType, columnInfo, fmt)
    {
    	if(fmt == "qqqq")
    	{
    		return value.replace("Q", "Quarter");
    	}
    	return value;
    };
    
    this.formatWeek = function(value, dataType, columnInfo, fmt)
    {
    	if(fmt == "WW")
    	{
    		return value.replace("Week ", "W"); // No I18n
    	}
    	return value;
    };
    
    this.formatWeekDay = function(value, dataType, columnInfo, fmt)
    {
    	if(fmt == "EEEE")
    	{
    		var weekDayShrtToLongMap = {"Sun":"Sunday", "Mon":"Monday", "Tue": "Tuesday", "Wed":"Wednesday", "Thu":"Thursday", "Fri":"Friday", "Sat":"Saturday"}; // No I18n
    		return weekDayShrtToLongMap[value] != null ? weekDayShrtToLongMap[value] : value;
    	}
    	return value;
    };
    
    this.formatHour = function(value, dataType, columnInfo, fmt)
    {
    	value = Number(value);
    	if(fmt == "12-h")
    	{
    		if(value == 0)
    		{
    			value = "12 AM"; //No I18n
    		}
    		else if(value == 12)
    		{
    			value = "12 PM"; //No I18n
    		}
    		else if(value > 12)
    		{
    			value = value - 12;
    			value += " PM"; // No I18n
    		}
    		else
    		{
    			value += " AM"; // No I18n
    		}
    	}
    	return value;
    }
    
    this.addNewValToProp = function(obj, prop, newVal)
    {
    	ZCFormatUtil.backUpProp(obj, prop);
    	obj[prop] = newVal + obj["backUp"+prop]; //No I18N 
    };
    
    this.backUpProp = function(obj, prop)
    {
    	if(!obj["backUp"+prop] && obj["backUp"+prop] !== '')
		{
    		obj["backUp"+prop] = obj[prop] ? obj[prop] : ''; //No I18N 
		}
    };
    
    this.getFiscalYearVal = function(value, datatype, columnInfo)
    {
    	var date = new Date(value);
    	//here setStartMonthDateVal is not necessary - so it is not called
    	var fyYear = columnInfo["useUTC"] ? date.getUTCFullYear() : date.getFullYear();
    	return ZCFormatUtil.getFiscalYearFormat(fyYear, columnInfo["fyFormat"], columnInfo["fyPrefix"]);
    };
    
    this.getFormattedFiscalYear = function(date, startMonth, columnInfo, strictFormat)
    {
    	date = ZCFormatUtil.setStartMonthDateVal(date, startMonth, columnInfo["useUTC"]);
        var fyYear = columnInfo["useUTC"] ? date.getUTCFullYear() : date.getFullYear();
        return ZCFormatUtil.getFiscalYearFormat(fyYear, columnInfo["fyFormat"], columnInfo["fyPrefix"], strictFormat);
    };
    
    this.calculateFiscalQuarter = function(date, startMonth, columnInfo)
    {
    	var month = columnInfo["useUTC"] ? date.getUTCMonth() : date.getMonth();
    	month = month >= startMonth ? month - startMonth : month - startMonth + 12;
    	return Math.floor(month/3) + 1;
    };
    
    this.getFormattedQuarterVal = function (value, datatype, columnInfo, position)
    {
    	var date = new Date(Number(value));
    	var dateFmt = columnInfo[position]["dateFmt"] || columnInfo["format"]["dateFmt"]; // No I18n
    	dateFmt = dateFmt.trim().toLowerCase();	
    	var startMonth = columnInfo["startMonth"] == null ? 0 : columnInfo["startMonth"];
    	var useUTC = columnInfo["useUTC"];
    	var isFiscal = columnInfo["FISCAL_QUARTER"];
    	var year,quarter,month;
    	if(isFiscal)
    	{
    		quarter = ZCFormatUtil.calculateFiscalQuarter(date, startMonth, columnInfo);
    		year = ZCFormatUtil.getFormattedFiscalYear(date, startMonth, columnInfo);
    	}
    	else
    	{
    		year = useUTC ? date.getUTCFullYear() : date.getFullYear();
    		year += "";
    		month = useUTC ? date.getUTCMonth() : date.getMonth();
        	quarter = Math.floor(month/3)+1;
    	}
    	var qrFmt = dateFmt.indexOf("qqqq") != -1 ? "Quarter" : "Q" ; // No I18N
    	var formattedYear = dateFmt.indexOf("yyyy") != -1 ? year : ZCFormatUtil.getFormatYear(year, columnInfo["fyPrefix"]);//No I18n
    	var sym = dateFmt.replace("qqqq", "").replace("qq","").replace("yyyy","").replace("yy","");
    	return qrFmt + quarter + sym + formattedYear;
    }
    
    this.getFormatYear = function(year, prefix)
    {
    	if(year.length == 4)
    	{
    		return year.substr(year.length-2, year.length-1);
    	}
    	else if(year.indexOf(prefix) != -1)
    	{
    		var yr = year.substr(year.length-2, year.length-1);
    		return prefix + " " + yr; //No I18n
    	}
    	else
    	{
    		return year;
    	}
    }
    
    this.getShortValue = function(value, datatype, columnInfo)
    {
        var value = ("W" + ZCFormatUtil.getWeek(value, columnInfo) + " " + ZCFormatUtil.getWeekYear(value, columnInfo)); //No I18N
        return value;
    };

    this.getMediumValue = function(value, datatype, columnInfo)
    {
        return ("Week " + ZCFormatUtil.getWeek(value, columnInfo) + " " + ZCFormatUtil.getWeekYear(value, columnInfo)); //No I18N
    };
    
    this.getLongValue = function(value, datatype, columnInfo)
    {
    	var startWeekDay = columnInfo["startWeekDay"];
    	var useUTC = columnInfo["useUTC"];
    	var startMonth = columnInfo["startMonth"];
    	startMonth = startMonth == null ? 0 : startMonth;
    	var weekMode = columnInfo["weekMode"];
    	var date = ZCFormatUtil.getMidDay(new Date(value), startWeekDay, useUTC);
        var date1 = new Date(date);
        var date2 = new Date(date);
        if(useUTC)
    	{
        	date1.setUTCDate(date1.getUTCDate() - 3);
            date2.setUTCDate(date2.getUTCDate() + 3);
    	}
        else
    	{
        	date1.setDate(date1.getDate() - 3);
            date2.setDate(date2.getDate() + 3);
    	}
        var week1 = this.getWeek(new Date(date1), columnInfo);
        var week2 = this.getWeek(new Date(date2), columnInfo);
        var i = 6;
        while(week1 != week2 && i>=0 && weekMode == 2 )
        {
        	var curDate = new Date(value);
        	var currMonth = useUTC ? curDate.getUTCMonth():curDate.getMonth();
        	if(currMonth == startMonth)
        	{
        		date1 = new Date(value);
        		var date = useUTC ? date1.getUTCDate():date1.getDate();
                date2.setDate(date + i);
        	}
        	else
        	{
        		var date = useUTC ? date2.getUTCDate() : date2.getDate();
        		date2.setDate(date - 1);
        	}
        	i = i-1;
        	week1 = this.getWeek(new Date(date1), columnInfo);
        	week2 = this.getWeek(new Date(date2), columnInfo);
        }
        var str = "";
        var monFmt = d3.time.format("%b"); //No I18N
        var month1 = monFmt(date1);
        var month2 = monFmt(date2);
        if(useUTC)
    	{
        	if(month1 == month2)
            {
                str = str + ZCFormatUtil.adjustNumberLessThanTen(date1.getUTCDate()) + " - " + ZCFormatUtil.adjustNumberLessThanTen(date2.getUTCDate()) + " " + month2
                                                            + " " + date2.getUTCFullYear();
            }
            else
            {
                if(date2.getUTCFullYear() == date1.getUTCFullYear())
                {
                    str += ZCFormatUtil.adjustNumberLessThanTen(date1.getUTCDate()) + " " + month1 + " - " + ZCFormatUtil.adjustNumberLessThanTen(date2.getUTCDate())
                                                + " " + month2 + " " + date2.getUTCFullYear();
                }
                else
                {
                    str += ZCFormatUtil.adjustNumberLessThanTen(date1.getUTCDate()) + " " + month1 + " " + date1.getUTCFullYear()
                            + " - " + ZCFormatUtil.adjustNumberLessThanTen(date2.getUTCDate()) + " " + month2 + " " + date2.getUTCFullYear();
                }
            }
    	}
        else
    	{
        	if(month1 == month2)
            {
                str = str + ZCFormatUtil.adjustNumberLessThanTen(date1.getDate()) + " - " + ZCFormatUtil.adjustNumberLessThanTen(date2.getDate()) + " " + month2
                                                            + " " + date2.getFullYear();
            }
            else
            {
                if(date2.getFullYear() == date1.getFullYear())
                {
                    str += ZCFormatUtil.adjustNumberLessThanTen(date1.getDate()) + " " + month1 + " - " + ZCFormatUtil.adjustNumberLessThanTen(date2.getDate())
                                                + " " + month2 + " " + date2.getFullYear();
                }
                else
                {
                    str += ZCFormatUtil.adjustNumberLessThanTen(date1.getDate()) + " " + month1 + " " + date1.getFullYear()
                            + " - " + ZCFormatUtil.adjustNumberLessThanTen(date2.getDate()) + " " + month2 + " " + date2.getFullYear();
                }
            }
    	}
        return str;
    };
    
    this.adjustNumberLessThanTen = function(number)
    {
    	if(number > 0 && number < 10)
		{
    		return "0" + number;
		}
    	return number;
    };
    
    this.getWeek = function (unixTime, formatConf) 
    {  
    	var startDay = formatConf["startWeekDay"];
    	var startMonth = formatConf["startMonth"];
    	var useUTC = formatConf["useUTC"];
    	var weekMode = formatConf["weekMode"];
    	var pvtDay = weekMode == 2 ? 0 : 3; // 0 - get the start day of the given week. 3 - get the mid day of the given week
        var exactDate = ZCFormatUtil.getMidDay(new Date(unixTime), startDay, useUTC, pvtDay);
        var startDate = new Date(exactDate);
        if(startMonth == null)
    	{
        	startMonth = 0;
    	}
        startDate = ZCFormatUtil.setStartMonthDateVal(startDate, startMonth, useUTC);
        // since startMonth will act as a reference - hence calculating as UTC - absolute
		var startVal = startDate.valueOf();
        startDate = ZCFormatUtil.getMidDay(startDate, startDay, useUTC, pvtDay);
        if(startDate.valueOf() < startVal && (weekMode != 2))
    	{
        	if(useUTC)
    		{
        		startDate.setUTCDate(startDate.getUTCDate() + 7);
    		}
        	else
    		{
        		startDate.setDate(startDate.getDate() + 7);
    		}
    	}
        var weekNum = 1 + Math.ceil((exactDate - startDate) / 604800000); // 604800000 = 7 * 24 * 3600 * 1000
        if(weekNum == 53 || weekNum == 54 && weekMode == 2)
        {
        	var date = new Date(unixTime);
        	var currMon = useUTC ? date.getUTCMonth() : date.getMonth();
        	if(currMon == startMonth)
        	{
        		weekNum = 1;
        	}
        }
        return ZCFormatUtil.adjustNumberLessThanTen(weekNum);
    };
    
    this.getWeekYear = function (unixTime, columnInfo, strictFormat)   
    {
    	var startDay = columnInfo["startWeekDay"];
    	var useUTC = columnInfo["useUTC"];
    	var weekMode = columnInfo["weekMode"];
    	var curDate;
    	if(weekMode != 2)
    	{
    		curDate = ZCFormatUtil.getMidDay(new Date(unixTime), startDay, useUTC);
    	}
    	else
    	{
    		curDate = new Date(unixTime);
    	}
    	var startMonth = columnInfo["startMonth"];
    	if(startMonth == null || startMonth == 0)
		{
    		return useUTC ? curDate.getUTCFullYear() : curDate.getFullYear();
		}
    	return ZCFormatUtil.getFormattedFiscalYear(curDate, startMonth, columnInfo, strictFormat);
    };
    
    this.setStartMonthDateVal = function(curDate, startMonth, useUTC)
    {
    	var curMonth = useUTC ? curDate.getUTCMonth() : curDate.getMonth();
    	if(curMonth < startMonth)
    	{
    		if(useUTC)
			{
    			curDate.setUTCFullYear(curDate.getUTCFullYear() - 1);
			}
    		else
			{
    			curDate.setFullYear(curDate.getFullYear() - 1);
			}
    		
    	}
    	if(useUTC)
		{
    		curDate.setUTCDate(1);
    		curDate.setUTCMonth(startMonth);
		}
    	else
		{
    		curDate.setDate(1);
    		curDate.setMonth(startMonth);
		}
    	return curDate;
    };
    
    this.getFiscalYearFormat = function(fyYear, fyFormat, fyPrefix, strictFormat)
    {
    	var fyFormat = strictFormat != null ? strictFormat : fyFormat;
    	var fyPrefix = strictFormat != null ? null : fyPrefix;
    	if(fyFormat == 1)
    	{
        	fyYear = fyYear+1;
    	}
        else if(fyFormat == 2)
    	{
        	var endYr = fyYear+1;
        	var stCentury = Math.floor(fyYear / 100);
        	var endCentury = Math.floor(endYr / 100);
        	fyYear = fyYear%100 < 10 ? ("0"+fyYear%100) : fyYear%100;
        	var endYr = endYr%100 < 10 ? ("0"+endYr%100) : endYr%100;
        	if(stCentury < endCentury)
    		{
        		fyYear = stCentury + "" + fyYear + " - " + endCentury + "" + endYr;
    		}
        	else
    		{
        		fyYear = stCentury + "" + fyYear + " - " + endYr;
    		}
    	}
        if(fyPrefix && fyFormat != 2)
    	{
        	return fyPrefix + " " + fyYear;
    	}
        return fyYear;
    };
    
    this.getMidDay = function(date, startDay, useUTC, pvtDay)
    {
    	if(startDay == null)
    	{
        	startDay = 0; // setting to SUNDAY
    	}
    	var midDay = pvtDay == null || pvtDay == 3 ? 3 : pvtDay;
    	var dayValue = useUTC ? date.getUTCDay() : date.getDay();
    	var dayDiff = (dayValue == startDay) ? 0 : (dayValue - startDay) % 7;
    	if(dayDiff < 0)
		{
    		dayDiff = 7 + dayDiff;
		}
    	if(useUTC)
		{
    		date.setUTCDate(date.getUTCDate() - dayDiff + midDay);
		}
    	else
		{
    		date.setDate(date.getDate() - dayDiff + midDay);
		}
    	return date;
    };
    
    this.setLegendFilter = function(data)
    {
    	if(!data.legend.legFilterInfo)
        {
    		return;
        }
    	var chartData = data.seriesdata.chartdata;
    	var dataArr;
        var ispie = false ;
    	if(chartData && chartData.length === 1 && chartData[0].data.length > 0) //double check
        {
        	dataArr = chartData[0].data[0] && chartData[0].data[0][0] instanceof Array ? chartData[0].data[0] : (chartData[0].data[0].length == 0 ? [] : chartData[0].data);
            ispie = true;
        }
    	else 
		{
    		dataArr = data.seriesdata.chartdata;
		}
        var removedCount = 0;
        var isMultiY = data.legend.legFilterInfo.isMultiY ;
        if(isMultiY == true)
        {
            var legIdArr = data.legend.legFilterInfo["legId"];
            legIdArr.sort(function(a,b){ return parseInt(a) > parseInt(b) ? 1 : -1});
            for(var i=0;i<legIdArr.length;i++)
            {
                var remindx = legIdArr[i];
                if(data.legend.isImgMashup)
                {
                    remindx -= removedCount;
                    dataArr.splice(remindx, 1);
                    data.legend.colors.splice(remindx,1);
                    removedCount++;
                }
                else if(dataArr[remindx])
                {
                    dataArr[remindx].disabled = true;
                }
            }
        }
        else if(ispie)
        {
            var dispvalarr = data.legend.legFilterInfo["dispValue"];
            var filterValArr = data.legend.filterValue;
            var len = filterValArr ? filterValArr.length : 0;
            for(var i=0; i<len; i++)
            {
                chckdispname = filterValArr[i];
                if(dispvalarr.indexOf(chckdispname) > -1)
                {
                    if(data.legend.isImgMashup)
                    {
                        var j = i - removedCount;
                        dataArr.splice(j, 1);
                        data.legend.colors.splice(j,1);
                        removedCount++;
                    }
                    else
                    {
                        dataArr[i].disabled = true;
                    }
                }
            }
        }
        else
        {
        	var dispvalarr = data.legend.legFilterInfo["dispValue"];
        	var chckdispname ;
        	for(var i=0;i<dataArr.length;i++)
        	{
    			chckdispname=dataArr[i]["filterValue"] ;
        		if(dispvalarr.indexOf(chckdispname) > -1)
        		{
        			if(data.legend.isImgMashup)
        			{
        				dataArr.splice(i, 1);
        				data.legend.colors.splice(i,1);
        				i--;
        			}
        			else
        			{
        				dataArr[i].disabled = true
        			}
        		}
        	}

        }
    	
    }
    
    this.setLegendColor = function(data)
    {
    	var nullIdx = -1;
    	if (data.legend.nullSeriesIdx || data.legend.nullSeriesIdx === 0)
    	{
    		nullIdx = data.legend.nullSeriesIdx;
    	}
    	var legColors = data.legend.colors;
    	var len = legColors.length;
        var isSkipIdx = false, skipIdxs = [-1];
        if(data.legend.skipIdxs)
        {
            skipIdxs = data.legend.skipIdxs;
            isSkipIdx = true;
        }
        var skipLen = skipIdxs.length;
        var key = data.ZRCLRPALETTE.KEYS;
    	var palette = data.ZRCLRPALETTE.DETAILS[key.CLRS];
    	var type = data.ZRCLRPALETTE.TYPE;
    	var brtns = data.ZRCLRPALETTE.DETAILS[key.BRTNS];
    	var trans = data.ZRCLRPALETTE.DETAILS[key.TRANS];
    	var subType = data.ZRCLRPALETTE.SUBTYPE;
    	var isLegend = data.legend.title != null;
    	var inHex = false;
    	var clrArray;
    	if (type === "SOLID")
    	{
    		clrArray = ZCFormatUtil.getLegendColorPalleteForSolid(palette, len, brtns, trans, inHex, subType, isLegend);
    	}
    	
    	if (type === "ONE")
    	{
    		var clr = palette.substr(0,7);
    		var isRev = data.ZRCLRPALETTE.DETAILS[key.RGRAD];
    		palette = ZRColorModelUtil.getElevenStepColors(clr, isRev);
    		clrArray = ZCFormatUtil.getLegendColorPalleteForOne(palette, len, brtns, trans, inHex);
    	}
    	if (type === "TWO")
    	{
    		var twoClrs = palette.split(",");
    		var isRev = data.ZRCLRPALETTE.DETAILS[key.RGRAD];
    		var isMerg = data.ZRCLRPALETTE.DETAILS[key.MGRAD];
    		if(len<=11)
    		{
    			palette = ZRColorModelUtil.getTwoColorsMix(twoClrs[0], twoClrs[1], isMerg, isRev, false);
    		}
    		else
    		{
    			var length = len > 22 ? 22 : len;
    			palette = ZRColorModelUtil.getTwoColorsMixForGT11Clrs(twoClrs[0], twoClrs[1], isMerg, isRev, false, length); 
    		}
    		clrArray = ZCFormatUtil.getLegendColorPalleteForTwo(palette, len, brtns, trans, inHex);
    	}
 
    	ZCFormatUtil.setTransForLegendClrs(legColors,clrArray);
    	for (var i = 0, j = 0, k=0; i < len; i++)
    	{
            if(isSkipIdx && k < skipLen && i === skipIdxs[k])
            {
                k++;
                if(nullIdx !== i) {
                    j++;
                }
                continue;
            }
    		if (!legColors[i])
    		{
    			legColors[i] = clrArray[j];
    		}
    		if (nullIdx !== i)
    		{
    			j++;
    		}
    	}
        if(isSkipIdx)
        {
            for(var i=skipLen-1; i >= 0; i--) {
                legColors.splice(skipIdxs[i], 1);
            }
        }
    	data.legend.colors = legColors;
    	if(data.legend.colorBand && !data.clrBndCorrection)
		{
    		ZCFormatUtil.correctAndFormatColorBand(data);
		}
    };
    
    this.correctAndFormatColorBand = function(data)
    {
    	ZCFormatUtil.correctRangeValues(data);
    	ZCFormatUtil.formatRangeLabels(data);
    	data.clrBndCorrection = true;
    };
    
    this.correctRangeValues = function(data)
    {
    	var positiveMax = Number.MAX_SAFE_INTEGER || 9007199254740991;
    	var negativeMax = -Number.MAX_SAFE_INTEGER || -9007199254740991;
    	var ranges = data.legend.colorBand.ranges;
    	for(var i = 0; i<ranges.length; i++)
    	{
    		var arr = ranges[i];
    		arr[0] = arr[0] == "negative" ? negativeMax : arr[0];
    		arr[1] = arr[1] == "positive" ? positiveMax : arr[1];
    	}	
    };
    
    this.formatRangeLabels = function(data)
    {
    	var rangeLbls = data.legend.colorBand.labels;
    	var clrIdx = data.metadata.axes.clr;
    	var columnInfo = data.metadata.columns[clrIdx];
    	columnInfo[columnInfo.datatype]["format"].trailingZeros = false;
    	for(var i = 0; i<rangeLbls.length; i++)
    	{
    		rangeLbls[i] = ZCFormatUtil.formatRangeValues(rangeLbls[i], columnInfo.datatype, columnInfo[columnInfo.datatype], "legendformat");
		}
    };
    
    this.getLegendColorPalleteForSolid = function(palette, len, brtns, trans, inHex, subType, isLegend)
    {
        var initClrArr = palette.split(",");
        if(len == 1) // For chart with single legend color
        {
        	if(subType == "DEF" && !isLegend)
        	{
        		return ["#57A9FB"]; // NO i18N
        	}
        	else
        	{
        		var clrArray = [];
        		clrArray[0] = ZRColorModelUtil.getUpdatedColor(initClrArr[0], brtns, trans, inHex);
        		return clrArray;
        	}
        }
        var i;
        for(i=0;i<initClrArr.length;i++)
        {
        	initClrArr[i] = ZRColorModelUtil.getUpdatedColor(initClrArr[i], brtns, trans, inHex);
        }
        
        var clrArray = [];
        while(len > clrArray.length)
    	{
            clrArray = clrArray.concat(initClrArr);
    	}
        return clrArray.slice(0, len);
    };
    
    this.getLegendColorPalleteForOne = function(palette, len, brtns, trans, inHex)
    {
    	var initClrArr = palette.split(",");
    	var clrArrLen = initClrArr.length;
    	if(len > clrArrLen)
    	{
    		var clrArray = [];
    		clrArray = ZRColorModelUtil.getStepColorsUntilWhiteOrBlack(initClrArr[0],17); // in addition to the first color the method returns (len-1) colors --> it would be equal to legend length
    		var i;
    		for(i=0;i<clrArray.length;i++)
    		{
    			clrArray[i] = ZRColorModelUtil.getUpdatedColor(clrArray[i], brtns, trans, inHex);
    		}
    		while(len > clrArray.length)
    		{
    			clrArray = clrArray.concat(clrArray);
    		}

    		return clrArray.slice(0, len);
    	}
    	var factor = Math.round(clrArrLen/len);
    	var i,sum = 0;
    	var clrArr = [];
    	var indexArr = [];
    	for(var j=0;j<len;j++)
    	{
			indexArr[j] = sum;
			sum = sum + factor;
			if(sum>clrArrLen)
			{
				sum = sum - clrArrLen;
			}
    	}
    	indexArr.sort(function(a, b){return a-b});
    	for(i=0;i<len;i++)
    	{
    		clrArr[i] = ZRColorModelUtil.getUpdatedColor(initClrArr[indexArr[i]], brtns, trans, inHex);
    		sum = sum+factor;
    		if(sum>clrArrLen)
    			{
    			sum = sum - clrArrLen;
    			}
    	}
    	return clrArr;
    };
    
    this.getLegendColorPalleteForTwo = function(palette, len, brtns, trans, inHex)
    {
    	var initClrArr = palette.split(",");
    	if(len == 1) // // For chart with single legend color
    	{
    		var clrArray = [];
    		clrArray[0] = ZRColorModelUtil.getUpdatedColor(initClrArr[0], brtns, trans, inHex);
    		return clrArray;
    	}
    	var clrArrLen = initClrArr.length;
    	if(len >= clrArrLen)
    	{
    		var i;
            for(i=0;i<initClrArr.length;i++)
            {
            	initClrArr[i] = ZRColorModelUtil.getUpdatedColor(initClrArr[i], brtns, trans, inHex);
            }
            
            var clrArray = [];
            while(len > clrArray.length)
        	{
                clrArray = clrArray.concat(initClrArr);
        	}
            return clrArray.slice(0, len);
    	}
    	var indexArr = [];
    	var clrArr = [];
    	indexArr[0] = 0;
    	indexArr[len-1] = clrArrLen-1;
    	var factor = Math.round(clrArrLen/len);
    	var sum1 = 0, sum2 = clrArrLen;
    	for(i=0;i<len-2;)
    	{
    		if(i % 2 == 0)
    		{
    			sum1 = sum1 + factor + 1;
    		indexArr[++i] = sum1;
    		
    		}
    		else
    		{
    			sum2 = sum2 - factor - 1;
    		indexArr[++i] = sum2;
    		}
   		}
    	var j =0;
    	indexArr.sort(function(a, b){return a-b});
    	for(;j<len;j++)
    		{
    		clrArr[j] = ZRColorModelUtil.getUpdatedColor(initClrArr[indexArr[j]], brtns, trans, inHex);
    		}
    	return clrArr;
    };
    
    this.customAnnotationX = function(chartObj, conf, ele)
    {
        var bound = ele.getBoundingClientRect();
        return chartObj.plotarea.left+ (chartObj.plotarea.width/2) - (bound.width/2);
    };
    
    this.customAnnotationY = function(chartObj, conf, ele)
    {
        var bound = ele.getBoundingClientRect();
        return chartObj.plotarea.top + (chartObj.plotarea.height/2) - (bound.height/2);
    };

    this.noDataAnnotation = function(chartObj, conf)
    {
        if(!chartObj.nochartdata)
        {
            if(chartObj.isAxisCategory || chartObj.dataObject.isPolarAxisCategory || chartObj.dataObject.hasLevelMarker)
            {
                var yCount = chartObj.axes.y.groups.length;
                for(var i=0; i < yCount; i++)
                {
                    var range = chartObj.axes.y.groups[i].scale.domain();
                    //this should be the fix
                    if(range[0] != 0 || range[1] != 0)
                    {
                        return "";
                    }
                }
                return chartObj.systemConf.noDataHandler.text;
            }
            else
            {
                var total = 0;
                if (chartObj.dataObject.isNonAxisMultiSeriesCategory) {
                    total = d3.max(chartObj.dataObject.seriesExtermes[0], function(d) {
                        return d[1];
                    });
                }
                else
                {
                    var d = chartObj.seriesdata[0].data[0],
                        dataset = chartObj.dataset,
                        yaxiscolumnorder = chartObj.seriesdata[0].yaxiscolumnorder[0],
                        ycol = chartObj.systemConf.metadata.axes.y[0][0],
                        col = chartObj.systemConf.metadata.columns[ycol];
                    total = d.reduce(function(prev,cur,i){return prev+(cur.disabled ? 0 :
                                            Math.abs(dataset.getY(cur,yaxiscolumnorder)))},0);
                }
                if (!total) {
                    return chartObj.systemConf.noDataHandler.text;
                }
            }
        }
        return "";
    };
    
    this.setTransForLegendClrs = function(legColors,clrArray)
    {
    	var sampleClr = clrArray[0];
    	if(sampleClr != null)
    	{
    		var isRGB = ZRColorModelUtil.isRGB(sampleClr);
    		if(isRGB)
    		{
    			var transparency = isRGB[3];
    			transparency = (1-transparency)*100;
    			for(var i=0;i<legColors.length;i++)
    			{
    				if(legColors[i] != null)
    				{
    					legColors[i] = ZRColorModelUtil.getUpdatedColor(legColors[i],50,transparency,false);

    				}
    			}
    		}
    	}
    	return legColors;
    };

    // adjust the threshold label displayed on top of chart based on width of chart
    this.setTholdLabelWidth = function(data, width, tholdLabel, chartContainer)
    {
        var isTholdLabel = data.notes && data.notes.blockValues && data.notes.blockValues[0].vAlign === "top";
        if(isTholdLabel)
        {
            if(!tholdLabel) {
                tholdLabel = data.notes.blockValues[0].htmlEl;
            }
            var htmlEl = tholdLabel;
            var regEx = /<span style='padding-left:5px'>/g;
            var spanEl = "<span style='padding-left:5px'>";
            var spanElLen = spanEl.length;
            var strIdx=0, endIdx=0;
            var closeTag = "</span></div>";
            var newEl = "";
            var result, plotWidth;
            var legend = data.legend;
            var hasLegend = (legend && (legend.hAlign === "right" || legend.hAlign === "left") && //No I18N
                                   legend.vAlign === "center" && legend.enabled === undefined); //No I18N
            if(width)
            {
                plotWidth = hasLegend ? (width - width * .25) : width;
            }
            else
            {
                var chartComp = jQuery(chartContainer).find('.canvas-component');
                if(chartComp.length === 0)
                {
                    var containerWidth = chartContainer.offsetWidth;
                    plotWidth = containerWidth;
                    if(hasLegend) {
                        plotWidth -= plotWidth * .15;
                    }
                }
                else
                {
                    plotWidth = chartContainer.offsetWidth;
                    if(hasLegend)
                    {
                        var legWidth = jQuery(chartContainer).find('.legendarea')[0].offsetWidth;
                        plotWidth -= (plotWidth === legWidth) ? (plotWidth * .15) : legWidth;
                    }
                }
            }
            var maxWidth = (plotWidth / ((htmlEl.match(regEx)).length * 6)) - 4;
            while ((result = regEx.exec(htmlEl)))
            {
                var idx = result.index;
                endIdx = htmlEl.indexOf(closeTag, idx);
                var label = htmlEl.substring(idx + spanElLen, endIdx);
                if(label.length > maxWidth) {
                    label = label.substring(0, maxWidth) + "...";
                }
                newEl += htmlEl.substring(strIdx, idx);
                
                var lblEl = spanEl + label + closeTag;
                newEl += lblEl;
                strIdx = endIdx + closeTag.length;
            }
            newEl += "</div>";
            data.notes.blockValues[0].htmlEl = newEl;
        }
    };
};

function ZDBJSCDynThreshold_initChart(error, chart)
{
    var dynSeriesPos = chart.userdata.seriesdata.DYN_THRESHOLD_SERIES;
    var lastSeries = chart.seriesdata.length-1;
    var symbol = (chart.axes && chart.axes.rotated) ? "vertical-line" : "line"; //No I18N
    for(var i=0; i<dynSeriesPos; i++)
    {
        var series = chart.seriesdata[lastSeries],
            scale = chart.barscale1;

        var isDynThold = (series.seriesname === "DY_TH" && series.hideInLegend); //No I18N
        if(scale && isDynThold)
        {
            var commonPlotoptions = series.plotoptions = {
                "datalabels": {}, //No I18N
                "marker": {},  //No I18N
                "hoveroptions": {}, //No I18N
                "animation": {}, //No I18N
                "events": {} //No I18N
            };
            var bandWidth = scale.rangeBand();
            var maxBandWidth = chart.systemConf.chart.plot.plotoptions.bar.maxBandWidth;
            if(maxBandWidth < bandWidth) {
                bandWidth = maxBandWidth;
            }
            var BW = bandWidth / 10;
            commonPlotoptions.datalabels.show = false;
            commonPlotoptions.marker.symbol = symbol;
            commonPlotoptions.marker.size = BW;
            commonPlotoptions.marker.innerStrokeOpacity = 0;
            commonPlotoptions.marker.outerStrokeWidth = series.strokeWidth;
            commonPlotoptions.marker.outerDashStyle = series.dashStyle;
            commonPlotoptions.hoveroptions.symbol = symbol;
            commonPlotoptions.hoveroptions.size = BW / 2;
            commonPlotoptions.hoveroptions.outerStrokeWidth = 4;
            commonPlotoptions.hoveroptions.innerStrokeOpacity = 0;
            //commonPlotoptions.hoveroptions.outerDashStyle = series.dashStyle;
            commonPlotoptions.animation.enabled = false;
            commonPlotoptions.events.click = null;
            commonPlotoptions.events.tap = null;
            //commonPlotoptions.datalabels.padding = -bandWidth;
        }
        else
        {
            var commonPlotoptions = chart.systemConf.chart.plot.plotoptions.scatter,
            scale = chart.barscale1;
            if(scale && commonPlotoptions && isDynThold)
            {
                var bandWidth = scale.rangeBand();
                var BW = bandWidth / 10;
                commonPlotoptions.marker.symbol = symbol;
                commonPlotoptions.marker.size = BW;
                commonPlotoptions.hoveroptions.symbol = symbol;
                commonPlotoptions.hoveroptions.size = BW / 2;
                commonPlotoptions.hoveroptions.outerStrokeWidth = 4;
                commonPlotoptions.animation.enabled = false;
                //commonPlotoptions.datalabels.padding = -bandWidth;
            }
        }
        --lastSeries;
    }
}

(function(exports) {
    'use strict';

    var define = function(constructor, factory, prototype) {
        constructor.prototype = factory.prototype = prototype;
        prototype.constructor = constructor;
    };

    function extend(parent, definition) {
        var prototype = Object.create(parent.prototype);
        for (var key in definition) prototype[key] = definition[key];
        return prototype;
    }

    function Color() {
    }

    var darker = 0.7;
    var brighter = 1 / darker;

    var reI = "\\s*([+-]?\\d+)\\s*";
    var reN = "\\s*([+-]?\\d*\\.?\\d+(?:[eE][+-]?\\d+)?)\\s*";
    var reP = "\\s*([+-]?\\d*\\.?\\d+(?:[eE][+-]?\\d+)?)%\\s*";
    var reHex3 = /^#([0-9a-f]{3})$/;
    var reHex6 = /^#([0-9a-f]{6})$/;
    var reRgbInteger = new RegExp("^rgb\\(" + [reI, reI, reI] + "\\)$");
    var reRgbPercent = new RegExp("^rgb\\(" + [reP, reP, reP] + "\\)$");
    var reRgbaInteger = new RegExp("^rgba\\(" + [reI, reI, reI, reN] + "\\)$");
    var reRgbaPercent = new RegExp("^rgba\\(" + [reP, reP, reP, reN] + "\\)$");
    var reHslPercent = new RegExp("^hsl\\(" + [reN, reP, reP] + "\\)$");
    var reHslaPercent = new RegExp("^hsla\\(" + [reN, reP, reP, reN] + "\\)$");

    var named = {};

    define(Color, color, {
        displayable: function() {
            return this.rgb().displayable();
        },
        toString: function() {
            return this.rgb() + "";
        }
    });

    function color(format) {
        var m;
        format = (format + "").trim().toLowerCase();
        return (m = reHex3.exec(format)) ? (m = parseInt(m[1], 16), new Rgb((m >> 8 & 0xf) | (m >> 4 & 0x0f0), (m >> 4 & 0xf) | (m & 0xf0), ((m & 0xf) << 4) | (m & 0xf), 1)) // #f00
            : (m = reHex6.exec(format)) ? rgbn(parseInt(m[1], 16)) // #ff0000
                : (m = reRgbInteger.exec(format)) ? new Rgb(m[1], m[2], m[3], 1) // rgb(255, 0, 0)
                    : (m = reRgbPercent.exec(format)) ? new Rgb(m[1] * 255 / 100, m[2] * 255 / 100, m[3] * 255 / 100, 1) // rgb(100%, 0%, 0%)
                        : (m = reRgbaInteger.exec(format)) ? rgba(m[1], m[2], m[3], m[4]) // rgba(255, 0, 0, 1)
                            : (m = reRgbaPercent.exec(format)) ? rgba(m[1] * 255 / 100, m[2] * 255 / 100, m[3] * 255 / 100, m[4]) // rgb(100%, 0%, 0%, 1)
                                : (m = reHslPercent.exec(format)) ? hsla(m[1], m[2] / 100, m[3] / 100, 1) // hsl(120, 50%, 50%)
                                    : (m = reHslaPercent.exec(format)) ? hsla(m[1], m[2] / 100, m[3] / 100, m[4]) // hsla(120, 50%, 50%, 1)
                                        : named.hasOwnProperty(format) ? rgbn(named[format])
                                            : format === "transparent" ? new Rgb(NaN, NaN, NaN, 0)
                                                : null;
    }

    function rgbn(n) {
        return new Rgb(n >> 16 & 0xff, n >> 8 & 0xff, n & 0xff, 1);
    }

    function rgba(r, g, b, a) {
        if (a <= 0) r = g = b = NaN;
        return new Rgb(r, g, b, a);
    }

    function rgbConvert(o) {
        if (!(o instanceof Color)) o = color(o);
        if (!o) return new Rgb;
        o = o.rgb();
        return new Rgb(o.r, o.g, o.b, o.opacity);
    }

    function rgb(r, g, b, opacity) {
        return arguments.length === 1 ? rgbConvert(r) : new Rgb(r, g, b, opacity == null ? 1 : opacity);
    }

    function Rgb(r, g, b, opacity) {
        this.r = +r;
        this.g = +g;
        this.b = +b;
        this.opacity = +opacity;
    }

    define(Rgb, rgb, extend(Color, {
        brighter: function(k) {
            k = k == null ? brighter : Math.pow(brighter, k);
            return new Rgb(this.r * k, this.g * k, this.b * k, this.opacity);
        },
        darker: function(k) {
            k = k == null ? darker : Math.pow(darker, k);
            return new Rgb(this.r * k, this.g * k, this.b * k, this.opacity);
        },
        rgb: function() {
            return this;
        },
        displayable: function() {
            return (0 <= this.r && this.r <= 255)
                && (0 <= this.g && this.g <= 255)
                && (0 <= this.b && this.b <= 255)
                && (0 <= this.opacity && this.opacity <= 1);
        },
        toString: function() {
            var a = this.opacity;
            a = isNaN(a) ? 1 : Math.max(0, Math.min(1, a));
            return (a === 1 ? "rgb(" : "rgba(")
                + Math.max(0, Math.min(255, Math.round(this.r) || 0)) + ", "
                + Math.max(0, Math.min(255, Math.round(this.g) || 0)) + ", "
                + Math.max(0, Math.min(255, Math.round(this.b) || 0))
                + (a === 1 ? ")" : ", " + a + ")");
        }
    }));


    // override
    var rgbOriginal = d3.rgb;
    function isRgb(color) {
        return /^rgb/.test(color);
    }

    exports.rgb = function(color) {
        if (!isRgb(color)) {
            color = rgbOriginal(color).toString();
        }
        return rgb(color);
    };

})(d3);
