//$Id$

var ZALegendSettings = new function()
{
    // display legend names in settings dialog
//    this.showLegendNames = function(propSetUtil)
//    {
//        var legendBody = propSetUtil.propSetForm.legendValBody;
//        if(legendBody==null) {
//            return;
//        }
//        var clrOrder = propSetUtil.el.getAttribute("clrOrder");
//        PropSettings.removeUnwantedChilds(legendBody);
//        var view = propSetUtil.view;
//        var isMultiY = view.chartSelectedEl.isMultiY;
//
//        if(propSetUtil.isLegend) {
//            this.displayLegendValues(propSetUtil, !isMultiY, clrOrder);
//        }
//        else {
//            propSetUtil.propSetForm.legendLabelProp.className = "";
//        }
//        if(ZDBLegendTools && ZDBLegendTools.parLegendEl)
//    	{
//        	ZDBLegendTools.parLegendEl = null;
//    	}
//    }
//
//
//    // common to multiy as well as singley-color
//    this.displayLegendValues = function(propSetUtil, disable, clrOrder)
//    {
//        var propSetForm = propSetUtil.propSetForm;
//        propSetForm.legendLblTitle.innerHTML = ZDBI18NMap.g("zrpt.common.analysis.legend.settings.js.legLabel"); //No I18N
//        if(disable)
//        {
//            propSetForm.legendLblProp.style.overflow = "auto";
//            propSetForm.legendLblProp.style.height = "200px";
//            propSetForm.legendLblTitle.innerHTML = ZDBI18NMap.g("zrpt.common.analysis.legend.settings.js.legColor"); //No I18N
//        }
//
//        var view = propSetUtil.view;
//        var legendBody = propSetUtil.propSetForm.legendValBody;
//        var legendTr = propSetUtil.propSetForm.legendValTr;
//        var legEls = view.chartArea.legendList.childNodes;
//        var inputEls = new Array();
//        for(var i=0, idx=0; i<legEls.length; i++)
//        {
//            var curLegend = legEls[i];
//            if(!curLegend.getAttribute) {
//                continue;
//            }
//            var legPropEl = ZDBUtil.getCloneNode(legendTr);
//            ZDBUtil.setNamedChildEls(legPropEl, legPropEl);
//            var dispValue = curLegend.getAttribute("value").trim();
//            var instId = curLegend.getAttribute("instid");
//            instId = ZDBAnalysisView.replaceInstKey(propSetUtil.view, instId);
//            var origValue = curLegend.getAttribute("origvalue");
//            legPropEl.legendValText.value = dispValue;
//            legPropEl.legendValText.disabled = disable;
//            legendBody.appendChild(legPropEl);
//            legPropEl.setAttribute("index", idx++);
//            legPropEl.setAttribute("dispValue", dispValue);
//            inputEls.push(legPropEl.legendValText);
//            legPropEl.legendValSpan.setAttribute("dispVal", dispValue);
//
//            var imgEls = curLegend.getElementsByTagName("img");
//            var legClr = imgEls[1].getAttribute("defaultColor");
//            legPropEl.legendColor.style.backgroundColor = legClr;
//            var clrVal = ZDBEscapeUtil.encodeForHtml(ZDBUtil.replaceStr(legClr, "#", ""));
//            legPropEl.legendColor.setAttribute("value", clrVal);
//            legPropEl.setAttribute("legendClr", clrVal);
//            legPropEl.setAttribute("origVal", origValue);
//            legPropEl.setAttribute("instId", instId);
//            legPropEl.legendColor.onclick = function(){ZALegendSettings.displayLegendClrDlg(this, 9);}
//            if(disable) {
//                legPropEl.legendColor.setAttribute("filtervalue", curLegend.getAttribute("filtervalue"));
//            }
//        }
//        if(!disable && clrOrder!=null) {
//            propSetUtil.focusEl = inputEls[parseInt(clrOrder)];
//        }
//        propSetForm.legClrsWarnIcon.style.display = "none";
//    }

    this.disableLegendLabel = function(propSetUtil, disable)
    {
        var propSetForm = propSetUtil.propSetForm;
        if(disable) {
            propSetForm.legendLabelProp.className = "inlineLegUtils alpha";
        }
        else {
            propSetForm.legendLabelProp.className = "inlineLegUtils";
        }

        var legendBody = propSetForm.legendValBody;
        if(legendBody==null) {return;}

        var isMultiY = propSetUtil.view.chartSelectedEl.isMultiY;
        var labelTextDisable = disable;
        if(!isMultiY) {
            labelTextDisable = true;
        }
        var clrDivs = legendBody.getElementsByTagName("div");
        var legendEls = legendBody.getElementsByTagName("Input");
        for(var i=0; i<legendEls.length; i++)
        {
            legendEls[i].disabled = labelTextDisable;
            if(disable) {
                clrDivs[i].onclick = null;
            }
            else {
                clrDivs[i].onclick = function(){ZALegendSettings.displayLegendClrDlg(this, 9);}
            }
        }
    }

    this.displayLegendClrDlg = function(el, type)
    {
        if(el.parentNode.parentNode.getAttribute("origVal") == null || el.getAttribute("filtervalue") == "--NULL--")
        {
            return;
        }
        var currClr = "#" + el.getAttribute("value");
        ZDBColorPalette.fontEventExist = false;
        if(ZDBGlobal.isClrPltEnabled())
        {
        	var callBack = ZALegendSettings.showResetToClrPltOption;
        }
        ZDBColorPalette.showClrPalette(el, currClr, PropSettings.getTitleForColorPalette(type), null, callBack);
    }
    
    this.showResetToClrPltOption = function(el)
    {
    	var legendValTr = ZDBUtil.getParentWithAttributeValue(el, "elname", "legendValTr");
    	var oldLegClr = legendValTr.getAttribute("legendclr");
    	var newLegClr = el.getAttribute("value");
    	var index = legendValTr.getAttribute("index");
    	var view = ZDBClientUI.getViewObj(el, "view");
    	if(oldLegClr != newLegClr)
		{
        	var propSetUtil = view.propSetUtil;
        	var legEls = view.chartObj.getLegendEls();
        	legEls[index].isPltClr = false;
        	var curPlt = propSetUtil.clrPltObj.props.jsonInfo.CURPLT.split("__");
        	var pltType = curPlt[0];
    		propSetUtil.propSetForm.resetKey.style.display = "inline-block";
    		propSetUtil.showCreateClrPltKeyLink();
		}
    	ZALegendSettings.displayWarnIconIfNeeded(view);
    }

    this.displayWarnIconIfNeeded = function(view)
    {
    	var propSetForm = view.propSetUtil.propSetForm;
    	var legEls = view.chartObj.getLegendEls();
    	var isDisplay = true;
    	for(var i=0; i<legEls.length; i++)
    	{
    		if(legEls[i].isPltClr)
    		{
    			isDisplay = false;
    		}
    	}
    	if(isDisplay)
    	{
    		propSetForm.legClrsWarnIcon.style.display = "none";// warn icon removed
    	}
    	else
    	{
    		propSetForm.legClrsWarnIcon.style.display = "none";	
    	}
    }


//    this.removeInValidValues = function(yList, curListProp, spanEls, propSetUtil)
//    {
//    	for(var i=0; i<yList.length; i++)
//        {
//            var instKey = yList[i].getAttribute("INSTKEY");
//            var keyVal = curListProp[instKey]["PVTCOLUMNNAME"];
//            if(!keyVal && keyVal != "" && keyVal != spanEls[i].getAttribute("dispVal"))
//            {
//                delete curListProp[instKey]["PVTCOLUMNNAME"];
//                propSetUtil.setModified();
//            }
//        }
//    }
    this.resetLegendColorsOnPreview = function(el)
    {
    	var view = ZDBClientUI.getViewObj(el, "view");
    	var propSetUtil = view.propSetUtil;
    	var jsonINFO = propSetUtil.clrPltObj.props.jsonInfo;
    	propSetUtil.propSetForm.resetKey.style.display = "none";
    	propSetUtil.propSetForm.createClrPltKey.style.display = "none";
    	propSetUtil.propSetForm.legClrsWarnIcon.style.display = "none";
    	PropSettings.setLegendPreviewOnPltChange(propSetUtil, jsonINFO, true);
    }
    
    this.createPltFrmLegClrs = function(view,value)
    {
    	var propSetUtil = view.propSetUtil;
    	var jsonInfo = propSetUtil.clrPltObj.props.jsonInfo;
    	var curPlt = jsonInfo["CURPLT"].split("__");
    	var pltType = curPlt[0];
    	var plt = curPlt[1];
    	var palettes = jsonInfo["PLTS"];
    	var currPlt  = palettes[pltType][plt];
//    	var key = palettes["KEY"];
//    	var pltBrtns = currPlt[key.BRTNS];
//    	var reqBrtns = 100 - pltBrtns; // if brightness is applied to the plt clrs, it would affect the current color selected. To reverse it first it is updated with opposite brightness
    	var length = 32; //since plt is generated only for the type solid color palette
    	var inHex = true;//the clrs should be in hex form
    	var clrArr = PropSettings.getCurrColorArrayForLegend(pltType,plt,palettes,length, inHex);
    	var legModel = view.chartObj.getLegendModel();
    	var legEls = legModel.getLegendEls();
    	var legLength = legEls.length;
    	var legendLabelProp = propSetUtil.propSetForm.legendLabelProp;
    	var legendValTr = ZDBUtil.getElsWithTagNAttrWithVal(legendLabelProp,"elname","legendValTr","tr");
    	for(var legIdx=0,clrIdx=0;(clrIdx<length) && (legIdx<legLength);legIdx++)
    	{
    		if(legEls[legIdx]["origValue"] == null)
    		{
    			continue;
    		}
    		var legPropEl = legendValTr[legIdx];
    		var clr = "#"+legPropEl.legendColor.getAttribute("value");
    		clrArr[clrIdx++] = clr;
    	}
    	var clrs = clrArr.toString();
    	var pltList = jsonInfo["PLTS"][pltType];
		var pltToDup = pltList[plt];
		var pltKeys = jsonInfo["PLTS"]["KEY"];
		var newCustPlt = [];
		newCustPlt = pltToDup.slice(0);
		newCustPlt[pltKeys.ISDEF] = false;
		newCustPlt[pltKeys.DISPNAME] = value;
		newCustPlt[pltKeys.CLRS] = clrs;
		newCustPlt[pltKeys.BRTNS] = 50; // resetting the brightness to 50 while creating a new palette
		newCustPlt[pltKeys.TRANS] = pltToDup[pltKeys.TRANS];
		var modified = jsonInfo.MODIFIED || {};
		modified.CUSTOMPLT = modified.CUSTOMPLTS || {};
		modified.CUSTOMPLT = newCustPlt;
		jsonInfo.MODIFIED = modified;
		jsonInfo.CURPLT = pltType + '__***CUSTOMPLT***';
		jsonInfo["PLTS"][pltType]["***CUSTOMPLT***"] = newCustPlt;
		var params = [];
		params.push(newCustPlt);
		params.push(pltType);
		return params;
    }
    
    this.sendPltFrmChart = function(view,value)
    {
    	var regex = /[^a-zA-Z0-9-_\s]/;
    	value = value.trim();
		if (regex.test(value)) {
			ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.colormodel.js.namerest"));
			textBox.select();
			return;
		}
		if (value.length > 100 || value.length == 0) {
			ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.colormodel.js.namelenrest"));
			textBox.select();
			return;
		}
		var params = ZALegendSettings.createPltFrmLegClrs(view,value);
		var customPlt = params[0];
		var pltType = params[1];
		var objRef = view.propSetUtil.clrPltObj;
//		AjaxAPI.sendRequest({ URL: "/reportsapi/db/" + ZDBClientUI.dbId + "/SAVENEWCUSTOMPLT",
//			PARAMETERS: "CUSTOMPALETTE=" + encodeURIComponent(JSON.stringify(customPlt)) + "&TYPE=" + pltType + "&DBID=" + ZDBClientUI.dbId, // No I18n
//			ONSUCCESSFUNC: objRef.handleSaveCustomPaletteSucc,
//			ONFAILUREFUNC: objRef.handleSaveCustomPaletteFail,
//			ISNEW:true,
//			OPSTATUSID: "ZDBMainLoader" });
                
                ZRSAjax.post('/reportsapi/db/' + ZDBClientUI.dbId + '/SAVENEWCUSTOMPLT', 'CUSTOMPALETTE=' + encodeURIComponent(JSON.stringify(customPlt)) + '&TYPE=' + pltType + '&DBID=' + ZDBClientUI.dbId,{//NO I18n
                    successHandler: {
                        func: objRef.handleSaveCustomPaletteSucc,
                        ctx: objRef
                    },
                    failureHandler: {
                        func: objRef.handleSaveCustomPaletteFail,
                        ctx: objRef
                    },
                    errorHandler: {
                        func: objRef.handleSaveCustomPaletteFail,
                        ctx: objRef
                    },
                    ISNEW: true
                });
                
		objRef.cancelFunc();
		var propSetForm = view.propSetUtil.propSetForm;
		propSetForm.resetKey.style.display = "none";
		propSetForm.createClrPltKey.style.display = "none";
		propSetForm.legClrsWarnIcon.style.display = "none";
		var legModel = view.chartObj.getLegendModel();
    	var legEls = legModel.getLegendEls();
    	for(var i=0;i<legEls.length;i++)
    	{
    		legEls[i].isPltClr = true;
    	}
	   }
    
    this.savePltFrmChart = function(el)
    {
    	var view = ZDBClientUI.getViewObj(el,"view");
    	var curPlt = view.propSetUtil.clrPltObj.props.jsonInfo["CURPLT"].split("__"); //No I18N
    	var pltType = curPlt[0];
    	var plt = curPlt[1];
    	var palettes = view.propSetUtil.clrPltObj.props.jsonInfo["PLTS"];
    	var keys = palettes["KEY"];
    	var pltList = palettes[pltType];
		var name = view.propSetUtil.clrPltObj.getNameForNewPlt(pltList,keys,pltType);
    	var cont = ZRBaseComponentsUtils.getContainer("SavePltDlg", document.body);
		var factory = React.createFactory(SavePltDlg);
		ReactDOM.render(factory({ view:view, isViewMode:true, name: name, saveFunc: this.sendPltFrmChart,
			cancelFunc: view.propSetUtil.clrPltObj.cancelFunc, title: ZDBI18NMap.f("zrpt.dbsettings.colormodel.js.savepltas", "") }), cont);
		view.propSetUtil.clrPltObj.createFreezeLayer();
    }
    
}
