//$Id$
var geoscatter = $ZC.charttype.geoscatter = 23,
    geobubble = $ZC.charttype.geobubble = 22,
    geofilled =  $ZC.charttype.geofilled = 25,
    geopie = $ZC.charttype.geopie = 26,
    geobubblepie = $ZC.charttype.geobubblepie = 27;

$ZC.charttypenames.set($ZC.charttype.geoscatter, "geoscatter");//NO I18N
$ZC.charttypenames.set($ZC.charttype.geobubble, "geobubble");//NO I18N
$ZC.charttypenames.set($ZC.charttype.geofilled, "geofilled");//NO I18N
$ZC.charttypenames.set($ZC.charttype.geopie, "geopie");//NO I18N
$ZC.charttypenames.set($ZC.charttype.geobubblepie, "geobubblepie");//NO I18N
    
$ZC.chartcategory.dotPlot.push(geoscatter,geobubble);

$ZC.chartcategory.piePlot.push(geopie, geobubblepie);

$ZC.mapcharts = function(container,data) {
    
    var chartObj = getMapChartObject(container, data);
        if (chartObj) {
            chartObj.draw();
        }
        return chartObj;
    
};

function getMapChartObject(container, data) {
    if (!document.body.contains(container)) {
        Console.warn("No container");//NO I18N
        return null;
    }
    var dataObj = d3_select(container)
        .datum(data);
    var chart = null;
    
    /*
     * Each chart instance is instantiated with chartRendered flag false
     * chart.initialize is defined in chart-constructor.js
     * */
    dataObj.each(function(data) {
        var chartHolder = d3_select(this);
        chart = new $ZC.mapcharts.get(chartHolder, data); // get chartobj
        chart.initialize(chartHolder, data);
        chart.showLoading(chartHolder);
    });
    return chart;
}

$ZC.mapcharts.get = function(container,data) {
    
    //Override certain functionalities of default chart object. To fix things with mapchart.
    var chart = $ZC.charts.get(container, data);
    var systemconf;
    var map_util = {};
    var map_renderer_util = {};
    var map_series_renderer = {};
    var map_ui_util = {};
    var eventsObject;
    