//$Id$
//ignorei18n_start
var DBSettingsVariableSearchTimer;
var DBSettingsVariableDlg = React.createClass({
	displayName: 'DBSettingsVariableDlg',

	createNewVarClick: function (event) {
		var jsonInfo = this.props.jsonInfo;
		jsonInfo.openCreateDlg = true;
		jsonInfo.newValCount = 1;
		ZRDBSettings.openedDlg++;
		setTimeout(function () {
			this.refs.CreateVariable.refs.varname.select();
		}.bind(this), 300);
		this.props.rerenderComp(jsonInfo);
	},
	editGivenVariable: function (selectedVariable) {
		var jsonInfo = this.props.jsonInfo;
		jsonInfo[selectedVariable.VarId] = {};
		ZRBaseComponentsUtils.combineObjects(jsonInfo[selectedVariable.VarId], selectedVariable);
		jsonInfo.editVarId = selectedVariable.VarId;
		jsonInfo.newValCount = 1;
		jsonInfo.editVar = true;
		jsonInfo.curVarName = selectedVariable.VarName.toLowerCase();
		setTimeout(function () {
			this.refs.CreateVariable.refs.varname.select();
		}.bind(this), 300);
		this.props.rerenderComp(jsonInfo);
	},
	createNewVariable: function (jsonInfo) {
		if (!jsonInfo[jsonInfo.newVariableKey]) {
			jsonInfo[jsonInfo.newVariableKey] = {};
			jsonInfo[jsonInfo.newVariableKey].VarName = "";
			jsonInfo[jsonInfo.newVariableKey].Values = [];
			jsonInfo[jsonInfo.newVariableKey].Values.push({ Value: '', Emails: '', Zaid: ZDBGlobal.ZAID ? ZDBGlobal.ZAID.toString() : '-1' });
			jsonInfo[jsonInfo.newVariableKey].defValues = [];
			jsonInfo[jsonInfo.newVariableKey].defValues.push({ Value: '', Zaid: ZDBGlobal.ZAID ? ZDBGlobal.ZAID.toString() : '-1', Emails: jsonInfo.defaultValueKey });
		}
	},
	getBodyContent: function () {
		var jsonInfo = this.props.jsonInfo;
		var variables = jsonInfo.variables;
		var className = null,
		    display;
		this.createNewVariable(jsonInfo);
		if (jsonInfo.openCreateDlg || jsonInfo.editVar) {
			className = "ZRDBVarCrEdDlg show";
			display = 'block';
		} else {
			className = "ZRDBVarCrEdDlg";
			display = 'none';
		}
		return React.createElement(
			'div',
			{ className: 'ZRDBVarHolder' },
			React.createElement(DBSetVariableListingDlg, {
				ref: 'ListingVariable',
				showToolTips: this.props.showToolTips,
				hideToolTips: this.props.hideToolTips,
				jsonInfo: jsonInfo,
				editGivenVariable: this.editGivenVariable,
				sendVariableReq: this.props.sendVariableReq,
				disableHolder: this.props.disableHolder,
				enableHolder: this.props.enableHolder,
				handleDoSearchForVariables: this.props.handleDoSearchForVariables,
				resetSearchForVariables: this.props.resetSearchForVariables,
				createNewVarClick: this.createNewVarClick,
				rerenderComp: this.props.rerenderComp }),
			React.createElement(DBSetVariableCreateNEditDlg, {
				'class': className,
				ref: 'CreateVariable',
				showToolTips: this.props.showToolTips,
				hideToolTips: this.props.hideToolTips,
				jsonInfo: jsonInfo,
				sendVariableReq: this.props.sendVariableReq,
				rerenderComp: this.props.rerenderComp,
				enableHolder: this.props.enableHolder,
				disableHolder: this.props.disableHolder,
				closeDBSettings: this.props.closeDBSettings,
				createNewVariable: this.createNewVariable }),
			React.createElement('div', { className: 'freezeLayer', style: { position: 'absolute', zIndex: '200', display: display } })
		);
	},
	render: function () {
		var bodyContent = this.getBodyContent();
		return React.createElement(
			'div',
			{ id: 'ZRDBSettingsBodyContentDiv' },
			bodyContent
		);
	}
});
var DBSetVariableListingDlg = React.createClass({
	displayName: 'DBSetVariableListingDlg',

	selectAllVarItems: function (event) {
		var inputs = this.refs.ListingComp.refs.ZRDBVarListingValues.querySelectorAll("li input");
		var target = event.target;
		var style = target.checked ? '#efefee' : '';
		for (var i = 0; i < inputs.length; i++) {
			inputs[i].checked = target.checked;
			inputs[i].parentElement.style.backgroundColor = style;
		}
		this.props.jsonInfo.selectAll = target.checked;
		this.refs.deleteAll.style.display = target.checked ? "" : "none";
	},
	selectVarItem: function (event) {
		var target = event.target;
		var style = target.checked ? '#efefee' : '';
		target.parentElement.style.backgroundColor = style;
		var allSelc = true;
		var inputs = this.refs.ListingComp.refs.ZRDBVarListingValues.querySelectorAll("li input");
		for (var i = 0; i < inputs.length; i++) {
			if (!inputs[i].checked) {
				allSelc = false;
				break;
			}
		}
		if (allSelc) {
			this.refs.selectAllCheckbox.checked = true;
			return;
		}
		this.props.jsonInfo.selectAll = false;
		this.refs.selectAllCheckbox.checked = false;
		inputs = this.refs.ListingComp.refs.ZRDBVarListingValues.querySelectorAll("li input[type='checkbox']:checked");
		this.refs.deleteAll.style.display = inputs.length > 0 ? "" : "none";
	},
	refreshVarList: function (event) {
		if (this.props.jsonInfo.origVariables) {
			this.clearSearch();
		}
		this.refs.selectAllCheckbox.checked = false;
		this.props.sendVariableReq(sideNavComponentArr[2], true, sideNavComponentArr[0]);
	},
	deleteVar: function (event) {
		ZDBToolTip.hide(null, true);
		var varids = "";
		if (this.props.jsonInfo.selectAll) {
			var variables = this.props.jsonInfo.variables;
			variables.forEach(function (variable) {
				if (varids) {
					varids += "," + variable.VarId;
				} else {
					varids = variable.VarId;
				}
			});
		} else {
			var checkedInputs = this.refs.ListingComp.refs.ZRDBVarListingValues.querySelectorAll("li input:checked");
			if (event.target.getAttribute("data-varid")) {
				varids = event.target.getAttribute("data-varid");
			} else {
				varids = checkedInputs.length > 0 ? checkedInputs[0].getAttribute("data-varid") : "";
				if (varids == "") {
					ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.variables.js.delerr"));
					return;
				}
				for (var i = 1; i < checkedInputs.length; i++) {
					var id = checkedInputs[i].getAttribute("data-varid");
					varids += "," + id;
				}
			}
		}

		ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.dbsettings.variables.js.delconf"), "ZDBYESNO", { ONCLICK: this.deleteVarConfirm, VARIDS: varids });
	},
	deleteVarConfirm: function (clickType, requestOptions) {
		if (clickType == "NO") {
			return;
		}
		var varids = requestOptions["VARIDS"];
		var domNode = this.props.disableHolder();
		var params = "VARIDS=" + encodeURIComponent(varids);
		if (requestOptions["DELETEFC"]) {
			params += "&REMOVE_FC=" + requestOptions["DELETEFC"];
		}
		//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId +"/DELETEVARIABLES",
		//							PARAMETERS:params,
		//							ONSUCCESSFUNC:this.handleDeleteVarSuccessResp,
		//							DOMNODE:domNode,
		//							ONFAILUREFUNC:this.handleDeleteVarFailureResp,
		//                    		OPSTATUSID:"ZDBMainLoader",NAVTYPE:sideNavComponentArr[2],
		//                    		VARIDS:varids});
		ZRSAjax.post('/reportsapi/db/' + ZDBClientUI.dbId + '/DELETEVARIABLES', params, {
			successHandler: {
				func: this.handleDeleteVarSuccessResp,
				ctx: this
			},
			failureHandler: {
				func: this.handleDeleteVarFailureResp,
				ctx: this
			},
			DOMNODE: domNode,
			NAVTYPE: sideNavComponentArr[2],
			VARIDS: varids
		});
	},

	handleDeleteVarSuccessResp: function (response, requestOptions) {
		this.props.enableHolder(requestOptions["DOMNODE"]);
		if (Object.keys(response).length > 0) {
			var variableUsage = response;
			ZDBAlertAPI.showMsg("", "ZDBYESNO", { ONCLICK: this.deleteVarConfirm,
				DELETEFC: true, VARIDS: requestOptions["VARIDS"] });
			var zdbmsg = document.getElementById("ZDBMSG");
			ReactDOM.render(React.createElement(DeleteConfirmUsageDeletion, {
				suggestionMsg: ZDBI18NMap.g("zrpt.dbsettings.variables.js.delconfusage"),
				delInfo: variableUsage }), zdbmsg);
			return;
		}
		var jsonInfo = this.props.jsonInfo;
		var variables = jsonInfo.variables;
		var varIDs = requestOptions["VARIDS"].split(",");
		var newVariables = [];
		variables.forEach(function (variable) {
			if (varIDs.indexOf(variable.VarId) == -1) {
				newVariables.push(variable);
			}
		});
		jsonInfo.variables = newVariables;
		if (jsonInfo.origVariables) {
			var newOrigVariables = [];
			jsonInfo.origVariables.forEach(function (variable) {
				if (varIDs.indexOf(variable.VarId) == -1) {
					newOrigVariables.push(variable);
				}
			});
			jsonInfo.origVariables = newOrigVariables;
		}
		this.props.rerenderComp(jsonInfo);
		ZDBMsgBox.showSuccess(ZDBI18NMap.g("zrpt.dbsettings.variables.js.delsucc"));
		if (typeof ZAVMFilter !== 'undefined' && ZAVMFilter.curDBVars) {
			ZAVMFilter.curDBVars = null;
		}
	},
	handleDeleteVarFailureResp: function (response, requestOptions) {
		this.props.enableHolder(requestOptions["DOMNODE"]);
		var msg = response.message ? response.message : ZDBI18NMap.g("zrpt.dbsettings.variables.js.delerr2");
		ZDBMsgBox.showError(msg);
	},
	handleSearch: function (event) {
		clearTimeout(DBSettingsVariableSearchTimer);
		if (event.target.value) {
			value = event.target.value;
			DBSettingsVariableSearchTimer = setTimeout(function () {
				this.doSearch(value);
			}.bind(this), 300);
		}
	},
	doSearch: function (value) {
		this.props.handleDoSearchForVariables(value.toLowerCase());
	},
	clearSearch: function (event) {
		if (!event) {
			this.refs.searchComponent.refs.search.value = "";
			this.refs.searchComponent.refs.clearSearch.className = "ZRSSearchIcon";
		}
		this.props.resetSearchForVariables();
	},
	editVariable: function (event) {
		ZDBToolTip.hide(null, true);
		var target = event.target.getAttribute("data-varid") ? event.target : ZDBUtil.getParentWithAttr(event.target, "data-varid", 5);
		var varid = target.getAttribute("data-varid");
		var selectedVariable;
		var variables = this.props.jsonInfo.variables;
		for (var i = 0; i < variables.length; i++) {
			if (variables[i].VarId == varid) {
				selectedVariable = variables[i];
				break;
			}
		}
		if (selectedVariable.Values) {
			this.props.editGivenVariable(selectedVariable);
			return;
		}
		var domNode = this.props.disableHolder();
		//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId +"/GETUSERVALUEMAPOFVARIABLE",
		//			PARAMETERS:"VARID="+varid,
		//			ONSUCCESSFUNC:this.handleEditVariableSuccess,DOMNODE:domNode,
		//			ONFAILUREFUNC:this.handleEditVariableFailure,
		//    		OPSTATUSID:"ZDBMainLoader",NAVTYPE:sideNavComponentArr[2],
		//    		VARIABLE:selectedVariable});

		ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETUSERVALUEMAPOFVARIABLE', 'VARID=' + varid, {
			successHandler: {
				func: this.handleEditVariableSuccess,
				ctx: this
			},
			failureHandler: {
				func: this.handleEditVariableFailure,
				ctx: this
			},
			errorHandler: {
				func: this.handleEditVariableFailure,
				ctx: this
			},
			DOMNODE: domNode,
			NAVTYPE: sideNavComponentArr[2],
			VARIABLE: selectedVariable
		});
	},
	handleEditVariableSuccess: function (combinedValues, requestOptions) {
		this.props.enableHolder(requestOptions["DOMNODE"]);
		var selectedVariable = requestOptions["VARIABLE"];
		var variableValues = { Values: [], defValues: [] };
		if (Object.keys(combinedValues).length > 0) {
			combinedValues.Values.forEach(function (curVal) {
				if (curVal.Emails.indexOf(this.props.jsonInfo.defaultValueKey) > -1) {
					var emails = curVal.Emails;
					if (emails.length > 1) {
						emails = emails.slice(0);
						emails.splice(emails.indexOf(this.props.jsonInfo.defaultValueKey), 1);
						var temp = [];
						emails.forEach(function (email) {
							temp.push(encodeURIComponent(email));
						});
						var tempObj = { Value: curVal.Value, Zaid: curVal.Zaid, Emails: temp.join(',') };
						variableValues.Values.push(tempObj);
						emails = curVal.Emails;
						emails = emails[emails.indexOf(this.props.jsonInfo.defaultValueKey)];
						curVal.Emails = emails;
						variableValues.defValues.push(curVal);
					} else {
						curVal.Emails = curVal.Emails[0];
						variableValues.defValues.push(curVal);
					}
				} else {
					var temp = curVal.Emails;
					var temp2 = [];
					temp.forEach(function (email) {
						temp2.push(encodeURIComponent(email));
					});
					curVal.Emails = temp2.join(",");
					variableValues.Values.push(curVal);
				}
			}.bind(this));
		}
		ZRBaseComponentsUtils.combineObjects(selectedVariable, variableValues);
		this.props.editGivenVariable(selectedVariable);
	},
	handleEditVariableFailure: function (response, requestOptions) {
		this.props.enableHolder(requestOptions["DOMNODE"]);
		ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.variables.js.getvarvalfail"));
	},
	showImageDesc: function (event) {
		window.open(ZDBI18NMap.g("zrpt.dbsettings.variable.js.help"), "_blank");
	},
	sortByName: function (event) {
		var jsonInfo = this.props.jsonInfo;
		var variables = jsonInfo.variables;
		var tempNameArr = [];
		var tempObj = {};
		variables.forEach(function (variable) {
			tempNameArr.push(variable.VarName);
			tempObj[variable.VarName] = variable;
		});
		var sortFunc = jsonInfo.sort == 'desc' ? this.sortAscending : this.sortDescending;
		tempNameArr.sort(sortFunc);
		var newVariables = [];
		tempNameArr.forEach(function (name) {
			var variable = tempObj[name];
			newVariables.push(variable);
		});
		jsonInfo.variables = newVariables;
		jsonInfo.sort = jsonInfo.sort == "asc" ? "desc" : "asc";
		this.props.rerenderComp(jsonInfo);
	},
	sortAscending: function (a, b) {
		if (a.toLowerCase() < b.toLowerCase()) return -1;
		if (a.toLowerCase() > b.toLowerCase()) return 1;
		return 0;
	},
	sortDescending: function (a, b) {
		if (a.toLowerCase() < b.toLowerCase()) return 1;
		if (a.toLowerCase() > b.toLowerCase()) return -1;
		return 0;
	},
	render: function () {
		var bodyContent;
		var jsonInfo = this.props.jsonInfo;
		var helpDisp = !ZDBClientUI.isCustomDomain ? "block" : "none";
		bodyContent = jsonInfo.variables && jsonInfo.variables.length > 0 || jsonInfo.origVariables ? React.createElement(
			'div',
			{ style: { height: 'calc(100% - 25px)', marginTop: '25px', marginLeft: '40px' } },
			React.createElement(TitleNDesc, { title: ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables"), desc: ZDBI18NMap.f("zrpt.dbsettings.variable.js.whatis", ZDBI18NMap.g("zrpt.dbsettings.variable.js.filtercrit")) }),
			React.createElement(
				'div',
				{ id: 'ZRDBVarListingHeader', ref: 'ZRDBVarListingHeader' },
				React.createElement(
					'div',
					null,
					React.createElement(
						'a',
						{ className: 'newBtn greenBtn font12', ref: 'createVar',
							onClick: this.props.createNewVarClick, style: { marginBottom: "17px" } },
						ZDBI18NMap.g("zrpt.dbsettings.variables.js.createnewvar")
					),
					React.createElement(
						'a',
						{ className: 'newBtn', onClick: this.refreshVarList, ref: 'refreshList' },
						React.createElement('span', { className: 'iconbg tRefreshIcon' }),
						React.createElement(
							'span',
							null,
							ZDBI18NMap.g("zrpt.common.js.refresh")
						)
					),
					React.createElement(
						'a',
						{ className: 'newBtn', style: { display: "none", padding: "2px 17px" }, onClick: this.deleteVar, ref: 'deleteAll' },
						ZDBI18NMap.g("zrpt.common.emailsch.js.delete")
					),
					React.createElement(SearchComponent, { ref: 'searchComponent',
						holderStyle: { width: '164px', marginRight: "10%", float: "right", marginTop: "6px" },
						inputStyle: { width: '133px' },
						inputChangeHandler: this.handleSearch,
						clearSearch: this.clearSearch,
						placeholder: ZDBI18NMap.g("zrpt.dbsettings.variables.js.searchvar") }),
					React.createElement(
						'div',
						{ style: { position: "absolute", top: "25px", right: "10%", display: !ZDBClientUI.isCustomDomain ? "block" : "none" }, className: 'externalHelp', onMouseOut: this.props.hideToolTips, onMouseMove: this.props.showToolTips, 'data-tip': 'Help Center', onClick: function () {
								window.open(ZDBI18NMap.g("zrpt.dbsettings.variable.js.help"), "_blank");
							} },
						'?'
					),
					React.createElement(
						'ul',
						{ className: 'DBUserSettingsTitleUL', style: { clear: "both", width: "90%" } },
						React.createElement(
							'li',
							{ style: { paddingBottom: "0px" } },
							React.createElement(
								'span',
								{ style: { marginLeft: "5px", width: "3%" } },
								React.createElement('input', { type: 'checkbox', onChange: this.selectAllVarItems, ref: 'selectAllCheckbox' })
							),
							React.createElement(
								'span',
								{ style: { width: "35%" } },
								React.createElement(
									'span',
									null,
									ZDBI18NMap.g("zrpt.dbsettings.variables.js.variable")
								),
								React.createElement('div', { style: { margin: '-5px 0px 0px -7px', display: "inline-block", float: "none", verticalAlign: "middle" }, ref: 'varNameSort', className: jsonInfo.sort == 'desc' ? 'iconbg zr_trashSortDesc' : 'iconbg zr_trashSortAsc', onClick: this.sortByName, 'data-tip': ZDBI18NMap.g("zrpt.dbsettings.js.sortbyname"), onMouseEnter: this.props.showToolTips, onMouseOut: this.props.hideToolTips })
							),
							React.createElement(
								'span',
								{ style: { width: "35%" } },
								ZDBI18NMap.g("zrpt.dbsettings.variables.js.defval")
							)
						)
					)
				)
			),
			React.createElement(DBSetVarListComp, { ref: 'ListingComp',
				jsonInfo: this.props.jsonInfo,
				deleteVar: this.deleteVar,
				selectVarItem: this.selectVarItem,
				editVariable: this.editVariable,
				showToolTips: this.props.showToolTips,
				hideToolTips: this.props.hideToolTips })
		) : React.createElement(
			'div',
			{ id: 'ZRDBVarListingHeader', className: 'createRAddDlgHolder', ref: 'ZRDBVarListingHeader', style: { marginTop: '25px', marginLeft: '40px', border: 'none', padding: '0px' } },
			React.createElement(
				'div',
				{ className: 'createRAddDlgHeader' },
				ZDBI18NMap.g("zrpt.dbsettings.sideNav.js.variables")
			),
			React.createElement(
				'div',
				{ style: { clear: 'both' }, className: 'createRAddDlgDesc' },
				React.createElement(
					'div',
					null,
					React.createElement(
						'span',
						null,
						ZDBI18NMap.f("zrpt.dbsettings.variable.js.whatis", "")
					),
					React.createElement(
						'span',
						null,
						'\xA0',
						React.createElement(
							'b',
							null,
							ZDBI18NMap.g("zrpt.dbsettings.variable.js.filtercrit"),
							'\xA0'
						)
					),
					React.createElement(
						'span',
						null,
						ZDBI18NMap.g("zrpt.dbsettings.variable.js.whereused")
					)
				),
				React.createElement(
					'div',
					{ className: 'ZRSLink', style: { display: helpDisp, paddingTop: '6px' }, onClick: this.showImageDesc },
					ZDBI18NMap.g("zrpt.dbsettings.variable.js.wantknowmore")
				)
			),
			React.createElement(
				'div',
				{ style: { marginBottom: '20px' }, className: 'newBtn greenBtn font15', ref: 'createVar', onClick: this.props.createNewVarClick },
				ZDBI18NMap.g("zrpt.dbsettings.variables.js.createnewvar")
			)
		);
		return React.createElement(
			'div',
			{ style: { marginLeft: '0px', marginTop: '0px', overflow: 'hidden', height: '100%' } },
			bodyContent
		);
	}
});
var DBSetVarListComp = React.createClass({
	displayName: 'DBSetVarListComp',

	getInitialState: function () {
		return {
			limit: 50,
			previousLimit: 0
		};
	},
	increaseLimit: function (event) {
		var target = event.target;
		if (target.scrollTop + target.clientHeight >= target.scrollHeight) {
			this.setState({
				limit: this.state.limit + 50
			});
		}
	},
	componentDidUpdate: function () {
		if (this.props.jsonInfo.selectAll) {
			var inputs = this.refs.ZRDBVarListingValues.querySelectorAll("li input");
			var style = '#efefee';
			for (var i = 0; i < inputs.length; i++) {
				inputs[i].checked = true;
				inputs[i].parentElement.style.backgroundColor = style;
			}
		}
	},
	render: function () {
		var varList = this.props.jsonInfo.variables;
		var varListComp = [];
		for (var i = this.state.previousLimit; i < varList.length && i < this.state.limit; i++) {
			var variable = varList[i];
			var defVal;
			var varDefVal = variable.VarDefVal.split(",");
			if (variable.VarDefVal.length == 0) {
				defVal = "-";
			} else if (varDefVal.indexOf(this.props.jsonInfo.allValKey) != -1) {
				var tempvarDefVal = [];
				varDefVal.forEach(function (defVal) {
					if (defVal == this.props.jsonInfo.allValKey) {
						tempvarDefVal.push(ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.all"));
					} else {
						tempvarDefVal.push(defVal);
					}
				}.bind(this));
				varDefVal = tempvarDefVal;

				defVal = varDefVal.join(",");
			} else {
				defVal = variable.VarDefVal;
			}
			varListComp.push(React.createElement(
				'li',
				{ className: 'ZRDBVarListLi', ref: variable.VarName,
					key: variable.VarId, 'data-varid': variable.VarId,
					onDoubleClick: this.props.editVariable },
				React.createElement('input', { style: { margin: '2px 15px 0px 5px', float: 'left', cursor: 'pointer' },
					'data-varid': variable.VarId, type: 'checkbox',
					onClick: this.props.selectVarItem }),
				React.createElement(
					'div',
					{ 'data-type': 'varname', className: 'fLeft textElipsis',
						style: { width: '35%' } },
					variable.VarName
				),
				React.createElement(
					'div',
					{ 'data-type': 'defval', className: 'fLeft textElipsis',
						style: { width: '20%' } },
					defVal
				),
				React.createElement('span', { className: 'iconbg ZRDBVarRenIcon', 'data-varid': variable.VarId,
					onClick: this.props.editVariable, onMouseEnter: this.props.showToolTips,
					onMouseLeave: this.props.hideToolTips, 'data-tip': ZDBI18NMap.g("zrpt.dbsettings.variables.js.editvar") }),
				React.createElement('span', { className: 'iconbg ZRDBVarDelIcon', 'data-varid': variable.VarId,
					onClick: this.props.deleteVar, onMouseEnter: this.props.showToolTips,
					onMouseLeave: this.props.hideToolTips, 'data-tip': ZDBI18NMap.g("zrpt.userdata.variable.js.delete") })
			));
		}
		return React.createElement(
			'div',
			{ id: 'ZRDBVarListingValues', ref: 'ZRDBVarListingValues', onScroll: this.increaseLimit },
			React.createElement(
				'ul',
				null,
				varListComp
			)
		);
	}
});

var DBSetVariableCreateNEditDlg = React.createClass({
	displayName: 'DBSetVariableCreateNEditDlg',

	componentWillMount: function (event) {
		document.addEventListener("keyup", this.handleCreateDlgClose);
	},
	componentWillUnmount: function () {
		document.removeEventListener("keyup", this.handleCreateDlgClose);
	},
	handleDefValChange: function (event) {
		var jsonInfo = this.props.jsonInfo;
		var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		variable.VarDefVal = event.target.value;
		this.props.rerenderComp(jsonInfo);
	},
	handleDefaultAllValClick: function (event) {
		var jsonInfo = this.props.jsonInfo;
		var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		variable.VarDefVal = event.target.checked ? jsonInfo.allValKey : "";
		this.props.rerenderComp(jsonInfo);
	},
	handleAddNewVal: function (event) {
		var jsonInfo = this.props.jsonInfo;
		var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		if (!(variable.Values.length == 0)) {
			var keyLen = variable.Values.length - 1;
			var key = "__value__" + keyLen;
			var newvalrefs = this.refs[key].refs;
			if (!newvalrefs.newvalcompvalue.refs.defcompinput.value && !(newvalrefs.newvalcompvalue.refs.allvalcheckbox && newvalrefs.newvalcompvalue.refs.allvalcheckbox.checked) && !newvalrefs.newvalcompemails.refs.basecontainer.getAttribute("data-emails")) {
				newvalrefs.newvalcompvalue.refs.defcompinput.focus();
				return;
			}
		}
		var values = variable.Values;
		values.push({ Value: "", Emails: "", Zaid: ZDBGlobal.ZAID ? ZDBGlobal.ZAID.toString() : '-1' });
		this.props.rerenderComp(jsonInfo);
		setTimeout(function () {
			this.focusAddedValComp('val');
		}.bind(this), 0);
	},
	focusAddedValComp: function (added) {
		try {
			var jsonInfo = this.props.jsonInfo;
			var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
			var key = added == 'val' ? "__value__" + (variable.Values.length - 1) : "__defvalue__" + (variable.defValues.length - 1);
			var newvalrefs = this.refs[key].refs;
			newvalrefs.newvalcompvalue.refs.defcompinput.focus();
		} catch (e) {
			//exception since rerendering takes time
		}
	},
	handleAddNewDefVal: function (event) {
		var jsonInfo = this.props.jsonInfo;
		var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		if (!(variable.defValues.length == 0)) {
			var keyLen = variable.defValues.length - 1;
			var key = "__defvalue__" + keyLen;
			var newvalrefs = this.refs[key].refs;
			if (!newvalrefs.newvalcompvalue.refs.defcompinput.value && !(newvalrefs.newvalcompvalue.refs.allvalcheckbox && newvalrefs.newvalcompvalue.refs.allvalcheckbox.checked)) {
				newvalrefs.newvalcompvalue.refs.defcompinput.focus();
				return;
			}
		}
		var values = variable.defValues;
		values.push({ Value: "", Emails: jsonInfo.defaultValueKey, Zaid: ZDBGlobal.ZAID ? ZDBGlobal.ZAID.toString() : '-1' });
		this.props.rerenderComp(jsonInfo);
		setTimeout(function () {
			this.focusAddedValComp('defval');
		}.bind(this), 0);
	},
	removeDefNewValComp: function (event) {
		var jsonInfo = this.props.jsonInfo;
		var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		var key = event.target.getAttribute("data-valkey");
		var value = this.refs[key];

		value.refs.newvalcompvalue.refs.defcompinput.style.boxShadow = '';
		value.refs.newvalcompvalue.refs.defcompinput.style.borderColor = '';
		value.refs.errorIcon.style.display = "none";

		var inputVal = value.refs.newvalcompvalue.refs.defcompinput.value;
		var valueChecked = value.refs.newvalcompvalue.refs.allvalcheckbox && value.refs.newvalcompvalue.refs.allvalcheckbox.checked;
		var selectVal = value.refs.newvalcompselect.refs.BASESELECTCOMPONENT.value;
		var values = variable.defValues.slice(0);
		for (var i = 0; i < values.length; i++) {
			value = values[i];
			var valueCheck = valueChecked ? !inputVal && value.Value == jsonInfo.allValKey : value.Value == inputVal;
			if (valueCheck && value.Zaid == selectVal) {
				values.splice(i, 1);
				break;
			}
		}
		variable.defValues = values;
		this.props.rerenderComp(jsonInfo);
	},
	removeNewValComp: function (event) {
		var inputVals, selectVal, valueChecked;
		var key = event.target.getAttribute("data-valkey");
		var value = this.refs[key];
		inputVals = [value.refs.newvalcompvalue.refs.defcompinput.value, value.refs.newvalcompemails.refs.basecontainer.getAttribute("data-emails")];
		selectVal = value.refs.newvalcompselect.refs.BASESELECTCOMPONENT.value;
		valueChecked = value.refs.newvalcompvalue.refs.allvalcheckbox && value.refs.newvalcompvalue.refs.allvalcheckbox.checked;

		value.refs.newvalcompvalue.refs.defcompinput.style.boxShadow = '';
		value.refs.newvalcompvalue.refs.defcompinput.style.borderColor = '';
		value.refs.newvalcompemails.refs.basecontainer.style.boxShadow = "";
		value.refs.newvalcompemails.refs.basecontainer.style.borderColor = "";
		value.refs.newvalcompemails.refs.basecontainer.nextSibling.style.display = "none";

		var jsonInfo = this.props.jsonInfo;
		var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		var values = variable.Values.slice(0);
		for (var i = 0; i < values.length; i++) {
			var value = values[i];
			var valueCheck = valueChecked ? inputVals[0] == "" && value.Value == jsonInfo.allValKey : value.Value == inputVals[0];
			if (valueCheck && value.Emails == inputVals[1] && value.Zaid == selectVal) {
				values.splice(i, 1);
				break;
			}
		}
		variable.Values = values;
		this.props.rerenderComp(jsonInfo);
	},
	handleCreateDlgClose: function (event) {
		if (event && event.type == "keyup" && event.keyCode !== KEY.ESC) {
			return;
		}
		ZRDBSettings.openedDlg--;
		var jsonInfo = {};
		ZRBaseComponentsUtils.combineObjects(jsonInfo, this.props.jsonInfo);
		if (jsonInfo.openCreateDlg) {
			//create variable case
			var varName = this.refs.varname;
			var errIcon = varName.nextSibling;
			errIcon.style.display = "none";
			varName.style.borderColor = "";
			varName.style.boxShadow = "";
			if (this.refs["__value__0"]) {
				var valueRefs = this.refs["__value__0"].refs;
				valueRefs.errorIcon.style.display = "none";
				valueRefs.newvalcompvalue.refs.defcompinput.style.borderColor = "";
				valueRefs.newvalcompvalue.refs.defcompinput.style.boxShadow = "";
				valueRefs.newvalcompemails.refs.basecontainer.style.borderColor = "";
				valueRefs.newvalcompemails.refs.basecontainer.style.boxShadow = "";
				valueRefs.newvalcompemails.refs.basecontainer.nextSibling.style.display = "none";
			}
			if (this.refs["__defvalue__0"]) {
				var defValueRefs = this.refs["__defvalue__0"].refs;
				defValueRefs.errorIcon.style.display = "none";
				defValueRefs.newvalcompvalue.refs.defcompinput.style.borderColor = "";
				defValueRefs.newvalcompvalue.refs.defcompinput.style.boxShadow = "";
				defValueRefs.newvalcompvalue.refs.defcompinput.nextSibling.style.display = "none";
			}
		}
		delete jsonInfo.openCreateDlg;
		delete jsonInfo.editVar;
		delete jsonInfo.editVarId;
		delete jsonInfo[jsonInfo.newVariableKey];
		delete jsonInfo.curVarName;
		if (jsonInfo.origVariables) {
			delete jsonInfo.variables;
			jsonInfo.variables = jsonInfo.origVariables.slice(0);
		}
		delete jsonInfo.origVariables;

		this.props.createNewVariable(jsonInfo);
		this.props.rerenderComp(jsonInfo);
	},
	nameChange: function (event) {
		var bool = this.validateVName(event);
		if (bool) {
			this.props.rerenderComp(this.props.jsonInfo);
		}
	},
	validateVName: function (event) {
		var target = event.target ? event.target : event;
		var value = target.value;
		var errIcon = target.nextSibling;
		var jsonInfo = this.props.jsonInfo;
		var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		//Length check
		if (value.length > 50) {
			this.showErrorIcon(errIcon, ZDBI18NMap.g("zrpt.dbsettings.variables.js.vnamelen"), target, true);
			return false;
		}
		//blank check
		if (value.length == 0) {
			this.showErrorIcon(errIcon, ZDBI18NMap.g("zrpt.dbsettings.variables.js.vnameempty"), target, true);
			variable.VarName = value;
			this.props.rerenderComp(jsonInfo);
			return false;
		}
		//system check
		if (value.toLowerCase().indexOf("system.") == 0) {
			this.showErrorIcon(errIcon, ZDBI18NMap.g("zrpt.dbsettings.variables.js.vnamesys"), target, true);
			variable.VarName = value;
			this.props.rerenderComp(jsonInfo);
			return false;
		}
		//curly braces check
		var curlyRegex = /[{\}]+/;
		if (curlyRegex.test(value.toLowerCase())) {
			this.showErrorIcon(errIcon, ZDBI18NMap.g("zrpt.dbsettings.variable.js.vcurlerr"), target, true);
			variable.VarName = value;
			this.props.rerenderComp(jsonInfo);
			return false;
		}
		//duplicate check
		var variables = this.props.jsonInfo.variables;
		for (var i = 0; i < variables.length; i++) {
			if (variables[i].VarName.toLowerCase() != this.props.jsonInfo.curVarName && variables[i].VarName.toLowerCase() == value.toLowerCase()) {
				this.showErrorIcon(errIcon, ZDBI18NMap.g("zrpt.dbsettings.variables.js.vnamedup"), target, true);
				variable.VarName = value;
				this.props.rerenderComp(jsonInfo);
				return false;
			}
		}

		//err icon hiding
		errIcon.style.display = "none";
		target.style.boxShadow = "";
		target.style.borderColor = "";

		variable.VarName = value;
		return true;
	},
	showErrorIcon: function (errIcon, errMsg, target, doFocus) {
		errIcon.style.display = "inline-block";
		errIcon.setAttribute("data-tip", errMsg);
		if (target) {
			if (target instanceof Array) {
				target.forEach(function (tar) {
					tar.style.boxShadow = "0px 0px 10px -2px #ea6060";
					tar.style.borderColor = '#ea6060';
				});
			} else {
				target.style.boxShadow = "0px 0px 10px -2px #ea6060";
				target.style.borderColor = '#ea6060';
			}
		}
		if (doFocus && target) {
			target.focus();
		}
	},
	emptyCheck: function (bool) {
		var jsonInfo = this.props.jsonInfo;
		var isEdit = jsonInfo.editVar;
		var variable = isEdit ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		var values = variable.Values;
		var defValues = variable.defValues;
		for (var j = 0; j < values.length; j++) {
			var temp = values[j];
			var key = "__value__" + j;
			var value = this.refs[key];
			var email = value.refs.newvalcompemails.refs.basecontainer;
			var valueEl = value.refs.newvalcompvalue.refs.defcompinput;
			if (!temp.Value || !temp.Emails || !temp.Zaid) {
				if (value) {
					var targetArr = [];
					if (!temp.Value) {
						targetArr.push(valueEl);
					}
					if (!temp.Emails) {
						targetArr.push(email);
					}
					var errorMsg;
					if (!temp.Value && !temp.Emails) {
						errorMsg = ZDBI18NMap.g("zrpt.dbsettings.variables.js.emptyvaluespleaseremove");
					} else if (!temp.Value) {
						errorMsg = ZDBI18NMap.g("zrpt.dbsettings.variables.js.emptyvalue");
					} else if (!temp.Emails) {
						errorMsg = ZDBI18NMap.g("zrpt.dbsettings.variables.js.emptyemail");
					}
					this.showErrorIcon(email.nextSibling, errorMsg, targetArr, false);
					bool = true;
				}
			}
			if (temp.Value) {
				valueEl.style.boxShadow = "";
				valueEl.style.borderColor = '';
			}
			if (temp.Emails) {
				email.style.boxShadow = "";
				email.style.borderColor = '';
			}
			if (temp.Value && temp.Emails && temp.Zaid) {
				email.nextSibling.style.display = "none";
			}
		}
		for (var j = 0; j < defValues.length; j++) {
			var temp = defValues[j];
			var key = "__defvalue__" + j;
			var value = this.refs[key];
			var valueEl = value.refs.newvalcompvalue.refs.defcompinput;
			var select = value.refs.newvalcompselect.refs.BASESELECTCOMPONENT;
			if (!temp.Value || !temp.Emails || !temp.Zaid) {
				if (value) {
					this.showErrorIcon(select.nextSibling, ZDBI18NMap.g("zrpt.dbsettings.variables.js.emptydefvalue"), [valueEl], false);
					bool = true;
				}
			}
			if (temp.Value) {
				valueEl.style.boxShadow = "";
				valueEl.style.borderColor = '';
				select.nextSibling.style.display = "none";
			}
		}
		return bool;
	},
	malformedEmailsCheck: function (bool) {
		var jsonInfo = this.props.jsonInfo;
		var isEdit = jsonInfo.editVar;
		var variable = isEdit ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		var malFormedEmailValues = this.validateEmails(variable.Values);
		malFormedEmailValues.forEach(function (malFormedEmailValue) {
			var i = 0;
			while (true) {
				var key = "__value__" + i;
				var value = this.refs[key];
				if (value) {
					var email = value.refs.newvalcompemails.refs.basecontainer;
					var valueVal = value.refs.newvalcompvalue.refs.defcompinput.value;
					var emailVal = email.getAttribute("data-emails");
					var selectVal = value.refs.newvalcompselect.refs.BASESELECTCOMPONENT.value;
					if ((valueVal == "" && malFormedEmailValue.Value == this.props.jsonInfo.allValKey || valueVal == malFormedEmailValue.Value) && emailVal == malFormedEmailValue.Emails && selectVal == malFormedEmailValue.Zaid) {
						this.showErrorIcon(email.nextSibling, ZDBI18NMap.g("zrpt.dbsettings.variables.js.emailmalformed"), email, false);
						bool = true;
					}
				} else {
					break;
				}

				i++;
			}
		}.bind(this));
		return bool;
	},
	saveVariableAndValues: function (event) {
		var jsonInfo = this.props.jsonInfo;
		var isEdit = jsonInfo.editVar;
		var variable = isEdit ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		variable = ZRBaseComponentsUtils.mergeObjsAndReturnNewObj({}, variable);
		//validations:
		var bool = false;
		//varname
		bool = !this.validateVName(this.refs.varname);

		//Empty values
		bool = this.emptyCheck(bool);
		//email
		bool = this.malformedEmailsCheck(bool);

		if (bool) {
			ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.dbsettings.variable.js.someerror"));
			return;
		}
		//duplication checks
		variable.Values = variable.Values.concat(variable.defValues);
		var values = variable.Values;
		var resultValues = [];
		values.forEach(function (value) {
			if (value.Value && value.Emails && value.Zaid) {
				resultValues.push(value);
			}
		});

		variable.Values = resultValues;
		var domainToValMaps = {};
		values = variable.Values;
		values.forEach(function (value) {
			domainToValMaps[value.Zaid] = domainToValMaps[value.Zaid] ? domainToValMaps[value.Zaid] : {};
			var domainVals = domainToValMaps[value.Zaid];
			domainVals[value.Value] = domainVals[value.Value] ? domainVals[value.Value] : [];
			var valsEmails = domainVals[value.Value];
			var emails = value.Emails.split(",");
			valsEmails = valsEmails.concat(emails);
			valsEmails = ZRBaseComponentsUtils.getUniqueArray(valsEmails);
			domainVals[value.Value] = valsEmails;
		});
		var values = [];
		for (var domain in domainToValMaps) {
			var domainVals = domainToValMaps[domain];
			for (var vals in domainVals) {
				var temp = {};
				temp.Value = vals;
				temp.Emails = domainVals[vals];
				temp.Zaid = domain;
				values.push(temp);
			}
		}
		var emailsToBeAdded = "";
		values.forEach(function (value) {
			var emails = value.Emails.slice(0);
			document.zaidToDomainMap && document.zaidToDomainMap[value.Zaid] && document.zaidToDomainMap[value.Zaid].forEach(function (group) {
				var encodedGroup = encodeURIComponent(group);
				var index = emails.indexOf(encodedGroup);
				if (index != -1) {
					emails.splice(index, 1);
				}
			});
			if (emails.indexOf(jsonInfo.defaultValueKey) > -1) {
				return;
			}
			emails = emails.toLocaleString();
			emailsToBeAdded = emailsToBeAdded ? emailsToBeAdded + "," + emails : emails;
		});
		variable.Values = values;
		var domNode = this.props.disableHolder();
		var varInfo = { VarName: variable.VarName, Values: variable.Values };
		varInfo.Values.forEach(function (val) {
			var temp = [];
			val.Emails.forEach(function (email) {
				temp.push(decodeURIComponent(email));
			});
			val.Emails = temp;
		});
		if (jsonInfo.editVar) {
			var newObjVals = {};
			newObjVals.Values = variable.Values;
			var params = "VARID=" + encodeURIComponent(variable.VarId) + "&VARNAME=" + encodeURIComponent(variable.VarName) + "&VALINFO=" + encodeURIComponent(JSON.stringify(newObjVals));
			//			AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId +"/EDITVARIABLE",
			//							PARAMETERS:params,
			//							ONSUCCESSFUNC:this.handleSaveNewVarCreationSuccess,
			//							ONFAILUREFUNC:this.handleSaveNewVarCreationFailure,
			//							OPSTATUSID:"ZDBMainLoader",DOMNODE:domNode});
			ZRSAjax.post('/reportsapi/db/' + ZDBClientUI.dbId + '/EDITVARIABLE', params, {
				successHandler: {
					func: this.handleSaveNewVarCreationSuccess,
					ctx: this
				},
				failureHandler: {
					func: this.handleSaveNewVarCreationFailure,
					ctx: this
				},
				DOMNODE: domNode
			});
		} else {
			//			AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ ZDBClientUI.dbId +"/CREATEVARIABLE",
			//							PARAMETERS:"VARINFO="+encodeURIComponent(JSON.stringify(varInfo)),
			//							ONSUCCESSFUNC:this.handleSaveNewVarCreationSuccess,
			//							ONFAILUREFUNC:this.handleSaveNewVarCreationFailure,
			//							OPSTATUSID:"ZDBMainLoader",DOMNODE:domNode});

			ZRSAjax.post('/reportsapi/db/' + ZDBClientUI.dbId + '/CREATEVARIABLE', 'VARINFO=' + encodeURIComponent(JSON.stringify(varInfo)), {
				successHandler: {
					func: this.handleSaveNewVarCreationSuccess,
					ctx: this
				},
				failureHandler: {
					func: this.handleSaveNewVarCreationFailure,
					ctx: this
				},
				DOMNODE: domNode
			});
		}
		if (emailsToBeAdded) {
			ZDBSecuritySettings.addNewContactsToIAM(decodeURIComponent(emailsToBeAdded));
		}
	},
	validateEmails: function (values) {
		var malFormed = [];
		for (var j = 0; j < values.length; j++) {
			var value = values[j];
			if (!value.Emails || !value.Value || !value.Zaid) {
				continue;
			}
			var regex = ZDBGlobal.emailRegex;
			var emails = value.Emails.split(",");
			var domains = document.zaidToDomainMap ? document.zaidToDomainMap[value.Zaid] : [];
			domains = domains ? domains : [];
			for (var i = 0; i < emails.length; i++) {
				if (!regex.test(decodeURIComponent(emails[i])) && domains.indexOf(decodeURIComponent(emails[i])) == -1) {
					malFormed.push(values[j]);
				}
			}
		}
		return malFormed;
	},
	handleSaveNewVarCreationSuccess: function () {
		delete this.props.jsonInfo.curVarName;
		this.props.sendVariableReq(sideNavComponentArr[2], true, sideNavComponentArr[0]);
		var msg = this.props.jsonInfo.editVar ? ZDBI18NMap.g("zrpt.dbsettings.variables.js.editsuccess") : ZDBI18NMap.g("zrpt.dbsettings.variables.js.createsuccess");
		ZDBMsgBox.showSuccess(msg);
		if (typeof ZAVMFilter !== 'undefined' && ZAVMFilter.curDBVars) {
			ZAVMFilter.curDBVars = null;
		}
	},
	handleSaveNewVarCreationFailure: function (response, requestOptions) {
		this.props.enableHolder(requestOptions["DOMNODE"]);
		var msg = response.message ? response.message : this.props.jsonInfo.editVar ? ZDBI18NMap.g("zrpt.dbsettings.variables.js.editfailure") : ZDBI18NMap.g("zrpt.dbsettings.variables.js.createfailure");
		//		if(response.code === 70323){
		//                    msg = response.message;
		//		}
		var jsonInfo = this.props.jsonInfo;
		var isEdit = jsonInfo.editVar;
		var variable = isEdit ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		var tempValues = variable.Values.slice(0);
		variable.Values = [];
		tempValues.forEach(function (temp) {
			if (temp.Emails.indexOf(jsonInfo.defaultValueKey) === -1) {
				variable.Values.push(temp);
			}
		});
		this.props.rerenderComp(jsonInfo);
		ZDBMsgBox.showError(msg);
	},
	valuesContainerBlur: function (event) {
		var values = [];
		var defValues = [];
		var i = 0;
		while (true) {
			var indexKey = "__defvalue__";
			var key = indexKey + i;
			if (this.refs[key]) {
				var value = this.refs[key];
				var valueComp = value.refs.newvalcompvalue.refs;
				var valueVal = valueComp.allvalcheckbox && valueComp.allvalcheckbox.checked ? this.props.jsonInfo.allValKey : valueComp.defcompinput.value;
				var valueZaid = value.refs.newvalcompselect.refs.BASESELECTCOMPONENT.value;
				var value = { Value: valueVal, Emails: this.props.jsonInfo.defaultValueKey, Zaid: valueZaid };
				defValues.push(value);
				i++;
			} else {
				break;
			}
		}
		i = 0;
		while (true) {
			var indexKey = "__value__";
			var key = indexKey + i;
			if (this.refs[key]) {
				var value = this.refs[key];
				var valueComp = value.refs.newvalcompvalue.refs;
				var valueVal = valueComp.allvalcheckbox && valueComp.allvalcheckbox.checked ? this.props.jsonInfo.allValKey : valueComp.defcompinput.value;
				var valueEmails;
				if ((!(event.type == "blur") || event.type == "blur" && value.refs.newvalcompemails.refs.input.value) && event.target == value.refs.newvalcompemails.refs.input) {
					valueEmails = value.refs.newvalcompemails.refs.basecontainer.getAttribute("data-emails");
					var inputVal = value.refs.newvalcompemails.refs.input.value;
					if (valueEmails && valueEmails.length > 0 && inputVal && inputVal != " ") {
						valueEmails += ",";
					} else if (inputVal && inputVal != " ") {
						valueEmails = "";
					}
					// inputVal = inputVal.replace(/\s+$/,'');
					inputVal = inputVal.replace(/\r?\n|\r/g, ",");
					inputVal = inputVal.split(",");
					inputVal = inputVal.map(function (email) {
						return encodeURIComponent(email);
					});
					inputVal = inputVal.join(",");
					valueEmails += inputVal;
				} else {
					valueEmails = value.refs.newvalcompemails.refs.basecontainer.getAttribute("data-emails");
					valueEmails = valueEmails ? valueEmails : "";
				}
				var valueZaid = value.refs.newvalcompselect.refs.BASESELECTCOMPONENT.value;
				var value = { Value: valueVal, Emails: valueEmails, Zaid: valueZaid };
				values.push(value);
				i++;
				continue;
			} else {
				break;
			}
		}
		var jsonInfo = this.props.jsonInfo;
		var variables = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		variables.Values = values;
		variables.defValues = defValues;
		this.props.rerenderComp(jsonInfo);
		return true;
	},
	removeEmail: function (event, removeLast) {
		event.stopPropagation();
		var target = event.target;
		var jsonInfo = this.props.jsonInfo;
		var emailToRemove, inputVals, selectVal;
		var key = event.target.getAttribute("data-valRef");
		var value = this.refs[key];
		inputVals = [value.refs.newvalcompvalue.refs.defcompinput.value, value.refs.newvalcompemails.refs.basecontainer.getAttribute("data-emails")];
		selectVal = value.refs.newvalcompselect.refs.BASESELECTCOMPONENT.value;
		emailToRemove = target.getAttribute("data-email");
		valueChecked = value.refs.newvalcompvalue.refs.allvalcheckbox && value.refs.newvalcompvalue.refs.allvalcheckbox.checked;
		var jsonInfo = this.props.jsonInfo;
		var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		var values = variable.Values;
		var valueKey = parseInt(key.replace("__value__", ""));
		var value = variable.Values[valueKey];
		var valueCheck = valueChecked ? inputVals[0] == "" && value.Value == jsonInfo.allValKey : value.Value == inputVals[0];
		if (valueCheck && value.Emails == inputVals[1] && value.Zaid == selectVal) {
			var emails = value.Emails.split(",");
			if (removeLast) {
				emails.splice(emails.length - 1, 1);
			} else {
				emails.splice(emails.indexOf(encodeURIComponent(emailToRemove)), 1);
			}
			value.Emails = emails.join(",");
		}
		variable.Values = values;
		this.props.rerenderComp(jsonInfo);
	},
	editEmail: function (event) {
		var key = event.currentTarget.getAttribute("data-valref");
		var valueKey = parseInt(key.replace("__value__", ""));
		var jsonInfo = this.props.jsonInfo;
		var variable = jsonInfo.editVar ? jsonInfo[jsonInfo.editVarId] : jsonInfo[jsonInfo.newVariableKey];
		var values = variable.Values;
		var value = values[valueKey];
		var emails = value.Emails.split(",");
		var emailToRemove = encodeURIComponent(event.currentTarget.getAttribute("data-email"));
		emails.splice(emails.indexOf(emailToRemove), 1);
		value.Emails = emails.join(",");
		variable.Values = values;
		this.props.rerenderComp(jsonInfo);
		var input = this.refs[key].refs.newvalcompemails.refs.input;
		input.value = decodeURIComponent(emailToRemove);
		input.focus();
	},
	componentDidMount: function () {
		if (!document.contactsString) {
			this.sendContactsReq();
		}
		if (!document.zaidToDomainMap) {
			this.sendZaidToDomainReq();
		}
		if (!document.zohoContacts) {
			this.getZohoContacts();
		}
		if (!document.sharedContacts) {
			this.getSharedContacts();
		}
		if (!document.existingContacts) {
            this.getExistingContacts();
        }
	},
	sendContactsReq: function () {
		AjaxAPI.sendRequest({ URL: "/ZDBSecurityAction.ma", PARAMETERS: "ZDBACTION=GETMYCONTACTS", METHOD: 'GET',
			ONSUCCESSFUNC: this.handleContactsRespSucc,
			ONFAILUREFUNC: this.handleContactsRespFail });
	},
	sendZaidToDomainReq: function () {
		//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ZDBClientUI.dbId+"/GETZAIDVSGROUP",
		//                    ONSUCCESSFUNC:this.handleZaidToDomainSucc,
		//                    ONFAILUREFUNC:this.handleZaidToDomainFail
		//                });
		ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETZAIDVSGROUP', null, {
			successHandler: {
				func: this.handleZaidToDomainSucc,
				ctx: this
			},
			failureHandler: {
				func: this.handleZaidToDomainFail,
				ctx: this
			},
			errorHandler: {
				func: this.handleZaidToDomainFail,
				ctx: this
			}
		});
	},
	handleContactsRespSucc: function (response, requestOptions) {
		document.contactsString = response.responseText;
	},
	handleContactsRespFail: function (response, requestOptions) {
		document.contactsString = "";
	},
	handleZaidToDomainSucc: function (json) {
		document.zaidToDomainMap = json;
	},
	handleZaidToDomainFail: function () {
		document.zaidToDomainMap = null;
	},
	handleAddUsersClick: function (event) {
		ZDBToolTip.hide(null, true);
		this.handleDomainToGroup(event);
		document.currentEmailSel = event.target.parentNode;
		var menuBatches = [];
		var existUsers = [{ value: ZDBI18NMap.g("zrpt.common.js.extusers"), clickEvtHand: this.sharedUsrsShowingFunc }];
		var activeUsers = [{ value: ZDBI18NMap.g("zrpt.common.js.allextusers"), clickEvtHand: this.existingUsrsShowingFunc }];
		var zCont = [{ value: ZDBI18NMap.g("zrpt.common.js.zusers"), clickEvtHand: this.zohoUsrsShowingFunc }];
		var gCont = [{ value: ZDBI18NMap.g("zrpt.common.js.gusers"), clickEvtHand: this.googleContShowingFunc }];
		var grps = [{ value: ZDBI18NMap.g("zrpt.common.js.mygrp"), clickEvtHand: this.groupsShowingFunc }];
		menuBatches.push(existUsers);
		if(ZDBClientUI.showExistingOPUsers){    
	    	menuBatches.push(activeUsers);
	    }
		if(!ZDBClientUI.isCustomDomain && ZDBClientUI.showZContacts){
            menuBatches.push(zCont);
        }
        if(!ZDBClientUI.isCustomDomain && ZDBClientUI.showGoogleContacts){
            menuBatches.push(gCont);
        }
		menuBatches.push(grps);
		var holder = ZRBaseComponentsUtils.getContainer("ZRAddUsersMenu", document.currentEmailSel.parentNode);
		var factory = React.createFactory(ReactMenu);
		ReactDOM.render(factory({ MenuBatches: menuBatches, srcEl: event.target, customPositionFunc: this.positionAddUsersMenu }), holder);
		ZDBUtil.addClass(document.currentEmailSel, "focused");
		event.stopPropagation();
	},
	positionAddUsersMenu: function (event) {
		var holder = document.getElementById("ZRAddUsersMenu").children[0];
		var parentHolderClientRect = document.getElementById("ZRDBVarCreateDlg").getBoundingClientRect();
		var boundingClientRect = event.target.getBoundingClientRect();
		var left = boundingClientRect.left - parentHolderClientRect.left - holder.getBoundingClientRect().width + boundingClientRect.width + 1;
		holder.style.left = left + 'px';
		holder.style.top = '52px';
		holder.style.position = "absolute";
	},
	unmountAddUsersMenu: function () {
		var holder = document.getElementById("ZRAddUsersMenu");
		if (holder) {
			var bool = ReactDOM.unmountComponentAtNode(holder);
			holder.parentNode.removeChild(holder);
			return bool;
		}
		return false;
	},
	handleDomainToGroup: function (event) {
		if (!ZDBLazyLoadUtil.loadJsAlone("ZDBExportNShare", "APPENDTODOC", this.handleDomainToGroup, [event])) {
			return;
		};
		if (document.zaidToDomainMap && document.contactsString && document.zohoContacts != null && document.sharedContacts != null && document.existingContacts != null) {
			var currentDomain = event.target.parentNode.previousSibling.value;
			var currentDomainGroups = document.zaidToDomainMap[currentDomain];
			currentDomainGroups = currentDomainGroups ? currentDomainGroups : [];
			var tempEmailArr = document.contactsString.split(",");
			tempEmailArr = tempEmailArr.map(function (em) {
				var index = em.lastIndexOf("(");
				if (em.charAt(em.length - 1) == ')') {
					em = em.substring(index + 1, em.length - 1);
				}
				return em;
			});
			var tempGrpArr = currentDomainGroups;
			tempGrpArr.forEach(function (elem) {
				tempEmailArr.push(encodeURIComponent(elem));
			});
			tempEmailArr.sort();
			var emailNGroupCombined = tempEmailArr.toLocaleString();
			ZDBAutoFillContacts.fillMyUsers(emailNGroupCombined);
			return;
		}
		if (!document.zaidToDomainMap) {
			this.sendZaidToDomainReq();
		}
		if (!document.contactsString) {
			this.sendContactsReq();
		}
		if (!document.zohoContacts) {
			this.getZohoContacts();
		}
		if (!document.sharedContacts) {
			this.getSharedContacts();
		}
		if (!document.existingContacts) {
            this.getExistingContacts();
        }
	},
	emailOrGroupListingFunc: function (scenario, event) {
		this.unmountAddUsersMenu();
		var curEmails = document.currentEmailSel.getAttribute("data-emails");
		var curDomain = document.currentEmailSel.previousSibling.value;
		var itemList;
		switch (scenario) {
			case 'group':
				itemList = document.zaidToDomainMap && document.zaidToDomainMap[curDomain];
				break;
			case 'zohoCnt':
				itemList = document.zohoContacts;
				break;
			case 'sharedCnt':
				itemList = document.sharedContacts;
				break;
			case 'googleCnt':
				itemList = document.googleContacts;
				break;
			case 'existingCnt':
                itemList = document.existingContacts;
                break;
		}

		itemList = itemList ? itemList : [];
		var selItms = [];
		curEmails.split(",").forEach(function (selEmails) {
			selItms.push(decodeURIComponent(selEmails));
		});
		// itemList.forEach(function(itm){
		// 	var encodedItm = encodeURIComponent(itm);
		// 	if(curEmails.indexOf(encodedItm) > -1){
		// 		selItms.push(decodeURIComponent(itm));
		// 	}
		// })
		var holder = ZRBaseComponentsUtils.getContainer("ZRDBSetAddList", document.currentEmailSel.parentNode);
		var factory = React.createFactory(ZRListingSelectorComp);
		var json = { items: itemList, addItemsFunc: this.handleAddItems, selectedItems: selItms, customPositionFunc: this.positionListingDlg, iconClass: scenario == 'group' ? "iconbg group" : "iconbg user", searchPlaceholder: scenario == 'group' ? ZDBI18NMap.g("zrpt.multigroup.js.search_db_groups") : ZDBI18NMap.g("zrpt.common.toolbar.share.zdbalertmsg.js.searchusers"), buttonText: scenario == 'group' ? ZDBI18NMap.g("zrpt.common.js.addgroups") : ZDBI18NMap.g("zrpt.common.js.addusers"), noResultText: scenario == 'group' ? ZDBI18NMap.g("zrpt.common.js.nogroups") : ZDBI18NMap.g("zrpt.common.js.nousersavail"), isGroup: scenario == 'group', noMatchSearchStr: scenario == 'group' ? ZDBI18NMap.g("zrpt.common.js.nomatchgroup") : ZDBI18NMap.g("zrpt.common.js.nomatchusers") };
		if (scenario == "googleCnt") {
			json.customLinkText = ZDBI18NMap.g("zrpt.share.sharenewusr.addmycontact.js.signinasdiffguser");
			json.customLinkAction = this.revokeGAuthToken;
		}
		ReactDOM.render(factory(json), holder);
		ZDBUtil.addClass(document.currentEmailSel, "focused");
		event.stopPropagation();
	},
	groupsShowingFunc: function (event) {
		this.emailOrGroupListingFunc('group', event);
	},
	zohoUsrsShowingFunc: function (event) {
		this.emailOrGroupListingFunc('zohoCnt', event);
	},
	sharedUsrsShowingFunc: function (event) {
		this.emailOrGroupListingFunc('sharedCnt', event);
	},
	existingUsrsShowingFunc: function (event) {
        this.emailOrGroupListingFunc('existingCnt', event);
    },
	googleContShowingFunc: function (event) {
		event.persist();
		if (!document.googleContacts) this.getGoogleContacts(this.googleContShowingFunc, event);else {
			ZDBDialogUtil.closeDialog();
			this.emailOrGroupListingFunc('googleCnt', event);
		}
	},
	handleAddItems: function (items) {
		if (document.currentEmailSel && items.length > 0) {
			var dataItems = "";
			items.forEach(function (itm) {
				dataItems = dataItems ? dataItems + ',' + encodeURIComponent(itm) : encodeURIComponent(itm);
			});
			var curEmails = document.currentEmailSel.getAttribute("data-emails");
			var curEmailsArr = curEmails.split(",");
			var isEmail = ZDBGlobal.emailRegex.test(items[0]);
			var newSelItems = [],
			    resultantEmails;
			if (isEmail) {
				curEmailsArr.forEach(function (grp) {
					if (!ZDBGlobal.emailRegex.test(decodeURIComponent(grp))) {
						newSelItems.push(grp);
					}
				});
				var newCurGrps = newSelItems.join(",");
				resultantEmails = newCurGrps ? newCurGrps + ',' + dataItems : dataItems;
			} else {
				curEmailsArr.forEach(function (email) {
					if (ZDBGlobal.emailRegex.test(decodeURIComponent(email))) {
						newSelItems.push(email);
					}
				});
				var newCurEmails = newSelItems.join(",");
				resultantEmails = newCurEmails ? newCurEmails + ',' + dataItems : dataItems;
			}
			document.currentEmailSel.setAttribute("data-emails", resultantEmails);
			this.valuesContainerBlur({});
			document.currentEmailSel.querySelector("input").focus();
		}
	},
	positionListingDlg: function (event) {
		var holder = document.getElementById("ZRDBSetAddList");
		var parentHolderClientRect = document.getElementById("ZRDBVarCreateDlg").getBoundingClientRect();
		var boundingClientRect = document.currentEmailSel.querySelector(".ZRDBSetAddList").getBoundingClientRect();
		var left = boundingClientRect.left - parentHolderClientRect.left - holder.getBoundingClientRect().width + boundingClientRect.width;
		holder.style.left = left + 'px';
	},
	getZohoContacts: function () {
		//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ZDBClientUI.dbId+"/GETZOHOCONTACTS",
		//                    ONSUCCESSFUNC:this.getZohoContactSucc,
		//                    ONFAILUREFUNC:this.getZohoContactFail
		//                });
		ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETZOHOCONTACTS', null, {
			successHandler: {
				func: this.getZohoContactSucc,
				ctx: this
			},
			failureHandler: {
				func: this.getZohoContactFail,
				ctx: this
			},
			errorHandler: {
				func: this.getZohoContactFail,
				ctx: this
			}
		});
	},
	getZohoContactSucc: function (response) {
		document.zohoContacts = response.zohoContacts;
	},
	getZohoContactFail: function () {
		document.zohoContacts = null;
	},
	getSharedContacts: function () {
		//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ZDBClientUI.dbId+"/GETSHAREDCONTACTS",
		//                    ONSUCCESSFUNC:this.getSharedContactsSucc,
		//                    ONFAILUREFUNC:this.getSharedContactsFail
		//                });
		ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETSHAREDCONTACTS', null, {
			successHandler: {
				func: this.getSharedContactsSucc,
				ctx: this
			},
			failureHandler: {
				func: this.getSharedContactsFail,
				ctx: this
			}
		});
	},
	getSharedContactsSucc: function (response) {
		document.sharedContacts = response.sharedContacts;
	},
	getSharedContactsFail: function () {
		document.sharedContacts = null;
	},
	getExistingContacts: function () {
        //AjaxAPI.sendRequest({ URL: "/reportsapi/db/" + ZDBClientUI.dbId + "/GETEXISTINGCONTACTS",
        //    ONSUCCESSFUNC: this.getExistingContactsSucc,
        //    ONFAILUREFUNC: this.getExistingContactsFail });
        ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETEXISTINGCONTACTS', null, {
            successHandler: {
                func: this.getExistingContactsSucc,
                ctx: this
            },
            failureHandler: {
                func: this.getExistingContactsFail,
                ctx: this
            }
        });
    },
    getExistingContactsSucc: function (response) {
        document.existingContacts = response.existingcontacts;
    },
    getExistingContactsFail: function (response) {
        document.existingContacts = null;
    },
	getGoogleContacts: function (callBack, event) {
		this.unmountAddUsersMenu();
		var domNode = this.props.disableHolder();
		//		AjaxAPI.sendRequest({URL:"/reportsapi/db/"+ZDBClientUI.dbId+"/GETGOOGLECONTACTS",
		//                    PARAMETERS:"REFETCH=true",
		//                    ONSUCCESSFUNC:this.getGoogleContactsSucc,
		//                    ONFAILUREFUNC:this.getGoogleContactsFail,OPSTATUSID:'ZDBMainLoader',
		//                    FUNCTOCALLBACK:callBack,EVENT:event,DOMNODE:domNode
		//                });
		ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/GETGOOGLECONTACTS', 'REFETCH=true', {
			successHandler: {
				func: this.getGoogleContactsSucc,
				ctx: this
			},
			failureHandler: {
				func: this.getGoogleContactsFail,
				ctx: this
			},
			errorHandler: {
				func: this.getGoogleContactsFail,
				ctx: this
			},
			FUNCTOCALLBACK: callBack,
			EVENT: event,
			DOMNODE: domNode
		});
	},
	getGoogleContactsSucc: function (response, requestOption) {
		this.props.enableHolder(requestOption["DOMNODE"]);
		document.googleContacts = response.googleContacts;
		requestOption["FUNCTOCALLBACK"](requestOption["EVENT"]);
	},
	getGoogleContactsFail: function (response, requestOption) {
		this.props.enableHolder(requestOption["DOMNODE"]);
		var errCode = response.data.errorName;
		errCode = trimAll(errCode);
		if (errCode == "GOOGLE_AUTH_REQUIRED") {
			this.authenticateGoogle();
		}
		ZRBaseComponentsUtils.googleContCallBack = requestOption["FUNCTOCALLBACK"];
		ZRBaseComponentsUtils.googleContCallBackEvent = requestOption["EVENT"];
		document.googleContacts = null;
	},
	authenticateGoogle: function () {
		var authURL = ZDBGlobal.GAPP_EMBED_GADGET_URL + "/gcontacts?auth=true&zservice=" + ZDBGlobal.GAPP_ZSERVICE + "&border=no&serURL=" + ZDBGlobal.REPORTS_SERVER_URL + ZDBGlobal.REPORTS_CONTEXT_NAME + encodeURIComponent("/integ/GResponseRedirect.jsp?gauth_type=contacts&ISREACT=true");
		ZDBGoogleInteg.authGoogle(authURL);
	},
	revokeGAuthToken: function (event) {
		delete document.googleContacts;
		var url = "/ZDBSecurityAction.ma?ZDBACTION=ZDBREVOKEGTOKEN&GTYPE=contacts";
		AjaxAPI.sendRequest({ URL: url, //No I18N
			ONSUCCESSFUNC: this.handleRevokeGToken,
			ONFAILUREFUNC: this.handleRevokeGTokenFailure,
			GOOGLETYPE: "contacts",
			EVENT: event,
			OPSTATUSID: "ZDBMainLoader" });
	},
	handleRevokeGToken: function (response, requestOptions) {
		this.unmountAddUsersMenu();
		this.authenticateGoogle();
		ZRBaseComponentsUtils.googleContCallBack = this.googleContShowingFunc;
		ZRBaseComponentsUtils.googleContCallBackEvent = requestOptions["EVENT"];
	},
	handleRevokeGTokenFailure: function () {
		ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.share.shareview.js.errInGAuth"));
	},
	render: function () {
		var jsonInfo = this.props.jsonInfo;
		var variables = jsonInfo.variables;
		var openCreateAlreadyEdited = false;
		if (jsonInfo.openCreateDlg && jsonInfo[jsonInfo.newVariableKey]) {
			openCreateAlreadyEdited = true;
		}
		var title = jsonInfo.editVar ? "zrpt.dbsettings.variables.js.editvar" : "zrpt.dbsettings.variables.js.createtitle";
		var key = jsonInfo.editVar ? jsonInfo.editVarId : jsonInfo.newVariableKey;
		var values = jsonInfo[key].Values;
		var defValStyle = !ZDBClientUI.isCustomDomain && jsonInfo.domains.length > 1 ? { lineHeight: "65px" } : { paddingTop: '35px', clear: 'both' };
		var valuesHolder = values.map(function (value, index) {
			var isDefAllValSelected = value.Value == jsonInfo.allValKey ? true : false;
			var placeholder = isDefAllValSelected ? ZDBI18NMap.g("zrpt.dbsettings.variables.js.allvaldef") : ZDBI18NMap.g("zrpt.dbsettings.variables.js.value");
			var valueVal = isDefAllValSelected ? "" : value.Value;
			var refKey = "__value__" + index;
			return React.createElement(DBSetNewValComp, { ref: refKey,
				elname: 'custval',
				valkey: refKey,
				key: refKey,
				allValue: isDefAllValSelected,
				needAllVal: ZDBGlobal.enableAllValVar,
				placeholder: placeholder,
				domainInfo: jsonInfo.domains,
				value: valueVal,
				emails: value.Emails,
				zaid: value.Zaid,
				handleAddUsersClick: this.handleAddUsersClick,
				style: { whiteSpace: 'nowrap', clear: 'both', position: 'relative' },
				showToolTips: this.props.showToolTips,
				hideToolTips: this.props.hideToolTips,
				handleAllValClick: this.valuesContainerBlur,
				handleOnChange: this.valuesContainerBlur,
				removeNewValComp: this.removeNewValComp,
				removeEmail: this.removeEmail,
				editEmail: this.editEmail,
				handleDomainToGroup: this.handleDomainToGroup });
		}.bind(this));

		var defHeaderStyle = { paddingTop: '10px', clear: 'both' };
		if (jsonInfo[key].defValues.length > 0) {
			defHeaderStyle.marginBottom = "-10px";
		} else {
			defHeaderStyle.marginBottom = "0px";
		}
		var mapHeaderStyle = { clear: 'both' };
		if (jsonInfo[key].Values.length > 0) {
			mapHeaderStyle.marginBottom = "20px";
		} else {
			mapHeaderStyle.marginBottom = "17px";
		}
		var showDomains = !ZDBClientUI.isCustomDomain && jsonInfo.domains && jsonInfo.domains.length > 1 ? "" : "none";
		var back = "-- " + ZDBI18NMap.g("zrpt.common.inlineDlg.js.back");
		return React.createElement(
			'div',
			{ id: 'ZRDBSettingsBodyContentInnerDiv', style: { height: '100%' }, ref: 'keycontainer',
				className: this.props.class },
			React.createElement(
				'div',
				{ id: 'ZRDBVarCreateDlg', ref: 'ZRDBVarCreateDlg',
					style: { marginTop: '25px', marginLeft: '30px', minWidth: !ZDBClientUI.isCustomDomain && jsonInfo.domains && jsonInfo.domains.length > 1 ? '880px' : '750px' } },
				React.createElement(
					'div',
					{ className: 'ZRDBSettingsDBName font14', style: { padding: 0 } },
					ZDBI18NMap.g(title)
				),
				React.createElement(
					'div',
					{ style: { float: 'right', marginRight: '50px', marginTop: '-25px', display: !ZDBClientUI.isCustomDomain ? "block" : "none" }, className: 'externalHelp', onMouseOut: this.props.hideToolTips, onMouseMove: this.props.showToolTips, 'data-tip': 'Help Center', onClick: function () {
							window.open(ZDBI18NMap.g("zrpt.dbsettings.variable.js.help"), "_blank");
						} },
					'?'
				),
				React.createElement('div', { style: { marginTop: '10px' }, className: 'ZRDBSeparator' }),
				React.createElement(
					'div',
					{ style: { paddingTop: '20px' } },
					React.createElement(
						'label',
						{ className: 'ZRDBSetVarLabel ZRMandatory' },
						ZDBI18NMap.g("zrpt.dbsettings.variables.js.vname"),
						':*'
					),
					function (comp) {
						var value;
						if (jsonInfo.editVar) {
							value = jsonInfo[jsonInfo.editVarId].VarName;
						} else {
							value = jsonInfo[jsonInfo.newVariableKey].VarName;
						}
						return React.createElement('input', { className: 'fLeft',
							style: { width: '250px', height: '25px' },
							type: 'text',
							value: value,
							onChange: comp.nameChange,
							ref: 'varname',
							placeholder: ZDBI18NMap.g("zrpt.dbsettings.variables.js.vnameplahold") });
					}(this),
					React.createElement('span', { 'data-error': 'true',
						className: 'iconbg ZRDBWarn2',
						style: { margin: '3px 10px', display: 'none' },
						'data-tip': ZDBI18NMap.g("zrpt.dbsettings.variables.js.vnameempty"),
						onMouseOut: this.props.hideToolTips,
						onMouseMove: this.props.showToolTips })
				),
				React.createElement(
					'div',
					{ className: 'ZRDBSettingsDBName font13', style: defHeaderStyle, id: 'ZRDBVarDefVal' },
					ZDBI18NMap.g("zrpt.dbsettings.variables.js.defval"),
					':',
					React.createElement('div', { className: 'ZRSHelpIcon ZRDBVMiddle ZRDBMarginLeft5',
						'data-tip': ZDBI18NMap.g("zrpt.dbsettings.variables.js.defvalhelp"),
						onMouseMove: this.props.showToolTips,
						onMouseOut: this.props.hideToolTips,
						style: { fontWeight: 'initial' } })
				),
				function (comp) {
					var key = jsonInfo.editVar ? jsonInfo.editVarId : jsonInfo.newVariableKey;
					var values = jsonInfo[key].defValues;
					var defValHolder = values.map(function (value, index) {

						var isDefAllValSelected = value.Value == jsonInfo.allValKey ? true : false;
						var placeholder = isDefAllValSelected ? ZDBI18NMap.g("zrpt.dbsettings.variables.js.allvaldef") : ZDBI18NMap.g("zrpt.dbsettings.variables.js.value");
						var valueVal = isDefAllValSelected ? "" : value.Value;
						var refKey = "__defvalue__" + index;
						var optionValues, displaySelect;
						if (jsonInfo.domains) {
							optionValues = jsonInfo.domains;
							displaySelect = !ZDBClientUI.isCustomDomain && ZDBClientUI.isDBOwnerAndNotDBAdmin && jsonInfo.domains.length > 1 ? displaySelect = 'block' : displaySelect = 'none';
						}
						return React.createElement(DBSetDefNewValComp, {
							style: { height: '46px' },
							ref: refKey,
							key: refKey,
							refKey: refKey,
							valueVal: valueVal,
							isDefAllValSelected: isDefAllValSelected,
							valuesContainerBlur: comp.valuesContainerBlur,
							showToolTips: comp.props.showToolTips,
							hideToolTips: comp.props.hideToolTips,
							placeholder: placeholder,
							optionValues: optionValues,
							displaySelect: displaySelect,
							zaid: value.Zaid,
							removeDefNewValComp: comp.removeDefNewValComp });
					}.bind(comp));
					return defValHolder;
				}(this),
				React.createElement(
					'div',
					{ className: 'ZRSLink', ref: 'addnewdefval', style: { paddingTop: '15px', clear: 'both', width: '160px' },
						onClick: this.handleAddNewDefVal, id: 'ZRDBVarNewValAdd' },
					ZDBI18NMap.g("zrpt.dbsettings.variables.js.addnewdefval")
				),
				React.createElement(
					'div',
					{ className: 'ZRDBSettingsDBName font13', style: mapHeaderStyle },
					ZDBI18NMap.g("zrpt.dbsettings.variables.js.mapvalue"),
					React.createElement('div', { className: 'ZRSHelpIcon ZRDBVMiddle ZRDBMarginLeft5',
						'data-tip': ZDBI18NMap.g("zrpt.dbsettings.variables.js.mapvalhelp"),
						onMouseMove: this.props.showToolTips,
						onMouseOut: this.props.hideToolTips,
						style: { fontWeight: 'initial' } })
				),
				React.createElement(
					'div',
					{ id: 'valuesContainer', style: { marginTop: '-21px' } },
					valuesHolder
				),
				React.createElement(
					'div',
					{ className: 'ZRSLink', style: { padding: '18px 0px 20px 0', clear: 'both', width: '110px' },
						onClick: this.handleAddNewVal, id: 'ZRDBVarNewValAdd', ref: 'addnewval' },
					'+ ',
					ZDBI18NMap.g("zrpt.dbsettings.variables.js.addnewval")
				),
				React.createElement(
					'div',
					{ style: { marginBottom: '50px' } },
					React.createElement('input', { type: 'button', className: 'ZRDBMarginLeft5',
						value: ZDBI18NMap.g("zrpt.dialoginfo.backup.js.save"),
						onClick: this.saveVariableAndValues, ref: 'saveVariable' }),
					React.createElement('input', { className: 'ZRDBMarginLeft5', type: 'button',
						onClick: this.handleCreateDlgClose, ref: 'closeCreateOrEdit',
						value: ZDBI18NMap.g("zrpt.dialoginfo.js.cancelbtn") })
				)
			)
		);
	}
});

var DBSetDefNewValComp = React.createClass({
	displayName: 'DBSetDefNewValComp',

	render: function () {
		return React.createElement(
			'div',
			{ className: 'ZRDBValComp', 'data-valkey': this.props.refKey, style: this.props.style },
			React.createElement(DBSetVarDefComp, { ref: 'newvalcompvalue',
				value: this.props.valueVal,
				allValue: this.props.isDefAllValSelected,
				handleOnChange: this.props.valuesContainerBlur,
				handleAllValClick: this.props.valuesContainerBlur,
				showToolTips: this.props.showToolTips,
				hideToolTips: this.props.hideToolTips,
				needAllVal: true,
				valkey: this.props.refKey,
				style: { marginTop: '10px' },
				placeholder: this.props.placeholder }),
			React.createElement(SelectComponent, { ref: 'newvalcompselect',
				className: 'inlineSelect',
				optionValues: this.props.optionValues,
				style: { float: 'left', height: '28px', margin: '0px 0px 0px 40px', display: this.props.displaySelect, width: '120px' },
				onChange: this.props.valuesContainerBlur,
				value: this.props.zaid }),
			React.createElement('span', { 'data-error': 'true', ref: 'errorIcon',
				className: 'iconbg ZRDBWarn2',
				style: { margin: '3px 0px 0px 8px', display: 'none', verticalAlign: 'top' },
				'data-tip': ZDBI18NMap.g("zrpt.dbsettings.variables.js.vnameempty"),
				onMouseOut: this.props.hideToolTips,
				onMouseMove: this.props.showToolTips }),
			function (comp) {
				if (!comp.props.noNeedCross) {
					return React.createElement('a', { className: 'iconbg ZRDBCross', style: { margin: '7px 0px 0px 10px' },
						'data-valkey': comp.props.refKey, ref: 'removeNewValComp',
						onClick: comp.props.removeDefNewValComp });
				}
			}(this)
		);
	}
});

var DBSetNewValComp = React.createClass({
	displayName: 'DBSetNewValComp',

	render: function () {
		var optionValues, displaySelect;
		if (this.props.domainInfo) {
			optionValues = this.props.domainInfo;
			displaySelect = !ZDBClientUI.isCustomDomain && ZDBClientUI.isDBOwnerAndNotDBAdmin && optionValues.length > 1 ? displaySelect = 'block' : displaySelect = 'none';
		}
		return React.createElement(
			'div',
			{ style: this.props.style, 'data-elname': this.props.elname,
				id: this.props.id, 'data-valkey': this.props.valkey, className: 'ZRDBValComp' },
			React.createElement(DBSetVarDefComp, { ref: 'newvalcompvalue',
				value: this.props.value,
				style: { display: 'inline-block', margin: ZDBGlobal.enableAllValVar ? '5px 40px 0px 0px' : '23px 40px 0px 0px', borderColor: '', boxShadow: '', verticalAlign: 'top', float: 'left' },
				allValue: this.props.allValue,
				handleOnChange: this.props.handleOnChange,
				handleAllValClick: this.props.handleAllValClick,
				showToolTips: this.props.showToolTips,
				hideToolTips: this.props.hideToolTips,
				needAllVal: this.props.needAllVal,
				allValueStyle: this.props.allValueStyle,
				valkey: this.props.valkey,
				placeholder: this.props.placeholder }),
			React.createElement(SelectComponent, { ref: 'newvalcompselect',
				className: 'inlineSelect',
				optionValues: optionValues,
				style: { margin: '25px 40px 0px 0px', display: displaySelect, verticalAlign: 'top', float: 'left', width: '120px' },
				onChange: this.props.handleOnChange,
				value: this.props.zaid }),
			React.createElement(EmailBubbleContainerInput, { ref: 'newvalcompemails',
				valRef: this.props.valkey,
				zaid: this.props.zaid,
				showToolTips: this.props.showToolTips,
				hideToolTips: this.props.hideToolTips,
				removeEmailBubble: this.props.removeEmail,
				containerClassName: 'email-bubble-textarea',
				editEmail: this.props.editEmail,
				containerStyles: { margin: "24px 5px 0 0", display: 'block', verticalAlign: 'top', float: 'left' },
				emails: this.props.emails,
				needGroups: true,
				handleAddUsersClick: this.props.handleAddUsersClick,
				placeholder: ZDBI18NMap.g("zrpt.dbsettings.variables.js.emails"),
				customOnKeyUpHandler: this.props.handleOnChange,
				customOnBlur: this.props.handleOnChange,
				customOnFocus: this.props.handleDomainToGroup }),
			React.createElement('span', { 'data-error': 'true', ref: 'errorIcon',
				className: 'iconbg ZRDBWarn2',
				style: { margin: '27px 0px 0px 6px', float: 'none', display: 'none', float: 'left' },
				'data-tip': ZDBI18NMap.g("zrpt.dbsettings.variables.js.vnameempty"),
				onMouseOut: this.props.hideToolTips,
				onMouseMove: this.props.showToolTips }),
			function (comp) {
				if (!comp.props.noNeedCross) {
					return React.createElement('div', { className: 'iconbg ZRDBCross', style: { float: 'none', display: 'inline-block', verticalAlign: 'top', float: 'left' },
						'data-valkey': comp.props.valkey, ref: 'removeNewValComp',
						onClick: comp.props.removeNewValComp });
				}
			}(this)
		);
	}
});
var DBSetVarDefComp = React.createClass({
	displayName: 'DBSetVarDefComp',

	componentWillMount: function () {
		this.setState({
			allValue: this.props.allValue,
			value: this.props.value
		});
	},
	componentWillReceiveProps: function (nextProps) {
		this.setState({
			allValue: nextProps.allValue,
			value: nextProps.value
		});
	},
	shouldComponentUpdate: function () {
		return true;
	},
	render: function () {
		return React.createElement(
			'div',
			{ className: 'ZRDBVal', style: this.props.style },
			function (comp) {
				if (comp.props.needAllVal) {
					return React.createElement(
						'div',
						{ className: comp.state.allValue ? "ZRDBAllVal ZRDBAllValChecked" : "ZRDBAllVal", style: comp.props.allValueStyle },
						React.createElement('input', { ref: 'allvalcheckbox', type: 'checkbox',
							checked: comp.state.allValue,
							style: { verticalAlign: 'middle' },
							onChange: comp.props.handleAllValClick,
							'data-valkey': comp.props.valkey }),
						React.createElement(
							'span',
							{ style: { marginLeft: '2px', verticalAlign: 'middle', fontStyle: 'italic', cursor: 'default', fontSize: '12px' } },
							ZDBI18NMap.g("zrpt.dbsettings.variables.js.allval")
						),
						React.createElement('div', { className: 'QHelpIcon ZRDBMarginLeft5 ZRDBCursor', style: { verticalAlign: 'middle', marginBottom: '1px' },
							'data-tip': ZDBI18NMap.g("zrpt.dbsettings.variable.js.allvalhelp"),
							onMouseMove: comp.props.showToolTips,
							onMouseOut: comp.props.hideToolTips })
					);
				}
			}(this),
			React.createElement('input', { ref: 'defcompinput', className: 'fLeft', style: { width: '250px', height: '26px' },
				type: 'text', value: this.state.value, placeholder: this.props.placeholder,
				disabled: this.props.allValue, onChange: this.props.handleOnChange }),
			React.createElement('span', { 'data-error': 'true', className: 'iconbg ZRDBWarn2',
				style: { margin: '3px 10px', display: 'none' },
				'data-tip': ZDBI18NMap.g("zrpt.dbsettings.variables.js.vnameempty"),
				onMouseOut: this.props.hideToolTips,
				onMouseMove: this.props.showToolTips })
		);
	}
});

//ignorei18n_end