 //$Id$
var ZDBGridOper = new function()
{
  this.showRenameColDlg = function(element,gridObj)
  {  
    var lastFocusCell = ZDBDataGrid.getLastFocusCell(gridObj);
    if(gridObj.selectedCols.length == 0 && lastFocusCell != null)
    {
      gridObj.addSelectedCol(lastFocusCell.colObj);
    }    
    
    var el = ZDBUtil.getCachedRef(ZDBGridOper, "ZDBRenameColDetails");
    var title = ZDBI18NMap.g("zrpt.toolbar.clmproperities.js.renameColumnDlgTtl",el);
    el.style.display = "block";
    var colHead = gridObj.getSelectedColHead();
    if(colHead == null)
    {
      ZDBMsgBox.showError(ZDBI18NMap.g("zrpt.toolbar.clmproperities.errmsg.js.selCol2Rename"));
      return false;
    }    
    el.gridObj = gridObj;
    gridObj.selectColumn(); 
    ZDBDialogUtil.showDialog(el,{TITLE:title,ADDFRAME:true,MODAL:true,CALLOUT:true,SRCEL:colHead.cellEl,ONENTER:ZDBGridOper.submitColRenameDlg,ENTERARGS:[gridObj]});
    var colEl = $("ZDBColRenameTxtFld");
    colEl.value = colHead.displayName;
    colEl.origVal = colHead.displayName;
    var descEl = $("ZDBColDescTxtFld");
    if(!colHead.description)
    {
      descEl.value = "";
    }
    else
    {
      descEl.value = colHead.description;
    }  
    descEl.origVal = colHead.description;
    colEl.select();    
  }
  
  this.submitColRenameDlg = function(element, event, args)
  {
    var gridObj = args ? args[0] : null;
    if(!gridObj)
    {
      gridObj =  ZDBUtil.getPropertyFromEl(element, 'gridObj','object');
    }
    
    var txtFld = $('ZDBColRenameTxtFld');
    var colName = (txtFld.value).trim();
    var origColName = (txtFld.origVal).trim();    
    var dlg = ZDBDialogUtil.focusDialog;
    var els = DOMUtils.getChildElsWithAttr(dlg,"elname","*")
    if(!validateFormElements(els,dlg))
    {
      return;
    }
    if((gridObj.isFieldExists(colName) && colName != origColName) || (colName == ""))
    {
      var key = (colName == "") ? "zrpt.common.table.zdbalertmsg.js.emptyColName" : "zrpt.toolbar.clmproperities.custommsg.js.colNameExist"; //No I18N
      showCustomMessage(ZDBI18NMap.g(key), txtFld);
      txtFld.select();
      return;
    }
    var descEl = $('ZDBColDescTxtFld');
    var descModVal = descEl.value;
    var descOrigVal = descEl.origVal;
    if(origColName == colName && descModVal == descOrigVal)
    {
      ZDBDialogUtil.closeDialog();
      return;
    }
    colHead = gridObj.getSelectedColHead();
    ZDBGridOper.renameColumn(colHead,colName,descModVal);
  } 
  
  this.renameColumn = function(header,displayName,desc)
  {
    var xmlData = "";
    var descStr = "";              
    if(desc != null)
    {
      descStr = "DESCRIPTION=\"" + ZDBEscapeUtil.encodeForXML(desc) + "\"";
    }
    xmlData = xmlData + "\n" + "<T FIELDID=\"" + header.colId + "\" FIELDNAME=\"" +
              ZDBEscapeUtil.encodeForXML(displayName) + "\" " + descStr + 
              " ___oper=\"" + ZDBConst.MODIFIED + "\"/>";
    xmlData = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>" + xmlData + "\n</data>";
    this.sendRequestForRename(xmlData, header.parGrid);
  }
  
  this.sendRequestForRename = function(xmlData, gridObj)
  {
    var url = CommAPI.DESIGNURL + "&" + gridObj.getGridDetailsAsParams() + "&DATAVIEW=";
    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},
                       OPSTATUSID:"ZDBCOLRENAMEOPTSTATUS", 
                       ONSUCCESSFUNC:this.handleRenameCol,
                       VIEWCTX:gridObj.viewCtx};
    AjaxAPI.sendRequest(ajaxOptions);
  }

  this.handleRenameCol = function(response,requestOptions)
  {
	  if($("ZDBCOLRENAMEOPTSTATUS"))
	  {
	      $("ZDBCOLRENAMEOPTSTATUS").className = "mcLoaded" //PK: Hack
	  }
	  ZDBDialogUtil.closeDialog();
	  ZDBTableGrid.placeDataSheet(response,requestOptions);
	  var view = requestOptions["VIEWCTX"].tab.view;
      var objId = view.objId;
      ZDBClientUtil.deleteJsonForObjId(objId);
  }
  
  this.showAddColDlg = function(element,gridObj)
  {
    var el = ZDBUtil.getCachedRef(ZDBClientUI, "ZDBAddColumnDlg"); 
    el.style.display = "block";
    var txtFld = ZDBUtil.getCachedRef(el,'ZDBColumnNameTxtFld');
    var typeTd = ZDBUtil.getCachedRef(el,'ZDBTypeTD');
    var typeLabel = ZDBUtil.getCachedRef(el,'ZDBTypeLabel');
    var dataTypeLabel = typeLabel.getAttribute('dataTypeLabel');
    var lookupLabel = typeLabel.getAttribute('lookupLabel');
    var formatColLabel = ZDBUtil.getCachedRef(el,'ZRFormatCol');
    var formatColOpts = ZDBUtil.getCachedRef(el,'ZDBFormatOptions');
    var piiCheckboxShowHide = ZDBUtil.getCachedRef(el,'piiCheckBox');
    var piiCheckbox = ZDBUtil.getCachedRef(el,"isPII");
    el.lookup = false;
    var title;
    var lookup = element.getAttribute("lookup");
    var fkConstraintTr = ZDBUtil.getCachedRef(el,"FKConstraintTr");
    var dlgParams = {};
    if(lookup == "true")
    {
	    if(fkConstraintTr)
	    {
                if(gridObj.disablePhysicalLookup)
                {
                    fkConstraintTr.style.display="none";
                }
                else
                {
		 fkConstraintTr.style.display="";
	    }
	    }
      title = ZDBI18NMap.g('zrpt.toolbar.add.addcolumn.js.lookupDlgTtl',el);
      typeLabel.innerHTML = lookupLabel;
      if(ZDBClientUI.dataTypeEl != null)
      {
        ZDBClientUI.dataTypeEl.style.display = "none";
      }
      if(ZDBClientUI.lookupEl != null)
      {
        ZDBClientUI.lookupEl.style.display = "block";
      }  
      ZDBMetaDataChange.loadLookupCols(typeTd, gridObj);
      el.lookup = true;
      formatColLabel.style.display = "none";
      formatColOpts.style.display = "none";
      var okBtn = jQuery(el).find("#ZDBAddColDlgOkBtn");
      dlgParams = {TITLE:title,ADDFRAME:true,MODAL:true,ACTIONBUTTONS:okBtn};
    }
    else
    {
    	if(fkConstraintTr)
	    {
    		 fkConstraintTr.style.display="none";
	    }
      title = ZDBI18NMap.g('zrpt.toolbar.add.addcolumn.js.dlgTtl',el);
      typeLabel.innerHTML = dataTypeLabel;
      if(ZDBClientUI.lookupEl != null)
      {
        ZDBClientUI.lookupEl.style.display = "none";
      }
      if(ZDBClientUI.dataTypeEl == null)
      {
        ZDBMetaDataChange.loadDataTypeList(typeTd,2);
      }
      else
      {
        typeTd.appendChild(ZDBClientUI.dataTypeEl);
        ZDBClientUI.dataTypeEl.style.display = "block";
      }
      formatColLabel.style.display = "";
      ZDBUtil.setAttribute(formatColLabel, "false", "shown");
      formatColOpts.style.display = "none";
      el.formatApplied = false;
      var okBtn = jQuery(el).find("#ZDBAddColDlgOkBtn");
      dlgParams = {TITLE:title,ADDFRAME:true,MODAL:true,TOP:65,LEFT:500,ACTIONBUTTONS:okBtn};
    }
    if(ZDBGlobal.isPIIEnabled)
    {
      piiCheckboxShowHide.style.display = "";
      ZDBMetaDataChange.addRemoveAsPiiColumn(piiCheckbox,false);
    }
    else
    {
      piiCheckboxShowHide.style.display = "none";
    }
    txtFld.value = gridObj.getFieldName();
    el.gridObj = gridObj;
    ZDBDialogUtil.showDialog(el,dlgParams);
    $("ZDBADDCOLOPTSTATUS").className = "mcLoaded";
    txtFld.select();
    
  }
  
  this.handleColumnFormatOpts = function()
  {
	if(!ZDBLazyLoadUtil.loadJsAlone(["import/js/ZDBImport.js","format/js/ZDBSheetFormatExtn.js"],"APPENDTODOC",ZDBGridOper.handleColumnFormatOpts)) //NO I18N	
	{
		return;
	}
	var dlgEl = ZDBDialogUtil.focusDialog;
    var dataType = $("ZDBDataTypeSelect_AddDlg").options[$("ZDBDataTypeSelect_AddDlg").selectedIndex].value;
    var formatColLbl = $("ZRFormatCol");
    var status = ZDBUtil.getAttribute(formatColLbl, "shown");
    var formatOpts = $("ZDBFormatOptions");
    formatOpts.style.display = (status == "false") ? "" : "none";
    ZDBUtil.setAttribute(formatColLbl, (status == "false"), "shown");
    dlgEl.formatApplied = true;
    var editFrmtColOpts = new ZDBEditColumnFormat(null,ZDBEditColumnFormat.NORMAL_COL_FORMAT,null);
    ZDBSheetFormatExtn.editFrmtColOpts = editFrmtColOpts;
    ZDBSheetFormatExtn.enableDisableColumnFormatOpts(dataType);
    ZDBSheetFormatExtn.setDefaultFormatOpts_New(dataType);
  }
  
  this.onDataTypeChangeFormatOpts = function()
  {
	  if(!ZDBLazyLoadUtil.loadJsAlone("import/js/ZDBImport.js","APPENDTODOC",ZDBGridOper.handleColumnFormatOpts))
	  {
			return;
	  }
	  var dataTypeEl = ZDBClientUI.dataTypeEl;
	  var dataType = dataTypeEl.options[dataTypeEl.selectedIndex].value;
	  ZDBSheetFormatExtn.dataType = dataType;
	  var editFrmtColOpts = new ZDBEditColumnFormat(null,ZDBEditColumnFormat.NORMAL_COL_FORMAT,null);
          ZDBSheetFormatExtn.editFrmtColOpts = editFrmtColOpts;
	  ZDBSheetFormatExtn.enableDisableColumnFormatOpts(dataType);
	  ZDBSheetFormatExtn.setDefaultFormatOpts_New(dataType);
          if(dataType == ZDBConst.PERCENT)
          {
            ZDBDialogUtil.focusDialog.formatApplied = true;
  }
  }
  this.confirmAddColDlg = function(clickType,requestOpt)
  {
   if(clickType === "NO")
	{
		return;
	}
   var srcEl = requestOpt.SRCEL;
   ZDBGridOper.submitAddColDlg(srcEl,true);
  }
  
  this.submitAddColDlg = function(srcEl,isDDLLockskipped)
  {
    var gridObj =  ZDBUtil.getPropertyFromEl(srcEl, 'gridObj','object');
    var txtFld = ZDBClientUI.ZDBAddColumnDlg.ZDBColumnNameTxtFld;
    var colName = txtFld.value;
    var dlgEl = ZDBDialogUtil.focusDialog;
    var els = DOMUtils.getChildElsWithAttr(dlgEl,"name","*"); //No I18N
    var isPiiDlg = dlgEl.querySelector("#isPII"); //No I18N
    var isPii = (isPiiDlg) ? ZDBUtil.hasClass(isPiiDlg,"ZRSChecked") : false; //No I18N
    if(!validateFormElements(els,dlgEl))
    {
       ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored, true);
       return;
    }
    if(gridObj.isFieldExists(colName))
    {
      showCustomMessage(ZDBI18NMap.g('zrpt.toolbar.clmproperities.custommsg.js.colNameExist'), txtFld);
      ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored, true);
      txtFld.select();
      return;
    }
    if(ZDBClientUI.ZDBAddColumnDlg.lookup)
    {
      var index = gridObj.lookupEl.selectedIndex;
      var isValid = ZDBMetaDataChange.validateLookupcolumn(gridObj,index); 
      if(!isValid)
      {
        ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored, true);
        return;
      }
      var dlgEl = ZDBDialogUtil.focusDialog.bodyContent;
      var constCascade = DOMUtils.getChildElsWithAttr(dlgEl,"id","ZDBConstCascade")[0];//No i18N
      var constSetNull = DOMUtils.getChildElsWithAttr(dlgEl,"id","ZDBConstSetNull")[0];//No i18N
      var noCascade = DOMUtils.getChildElsWithAttr(dlgEl,"id","ZDBNoCascade")[0];//No i18N
      var fkConstraint="2"; // No action on this (child) table default value is 2
      if($('constSetNull') || $('constCascade') || $('noCascade') )
      {
       fkConstraint = (constSetNull.checked) ? constSetNull.value : (noCascade.checked) ? noCascade.value : constCascade.value;
      }
      var xmlData = ZDBGridOper.genXMLForLookupCol(gridObj, colName, index,fkConstraint,isPii);
      ZDBGridOper.addLookupColumn(gridObj, xmlData);
    }
    else
    {
      var subTypeId = ZDBClientUI.dataTypeEl[ZDBClientUI.dataTypeEl.selectedIndex].value;
      var colHead = new ZDBFormatColHeader(subTypeId);
      if(dlgEl.formatApplied)
      {
    	ZDBSheetFormatExtn.setFormatInColHead(colHead);  
      }
      var formatOpts = ZDBSheetFormat.constructFormatOptsAsParams(colHead);
      var georole = ZDBClientUI.dataTypeEl[ZDBClientUI.dataTypeEl.selectedIndex].getAttribute("georole");
      ZDBGridOper.addColumn(gridObj, colName, subTypeId, formatOpts,isDDLLockskipped,georole,isPii);
    }  
  }
  
  this.addColumn = function(gridObj, colName, subTypeId, formatOpts,isDDLLockskipped,georole,isPii)
  {
    var url = ZDBGlobal.CTX +"/ZDBDatabaseActionMI.ma?";
    var params = gridObj.getGridDetailsAsParams();
    if(isDDLLockskipped == true)
        {
            params = params + "&SKIPDDLCHECK=true";//No I18N
        }
            params = params + "&ZDBACTION=ADDCOLUMN&COLNAME=" + encodeURIComponent(colName) + 
             "&SUBTYPE=" + subTypeId + formatOpts; 		//No I18N
     if(subTypeId== ZDBConst.GEO || subTypeId== ZDBConst.GEO_NUM)
     {
         params +="&GEOROLE="+ georole; //NO I18N
     }
    params +="&ISPII=" + isPii; //No I18N
    AjaxAPI.sendRequest({URL:url,PARAMETERS:params,
                               ONSUCCESSFUNC:ZDBGridOper.addColumnResp,
                               ONFAILUREFUNC:ZDBGridOper.addColumnFailureFunc,
                               OPSTATUSID:"ZDBADDCOLOPTSTATUS",
                               VIEWCTX:gridObj.viewCtx});
  }
  
  this.addLookupColumn = function(gridObj, xmlData)
  {
    var url = CommAPI.DESIGNURL + "&" + gridObj.getGridDetailsAsParams() + "&DATAVIEW=";
    var ajaxOptions = {URL:url,POSTBODY:xmlData,REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},
                       OPSTATUSID:"ZDBADDCOLOPTSTATUS", //NO I18N
                       ONSUCCESSFUNC:ZDBGridOper.addColumnResp,
                       ONFAILUREFUNC:ZDBGridOper.addColumnFailureFunc,
                       VIEWCTX:gridObj.viewCtx};
    AjaxAPI.sendRequest(ajaxOptions);
  }
  
  this.addColumnFailureFunc = function(response,requestOptions){
	  ZDBDialogUtil.enableButtons(ZDBDialogUtil.btnsMonitored,true);
          var errCode = response.getResponsePart("ERRORCODE");
          errCode = trimAll(errCode);
              if(errCode === "DDL_LOCK_SINCE_IMPORT_IN_PROGRESS")
                  {
                    ZDBAlertAPI.showMsg(response.getResponsePart("STATUS_MESSAGE")+ZDBI18NMap.g("zrpt.common.showinfo.js.doyouwant"),"ZDBYESNO",  //No I18N
									{ONCLICK:ZDBGridOper.confirmAddColDlg,CALLOUT:false,SRCEL:$("ZDBAddColDlgOkBtn")});
                    return;
                  }
	  var message = response.getResponsePart("STATUS_MESSAGE");
	  if(!message){
		  message = response.getOnlyHtml();
	  }
	  StatusMsgAPI.showErrorMsg(message)
  }
  
  this.addColumnResp = function(response, requestOptions)
  {
    ZDBClientUI.clearCache();
    ZDBTableGrid.placeDataSheet(response, requestOptions);
    var objId = requestOptions["VIEWCTX"].tab.view.objId;
    ZDBClientUtil.deleteJsonForObjId(objId);
    ZDBDialogUtil.closeDialog();
  }
  
  this.genXMLForLookupCol = function(gridObj, colName, index, fkConstraint,isPii)
  {
    var xmlData = "<data csrftoken='" + ZDBEscapeUtil.encodeForXML(getCookie("CSRF_TOKEN")) + "'>\n<T FIELDID=\"AUTOID:1\" FIELDNAME=\"" + ZDBEscapeUtil.encodeForXML(colName) +
                   "\" FKCONSTRAINT=\"" + fkConstraint + "\" REFERREDCOLUMN=\"" + ZDBEscapeUtil.encodeForXML(gridObj.lookupEl[index].value) + "\" PII=\"" + isPii  + "\"" + //No I18N
                   " ___oper=\"" + ZDBConst.CREATED + "\"/></data>";
    return xmlData;               
  }
}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBGridOper.showAddColDlg"]=ZDBGridOper.showAddColDlg;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBGridOper.showRenameColDlg"]=ZDBGridOper.showRenameColDlg;
