//$Id$
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var ZRSZia_controller = {
    innerDialog: {
        shownDialog: null,
        show: function (dynamicData, holder, onClose, onCloseArg, onCloseCtx) {
            console.log('show');
            if (ZRSZia_controller.innerDialog.shownDialog) {
                ZRSZia_controller.innerDialog.close();
            }
            ZRSZia_controller.innerDialog.shownDialog = ZRSStringTemplateCreator.createTemplateForDynamicData('zrsziaInnerDialog', 'zrszia', false, dynamicData); //NO I18N
            holder = holder ? holder : document.body;
            holder.appendChild(ZRSZia_controller.innerDialog.shownDialog);
            ZDBUtil.setNamedChildEls(ZRSZia_controller.innerDialog.shownDialog, ZRSZia_controller.innerDialog.shownDialog);
            ZRSZia_controller.innerDialog.shownDialog.onClose = onClose;
            ZRSZia_controller.innerDialog.shownDialog.onCloseArg = onCloseArg;
            ZRSZia_controller.innerDialog.shownDialog.onCloseCtx = onCloseCtx;
            ZRSZia_controller.innerDialog.shownDialog.holder = holder;
            ZRSZia_controller.innerDialog.positionDialog();
            ZRSZia_controller.innerDialog.attachEvents();
        },
        close: function (event) {
            console.log('close');
            if (event && event.type === 'keyup') {
                if (parseInt(event.keyCode) !== KEY.ESC) {
                    return;
                }
            }
            if (ZRSZia_controller.innerDialog.shownDialog) {
                ZRSZia_controller.innerDialog.shownDialog.parentNode.removeChild(ZRSZia_controller.innerDialog.shownDialog);
                ZRSZia_controller.innerDialog.shownDialog = null;
                document.body.removeEventListener('keyup', ZRSZia_controller.innerDialog.close);
                if (event) {
                    event.stopPropagation();
                }
            }

        },
        attachEvents: function () {
            ZRSZia_controller.innerDialog.shownDialog.close.addEventListener('click', ZRSZia_controller.innerDialog.close);
            document.body.addEventListener('keyup', ZRSZia_controller.innerDialog.close);
        },
        positionDialog: function () {
            var holder = ZRSZia_controller.innerDialog.shownDialog.holder;
            var dialog = ZRSZia_controller.innerDialog.shownDialog;
            var holderWidth = holder.offsetWidth;
            var holderHeight = holder.offsetHeight;
            var dialogWidth = dialog.content.offsetWidth;
            var dialogHeight = dialog.content.offsetHeight;
            dialog.content.style.top = (holderHeight / 2 - dialogHeight / 2) + 'px';
            dialog.content.style.left = (holderWidth / 2 - dialogWidth / 2) + 'px';
            dialog.freeze.style.width = dialog.style.width = holder.scrollWidth + 'px';
            dialog.freeze.style.height = dialog.style.height = holder.scrollHeight + 'px';

        }
    },
    zrsziadatamodeltabncol: {
        moreLessEvent: function (event) {
            var target = event.target;
            var parent = target.parentNode;
            var action = target.getAttribute('action');
            var tableName = target.getAttribute('tableName');
            var tableCols = ZRSZia.tableToColMap[tableName];
            if (tableCols) {
                var createdCols = target.parentNode.querySelectorAll('div[elname="column"]');//NO I18N
                if (createdCols.length !== tableCols.length) {
                    var template = createdCols[0].cloneNode();
                    for (var i = ZRSZia_Model.zrsziadatamodeltabncol.initialColRendCount, len = tableCols.length; i < len; i++) {
                        var curCol = template.cloneNode();
                        curCol.innerText = tableCols[i].columnText;
                        parent.insertBefore(curCol, target);
                    }
                }
                for (var i = 0, len = createdCols.length; i < len; i++) {
                    if (action === 'less' && i >= ZRSZia_Model.zrsziadatamodeltabncol.initialColRendCount) {
                        ZDBUtil.addClass(createdCols[i], 'hide');
                    } else {
                        ZDBUtil.removeClass(createdCols[i], 'hide');
                    }
                }
                target.setAttribute('action', action === 'less' ? 'more' : 'less');
                target.innerText = (action === 'more') ? ZDBI18NMap.g('zrpt.common.import.moreorless.js.Less') : ZDBI18NMap.g('zrpt.common.import.moreorless.js.More');//NO I18N
            }
        }
    },
    zrsziaChartInfoDialog: {
        shownDlg: null,
        axisInfoToTextMapping: {
            'xaxis': ZDBI18NMap.g('zrpt.zia.js.xaxis'), //NO I18N
            'yaxis': ZDBI18NMap.g('zrpt.zia.js.yaxis'), //NO I18N
            'coloraxis': ZDBI18NMap.g('zrpt.zia.js.color'), //NO I18N
            'tooltip': ZDBI18NMap.g('zrpt.chartview.setting.js.tooltip'), //NO I18N
            'column': ZDBI18NMap.g('zrpt.pivot.condFormat.js.colData'), //NO I18N
            'row': ZDBI18NMap.g('zrpt.pivot.condFormat.js.rowData'), //NO I18N
            'groupby': ZDBI18NMap.g('zrpt.zia.js.groupby'), //NO I18N
            'data': ZDBI18NMap.g('zrpt.common.js.data'), //NO I18N
            'summarize': ZDBI18NMap.g('zrpt.zia.js.summarize'), //NO I18N
            'filtervalues': ZDBI18NMap.g('zrpt.zia.js.filteredval')//NO I18N
        },
        show: function (info, holder) {
            var chartInfo = ZRSZia_controller.zrsziaChartInfoDialog.buildDynamicData(info);
            ZRSZia_controller.zrsziaChartInfoDialog.shownDlg = ZRSStringTemplateCreator.createTemplateForDynamicData('zrsziachartinfodlg', 'zrszia', false, chartInfo);//NO I18N
            var filterTab = ZRSZia_controller.zrsziaChartInfoDialog.shownDlg.querySelector('div[filtertab="true"]');
            if (chartInfo.filterData.length === 0) {
                ZDBUtil.addClass(filterTab, 'hide');
            } else {
                ZDBUtil.removeClass(filterTab, 'hide');
            }
            holder.appendChild(ZRSZia_controller.zrsziaChartInfoDialog.shownDlg);
            ZRSZia_controller.zrsziaChartInfoDialog.addEvents();
        },
        buildDynamicData: function (chartInfo) {
            var baseData = ZDBUtil.duplicateObject(ZRSZia_Model.zrsziachartinfodlg);
            var colData = [];
            var filterData = [];
            if (chartInfo.columns) {
                var keys = Object.keys(chartInfo.columns);
                for (var i = 0, len = keys.length; i < len; i++) {
                    var curKey = keys[i];
                    var i18nTxt = ZRSZia_controller.zrsziaChartInfoDialog.axisInfoToTextMapping[curKey];
                    var columns = [];
                    var columnsInAxis = chartInfo.columns[curKey];
                    for (var j = 0, len2 = columnsInAxis.length; j < len2; j++) {
                        var curCol = columnsInAxis[j];
                        var columnName = curCol.column;
                        var actionAppliedOnColumn = curCol.operation;
                        var columnTableName = curCol.partblname;
                        columns.push({
                            col: ZDBEscapeUtil.encodeForHtml(columnName) + ' (' + actionAppliedOnColumn.toUpperCase() + ')',
                            title: ZDBEscapeUtil.encodeForHtmlAttr(columnTableName) + '.' + ZDBEscapeUtil.encodeForHtmlAttr(columnName)
                        });
                    }
                    var axisDataString = ZRSStringTemplateCreator.createTemplateForDynamicData('zrsziacharttablencolinfo', 'zrszia', true, {//NO I18N
                        axis: i18nTxt,
                        cols: columns
                    });
                    colData.push({
                        cols: axisDataString
                    });
                }
            }
            baseData.colData = colData;
            baseData.filterData = filterData;
            return baseData;
        },
        addEvents: function () {
            document.addEventListener('click', ZRSZia_controller.zrsziaChartInfoDialog.closeDlg);
        },
        removeEvents: function () {
            document.removeEventListener('click', ZRSZia_controller.zrsziaChartInfoDialog.closeDlg);
        },
        closeDlg: function (event) {
            if(ZRSZia_controller.zrsziaChartInfoDialog.shownDlg) {
                var target = event && event.target;
                if (event && event.type === 'click') {
                    var parent = DOMUtils.getParentWithAttr(target, 'chartInfoDlg', 5);
                    if (parent && parent === ZRSZia_controller.zrsziaChartInfoDialog.shownDlg) {
                        return;
                    }
                }
                ZRSZia_controller.zrsziaChartInfoDialog.shownDlg.parentNode.removeChild(ZRSZia_controller.zrsziaChartInfoDialog.shownDlg);
                ZRSZia_controller.zrsziaChartInfoDialog.shownDlg = null;
                ZRSZia_controller.zrsziaChartInfoDialog.removeEvents();
            }
        }
    }
};

