/*$Id$*/

var Components_View = {
    preloader: '<div class="reports-preloader-cont"><div class="reports-preloader"><span></span><span></span><span></span><span></span></div><div class="preloader-text font12"></div></div>', // No I18N
    sidepane: '<div class=sidepane onclick=sidepane.hide()><div class="enable-transition sec5 ZRSUnselectable sidepane-container"onclick=event.stopPropagation()><div class="confirm-dlg-cont enable-transition" onclick=sidepane.hideConfirmDialog(this)><div class=confirm-dlg onclick="event.stopPropagation();"><div class="gray font12" style="text-align:center;" data-message></div><div class=confirm-dlg-footer><a class="newBtn greenBtn">Proceed</a><a class="newBtn" onclick=sidepane.hideConfirmDialog(this)>Cancel</a></div></div></div><div class="enable-transition sec5 sidepane-layer-1"data-layer-1><div class=panel><header><span data-header-1></span> <span><span class="closeDlg iconbg" onclick="sidepane.close()"></span><span class="fLeft QHelpIcon" tip="{{i18n:zrpt.common.js.help}}" style="margin: -1px 0px 0px -55px; cursor:pointer; display: none;" style="" onmouseout="ZDBToolTip.hide();" onmousemove="ZDBToolTip.show(this,event);"></span></span></header><section class=font12 data-body-1></section><footer data-footer-1></footer></div></div><div class="enable-transition sec5 sidepane-layer-2"data-layer-2><div class=panel><header onclick=sidepane.slideIn()><span class="arrow left"></span> <span data-header-2></span></header><section class=font12 data-body-2></section><footer data-footer-2></footer></div></div></div></div>',
    tab: '<div class=tabs><ul class=tab-switches></ul><ul class=tab-contents></ul></div>',
    bubble: '<div class="bubble enable-transition" onclick=bubble.edit(this);><div class=bubble-pic-cont><img height=24 width=24><div class="bubble-icon enable-transition"></div></div><div class=bubble-value></div><div class=bubble-close></div></div>', // No I18N
    copyOption: '<div class="enable-transition copy-option"onclick="bubble.copyToClipboard(event);event.stopPropagation();"><svg class="svgIcons enable-transition"><use class=gr xlink:href=#ZR-copy></use></svg></div>', // No I18N
    filterCriteria: '<div class=fc-holder><div>{{i18n:zrpt.explorer.share.shareview.js.fc_dlgdesc1}}</div><div style="display: flex;"><span>{{i18n:zrpt.explorer.share.shareview.js.fc_dlgdesc2}}</span><span class="ZRSHelpIcon" style="margin-left: 5px;" onmouseenter="ZDBToolTip.show(this,event)" onmouseleave="ZDBToolTip.hide(this,event)" tip="{{i18n:zrpt.explorer.share.shareview.js.fc_tooltip}}"></span></div><div class="fc-example" style="margin:8px 0"><span class="strong-text gray">{{i18n:zrpt.explorer.share.shareview.js.fc_example}}</span><a class="ZRSLink" href=https://www.w3schools.com/sql/sql_where.asp target=_blank style="position: absolute;right: 25px;">{{i18n:zrpt.common.js.help}}</a></div><div class="font10 gray" style="padding: 0; margin-top: -4px;">{{i18n:zrpt.explorer.share.shareview.js.fc_exdesc}}</div><div class="fc-not-supported">{{i18n:zrpt.explorer.share.shareview.js.fc_multiseldisabledmsg}}</div><div class=fc-cont style="padding:5px 10px 6px 12px"><div class=fc-text-cont><header><span>{{i18n:zrpt.explorer.share.shareview.js.fc_titletxt}}</span> <a class=ZRSLink onclick=fc.requestPreview()>{{i18n:zrpt.explorer.share.shareview.js.fc_preview}}</a></header><section><div class="fc-text-area-cont"><textarea id=fcTextArea name=filterCriteria style="width:500px !important;height:183px;" onfocus="this.parentNode.classList.add(\'focus\')" onblur="this.parentNode.classList.remove(\'focus\')"></textarea></div><label for=inheritParentCriteria class="font12" style=display:flex;padding-top:7px><input id=inheritParentCriteria name=inheritParentCriteria style=vertical-align:bottom type=checkbox> <span style="padding-left: 3px;">{{i18n:zrpt.explorer.share.shareview.js.apply_criteria}}</span><span class="ZRSHelpIcon" style="margin-left: 5px;" onmouseenter="ZDBToolTip.show(this,event)" onmouseleave="ZDBToolTip.hide(this,event)" tip="{{i18n:zr.share.js.fc_inherit}}"><span></label></section></div><div class=fc-options-cont style="margin:5px 0 0 10px"><div style="padding-bottom: 4px;">{{i18n:zr.share.js.click_to_insert}}</div><header><div class="tab is-active"onclick=fc.loadTab(this)>{{i18n:zrpt.explorer.share.shareview.js.fc_columns}}</div><div class=tab onclick=fc.loadTab(this)>{{i18n:zrpt.explorer.share.shareview.js.fc_variables}}</div></header><section><div class=opts-cont><ul class=opts-cont-table id=columns></ul><ul class=opts-cont-variables id=variables></ul></div></section></div></div></div>',
    fcPreview: '<div style=display:none><div style=height:500px id=ZDBPreviewDiv><iframe height=500px id=ZDBPreviewIFrame src=""width=685px></iframe></div></div>', //No I18N
    columnChooser: '<div class="ZRShadow popup"><span class=ZRSMenuTopBefore></span> <span class=ZRSMenuTopAfter></span> <span class="closeDlg iconbg"style=float:right></span><div>{{title}}</div><label class=padding-top-10 for=columnChooser><input id=columnChooser type=checkbox> <strong>{{tableName}}</strong></label><div class=vud-columns-cont id=columnsCont></div></div>',
    pushbar: '<div class="enable-transition pushbar"><header><div class=pushbar-title><span id=pushbarTitle></span> <span class="closeDlg iconbg"onclick=PushBar.hide()></span></div></header><section id=pushbarBody></section></div>',
    accSearch: '<div class="search-container"><input type="text" placeholder="{{i18n:zrpt.common.toolbar.share.zdbalertmsg.js.searchcontacts}}"><div class="ZRSSearchIcon" style="top: 16px;right: 12px;position: absolute;"></div></div>', //No I18N
    accGroup: '<div class="enable-transition acc-group"><div class="acc-title"onclick=Accordion.showGroup(this)><svg class="svgIcons enable-transition"><use class=gr xlink:href=#ZR-downArrow></use></svg><span data-title=true></span><span data-search-result></span></div><div class="enable-transition acc-content font12"data-content=true></div></div>',
    contact: '<li class="enable-transition zr-contact" draggable="true" ondrag="bubble.handleContactDrag(this, event);" ondragstart="bubble.handleContactDragStart(this, event);" ondragend="bubble.handleContactDragEnd(this, event);"><div class=contact-pic-holder><img height=30 style=border-radius:50% width=30><div class="no-image s30"></div></div><div style=padding-left:10px><div class=strong-text data-name></div><div data-id></div><div style=display:none data-zuid></div></div><div class="contact-add-icon"><svg class="svgIcons"><use class="gr" xlink:href="#ZR-createNew"></use></svg></div>',
    tabHead: '<li class="enable-transition" onclick="tab.change(event);"></li>',
};

ZRSHTMLTemplateStrings['__preloader__components__view'] = Components_View.preloader;
ZRSHTMLTemplateStrings['__sidepane__components__view'] = Components_View.sidepane;
ZRSHTMLTemplateStrings['__tab__components__view'] = Components_View.tab;
ZRSHTMLTemplateStrings['__bubble__components__view'] = Components_View.bubble;
ZRSHTMLTemplateStrings['__copyOption__components__view'] = Components_View.copyOption;
ZRSHTMLTemplateStrings['__filterCriteria__components__view'] = Components_View.filterCriteria;
ZRSHTMLTemplateStrings['__fcPreview__components__view'] = Components_View.fcPreview;
ZRSHTMLTemplateStrings['__columnChooser__components__view'] = Components_View.columnChooser;
ZRSHTMLTemplateStrings['__pushbar__components__view'] = Components_View.pushbar;
ZRSHTMLTemplateStrings['__accSearch__components__view'] = Components_View.accSearch;
ZRSHTMLTemplateStrings['__accGroup__components__view'] = Components_View.accGroup;
ZRSHTMLTemplateStrings['__contact__components__view'] = Components_View.contact;
ZRSHTMLTemplateStrings['__tabHead__components__view'] = Components_View.tabHead;