// $Id$ 

/*actual format of string given below
 * homepage
 
 <header class='{{headerClass}}' id='ZDBMainHeader'>
        <div class='fLeft' style='height:inherit'>
            <div class='dInlineBlock ZRSwitchToSquare' tip='{{headerZApps}}' onmouseenter='ZDBToolTip.show(this,event,\"RIGHT\");' onmouseleave='ZDBToolTip.hide(this);'  onclick='ZRSMenu.showHeaderMenu(this, event,\"ZRZAppsMenu\")'>
                    <span></span>
                    <span class='two'></span>
                    <span></span>
                    <span></span>
                    <span class='five'></span>
                    <span></span>
                    <span></span>
                    <span class='eight'></span>
                    <span></span>
            </div>

            <div class='dInlineBlock vMiddle cPointer' style='margin-top: -5px; margin-right: 8px;'>
                    <img onclick='DOMUtils.openLink(this)' tip='{{domainURL}}' onmouseenter='ZDBToolTip.show(this,event);' onmouseleave='ZDBToolTip.hide(this);' data-url='{{domainURL}}' src='{{domainLogo}}' width='170' height='25'/>
            </div>
            {{if:homeLinkCond:
            <div class='dInlineBlock vMiddle cPointer' style='margin-top: -5px;'>
                    <a href='###homeLink###' ###hideOnNotLoggedIn### tip='###homeLinkTip###' onmouseout='ZDBToolTip.hide(this);' onmousemove='ZDBToolTip.show(this,event);' crmplus-module-clickname='zrpt.home.myhome'>
                        <svg class='svgIcons topbar-icon' style='height:18px;width:18px;'><use xlink:href='#ZR-home'></use></svg>
                    </a>
            </div>
            }}

            {{if:databaseListCond:
            <div id='ZRSDBInfo' onclick='ZDBHeader.showDatabases(this, event);'>
                <div id='ZDBDBNAME' class='ZRSDBNAME ellipsis fLeft' desc='###dbDesc###' dbname='###dbName###'>###dbName###</div>
                <div id="ZRSDBDropDown" class="fLeft" style="padding:0 5px">
                    <svg class="svgIcons topbar-icon" style=" height: 26px; width: 10px; stroke-width: 2px;" >
                        <use xlink:href="#ZR-downArrow"></use>
                    </svg>
                </div>
            </div>
            <div id='ZRSDBMenu' class='ZRSMenu shadowAdded' style="padding:10px">
                <span class='ZRSMenuTopBefore' style="left:42px;"></span>
                <span class='ZRSMenuTopAfter' style="left:42px;"></span>
                <div id='ZRSDBSearchComp' class='ZRSBorderBottom' style="height:30px;display:none;">
                    <div class='searchBox' style="white-space:nowrap; width: 262px;">
                        <div style="cursor:pointer; position: relative; margin-right: 5px;" onclick='ZDBHeader.showDBSearchMenu(this,event);' elname='ZRSSearchIcon' class='ZRSSearchIconLeft'>
                            <span style='position: absolute;top:9px;left:15px;' class='downArrow'></span>
                        </div>
                        <div onmousedown='ZDBHeader.clearSearch(this,event);' style="display:none;" class='ZRSSearchClearIcon'></div>
                        <input id='ZRSDBSearchBox' type='text' onblur='ZDBSearchUtil.showTipString(this);' 
                        onfocus='ZDBSearchUtil.hideTipString(this);' tipshown='true' searchempty='true' 
                        tipvalue='###dbListSearchText###' value='###dbListSearchText###' name='textfield' class='searchEl' 
                        elname='ZRSSearchInput' defaulttip='###dbListSearchText###' onkeyup='ZDBHeader.searchDatabases(event, null); style="margin: 0px;width:216px;"'>
                    </div>
                </div>
                <div id='ZRSALLDBList' onscroll='ZDBHeader.scrollDBList(event);'>
                    <ul>
                    </ul>
                </div>
            </div>
            }}

            {{if:databaseListOnly:
            <div id='ZDBDBNAME' class='ellipsis fLeft' desc='###dbDesc###' dbname='###dbName###'>###dbName###</div>
            }}
        </div>
	<div class='fRight' style='height:55px;line-height:55px;'>
		{{if:tryOtherEdition:
			<div class='fLeft' style='padding-right:16px;' onclick='ZDBGlobal.toggleTryNewEdition(this, event);'>
				<a class="try-editions-font">
					###text###
				</a>
			</div>
		}}

		{{if:storeDets:
			<div class='fLeft' style='padding-right: 8px;'>
				<a class="subscription-font" href='#' onclick="ZROrg.showOrgSubNSettings('Subscription')">###text###</a>
			</div>
		}}

		{{if:notification:
                        <div class='notification-ripple fLeft headerIcons' style='width:inherit;'>
                            <span></span><span></span>
                            <div style='position:relative;height:34px;' onclick='GlobalNotification.toggle(this);' onmousemove='ZDBToolTip.show(this,event);' onmouseout='ZDBToolTip.hide(this);' tip=###notificationText###>
                                    <a href='#'>
                                            <svg class='svgIcons topbar-icon'><use xlink:href='#ZR-notification'></use></svg>
                                    </a>
                                    <span id='notificationBadge' class='notification-badge enable-transition'></span>
                            </div>
                        </div>
		}}

		{{if:userDets:
			<div class='fLeft headerIcons' onmousemove='ZDBToolTip.show(this,event);' onmouseout='ZDBToolTip.hide(this);' tip=###settingsText###>
				<a href='#' onclick="ZROrg.showOrgSubNSettings('Settings')">
					<svg class='svgIcons topbar-icon'><use xlink:href='#ZR-settings'></use></svg>
				</a>
			</div>
		}}

		{{if:helpLink:
			<div class='fLeft headerIcons' onmousemove='ZDBToolTip.show(this,event);' onmouseout='ZDBToolTip.hide(this);' tip=###helpText### onclick='ZRSMenu.showHeaderMenu(this, event,\"ZDBProductLinksMenu\");'>
				<a href='#'>
					<svg class='svgIcons topbar-icon'><use xlink:href='#ZR-help'></use></svg>
				</a>
			</div>
		}}

		<div class='dInlineBlock' style='padding-left:5px;'>
			{{if:notSignedIn:
				<a href='###link###'>###text###</a>
			}}
			{{if:signedIn:
				<div id='ZDBProfileThumbCont' style='width:35px;' onclick='ZROrg.showProfileInfo_NEW(this);'>
                                    <div id='showProfileInfo' style='height:30px;background:none !important;'>
                                            <img class='ZRSProfileSmallPic'/>
                                            <div class='no-image no-profile-image thumb ZRSUnselectable' style='display: none;'></div>
                                    </div>
                                </div>
			}}
                </div>		
	</div>	
</header>



 *zohoapps
 
 <div id='ZRZAppsMenu' class='ZRZAppsMenu'>
	<div>
		<div class='ZAppGroup'>
			<ul>
				<li class='ZAppTitle'>{{marketing}}</li>
				{{for:salesNMarketing:
					<li class='ZAppProducts'>
						<a href='###link###' target='_blank'> 
							<span class='###appIcon###'></span>
							<span>###appText###</span> 
						</a>
					</li>
				}}
			</ul>
			<ul style='margin-top: 33px;''>
				<li class='ZAppTitle'>{{hrTitle}}</li>
				{{for:hr:
					<li class='ZAppProducts'>
						<a href='###link###' target='_blank'> 
							<span class='###appIcon###'></span>
							<span>###appText###</span> 
						</a>
					</li>
				}}
			</ul>
		</div>
		<div class='ZAppGroup'>
			<ul>
				<li class='ZAppTitle'>{{email}}</li>
				{{for:emailNCollaboration:
					<li class='ZAppProducts'>
						<a href='###link###' target='_blank'> 
							<span class='###appIcon###'></span>
							<span>###appText###</span> 
						</a>
					</li>
				}}
			</ul>
		</div>
		<div class='ZAppGroup'>
			<ul>
				<li class='ZAppTitle'>{{business}}</li>
				{{for:businessProcess:
					<li class='ZAppProducts'>
						<a href='###link###' target='_blank'> 
							<span class='###appIcon###'></span>
							<span>###appText###</span> 
						</a>
					</li>
				}}
			</ul>
			<ul style='margin-top: 33px;''>
				<li class='ZAppTitle'>{{financeTitle}}</li>
				{{for:finance:
					<li class='ZAppProducts'>
						<a href='###link###' target='_blank'> 
							<span class='###appIcon###'></span>
							<span>###appText###</span> 
						</a>
					</li>
				}}
			</ul>
			<ul style='margin-top: 33px;''>
				<li class='ZAppTitle'>{{help}}</li>
				{{for:helpDesk:
					<li class='ZAppProducts'>
						<a href='###link###' target='_blank'> 
							<span class='###appIcon###'></span>
							<span>###appText###</span> 
						</a>
					</li>
				}}
			</ul>
		</div>
	</div>
</div>
 
 
 *tryOtherPlan Dialog
 <div id='tryNewEditionsCont'>
	<span class='ZRSMenuTopBefore' style='left:270px;'></span>
	<span class='ZRSMenuTopAfter' style='left:270px'></span>
	<div class='edition_header'>{{header}}</div>
	{{for:plans:
		<div class='edition_labels'>
			<span>###planName###</span>
			<div class='try_now_btn' onclick='ZDBGlobal.tryPlan(###planID###);'>###tryNowText###</div>
		</div>
	}}
	<div class='other_options'>
		<a href='https://www.zoho.com/reports/zohoreports-pricing.html' target='_blank'>{{compareEditionText}}</a>
		<span>&nbsp;&nbsp;|&nbsp;&nbsp;</span>
		<a onclick='DOMUtils.openLink(this,\"_self\");' data-url={{upgradeLink}}>{{upgradeText}}</a>
	</div>
</div>
 
 
 *Help Menu
 *
 
 
 *signoutLinkMenu:
 *
<div id='accountOptionsCont' class='account-options-cont' onclick='ZROrg.closeProfileInfo_NEW();'>
    <div id='ZDBSignoutLinksMenu' class='account-options enable-transition font12 shadowAdded' onclick='ZRSMenu.closeAllMenu();event.stopPropagation();'>
        <div style='position: relative; height: 100%;overflow:hidden;'>
            <div id='ZRAccountOptions'>
                <div id='ZDBAccountInfo' class='account-info'>
                    
                    <div id='ZDBProfilePicCont' class='profile-pic-holder' data-first-letter='{{firstLetter}}' onclick=''>
                        <img id='ZDBProfilePic' class='change-image enable-transition' width='80' data-label='{{changeText}}'/>
                        <div class='no-image no-profile-image change-image enable-transition ZRSUnselectable' style='display: none;' data-label='{{changeText}}'></div>
                    </div>
                    
                    <div class='account-user-info'>
                        <div class='ellipsis font15 strong-text' style='max-width: 260px;' tip='{{userFullName_attr}}' onmousemove='ZDBToolTip.checkLengthAndShow(this, event);' onmouseout='ZDBToolTip.hide();'>{{userFullName}}</div>
                        <div class='ellipsis font12 gray' style='max-width: 260px;' tip='{{userEmail_attr}}' onmousemove='ZDBToolTip.checkLengthAndShow(this, event);' onmouseout='ZDBToolTip.hide();'>{{userEmail}}</div>
                        <div class='ellipsis font12 gray'>{{userZuidText}}: {{userZuid}}</div>
                            <div style='margin-top:10px;'>
                                <a class='ZRSBlueLink' style='margin-right: 10px;' target='_blank' href='{{iamURL}}'>{{accountText}}</a>
                                <span class='font11'>|</span>
                                <a class='ZRSSignOutLink' href='{{logoutURL}}' onClick='ZDBHeader.logoutAction();'>{{signoutText}}</a>
                            </div>
                        </div>
                    </div>
           
                    {{if:enableLayoutSelection:
                    <div class='options-holder enable-transition'>
                        <button class="ZRSButton layout-switch-button" onclick="ZDBGlobal.changeLayout()">###oldlayout###</button> 
                        <button class=ZRSButton onclick="ZDBGlobal.showHideThemeOptions(this)">###themeText###</button>
                        <button class=ZRSButton onclick="ZDBGlobal.showHideTabOptions(this)" style='###optiondisplay###'>Tab Layer</button> 
                        
                        <div class="theme-options">
                            <div style='margin: 20px; display: inline-block;'>
                                <div class=light_theme1 onclick=ZDBGlobal.changeTheme(this)>
                                    <svg class="svgIcons">
                                        <use xlink:href="#ZR-lightTheme"></use>
                                    </svg>
                                </div>
                                <div class=dark_theme1 onclick=ZDBGlobal.changeTheme(this)>
                                    <svg class="svgIcons">
                                        <use xlink:href="#ZR-darkTheme"></use>
                                    </svg>
                                </div>
                            </div>
                            <div style='margin: 20px; display: inline-block;'>
                                <div class=light_theme2 onclick=ZDBGlobal.changeTheme(this)>
                                    <svg class="svgIcons">
                                        <use xlink:href="#ZR-lightTheme"></use>
                                    </svg>
                                </div>
                                <div class=dark_theme2 onclick=ZDBGlobal.changeTheme(this)>
                                    <svg class="svgIcons">
                                        <use xlink:href="#ZR-darkTheme"></use>
                                    </svg>
                                </div>
                            </div>
                        </div>

                        <div class="tab-options">
                            <div style=margin:20px>
                                <span style="padding-left:20px;" value="1" class="###layer1class###" onclick="ZDBGlobal.changeTabLayerPosition(this);">Top Layer</span>
                                <span style="padding-left:20px;margin-left: 10px;" value="2" class="###layer2class###" onclick="ZDBGlobal.changeTabLayerPosition(this);">Separate Layer</span>
                            </div>
                        </div>

                        <div id="tablayercont" class="options-holder-menu shadowAdded" elname="optionsHolderMenu" style="display:none">
                            <span class="ZRSMenuTopBefore"></span>
                            <span class="ZRSMenuTopAfter"></span>
                            <div class="layout-holder">
                                <span style="padding-left:20px;" value="1" class="###layer1class###" onclick="ZDBGlobal.changeTabLayerPosition(this);">Top Layer</span>
                                <span style="padding-left:20px;margin-left: 10px;" value="2" class="###layer2class###" onclick="ZDBGlobal.changeTabLayerPosition(this);">Separate Layer</span>
                            </div>
                        </div>

                        <div id="themecont" class="options-holder-menu shadowAdded" elname="optionsHolderMenu" style="display:none">
                            <span class="ZRSMenuTopBefore"></span>
                            <span class="ZRSMenuTopAfter"></span>
                            <div class=themes-holder>
                                <span class=light_theme1 onclick=ZDBGlobal.changeTheme(this)></span> 
                                <span class=dark_theme1 onclick=ZDBGlobal.changeTheme(this)></span> 
                                <span class=light_theme2 onclick=ZDBGlobal.changeTheme(this)></span> 
                                <span class=dark_theme2 onclick=ZDBGlobal.changeTheme(this)></span>
                            </div>
                        </div>
                    </div>
                    }}
    
                </div>
            </div>
        </div>
    </div>
</div>
*/

/* Tab layer (Top layer)
<div id="topbarTab" class="dInlineBlock">
    <div class="topBarSpace" elname="topBarSpace" crmplus-action="alwaysVisibilityHidden">
        <div id="ZRSTabParent" class="tabEl" onscroll="ZDBNavigation.showHideTabNavigButtons(this, null, true)">
            <div id="ZRSTabHolder" class="fLeft" elname ="tabHolder"></div>
        </div>
    </div>
    <div class="fRight">
        <div class="zrLeftTabNavig tabEl" onclick="ZDBNavigation.scrollTab('left')">
            <svg class="svgIcons topbar-icon" style=" height: 17px; width: 13px; stroke-width: 1px; padding-right: 1px;" >
                <use xlink:href="#ZR-downArrow"></use>
            </svg>
        </div>
        <div class="zrRightTabNavig tabEl" onclick="ZDBNavigation.scrollTab('right')">
            <svg class="svgIcons topbar-icon" style=" height: 17px; width: 13px; stroke-width: 1px;" >
                <use xlink:href="#ZR-downArrow"></use>
            </svg>
        </div>
        <div class="ZRMoreTabs" onclick="ZDBNavigation.listOpenedViews(this, event);" menuparent="true">
            <svg class="svgIcons topbar-icon" style=" height: 38px; width: 16px;" >
                <use xlink:href="#ZR-more"></use>
            </svg>
        </div>
    </div>
</div>

 */

/*
 * Loader
    <div id='{{loaderId}}' class='{{loaderClassName}}' style='top: 50%; left: 50%; height: auto;margin-top:-20px;margin-left:-80px'>
        <div style='padding: 10px 40px; vertical-align: middle; background-position: 10px 5px;white-space: nowrap' class='loadingImage' elname='{{elname}}'>{{loadingText}}</div>
    </div>
 */


//Dont directly edit here. Edit in above structure and compress it and put it here.
var ZRSHeader_View = {
    homepage : "<header class='{{headerClass}}'id='ZDBMainHeader'><div class='fLeft' style='height:inherit'><div class='dInlineBlock ZRSwitchToSquare'onclick='ZRSMenu.showHeaderMenu(this, event,\"ZRZAppsMenu\")'tip='{{headerZApps}}'onmouseenter='ZDBToolTip.show(this,event,\"RIGHT\");'onmouseleave='ZDBToolTip.hide(this);'><span></span> <span class='two'></span> <span></span> <span></span> <span class='five'></span> <span></span> <span></span> <span class='eight'></span> <span></span></div><div class='dInlineBlock cPointer vMiddle'style='margin-top: -5px;margin-right:8px;'><img data-url='{{domainURL}}'height='25'onclick='DOMUtils.openLink(this)'onmouseenter='ZDBToolTip.show(this,event);'onmouseleave='ZDBToolTip.hide(this);'src='{{domainLogo}}'tip='{{domainURL}}'width='170'></div>{{if:homeLinkCond:<div class='dInlineBlock cPointer vMiddle'style='margin-top: -5px;'><a href='###homeLink###'###hideonnotloggedin### crmplus-module-clickname='zrpt.home.myhome'onmousemove='ZDBToolTip.show(this,event);'onmouseout='ZDBToolTip.hide(this);'tip='###homeLinkTip###'><svg class='svgIcons topbar-icon' style='height:18px;width:18px'><use xlink:href='#ZR-home'></use></svg></a></div>}} {{if:databaseListCond:<div id=ZRSDBInfo onclick=ZDBHeader.showDatabases(this,event)><div class='ellipsis ZRSDBNAME fLeft'id=ZDBDBNAME dbname='###dbName###' desc='###dbDesc###'>###dbName###</div><div class='fLeft'id=ZRSDBDropDown style='padding:0 5px'><svg class='svgIcons topbar-icon' style=height:26px;width:10px;stroke-width:2px><use xlink:href=#ZR-downArrow></use></svg></div></div><div class='ZRSMenu shadowAdded'id=ZRSDBMenu style=padding:10px><span class=ZRSMenuTopBefore style=left:42px></span> <span class=ZRSMenuTopAfter style=left:42px></span><div class=ZRSBorderBottom id=ZRSDBSearchComp style='height:30px;display:none;'><div class=searchBox style='white-space:nowrap; width: 262px;'><div class=ZRSSearchIconLeft onclick=ZDBHeader.showDBSearchMenu(this,event) elname=ZRSSearchIcon style='cursor:pointer; position: relative; margin-right: 5px;'><span class=downArrow style=position:absolute;top:9px;left:15px></span></div><div class=ZRSSearchClearIcon style=display:none onmousedown=ZDBHeader.clearSearch(this,event)></div><input class=searchEl defaulttip='###dbListSearchText###' elname=ZRSSearchInput id=ZRSDBSearchBox name=textfield onblur=ZDBSearchUtil.showTipString(this) onfocus=ZDBSearchUtil.hideTipString(this) onkeyup=ZDBHeader.searchDatabases(event,null) searchempty=true tipshown=true tipvalue='###dbListSearchText###' value='###dbListSearchText###' style='margin: 0px;width:216px;'></div></div><div id=ZRSALLDBList onscroll=ZDBHeader.scrollDBList(event)><ul></ul></div></div>}} {{if:databaseListOnly:<div class='ellipsis fLeft' id=ZDBDBNAME dbname='###dbName###' desc='###dbDesc###'>###dbName###</div>}} </div><div class='fRight'style='height:40px;line-height:40px;'>{{if:tryOtherEdition:<div class='fLeft'style='padding-right:16px;'onclick='ZDBGlobal.toggleTryNewEdition(this, event);'><a class=try-editions-font>###text###</a></div>}} {{if:storeDets:<div class='fLeft'style='padding-right: 8px;'><a href='#' onclick=ZROrg.showOrgSubNSettings('Subscription') class=subscription-font>###text###</a></div>}} {{if:notification:<div class='fLeft headerIcons notification-ripple'style='width:inherit;'><span></span><span></span><div style='position:relative;height:34px;'onclick='GlobalNotification.toggle(this);'onmousemove='ZDBToolTip.show(this,event);'onmouseout='ZDBToolTip.hide(this);'tip='###notificationText###'><a href='#'><svg class='svgIcons topbar-icon'><use xlink:href='#ZR-notification'></use></svg> </a><span class='enable-transition notification-badge'id='notificationBadge'></span></div></div>}} {{if:userDets:<div class='fLeft headerIcons'tip='###settingsText###'onmousemove='ZDBToolTip.show(this,event);'onmouseout='ZDBToolTip.hide(this);'><a href='#' onclick=ZROrg.showOrgSubNSettings('Settings')><svg class='svgIcons topbar-icon'><use xlink:href='#ZR-settings'></use></svg></a></div>}} {{if:helpLink:<div class='fLeft headerIcons'onclick='ZRSMenu.showHeaderMenu(this, event,\"ZDBProductLinksMenu\");'tip='###helpText###'onmousemove='ZDBToolTip.show(this,event);'onmouseout='ZDBToolTip.hide(this);'><a href='#'><svg class='svgIcons topbar-icon'><use xlink:href='#ZR-help'></use></svg></a></div>}}<div class='dInlineBlock'style='padding-left:5px;'>{{if:notSignedIn: <a href='###link###'>###text###</a> }} {{if:signedIn:<div style='width:35px;'onclick='ZROrg.showProfileInfo_NEW(this);'id='ZDBProfileThumbCont'><div style='height:30px;background:none !important;'id='showProfileInfo'><img class='ZRSProfileSmallPic'><div class='ZRSUnselectable no-image no-profile-image thumb'style='display: none;'></div></div></div>}}</div></div></header>",
    zohoapps : "<div class='ZRZAppsMenu'id='ZRZAppsMenu'><div><div class='ZAppGroup'><ul><li class='ZAppTitle'>{{marketing}}</li>{{for:salesNMarketing:<li class='ZAppProducts'><a href='###link###'target='_blank'><span class='###appIcon###'></span> <span>###appText###</span></a></li>}}</ul><ul style='margin-top: 33px;'><li class='ZAppTitle'>{{hrTitle}}</li>{{for:hr:<li class='ZAppProducts'><a href='###link###'target='_blank'><span class='###appIcon###'></span> <span>###appText###</span></a></li>}}</ul></div><div class='ZAppGroup'><ul><li class='ZAppTitle'>{{email}}</li>{{for:emailNCollaboration:<li class='ZAppProducts'><a href='###link###'target='_blank'><span class='###appIcon###'></span> <span>###appText###</span></a></li>}}</ul></div><div class='ZAppGroup'><ul><li class='ZAppTitle'>{{business}}</li>{{for:businessProcess:<li class='ZAppProducts'><a href='###link###'target='_blank'><span class='###appIcon###'></span> <span>###appText###</span></a></li>}}</ul><ul style='margin-top: 33px;'><li class='ZAppTitle'>{{financeTitle}}</li>{{for:finance:<li class='ZAppProducts'><a href='###link###'target='_blank'><span class='###appIcon###'></span> <span>###appText###</span></a></li>}}</ul><ul style='margin-top: 33px;'><li class='ZAppTitle'>{{help}}</li>{{for:helpDesk:<li class='ZAppProducts'><a href='###link###'target='_blank'><span class='###appIcon###'></span> <span>###appText###</span></a></li>}}</ul></div></div></div>",
    tryotherplans : "<div id='tryNewEditionsCont'><span class='ZRSMenuTopBefore'style='left:270px'></span> <span class='ZRSMenuTopAfter'style='left:270px'></span><div class='edition_header'>{{header}}</div>{{for:plans:<div class='edition_labels'><span>###planName###</span><div class='try_now_btn'onclick='ZDBGlobal.tryPlan(###planID###);'>###tryNowText###</div></div>}}<div class='other_options'><a href='https://www.zoho.com/reports/zohoreports-pricing.html'target='_blank'>{{compareEditionText}}</a> <span>  |  </span><a data-url='{{upgradeLink}}'onclick='DOMUtils.openLink(this,\"_self\");'>{{upgradeText}}</a></div></div>",
    signOutLinkMenu: "<div class=account-options-cont id=accountOptionsCont onclick=ZROrg.closeProfileInfo_NEW()><div class='shadowAdded account-options enable-transition font12'id=ZDBSignoutLinksMenu onclick=ZRSMenu.closeAllMenu(),event.stopPropagation()><div style=position:relative;height:100%;overflow:hidden><div id=ZRAccountOptions><div class=account-info id=ZDBAccountInfo><div class=profile-pic-holder id=ZDBProfilePicCont data-first-letter={{firstLetter}}><img class='enable-transition change-image'data-label={{changeText}} id=ZDBProfilePic width=80><div class='enable-transition change-image ZRSUnselectable no-image no-profile-image'style=display:none data-label={{changeText}}></div></div><div class=account-user-info><div class='ellipsis font15 strong-text'style=max-width:260px onmousemove=ZDBToolTip.checkLengthAndShow(this,event) onmouseout=ZDBToolTip.hide() tip={{userFullName_attr}}>{{userFullName}}</div><div class='ellipsis font12 gray'style=max-width:260px onmousemove=ZDBToolTip.checkLengthAndShow(this,event) onmouseout=ZDBToolTip.hide() tip={{userEmail_attr}}>{{userEmail}}</div><div class='ellipsis font12 gray'>{{userZuidText}}: {{userZuid}}</div><div style=margin-top:10px><a class=ZRSBlueLink href={{iamURL}} style=margin-right:10px target=_blank>{{accountText}}</a> <span class=font11>|</span> <a class=ZRSSignOutLink href={{logoutURL}} onclick=ZDBHeader.logoutAction()>{{signoutText}}</a></div></div></div>{{if:enableLayoutSelection:<div class='options-holder enable-transition'><button class='ZRSButton layout-switch-button' onclick=ZDBGlobal.changeLayout()>###oldlayout###</button><button class=ZRSButton onclick=ZDBGlobal.showHideThemeOptions(this)>###themeText###</button><button class=ZRSButton onclick=ZDBGlobal.showHideTabOptions(this) style='###optiondisplay###'>Tab Layer</button> <div class=theme-options><div style=margin:20px;display:inline-block><div onclick=ZDBGlobal.changeTheme(this) class=light_theme1><svg class=svgIcons><use xlink:href=#ZR-lightTheme></use></svg></div><div onclick=ZDBGlobal.changeTheme(this) class=dark_theme1><svg class=svgIcons><use xlink:href=#ZR-darkTheme></use></svg></div></div><div style=margin:20px;display:inline-block><div onclick=ZDBGlobal.changeTheme(this) class=light_theme2><svg class=svgIcons><use xlink:href=#ZR-lightTheme></use></svg></div><div onclick=ZDBGlobal.changeTheme(this) class=dark_theme2><svg class=svgIcons><use xlink:href=#ZR-darkTheme></use></svg></div></div></div> <div class=tab-options><div style=margin:20px><span class=###layer1class### onclick=ZDBGlobal.changeTabLayerPosition(this) style=padding-left:20px value=1>Top Layer</span> <span class=###layer2class### onclick=ZDBGlobal.changeTabLayerPosition(this) style=padding-left:20px;margin-left:10px value=2>Separate Layer</span></div></div> </div>}}</div></div></div></div>",
    topbarTab: '<div id=topbarTab class=dInlineBlock><div class="fLeft topBarSpace"elname=topBarSpace crmplus-action=alwaysVisibilityHidden><div class=tabEl id=ZRSTabParent onscroll="ZDBNavigation.showHideTabNavigButtons(this, null, true)"><div class=fLeft id=ZRSTabHolder elname=tabHolder></div></div> <div class="tabEl zrLeftTabNavig"onclick=ZDBNavigation.scrollTab("left")><svg class="svgIcons topbar-icon" style=height:17px;width:13px;stroke-width:1px;padding-right:1px><use xlink:href=#ZR-downArrow></use></svg></div><div class="tabEl zrRightTabNavig"onclick=ZDBNavigation.scrollTab("right")><svg class="svgIcons topbar-icon" style=height:17px;width:13px;stroke-width:1px><use xlink:href=#ZR-downArrow></use></svg></div><div class="ZRMoreTabs"onclick=ZDBNavigation.listOpenedViews(this,event) menuparent=true><svg class="svgIcons topbar-icon" style=height:38px;width:16px><use xlink:href=#ZR-more></use></svg></div></div></div>',
    loader: "<div class='{{loaderClassName}}'style='top: 50%; left: 50%; height: auto;margin-top:-20px;margin-left:-80px'id='{{loaderId}}'><div class='loadingImage'style='padding: 10px 40px; vertical-align: middle; background-position: 10px 5px;white-space: nowrap'elname='{{elname}}'>{{loadingText}}</div></div>"
};

ZRSHTMLTemplateStrings["__homepage__zrsheader__view"] = ZRSHeader_View.homepage;
ZRSHTMLTemplateStrings["__zohoapps__zrsheader__view"] = ZRSHeader_View.zohoapps;
ZRSHTMLTemplateStrings["__tryotherplans__zrsheader__view"] = ZRSHeader_View.tryotherplans;
ZRSHTMLTemplateStrings["__signOutLinkMenu__zrsheader__view"] = ZRSHeader_View.signOutLinkMenu;
ZRSHTMLTemplateStrings["__topbarTab__zrsheader__view"] = ZRSHeader_View.topbarTab;
ZRSHTMLTemplateStrings["__loader__zrsheader__view"] = ZRSHeader_View.loader;
