// $Id$ 
//ignorei18n_start
/*
 *ZRMenu_View Template 
 <div id="{{divID}}" class="ZRSMenu shadowAdded {{divClass}}" style="{{divStyle}}">
    {{if:pointerReq:
        <span class="###beforePointerClass###" style="###beforePointerStyle###"></span>
        <span class="###afterPointerClass###" style="###afterPointerStyle###"></span>
    }}
    <ul id="{{ulID}}" class="{{ulClass}}" style="{{ulStyle}}">
    {{for:menuData:
        <li>
            <a style='###style###' href="###link###" elname="###elname###" onclick="###onclick###" func="###func###" lzJs="###lzJs###" lazyload="###lazyload###" lzOper="###lzOper###" target="###target###" class="###class###">###menuText###</a>
        </li>
    }}
    </ul>
 </div>
 */



/*
 * Menu List Type 1
 * icon and text
   <div class="zrsNewMenu">
        <ul>
         {{for:menuItems:
             <li onclick="###onclickHandler###">
                 <svg class="zrsNewMenuIcons"><use xlink:href="###iconId###"></use></svg>
                 <span class="zrsmenuTextWImg ellipsis">###text###</span>
             </li>
         }}
        </ul>
   </div>
 */

/*
 * Menu List Type 2.
 * Text alone.
    <div class="zrsNewMenu">
        <ul>
        {{for:menuItems:
            <li onclick="###onclickHandler###">
                <span class="zrsmenuText ellipsis">###text###</span>
            </li>
        }}
        </ul>
    </div>
 */

/*
 * Menu List Type 3
 * Text with search bar
    <div class="zrsNewMenu">
        <ul style="max-height: 249px;">
         {{for:menuItems:
             <li onclick="###onclickHandler###">
                 <span class="zrsmenuText ellipsis">###text###</span>
             </li>
         }}
        </ul>
    </div>
 */
//Dont directly edit here. Edit in above structure and compress it and put it here.
var ZRSMenu_View = {
    oldMenu : "<div class='ZRSMenu shadowAdded {{divClass}}'id='{{divID}}'style='{{divStyle}}'>{{if:pointerReq: <span class='###beforePointerClass###'style='###beforePointerStyle###'></span> <span class='###afterPointerClass###'style='###afterPointerStyle###'></span> }}<ul class='{{ulClass}}'id='{{ulID}}'style='{{ulStyle}}'>{{for:menuData:<li><a class='###class###'elname='###elname###'func='###func###'href='###link###'lazyload='###lazyload###'lzjs='###lzJs###'lzoper='###lzOper###'onclick='###onclick###'style='###style###'target='###target###'>###menuText###</a></li>}}</ul></div>",
    zrsMenuType1 : "<div class='zrsNewMenu'><ul>{{for:menuItems:<li onclick='###onclickHandler###'><svg class='zrsNewMenuIcons'><use xlink:href='###iconId###'></use></svg> <span class='ellipsis zrsmenuTextWImg'>###text###</span></li>}}</ul></div>",
    zrsMenuType2 : "<div class='zrsNewMenu'><ul>{{for:menuItems:<li onclick='###onclickHandler###'><span class='ellipsis zrsmenuText'>###text###</span></li>}}</ul></div>",
    zrsMenuType3 : "<div class='zrsNewMenu'><ul style='max-height: 249px;'>{{for:menuItems:<li onclick='###onclickHandler###'><span class='ellipsis zrsmenuText'>###text###</span></li>}}</ul></div>"
};

ZRSHTMLTemplateStrings["__headerhelpmenu__zrsmenu__view"]  = ZRSMenu_View.oldMenu;
ZRSHTMLTemplateStrings['__zrsMenuType1__zrsmenu__view'] = ZRSMenu_View.zrsMenuType1;
ZRSHTMLTemplateStrings['__zrsMenuType2__zrsmenu__view'] = ZRSMenu_View.zrsMenuType2;
ZRSHTMLTemplateStrings['__zrsMenuType3__zrsmenu__view'] = ZRSMenu_View.zrsMenuType3;
//ignorei18n_end
