/*$Id$*/

var EditThreshold = new function()
{
    this.selThold = null;
    
    this.showTholdMenu = function(el, event)
    {
        var view = ZDBClientUI.selectedTab.view;
        if(view.editMode)
        {
            ZRSMenu.closeAllMenu(el);
            if(!$("ZAThresholdMenu")) {
                var menu = ZDBContentCache.appendAndGet("Threshold", "GridMenu", document.body); //No I18N
                menu.view = view;
            }
            ZDBMenu.showModuleMenu(el, event, "Threshold", "GridMenu", true); //No I18N
            EditThreshold.selThold = el.getAttribute("propname");
        };
    };
    
    // on hover threshold label, change hand cursor in edit mode
    this.setTholdLabelStyle = function(el)
    {
        var view = ZDBClientUI.selectedTab.view;
        el.style.cursor = view.editMode ? "pointer" : "default";
    };
    
    this.deleteThreshold = function()
    {
        var view = ZDBClientUI.selectedTab.view;
        if(view.editMode)
        {
            EditThreshold.deleteProp(view, EditThreshold.selThold);
            ZDBAnalysisView.setModifyAndRefreshView(view);
        }
    };
    
    this.deleteProp = function(view, propName)
    {
        var scope = PropSettings.CHART_THRESHOLD_SCOPE,
             func = PropSettings.CHART_THRESHOLD_FUNCTION,
            style = PropSettings.CHART_THRESHOLD_STYLE;
        var propSetUtil = view.propSetUtil;
        propSetUtil.deleteFromPropMap(propName);
        propSetUtil.deleteFromPropMap(propName + scope);
        propSetUtil.deleteFromPropMap(propName + func);
        propSetUtil.deleteFromPropMap(propName + style);
        
        var tholdIdx = parseInt(propName.substring(propName.length - 1));
        if(tholdIdx < 4)
        {
            for(var i=tholdIdx; i<5; i++)
            {
                var fromThold = PropSettings.CHART_THRESHOLD_NAME+(i+1);
                var toThold = PropSettings.CHART_THRESHOLD_NAME+i;
                propSetUtil.moveProp(fromThold, toThold);
                propSetUtil.moveProp(fromThold + scope, toThold + scope);
                propSetUtil.moveProp(fromThold + func, toThold + func);
                propSetUtil.moveProp(fromThold + style, toThold + style);
            }
        }
        propSetUtil.setPropSet(view);
    };
};
