/*$Id$*/

var TholdRelTables = new function()
{
    // get all the table objids of the related tables
    this.getRelatedTableIds = function(view, funcEl, event)
    {
        var url = "/ZATholdAction.ma?" + TholdRelTables.getParams(view); //No I18N
        var xml = ZDBAnalysisConfig.getCurrentConfig(view, false);
        AjaxAPI.sendRequest({URL:url, POSTBODY:xml, REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"},
                               ONFAILUREFUNC:TholdRelTables.handleFailure, VIEW:view, FUNCEL:funcEl, EVENT:event,
                               ONSUCCESSFUNC:TholdRelTables.getRelatedTables,
                               OPSTATUSID:"ZARelTableLoader"});  //No I18N
    };
    
    this.getParams = function(view)
    {
    	var params = "&ZDBACTION=GETRELTABLE"; //No I18N
        params += ZDBUtil.isNewView(view) ? "" : "&OBJID=" + view.objId; //No I18N
        params += "&PARENTVIEWID=" + view.parentViewId; //No I18N
        params += view.viewCtx.getAdditionalParams();
        return params;
    };

    this.getRelatedTables = function(response, requestOptions)
    {
        var view = requestOptions["VIEW"];
        var funcEl = requestOptions["FUNCEL"];
        var event = requestOptions["EVENT"];
        var jsonObj = JSON.parse(response.responseText.trim());
        view.propSetUtil.thresholdObj.relTbl = jsonObj.RELTBL;
        DynamicThreshold.showTholdFunc(funcEl, event);
    };
    
    this.handleFailure = function(response, requestOptions)
    {
        var funcEl = requestOptions["FUNCEL"];
        var event = requestOptions["EVENT"];
        DynamicThreshold.showTholdFunc(funcEl, event);
    };
};
