//$Id$
var ZDBNavEvtDelegation = new function() {

	/* -----------------------  EXPLORER VIEW TOOLBAR -------------------------*/
	this.toolbarEvtHandler = function() {
		var viewsToolBar = jQuery("#ZDBSheetActions"); //No i18N
		var headerToolbar = jQuery("#ZDBEXPHEADERROW");  //No i18N
		var dbName = headerToolbar.find("#ZDBEXDBNAME");
		var searchLayout = headerToolbar.find(".expGblSearch > input");
		var refreshExp = headerToolbar.find("#ZDBEXPLORERREFRESH_TITEM");
		dbName.unbind("click mouseover mouseout").bind("click mouseover mouseout", function(event){ ZDBNavEvtDelegation.dbEditEvtHandler(this,event);});//No i18N
		headerToolbar.unbind("keyup").bind("keyup", ZDBNavEvtDelegation.dbEditOnKeyUp);  //No i18N
		refreshExp.unbind("click").bind("click", function(){ZDBNavigation.refreshExplorer(this);});//No i18N
		searchLayout.unbind("click blur keyup").bind("click blur keyup", function(event){ZDBNavEvtDelegation.searchEvtHandler(this,event);});  //No i18N
		headerToolbar.find(".expMegaSrchIcn, .expSrchdropDown").unbind("click").bind("click", function(event){ZDBNavigation.showSearchByOpts(this,event);});//No i18N
		headerToolbar.find(".ZRSSearchClearIcon").unbind("click").bind("click", function(event){ZDBNavigation.clearSearchState($("explorerFilterSpace"), this);});//No i18N
		headerToolbar.find(".fRight").unbind("click").bind("click", function(event){ZDBNavEvtDelegation.dynamicOptsEvtHandler(event);}); //No i18N
		headerToolbar.find("#RDBConnectErr_Exp").unbind("click").bind("click", function(){ZDBCreateViewAPI.showRDBConDlg(true);});//No i18N
		headerToolbar.next("#ZRCreateNimportOpt").find(".greenBtn").unbind("click").bind("click", function(){ZDBCreateViewAPI.showCreateNewTblDlg(false);}); //No i18N
		headerToolbar.siblings("#ZRRDBLinkTables").find("input").unbind("click").bind("click", function(event){ZDBLoadJsAlone.loadJs(this, event);}); //No i18N
	}
	
	/* ------------------------ Navigation_Report_List_Menu ------------------------- */
	this.expMenuListEvtHandler = function() {
		var menuListParent = jQuery("#ZRNavigationViewListComponent"); //No i18N
		menuListParent.find(".ZRSSearchIcon").unbind("mousedown").bind("mousedown", function(event){ZDBNavigation.clearSearch(this,event);});//No i18N
		menuListParent.find(".NavViewListSearchBox > input").unbind("focus blur").bind("focus blur", function(event) { ZDBNavEvtDelegation.MenuListSrchEvtHandler(this, event);}); //No i18N
		menuListParent.find(".NavViewListSearchBox > input").unbind("keyup").bind("keyup", function(event){ //No i18N
			if(menuListParent.find(".showNavMenuItem").hasClass("ZDBNavExplorer")) {
				ZDBSearchUtil.searchDBObjects(true);
			}
			else {
				ZDBNavigation.searchInNavViewList(this);
			}
		});
	}
	 this.expMenuItemEvtHandler = function() {
		 var expMenuItems = jQuery("#ZRIconAndDescModeNav > ul, #ZRIconModeNav > ul"); //No i18N
		 expMenuItems.find(".singleLayoutComp").unbind("click").bind("click", function(event) {ZDBNavigation.selectData(this,event);});//No i18N
		 var expNavMinMode = jQuery("#ZRIconModeNav"); //No i18N
		 expNavMinMode.find(".singleLayoutComp").on("mouseover",function(event){ZDBToolTip.show(this, event, "RIGHT");}).on("mouseout",function(){ZDBToolTip.hide();});
		 
	 }
	
	this.dbEditEvtHandler = function(dbEl, e) {
		if(ZDBClientUI.isDBOwner) {
			if(e.type == "click"){
				ZDBNavigation.setEditable(dbEl);
			}
			if(e.type == "mouseover"){
				ZDBNavigation.showEditable(dbEl);
			}
			if(e.type == "mouseout"){
				ZDBNavigation.hideEditable(dbEl);
			}			
		}
	}
	this.dbEditOnKeyUp = function(event) {
		if(ZDBClientUI.isDBOwner) {
			if(event.target.id == "setDBName") {
				ZDBNavigation.expandEditor(event.target, event);
			}
		}
	}
	this.searchEvtHandler = function(srchEl, e) {
		if(e.type == "click"){
			ZDBNavigation.expGblSrchClick(srchEl);
		}
		if(e.type == "blur"){
			ZDBNavigation.expGblSrchBlur(srchEl);
		}
		if(e.type == "keyup"){
			ZDBNavigation.expGblSrchKeyUp(e);
		}
	}
	this.dynamicOptsEvtHandler =  function(e) {
		var parentEl = (e.target.tagName == "A") ? e.target : ZDBUtil.getParentWithTagName(e.target, "a");		//No I18N
		var eTarId = parentEl.id;
		if(eTarId == "ZDBIMPORTMENU"){
			ZDBCreateViewAPI.showCreateNewTblDlg(false);
		}
		if(eTarId == "ZDBEXPLORERMANAGEDB_TITEM"){
			ZDBCreateViewAPI.showRDBConDlg();
		}
		if(eTarId == "ZDBEXPLORERERDG_TITEM"){
			ZDBNavigation.getERDiagram(e.target);
		}
		if(eTarId == "ZDBEXPLORERCONNPROPLIST_TITEM"){
			ZDBNavigation.fetchDBConnectionJs(e.target,e);
		}
		if(eTarId == "ZDBEXPLORERDATASOURCE_TITEM"){
			ZDBLoadJsAlone.loadJs(parentEl, e);
		}
	}
	this.MenuListSrchEvtHandler = function(obj, e) {
		if(e.type == "focus"){
			ZDBNavigation.handleFocus(obj);
		}
		if(e.type == "blur"){
			ZDBNavigation.handleBlur(obj);
		}
	}

	
}
