//$Id$
var ZDBCreateViewAPI = new function()
{

	this.showImpIntoThsTblDlg = function()
	{
		var gridObj = ZDBClientUI.selectedTab.view;
		if(!ZDBClientUI.checkAskSaveView(gridObj,ZDBI18NMap.g("zrpt.common.js.import"),gridObj))
		{
			return;
		}
		ZDBMenuUtil.closeMenu();
		if(ZDBClientUI.notLoggedIn)
		{
			ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.newrpt.js.signIn2CreateNewRpt",ZDBGlobal.PRODUCTNAME));
			return;
		} 
		if(!ZDBLazyLoadUtil.loadSnippet("IMPORT_INTO_THIS_TABLE","/ZDBImpIntoThisTbl.cc?OBJID=" + gridObj.objId,this,"APPENDTODOC"))
		{
			return;
		}
		var createNewViewTblEl = ZDBClientUI.$$('ZDBEXISTIMPTBLVIEW');
		var nodes = createNewViewTblEl.getElementsByTagName('tr');

		var par = ZDBClientUI.$$("ZDBEXISTIMPTBLDLG");
		if(par.parentNode != null)
		{
			par.parentNode.removeChild(par);
		}

		var viewName = ZDBI18NMap.g("zrpt.common.js.existtable");
		var tab = ZDBClientUI.createDummyTab(gridObj.objId,viewName,par.cloneNode(true),
		"NewOption");// No I18N
		ZDBClientUI.selectTab(tab);
		//ZDBTemplate.enableOrDisableTemplateIcons();

	}
	  
	// Remote DB
	
	  this.showRDBConDlg = function(showOnlyEditConn)
	  { 
	    ZDBMenuUtil.closeMenu();
	    if(ZDBClientUI.notLoggedIn)
	    {
	      ZDBAlertAPI.showMsg("Sign in to use this feature",ZDBGlobal.PRODUCTNAME); //No i18N
	      return;
	    }
	    if(!ZDBClientUI.isDBOwner)
	    {
	      ZDBAlertAPI.showMsg("No permissions to use this feature"); //No i18N
	      return;
	    }
	    if(!ZDBLazyLoadUtil.loadSnippet("SHOW_RDB","/ZDBRemoteDBConnection.cc?DBID=" + ZDBClientUI.dbId,this,"APPENDTODOC"))
	    {
	      return;
	    }
	    
	    var createNewViewTblEl = ZDBClientUI.$$('ZDBCREATERDBVIEW');
	    var par = ZDBClientUI.$$("RDBDLG");
	    if(par.parentNode != null)
	    {
	      par.parentNode.removeChild(par);
	    }
	    if(showOnlyEditConn)
	    {
	      ZDBInlineDialog.showDialog(par,{MODAL:true});
	      RDBPage.editConnectionDialog(true);
	    }
	    else
	    {
	      ZDBInlineDialog.showDialog(par,{MODAL:true, TITLE:ZDBI18NMap.g("zrpt.databasedata.connname.js.managedb")});
//	      var viewName = ZDBI18NMap.g("zrpt.databasedata.connname.js.managedb"); 
//		  var tab = ZDBClientUI.createDummyTab(ZDBClientUI.curDummyViewId--,viewName,par.cloneNode(true),
//		                                         "NewOption"); //No i18N
//		    
//		  ZDBClientUI.selectTab(tab);
	      RDBPage.selectTab($("RDBLinkTablesTab"));
	      RDBPage.updateManageDB();
	    }
	  } 
  
  this.showCreateNewTblDlg = function(isNewReport,fromGDrive,mode,response)
  {
	if(!ZDBLazyLoadUtil.loadJsAlone(["import/js/ZDBImport.js","template/js/ZDBTemplate.js"],this,ZDBCreateViewAPI.showCreateNewTblDlg,[isNewReport,fromGDrive,mode,response]))
	{
		return;
	}
    ZDBMenuUtil.closeMenu();
    if(ZDBClientUI.notLoggedIn)
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.f("zrpt.common.newrpt.js.signIn2CreateNewRpt",ZDBGlobal.PRODUCTNAME));
      return;
    }
    if(!ZDBClientUI.isDBOwner && !isNewReport)
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.newtbl.js.noPerm2CreateNewTbl"));
      return;
    }
    if(!ZDBLazyLoadUtil.loadSnippet("CREATE_NEW_TABLE","/ZDBCreateNewTbl.cc?&DBID="+ZDBClientUI.dbId,this,"APPENDTODOC",null,ZDBCreateViewAPI.showCreateNewTblDlg,[isNewReport,fromGDrive,mode,response]))
    {
      return;
    }

    var createNewViewTblEl = ZDBClientUI.$$('ZDBCREATETBLVIEW_TABLE');
    var nodes = createNewViewTblEl.getElementsByTagName('li');
    var tblList = [];
    var tblObjIds = [];

    ZDBCreateViewAPI.addTableList(tblList, tblObjIds);
    var tblPresent = tblList.length > 0;
    for(var i = 0;i < nodes.length;i++)
    {
      var trEl = nodes[i];
      var type = trEl.getAttribute("zdbtype");
      var enable = ((type == null)
                    || ((type == "view") && (isNewReport)  && tblPresent)
                    || ((type == "table") && (ZDBClientUI.isDBOwner) && (!isNewReport))
                    || ((type == "autogen") && (ZDBClientUI.isDBOwner || ZDBClientUI.isGroupMember)
                        && (isNewReport) && tblPresent)
                    || ((type == "dashboard") && (isNewReport))// No I18N
              || ((type == "IntegDBtemplate") && (ZDBClientUI.isDBOwner || ZDBClientUI.isGroupMember)// No I18N
                  && (isNewReport) && tblPresent));
      trEl.style.display = (enable)? ZDBUtil.visibleTrStyle:"none";
    }

    var par = ZDBClientUI.$$("ZDBCREATETBLDLG");
    if(par.parentNode != null)
    {
      par.parentNode.removeChild(par);
    }
    var viewName = (isNewReport) ? ZDBI18NMap.g("zrpt.common.js.newReport"):ZDBI18NMap.g("zrpt.common.js.newTable"); //No I18N
	var existingTab = ZDBClientUI.toCheckIfTabAlreadyOpen(ZDBClientUI.curDummyViewId--, viewName, "NewOption");//No I18N
    if(ZDBGlobal.ISNEWLAYOUT) {ZRSMenu.visibleNavMenu= "clear"};  // added to clear the menuSelection in Tiles
	if(existingTab) {
	  return existingTab;
	}
    var tab = ZDBClientUI.createDummyTab(ZDBClientUI.curDummyViewId--,viewName,par.cloneNode(true),
                                         "NewOption");
    ZDBClientUI.selectTab(tab);
    ZDBTemplate.enableOrDisableTemplateIcons();
    if(fromGDrive == true && mode == "readDoc")
    {
        ZDBClientUI.importGDriveFile(response);
    }
    else
    {
        if($("IMPORTFREEZE")!=null && $("ZDBMainLoader_new")!=null)
        {
          document.body.removeChild($("IMPORTFREEZE"));
          document.body.removeChild($("ZDBMainLoader_new"));
        }
    }
  }
this.showTemplateViewTab=function(dbId,connectorId,isTemplateReportsLaunchFromLeftPanel)
  {
    ZDBMenuUtil.closeMenu();
    if(!ZDBLazyLoadUtil.loadSnippet("VIEW_ALL_TEMPLATE_LIST","/ZDBCopyTemplate.cc?&DBID="+dbId+"&ZDBACTION=GETTEMPLATEVIEWSLIST",this,"APPENDTODOC"))
    {
      return;
    }
    var par = ZDBClientUI.$$("ZDBTEMPLATEVIEWDLG");
    if(par.parentNode != null)
    {
      par.parentNode.removeChild(par);
    }
    var viewName = ZDBI18NMap.g("zrpt.report.library.js.title");// No I18N
    var templateTab = jQuery("#ZDBTABTPL.TemplateReportsObj")[0];//No I18N
    if(templateTab)//Checks if Gallery tab is already opened in any other tab
    {
      if(ZDBClientUI.selectedTab != templateTab){
        ZDBClientUI.selectTab(templateTab);        
      }
      var tab = ZDBClientUI.selectedTab;
      var view = new DummyView(ZDBClientUI.curDummyViewId--,viewName,"TemplateReports",par.cloneNode(true));//No I18N
      ZDBClientUI.initializeTab(tab,view,par.cloneNode(true));
      ZDBClientUI.selectTab(tab);
      ZDBTemplateList.createListViewFromDlg(dbId,connectorId);
    }
    else{ //Reports library is not opened in any tabs
      if(isTemplateReportsLaunchFromLeftPanel == 'true'){
        var tab = ZDBClientUI.createDummyTab(ZDBClientUI.curDummyViewId--,viewName,par.cloneNode(true),"TemplateReports");//No I18N
        ZDBClientUI.selectTab(tab);
      }else{
        var tab = ZDBClientUI.selectedTab;
        var view = new DummyView(ZDBClientUI.curDummyViewId--,viewName,"TemplateReports",par.cloneNode(true));//No I18N
        ZDBClientUI.initializeTab(tab,view,par.cloneNode(true));
        ZDBClientUI.selectTab(tab);
      }
      ZDBTemplateList.createListViewFromDlg(dbId,connectorId);
    }

  }
  this.submitTableForViewDlg = function(element, event)
  {
	if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/autogen/ZDBSampleViews.js",this,ZDBCreateViewAPI.submitTableForViewDlg,[element, event]))
	{
	 	return;
	}
    var el = ZDBCreateViewAPI.ZDBTableForViewDlg;
    var selEl = ZDBCreateViewAPI.ZDB_TABLEPICK;
    var selTable = selEl[selEl.selectedIndex].value;
    var parentViewId = null;
    for(var i = 0;i < el.tblList.length;i++)
    {
      if(el.tblList[i] == selTable)
      {
        parentViewId = el.tblObjId[i];
        break;
      }
    }

    ZDBDialogUtil.closeDialog();
    ZDBCreateViewAPI.createViewTab(parentViewId,el.viewType);
  }

  this.createViewTab = function(parentViewId,viewType) // to decide whether the new report should be created in same tab or new one
  {
    if(!ZDBLazyLoadUtil.loadJsAlone("zdbjs/autogen/ZDBSampleViews.js",this,ZDBCreateViewAPI.createViewTab,[parentViewId, viewType]))
    {
            return;
    } 
    if(viewType == "AutoGen")
    {
      ZDBSampleViews.createSampleViews("YES",null,parentViewId);
    }
    else
    {
      if(!ZDBClientUI.selectedTab.view.isDummyView)
      {
        var dispName="";
        var tab = null;
      }
      else
      {
        var tab = ZDBClientUI.selectedTab;
        var dispName = tab.view.displayName;
      }
      ZDBClientUI.createView(ZDBClientUI.dbId,parentViewId,dispName,viewType,tab);
    }
  }


  this.createViewEl = function(element, event, viewType)
  {
    var view = ZDBClientUI.selectedTab.view;

    var parViewId = ZDBCreateViewAPI.getTableObjectIdForView(view);
    if(parViewId == null)
    {
      ZDBCreateViewAPI.createViewFromDlg(element,viewType);
    }
    else if(!ZDBUtil.isNewView(view))
    {
      ZDBClientUI.createView(view.dbId,parViewId,view.displayName,
                             viewType,null);
    }
    else
    {
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.newrpt.zdbalertmsg.js.saveConfirm2CreateNew"));
    }
  }


  this.getTableObjectIdForView =function(view)
  {
    return (view.type == "Table" || view.type == "QueryTable") ? view.objId: view.parentViewId;
  }




  this.createViewFromDlg = function(element,viewType)
  {
    if(!ZDBLazyLoadUtil.loadSnippet("PICK_TABLE_FOR_VIEW","/ZDBPickTableForView.cc",this,"APPENDTODOC"))
    {
      return;
    }
    if(!ZDBLazyLoadUtil.loadCssOnly(["CSSLIST_GRIDSTYLES", "CSSLIST_ANALYSISVIEWSTYLES"], this, ZDBCreateViewAPI.createViewFromDlg,[element,viewType])){
    	return;
    }
    var selEl = ZDBUtil.getCachedRef(ZDBCreateViewAPI,'ZDB_TABLEPICK');
    //--ZROP Changes
    setTimeout(function(){ZDBCreateViewAPI.sortSelect(selEl);},200);
    var chNodes = selEl.childNodes;
    for(var i = chNodes.length -1;i > -1;i--)
    {
      selEl.removeChild(chNodes[i]);
    }
    var tblList = [];
    var tblObjId = [];

    if(!ZDBCreateViewAPI.checkAndGetTableList(tblList, tblObjId))
    {
      return;
    }
    if(tblList.length == 1) // if only one table is present directly jumping to creating view tab
    {
        var parentViewId = tblObjId[0];
        ZDBCreateViewAPI.createViewTab(parentViewId,viewType);
        return;
    }
    for(var i = 0;i < tblList.length;i++)
    {
      var option = document.createElement("Option");
      option.text = tblList[i];
      option.value = tblList[i];
      (BROWSER.IE) ? selEl.add(option):selEl.appendChild(option);
    }
    var el = ZDBUtil.getCachedRef(ZDBCreateViewAPI,"ZDBTableForViewDlg");
    el.style.display = "block";
    el.viewType = viewType;
    el.tblList = tblList;
    el.tblObjId = tblObjId;
    ZDBDialogUtil.showDialog(el,{TITLE:ZDBI18NMap.g('zrpt.common.newrpt.selbasetbl.js.dlgTtl',el),ADDFRAME:true,MODAL:true});
    return;
  }
  //--ZROP Changes--
  this.sortSelect=function (elem) {
      var tempArray = new Array();
      for (var i=0;i<elem.options.length;i++) {
          tempArray[i] = new Array();
          tempArray[i][0] = elem.options[i].text;
          tempArray[i][1] = elem.options[i].value;
      }
      tempArray.sort(function(a,b){if(a[0] === b[0]){return 0;}else {return (a[0] < b[0]) ? -1 : 1;}});
      while (elem.options.length > 0) {
          elem.options[0] = null;
      }
      for (var i=0;i<tempArray.length;i++) {
          var op = new Option(tempArray[i][0], tempArray[i][1]);
          elem.options[i] = op;
      }
  }
  //--ZROP Changes--
  this.createStandAloneView = function(el,event,type,checkIfTableExists,useSameTab)
  {
    if(checkIfTableExists && !ZDBCreateViewAPI.checkAndGetTableList([],[])){return;}
    ZDBClientUI.createView(ZDBClientUI.dbId,null,null,type,((useSameTab)?ZDBClientUI.selectedTab:null));
  }

  this.addTableList = function(tblList,tblObjId)
  {
        var types=["Table","QueryTable"]; //No I18n
        var objIds=ZDBExpViewHandler.getViewListForGivenTypes(types);
        for(var i=0;i<objIds.length;i++)
        {
            var viewInfo = ZDBExpViewHandler.fetchViewListInfo(objIds[i]);
            tblList.push(viewInfo[ZDBExpViewHandler.VIEW_NAME]);
            tblObjId.push(objIds[i]);
        }
    }

  this.checkAndGetTableList = function(tblList,tblObjId)
  {
    this.addTableList(tblList,tblObjId);
    if(tblList.length == 0)
    {
      var dbNameEl = ZDBUtil.getCachedRef(this,"ZDBDBNAME");
      ZDBAlertAPI.showMsg(ZDBI18NMap.g("zrpt.common.newrpt.zdbalertmsg.js.noTblsFound")+" '" + dbNameEl.innerHTML + "'");
      return false;
    }
    return true;
  }

  this.fetchEnterDataView = function(element, event, dbId, dbExists, tableName)
  {
    if(!ZDBLazyLoadUtil.loadJsAlone("ZDBGridList","APPENDTODOC",ZDBCreateViewAPI.fetchEnterDataView,[element,event,dbId,dbExists,tableName]))
    {
      return;
    }
    if(!ZDBLazyLoadUtil.loadCssOnly("CSSLIST_GRIDSTYLES", "APPENDTODOC", ZDBCreateViewAPI.fetchEnterDataView,[element, event, dbId, dbExists, tableName])){
    	return;
    }
    if(!tableName)
    {
      ZDBCreateViewAPI.fetchNextObjectName(dbId);
      return;
    }
    var tab = null;
    if(dbExists)
    {
      tab = ZDBClientUI.selectedTab;
    }
    else
    {
      tab = ZDBClientUI.createDummyTab(ZDBClientUI.curDummyViewId--,tableName,
                                       ZDBClientUI.dummyGrid,"Table");
    }
    var gridObj = ZDBDataGridExt.createGrid(dbId, tableName);
    gridObj.enterData = true; //PK: hack
    gridObj.setColumnHeaders(gridObj.getColHeaders());
    var headers = gridObj.colHeaders;
    for(var i = 0;i < headers.length;i++)
    {
      if(headers[i].objType == ZDBConst.COLHEAD)
      {
        headers[i].isEditable = true;
      }

    }
    gridObj.setNavigationInfo(1,0,0);
    gridObj.showFirstPage();
    tab.viewCtx.handle(gridObj);
    var widthArray =[];
    for(var i=0;i<headers.length-3;i++)
    	{
    	widthArray[i]=120;
    	}
    widthArray[widthArray.length] =0 ;
    widthArray[widthArray.length]=0;
    gridObj.generateColumnWidth(widthArray);
    var rhWidthArray=[30];
    gridObj.rhWidthArray=rhWidthArray;
    gridObj.generateLeftColumnWidth(gridObj.rhWidthArray);
    gridObj.setFillerHeight();
  }
  this.confirmCopySettings = function(clickType)
  {
    if(clickType != "YES")
    {
    return;
    }
  $("ZDBSaveDlgOkBtn").setAttribute("hugeDataCopy","true");
  ZDBCreateViewAPI.handleSaveDlg($("ZDBSaveDlgOkBtn"));
  }


  this.fetchNextObjectName = function(dbId)
  {
    var tabIcon = ZDBClientUI.selectedTab.tabIcon;
    AjaxAPI.sendRequest({URL:ZDBGlobal.CTX + "/ZDBDatabaseActionMI.ma?ZDBACTION=NEXTOBJECT",
                               PARAMETERS:"DBID="+dbId,
                               METHOD:"GET",  //No I18N
                               ONSUCCESSFUNC:ZDBCreateViewAPI.fetchDataViewForEntry,
                               ONFAILUREFUNC:ZDBCreateViewAPI.handleFailureForView,OPSTATUSID:tabIcon});

  }




  this.fetchDataViewForEntry = function(response, requestOptions)
  {
    var params = response.getResponseParams();
    ZDBCreateViewAPI.fetchEnterDataView(null, null, params["DBID"],true,params["NEXTOBJNAME"]);
  }


  this.handleFailureForView = function(response, requestOptions)
  {
    var params = response.getResponseParams();
    ZDBClientUI.fetchEnterDataView(null, null, params["DBID"],true,'Untitled-1');
  }



  this.getNameForNewView = function(view,requestOptions,isSaveAs)
  {
    if(!ZDBLazyLoadUtil.loadSnippet("SAVE_DLG","/ZDBSave.cc?",this,"APPENDTODOC", null, ZDBCreateViewAPI.getNameForNewView, [view, requestOptions, isSaveAs], 'ZDBMainLoader'))
    {
      return;
    }
    if(view.newName != null){ return true;}
    if(ZDBCreateViewAPI.saveDlg == null)
    {
      ZDBCreateViewAPI.saveDlg = $("ZDBSaveDlgFrm");
      ZDBUtil.setIdBasedNamedChildEls(ZDBCreateViewAPI.saveDlg,
      ["nameTxtFld","descTxtFld","copyDataChkFld","copyLookupChkFld"],"ZDBObj_");// No I18N
    }
    var saveDlg = ZDBCreateViewAPI.saveDlg;
    saveDlg.nameTxtFld.value = view.displayName + ((isSaveAs)? ZDBI18NMap.g("zrpt.common.js.copy"):"");
    saveDlg.descTxtFld.value = (view.description != null)? view.description:"";
    saveDlg.copyDataChkFld.style.display=(view.type!="Table"||!isSaveAs)?"none":"table-Row";
    saveDlg.copyLookupChkFld.style.display=(view.type!="Table"||!isSaveAs)?"none":"table-Row";
    saveDlg.curView = view;
    saveDlg.isSaveAs= isSaveAs;
    saveDlg.origReqOptions = requestOptions;
    ZDBNavigation.loadFolderList("ZDBFolderItemList","ZDBFOLDERLISTOPTSTATUS",null);
    ZDBDialogUtil.showDialog(saveDlg,{MODAL:true,TITLE:ZDBI18NMap.g("zrpt.common.newrpt.saveas.js.dlgTtl",saveDlg),ADDFRAME:true, VIEW : view,ONCLOSE: (view.type === "Dashboard" && view._$type !== undefined) ? ZRDashboardAdapterAPI.handleSaveAsClose : null});
    saveDlg.nameTxtFld.focus();
    $("ZDBSaveDlgOkBtn").setAttribute("hugeDataCopy","false");
    $("ZDBDBCPDataChkBox").checked = true;
    $("ZDBDBCPLookupChkBox").checked = true;
}


  this.handleSaveDlg = function(el)
  {
    var dlgEl = DOMUtils.getParentWithAttr(el,"isFrm");
    var els = DOMUtils.getChildElsWithAttr(dlgEl,"name","*");
    if(!validateFormElements(els,dlgEl))
    {
      return;
    }
    var view = dlgEl.curView;
    try
    {
      var displayName = dlgEl.nameTxtFld.value;
      view.newName = displayName;
      var desc = dlgEl.descTxtFld.value;
      view.newDesc = desc;
      view.folderId = $("ZDBFolderListCombo").value;
      var hugeDataCopy = $("ZDBSaveDlgOkBtn").getAttribute("hugeDataCopy");
      var viewType = view.type;
      var objid = view.objId;
      var dbid = view.dbId;
      if(dlgEl.isSaveAs)
      {
       view.isSaveAs = true;
	  if(viewType == "AnalysisView" ||viewType == "Pivot" || viewType == "SummaryView" || viewType == "Dashboard")
	  {
	     this.saveAsNewView(view);
	  }
          else if(viewType == "Table")
          {
             view.saveTableAsNewView(displayName,objid,dbid,view.folderId,desc,hugeDataCopy);   
          }
	  else
	  {
            view.saveAsNewView();
	  }
      }
      else
      {
        view.save(dlgEl.origReqOptions);
      }
    }
    finally
    {
      view.newName = null;
      view.newDesc = null;
    }
    ZDBDialogUtil.closeDialog(el);
  }

  this.saveAsNewView = function(view)
  {//$$ Sort of a hack!!.
	  var objId = view.objId;
	  var displayName = view.displayName;
	  var descr = view.description;
	  try
	  {
		  view.objId = -1;
		  if(!ZDBCreateViewAPI.getNameForNewView(view,null,true))
		  {
			  return;
		  }
		  view.displayName= view.newName;
		  view.description= view.newDesc;
		  if(view.type == "Dashboard")
		  {
			view.saveCurrentConfig(null,true,objId);
		  }
		  else
		  {
	          	view.saveCurrentConfig();
		  }
	  }
	  finally
	  {
		  view.objId = objId;
		  view.displayName= displayName;
		  view.description = descr;
      view.isSaveAs = false;
	  }
  }


  this.handleViewSaveFailure = function(response,requestOptions)
  {
    var view = requestOptions.VIEW;
    if(view && view.viewCtx.isZia){
        ZRSZia.handleSaveFailure(response,requestOptions);
        return;
    }
    var errCode = response.getResponsePart("ERRORCODE");
    errCode = trimAll(errCode);
    if(errCode == "META_DBOBJECT_NAME_DUPLICATED")
    {
           var dlg = ZDBCreateViewAPI.saveDlg;
	    ZDBDialogUtil.showDialog(dlg,{MODAL:true, TITLE:ZDBI18NMap.g("zrpt.common.newrpt.saveas.js.dlgTtl",dlg),ADDFRAME:true});
      ZDBCreateViewAPI.saveDlg.nameTxtFld.focus();
      showCustomMessage(response.getResponsePart("STATUS_MESSAGE"), ZDBCreateViewAPI.saveDlg.nameTxtFld);
	  $("customAlertMessage").style.zIndex = 20001;
	  $("_CUSTOMALERTFRAME").style.zIndex = 20000;
    }
    else if(errCode == "COLUMN_PRESENT_IN_FILTER_CRITERIA")
    {
      var msg = ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.deletecolwithfiltercriteria");
      var reqOpts = requestOptions["ORIGREQOPTIONS"];
      var urlToSend = requestOptions["PREVIOUSURL"];
      var dataGrid = requestOptions["GRIDOBJ"];
      ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK:CommAPI.continueSendModData,ORIGREQOPTIONS:reqOpts,GRIDOBJ:dataGrid,URLTOSEND:urlToSend,SKIPFC:true}); // No I18N
    }
    else if(errCode == "DRILLDOWN_CHANGEDATATYPE_NOTALLOWED")
    {
      var msg = ZDBI18NMap.g("zrpt.common.zdbalertmsg.js.dtchangenotallowed");
      var reqOpts = requestOptions["ORIGREQOPTIONS"];
      var urlToSend = requestOptions["PREVIOUSURL"];
      var dataGrid = requestOptions["GRIDOBJ"];
      urlToSend+="&DELETE_INVALID_DRILLFLOW="+"true"; //NO I18N
      ZDBAlertAPI.showMsg(msg,"ZDBYESNO",{ONCLICK:CommAPI.continueSendModData,ORIGREQOPTIONS:reqOpts,GRIDOBJ:dataGrid,URLTOSEND:urlToSend}); // No I18N
    }
    else if(errCode=="INCOMPATIBLE_LOOKUP_ON_DATATYPE_CONVERSION")
    {
       ZDBAlertAPI.showMsg(ZDBEscapeUtil.decodeForHtml(response.getResponsePart("STATUS_MESSAGE")));
    }
    else
    {
      AjaxAPI.onFailureFunc(response,requestOptions);
    }
  }

  this.getNewNameInfoAsParams = function(view)
  {
    var params = "&DISPLAYNAME=" + encodeURIComponent(view.newName);
    if(view.newDesc)
    {
      params += "&DESCRIPTION=" + encodeURIComponent(view.newDesc);
    }
    if(view.folderId > 0)
    {
      params += "&FOLDERID=" + encodeURIComponent(view.folderId);
    }
    return params;
  }

  this.handleViewSave = function(response,requestOptions,isTable)
  {
    var view = requestOptions["VIEW"];
    var folderId = view.folderId;
    ZDBNavigation.openFolderWithFolderId(folderId);
    var jsonObj = (response.responseText.length > 0 ) ? JSON.parse(response.responseText) : {};
    var widgetIdMap = jsonObj.WidgetIdMap;
    if(requestOptions["ISNEWVIEW"])
    {
      var params = JSON.parse(response.responseText);
      var index = ZDBClientUI.openedViewsObjId.indexOf(Number(view.objId));
      if(index != -1 ) {ZDBClientUI.openedViewsObjId[index] = params["objId"];}
      ZDBCreateViewAPI.newViewSaved(view,params);
      if(window.WidgetUtils && view.typeValue === ZDBClientViewAPI.TYPE_DASHBOARD && widgetIdMap)//revisit
        {
            WidgetUtils.updateWidgetIds(view.widgetIdMap,widgetIdMap,view.objId);
        }
    }
    else
    {
        for(i in jsonObj)
        {
            view[i] = jsonObj[i];
        }
    }
    if(window.WidgetUtils && view.typeValue === ZDBClientViewAPI.TYPE_DASHBOARD && widgetIdMap)
    {
    	WidgetUtils.updateWidgetIds(view.widgetIdMap,widgetIdMap,view.objId);
    }
    view.confModified = false;
    view.clearModified();
    view.widgetIdMap = {};
    view.isSaveAs = false;
    if(!isTable)
        {
    ZDBMsgBox.showViewSavedMsg(view.displayName);
        }
    if(requestOptions["ORIGREQOPTIONS"] != null)
    {
      requestOptions["ORIGREQOPTIONS"]["HANDLESAVE"](requestOptions["ORIGREQOPTIONS"]);
    }
  }

  this.newViewSaved = function(view,params)
  {
    for(var i in params)
    {
      view[i] = params[i];
    }


    if(view.description == null)
    {
      view.description = "";
    }
    ZDBClientUI.newViewAdded(view);
  }

  this.enableOrDisableTemplateIcons = function()
  {
    $("autoGenIcon").style.display =(!ZDBClientUI.isDBOwner) ? "none" : "";
    $("autoGenText").style.display =(!ZDBClientUI.isDBOwner) ? "none" : "";
  }

}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZDBCreateViewAPI.createViewFromDlg"]=ZDBCreateViewAPI.createViewFromDlg;
