//$Id$

var ZDBUtil = new function()
{
  this.timeoutCnt = 1;
  
  //this.visibleTdStyle = (BROWSER.NONIE)? "table-cell":"block";
  //this.visibleTrStyle = (BROWSER.NONIE)? "table-row":"block";
  //this.visibleTableStyle = (BROWSER.NONIE)? "table":"block";  
  this.visibleTdStyle = "";
  this.visibleTrStyle = "";
  this.visibleTableStyle = ""; 

  this.dataTypeNumVsSubtypeDisp = {"1":"PLAIN", //No I18N
                                    "2":"MULTI_LINE", //No I18N
                                    "3":"EMAIL",  //No I18N
                                    "4":"NUMBER", //No I18N
                                    "5":"POSITIVE_NUMBER",  //No I18N
                                    "6":"DECIMAL_NUMBER", //No I18N
                                    "7":"CURRENCY", //No I18N
                                    "8":"PERCENT",  //No I18N
                                    "9":"DATE", //No I18N
                                    "10":"BOOLEAN", //No I18N
                                    "14":"REFCOL", //NO I18N
                                    "18":"AUTO_NUMBER", //No I18N
                                    "19":"URL", //NO I18N
                                    "20":"RELCOL",  //No I18N
                                    "21":"GEO",//No I18N
                                    "22":"DATE_AS_DATE",  //No I18N
				    "23":"GEO_NUM"};  //No I18N
  this.dataTypeVsdataTypeNum = {"PLAIN":"1",	//No I18N
                                "MULTI_LINE":"2",	//No I18N
                                "EMAIL":"3",	//No I18N
                                "NUMBER":"4",	//No I18N
                                "POSITIVE_NUMBER":"5",	//No I18N
                                "DECIMAL_NUMBER":"6",	//No I18N
                                "CURRENCY":"7",	//No I18N
                                "PERCENT":"8",	//No I18N
                                "DATE":"9",	//No I18N
                                "BOOLEAN":"10",	//No I18N
                                "REFCOL":"14",	//No I18N
                                "AUTO_NUMBER":"18",	//No I18N
                                "URL":"19",	//No I18N
                                "RELCOL":"20", //NO I18N
                                "GEO":"21",	//No I18N
                                "DATE_AS_DATE":"22",//No I18N  
				"GEO_NUM":"23"}; //No I18N   
  
  this.datatypeVsFormatType = {"PLAIN":"Text", //No I18N
                                "MULTI_LINE":"Text", //No I18N
                                "EMAIL":"Text", //No I18N
                                "URL":"Text", //No I18N
                                "BOOLEAN":"Text", //No I18N
                                "NUMBER":"Numeric", //No I18N
                                "POSITIVE_NUMBER":"Numeric", //No I18N
                                "AUTO_NUMBER":"Numeric", //No I18N
                                "DECIMAL_NUMBER":"Float", //No I18N
                                "GEO_NUM":"Float", //No I18N
                                "CURRENCY":"Cur", //No I18N
                                "PERCENT":"Percent", //No I18N
                                "DATE":"Date", //No I18N
                                "GEO":"Geo", //No I18N
                                "DATE_AS_DATE":"Date"}; //No I18N   
this.georoleVSName={
                    "0":"CONTINENT",
                    "1":"COUNTRY",
                    "2":"STATEPROVINCE",
                    "3":"COUNTY",
                    "4":"CITY",
                    "5":"ZIPCODE",
                    "6":"LATITUDE",
                    "7":"LONGITUDE"
                    }    
this.geoNameVsRole={
                    "CONTINENT":0,//NO I18N
                    "COUNTRY":1,//NO I18N
                    "STATEPROVINCE":2,//NO I18N
                    "COUNTY":3,//NO I18N
                    "CITY":4,//NO I18N
                    "ZIPCODE":5,//NO I18N
                    "LATITUDE":6,//NO I18N
                    "LONGITUDE":7//NO I18N
                    }    

  this.dataTypeNumVsSubtypeDisp.length = 12;
  
  this.dataTypeVsDisplayType = {"PLAIN":"Plain Text",
                                 "MULTI_LINE":"Multi Line Text",
                                 "EMAIL":"E-mail",
                                 "URL":"URL",
                                 "NUMBER":"Number",
                                 "POSITIVE_NUMBER":"Positive Number",
                                 "AUTO_NUMBER":"Auto Number",
                                 "DECIMAL_NUMBER":"Decimal Number",
                                 "CURRENCY":"Currency",
                                 "PERCENT":"Percentage",
                                 "DATE":"Date",
                                 "BOOLEAN":"Decision Box",
                                 "REFCOL":"Lookup Column",  //No I18N
                                 "RELCOL":"Lookup Column",  //No I18N
                                 "GEO_NUM":"Geo Location",  //No I18N
                                 "GEO":"Geo Location",  //No I18N
                                 "DATE_AS_DATE":"Date"};  //No I18N
                               
    //this.allowedTypes_for_Drill = ["PLAIN","MULTI_LINE","DATE","EMAIL","URL","BOOLEAN"]; //NO I18N
    this.allowedTypes_for_Drill = ["PLAIN","DATE","DATE_AS_DATE","EMAIL","URL","GEO"]; //NO I18N
    
    this.getParGridColHeaderForColId = function(colId)
    {
      var gridObj = (ZDBDialogUtil.focusDialog) ? ZDBDialogUtil.focusDialog.gridObj : ZDBClientUI.selectedTab.focusedDialog.gridObj;
      if(!gridObj)
      {
        gridObj = ZDBClientUI.ZDBViewEl.view;
      }
      var colHeaders = gridObj.colHeaders;
      var colObj;
      for(var j=0;j<colHeaders.length;j++)
      {
        var colHdr = colHeaders[j];
        if(colHdr.colId && (colHdr.colId.toString()===colId.toString()))
          {
            colObj = colHdr;
            break;
          }
      }
      return colObj;
    }
    
    this.getOrigColTypeForEl = function(cellObj)
    {
      var type = ZDBDesignGrid.getColumnDataTypeForField(cellObj);
      
      if(type!="RELCOL" && type!="REFCOL")
      {
        return type;
      }      
        var idx = cellObj.rowObj.parGrid.getColumnIndex("FIELDID"); //NO i18N
        var fieldIdObj = cellObj.rowObj.values[idx];
        if(fieldIdObj)
        {          
          var colId = fieldIdObj.getValue();
          var colObj = ZDBUtil.getParGridColHeaderForColId(colId);
          if(!colObj)
        	{
          	return;
        	}
          var type = colObj.type;
          type = (type=="RELCOL" || type=="REFCOL") ? colObj.relColType : type; //NO I18N
        }      
      return type;
    }
    
    this.isColTypeAllowedForDrill = function(cellObj)
    {      
      var type = ZDBUtil.getOrigColTypeForEl(cellObj);
      return jQuery.inArray(type,ZDBUtil.allowedTypes_for_Drill)>=0;
    }
    
    this.getMonthName = function(index, startIndexOne, abr)
    {
       if(isNaN(index))
        {
            return "Invalid";
        }
        var monthNames = ['January', 'February', 'March', 'April', 'May',
              'June', 'July', 'August', 'September', 'October', 'November','December'];
        
        if(startIndexOne)
        {
            index--;
        }
        return abr ? monthNames[index].substring(0,3) : monthNames[index];
    }


    this.isNumber = function(value)
    {
        if( (value != null)  && 
            ((typeof value) != 'undefined') &&
            (!isNaN(value)) &&
            ((parseInt(value,10)+"").length == value.length))
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    this.replaceStr = function(srcStr, matchStr, subStr)
    {
      ///PK: Remove the try catch
        try
        {
            var workStr = srcStr;
            var replacedStr = "";
            var curIndex = workStr.indexOf(matchStr); 
            while(curIndex >= 0)
            {
                replacedStr += workStr.substring(0,curIndex) + subStr;
                workStr = workStr.substring(curIndex+matchStr.length, workStr.length);
                curIndex = workStr.indexOf(matchStr);    
            }
            return (replacedStr + workStr);
        }
        catch(e) {return srcStr;}
    
    } 
    
    
    this.removeChar = function(orgStr, charToRemove)
    {
        if(!(orgStr && charToRemove))
        {
            return orgStr;
        }
        var replacedStr = "";
        orgStr = orgStr+"";
        var len = orgStr.length;
        for(i=0;i<len;++i)
        {
            var curChar = orgStr.charAt(i);
            if(curChar == charToRemove)
            {
                continue;
            } 
            replacedStr += curChar;
        }
        return replacedStr;
    }

	// This method will work in IE only for textarea and not for textfield

    this.getCaretPos = function(textNode) 
    {
     var pos = 0;
     //textNode.focus(); 
     /* without textNode.focus() IE will returns -1 when focus is not on textNode */
     if(textNode.selectionStart)
     {
      pos =textNode.selectionStart;
     }
     else if(!document.selection) 
     {
      pos = 0;
     }
     else
     {
      var c		= "\001";
      var sel	= document.selection.createRange();
      var dul	= sel.duplicate();
      dul.moveToElementText(textNode);
      if(sel.text.length == 0)
      {
        sel.text	= c;
        pos	= (dul.text.indexOf(c));
        sel.moveStart('character',-1);
        sel.text	= "";
        if(textNode.zdbselrange)
        {
          textNode.zdbselrange = null;
        }
      }
      else
      {// text selected
        dul.setEndPoint('EndToEnd', sel);
        var selStart = dul.text.length-sel.text.length;
        textNode.zdbselrange = [selStart, selStart + sel.text.length];
      }
     }
     return (pos < 0 ? textNode.value.length : pos);
    }

	this.insertText = function(input, val, insPos, endPos)
	{
		var start = this.getSelection(input, true);
		var end = this.getSelection(input, false);
		if(BROWSER.IE)
		{
			start = end = insPos;
      if(endPos != -1)
      {
        end = endPos;
        input.zdbselrange = null;
      }
		}
		var split1 = input.value.substring(0, start);
		var split2 = input.value.substring(end, input.value.length);
		input.value = split1 + val + split2;
		this.setCaretToPos(input, (insPos + val.length));
	}

      // method not at used. Moved from ZDBAnalysisUtils.js to Here on shibu's suggestion
      this.positionCenter = function(el)
      {
            if(el!=null)
            {
            var posX = ((document.body.clientWidth/2)-((el.offsetWidth)*0.50));
            var posY = ((document.body.clientHeight/2)-((el.offsetHeight)*0.50));
            el.style.position="absolute";
            el.style.left=posX+"px";
            el.style.top=posY+"px";
            }
      }

	// This method will work in IE only for textfield and not for textarea
	this.getCaretCurPos = function(input)
	{
		input.focus();
		return this.getSelection(input, true);
	}

	this.getSelection = function(input, isStart)
	{
		if(BROWSER.NONIE || BROWSER.IE11AndAbove)
		{
			return isStart ? input.selectionStart : input.selectionEnd; 
		}
		else
		{// IE
			var range = document.selection.createRange();
			var isCollapsed = range.compareEndPoints("StartToEnd", range) == 0;
			if (!isCollapsed)
			{
				isStart ? range.collapse(true) : range.collapse(false);
			}
			var b = range.getBookmark();
			return b.charCodeAt(2) - 2;
		}
	}

    this.addToNode = function(elementId, parentNode)
    {
        var node = document.getElementById(elementId); // Assumption: elementId available
        if(parentNode)
        {
            parentNode.appendChild(node);
        }
        else
        {
            document.body.appendChild(node);
        }
        return node; 
    }
    
  //Method name is wrong!!
    this.getCloned = function(elementId)
    {
      var node = (typeof elementId == 'string') ? document.getElementById(elementId) : elementId; // Assumption: elementId available, either ID or node
      if(node != null)
      {
        node = node.cloneNode(true);
        node.removeAttribute("id");
      }
      return node; 
    }
    
    this.getCloneNode = function(elementId)
    {
      var node = (typeof elementId == 'string') ? document.getElementById(elementId) : elementId; //No I18N
      if(node != null)
      {
        node = node.cloneNode(true);
        node.removeAttribute("id");
				node.elnameSet = false;
      }
      return node; 
    }
    
    this.getSelectedRadioEltWithAttrVal = function(parentDiv, attr, value)
    {
	var els = DOMUtils.getChildElsWithAttr(parentDiv,attr,value);
	var len = els.length;                              
        for(var i=0; i<len; i++)                             
        {                                                    
            var opt = els[i];                              
            if(opt.checked)                                  
            {                                                
                return opt;                                  
            }                                                
        }
    }
   
    this.getSelectedRadioElement = function(form,element)
    {
        var radio = form[element];
        var len = radio.length;
        for(var i=0; i<len; i++)
        {
            var opt = radio[i];
            if(opt.checked)
            {
                return opt;
            }
        }
    }
    
    this.getRadioSelectedValue = function(form,name)//check our util and replace the method
    {
        var radio = form[name];
        var len = radio.length;
        for(var i=0; i<len; i++)
        {
            var opt = radio[i];
            if(opt.checked)
            {
                return opt.value;
            }
        }
    }
    
    this.setRadioSelectedValue = function(form,name,selectValue,attr)//check our util and replace the method
    {
        if(selectValue==null){return;}
        var radio = form[name];
        var len = radio.length;
        var attr = (attr!=null)?attr:"value"; //No I18N
        for(var i=0; i<len; i++)
        {
            var opt = radio[i];
            if(opt.getAttribute(attr) == selectValue)
            {
              opt.checked = true;              
              if(opt.onchange)
              {
                opt.onchange();
              }
              break;
            }
        }
    }
    this.stopEventBubble = function(event)
    {
        if(event && event.stopPropagation)
        {
            event.preventDefault();
            event.stopPropagation();
        }
        if(window.event) 
        {
            window.event.cancelBubble = true;
            window.event.returnValue = false;
        }
    }

    this.doNothing = function(event)
    {
        ZDBUtil.stopEventBubble(event);
        return false;
    }
    
    this.isPrintable = function(keycode)
    {
        return keycode > 0;
    }

    this.getSourceElement = function(event)
    {
        if(window.event && window.event.srcElement) 
            return window.event.srcElement;
        else if(event && event.target) 
            return event.target;
        else if(event && event.src)
            return event.src;
        else
            return null;
    }
    this.getSourceEvent = function(event){
       if(event && event.target) 
            return event.target;
       else if(window.event && window.event.srcElement) 
            return window.event.srcElement;
        
        else if(event && event.src)
            return event.src;
        else
            return null;
    }
    
    this.attachEvent = function(eSrc, eName,eHandler, eBubble)
    {
        if(eHandler)
        {
            eSrc.addEventListener(eName, eHandler, eBubble);
        }
        else
        {
            eSrc.addEventListener(eName, ZDBUtil.doNothing, false);
        }
    }

    this.detachEvent = function(eSrc, eName,eHandler, eBubble)
    {
        if(eHandler)
        {
            eSrc.removeEventListener(eName, eHandler, eBubble);
        }
        else
        {
            eSrc.removeEventListener(eName, ZDBUtil.doNothing, false);
        }
    }


    this.isCapsLockOn = function (keyCode, shiftKey)
    {
	   return (keyCode >= 65 && keyCode <= 90 && !shiftKey) ||
              (keyCode >= 95 && keyCode <= 123 && shiftKey);
    }
    

    this.getGridKeyUpEvent = function(event)
    {
        var keycode = 0;
        if (window.event)
        {
            keycode = window.event.keyCode;
        }
        
        var ev = event || window.event;
        if(ev)
        {
            return {
                    obj : ev,
                    keyCode: keycode,
                    shiftPressed: ev.shiftKey,
                    ctrlPressed: ev.ctrlKey,
                    cmdPressed: ev.metaKey,
                    altPressed: ev.altKey,
                    modifierPressed : ev.shiftKey || ev.ctrlKey || ev.altKey || ev.metaKey
                    // must very them
                    // capsOn : this.isCapsLockOn(ev.keyCode || event.which, ev.shiftKey)
                   };
        }
        else
        {
            return event;
        }    
    }
    
    this.getGridKeyPressEvent = function(event)
    {
        var charcode = 0;

		if (window.event)
		{
			charcode = window.event.keyCode;
		}
        else if(event)
        {
            if(event.charCode)
            {
                charcode = event.charCode;
            }
        }
        
        var ev = event || window.event;
        return {
                obj : ev,
                charCode: charcode,
                shiftPressed: ev.shiftKey,
                ctrlPressed: ev.ctrlKey,
                cmdPressed: ev.metaKey,
                altPressed: ev.altKey,
                modifierPressed : ev.shiftKey || ev.ctrlKey || ev.altKey || ev.metaKey
                // must very them
                // capsOn : this.isCapsLockOn(ev.keyCode || event.which, ev.shiftKey)
               };
    }

    this.getObject = function(startObj, nameToFind)
    {
        while(startObj)
        {
            if(startObj[nameToFind])
            {
                return startObj[nameToFind];
            }
            else
            {
                startObj = startObj.parentNode;
            }
        }
        throw new Error("Could not find " + nameToFind);
    }
    
    
    this.getCursorPos = function(ev) 
    {
      if(BROWSER.NONIE)
      {
        return {x : ev.pageX, y : ev.pageY};
      }
      else if(BROWSER.IE)
      {
        return ({x : (window.event.clientX + document.body.scrollLeft), 
                    y : (window.event.clientY + document.body.scrollTop)
                    });
      }
      return ({x:0,y:0});
        
    }

    this.isMouseLeftButtonPressed = function(ev) 
    {
        if(BROWSER.NONIE)
        {
    		return ev &&  ev.button == 0 ? true : false;
        }
        else if(BROWSER.IE11AndAbove)
        {
        	return window.event &&  window.event.button == 0 ? true : false;
        }
        else if(BROWSER.IE)
        {
    		return window.event &&  window.event.button == 1 ? true : false;
        }
        else
        {
            throw new Exception("Can not determine!");
        }
    }



    this.getElementAbsolutePos = function(element)
    {
      var res = new Object();
      res.x = 0;res.y = 0;
      if (element !== null) 
      {
        if (element.getBoundingClientRect) 
        {
          var viewportElement = document.documentElement;
          var box = element.getBoundingClientRect();
          var scrollLeft = viewportElement.scrollLeft;
          var scrollTop = viewportElement.scrollTop;

          res.x = box.left + scrollLeft;
          res.y = box.top + scrollTop;

        }
      }
      return res;
    }

    this.getElementAbsoluteLeft = function(element)
    {
        return this.getElementAbsolutePos(element).x;
    }

    this.getElementAbsoluteTop = function(element)
    {
        return this.getElementAbsolutePos(element).y;
    }

    this.getObjTop = function(obj,isNoScroll,upToParent)
    {// isNoScroll - whether scrollTop should be used in calculation or not
//      isNoScroll = (isNoScroll)? isNoScroll : obj.scrollHeight > 0;
    	if(!obj)
    	{
            throw new Error("NULL Object. findObjTop returns null");
            return null;
        }
        
        var curtop = 0;
    	if (document.getElementById || document.all)
        {
          while (obj && obj.parentNode && obj.offsetParent && (obj != upToParent))
          {
            curtop += (isNoScroll) ? obj.offsetTop : (obj.offsetTop - obj.scrollTop);
            obj = obj.offsetParent;
          }
    	}
        else if (document.layers)
        {
          curtop += (isNoScroll) ? obj.y : (obj.y - obj.scrollTop);
    	}
    	return curtop;
    }

    this.getObjTopWithScrollUpToPar = function(el, parWithScroll)
    {
        var oldScrollTop = parWithScroll.scrollTop;
        parWithScroll.scrollTop = 0;
        var parentY = (ZDBUtil.getObjTop(parWithScroll));
        var elY = (ZDBUtil.getObjTop(el));
        var elYFromParent = elY-parentY;
        parWithScroll.scrollTop = oldScrollTop;

        return elYFromParent;
    }

    this.isElVisibleWithinPar = function(el,parWithScroll)
    {
        var curScrollTop = parWithScroll.scrollTop;
        var objTopToPar = ZDBUtil.getObjTopWithScrollUpToPar(el,parWithScroll);
        var y1 = objTopToPar;
        var y2 = objTopToPar + el.offsetHeight+100;

        var isVisible = (
                          (curScrollTop <= y1) &&
                          (y2 < (curScrollTop+parWithScroll.clientHeight))
                        );

         return isVisible;
    }

    this.scrollElToVisibleAreaWithinPar = function(el,parWithScroll)
    {
        if(!ZDBUtil.isElVisibleWithinPar(el,parWithScroll))
        {
           var objTop = ZDBUtil.getObjTopWithScrollUpToPar(el,parWithScroll);
           if((parWithScroll.scrollTop-objTop) > 0)
           {
                parWithScroll.scrollTop = objTop;
           }
           else if((parWithScroll.scrollTop-objTop) < 0)
           {
                parWithScroll.scrollTop += ((objTop+el.offsetHeight+100)-(parWithScroll.scrollTop+parWithScroll.clientHeight));
           }
        }
    }

    this.getObjTopUpTo = function(parentEl,isNoScroll)
    { // This method is using specifically for AutoGenViews
        var obj = ZDBNavigation.getAutoGenTr(parentEl);
        var curtop = 0;
        if(obj == null)
        {
            return curtop;
        }
    	if (document.getElementById || document.all)
        {
          while (obj.id != parentEl.id && obj.parentNode)
          {
            curtop += (isNoScroll) ? obj.offsetTop : (obj.offsetTop - obj.scrollTop);
            obj = obj.parentNode;
          }
    	}
        else if (document.layers)
        {
          curtop += (isNoScroll) ? obj.y : (obj.y - obj.scrollTop);
    	}
    	return curtop;
    }

    this.getObjLeft = function(obj,isNoScroll,upToParent)
    {// isNoScroll - whether scrollLeft should be used in calculation or not
      if(!obj)
      {
        throw new Error("NULL Object. getObjLeft returns null");
        return null;
      }
      var curleft = 0;
      if (document.getElementById || document.all)
      {
        while (obj && obj.parentNode && obj.offsetParent && (obj != upToParent))
        {
          curleft += (isNoScroll) ? obj.offsetLeft : (obj.offsetLeft - obj.scrollLeft);
          obj = obj.offsetParent;
        }
      }
      else if (document.layers)
      {
        curleft += (isNoScroll) ? obj.x : (obj.x - obj.scrollLeft);
      }
      return curleft;
    }

    
    this.setCaretToEnd = function(control) 
    {
      if (control.createTextRange)
      {
        var range = control.createTextRange();
        range.collapse(false);
        range.select();
      }
      else if (control.setSelectionRange)
      {
        var length = control.value.length;
        control.setSelectionRange(length, length);
      }
    }
    
    this.setCaretToPos = function(control, pos) 
    {
      if (control.createTextRange)
      {
        var range = control.createTextRange();
        range.move("character",pos);
        range.collapse(false);  
        range.select();
      }
      else if (control.setSelectionRange)
      {
        control.focus();
        control.setSelectionRange(pos,pos);
      }
    }


    this.setCaretToStart  = function(control)
    {
      
    if (control.createTextRange)
      {
        var range = control.createTextRange();
        range.collapse(true);
        range.select();
      }
      else if (control.setSelectionRange)
      {
    //    control.focus();
        control.setSelectionRange(0, 0);
      }
    }

    this.getKeyCode = function(event)
    {
        if(BROWSER.NONIE)
        {
            return event.keyCode;
        }
        else if(BROWSER.IE)
        {
            return window.event.keyCode;
        }
    }

    this.getCharCode = function(event)
    {
        if(BROWSER.NONIE)
        {
            return event.charCode;
        }
        else if(BROWSER.IE)
        {
            return window.event.keyCode;
        }
    }
    
    this.findParentWithTagName = function(element, name)
    {
        if(!element || !name)
        {
            throw new Error("Either element or name is missing!")
            return;
        }
        name = name.toUpperCase();
        
        var curEl = element;
        do
        {
            if(curEl.nodeName.toUpperCase() == name)
            {
                return curEl;
            }
            curEl = curEl.parentNode;
        }while(curEl);
    
    }

    this.findObjectWithProperty = function(property, start, end, direction)
    {
        //Doesn't check for siblings
        if(document.body[property])
        {
            return document.body;
        }
        var nodeList = document.body.childNodes;
        var len = nodeList.length;
        for(var j=0;j<len;++j)
        {
            if(nodeList[j][property])
            {
                return nodeList[j];
            }
        }
        return null;
    }
    
    

    this.getObj = function(n,d) 
    {
    	var p,i,x;
    	if(!d) d = document;
    
    	if((p=n.indexOf("?"))>0&&parent.frames.length) 
        {
    		d=parent.frames[n.substring(p+1)].document; 
            n=n.substring(0,p);
    	}
    
    	if(!(x=d[n])&&d.all)
        {
    		x=d.all[n];
    	}
    
    	for(i=0;!x&&i<d.forms.length;i++)
        {
    		x=d.forms[i][n];
    	}
    
    	var lay = d.layers;
        for(i=0;!x&& lay &&i<lay.length;i++)
        {
    		x= this.getObj(n,d.lay[i].document);
    	}
    
    	if(!x && d.getElementById)
        {
    		x=d.getElementById(n);
    	}
    	return x;
    }

    this.createInput = function(node, parentNode, type)
    {
        if(BROWSER.IE)
        {
            var s = "<" + node + " " +"type=" + type + " />"
            var temp = document.createElement(s);
            if(parentNode)
            {
                parentNode.appendChild(temp);
            }
            return temp;
        }
        else if(BROWSER.NONIE)
        {
            var temp = document.createElement(node);
            if(parentNode)
            {
                parentNode.appendChild(temp);
            }
            if(type)
            {
                temp.type = type;
            }
            return temp;
        }
        
    
    }


    this.clearTextSelection = function()
		{
			if (window.getSelection) {
			if (window.getSelection().empty) {  // Chrome
			window.getSelection().empty();
			} else if (window.getSelection().removeAllRanges) {  // Firefox
			window.getSelection().removeAllRanges();
			}
			} else if (document.selection) {  // IE?
			document.selection.empty();
			}
	
		}
	
    this.getActualDimension = function(domElement)
    {   //assumption: units are present like 0px, 5cm ...
        
        var obj = new Object();
        obj.width = domElement.style.width ? parseInt(domElement.style.width) : 0 ;
        obj.height = domElement.style.height? parseInt(domElement.style.height): 0;

        if(BROWSER.IE)
        {
            return obj;
        }
        var marginL = marginR = marginT = marginB = 0;
        var paddingL = paddingR = paddingT = paddingB = 0;
        var borderL = borderR = borderT = borderB = 0;
        with(domElement.style)
        {
            if(border)
            {
                borderL = borderR = borderT = borderB = parseInt(border);
            }
            else
            {
                    borderL = borderLeft ? parseInt(borderLeft) : 0;
                    borderR = borderRight ? parseInt(borderRight) : 0;
                    borderT = borderTop ? parseInt(borderTop) : 0;
                    borderB = borderBottom ? parseInt(borderBottom) : 0;
            }
            if(margin)
            {
                marginL = marginR = marginT = marginB = parseInt(margin);
            }
            else
            {
                    marginL = marginLeft ? parseInt(marginLeft) : 0;
                    marginR = marginRight ? parseInt(marginRight) : 0;
                    marginT = marginTop ? parseInt(marginTop) : 0;
                    marginB = marginBottom ? parseInt(marginBottom) : 0;
            }
            if(padding)
            {
                paddingL = paddingR = paddingT = paddingB = parseInt(padding);
            }
            else
            {
                    paddingL = paddingLeft ? parseInt(paddingLeft) : 0;
                    paddingR = paddingRight ? parseInt(paddingRight) : 0;
                    paddingT = paddingTop ? parseInt(paddingTop) : 0;
                    paddingB = paddingBottom ? parseInt(paddingBottom) : 0;
            }
        }
        obj.width += borderL + borderR + marginL + marginR + paddingL + paddingR;
        obj.height += borderT + borderB + marginT + marginB + paddingT + paddingB;
        return obj;
    }

    this.getBoxModelDimension = function(width, border, margin, padding)
    {
        border = typeof(border) != 'undefined' ? border : 1;
        margin = typeof(margin) != 'undefined' ? margin : 0;
        padding = typeof(padding) != 'undefined'? padding : 0;

        if(BROWSER.IE)
        {
            return width + 2 * border + 2 * margin + 2 * padding;
        }
        else
        {
            return width;
        }
      
    }
    
    this.getAdjustedSize = function(size, border, margin, padding)
    {
        border = typeof(border) != 'undefined' ? border : 0;
        margin = typeof(margin) != 'undefined' ? margin : 0;
        padding = typeof(padding) != 'undefined'? padding : 0;

        if(BROWSER.IE)
        {
            return size;
        }
        else if(BROWSER.NONIE)
        {
            return size - 2 * border - 2 * margin - 2 * padding;
        }
      
    }


    this.setDimensionForPopup = function(element, event)
    {
        // Call this method after filling the popup element with data
        
        if(!element)
        {
            throw new Error("Couln't find elementID");
            return;
        }

        var right = 0;
        var bottom = 0;
        var left = 0;
        var top = 0;
        var ofHeight = element.offsetHeight;
        var ofWidth = element.offsetWidth;
        
        if(BROWSER.IE)
        {
            right = document.body.clientWidth - window.event.clientX;
            bottom = document.body.clientHeight - window.event.clientY;
            if (right < ofWidth)
            {
                left = window.event.clientX + document.body.scrollLeft - ofWidth ;
            }
            else
            {
                left = window.event.clientX + document.body.scrollLeft;
            }
            
            if (bottom < ofHeight)
            {
                top = window.event.clientY + document.body.scrollTop - ofHeight;
            }
            else
            {
                top = window.event.clientY + document.body.scrollTop;
            }
        }
        else if(BROWSER.NONIE)
        {
            right = window.innerWidth - event.clientX;
            bottom = window.innerHeight - event.clientY;
            if (right < ofWidth)
            {
                left = event.clientX + window.pageXOffset - ofWidth;
            }
            else
            {
               left = event.clientX + window.pageXOffset;
            }
            if (bottom < ofHeight)
            {
                top = event.clientY + window.pageYOffset - ofHeight;
            }
            else
            {
                top = event.clientY + window.pageYOffset;
            }
        }

        
        element.style.overflow = "auto";
        element.style.position = "absolute";
        element.style.top = top + "px";
        element.style.left = left + "px";
        element.zIndex = "9999";
    }    
    
    this.deepRemoveNonElements = function(el,tagName)
    {      
      this.removeNonElements(el);
      tagName = tagName ? tagName : "*";
      var els = el.getElementsByTagName(tagName);
      for(var i =0; i < els.length;i++)
      {
        if(els[i].getAttribute("keeptext") != "true")
        {
          this.removeNonElements(els[i]);
        }
      }
    }

    
    this.removeAllUnwanted = function(el, tagName){
    	if(el==null){return;}
    	tagName = tagName ? tagName : "*";
        var childNodes = el.getElementsByTagName(tagName);
        for(var i=childNodes.length -1; i > -1; i--)
        {
        	if(childNodes[i].getAttribute("keeptext") != "true")
            {
        		childNodes[i].parentNode.removeChild(childNodes[i]);
            }
        }
    }
    
  this.removeAllChildren  = function(el)
  {
	  if(el==null){return;}
    var childNodes = el.childNodes;
    for(var i=childNodes.length -1; i > -1; i--)
    {
      el.removeChild(childNodes[i]);
    }
  }
  
    this.removeNonElements = function(el)
    {
      if(el && !el.elTrimmed)
      {
        var childEls = el.childNodes;
        for(var i=childEls.length -1;i > -1; i--)
        {
          if(!childEls[i].getElementsByTagName)
          {
            el.removeChild(childEls[i]);
          }
        }
        el.elTrimmed = true;
      }
      
    }

    this.removeElementsByClassName = function(el, className)
    {
    	if(!className)
    	{
    		return;
    	}
    	var els = el.getElementsByClassName(className);
    	for(var i=els.length-1; i>=0; i--)
    	{
    		if(els[i].getAttribute("keeptext") != "true")
    		{
    			els[i].parentElement.removeChild(els[i]);
    		}
    	}
    }

  this.setNamedChildEls = function(parentEl,objToSetOn,attributeName,includeParentEl, needToBeVisible, needReassign)
  {
    if(attributeName == null){attributeName = "elname";}
   if(objToSetOn[attributeName + "Set"] == true)
   {
     return;
   }
	if(includeParentEl)
	{
      var name = parentEl.getAttribute(attributeName);
      if(name != null){objToSetOn[name] = parentEl;}
	}
    var els = parentEl.getElementsByTagName("*");
    for(var i=0, j = els.length; i < j; i++)
    {
      var name = els[i].getAttribute(attributeName);
      if(name != null) {
    	  if (!needToBeVisible || (els[i].style.display != "none" && els[i].offsetParent))
    		  objToSetOn[name] = els[i];
      }
    }
    if(!needReassign){
      objToSetOn[attributeName + "Set"] = true;
    }
  }


  this.setIdBasedNamedChildEls = function(objToSetOn,names,prefix)
  {
    if(objToSetOn[prefix + "Set"] == true)
    {
      return;
    }
    var elsToRemove = []
    for(var i =0, j = names.length; i < j; i++)
    {
      var idVal = prefix + names[i];
      var el = document.getElementById(idVal);
      if(el != null)
      {
        el.id="";
        if(el.getAttribute("REMOVEFROMPARENT") == "true"){elsToRemove.push(el);}
      }
      objToSetOn[names[i]] = el;
    }
    for(var i =0,j = elsToRemove.length;i< j; i++)
    {
       elsToRemove[i].parentNode.removeChild(elsToRemove[i]);
    }
    objToSetOn[prefix + "Set"] = true;
  }
  

  this.updateIdBasedNamedChildEls = function(objToSetOn,names,prefix)
  {
    objToSetOn[prefix + "Set"] = false;
    this.setIdBasedNamedChildEls(objToSetOn,names,prefix);		 
  }


  
    this.getCachedRef = function(obj,elId)
    {
      var el = obj[elId];
      if(el == null)
      {
        el = document.getElementById(elId);
        obj[elId] = el;
      }
      return el;
    }

    this.positionEl = function(elId,position,top, left, width, height,display)
    {
      var el = ZDBGlobal[elId];
      if(el == null)
      {
        el = document.getElementById(elId);
        if(!el)
        {
          throw new Error(elId + " not present");
        }
        if(el.parentNode != document.body)
        {
          document.body.appendChild(el);
        }
        ZDBGlobal[elId] = el;
      }
      var style = el.style;
      if(position){style.position = position;}
      if(top !== undefined && top !== null){style.top = top + "px";}
      if(left !== undefined && left !== null){style.left = left + "px";}
      if(width !== undefined && width !== null && width >= 0){style.width = width + "px";}
      if(height !== undefined && height !== null && height >= 0){style.height = height + "px";}
      if(display !== undefined && display !== null){style.display = display;}
    }


this.indexOf = function(arrayObj,val,abbrLen, ignoreCase)
  {
    // When the abbrLen is passed for string values, both abbr. and full text is compared
    // Ex1: indexOf(["Hello","World"], "Wor", 3, true) => 1
    // Ex2: indexOf(["Hello","World"], "World", 3, true) => 1
    
    var len = arrayObj.length;
    var isValStringType = ((typeof val) == 'string'); 
    if(isValStringType  && ignoreCase)
    {
      val = val.toLowerCase();
    }
    for(var i=0; i < len;i++)
    {
      var curObj = arrayObj[i];
      if((isValStringType && (typeof curObj) == 'string'))
      {
         if(ignoreCase)
         {
          curObj = curObj.toLowerCase();
         }
         if(curObj  == val)
         {
          return i;
         }
         if(abbrLen && curObj.substring(0, abbrLen) == val)
         {
          return i;
         }
      }
      else if (curObj == val)
      {
        return i;
      } 
    }    
    return -1;
  }
    
  this.addToSet = function(setObj,val)
  {
    if(this.indexOf(setObj,val) == -1)
    {
      setObj.push(val);
      return true;
    }
    else
    {
      return false;
    }    
  }

  this.removeFromSet = function(setObj,val)
  {
    var index = ZDBUtil.indexOf(setObj,val);
    if(index > -1)
    {
      setObj.splice(index,1);
    }    
    return index;
  }

  this.roundDecimals = function(number, scale)
  {
	  var value = number * Math.pow(10, scale);
	  value = Math.round(value);
	  value = value / Math.pow(10, scale);
	  return value;
  }

  this.dummyFunc = function()
  {
  }

  this.getAssocArraySize = function(asscArr)
  {
    var i = 0;
    for(var arg in asscArr)
    {
      i++;
    }
    return i;
  }

  this.scrollToView = function(elToView,parEl,adjust)
  {
    var dWidth = parEl.offsetWidth; /// back here!
    var dHeight = parEl.offsetHeight;
  	
    var cLeft = elToView.offsetLeft - parEl.scrollLeft;
    var cTop = elToView.offsetTop - parEl.scrollTop;
    var cWidth = elToView.offsetWidth;
    var cHeight = elToView.offsetHeight;

    
    if (cLeft + cWidth > dWidth - adjust)
    {
      parEl.scrollLeft += (cLeft + cWidth) - (dWidth - adjust);
    }
    else if (cLeft < 0)
    {
      parEl.scrollLeft += cLeft;
    }
  	
    if (cTop + cHeight > dHeight - adjust)
    {
      parEl.scrollTop += (cTop + cHeight) - (dHeight - adjust);
    }
    else if (cTop < 0)
    {
      parEl.scrollTop += cTop;
    }
    
  }

  this.showRefErr = function(innerHTML,title)
  {
    var dlg = ZDBContentCache.appendAndGet("Ref_Details_Dlg","GridMenu",document.body);
    dlg.style.display = 'block';
    var errDiv = $('ZDBSHEETREFERR_CONTENT');
    errDiv.style.height = "";
    // $$ XSS
    errDiv.innerHTML = innerHTML;
    ZDBDialogUtil.showDialog(dlg,{TITLE:title,ADDFRAME:true,MODAL:true,DONTREMOVE:true});
    if(errDiv.offsetHeight > 200)
    {
      errDiv.style.height = "200px";
    }
    ZDBMenu.resizeIframe(ZDBDialogUtil.focusDialog);
  }

this.getTrimmedString = function(string, charCount, sufText)
{
    if(string == null)
    {
    return "";
    }
    if(string.length > charCount)
    {
    return string.substring(0, charCount) + sufText;
    }
    return string;
}


  this.trace = function()
  {
    var str = "";
    var curFunc = arguments.callee;
    
    while(curFunc != null)
    {
      str += curFunc;
      curFunc = curFunc.caller;
    }
  }

	this.createIframes = function()
	{
          for(i=0; i<2; i++)
          {
            var newIframe = null;
            if((BROWSER.NETSCAPE) || (BROWSER.NONIE))
     	    {
              newIframe = document.createElement("div");
              newIframe.style.overflow = "auto";
            }
            else
            {
              newIframe =document.createElement("iframe");
              if(window.location.protocol == "https:")
              {
                  newIframe.src= ZDBGlobal.REPORTS_CONTEXT_NAME + "/framework/html/blank.html";
              }
              else
              {
                  newIframe.src= "about:blank";
              }
              newIframe.scrolling = "no";
              newIframe.frameBorder = 0;
            }
            //newIframe.className = "alpha0";
            newIframe.style.background = "none";
            newIframe.style.border = "none";
            newIframe.style.position="absolute";
            ZDBUtil.iframeList.push(newIframe);
          }		
		
	}
	
	this.getCachedIframe = function()
	{
          if(ZDBUtil.iframeList==null)
          {
            this.iframeList = new Array();
          }
          if(ZDBUtil.iframeList.length<1)
          {
            ZDBUtil.createIframes();
          }
          return ZDBUtil.iframeList.pop();
	}
	
	
	this.returnIframeToCache = function(iframe)
	{
          ZDBUtil.iframeList.push(iframe);
          iframe.parentNode.removeChild(iframe);
	}

    this.setIfGAppsUser = function()
    {
        AjaxAPI.sendRequest({URL:"/ZDBSecurityAction.ma?ZDBACTION=ZDBCHECKIFGAPPUSER",METHOD:"GET",
                               ONSUCCESSFUNC:ZDBUtil.gAppUserCheckResp,  //No I18N
                               ONFAILUREFUNC:ZDBUtil.gAppUserCheckRespFailure});  //No I18N
    }

    this.gAppUserCheckResp = function(response,requestOptions)
    {
      var resp = response.responseText;
      if(resp == "true")
      {
        ZDBClientUI.isGAppUser=true;
      }
      else
      {
        ZDBClientUI.isGAppUser=false;
      }
    }

    this.gAppUserCheckRespFailure = function(response,requestOptions)
    {
      ZDBClientUI.isGAppUser=false;
    }

    this.gAppAdminCheckResp = function(response,requestOptions)
    {
      var resp = response.responseText;
      if(resp == "true")
      {
        ZDBClientUI.isGAppAdmin=true;
      }
      else
      {
        ZDBClientUI.isGAppAdmin=false;
      }
    }

    this.gAppAdminCheckRespFailure = function(response,requestOptions)
    {
      ZDBClientUI.isGAppAdmin=false;
    }
    
    this.showTouchEffect = function(el,event,className)
    {
    	if(el)
    	{
    		el.className += (className) ? className : " touched";	//No I18N
    	}
    }
    
    this.removeTouchEffect = function(el,event,className)
    {
    	if(el)
    	{
    			el.className = ZDBUtil.replaceStr(el.className, (className) ? className :" touched" ,"");
    	}
    }
    this.ShowHideForceRefresh = function(view,isToolbarUpdate)
    {
      if(!view.toolbar || !view.toolbar.FetchData) //For ZIA and  Embed Case
      {
        return;
      } 
      if(view.maxCacheTime || view.cacheTime)
      {
        
        if(isToolbarUpdate)
        {
          ZDBUtil.updateActTime(view);
          view.toolbar.FetchData.style.display = "inline-block";
          return;
        }
        var cacheTime = (view.dashDiv) ? view.maxCacheTime.RELATIVE_TIME : view.cacheTime.RELATIVE_TIME;
        view.toolbar.FetchData.innerText = ZDBI18NMap.f("zrpt.common.js.fetchdata", cacheTime);
        view.toolbar.FetchData.style.display = "inline-block";
        ZDBUtil.setTimeout(ZDBUtil.updateActTime,null,[view],60000);
      }
      else
      {
        view.toolbar.FetchData.style.display = "none";
        view.toolbar.FetchData.innerText = "";
      }
    };   

    this.updateActTime = function(view)
    {
      if(view.maxCacheTime || view.cacheTime)
      {
        var cacheTime = (view.dashDiv) ? view.maxCacheTime.ACTUAL_TIME : view.cacheTime.ACTUAL_TIME;
        view.toolbar.FetchData.innerText = ZDBI18NMap.f("zrpt.common.js.fetchdata", cacheTime);
      }
    };

    this.setCacheTime = function(view,cacheTime)
    {
      if(cacheTime)
      {
        view.cacheTime = cacheTime;
      }
      else
      {
        view.cacheTime = null; 
      }
    };

    this.SendForceRefreshRequest = function(type)
    {
      switch(type)
      {
        case "Report": //No I18N
        case "Table": //No I18N
        case "QueryTable": //No I18N
          ZDBGridMenu.refreshSheet();
          break;
        case "AnalysisView": //No I18N
        case "Pivot": //No I18N
        case "SummaryView": //No I18N
          ZDBAnalysisView.refreshView(ZDBClientUI.selectedTab.comp);
          break;
        case "Dashboard": //No I18N
          DashUtils.refreshViews(ZDBClientUI.selectedTab.comp);  
          ZDBClientUI.selectedTab.view.maxTime = 0;
          break;      }
    };

    this.maxTime = function(cacheTime, maxCacheTime)
    {
      var timeText1 = cacheTime.RELATIVE_TIME;
      var timeText2 = (maxCacheTime) ? maxCacheTime.RELATIVE_TIME : null;
      var tOrder1 = ZDBUtil.timeOrder(timeText1);
      var tOrder2 = ZDBUtil.timeOrder(timeText2);
      if (tOrder1 > tOrder2)
      {
        return cacheTime;
      }
      else if(tOrder1 == tOrder2)
      {
        if(parseInt(timeText1) >= parseInt(timeText2))
        {
          return cacheTime;
        }
        else
        {
          return maxCacheTime;
        }
      }
      else
      {
        return maxCacheTime;
      }
    };

    this.timeOrder = function(timeText)
    {
      var secs = /(sec|secs)/i;
      var mins = /(min|mins)/i;
      var hrs = /(hr|hrs)/i;
      if(!timeText)
      {
        return 0;
      }
      else if(timeText.match(secs))
      {
        return 1;
      }
      else if(timeText.match(mins))
      {
        return 2;
      }
      else if(timeText.match(hrs))
      {
        return 3;
      }
    };

}
 
    
    DOMUtils.getElOrParentWithAttr = function(el,attrName)
    {
      if(el.getAttribute &&  el.getAttribute(attrName) != null){return el;}
      return DOMUtils.getParentWithAttr(el,attrName);
    }
    

    ZDBUtil.isEmptyObject = function(obj) {
        var bool = Object.keys(obj).length === 0 && obj.constructor === Object;
        return bool;
    }
        
ZDBUtil.templateCreator = function (tempData, cloneNode) {
//         tempStruct will be in the format of
//         { Id : {parId: "", tagName : "", attrs : {}, innerText : "", reference: "", svg: <xlinkName>} }
//          where attr is again a keyvalue pair { attrName : attrval }
    var elStack = {};
    if (HTMLTempStruct[tempData]["isCached"]) {
        return (cloneNode ? HTMLTempStruct[tempData].cloneNode(true) : HTMLTempStruct[tempData]);
    } else {
        var tempStruct = HTMLTempStruct[tempData];
        for (var key in tempStruct)
        {
            var tempKey = tempStruct[key];
            var parent = tempKey["ParId"];
            var attr = tempKey["attrs"];
            var customTag = tempKey["customTag"];
            var innerText = tempKey["innerText"];
            var reference = tempKey["reference"];
            var svgRef = tempKey["svg"]
            var el = (customTag) ? ZDBUtil.templateCreator(customTag) : document.createElement(tempKey["TagName"]);
            for (var attrName in attr) {
                if(typeof attr[attrName] == "string" && attr[attrName].indexOf(".js.") != -1) {
                    attr[attrName] = ZDBI18NMap.g(attr[attrName]);
                }
                el.setAttribute(attrName,attr[attrName]);
            }
            if (innerText) {
                var textNode = document.createTextNode(ZDBI18NMap.g(innerText));
                el.appendChild(textNode);
            }
            if (reference) {
                elStack[tempData][reference] = el;
            }
            if(svgRef) {
                var svgEl = ZDBUtil.createSVGTemplate(svgRef);
                el.appendChild(svgEl);
            }
            elStack[key] = el;
            if (key != parent)
            {
                elStack[parent].appendChild(el);
            }
        }
        HTMLTempStruct[tempData] = elStack[tempData];
        HTMLTempStruct[tempData]["isCached"] = true;
        return (cloneNode ? HTMLTempStruct[tempData].cloneNode(true) : HTMLTempStruct[tempData]);   // elStelStack[0] always considered as root
    }
}

ZDBUtil.createSVGTemplate = function(xlinkHref) {
    var svg = document.createElementNS(ZDBConst.SVGNAMESPACE, "svg");//No I18N
    svg.setAttribute("class","svgIcons"); // default class name
    var use = document.createElementNS(ZDBConst.SVGNAMESPACE, "use");//No I18N
    use.setAttributeNS(ZDBConst.XLINKNAMESPACE, "xlink:href", xlinkHref);//No I18N
    svg.appendChild(use);
    return svg;
}
    
    ZDBUtil.getParentWithAttributeValue = function(el, attributeName, attributeValue)
    {
	     attributeName = attributeName.toUpperCase();
	     attributeValue = attributeValue.toUpperCase();
             var curEl = el;
	     while(curEl)
	     {
               if(curEl.getAttribute && (""+curEl.getAttribute(attributeName)).toUpperCase() == attributeValue)
               {
                 return curEl;
               }
               curEl = curEl.parentNode;
             }
             return null;
    }
    
    ZDBUtil.getElsWithAttrName = function(parentEl, attrName)
    {
            if(parentEl==null){return}
            var els = new Array();
            var nodes = parentEl.getElementsByTagName("*");
            for(var i=0, j = nodes.length; i < j; i++)
            {
                    var name = nodes[i].getAttribute(attrName);
                    if(name != null){els.push(nodes[i]);}
            }

            return els;
    }

    ZDBUtil.getElsWithTagNAttr = function(parentEl, attrName, tagName)
    {
            if(parentEl==null){return}
            var els = new Array();
            var nodes = parentEl.getElementsByTagName(tagName);
            for(var i=0, j = nodes.length; i < j; i++)
            {
                    var name = nodes[i].getAttribute(attrName);
                    if(name != null){els.push(nodes[i]);}
            }

            return els;
    }

    ZDBUtil.getElWithTagNAttrWithVal = function(parentEl, attrName, attrVal, tagName)
    {
            if(parentEl==null){return}
            var nodes = parentEl.getElementsByTagName(tagName);
            for(var i=0, j = nodes.length; i < j; i++)
            {
                   var curEl = nodes[i];
                   var name = curEl.getAttribute(attrName);
                   if(name != null && (""+curEl.getAttribute(attrName)).toUpperCase() == attrVal.toUpperCase())
                   {
                     return curEl;
                   }
            }

            return;
    }

    ZDBUtil.getElsWithTagNAttrWithVal = function(parentEl, attrName, attrVal, tagName)
    {
            if(parentEl==null){return}
            var nodes = parentEl.getElementsByTagName(tagName);
            var els = new Array();
            for(var i=0, j = nodes.length; i < j; i++)
            {
                   var curEl = nodes[i];
                   var name = curEl.getAttribute(attrName);
                   if(name != null && (""+curEl.getAttribute(attrName)).toUpperCase() == attrVal.toUpperCase())
                   {
                     els.push(curEl);
                   }
            }
            return els;
    }
ZDBUtil.getElsWithTagNAttrWithVals = function (parentEl, attrName, attrVals, tagName)    // for Multiple attrVals ex: attrVal = [foldId1, foldId2, foldId3]
{
    if (parentEl == null) {
        return
    }
    var nodes = parentEl.getElementsByTagName(tagName);
    var els = new Array();
    for (var i = 0; i < nodes.length; i++)
    {
        var curEl = nodes[i];
        var name = curEl.getAttribute(attrName);
        if (name != null ) 
        {
            var elAttrVal = ("" + name).toUpperCase();
            for(var j = 0; j < attrVals.length; j++)
            {
                var val = (attrVals[j] + "").toUpperCase();
                if(elAttrVal == val)
                {
                    els.push(curEl);
                }
            }
        }
    }
    return els;
}
    
ZDBUtil.getParentWithTagName = function (el, tagName)
{
    if (!el) {
        return;
    }
    tagName = tagName.toUpperCase();
    var curEl = el;
    while (curEl && curEl.tagName.toUpperCase() != tagName)
    {
        curEl = curEl.parentNode;
    }
    return curEl;
}
    
    
ZDBUtil.getParentWithProperty = function(el,propName)
{
  var curEl = el;
  while(curEl && (curEl[propName] == null))
  {
    curEl = curEl.parentNode;
  }
  return curEl;
}

    if(window.console == null)
    {
         console = new Object();
         console.log = function(){};
         console.error = console.log;
         console.trace = console.log;
         console.logit = function(str) 
         {
           var line = document.createElement("div");
           // $$ XSS
           line.innerHTML = str;
           if(console.msgDiv == null)
           {
             console.msgDiv = document.getElementById("ZDBCONSOLEMSG");
             if(console.msgDiv == null){return;}
             console.msgDiv.style.display ="block";
             ZDBDialogUtil.showDialog(console.msgDiv,{ADDFRAME:true,TITLE:"Console"});  		 
           }
           console.msgDiv.appendChild(line);
           if(console.msgDiv.style.visibility != "visible")
           {
             console.msgDiv.style.visibility = "visible";
           }
    	    console.msgDiv.onclick=console.clearConsole;
         };
    	 
    	 console.clearConsole =function()
           {
             console.msgDiv.innerHTML="";
           }
         
         console.enableConsole =function()
           {
              
             console.log = console.logit;
             console.error=console.logit;
           }
         
         //console.enableConsole();
}
if(!console.trace){console.trace = ZDBUtil.dummyFunc;}

ZDBUtil.findDataInList = function(dataList, valueToFind, attributeToCheck, defaultIndexAttribute)
{
    var notFoundIndex = -1;
    if(!attributeToCheck)
    {
        attributeToCheck = "value";
    }
    var options = dataList.options;
    var len = options.length;
    for(var i= 0;i<len;++i)
    {
      var optValue = ZDBUtil.getAttribute(options[i], attributeToCheck) ? ZDBUtil.getAttribute(options[i],attributeToCheck) : "";
      if(optValue.toLowerCase() == (""+valueToFind).toLowerCase())
      {
        return i;
      }
      if(notFoundIndex == -1 && ZDBUtil.getAttribute(options[i], defaultIndexAttribute) == "true")
      {
        notFoundIndex = i;
      }
    }
    return notFoundIndex;
}

ZDBUtil.getSubStringInHTML = function(element,startTxt,endTxt)
{
    var html = element.outerHTML;
    var strtIndx = html.indexOf(startTxt);
    var val = html.substring(strtIndx + startTxt.length, html.length);
    val = val.substring(0, val.indexOf(endTxt));
    return val;
}

ZDBUtil.getAttribute = function(element, attributeName, scriptName)
{
  if(BROWSER.NONIE || (BROWSER.IE && 9 <= parseInt(BROWSER.VERSION)))
  {
      return element.getAttribute(attributeName);
  }
  else if (BROWSER.IE)
  {
      if(scriptName)
      {
          return element[scriptName];
      }
      else
      {
          return element[attributeName];
      }
  }
  else
  {
      return element.getAttribute(attributeName);
  }
};                                                 

ZDBUtil.setAttribute = function(element, value, attributeName, scriptName, isBoolean)
{
  if(scriptName)
  {
      element[scriptName] = value;
  }
  element.setAttribute(attributeName, value);
  if(isBoolean)
  {
    element[attributeName] = (value === 'true' || value === true) ? true : false;
  }
};                                                 

ZDBUtil.removeAttribute = function(element, attributeName, scriptName, isBoolean)
{
  if(scriptName)
  {
      element[scriptName] = false;
  }
  if(isBoolean && BROWSER.IE)
  {
    element.setAttribute(attributeName,false); //for IE && assumption: standard attribute like enabled, checked
  }
  else
  {
    element.removeAttribute(attributeName);
  }
};                                                 



function getDataIndex(list, dataAttribute, dataToFind, ignoreDefault)
{
  var options = list.options;
  var len = options.length;
  var optValue = "";
  dataToFind = dataToFind.toString();
  for(var i= (ignoreDefault ? 1 : 0);i<len;++i)
  {
    if(dataAttribute == null)
    {
      optvalue = options[i].trim();
    }
    else
    {
      optValue = options[i].getAttribute(dataAttribute) ? options[i].getAttribute(dataAttribute) : "";
    }
    if((optValue.toUpperCase() == dataToFind.toUpperCase()) || ((optValue.toUpperCase() == "DATE_AS_DATE" && dataToFind.toUpperCase() == "DATE") || (optValue.toUpperCase() == "DATE" && dataToFind.toUpperCase() == "DATE_AS_DATE")))
    {
      return i;
    }
  }
  return -1;
}

ZDBUtil.setAllAttributes = function(fromEl, toEl)
{
	if(fromEl==null || toEl==null){return null;}
	
	var attrs = fromEl.attributes;
	for(i in attrs)
	{
		if(attrs[i].nodeName)
		{
		toEl.setAttribute(attrs[i].nodeName, fromEl.getAttribute(attrs[i].nodeName));
		}
	}
}

ZDBUtil.getParentWithAttr = function(childNode,parentAttrName,limit)
{
	var parNode = childNode.parentNode;
	var cnt = 0;
	while((parNode != null) && (parNode.getAttribute != null) && (limit==null || cnt<limit))
	{	
	if(parNode.getAttribute(parentAttrName) != null)
	{
	return parNode;
	}
	cnt++;
	parNode = parNode.parentNode;
	}
	return null;
}


ZDBUtil.getElementsWithAttribute = function(set, attribName, attribValue)
{
  ///PK: set -> either array of nodes, or parentNode
  
  var outList = [];
  var inList = null;
  var curNode; 
  var curVal;
  if(set instanceof Array)
  {
    inList = set;
  }
  else
  {
    inList = set.childNodes; ///PK: incase of parentNode
  }
  
  if(inList)
  {
    var inLen = inList.length || 0;
    for(var i=0;i<inLen;++i)
    {
      curNode = inList[i];
      if(curNode.getAttribute)
      {
        curVal = curNode.getAttribute(attribName);
      }
      else
      {
        curVal = null;
      }
      
      if(curVal === null)
      {
        continue;
      }
      if(attribValue !== 'undefined' && attribValue != curVal)
      {
        continue;
      }
      //outList.splice(0,0,curNode);
       outList.push(curNode);
    }
  }
  return outList;
  
}

ZDBUtil.getStyle = function(oElm, strCssRule)
{
	var strValue = "";
	if(document.defaultView && document.defaultView.getComputedStyle && oElm!=null)
  {
		var computedStyle = document.defaultView.getComputedStyle(oElm, "");
		strValue = computedStyle.getPropertyValue(strCssRule);
	}
	else if(oElm!=null && oElm.currentStyle)
  {
  	strCssRule = strCssRule.replace(/\-(\w)/g, firstCharUpper);
		strValue = oElm.currentStyle[strCssRule];
	}

  return strValue;
}

ZDBUtil.getStyleNumeric = function(oElm, strCssRule)
{
  var val = ZDBUtil.getStyle(oElm, strCssRule);
  if(val)
  {
    val = parseInt(val, 10);
  }
  if(!val)
  {
    return 0;
  }
  return val;
}

function firstCharUpper()
{
  return firstCharUpper.arguments[1].toUpperCase();
}


ZDBUtil.getElementOuterWidth = function(element)
{
  var extraWidth = ZDBUtil.getStyleNumeric(element, 'padding-left');
  extraWidth += ZDBUtil.getStyleNumeric(element, 'padding-right');
  extraWidth += ZDBUtil.getStyleNumeric(element, 'border-left-width');
  extraWidth += ZDBUtil.getStyleNumeric(element, 'border-right-width');
  extraWidth += ZDBUtil.getStyleNumeric(element, 'margin-left');
  extraWidth += ZDBUtil.getStyleNumeric(element, 'margin-right');
  return extraWidth;
}

ZDBUtil.getElementOuterHeight = function(element)
{
  var extraHeight = ZDBUtil.getStyleNumeric(element, 'padding-bottom');
  extraHeight += ZDBUtil.getStyleNumeric(element, 'padding-top');
  extraHeight += ZDBUtil.getStyleNumeric(element, 'border-bottom-width');
  extraHeight += ZDBUtil.getStyleNumeric(element, 'border-top-width');
  extraHeight += ZDBUtil.getStyleNumeric(element, 'margin-bottom');
  extraHeight += ZDBUtil.getStyleNumeric(element, 'margin-top');
  return extraHeight;
}

ZDBUtil.getElementOuterSize = function(element, isWidth)
{
  return (isWidth ? ZDBUtil.getElementOuterWidth(element) : ZDBUtil.getElementOuterHeight(element));
}





ZDBUtil.getObjCoordinates = function(obj, isNoScroll)
{
  if(!obj)
  {
    return 0;
  }
  var curTop = 0;
  var curLeft = 0;
  if (document.getElementById || document.all)
  {
    while (obj && obj.parentNode && obj.offsetParent)
    {
      curTop += (isNoScroll) ? obj.offsetTop : (obj.offsetTop - obj.scrollTop);
      curLeft += (isNoScroll) ? obj.offsetLeft : (obj.offsetLeft - obj.scrollLeft);
      obj = obj.offsetParent;
    }
  }
  else if (document.layers)
  {
    curTop += (isNoScroll) ? obj.y : (obj.y - obj.scrollTop);
    curLeft += (isNoScroll) ? obj.x : (obj.x - obj.scrollLeft);
  }
  return ({x:curLeft, y:curTop});
}


ZDBUtil.disableTextSelection = function(element)
{
    element.onselectstart = function() {
        return false;
    };
    element.unselectable = "on";
    element.style.MozUserSelect = "none";
    element.style.cursor = "default";
}

ZDBUtil.getOffsetSize = function(element, isWidth)
{
  if(element==null){return null;}
  if(BROWSER.IE)
  {
    return isWidth ? element.offsetWidth : element.offsetHeight; 
  }
  return ZDBUtil.getStyleNumeric(element, isWidth ? "width" : "height") + ZDBUtil.getElementOuterSize(element, isWidth); 
}

ZDBUtil.getOneElementById = function(ch)
{
    var el;var finalEl;
    el = document.getElementById(ch);
    if(el==null){return null;}
    while(el!=null)
        {
            finalEl = document.getElementById(ch);
            finalEl.id = "";
            el = document.getElementById(ch);
        }
      finalEl.id = ch;
      return finalEl;
}



ZDBUtil.timeoutAction = function(timeOutId)
{
  var callInfo = ZDBUtil[timeOutId];
  var callFn = callInfo[0];
  var thisObj = callInfo[1];
  var callArg = callInfo[2];
  try
  {
    callFn.apply(thisObj, callArg);
  }
  catch(e)
  {
    throw new Error("Either function to call is null or argument is not an Array" + e);
  }
  finally
  {
    delete ZDBUtil[timeOutId];
  }
}


ZDBUtil.setTimeout = function(callFn, thisObj, argArr, timeWait)
{
  if(thisObj === null && argArr === null)
  {
    return setTimeout(callFn,timeWait);
  }
  var uniqueId = 'zdb' + ZDBUtil.timeoutCnt++;
  ZDBUtil[uniqueId] = [callFn, thisObj, argArr];
  return setTimeout("ZDBUtil.timeoutAction('" + uniqueId + "')", timeWait); 
}

ZDBUtil.setFocus = function(element, isSelect)
{
  ///PK: extend this to do all sort of DOM event handling
  if(typeof element == 'string')
  {
    element = $(element);
  }
  if(!(element && element.focus))
  {
    return;
  }
  try
  {
    element.focus();
    if(isSelect && element.select)
    {
        element.select();                    
    }
  }
  catch(e)
  {
    /// Possible reasons: element is not visible or not focusable
  }
  return true;
}




ZDBUtil.cloneObject = function(objToClone)
{
  if(objToClone === null || 'object' !== typeof(objToClone))
  {
    return objToClone;
  }
  if(objToClone.cloneNode)
  {
    return objToClone.cloneNode(true);
  }
  var clonedObj = {};
  for(prop in objToClone)
  {
    clonedObj[prop] = ZDBUtil.cloneObject(objToClone[prop]);
  }
  return clonedObj;
}

ZDBUtil.getPropertyFromEl = function(domEl, property, elementOrObj)
{
  var obj = null, el = null;
  while(domEl)
  {
    if(domEl[property] !== undefined)
    {
      obj = domEl[property];
      el = domEl;
      break;
    }
    domEl = domEl.parentNode;
  }

  if(elementOrObj == 'object')
  {
    return obj;
  }
  else if(elementOrObj == 'element')
  {
    return el;
  }
  else if(elementOrObj == 'both')
  {
    return ([obj, el]);
  }
}

ZDBUtil.getText = function(el)
{
  if(el.textContent !== undefined)
  {
    return el.textContent;
  }
  else if(el.innerText !== undefined)
  {
    return el.innerText;
  }
  else
  {
    return el.innerHTML;
  }
}

ZDBUtil.tabselected = function(tab)
{
var parentTable = DOMUtils.getParentWithAttr(tab,"mainTable");
var classtoapply = tab.getAttribute("selectionclass");
parentTable.className = classtoapply;
}

ZDBUtil.timedLoop = function(loopMethod, loopMethodParams, interval, increment, timerObj)
{
  if(timerObj)
  {
    if(!timerObj.isAlive)
    {
      clearTimeout(timerObj.currentId);
      delete timerObj;
      return;
    }
    loopMethodParams.shift();
    timerObj.curStartIndex = parseInt(loopMethodParams.shift()) + 1;
    timerObj.curEndIndex = timerObj.curStartIndex + timerObj.increment;
    loopMethodParams.unshift(timerObj.curStartIndex, timerObj.curEndIndex);
    loopMethod.apply(this, loopMethodParams);
    if(timerObj.curEndIndex < timerObj.endIndex)
    {
      timerObj.currentId = ZDBUtil.setTimeout(ZDBUtil.timedLoop, this, [loopMethod, loopMethodParams, null, null, timerObj], timerObj.interval);
    }
    else
    {
      delete timerObj;
      return;
    }
  }
  
  var timerObj = {};
  timerObj.isAlive = true;
  timerObj.interVal = interval ? interval : 5;
  timerObj.increment = increment ? increment : 10;
  timerObj.startIndex = parseInt(loopMethodParams.shift());
  timerObj.endIndex = parseInt(loopMethodParams.shift());
  timerObj.curStartIndex = timerObj.startIndex;
  timerObj.curEndIndex = timerObj.startIndex + timerObj.increment;
  timerObj.loopMethod = loopMethod;
  loopMethodParams.unshift(timerObj.curStartIndex, timerObj.curEndIndex);
  loopMethod.apply(this, loopMethodParams);
  timerObj.currentId = ZDBUtil.setTimeout(ZDBUtil.timedLoop, this, [timerObj.loopMethod, loopMethodParams, null, null, timerObj], timerObj.interval);
  return timerObj;
}

ZDBUtil.getParam = function(prop,propVal,asAttribVal)
{
  if(asAttribVal)
  {
    return " " + prop + "='" + ZDBEscapeUtil.encodeForXML(propVal) +"'";
  }
  else
  {
    return "&" + prop + "=" + encodeURIComponent(propVal);
  }
}


ZDBUtil.isNewView = function(view)
{
  var objId = view.objId;
  if(view.isDummyView)
  {
    return false;
  }
  if(objId !== undefined)
  {
    objId = parseInt(objId, 10);
    if(isNaN(objId) == false && objId >= 0)
    {
      return false;
    }
  }
  return true;
}


ZDBUtil.isViewModified = function(view)
{
  if(view.isDummyView)
  {
    return false;
  }
  if(ZDBUtil.isNewView(view))
  {
    return true;
  }
  if(view.isModified && view.isModified instanceof Function)
  {
    return view.isModified();
  }
  return view.modified !== undefined && view.modified != 0; 
}

ZDBUtil.addHttp = function(value)
{
  if(value.indexOf("://") == -1) 	 
  { 	 
    // to avoid cvs http check
    value = "http"+"://"+ value; 	  // No I18N
  }
  return value;
}

ZDBUtil.openWindow = function(value,dataType)
{
  if(value !== undefined && value !== null && value !== '')
  {
    value = value.trim();
    if(dataType == "EMAIL")
    {
      window.open("mailto:" + value,"_self");
    }
    else if(dataType == "URL")  	 
    { 	 
      value = ZDBUtil.addHttp(value); 
      var child = window.open(value,"_blank"); 	 
    }
  }
}

ZDBUtil.getParamMapFromUrl = function(url)
{
  var qstIdx = url.indexOf("?");
  if(qstIdx < 0)
  {
    return {};
  }
  url = url.substring(qstIdx + 1, url.length);
  var paramsArray = url.split("&");
  var paramsMap = {};
  for(var count = 0; count < paramsArray.length; count ++)
  {
    var curParam = paramsArray[count];
    var eqIndex = curParam.indexOf("=");
    var keyName = curParam.substring(0, eqIndex);
    var keyValue = decodeURIComponent(curParam.substring(eqIndex + 1, curParam.length));
    var curParamValue = paramsMap[keyName]; 
    if( curParamValue === undefined)
    {
      paramsMap[keyName] = keyValue;
    }
    else if(curParamValue instanceof Array)
    {
      curParamValue[curParamValue.length] = keyValue;
    }
    else
    {
      paramsMap[keyName] = [curParamValue, keyValue];
    }
  }
  return paramsMap;
}

ZDBUtil.setElPos = function(el,props)
{
  var propValue = ['height','width','top','left'];
  for(var i = 0; i < props.length; i++)
  {
    if(props[i] != null)
    {
      el.style[propValue[i]] = parseInt(props[i])+"px";
    }
  }
}

  ZDBUtil.getUsersAsCommaSeparated = function(users)
  {
    if(users != "")
    {
      var usersArray = users.split(/(\r\n|\n|\r)/gm);
      users = ZDBUtil.remvomeBlankSpacesAndReturnAsString(usersArray);
    }
    return users;
  }
  
  ZDBUtil.getValidatedEmailsAsCommaSeparated = function(emailString)
  {
    if(emailString != "")
    {
      var emailArray = emailString.split(/(\r\n|\n|\r)/gm);
      emailString = ZDBUtil.validateEmailsAndReturnAsString(emailArray);
    }
    return emailString;
  }
  
  ZDBUtil.validateEmailsAndReturnAsString = function(emailArray)
  {
    var csValue = "";
    for(var i = 0; i < emailArray.length; i++)
    {
      var value = emailArray[i].trim();
      if(value != "")
      {
        
          if(!ZDBValidator.isEmail(value, false))	 
          {	 
                 throw {
                     name: "INVALID_EMAILID", //No I18N
                     message: ZDBI18NMap.g("zrpt.common.pricing.manageusr.js.invalid_email_ids")
                 }
          }
          
        if(csValue != "")
        {
          csValue += ",";
        }
        csValue += value;
      }
    }
    return csValue;
  }

  ZDBUtil.remvomeBlankSpacesAndReturnAsString = function(usersArray)
  {
    var csValue = "";
    for(var i = 0; i < usersArray.length; i++)
    {
      var value = usersArray[i].trim();
      if(value != "")
      {
        if(csValue != "")
        {
          csValue += ",";
        }
        csValue += value;
      }
    }
    return csValue;
  }

ZDBUtil.setValueInSelectBox = function(listEl,dataAttribute,dataToFind,ignoreDefault)
{
  var index = getDataIndex(listEl,dataAttribute,dataToFind,ignoreDefault);
  listEl[index].selected = true;
}

ZDBUtil.getSubString = function(str,allowedLength)
{
	var len = str.toString().length;
	if(len<=allowedLength){
		return str;
	}
	return str.substr(0,allowedLength)+"...";
}

ZDBUtil.containsAllValues = function(value,list)
{
  value = value.toUpperCase();
  for(var i = 0,len = list.length; i < len; i++)
  {
    var index = value.indexOf(list[i].toUpperCase());
    if(index == -1)
    {
      return false;
    }
  }
  return true;
}

ZDBUtil.containsAnyValue = function(value,list)
{
  value = value.toUpperCase();
  for(var i = 0,len = list.length; i < len; i++)
  {
    var index = value.indexOf(list[i].toUpperCase());
    if(index != -1)
    {
      return true;
    }
  }
  return false;
}

ZDBUtil.replaceValues = function(value,toList,withList)
{
  for(var i = 0, len = toList.length; i < len; i++)
  {
    value = value.replace(toList[i],withList[i]);
  }
  return value;
}

ZDBUtil.replaceAllValues = function(value,toList,withList)
{
  for(var i = 0, len = toList.length; i < len; i++)
  {
    value = ZDBUtil.replaceStr(value,toList[i],withList[i]);
  }
  return value;
}

ZDBUtil.removeSpace = function(val)
{
  return val.split(' ').join('');
}

ZDBUtil.calendarDateFormat = function(userDateFormat)
{
  var replaceToList = ["dd","MMMM","MMM","MM","yyyy","yy","mm","HH","hh","ss","a","EEEE","EEE","SSS"]; //No I18N
  var replaceWithList = ["%d","%B","%b","%m","%Y","%y","%M","%H","%I","%S","%p","%A","%a","%f"]; //No I18N
  var format = ZDBUtil.replaceValues(userDateFormat,replaceToList,replaceWithList);
  return format;
}

ZDBUtil.replaceAll = function(Source,stringToFind,stringToReplace)
     {
        var temp = Source;
        var index = temp.indexOf(stringToFind);
        while(index != -1)
        {
            temp = temp.replace(stringToFind,stringToReplace);
            index = temp.indexOf(stringToFind);
        }
        return temp;
    }

ZDBUtil.getValueFromLocal = function(key)
{
	try{
		if(window.localStorage!=null){// New Browsers
	        return window.localStorage.getItem(key);
	    }
	    return getCookie(key);// Older Browsers
	}
	catch(e){
		//For the following type of errors
		//NS_ERROR_FAILURE
		//NS_ERROR_FILE_NO_DEVICE_SPACE
		//NS_ERROR_MALFORMED_URI
		//NS_ERROR_NOT_AVAILABLE
		//NS_ERROR_STORAGE_IO
		//Above errors occur due to filesystem space insufficiency and corrupt file system.
		return null;
	}
}

ZDBUtil.setValueToLocal = function(key, val)
{
    try{
    	if(window.localStorage!=null){// New Browsers
    		 window.localStorage.setItem(key, val);
    	        return;
    	}
    	setCookie(key,val);// Older Browsers
    }
    catch(e){
    	//For the following type of errors
		//NS_ERROR_FAILURE
		//NS_ERROR_FILE_NO_DEVICE_SPACE
		//NS_ERROR_MALFORMED_URI
		//NS_ERROR_NOT_AVAILABLE
		//NS_ERROR_STORAGE_IO
		//Above errors occur due to filesystem space insufficiency and corrupt file system.
    	return;
    }
}

ZDBUtil.deleteValueFromLocal = function(key)
{
    try{
    	if(window.localStorage!=null){// New Browsers
            window.localStorage.removeItem(key);
            return;
        }
        deleteCookie(key);// Older Browsers
    }catch(e){
    	//For the following type of errors
		//NS_ERROR_FAILURE
		//NS_ERROR_FILE_NO_DEVICE_SPACE
		//NS_ERROR_MALFORMED_URI
		//NS_ERROR_NOT_AVAILABLE
		//NS_ERROR_STORAGE_IO
		//Above errors occur due to filesystem space insufficiency and corrupt file system.
    	return;
    }
}

ZDBUtil.getPreviousSiblingWithAttr = function(el,attributeName)
{
    var attrName = attributeName;
    var curEl = el;
	     while(curEl)
	     {
               if(curEl.getAttribute && (curEl.getAttribute(attrName) != null))
               {
                 return curEl;
               }
               curEl = curEl.previousSibling;
             }
             return null;
}

ZDBUtil.getDataTypeNo = function(dataType)
{
  var len = ZDBUtil.dataTypeNumVsSubtypeDisp.length;
  for(var i=0; i<len; i++)
  {
    if(ZDBUtil.dataTypeNumVsSubtypeDisp[i] == dataType)
    {
      return i;
    }
  }
}

  ZDBUtil.removeElsAttrWithVal = function(parentEl, attrName, attrVal, tagName)
    {
            if(parentEl==null){return}
            var nodes = parentEl.getElementsByTagName(tagName);
            for(var i=0, j = nodes.length; i < j; i++)
            {
                   var curEl = nodes[i];
                   var name = (curEl!=null)?curEl.getAttribute(attrName):null;
                   if(name != null && (""+curEl.getAttribute(attrName)).toUpperCase() == attrVal.toUpperCase())
                   {
                    curEl.parentElement.removeChild(curEl);
                    i--;
                    j--;
                   }
            }
    }
    
ZDBUtil.removeAllElsAttrWithVal = function (parentEl, attrName, attrVals, tagName)  // for Array of attrVals and one AttrName
{                                                                                  // ex: attrName as objId and varying attrVal
    if (parentEl == null) {
        return
    }
    var nodes = parentEl.getElementsByTagName(tagName);
    for (var i = 0; i < nodes.length; i++)
    {
        var curEl = nodes[i];
        var name = (curEl != null) ? curEl.getAttribute(attrName) : null;
        for (var j = 0; j < attrVals.length; j++) {
            if (name != null && ("" + curEl.getAttribute(attrName)).toUpperCase() == attrVals[j].toUpperCase())
            {
                curEl.parentElement.removeChild(curEl);
                i--;
            }
        }
    }
}

ZDBUtil.fadeOutAnimation = function(el,foldEl)
{
  ZDBUtil.addClass(el,"animationSet");
  el.style.animationName = (ZDBClientUI.ISCARDLAYOUT & !foldEl) ? "fadeOut-Scale" : "fadeOut-Left"; //No I18N
}
  
ZDBUtil.animateFavIcon = function(el,animationName,opt)
{
  var svgEl = el.querySelector("svg"); //No I18N
  svgEl.style.animationName = animationName;
  switch(opt)
  {
      case 0:
          svgEl.style.animationIterationCount = "";
          break;
      case 1:
          svgEl.style.animationIterationCount = "infinite"; //No I18N
          break;    
  }
}

ZDBUtil.hasScrollBar = function(el)
{
	var _this = jQuery(el);
	return _this.get(0).scrollHeight > _this.height();
}

ZDBUtil.isCursorBusyOnInputField = function(){
	var activeElement = document.activeElement;
	if(!activeElement)
		{
			return;
		}
	var focusElement = activeElement.tagName.toLowerCase();
	var isCursorBusy = (focusElement=='input' || focusElement == 'textarea');//NO I18N
	return isCursorBusy;
	}

ZDBUtil.setTooltipForMenuItems = function(ulEl, event)
{
	var tooltipTime = 0;
  var listEls = ulEl.children();
  listEls.hover(
	  function(event)
	  {
		  var el = jQuery(this);
		  var anchor = el.find('a')[0];
		  if(anchor.scrollWidth > anchor.clientWidth)
		  {
			  tooltipTime = setTimeout(
					  function()
					  {
						  ZDBToolTip.show(el, event);
					  },1000,el,event);
		  }
	  },
	  function(event)
	  {
		  clearTimeout(tooltipTime);
		  ZDBToolTip.hide(this,event);
	  }); //No I18N
}

ZDBUtil.highlightSave = function(view, designView)
{
		if(designView)
		{
			var el = jQuery(view).find("span[elname='ZRDesignSave']");
			if(!ZDBGlobal.ISNEWLAYOUT && el.hasClass("saveIcon"))
			{
				el.removeClass('saveIcon').addClass("highlightSave");//No I18N
			}
		}
		else
		{   var el = jQuery(view.toolbar.ZRSave);
            var saveClass = (ZDBGlobal.ISNEWLAYOUT) ? "saveWithTextMargin" : "highlightSave saveWithTextMargin";//No I18N
			el.removeClass("saveIcon marginRight").addClass(saveClass);
			var saveText = view.toolbar.ZRSaveText;
			var verticalLine = view.toolbar.separatorLine;
			if(saveText){
			saveText.style.display="";
			if(verticalLine){
				verticalLine.style.display="";
				}
			}
		}
}

ZDBUtil.removeHighlight = function(view, designView)
{
		if(designView)
		{
			var el = jQuery(view).find("span[elname='ZRDesignSave']");
			if(!ZDBGlobal.ISNEWLAYOUT && el.hasClass("highlightSave"))
			{
				el.removeClass('highlightSave').addClass("saveIcon");//No I18N
			}
		}
		else
		{
			var el = jQuery(view.toolbar.ZRSave);
			if(!ZDBGlobal.ISNEWLAYOUT && el.hasClass("highlightSave"))
			{
				el.removeClass("highlightSave").addClass("saveIcon");//No I18N
			}
			if(el.hasClass("saveWithTextMargin")){
				el.removeClass("saveWithTextMargin");
                if(!ZDBGlobal.ISNEWLAYOUT) {
                    el.addClass("marginRight");
                }
			}
			
			var saveText = view.toolbar.ZRSaveText;
			var verticalLine = view.toolbar.separatorLine;
			if(saveText)
				{
				saveText.style.display="none";
				if(verticalLine){
				verticalLine.style.display="none";
				}
				}
		}
		
}
//ignorei18n_start
ZDBUtil.addClass = function (el, className) {
    if (!el) {
        return;
    }
    var oldClassName = '';
    var useAttribute = typeof el.className !== 'string';
    if (useAttribute) {
        oldClassName = el.getAttribute('class');
    } else {
        oldClassName = el.className;
    }
    var cls = oldClassName.split(" ");
    if (cls.indexOf(className) === -1) {
        if(useAttribute) {
            el.setAttribute('class', oldClassName + (oldClassName === '' ? '' : ' ' + className));
        }
        else {
            el.className += ((oldClassName === "") ? "" : " ") + className;
        }
        
    }
};

ZDBUtil.removeClass = function (el, className) {
    if(el) {
        var oldClassName = '';
        var useAttribute = typeof el.className !== 'string';
        if (useAttribute) {
            oldClassName = el.getAttribute('class');
        } else {
            oldClassName = el.className;
        }
        if (!oldClassName) {
            return;
        }
        var cls = oldClassName.split(" ");
        var remCls = className.split(" ");
        var arr = new Array();
        for (var i = cls.length; i > 0; ) {
            if (remCls.indexOf(cls[--i]) === -1) {
                arr[arr.length] = cls[i];
            }
        }
        var newClass = arr.join(' ');
        if(useAttribute) {
            el.setAttribute('class', newClass);
        }
        else {
            el.className = newClass;
        }
    }
};
//ignorei18n_end
// ToggleClass is used to add or remove the class 
ZDBUtil.toggleClass = function(el, className) {
    ZDBUtil.hasClass(el,className) ? ZDBUtil.removeClass(el,className) : ZDBUtil.addClass(el,className);
}

// swapClass is used to swap between 2 classes
// Incase of there isnt either of the classes, It adds the frst class`
ZDBUtil.swapClass = function(el, className1, className2) {
    var cls = el.className.split(" ");
    var elHasClass1 = cls.indexOf(className1) > -1;
    var elHasClass2 = cls.indexOf(className2) > -1;
    if(!elHasClass1 && !elHasClass2) {
        ZDBUtil.addClass(el, className1);
        return;
    }
    var matchedClass = (elHasClass1) ? className1 : className2;
    var replaceClass = (elHasClass1) ? className2 : className1;
    var swapClass = ZDBUtil.replaceStr(el.className, matchedClass, replaceClass);
    el.className = swapClass;
}


ZDBUtil.hasClass = function(el,className){
    if(!el) {
        return;
    }
  var cls = el.className.split(" ");
  return (cls.indexOf(className) > -1)?true:false;
}

//classArray is an array of classes
//hasAnyOneClass() returns true even if one class from the classArray is present in element's classname
ZDBUtil.hasAnyOneClass = function(el,classArray) 
{
    var elClasses = el.className.split(" ");
    for(var i=0;i<classArray.length;i++)
    {
        if(elClasses.indexOf(classArray[i]) > -1)
            return true;
    }
    return false;
}

ZDBUtil.getInnerHTML = function(tl,isNotClassSelector)
{
	//tl object must have array of arrays affectedStylesGroups .i.e.[["zdbDataCell"],["zdbRowHead"]]
	//tl must also contain affectedStylesAndValues is array of objects .i.e.[{style:"color",group:1,value:"#e2e2e2"},{style:"background-color",group:2,value:"#abcdef"}]
    //tl must also contain variable mainClass it may be a class or other css selector such as div[gridId = 1]
	// isNotClassSelector must be true if the tl.mainClass variable
    //is some other css selectors other than class(e.g. id selector)
	//if tl.mainclass is PivotSheet and isNotClassSelector is false the string generated by this method will be
	//" .PivotSheet .zdbDataCell{color:#e2e2e2;} .PivotSheet .zdbRowHead{background-color:#abcdef;}"
	
	var css= [];
	var affectedStylesGroups = tl.affectedStyleGroups;
	
	for(var i=0;i<affectedStylesGroups.length;i++)
	{
	var group = affectedStylesGroups[i];
	var selectorString ="";
	for(var k=0;k<group.length;k++)
	{
	if(selectorString != "")
	{
		selectorString+=", "; // "," need to appended at end of each selector
	}
	selectorString += ZDBUtil.generateCssSelectorString(group[k],tl.mainClass,isNotClassSelector);
	}
	css.push(selectorString + " {");
	}

	var affectedStyles  = tl.affectedStylesAndValues;

	for(var i=0;i<affectedStyles.length;i++)
	{
	css[affectedStyles[i].group-1]+=affectedStyles[i].style+":"+affectedStyles[i].value+";"
	}
	
	css = css.map(function(cssString){return cssString+"} ";});
	
    var y = css.reduce(function sum(innerHTML,x){return innerHTML+x;});
    return y;
}

ZDBUtil.generateCssSelectorString = function(selector,prefixSelector,isNotClassSelector)
{
  // example : to get selector as .PivotSheet .zdbDatacell selector must be "zdbDataCell",prefixSelector must be "PivotSheet"
  // isNotClassSelector must be undefined or false because "PivotSheet" is a class.
  // to get prefixSelector is not a class no need of "." before that and so isNotClassSelector must be true
	var selectorString = "";
	if (isNotClassSelector) {
		selectorString += prefixSelector;
	} 
	else {
		selectorString += "." + prefixSelector;
	}

	if (selector != "") {
		selectorString += " ." + selector;
	}

	return selectorString;
}

ZDBUtil.returnStyleObject = function(styleName,group,value)
{    // this mehod will retun an object with input variables as the variables of object
	var x = new Object();
	x.style = styleName;
	x.group = parseInt(group);
	x.value = value;
	return x;
}
ZDBUtil.getStyleSheet = function(gridEl, gridId, isForTheme){
	var styleSheetId ;
	if(isForTheme)    //isForTheme will be false for fontsize and undefined for gridstyle
		{		
	styleSheetId= "ThemeStyleSheet" + gridId; //No I18N
		}
	else if(isForTheme == undefined)
		{
	styleSheetId= "DynGridStylesheet" + gridId; //No I18N
		}
	else
		{
	styleSheetId= "FontSize" + gridId; //No I18N
		}
	var styleSheet = gridEl.getElementsByTagName("style");
	for(var i=0;i<styleSheet.length;i++)
	{
	if(styleSheet[i].id == styleSheetId)
		{
		return styleSheet[i];
		}
	}
	var style = document.createElement('style');
	style.type = "text/css";
	style.id = styleSheetId;
	gridEl.appendChild(style);
	return style;
}

ZDBUtil.iterativeFind = function(parEl, selector, attr, selectorVal, tag)
{
    var matchedResults = [];
        for(var i = 0; i < parEl.length; i++) {
            var el = ZDBUtil.find(parEl[i], selector, attr, selectorVal, tag);
            matchedResults = matchedResults.concat(el);
        }
    return matchedResults;
}

ZDBUtil.find = function(parEl, selector, attr, selectorVal, tag)
{
    var elLists;
    switch(selector) {
        case "class":  //No I18N
        {
            elLists = parEl.getElementsByClassName(selectorVal);
            elLists = Array.prototype.slice.call(elLists);
            break;
        }
        case "tag":  //No I18N
        {
            elLists = parEl.getElementsByTagName(tag);
             elLists = Array.prototype.slice.call(elLists);
            break;
        }
        case "attr": //No I18N
        {
            elLists = ZDBUtil.getElsWithAttrName(parEl, attr);
            break;
        }
        case "attrAndVal": //No I18N
        {
            elLists = ZDBUtil.getElsWithTagNAttrWithVal(parEl, attr, selectorVal, tag);
        }
    }
    return elLists;
}
ZDBUtil.show = function(el) {
    if(!el) {
        return;
    }
    el.style.display = "block";
}
ZDBUtil.hide = function(el) {
    if(!el) {
        return;
    }
    el.style.display = "none";
}

ZDBUtil.nextMatchedSibling = function(el, className) {
    var matchEl = false;
    while (el && !matchEl) {
        var el = el.nextSibling;
        matchEl = ZDBUtil.hasClass(el, className);
    }
    return el;
}
ZDBUtil.isVisible = function(el) {
    //if( IE 9 or in cases where position is fixed ) 
    {
        var style = window.getComputedStyle(el);
        return (style.display === 'none');
    }
//    else 
    {
        return (el.offsetParent === null);
    }
    
}

ZDBUtil.nodeCollectionToArray = function(nodeCollection){
  var filter = Array.prototype.filter;
  var result = nodeCollection;
  result = filter.call(nodeCollection,function(node)
  {
    return true;
  }    
  )
  return result;
}

ZDBUtil.removeChildrenWithClass = function(parent, className){
  parent = (parent instanceof HTMLElement)? parent : document.getElementById(parent);
  var children = parent.querySelectorAll("."+className);
  var childrenArray = ZDBUtil.nodeCollectionToArray(children);
  childrenArray.forEach(function(el){
    parent.removeChild(el);
  })
}

ZDBUtil.combineValues = function(temp, object1)
{
    for(var val in object1)
        {
            if (typeof object1[val] === 'object' && !(object1[val] instanceof Array))
            {
                if (typeof temp[val] !== 'object')
                {
                    temp[val] = {};
                }
                ZDBUtil.combineValues(temp[val], object1[val]);
            } 
            else if(typeof object1[val] === 'object' && object1[val] instanceof Array){
                var newArray = [];
                for(var i=0,len=object1[val].length; i<len; i++){
                    var arrVal = object1[val][i];
                    if (typeof arrVal === 'object' && !(arrVal instanceof Array)){
                        //Cloning Object inside array
                        var tempObj = {};
                        ZDBUtil.combineValues(tempObj, arrVal)
                        newArray.push(tempObj);
                    }
                    else if (typeof arrVal === 'object' && arrVal instanceof Array){
                        newArray.push(arrVal.slice(0));
                    }
                    else{
                        newArray.push(arrVal);
                    }
                }
                temp[val] = newArray;
            }
            else if(object1.hasOwnProperty(val))
            {
                temp[val] = object1[val];
            }
        }  
}

ZDBUtil.mergeObjects = function(object1, object2)
{
    var temp = {};
    ZDBUtil.combineValues(temp, object1);
    ZDBUtil.combineValues(temp, object2);
    return temp;
}

ZDBUtil.duplicateObject = function(object){
    return ZDBUtil.mergeObjects({}, object);
}

ZDBUtil.removeAndInsertJsObj = function(gridObj)
{ // this method just removes the grid from DOM and re-inserts it. safari computes table layout fixed only after that
	var gArea = gridObj.gArea;
    var nextChildren=gridObj.gArea.nextElementSibling;
    var parent = gArea.parentNode;
    gArea.parentNode.removeChild(gArea);
	  if(nextChildren)
		  {
		  nextChildren.parentNode.insertBefore(gArea,nextChildren);
		  }
	  else
		  {
		  parent.appendChild(gArea);		  
		  }
}
