//$Id$
var ZDBTabSwitchHandler = new function()
{
    this.Q = new Object();

    this.isRelevendTab2Exec = function(tabView,func)
    {
        if(tabView.viewCtx.isZia || ZDBClientUI.selectedTab && ((tabView == ZDBClientUI.selectedTab.view) || ZDBClientUI.selectedTab.view.iPhoneDashTab))
        {
            return true;
        }
        ZDBTabSwitchHandler.add2UnexecutedQ(tabView,func);
        return false;
    }

    this.add2UnexecutedQ = function(tabView,func)
    {
    	var objId = tabView.objId;
    	if(tabView.type == "Dashboard" && tabView._$type != undefined){
    		objId = tabView._$type+"_"+tabView.objId;
    	}
        var qName = "FUNC"+objId;//No I18N
        if(ZDBTabSwitchHandler.Q[qName]!=null)
            {
                ZDBTabSwitchHandler.Q[qName].push(func);
                return;
            }
        ZDBTabSwitchHandler.Q[qName] = new Array();
        ZDBTabSwitchHandler.Q[qName].push(func);
    }
    
    this.executeMatchedFuncsInQ = function(tabView)
    {
        if(tabView==null){return;}
        var objId = tabView.objId;
    	if(tabView.type == "Dashboard" && tabView._$type != undefined){
    		objId = tabView._$type+"_"+tabView.objId;
    	}
         var qName = "FUNC"+objId;//No I18N
        if(ZDBTabSwitchHandler.Q[qName]==null){return;}
        var functionQ = ZDBTabSwitchHandler.Q[qName];
        var len = functionQ.length;
        for(var i=0; i<len; i++)
	{
		functionQ[0]();
		functionQ.shift();
	}
    }

    this.deleteViewInQ = function(tabView)
    {
    	var objId = tabView.objId;
    	if(tabView.type == "Dashboard" && tabView._$type != undefined){
    		objId = tabView._$type+"_"+tabView.objId;
    	}
        var qName = "FUNC"+objId;//No I18N
        if(ZDBTabSwitchHandler.Q[qName]!=null)
            {
                delete ZDBTabSwitchHandler.Q[qName];
                return;
            }
    }

    // on closing the tab remove the wms data in the view present
    this.clearWMSQueue = function(tabView)
    {
        var type = tabView.type;
        if(type === "AnalysisView")
        {
            ZALazyLoadData.deleteWMSQueueInView(tabView);
        }
        else if(type === "Dashboard")
        {
            var dashboardViews = ZDBDashboardAPI.viewsInDashboard(tabView);
            var count = dashboardViews.length;
            for(var i=0; i<count; i++)
            {
                if(dashboardViews[i].ctx && dashboardViews[i].ctx.view)
                {
                    var view = dashboardViews[i].ctx.view;
                    if(view.type === "AnalysisView")
                    {
                        ZALazyLoadData.deleteWMSQueueInView(view);
                    }
                }
            }
        }
    };
}