//$Id$
var ZASliderComp = new function()
{
     this.sliderRangesForGridView = function(sliderBounds,view)
    {
        view.sliderBounds = sliderBounds;
        ZASliderComp.setSliderRanges(view);
    }

    //Edit Mode
    this.setTabforDlg = function(hideTab2,dlg)
    {
        var tabSelection = $("ZDBVMFilterTabFrame");
        
        ZDBUtil.setNamedChildEls(tabSelection,tabSelection);
         var dlgTitleEl = null;
            if(dlg!=null)
            {
                dlgTitleEl = DOMUtils.getFirstMatchingChild(dlg,"span","elname","dlgTitle");//NO I18N
            }
        if(hideTab2)
        {

           tabSelection.step2Tab.className = "sharedTab2 alpha";
           tabSelection.step2Tab.disabled = true;
        }
        else
        {
            tabSelection.step2Tab.className = "sharedTab2";
            tabSelection.step2Tab.disabled = false;
        }
        if(dlgTitleEl!=null)
        {
            dlgTitleEl.innerHTML =ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.steps");
        }
    }

//    this.updateOperation = function(el,value)
//    {
//        var view = ZDBClientUI.getViewObj(el,"view"); //NO I18N
//        view.tempVMFilterField.setAttribute("OPERATION",value);
//    }

    //View Mode

    this.setSliderPos = function(el,event)
    {
        if(ZDBAnalysisSlider.setSliderPos(el,event))
        {
            this.applySliderCr(event,el);
              
        }
      
    }

    this.setDlayToAplySldrCr = function(event)
    {
        ZDBUtil.detachEvent(document, (ZDBGlobal.IS_MOBILE) ? 'touchend' : 'mouseup',
                                            ZASliderComp.setDlayToAplySldrCr, true);
        setTimeout("ZASliderComp.applySliderCr()", 500);
    }

    this.applySliderCr = function(event,el)
    {
        var slider = ZDBAnalysisSlider.slider;
        ZDBUtil.setNamedChildEls(slider,slider);
        var srcEl = ZDBAnalysisSlider.elToMove;//ZDBUtil.getSourceElement(event);
        var view = ZDBClientUI.getViewObj(slider,"view"); //NO I18N
        view.changeSliderBoundaries = false;
        var minValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "minValue")[0];  //No I18N
        var maxValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "maxValue")[0];  //No I18N
        var minVal = minValueEl.getAttribute("origVal");
        var maxVal = maxValueEl.getAttribute("origVal");
        var changedElName = srcEl.getAttribute("elname");
        var changedVal= (changedElName=="minRange"||changedElName=="minValue")?minVal:maxVal;  //No I18N
        var component = DOMUtils.getSelfOrParentWithAttr(slider, "COLUMN_ID");//NO I18N
        var jsonObj = {};
        jsonObj["columnName"] = component.getAttribute("LABEL");//No I18N
        jsonObj["value"] = changedVal;
        jsonObj["range"] = changedElName;
        view.changedCol = JSON.stringify(jsonObj);
        ZDBUtil.setNamedChildEls(component,component);
        var compElCont = component.compElContainer;
        var cr = 'B '+ minVal +':'+ maxVal +",";
        var dcr = ZDBI18NMap.f("zrpt.VMFilters.dlg.js.compRange",minValueEl.value, maxValueEl.value);//minValueEl.value + ' to '+maxValueEl.value +",";        
        if(cr!=null)
        {
            compElCont.setAttribute("selVal",cr);
            compElCont.setAttribute("dispSelVal",dcr);
            compElCont.setAttribute("displayVal",dcr);
        }
        component.setAttribute("EXCLUDE","false");
        view.lastAppliedEl = component;
        ZAVMFilter.refreshView(component,view);
        ZAVMFilter.showHideResetBtn(view, false);
        component.setAttribute("canReset","true");
        if(ZDBGlobal.IS_MOBILE) ZAVMFilter.showHideCompResetBtn(component,true);
        jQuery(component).addClass("compFilterApplied");
    }

    this.resetSliderPositions =function(slider,comp)
    {
        ZDBUtil.setNamedChildEls(slider,slider);
          var minValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "minValue")[0];  //No I18N
        var maxValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "maxValue")[0];  //No I18N
        var minVal = comp.getAttribute("MINVAL");
        var maxVal = comp.getAttribute("MAXVAL");
        var minDispVal = comp.getAttribute("MINDISPVAL");
        var maxDispVal = comp.getAttribute("MAXDISPVAL");
        slider.defaultMin = minVal;
        slider.defaultMax = maxVal;
        minValueEl.style.width = ZASliderComp.calcWidth(minDispVal)+"px";
        minValueEl.blur();
        minValueEl.value = minDispVal;
        minValueEl.setAttribute("value",minDispVal);
        minValueEl.setAttribute("origVal",minVal);
        maxValueEl.style.width = ZASliderComp.calcWidth(maxDispVal)+"px";
        maxValueEl.blur();
        maxValueEl.value = maxDispVal;
        maxValueEl.setAttribute("value",maxDispVal);
        maxValueEl.setAttribute("origVal",maxVal);
        ZDBAnalysisSlider.setSliderPos(minValueEl);
        ZDBAnalysisSlider.setSliderPos(maxValueEl);
    }

    this.setSliderRanges = function(view)
    {
    	var vmFiltersHolderEls = view.VMFiltersHolder.childNodes;
    	var vmfArea = view.VMFilterArea;
        var vmfDisplay = vmfArea.style.display;
        if(vmfArea)
        {
          vmfArea.style.display = "";
        }
        var len = vmFiltersHolderEls.length;
        if(!view.changeSliderBoundaries && !view.editMode)
        {
            var jsonObj = JSON.parse(view.changedCol);
            var columnName = jsonObj["columnName"];
            var range = jsonObj["range"];
            var parentId = (view.type=="Dashboard")?view.dbId.toString():view.parentViewId.toString();
            var prefixId = (view.objId<0)?parentId:view.objId.toString();
            var dispVal = view.sliderBounds[prefixId+"_"+columnName];
            var comp = DOMUtils.getChildElsWithAttr(view.VMFiltersHolder, "LABEL", columnName)[0];
            var slider = DOMUtils.getChildElsWithAttr(comp, "slider", "true")[0];  //No I18N
            var minValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "minValue")[0];  //No I18N
            var maxValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "maxValue")[0];  //No I18N                
            var el =(range=="minRange" || range=="minValue")?minValueEl:maxValueEl;//No I18N
            if(view.type=="Dashboard" && comp.boundsExtended==true)
            {
                (range=="minRange" || range=="minValue") ? comp.setAttribute("MINDISPVAL",dispVal): comp.setAttribute("MAXDISPVAL",dispVal); //NO I18N
            }
            if(!el.isfocused)
            {
                el.style.width = ZASliderComp.calcWidth(dispVal)+"px";
                el.value= dispVal;
                el.setAttribute("value",dispVal);
            }
            var dcr = ZDBI18NMap.f("zrpt.VMFilters.dlg.js.compRange",minValueEl.value, maxValueEl.value);//minValueEl.value + ' to '+maxValueEl.value +",";
            comp.compElContainer.setAttribute("dispSelVal",dcr);
            comp.compElContainer.setAttribute("displayVal",dcr);
        }
        else
        {
            for(var i=0; i<len; i++)
            {
                var child = vmFiltersHolderEls[i];
                if((child.getAttribute) && (child.getAttribute("column_id") != null) && child.getAttribute("UITYPE")=="6")
                {
                    var slider = DOMUtils.getChildElsWithAttr(child, "slider", "true")[0];  //No I18N
                    var minMaxVals = null;
                    minMaxVals = this.getMinMaxVals(child,slider,view);
                    if(!minMaxVals)
                    {
                      continue;
                    }
                    var minVal = minMaxVals["minVal"];
                    var maxVal = minMaxVals["maxVal"];
                    var minDispVal = minMaxVals["prevMinDispVal"];
                    var maxDispVal = minMaxVals["prevMaxDispVal"];
                    var minOrigVal = minMaxVals["prevMinVal"];
                    var maxOrigVal = minMaxVals["prevMaxVal"];
                    slider.defaultMin = minVal;
                    slider.defaultMax = maxVal;
                    slider.setAttribute("MINVAL",minVal);
                    slider.setAttribute("MAXVAL",maxVal);
                    var minValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "minValue")[0];  //No I18N
                    var maxValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "maxValue")[0];  //No I18N
                    minValueEl.style.width = ZASliderComp.calcWidth(minDispVal)+"px";
                    minValueEl.value= minDispVal
                    minValueEl.setAttribute("value",minDispVal);
                    minValueEl.setAttribute("origVal",minOrigVal);
                    maxValueEl.style.width = ZASliderComp.calcWidth(maxDispVal)+"px";
                    maxValueEl.value = maxDispVal;
                    maxValueEl.setAttribute("value",maxDispVal);
                    maxValueEl.setAttribute("origVal",maxOrigVal);
                    slider.initialized=false;
                    ZDBAnalysisSlider.setSliderPos(minValueEl);
                    ZDBAnalysisSlider.setSliderPos(maxValueEl);
                }
            }
        }
           if(vmfArea)
          {
            vmfArea.style.display = vmfDisplay;
          }
    }

    this.calcWidth = function(text)
    {
        if(text==null){return;}
        var tempSpan = $("tempSpan");
        tempSpan.innerHTML = text.toString().trim();
        var parent = tempSpan.parentNode;
        var display = (tempSpan.style.display!="none")?"":"none";//No I18N
        tempSpan.style.visibility = "hidden";
        tempSpan.style.display = "";
        document.body.appendChild(tempSpan);
        var width = tempSpan.offsetWidth;
        parent.appendChild(tempSpan);
        tempSpan.style.visibility = "visible";
        tempSpan.style.display = display;
        return (width>55)?55:width;
    }

    this.getMinMaxVals = function(child,slider,view)
    {
        var minMaxVals = null;
        minMaxVals= this.getMinMaxValsForView(child,view);
        if(!minMaxVals)
        {
        	return minMaxVals;
        }
        var minVal = minMaxVals[0];
        var minDispVal = minMaxVals[1];
        var maxVal = minMaxVals[2];
        var maxDispVal =minMaxVals[3];
        ZDBUtil.setNamedChildEls(slider,slider);
        var minValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "minValue")[0];  //No I18N
        var maxValueEl = DOMUtils.getChildElsWithAttr(slider, "elname", "maxValue")[0];  //No I18N
        child.setAttribute("MINVAL",minVal);
        child.setAttribute("MAXVAL",maxVal);
        child.setAttribute("MINDISPVAL",minDispVal);
        child.setAttribute("MAXDISPVAL",maxDispVal);
        var els = DOMUtils.getChildElsWithAttr(child, "elname", "compElContainer"); //NO I18N
        var compElCont = els[0];
        var cr = compElCont.getAttribute("selVal");
        var prevMinVal = minVal;
        var prevMaxVal = maxVal;
        var prevMinDispVal = minDispVal;
        var prevMaxDispVal = maxDispVal;
        if(cr&&cr!=null)
        {
            var prevMinDispVal = minValueEl.value;
            var prevMaxDispVal = maxValueEl.value;
            var prevMinVal = minValueEl.getAttribute("origVal");
            var prevMaxVal = maxValueEl.getAttribute("origVal");
            if(parseFloat(prevMinVal)<parseFloat(minVal))
            {
                minVal=prevMinVal;
                minDispVal = prevMinDispVal;
            }
            if(parseFloat(prevMaxVal)>parseFloat(maxVal))
            {
                maxVal=prevMaxVal;
                maxDispVal = prevMaxDispVal;
            }
        }
        var list = {minVal:minVal,
                    maxVal:maxVal,
                    minDispVal:minDispVal,
                    maxDispVal:maxDispVal,
                    prevMinVal:prevMinVal,
                    prevMaxVal:prevMaxVal,
                    prevMinDispVal:prevMinDispVal,
                    prevMaxDispVal:prevMaxDispVal
                    };
        return list;
    }

    this.getMinMaxValsForView= function(child,view)
    {
        var label = child.getAttribute("label");
        var prefixId = (view.objId<0)?view.parentViewId.toString():view.objId.toString();
        return view.sliderBounds[prefixId+"_"+label];
    }
}
