//$Id$
var ZAVMFilterComp = new function()
{
    this.setSelectedRange= function(critDiv,fromDtel,toDtel)
    {
        var fromVal = (fromDtel.getAttribute("inputVal")=="From")?"":fromDtel.value;//NO I18N
        var toVal = (toDtel.getAttribute("inputVal")=="To")?"":toDtel.value;//NO I18N
        var fromDate = (fromVal!="")?fromDtel.value:critDiv.getAttribute("MINDATE");
        var toDate =(toVal!="")? toDtel.value:critDiv.getAttribute("MAXDATE");
        fromDate=(fromDate=="null" || fromDate == null)?toDate:fromDate; //NO I18N
        toDate = (toDate=="null" || toDate == null)?fromDate:toDate;//NO I18N
        var cr =  ('B ' + fromDate.trim() + '-' + toDate.trim()+','); //NO I18N
        var dcr = ZDBI18NMap.f("zrpt.VMFilters.dlg.js.compRange",fromDate, toDate);//fromDate + ' to ' + toDate; //NO I18N
        var valueStr = fromVal + " - " + toVal;
        if(fromVal != "" && toVal == "")
        {
        	valueStr = ZDBI18NMap.g("zrpt.VMFilters.dlg.js.fromdate") + " " + fromVal;
        }
        else if(fromVal == "" && toVal != "")
        {
        	valueStr = ZDBI18NMap.g("zrpt.VMFilters.dlg.js.tilldate") + " " + toVal;
        }
        critDiv.displayAppliedFilter.setAttribute("value",valueStr);
        critDiv.displayAppliedFilter.setAttribute("data-tip",valueStr);
        critDiv.displayAppliedFilter.innerHTML = valueStr;
        if(cr!=null)
        {
            critDiv.compElContainer.setAttribute("selVal",cr);
            critDiv.compElContainer.setAttribute("dispSelVal",dcr);
        }
    }

    this.validateNRefresh = function(el, event)
    {
        var component = DOMUtils.getSelfOrParentWithAttr(el, "COLUMN_ID");//NO I18N
        if(!component)
        {
        	var menuEl = DOMUtils.getSelfOrParentWithAttrValue(el,"elname","dateMenuEl");//No I18N
            component = menuEl.component;
        }
        var view = ZDBClientUI.getViewObj(el,"view"); //NO I18N
        component.elnameSet = false;
        ZDBUtil.setNamedChildEls(component,component);//NO I18N
        ZDBUtil.setNamedChildEls(component.dateMenuEl,component.dateMenuEl);//NO I18N
        if(ZAVMFilterComp.isValidDateRange(component,component.dateMenuEl.fromValue,component.dateMenuEl.toValue))
        {
            ZAVMFilterComp.setSelectedRange(component,component.dateMenuEl.fromValue,component.dateMenuEl.toValue);
            ZAVMFilter.refreshView(component);
            ZAVMFilter.hideDateRangeMenuEl(event, true);
            ZAVMFilter.showHideResetBtn(view, false);
            component.setAttribute("canReset","true");
            if(ZDBGlobal.IS_MOBILE) ZAVMFilter.showHideCompResetBtn(component,true);
            jQuery(component).addClass("compFilterApplied");
        }
    }

    this.isValidDateRange = function(component,fromDtel,toDtel)
    {
        var fromVal = (fromDtel.getAttribute("inputVal")=="From")?"":fromDtel.value;//NO I18N
        var toVal = (toDtel.getAttribute("inputVal")=="To")?"":toDtel.value;//NO I18N
         var includeTime = component.getAttribute("INCLUDETIME")=="true";
        if(fromVal!="")
        {
            fromVal = ZDBValidator.ValUserFltrDtFormat(fromDtel,includeTime);
            if(fromVal=="false")
            {
                return false;
            }
           fromDtel.value= fromVal;
        }
        if(toVal!="")
        {
             toVal = ZDBValidator.ValUserFltrDtFormat(toDtel,includeTime);
            if(toVal=="false")
            {
                return false;
            }
           toDtel.value= toVal;
        }
        if(fromVal == "" && toVal == "")
    	{
        	var menuEl = (component.dateMenuEl) ? component.dateMenuEl : component.timeLineMenuEl;
        	menuEl.VMFilterGoBtn.setAttribute("disabled", true);
        	menuEl.VMFilterGoBtn.className = "glossyButton alpha";
            ZAVMFilterComp.showDateString(component.toValue);
            ZAVMFilterComp.showDateString(component.fromValue);
            var compElContainer = component.compElContainer;
            if(compElContainer.getAttribute("selVal"))
        	{
            	if(component.getAttribute("istimelinecomp") == "true")
            	{
            		ZRTimelineFilter.resetTimeLineComp(component);
            	}
            	else
            	{
            		ZAVMFilterComp.resetComp(component);
            	}
            	ZAVMFilter.refreshView(component);
        	}
            return false;
    	}
//        if(fromVal=="" || toVal=="")
//        {
//            showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.invalidDate"), component.fromValue);
//            return false;
//        }
        var fromDt="";
        var toDt="";
        var isAllVal = component.getAttribute("ISALLVAL");

        if(isAllVal=="true")
        {
            fromDt = (fromVal=="")?"01 Jan 1000":fromVal;//No I18N
            toDt = (toVal=="")?"30 Dec 3000":toVal;//No I18N
        }
        else
        {
            var dates =  ZAVMFilter.getDateRange(component);
            fromDt = (fromVal=="")?dates[0]:fromVal;
            component.setAttribute("MINDATE",fromDt);
            toDt = (toVal=="")?dates[1]:toVal;
            component.setAttribute("MAXDATE",toDt);
        }
        if((new Date(fromDt) > new Date(toDt)))
        {
            showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.FromDtLarge"), fromDtel); // need I18N
            return false;
        }
        if(isAllVal!="true" && !this.isDateInRange(component, fromVal, toVal))
        {
            return false;
        }
        hideCustomMessage();
        return true;
    }

    this.isDateInRange = function(component,fromDate,toDate)
    {
        var dates = ZAVMFilter.getDateRange(component);
        var LtdFromDate = new Date(dates[0]);
        var LtdToDate = new Date(dates[1]);
        var fromInRng = (LtdFromDate > new Date(fromDate)) ? false : true ;
        var toInRng =  (LtdToDate < new Date(toDate)) ? false : true ;
        if(!fromInRng || !toInRng)
        {
            var custMsgPos = (!fromInRng)? component.fromValue :  component.toValue;
            showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.notInRange"), custMsgPos); // need I18N
            return false;
        }
        return true;
    }

    this.initCalender = function(inputEl,showTime,range, excludeScroll)
    {
        var fromDate = range && range[0] ? range[0] : 1000;
        var toDate = range && range[1] ? range[1] : 9999;
        var format = (showTime)? "%d %b %Y %H:%M:%S": "%d %b %Y ";//NO I18N
        if(inputEl.initialized)
        {
          return;
        }        
        Calendar.setup(
        {
            inputField     :    inputEl,      // id of the input field
            ifFormat       :    format,       // format of the input field //NO I18N
            showsTime      :    showTime,            // will display a time selector
            button         :    inputEl,   // trigger for the calendar (button ID)
            singleClick    :    true,           // double-click mode
            weekNumbers    :   	false,
            range          :    [fromDate,toDate],
            step           :    1,                // show all years in drop-down boxes (instead of every other year as default)
            onClose        :    function(){
                this.hide();this.destroy();
            }
        }
        ); //NO I18N
        inputEl.initialized = true;
        if(excludeScroll)
        {
        	inputEl.addEventListener("click", function(){
        		setTimeout(function(){
                    if(window.calendar && (inputEl == window.calendar.params.inputField))
                    {
            			var el = window.calendar.element;
            			var bndCliRect = inputEl.getBoundingClientRect();
                        el.style.top = bndCliRect.bottom +"px";
                    }
                }, 11);
        	});
        	
        }
    }
    
    this.hideDateString = function(el,event)
    {
        hideCustomMessage();
        ZAVMFilterUtil.closeList(event, true);
        
        var menuEl = DOMUtils.getSelfOrParentWithAttrValue(el,"elname","dateMenuEl");//No I18N
        var component = menuEl.component;
        el.component = component;
        component.drBtnSet = false;
        ZDBUtil.setNamedChildEls(menuEl,menuEl,"drBtn");//NO I18N
        menuEl.VMFilterGoBtn.removeAttribute("disabled");
        menuEl.VMFilterGoBtn.className = "glossyButton";   
        var compType = component.getAttribute("COMPTYPE");
        var isAllVal = component.getAttribute("ISALLVAL");
        var fetchStutas = component.getAttribute("VMFilterFetchStatus");
        var range = new Array(2);
        if(isAllVal =="true" && fetchStutas<=0)
        {
            ZAVMFilter.fetchVMFilterCriteria(el, component.getAttribute("LABEL"), event, "false");
        }
        if(isAllVal!="true")
        {
            var dates = ZAVMFilter.getDateRange(component);
            range[0] = new Date(dates[0]).getFullYear();
            range[1] = new Date(dates[1]).getFullYear();   
            el.value = el.getAttribute("elname")=="fromValue" ? dates[0] : dates[1];
        }
        var showTime = (component.getAttribute("INCLUDETIME")=="true")?true:false;		
        ZAVMFilterComp.initCalender(el,showTime,range);
        if(el.getAttribute("inputVal") != "From" && el.getAttribute("inputVal") != "To" )		
        {		
            return;		
        }		
        if(el.getAttribute("tipShown") == "true")		
        {			
            el.setAttribute("inputVal","");		
            el.setAttribute("tipShown","false");
        }
    }

    this.showDateString = function(el)
    {
        if((el.value == "" || el.value == "From" || el.value == "To") && (el.getAttribute("tipShown") == "false"))
        {
            var dateType = el.getAttribute("elname");
            el.value= (dateType == "fromValue")?ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.from") : ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.to"); //NO I18N

            var inputVal = (dateType == "fromValue")?"From":"To"; //NO I18N
            el.setAttribute("inputVal",inputVal);
            el.setAttribute("tipShown","true");
            var menuEl = DOMUtils.getSelfOrParentWithAttrValue(el,"elname","dateMenuEl");//No I18N
        	var component = menuEl.component;
            component.elnameSet = false;
            ZDBUtil.setNamedChildEls(component,component);//NO I18N
            if(component.fromValue.getAttribute("inputVal")!="From" && component.toValue.getAttribute("inputVal")!="To")
            {
                component.dateMenuEl.VMFilterGoBtn.setAttribute("disabled","true");
                component.dateMenuEl.VMFilterGoBtn.className = "glossyButton alpha";
            }
        }

    }

    //single select related
    this.singleSelect = function(ev)
    {
        var srcEl = ZDBUtil.getSourceElement(ev);
        if(!srcEl.getAttribute("filteredvalue")){return;}
        var el = DOMUtils.getSelfOrParentWithAttrValue(srcEl, "optionList","true"); //NO I18N
        var component =el.component;
        ZAVMFilterComp.singleSelectChange(el,srcEl,ev);
        ZAVMFilterUtil.closeList(ev, true);
        var view = ZDBClientUI.getViewObj(component,"view"); //NO I18N
        view.changeSliderBoundaries = true;
         view.lastAppliedEl = component;
        ZAVMFilter.refreshView(component);
        ZAVMFilter.showHideResetBtn(view, false);
        component.setAttribute("canReset","true");
        if(ZDBGlobal.IS_MOBILE) ZAVMFilter.showHideCompResetBtn(component,true);
        jQuery(component).addClass("compFilterApplied");
        ZMstopEventBubble(ev);
    }

    this.singleSelectChange = function(optionList,srcEl)
    {
        ZAVMFilterComp.handleSingleSelectTick(optionList,srcEl);
        var component = optionList.component;
        srcEl.setAttribute("filtered","true");
        var optionHead= component.compElContainer;
        var criteria = component.getAttribute("CRITERIA");
        var dispCriteria = component.getAttribute("DISPLAYCRITERIA");
        var dispVal = srcEl.getAttribute("displayValue");
        var selVal = srcEl.getAttribute("filteredValue");
        var dispSelVal = srcEl.getAttribute("filterDispValue");
        var index = criteria.indexOf(ZAVMFilter.OTHERS_CR_KEY);
        var includeOthers = (index!=-1);
        var exclude =(includeOthers && selVal==ZAVMFilter.OTHERS_CR_KEY+",")?"true":"false"; //NO I18N
        var srcElName = srcEl.getAttribute("elname");
        var isValNotInDataList = srcEl.getAttribute("valNotInDataList");
        component.setAttribute("EXCLUDE",exclude);
        optionHead.setAttribute("EXCLUDE",exclude);
        if(selVal=="All"&&component.getAttribute("ISALLVAL")!="true" && !includeOthers)
        {
            selVal = criteria;
            dispSelVal = dispCriteria;
        }
        else if(includeOthers && selVal==ZAVMFilter.OTHERS_CR_KEY+",")
        {
            selVal =criteria.replace(ZAVMFilter.OTHERS_CR_KEY+",","");//substring(0,index);
            dispSelVal = dispCriteria.replace(dispVal+",","");
        }
        var isVarPatternData = false;
        if(dispVal.indexOf(ZAVMFilter.START_VAR_PATTERN)==0 &&
            dispVal.indexOf(ZAVMFilter.END_VAR_PATTERN) == dispVal.length-1) {isVarPatternData=true;}
        if(!isValNotInDataList)
        {
        	dispVal = (dispVal.indexOf(",")>=0 || isVarPatternData) ? "\""+dispVal+"\"" :dispVal;
        }
        optionHead.setAttribute("selVal",selVal);
        optionHead.setAttribute("dispSelVal",dispSelVal);
        optionHead.setAttribute("displayVal",dispVal);
        var elements = DOMUtils.getChildElsWithAttr(optionHead, "elname", "displaySelected"); //NO I18N
        var element = elements[0];
        element.innerHTML =  ZDBEscapeUtil.encodeForHtml(dispVal);
        if(srcElName=="selAllLi")
        	{
        		dispVal = srcEl.getAttribute("value");
        	}
        element.setAttribute("value",ZDBUtil.getSubString(dispVal,150));
        element.setAttribute("data-tip",ZDBUtil.getSubString(dispVal,150));
        ZAVMFilterSearch.addtoSelCr(false,srcEl,optionList);


     }

    this.handleSingleSelectTick = function(el,srcEl)
    {
        ZDBUtil.removeNonElements(el);
        var childNodes = el.getElementsByTagName("li");
        var className = "";
        var filtered = "";
        for(var i=0;i<childNodes.length;i++)
        {
            var child = childNodes[i];
            if(child==srcEl && child.getAttribute("filteredValue")!="All")
            {
                className = "dComboSSOptionSelected";//NO I18N
                filtered = "true";
            }
            else
            {
                className = "dComboSSOption";//NO I18N
                filtered = "false";
            }
            child.className = className;
            child.setAttribute("origClass",className)
            child.setAttribute("filtered",filtered);
        }
    }

    // multi select related
    this.multiSelect= function(event)
    {
        var srcEl = ZDBUtil.getSourceElement(event);
        var el = DOMUtils.getSelfOrParentWithAttrValue(srcEl, "optionList","true");//NO I18N
        el.elnameSet=false;
        ZDBUtil.setNamedChildEls(el,el,"elname");//NO I18N
        var func = srcEl.getAttribute("valFunc");
        var isElOfList = DOMUtils.getParentWithAttrValue(srcEl,"elname","selectListEl");//NO I18N
        if(func!=null)
        {
            if(ZAVMFilter.prevEl && isElOfList && event.shiftKey)
        	{
            	var startEl = ZAVMFilter.prevEl;
  				var endEl = srcEl;
  				var srcElAttr = srcEl.getAttribute("filtered");
  				if(startEl.offsetTop > endEl.offsetTop)
  				{
  					startEl = srcEl;
  					endEl = ZAVMFilter.prevEl;
  				}
  				var listEls = jQuery(el.selectListEl).find("li");
  				var indexStartEl = listEls.index(startEl);
  				var indexEndEl = listEls.index(endEl);
  				listEls = listEls.slice(indexStartEl,indexEndEl+1);
  				for(var i=0;i<listEls.length;i++)
  				{
  					if(listEls[i].getAttribute("filtered")==srcElAttr)
  					{
  						(ZAVMFilterComp[func](el,listEls[i],event));
  					}
  				}
        	}
            else
            {
            	(ZAVMFilterComp[func](el,srcEl,event));
            }
            ZAVMFilter.prevEl = (isElOfList) ? srcEl : null;
        }
    }

    this.selOrDeselAll = function(el,srcEl,event)
    {
      var filteredAttr = (srcEl.className=="dComboselectAllCheckbox" || srcEl.className=="dComboselectAllCheckboxHover")?false:true;
      var optionDiv = el.optionDiv;
      if(!optionDiv)
      {
        ZDBUtil.setNamedChildEls(el,el,"elname");//NO I18N
        optionDiv = el.optionDiv;
      }
      optionDiv.removeAttribute("SelCr");
      optionDiv.removeAttribute("selDcr");
      optionDiv.removeAttribute("selDVal");
      el.component.displaySelected.value = filteredAttr ? ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.all") : "";
      ZAVMFilterComp.deselectAll(el.component,!filteredAttr);
    }

    this.selOrDeselEl= function(el,srcEl,event)
    {
        if(!el){return;}
        el.elnameSet=false;
        ZDBUtil.setNamedChildEls(el,el);
        var optionListUL = el.selectListEl;
        var deselected = (srcEl.getAttribute("filtered") !="false");
        var className = "";
        var comelcntr = el.component.compElContainer;
        var inputEl = DOMUtils.getChildElsWithAttr(comelcntr, "elname", "displaySelected")[0]; //NO I18N
        if(deselected)
        {
            className = "dComboDeselectOption";//NO I18N
            srcEl.className = className;
            srcEl.setAttribute("origClass",className);
            srcEl.setAttribute("filtered","false");
            if(el.selAllLi.className=="dComboselectAllCheckbox")
            {
                el.selAllLi.className= "dComboDeselectAllCheckbox";
                el.selAllLi.setAttribute("origClass","dComboDeselectAllCheckbox");
            }
            ZAEditableUF.updateOnDeselect(inputEl, optionListUL);
            ZAEditableUF.fixDispValue(inputEl, srcEl.getAttribute("displayvalue"));
        }
        else
        {
            className="dComboSelectOption";//NO I18N
            srcEl.className=className;
            srcEl.setAttribute("origClass",className);
            srcEl.setAttribute("filtered","true");
	    var showAllDiv =DOMUtils.getFirstMatchingChild(el,"div","showalldiv","true");//NO I18N
	    var cascaded = showAllDiv.style.display==="";
	    className = cascaded ? "dComboDeselectAllCheckbox":ZAVMFilterComp.checkForSelectAll(optionListUL); //NO I18N
            if(el.selAllLi.style.display!="none")
            {
            el.selAllLi.className = className ;
            el.selAllLi.setAttribute("origClass",className);
            }
            if(ZAVMFilterUtil.curList && ZAVMFilterUtil.curList.style.display != "none")
            {
                if(el.selAllLi.style.display != "none" && className == "dComboselectAllCheckbox") {
                    inputEl.value = ZDBI18NMap.g("zrpt.common.VMFilterEditMode.zdbalertmsg.js.all");
                }
                else {
                    ZAEditableUF.addIfNotDuplicate(inputEl, srcEl.getAttribute("displayvalue"));
                }
            }
        }
        ZAVMFilterSearch.addtoSelCr(deselected,srcEl,el);
   }

    this.checkForSelectAll = function(optionListUL)
    {
        var optList = optionListUL.getElementsByTagName("LI");//optionListUL.childNodes;
        for(var i=0;i<optList.length;i++)
        {
            if(optList[i].className=="dComboDeselectOption")
            {
                return "dComboDeselectAllCheckbox";//NO I18N
            }
        }
        return "dComboselectAllCheckbox";//NO I18N
    }

    this.applyMultiSel = function(parEl,srcEl)
    {
        var el =parEl.component;
        if(srcEl==parEl.multiSelCancel)
        {
            ZAEditableUF.resetValue(el);
            ZAVMFilterUtil.closeList(null, true);
            return;
        }
        var view = ZDBClientUI.getViewObj(el,"view"); //NO I18N
        view.changeSliderBoundaries = true;
        view.lastAppliedEl = el;
        ZAVMFilterComp.setSelectedVals(el);
        ZAVMFilter.showHideResetBtn(view, false);
        el.setAttribute("canReset","true");
        if(ZDBGlobal.IS_MOBILE) ZAVMFilter.showHideCompResetBtn(el,true);
        jQuery(el).addClass("compFilterApplied");
    }

    this.setSelectedVals = function(el)
    {
        var optionList = el.optionList;
        var allSelected = optionList.selAllLi.className;
        var isAllSel = (allSelected == "dComboselectAllCheckbox" || allSelected =="dComboselectAllCheckboxHover");//NO I18N
        var isAllVal = el.getAttribute("ISALLVAL");
        var displayDiv =  optionList.displaySelected;
        var dispSelDiv = ZDBUtil.getParentWithAttributeValue(displayDiv, "elname", "dispSelDiv"); //No I18N
        var optionDiv = el.optionDiv;
        var criteria =  optionDiv.getAttribute("CrStr");
        var DispCriteria = optionDiv.getAttribute("dispFilterStr");
        var includeOthers = (el.getAttribute("CRITERIA").indexOf(ZAVMFilter.OTHERS_CR_KEY)!=-1);
        var showAllDiv =DOMUtils.getFirstMatchingChild(optionList,"div","showalldiv","true");//NO I18N
        var cascaded = showAllDiv.style.display=="";
        var uiType = el.getAttribute("uitype");
        if(isAllSel)
        {
            if(cascaded)
            {
                el.compElContainer.setAttribute("selVal",optionDiv.getAttribute("crstr"));
                el.compElContainer.setAttribute("dispSelVal",optionDiv.getAttribute("dispfilterstr"));
                el.compElContainer.setAttribute("displayVal",optionDiv.getAttribute("dispcrstr"));
            }
            var dispVal = optionList.selAllLi.innerHTML;
            if(uiType == "2") {
                displayDiv.value = dispVal;
            }
            else {
                displayDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(dispVal);
            }
            displayDiv.setAttribute("value",ZDBUtil.getSubString(dispVal,150));
            dispSelDiv.setAttribute("value", ZDBUtil.getSubString(dispVal, 150));
            displayDiv.setAttribute("data-tip",ZDBUtil.getSubString(dispVal,150));
            dispSelDiv.setAttribute("data-tip", ZDBUtil.getSubString(dispVal, 150));
            el.compElContainer.displayValue = dispVal;
            if((isAllVal=="true")|| includeOthers)
            {
                el.compElContainer.setAttribute("selVal","");
                el.compElContainer.setAttribute("dispSelVal",dispVal);
                el.compElContainer.setAttribute("displayVal",dispVal);
            }
            else
            {
                var crVal = el.getAttribute("CRITERIA");
                var dispCrVal = el.getAttribute("DISPLAYCRITERIA");
                var valOfVar = el.getAttribute("VALUEOFVAR");
                if(valOfVar != null)
                {
                    var isPresent = el.getAttribute("VARVALINCRITERIA");
                    if(isPresent == "false")
                    {
                        var varValue = el.getAttribute("VARIABLEVALUE");
                        crVal += varValue + ",";
                        dispCrVal += varValue + ",";
                    }
                }
                el.compElContainer.setAttribute("selVal", crVal);
                el.compElContainer.setAttribute("dispSelVal", dispCrVal);
                el.compElContainer.setAttribute("displayVal", dispCrVal);
                el.compElContainer.setAttribute("EXCLUDE","false");
            }
             el.setAttribute("EXCLUDE",el.compElContainer.getAttribute("EXCLUDE"));
        }
        else
        {
           var exclude = el.compElContainer.getAttribute("EXCLUDE")=="true";
           var cr = optionDiv.getAttribute("SelCr");
           var dcr = optionDiv.getAttribute("selDcr");
           var dcv = optionDiv.getAttribute("selDVal");
           if(!exclude && (cr==null || cr=="" || cr=="All"))
           {
                showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.noSelect"),optionList.selAllLi);
                return;
           }
           
           if(exclude)
           {
               var dispCrStr = optionDiv.getAttribute("dispCrStr");
               dcv = ZAVMFilterSearch.remDefCrFromCr(dcv,dispCrStr);
           }
           if(dcv.charAt(dcv.length-1)==",")
           {
               dcv = dcv.substring(0,dcv.length-1);
           }
           dcv = ZDBUtil.replaceStr(dcv, "--C--", ","); //NO I18N
          if(cr!=null && cr.indexOf(ZAVMFilter.OTHERS_CR_KEY)!=-1)
          {
            var excludedCr = ZAVMFilterSearch.remDefCrFromCr(cr,criteria);
            var excludedDcr = ZAVMFilterSearch.remDefCrFromCr(dcr,DispCriteria);
            if(excludedCr==null || excludedCr=="")
            {
                showCustomMessage(ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.noSelect"),optionList.selAllLi);
                return;
            }
            if(!exclude)
            {
                el.setAttribute("EXCLUDE","true");
                el.compElContainer.setAttribute("selVal",excludedCr);
                el.compElContainer.setAttribute("dispSelVal",excludedDcr);
                el.compElContainer.setAttribute("displayVal",dcv);
            }
            else
            {
                el.setAttribute("EXCLUDE","false");
                el.compElContainer.setAttribute("selVal",excludedCr);
                el.compElContainer.setAttribute("dispSelVal",excludedDcr);
                el.compElContainer.setAttribute("displayVal",dcv);
            }
          }
          else
          {
              if(exclude && cascaded)
              {
                  cr = ZAVMFilterSearch.remDefCrFromCr(cr,optionDiv.getAttribute("crstr"));
                  dcr = ZAVMFilterSearch.remDefCrFromCr(dcr,optionDiv.getAttribute("dispfilterstr"));
                  exclude = false;
                  if(cr!=null && cr.indexOf(ZAVMFilter.OTHERS_CR_KEY)!=-1 ) // If the excluded relevant criteria is having
                  {
                      cr = ZAVMFilterSearch.remDefCrFromCr(cr,el.getAttribute("CRITERIA"));
                      dcr = ZAVMFilterSearch.remDefCrFromCr(dcr,el.getAttribute("DISPLAYCRITERIA"));
                      exclude = true;
                  }
              }
              el.setAttribute("EXCLUDE",exclude.toString());
              el.compElContainer.setAttribute("selVal",cr);
              el.compElContainer.setAttribute("dispSelVal",dcr);
              el.compElContainer.setAttribute("displayVal",dcv);
          }
          displayDiv.setAttribute("value",ZDBUtil.getSubString(dcv,150));
          displayDiv.setAttribute("data-tip",ZDBUtil.getSubString(dcv,150));
          if(uiType == "2") {
            displayDiv.value = dcv;
          }
          else {
            displayDiv.innerHTML = ZDBEscapeUtil.encodeForHtml(dcv);
          }
          dispSelDiv.setAttribute("value", ZDBUtil.getSubString(dcv, 150));
          dispSelDiv.setAttribute("data-tip", ZDBUtil.getSubString(dcv, 150));
          el.compElContainer.displayValue = dcv;
      }
      el.compElContainer.setAttribute("EXCLUDE",el.getAttribute("EXCLUDE"));
      ZAVMFilterUtil.closeList(null, true);
      ZAVMFilter.refreshView(el);
    }

    this.clearSelect = function(critDiv,isDeselect)
    {
        var compElContainer = critDiv.compElContainer;
        compElContainer.removeAttribute("selVal");
        compElContainer.removeAttribute("dispSelVal");
        compElContainer.removeAttribute("displayVal");
    }

    this.clearCombo = function(critDiv,isDeselect)
    {
        ZDBUtil.setNamedChildEls(critDiv,critDiv,"elname");//NO I18N
        this.clearSelect(critDiv);
        if(!critDiv.selAllLi)
        {
            return;
        }
        this.clearComboSelection(critDiv,isDeselect);
    }

    this.clearComboSelection = function(critDiv,isDeselect,isSearch)
    {
        var className = isDeselect?"dComboDeselectAllCheckbox":"dComboselectAllCheckbox";//NO I18N
        if(!critDiv.selAllLi)
        {
            return;
        }
        critDiv.selAllLi.className = className;//NO I18N
        critDiv.selAllLi.setAttribute("origClass",className);
        var options = critDiv.selectListEl.getElementsByTagName("li");
//        critDiv.optionDiv.removeAttr("selcr");
//        critDiv.optionDiv.removeAttribute("selDVal");

        var dispValsStr ="";
        var filterStr ="";
        var dispFilterStr ="";
        for(var i=0;i<options.length;i++)
        {
            var curOption = options[i];
            if(isDeselect)
            {
                curOption.className="dComboDeselectOption";
                curOption.setAttribute("origClass","dComboDeselectOption");
                curOption.setAttribute("filtered","false");
            }
            else
            {
                curOption.className="dComboSelectOption";
                curOption.setAttribute("origClass","dComboSelectOption");
                curOption.setAttribute("filtered","true");
            }
            var dispVal = curOption.getAttribute("displayvalue");
            var filterVal = curOption.getAttribute("filteredvalue");
            var dispFilterVal = curOption.getAttribute("filterdispvalue");
            var isVarPatternData = false;
            if(dispVal.indexOf(ZAVMFilter.START_VAR_PATTERN)==0 &&
                dispVal.indexOf(ZAVMFilter.END_VAR_PATTERN) == dispVal.length-1) {isVarPatternData=true;}
            dispVal = (dispVal.indexOf(",")>=0 || isVarPatternData) ? "\""+dispVal+"\"" : dispVal;
            dispValsStr = dispValsStr+dispVal+",";
            filterStr = filterStr+filterVal;
            dispFilterStr = dispFilterStr+dispFilterVal+",";
        }
        if(!isSearch)
        {
            critDiv.optionDiv.setAttribute("DispCrStr",dispValsStr);
            critDiv.optionDiv.setAttribute("CrStr",filterStr);
            critDiv.optionDiv.setAttribute("dispFilterStr",dispFilterStr);
        }
    }

    this.deselectAll = function(component,deselectAll,isSearch)
    {
       var func = component.filterHead.getAttribute("clearFunc");
        if(func=="clearSelect")
        {
            return;
        }
        var exclude = deselectAll ?"false":"true";
        component.compElContainer.setAttribute("EXCLUDE",exclude);
        this[func+"Selection"](component,deselectAll,isSearch);
    }

    this.resetComp = function(el)
    {
        var comp = (el.component)?el.component:el;
        var containerEl = comp.compElContainer;
        if(containerEl==null)
        {
            return;
        }
        comp.removeAttribute("checked");
        var view = ZDBClientUI.getViewObj(el, "view"); //NO I18N
        var chartObj = view.chartObj;
        if(chartObj)
        {
            var defDispCr = jQuery(containerEl).closest("div[compBodyEl]").attr("defaultdisplaycriteria"); //NO I18N
            var dispVal = containerEl.getAttribute("displayval");
            if(dispVal && dispVal !== defDispCr) {
                chartObj.sendReq = true;
            }
        }
        var filterHead = el.filterHead;
        var func = filterHead.getAttribute("clearFunc");
        this[func](comp);
        ZAVMFilter.checkForDefaultCriteria(comp,view);
    }

      this.clearSlider = function(comp)
    {
        var slider = DOMUtils.getFirstMatchingChild(comp,"div","slider","true");//NO I18N
        var els = DOMUtils.getChildElsWithAttr(comp, "elname", "compElContainer"); //NO I18N
        var compElCont = els[0];
        compElCont.removeAttribute("selVal");
        compElCont.removeAttribute("dispSelVal");
        compElCont.removeAttribute("displayVal");
        ZASliderComp.resetSliderPositions(slider,comp);
    }

    this.clearSelectRange = function(critDiv)
    {
        ZDBUtil.setNamedChildEls(critDiv,critDiv,"drBtn");//NO I18N
//        critDiv = critDiv.dateMenuEl;
        critDiv.elnameSet = false;
        ZDBUtil.setNamedChildEls(critDiv,critDiv);
        var goBtn = (critDiv.VMFilterGoBtn) ? (critDiv.VMFilterGoBtn) : (critDiv.dateMenuEl.VMFilterGoBtn);
        critDiv.fromValue.value = ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.from"); //NO I18N
        critDiv.fromValue.setAttribute("inputVal","From");
        critDiv.fromValue.setAttribute("tipShown","true");
        critDiv.toValue.value = ZDBI18NMap.g("zrpt.common.analysis.filter.custommsg.js.to");//NO I18N
        critDiv.toValue.setAttribute("inputVal","To");
        critDiv.toValue.setAttribute("tipShown","true");
        critDiv.displayAppliedFilter.innerHTML = ZDBI18NMap.f("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select");
        critDiv.displayAppliedFilter.setAttribute("value",ZDBI18NMap.f("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select"));
        critDiv.displayAppliedFilter.setAttribute("data-tip",ZDBI18NMap.f("zrpt.common.VMFilterEditMode.zdbalertmsg.js.select"));
        var compElCont = critDiv.compElContainer;
        if(critDiv.getAttribute("ISALLVAL")!="true")
        {
            compElCont.setAttribute("selVal",critDiv.getAttribute("CRITERIA"));
            compElCont.setAttribute("dispSelVal",critDiv.getAttribute("DISPLAYCRITERIA"));
            compElCont.setAttribute("displayVal",critDiv.getAttribute("DISPLAYCRITERIA"));
        }
        compElCont.removeAttribute("selVal");
        compElCont.removeAttribute("dispSelVal");
        compElCont.removeAttribute("displayVal");
        goBtn.setAttribute("disabled","true");
        goBtn.className = "glossyButton alpha";
    }
}// jshint ignore:line
