//$Id$

var ZAVMFilterSearch= new function()
{
  this.defArrList = new Array();
  this.hideTipString = function(el,removeClass)
  {
    ZAVMFilter.searchFocused = true;
    ZDBUtil.detachEvent(document,'keydown',ZAVMFilterUtil.checkKeyNContinue,true);
    ZDBUtil.attachEvent(document,'keyup',ZAVMFilterSearch.checkKeyAndSearch,true);
    var searchElHolder = DOMUtils.getSelfOrParentWithAttrValue(el, "elname", "searchElHolder");//NO I18N
    var searchIcon = DOMUtils.getFirstMatchingChild(searchElHolder, "*", "searchIcon", "true");//NO I18N
    jQuery(searchElHolder).addClass("searchFieldFocus");
    searchIcon.className = "ZRSSearchClearIcon";
    if(el.getAttribute("tipShown") == "true")
    {
      el.value="";
      el.setAttribute("tipShown","false");
      if(removeClass)
      {
        el.className = "";
      }
    }
  }

  this.showTipString = function(el,setClass)
  {
  if(ZDBSearchUtil.dntBlur)
    {
      ZDBSearchUtil.dntBlur=false;
          setTimeout(function(){jQuery(el).focus(); if(BROWSER.IE){ZDBSearchUtil.setCursorToTextEnd(el);} },200);
          return;
    }
    ZAVMFilter.searchFocused = false;
    ZDBUtil.attachEvent(document,'keydown',ZAVMFilterUtil.checkKeyNContinue,true);
    ZDBUtil.detachEvent(document,'keyup',ZAVMFilterSearch.checkKeyAndSearch,true);
    var searchElHolder, searchIcon;
    searchElHolder = DOMUtils.getSelfOrParentWithAttrValue(el, "elname", "searchElHolder");//NO I18N
    searchIcon = DOMUtils.getFirstMatchingChild(searchElHolder, "*", "searchIcon", "true");//NO I18N
    jQuery(searchElHolder).removeClass("searchFieldFocus");
    if(el.value == "" &&  el.getAttribute("tipShown") == "false")
    {
      var tip = el.getAttribute("tipValue");
      el.value= (tip != null)? tip :ZDBI18NMap.g("zrpt.common.js.search");
      el.setAttribute("tipShown","true");
      if(searchIcon)
      {
        searchIcon.className = "ZRSSearchIcon";
      }
      if(setClass)
      {
        el.className = "tipTextColor";
      }
    }
  }
  
  this.checkKeyAndSearch = function(ev)
  {
    if(!ev){ev = window.event;}
    if(ev.keyCode==27)
    {
        ZAVMFilterUtil.closeList(ev, true);
    }
    else 
    {
       setTimeout(function(){ZAVMFilterSearch.searchList();},500);
    }
    
  }
  
  this.searchList = function(){
        var optList = ZAVMFilterUtil.curList;
        var component = optList.component
        var searchEl =   DOMUtils.getFirstMatchingChild(optList,"input","searchbox", "true"); //NO I18N
        var optionDiv = DOMUtils.getFirstMatchingChild(optList,"div","elname", "optionDiv"); //NO I18N
        optList.setAttribute("next",component.next);
        if(optList.getAttribute("next") >-1)
        {
           ZAVMFilterSearch.fetchNextOrSearch(optionDiv,false);
        }
        else{
            component.setAttribute("VMFilterFetchStatus","0");
        }
        var view = ZDBClientUI.getViewObj(searchEl,"view");//NO I18N
        var value = ZDBSearchUtil.getSearchValue(searchEl);
        ZAVMFilterSearch.filterTheListItems(component,value);
        ZDBUtil.setNamedChildEls(optList,optList);
        if(!(optList.getAttribute("next") >-1)){ZAVMFilter.constructNoDataAvailableMsg(optList.selectListEl, false)}
        component.optionDiv.style.height="";
        ZAVMFilter.setHghAndRezableVsble(view,component);
  }
  
  this.filterTheListItems = function(component,searchValue)
  {

            var jopLst = jQuery(component.optionList).find("LI");
            jQuery(jopLst).each(function()
            {
                if(searchValue!=null && this.innerHTML.toLowerCase().indexOf(searchValue.toLowerCase()) === -1)
                {
                    jQuery(this).hide();
                }
                else
                {
                    jQuery(this).show();
                }
            });
  }
  this.clearTheList = function(el)
  {
      var optList = ZAVMFilterUtil.curList;
      var el =   DOMUtils.getFirstMatchingChild(optList,"input","searchbox", "true"); //NO I18N
      ZAVMFilterSearch.fetchNextOrSearch(el,false);
  }

  this.serachTheList = function(el,ev)
  {
      var searchEl =  DOMUtils.getChildElsWithAttr(el.parentNode, "searchBox", "true")[0]; //NO I18N
      if(searchEl)
      {
        this.fetchNextOrSearch(searchEl,false,ev);
      }
  }

  this.addtoSelCr = function(deselect,srcEl,optionList)
  {
        var optionDiv = optionList.optionDiv;
        if(!optionDiv)
        {
          ZDBUtil.setNamedChildEls(optionList,optionList,"elname");//NO I18N
          optionDiv = optionList.optionDiv;
        }
       var exclude = optionList.component.compElContainer.getAttribute("EXCLUDE")=="true";
       var uiType = optionList.component.getAttribute("UITYPE");
       var origVal = srcEl.getAttribute("filteredValue");
       var dispVal = srcEl.getAttribute("filterDispValue")+",";
       var dispStr = srcEl.getAttribute("displayValue");
       var isVarPatternData = false;
       if(dispVal.indexOf(ZAVMFilter.START_VAR_PATTERN) == 0 &&
           dispVal.indexOf(ZAVMFilter.END_VAR_PATTERN) == dispVal.length-2)
       {
           isVarPatternData=true;
       }
       dispStr = (dispStr.indexOf(",")>0 || isVarPatternData) ? "\""+dispStr+"\"" : dispStr;
       if(srcEl.tagName != "LI"){return;}
       if(uiType=="4")
       {
        optionDiv.setAttribute("SelCr",origVal);
        optionDiv.setAttribute("selDcr",dispVal);
        optionDiv.setAttribute("selDVal",dispStr);
       return;
       }
       var cr = optionDiv.getAttribute("SelCr");
       var dcr = optionDiv.getAttribute("selDcr");
       var dcv = optionDiv.getAttribute("selDVal");

       if((exclude && deselect)||(!exclude && !deselect))
       {
           var checkVal = origVal.replace(",","");//to get criteria for the selected value without comma 
           if(cr!=null && cr.split(",").indexOf(checkVal)!=-1){return;}
           cr = (cr==null)?(origVal):(cr+origVal);
           dcr = (dcr==null)?(dispVal):(dcr+dispVal);
           dcv = (dcv==null || dcv=="")?(dispStr):(dcv+","+dispStr);
       }
       else if(((exclude && !deselect)||(!exclude && deselect))&&(cr!=null&&cr!="null"))
       {
            cr = cr.replace(origVal,"");
            dcr = dcr.replace(dispVal,"");
            if(dcv.indexOf(dispStr)>0)
            {
                 dcv = dcv.replace(","+dispStr,"");
            }
            else
            {
                var replaceStr = (dcv==dispStr)? dispStr:dispStr+",";
                dcv = dcv.replace(replaceStr,"");
            }
       }
       optionDiv.setAttribute("SelCr",cr);
       optionDiv.setAttribute("selDcr",dcr);
       optionDiv.setAttribute("selDVal",dcv);
  }

  this.fetchNextOrSearch = function(el,nextFetch,ev)
  {
    var optionList = ZDBUtil.getParentWithAttributeValue(el,"optionList","true"); //NO I18N
    if(el.sent || (el==null))
    {
      return;
    }
    var comp= optionList.component;
    var opStatusEl = comp.filterHead;
    if(nextFetch)
    {
        start = optionList.getAttribute("next");
        if(start==-1 || start==null || start=="null" || start=="undefined")
        {
         return;
        }
        opStatusEl = DOMUtils.getFirstMatchingChild(optionList,"div","elname","filterLoading"); //NO I18N
        opStatusEl.style.display="";
    }
    el.sent = true;
    var searchBox =   DOMUtils.getFirstMatchingChild(optionList,"input","searchbox", "true"); //NO I18N
    var search = ZDBSearchUtil.getSearchValue(searchBox); 
    var searchVal = search;
    var isSearch = false;
    if(search != null && search != "" )
    {
        search = "&SEARCH=" + encodeURIComponent(search.toString()); //NO I18N
        isSearch = true;
//        opStatusEl = DOMUtils.getFirstMatchingChild(optionList,"div","elname","filterLoading"); //NO I18N
//        opStatusEl.style.display="";
    }
     else
    {
        search = "";
    }
    var  start = (nextFetch)? "&START=" + start:""; //NO I18N
    var view = ZDBClientUI.getViewObj(comp,"view");
    var labelName = comp.getAttribute("label");
    view.lastAppliedEl = null;
    viewParams=view.getViewParams();
    if(view.type == "Dashboard")
    {
      viewParams += "&CONOBJID=" + view.objId;//NO I18N
    }
  url = (ZDBClientUI.isNewRequest)?"/VMFilterDataFetch.ve?":"/VMFilterListFetch.cc?"//NO I18N
   url +="VMFILTERLBLNAME="+encodeURIComponent(labelName);// NO I18N
    if(start!="")
    {
        url+= start; 
    }
    var vmfAction = nextFetch?"NEXTLISTFETCH":"VMFILTERSEARCH"; //NO I18N
    url+="&VMFILTERACTION="+vmfAction;  //NO I18N
    url+=search;
    var config = null;
    var include = comp.getAttribute("INCLUDECR") === "true" ? true : false;
    var includeCr = include && !comp.showMoreClicked ? true : false ;
    if(view.type=="AnalysisView" || view.type=="Pivot" || view.type=="SummaryView")
    {  
      config = ZDBAnalysisConfig.getCurrentConfig(view,includeCr);
      url+="&INCLUDECR="+(includeCr&&view.isVMFilterApplied)+"&ISDASHBOARDUF="+false;//NO I18N;//NO I18N
    }
    else if(view.type=="Dashboard")
    {
      config = ZDBDStructure.getDashBoardCurrentConfig(view,includeCr);
      url+="&ISDASHBOARDUF="+true;//NO I18N
      viewParams+="&PARENTVIEWID="+comp.getAttribute("PARENT_OBJ_ID"); //NO I18N
    }
    url+=viewParams;
    AjaxAPI.sendRequest({URL:url,POSTBODY:config,
                               REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                               ONFAILUREFUNC:ZAVMFilterSearch.handleFailure,
                                                 VIEW:view,COMPONENT:comp,FILTEREL:el,
                                                 OPTLIST:optionList,
                                                 ISNEXTFETCH:nextFetch,
                                                 CONFIG:config,
                                                 SEARCH:searchVal,
                                                 ISSEARCH:isSearch,INCLUDECR:includeCr,
                                                 ONSUCCESSFUNC:ZAVMFilterSearch.placeSearchedData,
                                                 OPSTATUSID:opStatusEl 
                                                 });
  }

  this.placeSearchedData = function(response,requestOptions)
  {
        var isNextFetch = requestOptions["ISNEXTFETCH"];
        var optionList = requestOptions["OPTLIST"];
        var includeCr = requestOptions["INCLUDECR"];
        var isSearch= requestOptions["ISSEARCH"];
        var search = requestOptions["SEARCH"];
        var component = requestOptions["COMPONENT"];
        var view = requestOptions["VIEW"];
        var el = requestOptions["FILTEREL"];
        var lab = component.getAttribute("label");
        var div = document.createElement("div");
        var searchBox =   DOMUtils.getFirstMatchingChild(optionList,"input","searchbox", "true"); //NO I18N
        var currentsearchValue = ZDBSearchUtil.getSearchValue(searchBox); 
        if( currentsearchValue!= search){
            el.sent = false;
            ZAVMFilterSearch.fetchNextOrSearch(el,false);
            return;
        }
        if(ZDBClientUI.isNewRequest)
        {
            var responseData = JSON.parse(response.responseText);
            var VMFlisEl = ZAVMFilter.getList(responseData,component.getAttribute("uitype"),lab,true,component);
            div.innerHTML="";
            !(VMFlisEl[0]) ? div.appendChild(VMFlisEl) : null;
            if(0<responseData.VAR_LIST)
            {
               ZAVMFilter.constructVariableList(responseData, VMFlisEl, component, false);
            }
        }
        else{
            div.innerHTML =response.responseText;
        }
        var optionList = component.optionList;
        var fetchedEl = DOMUtils.getChildElsWithAttr(div, "fetchedDiv", "true")[0]; //NO I18N
        if(fetchedEl)
        {
            optionList.setAttribute("next",fetchedEl.getAttribute("next"));
            optionList.setAttribute("length",fetchedEl.getAttribute("length"));
        }
        if(isNextFetch && fetchedEl)
        {
            var mainList = DOMUtils.getChildElsWithAttr(optionList, "elname", "mainList")[0]; //NO I18N
            mainList.innerHTML += fetchedEl.innerHTML;
        }
        else if(!isNextFetch && fetchedEl)
        {
          var selectList = DOMUtils.getChildElsWithAttr(optionList, "elname", "selectListEl")[0]; //NO I18N
          if(ZDBClientUI.isNewRequest)
          {
              selectList.innerHTML="";
               selectList.appendChild(fetchedEl);
              if(responseData.REL_LIST)
              {
                  var fetchedElm = ZAVMFilter.constructRelativeList(fetchedEl,fetchedEl,responseData,component.getAttribute("uiType"),component);
                   selectList.appendChild(fetchedElm);
               }
              if(responseData.EXTRA_INFO.containsOthers){
                    var VMFSp = document.createElement("DIV");// VMFSp = VMFilterSeparator
                    jQuery(VMFSp).addClass("VMFilterSeparator");
                    selectList.appendChild(VMFSp);
                   ZAVMFilter.constructOthersOpt(selectList,component.getAttribute("uiType"));
                }

          }
          else{
               selectList.innerHTML = fetchedEl.innerHTML;
          }
            if(!isNextFetch && !isSearch)
            {
                component.setAttribute("VMFilterFetchStatus","2");
                
            }
            else
            {
                component.setAttribute("VMFilterFetchStatus","0");
            }
        }
        var showAllDiv = DOMUtils.getFirstMatchingChild(optionList,"div","showAllDiv", "true"); //NO I18N
        if(showAllDiv)
        {
           showAllDiv.style.display= (includeCr&&view.isVMFilterApplied )?"":"none";
        }
        ZAVMFilter.showOptionList(component,component.compElContainer,null,true,isNextFetch,isSearch);
        if(!isNextFetch)
        {
            var searchBox =   DOMUtils.getFirstMatchingChild(optionList,"input","searchbox", "true"); //NO I18N
            setTimeout(function(){jQuery(searchBox).focus(); if(BROWSER.IE){ZDBSearchUtil.setCursorToTextEnd(searchBox);} },200);
            if(component.getAttribute("CASCADELIST")=="true")
            {
               var lblName = component.getAttribute("LABEL");
               view.vmFilterListCatch[lblName]=null;
            }
        }
        el.sent = false;
  }
  this.handleFailure = function(response,requestOptions)
  {
    var view = requestOptions["VIEW"]
    if(view.type=="Dashboard")
      {
        AjaxAPI.onFailureFunc(response,requestOptions);
      }
      else
      {
        var el = requestOptions["FILTEREL"];
        el.sent = false;
        ZDBAnalysisView.closeRefreshDiv(requestOptions["VIEW"]);
        AjaxAPI.onFailureFunc(response,requestOptions);
      }
  }
    this.scrollingList = function(el,event)
    {
        if (el.scrollHeight - (el.scrollTop+el.offsetHeight) <= 30)
        {
          ZAVMFilterSearch.fetchNextOrSearch(el,true);
        }
    }

  this.remDefCrFromCr = function(defStr,CritStr)
  {
      var defStrList = defStr.split(",");
      for(var i=0;i<defStrList.length&&defStrList[i]!="";i++)
      {
          var str1 = defStrList[i]+",";
          CritStr = CritStr.replace(str1,"");
      }
      return CritStr.trim();
  }

this.getSearchValue = function(searchEl)
  {
      var searchVal = searchEl.value;
//      searchVal =  ZDBUtil.replaceStr(searchVal,", ",",");
      var quotStart = searchVal.lastIndexOf(",\"");
      if(quotStart<0)
      {
              quotStart = searchVal.lastIndexOf("\"")==0? 0 :quotStart;
      }
      else
      {
           quotStart = searchVal.lastIndexOf(",\"");
      }
      var quotEnd = searchVal.lastIndexOf("\",");
      if(quotEnd<0)
      {
          quotEnd = searchVal.lastIndexOf("\"")==searchVal.length-1?searchVal.lastIndexOf("\""):quotEnd;
      }
      else
      {
           quotEnd = searchVal.lastIndexOf("\",");
      }
     var lastIndex = searchVal.lastIndexOf(",");
     var prevSearchVal = searchVal.substring(0,lastIndex+1);
     if(quotStart>=quotEnd && !(quotStart<0))
      {
          lastIndex = quotEnd;
          prevSearchVal = searchVal.substring(0,quotEnd);
      }
      searchEl.setAttribute("dispVal",prevSearchVal);
      searchVal = (lastIndex>0)?searchVal.substring(lastIndex+1,searchVal.length):searchVal;
//      searchVal = searchVal.trim();
      return (searchVal.indexOf("\"")==0)?searchVal.substring(1, searchVal.length):searchVal;
  }

  this.fetchDefList = function(el,randomNumber)
  {
        var view = ZDBClientUI.getViewObj(el,"view"); //NO I18N
        var search = this.getSearchValue(el); //el.value;
        var dlg = ZDBDialogUtil.focusDialog;
        var field = dlg.field;
        var subType = dlg.modifyProps.subtype;
        var operation = dlg.modifyProps.operation;
        var rel_filter = dlg.modifyProps.rel_criteria;
        var rel_dispFilter = dlg.modifyProps.rel_dispcriteria;
        if(search==null || search=="")
        {
            var defList = $("defList");
            defList.style.display = "none";
            return;
        }
        var randomnumber2 = el.getAttribute("random");
        if(randomNumber!=randomnumber2){return;}
        ZDBUtil.detachEvent(document,'keydown',ZAVMFilterUtil.checkKeyNContinue,true);
        ZDBUtil.detachEvent(document,'click',ZAVMFilterUtil.closeList,true);
        var searchVal = "&SEARCH=" + encodeURIComponent(search.toString()); //NO I18N
        subType = "&SUBTYPE="+subType; //No I18N
        operation = "&OPERATION="+operation; //No I18N

          var viewParams = ZAVMFilterSearch.ufParameters(view,el,field);
          var colParViewId = field.getAttribute("PARENT_OBJ_ID") != null ? field.getAttribute("PARENT_OBJ_ID").trim() : view.parentViewId ;
          viewParams += "&COLPARENTVIEWID=" + colParViewId;//No I18N

        var url = "/VMDefListFetch.cc?"+ viewParams+"&VMFILTERACTION=DEFLISTFETCH"; //No I18N
        var isDashboard = (view.type=="Dashboard")?true :false;
        url+=searchVal+subType+operation;
        url+="&RELCR="+encodeURIComponent(rel_filter);//NO I18N
        url+="&RELDISPCR="+encodeURIComponent(rel_dispFilter);//NO I18N
        var doXml = (isDashboard) ? ZDBDStructure.getDashBoardCurrentConfig(view,false) : ZDBAnalysisConfig.getCurrentConfig(view,false);
        AjaxAPI.sendRequest({URL:url,POSTBODY:doXml,
                            REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                            ONFAILUREFUNC:ZAVMFilterSearch.hndlDefValFail,
                            VIEW:view,DEFFIELD:el,SEARCH:search,
                            ONSUCCESSFUNC:ZAVMFilterSearch.handleDefListResp
        });
  }

  this.onFailureFunc = function(response, requestOptions)
  {
     AjaxAPI.onFailureFunc(response,requestOptions);
  }
   this.promptDefList = function(el,event)
  {
       if(event.keyCode==37 || event.keyCode==39||event.keyCode==40 || event.keyCode==38 ||event.keyCode==13 || event.keyCode==32 || event.keyCode==27)
       {
            return;
       }
        var dlg = ZDBDialogUtil.focusDialog;
        if(dlg.modifyProps.isallval == "true")
        {
            var randomnumber=Math.floor(Math.random()*101)
            el.setAttribute("random",randomnumber);
            setTimeout(function(){ZAVMFilterSearch.fetchDefList(el,randomnumber);},500);
        }
        else
        {
           this.searchNAppendList(el,dlg.field);
        }
  }
  this.searchNAppendList = function(el,field)
  {
        var view = ZDBClientUI.getViewObj(el,"view"); //NO I18N
        var isNumber = field.getAttribute("ADDONTYPE")=="NUMBER"; //NO I18N
        var search = this.getSearchValue(el).toLowerCase(); //el.value;
        if(search==null || search=="")
        {
              var defList = $("defList");
            defList.style.display = "none";
            return;
        }
         var innerText = "<ul class='defValsList' onclick='ZAVMFilterSearch.selectDefVal(this,event);'>"
         var str = "";
         var arrList = this.defArrList;
         str+=ZAVMFilterSearch.constructSearchList(el, arrList, isNumber, search);

         innerText+=str+"</ul>"
         ZAVMFilterSearch.showDefList(innerText,el,search);
  }
  this.constructSearchList = function(el,arrList,isNumber,search,appendSeperator)
  {
    var str = "";
    		var dlg = ZDBDialogUtil.focusDialog;
            var subType = dlg.modifyProps.subtype;
            var isActualNum = (isNumber && subType=="1")? true :false; //NO I18N
            if(appendSeperator)
              {
                str+="<div class='VMFilterSeparator'></div>";
              }
    for(var i=0;i<arrList.length;i++)
         {
             var arr = arrList[i];
             var dispVal = ZDBUtil.replaceStr(arr[1],"--C--",","); //NO I18N
             var startsWith = isActualNum ?arr[0].toLowerCase().indexOf(search)==0: dispVal.toLowerCase().indexOf(search)==0;
             if(isNumber && !startsWith)
             {
                 var temp = (isActualNum)? dispVal:dispVal.replace(/[^a-zA-Z 0-9+-.,]+/g,'');
                 startsWith = temp.toLowerCase().indexOf(search)==0;
             }
             if(startsWith)
             {
                 var varPatternData = "";
                 if(dispVal.indexOf(ZAVMFilter.START_VAR_PATTERN)==0 &&
                         dispVal.indexOf(ZAVMFilter.END_VAR_PATTERN)==dispVal.length-1)
                 {
                     varPatternData = "varpatterndata=\"true\""; //No I18N
                 }
                 str += "<li class='dComboSSOption' origClass='dComboSSOption' valFunc='setDefVal' "+ varPatternData +  //No I18N
                     "displayValue='" + ZDBEscapeUtil.encodeForHtmlAttr(dispVal) + "\' displayfiltervalue='" +              //No I18N
                      ZDBEscapeUtil.encodeForHtmlAttr(arr[1]) + "\' filtervalue='" + ZDBEscapeUtil.encodeForHtmlAttr(arr[0]) +
                      "\' >" + ZDBEscapeUtil.encodeForHtml(dispVal.toString()) + "</li>"; //NO I18N
             }
         }
         return str;
  }
  this.handleDefListResp = function(response,requestOptions)
  {
       var defField = requestOptions["DEFFIELD"];
      var search = requestOptions["SEARCH"];
      ZAVMFilterSearch.showDefList(response.responseText,defField,search)
  }
  this.showDefList = function(respText,defField,search)
  {
      var defList = $("defList");
      defList.innerHTML = respText;
      document.body.appendChild(defList);
      var els = defList.getElementsByTagName("LI");
      var defFieldHldr= ZDBUtil.getParentWithAttributeValue(defField, "defInputHolder", "true");//NO I18N

      if(els.length<=0 || (els.length==1 && search==els[0].getAttribute("displayValue")))
      {
          defList.style.display ="none";
          return;
      }
      defList.style.left = (ZDBUtil.getObjLeft(defFieldHldr))+"px";
      defList.style.top = ((ZDBUtil.getObjTop(defFieldHldr)+defFieldHldr.offsetHeight)+10)+"px";
      defList.style.position = "absolute";
      defList.style.display="";
      defList.defInputEl = defField;
      defField.defList = defList;
      var height = els[0].offsetHeight*5;
      var scroll = false;
      defList.style.height ="auto";
      if(defList.offsetHeight>height)
      {
        defList.style.height = height+"px";
        defList.style.overflowY = "auto";//NO I18N
        scroll=true;
      }
      if(defList.offsetWidth<=defField.offsetWidth)
      {
        defList.style.width=(scroll)?defField.offsetWidth+20+"px":defField.offsetWidth+"px";
      }
      defList.style.zIndex = parseInt(ZDBDialogUtil.focusDialog.style.zIndex)+10;
       ZAVMFilterUtil.curList = defList;
        ZDBUtil.attachEvent(ZAVMFilterUtil.curList,'mouseover',ZAVMFilterUtil.highlightSelected,true);
        ZDBUtil.attachEvent(document,'click',ZAVMFilterUtil.closeList,true);
        ZDBUtil.attachEvent(document,'keydown',ZAVMFilterUtil.checkKeyNContinue,true);
    }

    this.selectDefVal = function(list,event)
    {
      var defList = ZDBUtil.getParentWithAttributeValue(list,"defList","true");//NO I18N
       var srcEl = ZDBUtil.getSourceElement(event);
       ZAVMFilterSearch.setDefVal(defList,srcEl);
       ZAVMFilterUtil.closeList(event,true);
       $("defInput").focus();
    }

    this.setDefVal = function(defList,srcEl)
    {
        var inputEl = defList.defInputEl;
        var dispVal = srcEl.getAttribute("displayValue");
        var isVarPatternData = (srcEl.getAttribute("varpatterndata") != null) ? true : false;
        dispVal = (dispVal.indexOf(",")>=0 || isVarPatternData) ? ("\""+dispVal+"\",") : dispVal+",";
        var oldDispVal = inputEl.getAttribute("dispVal");
        oldDispVal = (oldDispVal==null || oldDispVal=="") ? "" : oldDispVal;
        oldDispVal.indexOf(dispVal)>=0?inputEl.setAttribute("dispVal",oldDispVal):inputEl.setAttribute("dispVal",oldDispVal+dispVal);
        inputEl.value = inputEl.getAttribute("dispVal");//oldDispVal+dispVal;
        inputEl.setAttribute("value",inputEl.value);
    }

    this.updateTheSelList = function(el)
    {
         var dlg = ZDBDialogUtil.focusDialog;
         if(dlg.modifyProps.isallval == "true"){return;}
         this.defArrList = new Array();
         var itemSelectedContent = DOMUtils.getChildElsWithAttr(el.form, "elname", "selItemHolder")[0]; //NO I18N
         var selectedList = itemSelectedContent.getElementsByTagName("div");
         for(var i=0;i<selectedList.length;i++)
         {
            var listEl = selectedList[i];
            var arr = new Array();
            arr[0]=listEl.getAttribute("filtervalue");
            arr[1]=listEl.getAttribute("displayfiltervalue");
            this.defArrList.push(arr);
         }
         if(dlg.modifyProps.relrow_present.toString()=="true")
         {
           var relItemSelDiv = DOMUtils.getChildElsWithAttr(el.form, "elname", "relSelectedValuesDiv")[0]; //NO I18N
           var relItemSelectedContent = DOMUtils.getChildElsWithAttr(relItemSelDiv, "elname", "selItemHolder")[0]; //NO I18N
           var relSelectedList = relItemSelectedContent.getElementsByTagName("div");
           for(var j=0;j<relSelectedList.length;j++)
           {
              var relListEl = relSelectedList[j];
              var relArr = new Array();
              relArr[0]=relListEl.getAttribute("filtervalue");
              relArr[1]=relListEl.getAttribute("displayfiltervalue");
              this.defArrList.push(relArr);
           }
         }
         if($("inclOthers").checked)
         {
            var arr = new Array();
            arr[0]=ZAVMFilter.OTHERS_CR_KEY;
            arr[1]=ZAVMFilter.OTHERS_KEY;
            this.defArrList.push(arr);
         }
    }

    this.ufParameters = function(view,el,field)
    {
        var colID = field.getAttribute("COLUMN_ID");
        var lblName = el.form["label"].value;
        var viewParams = view.getViewParams();
        if(view.type=="Dashboard")
        {
          viewParams+="&PARENTVIEWID="+field.getAttribute("PARENT_OBJ_ID");//NO I18N
        }
        viewParams+="&COLID="+colID+"&LABELNAME="+encodeURIComponent(lblName); //No I18N
        var isDashboard = (view.type=="Dashboard")?true :false;
        viewParams+="&ISDASHBOARDUF="+ isDashboard;//NO I18N
        return viewParams;
    }

    this.validateDefValue = function(el,view,form)
    {
        var defaultValueField = form.defaultValues;
        var dlg = ZDBDialogUtil.focusDialog;
        var field = dlg.field;
        var isAllVal = dlg.modifyProps.isallval;
        var valid = ZAVMFilterEdit.validateNSetDefaultValue(field,defaultValueField);
        var defVal = defaultValueField.value;
        defVal =  ZAVMFilterUtil.trimCommaAtEnd(defVal);
        var subType = dlg.modifyProps.subtype;
        var operation = dlg.modifyProps.operation;
       if(isAllVal == "true" && valid)
       {
            var rel_filter = dlg.modifyProps.rel_criteria;
            var rel_dispFilter = dlg.modifyProps.rel_dispcriteria;
            if(defVal==null || defVal==""){return;}
            var viewParams = ZAVMFilterSearch.ufParameters(view,el,field);
            var colParViewId = field.getAttribute("PARENT_OBJ_ID") != null ? field.getAttribute("PARENT_OBJ_ID").trim() : view.parentViewId ;
            viewParams += "&COLPARENTVIEWID=" + colParViewId;//No I18N
            var url = "/VMDefListFetch.cc?"+ viewParams+"&VMFILTERACTION=VALIDATEDEFVAL"; //No I18N
            url+="&DEFVAL="+encodeURIComponent(defVal);//NO I18N
            subType = "&SUBTYPE="+subType; //No I18N
            operation = "&OPERATION="+operation; //No I18N
            url+=subType+operation;
            url+="&RELCR="+encodeURIComponent(rel_filter);//NO I18N
            url+="&RELDISPCR="+encodeURIComponent(rel_dispFilter);//NO I18N
            var isDashboard = (view.type=="Dashboard")?true :false;
            var doXml = (isDashboard) ? ZDBDStructure.getDashBoardCurrentConfig(view,false) : ZDBAnalysisConfig.getCurrentConfig(view,false);
            AjaxAPI.sendRequest({URL:url,POSTBODY:doXml,
                            REQUESTHEADERS:{"Content-type":"text/xml;charset=utf-8"}, //No I18N
                            ONFAILUREFUNC:ZAVMFilterSearch.hndlDefValFail,
                            VIEW:view,FORM:form,DEFEL:defaultValueField,FIELD:field,
                            ONSUCCESSFUNC:ZAVMFilterSearch.hndlDefValSuccess 
                             });
       }
    }
    
    
    this.hndlDefValSuccess = function(response,requestOptions)
    {
        var defaultValueField = requestOptions["DEFEL"];
        var view = requestOptions["VIEW"];
        var field = requestOptions["FIELD"];
        var form = requestOptions["FORM"];
        var defList = $("defList");
        var dlg = ZDBDialogUtil.focusDialog;
        defList.innerHTML = response.responseText;
        var defEl = $("defCriteria");
        var defCr = ZDBUtil.replaceStr(defEl.getAttribute("DEFCR"),"--D--","\""); //NO I18N
        var defDispCr = ZDBUtil.replaceStr(defEl.getAttribute("DEFDISPCR"),"--D--","\""); //NO I18N
        defDispCr= ZAVMFilterUtil.trimCommaAtEnd(defDispCr);
        dlg.modifyProps.defaultcriteria = defCr;
        dlg.modifyProps.defaultdisplaycriteria = defDispCr;
//        field.setAttribute("DEFAULTCRITERIA", defCr);
//        field.setAttribute("DEFAULTDISPLAYCRITERIA",defDispCr);
        defaultValueField.setAttribute("selDefCr",defCr);
        var defValCr = defEl.getAttribute("DEFVALCR");
        if(defValCr != null)
        {
            defValCr = ZDBUtil.replaceStr(defValCr, "--D--", "\""); //No I18N
            defValCr = ZDBUtil.replaceStr(defValCr, "--S--", "$"); //No I18N
            defaultValueField.setAttribute("defValCr", defValCr);
            var dispVarCr = defEl.getAttribute("DEFDISPVALCR");
            dispVarCr = ZDBUtil.replaceStr(dispVarCr, "--D--", "\""); //No I18N
            dispVarCr = ZAVMFilterUtil.trimCommaAtEnd(dispVarCr);
            field.setAttribute("VALUEOFVAR", defValCr);
            field.setAttribute("DISPVALUEOFVAR", dispVarCr);
        }
        var dlg = ZDBDialogUtil.focusDialog;
        var relFilterEl = DOMUtils.getChildElsWithAttr(dlg,"filterel","true")[1];//No I18N
        var filterEl = DOMUtils.getFirstMatchingChild(dlg,null,"filterel","true");//No I18N
        ZAVMFilterEdit.updateValuesNCloseDlg(view, form, filterEl, relFilterEl);
        
    }
    this.hndlDefValFail = function(response,requestOptions)
    {
        var defaultValueField = requestOptions["DEFEL"];
        var errCode = response.getResponsePart("ERRORCODE");
        errCode = trimAll(errCode);
        if(errCode == "DEFVAL_NOTVALID")
        {
            showCustomMessage(response.getResponsePart("STATUS_MESSAGE"),defaultValueField);
            $("customAlertMessage").style.width = "auto";
            $("_CUSTOMALERTFRAME").style.width = "auto";
        }
        else
        {
            AjaxAPI.onFailureFunc(response,requestOptions);
        }
    }
     this.ReplaceAll = function(Source,stringToFind,stringToReplace)
     {
        var temp = Source;
        var index = temp.indexOf(stringToFind);
        while(index != -1)
        {
            temp = temp.replace(stringToFind,stringToReplace);
            index = temp.indexOf(stringToFind);
        }
        return temp;
    }

}
