/* $Id$ */
//ignorei18n_start
var ZRSZiaClass = function () {
    this.apiToUse = window.location.href.indexOf('zia') > 0 ? '/zia/reportsnlp/' : '/reportsnlp/';
    this.tableOBJId = null;
    this.folderList = null;
    this.dashboardList = null;
    this.autosuggester = null;
    this.transitioningRightSideBar = null;
    this.reports = null;
    this.redisKey = null;
    this.genReportResp = null;
    this.loader = null;
    this.opened = false;
    this.recentQueryToggleLink = null;
    this.loadingRecentQueries = null;
    this.loadedRecentQueries = null;
    this.tableToColMap = {};
    this.chartHolderComponent = ZRSStringTemplateCreator.createTemplateForData('zrsziaChartBoxHolder', 'zrszia', true);
    this.initializeNLPSearch = function () {
        if(this.autosuggester === null || this.autosuggester === undefined || this.autosuggester.tableObjId !== this.tableOBJId) {
            if(this.autosuggester) {
                AutoSuggest.close(this.autosuggester);
            }
            this.autosuggester = new AutoSuggest({
                uiConfig : {
                    holder: document.getElementById('ZRNLPInputHolder'),
                    searchBox: {
                        style: {},
                        customAttributes: {}
                    },
                    suggestionBox: {
                        style: {},
                        customAttributes: {}
                    }
                },
                metaConfig : {
                    suggestionRequest: this.apiToUse + 'getsuggestions',
                    alternateSuggestionRequest: this.apiToUse + 'autosuggestalternatesuggestions',
                    completionRequestHandler: this.sendGraphGenerateRequestb,
                    suggestionRequestParams: 'DBID='
                            + ZDBClientUI.dbId
                            + (this.tableOBJId ? '&TABLEID=' + this.tableOBJId : ''),
                    alternateSuggestionRequestParams: 'DBID='
                            + ZDBClientUI.dbId
                            + (this.tableOBJId ? '&TABLEID=' + this.tableOBJId : '')
                }
            });
            this.autosuggester.tableObjId = this.tableOBJId;
            this.removeRecentAndSuggQueryLoadedDiv();
            this.createRecentAndSuggQueryLoadingDiv();
            setTimeout(function () {
                AutoSuggest.Ajax.sendRequest({
                    URL: this.apiToUse + 'querysuggestions',
                    METHOD: 'GET',
                    DEFAULTPARAMS: 'DBID=' + ZDBClientUI.dbId + (this.tableOBJId ? '&TABLEID=' + this.tableOBJId : ''),
                    ONSUCCESSFUNC: this.handleQuerySuggestionSuccess,
                    ONFAILUREFUNC: this.handleQuerySuggestionFailure,
                    OBJCTX: this
                });
            }.bind(this), 500);
        }
        else {
            this.showRecentAndSuggestedQueries();
        }

//        this.autosuggester = new AutoSuggest({
//            uiConfig : {
//                holder: document.getElementById('ZRNLPInputHolder'),
//                searchBox: {
//                    style: {},
//                    customAttributes: {}
//                },
//                suggestionBox: {
//                    style: {},
//                    customAttributes: {}
//                }
//            },
//            metaConfig : {
//                suggestionRequest: this.apiToUse + 'getsuggestions',
//                alternateSuggestionRequest: this.apiToUse + 'autosuggestalternatesuggestions',
//                completionRequestHandler: this.sendGraphGenerateRequestb,
//                suggestionRequestParams: 'DBID='
//                        + ZDBClientUI.dbId
//                        + (this.tableOBJId ? '&TABLEID=' + this.tableOBJId : ''),
//                alternateSuggestionRequestParams: 'DBID='
//                        + ZDBClientUI.dbId
//                        + (this.tableOBJId ? '&TABLEID=' + this.tableOBJId : '')
//            }
//        });
//        this.removeRecentAndSuggQueryLoadedDiv();
//        this.createRecentAndSuggQueryLoadingDiv();
//        setTimeout(function () {
//            AutoSuggest.Ajax.sendRequest({
//                URL: this.apiToUse + 'querysuggestions',
//                METHOD: 'GET',
//                DEFAULTPARAMS: 'DBID=' + ZDBClientUI.dbId + (this.tableOBJId ? '&TABLEID=' + this.tableOBJId : ''),
//                ONSUCCESSFUNC: this.handleQuerySuggestionSuccess,
//                ONFAILUREFUNC: this.handleQuerySuggestionFailure,
//                OBJCTX: this
//            });
//        }.bind(this), 500);
    };
    
    this.createRecentAndSuggQueryLoadingDiv = function () {
        this.loadingRecentQueries = ZRSStringTemplateCreator.createTemplateForData('zrsZiaRecentNSuggQueryLoading', 'zrszia');
        this.transitioningRightSideBar.contentBody.insertBefore(this.loadingRecentQueries, document.getElementById('ZRNLPSearchHolder').nextSibling);
    };
    
    this.removeRecentAndSuggQueryLoadingDiv = function () {
        this.loadingRecentQueries && this.loadingRecentQueries.parentNode.removeChild(this.loadingRecentQueries);
        this.loadingRecentQueries = null;
    };
    
    this.removeRecentAndSuggQueryLoadedDiv = function () {
        this.loadedRecentQueries && this.loadedRecentQueries.parentNode.removeChild(this.loadedRecentQueries);
        this.recentQueryToggleLink && this.recentQueryToggleLink.parentNode.removeChild(this.recentQueryToggleLink);
        this.loadedRecentQueries = null;
        this.recentQueryToggleLink = null;
    };
    
    this.handleQuerySuggestionSuccess = function (response, config) {
        this.removeRecentAndSuggQueryLoadingDiv();
        response = JSON.parse(response);
        var dynamicMeta = AutoSuggest.GeneralUtils.duplicateObject(ZRSZia_Model.zrsZiaRecentNSuggQueryLoading);
        var suggestedQuery = response.querysuggestion;
        var htmlEncoder = AutoSuggest.Encoder.getHTMLEncoder();
        var jsEncoder = AutoSuggest.Encoder.getJSEncoder();
        if(suggestedQuery){
            var sugQuery = [];
            for(var i=0,len=suggestedQuery.length; i<10 && i<len; i++) {
                var htmlEncodedValue = htmlEncoder.encode(suggestedQuery[i]);
                var attributeEncodedValue = jsEncoder.encode(htmlEncodedValue);
                sugQuery.push({query: htmlEncodedValue, paramQuery: attributeEncodedValue});
            }
            dynamicMeta.suggQuery = sugQuery;
        }
        else {
            dynamicMeta.suggQuery= [];
            dynamicMeta.emptySuggQuery = {condition: true, data: {suggQueryEmpty: ZDBI18NMap.g('zrpt.zia.js.emptysuggquery')}};
        }
        var recentQuery = response.recentsuggestion;
        if(recentQuery) {
            var recentQuery = [];
            for(var i=0,len=recentQuery.length; i<len; i++) {
                var htmlEncodedValue = htmlEncoder.encode(recentQuery[i]);
                var attributeEncodedValue = jsEncoder.encode(htmlEncodedValue);
                recentQuery.push({query: htmlEncodedValue, paramQuery: attributeEncodedValue});
            }
            dynamicMeta.recentQuery = recentQuery;
        }
        else {
            dynamicMeta.recentQuery= [];
            dynamicMeta.emptyRecentQuery = {condition: true, data: {recentQueryEmpty: ZDBI18NMap.g('zrpt.zia.js.emptyrecentquery')}};
        }
        this.loadedRecentQueries = ZRSStringTemplateCreator.createTemplateForDynamicData('zrsZiaRecentNSuggQuery', 'zrszia', false, dynamicMeta);
        this.recentQueryToggleLink = AutoSuggest.DomCreator.getDivWithGivenOptions({
            class: 'ZRSLink zrsziaRecentToggle'
        });
        this.recentQueryToggleLink.innerText = ZDBI18NMap.g('zrpt.zia.js.togglerecentquery');
        this.recentQueryToggleLink.addEventListener('click', this.toggleRecentQueriesb);
        var nlpHolder = document.getElementById('ZRNLPSearchHolder');
        this.transitioningRightSideBar.contentBody.insertBefore(this.loadedRecentQueries, nlpHolder.nextSibling);
        this.transitioningRightSideBar.contentBody.insertBefore(this.recentQueryToggleLink, nlpHolder.nextSibling);
    };
    
    this.toggleRecentQueries = function(event) {
        event.preventDefault();
        this.toggleRecentAndSuggestedQueries();
    };
    
    this.toggleRecentQueriesb = this.toggleRecentQueries.bind(this);
    
    this.handleQuerySelection = function (target) {
        var innerText = target.getAttribute('query');
        var searchBoxObj = ZRSZia.autosuggester.renderer.searchBox;
        var metaHandler = ZRSZia.autosuggester.metaHandler;
        var textParser = searchBoxObj.textParser;
        textParser.resetTextBoxValue(innerText);
        searchBoxObj.updateRender();
        searchBoxObj.inputBox.value = '';
        searchBoxObj.inputBox.style.display = 'inline-block';
        searchBoxObj.inputBox.style.opacity = '1';
        metaHandler.getSuggestions(false, metaHandler.triggerCompletionRequestHandler, metaHandler);
    };
    
    this.handleQuerySuggestionFailure = function () {
        this.removeRecentAndSuggQueryLoadingDiv();
    };
    
    this.toggleRecentAndSuggestedQueries = function () {
        AutoSuggest.GeneralUtils.toggleClass(this.loadedRecentQueries, 'hide');
    };
    
    this.hideRecentAndSuggestedQueries = function () {
        AutoSuggest.GeneralUtils.addClass(this.loadedRecentQueries, 'hide');
    };
    
    this.showRecentAndSuggestedQueries = function () {
        AutoSuggest.GeneralUtils.removeClass(this.loadedRecentQueries, 'hide');
    };
    
    this.addLoader = function() {
        this.loader = AutoSuggest.DomCreator.getDivWithGivenOptions({
            class: 'cardViewLoading'
        });
        this.transitioningRightSideBar.contentBody.appendChild(this.loader);
    };
    
    this.removeLoader = function () {
        this.loader.parentNode.removeChild(this.loader);
    };
    
    this.sendGraphGenerateRequest = function (json) {
        this.hideRecentAndSuggestedQueries();
        this.resetView();
        this.addLoader();
        var params = 'DBID=' + ZDBClientUI.dbId + '&MODELTYPE=1' + '&NLPTEXT='
                + encodeURIComponent(JSON.stringify(json))
                + (this.tableOBJId ? '&TABLEID=' + this.tableOBJId : '');
        AutoSuggest.Ajax.sendRequest({
            URL: this.apiToUse + 'createreport',
            METHOD: 'POST',
            DEFAULTPARAMS: params,
            ONSUCCESSFUNC: this.handleGraphGenerationSuccessb
        });
    };
    this.sendGraphGenerateRequestb = this.sendGraphGenerateRequest.bind(this);

    this.handleGraphGenerationSuccess = function (response) {
        this.removeLoader();
        this.genReportResp = JSON.parse(response);
        this.reports = this.genReportResp.reports;
        this.redisKey = this.genReportResp.rediskey;
        if (this.reports.length > 0) {
            this.placeTemplates();
            this.fillTemplates();
            this.transitioningRightSideBar.contentBody.addEventListener(
                    'scroll', function (event) {
                        if (typeof ZDBAnalysisUtil !== 'undefined' && ZDBAnalysisView.miniChartTypeDlg) {
                            ZDBAnalysisUtil.closeChartChooser(event);
                        }
                        ZRSMenu_controller.closeOpenedMenus();
                    });
        }
    };
    this.handleGraphGenerationSuccessb = this.handleGraphGenerationSuccess.bind(this);

    this.placeTemplates = function () {
        this.resetView();
        for (var i = 0, len = this.reports.length; i < len; i++) {
            var template = this.getHTML(this.chartHolderComponent);
            template.setAttribute('chartIndex', i);
            this.transitioningRightSideBar.contentBody.appendChild(template);
        }
    };

    this.fillTemplates = function () {
        var tab = this.transitioningRightSideBar.contentBody.querySelector('.zrsziaChart[chartIndex="' + 0 + '"]');
        this.placeReportsb(0, tab.querySelector('.zrsziaChartHolder'), true, 1);
        this.updateInterpretedQuery(tab, 0);
    };

    this.fetchNextChart = function (index) {
        if (this.reports[index]) {
            var tab = this.transitioningRightSideBar.contentBody.querySelector('.zrsziaChart[chartIndex="' + index + '"]');
            this.placeReportsb(index, tab.querySelector('.zrsziaChartHolder'), true, index + 1);
            this.updateInterpretedQuery(tab, index);
        }
    };

    this.getHTML = function (str) {
        var div = document.createElement('div');
        div.innerHTML = str;
        return div.firstChild;
    };

    this.resetView = function () {
        var chartsRendered = this.transitioningRightSideBar.contentBody.querySelectorAll('.zrsziaChart');
        var i, len;
        for (i = 0, len = chartsRendered.length; i < len; i++) {
            var tabHolder = chartsRendered[i];
            var tab = tabHolder.querySelector('.zrsziaChartHolder');
            if (tab.view && tab.view.analysisArea) {
                tab.view.removeView();
                tab.view.analysisArea.parentNode.removeChild(tab.view.analysisArea);
                window.removeEventListener('resize', tab.view.viewCtx.handleResizeb);
            }
            tab.view = null;
            tabHolder.parentNode.removeChild(tabHolder);
        }
    };

    this.placeReports = function (index, tab, triggerSubsequentReqs, subReqIndex) {
        var curReport = this.reports[index];
        tab = tab ? tab : this.transitioningRightSideBar.contentBody.querySelector('.zrsziaChartHolder');
        tab.ziaIndex = index;
        var view = new DummyView(ZDBClientUI.curDummyViewId--, null, null, null, this.redisKey + '_' + index, curReport.parentobjid);
        tab.viewCtx = new ZRSZiaViewCtx({
            standAlone: ZDBClientUI.standAlone,
            tab: tab,
            isZia: true,
            triggerSubsequentReqs: triggerSubsequentReqs,
            subReqIndex: subReqIndex,
            loadIndicator: tab.querySelector('[classPrefix]')
        });
        ZDBClientUI.initializeTab(tab, view, null);
        ZDBAnalysisViewAPI.fetchView(ZDBClientUI.curDummyViewId--, tab.viewCtx, false);
    };

    this.placeReportsb = this.placeReports.bind(this);

    this.updateInterpretedQuery = function (tab, index) {
        var interpQryHolder = tab.querySelector('.zrsziaChartInterpQuery');
        var html = this.getHTML(this.reports[index].interpretedQuery);
        html.style.display = 'inline-block';
        interpQryHolder.appendChild(html);
    };

    this.closeZia = function () {
//        AutoSuggest.close(this.autosuggester);
        this.opened = false;
//        this.autosuggester = null;
        this.tableOBJId = null;
        ZRSCommonComponents_Controller.transitioningRightSideBar_controller.close(this.transitioningRightSideBar, true);
//        this.removeRecentAndSuggQueryLoadingDiv();
//        this.removeRecentAndSuggQueryLoadedDiv();
//        this.resetView();
        document.removeEventListener('keyup', this.handleZiaCloseb);
        window.removeEventListener('resize', this.handleResizeb);
        ZDBNavigation.closeNavViewList(null, true);
    };

    this.handleZiaClose = function (event) {
        var key = event.keyCode || event.which || event.key;
        if (parseInt(key) === KEY.ESC) {
            this.closeZia();
        }
    };
    this.handleZiaCloseb = this.handleZiaClose.bind(this);
    this.openNewZia = function (isGlobal) {
        if(!this.opened) {
            this.opened = true;
            isGlobal = typeof isGlobal === 'boolean' ? isGlobal : false;
            if (!this.transitioningRightSideBar) {
                this.transitioningRightSideBar = ZRSCommonComponents_Controller.transitioningRightSideBar_controller.getTransitioningRightSideBarForModel({
                    titleText: ZDBI18NMap.g('zrpt.common.js.askzia'),
                    bodyContent: ZRSStringTemplateCreator.createTemplateForData('zrsziaSearchHolder', 'zrszia', true),
                    needHelpIcon: {
                        condition: true,
                        data: {
                            helpText: ZDBI18NMap.g('zrpt.common.js.help')
                        }
                    },
                    needCloseIcon: {
                        condition: true,
                        data: {
                            closeText: ZDBI18NMap.g('zrpt.diabloginfo.js.close'),
                            onClickHandler: 'ZRSZia.closeZia();'
                        }
                    }
                });
            }
            this.tableOBJId = isGlobal ? null : ZDBCreateViewAPI.getTableObjectIdForView(ZDBClientUI.selectedTab.view);
            ZRSCommonComponents_Controller.transitioningRightSideBar_controller.show(this.transitioningRightSideBar, this.initializeNLPSearch, this);
            document.addEventListener('keyup', this.handleZiaCloseb);
            ZDBLazyLoadUtil.loadExternalSVG("themes/common/svgimages/nlpicons.svg");//NO I18N
        }
    };
    this.openNewZiab = this.openNewZia.bind(this);

    this.handleViewLoadingFailure = function (response, requestOptions) {
        //need to handle failure cases.
        var tab = requestOptions.VIEW.tab;
        tab.view = null;
        var viewHolder = tab.querySelector('[zdbaworkareaparent]');
        tab.removeChild(viewHolder);
        var errorInfoDiv = tab.querySelector('.errorHolderDiv');
        ZDBUtil.removeClass(errorInfoDiv, 'hide');
        errorInfoDiv.innerHTML = response.getResponsePart('STATUS_MESSAGE');
    };
    this.changeChartType = function (event) {
        if (!ZDBLazyLoadUtil.loadJsAlone(["zdbjs/analysisview/ZDBOtherChart.js"], this, this.changeChartType, [event], 'ZDBMainLoader')) {
            return;
        }
        event.stopPropagation();
        var target = event.target;
        var tab = DOMUtils.getSelfOrParentWithAttr(target, 'chartHolder').querySelector('.zrsziaChartHolder');
        ZDBChartOptions.miniChartChooser(target, tab.view);
        var bounds = target.getBoundingClientRect();
        ZDBAnalysisView.miniChartTypeDlg.style.top = ((ZDBClientUI.standAlone && ZDBGlobal.IS_MOBILE) ? ZDBUtil.getObjTop(target, true) : bounds.top) + bounds.height + 2 + "px";
        ZDBAnalysisView.miniChartTypeDlg.style.left = bounds.left + bounds.width - ZDBAnalysisView.miniChartTypeDlg.offsetWidth + "px";
    };
    this.saveChart = function (event, fromMenu) {
        var target = fromMenu ? DOMUtils.getSelfOrParentWithTagName(event.target, 'ul').srcEl : event.target;
        var tab = DOMUtils.getSelfOrParentWithAttr(target, 'chartHolder').querySelector('.zrsziaChartHolder');
        if (!ZRSZia.folderList) {
            ZRSZia.fetchFolderList(ZRSZia.saveChart, ZRSZia, [event, fromMenu], tab.querySelector('.cardViewLoaded'));
            return;
        }
        var saveDialogData = {
            namelabel: 'Name',
            namevalue: tab.parentNode.querySelector('.zrsziaChartInterpQuery p').innerText,
            nameplaceholder: ZDBI18NMap.g('zrpt.zia.js.enternameforview'),
            folderlabel: 'Folder',
            descriptionlabel: 'Description',
            descriptionvalue: '',
            descriptionplaceholder: ZDBI18NMap.g('zrpt.zia.js.enterdescforview'),
            proceedText: ZDBI18NMap.g("zrpt.toolbar.filter.js.save"),
            cancelText: ZDBI18NMap.g("zrpt.dialoginfo.js.cancelbtn"),
            optionsData: [],
            okhandler: 'ZRSZia.handleSaveChart(event)',
            cancelhandler: 'ZRSZia_controller.innerDialog.close(event);'
        };
        var selectedIndex = 0;
        for (var i = 0, len = ZRSZia.folderList.length; i < len; i++) {
            var curFolder = ZRSZia.folderList[i];
            saveDialogData.optionsData.push({
                value: curFolder[0],
                text: curFolder[1]
            });
            if (curFolder[4]) {
                selectedIndex = i;
            }
        }
        var dynamicData = {
            bodyContent: ZRSStringTemplateCreator.createTemplateForDynamicData('zrsziaSaveDialog', 'zrszia', true, saveDialogData),
            dialogTitle: ZDBI18NMap.g("zrpt.toolbar.filter.js.save")
        };
        ZRSZia_controller.innerDialog.show(dynamicData, tab.parentNode);
        var saveDialog = ZRSZia_controller.innerDialog.shownDialog.body.firstChild;
        ZDBUtil.setNamedChildEls(saveDialog, saveDialog);
        saveDialog.nameBox.select();
        saveDialog.selectBox.selectedIndex = selectedIndex;
        ZRSZia.folderList = null;
        delete saveDialogData;
        delete dynamicData;
    };
    this.handleSaveChart = function (event) {
        console.log('handlesave');
        var saveDialog = ZRSZia_controller.innerDialog.shownDialog.body.firstChild;
        var nameBoxValue = saveDialog.nameBox.value;
        var descBoxValue = saveDialog.descBox.value;
        var selectBoxValue = saveDialog.selectBox.value;
        if (!nameBoxValue) {
            saveDialog.nameBox.select();
            return;
        }
        var tab = ZRSZia_controller.innerDialog.shownDialog.parentNode.querySelector('.zrsziaChartHolder');
        var view = tab.view;
        view.newName = nameBoxValue;
        view.newDesc = descBoxValue;
        view.folderId = selectBoxValue;
        view.save({
            tab: tab
        });
    };
    this.fetchFolderList = function (callback, callbackCtx, callbackArgs, loader) {
        ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/FOLDERLIST', null, {
            successHandler: {
                func: ZRSZia.handleFolderListSuccess,
                ctx: ZRSZia
            },
            callback: callback,
            callbackCtx: callbackCtx,
            callbackArgs: callbackArgs,
            loader: loader
        });

    };
    this.fetchDashboardList = function (callback, callbackCtx, callbackArgs, loader) {
        ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/MYDASHBOARDS', null, {
            successHandler: {
                func: ZRSZia.handleFolderListSuccess,
                ctx: ZRSZia
            },
            callback: callback,
            callbackCtx: callbackCtx,
            callbackArgs: callbackArgs,
            loader: loader
        });
    };
    this.handleFolderListSuccess = function (response, config) {
        console.log(response);
        ZRSZia.folderList = response.folderListValues;
        config.callback.apply(config.callbackCtx, config.callbackArgs);
    };
    this.handleSaveSuccess = function (response, requestOptions) {
        var json = JSON.parse(response.responseText);
        ZDBMsgBox.showViewSavedMsg(json.displayName);
        ZRSZia_controller.innerDialog.close();
        var tab = requestOptions.ORIGREQOPTIONS.tab;
        tab.view.objId = json.objId;
        tab.view.displayName = json.displayName;
        ZDBNavigation.refreshExplorer();
        this.updateToolbar(tab);
    };
    this.handleSaveFailure = function (response, requestOptions) {
        var knownFailure = AjaxUtils.extractFromResponse(response.responseText, 'ERRORNUMCODE').trim() === "7111";
        ZDBMsgBox.showError(AjaxUtils.extractFromResponse(response.responseText, 'STATUS_MESSAGE').trim());
        var nameBox = ZRSZia_controller.innerDialog.shownDialog.body.firstChild.nameBox;
        nameBox.focus();
    };
    this.addToDashboard = function (event, fromMenu) {};
    this.openView = function (event, fromMenu, openInEditMode) {
        if(!ZDBLazyLoadUtil.loadJsAlone(["ZDBAnalysisEditList"],this,this.openView,[event, fromMenu, openInEditMode]))
        {
            return;
        }
        if (!fromMenu) {
            event.stopPropagation();
        }
        ZDBToolTip.hide(event, true);
        var target = fromMenu ? DOMUtils.getSelfOrParentWithTagName(event.target, 'ul').srcEl : event.target;
        var tab = DOMUtils.getSelfOrParentWithAttr(target, 'chartHolder').querySelector('.zrsziaChartHolder');
        var view = tab.view;
        var prevTab = ZDBClientUI.getExistingTab(view.objId);
        if (prevTab) {
            ZDBClientUI.selectTab(prevTab);
            ZDBClientUI.resizePlaceHolder();
            if (openInEditMode) {
                prevTab.view.toolbar.querySelector('#ZDBAnalysisEdit').click();
            } else {
                prevTab.view.resize(true);
            }
        } else {
            if (parseFloat(view.objId) > 0) {
                ZDBClientUI.fetchView(view.objId, ZDBClientUI.dbId, view.displayName, view.type, null, null, view.parentViewId, openInEditMode);
            } else {
                var viewName = ZDBI18NMap.g(ZDBClientUI.typeDefns[view.type].newName);
                var newTab = ZDBClientUI.createUpdateDummyTab(ZDBClientUI.curDummyViewId--, viewName, view.type, null, view.viewCtx.objKey, view.parentViewId);
                ZDBClientUI.selectTab(newTab);
                newTab.view.parentViewId = view.parentViewId;
                newTab.view.objKey = view.viewCtx.objKey;
//                ZDBClientUI.fetchView(ZDBClientUI.curDummyViewId--, ZDBClientUI.dbId, viewName, view.type, newTab, view.viewCtx.objKey, view.parentViewId, true);
                ZDBClientUI.typeDefns[view.type].createView(newTab.view.viewCtx,view.type,ZDBClientUI.dbId,view.parentViewId, viewName,ZDBClientUI.curDummyViewId--);
//                debugger;
//                newTab.view.parentViewId = view.parentViewId;
//                newTab.view.objKey = view.viewCtx.objKey;
//                ZDBClientUI.selectTab(newTab);
//                ZDBClientUI.typeDefns[view.type].createView(newTab.view.viewCtx, view.type, ZDBClientUI.dbId, view.parentViewId, view.parDispName, tab.view.objId);
//                ZDBClientUI.fetchView(ZDBClientUI.curDummyViewId--, ZDBClientUI.dbId, viewName, view.type, null, view.viewCtx.objKey, view.parentViewId, true);
            }
        }
        this.closeZia();
    };
    this.openViewb = this.openView.bind(this);
    this.updateToolbar = function (tab) {
        var toolbar = tab.parentNode.querySelector('.zrsziaChartToolbar').firstChild;
        var firstTwoChild = toolbar.querySelectorAll('div[action="changeChartType"]');
        var saveIcon = toolbar.querySelector('div[action="chartSave"]');
        var saveDisp = tab.view.objId > 0 ? ' hide' : '';
        var openView = toolbar.querySelector('div[action="chartOpen"]');
        openView.setAttribute('class', openView.getAttribute('class').replace('hide', '') + (saveDisp ? '' : ' hide'));
        saveIcon.setAttribute('class', saveIcon.getAttribute('class').replace('hide', '') + saveDisp);
        var func = tab.view.typeValue === ZDBClientViewAPI.TYPE_ANALYSISVIEW ? '' : ' hide';
        for (var i = 0, len = firstTwoChild.length; i < len; i++) {
            firstTwoChild[i].setAttribute('class', firstTwoChild[i].getAttribute('class').replace('hide', '') + func);
        }
    };
    this.getDataModel = function () {
        AutoSuggest.Ajax.sendRequest({
            URL: this.apiToUse + 'getdatamodel',
            METHOD: 'GET',
            DEFAULTPARAMS: 'DBID=' + ZDBClientUI.dbId + (this.tableOBJId ? '&TABLEID=' + this.tableOBJId : ''),
            ONSUCCESSFUNC: this.openDataModel,
            OBJCTX: this
        });
    };
    
    this.openDataModel = function (response, config) {
        response = JSON.parse(response);
        if (response) {
            ZRSZia.tableToColMap = {};
            var tables = Object.keys(response);
            for (var i = 0, len = tables.length; i < len; i++) {
                var curTab = tables[i];
                var curColList = Object.keys(response[curTab]);
                var temp = [];
                for(var j=0,len2=curColList.length; j<len2; j++) {
                    temp.push({columnText: curColList[j]});
                }
                ZRSZia.tableToColMap[curTab] = temp;
            }
//            var tables = Object.keys(ZRSZia.tableToColMap);
            var totalRender = '';
            for (var i = 0, len = tables.length; i < len; i++) {
                var curTable = tables[i];
                var curTablesCols = ZRSZia.tableToColMap[curTable];
                totalRender += ZRSStringTemplateCreator.createTemplateForDynamicData('zrsziadatamodeltabncol', 'zrszia', true, {
                    tableText: curTable,
                    columns: curTablesCols.length > ZRSZia_Model.zrsziadatamodeltabncol.initialColRendCount ? curTablesCols.slice(0, ZRSZia_Model.zrsziadatamodeltabncol.initialColRendCount) : curTablesCols,
                    columnsTrunc: {
                        condition: curTablesCols.length > ZRSZia_Model.zrsziadatamodeltabncol.initialColRendCount,
                        data: {
                            onclickHandler: 'ZRSZia_controller.zrsziadatamodeltabncol.moreLessEvent(event);',
                            moreText: ZDBI18NMap.g('zrpt.common.import.moreorless.js.More'),
                            tableName: curTable
                        }
                    }
                });
            }
            var dynamicData = {
                bodyContent: ZRSStringTemplateCreator.createTemplateForDynamicData('zrsziadatamodelbase', 'zrszia', true, {dataModelBody: totalRender}),
                dialogTitle: ZDBI18NMap.g("zrpt.zia.js.dm")
            };
            ZRSZia_controller.innerDialog.show(dynamicData, ZRSZia.transitioningRightSideBar.contentBody);
        }
    };
    this.showChartInfoDlg = function (event) {
        event.stopPropagation();
        ZDBToolTip.hide();
        ZRSZia_controller.zrsziaChartInfoDialog.closeDlg();
        var tab = DOMUtils.getElOrParentWithAttr(event.target, 'chartIndex');
        var chartIndex = tab.getAttribute('chartIndex');
        var chartInfo = this.genReportResp.reports[chartIndex].reportdesc;
        console.log(chartInfo);
        ZRSZia_controller.zrsziaChartInfoDialog.show(chartInfo, tab);
    };
    this.showChartInfoDlgb = this.showChartInfoDlg.bind(this);
    return this;
};

function ZRSZiaViewCtx(params) {
    this.base = ZDBDefViewCtx;
    this.base(params);
    this.handle = function (view) {
        ZDBClientUI.initializeTab(this.tab, view, null);
        window.addEventListener('resize', this.handleResizeb);
        this.tab.appendChild(view.analysisArea);
        ZRSZia.updateToolbar(this.tab);
        this.tab.viewLoaded = true;
        if (this.triggerSubsequentReqs) {
            ZRSZia.fetchNextChart(this.subReqIndex);
        }
    };
    this.handleResize = function () {
        if (this.windowResizeTimeout !== null) {
            clearTimeout(this.windowResizeTimeout);
        }
        this.windowResizeTimeout = setTimeout(function(){this.tab.view.resize.apply(this.tab.view);}.bind(this), 500);
    };
    this.handleResizeb = this.handleResize.bind(this);
}

ZRSZiaViewCtx.prototype = new ZDBDefViewCtx;

var ZRSZia = new ZRSZiaClass();

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRSZia.openNewZiab"] = ZRSZia.openNewZiab;
//ignorei18n_end