//$Id$
canvas_drawer.line = function() {
    
    var x = canvasUtils.pointX,
        y = canvasUtils.pointY,
        defined = false,
        context = null,
        curve = canvasInterpolation.linear,
        output = null;
    
    function line(data) {
        var i,
            n = data.length,
            d,
            defined0 = false,
            buffer;
        if (context == null) {
            output = curve(buffer = d3Path.path());
        }
        
        for (i = 0; i <= n; ++i) {
            if (!(i < n && defined(d = data[i], i, data)) === defined0) {
                if (defined0 = !defined0) {
                    output.lineStart();
                } else {
                    output.lineEnd();
                }
            }
            if (defined0) {
                output.point(+x(d, i, data), +y(d, i, data));
            }
        }
        if (buffer) {
            return output = null, buffer + "" || null;
        }
    }
    
    line.x = function(_) {
        x = _;
        return line;
    };
    line.y = function(_) {
        y = _;
        return line;
    };
    line.defined = function(_) {
        defined = _;
        return line;
    };
    line.interpolate = function(_) {
        _ = (canvasInterpolation[_]) ? canvasInterpolation[_] : canvasInterpolation.linear;
        curve = _;
        output = curve(context);
        return line;
    };
    line.context = function(_) {
        context = _;
        return line;
    };
    return line;
};