//$Id$
$ZC._GeoChart.getLeaflet = function(_abstractMapObj) {
    var _update, _setupMapEvents, _createStaticPane, _createChartPane;
    var mapObj = function(container, map) {
        this.container = container;
        this.map = map;
        this.plotted_data = null;
        this.unknowndata_Key = null;
        this.basegeorole = null;
    };
    mapObj.prototype = Object.create(_abstractMapObj);
    
    mapObj.prototype.fitBounds = function() {
        var bound;
        var arg0 = arguments[0];
        if (arg0 == null) {
            return;
        }
        if (arg0 instanceof Array) {
            var points = arg0;
            if (points.length > 0) {
                bound = L.latLngBounds(points);
            } else {
                return;
            }
        } else {
            var southWest = arg0.southWest,
                northEast = arg0.northEast;
            bound = L.latLngBounds(L.latLng(southWest.lat, southWest.lng), L.latLng(northEast.lat, northEast.lng));
        }
        var prop = arguments[1];
        this.map.fitBounds(bound, prop);
    };
    mapObj.prototype.disable = function() {
        this.map.zoomControl.remove();
        this.map.scrollWheelZoom.disable()
        this.map.dragging.disable()
        this.map.touchZoom.disable()
        this.map.doubleClickZoom.disable()
        this.map.boxZoom.disable()
        this.map.keyboard.disable()
        if (this.map.tap) {
            this.map.tap.disable()
        }
    };
    
    return mapObj;
};