//$Id$
$ZC.zohoreports = function(userProp) {
    // $ZCG.calcfontSize(denominator);
    var zohoreports = {
        
        "canvas": {
            "title": {
                "show": true,
                "marginBottom": 10,
                "fontColor": "#22c48a",
                "fontSize": 16,
                "fontFamily": "Roboto"
            },
            "subtitle": {
                "show": false,
                "text": "description",
                "hAlign": "center",
                "marginLeft": 0,
                "fontColor": "#CCCCCC"
            },
            "border": {
                "radius": 0,
                "color": "red"
            },
            "shadow": {
                "x": 0,
                "y": 0
            },
        },
        "chart": {
            "marginTop": 20,
            "axes": {
                "xaxis": {
                    "label": {
                        "fontColor": "#363636",
                        "fontFamily": null,
                        "marginTop": 0,
                        "marginRight": 0,
                        "marginBottom": 0,
                        "marginLeft": 0
                    },
                    "ticklabel": {
                        "fontColor": "#696969",
                        "fontFamily": null
                    },
                    "tickmark": {
                        "color": "#909090",
                        "size": 4,
                        "strokeWidth": 2
                    }
                },
                "yaxis": [{
                    "label": {
                        "fontFamily": null,
                        "fontColor": "#363636",
                        "marginTop": 0,
                        "marginRight": 10,
                        "marginBottom": 0,
                        "marginLeft": 10
                    },
                    "ticklabel": {
                        "fontColor": "#696969",
                        "fontFamily": null
                    },
                    "tickmark": {
                        "color": "#909090",
                        "size": 4,
                        "strokeWidth": 2
                    }
                }]
            },
            "plot": {
                "events": {
                    "click": "viewUDJS" // On click on the plot, user function can be binded, el and event will be passed
                },
                "datalabels": {
                    "show": false,
                    "fontColor": "#696969",
                    "fontSize": "11"
                },
                "plotoptions": {
                    "bar": {
                        "levelMarker": {
                            "color": "rgba(0,0,0,0.2)"
                        },
                        "datalabels": {
                            "padding": 5
                        },
                        "interPadding": 0.07,
                        "gradients": {
                            "type": "linear",
                            "options": {
                                "linear": {
                                    "y2": 100,
                                    "colorGamma": [0.4, 0]
                                }
                            }
                        }
                    },
                    "line": {
                        "marker": {
                            "innerFillColor": "white",
                            "outerStrokeWidth": 1
                        },
                        "hoveroptions": {
                            "outerFillColor": "white",
                            "outerFillOpacity": 1,
                            "outerStrokeOpacity": 1
                        }
                    },
                    "pie": {
                        "strokeColor": "transparent",
                        "datalabels": {
                            "innerLabel": {
                                "fontColor": "rgba(255,255,255,1)"
                            }
                        },
                        "gradients": {
                            "type": "linear",
                            "options": {
                                "linear": {
                                    "y2": 100,
                                    "colorGamma": [0.55, 0]
                                }
                            }
                        }
                    },
                    "funnel": {
                        "datalabels": {
                            "innerLabel": {
                                "fontColor": "rgba(255,255,255,1)"
                            }
                        }
                    },
                    "scatter": {
                        "hoveroptions": {
                            "outerStrokeWidth": 1
                        }
                    }
                }
            }
        },
        "legend": {
            "fontColor": "#696969",
            "itemMargin": 7,
            "title": {
                "show": true
            },
            "fontSize": "12",
            "colorPallete": {
                "options": {
                    "multicolor": "zoho-reports-new"
                }
            }
        },
        "tooltip": {
            "borderColor": "white",
            "lineHeight": "15",
            "fontSize": 12,
            "fontColor": "white",
            "opacity": 0.9,
            "zindex": 1000,
            "shadow": "0px 5px 5px rgba(0,0,0,0.2)"
        }
    };
    return zohoreports;
};