//$Id$
function get_threshold_text_orient(orient) {
    return /(left|right)/.test(orient) ? "bottom" : "left";
}

function overrideThresholdFonts(systemConf, userOptions) {
	for (var attr in userOptions) {
		if (userOptions.hasOwnProperty(attr)) {
			systemConf[attr] = userOptions[attr];
		}
	}

	return systemConf;
}

function getCustomThresholdText(text, data, colInfo, chartObj) {
    var dataType = colInfo.datatype,
        format = colInfo[dataType],
        type = "threshold",
        decode = false;

    return text.replace(CUSTOM_VALUE_PATTERN, function($1, index) {
        var val = "";
        if (isArray(data[index])) {
            val = getFormattedValue(format, data[index][0], dataType, chartObj, type, decode);
            val += " - " + getFormattedValue(format, data[index][1], dataType, chartObj, type, decode);
        } else {
            val = getFormattedValue(format, data[index], dataType, chartObj, type, decode);
        }
        return val;
    });
}
