//$Id$
var ZRZBooksInteg = new function()
{
	this.connectorID = 11;
	this.connectorKey = ZDBI18NMap.g('zrpt.connector.js.zbooksorinvinteg');
	this.fetchZBooksImpDlg = function(isNewDB)
	{
		if(!ZDBLazyLoadUtil.loadSnippet("ZBOOKS_IMPORT_DLG","/ZRZBooksImportUI.cc?ZDBACTION=ZBOOKSORGINFO"+(!isNewDB ?"&NEWTABLEMODE=true&DBID="+ZDBClientUI.dbId : ""),this,"APPENDTODOC"))
        {
            return;
        }
        delete ZDBLazyLoadUtil.loadedSnippets.ZBOOKS_IMPORT_DLG;
		ZRZBooksInteg.isUserExpired = $("ZRZBOOKS_IS_EXPIRED_USER").value;
		ZRZBooksInteg.isFreshUser = $("ZRZBOOKS_IS_NOT_USER").value;
		ZRZBooksInteg.isReportsUser = $("ZRZBOOKS_IS_REPORTS_USER").value;
		if(ZRZBooksInteg.isUserExpired === "true")
        {
        	ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.conn.js.userexpired.msg",ZDBI18NMap.f("zrpt.connector.js.zbooksorinvinteg"),ZDBGlobal.PRODUCTNAME));
        	return;
        }   
        else if(ZRZBooksInteg.isReportsUser !== "true" && ZRZBooksInteg.isFreshUser === "true")
        {
        	ZDBAlertAPI.showErrorMsg(ZDBI18NMap.f("zrpt.conn.js.otherservice.freeuser",ZRZBooksInteg.connectorKey,ZDBGlobal.PRODUCT_NAME));
        	return;
        }
        else if(ZRZBooksInteg.isFreshUser === "true")
        {
        	var infoDlg =  $("ZRZBooksTrialInfo");
        	infoDlg.style.display = "" ;
        	ZDBDialogUtil.showDialog(infoDlg,{TITLE: ZDBI18NMap.f("zrpt.conn.js.title_trial",ZDBGlobal.PRODUCT_NAME,ZRZBooksInteg.connectorKey), ADDFRAME:true,MODAL:true,DONTREMOVE:true});
        	$("ZRZBoosNewUserOkBtn").setAttribute('onclick','ZRZBooksInteg.showDBDetsDlg('+isNewDB+')');
        }
        else
        {
        	ZRZBooksInteg.showDBDetsDlg(isNewDB);
        }
	}
	this.showDBDetsDlg = function(isNewDB)
	{
        ZDBDialogUtil.closeDialog();
		var importDlg = $("ZRBooksImpDlg"); //No I18N
		var showInfoDlg = importDlg.getAttribute("showZBooksInfoDlg");
		 if(showInfoDlg === "true")
		 	{

	        	$("ZDBZBooksInfoNxtBtn").setAttribute('onclick','ZRZBooksInteg.checkAndShowZBooksImportDlg('+isNewDB+')');
	        	ZDBDialogUtil.showDialog($("ZDBZBooksInfoDlg"),{TITLE:ZDBI18NMap.f("zrpt.conn.js.demo.title",ZRZBooksInteg.connectorKey),
	        						ADDFRAME:true,DONTREMOVE:true, MODAL:true});
	        	ZDBUtil.setFocus("ZDBZBooksInfoNxtBtn",true); //No I18N
		 	}
		 else
			 {
			 ZRZBooksInteg.showZBooksImportDlg(isNewDB);
			 }
		
	}
	
	this.checkAndShowZBooksImportDlg = function(isNewDB)
	{
        if($("ZBooksInfo").checked)
        {
            var url = "/ConnectorAction.ma?ZDBACTION=DONTSHOWDEMODLG&CONNECTORID=11"; //No I18N
            AjaxAPI.sendRequest({URL:url,ONSUCCESSFUNC:ZRZBooksInteg.checkedAndCallShowDlg,ISNEWDB:isNewDB});  //No I18N
        }
        else
		 {
		 ZRZBooksInteg.showZBooksImportDlg(isNewDB);
		 }
		
	}
    this.checkSubPriModule = function(el)
    {
    	if(el.checked === true)
    	{
    		jQuery("#ZBooks"+el.getAttribute("primarymodid")+" input").prop("checked","checked"); //NO I18N
    	}
    };
	this.checkedAndCallShowDlg = function(response, requestOptions)
	{
		ZRZBooksInteg.showZBooksImportDlg(requestOptions.ISNEWDB);
	}
	this.showZBooksImportDlg = function(isNewDB)
	{

        ZDBDialogUtil.closeDialog();
		var importDlg = $("ZRBooksImpDlg"); //No I18N
        if(isNewDB == true)
		{
			ZDBFullPageDialog.showDialog(importDlg,{TITLE:ZDBI18NMap.f("zrpt.conn.js.setupdlg.title",ZDBI18NMap.g("zrpt.connector.js.zohobooks")),ADDFRAME:true,MODAL:true,DONTREMOVE:true}); // No I18N
			jQuery("#ZRZBooksIncludeDefaultReport").parent().hide(); //NO I18N
			jQuery("#ZRZBooksCreateCRMLookup").parent().hide(); //NO I18N
		}
		else
		{
			 ZDBInlineDialog.showDialog(importDlg,{TITLE:ZDBI18NMap.f("zrpt.conn.js.setupdlg.title",ZDBI18NMap.g("zrpt.connector.js.zohobooks")),ADDFRAME:true,MODAL:true,DONTREMOVE:true}); // No I18N
			 jQuery("#ZRZBooksIncludeDefaultReport").prop("checked",false); //NO I18N
			 if($("ISCRMENABLEDFORORG").value == "false")
			 {
					jQuery("#ZRZBooksCreateCRMLookup").parent().hide(); //NO I18N
			 }
			 else
			 {
					jQuery("#ZRZBooksCreateCRMLookup").parent().show(); //NO I18N
			 }
		}
        
		ZRZBooksInteg.curModule = $("ZBOOKSCURMOD").getAttribute("currModule");
		jQuery('#ZRZBooksSelectAll').change(function(){jQuery("#"+ZRZBooksInteg.curModule+"FieldsContainer input").not(":disabled").prop("checked",this.checked);
		if(this.checked)
		{
			jQuery("#"+ZRZBooksInteg.curModule+" input").prop("checked",true);
		}
		}); 

		$("ZCSearchFields" ).setAttribute("searchDivId",""+ZRZBooksInteg.curModule+"FieldsContainer");
		ZRConnector.changeSchTimeToCurrentTime();
	}
	this.fetchZBooksNewDBImpDlg = function()
	{
		ZRZBooksInteg.fetchZBooksImpDlg(true);
	}
	this.fetchZBooksNewTableImpDlg = function()
	{
		ZRZBooksInteg.fetchZBooksImpDlg(false);
	}
	this.showFieldsContainer = function(el,secMod)
    {
      if(ZRZBooksInteg.curModule === el.id)
      {
          return;
      }

      if(ZRZBooksInteg.curModule !== null)
      {
        jQuery("#" +ZRZBooksInteg.curModule + "FieldsContainer").hide(); //No I18N
        var module = $(el.id + "FieldsContainer");
        $("ZCSearchFields" ).setAttribute("searchDivId",""+module.id);
        $("ZCSearchFields").value="";
        $("ZCSearchFields").setAttribute("tipshown","false");
        ZDBSearchUtil.showTipString($("ZCSearchFields"));
        ZRZBooksInteg.searchFields();
        $("ZBooksEmptyFieldsMsg").style.display="none";
        module.scrollTop=0;
        $(""+el.id).className="moduleTabSelected";
        $(ZRZBooksInteg.curModule).className = "moduleTab";
        jQuery(module).show();
        ZRZBooksInteg.curModule = el.id;
        $("ZBOOKSCURMOD").value = ZRZBooksInteg.curModule;
      }
      jQuery("#ZRZBooksSelectAll").prop("checked",jQuery("#" +ZRZBooksInteg.curModule + "FieldsContainer input").length == jQuery("#" +ZRZBooksInteg.curModule + "FieldsContainer input:checked").length);//NO I18N
    };
    this.getSelectedCol = function(form)
    {
      
      var selCols="{";
      
      jQuery('div#ZBooksModContainer input[type=checkbox]').each(function() {//NO I18N
         if ($(this).checked) {
        	selCols += ZRZBooksInteg.getSelectedColStr(jQuery(this).attr('modId'),form[jQuery(this).attr('value')]) + "," ;//NO I18N
         }
      });
      jQuery('.secModule input[type=checkbox]').each(function() {//NO I18N
          if ($(this).checked) {
         	selCols += ZRZBooksInteg.getSelectedColStr(jQuery(this).attr('modId'),form[jQuery(this).attr('modId')]) + "," ;//NO I18N
          }
       });	
      
      selCols += "}";
      return selCols;
    };

    this.getSelectedColStr = function(mod,fieldArr)
    {
      var isFirst = true;
      var usrStr = "";
      if(fieldArr.length == undefined)
      {
    	  usrStr = fieldArr.value;
      }
      else
      {
    	  for (var i=0; i<fieldArr.length; i++)
    	  {
    		  if (fieldArr[i].checked === true)
    		  {
    			  if(isFirst)
    			  {
    				  isFirst = false;
    			  }
    			  else
    			  {
    				  usrStr += ",";
    			  }
    			  usrStr += fieldArr[i].value;
    		  }
    	  }
      }
      return "\"" + mod  + "\":[" + usrStr + "]";
    };
    
    this.searchFields = function()
    {
    	var searchFieldElem = $("ZCSearchFields");
    	var containerDivId = searchFieldElem.getAttribute("searchDivId");
    	var attr = "displayValLcase"; //No I18N
    	var basedOnTag = "input"; //No I18N
    	ZDBClientUtil.searchAndDisplay(containerDivId,basedOnTag,attr,searchFieldElem,$("ZBooksEmptyFieldsMsg"));
    };
    
    this.searchMods = function()
    {
    	var searchFieldElem = $("ZBooksSearchMods");			
    	var containerDivId = "ZBooksModContainer"; //NO I18N
    	var attr = "modDisplayValLCase"; //No I18N
    	var basedOnTag = "input"; //No I18N
    	ZDBClientUtil.searchAndDisplay(containerDivId,basedOnTag,attr,searchFieldElem,$("ZBooksEmptyModsMsg"));
    };
	
	this.showNotSchNote = function(el) 
	{
		if (el.value == "none") 
		{
			$("ZBooksNotScheduled").style.display = ""; // NO I18N
		} 
		else 
		{
			$("ZBooksNotScheduled").style.display = "none"; // NO I18N
		}
	}
	
	this.showOrgList = function(ev) 
	{
		var orgList = $("booksOrgList");  
		if(orgList.style.display == "none") 
		{
           orgList.style.display = "";
		} 
		else
		{
			ZRZBooksInteg.closeOrgListIfOpen();
		}
		ev.stopPropagation();
	}
	
	this.closeOrgListIfOpen = function() 
	{
		var orgList = $("booksOrgList");  
		if(orgList.style.display == "") 
		{
           orgList.style.display = "none";
		} 
	}
	
	this.setSelectedOrg = function(dbId,orgName,orgId,event) 
	{
		var orgList = $("booksOrgList"); 				 
		orgList.style.display = "none";
		var selOrg = $("ZBooksSelectedOrg");
		var prevSelOrgId = selOrg.getAttribute("orgId");
		if(prevSelOrgId==orgId)
		{
			return;
		}
		selOrg.setAttribute("orgId",orgId);
		selOrg.setAttribute("orgName",orgName);
		$("ZBooksSelectedOrg").innerHTML = orgName	; 	 
		ZRZBooksInteg.loadZbooksModules(dbId,orgId);
		event.stopPropagation();
	}
	
	this.createZBooksSetup = function(elt)
	{
		var form = elt.form;
		var newTableMode=$("ZBooksNewTableMode").value;
		var params =""; 	
		var needReport=false;
		var needCRMLookup = false;
		if($("ZRZBooksIncludeDefaultReport").checked == false)
		{
			needReport = true;
		}
		if($("ZRZBooksCreateCRMLookup").checked == true)
		{
			needCRMLookup = true;
		}
		if(newTableMode !== "true")
		{ 		
			params+= "&DATABASENAME=" + form.ZBooksDBName.value+ "&DATABASEDESC=" + form.ZBooksDesc.value        // No I18N	
			needReport = true;
		}
		else
		{
			params +="&DBID="+ZDBClientUI.dbId ;//NO I18N
		}
		var selOrg = $("ZBooksSelectedOrg"); 
		if(!(selOrg.getAttribute("orgId")=="_dummy"))
		{
			params+="&ORGID=" + selOrg.getAttribute("orgId")  + "&ZOHO_SERVICES=" + selOrg.getAttribute("services") +	"&ZOHO_ORGNAME=" + selOrg.getAttribute("orgName") +		// No I18N
			"&SCHEDULETIME="+ZRConnector.getSchTime()+ "&SCHTIMEZONE="+ ZRConnector.getSchTimeZone()+"&NEWTABLEMODE="+newTableMode+"&NEEDREPORTS="+needReport+"&NEEDCRMLOOKUP="+needCRMLookup+"&SELECTEDCOLS="+ZRZBooksInteg.getSelectedCol(form);     // No I18N	
		}
		
		var selColumnsForLookupSugg = ZRZBooksInteg.getSelColsForLookupSugg();
		params += "&SELCOLSLOOKUPDETAILS=" + encodeURIComponent(selColumnsForLookupSugg);	//No I18N
		AjaxAPI.sendRequest({
	        URL:"/ZRZBooksImport.ve?ZDBACTION=ZBOOKSCREATEDB", // No I18N
	        ONSUCCESSFUNC:ZRZBooksInteg.zbooksSetupSuccess,PARAMETERS:params,
	        ONFAILUREFUNC:ZRConnector.connSetupFailure,
	        OPSTATUSID:"ZBooksFetchSts" //No I18N		        
		});	
	}
	
	this.zbooksSetupSuccess = function(response, requestOptions)
	{
		jQuery("#ZRZBooksForm").hide();//No i18N
    	jQuery("#ZBooksSetupCmpltdDlg").css("display","inline-block").focus();//No i18N
    	var params = response.getResponseParams();
    	if(params["ISNEWTABLEMODE"] == "false")
    	{
    		ZDBFullPageDialog.currentFullPageDialog.params.ONCLOSE=ZRConnector.gotoExplorerView;
    		ZDBFullPageDialog.currentFullPageDialog.params.REQPARAMS=params;
            $("ZBooksDesc").innerHTML =  ZDBI18NMap.f("zrpt.conn.js.dbsuccess.desc",ZRZBooksInteg.connectorKey);
    	}
    	else
    	{
    		var tab = ZDBClientUI.selectedTab;
    		var dialog = tab.dialogs[tab.view.dialogStatus-1];
    		dialog.params.ONCLOSE=ZRConnector.gotoExplorerView;
    		dialog.params.REQPARAMS=params;
    	}
    	$("ZBooksTitle").innerHTML = ZDBI18NMap.f("zrpt.conn.js.dbsuccess.title",ZRZBooksInteg.connectorKey);
    	var msg = ZDBI18NMap.f('zrpt.zbooks.js.step2.msg', ZDBEscapeUtil.encodeForHtml(params["DBNAME"]),params["EMAILID"]);
        jQuery("#ZRConnectorSetupCompMsg").html(msg); //No I18N
	}
	
	this.loadZbooksModules = function(dbId,orgId)
    {
        var selectedOrg = orgId; 
        if(selectedOrg == null || selectedOrg == "_dummy")
        {
            return;
        }

        var params = "&ORGID=" + selectedOrg; // No I18N
        if(dbId != null && dbId !='null')
        {
        	params += "&DBID="+dbId; //NO I18N
        }
        AjaxAPI.sendRequest({
                URL:"/ZRLoadZBooksModules.cc?ZDBACTION=LOADMODULES", // No I18N
                PARAMETERS:params,
                METHOD:"GET",  //No I18N
                ONSUCCESSFUNC:ZRZBooksInteg.loadModulesResp,
                OPSTATUSID:"ZBooksLoader" // No I18N
            });
    };
    
    this.showEditFieldsDlg = function(connDBInfoId)
    {
    	 AjaxAPI.sendRequest({URL:"/ZRZBooksEditSetupUI.cc?ZDBACTION=ZBOOKSEDITSETUP&DBID="+ZDBClientUI.dbId+"&CONNDBINFOID="+connDBInfoId,
             METHOD:"GET",  //No I18N
             ONSUCCESSFUNC:ZRZBooksInteg.handleShowEditSetupDlgSucc,
             OPSTATUSID:"ZDBMainLoader"}); //No I18N
    };
    
    this.handleShowEditSetupDlgSucc = function(response,responseText)
    {
    	var div = document.createElement("div");
        div.innerHTML = response.responseText;
        document.body.appendChild(div);
        ZDBDialogUtil.closeDialog();
        div.addEventListener("click",(function(ev){ 
	    	ev.stopPropagation();
	    	var customizeMenu = $('ZBooksOrgModSettingsMenu');
	    	if(ev.target.id!="ZBooksOrgModSettingsMenu" && customizeMenu ){  // if click is not in 'mydiv'
	    		customizeMenu.style.display = "none" ;
	    	  }
	    	}));
        ZDBDialogUtil.showDialog(div,{MODAL:true, ADDFRAME:true, SHADOW:true,    //No I18N
                              TITLE:ZDBI18NMap.f('zrpt.conn.js.edit.setup',ZRZBooksInteg.connectorKey)});     
        ZRZBooksInteg.curModule = $("ZBOOKSCURMOD").getAttribute("currModule");
		jQuery('#ZRZBooksSelectAll').change(function(){jQuery("#"+ZRZBooksInteg.curModule+"FieldsContainer input").not(":disabled").prop("checked",this.checked);}); //NO I18N

		$("ZBooksSearchMods").blur();
		$("ZCSearchFields" ).setAttribute("searchDivId",""+ZRZBooksInteg.curModule+"FieldsContainer");
		jQuery("#ZRZBooksEditSetupSubmit").click(function(){ ZRZBooksInteg.submitEditSetup(this.form);}); //No I18N
    	ZRConnector.setSchDetails();
    };
    
    this.submitEditSetup = function(frm)
    {
    	hideCustomMessage();
        var selCols = ZRZBooksInteg.getSelectedCol(frm);//No I18N
        var params = "&SCHEDULETIME=" + ZRConnector.getSchTime(frm) + "&DBID=" + frm.ZOHO_DBID.value + "&ZOHO_SELECTED_MODULES="+ZRZBooksInteg.getSelOrgs()		//No I18N
                      	+ "&CONNDBINFOID=" + $("CONNDBINFOID").value +"&CONNECTORID=" + $("CONNECTORID").value + "&CONFIRMED=false" + "&SCHTIMEZONE="+ ZRConnector.getSchTimeZone()+"&SELECTEDCOLS="+selCols; //No I18N
        
        AjaxAPI.sendRequest({URL:"/ConnectorAction.ma?&ZDBACTION=SAVEEDITSETTINGS",METHOD:"POST",PARAMETERS:params,
  									ONSUCCESSFUNC:ZRZBooksInteg.handleSubmitEditSetupSucc,OPSTATUSID:"ZBOOKSEDITSETUPOPTSTATUS",PARAMS:params}); //No I18N
    }
    
    this.handleSubmitEditSetupSucc = function(response, requestOptions)
    {
      ZRConnector.alertIfNeeded(response,requestOptions);
    };
    
    this.loadModulesResp = function(response,requestOptions)
    {
    	var modsDiv = response.getOnlyHtml();
    	var modHolderDiv = $("ZRBooksContainer");
    	modHolderDiv.innerHTML = modsDiv;
		ZRZBooksInteg.curModule = $("ZBOOKSCURMOD").getAttribute("currModule");
		jQuery('#ZRZBooksSelectAll').change(function(){jQuery("#"+ZRZBooksInteg.curModule+"FieldsContainer input").not(":disabled").prop("checked",this.checked);}); //NO I18N
	    
		$("ZCSearchFields" ).setAttribute("searchDivId",""+ZRZBooksInteg.curModule+"FieldsContainer");
		if($("ISCRMENABLEDFORORGLOADED").value == "false")
		{
			jQuery("#ZRZBooksCreateCRMLookup").parent().hide(); //NO I18N
		}
		else
		{
			jQuery("#ZRZBooksCreateCRMLookup").parent().show(); //NO I18N
		}
    };
	
	this.getConnLookups = function()
	{
		var selColumnsForLookupSugg = ZRZBooksInteg.getSelColsForLookupSugg();
		var params =  "CONNECTORID=" + ZRZBooksInteg.connectorID + "&SELCOLSLOOKUPDETAILS="+ encodeURIComponent(selColumnsForLookupSugg); //No I18N    
//                AjaxAPI.sendRequest({ URL: "/reportsapi/db/" + ZDBClientUI.dbId + "/SUGGESTCONNLOOKUPS",
//			ONSUCCESSFUNC: ZRZBooksInteg.showLookupSuggestions,
//			OPSTATUSID: "ZDBMainLoader",	//No I18N			
//			METHOD:"POST",//No I18N
//			PARAMETERS:params});
                ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/SUGGESTCONNLOOKUPS', params, {
                    successHandler: {
                        func: ZRZBooksInteg.showLookupSuggestions,
                        ctx: ZRZBooksInteg
                    }
                });
	}
	
	this.getSelColsForLookupSugg = function()
	{
		var selColsForLookup = {data:[]};
		var modList = $("ZBooksModContainer").getElementsByTagName("input");
		  
		for (var i = 0; i < modList.length; i++)
		{
			if (!modList[i].checked) 
			{
				continue;
			}
			var modInfo = {fields:[]};
			var modID = modList[i].getAttribute("modid");
			modInfo.modUniqueName = modID;
			modInfo.modDispName = modList[i].getAttribute("modDisplayVal");
			var fieldList = $("ZBooks" + modID + "FieldsContainer").getElementsByTagName("input");  
			for(var f=0;f<fieldList.length;f++)
			{
				if (!fieldList[f].checked) 
				{
					continue;
				}
				
				modInfo.fields.push({ "fieldUniqueName" :fieldList[f].value ,"fieldDisplayName"  : fieldList[f].getAttribute("displayval")});
			}
			selColsForLookup.data.push(modInfo);	
		}
		return JSON.stringify(selColsForLookup.data);
	}
		
	this.selSubMods = function(el)
	{
		if(!el.hasAttribute("hasSubModules") || el.getAttribute("hasSubModules") === "false")
		{
			return;
		}
		var subModDiv = $("Zbooks"+el.getAttribute("modId")+"SubMods");	//NO I18N
		if(subModDiv==null || subModDiv==undefined)
		{
			return;
		}
		ZRConnector.toggleAllCheckBoxes(subModDiv.getAttribute("id"),el.checked);			
	}
	
	this.getConnLookups = function()
	{
		var selColumnsForLookupSugg = ZRZBooksInteg.getSelColsForLookupSugg();
		var params =  "CONNECTORID=" + ZRZBooksInteg.connectorID + "&SELCOLSDETAILS="+ encodeURIComponent(selColumnsForLookupSugg); //No I18N    
//        AjaxAPI.sendRequest({ URL: "/reportsapi/db/" + ZDBClientUI.dbId + "/SUGGESTCONNLOOKUPS",
//			ONSUCCESSFUNC: ZRZBooksInteg.showLookupSuggestions,
//			OPSTATUSID: "ZDBMainLoader",
//			
//			METHOD:"POST",
//			PARAMETERS:params});
                    
                ZRSAjax.get('/reportsapi/db/' + ZDBClientUI.dbId + '/SUGGESTCONNLOOKUPS', params, {
                    successHandler: {
                        func: ZRZBooksInteg.showLookupSuggestions,
                        ctx: ZRZBooksInteg
                    }
                });
	}
	
	this.showLookupSuggestions = function(response,requestOptions)
	{
		ZRConnector.showRelations(response,requestOptions);
	}
	
	this.getSelColsForLookupSugg = function()
	{
		var selColsForLookup = {data:[]};
		var modList = $("ZBooksModContainer").getElementsByTagName("input");
		  
		for (var i = 0; i < modList.length; i++)
		{
			if (!modList[i].checked) 
			{
				continue;
			}
			var modInfo = {fields:[]};
			var modID = modList[i].getAttribute("modid");
			modInfo.modUniqueName = modID;
			modInfo.modDispName = modList[i].getAttribute("modDisplayVal");
			var fieldList = $("ZBooks" + modID + "FieldsContainer").getElementsByTagName("input");  
			for(var f=0;f<fieldList.length;f++)
			{
				if (!fieldList[f].checked) 
				{
					continue;
				}
				
				modInfo.fields.push({ "fieldUniqueName" :fieldList[f].value ,"fieldDisplayName"  : fieldList[f].getAttribute("displayval")});
			}
			selColsForLookup.data.push(modInfo);	
		}
		return JSON.stringify(selColsForLookup.data);
	}
		
 
	
	this.toggleScheduleDiv = function(optValue)
    {
        if(optValue === "none")
        {
        	$("ZCSchTimeDiv").style.display ="none";
        	$("ZCNotScheduledHelp").style.display = "";
        	$("ZCNotScheduledHelp").style.display ="block";

        }
        else if(optValue === "daily")
        {
        	$("ZCSchTimeDiv").style.display = "block";
        	$("ZCNotScheduledHelp").style.display = "none";
        }
    };
    
    this.toggleOrgSelModSelOpenClose = function(el)
    {
    	var orgSelHolder = $("ZFORGSHOLDER");
    	var modSelHolder = $("ZCVIEWSHOLDER");
		if(el.id==='ZBooksOrgCustomize')
	    {
	    	$("ZFinanceOrgModSelHdr").innerHTML =  ZDBI18NMap.g('zrpt.js.import.selectorgmsg');
	    	modSelHolder.style.display = 'none';
	    	orgSelHolder.style.display = 'block';
	    	$('ZBooksOrgCustomize').className="ZRSMenuHover";
	    	$('ZBooksModFieldSel').className="";
	    }
    	else
		{
    		$("ZFinanceOrgModSelHdr").innerHTML =  ZDBI18NMap.g('zrpt.zbooks.js.selectorgfieldsdesc');
	    	modSelHolder.style.display = 'block';
	    	orgSelHolder.style.display = 'none';
	    	$('ZBooksOrgCustomize').className="";
	    	$('ZBooksModFieldSel').className="ZRSMenuHover";	    	
		}
		$('ZBooksOrgModSettingsMenu').style.display = 'none';

    }
    
    this.getSelOrgs = function()
	{
    	var orgList = $("booksOrgList");
    	var selOrgs = "";
    	if(orgList)
		{
        	var inputElts = orgList.getElementsByTagName("input");
    		var isFirst = true;
    		
    		for (var i = 0; i < inputElts.length; i++) 
    		{
    			if (!inputElts[i].checked) 
    			{
    				continue;
    			}
				var org = inputElts[i].getAttribute("orgId");
				if (!isFirst) 
				{
					selOrgs += ","
				}
				selOrgs += "\"" + org + "\"";
				isFirst = false;
    		}    		
		}
    	return "[" + selOrgs + "]";
	}
    
    this.searchOrgs = function()
    {
    	var searchFieldElem = $("ZBooksSearchOrgs");			
    	var containerDivId = "booksOrgList"; //NO I18N
    	var attr = "orgDisplayValLCase"; //No I18N
    	var basedOnTag = "input"; //No I18N
    	ZDBClientUtil.searchAndDisplay(containerDivId,basedOnTag,attr,searchFieldElem,$("ZBooksEmptyModsMsg"));
    };
    
    this.showModOrgSelMenu = function(evnt) 
    {    	
    	var customizeMenu = $('ZBooksOrgModSettingsMenu');
    	customizeMenu.style.display = "" ;
    	var orgSelHolder = $("ZFORGSHOLDER");
    	var modSelHolder = $("ZCVIEWSHOLDER");
	    if(modSelHolder.style.display == 'none')
	    { 
	    	$('ZBooksOrgCustomize').className="moduleTabSelected";
	    	$('ZBooksModFieldSel').className="";	    	
	    }
	    else
    	{
	    	$('ZBooksModFieldSel').className="moduleTabSelected";
	    	$('ZBooksOrgCustomize').className="";	    	
    	}
	    evnt.stopPropagation();	    
    }
}

ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRZBooksInteg.fetchZBooksNewDBImpDlg"] = ZRZBooksInteg.fetchZBooksNewDBImpDlg;
ZDBLazyLoadFuncMap.lazyLoadFuncMap["ZRZBooksInteg.fetchZBooksNewTableImpDlg"] = ZRZBooksInteg.fetchZBooksNewTableImpDlg;


