//$Id$

var defPass = '(change password)'; //No I18N
var licViolTabs = ['licencetab', 'usertab','publishusertab']; //NO I18N
function loadContent(linkToLoad, heading, elid) {
  // jQuery.ajaxSetup({
  // 	cache: true
  // });
  //for rebranding, preview removal
  jQuery("#ZDBLogo").show(); //NO I18N
  jQuery("#temp-logo").remove(); //NO I18N
  if (linkToLoad) {
    el = "#" + elid;
    jQuery.get(linkToLoad).done(function(result, status, xhr) {
      var isLicenseViolated = checkLicenseViolated(xhr);
      if (isLicenseViolated) {
        var redirectUrl=xhr.getResponseHeader('RedirectTo');//NO I18N
        var licenseState=getLicenseState(xhr);
        if(licenseState=='Expired')
        {
           window.location.replace(redirectUrl);
        }
        else
        {
          if(!isTabAllowedInLicViol(elid))
          {
            window.location.replace(redirectUrl)
          }
          else
          {
            continueLoadingThepage(xhr,heading,result);
            if (isLicenseViolated) {
            showLicenseAlert(xhr, showPopOver(xhr));
            disableOtherTabs();
            }
            }
        }
      } else {
             continueLoadingThepage(xhr,heading,result);
        }
    });
  }
}


function continueLoadingThepage(xhr,heading,result)
{
        jQuery(el).parent().addClass("active"); //NO I18N
        jQuery(el).parent().siblings().removeClass("active"); //NO I18N
        jQuery(".zrop-admin-header").html(heading); //NO I18N
        jQuery(".zrop-admin-content").html(result); //NO I18N
        enableOtherTabs();
        hideLicenseAlert();
}

function getLicenseState(xhr)
{
 return xhr.getResponseHeader('licenseState');
}

function showPopOver(xhr) {
  var value = xhr.getResponseHeader('showPopOver'); //No I18N
  var eval = "true".localeCompare(value); //NO I18N
  if (eval == 0) {
    return true;
  }
  return false;
}

function enableOtherTabs() {
  //	alert("called enable");
  jQuery("#usertab").parent("li").removeClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#mailtab").parent("li").removeClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#proxytab").parent("li").removeClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#rebrandtab").parent("li").removeClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#advancedsettings").parent("li").removeClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#manageusertab").parent("li").removeClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#manageintegtab").parent("li").removeClass("zrop-elem-disable-opacity"); //NO I18N
}

function disableOtherTabs() {
  //	alert("called disable");
  jQuery("#mailtab").parent("li").addClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#proxytab").parent("li").addClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#rebrandtab").parent("li").addClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#advancedsettings").parent("li").addClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#manageusertab").parent("li").addClass("zrop-elem-disable-opacity"); //NO I18N
  jQuery("#manageintegtab").parent("li").addClass("zrop-elem-disable-opacity"); //NO I18N
}

function checkLicenseViolated(xhr) {
  var value = xhr.getResponseHeader('isLicenseStable'); //No I18N
  var eval = "false".localeCompare(value); //NO I18N
  if (eval == 0) {
    return true;
  }
  return false;
}

function isTabAllowedInLicViol(elid) {
  var arrayLength = licViolTabs.length;
  for (var i = 0; i < arrayLength; i++) {

    if (elid.localeCompare(licViolTabs[i]) == 0) {
      return true;
    }
  }
  return false;

}

function showStatusMsg(msg, status) {
  jQuery('#zrop-notifications').removeClass('zrop-success zrop-warning zrop-error'); //No I18N
  jQuery('#zrop-notifications').addClass('zrop-' + status); //No I18N
  jQuery('#zrop-notifications').html(msg); //NO I18N
  jQuery('#zrop-notifications').show().delay(5000).fadeOut(); //No I18N
}

function hideMsg() {
  jQuery('#zrop-notifications').hide(); //NO I18N
}

function getZropI18nValue(i18nkey) {
  return ZDBI18NMap.g(i18nkey);
}

function showZropAlert(i18nkey) {
  jQuery("#zrop-new-alert-box").show(); //No I18N
  jQuery("#zrop-alert-msg").text(ZDBI18NMap.g(i18nkey)); //No I18N
  jQuery(".zrop-overlay").css({ //No I18N
    display: 'block' //No I18N
  });
}

function passinFocus() {
  if (jQuery(this).val() == defPass) {
    jQuery(this).val('');
  }
  var field = jQuery(this).attr('id'); //No I18N
  changeFieldType(field, 'password'); //No I18N
  jQuery(this).removeClass('zrop-default-password');
}

function passOutofFocus() {
  var field = jQuery(this).attr('id'); //No I18N
  changeFieldType(field, 'password'); //No I18N
  if (jQuery(this).val() == '') {
    if (field == 'password1' && primaryConfigured && primaryAuthReqd) {
      jQuery(this).val(defPass);
      jQuery(this).addClass('zrop-default-password');
      changeFieldType(field, 'text'); //No I18N
    } else if (field == 'password2' && secondaryConfigured && secondaryAuthReqd) { //No I18N
      jQuery(this).val(defPass);
      jQuery(this).addClass('zrop-default-password');
      changeFieldType(field, 'text'); //No I18N
    } else if (field == 'password3' && authRequiredCheck) { //No I18N
      jQuery(this).val(defPass);
      jQuery(this).addClass('zrop-default-password');
      changeFieldType(field, 'text'); //No I18N
    }
  }
}

function applyFancyLabelBehavior() {
  jQuery('.zrop-input-animated').on('focus blur', function(e) { //No I18N
    jQuery(this).parents('.zrop-form-animated').toggleClass('focused', (e.type === 'focus' || this.value.length > 0));
  }).trigger('blur'); //No I18N
}

function changeFieldType(field, type) {
  var passwordField = document.getElementById(field);
  var value = passwordField.value;
  if ((value == defPass || value == '') && type == 'text') { //No I18N
    passwordField.type = type;
    passwordField.value = value;
  } else if (type == 'password' && value != defPass) { //No I18N
    passwordField.type = type;
    passwordField.value = value;
  }
}

function changePassFieldType(field, type) {
  var passwordField = document.getElementById(field);
  var value = passwordField.value;
  passwordField.type = type;
  passwordField.value = value;
}

function validatePassword(password) {
  if (password == defPass) {
    return 'dont.change.password'; //No I18N
  }
  return password;
}

function showNotification(message, status) {
  jQuery('#zrop-notifications').html(ZDBI18NMap.g(message)); //No I18N
  jQuery('#zrop-notifications').removeClass('zrop-success zrop-warning zrop-error'); //No I18N
  jQuery('#zrop-notifications').addClass('zrop-' + status); //No I18N
  jQuery('#zrop-notifications').show().delay(5000).fadeOut(); //No I18N
  jQuery(".zrop-overlay").remove(); //No I18N
}

function tabOnload(tab) {
  if (tab[0].id == "mailtab") {
    loadMailProps();
  }; //No I18N
}

function fancyLoaderShow() {
  jQuery(".zrop-fancy-loader").show(); //No I18N
  jQuery(".zrop-admin-content").addClass("zrop-elem-disable-opacity"); //No I18N
}

function fancyLoaderHide() {
  jQuery(".zrop-fancy-loader").hide(); //No I18N
  jQuery(".zrop-admin-content").removeClass("zrop-elem-disable-opacity"); //No I18N
}

function showLicenseAlert(xhr, showpopover) {
  jQuery("#license-notifications").show(); //No I18N
  if (showpopover) {
    jQuery(".zrop-popover-arrow").show(); //NO I18N
    jQuery("#zrop-violated-popover").show(); //NO I18N
    jQuery("td.zrop-usercount").addClass("error"); //NO I18N
  } else {
    jQuery("#usertab").parent("li").addClass("zrop-elem-disable-opacity"); //No I18N
  }
  jQuery("#license-notifications").addClass("zrop-license-error"); //NO I18N
  jQuery("#license-notifications").html(ZDBI18NMap.g(xhr.getResponseHeader('Message'))); //No I18N
}

function hideLicenseAlert() {
  jQuery("#license-notifications").hide(); //No I18N
  jQuery(".zrop-popover-arrow").hide(); //NO I18N
  jQuery("#zrop-violated-popover").hide(); //NO I18N
  jQuery(".zrop-usercount").removeClass("error"); //NO I18N
  jQuery("#license-notifications").removeClass("zrop-license-error"); //NO I18N
}

jQuery(function() {
  jQuery('*').scroll(function() {
    var headTop = jQuery('#ZDBMainHeader').height() + 10; //No I18N
    if (jQuery(this).scrollTop() >= headTop) {
      jQuery('#zrop-wrapper').addClass('zrop-sidebarFix'); //No I18N
    } else {
      jQuery('#zrop-wrapper').removeClass('zrop-sidebarFix'); //No I18N
    }
  });
});
